(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
(function (global){
const libchipmunk = require('../src/libchipmunk');
const cpvlib = require('./cpVect');
const cpslib = require('./cpShape');

const PROP_NAME_VELOCITY_UPDATE_FUNC = ("__VELOCITY_UPDATE_FUNC__");
const PROP_NAME_VELOCITY_UPDATE_THIS = ("__VELOCITY_UPDATE_THIS__");
const PROP_NAME_POSITION_UPDATE_FUNC = ("__POSITION_UPDATE_FUNC__");
const PROP_NAME_POSITION_UPDATE_THIS = ("__POSITION_UPDATE_THIS__");

var Chipmunk = function()
{
    this.runtime = null;
    this.bodiesUserDatas = new Map();
}

Chipmunk.prototype.reset = function(runtime)
{
    this.runtime = runtime;
    this.cpBodyUpdateVelocityFuncDefaultPtr = runtime.addFunction(this.cpBodyUpdateVelocityFuncDefault, 'vddddd');
    this.cpBodyUpdateVelocityFuncCurrentPtr = runtime.addFunction(this.cpBodyUpdateVelocityFuncCurrent, 'vddddd');
    this.cpBodyUpdatePositionFuncDefaultPtr = runtime.addFunction(this.cpBodyUpdatePositionFuncDefault, 'vdd');
    this.cpBodyUpdatePositionFuncCurrentPtr = runtime.addFunction(this.cpBodyUpdatePositionFuncCurrent, 'vdd');
}

Chipmunk.prototype.cpBodyNew = function(mass, moment)
{
    return this.runtime.ccall('cpBodyNew', 'number', ['number', 'number'], [mass, moment]);
}

Chipmunk.prototype.cpBodyNewStatic = function()
{
    return this.runtime.ccall('cpBodyNewStatic', 'number');
}

Chipmunk.prototype.cpBodyNewKinematic = function()
{
    return this.runtime.ccall('cpBodyNewKinematic', 'number');
}

Chipmunk.prototype.cpBodyFree = function(body)
{
    this.runtime.ccall('cpBodyFree', null, ['number'], [body]);
}

Chipmunk.prototype.cpBodySetUserData = function(body, userData)
{
    this.bodiesUserDatas.set(body, userData);
}

Chipmunk.prototype.cpBodyGetUserData = function(body)
{
    return this.bodiesUserDatas.get(body);
}

Chipmunk.prototype.cpBodyGetPosition = function(body)
{
    var position = cpvlib.cpv(0.0, 0.0);
    var stack = this.runtime.stackSave();
    var positionPtr = this.runtime.allocate([position.x, position.y], 'double', this.runtime.ALLOC_STACK);
    this.runtime.ccall('chipmunk_cpBodyGetPosition', null, ['number', 'number'], [body, positionPtr]);
    position.x = this.runtime.getValue(positionPtr + 0, 'double');
    position.y = this.runtime.getValue(positionPtr + 8, 'double');
    this.runtime.stackRestore(stack);
    return position;
}

Chipmunk.prototype.cpBodySetPosition = function(body, position)
{
    this.runtime.ccall('chipmunk_cpBodySetPosition', null, ['number', 'number', 'number'], [body, position.x, position.y]);
}

Chipmunk.prototype.cpBodyGetVelocity = function(body)
{
    var velocity = cpvlib.cpv(0.0, 0.0);
    var stack = this.runtime.stackSave();
    var velocityPtr = this.runtime.allocate([velocity.x, velocity.y], 'double', this.runtime.ALLOC_STACK);
    this.runtime.ccall('chipmunk_cpBodyGetVelocity', null, ['number', 'number'], [body, velocityPtr]);
    velocity.x = this.runtime.getValue(velocityPtr + 0, 'double');
    velocity.y = this.runtime.getValue(velocityPtr + 8, 'double');
    this.runtime.stackRestore(stack);
    return velocity;
}

Chipmunk.prototype.cpBodySetVelocity = function(body, velocity)
{
    this.runtime.ccall('chipmunk_cpBodySetVelocity', null, ['number', 'number', 'number'], [body, velocity.x, velocity.y]);
}

Chipmunk.prototype.cpBodyGetMass = function(body)
{
    return this.runtime.ccall('cpBodyGetMass', 'number', ['number'], [body]);
}

Chipmunk.prototype.cpBodySetMass = function(body, mass)
{
    this.runtime.ccall('cpBodySetMass', null, ['number', 'number'], [body, mass]);
}

Chipmunk.prototype.cpBodyGetAngle = function(body)
{
    return this.runtime.ccall('cpBodyGetAngle', 'number', ['number'], [body]);
}

Chipmunk.prototype.cpBodySetAngle = function(body, angle)
{
    this.runtime.ccall('cpBodySetAngle', null, ['number', 'number'], [body, angle]);
}

Chipmunk.prototype.cpBodyGetAngularVelocity = function(body)
{
    return this.runtime.ccall('cpBodyGetAngularVelocity', 'number', ['number'], [body]);
}

Chipmunk.prototype.cpBodySetAngularVelocity = function(body, angularVelocity)
{
    this.runtime.ccall('cpBodySetAngularVelocity', null, ['number', 'number'], [body, angularVelocity]);
}

Chipmunk.prototype.cpBodyGetType = function(body)
{
    return this.runtime.ccall('cpBodyGetType', 'number', ['number'], [body]);
}

Chipmunk.prototype.cpBodySetType = function(body, type)
{
    this.runtime.ccall('cpBodySetType', null, ['number', 'number'], [body, type]);
}

Chipmunk.prototype.cpBodyIsSleeping = function(body)
{
    return this.runtime.ccall('cpBodyIsSleeping', 'boolean', ['number'], [body]);
}

Chipmunk.prototype.cpBodyActivate = function(body)
{
    return this.runtime.ccall('cpBodyActivate', null, ['number'], [body]);
}

Chipmunk.prototype.cpBodySleep = function(body)
{
    return this.runtime.ccall('cpBodySleep', null, ['number'], [body]);
}

Chipmunk.prototype.cpBodyUpdateVelocity = function(body, gravity, damping, dt)
{
    return this.runtime.ccall('chipmunk_cpBodyUpdateVelocity',
                              null, ['number', 'number', 'number', 'number', 'number'], [body, gravity.x, gravity.y, damping, dt]);
}

Chipmunk.prototype.cpBodyUpdateVelocityFuncDefault = function(body, gravityX, gravityY, damping, dt)
{
    return this.runtime.ccall('chipmunk_cpBodyUpdateVelocity', null, ['number', 'number', 'number', 'number', 'number'], [body, gravityX, gravityY, damping, dt]);
}

Chipmunk.prototype.cpBodyUpdateVelocityFuncCurrent = function(body, gravityX, gravityY, damping, dt)
{
    var userData = this.cpBodyGetUserData(body);
    if (userData) {
        var velocityUpdateFunc = userData[PROP_NAME_VELOCITY_UPDATE_FUNC];
        var velocityUpdateThis = userData[PROP_NAME_VELOCITY_UPDATE_THIS];
        velocityUpdateFunc.call(velocityUpdateThis, body, new cpvlib.cpVect(gravityX, gravityY), damping, dt);
    }
    else {
        throw new Error("invalid user data!");
    }
}

Chipmunk.prototype.cpBodySetVelocityUpdateFunc = function(body, velocityUpdateFunc, velocityUpdateThis)
{
    if (velocityUpdateFunc != null) {
        var userData = this.cpBodyGetUserData(body);
        if (userData) {
            userData[PROP_NAME_VELOCITY_UPDATE_FUNC] = velocityUpdateFunc;
            userData[PROP_NAME_VELOCITY_UPDATE_THIS] = velocityUpdateThis;
            return this.runtime.ccall('chipmunk_cpBodySetVelocityUpdateFunc', null, ['number', 'number'], [body, this.cpBodyUpdateVelocityFuncCurrentPtr]);
        }
        else {
            throw new Error("invalid user data!");
        }
    }
    else {
        return this.runtime.ccall('chipmunk_cpBodySetVelocityUpdateFunc', null, ['number', 'number'], [body, this.cpBodyUpdateVelocityFuncDefaultPtr]);
    }
}

Chipmunk.prototype.cpBodyUpdatePosition = function(body, dt)
{
    return this.runtime.ccall('cpBodyUpdatePosition', null, ['number', 'number'], [body, dt]);
}

Chipmunk.prototype.cpBodyUpdatePositionFuncDefault = function(body, dt)
{
    return this.runtime.ccall('cpBodyUpdatePosition', null, ['number', 'number'], [body, dt]);
}

Chipmunk.prototype.cpBodyUpdatePositionFuncCurrent = function(body, dt)
{
    var userData = this.cpBodyGetUserData(body);
    if (userData) {
        var positionUpdateFunc = userData[PROP_NAME_POSITION_UPDATE_FUNC];
        var positionUpdateThis = userData[PROP_NAME_POSITION_UPDATE_THIS];
        positionUpdateFunc.call(positionUpdateThis, body, dt);
    }
    else {
        throw new Error("invalid user data!");
    }
}

Chipmunk.prototype.cpBodySetPositionUpdateFunc = function(body, positionUpdateFunc, positionUpdateThis)
{
    if (positionUpdateFunc != null) {
        var userData = this.cpBodyGetUserData(body);
        if (userData) {
            userData[PROP_NAME_POSITION_UPDATE_FUNC] = positionUpdateFunc;
            userData[PROP_NAME_POSITION_UPDATE_THIS] = positionUpdateThis;
            return this.runtime.ccall('cpBodySetPositionUpdateFunc', null, ['number', 'number'], [body, this.cpBodyUpdatePositionFuncCurrentPtr]);
        }
        else {
            throw new Error("invalid user data!");
        }
    }
    else {
        return this.runtime.ccall('cpBodySetPositionUpdateFunc', null, ['number', 'number'], [body, this.cpBodyUpdatePositionFuncDefaultPtr]);
    }
}

Chipmunk.prototype.cpBodyApplyForceAtWorldPoint = function(body, force, point)
{
    return this.runtime.ccall('chipmunk_cpBodyApplyForceAtWorldPoint', null, ['number', 'number', 'number', 'number', 'number'], [body, force.x, force.y, point.x, point.y]);
}

Chipmunk.prototype.cpBodyApplyForceAtLocalPoint = function(body, force, point)
{
    return this.runtime.ccall('chipmunk_cpBodyApplyForceAtLocalPoint', null, ['number', 'number', 'number', 'number', 'number'], [body, force.x, force.y, point.x, point.y]);
}

Chipmunk.prototype.cpBodyApplyImpulseAtWorldPoint = function(body, impulse, point)
{
    return this.runtime.ccall('chipmunk_cpBodyApplyImpulseAtWorldPoint', null, ['number', 'number', 'number', 'number', 'number'], [body, impulse.x, impulse.y, point.x, point.y]);
}

Chipmunk.prototype.cpBodyApplyImpulseAtLocalPoint = function(body, impulse, point)
{
    return this.runtime.ccall('chipmunk_cpBodyApplyImpulseAtLocalPoint', null, ['number', 'number', 'number', 'number', 'number'], [body, impulse.x, impulse.y, point.x, point.y]);
}

Chipmunk.prototype.cpSpaceNew = function()
{
    return this.runtime.ccall('cpSpaceNew', 'number');
}

Chipmunk.prototype.cpSpaceContainsBody = function(space, body)
{
    return this.runtime.ccall('cpSpaceContainsBody', 'boolean', ['number', 'number'], [space, body]);
}

Chipmunk.prototype.cpSpaceContainsShape = function(space, shape)
{
    return this.runtime.ccall('cpSpaceContainsShape', 'boolean', ['number', 'number'], [space, shape]);
}

Chipmunk.prototype.cpSpaceAddBody = function(space, body)
{
    return this.runtime.ccall('cpSpaceAddBody', null, ['number', 'number'], [space, body]);
}

Chipmunk.prototype.cpSpaceRemoveBody = function(space, body)
{
    return this.runtime.ccall('cpSpaceRemoveBody', null, ['number', 'number'], [space, body]);
}

Chipmunk.prototype.cpSpaceReindexShapesForBody = function(space, body)
{
    return this.runtime.ccall('cpSpaceReindexShapesForBody', null, ['number', 'number'], [space, body]);
}

Chipmunk.prototype.cpSpaceAddShape = function(space, shape)
{
    return this.runtime.ccall('cpSpaceAddShape', null, ['number', 'number'], [space, shape]);
}

Chipmunk.prototype.cpSpaceRemoveShape = function(space, shape)
{
    return this.runtime.ccall('cpSpaceRemoveShape', null, ['number', 'number'], [space, shape]);
}

Chipmunk.prototype.cpSpaceFree = function(space)
{
    this.runtime.ccall('cpSpaceFree', null, ['number'], [space]);
}

var chipmunk = new Chipmunk();

chipmunk.CP_VERSION_MAJOR = 7;
chipmunk.CP_VERSION_MINOR = 0;
chipmunk.CP_VERSION_RELEASE = 1;

chipmunk.CP_BODY_TYPE_DYNAMIC   = 0;
chipmunk.CP_BODY_TYPE_KINEMATIC = 1;
chipmunk.CP_BODY_TYPE_STATIC    = 2;

chipmunk.cpAreaForCircle = function cpAreaForCircle(r1, r2)
{
	return cpvlib.CP_PI * cpvlib.cpfabs(r1*r1 - r2*r2);
}

global.cpVect = cpvlib.cpVect;
global.cpShapeFilter = cpslib.cpShapeFilter;

exports.chipmunk = chipmunk;
exports.webassembly = libchipmunk;
exports.cpvlib = cpvlib;
exports.cpslib = cpslib;

}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{"../src/libchipmunk":7,"./cpShape":2,"./cpVect":3}],2:[function(require,module,exports){
const CP_NO_GROUP                = 0;
const CP_ALL_CATEGORIES          = (~0);
const CP_WILDCARD_COLLISION_TYPE = (~0);

const cpShapeFilter = function cpShapeFilter(group, categories, mask)
{
    this.group = group;
    this.categories = categories;
    this.mask = mask;
}
const cpShapeFilterNew = function cpShapeFilterNew(group, categories, mask)
{
    return new cpShapeFilter(group, categories, mask);
}

cpShapeFilter.prototype.group;
cpShapeFilter.prototype.categories;
cpShapeFilter.prototype.mask;

const CP_SHAPE_FILTER_ALL  = new cpShapeFilter(CP_NO_GROUP, CP_ALL_CATEGORIES, CP_ALL_CATEGORIES);
const CP_SHAPE_FILTER_NONE = new cpShapeFilter(CP_NO_GROUP, ~CP_ALL_CATEGORIES, ~CP_ALL_CATEGORIES);

exports.CP_NO_GROUP = CP_NO_GROUP;
exports.CP_ALL_CATEGORIES = CP_ALL_CATEGORIES;
exports.CP_WILDCARD_COLLISION_TYPE = CP_WILDCARD_COLLISION_TYPE;

exports.cpShapeFilter = cpShapeFilter;
exports.cpShapeFilterNew = cpShapeFilterNew;

exports.CP_SHAPE_FILTER_ALL = CP_SHAPE_FILTER_ALL;
exports.CP_SHAPE_FILTER_NONE = CP_SHAPE_FILTER_NONE;


},{}],3:[function(require,module,exports){
const CPFLOAT_MIN = 1e-37;
const CP_PI = Math.PI;
const cpfabs = Math.abs;
const cpfsqrt = Math.sqrt;
const cpfsin = Math.sin;
const cpfcos = Math.cos;
const cpfacos = Math.acos;
const cpfatan2 = Math.atan2;
// const cpfmod = Math.fmod;
const cpfexp = Math.exp;
const cpfpow = Math.pow;
const cpffloor = Math.floor;
const cpfceil = Math.ceil;

const cpVect = function cpVect(x, y)
{
    this.x = x;
    this.y = y;
}

cpVect.prototype.x;
cpVect.prototype.y;

const cpvzero = new cpVect(0.0, 0.0);

const cpv = function cpv(x, y)
{
    return new cpVect(x, y);
}

const cpveql = function cpveql(v1, v2)
{
	return (v1.x == v2.x && v1.y == v2.y);
}

const cpvadd = function cpvadd(v1, v2)
{
	return cpv(v1.x + v2.x, v1.y + v2.y);
}

const cpvsub = function cpvsub(v1, v2)
{
	return cpv(v1.x - v2.x, v1.y - v2.y);
}

const cpvneg = function cpvneg(v)
{
	return cpv(-v.x, -v.y);
}

const cpvmult = function cpvmult(v, s)
{
	return cpv(v.x*s, v.y*s);
}

const cpvdot = function cpvdot(v1, v2)
{
	return v1.x*v2.x + v1.y*v2.y;
}

const cpvcross = function cpvcross(v1, v2)
{
	return v1.x*v2.y - v1.y*v2.x;
}

const cpvperp = function cpvperp(v)
{
	return cpv(-v.y, v.x);
}

const cpvrperp = function cpvrperp(v)
{
	return cpv(v.y, -v.x);
}

const cpvproject = function cpvproject(v1, v2)
{
	return cpvmult(v2, cpvdot(v1, v2)/cpvdot(v2, v2));
}

const cpvforangle = function cpvforangle(a)
{
	return cpv(cpfcos(a), cpfsin(a));
}

const cpvtoangle = function cpvtoangle(v)
{
	return cpfatan2(v.y, v.x);
}

const cpvrotate = function cpvrotate(v1, v2)
{
	return cpv(v1.x*v2.x - v1.y*v2.y, v1.x*v2.y + v1.y*v2.x);
}

const cpvunrotate = function cpvunrotate(v1, v2)
{
	return cpv(v1.x*v2.x + v1.y*v2.y, v1.y*v2.x - v1.x*v2.y);
}

const cpvlengthsq = function cpvlengthsq(v)
{
	return cpvdot(v, v);
}

const cpvlength = function cpvlength(v)
{
	return cpfsqrt(cpvdot(v, v));
}

const cpvlerp = function cpvlerp(v1, v2, t)
{
	return cpvadd(cpvmult(v1, 1.0 - t), cpvmult(v2, t));
}

const cpvnormalize = function cpvnormalize(v)
{
	// Neat trick I saw somewhere to avoid div/0.
	return cpvmult(v, 1.0/(cpvlength(v) + CPFLOAT_MIN));
}

const cpvslerp = function cpvslerp(v1, v2, t)
{
	var dot = cpvdot(cpvnormalize(v1), cpvnormalize(v2));
	var omega = cpfacos(cpfclamp(dot, -1.0, 1.0));	
	if(omega < 1e-3) {
		// If the angle between two vectors is very small, lerp instead to avoid precision issues.
		return cpvlerp(v1, v2, t);
	}
    else {
		var denom = 1.0/cpfsin(omega);
		return cpvadd(cpvmult(v1, cpfsin((1.0 - t)*omega)*denom), cpvmult(v2, cpfsin(t*omega)*denom));
	}
}

const cpvslerpconst = function cpvslerpconst(v1, v2, a)
{
	var dot = cpvdot(cpvnormalize(v1), cpvnormalize(v2));
	var omega = cpfacos(cpfclamp(dot, -1.0, 1.0));
	
	return cpvslerp(v1, v2, cpfmin(a, omega)/omega);
}

const cpvclamp = function cpvclamp(v, len)
{
	return (cpvdot(v,v) > len*len) ? cpvmult(cpvnormalize(v), len) : v;
}

const cpvlerpconst = function cpvlerpconst(v1, v2, d)
{
	return cpvadd(v1, cpvclamp(cpvsub(v2, v1), d));
}

const cpvdist = function cpvdist(v1, v2)
{
	return cpvlength(cpvsub(v1, v2));
}

/// Returns the squared distance between v1 and v2. Faster than cpvdist() when you only need to compare distances.
const cpvdistsq = function cpvdistsq(v1, v2)
{
	return cpvlengthsq(cpvsub(v1, v2));
}

/// Returns true if the distance between v1 and v2 is less than dist.
const cpvnear = function cpvnear(v1, v2, dist)
{
	return cpvdistsq(v1, v2) < dist*dist;
}

exports.CPFLOAT_MIN = CPFLOAT_MIN;
exports.CP_PI = CP_PI;
exports.cpfabs = Math.abs;
exports.cpfsqrt = cpfsqrt;
exports.cpfsin = cpfsin;
exports.cpfcos = cpfcos;
exports.cpfacos = cpfacos;
exports.cpfatan2 = cpfatan2;
// exports.cpfmod = Math.fmod;
exports.cpfexp = cpfexp;
exports.cpfpow = cpfpow;
exports.cpffloor = cpffloor;
exports.cpfceil = cpfceil;

exports.cpVect = cpVect;

exports.cpvzero = cpvzero;
exports.cpv = cpv;
exports.cpveql = cpveql;
exports.cpvadd = cpvadd;
exports.cpvsub = cpvsub;
exports.cpvneg = cpvneg;
exports.cpvmult = cpvmult;
exports.cpvdot = cpvdot;
exports.cpvcross = cpvcross;
exports.cpvperp = cpvperp;
exports.cpvrperp = cpvrperp;
exports.cpvproject = cpvproject;
exports.cpvforangle = cpvforangle;
exports.cpvtoangle = cpvtoangle;
exports.cpvrotate = cpvrotate;
exports.cpvunrotate = cpvunrotate;
exports.cpvlengthsq = cpvlengthsq;
exports.cpvlength = cpvlength;
exports.cpvlerp = cpvlerp;
exports.cpvnormalize = cpvnormalize;
exports.cpvslerp = cpvslerp;
exports.cpvslerpconst = cpvslerpconst;
exports.cpvclamp = cpvclamp;
exports.cpvlerpconst = cpvlerpconst;
exports.cpvdist = cpvdist;
exports.cpvdistsq = cpvdistsq;
exports.cpvnear = cpvnear;

},{}],4:[function(require,module,exports){

},{}],5:[function(require,module,exports){
(function (process){
// .dirname, .basename, and .extname methods are extracted from Node.js v8.11.1,
// backported and transplited with Babel, with backwards-compat fixes

// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

// resolves . and .. elements in a path array with directory names there
// must be no slashes, empty elements, or device names (c:\) in the array
// (so also no leading and trailing slashes - it does not distinguish
// relative and absolute paths)
function normalizeArray(parts, allowAboveRoot) {
  // if the path tries to go above the root, `up` ends up > 0
  var up = 0;
  for (var i = parts.length - 1; i >= 0; i--) {
    var last = parts[i];
    if (last === '.') {
      parts.splice(i, 1);
    } else if (last === '..') {
      parts.splice(i, 1);
      up++;
    } else if (up) {
      parts.splice(i, 1);
      up--;
    }
  }

  // if the path is allowed to go above the root, restore leading ..s
  if (allowAboveRoot) {
    for (; up--; up) {
      parts.unshift('..');
    }
  }

  return parts;
}

// path.resolve([from ...], to)
// posix version
exports.resolve = function() {
  var resolvedPath = '',
      resolvedAbsolute = false;

  for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
    var path = (i >= 0) ? arguments[i] : process.cwd();

    // Skip empty and invalid entries
    if (typeof path !== 'string') {
      throw new TypeError('Arguments to path.resolve must be strings');
    } else if (!path) {
      continue;
    }

    resolvedPath = path + '/' + resolvedPath;
    resolvedAbsolute = path.charAt(0) === '/';
  }

  // At this point the path should be resolved to a full absolute path, but
  // handle relative paths to be safe (might happen when process.cwd() fails)

  // Normalize the path
  resolvedPath = normalizeArray(filter(resolvedPath.split('/'), function(p) {
    return !!p;
  }), !resolvedAbsolute).join('/');

  return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
};

// path.normalize(path)
// posix version
exports.normalize = function(path) {
  var isAbsolute = exports.isAbsolute(path),
      trailingSlash = substr(path, -1) === '/';

  // Normalize the path
  path = normalizeArray(filter(path.split('/'), function(p) {
    return !!p;
  }), !isAbsolute).join('/');

  if (!path && !isAbsolute) {
    path = '.';
  }
  if (path && trailingSlash) {
    path += '/';
  }

  return (isAbsolute ? '/' : '') + path;
};

// posix version
exports.isAbsolute = function(path) {
  return path.charAt(0) === '/';
};

// posix version
exports.join = function() {
  var paths = Array.prototype.slice.call(arguments, 0);
  return exports.normalize(filter(paths, function(p, index) {
    if (typeof p !== 'string') {
      throw new TypeError('Arguments to path.join must be strings');
    }
    return p;
  }).join('/'));
};


// path.relative(from, to)
// posix version
exports.relative = function(from, to) {
  from = exports.resolve(from).substr(1);
  to = exports.resolve(to).substr(1);

  function trim(arr) {
    var start = 0;
    for (; start < arr.length; start++) {
      if (arr[start] !== '') break;
    }

    var end = arr.length - 1;
    for (; end >= 0; end--) {
      if (arr[end] !== '') break;
    }

    if (start > end) return [];
    return arr.slice(start, end - start + 1);
  }

  var fromParts = trim(from.split('/'));
  var toParts = trim(to.split('/'));

  var length = Math.min(fromParts.length, toParts.length);
  var samePartsLength = length;
  for (var i = 0; i < length; i++) {
    if (fromParts[i] !== toParts[i]) {
      samePartsLength = i;
      break;
    }
  }

  var outputParts = [];
  for (var i = samePartsLength; i < fromParts.length; i++) {
    outputParts.push('..');
  }

  outputParts = outputParts.concat(toParts.slice(samePartsLength));

  return outputParts.join('/');
};

exports.sep = '/';
exports.delimiter = ':';

exports.dirname = function (path) {
  if (typeof path !== 'string') path = path + '';
  if (path.length === 0) return '.';
  var code = path.charCodeAt(0);
  var hasRoot = code === 47 /*/*/;
  var end = -1;
  var matchedSlash = true;
  for (var i = path.length - 1; i >= 1; --i) {
    code = path.charCodeAt(i);
    if (code === 47 /*/*/) {
        if (!matchedSlash) {
          end = i;
          break;
        }
      } else {
      // We saw the first non-path separator
      matchedSlash = false;
    }
  }

  if (end === -1) return hasRoot ? '/' : '.';
  if (hasRoot && end === 1) {
    // return '//';
    // Backwards-compat fix:
    return '/';
  }
  return path.slice(0, end);
};

function basename(path) {
  if (typeof path !== 'string') path = path + '';

  var start = 0;
  var end = -1;
  var matchedSlash = true;
  var i;

  for (i = path.length - 1; i >= 0; --i) {
    if (path.charCodeAt(i) === 47 /*/*/) {
        // If we reached a path separator that was not part of a set of path
        // separators at the end of the string, stop now
        if (!matchedSlash) {
          start = i + 1;
          break;
        }
      } else if (end === -1) {
      // We saw the first non-path separator, mark this as the end of our
      // path component
      matchedSlash = false;
      end = i + 1;
    }
  }

  if (end === -1) return '';
  return path.slice(start, end);
}

// Uses a mixed approach for backwards-compatibility, as ext behavior changed
// in new Node.js versions, so only basename() above is backported here
exports.basename = function (path, ext) {
  var f = basename(path);
  if (ext && f.substr(-1 * ext.length) === ext) {
    f = f.substr(0, f.length - ext.length);
  }
  return f;
};

exports.extname = function (path) {
  if (typeof path !== 'string') path = path + '';
  var startDot = -1;
  var startPart = 0;
  var end = -1;
  var matchedSlash = true;
  // Track the state of characters (if any) we see before our first dot and
  // after any path separator we find
  var preDotState = 0;
  for (var i = path.length - 1; i >= 0; --i) {
    var code = path.charCodeAt(i);
    if (code === 47 /*/*/) {
        // If we reached a path separator that was not part of a set of path
        // separators at the end of the string, stop now
        if (!matchedSlash) {
          startPart = i + 1;
          break;
        }
        continue;
      }
    if (end === -1) {
      // We saw the first non-path separator, mark this as the end of our
      // extension
      matchedSlash = false;
      end = i + 1;
    }
    if (code === 46 /*.*/) {
        // If this is our first dot, mark it as the start of our extension
        if (startDot === -1)
          startDot = i;
        else if (preDotState !== 1)
          preDotState = 1;
    } else if (startDot !== -1) {
      // We saw a non-dot and non-path separator before our dot, so we should
      // have a good chance at having a non-empty extension
      preDotState = -1;
    }
  }

  if (startDot === -1 || end === -1 ||
      // We saw a non-dot character immediately before the dot
      preDotState === 0 ||
      // The (right-most) trimmed path component is exactly '..'
      preDotState === 1 && startDot === end - 1 && startDot === startPart + 1) {
    return '';
  }
  return path.slice(startDot, end);
};

function filter (xs, f) {
    if (xs.filter) return xs.filter(f);
    var res = [];
    for (var i = 0; i < xs.length; i++) {
        if (f(xs[i], i, xs)) res.push(xs[i]);
    }
    return res;
}

// String.prototype.substr - negative index don't work in IE8
var substr = 'ab'.substr(-1) === 'b'
    ? function (str, start, len) { return str.substr(start, len) }
    : function (str, start, len) {
        if (start < 0) start = str.length + start;
        return str.substr(start, len);
    }
;

}).call(this,require('_process'))
},{"_process":6}],6:[function(require,module,exports){
// shim for using process in browser
var process = module.exports = {};

// cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
(function () {
    try {
        if (typeof setTimeout === 'function') {
            cachedSetTimeout = setTimeout;
        } else {
            cachedSetTimeout = defaultSetTimout;
        }
    } catch (e) {
        cachedSetTimeout = defaultSetTimout;
    }
    try {
        if (typeof clearTimeout === 'function') {
            cachedClearTimeout = clearTimeout;
        } else {
            cachedClearTimeout = defaultClearTimeout;
        }
    } catch (e) {
        cachedClearTimeout = defaultClearTimeout;
    }
} ())
function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}

process.nextTick = function (fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
};

// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues
process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;
process.prependListener = noop;
process.prependOnceListener = noop;

process.listeners = function (name) { return [] }

process.binding = function (name) {
    throw new Error('process.binding is not supported');
};

process.cwd = function () { return '/' };
process.chdir = function (dir) {
    throw new Error('process.chdir is not supported');
};
process.umask = function() { return 0; };

},{}],7:[function(require,module,exports){
(function (process,__dirname){

var Module = (function() {
  var _scriptDir = typeof document !== 'undefined' && document.currentScript ? document.currentScript.src : undefined;
  return (
function(Module) {
  Module = Module || {};

// Copyright 2010 The Emscripten Authors.  All rights reserved.
// Emscripten is available under two separate licenses, the MIT license and the
// University of Illinois/NCSA Open Source License.  Both these licenses can be
// found in the LICENSE file.

// The Module object: Our interface to the outside world. We import
// and export values on it. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to check if Module already exists (e.g. case 3 above).
// Substitution will be replaced with actual code on later stage of the build,
// this way Closure Compiler will not mangle it (e.g. case 4. above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module = typeof Module !== 'undefined' ? Module : {};

// --pre-jses are emitted after the Module integration code, so that they can
// refer to Module (if they choose; they can also define Module)
// {{PRE_JSES}}

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
var key;
for (key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

Module['arguments'] = [];
Module['thisProgram'] = './this.program';
Module['quit'] = function(status, toThrow) {
  throw toThrow;
};
Module['preRun'] = [];
Module['postRun'] = [];

// Determine the runtime environment we are in. You can customize this by
// setting the ENVIRONMENT setting at compile time (see settings.js).

var ENVIRONMENT_IS_WEB = false;
var ENVIRONMENT_IS_WORKER = false;
var ENVIRONMENT_IS_NODE = false;
var ENVIRONMENT_IS_SHELL = false;
ENVIRONMENT_IS_WEB = typeof window === 'object';
ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function' && !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_WORKER;
ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (Module['ENVIRONMENT']) {
  throw new Error('Module.ENVIRONMENT has been deprecated. To force the environment, use the ENVIRONMENT compile-time option (for example, -s ENVIRONMENT=web or -s ENVIRONMENT=node)');
}

// Three configurations we can be running in:
// 1) We could be the application main() thread running in the main JS UI thread. (ENVIRONMENT_IS_WORKER == false and ENVIRONMENT_IS_PTHREAD == false)
// 2) We could be the application main() thread proxied to worker. (with Emscripten -s PROXY_TO_WORKER=1) (ENVIRONMENT_IS_WORKER == true, ENVIRONMENT_IS_PTHREAD == false)
// 3) We could be an application pthread running in a worker. (ENVIRONMENT_IS_WORKER == true and ENVIRONMENT_IS_PTHREAD == true)

// `/` should be present at the end if `scriptDirectory` is not empty
var scriptDirectory = '';
function locateFile(path) {
  if (Module['locateFile']) {
    return Module['locateFile'](path, scriptDirectory);
  } else {
    return scriptDirectory + path;
  }
}

if (ENVIRONMENT_IS_NODE) {
  scriptDirectory = __dirname + '/';

  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  var nodeFS;
  var nodePath;

  Module['read'] = function shell_read(filename, binary) {
    var ret;
      if (!nodeFS) nodeFS = require('fs');
      if (!nodePath) nodePath = require('path');
      filename = nodePath['normalize'](filename);
      ret = nodeFS['readFileSync'](filename);
    return binary ? ret : ret.toString();
  };

  Module['readBinary'] = function readBinary(filename) {
    var ret = Module['read'](filename, true);
    if (!ret.buffer) {
      ret = new Uint8Array(ret);
    }
    assert(ret.buffer);
    return ret;
  };

  if (process['argv'].length > 1) {
    Module['thisProgram'] = process['argv'][1].replace(/\\/g, '/');
  }

  Module['arguments'] = process['argv'].slice(2);

  // MODULARIZE will export the module in the proper place outside, we don't need to export here

  process['on']('uncaughtException', function(ex) {
    // suppress ExitStatus exceptions from showing an error
    if (!(ex instanceof ExitStatus)) {
      throw ex;
    }
  });
  // Currently node will swallow unhandled rejections, but this behavior is
  // deprecated, and in the future it will exit with error status.
  process['on']('unhandledRejection', abort);

  Module['quit'] = function(status) {
    process['exit'](status);
  };

  Module['inspect'] = function () { return '[Emscripten Module object]'; };
} else
if (ENVIRONMENT_IS_SHELL) {


  if (typeof read != 'undefined') {
    Module['read'] = function shell_read(f) {
      return read(f);
    };
  }

  Module['readBinary'] = function readBinary(f) {
    var data;
    if (typeof readbuffer === 'function') {
      return new Uint8Array(readbuffer(f));
    }
    data = read(f, 'binary');
    assert(typeof data === 'object');
    return data;
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof quit === 'function') {
    Module['quit'] = function(status) {
      quit(status);
    }
  }
} else
if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  if (ENVIRONMENT_IS_WORKER) { // Check worker, not web, since window could be polyfilled
    scriptDirectory = self.location.href;
  } else if (document.currentScript) { // web
    scriptDirectory = document.currentScript.src;
  }
  // When MODULARIZE (and not _INSTANCE), this JS may be executed later, after document.currentScript
  // is gone, so we saved it, and we use it here instead of any other info.
  if (_scriptDir) {
    scriptDirectory = _scriptDir;
  }
  // blob urls look like blob:http://site.com/etc/etc and we cannot infer anything from them.
  // otherwise, slice off the final part of the url to find the script directory.
  // if scriptDirectory does not contain a slash, lastIndexOf will return -1,
  // and scriptDirectory will correctly be replaced with an empty string.
  if (scriptDirectory.indexOf('blob:') !== 0) {
    scriptDirectory = scriptDirectory.substr(0, scriptDirectory.lastIndexOf('/')+1);
  } else {
    scriptDirectory = '';
  }


  Module['read'] = function shell_read(url) {
      var xhr = new XMLHttpRequest();
      xhr.open('GET', url, false);
      xhr.send(null);
      return xhr.responseText;
  };

  if (ENVIRONMENT_IS_WORKER) {
    Module['readBinary'] = function readBinary(url) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, false);
        xhr.responseType = 'arraybuffer';
        xhr.send(null);
        return new Uint8Array(xhr.response);
    };
  }

  Module['readAsync'] = function readAsync(url, onload, onerror) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, true);
    xhr.responseType = 'arraybuffer';
    xhr.onload = function xhr_onload() {
      if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
        onload(xhr.response);
        return;
      }
      onerror();
    };
    xhr.onerror = onerror;
    xhr.send(null);
  };

  Module['setWindowTitle'] = function(title) { document.title = title };
} else
{
  throw new Error('environment detection error');
}

// Set up the out() and err() hooks, which are how we can print to stdout or
// stderr, respectively.
// If the user provided Module.print or printErr, use that. Otherwise,
// console.log is checked first, as 'print' on the web will open a print dialogue
// printErr is preferable to console.warn (works better in shells)
// bind(console) is necessary to fix IE/Edge closed dev tools panel behavior.
var out = Module['print'] || (typeof console !== 'undefined' ? console.log.bind(console) : (typeof print !== 'undefined' ? print : null));
var err = Module['printErr'] || (typeof printErr !== 'undefined' ? printErr : ((typeof console !== 'undefined' && console.warn.bind(console)) || out));

// Merge back in the overrides
for (key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}
// Free the object hierarchy contained in the overrides, this lets the GC
// reclaim data used e.g. in memoryInitializerRequest, which is a large typed array.
moduleOverrides = undefined;

// perform assertions in shell.js after we set up out() and err(), as otherwise if an assertion fails it cannot print the message
assert(typeof Module['memoryInitializerPrefixURL'] === 'undefined', 'Module.memoryInitializerPrefixURL option was removed, use Module.locateFile instead');
assert(typeof Module['pthreadMainPrefixURL'] === 'undefined', 'Module.pthreadMainPrefixURL option was removed, use Module.locateFile instead');
assert(typeof Module['cdInitializerPrefixURL'] === 'undefined', 'Module.cdInitializerPrefixURL option was removed, use Module.locateFile instead');
assert(typeof Module['filePackagePrefixURL'] === 'undefined', 'Module.filePackagePrefixURL option was removed, use Module.locateFile instead');



// Copyright 2017 The Emscripten Authors.  All rights reserved.
// Emscripten is available under two separate licenses, the MIT license and the
// University of Illinois/NCSA Open Source License.  Both these licenses can be
// found in the LICENSE file.

// {{PREAMBLE_ADDITIONS}}

var STACK_ALIGN = 16;

// stack management, and other functionality that is provided by the compiled code,
// should not be used before it is ready
stackSave = stackRestore = stackAlloc = function() {
  abort('cannot use the stack before compiled code is ready to run, and has provided stack access');
};

function staticAlloc(size) {
  assert(!staticSealed);
  var ret = STATICTOP;
  STATICTOP = (STATICTOP + size + 15) & -16;
  assert(STATICTOP < TOTAL_MEMORY, 'not enough memory for static allocation - increase TOTAL_MEMORY');
  return ret;
}

function dynamicAlloc(size) {
  assert(DYNAMICTOP_PTR);
  var ret = HEAP32[DYNAMICTOP_PTR>>2];
  var end = (ret + size + 15) & -16;
  HEAP32[DYNAMICTOP_PTR>>2] = end;
  if (end >= TOTAL_MEMORY) {
    var success = enlargeMemory();
    if (!success) {
      HEAP32[DYNAMICTOP_PTR>>2] = ret;
      return 0;
    }
  }
  return ret;
}

function alignMemory(size, factor) {
  if (!factor) factor = STACK_ALIGN; // stack alignment (16-byte) by default
  var ret = size = Math.ceil(size / factor) * factor;
  return ret;
}

function getNativeTypeSize(type) {
  switch (type) {
    case 'i1': case 'i8': return 1;
    case 'i16': return 2;
    case 'i32': return 4;
    case 'i64': return 8;
    case 'float': return 4;
    case 'double': return 8;
    default: {
      if (type[type.length-1] === '*') {
        return 4; // A pointer
      } else if (type[0] === 'i') {
        var bits = parseInt(type.substr(1));
        assert(bits % 8 === 0);
        return bits / 8;
      } else {
        return 0;
      }
    }
  }
}

function warnOnce(text) {
  if (!warnOnce.shown) warnOnce.shown = {};
  if (!warnOnce.shown[text]) {
    warnOnce.shown[text] = 1;
    err(text);
  }
}

var asm2wasmImports = { // special asm2wasm imports
    "f64-rem": function(x, y) {
        return x % y;
    },
    "debugger": function() {
        debugger;
    }
};



var jsCallStartIndex = 1;
var functionPointers = new Array(4);

// 'sig' parameter is only used on LLVM wasm backend
function addFunction(func, sig) {
  if (typeof sig === 'undefined') {
    err('warning: addFunction(): You should provide a wasm function signature string as a second argument. This is not necessary for asm.js and asm2wasm, but is required for the LLVM wasm backend, so it is recommended for full portability.');
  }
  var base = 0;
  for (var i = base; i < base + 4; i++) {
    if (!functionPointers[i]) {
      functionPointers[i] = func;
      return jsCallStartIndex + i;
    }
  }
  throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
}

function removeFunction(index) {
  functionPointers[index-jsCallStartIndex] = null;
}

var funcWrappers = {};

function getFuncWrapper(func, sig) {
  if (!func) return; // on null pointer, return undefined
  assert(sig);
  if (!funcWrappers[sig]) {
    funcWrappers[sig] = {};
  }
  var sigCache = funcWrappers[sig];
  if (!sigCache[func]) {
    // optimize away arguments usage in common cases
    if (sig.length === 1) {
      sigCache[func] = function dynCall_wrapper() {
        return dynCall(sig, func);
      };
    } else if (sig.length === 2) {
      sigCache[func] = function dynCall_wrapper(arg) {
        return dynCall(sig, func, [arg]);
      };
    } else {
      // general case
      sigCache[func] = function dynCall_wrapper() {
        return dynCall(sig, func, Array.prototype.slice.call(arguments));
      };
    }
  }
  return sigCache[func];
}


function makeBigInt(low, high, unsigned) {
  return unsigned ? ((+((low>>>0)))+((+((high>>>0)))*4294967296.0)) : ((+((low>>>0)))+((+((high|0)))*4294967296.0));
}

function dynCall(sig, ptr, args) {
  if (args && args.length) {
    assert(args.length == sig.length-1);
    assert(('dynCall_' + sig) in Module, 'bad function pointer type - no table for sig \'' + sig + '\'');
    return Module['dynCall_' + sig].apply(null, [ptr].concat(args));
  } else {
    assert(sig.length == 1);
    assert(('dynCall_' + sig) in Module, 'bad function pointer type - no table for sig \'' + sig + '\'');
    return Module['dynCall_' + sig].call(null, ptr);
  }
}

var tempRet0 = 0;

var setTempRet0 = function(value) {
  tempRet0 = value;
}

var getTempRet0 = function() {
  return tempRet0;
}

function getCompilerSetting(name) {
  throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for getCompilerSetting or emscripten_get_compiler_setting to work';
}

var Runtime = {
  // FIXME backwards compatibility layer for ports. Support some Runtime.*
  //       for now, fix it there, then remove it from here. That way we
  //       can minimize any period of breakage.
  dynCall: dynCall, // for SDL2 port
  // helpful errors
  getTempRet0: function() { abort('getTempRet0() is now a top-level function, after removing the Runtime object. Remove "Runtime."') },
  staticAlloc: function() { abort('staticAlloc() is now a top-level function, after removing the Runtime object. Remove "Runtime."') },
  stackAlloc: function() { abort('stackAlloc() is now a top-level function, after removing the Runtime object. Remove "Runtime."') },
};

// The address globals begin at. Very low in memory, for code size and optimization opportunities.
// Above 0 is static memory, starting with globals.
// Then the stack.
// Then 'dynamic' memory for sbrk.
var GLOBAL_BASE = 8;


// === Preamble library stuff ===

// Documentation for the public APIs defined in this file must be updated in:
//    site/source/docs/api_reference/preamble.js.rst
// A prebuilt local version of the documentation is available at:
//    site/build/text/docs/api_reference/preamble.js.txt
// You can also build docs locally as HTML or other formats in site/
// An online HTML version (which may be of a different version of Emscripten)
//    is up at http://kripken.github.io/emscripten-site/docs/api_reference/preamble.js.html


function getSafeHeapType(bytes, isFloat) {
  switch (bytes) {
    case 1: return 'i8';
    case 2: return 'i16';
    case 4: return isFloat ? 'float' : 'i32';
    case 8: return 'double';
    default: assert(0);
  }
}


function SAFE_HEAP_STORE(dest, value, bytes, isFloat) {
  if (dest <= 0) abort('segmentation fault storing ' + bytes + ' bytes to address ' + dest);
  if (dest % bytes !== 0) abort('alignment error storing to address ' + dest + ', which was expected to be aligned to a multiple of ' + bytes);
  if (staticSealed) {
    if (dest + bytes > HEAP32[DYNAMICTOP_PTR>>2]) abort('segmentation fault, exceeded the top of the available dynamic heap when storing ' + bytes + ' bytes to address ' + dest + '. STATICTOP=' + STATICTOP + ', DYNAMICTOP=' + HEAP32[DYNAMICTOP_PTR>>2]);
    assert(DYNAMICTOP_PTR);
    assert(HEAP32[DYNAMICTOP_PTR>>2] <= TOTAL_MEMORY);
  } else {
    if (dest + bytes > STATICTOP) abort('segmentation fault, exceeded the top of the available static heap when storing ' + bytes + ' bytes to address ' + dest + '. STATICTOP=' + STATICTOP);
  }
  setValue(dest, value, getSafeHeapType(bytes, isFloat), 1);
}
function SAFE_HEAP_STORE_D(dest, value, bytes) {
  SAFE_HEAP_STORE(dest, value, bytes, true);
}

function SAFE_HEAP_LOAD(dest, bytes, unsigned, isFloat) {
  if (dest <= 0) abort('segmentation fault loading ' + bytes + ' bytes from address ' + dest);
  if (dest % bytes !== 0) abort('alignment error loading from address ' + dest + ', which was expected to be aligned to a multiple of ' + bytes);
  if (staticSealed) {
    if (dest + bytes > HEAP32[DYNAMICTOP_PTR>>2]) abort('segmentation fault, exceeded the top of the available dynamic heap when loading ' + bytes + ' bytes from address ' + dest + '. STATICTOP=' + STATICTOP + ', DYNAMICTOP=' + HEAP32[DYNAMICTOP_PTR>>2]);
    assert(DYNAMICTOP_PTR);
    assert(HEAP32[DYNAMICTOP_PTR>>2] <= TOTAL_MEMORY);
  } else {
    if (dest + bytes > STATICTOP) abort('segmentation fault, exceeded the top of the available static heap when loading ' + bytes + ' bytes from address ' + dest + '. STATICTOP=' + STATICTOP);
  }
  var type = getSafeHeapType(bytes, isFloat);
  var ret = getValue(dest, type, 1);
  if (unsigned) ret = unSign(ret, parseInt(type.substr(1)), 1);
  return ret;
}
function SAFE_HEAP_LOAD_D(dest, bytes, unsigned) {
  return SAFE_HEAP_LOAD(dest, bytes, unsigned, true);
}

function SAFE_FT_MASK(value, mask) {
  var ret = value & mask;
  if (ret !== value) {
    abort('Function table mask error: function pointer is ' + value + ' which is masked by ' + mask + ', the likely cause of this is that the function pointer is being called by the wrong type.');
  }
  return ret;
}

function segfault() {
  abort('segmentation fault');
}
function alignfault() {
  abort('alignment fault');
}
function ftfault() {
  abort('Function table mask error');
}

//========================================
// Runtime essentials
//========================================

// whether we are quitting the application. no code should run after this.
// set in exit() and abort()
var ABORT = false;

// set by exit() and abort().  Passed to 'onExit' handler.
// NOTE: This is also used as the process return code code in shell environments
// but only when noExitRuntime is false.
var EXITSTATUS = 0;

/** @type {function(*, string=)} */
function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  var func = Module['_' + ident]; // closure exported function
  assert(func, 'Cannot call unknown function ' + ident + ', make sure it is exported');
  return func;
}

var JSfuncs = {
  // Helpers for cwrap -- it can't refer to Runtime directly because it might
  // be renamed by closure, instead it calls JSfuncs['stackSave'].body to find
  // out what the minified function name is.
  'stackSave': function() {
    stackSave()
  },
  'stackRestore': function() {
    stackRestore()
  },
  // type conversion from js to c
  'arrayToC' : function(arr) {
    var ret = stackAlloc(arr.length);
    writeArrayToMemory(arr, ret);
    return ret;
  },
  'stringToC' : function(str) {
    var ret = 0;
    if (str !== null && str !== undefined && str !== 0) { // null string
      // at most 4 bytes per UTF-8 code point, +1 for the trailing '\0'
      var len = (str.length << 2) + 1;
      ret = stackAlloc(len);
      stringToUTF8(str, ret, len);
    }
    return ret;
  }
};

// For fast lookup of conversion functions
var toC = {
  'string': JSfuncs['stringToC'], 'array': JSfuncs['arrayToC']
};


// C calling interface.
function ccall(ident, returnType, argTypes, args, opts) {
  function convertReturnValue(ret) {
    if (returnType === 'string') return Pointer_stringify(ret);
    if (returnType === 'boolean') return Boolean(ret);
    return ret;
  }

  var func = getCFunc(ident);
  var cArgs = [];
  var stack = 0;
  assert(returnType !== 'array', 'Return type should not be "array".');
  if (args) {
    for (var i = 0; i < args.length; i++) {
      var converter = toC[argTypes[i]];
      if (converter) {
        if (stack === 0) stack = stackSave();
        cArgs[i] = converter(args[i]);
      } else {
        cArgs[i] = args[i];
      }
    }
  }
  var ret = func.apply(null, cArgs);
  ret = convertReturnValue(ret);
  if (stack !== 0) stackRestore(stack);
  return ret;
}

function cwrap(ident, returnType, argTypes, opts) {
  return function() {
    return ccall(ident, returnType, argTypes, arguments, opts);
  }
}

/** @type {function(number, number, string, boolean=)} */
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
  if (noSafe) {
    switch(type) {
      case 'i1': HEAP8[((ptr)>>0)]=value; break;
      case 'i8': HEAP8[((ptr)>>0)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
  } else {
    switch(type) {
      case 'i1': SAFE_HEAP_STORE(((ptr)|0), ((value)|0), 1); break;
      case 'i8': SAFE_HEAP_STORE(((ptr)|0), ((value)|0), 1); break;
      case 'i16': SAFE_HEAP_STORE(((ptr)|0), ((value)|0), 2); break;
      case 'i32': SAFE_HEAP_STORE(((ptr)|0), ((value)|0), 4); break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],SAFE_HEAP_STORE(((ptr)|0), ((tempI64[0])|0), 4),SAFE_HEAP_STORE((((ptr)+(4))|0), ((tempI64[1])|0), 4)); break;
      case 'float': SAFE_HEAP_STORE_D(((ptr)|0), (+(value)), 4); break;
      case 'double': SAFE_HEAP_STORE_D(((ptr)|0), (+(value)), 8); break;
      default: abort('invalid type for setValue: ' + type);
    }
  }
}

/** @type {function(number, string, boolean=)} */
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
  if (noSafe) {
    switch(type) {
      case 'i1': return HEAP8[((ptr)>>0)];
      case 'i8': return HEAP8[((ptr)>>0)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for getValue: ' + type);
    }
  } else {
    switch(type) {
      case 'i1': return ((SAFE_HEAP_LOAD(((ptr)|0), 1, 0))|0);
      case 'i8': return ((SAFE_HEAP_LOAD(((ptr)|0), 1, 0))|0);
      case 'i16': return ((SAFE_HEAP_LOAD(((ptr)|0), 2, 0))|0);
      case 'i32': return ((SAFE_HEAP_LOAD(((ptr)|0), 4, 0))|0);
      case 'i64': return ((SAFE_HEAP_LOAD(((ptr)|0), 8, 0))|0);
      case 'float': return (+(SAFE_HEAP_LOAD_D(((ptr)|0), 4, 0)));
      case 'double': return (+(SAFE_HEAP_LOAD_D(((ptr)|0), 8, 0)));
      default: abort('invalid type for getValue: ' + type);
    }
  }
  return null;
}

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
/** @type {function((TypedArray|Array<number>|number), string, number, number=)} */
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [typeof _malloc === 'function' ? _malloc : staticAlloc, stackAlloc, staticAlloc, dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var stop;
    ptr = ret;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)>>0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(/** @type {!Uint8Array} */ (slab), ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }
    assert(type, 'Must know what type to store in allocate!');

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}

// Allocate memory during any stage of startup - static memory early on, dynamic memory later, malloc when ready
function getMemory(size) {
  if (!staticSealed) return staticAlloc(size);
  if (!runtimeInitialized) return dynamicAlloc(size);
  return _malloc(size);
}

/** @type {function(number, number=)} */
function Pointer_stringify(ptr, length) {
  if (length === 0 || !ptr) return '';
  // Find the length, and check for UTF while doing so
  var hasUtf = 0;
  var t;
  var i = 0;
  while (1) {
    assert(ptr + i < TOTAL_MEMORY);
    t = ((SAFE_HEAP_LOAD((((ptr)+(i))|0), 1, 1))|0);
    hasUtf |= t;
    if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (hasUtf < 128) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }
  return UTF8ToString(ptr);
}

// Given a pointer 'ptr' to a null-terminated ASCII-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.

function AsciiToString(ptr) {
  var str = '';
  while (1) {
    var ch = ((SAFE_HEAP_LOAD(((ptr++)|0), 1, 0))|0);
    if (!ch) return str;
    str += String.fromCharCode(ch);
  }
}

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in ASCII form. The copy will require at most str.length+1 bytes of space in the HEAP.

function stringToAscii(str, outPtr) {
  return writeAsciiToMemory(str, outPtr, false);
}

// Given a pointer 'ptr' to a null-terminated UTF8-encoded string in the given array that contains uint8 values, returns
// a copy of that string as a Javascript String object.

var UTF8Decoder = typeof TextDecoder !== 'undefined' ? new TextDecoder('utf8') : undefined;
function UTF8ArrayToString(u8Array, idx) {
  var endPtr = idx;
  // TextDecoder needs to know the byte length in advance, it doesn't stop on null terminator by itself.
  // Also, use the length info to avoid running tiny strings through TextDecoder, since .subarray() allocates garbage.
  while (u8Array[endPtr]) ++endPtr;

  if (endPtr - idx > 16 && u8Array.subarray && UTF8Decoder) {
    return UTF8Decoder.decode(u8Array.subarray(idx, endPtr));
  } else {
    var u0, u1, u2, u3, u4, u5;

    var str = '';
    while (1) {
      // For UTF8 byte structure, see:
      // http://en.wikipedia.org/wiki/UTF-8#Description
      // https://www.ietf.org/rfc/rfc2279.txt
      // https://tools.ietf.org/html/rfc3629
      u0 = u8Array[idx++];
      if (!u0) return str;
      if (!(u0 & 0x80)) { str += String.fromCharCode(u0); continue; }
      u1 = u8Array[idx++] & 63;
      if ((u0 & 0xE0) == 0xC0) { str += String.fromCharCode(((u0 & 31) << 6) | u1); continue; }
      u2 = u8Array[idx++] & 63;
      if ((u0 & 0xF0) == 0xE0) {
        u0 = ((u0 & 15) << 12) | (u1 << 6) | u2;
      } else {
        u3 = u8Array[idx++] & 63;
        if ((u0 & 0xF8) == 0xF0) {
          u0 = ((u0 & 7) << 18) | (u1 << 12) | (u2 << 6) | u3;
        } else {
          u4 = u8Array[idx++] & 63;
          if ((u0 & 0xFC) == 0xF8) {
            u0 = ((u0 & 3) << 24) | (u1 << 18) | (u2 << 12) | (u3 << 6) | u4;
          } else {
            u5 = u8Array[idx++] & 63;
            u0 = ((u0 & 1) << 30) | (u1 << 24) | (u2 << 18) | (u3 << 12) | (u4 << 6) | u5;
          }
        }
      }
      if (u0 < 0x10000) {
        str += String.fromCharCode(u0);
      } else {
        var ch = u0 - 0x10000;
        str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
      }
    }
  }
}

// Given a pointer 'ptr' to a null-terminated UTF8-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.

function UTF8ToString(ptr) {
  return UTF8ArrayToString(HEAPU8,ptr);
}

// Copies the given Javascript String object 'str' to the given byte array at address 'outIdx',
// encoded in UTF8 form and null-terminated. The copy will require at most str.length*4+1 bytes of space in the HEAP.
// Use the function lengthBytesUTF8 to compute the exact number of bytes (excluding null terminator) that this function will write.
// Parameters:
//   str: the Javascript string to copy.
//   outU8Array: the array to copy to. Each index in this array is assumed to be one 8-byte element.
//   outIdx: The starting offset in the array to begin the copying.
//   maxBytesToWrite: The maximum number of bytes this function can write to the array.
//                    This count should include the null terminator,
//                    i.e. if maxBytesToWrite=1, only the null terminator will be written and nothing else.
//                    maxBytesToWrite=0 does not write any bytes to the output, not even the null terminator.
// Returns the number of bytes written, EXCLUDING the null terminator.

function stringToUTF8Array(str, outU8Array, outIdx, maxBytesToWrite) {
  if (!(maxBytesToWrite > 0)) // Parameter maxBytesToWrite is not optional. Negative values, 0, null, undefined and false each don't write out any bytes.
    return 0;

  var startIdx = outIdx;
  var endIdx = outIdx + maxBytesToWrite - 1; // -1 for string null terminator.
  for (var i = 0; i < str.length; ++i) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! So decode UTF16->UTF32->UTF8.
    // See http://unicode.org/faq/utf_bom.html#utf16-3
    // For UTF8 byte structure, see http://en.wikipedia.org/wiki/UTF-8#Description and https://www.ietf.org/rfc/rfc2279.txt and https://tools.ietf.org/html/rfc3629
    var u = str.charCodeAt(i); // possibly a lead surrogate
    if (u >= 0xD800 && u <= 0xDFFF) {
      var u1 = str.charCodeAt(++i);
      u = 0x10000 + ((u & 0x3FF) << 10) | (u1 & 0x3FF);
    }
    if (u <= 0x7F) {
      if (outIdx >= endIdx) break;
      outU8Array[outIdx++] = u;
    } else if (u <= 0x7FF) {
      if (outIdx + 1 >= endIdx) break;
      outU8Array[outIdx++] = 0xC0 | (u >> 6);
      outU8Array[outIdx++] = 0x80 | (u & 63);
    } else if (u <= 0xFFFF) {
      if (outIdx + 2 >= endIdx) break;
      outU8Array[outIdx++] = 0xE0 | (u >> 12);
      outU8Array[outIdx++] = 0x80 | ((u >> 6) & 63);
      outU8Array[outIdx++] = 0x80 | (u & 63);
    } else if (u <= 0x1FFFFF) {
      if (outIdx + 3 >= endIdx) break;
      outU8Array[outIdx++] = 0xF0 | (u >> 18);
      outU8Array[outIdx++] = 0x80 | ((u >> 12) & 63);
      outU8Array[outIdx++] = 0x80 | ((u >> 6) & 63);
      outU8Array[outIdx++] = 0x80 | (u & 63);
    } else if (u <= 0x3FFFFFF) {
      if (outIdx + 4 >= endIdx) break;
      outU8Array[outIdx++] = 0xF8 | (u >> 24);
      outU8Array[outIdx++] = 0x80 | ((u >> 18) & 63);
      outU8Array[outIdx++] = 0x80 | ((u >> 12) & 63);
      outU8Array[outIdx++] = 0x80 | ((u >> 6) & 63);
      outU8Array[outIdx++] = 0x80 | (u & 63);
    } else {
      if (outIdx + 5 >= endIdx) break;
      outU8Array[outIdx++] = 0xFC | (u >> 30);
      outU8Array[outIdx++] = 0x80 | ((u >> 24) & 63);
      outU8Array[outIdx++] = 0x80 | ((u >> 18) & 63);
      outU8Array[outIdx++] = 0x80 | ((u >> 12) & 63);
      outU8Array[outIdx++] = 0x80 | ((u >> 6) & 63);
      outU8Array[outIdx++] = 0x80 | (u & 63);
    }
  }
  // Null-terminate the pointer to the buffer.
  outU8Array[outIdx] = 0;
  return outIdx - startIdx;
}

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF8 form. The copy will require at most str.length*4+1 bytes of space in the HEAP.
// Use the function lengthBytesUTF8 to compute the exact number of bytes (excluding null terminator) that this function will write.
// Returns the number of bytes written, EXCLUDING the null terminator.

function stringToUTF8(str, outPtr, maxBytesToWrite) {
  assert(typeof maxBytesToWrite == 'number', 'stringToUTF8(str, outPtr, maxBytesToWrite) is missing the third parameter that specifies the length of the output buffer!');
  return stringToUTF8Array(str, HEAPU8,outPtr, maxBytesToWrite);
}

// Returns the number of bytes the given Javascript string takes if encoded as a UTF8 byte array, EXCLUDING the null terminator byte.

function lengthBytesUTF8(str) {
  var len = 0;
  for (var i = 0; i < str.length; ++i) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! So decode UTF16->UTF32->UTF8.
    // See http://unicode.org/faq/utf_bom.html#utf16-3
    var u = str.charCodeAt(i); // possibly a lead surrogate
    if (u >= 0xD800 && u <= 0xDFFF) u = 0x10000 + ((u & 0x3FF) << 10) | (str.charCodeAt(++i) & 0x3FF);
    if (u <= 0x7F) {
      ++len;
    } else if (u <= 0x7FF) {
      len += 2;
    } else if (u <= 0xFFFF) {
      len += 3;
    } else if (u <= 0x1FFFFF) {
      len += 4;
    } else if (u <= 0x3FFFFFF) {
      len += 5;
    } else {
      len += 6;
    }
  }
  return len;
}

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.

var UTF16Decoder = typeof TextDecoder !== 'undefined' ? new TextDecoder('utf-16le') : undefined;
function UTF16ToString(ptr) {
  assert(ptr % 2 == 0, 'Pointer passed to UTF16ToString must be aligned to two bytes!');
  var endPtr = ptr;
  // TextDecoder needs to know the byte length in advance, it doesn't stop on null terminator by itself.
  // Also, use the length info to avoid running tiny strings through TextDecoder, since .subarray() allocates garbage.
  var idx = endPtr >> 1;
  while (HEAP16[idx]) ++idx;
  endPtr = idx << 1;

  if (endPtr - ptr > 32 && UTF16Decoder) {
    return UTF16Decoder.decode(HEAPU8.subarray(ptr, endPtr));
  } else {
    var i = 0;

    var str = '';
    while (1) {
      var codeUnit = ((SAFE_HEAP_LOAD((((ptr)+(i*2))|0), 2, 0))|0);
      if (codeUnit == 0) return str;
      ++i;
      // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
      str += String.fromCharCode(codeUnit);
    }
  }
}

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16 form. The copy will require at most str.length*4+2 bytes of space in the HEAP.
// Use the function lengthBytesUTF16() to compute the exact number of bytes (excluding null terminator) that this function will write.
// Parameters:
//   str: the Javascript string to copy.
//   outPtr: Byte address in Emscripten HEAP where to write the string to.
//   maxBytesToWrite: The maximum number of bytes this function can write to the array. This count should include the null
//                    terminator, i.e. if maxBytesToWrite=2, only the null terminator will be written and nothing else.
//                    maxBytesToWrite<2 does not write any bytes to the output, not even the null terminator.
// Returns the number of bytes written, EXCLUDING the null terminator.

function stringToUTF16(str, outPtr, maxBytesToWrite) {
  assert(outPtr % 2 == 0, 'Pointer passed to stringToUTF16 must be aligned to two bytes!');
  assert(typeof maxBytesToWrite == 'number', 'stringToUTF16(str, outPtr, maxBytesToWrite) is missing the third parameter that specifies the length of the output buffer!');
  // Backwards compatibility: if max bytes is not specified, assume unsafe unbounded write is allowed.
  if (maxBytesToWrite === undefined) {
    maxBytesToWrite = 0x7FFFFFFF;
  }
  if (maxBytesToWrite < 2) return 0;
  maxBytesToWrite -= 2; // Null terminator.
  var startPtr = outPtr;
  var numCharsToWrite = (maxBytesToWrite < str.length*2) ? (maxBytesToWrite / 2) : str.length;
  for (var i = 0; i < numCharsToWrite; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    SAFE_HEAP_STORE(((outPtr)|0), ((codeUnit)|0), 2);
    outPtr += 2;
  }
  // Null-terminate the pointer to the HEAP.
  SAFE_HEAP_STORE(((outPtr)|0), ((0)|0), 2);
  return outPtr - startPtr;
}

// Returns the number of bytes the given Javascript string takes if encoded as a UTF16 byte array, EXCLUDING the null terminator byte.

function lengthBytesUTF16(str) {
  return str.length*2;
}

function UTF32ToString(ptr) {
  assert(ptr % 4 == 0, 'Pointer passed to UTF32ToString must be aligned to four bytes!');
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = ((SAFE_HEAP_LOAD((((ptr)+(i*4))|0), 4, 0))|0);
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    // See http://unicode.org/faq/utf_bom.html#utf16-3
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32 form. The copy will require at most str.length*4+4 bytes of space in the HEAP.
// Use the function lengthBytesUTF32() to compute the exact number of bytes (excluding null terminator) that this function will write.
// Parameters:
//   str: the Javascript string to copy.
//   outPtr: Byte address in Emscripten HEAP where to write the string to.
//   maxBytesToWrite: The maximum number of bytes this function can write to the array. This count should include the null
//                    terminator, i.e. if maxBytesToWrite=4, only the null terminator will be written and nothing else.
//                    maxBytesToWrite<4 does not write any bytes to the output, not even the null terminator.
// Returns the number of bytes written, EXCLUDING the null terminator.

function stringToUTF32(str, outPtr, maxBytesToWrite) {
  assert(outPtr % 4 == 0, 'Pointer passed to stringToUTF32 must be aligned to four bytes!');
  assert(typeof maxBytesToWrite == 'number', 'stringToUTF32(str, outPtr, maxBytesToWrite) is missing the third parameter that specifies the length of the output buffer!');
  // Backwards compatibility: if max bytes is not specified, assume unsafe unbounded write is allowed.
  if (maxBytesToWrite === undefined) {
    maxBytesToWrite = 0x7FFFFFFF;
  }
  if (maxBytesToWrite < 4) return 0;
  var startPtr = outPtr;
  var endPtr = startPtr + maxBytesToWrite - 4;
  for (var i = 0; i < str.length; ++i) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    // See http://unicode.org/faq/utf_bom.html#utf16-3
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++i);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    SAFE_HEAP_STORE(((outPtr)|0), ((codeUnit)|0), 4);
    outPtr += 4;
    if (outPtr + 4 > endPtr) break;
  }
  // Null-terminate the pointer to the HEAP.
  SAFE_HEAP_STORE(((outPtr)|0), ((0)|0), 4);
  return outPtr - startPtr;
}

// Returns the number of bytes the given Javascript string takes if encoded as a UTF16 byte array, EXCLUDING the null terminator byte.

function lengthBytesUTF32(str) {
  var len = 0;
  for (var i = 0; i < str.length; ++i) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    // See http://unicode.org/faq/utf_bom.html#utf16-3
    var codeUnit = str.charCodeAt(i);
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) ++i; // possibly a lead surrogate, so skip over the tail surrogate.
    len += 4;
  }

  return len;
}

// Allocate heap space for a JS string, and write it there.
// It is the responsibility of the caller to free() that memory.
function allocateUTF8(str) {
  var size = lengthBytesUTF8(str) + 1;
  var ret = _malloc(size);
  if (ret) stringToUTF8Array(str, HEAP8, ret, size);
  return ret;
}

// Allocate stack space for a JS string, and write it there.
function allocateUTF8OnStack(str) {
  var size = lengthBytesUTF8(str) + 1;
  var ret = stackAlloc(size);
  stringToUTF8Array(str, HEAP8, ret, size);
  return ret;
}

function demangle(func) {
  warnOnce('warning: build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling');
  return func;
}

function demangleAll(text) {
  var regex =
    /__Z[\w\d_]+/g;
  return text.replace(regex,
    function(x) {
      var y = demangle(x);
      return x === y ? x : (y + ' [' + x + ']');
    });
}

function jsStackTrace() {
  var err = new Error();
  if (!err.stack) {
    // IE10+ special cases: It does have callstack info, but it is only populated if an Error object is thrown,
    // so try that as a special-case.
    try {
      throw new Error(0);
    } catch(e) {
      err = e;
    }
    if (!err.stack) {
      return '(no stack trace available)';
    }
  }
  return err.stack.toString();
}

function stackTrace() {
  var js = jsStackTrace();
  if (Module['extraStackTrace']) js += '\n' + Module['extraStackTrace']();
  return demangleAll(js);
}

// Memory management

var PAGE_SIZE = 16384;
var WASM_PAGE_SIZE = 65536;
var ASMJS_PAGE_SIZE = 16777216;
var MIN_TOTAL_MEMORY = 16777216;

function alignUp(x, multiple) {
  if (x % multiple > 0) {
    x += multiple - (x % multiple);
  }
  return x;
}

var HEAP,
/** @type {ArrayBuffer} */
  buffer,
/** @type {Int8Array} */
  HEAP8,
/** @type {Uint8Array} */
  HEAPU8,
/** @type {Int16Array} */
  HEAP16,
/** @type {Uint16Array} */
  HEAPU16,
/** @type {Int32Array} */
  HEAP32,
/** @type {Uint32Array} */
  HEAPU32,
/** @type {Float32Array} */
  HEAPF32,
/** @type {Float64Array} */
  HEAPF64;

function updateGlobalBuffer(buf) {
  Module['buffer'] = buffer = buf;
}

function updateGlobalBufferViews() {
  Module['HEAP8'] = HEAP8 = new Int8Array(buffer);
  Module['HEAP16'] = HEAP16 = new Int16Array(buffer);
  Module['HEAP32'] = HEAP32 = new Int32Array(buffer);
  Module['HEAPU8'] = HEAPU8 = new Uint8Array(buffer);
  Module['HEAPU16'] = HEAPU16 = new Uint16Array(buffer);
  Module['HEAPU32'] = HEAPU32 = new Uint32Array(buffer);
  Module['HEAPF32'] = HEAPF32 = new Float32Array(buffer);
  Module['HEAPF64'] = HEAPF64 = new Float64Array(buffer);
}

var STATIC_BASE, STATICTOP, staticSealed; // static area
var STACK_BASE, STACKTOP, STACK_MAX; // stack area
var DYNAMIC_BASE, DYNAMICTOP_PTR; // dynamic area handled by sbrk

  STATIC_BASE = STATICTOP = STACK_BASE = STACKTOP = STACK_MAX = DYNAMIC_BASE = DYNAMICTOP_PTR = 0;
  staticSealed = false;


// Initializes the stack cookie. Called at the startup of main and at the startup of each thread in pthreads mode.
function writeStackCookie() {
  assert((STACK_MAX & 3) == 0);
  HEAPU32[(STACK_MAX >> 2)-1] = 0x02135467;
  HEAPU32[(STACK_MAX >> 2)-2] = 0x89BACDFE;
}

function checkStackCookie() {
  if (HEAPU32[(STACK_MAX >> 2)-1] != 0x02135467 || HEAPU32[(STACK_MAX >> 2)-2] != 0x89BACDFE) {
    abort('Stack overflow! Stack cookie has been overwritten, expected hex dwords 0x89BACDFE and 0x02135467, but received 0x' + HEAPU32[(STACK_MAX >> 2)-2].toString(16) + ' ' + HEAPU32[(STACK_MAX >> 2)-1].toString(16));
  }
  // Also test the global address 0 for integrity.
  if (HEAP32[0] !== 0x63736d65 /* 'emsc' */) throw 'Runtime error: The application has corrupted its heap memory area (address zero)!';
}

function abortStackOverflow(allocSize) {
  abort('Stack overflow! Attempted to allocate ' + allocSize + ' bytes on the stack, but stack has only ' + (STACK_MAX - stackSave() + allocSize) + ' bytes available!');
}


function abortOnCannotGrowMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with  -s TOTAL_MEMORY=X  with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with  -s ALLOW_MEMORY_GROWTH=1  which allows increasing the size at runtime but prevents some optimizations, (3) set Module.TOTAL_MEMORY to a higher value before the program runs, or (4) if you want malloc to return NULL (0) instead of this abort, compile with  -s ABORTING_MALLOC=0 ');
}


function enlargeMemory() {
  abortOnCannotGrowMemory();
}


var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 16777216;
if (TOTAL_MEMORY < TOTAL_STACK) err('TOTAL_MEMORY should be larger than TOTAL_STACK, was ' + TOTAL_MEMORY + '! (TOTAL_STACK=' + TOTAL_STACK + ')');

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && Int32Array.prototype.subarray !== undefined && Int32Array.prototype.set !== undefined,
       'JS engine does not provide full typed array support');



// Use a provided buffer, if there is one, or else allocate a new one
if (Module['buffer']) {
  buffer = Module['buffer'];
  assert(buffer.byteLength === TOTAL_MEMORY, 'provided buffer should be ' + TOTAL_MEMORY + ' bytes, but it is ' + buffer.byteLength);
} else {
  // Use a WebAssembly memory where available
  {
    buffer = new ArrayBuffer(TOTAL_MEMORY);
  }
  assert(buffer.byteLength === TOTAL_MEMORY);
  Module['buffer'] = buffer;
}
updateGlobalBufferViews();


function getTotalMemory() {
  return TOTAL_MEMORY;
}

// Endianness check (note: assumes compiler arch was little-endian)
  HEAP32[0] = 0x63736d65; /* 'emsc' */
HEAP16[1] = 0x6373;
if (HEAPU8[2] !== 0x73 || HEAPU8[3] !== 0x63) throw 'Runtime error: expected the system to be little-endian!';

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Module['dynCall_v'](func);
      } else {
        Module['dynCall_vi'](func, callback.arg);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the main() is called

var runtimeInitialized = false;
var runtimeExited = false;


function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  checkStackCookie();
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  checkStackCookie();
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  checkStackCookie();
  callRuntimeCallbacks(__ATEXIT__);
  runtimeExited = true;
}

function postRun() {
  checkStackCookie();
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}

// Deprecated: This function should not be called because it is unsafe and does not provide
// a maximum length limit of how many bytes it is allowed to write. Prefer calling the
// function stringToUTF8Array() instead, which takes in a maximum length that can be used
// to be secure from out of bounds writes.
/** @deprecated */
function writeStringToMemory(string, buffer, dontAddNull) {
  warnOnce('writeStringToMemory is deprecated and should not be called! Use stringToUTF8() instead!');

  var /** @type {number} */ lastChar, /** @type {number} */ end;
  if (dontAddNull) {
    // stringToUTF8Array always appends null. If we don't want to do that, remember the
    // character that existed at the location where the null will be placed, and restore
    // that after the write (below).
    end = buffer + lengthBytesUTF8(string);
    lastChar = HEAP8[end];
  }
  stringToUTF8(string, buffer, Infinity);
  if (dontAddNull) HEAP8[end] = lastChar; // Restore the value under the null character.
}

function writeArrayToMemory(array, buffer) {
  assert(array.length >= 0, 'writeArrayToMemory array must have a length (should be an array or typed array)')
  HEAP8.set(array, buffer);
}

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; ++i) {
    assert(str.charCodeAt(i) === str.charCodeAt(i)&0xff);
    SAFE_HEAP_STORE(((buffer++)|0), ((str.charCodeAt(i))|0), 1);
  }
  // Null-terminate the pointer to the HEAP.
  if (!dontAddNull) SAFE_HEAP_STORE(((buffer)|0), ((0)|0), 1);
}

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

assert(Math.imul, 'This browser does not support Math.imul(), build with LEGACY_VM_SUPPORT or POLYFILL_OLD_MATH_FUNCTIONS to add in a polyfill');
assert(Math.fround, 'This browser does not support Math.fround(), build with LEGACY_VM_SUPPORT or POLYFILL_OLD_MATH_FUNCTIONS to add in a polyfill');
assert(Math.clz32, 'This browser does not support Math.clz32(), build with LEGACY_VM_SUPPORT or POLYFILL_OLD_MATH_FUNCTIONS to add in a polyfill');
assert(Math.trunc, 'This browser does not support Math.trunc(), build with LEGACY_VM_SUPPORT or POLYFILL_OLD_MATH_FUNCTIONS to add in a polyfill');

var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_round = Math.round;
var Math_min = Math.min;
var Math_max = Math.max;
var Math_clz32 = Math.clz32;
var Math_trunc = Math.trunc;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// Module.preRun (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled
var runDependencyTracking = {};

function getUniqueRunDependency(id) {
  var orig = id;
  while (1) {
    if (!runDependencyTracking[id]) return id;
    id = orig + Math.random();
  }
  return id;
}

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (id) {
    assert(!runDependencyTracking[id]);
    runDependencyTracking[id] = 1;
    if (runDependencyWatcher === null && typeof setInterval !== 'undefined') {
      // Check for missing dependencies every few seconds
      runDependencyWatcher = setInterval(function() {
        if (ABORT) {
          clearInterval(runDependencyWatcher);
          runDependencyWatcher = null;
          return;
        }
        var shown = false;
        for (var dep in runDependencyTracking) {
          if (!shown) {
            shown = true;
            err('still waiting on run dependencies:');
          }
          err('dependency: ' + dep);
        }
        if (shown) {
          err('(end of list)');
        }
      }, 10000);
    }
  } else {
    err('warning: run dependency added without ID');
  }
}

function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (id) {
    assert(runDependencyTracking[id]);
    delete runDependencyTracking[id];
  } else {
    err('warning: run dependency removed without ID');
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data



var memoryInitializer = null;



var /* show errors on likely calls to FS when it was not included */ FS = {
  error: function() {
    abort('Filesystem support (FS) was not included. The problem is that you are using files from JS, but files were not used from C/C++, so filesystem support was not auto-included. You can force-include filesystem support with  -s FORCE_FILESYSTEM=1');
  },
  init: function() { FS.error() },
  createDataFile: function() { FS.error() },
  createPreloadedFile: function() { FS.error() },
  createLazyFile: function() { FS.error() },
  open: function() { FS.error() },
  mkdev: function() { FS.error() },
  registerDevice: function() { FS.error() },
  analyzePath: function() { FS.error() },
  loadFilesFromDB: function() { FS.error() },

  ErrnoError: function ErrnoError() { FS.error() },
};
Module['FS_createDataFile'] = FS.createDataFile;
Module['FS_createPreloadedFile'] = FS.createPreloadedFile;



// Copyright 2017 The Emscripten Authors.  All rights reserved.
// Emscripten is available under two separate licenses, the MIT license and the
// University of Illinois/NCSA Open Source License.  Both these licenses can be
// found in the LICENSE file.

// Prefix of data URIs emitted by SINGLE_FILE and related options.
var dataURIPrefix = 'data:application/octet-stream;base64,';

// Indicates whether filename is a base64 data URI.
function isDataURI(filename) {
  return String.prototype.startsWith ?
      filename.startsWith(dataURIPrefix) :
      filename.indexOf(dataURIPrefix) === 0;
}





// === Body ===

var ASM_CONSTS = [];





STATIC_BASE = GLOBAL_BASE;

STATICTOP = STATIC_BASE + 11888;
/* global initializers */  __ATINIT__.push();


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,16,0,0,0,17,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,17,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,13,0,0,0,23,0,0,0,47,0,0,0,97,0,0,0,193,0,0,0,133,1,0,0,1,3,0,0,7,6,0,0,7,12,0,0,7,24,0,0,1,48,0,0,17,96,0,0,5,192,0,0,13,128,1,0,5,0,3,0,25,0,6,0,1,0,12,0,5,0,24,0,11,0,48,0,13,0,96,0,5,0,192,0,19,0,128,1,5,0,0,3,23,0,0,6,19,0,0,12,5,0,0,24,89,0,0,48,5,0,0,96,0,0,0,0,0,0,0,0,0,0,0,0,17,0,10,0,17,17,17,0,0,0,0,5,0,0,0,0,0,0,9,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,15,10,17,17,17,3,10,7,0,1,19,9,11,11,0,0,9,6,11,0,0,11,0,6,17,0,0,0,17,17,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,10,10,17,17,17,0,10,0,0,2,0,9,11,0,0,0,9,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,4,13,0,0,0,0,9,14,0,0,0,0,0,14,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,15,0,0,0,0,9,16,0,0,0,0,0,16,0,0,16,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,10,0,0,0,0,9,11,0,0,0,0,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,84,33,34,25,13,1,2,3,17,75,28,12,16,4,11,29,18,30,39,104,110,111,112,113,98,32,5,6,15,19,20,21,26,8,22,7,40,36,23,24,9,10,14,27,31,37,35,131,130,125,38,42,43,60,61,62,63,67,71,74,77,88,89,90,91,92,93,94,95,96,97,99,100,101,102,103,105,106,107,108,114,115,116,121,122,123,124,0,0,0,0,0,0,0,0,0,73,108,108,101,103,97,108,32,98,121,116,101,32,115,101,113,117,101,110,99,101,0,68,111,109,97,105,110,32,101,114,114,111,114,0,82,101,115,117,108,116,32,110,111,116,32,114,101,112,114,101,115,101,110,116,97,98,108,101,0,78,111,116,32,97,32,116,116,121,0,80,101,114,109,105,115,115,105,111,110,32,100,101,110,105,101,100,0,79,112,101,114,97,116,105,111,110,32,110,111,116,32,112,101,114,109,105,116,116,101,100,0,78,111,32,115,117,99,104,32,102,105,108,101,32,111,114,32,100,105,114,101,99,116,111,114,121,0,78,111,32,115,117,99,104,32,112,114,111,99,101,115,115,0,70,105,108,101,32,101,120,105,115,116,115,0,86,97,108,117,101,32,116,111,111,32,108,97,114,103,101,32,102,111,114,32,100,97,116,97,32,116,121,112,101,0,78,111,32,115,112,97,99,101,32,108,101,102,116,32,111,110,32,100,101,118,105,99,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,115,111,117,114,99,101,32,98,117,115,121,0,73,110,116,101,114,114,117,112,116,101,100,32,115,121,115,116,101,109,32,99,97,108,108,0,82,101,115,111,117,114,99,101,32,116,101,109,112,111,114,97,114,105,108,121,32,117,110,97,118,97,105,108,97,98,108,101,0,73,110,118,97,108,105,100,32,115,101,101,107,0,67,114,111,115,115,45,100,101,118,105,99,101,32,108,105,110,107,0,82,101,97,100,45,111,110,108,121,32,102,105,108,101,32,115,121,115,116,101,109,0,68,105,114,101,99,116,111,114,121,32,110,111,116,32,101,109,112,116,121,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,112,101,101,114,0,79,112,101,114,97,116,105,111,110,32,116,105,109,101,100,32,111,117,116,0,67,111,110,110,101,99,116,105,111,110,32,114,101,102,117,115,101,100,0,72,111,115,116,32,105,115,32,100,111,119,110,0,72,111,115,116,32,105,115,32,117,110,114,101,97,99,104,97,98,108,101,0,65,100,100,114,101,115,115,32,105,110,32,117,115,101,0,66,114,111,107,101,110,32,112,105,112,101,0,73,47,79,32,101,114,114,111,114,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,32,111,114,32,97,100,100,114,101,115,115,0,66,108,111,99,107,32,100,101,118,105,99,101,32,114,101,113,117,105,114,101,100,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,0,78,111,116,32,97,32,100,105,114,101,99,116,111,114,121,0,73,115,32,97,32,100,105,114,101,99,116,111,114,121,0,84,101,120,116,32,102,105,108,101,32,98,117,115,121,0,69,120,101,99,32,102,111,114,109,97,116,32,101,114,114,111,114,0,73,110,118,97,108,105,100,32,97,114,103,117,109,101,110,116,0,65,114,103,117,109,101,110,116,32,108,105,115,116,32,116,111,111,32,108,111,110,103,0,83,121,109,98,111,108,105,99,32,108,105,110,107,32,108,111,111,112,0,70,105,108,101,110,97,109,101,32,116,111,111,32,108,111,110,103,0,84,111,111,32,109,97,110,121,32,111,112,101,110,32,102,105,108,101,115,32,105,110,32,115,121,115,116,101,109,0,78,111,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,115,32,97,118,97,105,108,97,98,108,101,0,66,97,100,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,0,78,111,32,99,104,105,108,100,32,112,114,111,99,101,115,115,0,66,97,100,32,97,100,100,114,101,115,115,0,70,105,108,101,32,116,111,111,32,108,97,114,103,101,0,84,111,111,32,109,97,110,121,32,108,105,110,107,115,0,78,111,32,108,111,99,107,115,32,97,118,97,105,108,97,98,108,101,0,82,101,115,111,117,114,99,101,32,100,101,97,100,108,111,99,107,32,119,111,117,108,100,32,111,99,99,117,114,0,83,116,97,116,101,32,110,111,116,32,114,101,99,111,118,101,114,97,98,108,101,0,80,114,101,118,105,111,117,115,32,111,119,110,101,114,32,100,105,101,100,0,79,112,101,114,97,116,105,111,110,32,99,97,110,99,101,108,101,100,0,70,117,110,99,116,105,111,110,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,78,111,32,109,101,115,115,97,103,101,32,111,102,32,100,101,115,105,114,101,100,32,116,121,112,101,0,73,100,101,110,116,105,102,105,101,114,32,114,101,109,111,118,101,100,0,68,101,118,105,99,101,32,110,111,116,32,97,32,115,116,114,101,97,109,0,78,111,32,100,97,116,97,32,97,118,97,105,108,97,98,108,101,0,68,101,118,105,99,101,32,116,105,109,101,111,117,116,0,79,117,116,32,111,102,32,115,116,114,101,97,109,115,32,114,101,115,111,117,114,99,101,115,0,76,105,110,107,32,104,97,115,32,98,101,101,110,32,115,101,118,101,114,101,100,0,80,114,111,116,111,99,111,108,32,101,114,114,111,114,0,66,97,100,32,109,101,115,115,97,103,101,0,70,105,108,101,32,100,101,115,99,114,105,112,116,111,114,32,105,110,32,98,97,100,32,115,116,97,116,101,0,78,111,116,32,97,32,115,111,99,107,101,116,0,68,101,115,116,105,110,97,116,105,111,110,32,97,100,100,114,101,115,115,32,114,101,113,117,105,114,101,100,0,77,101,115,115,97,103,101,32,116,111,111,32,108,97,114,103,101,0,80,114,111,116,111,99,111,108,32,119,114,111,110,103,32,116,121,112,101,32,102,111,114,32,115,111,99,107,101,116,0,80,114,111,116,111,99,111,108,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,80,114,111,116,111,99,111,108,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,83,111,99,107,101,116,32,116,121,112,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,111,116,32,115,117,112,112,111,114,116,101,100,0,80,114,111,116,111,99,111,108,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,65,100,100,114,101,115,115,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,112,114,111,116,111,99,111,108,0,65,100,100,114,101,115,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,78,101,116,119,111,114,107,32,105,115,32,100,111,119,110,0,78,101,116,119,111,114,107,32,117,110,114,101,97,99,104,97,98,108,101,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,110,101,116,119,111,114,107,0,67,111,110,110,101,99,116,105,111,110,32,97,98,111,114,116,101,100,0,78,111,32,98,117,102,102,101,114,32,115,112,97,99,101,32,97,118,97,105,108,97,98,108,101,0,83,111,99,107,101,116,32,105,115,32,99,111,110,110,101,99,116,101,100,0,83,111,99,107,101,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,67,97,110,110,111,116,32,115,101,110,100,32,97,102,116,101,114,32,115,111,99,107,101,116,32,115,104,117,116,100,111,119,110,0,79,112,101,114,97,116,105,111,110,32,97,108,114,101,97,100,121,32,105,110,32,112,114,111,103,114,101,115,115,0,79,112,101,114,97,116,105,111,110,32,105,110,32,112,114,111,103,114,101,115,115,0,83,116,97,108,101,32,102,105,108,101,32,104,97,110,100,108,101,0,82,101,109,111,116,101,32,73,47,79,32,101,114,114,111,114,0,81,117,111,116,97,32,101,120,99,101,101,100,101,100,0,78,111,32,109,101,100,105,117,109,32,102,111,117,110,100,0,87,114,111,110,103,32,109,101,100,105,117,109,32,116,121,112,101,0,78,111,32,101,114,114,111,114,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,2,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,0,0,0,0,31,0,0,0,0,0,0,0,32,0,0,0,33,0,0,0,1,0,0,0,34,0,0,0,0,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,255,255,255,255,255,255,255,255,41,0,0,0,41,0,0,0,42,0,0,0,42,0,0,0,0,0,0,0,184,10,0,0,5,0,0,0,0,0,0,0,0,0,0,0,43,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,44,0,0,0,45,0,0,0,105,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,11,0,0,5,0,0,0,0,0,0,0,0,0,0,0,43,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,46,0,0,0,45,0,0,0,216,39,0,0,0,4,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,55,46,48,46,50,0,65,98,111,114,116,105,110,103,32,100,117,101,32,116,111,32,67,104,105,112,109,117,110,107,32,101,114,114,111,114,58,32,0,67,104,105,112,109,117,110,107,32,119,97,114,110,105,110,103,58,32,0,10,0,9,70,97,105,108,101,100,32,99,111,110,100,105,116,105,111,110,58,32,37,115,10,0,9,83,111,117,114,99,101,58,37,115,58,37,100,10,0,47,85,115,101,114,115,47,120,105,111,110,103,119,101,110,106,105,101,47,68,111,99,117,109,101,110,116,115,47,71,73,84,115,47,67,104,105,112,109,117,110,107,50,68,47,115,114,99,47,99,112,66,66,84,114,101,101,46,99,0,33,78,111,100,101,73,115,76,101,97,102,40,112,97,114,101,110,116,41,0,73,110,116,101,114,110,97,108,32,69,114,114,111,114,58,32,67,97,110,110,111,116,32,114,101,112,108,97,99,101,32,99,104,105,108,100,32,111,102,32,97,32,108,101,97,102,46,0,99,104,105,108,100,32,61,61,32,112,97,114,101,110,116,45,62,65,32,124,124,32,99,104,105,108,100,32,61,61,32,112,97,114,101,110,116,45,62,66,0,73,110,116,101,114,110,97,108,32,69,114,114,111,114,58,32,78,111,100,101,32,105,115,32,110,111,116,32,97,32,99,104,105,108,100,32,111,102,32,112,97,114,101,110,116,46,0,73,103,110,111,114,105,110,103,32,99,112,66,66,84,114,101,101,83,101,116,86,101,108,111,99,105,116,121,70,117,110,99,40,41,32,99,97,108,108,32,116,111,32,110,111,110,45,116,114,101,101,32,115,112,97,116,105,97,108,32,105,110,100,101,120,46,0,98,111,100,121,45,62,109,32,61,61,32,98,111,100,121,45,62,109,32,38,38,32,98,111,100,121,45,62,109,95,105,110,118,32,61,61,32,98,111,100,121,45,62,109,95,105,110,118,0,47,85,115,101,114,115,47,120,105,111,110,103,119,101,110,106,105,101,47,68,111,99,117,109,101,110,116,115,47,71,73,84,115,47,67,104,105,112,109,117,110,107,50,68,47,115,114,99,47,99,112,66,111,100,121,46,99,0,66,111,100,121,39,115,32,109,97,115,115,32,105,115,32,78,97,78,46,0,98,111,100,121,45,62,105,32,61,61,32,98,111,100,121,45,62,105,32,38,38,32,98,111,100,121,45,62,105,95,105,110,118,32,61,61,32,98,111,100,121,45,62,105,95,105,110,118,0,66,111,100,121,39,115,32,109,111,109,101,110,116,32,105,115,32,78,97,78,46,0,98,111,100,121,45,62,109,32,62,61,32,48,46,48,102,0,66,111,100,121,39,115,32,109,97,115,115,32,105,115,32,110,101,103,97,116,105,118,101,46,0,98,111,100,121,45,62,105,32,62,61,32,48,46,48,102,0,66,111,100,121,39,115,32,109,111,109,101,110,116,32,105,115,32,110,101,103,97,116,105,118,101,46,0,66,111,100,121,39,115,32,112,111,115,105,116,105,111,110,32,105,115,32,105,110,118,97,108,105,100,46,0,66,111,100,121,39,115,32,118,101,108,111,99,105,116,121,32,105,115,32,105,110,118,97,108,105,100,46,0,66,111,100,121,39,115,32,102,111,114,99,101,32,105,115,32,105,110,118,97,108,105,100,46,0,98,111,100,121,45,62,97,32,61,61,32,98,111,100,121,45,62,97,32,38,38,32,99,112,102,97,98,115,40,98,111,100,121,45,62,97,41,32,33,61,32,73,78,70,73,78,73,84,89,0,66,111,100,121,39,115,32,97,110,103,108,101,32,105,115,32,105,110,118,97,108,105,100,46,0,98,111,100,121,45,62,119,32,61,61,32,98,111,100,121,45,62,119,32,38,38,32,99,112,102,97,98,115,40,98,111,100,121,45,62,119,41,32,33,61,32,73,78,70,73,78,73,84,89,0,66,111,100,121,39,115,32,97,110,103,117,108,97,114,32,118,101,108,111,99,105,116,121,32,105,115,32,105,110,118,97,108,105,100,46,0,98,111,100,121,45,62,116,32,61,61,32,98,111,100,121,45,62,116,32,38,38,32,99,112,102,97,98,115,40,98,111,100,121,45,62,116,41,32,33,61,32,73,78,70,73,78,73,84,89,0,66,111,100,121,39,115,32,116,111,114,113,117,101,32,105,115,32,105,110,118,97,108,105,100,46,0,99,112,102,97,98,115,40,118,46,120,41,32,33,61,32,73,78,70,73,78,73,84,89,32,38,38,32,99,112,102,97,98,115,40,118,46,121,41,32,33,61,32,73,78,70,73,78,73,84,89,0,118,46,120,32,61,61,32,118,46,120,32,38,38,32,118,46,121,32,61,61,32,118,46,121,0,109,111,109,101,110,116,32,62,61,32,48,46,48,102,0,77,111,109,101,110,116,32,111,102,32,73,110,101,114,116,105,97,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,46,0,89,111,117,32,99,97,110,110,111,116,32,115,101,116,32,116,104,101,32,109,97,115,115,32,111,102,32,107,105,110,101,109,97,116,105,99,32,111,114,32,115,116,97,116,105,99,32,98,111,100,105,101,115,46,0,48,46,48,102,32,60,61,32,109,97,115,115,32,38,38,32,109,97,115,115,32,60,32,73,78,70,73,78,73,84,89,0,77,97,115,115,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,97,110,100,32,102,105,110,105,116,101,46,0,98,111,100,121,45,62,109,32,62,32,48,46,48,102,32,38,38,32,98,111,100,121,45,62,105,32,62,32,48,46,48,102,0,66,111,100,121,39,115,32,109,97,115,115,32,97,110,100,32,109,111,109,101,110,116,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,116,111,32,115,105,109,117,108,97,116,101,46,32,40,77,97,115,115,58,32,37,102,32,77,111,109,101,110,116,58,32,37,102,41,0,105,110,102,111,45,62,99,111,117,110,116,32,60,61,32,67,80,95,77,65,88,95,67,79,78,84,65,67,84,83,95,80,69,82,95,65,82,66,73,84,69,82,0,47,85,115,101,114,115,47,120,105,111,110,103,119,101,110,106,105,101,47,68,111,99,117,109,101,110,116,115,47,71,73,84,115,47,67,104,105,112,109,117,110,107,50,68,47,115,114,99,47,99,112,67,111,108,108,105,115,105,111,110,46,99,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,84,114,105,101,100,32,116,111,32,112,117,115,104,32,116,111,111,32,109,97,110,121,32,99,111,110,116,97,99,116,115,46,0,105,116,101,114,97,116,105,111,110,32,60,32,87,65,82,78,95,71,74,75,95,73,84,69,82,65,84,73,79,78,83,0,72,105,103,104,32,71,74,75,32,105,116,101,114,97,116,105,111,110,115,58,32,37,100,0,72,105,103,104,32,71,74,75,45,62,69,80,65,32,105,116,101,114,97,116,105,111,110,115,58,32,37,100,0,33,99,112,118,101,113,108,40,118,48,46,97,98,44,32,118,49,46,97,98,41,0,73,110,116,101,114,110,97,108,32,69,114,114,111,114,58,32,69,80,65,32,118,101,114,116,101,120,101,115,32,97,114,101,32,116,104,101,32,115,97,109,101,32,40,37,100,32,97,110,100,32,37,100,41,0,105,116,101,114,97,116,105,111,110,32,60,32,87,65,82,78,95,69,80,65,95,73,84,69,82,65,84,73,79,78,83,0,72,105,103,104,32,69,80,65,32,105,116,101,114,97,116,105,111,110,115,58,32,37,100,0,99,112,70,97,108,115,101,0,73,110,116,101,114,110,97,108,32,69,114,114,111,114,58,32,83,104,97,112,101,32,116,121,112,101,115,32,97,114,101,32,110,111,116,32,115,111,114,116,101,100,46,0,109,97,120,70,111,114,99,101,32,62,61,32,48,46,48,102,0,47,85,115,101,114,115,47,120,105,111,110,103,119,101,110,106,105,101,47,68,111,99,117,109,101,110,116,115,47,71,73,84,115,47,67,104,105,112,109,117,110,107,50,68,47,115,114,99,47,99,112,67,111,110,115,116,114,97,105,110,116,46,99,0,109,97,120,70,111,114,99,101,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,46,0,101,114,114,111,114,66,105,97,115,32,62,61,32,48,46,48,102,0,101,114,114,111,114,66,105,97,115,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,46,0,109,97,120,66,105,97,115,32,62,61,32,48,46,48,102,0,109,97,120,66,105,97,115,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,46,0,112,114,105,109,101,115,91,105,93,0,47,85,115,101,114,115,47,120,105,111,110,103,119,101,110,106,105,101,47,68,111,99,117,109,101,110,116,115,47,71,73,84,115,47,67,104,105,112,109,117,110,107,50,68,47,115,114,99,47,112,114,105,109,101,46,104,0,84,114,105,101,100,32,116,111,32,114,101,115,105,122,101,32,97,32,104,97,115,104,32,116,97,98,108,101,32,116,111,32,97,32,115,105,122,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,49,54,49,48,54,49,50,55,52,49,32,79,95,111,0,47,85,115,101,114,115,47,120,105,111,110,103,119,101,110,106,105,101,47,68,111,99,117,109,101,110,116,115,47,71,73,84,115,47,67,104,105,112,109,117,110,107,50,68,47,115,114,99,47,99,112,72,97,115,104,83,101,116,46,99,0,73,110,116,101,114,110,97,108,32,69,114,114,111,114,58,32,66,117,102,102,101,114,32,115,105,122,101,32,105,115,32,116,111,111,32,115,109,97,108,108,46,0,100,101,116,32,33,61,32,48,46,48,0,85,110,115,111,108,118,97,98,108,101,32,99,111,110,115,116,114,97,105,110,116,46,0,33,99,112,83,104,97,112,101,65,99,116,105,118,101,40,115,104,97,112,101,41,0,47,85,115,101,114,115,47,120,105,111,110,103,119,101,110,106,105,101,47,68,111,99,117,109,101,110,116,115,47,71,73,84,115,47,67,104,105,112,109,117,110,107,50,68,47,115,114,99,47,99,112,83,104,97,112,101,46,99,0,89,111,117,32,99,97,110,110,111,116,32,99,104,97,110,103,101,32,116,104,101,32,98,111,100,121,32,111,110,32,97,110,32,97,99,116,105,118,101,32,115,104,97,112,101,46,32,89,111,117,32,109,117,115,116,32,114,101,109,111,118,101,32,116,104,101,32,115,104,97,112,101,32,102,114,111,109,32,116,104,101,32,115,112,97,99,101,32,98,101,102,111,114,101,32,99,104,97,110,103,105,110,103,32,116,104,101,32,98,111,100,121,46,0,101,108,97,115,116,105,99,105,116,121,32,62,61,32,48,46,48,102,0,69,108,97,115,116,105,99,105,116,121,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,46,0,102,114,105,99,116,105,111,110,32,62,61,32,48,46,48,102,0,70,114,105,99,116,105,111,110,32,109,117,115,116,32,98,101,32,112,111,115,116,105,118,101,46,0,115,104,97,112,101,45,62,107,108,97,115,115,32,61,61,32,38,99,112,67,105,114,99,108,101,83,104,97,112,101,67,108,97,115,115,0,83,104,97,112,101,32,105,115,32,110,111,116,32,97,32,99,105,114,99,108,101,32,115,104,97,112,101,46,0,115,104,97,112,101,45,62,107,108,97,115,115,32,61,61,32,38,99,112,83,101,103,109,101,110,116,83,104,97,112,101,67,108,97,115,115,0,83,104,97,112,101,32,105,115,32,110,111,116,32,97,32,115,101,103,109,101,110,116,32,115,104,97,112,101,46,0,118,97,108,117,101,32,33,61,32,48,46,48,0,47,85,115,101,114,115,47,120,105,111,110,103,119,101,110,106,105,101,47,68,111,99,117,109,101,110,116,115,47,71,73,84,115,47,67,104,105,112,109,117,110,107,50,68,47,105,110,99,108,117,100,101,47,99,104,105,112,109,117,110,107,47,99,104,105,112,109,117,110,107,95,112,114,105,118,97,116,101,46,104,0,85,110,115,111,108,118,97,98,108,101,32,99,111,108,108,105,115,105,111,110,32,111,114,32,99,111,110,115,116,114,97,105,110,116,46,0,73,110,105,116,105,97,108,105,122,105,110,103,32,99,112,83,112,97,99,101,32,45,32,67,104,105,112,109,117,110,107,32,118,37,115,32,40,68,101,98,117,103,32,69,110,97,98,108,101,100,41,10,0,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,78,68,69,66,85,71,32,100,101,102,105,110,101,100,32,116,111,32,100,105,115,97,98,108,101,32,100,101,98,117,103,32,109,111,100,101,32,97,110,100,32,114,117,110,116,105,109,101,32,97,115,115,101,114,116,105,111,110,32,99,104,101,99,107,115,10,0,115,112,97,99,101,45,62,115,116,97,116,105,99,66,111,100,121,45,62,115,104,97,112,101,76,105,115,116,32,61,61,32,78,85,76,76,0,47,85,115,101,114,115,47,120,105,111,110,103,119,101,110,106,105,101,47,68,111,99,117,109,101,110,116,115,47,71,73,84,115,47,67,104,105,112,109,117,110,107,50,68,47,115,114,99,47,99,112,83,112,97,99,101,46,99,0,73,110,116,101,114,110,97,108,32,69,114,114,111,114,58,32,67,104,97,110,103,105,110,103,32,116,104,101,32,100,101,115,105,103,110,97,116,101,100,32,115,116,97,116,105,99,32,98,111,100,121,32,119,104,105,108,101,32,116,104,101,32,111,108,100,32,111,110,101,32,115,116,105,108,108,32,104,97,100,32,115,104,97,112,101,115,32,97,116,116,97,99,104,101,100,46,0,105,116,101,114,97,116,105,111,110,115,32,62,32,48,0,73,116,101,114,97,116,105,111,110,115,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,97,110,100,32,110,111,110,45,122,101,114,111,46,0,100,97,109,112,105,110,103,32,62,61,32,48,46,48,0,68,97,109,112,105,110,103,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,46,0,115,104,97,112,101,45,62,115,112,97,99,101,32,33,61,32,115,112,97,99,101,0,89,111,117,32,104,97,118,101,32,97,108,114,101,97,100,121,32,97,100,100,101,100,32,116,104,105,115,32,115,104,97,112,101,32,116,111,32,116,104,105,115,32,115,112,97,99,101,46,32,89,111,117,32,109,117,115,116,32,110,111,116,32,97,100,100,32,105,116,32,97,32,115,101,99,111,110,100,32,116,105,109,101,46,0,33,115,104,97,112,101,45,62,115,112,97,99,101,0,89,111,117,32,104,97,118,101,32,97,108,114,101,97,100,121,32,97,100,100,101,100,32,116,104,105,115,32,115,104,97,112,101,32,116,111,32,97,110,111,116,104,101,114,32,115,112,97,99,101,46,32,89,111,117,32,99,97,110,110,111,116,32,97,100,100,32,105,116,32,116,111,32,97,32,115,101,99,111,110,100,46,0,33,115,112,97,99,101,45,62,108,111,99,107,101,100,0,84,104,105,115,32,111,112,101,114,97,116,105,111,110,32,99,97,110,110,111,116,32,98,101,32,100,111,110,101,32,115,97,102,101,108,121,32,100,117,114,105,110,103,32,97,32,99,97,108,108,32,116,111,32,99,112,83,112,97,99,101,83,116,101,112,40,41,32,111,114,32,100,117,114,105,110,103,32,97,32,113,117,101,114,121,46,32,80,117,116,32,116,104,101,115,101,32,99,97,108,108,115,32,105,110,116,111,32,97,32,112,111,115,116,45,115,116,101,112,32,99,97,108,108,98,97,99,107,46,0,98,111,100,121,45,62,115,112,97,99,101,32,33,61,32,115,112,97,99,101,0,89,111,117,32,104,97,118,101,32,97,108,114,101,97,100,121,32,97,100,100,101,100,32,116,104,105,115,32,98,111,100,121,32,116,111,32,116,104,105,115,32,115,112,97,99,101,46,32,89,111,117,32,109,117,115,116,32,110,111,116,32,97,100,100,32,105,116,32,97,32,115,101,99,111,110,100,32,116,105,109,101,46,0,33,98,111,100,121,45,62,115,112,97,99,101,0,89,111,117,32,104,97,118,101,32,97,108,114,101,97,100,121,32,97,100,100,101,100,32,116,104,105,115,32,98,111,100,121,32,116,111,32,97,110,111,116,104,101,114,32,115,112,97,99,101,46,32,89,111,117,32,99,97,110,110,111,116,32,97,100,100,32,105,116,32,116,111,32,97,32,115,101,99,111,110,100,46,0,99,111,110,115,116,114,97,105,110,116,45,62,115,112,97,99,101,32,33,61,32,115,112,97,99,101,0,89,111,117,32,104,97,118,101,32,97,108,114,101,97,100,121,32,97,100,100,101,100,32,116,104,105,115,32,99,111,110,115,116,114,97,105,110,116,32,116,111,32,116,104,105,115,32,115,112,97,99,101,46,32,89,111,117,32,109,117,115,116,32,110,111,116,32,97,100,100,32,105,116,32,97,32,115,101,99,111,110,100,32,116,105,109,101,46,0,33,99,111,110,115,116,114,97,105,110,116,45,62,115,112,97,99,101,0,89,111,117,32,104,97,118,101,32,97,108,114,101,97,100,121,32,97,100,100,101,100,32,116,104,105,115,32,99,111,110,115,116,114,97,105,110,116,32,116,111,32,97,110,111,116,104,101,114,32,115,112,97,99,101,46,32,89,111,117,32,99,97,110,110,111,116,32,97,100,100,32,105,116,32,116,111,32,97,32,115,101,99,111,110,100,46,0,97,32,33,61,32,78,85,76,76,32,38,38,32,98,32,33,61,32,78,85,76,76,0,67,111,110,115,116,114,97,105,110,116,32,105,115,32,97,116,116,97,99,104,101,100,32,116,111,32,97,32,78,85,76,76,32,98,111,100,121,46,0,99,112,83,112,97,99,101,67,111,110,116,97,105,110,115,83,104,97,112,101,40,115,112,97,99,101,44,32,115,104,97,112,101,41,0,67,97,110,110,111,116,32,114,101,109,111,118,101,32,97,32,115,104,97,112,101,32,116,104,97,116,32,119,97,115,32,110,111,116,32,97,100,100,101,100,32,116,111,32,116,104,101,32,115,112,97,99,101,46,32,40,82,101,109,111,118,101,100,32,116,119,105,99,101,32,109,97,121,98,101,63,41,0,98,111,100,121,32,33,61,32,99,112,83,112,97,99,101,71,101,116,83,116,97,116,105,99,66,111,100,121,40,115,112,97,99,101,41,0,67,97,110,110,111,116,32,114,101,109,111,118,101,32,116,104,101,32,100,101,115,105,103,110,97,116,101,100,32,115,116,97,116,105,99,32,98,111,100,121,32,102,111,114,32,116,104,101,32,115,112,97,99,101,46,0,99,112,83,112,97,99,101,67,111,110,116,97,105,110,115,66,111,100,121,40,115,112,97,99,101,44,32,98,111,100,121,41,0,67,97,110,110,111,116,32,114,101,109,111,118,101,32,97,32,98,111,100,121,32,116,104,97,116,32,119,97,115,32,110,111,116,32,97,100,100,101,100,32,116,111,32,116,104,101,32,115,112,97,99,101,46,32,40,82,101,109,111,118,101,100,32,116,119,105,99,101,32,109,97,121,98,101,63,41,0,99,112,83,112,97,99,101,67,111,110,116,97,105,110,115,67,111,110,115,116,114,97,105,110,116,40,115,112,97,99,101,44,32,99,111,110,115,116,114,97,105,110,116,41,0,67,97,110,110,111,116,32,114,101,109,111,118,101,32,97,32,99,111,110,115,116,114,97,105,110,116,32,116,104,97,116,32,119,97,115,32,110,111,116,32,97,100,100,101,100,32,116,111,32,116,104,101,32,115,112,97,99,101,46,32,40,82,101,109,111,118,101,100,32,116,119,105,99,101,32,109,97,121,98,101,63,41,0,89,111,117,32,99,97,110,110,111,116,32,109,97,110,117,97,108,108,121,32,114,101,105,110,100,101,120,32,111,98,106,101,99,116,115,32,119,104,105,108,101,32,116,104,101,32,115,112,97,99,101,32,105,115,32,108,111,99,107,101,100,46,32,87,97,105,116,32,117,110,116,105,108,32,116,104,101,32,99,117,114,114,101,110,116,32,113,117,101,114,121,32,111,114,32,115,116,101,112,32,105,115,32,99,111,109,112,108,101,116,101,46,0,99,112,66,111,100,121,71,101,116,84,121,112,101,40,98,111,100,121,41,32,61,61,32,67,80,95,66,79,68,89,95,84,89,80,69,95,68,89,78,65,77,73,67,0,47,85,115,101,114,115,47,120,105,111,110,103,119,101,110,106,105,101,47,68,111,99,117,109,101,110,116,115,47,71,73,84,115,47,67,104,105,112,109,117,110,107,50,68,47,115,114,99,47,99,112,83,112,97,99,101,67,111,109,112,111,110,101,110,116,46,99,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,65,116,116,101,109,112,116,105,110,103,32,116,111,32,97,99,116,105,118,97,116,101,32,97,32,110,111,110,45,100,121,110,97,109,105,99,32,98,111,100,121,46,0,98,111,100,121,45,62,115,108,101,101,112,105,110,103,46,114,111,111,116,32,61,61,32,78,85,76,76,32,38,38,32,98,111,100,121,45,62,115,108,101,101,112,105,110,103,46,110,101,120,116,32,61,61,32,78,85,76,76,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,65,99,116,105,118,97,116,105,110,103,32,98,111,100,121,32,110,111,110,45,78,85,76,76,32,110,111,100,101,32,112,111,105,110,116,101,114,115,46,0,99,112,66,111,100,121,71,101,116,84,121,112,101,40,114,111,111,116,41,32,61,61,32,67,80,95,66,79,68,89,95,84,89,80,69,95,68,89,78,65,77,73,67,0,73,110,116,101,114,110,97,108,32,69,114,114,111,114,58,32,78,111,110,45,100,121,110,97,109,105,99,32,98,111,100,121,32,99,111,109,112,111,110,101,110,116,32,114,111,111,116,32,100,101,116,101,99,116,101,100,46,0,99,112,66,111,100,121,71,101,116,84,121,112,101,40,98,111,100,121,41,32,61,61,32,67,80,95,66,79,68,89,95,84,89,80,69,95,83,84,65,84,73,67,0,99,112,66,111,100,121,65,99,116,105,118,97,116,101,83,116,97,116,105,99,40,41,32,99,97,108,108,101,100,32,111,110,32,97,32,110,111,110,45,115,116,97,116,105,99,32,98,111,100,121,46,0,98,111,100,121,45,62,115,108,101,101,112,105,110,103,46,110,101,120,116,32,61,61,32,78,85,76,76,0,73,110,116,101,114,110,97,108,32,69,114,114,111,114,58,32,68,97,110,103,108,105,110,103,32,110,101,120,116,32,112,111,105,110,116,101,114,32,100,101,116,101,99,116,101,100,32,105,110,32,99,111,110,116,97,99,116,32,103,114,97,112,104,46,0,98,111,100,121,45,62,115,108,101,101,112,105,110,103,46,114,111,111,116,32,61,61,32,78,85,76,76,0,73,110,116,101,114,110,97,108,32,69,114,114,111,114,58,32,68,97,110,103,108,105,110,103,32,114,111,111,116,32,112,111,105,110,116,101,114,32,100,101,116,101,99,116,101,100,32,105,110,32,99,111,110,116,97,99,116,32,103,114,97,112,104,46,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,65,116,116,101,109,112,116,105,110,103,32,116,111,32,100,101,97,99,116,105,118,97,116,101,32,97,32,110,111,110,45,100,121,110,97,109,105,99,32,98,111,100,121,46,0,111,116,104,101,114,95,114,111,111,116,32,61,61,32,114,111,111,116,0,73,110,116,101,114,110,97,108,32,69,114,114,111,114,58,32,73,110,99,111,110,115,105,115,116,101,110,99,121,32,100,101,99,116,101,99,116,101,100,32,105,110,32,116,104,101,32,99,111,110,116,97,99,116,32,103,114,97,112,104,46,0,99,112,65,114,98,105,116,101,114,84,104,114,101,97,100,70,111,114,66,111,100,121,40,97,114,98,44,32,98,111,100,121,41,45,62,110,101,120,116,32,61,61,32,78,85,76,76,0,73,110,116,101,114,110,97,108,32,69,114,114,111,114,58,32,68,97,110,103,108,105,110,103,32,99,111,110,116,97,99,116,32,103,114,97,112,104,32,112,111,105,110,116,101,114,115,32,100,101,116,101,99,116,101,100,46,32,40,65,41,0,99,112,65,114,98,105,116,101,114,84,104,114,101,97,100,70,111,114,66,111,100,121,40,97,114,98,44,32,98,111,100,121,41,45,62,112,114,101,118,32,61,61,32,78,85,76,76,0,73,110,116,101,114,110,97,108,32,69,114,114,111,114,58,32,68,97,110,103,108,105,110,103,32,99,111,110,116,97,99,116,32,103,114,97,112,104,32,112,111,105,110,116,101,114,115,32,100,101,116,101,99,116,101,100,46,32,40,66,41,0,110,101,120,116,32,61,61,32,78,85,76,76,32,124,124,32,99,112,65,114,98,105,116,101,114,84,104,114,101,97,100,70,111,114,66,111,100,121,40,110,101,120,116,44,32,98,111,100,121,41,45,62,112,114,101,118,32,61,61,32,78,85,76,76,0,73,110,116,101,114,110,97,108,32,69,114,114,111,114,58,32,68,97,110,103,108,105,110,103,32,99,111,110,116,97,99,116,32,103,114,97,112,104,32,112,111,105,110,116,101,114,115,32,100,101,116,101,99,116,101,100,46,32,40,67,41,0,78,111,110,45,100,121,110,97,109,105,99,32,98,111,100,105,101,115,32,99,97,110,110,111,116,32,98,101,32,112,117,116,32,116,111,32,115,108,101,101,112,46,0,33,99,112,83,112,97,99,101,73,115,76,111,99,107,101,100,40,115,112,97,99,101,41,0,66,111,100,105,101,115,32,99,97,110,110,111,116,32,98,101,32,112,117,116,32,116,111,32,115,108,101,101,112,32,100,117,114,105,110,103,32,97,32,113,117,101,114,121,32,111,114,32,97,32,99,97,108,108,32,116,111,32,99,112,83,112,97,99,101,83,116,101,112,40,41,46,32,80,117,116,32,116,104,101,115,101,32,99,97,108,108,115,32,105,110,116,111,32,97,32,112,111,115,116,45,115,116,101,112,32,99,97,108,108,98,97,99,107,46,0,99,112,83,112,97,99,101,71,101,116,83,108,101,101,112,84,105,109,101,84,104,114,101,115,104,111,108,100,40,115,112,97,99,101,41,32,60,32,73,78,70,73,78,73,84,89,0,83,108,101,101,112,105,110,103,32,105,115,32,110,111,116,32,101,110,97,98,108,101,100,32,111,110,32,116,104,101,32,115,112,97,99,101,46,32,89,111,117,32,99,97,110,110,111,116,32,115,108,101,101,112,32,97,32,98,111,100,121,32,119,105,116,104,111,117,116,32,115,101,116,116,105,110,103,32,97,32,115,108,101,101,112,32,116,105,109,101,32,116,104,114,101,115,104,111,108,100,32,111,110,32,116,104,101,32,115,112,97,99,101,46,0,103,114,111,117,112,32,61,61,32,78,85,76,76,32,124,124,32,99,112,66,111,100,121,73,115,83,108,101,101,112,105,110,103,40,103,114,111,117,112,41,0,67,97,110,110,111,116,32,117,115,101,32,97,32,110,111,110,45,115,108,101,101,112,105,110,103,32,98,111,100,121,32,97,115,32,97,32,103,114,111,117,112,32,105,100,101,110,116,105,102,105,101,114,46,0,67,111,109,112,111,110,101,110,116,82,111,111,116,40,98,111,100,121,41,32,61,61,32,67,111,109,112,111,110,101,110,116,82,111,111,116,40,103,114,111,117,112,41,0,84,104,101,32,98,111,100,121,32,105,115,32,97,108,114,101,97,100,121,32,115,108,101,101,112,105,110,103,32,97,110,100,32,105,116,39,115,32,103,114,111,117,112,32,99,97,110,110,111,116,32,98,101,32,114,101,97,115,115,105,103,110,101,100,46,0,115,112,97,99,101,45,62,108,111,99,107,101,100,0,47,85,115,101,114,115,47,120,105,111,110,103,119,101,110,106,105,101,47,68,111,99,117,109,101,110,116,115,47,71,73,84,115,47,67,104,105,112,109,117,110,107,50,68,47,115,114,99,47,99,112,83,112,97,99,101,83,116,101,112,46,99,0,65,100,100,105,110,103,32,97,32,112,111,115,116,45,115,116,101,112,32,99,97,108,108,98,97,99,107,32,119,104,101,110,32,116,104,101,32,115,112,97,99,101,32,105,115,32,110,111,116,32,108,111,99,107,101,100,32,105,115,32,117,110,110,101,99,101,115,115,97,114,121,46,32,80,111,115,116,45,115,116,101,112,32,99,97,108,108,98,97,99,107,115,32,119,105,108,108,32,110,111,116,32,99,97,108,108,101,100,32,117,110,116,105,108,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,110,101,120,116,32,99,97,108,108,32,116,111,32,99,112,83,112,97,99,101,83,116,101,112,40,41,32,111,114,32,116,104,101,32,110,101,120,116,32,113,117,101,114,121,46,0,115,112,97,99,101,45,62,108,111,99,107,101,100,32,62,61,32,48,0,73,110,116,101,114,110,97,108,32,69,114,114,111,114,58,32,83,112,97,99,101,32,108,111,99,107,32,117,110,100,101,114,102,108,111,119,46,0,99,111,117,110,116,32,60,61,32,67,80,95,77,65,88,95,67,79,78,84,65,67,84,83,95,80,69,82,95,65,82,66,73,84,69,82,0,73,110,116,101,114,110,97,108,32,69,114,114,111,114,58,32,67,111,110,116,97,99,116,32,98,117,102,102,101,114,32,111,118,101,114,102,108,111,119,33,0,99,111,117,110,116,0,73,110,116,101,114,110,97,108,32,69,114,114,111,114,58,32,66,117,102,102,101,114,32,115,105,122,101,32,116,111,111,32,115,109,97,108,108,46,0,33,115,116,97,116,105,99,73,110,100,101,120,45,62,100,121,110,97,109,105,99,73,110,100,101,120,0,47,85,115,101,114,115,47,120,105,111,110,103,119,101,110,106,105,101,47,68,111,99,117,109,101,110,116,115,47,71,73,84,115,47,67,104,105,112,109,117,110,107,50,68,47,115,114,99,47,99,112,83,112,97,116,105,97,108,73,110,100,101,120,46,99,0,84,104,105,115,32,115,116,97,116,105,99,32,105,110,100,101,120,32,105,115,32,97,108,114,101,97,100,121,32,97,115,115,111,99,105,97,116,101,100,32,119,105,116,104,32,97,32,100,121,110,97,109,105,99,32,105,110,100,101,120,46,0,45,43,32,32,32,48,88,48,120,0,40,110,117,108,108,41,0,45,48,88,43,48,88,32,48,88,45,48,120,43,48,120,32,48,120,0,105,110,102,0,73,78,70,0,110,97,110,0,78,65,78,0,46,0], "i8", ALLOC_NONE, GLOBAL_BASE);





/* no memory initializer */
var tempDoublePtr = STATICTOP; STATICTOP += 16;
assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much
  HEAP8[tempDoublePtr] = HEAP8[ptr];
  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];
  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];
  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];
}

function copyTempDouble(ptr) {
  HEAP8[tempDoublePtr] = HEAP8[ptr];
  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];
  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];
  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];
  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];
  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];
  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];
  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];
}

// {{PRE_LIBRARY}}


  function ___lock() {}

  
    

  
  var SYSCALLS={buffers:[null,[],[]],printChar:function (stream, curr) {
        var buffer = SYSCALLS.buffers[stream];
        assert(buffer);
        if (curr === 0 || curr === 10) {
          (stream === 1 ? out : err)(UTF8ArrayToString(buffer, 0));
          buffer.length = 0;
        } else {
          buffer.push(curr);
        }
      },varargs:0,get:function (varargs) {
        SYSCALLS.varargs += 4;
        var ret = ((SAFE_HEAP_LOAD((((SYSCALLS.varargs)-(4))|0), 4, 0))|0);
        return ret;
      },getStr:function () {
        var ret = Pointer_stringify(SYSCALLS.get());
        return ret;
      },get64:function () {
        var low = SYSCALLS.get(), high = SYSCALLS.get();
        if (low >= 0) assert(high === 0);
        else assert(high === -1);
        return low;
      },getZero:function () {
        assert(SYSCALLS.get() === 0);
      }};function ___syscall140(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // llseek
      var stream = SYSCALLS.getStreamFromFD(), offset_high = SYSCALLS.get(), offset_low = SYSCALLS.get(), result = SYSCALLS.get(), whence = SYSCALLS.get();
      // NOTE: offset_high is unused - Emscripten's off_t is 32-bit
      var offset = offset_low;
      FS.llseek(stream, offset, whence);
      SAFE_HEAP_STORE(((result)|0), ((stream.position)|0), 4);
      if (stream.getdents && offset === 0 && whence === 0) stream.getdents = null; // reset readdir state
      return 0;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  
  function flush_NO_FILESYSTEM() {
      // flush anything remaining in the buffers during shutdown
      var fflush = Module["_fflush"];
      if (fflush) fflush(0);
      var buffers = SYSCALLS.buffers;
      if (buffers[1].length) SYSCALLS.printChar(1, 10);
      if (buffers[2].length) SYSCALLS.printChar(2, 10);
    }function ___syscall146(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // writev
      // hack to support printf in FILESYSTEM=0
      var stream = SYSCALLS.get(), iov = SYSCALLS.get(), iovcnt = SYSCALLS.get();
      var ret = 0;
      for (var i = 0; i < iovcnt; i++) {
        var ptr = ((SAFE_HEAP_LOAD((((iov)+(i*8))|0), 4, 0))|0);
        var len = ((SAFE_HEAP_LOAD((((iov)+(i*8 + 4))|0), 4, 0))|0);
        for (var j = 0; j < len; j++) {
          SYSCALLS.printChar(stream, HEAPU8[ptr+j]);
        }
        ret += len;
      }
      return ret;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall54(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // ioctl
      return 0;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  function ___syscall6(which, varargs) {SYSCALLS.varargs = varargs;
  try {
   // close
      var stream = SYSCALLS.getStreamFromFD();
      FS.close(stream);
      return 0;
    } catch (e) {
    if (typeof FS === 'undefined' || !(e instanceof FS.ErrnoError)) abort(e);
    return -e.errno;
  }
  }

  
  
   
  
   
  
     

  function ___unlock() {}

  function _abort() {
      Module['abort']();
    }

   

   



   

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 

   

  
  function ___setErrNo(value) {
      if (Module['___errno_location']) SAFE_HEAP_STORE(((Module['___errno_location']())|0), ((value)|0), 4);
      else err('failed to set errno from JS');
      return value;
    } 
DYNAMICTOP_PTR = staticAlloc(4);

STACK_BASE = STACKTOP = alignMemory(STATICTOP);

STACK_MAX = STACK_BASE + TOTAL_STACK;

DYNAMIC_BASE = alignMemory(STACK_MAX);

HEAP32[DYNAMICTOP_PTR>>2] = DYNAMIC_BASE;

staticSealed = true; // seal the static portion of memory

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

var ASSERTIONS = true;

// Copyright 2017 The Emscripten Authors.  All rights reserved.
// Emscripten is available under two separate licenses, the MIT license and the
// University of Illinois/NCSA Open Source License.  Both these licenses can be
// found in the LICENSE file.

/** @type {function(string, boolean=, number=)} */
function intArrayFromString(stringy, dontAddNull, length) {
  var len = length > 0 ? length : lengthBytesUTF8(stringy)+1;
  var u8array = new Array(len);
  var numBytesWritten = stringToUTF8Array(stringy, u8array, 0, u8array.length);
  if (dontAddNull) u8array.length = numBytesWritten;
  return u8array;
}

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      if (ASSERTIONS) {
        assert(false, 'Character code ' + chr + ' (' + String.fromCharCode(chr) + ')  at offset ' + i + ' not in 0x00-0xFF.');
      }
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}



function nullFunc_di(x) { err("Invalid function pointer called with signature 'di'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  err("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_diii(x) { err("Invalid function pointer called with signature 'diii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  err("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_ii(x) { err("Invalid function pointer called with signature 'ii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  err("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_iii(x) { err("Invalid function pointer called with signature 'iii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  err("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_iiii(x) { err("Invalid function pointer called with signature 'iiii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  err("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_iiiii(x) { err("Invalid function pointer called with signature 'iiiii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  err("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_vi(x) { err("Invalid function pointer called with signature 'vi'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  err("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_vid(x) { err("Invalid function pointer called with signature 'vid'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  err("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_vii(x) { err("Invalid function pointer called with signature 'vii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  err("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_viidd(x) { err("Invalid function pointer called with signature 'viidd'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  err("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_viidii(x) { err("Invalid function pointer called with signature 'viidii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  err("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_viii(x) { err("Invalid function pointer called with signature 'viii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  err("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_viiidi(x) { err("Invalid function pointer called with signature 'viiidi'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  err("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_viiiidii(x) { err("Invalid function pointer called with signature 'viiiidii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  err("Build with ASSERTIONS=2 for more info.");abort(x) }

function nullFunc_viiiii(x) { err("Invalid function pointer called with signature 'viiiii'. Perhaps this is an invalid value (e.g. caused by calling a virtual method on a NULL pointer)? Or calling a function with an incorrect type, which will fail? (it is worth building your source files with -Werror (warnings are errors), as warnings can indicate undefined behavior which can cause this)");  err("Build with ASSERTIONS=2 for more info.");abort(x) }

function jsCall_di(index,a1) {
    return functionPointers[index](a1);
}

function jsCall_diii(index,a1,a2,a3) {
    return functionPointers[index](a1,a2,a3);
}

function jsCall_ii(index,a1) {
    return functionPointers[index](a1);
}

function jsCall_iii(index,a1,a2) {
    return functionPointers[index](a1,a2);
}

function jsCall_iiii(index,a1,a2,a3) {
    return functionPointers[index](a1,a2,a3);
}

function jsCall_iiiii(index,a1,a2,a3,a4) {
    return functionPointers[index](a1,a2,a3,a4);
}

function jsCall_vi(index,a1) {
    functionPointers[index](a1);
}

function jsCall_vid(index,a1,a2) {
    functionPointers[index](a1,a2);
}

function jsCall_vii(index,a1,a2) {
    functionPointers[index](a1,a2);
}

function jsCall_viidd(index,a1,a2,a3,a4) {
    functionPointers[index](a1,a2,a3,a4);
}

function jsCall_viidii(index,a1,a2,a3,a4,a5) {
    functionPointers[index](a1,a2,a3,a4,a5);
}

function jsCall_viii(index,a1,a2,a3) {
    functionPointers[index](a1,a2,a3);
}

function jsCall_viiidi(index,a1,a2,a3,a4,a5) {
    functionPointers[index](a1,a2,a3,a4,a5);
}

function jsCall_viiiidii(index,a1,a2,a3,a4,a5,a6,a7) {
    functionPointers[index](a1,a2,a3,a4,a5,a6,a7);
}

function jsCall_viiiii(index,a1,a2,a3,a4,a5) {
    functionPointers[index](a1,a2,a3,a4,a5);
}

Module.asmGlobalArg = { "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array, "NaN": NaN, "Infinity": Infinity };

Module.asmLibraryArg = { "abort": abort, "assert": assert, "enlargeMemory": enlargeMemory, "getTotalMemory": getTotalMemory, "setTempRet0": setTempRet0, "getTempRet0": getTempRet0, "abortOnCannotGrowMemory": abortOnCannotGrowMemory, "abortStackOverflow": abortStackOverflow, "segfault": segfault, "alignfault": alignfault, "ftfault": ftfault, "nullFunc_di": nullFunc_di, "nullFunc_diii": nullFunc_diii, "nullFunc_ii": nullFunc_ii, "nullFunc_iii": nullFunc_iii, "nullFunc_iiii": nullFunc_iiii, "nullFunc_iiiii": nullFunc_iiiii, "nullFunc_vi": nullFunc_vi, "nullFunc_vid": nullFunc_vid, "nullFunc_vii": nullFunc_vii, "nullFunc_viidd": nullFunc_viidd, "nullFunc_viidii": nullFunc_viidii, "nullFunc_viii": nullFunc_viii, "nullFunc_viiidi": nullFunc_viiidi, "nullFunc_viiiidii": nullFunc_viiiidii, "nullFunc_viiiii": nullFunc_viiiii, "jsCall_di": jsCall_di, "jsCall_diii": jsCall_diii, "jsCall_ii": jsCall_ii, "jsCall_iii": jsCall_iii, "jsCall_iiii": jsCall_iiii, "jsCall_iiiii": jsCall_iiiii, "jsCall_vi": jsCall_vi, "jsCall_vid": jsCall_vid, "jsCall_vii": jsCall_vii, "jsCall_viidd": jsCall_viidd, "jsCall_viidii": jsCall_viidii, "jsCall_viii": jsCall_viii, "jsCall_viiidi": jsCall_viiidi, "jsCall_viiiidii": jsCall_viiiidii, "jsCall_viiiii": jsCall_viiiii, "___lock": ___lock, "___setErrNo": ___setErrNo, "___syscall140": ___syscall140, "___syscall146": ___syscall146, "___syscall54": ___syscall54, "___syscall6": ___syscall6, "___unlock": ___unlock, "_abort": _abort, "_emscripten_memcpy_big": _emscripten_memcpy_big, "flush_NO_FILESYSTEM": flush_NO_FILESYSTEM, "DYNAMICTOP_PTR": DYNAMICTOP_PTR, "tempDoublePtr": tempDoublePtr, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX };
// EMSCRIPTEN_START_ASM
var asm = (/** @suppress {uselessCode} */ function(global, env, buffer) {
'almost asm';


  var HEAP8 = new global.Int8Array(buffer);
  var HEAP16 = new global.Int16Array(buffer);
  var HEAP32 = new global.Int32Array(buffer);
  var HEAPU8 = new global.Uint8Array(buffer);
  var HEAPU16 = new global.Uint16Array(buffer);
  var HEAPU32 = new global.Uint32Array(buffer);
  var HEAPF32 = new global.Float32Array(buffer);
  var HEAPF64 = new global.Float64Array(buffer);

  var DYNAMICTOP_PTR=env.DYNAMICTOP_PTR|0;
  var tempDoublePtr=env.tempDoublePtr|0;
  var STACKTOP=env.STACKTOP|0;
  var STACK_MAX=env.STACK_MAX|0;

  var __THREW__ = 0;
  var threwValue = 0;
  var setjmpId = 0;
  var undef = 0;
  var nan = global.NaN, inf = global.Infinity;
  var tempInt = 0, tempBigInt = 0, tempBigIntS = 0, tempValue = 0, tempDouble = 0.0;

  var Math_floor=global.Math.floor;
  var Math_abs=global.Math.abs;
  var Math_sqrt=global.Math.sqrt;
  var Math_pow=global.Math.pow;
  var Math_cos=global.Math.cos;
  var Math_sin=global.Math.sin;
  var Math_tan=global.Math.tan;
  var Math_acos=global.Math.acos;
  var Math_asin=global.Math.asin;
  var Math_atan=global.Math.atan;
  var Math_atan2=global.Math.atan2;
  var Math_exp=global.Math.exp;
  var Math_log=global.Math.log;
  var Math_ceil=global.Math.ceil;
  var Math_imul=global.Math.imul;
  var Math_min=global.Math.min;
  var Math_max=global.Math.max;
  var Math_clz32=global.Math.clz32;
  var abort=env.abort;
  var assert=env.assert;
  var enlargeMemory=env.enlargeMemory;
  var getTotalMemory=env.getTotalMemory;
  var setTempRet0=env.setTempRet0;
  var getTempRet0=env.getTempRet0;
  var abortOnCannotGrowMemory=env.abortOnCannotGrowMemory;
  var abortStackOverflow=env.abortStackOverflow;
  var segfault=env.segfault;
  var alignfault=env.alignfault;
  var ftfault=env.ftfault;
  var nullFunc_di=env.nullFunc_di;
  var nullFunc_diii=env.nullFunc_diii;
  var nullFunc_ii=env.nullFunc_ii;
  var nullFunc_iii=env.nullFunc_iii;
  var nullFunc_iiii=env.nullFunc_iiii;
  var nullFunc_iiiii=env.nullFunc_iiiii;
  var nullFunc_vi=env.nullFunc_vi;
  var nullFunc_vid=env.nullFunc_vid;
  var nullFunc_vii=env.nullFunc_vii;
  var nullFunc_viidd=env.nullFunc_viidd;
  var nullFunc_viidii=env.nullFunc_viidii;
  var nullFunc_viii=env.nullFunc_viii;
  var nullFunc_viiidi=env.nullFunc_viiidi;
  var nullFunc_viiiidii=env.nullFunc_viiiidii;
  var nullFunc_viiiii=env.nullFunc_viiiii;
  var jsCall_di=env.jsCall_di;
  var jsCall_diii=env.jsCall_diii;
  var jsCall_ii=env.jsCall_ii;
  var jsCall_iii=env.jsCall_iii;
  var jsCall_iiii=env.jsCall_iiii;
  var jsCall_iiiii=env.jsCall_iiiii;
  var jsCall_vi=env.jsCall_vi;
  var jsCall_vid=env.jsCall_vid;
  var jsCall_vii=env.jsCall_vii;
  var jsCall_viidd=env.jsCall_viidd;
  var jsCall_viidii=env.jsCall_viidii;
  var jsCall_viii=env.jsCall_viii;
  var jsCall_viiidi=env.jsCall_viiidi;
  var jsCall_viiiidii=env.jsCall_viiiidii;
  var jsCall_viiiii=env.jsCall_viiiii;
  var ___lock=env.___lock;
  var ___setErrNo=env.___setErrNo;
  var ___syscall140=env.___syscall140;
  var ___syscall146=env.___syscall146;
  var ___syscall54=env.___syscall54;
  var ___syscall6=env.___syscall6;
  var ___unlock=env.___unlock;
  var _abort=env._abort;
  var _emscripten_memcpy_big=env._emscripten_memcpy_big;
  var flush_NO_FILESYSTEM=env.flush_NO_FILESYSTEM;
  var tempFloat = 0.0;

// EMSCRIPTEN_START_FUNCS
function _malloc($0) {
 $0 = $0 | 0; //@line 6100
 var $$0 = 0, $$0$i$i = 0, $$0$i$i$i = 0, $$0$i16$i = 0, $$0187$i = 0, $$0189$i = 0, $$0190$i = 0, $$0191$i = 0, $$0197 = 0, $$0199 = 0, $$02065$i$i = 0, $$0207$lcssa$i$i = 0, $$02074$i$i = 0, $$0211$i$i = 0, $$0212$i$i = 0, $$024372$i = 0, $$0286$i$i = 0, $$028711$i$i = 0, $$0288$lcssa$i$i = 0, $$028810$i$i = 0; //@line 6101
 var $$0294$i$i = 0, $$0295$i$i = 0, $$0340$i = 0, $$034217$i = 0, $$0343$lcssa$i = 0, $$034316$i = 0, $$0345$i = 0, $$0351$i = 0, $$0357$i = 0, $$0358$i = 0, $$0360$i = 0, $$0361$i = 0, $$0367$i = 0, $$1194$i = 0, $$1194$i$be = 0, $$1194$i$ph = 0, $$1196$i = 0, $$1196$i$be = 0, $$1196$i$ph = 0, $$124471$i = 0; //@line 6102
 var $$1290$i$i = 0, $$1290$i$i$be = 0, $$1290$i$i$ph = 0, $$1292$i$i = 0, $$1292$i$i$be = 0, $$1292$i$i$ph = 0, $$1341$i = 0, $$1346$i = 0, $$1362$i = 0, $$1369$i = 0, $$1369$i$be = 0, $$1369$i$ph = 0, $$1373$i = 0, $$1373$i$be = 0, $$1373$i$ph = 0, $$2234243136$i = 0, $$2247$ph$i = 0, $$2253$ph$i = 0, $$2353$i = 0, $$3$i = 0; //@line 6103
 var $$3$i$i = 0, $$3$i203 = 0, $$3$i203218 = 0, $$3348$i = 0, $$3371$i = 0, $$4$lcssa$i = 0, $$420$i = 0, $$420$i$ph = 0, $$4236$i = 0, $$4349$lcssa$i = 0, $$434919$i = 0, $$434919$i$ph = 0, $$4355$i = 0, $$535618$i = 0, $$535618$i$ph = 0, $$723947$i = 0, $$748$i = 0, $$pre = 0, $$pre$i = 0, $$pre$i$i = 0; //@line 6104
 var $$pre$i17$i = 0, $$pre$i208 = 0, $$pre$i210 = 0, $$pre$phi$i$iZ2D = 0, $$pre$phi$i18$iZ2D = 0, $$pre$phi$i209Z2D = 0, $$pre$phi$iZ2D = 0, $$pre$phi17$i$iZ2D = 0, $$pre$phiZ2D = 0, $$pre16$i$i = 0, $$sink = 0, $$sink325 = 0, $$sink326 = 0, $1 = 0, $10 = 0, $100 = 0, $1000 = 0, $1001 = 0, $1002 = 0, $1003 = 0; //@line 6105
 var $1004 = 0, $1005 = 0, $1006 = 0, $1007 = 0, $1008 = 0, $1009 = 0, $101 = 0, $1010 = 0, $1011 = 0, $1012 = 0, $1013 = 0, $1014 = 0, $1015 = 0, $1016 = 0, $1017 = 0, $1018 = 0, $1019 = 0, $102 = 0, $1020 = 0, $1021 = 0; //@line 6106
 var $1022 = 0, $1023 = 0, $1024 = 0, $1025 = 0, $1026 = 0, $1027 = 0, $1028 = 0, $1029 = 0, $103 = 0, $1030 = 0, $1031 = 0, $1032 = 0, $1033 = 0, $1034 = 0, $1035 = 0, $1036 = 0, $1037 = 0, $1038 = 0, $1039 = 0, $104 = 0; //@line 6107
 var $1040 = 0, $1041 = 0, $1042 = 0, $1043 = 0, $1044 = 0, $1045 = 0, $1046 = 0, $1047 = 0, $1048 = 0, $1049 = 0, $105 = 0, $1050 = 0, $1051 = 0, $1052 = 0, $1053 = 0, $1054 = 0, $1055 = 0, $1056 = 0, $1057 = 0, $1058 = 0; //@line 6108
 var $1059 = 0, $106 = 0, $1060 = 0, $1061 = 0, $1062 = 0, $1063 = 0, $1064 = 0, $1065 = 0, $1066 = 0, $1067 = 0, $1068 = 0, $1069 = 0, $107 = 0, $1070 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0; //@line 6109
 var $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0; //@line 6110
 var $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0; //@line 6111
 var $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0; //@line 6112
 var $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0; //@line 6113
 var $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $2 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0; //@line 6114
 var $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0; //@line 6115
 var $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0; //@line 6116
 var $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0; //@line 6117
 var $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0; //@line 6118
 var $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0; //@line 6119
 var $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0, $299 = 0, $3 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0; //@line 6120
 var $311 = 0, $312 = 0, $313 = 0, $314 = 0, $315 = 0, $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0, $329 = 0; //@line 6121
 var $33 = 0, $330 = 0, $331 = 0, $332 = 0, $333 = 0, $334 = 0, $335 = 0, $336 = 0, $337 = 0, $338 = 0, $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0, $344 = 0, $345 = 0, $346 = 0, $347 = 0; //@line 6122
 var $348 = 0, $349 = 0, $35 = 0, $350 = 0, $351 = 0, $352 = 0, $353 = 0, $354 = 0, $355 = 0, $356 = 0, $357 = 0, $358 = 0, $359 = 0, $36 = 0, $360 = 0, $361 = 0, $362 = 0, $363 = 0, $364 = 0, $365 = 0; //@line 6123
 var $366 = 0, $367 = 0, $368 = 0, $369 = 0, $37 = 0, $370 = 0, $371 = 0, $372 = 0, $373 = 0, $374 = 0, $375 = 0, $376 = 0, $377 = 0, $378 = 0, $379 = 0, $38 = 0, $380 = 0, $381 = 0, $382 = 0, $383 = 0; //@line 6124
 var $384 = 0, $385 = 0, $386 = 0, $387 = 0, $388 = 0, $389 = 0, $39 = 0, $390 = 0, $391 = 0, $392 = 0, $393 = 0, $394 = 0, $395 = 0, $396 = 0, $397 = 0, $398 = 0, $399 = 0, $4 = 0, $40 = 0, $400 = 0; //@line 6125
 var $401 = 0, $402 = 0, $403 = 0, $404 = 0, $405 = 0, $406 = 0, $407 = 0, $408 = 0, $409 = 0, $41 = 0, $410 = 0, $411 = 0, $412 = 0, $413 = 0, $414 = 0, $415 = 0, $416 = 0, $417 = 0, $418 = 0, $419 = 0; //@line 6126
 var $42 = 0, $420 = 0, $421 = 0, $422 = 0, $423 = 0, $424 = 0, $425 = 0, $426 = 0, $427 = 0, $428 = 0, $429 = 0, $43 = 0, $430 = 0, $431 = 0, $432 = 0, $433 = 0, $434 = 0, $435 = 0, $436 = 0, $437 = 0; //@line 6127
 var $438 = 0, $439 = 0, $44 = 0, $440 = 0, $441 = 0, $442 = 0, $443 = 0, $444 = 0, $445 = 0, $446 = 0, $447 = 0, $448 = 0, $449 = 0, $45 = 0, $450 = 0, $451 = 0, $452 = 0, $453 = 0, $454 = 0, $455 = 0; //@line 6128
 var $456 = 0, $457 = 0, $458 = 0, $459 = 0, $46 = 0, $460 = 0, $461 = 0, $462 = 0, $463 = 0, $464 = 0, $465 = 0, $466 = 0, $467 = 0, $468 = 0, $469 = 0, $47 = 0, $470 = 0, $471 = 0, $472 = 0, $473 = 0; //@line 6129
 var $474 = 0, $475 = 0, $476 = 0, $477 = 0, $478 = 0, $479 = 0, $48 = 0, $480 = 0, $481 = 0, $482 = 0, $483 = 0, $484 = 0, $485 = 0, $486 = 0, $487 = 0, $488 = 0, $489 = 0, $49 = 0, $490 = 0, $491 = 0; //@line 6130
 var $492 = 0, $493 = 0, $494 = 0, $495 = 0, $496 = 0, $497 = 0, $498 = 0, $499 = 0, $5 = 0, $50 = 0, $500 = 0, $501 = 0, $502 = 0, $503 = 0, $504 = 0, $505 = 0, $506 = 0, $507 = 0, $508 = 0, $509 = 0; //@line 6131
 var $51 = 0, $510 = 0, $511 = 0, $512 = 0, $513 = 0, $514 = 0, $515 = 0, $516 = 0, $517 = 0, $518 = 0, $519 = 0, $52 = 0, $520 = 0, $521 = 0, $522 = 0, $523 = 0, $524 = 0, $525 = 0, $526 = 0, $527 = 0; //@line 6132
 var $528 = 0, $529 = 0, $53 = 0, $530 = 0, $531 = 0, $532 = 0, $533 = 0, $534 = 0, $535 = 0, $536 = 0, $537 = 0, $538 = 0, $539 = 0, $54 = 0, $540 = 0, $541 = 0, $542 = 0, $543 = 0, $544 = 0, $545 = 0; //@line 6133
 var $546 = 0, $547 = 0, $548 = 0, $549 = 0, $55 = 0, $550 = 0, $551 = 0, $552 = 0, $553 = 0, $554 = 0, $555 = 0, $556 = 0, $557 = 0, $558 = 0, $559 = 0, $56 = 0, $560 = 0, $561 = 0, $562 = 0, $563 = 0; //@line 6134
 var $564 = 0, $565 = 0, $566 = 0, $567 = 0, $568 = 0, $569 = 0, $57 = 0, $570 = 0, $571 = 0, $572 = 0, $573 = 0, $574 = 0, $575 = 0, $576 = 0, $577 = 0, $578 = 0, $579 = 0, $58 = 0, $580 = 0, $581 = 0; //@line 6135
 var $582 = 0, $583 = 0, $584 = 0, $585 = 0, $586 = 0, $587 = 0, $588 = 0, $589 = 0, $59 = 0, $590 = 0, $591 = 0, $592 = 0, $593 = 0, $594 = 0, $595 = 0, $596 = 0, $597 = 0, $598 = 0, $599 = 0, $6 = 0; //@line 6136
 var $60 = 0, $600 = 0, $601 = 0, $602 = 0, $603 = 0, $604 = 0, $605 = 0, $606 = 0, $607 = 0, $608 = 0, $609 = 0, $61 = 0, $610 = 0, $611 = 0, $612 = 0, $613 = 0, $614 = 0, $615 = 0, $616 = 0, $617 = 0; //@line 6137
 var $618 = 0, $619 = 0, $62 = 0, $620 = 0, $621 = 0, $622 = 0, $623 = 0, $624 = 0, $625 = 0, $626 = 0, $627 = 0, $628 = 0, $629 = 0, $63 = 0, $630 = 0, $631 = 0, $632 = 0, $633 = 0, $634 = 0, $635 = 0; //@line 6138
 var $636 = 0, $637 = 0, $638 = 0, $639 = 0, $64 = 0, $640 = 0, $641 = 0, $642 = 0, $643 = 0, $644 = 0, $645 = 0, $646 = 0, $647 = 0, $648 = 0, $649 = 0, $65 = 0, $650 = 0, $651 = 0, $652 = 0, $653 = 0; //@line 6139
 var $654 = 0, $655 = 0, $656 = 0, $657 = 0, $658 = 0, $659 = 0, $66 = 0, $660 = 0, $661 = 0, $662 = 0, $663 = 0, $664 = 0, $665 = 0, $666 = 0, $667 = 0, $668 = 0, $669 = 0, $67 = 0, $670 = 0, $671 = 0; //@line 6140
 var $672 = 0, $673 = 0, $674 = 0, $675 = 0, $676 = 0, $677 = 0, $678 = 0, $679 = 0, $68 = 0, $680 = 0, $681 = 0, $682 = 0, $683 = 0, $684 = 0, $685 = 0, $686 = 0, $687 = 0, $688 = 0, $689 = 0, $69 = 0; //@line 6141
 var $690 = 0, $691 = 0, $692 = 0, $693 = 0, $694 = 0, $695 = 0, $696 = 0, $697 = 0, $698 = 0, $699 = 0, $7 = 0, $70 = 0, $700 = 0, $701 = 0, $702 = 0, $703 = 0, $704 = 0, $705 = 0, $706 = 0, $707 = 0; //@line 6142
 var $708 = 0, $709 = 0, $71 = 0, $710 = 0, $711 = 0, $712 = 0, $713 = 0, $714 = 0, $715 = 0, $716 = 0, $717 = 0, $718 = 0, $719 = 0, $72 = 0, $720 = 0, $721 = 0, $722 = 0, $723 = 0, $724 = 0, $725 = 0; //@line 6143
 var $726 = 0, $727 = 0, $728 = 0, $729 = 0, $73 = 0, $730 = 0, $731 = 0, $732 = 0, $733 = 0, $734 = 0, $735 = 0, $736 = 0, $737 = 0, $738 = 0, $739 = 0, $74 = 0, $740 = 0, $741 = 0, $742 = 0, $743 = 0; //@line 6144
 var $744 = 0, $745 = 0, $746 = 0, $747 = 0, $748 = 0, $749 = 0, $75 = 0, $750 = 0, $751 = 0, $752 = 0, $753 = 0, $754 = 0, $755 = 0, $756 = 0, $757 = 0, $758 = 0, $759 = 0, $76 = 0, $760 = 0, $761 = 0; //@line 6145
 var $762 = 0, $763 = 0, $764 = 0, $765 = 0, $766 = 0, $767 = 0, $768 = 0, $769 = 0, $77 = 0, $770 = 0, $771 = 0, $772 = 0, $773 = 0, $774 = 0, $775 = 0, $776 = 0, $777 = 0, $778 = 0, $779 = 0, $78 = 0; //@line 6146
 var $780 = 0, $781 = 0, $782 = 0, $783 = 0, $784 = 0, $785 = 0, $786 = 0, $787 = 0, $788 = 0, $789 = 0, $79 = 0, $790 = 0, $791 = 0, $792 = 0, $793 = 0, $794 = 0, $795 = 0, $796 = 0, $797 = 0, $798 = 0; //@line 6147
 var $799 = 0, $8 = 0, $80 = 0, $800 = 0, $801 = 0, $802 = 0, $803 = 0, $804 = 0, $805 = 0, $806 = 0, $807 = 0, $808 = 0, $809 = 0, $81 = 0, $810 = 0, $811 = 0, $812 = 0, $813 = 0, $814 = 0, $815 = 0; //@line 6148
 var $816 = 0, $817 = 0, $818 = 0, $819 = 0, $82 = 0, $820 = 0, $821 = 0, $822 = 0, $823 = 0, $824 = 0, $825 = 0, $826 = 0, $827 = 0, $828 = 0, $829 = 0, $83 = 0, $830 = 0, $831 = 0, $832 = 0, $833 = 0; //@line 6149
 var $834 = 0, $835 = 0, $836 = 0, $837 = 0, $838 = 0, $839 = 0, $84 = 0, $840 = 0, $841 = 0, $842 = 0, $843 = 0, $844 = 0, $845 = 0, $846 = 0, $847 = 0, $848 = 0, $849 = 0, $85 = 0, $850 = 0, $851 = 0; //@line 6150
 var $852 = 0, $853 = 0, $854 = 0, $855 = 0, $856 = 0, $857 = 0, $858 = 0, $859 = 0, $86 = 0, $860 = 0, $861 = 0, $862 = 0, $863 = 0, $864 = 0, $865 = 0, $866 = 0, $867 = 0, $868 = 0, $869 = 0, $87 = 0; //@line 6151
 var $870 = 0, $871 = 0, $872 = 0, $873 = 0, $874 = 0, $875 = 0, $876 = 0, $877 = 0, $878 = 0, $879 = 0, $88 = 0, $880 = 0, $881 = 0, $882 = 0, $883 = 0, $884 = 0, $885 = 0, $886 = 0, $887 = 0, $888 = 0; //@line 6152
 var $889 = 0, $89 = 0, $890 = 0, $891 = 0, $892 = 0, $893 = 0, $894 = 0, $895 = 0, $896 = 0, $897 = 0, $898 = 0, $899 = 0, $9 = 0, $90 = 0, $900 = 0, $901 = 0, $902 = 0, $903 = 0, $904 = 0, $905 = 0; //@line 6153
 var $906 = 0, $907 = 0, $908 = 0, $909 = 0, $91 = 0, $910 = 0, $911 = 0, $912 = 0, $913 = 0, $914 = 0, $915 = 0, $916 = 0, $917 = 0, $918 = 0, $919 = 0, $92 = 0, $920 = 0, $921 = 0, $922 = 0, $923 = 0; //@line 6154
 var $924 = 0, $925 = 0, $926 = 0, $927 = 0, $928 = 0, $929 = 0, $93 = 0, $930 = 0, $931 = 0, $932 = 0, $933 = 0, $934 = 0, $935 = 0, $936 = 0, $937 = 0, $938 = 0, $939 = 0, $94 = 0, $940 = 0, $941 = 0; //@line 6155
 var $942 = 0, $943 = 0, $944 = 0, $945 = 0, $946 = 0, $947 = 0, $948 = 0, $949 = 0, $95 = 0, $950 = 0, $951 = 0, $952 = 0, $953 = 0, $954 = 0, $955 = 0, $956 = 0, $957 = 0, $958 = 0, $959 = 0, $96 = 0; //@line 6156
 var $960 = 0, $961 = 0, $962 = 0, $963 = 0, $964 = 0, $965 = 0, $966 = 0, $967 = 0, $968 = 0, $969 = 0, $97 = 0, $970 = 0, $971 = 0, $972 = 0, $973 = 0, $974 = 0, $975 = 0, $976 = 0, $977 = 0, $978 = 0; //@line 6157
 var $979 = 0, $98 = 0, $980 = 0, $981 = 0, $982 = 0, $983 = 0, $984 = 0, $985 = 0, $986 = 0, $987 = 0, $988 = 0, $989 = 0, $99 = 0, $990 = 0, $991 = 0, $992 = 0, $993 = 0, $994 = 0, $995 = 0, $996 = 0; //@line 6158
 var $997 = 0, $998 = 0, $999 = 0, $cond$i = 0, $cond$i$i = 0, $cond$i207 = 0, $not$$i = 0, $or$cond$i = 0, $or$cond$i213 = 0, $or$cond1$i = 0, $or$cond11$i = 0, $or$cond2$i = 0, $or$cond2$i214 = 0, $or$cond5$i = 0, $or$cond50$i = 0, $or$cond51$i = 0, $or$cond6$i = 0, $or$cond7$i = 0, $or$cond8$i = 0, $or$cond8$not$i = 0; //@line 6159
 var $spec$select$i = 0, $spec$select$i205 = 0, $spec$select1$i = 0, $spec$select3$i = 0, $spec$select49$i = 0, $spec$select7$i = 0, $spec$select9$i = 0, label = 0, sp = 0; //@line 6160
 sp = STACKTOP; //@line 6161
 STACKTOP = STACKTOP + 16 | 0; //@line 6162
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 6162
 $1 = sp; //@line 6163
 $2 = $0 >>> 0 < 245; //@line 6164
 do {
  if ($2) {
   $3 = $0 >>> 0 < 11; //@line 6167
   $4 = $0 + 11 | 0; //@line 6168
   $5 = $4 & -8; //@line 6169
   $6 = $3 ? 16 : $5; //@line 6170
   $7 = $6 >>> 3; //@line 6171
   $8 = SAFE_HEAP_LOAD(2824 * 4 | 0, 4, 0) | 0 | 0; //@line 6172
   $9 = $8 >>> $7; //@line 6173
   $10 = $9 & 3; //@line 6174
   $11 = ($10 | 0) == 0; //@line 6175
   if (!$11) {
    $12 = $9 & 1; //@line 6177
    $13 = $12 ^ 1; //@line 6178
    $14 = $13 + $7 | 0; //@line 6179
    $15 = $14 << 1; //@line 6180
    $16 = 11336 + ($15 << 2) | 0; //@line 6181
    $17 = $16 + 8 | 0; //@line 6182
    $18 = SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0; //@line 6183
    $19 = $18 + 8 | 0; //@line 6184
    $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 6185
    $21 = ($20 | 0) == ($16 | 0); //@line 6186
    do {
     if ($21) {
      $22 = 1 << $14; //@line 6189
      $23 = $22 ^ -1; //@line 6190
      $24 = $8 & $23; //@line 6191
      SAFE_HEAP_STORE(2824 * 4 | 0, $24 | 0, 4);
     } else {
      $25 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 6194
      $26 = $25 >>> 0 > $20 >>> 0; //@line 6195
      if ($26) {
       _abort(); //@line 6197
      }
      $27 = $20 + 12 | 0; //@line 6200
      $28 = SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0; //@line 6201
      $29 = ($28 | 0) == ($18 | 0); //@line 6202
      if ($29) {
       SAFE_HEAP_STORE($27 | 0, $16 | 0, 4);
       SAFE_HEAP_STORE($17 | 0, $20 | 0, 4);
       break;
      } else {
       _abort(); //@line 6208
      }
     }
    } while (0);
    $30 = $14 << 3; //@line 6213
    $31 = $30 | 3; //@line 6214
    $32 = $18 + 4 | 0; //@line 6215
    SAFE_HEAP_STORE($32 | 0, $31 | 0, 4);
    $33 = $18 + $30 | 0; //@line 6217
    $34 = $33 + 4 | 0; //@line 6218
    $35 = SAFE_HEAP_LOAD($34 | 0, 4, 0) | 0 | 0; //@line 6219
    $36 = $35 | 1; //@line 6220
    SAFE_HEAP_STORE($34 | 0, $36 | 0, 4);
    $$0 = $19; //@line 6222
    STACKTOP = sp; //@line 6223
    return $$0 | 0; //@line 6223
   }
   $37 = SAFE_HEAP_LOAD(11304 | 0, 4, 0) | 0 | 0; //@line 6225
   $38 = $6 >>> 0 > $37 >>> 0; //@line 6226
   if ($38) {
    $39 = ($9 | 0) == 0; //@line 6228
    if (!$39) {
     $40 = $9 << $7; //@line 6230
     $41 = 2 << $7; //@line 6231
     $42 = 0 - $41 | 0; //@line 6232
     $43 = $41 | $42; //@line 6233
     $44 = $40 & $43; //@line 6234
     $45 = 0 - $44 | 0; //@line 6235
     $46 = $44 & $45; //@line 6236
     $47 = $46 + -1 | 0; //@line 6237
     $48 = $47 >>> 12; //@line 6238
     $49 = $48 & 16; //@line 6239
     $50 = $47 >>> $49; //@line 6240
     $51 = $50 >>> 5; //@line 6241
     $52 = $51 & 8; //@line 6242
     $53 = $52 | $49; //@line 6243
     $54 = $50 >>> $52; //@line 6244
     $55 = $54 >>> 2; //@line 6245
     $56 = $55 & 4; //@line 6246
     $57 = $53 | $56; //@line 6247
     $58 = $54 >>> $56; //@line 6248
     $59 = $58 >>> 1; //@line 6249
     $60 = $59 & 2; //@line 6250
     $61 = $57 | $60; //@line 6251
     $62 = $58 >>> $60; //@line 6252
     $63 = $62 >>> 1; //@line 6253
     $64 = $63 & 1; //@line 6254
     $65 = $61 | $64; //@line 6255
     $66 = $62 >>> $64; //@line 6256
     $67 = $65 + $66 | 0; //@line 6257
     $68 = $67 << 1; //@line 6258
     $69 = 11336 + ($68 << 2) | 0; //@line 6259
     $70 = $69 + 8 | 0; //@line 6260
     $71 = SAFE_HEAP_LOAD($70 | 0, 4, 0) | 0 | 0; //@line 6261
     $72 = $71 + 8 | 0; //@line 6262
     $73 = SAFE_HEAP_LOAD($72 | 0, 4, 0) | 0 | 0; //@line 6263
     $74 = ($73 | 0) == ($69 | 0); //@line 6264
     do {
      if ($74) {
       $75 = 1 << $67; //@line 6267
       $76 = $75 ^ -1; //@line 6268
       $77 = $8 & $76; //@line 6269
       SAFE_HEAP_STORE(2824 * 4 | 0, $77 | 0, 4);
       $98 = $77; //@line 6271
      } else {
       $78 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 6273
       $79 = $78 >>> 0 > $73 >>> 0; //@line 6274
       if ($79) {
        _abort(); //@line 6276
       }
       $80 = $73 + 12 | 0; //@line 6279
       $81 = SAFE_HEAP_LOAD($80 | 0, 4, 0) | 0 | 0; //@line 6280
       $82 = ($81 | 0) == ($71 | 0); //@line 6281
       if ($82) {
        SAFE_HEAP_STORE($80 | 0, $69 | 0, 4);
        SAFE_HEAP_STORE($70 | 0, $73 | 0, 4);
        $98 = $8; //@line 6285
        break;
       } else {
        _abort(); //@line 6288
       }
      }
     } while (0);
     $83 = $67 << 3; //@line 6293
     $84 = $83 - $6 | 0; //@line 6294
     $85 = $6 | 3; //@line 6295
     $86 = $71 + 4 | 0; //@line 6296
     SAFE_HEAP_STORE($86 | 0, $85 | 0, 4);
     $87 = $71 + $6 | 0; //@line 6298
     $88 = $84 | 1; //@line 6299
     $89 = $87 + 4 | 0; //@line 6300
     SAFE_HEAP_STORE($89 | 0, $88 | 0, 4);
     $90 = $71 + $83 | 0; //@line 6302
     SAFE_HEAP_STORE($90 | 0, $84 | 0, 4);
     $91 = ($37 | 0) == 0; //@line 6304
     if (!$91) {
      $92 = SAFE_HEAP_LOAD(11316 | 0, 4, 0) | 0 | 0; //@line 6306
      $93 = $37 >>> 3; //@line 6307
      $94 = $93 << 1; //@line 6308
      $95 = 11336 + ($94 << 2) | 0; //@line 6309
      $96 = 1 << $93; //@line 6310
      $97 = $98 & $96; //@line 6311
      $99 = ($97 | 0) == 0; //@line 6312
      if ($99) {
       $100 = $98 | $96; //@line 6314
       SAFE_HEAP_STORE(2824 * 4 | 0, $100 | 0, 4);
       $$pre = $95 + 8 | 0; //@line 6316
       $$0199 = $95; //@line 6317
       $$pre$phiZ2D = $$pre; //@line 6317
      } else {
       $101 = $95 + 8 | 0; //@line 6319
       $102 = SAFE_HEAP_LOAD($101 | 0, 4, 0) | 0 | 0; //@line 6320
       $103 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 6321
       $104 = $103 >>> 0 > $102 >>> 0; //@line 6322
       if ($104) {
        _abort(); //@line 6324
       } else {
        $$0199 = $102; //@line 6327
        $$pre$phiZ2D = $101; //@line 6327
       }
      }
      SAFE_HEAP_STORE($$pre$phiZ2D | 0, $92 | 0, 4);
      $105 = $$0199 + 12 | 0; //@line 6331
      SAFE_HEAP_STORE($105 | 0, $92 | 0, 4);
      $106 = $92 + 8 | 0; //@line 6333
      SAFE_HEAP_STORE($106 | 0, $$0199 | 0, 4);
      $107 = $92 + 12 | 0; //@line 6335
      SAFE_HEAP_STORE($107 | 0, $95 | 0, 4);
     }
     SAFE_HEAP_STORE(11304 | 0, $84 | 0, 4);
     SAFE_HEAP_STORE(11316 | 0, $87 | 0, 4);
     $$0 = $72; //@line 6340
     STACKTOP = sp; //@line 6341
     return $$0 | 0; //@line 6341
    }
    $108 = SAFE_HEAP_LOAD(11300 | 0, 4, 0) | 0 | 0; //@line 6343
    $109 = ($108 | 0) == 0; //@line 6344
    if ($109) {
     $$0197 = $6; //@line 6346
    } else {
     $110 = 0 - $108 | 0; //@line 6348
     $111 = $108 & $110; //@line 6349
     $112 = $111 + -1 | 0; //@line 6350
     $113 = $112 >>> 12; //@line 6351
     $114 = $113 & 16; //@line 6352
     $115 = $112 >>> $114; //@line 6353
     $116 = $115 >>> 5; //@line 6354
     $117 = $116 & 8; //@line 6355
     $118 = $117 | $114; //@line 6356
     $119 = $115 >>> $117; //@line 6357
     $120 = $119 >>> 2; //@line 6358
     $121 = $120 & 4; //@line 6359
     $122 = $118 | $121; //@line 6360
     $123 = $119 >>> $121; //@line 6361
     $124 = $123 >>> 1; //@line 6362
     $125 = $124 & 2; //@line 6363
     $126 = $122 | $125; //@line 6364
     $127 = $123 >>> $125; //@line 6365
     $128 = $127 >>> 1; //@line 6366
     $129 = $128 & 1; //@line 6367
     $130 = $126 | $129; //@line 6368
     $131 = $127 >>> $129; //@line 6369
     $132 = $130 + $131 | 0; //@line 6370
     $133 = 11600 + ($132 << 2) | 0; //@line 6371
     $134 = SAFE_HEAP_LOAD($133 | 0, 4, 0) | 0 | 0; //@line 6372
     $135 = $134 + 4 | 0; //@line 6373
     $136 = SAFE_HEAP_LOAD($135 | 0, 4, 0) | 0 | 0; //@line 6374
     $137 = $136 & -8; //@line 6375
     $138 = $137 - $6 | 0; //@line 6376
     $$0189$i = $134; //@line 6377
     $$0190$i = $134; //@line 6377
     $$0191$i = $138; //@line 6377
     while (1) {
      $139 = $$0189$i + 16 | 0; //@line 6379
      $140 = SAFE_HEAP_LOAD($139 | 0, 4, 0) | 0 | 0; //@line 6380
      $141 = ($140 | 0) == (0 | 0); //@line 6381
      if ($141) {
       $142 = $$0189$i + 20 | 0; //@line 6383
       $143 = SAFE_HEAP_LOAD($142 | 0, 4, 0) | 0 | 0; //@line 6384
       $144 = ($143 | 0) == (0 | 0); //@line 6385
       if ($144) {
        break;
       } else {
        $146 = $143; //@line 6389
       }
      } else {
       $146 = $140; //@line 6392
      }
      $145 = $146 + 4 | 0; //@line 6394
      $147 = SAFE_HEAP_LOAD($145 | 0, 4, 0) | 0 | 0; //@line 6395
      $148 = $147 & -8; //@line 6396
      $149 = $148 - $6 | 0; //@line 6397
      $150 = $149 >>> 0 < $$0191$i >>> 0; //@line 6398
      $spec$select$i = $150 ? $149 : $$0191$i; //@line 6399
      $spec$select1$i = $150 ? $146 : $$0190$i; //@line 6400
      $$0189$i = $146; //@line 6401
      $$0190$i = $spec$select1$i; //@line 6401
      $$0191$i = $spec$select$i; //@line 6401
     }
     $151 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 6403
     $152 = $151 >>> 0 > $$0190$i >>> 0; //@line 6404
     if ($152) {
      _abort(); //@line 6406
     }
     $153 = $$0190$i + $6 | 0; //@line 6409
     $154 = $153 >>> 0 > $$0190$i >>> 0; //@line 6410
     if (!$154) {
      _abort(); //@line 6412
     }
     $155 = $$0190$i + 24 | 0; //@line 6415
     $156 = SAFE_HEAP_LOAD($155 | 0, 4, 0) | 0 | 0; //@line 6416
     $157 = $$0190$i + 12 | 0; //@line 6417
     $158 = SAFE_HEAP_LOAD($157 | 0, 4, 0) | 0 | 0; //@line 6418
     $159 = ($158 | 0) == ($$0190$i | 0); //@line 6419
     do {
      if ($159) {
       $169 = $$0190$i + 20 | 0; //@line 6422
       $170 = SAFE_HEAP_LOAD($169 | 0, 4, 0) | 0 | 0; //@line 6423
       $171 = ($170 | 0) == (0 | 0); //@line 6424
       if ($171) {
        $172 = $$0190$i + 16 | 0; //@line 6426
        $173 = SAFE_HEAP_LOAD($172 | 0, 4, 0) | 0 | 0; //@line 6427
        $174 = ($173 | 0) == (0 | 0); //@line 6428
        if ($174) {
         $$3$i = 0; //@line 6430
         break;
        } else {
         $$1194$i$ph = $173; //@line 6433
         $$1196$i$ph = $172; //@line 6433
        }
       } else {
        $$1194$i$ph = $170; //@line 6436
        $$1196$i$ph = $169; //@line 6436
       }
       $$1194$i = $$1194$i$ph; //@line 6438
       $$1196$i = $$1196$i$ph; //@line 6438
       while (1) {
        $175 = $$1194$i + 20 | 0; //@line 6440
        $176 = SAFE_HEAP_LOAD($175 | 0, 4, 0) | 0 | 0; //@line 6441
        $177 = ($176 | 0) == (0 | 0); //@line 6442
        if ($177) {
         $178 = $$1194$i + 16 | 0; //@line 6444
         $179 = SAFE_HEAP_LOAD($178 | 0, 4, 0) | 0 | 0; //@line 6445
         $180 = ($179 | 0) == (0 | 0); //@line 6446
         if ($180) {
          break;
         } else {
          $$1194$i$be = $179; //@line 6450
          $$1196$i$be = $178; //@line 6450
         }
        } else {
         $$1194$i$be = $176; //@line 6453
         $$1196$i$be = $175; //@line 6453
        }
        $$1194$i = $$1194$i$be; //@line 6455
        $$1196$i = $$1196$i$be; //@line 6455
       }
       $181 = $151 >>> 0 > $$1196$i >>> 0; //@line 6457
       if ($181) {
        _abort(); //@line 6459
       } else {
        SAFE_HEAP_STORE($$1196$i | 0, 0 | 0, 4);
        $$3$i = $$1194$i; //@line 6463
        break;
       }
      } else {
       $160 = $$0190$i + 8 | 0; //@line 6467
       $161 = SAFE_HEAP_LOAD($160 | 0, 4, 0) | 0 | 0; //@line 6468
       $162 = $151 >>> 0 > $161 >>> 0; //@line 6469
       if ($162) {
        _abort(); //@line 6471
       }
       $163 = $161 + 12 | 0; //@line 6474
       $164 = SAFE_HEAP_LOAD($163 | 0, 4, 0) | 0 | 0; //@line 6475
       $165 = ($164 | 0) == ($$0190$i | 0); //@line 6476
       if (!$165) {
        _abort(); //@line 6478
       }
       $166 = $158 + 8 | 0; //@line 6481
       $167 = SAFE_HEAP_LOAD($166 | 0, 4, 0) | 0 | 0; //@line 6482
       $168 = ($167 | 0) == ($$0190$i | 0); //@line 6483
       if ($168) {
        SAFE_HEAP_STORE($163 | 0, $158 | 0, 4);
        SAFE_HEAP_STORE($166 | 0, $161 | 0, 4);
        $$3$i = $158; //@line 6487
        break;
       } else {
        _abort(); //@line 6490
       }
      }
     } while (0);
     $182 = ($156 | 0) == (0 | 0); //@line 6495
     L78 : do {
      if (!$182) {
       $183 = $$0190$i + 28 | 0; //@line 6498
       $184 = SAFE_HEAP_LOAD($183 | 0, 4, 0) | 0 | 0; //@line 6499
       $185 = 11600 + ($184 << 2) | 0; //@line 6500
       $186 = SAFE_HEAP_LOAD($185 | 0, 4, 0) | 0 | 0; //@line 6501
       $187 = ($$0190$i | 0) == ($186 | 0); //@line 6502
       do {
        if ($187) {
         SAFE_HEAP_STORE($185 | 0, $$3$i | 0, 4);
         $cond$i = ($$3$i | 0) == (0 | 0); //@line 6506
         if ($cond$i) {
          $188 = 1 << $184; //@line 6508
          $189 = $188 ^ -1; //@line 6509
          $190 = $108 & $189; //@line 6510
          SAFE_HEAP_STORE(11300 | 0, $190 | 0, 4);
          break L78;
         }
        } else {
         $191 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 6515
         $192 = $191 >>> 0 > $156 >>> 0; //@line 6516
         if ($192) {
          _abort(); //@line 6518
         } else {
          $193 = $156 + 16 | 0; //@line 6521
          $194 = SAFE_HEAP_LOAD($193 | 0, 4, 0) | 0 | 0; //@line 6522
          $195 = ($194 | 0) == ($$0190$i | 0); //@line 6523
          $196 = $156 + 20 | 0; //@line 6524
          $$sink = $195 ? $193 : $196; //@line 6525
          SAFE_HEAP_STORE($$sink | 0, $$3$i | 0, 4);
          $197 = ($$3$i | 0) == (0 | 0); //@line 6527
          if ($197) {
           break L78;
          } else {
           break;
          }
         }
        }
       } while (0);
       $198 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 6536
       $199 = $198 >>> 0 > $$3$i >>> 0; //@line 6537
       if ($199) {
        _abort(); //@line 6539
       }
       $200 = $$3$i + 24 | 0; //@line 6542
       SAFE_HEAP_STORE($200 | 0, $156 | 0, 4);
       $201 = $$0190$i + 16 | 0; //@line 6544
       $202 = SAFE_HEAP_LOAD($201 | 0, 4, 0) | 0 | 0; //@line 6545
       $203 = ($202 | 0) == (0 | 0); //@line 6546
       do {
        if (!$203) {
         $204 = $198 >>> 0 > $202 >>> 0; //@line 6549
         if ($204) {
          _abort(); //@line 6551
         } else {
          $205 = $$3$i + 16 | 0; //@line 6554
          SAFE_HEAP_STORE($205 | 0, $202 | 0, 4);
          $206 = $202 + 24 | 0; //@line 6556
          SAFE_HEAP_STORE($206 | 0, $$3$i | 0, 4);
          break;
         }
        }
       } while (0);
       $207 = $$0190$i + 20 | 0; //@line 6562
       $208 = SAFE_HEAP_LOAD($207 | 0, 4, 0) | 0 | 0; //@line 6563
       $209 = ($208 | 0) == (0 | 0); //@line 6564
       if (!$209) {
        $210 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 6566
        $211 = $210 >>> 0 > $208 >>> 0; //@line 6567
        if ($211) {
         _abort(); //@line 6569
        } else {
         $212 = $$3$i + 20 | 0; //@line 6572
         SAFE_HEAP_STORE($212 | 0, $208 | 0, 4);
         $213 = $208 + 24 | 0; //@line 6574
         SAFE_HEAP_STORE($213 | 0, $$3$i | 0, 4);
         break;
        }
       }
      }
     } while (0);
     $214 = $$0191$i >>> 0 < 16; //@line 6581
     if ($214) {
      $215 = $$0191$i + $6 | 0; //@line 6583
      $216 = $215 | 3; //@line 6584
      $217 = $$0190$i + 4 | 0; //@line 6585
      SAFE_HEAP_STORE($217 | 0, $216 | 0, 4);
      $218 = $$0190$i + $215 | 0; //@line 6587
      $219 = $218 + 4 | 0; //@line 6588
      $220 = SAFE_HEAP_LOAD($219 | 0, 4, 0) | 0 | 0; //@line 6589
      $221 = $220 | 1; //@line 6590
      SAFE_HEAP_STORE($219 | 0, $221 | 0, 4);
     } else {
      $222 = $6 | 3; //@line 6593
      $223 = $$0190$i + 4 | 0; //@line 6594
      SAFE_HEAP_STORE($223 | 0, $222 | 0, 4);
      $224 = $$0191$i | 1; //@line 6596
      $225 = $153 + 4 | 0; //@line 6597
      SAFE_HEAP_STORE($225 | 0, $224 | 0, 4);
      $226 = $153 + $$0191$i | 0; //@line 6599
      SAFE_HEAP_STORE($226 | 0, $$0191$i | 0, 4);
      $227 = ($37 | 0) == 0; //@line 6601
      if (!$227) {
       $228 = SAFE_HEAP_LOAD(11316 | 0, 4, 0) | 0 | 0; //@line 6603
       $229 = $37 >>> 3; //@line 6604
       $230 = $229 << 1; //@line 6605
       $231 = 11336 + ($230 << 2) | 0; //@line 6606
       $232 = 1 << $229; //@line 6607
       $233 = $232 & $8; //@line 6608
       $234 = ($233 | 0) == 0; //@line 6609
       if ($234) {
        $235 = $232 | $8; //@line 6611
        SAFE_HEAP_STORE(2824 * 4 | 0, $235 | 0, 4);
        $$pre$i = $231 + 8 | 0; //@line 6613
        $$0187$i = $231; //@line 6614
        $$pre$phi$iZ2D = $$pre$i; //@line 6614
       } else {
        $236 = $231 + 8 | 0; //@line 6616
        $237 = SAFE_HEAP_LOAD($236 | 0, 4, 0) | 0 | 0; //@line 6617
        $238 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 6618
        $239 = $238 >>> 0 > $237 >>> 0; //@line 6619
        if ($239) {
         _abort(); //@line 6621
        } else {
         $$0187$i = $237; //@line 6624
         $$pre$phi$iZ2D = $236; //@line 6624
        }
       }
       SAFE_HEAP_STORE($$pre$phi$iZ2D | 0, $228 | 0, 4);
       $240 = $$0187$i + 12 | 0; //@line 6628
       SAFE_HEAP_STORE($240 | 0, $228 | 0, 4);
       $241 = $228 + 8 | 0; //@line 6630
       SAFE_HEAP_STORE($241 | 0, $$0187$i | 0, 4);
       $242 = $228 + 12 | 0; //@line 6632
       SAFE_HEAP_STORE($242 | 0, $231 | 0, 4);
      }
      SAFE_HEAP_STORE(11304 | 0, $$0191$i | 0, 4);
      SAFE_HEAP_STORE(11316 | 0, $153 | 0, 4);
     }
     $243 = $$0190$i + 8 | 0; //@line 6638
     $$0 = $243; //@line 6639
     STACKTOP = sp; //@line 6640
     return $$0 | 0; //@line 6640
    }
   } else {
    $$0197 = $6; //@line 6643
   }
  } else {
   $244 = $0 >>> 0 > 4294967231; //@line 6646
   if ($244) {
    $$0197 = -1; //@line 6648
   } else {
    $245 = $0 + 11 | 0; //@line 6650
    $246 = $245 & -8; //@line 6651
    $247 = SAFE_HEAP_LOAD(11300 | 0, 4, 0) | 0 | 0; //@line 6652
    $248 = ($247 | 0) == 0; //@line 6653
    if ($248) {
     $$0197 = $246; //@line 6655
    } else {
     $249 = 0 - $246 | 0; //@line 6657
     $250 = $245 >>> 8; //@line 6658
     $251 = ($250 | 0) == 0; //@line 6659
     if ($251) {
      $$0357$i = 0; //@line 6661
     } else {
      $252 = $246 >>> 0 > 16777215; //@line 6663
      if ($252) {
       $$0357$i = 31; //@line 6665
      } else {
       $253 = $250 + 1048320 | 0; //@line 6667
       $254 = $253 >>> 16; //@line 6668
       $255 = $254 & 8; //@line 6669
       $256 = $250 << $255; //@line 6670
       $257 = $256 + 520192 | 0; //@line 6671
       $258 = $257 >>> 16; //@line 6672
       $259 = $258 & 4; //@line 6673
       $260 = $259 | $255; //@line 6674
       $261 = $256 << $259; //@line 6675
       $262 = $261 + 245760 | 0; //@line 6676
       $263 = $262 >>> 16; //@line 6677
       $264 = $263 & 2; //@line 6678
       $265 = $260 | $264; //@line 6679
       $266 = 14 - $265 | 0; //@line 6680
       $267 = $261 << $264; //@line 6681
       $268 = $267 >>> 15; //@line 6682
       $269 = $266 + $268 | 0; //@line 6683
       $270 = $269 << 1; //@line 6684
       $271 = $269 + 7 | 0; //@line 6685
       $272 = $246 >>> $271; //@line 6686
       $273 = $272 & 1; //@line 6687
       $274 = $273 | $270; //@line 6688
       $$0357$i = $274; //@line 6689
      }
     }
     $275 = 11600 + ($$0357$i << 2) | 0; //@line 6692
     $276 = SAFE_HEAP_LOAD($275 | 0, 4, 0) | 0 | 0; //@line 6693
     $277 = ($276 | 0) == (0 | 0); //@line 6694
     L122 : do {
      if ($277) {
       $$2353$i = 0; //@line 6697
       $$3$i203 = 0; //@line 6697
       $$3348$i = $249; //@line 6697
       label = 85; //@line 6698
      } else {
       $278 = ($$0357$i | 0) == 31; //@line 6700
       $279 = $$0357$i >>> 1; //@line 6701
       $280 = 25 - $279 | 0; //@line 6702
       $281 = $278 ? 0 : $280; //@line 6703
       $282 = $246 << $281; //@line 6704
       $$0340$i = 0; //@line 6705
       $$0345$i = $249; //@line 6705
       $$0351$i = $276; //@line 6705
       $$0358$i = $282; //@line 6705
       $$0361$i = 0; //@line 6705
       while (1) {
        $283 = $$0351$i + 4 | 0; //@line 6707
        $284 = SAFE_HEAP_LOAD($283 | 0, 4, 0) | 0 | 0; //@line 6708
        $285 = $284 & -8; //@line 6709
        $286 = $285 - $246 | 0; //@line 6710
        $287 = $286 >>> 0 < $$0345$i >>> 0; //@line 6711
        if ($287) {
         $288 = ($286 | 0) == 0; //@line 6713
         if ($288) {
          $$420$i$ph = $$0351$i; //@line 6715
          $$434919$i$ph = 0; //@line 6715
          $$535618$i$ph = $$0351$i; //@line 6715
          label = 89; //@line 6716
          break L122;
         } else {
          $$1341$i = $$0351$i; //@line 6719
          $$1346$i = $286; //@line 6719
         }
        } else {
         $$1341$i = $$0340$i; //@line 6722
         $$1346$i = $$0345$i; //@line 6722
        }
        $289 = $$0351$i + 20 | 0; //@line 6724
        $290 = SAFE_HEAP_LOAD($289 | 0, 4, 0) | 0 | 0; //@line 6725
        $291 = $$0358$i >>> 31; //@line 6726
        $292 = ($$0351$i + 16 | 0) + ($291 << 2) | 0; //@line 6727
        $293 = SAFE_HEAP_LOAD($292 | 0, 4, 0) | 0 | 0; //@line 6728
        $294 = ($290 | 0) == (0 | 0); //@line 6729
        $295 = ($290 | 0) == ($293 | 0); //@line 6730
        $or$cond2$i = $294 | $295; //@line 6731
        $$1362$i = $or$cond2$i ? $$0361$i : $290; //@line 6732
        $296 = ($293 | 0) == (0 | 0); //@line 6733
        $spec$select7$i = $$0358$i << 1; //@line 6734
        if ($296) {
         $$2353$i = $$1362$i; //@line 6736
         $$3$i203 = $$1341$i; //@line 6736
         $$3348$i = $$1346$i; //@line 6736
         label = 85; //@line 6737
         break;
        } else {
         $$0340$i = $$1341$i; //@line 6740
         $$0345$i = $$1346$i; //@line 6740
         $$0351$i = $293; //@line 6740
         $$0358$i = $spec$select7$i; //@line 6740
         $$0361$i = $$1362$i; //@line 6740
        }
       }
      }
     } while (0);
     if ((label | 0) == 85) {
      $297 = ($$2353$i | 0) == (0 | 0); //@line 6746
      $298 = ($$3$i203 | 0) == (0 | 0); //@line 6747
      $or$cond$i = $297 & $298; //@line 6748
      if ($or$cond$i) {
       $299 = 2 << $$0357$i; //@line 6750
       $300 = 0 - $299 | 0; //@line 6751
       $301 = $299 | $300; //@line 6752
       $302 = $301 & $247; //@line 6753
       $303 = ($302 | 0) == 0; //@line 6754
       if ($303) {
        $$0197 = $246; //@line 6756
        break;
       }
       $304 = 0 - $302 | 0; //@line 6759
       $305 = $302 & $304; //@line 6760
       $306 = $305 + -1 | 0; //@line 6761
       $307 = $306 >>> 12; //@line 6762
       $308 = $307 & 16; //@line 6763
       $309 = $306 >>> $308; //@line 6764
       $310 = $309 >>> 5; //@line 6765
       $311 = $310 & 8; //@line 6766
       $312 = $311 | $308; //@line 6767
       $313 = $309 >>> $311; //@line 6768
       $314 = $313 >>> 2; //@line 6769
       $315 = $314 & 4; //@line 6770
       $316 = $312 | $315; //@line 6771
       $317 = $313 >>> $315; //@line 6772
       $318 = $317 >>> 1; //@line 6773
       $319 = $318 & 2; //@line 6774
       $320 = $316 | $319; //@line 6775
       $321 = $317 >>> $319; //@line 6776
       $322 = $321 >>> 1; //@line 6777
       $323 = $322 & 1; //@line 6778
       $324 = $320 | $323; //@line 6779
       $325 = $321 >>> $323; //@line 6780
       $326 = $324 + $325 | 0; //@line 6781
       $327 = 11600 + ($326 << 2) | 0; //@line 6782
       $328 = SAFE_HEAP_LOAD($327 | 0, 4, 0) | 0 | 0; //@line 6783
       $$3$i203218 = 0; //@line 6784
       $$4355$i = $328; //@line 6784
      } else {
       $$3$i203218 = $$3$i203; //@line 6786
       $$4355$i = $$2353$i; //@line 6786
      }
      $329 = ($$4355$i | 0) == (0 | 0); //@line 6788
      if ($329) {
       $$4$lcssa$i = $$3$i203218; //@line 6790
       $$4349$lcssa$i = $$3348$i; //@line 6790
      } else {
       $$420$i$ph = $$3$i203218; //@line 6792
       $$434919$i$ph = $$3348$i; //@line 6792
       $$535618$i$ph = $$4355$i; //@line 6792
       label = 89; //@line 6793
      }
     }
     if ((label | 0) == 89) {
      $$420$i = $$420$i$ph; //@line 6797
      $$434919$i = $$434919$i$ph; //@line 6797
      $$535618$i = $$535618$i$ph; //@line 6797
      while (1) {
       $330 = $$535618$i + 4 | 0; //@line 6799
       $331 = SAFE_HEAP_LOAD($330 | 0, 4, 0) | 0 | 0; //@line 6800
       $332 = $331 & -8; //@line 6801
       $333 = $332 - $246 | 0; //@line 6802
       $334 = $333 >>> 0 < $$434919$i >>> 0; //@line 6803
       $spec$select$i205 = $334 ? $333 : $$434919$i; //@line 6804
       $spec$select3$i = $334 ? $$535618$i : $$420$i; //@line 6805
       $335 = $$535618$i + 16 | 0; //@line 6806
       $336 = SAFE_HEAP_LOAD($335 | 0, 4, 0) | 0 | 0; //@line 6807
       $337 = ($336 | 0) == (0 | 0); //@line 6808
       if ($337) {
        $338 = $$535618$i + 20 | 0; //@line 6810
        $339 = SAFE_HEAP_LOAD($338 | 0, 4, 0) | 0 | 0; //@line 6811
        $341 = $339; //@line 6812
       } else {
        $341 = $336; //@line 6814
       }
       $340 = ($341 | 0) == (0 | 0); //@line 6816
       if ($340) {
        $$4$lcssa$i = $spec$select3$i; //@line 6818
        $$4349$lcssa$i = $spec$select$i205; //@line 6818
        break;
       } else {
        $$420$i = $spec$select3$i; //@line 6821
        $$434919$i = $spec$select$i205; //@line 6821
        $$535618$i = $341; //@line 6821
       }
      }
     }
     $342 = ($$4$lcssa$i | 0) == (0 | 0); //@line 6825
     if ($342) {
      $$0197 = $246; //@line 6827
     } else {
      $343 = SAFE_HEAP_LOAD(11304 | 0, 4, 0) | 0 | 0; //@line 6829
      $344 = $343 - $246 | 0; //@line 6830
      $345 = $$4349$lcssa$i >>> 0 < $344 >>> 0; //@line 6831
      if ($345) {
       $346 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 6833
       $347 = $346 >>> 0 > $$4$lcssa$i >>> 0; //@line 6834
       if ($347) {
        _abort(); //@line 6836
       }
       $348 = $$4$lcssa$i + $246 | 0; //@line 6839
       $349 = $348 >>> 0 > $$4$lcssa$i >>> 0; //@line 6840
       if (!$349) {
        _abort(); //@line 6842
       }
       $350 = $$4$lcssa$i + 24 | 0; //@line 6845
       $351 = SAFE_HEAP_LOAD($350 | 0, 4, 0) | 0 | 0; //@line 6846
       $352 = $$4$lcssa$i + 12 | 0; //@line 6847
       $353 = SAFE_HEAP_LOAD($352 | 0, 4, 0) | 0 | 0; //@line 6848
       $354 = ($353 | 0) == ($$4$lcssa$i | 0); //@line 6849
       do {
        if ($354) {
         $364 = $$4$lcssa$i + 20 | 0; //@line 6852
         $365 = SAFE_HEAP_LOAD($364 | 0, 4, 0) | 0 | 0; //@line 6853
         $366 = ($365 | 0) == (0 | 0); //@line 6854
         if ($366) {
          $367 = $$4$lcssa$i + 16 | 0; //@line 6856
          $368 = SAFE_HEAP_LOAD($367 | 0, 4, 0) | 0 | 0; //@line 6857
          $369 = ($368 | 0) == (0 | 0); //@line 6858
          if ($369) {
           $$3371$i = 0; //@line 6860
           break;
          } else {
           $$1369$i$ph = $368; //@line 6863
           $$1373$i$ph = $367; //@line 6863
          }
         } else {
          $$1369$i$ph = $365; //@line 6866
          $$1373$i$ph = $364; //@line 6866
         }
         $$1369$i = $$1369$i$ph; //@line 6868
         $$1373$i = $$1373$i$ph; //@line 6868
         while (1) {
          $370 = $$1369$i + 20 | 0; //@line 6870
          $371 = SAFE_HEAP_LOAD($370 | 0, 4, 0) | 0 | 0; //@line 6871
          $372 = ($371 | 0) == (0 | 0); //@line 6872
          if ($372) {
           $373 = $$1369$i + 16 | 0; //@line 6874
           $374 = SAFE_HEAP_LOAD($373 | 0, 4, 0) | 0 | 0; //@line 6875
           $375 = ($374 | 0) == (0 | 0); //@line 6876
           if ($375) {
            break;
           } else {
            $$1369$i$be = $374; //@line 6880
            $$1373$i$be = $373; //@line 6880
           }
          } else {
           $$1369$i$be = $371; //@line 6883
           $$1373$i$be = $370; //@line 6883
          }
          $$1369$i = $$1369$i$be; //@line 6885
          $$1373$i = $$1373$i$be; //@line 6885
         }
         $376 = $346 >>> 0 > $$1373$i >>> 0; //@line 6887
         if ($376) {
          _abort(); //@line 6889
         } else {
          SAFE_HEAP_STORE($$1373$i | 0, 0 | 0, 4);
          $$3371$i = $$1369$i; //@line 6893
          break;
         }
        } else {
         $355 = $$4$lcssa$i + 8 | 0; //@line 6897
         $356 = SAFE_HEAP_LOAD($355 | 0, 4, 0) | 0 | 0; //@line 6898
         $357 = $346 >>> 0 > $356 >>> 0; //@line 6899
         if ($357) {
          _abort(); //@line 6901
         }
         $358 = $356 + 12 | 0; //@line 6904
         $359 = SAFE_HEAP_LOAD($358 | 0, 4, 0) | 0 | 0; //@line 6905
         $360 = ($359 | 0) == ($$4$lcssa$i | 0); //@line 6906
         if (!$360) {
          _abort(); //@line 6908
         }
         $361 = $353 + 8 | 0; //@line 6911
         $362 = SAFE_HEAP_LOAD($361 | 0, 4, 0) | 0 | 0; //@line 6912
         $363 = ($362 | 0) == ($$4$lcssa$i | 0); //@line 6913
         if ($363) {
          SAFE_HEAP_STORE($358 | 0, $353 | 0, 4);
          SAFE_HEAP_STORE($361 | 0, $356 | 0, 4);
          $$3371$i = $353; //@line 6917
          break;
         } else {
          _abort(); //@line 6920
         }
        }
       } while (0);
       $377 = ($351 | 0) == (0 | 0); //@line 6925
       L176 : do {
        if ($377) {
         $469 = $247; //@line 6928
        } else {
         $378 = $$4$lcssa$i + 28 | 0; //@line 6930
         $379 = SAFE_HEAP_LOAD($378 | 0, 4, 0) | 0 | 0; //@line 6931
         $380 = 11600 + ($379 << 2) | 0; //@line 6932
         $381 = SAFE_HEAP_LOAD($380 | 0, 4, 0) | 0 | 0; //@line 6933
         $382 = ($$4$lcssa$i | 0) == ($381 | 0); //@line 6934
         do {
          if ($382) {
           SAFE_HEAP_STORE($380 | 0, $$3371$i | 0, 4);
           $cond$i207 = ($$3371$i | 0) == (0 | 0); //@line 6938
           if ($cond$i207) {
            $383 = 1 << $379; //@line 6940
            $384 = $383 ^ -1; //@line 6941
            $385 = $247 & $384; //@line 6942
            SAFE_HEAP_STORE(11300 | 0, $385 | 0, 4);
            $469 = $385; //@line 6944
            break L176;
           }
          } else {
           $386 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 6948
           $387 = $386 >>> 0 > $351 >>> 0; //@line 6949
           if ($387) {
            _abort(); //@line 6951
           } else {
            $388 = $351 + 16 | 0; //@line 6954
            $389 = SAFE_HEAP_LOAD($388 | 0, 4, 0) | 0 | 0; //@line 6955
            $390 = ($389 | 0) == ($$4$lcssa$i | 0); //@line 6956
            $391 = $351 + 20 | 0; //@line 6957
            $$sink325 = $390 ? $388 : $391; //@line 6958
            SAFE_HEAP_STORE($$sink325 | 0, $$3371$i | 0, 4);
            $392 = ($$3371$i | 0) == (0 | 0); //@line 6960
            if ($392) {
             $469 = $247; //@line 6962
             break L176;
            } else {
             break;
            }
           }
          }
         } while (0);
         $393 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 6970
         $394 = $393 >>> 0 > $$3371$i >>> 0; //@line 6971
         if ($394) {
          _abort(); //@line 6973
         }
         $395 = $$3371$i + 24 | 0; //@line 6976
         SAFE_HEAP_STORE($395 | 0, $351 | 0, 4);
         $396 = $$4$lcssa$i + 16 | 0; //@line 6978
         $397 = SAFE_HEAP_LOAD($396 | 0, 4, 0) | 0 | 0; //@line 6979
         $398 = ($397 | 0) == (0 | 0); //@line 6980
         do {
          if (!$398) {
           $399 = $393 >>> 0 > $397 >>> 0; //@line 6983
           if ($399) {
            _abort(); //@line 6985
           } else {
            $400 = $$3371$i + 16 | 0; //@line 6988
            SAFE_HEAP_STORE($400 | 0, $397 | 0, 4);
            $401 = $397 + 24 | 0; //@line 6990
            SAFE_HEAP_STORE($401 | 0, $$3371$i | 0, 4);
            break;
           }
          }
         } while (0);
         $402 = $$4$lcssa$i + 20 | 0; //@line 6996
         $403 = SAFE_HEAP_LOAD($402 | 0, 4, 0) | 0 | 0; //@line 6997
         $404 = ($403 | 0) == (0 | 0); //@line 6998
         if ($404) {
          $469 = $247; //@line 7000
         } else {
          $405 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 7002
          $406 = $405 >>> 0 > $403 >>> 0; //@line 7003
          if ($406) {
           _abort(); //@line 7005
          } else {
           $407 = $$3371$i + 20 | 0; //@line 7008
           SAFE_HEAP_STORE($407 | 0, $403 | 0, 4);
           $408 = $403 + 24 | 0; //@line 7010
           SAFE_HEAP_STORE($408 | 0, $$3371$i | 0, 4);
           $469 = $247; //@line 7012
           break;
          }
         }
        }
       } while (0);
       $409 = $$4349$lcssa$i >>> 0 < 16; //@line 7018
       L200 : do {
        if ($409) {
         $410 = $$4349$lcssa$i + $246 | 0; //@line 7021
         $411 = $410 | 3; //@line 7022
         $412 = $$4$lcssa$i + 4 | 0; //@line 7023
         SAFE_HEAP_STORE($412 | 0, $411 | 0, 4);
         $413 = $$4$lcssa$i + $410 | 0; //@line 7025
         $414 = $413 + 4 | 0; //@line 7026
         $415 = SAFE_HEAP_LOAD($414 | 0, 4, 0) | 0 | 0; //@line 7027
         $416 = $415 | 1; //@line 7028
         SAFE_HEAP_STORE($414 | 0, $416 | 0, 4);
        } else {
         $417 = $246 | 3; //@line 7031
         $418 = $$4$lcssa$i + 4 | 0; //@line 7032
         SAFE_HEAP_STORE($418 | 0, $417 | 0, 4);
         $419 = $$4349$lcssa$i | 1; //@line 7034
         $420 = $348 + 4 | 0; //@line 7035
         SAFE_HEAP_STORE($420 | 0, $419 | 0, 4);
         $421 = $348 + $$4349$lcssa$i | 0; //@line 7037
         SAFE_HEAP_STORE($421 | 0, $$4349$lcssa$i | 0, 4);
         $422 = $$4349$lcssa$i >>> 3; //@line 7039
         $423 = $$4349$lcssa$i >>> 0 < 256; //@line 7040
         if ($423) {
          $424 = $422 << 1; //@line 7042
          $425 = 11336 + ($424 << 2) | 0; //@line 7043
          $426 = SAFE_HEAP_LOAD(2824 * 4 | 0, 4, 0) | 0 | 0; //@line 7044
          $427 = 1 << $422; //@line 7045
          $428 = $426 & $427; //@line 7046
          $429 = ($428 | 0) == 0; //@line 7047
          if ($429) {
           $430 = $426 | $427; //@line 7049
           SAFE_HEAP_STORE(2824 * 4 | 0, $430 | 0, 4);
           $$pre$i208 = $425 + 8 | 0; //@line 7051
           $$0367$i = $425; //@line 7052
           $$pre$phi$i209Z2D = $$pre$i208; //@line 7052
          } else {
           $431 = $425 + 8 | 0; //@line 7054
           $432 = SAFE_HEAP_LOAD($431 | 0, 4, 0) | 0 | 0; //@line 7055
           $433 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 7056
           $434 = $433 >>> 0 > $432 >>> 0; //@line 7057
           if ($434) {
            _abort(); //@line 7059
           } else {
            $$0367$i = $432; //@line 7062
            $$pre$phi$i209Z2D = $431; //@line 7062
           }
          }
          SAFE_HEAP_STORE($$pre$phi$i209Z2D | 0, $348 | 0, 4);
          $435 = $$0367$i + 12 | 0; //@line 7066
          SAFE_HEAP_STORE($435 | 0, $348 | 0, 4);
          $436 = $348 + 8 | 0; //@line 7068
          SAFE_HEAP_STORE($436 | 0, $$0367$i | 0, 4);
          $437 = $348 + 12 | 0; //@line 7070
          SAFE_HEAP_STORE($437 | 0, $425 | 0, 4);
          break;
         }
         $438 = $$4349$lcssa$i >>> 8; //@line 7074
         $439 = ($438 | 0) == 0; //@line 7075
         if ($439) {
          $$0360$i = 0; //@line 7077
         } else {
          $440 = $$4349$lcssa$i >>> 0 > 16777215; //@line 7079
          if ($440) {
           $$0360$i = 31; //@line 7081
          } else {
           $441 = $438 + 1048320 | 0; //@line 7083
           $442 = $441 >>> 16; //@line 7084
           $443 = $442 & 8; //@line 7085
           $444 = $438 << $443; //@line 7086
           $445 = $444 + 520192 | 0; //@line 7087
           $446 = $445 >>> 16; //@line 7088
           $447 = $446 & 4; //@line 7089
           $448 = $447 | $443; //@line 7090
           $449 = $444 << $447; //@line 7091
           $450 = $449 + 245760 | 0; //@line 7092
           $451 = $450 >>> 16; //@line 7093
           $452 = $451 & 2; //@line 7094
           $453 = $448 | $452; //@line 7095
           $454 = 14 - $453 | 0; //@line 7096
           $455 = $449 << $452; //@line 7097
           $456 = $455 >>> 15; //@line 7098
           $457 = $454 + $456 | 0; //@line 7099
           $458 = $457 << 1; //@line 7100
           $459 = $457 + 7 | 0; //@line 7101
           $460 = $$4349$lcssa$i >>> $459; //@line 7102
           $461 = $460 & 1; //@line 7103
           $462 = $461 | $458; //@line 7104
           $$0360$i = $462; //@line 7105
          }
         }
         $463 = 11600 + ($$0360$i << 2) | 0; //@line 7108
         $464 = $348 + 28 | 0; //@line 7109
         SAFE_HEAP_STORE($464 | 0, $$0360$i | 0, 4);
         $465 = $348 + 16 | 0; //@line 7111
         $466 = $465 + 4 | 0; //@line 7112
         SAFE_HEAP_STORE($466 | 0, 0 | 0, 4);
         SAFE_HEAP_STORE($465 | 0, 0 | 0, 4);
         $467 = 1 << $$0360$i; //@line 7115
         $468 = $469 & $467; //@line 7116
         $470 = ($468 | 0) == 0; //@line 7117
         if ($470) {
          $471 = $469 | $467; //@line 7119
          SAFE_HEAP_STORE(11300 | 0, $471 | 0, 4);
          SAFE_HEAP_STORE($463 | 0, $348 | 0, 4);
          $472 = $348 + 24 | 0; //@line 7122
          SAFE_HEAP_STORE($472 | 0, $463 | 0, 4);
          $473 = $348 + 12 | 0; //@line 7124
          SAFE_HEAP_STORE($473 | 0, $348 | 0, 4);
          $474 = $348 + 8 | 0; //@line 7126
          SAFE_HEAP_STORE($474 | 0, $348 | 0, 4);
          break;
         }
         $475 = SAFE_HEAP_LOAD($463 | 0, 4, 0) | 0 | 0; //@line 7130
         $476 = $475 + 4 | 0; //@line 7131
         $477 = SAFE_HEAP_LOAD($476 | 0, 4, 0) | 0 | 0; //@line 7132
         $478 = $477 & -8; //@line 7133
         $479 = ($478 | 0) == ($$4349$lcssa$i | 0); //@line 7134
         L218 : do {
          if ($479) {
           $$0343$lcssa$i = $475; //@line 7137
          } else {
           $480 = ($$0360$i | 0) == 31; //@line 7139
           $481 = $$0360$i >>> 1; //@line 7140
           $482 = 25 - $481 | 0; //@line 7141
           $483 = $480 ? 0 : $482; //@line 7142
           $484 = $$4349$lcssa$i << $483; //@line 7143
           $$034217$i = $484; //@line 7144
           $$034316$i = $475; //@line 7144
           while (1) {
            $491 = $$034217$i >>> 31; //@line 7146
            $492 = ($$034316$i + 16 | 0) + ($491 << 2) | 0; //@line 7147
            $487 = SAFE_HEAP_LOAD($492 | 0, 4, 0) | 0 | 0; //@line 7148
            $493 = ($487 | 0) == (0 | 0); //@line 7149
            if ($493) {
             break;
            }
            $485 = $$034217$i << 1; //@line 7153
            $486 = $487 + 4 | 0; //@line 7154
            $488 = SAFE_HEAP_LOAD($486 | 0, 4, 0) | 0 | 0; //@line 7155
            $489 = $488 & -8; //@line 7156
            $490 = ($489 | 0) == ($$4349$lcssa$i | 0); //@line 7157
            if ($490) {
             $$0343$lcssa$i = $487; //@line 7159
             break L218;
            } else {
             $$034217$i = $485; //@line 7162
             $$034316$i = $487; //@line 7162
            }
           }
           $494 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 7165
           $495 = $494 >>> 0 > $492 >>> 0; //@line 7166
           if ($495) {
            _abort(); //@line 7168
           } else {
            SAFE_HEAP_STORE($492 | 0, $348 | 0, 4);
            $496 = $348 + 24 | 0; //@line 7172
            SAFE_HEAP_STORE($496 | 0, $$034316$i | 0, 4);
            $497 = $348 + 12 | 0; //@line 7174
            SAFE_HEAP_STORE($497 | 0, $348 | 0, 4);
            $498 = $348 + 8 | 0; //@line 7176
            SAFE_HEAP_STORE($498 | 0, $348 | 0, 4);
            break L200;
           }
          }
         } while (0);
         $499 = $$0343$lcssa$i + 8 | 0; //@line 7182
         $500 = SAFE_HEAP_LOAD($499 | 0, 4, 0) | 0 | 0; //@line 7183
         $501 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 7184
         $502 = $501 >>> 0 <= $$0343$lcssa$i >>> 0; //@line 7185
         $503 = $501 >>> 0 <= $500 >>> 0; //@line 7186
         $504 = $503 & $502; //@line 7187
         if ($504) {
          $505 = $500 + 12 | 0; //@line 7189
          SAFE_HEAP_STORE($505 | 0, $348 | 0, 4);
          SAFE_HEAP_STORE($499 | 0, $348 | 0, 4);
          $506 = $348 + 8 | 0; //@line 7192
          SAFE_HEAP_STORE($506 | 0, $500 | 0, 4);
          $507 = $348 + 12 | 0; //@line 7194
          SAFE_HEAP_STORE($507 | 0, $$0343$lcssa$i | 0, 4);
          $508 = $348 + 24 | 0; //@line 7196
          SAFE_HEAP_STORE($508 | 0, 0 | 0, 4);
          break;
         } else {
          _abort(); //@line 7200
         }
        }
       } while (0);
       $509 = $$4$lcssa$i + 8 | 0; //@line 7205
       $$0 = $509; //@line 7206
       STACKTOP = sp; //@line 7207
       return $$0 | 0; //@line 7207
      } else {
       $$0197 = $246; //@line 7209
      }
     }
    }
   }
  }
 } while (0);
 $510 = SAFE_HEAP_LOAD(11304 | 0, 4, 0) | 0 | 0; //@line 7216
 $511 = $510 >>> 0 < $$0197 >>> 0; //@line 7217
 if (!$511) {
  $512 = $510 - $$0197 | 0; //@line 7219
  $513 = SAFE_HEAP_LOAD(11316 | 0, 4, 0) | 0 | 0; //@line 7220
  $514 = $512 >>> 0 > 15; //@line 7221
  if ($514) {
   $515 = $513 + $$0197 | 0; //@line 7223
   SAFE_HEAP_STORE(11316 | 0, $515 | 0, 4);
   SAFE_HEAP_STORE(11304 | 0, $512 | 0, 4);
   $516 = $512 | 1; //@line 7226
   $517 = $515 + 4 | 0; //@line 7227
   SAFE_HEAP_STORE($517 | 0, $516 | 0, 4);
   $518 = $513 + $510 | 0; //@line 7229
   SAFE_HEAP_STORE($518 | 0, $512 | 0, 4);
   $519 = $$0197 | 3; //@line 7231
   $520 = $513 + 4 | 0; //@line 7232
   SAFE_HEAP_STORE($520 | 0, $519 | 0, 4);
  } else {
   SAFE_HEAP_STORE(11304 | 0, 0 | 0, 4);
   SAFE_HEAP_STORE(11316 | 0, 0 | 0, 4);
   $521 = $510 | 3; //@line 7237
   $522 = $513 + 4 | 0; //@line 7238
   SAFE_HEAP_STORE($522 | 0, $521 | 0, 4);
   $523 = $513 + $510 | 0; //@line 7240
   $524 = $523 + 4 | 0; //@line 7241
   $525 = SAFE_HEAP_LOAD($524 | 0, 4, 0) | 0 | 0; //@line 7242
   $526 = $525 | 1; //@line 7243
   SAFE_HEAP_STORE($524 | 0, $526 | 0, 4);
  }
  $527 = $513 + 8 | 0; //@line 7246
  $$0 = $527; //@line 7247
  STACKTOP = sp; //@line 7248
  return $$0 | 0; //@line 7248
 }
 $528 = SAFE_HEAP_LOAD(11308 | 0, 4, 0) | 0 | 0; //@line 7250
 $529 = $528 >>> 0 > $$0197 >>> 0; //@line 7251
 if ($529) {
  $530 = $528 - $$0197 | 0; //@line 7253
  SAFE_HEAP_STORE(11308 | 0, $530 | 0, 4);
  $531 = SAFE_HEAP_LOAD(11320 | 0, 4, 0) | 0 | 0; //@line 7255
  $532 = $531 + $$0197 | 0; //@line 7256
  SAFE_HEAP_STORE(11320 | 0, $532 | 0, 4);
  $533 = $530 | 1; //@line 7258
  $534 = $532 + 4 | 0; //@line 7259
  SAFE_HEAP_STORE($534 | 0, $533 | 0, 4);
  $535 = $$0197 | 3; //@line 7261
  $536 = $531 + 4 | 0; //@line 7262
  SAFE_HEAP_STORE($536 | 0, $535 | 0, 4);
  $537 = $531 + 8 | 0; //@line 7264
  $$0 = $537; //@line 7265
  STACKTOP = sp; //@line 7266
  return $$0 | 0; //@line 7266
 }
 $538 = SAFE_HEAP_LOAD(2942 * 4 | 0, 4, 0) | 0 | 0; //@line 7268
 $539 = ($538 | 0) == 0; //@line 7269
 if ($539) {
  SAFE_HEAP_STORE(11776 | 0, 4096 | 0, 4);
  SAFE_HEAP_STORE(11772 | 0, 4096 | 0, 4);
  SAFE_HEAP_STORE(11780 | 0, -1 | 0, 4);
  SAFE_HEAP_STORE(11784 | 0, -1 | 0, 4);
  SAFE_HEAP_STORE(11788 | 0, 0 | 0, 4);
  SAFE_HEAP_STORE(11740 | 0, 0 | 0, 4);
  $540 = $1; //@line 7277
  $541 = $540 & -16; //@line 7278
  $542 = $541 ^ 1431655768; //@line 7279
  SAFE_HEAP_STORE(2942 * 4 | 0, $542 | 0, 4);
  $546 = 4096; //@line 7281
 } else {
  $$pre$i210 = SAFE_HEAP_LOAD(11776 | 0, 4, 0) | 0 | 0; //@line 7283
  $546 = $$pre$i210; //@line 7284
 }
 $543 = $$0197 + 48 | 0; //@line 7286
 $544 = $$0197 + 47 | 0; //@line 7287
 $545 = $546 + $544 | 0; //@line 7288
 $547 = 0 - $546 | 0; //@line 7289
 $548 = $545 & $547; //@line 7290
 $549 = $548 >>> 0 > $$0197 >>> 0; //@line 7291
 if (!$549) {
  $$0 = 0; //@line 7293
  STACKTOP = sp; //@line 7294
  return $$0 | 0; //@line 7294
 }
 $550 = SAFE_HEAP_LOAD(11736 | 0, 4, 0) | 0 | 0; //@line 7296
 $551 = ($550 | 0) == 0; //@line 7297
 if (!$551) {
  $552 = SAFE_HEAP_LOAD(11728 | 0, 4, 0) | 0 | 0; //@line 7299
  $553 = $552 + $548 | 0; //@line 7300
  $554 = $553 >>> 0 <= $552 >>> 0; //@line 7301
  $555 = $553 >>> 0 > $550 >>> 0; //@line 7302
  $or$cond1$i = $554 | $555; //@line 7303
  if ($or$cond1$i) {
   $$0 = 0; //@line 7305
   STACKTOP = sp; //@line 7306
   return $$0 | 0; //@line 7306
  }
 }
 $556 = SAFE_HEAP_LOAD(11740 | 0, 4, 0) | 0 | 0; //@line 7309
 $557 = $556 & 4; //@line 7310
 $558 = ($557 | 0) == 0; //@line 7311
 L257 : do {
  if ($558) {
   $559 = SAFE_HEAP_LOAD(11320 | 0, 4, 0) | 0 | 0; //@line 7314
   $560 = ($559 | 0) == (0 | 0); //@line 7315
   L259 : do {
    if ($560) {
     label = 173; //@line 7318
    } else {
     $$0$i$i = 11744; //@line 7320
     while (1) {
      $561 = SAFE_HEAP_LOAD($$0$i$i | 0, 4, 0) | 0 | 0; //@line 7322
      $562 = $561 >>> 0 > $559 >>> 0; //@line 7323
      if (!$562) {
       $563 = $$0$i$i + 4 | 0; //@line 7325
       $564 = SAFE_HEAP_LOAD($563 | 0, 4, 0) | 0 | 0; //@line 7326
       $565 = $561 + $564 | 0; //@line 7327
       $566 = $565 >>> 0 > $559 >>> 0; //@line 7328
       if ($566) {
        break;
       }
      }
      $567 = $$0$i$i + 8 | 0; //@line 7333
      $568 = SAFE_HEAP_LOAD($567 | 0, 4, 0) | 0 | 0; //@line 7334
      $569 = ($568 | 0) == (0 | 0); //@line 7335
      if ($569) {
       label = 173; //@line 7337
       break L259;
      } else {
       $$0$i$i = $568; //@line 7340
      }
     }
     $592 = $545 - $528 | 0; //@line 7343
     $593 = $592 & $547; //@line 7344
     $594 = $593 >>> 0 < 2147483647; //@line 7345
     if ($594) {
      $595 = $$0$i$i + 4 | 0; //@line 7347
      $596 = _sbrk($593 | 0) | 0; //@line 7348
      $597 = SAFE_HEAP_LOAD($$0$i$i | 0, 4, 0) | 0 | 0; //@line 7349
      $598 = SAFE_HEAP_LOAD($595 | 0, 4, 0) | 0 | 0; //@line 7350
      $599 = $597 + $598 | 0; //@line 7351
      $600 = ($596 | 0) == ($599 | 0); //@line 7352
      if ($600) {
       $601 = ($596 | 0) == (-1 | 0); //@line 7354
       if ($601) {
        $$2234243136$i = $593; //@line 7356
       } else {
        $$723947$i = $593; //@line 7358
        $$748$i = $596; //@line 7358
        label = 190; //@line 7359
        break L257;
       }
      } else {
       $$2247$ph$i = $596; //@line 7363
       $$2253$ph$i = $593; //@line 7363
       label = 181; //@line 7364
      }
     } else {
      $$2234243136$i = 0; //@line 7367
     }
    }
   } while (0);
   do {
    if ((label | 0) == 173) {
     $570 = _sbrk(0) | 0; //@line 7373
     $571 = ($570 | 0) == (-1 | 0); //@line 7374
     if ($571) {
      $$2234243136$i = 0; //@line 7376
     } else {
      $572 = $570; //@line 7378
      $573 = SAFE_HEAP_LOAD(11772 | 0, 4, 0) | 0 | 0; //@line 7379
      $574 = $573 + -1 | 0; //@line 7380
      $575 = $574 & $572; //@line 7381
      $576 = ($575 | 0) == 0; //@line 7382
      $577 = $574 + $572 | 0; //@line 7383
      $578 = 0 - $573 | 0; //@line 7384
      $579 = $577 & $578; //@line 7385
      $580 = $579 - $572 | 0; //@line 7386
      $581 = $576 ? 0 : $580; //@line 7387
      $spec$select49$i = $581 + $548 | 0; //@line 7388
      $582 = SAFE_HEAP_LOAD(11728 | 0, 4, 0) | 0 | 0; //@line 7389
      $583 = $spec$select49$i + $582 | 0; //@line 7390
      $584 = $spec$select49$i >>> 0 > $$0197 >>> 0; //@line 7391
      $585 = $spec$select49$i >>> 0 < 2147483647; //@line 7392
      $or$cond$i213 = $584 & $585; //@line 7393
      if ($or$cond$i213) {
       $586 = SAFE_HEAP_LOAD(11736 | 0, 4, 0) | 0 | 0; //@line 7395
       $587 = ($586 | 0) == 0; //@line 7396
       if (!$587) {
        $588 = $583 >>> 0 <= $582 >>> 0; //@line 7398
        $589 = $583 >>> 0 > $586 >>> 0; //@line 7399
        $or$cond2$i214 = $588 | $589; //@line 7400
        if ($or$cond2$i214) {
         $$2234243136$i = 0; //@line 7402
         break;
        }
       }
       $590 = _sbrk($spec$select49$i | 0) | 0; //@line 7406
       $591 = ($590 | 0) == ($570 | 0); //@line 7407
       if ($591) {
        $$723947$i = $spec$select49$i; //@line 7409
        $$748$i = $570; //@line 7409
        label = 190; //@line 7410
        break L257;
       } else {
        $$2247$ph$i = $590; //@line 7413
        $$2253$ph$i = $spec$select49$i; //@line 7413
        label = 181; //@line 7414
       }
      } else {
       $$2234243136$i = 0; //@line 7417
      }
     }
    }
   } while (0);
   do {
    if ((label | 0) == 181) {
     $602 = 0 - $$2253$ph$i | 0; //@line 7424
     $603 = ($$2247$ph$i | 0) != (-1 | 0); //@line 7425
     $604 = $$2253$ph$i >>> 0 < 2147483647; //@line 7426
     $or$cond7$i = $604 & $603; //@line 7427
     $605 = $543 >>> 0 > $$2253$ph$i >>> 0; //@line 7428
     $or$cond6$i = $605 & $or$cond7$i; //@line 7429
     if (!$or$cond6$i) {
      $615 = ($$2247$ph$i | 0) == (-1 | 0); //@line 7431
      if ($615) {
       $$2234243136$i = 0; //@line 7433
       break;
      } else {
       $$723947$i = $$2253$ph$i; //@line 7436
       $$748$i = $$2247$ph$i; //@line 7436
       label = 190; //@line 7437
       break L257;
      }
     }
     $606 = SAFE_HEAP_LOAD(11776 | 0, 4, 0) | 0 | 0; //@line 7441
     $607 = $544 - $$2253$ph$i | 0; //@line 7442
     $608 = $607 + $606 | 0; //@line 7443
     $609 = 0 - $606 | 0; //@line 7444
     $610 = $608 & $609; //@line 7445
     $611 = $610 >>> 0 < 2147483647; //@line 7446
     if (!$611) {
      $$723947$i = $$2253$ph$i; //@line 7448
      $$748$i = $$2247$ph$i; //@line 7448
      label = 190; //@line 7449
      break L257;
     }
     $612 = _sbrk($610 | 0) | 0; //@line 7452
     $613 = ($612 | 0) == (-1 | 0); //@line 7453
     if ($613) {
      _sbrk($602 | 0) | 0; //@line 7455
      $$2234243136$i = 0; //@line 7456
      break;
     } else {
      $614 = $610 + $$2253$ph$i | 0; //@line 7459
      $$723947$i = $614; //@line 7460
      $$748$i = $$2247$ph$i; //@line 7460
      label = 190; //@line 7461
      break L257;
     }
    }
   } while (0);
   $616 = SAFE_HEAP_LOAD(11740 | 0, 4, 0) | 0 | 0; //@line 7466
   $617 = $616 | 4; //@line 7467
   SAFE_HEAP_STORE(11740 | 0, $617 | 0, 4);
   $$4236$i = $$2234243136$i; //@line 7469
   label = 188; //@line 7470
  } else {
   $$4236$i = 0; //@line 7472
   label = 188; //@line 7473
  }
 } while (0);
 if ((label | 0) == 188) {
  $618 = $548 >>> 0 < 2147483647; //@line 7477
  if ($618) {
   $619 = _sbrk($548 | 0) | 0; //@line 7479
   $620 = _sbrk(0) | 0; //@line 7480
   $621 = ($619 | 0) != (-1 | 0); //@line 7481
   $622 = ($620 | 0) != (-1 | 0); //@line 7482
   $or$cond5$i = $621 & $622; //@line 7483
   $623 = $619 >>> 0 < $620 >>> 0; //@line 7484
   $or$cond8$i = $623 & $or$cond5$i; //@line 7485
   $624 = $620; //@line 7486
   $625 = $619; //@line 7487
   $626 = $624 - $625 | 0; //@line 7488
   $627 = $$0197 + 40 | 0; //@line 7489
   $628 = $626 >>> 0 > $627 >>> 0; //@line 7490
   $spec$select9$i = $628 ? $626 : $$4236$i; //@line 7491
   $or$cond8$not$i = $or$cond8$i ^ 1; //@line 7492
   $629 = ($619 | 0) == (-1 | 0); //@line 7493
   $not$$i = $628 ^ 1; //@line 7494
   $630 = $629 | $not$$i; //@line 7495
   $or$cond50$i = $630 | $or$cond8$not$i; //@line 7496
   if (!$or$cond50$i) {
    $$723947$i = $spec$select9$i; //@line 7498
    $$748$i = $619; //@line 7498
    label = 190; //@line 7499
   }
  }
 }
 if ((label | 0) == 190) {
  $631 = SAFE_HEAP_LOAD(11728 | 0, 4, 0) | 0 | 0; //@line 7504
  $632 = $631 + $$723947$i | 0; //@line 7505
  SAFE_HEAP_STORE(11728 | 0, $632 | 0, 4);
  $633 = SAFE_HEAP_LOAD(11732 | 0, 4, 0) | 0 | 0; //@line 7507
  $634 = $632 >>> 0 > $633 >>> 0; //@line 7508
  if ($634) {
   SAFE_HEAP_STORE(11732 | 0, $632 | 0, 4);
  }
  $635 = SAFE_HEAP_LOAD(11320 | 0, 4, 0) | 0 | 0; //@line 7512
  $636 = ($635 | 0) == (0 | 0); //@line 7513
  L294 : do {
   if ($636) {
    $637 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 7516
    $638 = ($637 | 0) == (0 | 0); //@line 7517
    $639 = $$748$i >>> 0 < $637 >>> 0; //@line 7518
    $or$cond11$i = $638 | $639; //@line 7519
    if ($or$cond11$i) {
     SAFE_HEAP_STORE(11312 | 0, $$748$i | 0, 4);
    }
    SAFE_HEAP_STORE(11744 | 0, $$748$i | 0, 4);
    SAFE_HEAP_STORE(11748 | 0, $$723947$i | 0, 4);
    SAFE_HEAP_STORE(11756 | 0, 0 | 0, 4);
    $640 = SAFE_HEAP_LOAD(2942 * 4 | 0, 4, 0) | 0 | 0; //@line 7526
    SAFE_HEAP_STORE(11332 | 0, $640 | 0, 4);
    SAFE_HEAP_STORE(11328 | 0, -1 | 0, 4);
    SAFE_HEAP_STORE(11348 | 0, 11336 | 0, 4);
    SAFE_HEAP_STORE(11344 | 0, 11336 | 0, 4);
    SAFE_HEAP_STORE(11356 | 0, 11344 | 0, 4);
    SAFE_HEAP_STORE(11352 | 0, 11344 | 0, 4);
    SAFE_HEAP_STORE(11364 | 0, 11352 | 0, 4);
    SAFE_HEAP_STORE(11360 | 0, 11352 | 0, 4);
    SAFE_HEAP_STORE(11372 | 0, 11360 | 0, 4);
    SAFE_HEAP_STORE(11368 | 0, 11360 | 0, 4);
    SAFE_HEAP_STORE(11380 | 0, 11368 | 0, 4);
    SAFE_HEAP_STORE(11376 | 0, 11368 | 0, 4);
    SAFE_HEAP_STORE(11388 | 0, 11376 | 0, 4);
    SAFE_HEAP_STORE(11384 | 0, 11376 | 0, 4);
    SAFE_HEAP_STORE(11396 | 0, 11384 | 0, 4);
    SAFE_HEAP_STORE(11392 | 0, 11384 | 0, 4);
    SAFE_HEAP_STORE(11404 | 0, 11392 | 0, 4);
    SAFE_HEAP_STORE(11400 | 0, 11392 | 0, 4);
    SAFE_HEAP_STORE(11412 | 0, 11400 | 0, 4);
    SAFE_HEAP_STORE(11408 | 0, 11400 | 0, 4);
    SAFE_HEAP_STORE(11420 | 0, 11408 | 0, 4);
    SAFE_HEAP_STORE(11416 | 0, 11408 | 0, 4);
    SAFE_HEAP_STORE(11428 | 0, 11416 | 0, 4);
    SAFE_HEAP_STORE(11424 | 0, 11416 | 0, 4);
    SAFE_HEAP_STORE(11436 | 0, 11424 | 0, 4);
    SAFE_HEAP_STORE(11432 | 0, 11424 | 0, 4);
    SAFE_HEAP_STORE(11444 | 0, 11432 | 0, 4);
    SAFE_HEAP_STORE(11440 | 0, 11432 | 0, 4);
    SAFE_HEAP_STORE(11452 | 0, 11440 | 0, 4);
    SAFE_HEAP_STORE(11448 | 0, 11440 | 0, 4);
    SAFE_HEAP_STORE(11460 | 0, 11448 | 0, 4);
    SAFE_HEAP_STORE(11456 | 0, 11448 | 0, 4);
    SAFE_HEAP_STORE(11468 | 0, 11456 | 0, 4);
    SAFE_HEAP_STORE(11464 | 0, 11456 | 0, 4);
    SAFE_HEAP_STORE(11476 | 0, 11464 | 0, 4);
    SAFE_HEAP_STORE(11472 | 0, 11464 | 0, 4);
    SAFE_HEAP_STORE(11484 | 0, 11472 | 0, 4);
    SAFE_HEAP_STORE(11480 | 0, 11472 | 0, 4);
    SAFE_HEAP_STORE(11492 | 0, 11480 | 0, 4);
    SAFE_HEAP_STORE(11488 | 0, 11480 | 0, 4);
    SAFE_HEAP_STORE(11500 | 0, 11488 | 0, 4);
    SAFE_HEAP_STORE(11496 | 0, 11488 | 0, 4);
    SAFE_HEAP_STORE(11508 | 0, 11496 | 0, 4);
    SAFE_HEAP_STORE(11504 | 0, 11496 | 0, 4);
    SAFE_HEAP_STORE(11516 | 0, 11504 | 0, 4);
    SAFE_HEAP_STORE(11512 | 0, 11504 | 0, 4);
    SAFE_HEAP_STORE(11524 | 0, 11512 | 0, 4);
    SAFE_HEAP_STORE(11520 | 0, 11512 | 0, 4);
    SAFE_HEAP_STORE(11532 | 0, 11520 | 0, 4);
    SAFE_HEAP_STORE(11528 | 0, 11520 | 0, 4);
    SAFE_HEAP_STORE(11540 | 0, 11528 | 0, 4);
    SAFE_HEAP_STORE(11536 | 0, 11528 | 0, 4);
    SAFE_HEAP_STORE(11548 | 0, 11536 | 0, 4);
    SAFE_HEAP_STORE(11544 | 0, 11536 | 0, 4);
    SAFE_HEAP_STORE(11556 | 0, 11544 | 0, 4);
    SAFE_HEAP_STORE(11552 | 0, 11544 | 0, 4);
    SAFE_HEAP_STORE(11564 | 0, 11552 | 0, 4);
    SAFE_HEAP_STORE(11560 | 0, 11552 | 0, 4);
    SAFE_HEAP_STORE(11572 | 0, 11560 | 0, 4);
    SAFE_HEAP_STORE(11568 | 0, 11560 | 0, 4);
    SAFE_HEAP_STORE(11580 | 0, 11568 | 0, 4);
    SAFE_HEAP_STORE(11576 | 0, 11568 | 0, 4);
    SAFE_HEAP_STORE(11588 | 0, 11576 | 0, 4);
    SAFE_HEAP_STORE(11584 | 0, 11576 | 0, 4);
    SAFE_HEAP_STORE(11596 | 0, 11584 | 0, 4);
    SAFE_HEAP_STORE(11592 | 0, 11584 | 0, 4);
    $641 = $$723947$i + -40 | 0; //@line 7593
    $642 = $$748$i + 8 | 0; //@line 7594
    $643 = $642; //@line 7595
    $644 = $643 & 7; //@line 7596
    $645 = ($644 | 0) == 0; //@line 7597
    $646 = 0 - $643 | 0; //@line 7598
    $647 = $646 & 7; //@line 7599
    $648 = $645 ? 0 : $647; //@line 7600
    $649 = $$748$i + $648 | 0; //@line 7601
    $650 = $641 - $648 | 0; //@line 7602
    SAFE_HEAP_STORE(11320 | 0, $649 | 0, 4);
    SAFE_HEAP_STORE(11308 | 0, $650 | 0, 4);
    $651 = $650 | 1; //@line 7605
    $652 = $649 + 4 | 0; //@line 7606
    SAFE_HEAP_STORE($652 | 0, $651 | 0, 4);
    $653 = $$748$i + $641 | 0; //@line 7608
    $654 = $653 + 4 | 0; //@line 7609
    SAFE_HEAP_STORE($654 | 0, 40 | 0, 4);
    $655 = SAFE_HEAP_LOAD(11784 | 0, 4, 0) | 0 | 0; //@line 7611
    SAFE_HEAP_STORE(11324 | 0, $655 | 0, 4);
   } else {
    $$024372$i = 11744; //@line 7614
    while (1) {
     $656 = SAFE_HEAP_LOAD($$024372$i | 0, 4, 0) | 0 | 0; //@line 7616
     $657 = $$024372$i + 4 | 0; //@line 7617
     $658 = SAFE_HEAP_LOAD($657 | 0, 4, 0) | 0 | 0; //@line 7618
     $659 = $656 + $658 | 0; //@line 7619
     $660 = ($$748$i | 0) == ($659 | 0); //@line 7620
     if ($660) {
      label = 199; //@line 7622
      break;
     }
     $661 = $$024372$i + 8 | 0; //@line 7625
     $662 = SAFE_HEAP_LOAD($661 | 0, 4, 0) | 0 | 0; //@line 7626
     $663 = ($662 | 0) == (0 | 0); //@line 7627
     if ($663) {
      break;
     } else {
      $$024372$i = $662; //@line 7631
     }
    }
    if ((label | 0) == 199) {
     $664 = $$024372$i + 4 | 0; //@line 7635
     $665 = $$024372$i + 12 | 0; //@line 7636
     $666 = SAFE_HEAP_LOAD($665 | 0, 4, 0) | 0 | 0; //@line 7637
     $667 = $666 & 8; //@line 7638
     $668 = ($667 | 0) == 0; //@line 7639
     if ($668) {
      $669 = $656 >>> 0 <= $635 >>> 0; //@line 7641
      $670 = $$748$i >>> 0 > $635 >>> 0; //@line 7642
      $or$cond51$i = $670 & $669; //@line 7643
      if ($or$cond51$i) {
       $671 = $658 + $$723947$i | 0; //@line 7645
       SAFE_HEAP_STORE($664 | 0, $671 | 0, 4);
       $672 = SAFE_HEAP_LOAD(11308 | 0, 4, 0) | 0 | 0; //@line 7647
       $673 = $672 + $$723947$i | 0; //@line 7648
       $674 = $635 + 8 | 0; //@line 7649
       $675 = $674; //@line 7650
       $676 = $675 & 7; //@line 7651
       $677 = ($676 | 0) == 0; //@line 7652
       $678 = 0 - $675 | 0; //@line 7653
       $679 = $678 & 7; //@line 7654
       $680 = $677 ? 0 : $679; //@line 7655
       $681 = $635 + $680 | 0; //@line 7656
       $682 = $673 - $680 | 0; //@line 7657
       SAFE_HEAP_STORE(11320 | 0, $681 | 0, 4);
       SAFE_HEAP_STORE(11308 | 0, $682 | 0, 4);
       $683 = $682 | 1; //@line 7660
       $684 = $681 + 4 | 0; //@line 7661
       SAFE_HEAP_STORE($684 | 0, $683 | 0, 4);
       $685 = $635 + $673 | 0; //@line 7663
       $686 = $685 + 4 | 0; //@line 7664
       SAFE_HEAP_STORE($686 | 0, 40 | 0, 4);
       $687 = SAFE_HEAP_LOAD(11784 | 0, 4, 0) | 0 | 0; //@line 7666
       SAFE_HEAP_STORE(11324 | 0, $687 | 0, 4);
       break;
      }
     }
    }
    $688 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 7672
    $689 = $$748$i >>> 0 < $688 >>> 0; //@line 7673
    if ($689) {
     SAFE_HEAP_STORE(11312 | 0, $$748$i | 0, 4);
     $753 = $$748$i; //@line 7676
    } else {
     $753 = $688; //@line 7678
    }
    $690 = $$748$i + $$723947$i | 0; //@line 7680
    $$124471$i = 11744; //@line 7681
    while (1) {
     $691 = SAFE_HEAP_LOAD($$124471$i | 0, 4, 0) | 0 | 0; //@line 7683
     $692 = ($691 | 0) == ($690 | 0); //@line 7684
     if ($692) {
      label = 207; //@line 7686
      break;
     }
     $693 = $$124471$i + 8 | 0; //@line 7689
     $694 = SAFE_HEAP_LOAD($693 | 0, 4, 0) | 0 | 0; //@line 7690
     $695 = ($694 | 0) == (0 | 0); //@line 7691
     if ($695) {
      break;
     } else {
      $$124471$i = $694; //@line 7695
     }
    }
    if ((label | 0) == 207) {
     $696 = $$124471$i + 12 | 0; //@line 7699
     $697 = SAFE_HEAP_LOAD($696 | 0, 4, 0) | 0 | 0; //@line 7700
     $698 = $697 & 8; //@line 7701
     $699 = ($698 | 0) == 0; //@line 7702
     if ($699) {
      SAFE_HEAP_STORE($$124471$i | 0, $$748$i | 0, 4);
      $700 = $$124471$i + 4 | 0; //@line 7705
      $701 = SAFE_HEAP_LOAD($700 | 0, 4, 0) | 0 | 0; //@line 7706
      $702 = $701 + $$723947$i | 0; //@line 7707
      SAFE_HEAP_STORE($700 | 0, $702 | 0, 4);
      $703 = $$748$i + 8 | 0; //@line 7709
      $704 = $703; //@line 7710
      $705 = $704 & 7; //@line 7711
      $706 = ($705 | 0) == 0; //@line 7712
      $707 = 0 - $704 | 0; //@line 7713
      $708 = $707 & 7; //@line 7714
      $709 = $706 ? 0 : $708; //@line 7715
      $710 = $$748$i + $709 | 0; //@line 7716
      $711 = $690 + 8 | 0; //@line 7717
      $712 = $711; //@line 7718
      $713 = $712 & 7; //@line 7719
      $714 = ($713 | 0) == 0; //@line 7720
      $715 = 0 - $712 | 0; //@line 7721
      $716 = $715 & 7; //@line 7722
      $717 = $714 ? 0 : $716; //@line 7723
      $718 = $690 + $717 | 0; //@line 7724
      $719 = $718; //@line 7725
      $720 = $710; //@line 7726
      $721 = $719 - $720 | 0; //@line 7727
      $722 = $710 + $$0197 | 0; //@line 7728
      $723 = $721 - $$0197 | 0; //@line 7729
      $724 = $$0197 | 3; //@line 7730
      $725 = $710 + 4 | 0; //@line 7731
      SAFE_HEAP_STORE($725 | 0, $724 | 0, 4);
      $726 = ($635 | 0) == ($718 | 0); //@line 7733
      L317 : do {
       if ($726) {
        $727 = SAFE_HEAP_LOAD(11308 | 0, 4, 0) | 0 | 0; //@line 7736
        $728 = $727 + $723 | 0; //@line 7737
        SAFE_HEAP_STORE(11308 | 0, $728 | 0, 4);
        SAFE_HEAP_STORE(11320 | 0, $722 | 0, 4);
        $729 = $728 | 1; //@line 7740
        $730 = $722 + 4 | 0; //@line 7741
        SAFE_HEAP_STORE($730 | 0, $729 | 0, 4);
       } else {
        $731 = SAFE_HEAP_LOAD(11316 | 0, 4, 0) | 0 | 0; //@line 7744
        $732 = ($731 | 0) == ($718 | 0); //@line 7745
        if ($732) {
         $733 = SAFE_HEAP_LOAD(11304 | 0, 4, 0) | 0 | 0; //@line 7747
         $734 = $733 + $723 | 0; //@line 7748
         SAFE_HEAP_STORE(11304 | 0, $734 | 0, 4);
         SAFE_HEAP_STORE(11316 | 0, $722 | 0, 4);
         $735 = $734 | 1; //@line 7751
         $736 = $722 + 4 | 0; //@line 7752
         SAFE_HEAP_STORE($736 | 0, $735 | 0, 4);
         $737 = $722 + $734 | 0; //@line 7754
         SAFE_HEAP_STORE($737 | 0, $734 | 0, 4);
         break;
        }
        $738 = $718 + 4 | 0; //@line 7758
        $739 = SAFE_HEAP_LOAD($738 | 0, 4, 0) | 0 | 0; //@line 7759
        $740 = $739 & 3; //@line 7760
        $741 = ($740 | 0) == 1; //@line 7761
        if ($741) {
         $742 = $739 & -8; //@line 7763
         $743 = $739 >>> 3; //@line 7764
         $744 = $739 >>> 0 < 256; //@line 7765
         L325 : do {
          if ($744) {
           $745 = $718 + 8 | 0; //@line 7768
           $746 = SAFE_HEAP_LOAD($745 | 0, 4, 0) | 0 | 0; //@line 7769
           $747 = $718 + 12 | 0; //@line 7770
           $748 = SAFE_HEAP_LOAD($747 | 0, 4, 0) | 0 | 0; //@line 7771
           $749 = $743 << 1; //@line 7772
           $750 = 11336 + ($749 << 2) | 0; //@line 7773
           $751 = ($746 | 0) == ($750 | 0); //@line 7774
           do {
            if (!$751) {
             $752 = $753 >>> 0 > $746 >>> 0; //@line 7777
             if ($752) {
              _abort(); //@line 7779
             }
             $754 = $746 + 12 | 0; //@line 7782
             $755 = SAFE_HEAP_LOAD($754 | 0, 4, 0) | 0 | 0; //@line 7783
             $756 = ($755 | 0) == ($718 | 0); //@line 7784
             if ($756) {
              break;
             }
             _abort(); //@line 7788
            }
           } while (0);
           $757 = ($748 | 0) == ($746 | 0); //@line 7792
           if ($757) {
            $758 = 1 << $743; //@line 7794
            $759 = $758 ^ -1; //@line 7795
            $760 = SAFE_HEAP_LOAD(2824 * 4 | 0, 4, 0) | 0 | 0; //@line 7796
            $761 = $760 & $759; //@line 7797
            SAFE_HEAP_STORE(2824 * 4 | 0, $761 | 0, 4);
            break;
           }
           $762 = ($748 | 0) == ($750 | 0); //@line 7801
           do {
            if ($762) {
             $$pre16$i$i = $748 + 8 | 0; //@line 7804
             $$pre$phi17$i$iZ2D = $$pre16$i$i; //@line 7805
            } else {
             $763 = $753 >>> 0 > $748 >>> 0; //@line 7807
             if ($763) {
              _abort(); //@line 7809
             }
             $764 = $748 + 8 | 0; //@line 7812
             $765 = SAFE_HEAP_LOAD($764 | 0, 4, 0) | 0 | 0; //@line 7813
             $766 = ($765 | 0) == ($718 | 0); //@line 7814
             if ($766) {
              $$pre$phi17$i$iZ2D = $764; //@line 7816
              break;
             }
             _abort(); //@line 7819
            }
           } while (0);
           $767 = $746 + 12 | 0; //@line 7823
           SAFE_HEAP_STORE($767 | 0, $748 | 0, 4);
           SAFE_HEAP_STORE($$pre$phi17$i$iZ2D | 0, $746 | 0, 4);
          } else {
           $768 = $718 + 24 | 0; //@line 7827
           $769 = SAFE_HEAP_LOAD($768 | 0, 4, 0) | 0 | 0; //@line 7828
           $770 = $718 + 12 | 0; //@line 7829
           $771 = SAFE_HEAP_LOAD($770 | 0, 4, 0) | 0 | 0; //@line 7830
           $772 = ($771 | 0) == ($718 | 0); //@line 7831
           do {
            if ($772) {
             $782 = $718 + 16 | 0; //@line 7834
             $783 = $782 + 4 | 0; //@line 7835
             $784 = SAFE_HEAP_LOAD($783 | 0, 4, 0) | 0 | 0; //@line 7836
             $785 = ($784 | 0) == (0 | 0); //@line 7837
             if ($785) {
              $786 = SAFE_HEAP_LOAD($782 | 0, 4, 0) | 0 | 0; //@line 7839
              $787 = ($786 | 0) == (0 | 0); //@line 7840
              if ($787) {
               $$3$i$i = 0; //@line 7842
               break;
              } else {
               $$1290$i$i$ph = $786; //@line 7845
               $$1292$i$i$ph = $782; //@line 7845
              }
             } else {
              $$1290$i$i$ph = $784; //@line 7848
              $$1292$i$i$ph = $783; //@line 7848
             }
             $$1290$i$i = $$1290$i$i$ph; //@line 7850
             $$1292$i$i = $$1292$i$i$ph; //@line 7850
             while (1) {
              $788 = $$1290$i$i + 20 | 0; //@line 7852
              $789 = SAFE_HEAP_LOAD($788 | 0, 4, 0) | 0 | 0; //@line 7853
              $790 = ($789 | 0) == (0 | 0); //@line 7854
              if ($790) {
               $791 = $$1290$i$i + 16 | 0; //@line 7856
               $792 = SAFE_HEAP_LOAD($791 | 0, 4, 0) | 0 | 0; //@line 7857
               $793 = ($792 | 0) == (0 | 0); //@line 7858
               if ($793) {
                break;
               } else {
                $$1290$i$i$be = $792; //@line 7862
                $$1292$i$i$be = $791; //@line 7862
               }
              } else {
               $$1290$i$i$be = $789; //@line 7865
               $$1292$i$i$be = $788; //@line 7865
              }
              $$1290$i$i = $$1290$i$i$be; //@line 7867
              $$1292$i$i = $$1292$i$i$be; //@line 7867
             }
             $794 = $753 >>> 0 > $$1292$i$i >>> 0; //@line 7869
             if ($794) {
              _abort(); //@line 7871
             } else {
              SAFE_HEAP_STORE($$1292$i$i | 0, 0 | 0, 4);
              $$3$i$i = $$1290$i$i; //@line 7875
              break;
             }
            } else {
             $773 = $718 + 8 | 0; //@line 7879
             $774 = SAFE_HEAP_LOAD($773 | 0, 4, 0) | 0 | 0; //@line 7880
             $775 = $753 >>> 0 > $774 >>> 0; //@line 7881
             if ($775) {
              _abort(); //@line 7883
             }
             $776 = $774 + 12 | 0; //@line 7886
             $777 = SAFE_HEAP_LOAD($776 | 0, 4, 0) | 0 | 0; //@line 7887
             $778 = ($777 | 0) == ($718 | 0); //@line 7888
             if (!$778) {
              _abort(); //@line 7890
             }
             $779 = $771 + 8 | 0; //@line 7893
             $780 = SAFE_HEAP_LOAD($779 | 0, 4, 0) | 0 | 0; //@line 7894
             $781 = ($780 | 0) == ($718 | 0); //@line 7895
             if ($781) {
              SAFE_HEAP_STORE($776 | 0, $771 | 0, 4);
              SAFE_HEAP_STORE($779 | 0, $774 | 0, 4);
              $$3$i$i = $771; //@line 7899
              break;
             } else {
              _abort(); //@line 7902
             }
            }
           } while (0);
           $795 = ($769 | 0) == (0 | 0); //@line 7907
           if ($795) {
            break;
           }
           $796 = $718 + 28 | 0; //@line 7911
           $797 = SAFE_HEAP_LOAD($796 | 0, 4, 0) | 0 | 0; //@line 7912
           $798 = 11600 + ($797 << 2) | 0; //@line 7913
           $799 = SAFE_HEAP_LOAD($798 | 0, 4, 0) | 0 | 0; //@line 7914
           $800 = ($799 | 0) == ($718 | 0); //@line 7915
           do {
            if ($800) {
             SAFE_HEAP_STORE($798 | 0, $$3$i$i | 0, 4);
             $cond$i$i = ($$3$i$i | 0) == (0 | 0); //@line 7919
             if (!$cond$i$i) {
              break;
             }
             $801 = 1 << $797; //@line 7923
             $802 = $801 ^ -1; //@line 7924
             $803 = SAFE_HEAP_LOAD(11300 | 0, 4, 0) | 0 | 0; //@line 7925
             $804 = $803 & $802; //@line 7926
             SAFE_HEAP_STORE(11300 | 0, $804 | 0, 4);
             break L325;
            } else {
             $805 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 7930
             $806 = $805 >>> 0 > $769 >>> 0; //@line 7931
             if ($806) {
              _abort(); //@line 7933
             } else {
              $807 = $769 + 16 | 0; //@line 7936
              $808 = SAFE_HEAP_LOAD($807 | 0, 4, 0) | 0 | 0; //@line 7937
              $809 = ($808 | 0) == ($718 | 0); //@line 7938
              $810 = $769 + 20 | 0; //@line 7939
              $$sink326 = $809 ? $807 : $810; //@line 7940
              SAFE_HEAP_STORE($$sink326 | 0, $$3$i$i | 0, 4);
              $811 = ($$3$i$i | 0) == (0 | 0); //@line 7942
              if ($811) {
               break L325;
              } else {
               break;
              }
             }
            }
           } while (0);
           $812 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 7951
           $813 = $812 >>> 0 > $$3$i$i >>> 0; //@line 7952
           if ($813) {
            _abort(); //@line 7954
           }
           $814 = $$3$i$i + 24 | 0; //@line 7957
           SAFE_HEAP_STORE($814 | 0, $769 | 0, 4);
           $815 = $718 + 16 | 0; //@line 7959
           $816 = SAFE_HEAP_LOAD($815 | 0, 4, 0) | 0 | 0; //@line 7960
           $817 = ($816 | 0) == (0 | 0); //@line 7961
           do {
            if (!$817) {
             $818 = $812 >>> 0 > $816 >>> 0; //@line 7964
             if ($818) {
              _abort(); //@line 7966
             } else {
              $819 = $$3$i$i + 16 | 0; //@line 7969
              SAFE_HEAP_STORE($819 | 0, $816 | 0, 4);
              $820 = $816 + 24 | 0; //@line 7971
              SAFE_HEAP_STORE($820 | 0, $$3$i$i | 0, 4);
              break;
             }
            }
           } while (0);
           $821 = $815 + 4 | 0; //@line 7977
           $822 = SAFE_HEAP_LOAD($821 | 0, 4, 0) | 0 | 0; //@line 7978
           $823 = ($822 | 0) == (0 | 0); //@line 7979
           if ($823) {
            break;
           }
           $824 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 7983
           $825 = $824 >>> 0 > $822 >>> 0; //@line 7984
           if ($825) {
            _abort(); //@line 7986
           } else {
            $826 = $$3$i$i + 20 | 0; //@line 7989
            SAFE_HEAP_STORE($826 | 0, $822 | 0, 4);
            $827 = $822 + 24 | 0; //@line 7991
            SAFE_HEAP_STORE($827 | 0, $$3$i$i | 0, 4);
            break;
           }
          }
         } while (0);
         $828 = $718 + $742 | 0; //@line 7997
         $829 = $742 + $723 | 0; //@line 7998
         $$0$i16$i = $828; //@line 7999
         $$0286$i$i = $829; //@line 7999
        } else {
         $$0$i16$i = $718; //@line 8001
         $$0286$i$i = $723; //@line 8001
        }
        $830 = $$0$i16$i + 4 | 0; //@line 8003
        $831 = SAFE_HEAP_LOAD($830 | 0, 4, 0) | 0 | 0; //@line 8004
        $832 = $831 & -2; //@line 8005
        SAFE_HEAP_STORE($830 | 0, $832 | 0, 4);
        $833 = $$0286$i$i | 1; //@line 8007
        $834 = $722 + 4 | 0; //@line 8008
        SAFE_HEAP_STORE($834 | 0, $833 | 0, 4);
        $835 = $722 + $$0286$i$i | 0; //@line 8010
        SAFE_HEAP_STORE($835 | 0, $$0286$i$i | 0, 4);
        $836 = $$0286$i$i >>> 3; //@line 8012
        $837 = $$0286$i$i >>> 0 < 256; //@line 8013
        if ($837) {
         $838 = $836 << 1; //@line 8015
         $839 = 11336 + ($838 << 2) | 0; //@line 8016
         $840 = SAFE_HEAP_LOAD(2824 * 4 | 0, 4, 0) | 0 | 0; //@line 8017
         $841 = 1 << $836; //@line 8018
         $842 = $840 & $841; //@line 8019
         $843 = ($842 | 0) == 0; //@line 8020
         do {
          if ($843) {
           $844 = $840 | $841; //@line 8023
           SAFE_HEAP_STORE(2824 * 4 | 0, $844 | 0, 4);
           $$pre$i17$i = $839 + 8 | 0; //@line 8025
           $$0294$i$i = $839; //@line 8026
           $$pre$phi$i18$iZ2D = $$pre$i17$i; //@line 8026
          } else {
           $845 = $839 + 8 | 0; //@line 8028
           $846 = SAFE_HEAP_LOAD($845 | 0, 4, 0) | 0 | 0; //@line 8029
           $847 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 8030
           $848 = $847 >>> 0 > $846 >>> 0; //@line 8031
           if (!$848) {
            $$0294$i$i = $846; //@line 8033
            $$pre$phi$i18$iZ2D = $845; //@line 8033
            break;
           }
           _abort(); //@line 8036
          }
         } while (0);
         SAFE_HEAP_STORE($$pre$phi$i18$iZ2D | 0, $722 | 0, 4);
         $849 = $$0294$i$i + 12 | 0; //@line 8041
         SAFE_HEAP_STORE($849 | 0, $722 | 0, 4);
         $850 = $722 + 8 | 0; //@line 8043
         SAFE_HEAP_STORE($850 | 0, $$0294$i$i | 0, 4);
         $851 = $722 + 12 | 0; //@line 8045
         SAFE_HEAP_STORE($851 | 0, $839 | 0, 4);
         break;
        }
        $852 = $$0286$i$i >>> 8; //@line 8049
        $853 = ($852 | 0) == 0; //@line 8050
        do {
         if ($853) {
          $$0295$i$i = 0; //@line 8053
         } else {
          $854 = $$0286$i$i >>> 0 > 16777215; //@line 8055
          if ($854) {
           $$0295$i$i = 31; //@line 8057
           break;
          }
          $855 = $852 + 1048320 | 0; //@line 8060
          $856 = $855 >>> 16; //@line 8061
          $857 = $856 & 8; //@line 8062
          $858 = $852 << $857; //@line 8063
          $859 = $858 + 520192 | 0; //@line 8064
          $860 = $859 >>> 16; //@line 8065
          $861 = $860 & 4; //@line 8066
          $862 = $861 | $857; //@line 8067
          $863 = $858 << $861; //@line 8068
          $864 = $863 + 245760 | 0; //@line 8069
          $865 = $864 >>> 16; //@line 8070
          $866 = $865 & 2; //@line 8071
          $867 = $862 | $866; //@line 8072
          $868 = 14 - $867 | 0; //@line 8073
          $869 = $863 << $866; //@line 8074
          $870 = $869 >>> 15; //@line 8075
          $871 = $868 + $870 | 0; //@line 8076
          $872 = $871 << 1; //@line 8077
          $873 = $871 + 7 | 0; //@line 8078
          $874 = $$0286$i$i >>> $873; //@line 8079
          $875 = $874 & 1; //@line 8080
          $876 = $875 | $872; //@line 8081
          $$0295$i$i = $876; //@line 8082
         }
        } while (0);
        $877 = 11600 + ($$0295$i$i << 2) | 0; //@line 8085
        $878 = $722 + 28 | 0; //@line 8086
        SAFE_HEAP_STORE($878 | 0, $$0295$i$i | 0, 4);
        $879 = $722 + 16 | 0; //@line 8088
        $880 = $879 + 4 | 0; //@line 8089
        SAFE_HEAP_STORE($880 | 0, 0 | 0, 4);
        SAFE_HEAP_STORE($879 | 0, 0 | 0, 4);
        $881 = SAFE_HEAP_LOAD(11300 | 0, 4, 0) | 0 | 0; //@line 8092
        $882 = 1 << $$0295$i$i; //@line 8093
        $883 = $881 & $882; //@line 8094
        $884 = ($883 | 0) == 0; //@line 8095
        if ($884) {
         $885 = $881 | $882; //@line 8097
         SAFE_HEAP_STORE(11300 | 0, $885 | 0, 4);
         SAFE_HEAP_STORE($877 | 0, $722 | 0, 4);
         $886 = $722 + 24 | 0; //@line 8100
         SAFE_HEAP_STORE($886 | 0, $877 | 0, 4);
         $887 = $722 + 12 | 0; //@line 8102
         SAFE_HEAP_STORE($887 | 0, $722 | 0, 4);
         $888 = $722 + 8 | 0; //@line 8104
         SAFE_HEAP_STORE($888 | 0, $722 | 0, 4);
         break;
        }
        $889 = SAFE_HEAP_LOAD($877 | 0, 4, 0) | 0 | 0; //@line 8108
        $890 = $889 + 4 | 0; //@line 8109
        $891 = SAFE_HEAP_LOAD($890 | 0, 4, 0) | 0 | 0; //@line 8110
        $892 = $891 & -8; //@line 8111
        $893 = ($892 | 0) == ($$0286$i$i | 0); //@line 8112
        L410 : do {
         if ($893) {
          $$0288$lcssa$i$i = $889; //@line 8115
         } else {
          $894 = ($$0295$i$i | 0) == 31; //@line 8117
          $895 = $$0295$i$i >>> 1; //@line 8118
          $896 = 25 - $895 | 0; //@line 8119
          $897 = $894 ? 0 : $896; //@line 8120
          $898 = $$0286$i$i << $897; //@line 8121
          $$028711$i$i = $898; //@line 8122
          $$028810$i$i = $889; //@line 8122
          while (1) {
           $905 = $$028711$i$i >>> 31; //@line 8124
           $906 = ($$028810$i$i + 16 | 0) + ($905 << 2) | 0; //@line 8125
           $901 = SAFE_HEAP_LOAD($906 | 0, 4, 0) | 0 | 0; //@line 8126
           $907 = ($901 | 0) == (0 | 0); //@line 8127
           if ($907) {
            break;
           }
           $899 = $$028711$i$i << 1; //@line 8131
           $900 = $901 + 4 | 0; //@line 8132
           $902 = SAFE_HEAP_LOAD($900 | 0, 4, 0) | 0 | 0; //@line 8133
           $903 = $902 & -8; //@line 8134
           $904 = ($903 | 0) == ($$0286$i$i | 0); //@line 8135
           if ($904) {
            $$0288$lcssa$i$i = $901; //@line 8137
            break L410;
           } else {
            $$028711$i$i = $899; //@line 8140
            $$028810$i$i = $901; //@line 8140
           }
          }
          $908 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 8143
          $909 = $908 >>> 0 > $906 >>> 0; //@line 8144
          if ($909) {
           _abort(); //@line 8146
          } else {
           SAFE_HEAP_STORE($906 | 0, $722 | 0, 4);
           $910 = $722 + 24 | 0; //@line 8150
           SAFE_HEAP_STORE($910 | 0, $$028810$i$i | 0, 4);
           $911 = $722 + 12 | 0; //@line 8152
           SAFE_HEAP_STORE($911 | 0, $722 | 0, 4);
           $912 = $722 + 8 | 0; //@line 8154
           SAFE_HEAP_STORE($912 | 0, $722 | 0, 4);
           break L317;
          }
         }
        } while (0);
        $913 = $$0288$lcssa$i$i + 8 | 0; //@line 8160
        $914 = SAFE_HEAP_LOAD($913 | 0, 4, 0) | 0 | 0; //@line 8161
        $915 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 8162
        $916 = $915 >>> 0 <= $$0288$lcssa$i$i >>> 0; //@line 8163
        $917 = $915 >>> 0 <= $914 >>> 0; //@line 8164
        $918 = $917 & $916; //@line 8165
        if ($918) {
         $919 = $914 + 12 | 0; //@line 8167
         SAFE_HEAP_STORE($919 | 0, $722 | 0, 4);
         SAFE_HEAP_STORE($913 | 0, $722 | 0, 4);
         $920 = $722 + 8 | 0; //@line 8170
         SAFE_HEAP_STORE($920 | 0, $914 | 0, 4);
         $921 = $722 + 12 | 0; //@line 8172
         SAFE_HEAP_STORE($921 | 0, $$0288$lcssa$i$i | 0, 4);
         $922 = $722 + 24 | 0; //@line 8174
         SAFE_HEAP_STORE($922 | 0, 0 | 0, 4);
         break;
        } else {
         _abort(); //@line 8178
        }
       }
      } while (0);
      $1059 = $710 + 8 | 0; //@line 8183
      $$0 = $1059; //@line 8184
      STACKTOP = sp; //@line 8185
      return $$0 | 0; //@line 8185
     }
    }
    $$0$i$i$i = 11744; //@line 8188
    while (1) {
     $923 = SAFE_HEAP_LOAD($$0$i$i$i | 0, 4, 0) | 0 | 0; //@line 8190
     $924 = $923 >>> 0 > $635 >>> 0; //@line 8191
     if (!$924) {
      $925 = $$0$i$i$i + 4 | 0; //@line 8193
      $926 = SAFE_HEAP_LOAD($925 | 0, 4, 0) | 0 | 0; //@line 8194
      $927 = $923 + $926 | 0; //@line 8195
      $928 = $927 >>> 0 > $635 >>> 0; //@line 8196
      if ($928) {
       break;
      }
     }
     $929 = $$0$i$i$i + 8 | 0; //@line 8201
     $930 = SAFE_HEAP_LOAD($929 | 0, 4, 0) | 0 | 0; //@line 8202
     $$0$i$i$i = $930; //@line 8203
    }
    $931 = $927 + -47 | 0; //@line 8205
    $932 = $931 + 8 | 0; //@line 8206
    $933 = $932; //@line 8207
    $934 = $933 & 7; //@line 8208
    $935 = ($934 | 0) == 0; //@line 8209
    $936 = 0 - $933 | 0; //@line 8210
    $937 = $936 & 7; //@line 8211
    $938 = $935 ? 0 : $937; //@line 8212
    $939 = $931 + $938 | 0; //@line 8213
    $940 = $635 + 16 | 0; //@line 8214
    $941 = $939 >>> 0 < $940 >>> 0; //@line 8215
    $942 = $941 ? $635 : $939; //@line 8216
    $943 = $942 + 8 | 0; //@line 8217
    $944 = $942 + 24 | 0; //@line 8218
    $945 = $$723947$i + -40 | 0; //@line 8219
    $946 = $$748$i + 8 | 0; //@line 8220
    $947 = $946; //@line 8221
    $948 = $947 & 7; //@line 8222
    $949 = ($948 | 0) == 0; //@line 8223
    $950 = 0 - $947 | 0; //@line 8224
    $951 = $950 & 7; //@line 8225
    $952 = $949 ? 0 : $951; //@line 8226
    $953 = $$748$i + $952 | 0; //@line 8227
    $954 = $945 - $952 | 0; //@line 8228
    SAFE_HEAP_STORE(11320 | 0, $953 | 0, 4);
    SAFE_HEAP_STORE(11308 | 0, $954 | 0, 4);
    $955 = $954 | 1; //@line 8231
    $956 = $953 + 4 | 0; //@line 8232
    SAFE_HEAP_STORE($956 | 0, $955 | 0, 4);
    $957 = $$748$i + $945 | 0; //@line 8234
    $958 = $957 + 4 | 0; //@line 8235
    SAFE_HEAP_STORE($958 | 0, 40 | 0, 4);
    $959 = SAFE_HEAP_LOAD(11784 | 0, 4, 0) | 0 | 0; //@line 8237
    SAFE_HEAP_STORE(11324 | 0, $959 | 0, 4);
    $960 = $942 + 4 | 0; //@line 8239
    SAFE_HEAP_STORE($960 | 0, 27 | 0, 4);
    SAFE_HEAP_STORE($943 | 0, SAFE_HEAP_LOAD(11744 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($943 + 4 | 0, SAFE_HEAP_LOAD(11744 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($943 + 8 | 0, SAFE_HEAP_LOAD(11744 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($943 + 12 | 0, SAFE_HEAP_LOAD(11744 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE(11744 | 0, $$748$i | 0, 4);
    SAFE_HEAP_STORE(11748 | 0, $$723947$i | 0, 4);
    SAFE_HEAP_STORE(11756 | 0, 0 | 0, 4);
    SAFE_HEAP_STORE(11752 | 0, $943 | 0, 4);
    $962 = $944; //@line 8246
    while (1) {
     $961 = $962 + 4 | 0; //@line 8248
     SAFE_HEAP_STORE($961 | 0, 7 | 0, 4);
     $963 = $962 + 8 | 0; //@line 8250
     $964 = $963 >>> 0 < $927 >>> 0; //@line 8251
     if ($964) {
      $962 = $961; //@line 8253
     } else {
      break;
     }
    }
    $965 = ($942 | 0) == ($635 | 0); //@line 8258
    if (!$965) {
     $966 = $942; //@line 8260
     $967 = $635; //@line 8261
     $968 = $966 - $967 | 0; //@line 8262
     $969 = SAFE_HEAP_LOAD($960 | 0, 4, 0) | 0 | 0; //@line 8263
     $970 = $969 & -2; //@line 8264
     SAFE_HEAP_STORE($960 | 0, $970 | 0, 4);
     $971 = $968 | 1; //@line 8266
     $972 = $635 + 4 | 0; //@line 8267
     SAFE_HEAP_STORE($972 | 0, $971 | 0, 4);
     SAFE_HEAP_STORE($942 | 0, $968 | 0, 4);
     $973 = $968 >>> 3; //@line 8270
     $974 = $968 >>> 0 < 256; //@line 8271
     if ($974) {
      $975 = $973 << 1; //@line 8273
      $976 = 11336 + ($975 << 2) | 0; //@line 8274
      $977 = SAFE_HEAP_LOAD(2824 * 4 | 0, 4, 0) | 0 | 0; //@line 8275
      $978 = 1 << $973; //@line 8276
      $979 = $977 & $978; //@line 8277
      $980 = ($979 | 0) == 0; //@line 8278
      if ($980) {
       $981 = $977 | $978; //@line 8280
       SAFE_HEAP_STORE(2824 * 4 | 0, $981 | 0, 4);
       $$pre$i$i = $976 + 8 | 0; //@line 8282
       $$0211$i$i = $976; //@line 8283
       $$pre$phi$i$iZ2D = $$pre$i$i; //@line 8283
      } else {
       $982 = $976 + 8 | 0; //@line 8285
       $983 = SAFE_HEAP_LOAD($982 | 0, 4, 0) | 0 | 0; //@line 8286
       $984 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 8287
       $985 = $984 >>> 0 > $983 >>> 0; //@line 8288
       if ($985) {
        _abort(); //@line 8290
       } else {
        $$0211$i$i = $983; //@line 8293
        $$pre$phi$i$iZ2D = $982; //@line 8293
       }
      }
      SAFE_HEAP_STORE($$pre$phi$i$iZ2D | 0, $635 | 0, 4);
      $986 = $$0211$i$i + 12 | 0; //@line 8297
      SAFE_HEAP_STORE($986 | 0, $635 | 0, 4);
      $987 = $635 + 8 | 0; //@line 8299
      SAFE_HEAP_STORE($987 | 0, $$0211$i$i | 0, 4);
      $988 = $635 + 12 | 0; //@line 8301
      SAFE_HEAP_STORE($988 | 0, $976 | 0, 4);
      break;
     }
     $989 = $968 >>> 8; //@line 8305
     $990 = ($989 | 0) == 0; //@line 8306
     if ($990) {
      $$0212$i$i = 0; //@line 8308
     } else {
      $991 = $968 >>> 0 > 16777215; //@line 8310
      if ($991) {
       $$0212$i$i = 31; //@line 8312
      } else {
       $992 = $989 + 1048320 | 0; //@line 8314
       $993 = $992 >>> 16; //@line 8315
       $994 = $993 & 8; //@line 8316
       $995 = $989 << $994; //@line 8317
       $996 = $995 + 520192 | 0; //@line 8318
       $997 = $996 >>> 16; //@line 8319
       $998 = $997 & 4; //@line 8320
       $999 = $998 | $994; //@line 8321
       $1000 = $995 << $998; //@line 8322
       $1001 = $1000 + 245760 | 0; //@line 8323
       $1002 = $1001 >>> 16; //@line 8324
       $1003 = $1002 & 2; //@line 8325
       $1004 = $999 | $1003; //@line 8326
       $1005 = 14 - $1004 | 0; //@line 8327
       $1006 = $1000 << $1003; //@line 8328
       $1007 = $1006 >>> 15; //@line 8329
       $1008 = $1005 + $1007 | 0; //@line 8330
       $1009 = $1008 << 1; //@line 8331
       $1010 = $1008 + 7 | 0; //@line 8332
       $1011 = $968 >>> $1010; //@line 8333
       $1012 = $1011 & 1; //@line 8334
       $1013 = $1012 | $1009; //@line 8335
       $$0212$i$i = $1013; //@line 8336
      }
     }
     $1014 = 11600 + ($$0212$i$i << 2) | 0; //@line 8339
     $1015 = $635 + 28 | 0; //@line 8340
     SAFE_HEAP_STORE($1015 | 0, $$0212$i$i | 0, 4);
     $1016 = $635 + 20 | 0; //@line 8342
     SAFE_HEAP_STORE($1016 | 0, 0 | 0, 4);
     SAFE_HEAP_STORE($940 | 0, 0 | 0, 4);
     $1017 = SAFE_HEAP_LOAD(11300 | 0, 4, 0) | 0 | 0; //@line 8345
     $1018 = 1 << $$0212$i$i; //@line 8346
     $1019 = $1017 & $1018; //@line 8347
     $1020 = ($1019 | 0) == 0; //@line 8348
     if ($1020) {
      $1021 = $1017 | $1018; //@line 8350
      SAFE_HEAP_STORE(11300 | 0, $1021 | 0, 4);
      SAFE_HEAP_STORE($1014 | 0, $635 | 0, 4);
      $1022 = $635 + 24 | 0; //@line 8353
      SAFE_HEAP_STORE($1022 | 0, $1014 | 0, 4);
      $1023 = $635 + 12 | 0; //@line 8355
      SAFE_HEAP_STORE($1023 | 0, $635 | 0, 4);
      $1024 = $635 + 8 | 0; //@line 8357
      SAFE_HEAP_STORE($1024 | 0, $635 | 0, 4);
      break;
     }
     $1025 = SAFE_HEAP_LOAD($1014 | 0, 4, 0) | 0 | 0; //@line 8361
     $1026 = $1025 + 4 | 0; //@line 8362
     $1027 = SAFE_HEAP_LOAD($1026 | 0, 4, 0) | 0 | 0; //@line 8363
     $1028 = $1027 & -8; //@line 8364
     $1029 = ($1028 | 0) == ($968 | 0); //@line 8365
     L451 : do {
      if ($1029) {
       $$0207$lcssa$i$i = $1025; //@line 8368
      } else {
       $1030 = ($$0212$i$i | 0) == 31; //@line 8370
       $1031 = $$0212$i$i >>> 1; //@line 8371
       $1032 = 25 - $1031 | 0; //@line 8372
       $1033 = $1030 ? 0 : $1032; //@line 8373
       $1034 = $968 << $1033; //@line 8374
       $$02065$i$i = $1034; //@line 8375
       $$02074$i$i = $1025; //@line 8375
       while (1) {
        $1041 = $$02065$i$i >>> 31; //@line 8377
        $1042 = ($$02074$i$i + 16 | 0) + ($1041 << 2) | 0; //@line 8378
        $1037 = SAFE_HEAP_LOAD($1042 | 0, 4, 0) | 0 | 0; //@line 8379
        $1043 = ($1037 | 0) == (0 | 0); //@line 8380
        if ($1043) {
         break;
        }
        $1035 = $$02065$i$i << 1; //@line 8384
        $1036 = $1037 + 4 | 0; //@line 8385
        $1038 = SAFE_HEAP_LOAD($1036 | 0, 4, 0) | 0 | 0; //@line 8386
        $1039 = $1038 & -8; //@line 8387
        $1040 = ($1039 | 0) == ($968 | 0); //@line 8388
        if ($1040) {
         $$0207$lcssa$i$i = $1037; //@line 8390
         break L451;
        } else {
         $$02065$i$i = $1035; //@line 8393
         $$02074$i$i = $1037; //@line 8393
        }
       }
       $1044 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 8396
       $1045 = $1044 >>> 0 > $1042 >>> 0; //@line 8397
       if ($1045) {
        _abort(); //@line 8399
       } else {
        SAFE_HEAP_STORE($1042 | 0, $635 | 0, 4);
        $1046 = $635 + 24 | 0; //@line 8403
        SAFE_HEAP_STORE($1046 | 0, $$02074$i$i | 0, 4);
        $1047 = $635 + 12 | 0; //@line 8405
        SAFE_HEAP_STORE($1047 | 0, $635 | 0, 4);
        $1048 = $635 + 8 | 0; //@line 8407
        SAFE_HEAP_STORE($1048 | 0, $635 | 0, 4);
        break L294;
       }
      }
     } while (0);
     $1049 = $$0207$lcssa$i$i + 8 | 0; //@line 8413
     $1050 = SAFE_HEAP_LOAD($1049 | 0, 4, 0) | 0 | 0; //@line 8414
     $1051 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 8415
     $1052 = $1051 >>> 0 <= $$0207$lcssa$i$i >>> 0; //@line 8416
     $1053 = $1051 >>> 0 <= $1050 >>> 0; //@line 8417
     $1054 = $1053 & $1052; //@line 8418
     if ($1054) {
      $1055 = $1050 + 12 | 0; //@line 8420
      SAFE_HEAP_STORE($1055 | 0, $635 | 0, 4);
      SAFE_HEAP_STORE($1049 | 0, $635 | 0, 4);
      $1056 = $635 + 8 | 0; //@line 8423
      SAFE_HEAP_STORE($1056 | 0, $1050 | 0, 4);
      $1057 = $635 + 12 | 0; //@line 8425
      SAFE_HEAP_STORE($1057 | 0, $$0207$lcssa$i$i | 0, 4);
      $1058 = $635 + 24 | 0; //@line 8427
      SAFE_HEAP_STORE($1058 | 0, 0 | 0, 4);
      break;
     } else {
      _abort(); //@line 8431
     }
    }
   }
  } while (0);
  $1060 = SAFE_HEAP_LOAD(11308 | 0, 4, 0) | 0 | 0; //@line 8437
  $1061 = $1060 >>> 0 > $$0197 >>> 0; //@line 8438
  if ($1061) {
   $1062 = $1060 - $$0197 | 0; //@line 8440
   SAFE_HEAP_STORE(11308 | 0, $1062 | 0, 4);
   $1063 = SAFE_HEAP_LOAD(11320 | 0, 4, 0) | 0 | 0; //@line 8442
   $1064 = $1063 + $$0197 | 0; //@line 8443
   SAFE_HEAP_STORE(11320 | 0, $1064 | 0, 4);
   $1065 = $1062 | 1; //@line 8445
   $1066 = $1064 + 4 | 0; //@line 8446
   SAFE_HEAP_STORE($1066 | 0, $1065 | 0, 4);
   $1067 = $$0197 | 3; //@line 8448
   $1068 = $1063 + 4 | 0; //@line 8449
   SAFE_HEAP_STORE($1068 | 0, $1067 | 0, 4);
   $1069 = $1063 + 8 | 0; //@line 8451
   $$0 = $1069; //@line 8452
   STACKTOP = sp; //@line 8453
   return $$0 | 0; //@line 8453
  }
 }
 $1070 = ___errno_location() | 0; //@line 8456
 SAFE_HEAP_STORE($1070 | 0, 12 | 0, 4);
 $$0 = 0; //@line 8458
 STACKTOP = sp; //@line 8459
 return $$0 | 0; //@line 8459
}
function _fmt_fp($0, $1, $2, $3, $4, $5) {
 $0 = $0 | 0; //@line 12911
 $1 = +$1; //@line 12912
 $2 = $2 | 0; //@line 12913
 $3 = $3 | 0; //@line 12914
 $4 = $4 | 0; //@line 12915
 $5 = $5 | 0; //@line 12916
 var $$ = 0, $$0 = 0, $$0463$lcssa = 0, $$0463588 = 0, $$0464599 = 0, $$0471 = 0.0, $$0479 = 0, $$0487657 = 0, $$0488 = 0, $$0488669 = 0, $$0488671 = 0, $$0497670 = 0, $$0498 = 0, $$0511586 = 0.0, $$0512 = 0, $$0513 = 0, $$0516652 = 0, $$0522 = 0, $$0523 = 0, $$0525 = 0; //@line 12917
 var $$0527 = 0, $$0529 = 0, $$0529$in646 = 0, $$0532651 = 0, $$1465 = 0, $$1467 = 0.0, $$1469 = 0.0, $$1472 = 0.0, $$1480 = 0, $$1482$lcssa = 0, $$1482683 = 0, $$1489656 = 0, $$1499 = 0, $$1510587 = 0, $$1514$lcssa = 0, $$1514614 = 0, $$1517 = 0, $$1526 = 0, $$1528 = 0, $$1530621 = 0; //@line 12918
 var $$1533$lcssa = 0, $$1533645 = 0, $$1604 = 0, $$2 = 0, $$2473 = 0.0, $$2476 = 0, $$2483 = 0, $$2490$lcssa = 0, $$2490638 = 0, $$2500$lcssa = 0, $$2500682 = 0, $$2515 = 0, $$2518634 = 0, $$2531 = 0, $$2534633 = 0, $$3 = 0.0, $$3477 = 0, $$3484$lcssa = 0, $$3484663 = 0, $$3501$lcssa = 0; //@line 12919
 var $$3501676 = 0, $$3535620 = 0, $$4 = 0.0, $$4478$lcssa = 0, $$4478594 = 0, $$4492 = 0, $$4502$lcssa = 0, $$4502662 = 0, $$4520 = 0, $$5$lcssa = 0, $$5486$lcssa = 0, $$5486639 = 0, $$5493603 = 0, $$5503 = 0, $$5521 = 0, $$560 = 0, $$5609 = 0, $$6 = 0, $$6494593 = 0, $$7495608 = 0; //@line 12920
 var $$8 = 0, $$8506 = 0, $$9 = 0, $$9507$lcssa = 0, $$9507625 = 0, $$lcssa583 = 0, $$lobit = 0, $$neg = 0, $$neg571 = 0, $$not = 0, $$pn = 0, $$pr = 0, $$pr564 = 0, $$pre = 0, $$pre$phi717Z2D = 0, $$pre$phi718Z2D = 0, $$pre720 = 0, $$sink757 = 0, $10 = 0, $100 = 0; //@line 12921
 var $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0; //@line 12922
 var $12 = 0, $120 = 0, $121 = 0.0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0.0, $129 = 0.0, $13 = 0, $130 = 0.0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0; //@line 12923
 var $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0.0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0; //@line 12924
 var $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0; //@line 12925
 var $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0; //@line 12926
 var $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0; //@line 12927
 var $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0; //@line 12928
 var $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0.0; //@line 12929
 var $247 = 0.0, $248 = 0, $249 = 0.0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0;
 var $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0; //@line 12931
 var $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0, $299 = 0, $30 = 0, $300 = 0; //@line 12932
 var $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0, $311 = 0, $312 = 0, $313 = 0, $314 = 0, $315 = 0, $316 = 0, $317 = 0, $318 = 0, $319 = 0; //@line 12933
 var $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0, $329 = 0, $33 = 0, $330 = 0, $331 = 0, $332 = 0, $333 = 0, $334 = 0, $335 = 0, $336 = 0, $337 = 0; //@line 12934
 var $338 = 0, $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0, $344 = 0, $345 = 0, $346 = 0, $347 = 0, $348 = 0, $349 = 0, $35 = 0, $350 = 0, $351 = 0, $352 = 0, $353 = 0, $354 = 0, $355 = 0; //@line 12935
 var $356 = 0, $357 = 0, $358 = 0, $359 = 0, $36 = 0, $360 = 0, $361 = 0, $362 = 0, $363 = 0, $364 = 0, $365 = 0, $366 = 0, $367 = 0, $368 = 0, $369 = 0, $37 = 0.0, $370 = 0, $371 = 0, $372 = 0, $373 = 0; //@line 12936
 var $374 = 0, $375 = 0, $376 = 0, $377 = 0, $378 = 0, $379 = 0, $38 = 0.0, $380 = 0, $381 = 0, $382 = 0, $383 = 0, $384 = 0, $385 = 0, $386 = 0, $387 = 0, $388 = 0, $389 = 0, $39 = 0, $390 = 0, $391 = 0; //@line 12937
 var $392 = 0, $393 = 0, $394 = 0, $395 = 0, $396 = 0, $397 = 0, $398 = 0, $399 = 0, $40 = 0, $400 = 0, $401 = 0, $402 = 0, $403 = 0, $404 = 0, $405 = 0, $406 = 0, $407 = 0, $408 = 0, $409 = 0, $41 = 0; //@line 12938
 var $410 = 0, $411 = 0, $412 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0.0, $54 = 0, $55 = 0, $56 = 0, $57 = 0.0, $58 = 0.0; //@line 12939
 var $59 = 0.0, $6 = 0, $60 = 0.0, $61 = 0.0, $62 = 0.0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0;
 var $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0.0, $91 = 0.0, $92 = 0.0, $93 = 0, $94 = 0; //@line 12941
 var $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $not$ = 0, $or$cond = 0, $or$cond3$not = 0, $or$cond543 = 0, $or$cond546 = 0, $or$cond556 = 0, $or$cond559 = 0, $or$cond6 = 0, $scevgep711 = 0, $scevgep711712 = 0, $spec$select = 0, $spec$select539 = 0, $spec$select540 = 0, $spec$select540722 = 0, $spec$select540723 = 0; //@line 12942
 var $spec$select541 = 0, $spec$select544 = 0.0, $spec$select547 = 0, $spec$select548 = 0, $spec$select549 = 0, $spec$select551 = 0, $spec$select554 = 0, $spec$select557 = 0, $spec$select561 = 0.0, $spec$select562 = 0, $spec$select563 = 0, $spec$select565 = 0, $spec$select566 = 0, $spec$select567 = 0.0, $spec$select568 = 0.0, $spec$select569 = 0.0, label = 0, sp = 0; //@line 12943
 sp = STACKTOP; //@line 12944
 STACKTOP = STACKTOP + 560 | 0; //@line 12945
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(560 | 0); //@line 12945
 $6 = sp + 32 | 0; //@line 12946
 $7 = sp + 536 | 0; //@line 12947
 $8 = sp; //@line 12948
 $9 = $8; //@line 12949
 $10 = sp + 540 | 0; //@line 12950
 SAFE_HEAP_STORE($7 | 0, 0 | 0, 4);
 $11 = $10 + 12 | 0; //@line 12952
 $12 = ___DOUBLE_BITS_662($1) | 0; //@line 12953
 $13 = getTempRet0() | 0; //@line 12954
 $14 = ($13 | 0) < 0; //@line 12955
 if ($14) {
  $15 = -$1; //@line 12957
  $16 = ___DOUBLE_BITS_662($15) | 0; //@line 12958
  $17 = getTempRet0() | 0; //@line 12959
  $$0471 = $15; //@line 12960
  $$0522 = 1; //@line 12960
  $$0523 = 10147; //@line 12960
  $25 = $17; //@line 12960
  $412 = $16; //@line 12960
 } else {
  $18 = $4 & 2048; //@line 12962
  $19 = ($18 | 0) == 0; //@line 12963
  $20 = $4 & 1; //@line 12964
  $21 = ($20 | 0) == 0; //@line 12965
  $$ = $21 ? 10148 : 10153; //@line 12966
  $spec$select565 = $19 ? $$ : 10150; //@line 12967
  $22 = $4 & 2049; //@line 12968
  $23 = ($22 | 0) != 0; //@line 12969
  $spec$select566 = $23 & 1; //@line 12970
  $$0471 = $1; //@line 12971
  $$0522 = $spec$select566; //@line 12971
  $$0523 = $spec$select565; //@line 12971
  $25 = $13; //@line 12971
  $412 = $12; //@line 12971
 }
 $24 = $25 & 2146435072; //@line 12973
 $26 = 0 == 0; //@line 12974
 $27 = ($24 | 0) == 2146435072; //@line 12975
 $28 = $26 & $27; //@line 12976
 do {
  if ($28) {
   $29 = $5 & 32; //@line 12979
   $30 = ($29 | 0) != 0; //@line 12980
   $31 = $30 ? 10166 : 10170; //@line 12981
   $32 = $$0471 != $$0471 | 0.0 != 0.0; //@line 12982
   $33 = $30 ? 10174 : 10178; //@line 12983
   $$0512 = $32 ? $33 : $31; //@line 12984
   $34 = $$0522 + 3 | 0; //@line 12985
   $35 = $4 & -65537; //@line 12986
   _pad_661($0, 32, $2, $34, $35); //@line 12987
   _out_655($0, $$0523, $$0522); //@line 12988
   _out_655($0, $$0512, 3); //@line 12989
   $36 = $4 ^ 8192; //@line 12990
   _pad_661($0, 32, $2, $34, $36); //@line 12991
   $$sink757 = $34; //@line 12992
  } else {
   $37 = +_frexpl($$0471, $7); //@line 12994
   $38 = $37 * 2.0; //@line 12995
   $39 = $38 != 0.0; //@line 12996
   if ($39) {
    $40 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 12998
    $41 = $40 + -1 | 0; //@line 12999
    SAFE_HEAP_STORE($7 | 0, $41 | 0, 4);
   }
   $42 = $5 | 32; //@line 13002
   $43 = ($42 | 0) == 97; //@line 13003
   if ($43) {
    $44 = $5 & 32; //@line 13005
    $45 = ($44 | 0) == 0; //@line 13006
    $46 = $$0523 + 9 | 0; //@line 13007
    $spec$select = $45 ? $$0523 : $46; //@line 13008
    $47 = $$0522 | 2; //@line 13009
    $48 = $3 >>> 0 > 11; //@line 13010
    $49 = 12 - $3 | 0; //@line 13011
    $50 = ($49 | 0) == 0; //@line 13012
    $51 = $48 | $50; //@line 13013
    do {
     if ($51) {
      $$1472 = $38; //@line 13016
     } else {
      $$0511586 = 8.0; //@line 13018
      $$1510587 = $49; //@line 13018
      while (1) {
       $52 = $$1510587 + -1 | 0; //@line 13020
       $53 = $$0511586 * 16.0; //@line 13021
       $54 = ($52 | 0) == 0; //@line 13022
       if ($54) {
        break;
       } else {
        $$0511586 = $53; //@line 13026
        $$1510587 = $52; //@line 13026
       }
      }
      $55 = SAFE_HEAP_LOAD($spec$select >> 0 | 0, 1, 0) | 0 | 0; //@line 13029
      $56 = $55 << 24 >> 24 == 45; //@line 13030
      if ($56) {
       $57 = -$38; //@line 13032
       $58 = $57 - $53; //@line 13033
       $59 = $53 + $58; //@line 13034
       $60 = -$59; //@line 13035
       $$1472 = $60; //@line 13036
       break;
      } else {
       $61 = $38 + $53; //@line 13039
       $62 = $61 - $53; //@line 13040
       $$1472 = $62; //@line 13041
       break;
      }
     }
    } while (0);
    $63 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 13046
    $64 = ($63 | 0) < 0; //@line 13047
    $65 = 0 - $63 | 0; //@line 13048
    $66 = $64 ? $65 : $63; //@line 13049
    $67 = ($66 | 0) < 0; //@line 13050
    $68 = $67 << 31 >> 31; //@line 13051
    $69 = _fmt_u($66, $68, $11) | 0; //@line 13052
    $70 = ($69 | 0) == ($11 | 0); //@line 13053
    if ($70) {
     $71 = $10 + 11 | 0; //@line 13055
     SAFE_HEAP_STORE($71 >> 0 | 0, 48 | 0, 1);
     $$0513 = $71; //@line 13057
    } else {
     $$0513 = $69; //@line 13059
    }
    $72 = $63 >> 31; //@line 13061
    $73 = $72 & 2; //@line 13062
    $74 = $73 + 43 | 0; //@line 13063
    $75 = $74 & 255; //@line 13064
    $76 = $$0513 + -1 | 0; //@line 13065
    SAFE_HEAP_STORE($76 >> 0 | 0, $75 | 0, 1);
    $77 = $5 + 15 | 0; //@line 13067
    $78 = $77 & 255; //@line 13068
    $79 = $$0513 + -2 | 0; //@line 13069
    SAFE_HEAP_STORE($79 >> 0 | 0, $78 | 0, 1);
    $80 = ($3 | 0) < 1; //@line 13071
    $81 = $4 & 8; //@line 13072
    $82 = ($81 | 0) == 0; //@line 13073
    $$0525 = $8; //@line 13074
    $$2473 = $$1472; //@line 13074
    while (1) {
     $83 = ~~$$2473; //@line 13076
     $84 = 656 + $83 | 0; //@line 13077
     $85 = SAFE_HEAP_LOAD($84 >> 0 | 0, 1, 0) | 0 | 0; //@line 13078
     $86 = $85 & 255; //@line 13079
     $87 = $44 | $86; //@line 13080
     $88 = $87 & 255; //@line 13081
     $89 = $$0525 + 1 | 0; //@line 13082
     SAFE_HEAP_STORE($$0525 >> 0 | 0, $88 | 0, 1);
     $90 = +($83 | 0); //@line 13084
     $91 = $$2473 - $90; //@line 13085
     $92 = $91 * 16.0; //@line 13086
     $93 = $89; //@line 13087
     $94 = $93 - $9 | 0; //@line 13088
     $95 = ($94 | 0) == 1; //@line 13089
     if ($95) {
      $96 = $92 == 0.0; //@line 13091
      $or$cond3$not = $80 & $96; //@line 13092
      $or$cond = $82 & $or$cond3$not; //@line 13093
      if ($or$cond) {
       $$1526 = $89; //@line 13095
      } else {
       $97 = $$0525 + 2 | 0; //@line 13097
       SAFE_HEAP_STORE($89 >> 0 | 0, 46 | 0, 1);
       $$1526 = $97; //@line 13099
      }
     } else {
      $$1526 = $89; //@line 13102
     }
     $98 = $92 != 0.0; //@line 13104
     if ($98) {
      $$0525 = $$1526; //@line 13106
      $$2473 = $92; //@line 13106
     } else {
      break;
     }
    }
    $99 = ($3 | 0) == 0; //@line 13111
    $$pre720 = $$1526; //@line 13112
    if ($99) {
     label = 25; //@line 13114
    } else {
     $100 = -2 - $9 | 0; //@line 13116
     $101 = $100 + $$pre720 | 0; //@line 13117
     $102 = ($101 | 0) < ($3 | 0); //@line 13118
     if ($102) {
      $103 = $11; //@line 13120
      $104 = $79; //@line 13121
      $105 = $3 + 2 | 0; //@line 13122
      $106 = $105 + $103 | 0; //@line 13123
      $107 = $106 - $104 | 0; //@line 13124
      $$0527 = $107; //@line 13125
      $$pre$phi717Z2D = $103; //@line 13125
      $$pre$phi718Z2D = $104; //@line 13125
     } else {
      label = 25; //@line 13127
     }
    }
    if ((label | 0) == 25) {
     $108 = $11; //@line 13131
     $109 = $79; //@line 13132
     $110 = $108 - $9 | 0; //@line 13133
     $111 = $110 - $109 | 0; //@line 13134
     $112 = $111 + $$pre720 | 0; //@line 13135
     $$0527 = $112; //@line 13136
     $$pre$phi717Z2D = $108; //@line 13136
     $$pre$phi718Z2D = $109; //@line 13136
    }
    $113 = $$0527 + $47 | 0; //@line 13138
    _pad_661($0, 32, $2, $113, $4); //@line 13139
    _out_655($0, $spec$select, $47); //@line 13140
    $114 = $4 ^ 65536; //@line 13141
    _pad_661($0, 48, $2, $113, $114); //@line 13142
    $115 = $$pre720 - $9 | 0; //@line 13143
    _out_655($0, $8, $115); //@line 13144
    $116 = $$pre$phi717Z2D - $$pre$phi718Z2D | 0; //@line 13145
    $117 = $115 + $116 | 0; //@line 13146
    $118 = $$0527 - $117 | 0; //@line 13147
    _pad_661($0, 48, $118, 0, 0); //@line 13148
    _out_655($0, $79, $116); //@line 13149
    $119 = $4 ^ 8192; //@line 13150
    _pad_661($0, 32, $2, $113, $119); //@line 13151
    $$sink757 = $113; //@line 13152
    break;
   }
   $120 = ($3 | 0) < 0; //@line 13155
   $spec$select539 = $120 ? 6 : $3; //@line 13156
   if ($39) {
    $121 = $38 * 268435456.0; //@line 13158
    $122 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 13159
    $123 = $122 + -28 | 0; //@line 13160
    SAFE_HEAP_STORE($7 | 0, $123 | 0, 4);
    $$3 = $121; //@line 13162
    $$pr = $123; //@line 13162
   } else {
    $$pre = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 13164
    $$3 = $38; //@line 13165
    $$pr = $$pre; //@line 13165
   }
   $124 = ($$pr | 0) < 0; //@line 13167
   $125 = $6 + 288 | 0; //@line 13168
   $$0498 = $124 ? $6 : $125; //@line 13169
   $$1499 = $$0498; //@line 13170
   $$4 = $$3; //@line 13170
   while (1) {
    $126 = ~~$$4 >>> 0; //@line 13172
    SAFE_HEAP_STORE($$1499 | 0, $126 | 0, 4);
    $127 = $$1499 + 4 | 0; //@line 13174
    $128 = +($126 >>> 0); //@line 13175
    $129 = $$4 - $128; //@line 13176
    $130 = $129 * 1.0e9; //@line 13177
    $131 = $130 != 0.0; //@line 13178
    if ($131) {
     $$1499 = $127; //@line 13180
     $$4 = $130; //@line 13180
    } else {
     break;
    }
   }
   $132 = $$0498; //@line 13185
   $133 = ($$pr | 0) > 0; //@line 13186
   if ($133) {
    $$1482683 = $$0498; //@line 13188
    $$2500682 = $127; //@line 13188
    $135 = $$pr; //@line 13188
    while (1) {
     $134 = ($135 | 0) < 29; //@line 13190
     $136 = $134 ? $135 : 29; //@line 13191
     $$0488669 = $$2500682 + -4 | 0; //@line 13192
     $137 = $$0488669 >>> 0 < $$1482683 >>> 0; //@line 13193
     if ($137) {
      $$2483 = $$1482683; //@line 13195
     } else {
      $$0488671 = $$0488669; //@line 13197
      $$0497670 = 0; //@line 13197
      while (1) {
       $138 = SAFE_HEAP_LOAD($$0488671 | 0, 4, 0) | 0 | 0; //@line 13199
       $139 = _bitshift64Shl($138 | 0, 0, $136 | 0) | 0; //@line 13200
       $140 = getTempRet0() | 0; //@line 13201
       $141 = _i64Add($139 | 0, $140 | 0, $$0497670 | 0, 0) | 0; //@line 13202
       $142 = getTempRet0() | 0; //@line 13203
       $143 = ___udivdi3($141 | 0, $142 | 0, 1e9, 0) | 0; //@line 13204
       $144 = getTempRet0() | 0; //@line 13205
       $145 = ___muldi3($143 | 0, $144 | 0, 1e9, 0) | 0; //@line 13206
       $146 = getTempRet0() | 0; //@line 13207
       $147 = _i64Subtract($141 | 0, $142 | 0, $145 | 0, $146 | 0) | 0; //@line 13208
       $148 = getTempRet0() | 0; //@line 13209
       SAFE_HEAP_STORE($$0488671 | 0, $147 | 0, 4);
       $$0488 = $$0488671 + -4 | 0; //@line 13211
       $149 = $$0488 >>> 0 < $$1482683 >>> 0; //@line 13212
       if ($149) {
        break;
       } else {
        $$0488671 = $$0488; //@line 13216
        $$0497670 = $143; //@line 13216
       }
      }
      $150 = ($143 | 0) == 0; //@line 13219
      if ($150) {
       $$2483 = $$1482683; //@line 13221
      } else {
       $151 = $$1482683 + -4 | 0; //@line 13223
       SAFE_HEAP_STORE($151 | 0, $143 | 0, 4);
       $$2483 = $151; //@line 13225
      }
     }
     $152 = $$2500682 >>> 0 > $$2483 >>> 0; //@line 13228
     L57 : do {
      if ($152) {
       $$3501676 = $$2500682; //@line 13231
       while (1) {
        $154 = $$3501676 + -4 | 0; //@line 13233
        $155 = SAFE_HEAP_LOAD($154 | 0, 4, 0) | 0 | 0; //@line 13234
        $156 = ($155 | 0) == 0; //@line 13235
        if (!$156) {
         $$3501$lcssa = $$3501676; //@line 13237
         break L57;
        }
        $153 = $154 >>> 0 > $$2483 >>> 0; //@line 13240
        if ($153) {
         $$3501676 = $154; //@line 13242
        } else {
         $$3501$lcssa = $154; //@line 13244
         break;
        }
       }
      } else {
       $$3501$lcssa = $$2500682; //@line 13249
      }
     } while (0);
     $157 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 13252
     $158 = $157 - $136 | 0; //@line 13253
     SAFE_HEAP_STORE($7 | 0, $158 | 0, 4);
     $159 = ($158 | 0) > 0; //@line 13255
     if ($159) {
      $$1482683 = $$2483; //@line 13257
      $$2500682 = $$3501$lcssa; //@line 13257
      $135 = $158; //@line 13257
     } else {
      $$1482$lcssa = $$2483; //@line 13259
      $$2500$lcssa = $$3501$lcssa; //@line 13259
      $$pr564 = $158; //@line 13259
      break;
     }
    }
   } else {
    $$1482$lcssa = $$0498; //@line 13264
    $$2500$lcssa = $127; //@line 13264
    $$pr564 = $$pr; //@line 13264
   }
   $160 = ($$pr564 | 0) < 0; //@line 13266
   if ($160) {
    $161 = $spec$select539 + 25 | 0; //@line 13268
    $162 = ($161 | 0) / 9 & -1; //@line 13269
    $163 = $162 + 1 | 0; //@line 13270
    $164 = ($42 | 0) == 102; //@line 13271
    $$3484663 = $$1482$lcssa; //@line 13272
    $$4502662 = $$2500$lcssa; //@line 13272
    $166 = $$pr564; //@line 13272
    while (1) {
     $165 = 0 - $166 | 0; //@line 13274
     $167 = ($165 | 0) < 9; //@line 13275
     $168 = $167 ? $165 : 9; //@line 13276
     $169 = $$3484663 >>> 0 < $$4502662 >>> 0; //@line 13277
     if ($169) {
      $173 = 1 << $168; //@line 13279
      $174 = $173 + -1 | 0; //@line 13280
      $175 = 1e9 >>> $168; //@line 13281
      $$0487657 = 0; //@line 13282
      $$1489656 = $$3484663; //@line 13282
      while (1) {
       $176 = SAFE_HEAP_LOAD($$1489656 | 0, 4, 0) | 0 | 0; //@line 13284
       $177 = $176 & $174; //@line 13285
       $178 = $176 >>> $168; //@line 13286
       $179 = $178 + $$0487657 | 0; //@line 13287
       SAFE_HEAP_STORE($$1489656 | 0, $179 | 0, 4);
       $180 = Math_imul($177, $175) | 0; //@line 13289
       $181 = $$1489656 + 4 | 0; //@line 13290
       $182 = $181 >>> 0 < $$4502662 >>> 0; //@line 13291
       if ($182) {
        $$0487657 = $180; //@line 13293
        $$1489656 = $181; //@line 13293
       } else {
        break;
       }
      }
      $183 = SAFE_HEAP_LOAD($$3484663 | 0, 4, 0) | 0 | 0; //@line 13298
      $184 = ($183 | 0) == 0; //@line 13299
      $185 = $$3484663 + 4 | 0; //@line 13300
      $spec$select540 = $184 ? $185 : $$3484663; //@line 13301
      $186 = ($180 | 0) == 0; //@line 13302
      if ($186) {
       $$5503 = $$4502662; //@line 13304
       $spec$select540723 = $spec$select540; //@line 13304
      } else {
       $187 = $$4502662 + 4 | 0; //@line 13306
       SAFE_HEAP_STORE($$4502662 | 0, $180 | 0, 4);
       $$5503 = $187; //@line 13308
       $spec$select540723 = $spec$select540; //@line 13308
      }
     } else {
      $170 = SAFE_HEAP_LOAD($$3484663 | 0, 4, 0) | 0 | 0; //@line 13311
      $171 = ($170 | 0) == 0; //@line 13312
      $172 = $$3484663 + 4 | 0; //@line 13313
      $spec$select540722 = $171 ? $172 : $$3484663; //@line 13314
      $$5503 = $$4502662; //@line 13315
      $spec$select540723 = $spec$select540722; //@line 13315
     }
     $188 = $164 ? $$0498 : $spec$select540723; //@line 13317
     $189 = $$5503; //@line 13318
     $190 = $188; //@line 13319
     $191 = $189 - $190 | 0; //@line 13320
     $192 = $191 >> 2; //@line 13321
     $193 = ($192 | 0) > ($163 | 0); //@line 13322
     $194 = $188 + ($163 << 2) | 0; //@line 13323
     $spec$select541 = $193 ? $194 : $$5503; //@line 13324
     $195 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 13325
     $196 = $195 + $168 | 0; //@line 13326
     SAFE_HEAP_STORE($7 | 0, $196 | 0, 4);
     $197 = ($196 | 0) < 0; //@line 13328
     if ($197) {
      $$3484663 = $spec$select540723; //@line 13330
      $$4502662 = $spec$select541; //@line 13330
      $166 = $196; //@line 13330
     } else {
      $$3484$lcssa = $spec$select540723; //@line 13332
      $$4502$lcssa = $spec$select541; //@line 13332
      break;
     }
    }
   } else {
    $$3484$lcssa = $$1482$lcssa; //@line 13337
    $$4502$lcssa = $$2500$lcssa; //@line 13337
   }
   $198 = $$3484$lcssa >>> 0 < $$4502$lcssa >>> 0; //@line 13339
   if ($198) {
    $199 = $$3484$lcssa; //@line 13341
    $200 = $132 - $199 | 0; //@line 13342
    $201 = $200 >> 2; //@line 13343
    $202 = $201 * 9 | 0; //@line 13344
    $203 = SAFE_HEAP_LOAD($$3484$lcssa | 0, 4, 0) | 0 | 0; //@line 13345
    $204 = $203 >>> 0 < 10; //@line 13346
    if ($204) {
     $$1517 = $202; //@line 13348
    } else {
     $$0516652 = $202; //@line 13350
     $$0532651 = 10; //@line 13350
     while (1) {
      $205 = $$0532651 * 10 | 0; //@line 13352
      $206 = $$0516652 + 1 | 0; //@line 13353
      $207 = $203 >>> 0 < $205 >>> 0; //@line 13354
      if ($207) {
       $$1517 = $206; //@line 13356
       break;
      } else {
       $$0516652 = $206; //@line 13359
       $$0532651 = $205; //@line 13359
      }
     }
    }
   } else {
    $$1517 = 0; //@line 13364
   }
   $208 = ($42 | 0) == 102; //@line 13366
   $209 = $208 ? 0 : $$1517; //@line 13367
   $210 = $spec$select539 - $209 | 0; //@line 13368
   $211 = ($42 | 0) == 103; //@line 13369
   $212 = ($spec$select539 | 0) != 0; //@line 13370
   $213 = $212 & $211; //@line 13371
   $$neg = $213 << 31 >> 31; //@line 13372
   $214 = $210 + $$neg | 0; //@line 13373
   $215 = $$4502$lcssa; //@line 13374
   $216 = $215 - $132 | 0; //@line 13375
   $217 = $216 >> 2; //@line 13376
   $218 = $217 * 9 | 0; //@line 13377
   $219 = $218 + -9 | 0; //@line 13378
   $220 = ($214 | 0) < ($219 | 0); //@line 13379
   if ($220) {
    $221 = $$0498 + 4 | 0; //@line 13381
    $222 = $214 + 9216 | 0; //@line 13382
    $223 = ($222 | 0) / 9 & -1; //@line 13383
    $224 = $223 + -1024 | 0; //@line 13384
    $225 = $221 + ($224 << 2) | 0; //@line 13385
    $226 = $223 * 9 | 0; //@line 13386
    $227 = $222 - $226 | 0; //@line 13387
    $228 = ($227 | 0) < 8; //@line 13388
    if ($228) {
     $$0529$in646 = $227; //@line 13390
     $$1533645 = 10; //@line 13390
     while (1) {
      $$0529 = $$0529$in646 + 1 | 0; //@line 13392
      $229 = $$1533645 * 10 | 0; //@line 13393
      $230 = ($$0529$in646 | 0) < 7; //@line 13394
      if ($230) {
       $$0529$in646 = $$0529; //@line 13396
       $$1533645 = $229; //@line 13396
      } else {
       $$1533$lcssa = $229; //@line 13398
       break;
      }
     }
    } else {
     $$1533$lcssa = 10; //@line 13403
    }
    $231 = SAFE_HEAP_LOAD($225 | 0, 4, 0) | 0 | 0; //@line 13405
    $232 = ($231 >>> 0) / ($$1533$lcssa >>> 0) & -1; //@line 13406
    $233 = Math_imul($232, $$1533$lcssa) | 0; //@line 13407
    $234 = $231 - $233 | 0; //@line 13408
    $235 = ($234 | 0) == 0; //@line 13409
    $236 = $225 + 4 | 0; //@line 13410
    $237 = ($236 | 0) == ($$4502$lcssa | 0); //@line 13411
    $or$cond543 = $237 & $235; //@line 13412
    if ($or$cond543) {
     $$4492 = $225; //@line 13414
     $$4520 = $$1517; //@line 13414
     $$8 = $$3484$lcssa; //@line 13414
    } else {
     $238 = $232 & 1; //@line 13416
     $239 = ($238 | 0) == 0; //@line 13417
     $spec$select544 = $239 ? 9007199254740992.0 : 9007199254740994.0; //@line 13418
     $240 = $$1533$lcssa >>> 1; //@line 13419
     $241 = $234 >>> 0 < $240 >>> 0; //@line 13420
     $242 = ($234 | 0) == ($240 | 0); //@line 13421
     $or$cond546 = $237 & $242; //@line 13422
     $spec$select561 = $or$cond546 ? 1.0 : 1.5; //@line 13423
     $spec$select567 = $241 ? .5 : $spec$select561; //@line 13424
     $243 = ($$0522 | 0) == 0; //@line 13425
     if ($243) {
      $$1467 = $spec$select567; //@line 13427
      $$1469 = $spec$select544; //@line 13427
     } else {
      $244 = SAFE_HEAP_LOAD($$0523 >> 0 | 0, 1, 0) | 0 | 0; //@line 13429
      $245 = $244 << 24 >> 24 == 45; //@line 13430
      $246 = -$spec$select544; //@line 13431
      $247 = -$spec$select567; //@line 13432
      $spec$select568 = $245 ? $246 : $spec$select544; //@line 13433
      $spec$select569 = $245 ? $247 : $spec$select567; //@line 13434
      $$1467 = $spec$select569; //@line 13435
      $$1469 = $spec$select568; //@line 13435
     }
     $248 = $231 - $234 | 0; //@line 13437
     SAFE_HEAP_STORE($225 | 0, $248 | 0, 4);
     $249 = $$1469 + $$1467; //@line 13439
     $250 = $249 != $$1469; //@line 13440
     if ($250) {
      $251 = $248 + $$1533$lcssa | 0; //@line 13442
      SAFE_HEAP_STORE($225 | 0, $251 | 0, 4);
      $252 = $251 >>> 0 > 999999999; //@line 13444
      if ($252) {
       $$2490638 = $225; //@line 13446
       $$5486639 = $$3484$lcssa; //@line 13446
       while (1) {
        $253 = $$2490638 + -4 | 0; //@line 13448
        SAFE_HEAP_STORE($$2490638 | 0, 0 | 0, 4);
        $254 = $253 >>> 0 < $$5486639 >>> 0; //@line 13450
        if ($254) {
         $255 = $$5486639 + -4 | 0; //@line 13452
         SAFE_HEAP_STORE($255 | 0, 0 | 0, 4);
         $$6 = $255; //@line 13454
        } else {
         $$6 = $$5486639; //@line 13456
        }
        $256 = SAFE_HEAP_LOAD($253 | 0, 4, 0) | 0 | 0; //@line 13458
        $257 = $256 + 1 | 0; //@line 13459
        SAFE_HEAP_STORE($253 | 0, $257 | 0, 4);
        $258 = $257 >>> 0 > 999999999; //@line 13461
        if ($258) {
         $$2490638 = $253; //@line 13463
         $$5486639 = $$6; //@line 13463
        } else {
         $$2490$lcssa = $253; //@line 13465
         $$5486$lcssa = $$6; //@line 13465
         break;
        }
       }
      } else {
       $$2490$lcssa = $225; //@line 13470
       $$5486$lcssa = $$3484$lcssa; //@line 13470
      }
      $259 = $$5486$lcssa; //@line 13472
      $260 = $132 - $259 | 0; //@line 13473
      $261 = $260 >> 2; //@line 13474
      $262 = $261 * 9 | 0; //@line 13475
      $263 = SAFE_HEAP_LOAD($$5486$lcssa | 0, 4, 0) | 0 | 0; //@line 13476
      $264 = $263 >>> 0 < 10; //@line 13477
      if ($264) {
       $$4492 = $$2490$lcssa; //@line 13479
       $$4520 = $262; //@line 13479
       $$8 = $$5486$lcssa; //@line 13479
      } else {
       $$2518634 = $262; //@line 13481
       $$2534633 = 10; //@line 13481
       while (1) {
        $265 = $$2534633 * 10 | 0; //@line 13483
        $266 = $$2518634 + 1 | 0; //@line 13484
        $267 = $263 >>> 0 < $265 >>> 0; //@line 13485
        if ($267) {
         $$4492 = $$2490$lcssa; //@line 13487
         $$4520 = $266; //@line 13487
         $$8 = $$5486$lcssa; //@line 13487
         break;
        } else {
         $$2518634 = $266; //@line 13490
         $$2534633 = $265; //@line 13490
        }
       }
      }
     } else {
      $$4492 = $225; //@line 13495
      $$4520 = $$1517; //@line 13495
      $$8 = $$3484$lcssa; //@line 13495
     }
    }
    $268 = $$4492 + 4 | 0; //@line 13498
    $269 = $$4502$lcssa >>> 0 > $268 >>> 0; //@line 13499
    $spec$select547 = $269 ? $268 : $$4502$lcssa; //@line 13500
    $$5521 = $$4520; //@line 13501
    $$8506 = $spec$select547; //@line 13501
    $$9 = $$8; //@line 13501
   } else {
    $$5521 = $$1517; //@line 13503
    $$8506 = $$4502$lcssa; //@line 13503
    $$9 = $$3484$lcssa; //@line 13503
   }
   $270 = 0 - $$5521 | 0; //@line 13505
   $271 = $$8506 >>> 0 > $$9 >>> 0; //@line 13506
   L109 : do {
    if ($271) {
     $$9507625 = $$8506; //@line 13509
     while (1) {
      $273 = $$9507625 + -4 | 0; //@line 13511
      $274 = SAFE_HEAP_LOAD($273 | 0, 4, 0) | 0 | 0; //@line 13512
      $275 = ($274 | 0) == 0; //@line 13513
      if (!$275) {
       $$9507$lcssa = $$9507625; //@line 13515
       $$lcssa583 = 1; //@line 13515
       break L109;
      }
      $272 = $273 >>> 0 > $$9 >>> 0; //@line 13518
      if ($272) {
       $$9507625 = $273; //@line 13520
      } else {
       $$9507$lcssa = $273; //@line 13522
       $$lcssa583 = 0; //@line 13522
       break;
      }
     }
    } else {
     $$9507$lcssa = $$8506; //@line 13527
     $$lcssa583 = 0; //@line 13527
    }
   } while (0);
   do {
    if ($211) {
     $not$ = $212 ^ 1; //@line 13532
     $276 = $not$ & 1; //@line 13533
     $spec$select548 = $spec$select539 + $276 | 0; //@line 13534
     $277 = ($spec$select548 | 0) > ($$5521 | 0); //@line 13535
     $278 = ($$5521 | 0) > -5; //@line 13536
     $or$cond6 = $277 & $278; //@line 13537
     if ($or$cond6) {
      $279 = $5 + -1 | 0; //@line 13539
      $$neg571 = $spec$select548 + -1 | 0; //@line 13540
      $280 = $$neg571 - $$5521 | 0; //@line 13541
      $$0479 = $279; //@line 13542
      $$2476 = $280; //@line 13542
     } else {
      $281 = $5 + -2 | 0; //@line 13544
      $282 = $spec$select548 + -1 | 0; //@line 13545
      $$0479 = $281; //@line 13546
      $$2476 = $282; //@line 13546
     }
     $283 = $4 & 8; //@line 13548
     $284 = ($283 | 0) == 0; //@line 13549
     if ($284) {
      if ($$lcssa583) {
       $285 = $$9507$lcssa + -4 | 0; //@line 13552
       $286 = SAFE_HEAP_LOAD($285 | 0, 4, 0) | 0 | 0; //@line 13553
       $287 = ($286 | 0) == 0; //@line 13554
       if ($287) {
        $$2531 = 9; //@line 13556
       } else {
        $288 = ($286 >>> 0) % 10 & -1; //@line 13558
        $289 = ($288 | 0) == 0; //@line 13559
        if ($289) {
         $$1530621 = 0; //@line 13561
         $$3535620 = 10; //@line 13561
         while (1) {
          $290 = $$3535620 * 10 | 0; //@line 13563
          $291 = $$1530621 + 1 | 0; //@line 13564
          $292 = ($286 >>> 0) % ($290 >>> 0) & -1; //@line 13565
          $293 = ($292 | 0) == 0; //@line 13566
          if ($293) {
           $$1530621 = $291; //@line 13568
           $$3535620 = $290; //@line 13568
          } else {
           $$2531 = $291; //@line 13570
           break;
          }
         }
        } else {
         $$2531 = 0; //@line 13575
        }
       }
      } else {
       $$2531 = 9; //@line 13579
      }
      $294 = $$0479 | 32; //@line 13581
      $295 = ($294 | 0) == 102; //@line 13582
      $296 = $$9507$lcssa; //@line 13583
      $297 = $296 - $132 | 0; //@line 13584
      $298 = $297 >> 2; //@line 13585
      $299 = $298 * 9 | 0; //@line 13586
      $300 = $299 + -9 | 0; //@line 13587
      if ($295) {
       $301 = $300 - $$2531 | 0; //@line 13589
       $302 = ($301 | 0) > 0; //@line 13590
       $spec$select549 = $302 ? $301 : 0; //@line 13591
       $303 = ($$2476 | 0) < ($spec$select549 | 0); //@line 13592
       $spec$select562 = $303 ? $$2476 : $spec$select549; //@line 13593
       $$1480 = $$0479; //@line 13594
       $$3477 = $spec$select562; //@line 13594
       break;
      } else {
       $304 = $300 + $$5521 | 0; //@line 13597
       $305 = $304 - $$2531 | 0; //@line 13598
       $306 = ($305 | 0) > 0; //@line 13599
       $spec$select551 = $306 ? $305 : 0; //@line 13600
       $307 = ($$2476 | 0) < ($spec$select551 | 0); //@line 13601
       $spec$select563 = $307 ? $$2476 : $spec$select551; //@line 13602
       $$1480 = $$0479; //@line 13603
       $$3477 = $spec$select563; //@line 13603
       break;
      }
     } else {
      $$1480 = $$0479; //@line 13607
      $$3477 = $$2476; //@line 13607
     }
    } else {
     $$1480 = $5; //@line 13610
     $$3477 = $spec$select539; //@line 13610
    }
   } while (0);
   $308 = ($$3477 | 0) != 0; //@line 13613
   $309 = $4 >>> 3; //@line 13614
   $$lobit = $309 & 1; //@line 13615
   $310 = $308 ? 1 : $$lobit; //@line 13616
   $311 = $$1480 | 32; //@line 13617
   $312 = ($311 | 0) == 102; //@line 13618
   if ($312) {
    $313 = ($$5521 | 0) > 0; //@line 13620
    $314 = $313 ? $$5521 : 0; //@line 13621
    $$2515 = 0; //@line 13622
    $$pn = $314; //@line 13622
   } else {
    $315 = ($$5521 | 0) < 0; //@line 13624
    $316 = $315 ? $270 : $$5521; //@line 13625
    $317 = ($316 | 0) < 0; //@line 13626
    $318 = $317 << 31 >> 31; //@line 13627
    $319 = _fmt_u($316, $318, $11) | 0; //@line 13628
    $320 = $11; //@line 13629
    $321 = $319; //@line 13630
    $322 = $320 - $321 | 0; //@line 13631
    $323 = ($322 | 0) < 2; //@line 13632
    if ($323) {
     $$1514614 = $319; //@line 13634
     while (1) {
      $324 = $$1514614 + -1 | 0; //@line 13636
      SAFE_HEAP_STORE($324 >> 0 | 0, 48 | 0, 1);
      $325 = $324; //@line 13638
      $326 = $320 - $325 | 0; //@line 13639
      $327 = ($326 | 0) < 2; //@line 13640
      if ($327) {
       $$1514614 = $324; //@line 13642
      } else {
       $$1514$lcssa = $324; //@line 13644
       break;
      }
     }
    } else {
     $$1514$lcssa = $319; //@line 13649
    }
    $328 = $$5521 >> 31; //@line 13651
    $329 = $328 & 2; //@line 13652
    $330 = $329 + 43 | 0; //@line 13653
    $331 = $330 & 255; //@line 13654
    $332 = $$1514$lcssa + -1 | 0; //@line 13655
    SAFE_HEAP_STORE($332 >> 0 | 0, $331 | 0, 1);
    $333 = $$1480 & 255; //@line 13657
    $334 = $$1514$lcssa + -2 | 0; //@line 13658
    SAFE_HEAP_STORE($334 >> 0 | 0, $333 | 0, 1);
    $335 = $334; //@line 13660
    $336 = $320 - $335 | 0; //@line 13661
    $$2515 = $334; //@line 13662
    $$pn = $336; //@line 13662
   }
   $337 = $$0522 + 1 | 0; //@line 13664
   $338 = $337 + $$3477 | 0; //@line 13665
   $$1528 = $338 + $310 | 0; //@line 13666
   $339 = $$1528 + $$pn | 0; //@line 13667
   _pad_661($0, 32, $2, $339, $4); //@line 13668
   _out_655($0, $$0523, $$0522); //@line 13669
   $340 = $4 ^ 65536; //@line 13670
   _pad_661($0, 48, $2, $339, $340); //@line 13671
   if ($312) {
    $341 = $$9 >>> 0 > $$0498 >>> 0; //@line 13673
    $spec$select554 = $341 ? $$0498 : $$9; //@line 13674
    $342 = $8 + 9 | 0; //@line 13675
    $343 = $342; //@line 13676
    $344 = $8 + 8 | 0; //@line 13677
    $$5493603 = $spec$select554; //@line 13678
    while (1) {
     $345 = SAFE_HEAP_LOAD($$5493603 | 0, 4, 0) | 0 | 0; //@line 13680
     $346 = _fmt_u($345, 0, $342) | 0; //@line 13681
     $347 = ($$5493603 | 0) == ($spec$select554 | 0); //@line 13682
     if ($347) {
      $353 = ($346 | 0) == ($342 | 0); //@line 13684
      if ($353) {
       SAFE_HEAP_STORE($344 >> 0 | 0, 48 | 0, 1);
       $$1465 = $344; //@line 13687
      } else {
       $$1465 = $346; //@line 13689
      }
     } else {
      $348 = $346 >>> 0 > $8 >>> 0; //@line 13692
      if ($348) {
       $349 = $346; //@line 13694
       $350 = $349 - $9 | 0; //@line 13695
       _memset($8 | 0, 48, $350 | 0) | 0; //@line 13696
       $$0464599 = $346; //@line 13697
       while (1) {
        $351 = $$0464599 + -1 | 0; //@line 13699
        $352 = $351 >>> 0 > $8 >>> 0; //@line 13700
        if ($352) {
         $$0464599 = $351; //@line 13702
        } else {
         $$1465 = $351; //@line 13704
         break;
        }
       }
      } else {
       $$1465 = $346; //@line 13709
      }
     }
     $354 = $$1465; //@line 13712
     $355 = $343 - $354 | 0; //@line 13713
     _out_655($0, $$1465, $355); //@line 13714
     $356 = $$5493603 + 4 | 0; //@line 13715
     $357 = $356 >>> 0 > $$0498 >>> 0; //@line 13716
     if ($357) {
      break;
     } else {
      $$5493603 = $356; //@line 13720
     }
    }
    $$not = $308 ^ 1; //@line 13723
    $358 = $4 & 8; //@line 13724
    $359 = ($358 | 0) == 0; //@line 13725
    $or$cond556 = $359 & $$not; //@line 13726
    if (!$or$cond556) {
     _out_655($0, 10182, 1); //@line 13728
    }
    $360 = $356 >>> 0 < $$9507$lcssa >>> 0; //@line 13730
    $361 = ($$3477 | 0) > 0; //@line 13731
    $362 = $360 & $361; //@line 13732
    if ($362) {
     $$4478594 = $$3477; //@line 13734
     $$6494593 = $356; //@line 13734
     while (1) {
      $363 = SAFE_HEAP_LOAD($$6494593 | 0, 4, 0) | 0 | 0; //@line 13736
      $364 = _fmt_u($363, 0, $342) | 0; //@line 13737
      $365 = $364 >>> 0 > $8 >>> 0; //@line 13738
      if ($365) {
       $366 = $364; //@line 13740
       $367 = $366 - $9 | 0; //@line 13741
       _memset($8 | 0, 48, $367 | 0) | 0; //@line 13742
       $$0463588 = $364; //@line 13743
       while (1) {
        $368 = $$0463588 + -1 | 0; //@line 13745
        $369 = $368 >>> 0 > $8 >>> 0; //@line 13746
        if ($369) {
         $$0463588 = $368; //@line 13748
        } else {
         $$0463$lcssa = $368; //@line 13750
         break;
        }
       }
      } else {
       $$0463$lcssa = $364; //@line 13755
      }
      $370 = ($$4478594 | 0) < 9; //@line 13757
      $371 = $370 ? $$4478594 : 9; //@line 13758
      _out_655($0, $$0463$lcssa, $371); //@line 13759
      $372 = $$6494593 + 4 | 0; //@line 13760
      $373 = $$4478594 + -9 | 0; //@line 13761
      $374 = $372 >>> 0 < $$9507$lcssa >>> 0; //@line 13762
      $375 = ($$4478594 | 0) > 9; //@line 13763
      $376 = $374 & $375; //@line 13764
      if ($376) {
       $$4478594 = $373; //@line 13766
       $$6494593 = $372; //@line 13766
      } else {
       $$4478$lcssa = $373; //@line 13768
       break;
      }
     }
    } else {
     $$4478$lcssa = $$3477; //@line 13773
    }
    $377 = $$4478$lcssa + 9 | 0; //@line 13775
    _pad_661($0, 48, $377, 9, 0); //@line 13776
   } else {
    $378 = $$9 + 4 | 0; //@line 13778
    $spec$select557 = $$lcssa583 ? $$9507$lcssa : $378; //@line 13779
    $379 = $$9 >>> 0 < $spec$select557 >>> 0; //@line 13780
    $380 = ($$3477 | 0) > -1; //@line 13781
    $381 = $379 & $380; //@line 13782
    if ($381) {
     $382 = $8 + 9 | 0; //@line 13784
     $383 = $4 & 8; //@line 13785
     $384 = ($383 | 0) == 0; //@line 13786
     $385 = $382; //@line 13787
     $386 = 0 - $9 | 0; //@line 13788
     $387 = $8 + 8 | 0; //@line 13789
     $$5609 = $$3477; //@line 13790
     $$7495608 = $$9; //@line 13790
     while (1) {
      $388 = SAFE_HEAP_LOAD($$7495608 | 0, 4, 0) | 0 | 0; //@line 13792
      $389 = _fmt_u($388, 0, $382) | 0; //@line 13793
      $390 = ($389 | 0) == ($382 | 0); //@line 13794
      if ($390) {
       SAFE_HEAP_STORE($387 >> 0 | 0, 48 | 0, 1);
       $$0 = $387; //@line 13797
      } else {
       $$0 = $389; //@line 13799
      }
      $391 = ($$7495608 | 0) == ($$9 | 0); //@line 13801
      do {
       if ($391) {
        $395 = $$0 + 1 | 0; //@line 13804
        _out_655($0, $$0, 1); //@line 13805
        $396 = ($$5609 | 0) < 1; //@line 13806
        $or$cond559 = $384 & $396; //@line 13807
        if ($or$cond559) {
         $$2 = $395; //@line 13809
         break;
        }
        _out_655($0, 10182, 1); //@line 13812
        $$2 = $395; //@line 13813
       } else {
        $392 = $$0 >>> 0 > $8 >>> 0; //@line 13815
        if (!$392) {
         $$2 = $$0; //@line 13817
         break;
        }
        $scevgep711 = $$0 + $386 | 0; //@line 13820
        $scevgep711712 = $scevgep711; //@line 13821
        _memset($8 | 0, 48, $scevgep711712 | 0) | 0; //@line 13822
        $$1604 = $$0; //@line 13823
        while (1) {
         $393 = $$1604 + -1 | 0; //@line 13825
         $394 = $393 >>> 0 > $8 >>> 0; //@line 13826
         if ($394) {
          $$1604 = $393; //@line 13828
         } else {
          $$2 = $393; //@line 13830
          break;
         }
        }
       }
      } while (0);
      $397 = $$2; //@line 13836
      $398 = $385 - $397 | 0; //@line 13837
      $399 = ($$5609 | 0) > ($398 | 0); //@line 13838
      $400 = $399 ? $398 : $$5609; //@line 13839
      _out_655($0, $$2, $400); //@line 13840
      $401 = $$5609 - $398 | 0; //@line 13841
      $402 = $$7495608 + 4 | 0; //@line 13842
      $403 = $402 >>> 0 < $spec$select557 >>> 0; //@line 13843
      $404 = ($401 | 0) > -1; //@line 13844
      $405 = $403 & $404; //@line 13845
      if ($405) {
       $$5609 = $401; //@line 13847
       $$7495608 = $402; //@line 13847
      } else {
       $$5$lcssa = $401; //@line 13849
       break;
      }
     }
    } else {
     $$5$lcssa = $$3477; //@line 13854
    }
    $406 = $$5$lcssa + 18 | 0; //@line 13856
    _pad_661($0, 48, $406, 18, 0); //@line 13857
    $407 = $11; //@line 13858
    $408 = $$2515; //@line 13859
    $409 = $407 - $408 | 0; //@line 13860
    _out_655($0, $$2515, $409); //@line 13861
   }
   $410 = $4 ^ 8192; //@line 13863
   _pad_661($0, 32, $2, $339, $410); //@line 13864
   $$sink757 = $339; //@line 13865
  }
 } while (0);
 $411 = ($$sink757 | 0) < ($2 | 0); //@line 13868
 $$560 = $411 ? $2 : $$sink757; //@line 13869
 STACKTOP = sp; //@line 13870
 return $$560 | 0; //@line 13870
}
function _printf_core($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 11479
 $1 = $1 | 0; //@line 11480
 $2 = $2 | 0; //@line 11481
 $3 = $3 | 0; //@line 11482
 $4 = $4 | 0; //@line 11483
 var $$ = 0, $$0 = 0, $$0228 = 0, $$0229334 = 0, $$0232 = 0, $$0235 = 0, $$0237 = 0, $$0240313 = 0, $$0240313371 = 0, $$0240333 = 0, $$0243 = 0, $$0243$ph = 0, $$0243$ph$be = 0, $$0247 = 0, $$0247$ph = 0, $$0249$lcssa = 0, $$0249321 = 0, $$0252 = 0, $$0253 = 0, $$0254 = 0; //@line 11484
 var $$0259 = 0, $$0262$lcssa = 0, $$0262328 = 0, $$0269$ph = 0, $$1 = 0, $$1230340 = 0, $$1233 = 0, $$1236 = 0, $$1238 = 0, $$1241339 = 0, $$1248 = 0, $$1250 = 0, $$1255 = 0, $$1260 = 0, $$1263 = 0, $$1270 = 0, $$2 = 0, $$2234 = 0, $$2239 = 0, $$2242320 = 0; //@line 11485
 var $$2256 = 0, $$2256$ = 0, $$2261 = 0, $$2271 = 0, $$3257 = 0, $$3265 = 0, $$3272 = 0, $$3317 = 0, $$4258370 = 0, $$4266 = 0, $$5 = 0, $$6268 = 0, $$lcssa308 = 0, $$pre = 0, $$pre$phiZ2D = 0, $$pre360 = 0, $$pre362 = 0, $$pre363 = 0, $$pre363$pre = 0, $$pre364 = 0; //@line 11486
 var $$pre368 = 0, $$sink = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0; //@line 11487
 var $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0; //@line 11488
 var $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0; //@line 11489
 var $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0; //@line 11490
 var $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0; //@line 11491
 var $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0; //@line 11492
 var $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0; //@line 11493
 var $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0; //@line 11494
 var $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0, $260 = 0; //@line 11495
 var $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0; //@line 11496
 var $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0, $297 = 0; //@line 11497
 var $298 = 0, $299 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0, $311 = 0, $312 = 0, $313 = 0, $314 = 0, $315 = 0; //@line 11498
 var $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0, $329 = 0, $33 = 0, $330 = 0, $331 = 0, $332 = 0, $333 = 0; //@line 11499
 var $334 = 0, $335 = 0, $336 = 0.0, $337 = 0, $338 = 0, $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0, $344 = 0, $345 = 0, $346 = 0, $347 = 0, $348 = 0, $349 = 0, $35 = 0, $350 = 0, $351 = 0; //@line 11500
 var $352 = 0, $353 = 0, $354 = 0, $355 = 0, $356 = 0, $357 = 0, $358 = 0, $359 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0; //@line 11501
 var $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0; //@line 11502
 var $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0; //@line 11503
 var $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $arglist_current = 0, $arglist_current2 = 0, $arglist_next = 0; //@line 11504
 var $arglist_next3 = 0, $brmerge = 0, $brmerge326 = 0, $expanded = 0, $expanded10 = 0, $expanded11 = 0, $expanded13 = 0, $expanded14 = 0, $expanded15 = 0, $expanded4 = 0, $expanded6 = 0, $expanded7 = 0, $expanded8 = 0, $or$cond = 0, $or$cond276 = 0, $or$cond278 = 0, $or$cond283 = 0, $spec$select = 0, $spec$select281 = 0, $spec$select284 = 0; //@line 11505
 var $spec$select291 = 0, $spec$select292 = 0, $spec$select293 = 0, $spec$select294 = 0, $spec$select295 = 0, $spec$select296 = 0, $spec$select297 = 0, $spec$select298 = 0, $spec$select299 = 0, $storemerge273$lcssa = 0, $storemerge273327 = 0, $storemerge274 = 0, $trunc = 0, label = 0, sp = 0; //@line 11506
 sp = STACKTOP; //@line 11507
 STACKTOP = STACKTOP + 64 | 0; //@line 11508
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 11508
 $5 = sp + 56 | 0; //@line 11509
 $6 = sp + 40 | 0; //@line 11510
 $7 = sp; //@line 11511
 $8 = sp + 48 | 0; //@line 11512
 $9 = sp + 60 | 0; //@line 11513
 SAFE_HEAP_STORE($5 | 0, $1 | 0, 4);
 $10 = ($0 | 0) != (0 | 0); //@line 11515
 $11 = $7 + 40 | 0; //@line 11516
 $12 = $11; //@line 11517
 $13 = $7 + 39 | 0; //@line 11518
 $14 = $8 + 4 | 0; //@line 11519
 $$0243$ph = 0; //@line 11520
 $$0247$ph = 0; //@line 11520
 $$0269$ph = 0; //@line 11520
 L1 : while (1) {
  $$0243 = $$0243$ph; //@line 11522
  $$0247 = $$0247$ph; //@line 11522
  while (1) {
   $15 = ($$0247 | 0) > -1; //@line 11524
   do {
    if ($15) {
     $16 = 2147483647 - $$0247 | 0; //@line 11527
     $17 = ($$0243 | 0) > ($16 | 0); //@line 11528
     if ($17) {
      $18 = ___errno_location() | 0; //@line 11530
      SAFE_HEAP_STORE($18 | 0, 75 | 0, 4);
      $$1248 = -1; //@line 11532
      break;
     } else {
      $19 = $$0243 + $$0247 | 0; //@line 11535
      $$1248 = $19; //@line 11536
      break;
     }
    } else {
     $$1248 = $$0247; //@line 11540
    }
   } while (0);
   $20 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 11543
   $21 = SAFE_HEAP_LOAD($20 >> 0 | 0, 1, 0) | 0 | 0; //@line 11544
   $22 = $21 << 24 >> 24 == 0; //@line 11545
   if ($22) {
    label = 94; //@line 11547
    break L1;
   }
   $23 = $21; //@line 11550
   $25 = $20; //@line 11550
   L12 : while (1) {
    switch ($23 << 24 >> 24) {
    case 37:
     {
      label = 10; //@line 11554
      break L12;
      break;
     }
    case 0:
     {
      $$0249$lcssa = $25; //@line 11559
      break L12;
      break;
     }
    default:
     {}
    }
    $24 = $25 + 1 | 0; //@line 11566
    SAFE_HEAP_STORE($5 | 0, $24 | 0, 4);
    $$pre = SAFE_HEAP_LOAD($24 >> 0 | 0, 1, 0) | 0 | 0; //@line 11568
    $23 = $$pre; //@line 11569
    $25 = $24; //@line 11569
   }
   L15 : do {
    if ((label | 0) == 10) {
     label = 0; //@line 11573
     $$0249321 = $25; //@line 11574
     $27 = $25; //@line 11574
     while (1) {
      $26 = $27 + 1 | 0; //@line 11576
      $28 = SAFE_HEAP_LOAD($26 >> 0 | 0, 1, 0) | 0 | 0; //@line 11577
      $29 = $28 << 24 >> 24 == 37; //@line 11578
      if (!$29) {
       $$0249$lcssa = $$0249321; //@line 11580
       break L15;
      }
      $30 = $$0249321 + 1 | 0; //@line 11583
      $31 = $27 + 2 | 0; //@line 11584
      SAFE_HEAP_STORE($5 | 0, $31 | 0, 4);
      $32 = SAFE_HEAP_LOAD($31 >> 0 | 0, 1, 0) | 0 | 0; //@line 11586
      $33 = $32 << 24 >> 24 == 37; //@line 11587
      if ($33) {
       $$0249321 = $30; //@line 11589
       $27 = $31; //@line 11589
      } else {
       $$0249$lcssa = $30; //@line 11591
       break;
      }
     }
    }
   } while (0);
   $34 = $$0249$lcssa; //@line 11597
   $35 = $20; //@line 11598
   $36 = $34 - $35 | 0; //@line 11599
   if ($10) {
    _out_655($0, $20, $36); //@line 11601
   }
   $37 = ($36 | 0) == 0; //@line 11603
   if ($37) {
    break;
   } else {
    $$0243 = $36; //@line 11607
    $$0247 = $$1248; //@line 11607
   }
  }
  $38 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 11610
  $39 = $38 + 1 | 0; //@line 11611
  $40 = SAFE_HEAP_LOAD($39 >> 0 | 0, 1, 0) | 0 | 0; //@line 11612
  $41 = $40 << 24 >> 24; //@line 11613
  $42 = _isdigit($41) | 0; //@line 11614
  $43 = ($42 | 0) == 0; //@line 11615
  $$pre360 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 11616
  if ($43) {
   $$0253 = -1; //@line 11618
   $$1270 = $$0269$ph; //@line 11618
   $$sink = 1; //@line 11618
  } else {
   $44 = $$pre360 + 2 | 0; //@line 11620
   $45 = SAFE_HEAP_LOAD($44 >> 0 | 0, 1, 0) | 0 | 0; //@line 11621
   $46 = $45 << 24 >> 24 == 36; //@line 11622
   if ($46) {
    $47 = $$pre360 + 1 | 0; //@line 11624
    $48 = SAFE_HEAP_LOAD($47 >> 0 | 0, 1, 0) | 0 | 0; //@line 11625
    $49 = $48 << 24 >> 24; //@line 11626
    $50 = $49 + -48 | 0; //@line 11627
    $$0253 = $50; //@line 11628
    $$1270 = 1; //@line 11628
    $$sink = 3; //@line 11628
   } else {
    $$0253 = -1; //@line 11630
    $$1270 = $$0269$ph; //@line 11630
    $$sink = 1; //@line 11630
   }
  }
  $51 = $$pre360 + $$sink | 0; //@line 11633
  SAFE_HEAP_STORE($5 | 0, $51 | 0, 4);
  $52 = SAFE_HEAP_LOAD($51 >> 0 | 0, 1, 0) | 0 | 0; //@line 11635
  $53 = $52 << 24 >> 24; //@line 11636
  $54 = $53 + -32 | 0; //@line 11637
  $55 = $54 >>> 0 > 31; //@line 11638
  $56 = 1 << $54; //@line 11639
  $57 = $56 & 75913; //@line 11640
  $58 = ($57 | 0) == 0; //@line 11641
  $brmerge326 = $55 | $58; //@line 11642
  if ($brmerge326) {
   $$0262$lcssa = 0; //@line 11644
   $$lcssa308 = $52; //@line 11644
   $storemerge273$lcssa = $51; //@line 11644
  } else {
   $$0262328 = 0; //@line 11646
   $60 = $54; //@line 11646
   $storemerge273327 = $51; //@line 11646
   while (1) {
    $59 = 1 << $60; //@line 11648
    $61 = $59 | $$0262328; //@line 11649
    $62 = $storemerge273327 + 1 | 0; //@line 11650
    SAFE_HEAP_STORE($5 | 0, $62 | 0, 4);
    $63 = SAFE_HEAP_LOAD($62 >> 0 | 0, 1, 0) | 0 | 0; //@line 11652
    $64 = $63 << 24 >> 24; //@line 11653
    $65 = $64 + -32 | 0; //@line 11654
    $66 = $65 >>> 0 > 31; //@line 11655
    $67 = 1 << $65; //@line 11656
    $68 = $67 & 75913; //@line 11657
    $69 = ($68 | 0) == 0; //@line 11658
    $brmerge = $66 | $69; //@line 11659
    if ($brmerge) {
     $$0262$lcssa = $61; //@line 11661
     $$lcssa308 = $63; //@line 11661
     $storemerge273$lcssa = $62; //@line 11661
     break;
    } else {
     $$0262328 = $61; //@line 11664
     $60 = $65; //@line 11664
     $storemerge273327 = $62; //@line 11664
    }
   }
  }
  $70 = $$lcssa308 << 24 >> 24 == 42; //@line 11668
  if ($70) {
   $71 = $storemerge273$lcssa + 1 | 0; //@line 11670
   $72 = SAFE_HEAP_LOAD($71 >> 0 | 0, 1, 0) | 0 | 0; //@line 11671
   $73 = $72 << 24 >> 24; //@line 11672
   $74 = _isdigit($73) | 0; //@line 11673
   $75 = ($74 | 0) == 0; //@line 11674
   if ($75) {
    label = 27; //@line 11676
   } else {
    $76 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 11678
    $77 = $76 + 2 | 0; //@line 11679
    $78 = SAFE_HEAP_LOAD($77 >> 0 | 0, 1, 0) | 0 | 0; //@line 11680
    $79 = $78 << 24 >> 24 == 36; //@line 11681
    if ($79) {
     $80 = $76 + 1 | 0; //@line 11683
     $81 = SAFE_HEAP_LOAD($80 >> 0 | 0, 1, 0) | 0 | 0; //@line 11684
     $82 = $81 << 24 >> 24; //@line 11685
     $83 = $82 + -48 | 0; //@line 11686
     $84 = $4 + ($83 << 2) | 0; //@line 11687
     SAFE_HEAP_STORE($84 | 0, 10 | 0, 4);
     $85 = SAFE_HEAP_LOAD($80 >> 0 | 0, 1, 0) | 0 | 0; //@line 11689
     $86 = $85 << 24 >> 24; //@line 11690
     $87 = $86 + -48 | 0; //@line 11691
     $88 = $3 + ($87 << 3) | 0; //@line 11692
     $89 = $88; //@line 11693
     $90 = $89; //@line 11694
     $91 = SAFE_HEAP_LOAD($90 | 0, 4, 0) | 0 | 0; //@line 11695
     $92 = $89 + 4 | 0; //@line 11696
     $93 = $92; //@line 11697
     $94 = SAFE_HEAP_LOAD($93 | 0, 4, 0) | 0 | 0; //@line 11698
     $95 = $76 + 3 | 0; //@line 11699
     $$0259 = $91; //@line 11700
     $$2271 = 1; //@line 11700
     $storemerge274 = $95; //@line 11700
    } else {
     label = 27; //@line 11702
    }
   }
   if ((label | 0) == 27) {
    label = 0; //@line 11706
    $96 = ($$1270 | 0) == 0; //@line 11707
    if (!$96) {
     $$0 = -1; //@line 11709
     break;
    }
    if ($10) {
     $arglist_current = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 11713
     $97 = $arglist_current; //@line 11714
     $98 = 0 + 4 | 0; //@line 11715
     $expanded4 = $98; //@line 11716
     $expanded = $expanded4 - 1 | 0; //@line 11717
     $99 = $97 + $expanded | 0; //@line 11718
     $100 = 0 + 4 | 0; //@line 11719
     $expanded8 = $100; //@line 11720
     $expanded7 = $expanded8 - 1 | 0; //@line 11721
     $expanded6 = $expanded7 ^ -1; //@line 11722
     $101 = $99 & $expanded6; //@line 11723
     $102 = $101; //@line 11724
     $103 = SAFE_HEAP_LOAD($102 | 0, 4, 0) | 0 | 0; //@line 11725
     $arglist_next = $102 + 4 | 0; //@line 11726
     SAFE_HEAP_STORE($2 | 0, $arglist_next | 0, 4);
     $358 = $103; //@line 11728
    } else {
     $358 = 0; //@line 11730
    }
    $104 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 11732
    $105 = $104 + 1 | 0; //@line 11733
    $$0259 = $358; //@line 11734
    $$2271 = 0; //@line 11734
    $storemerge274 = $105; //@line 11734
   }
   SAFE_HEAP_STORE($5 | 0, $storemerge274 | 0, 4);
   $106 = ($$0259 | 0) < 0; //@line 11737
   $107 = $$0262$lcssa | 8192; //@line 11738
   $108 = 0 - $$0259 | 0; //@line 11739
   $spec$select291 = $106 ? $107 : $$0262$lcssa; //@line 11740
   $spec$select292 = $106 ? $108 : $$0259; //@line 11741
   $$1260 = $spec$select292; //@line 11742
   $$1263 = $spec$select291; //@line 11742
   $$3272 = $$2271; //@line 11742
   $112 = $storemerge274; //@line 11742
  } else {
   $109 = _getint_656($5) | 0; //@line 11744
   $110 = ($109 | 0) < 0; //@line 11745
   if ($110) {
    $$0 = -1; //@line 11747
    break;
   }
   $$pre362 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 11750
   $$1260 = $109; //@line 11751
   $$1263 = $$0262$lcssa; //@line 11751
   $$3272 = $$1270; //@line 11751
   $112 = $$pre362; //@line 11751
  }
  $111 = SAFE_HEAP_LOAD($112 >> 0 | 0, 1, 0) | 0 | 0; //@line 11753
  $113 = $111 << 24 >> 24 == 46; //@line 11754
  do {
   if ($113) {
    $114 = $112 + 1 | 0; //@line 11757
    $115 = SAFE_HEAP_LOAD($114 >> 0 | 0, 1, 0) | 0 | 0; //@line 11758
    $116 = $115 << 24 >> 24 == 42; //@line 11759
    if (!$116) {
     SAFE_HEAP_STORE($5 | 0, $114 | 0, 4);
     $152 = _getint_656($5) | 0; //@line 11762
     $$pre363$pre = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 11763
     $$0254 = $152; //@line 11764
     $$pre363 = $$pre363$pre; //@line 11764
     break;
    }
    $117 = $112 + 2 | 0; //@line 11767
    $118 = SAFE_HEAP_LOAD($117 >> 0 | 0, 1, 0) | 0 | 0; //@line 11768
    $119 = $118 << 24 >> 24; //@line 11769
    $120 = _isdigit($119) | 0; //@line 11770
    $121 = ($120 | 0) == 0; //@line 11771
    if (!$121) {
     $122 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 11773
     $123 = $122 + 3 | 0; //@line 11774
     $124 = SAFE_HEAP_LOAD($123 >> 0 | 0, 1, 0) | 0 | 0; //@line 11775
     $125 = $124 << 24 >> 24 == 36; //@line 11776
     if ($125) {
      $126 = $122 + 2 | 0; //@line 11778
      $127 = SAFE_HEAP_LOAD($126 >> 0 | 0, 1, 0) | 0 | 0; //@line 11779
      $128 = $127 << 24 >> 24; //@line 11780
      $129 = $128 + -48 | 0; //@line 11781
      $130 = $4 + ($129 << 2) | 0; //@line 11782
      SAFE_HEAP_STORE($130 | 0, 10 | 0, 4);
      $131 = SAFE_HEAP_LOAD($126 >> 0 | 0, 1, 0) | 0 | 0; //@line 11784
      $132 = $131 << 24 >> 24; //@line 11785
      $133 = $132 + -48 | 0; //@line 11786
      $134 = $3 + ($133 << 3) | 0; //@line 11787
      $135 = $134; //@line 11788
      $136 = $135; //@line 11789
      $137 = SAFE_HEAP_LOAD($136 | 0, 4, 0) | 0 | 0; //@line 11790
      $138 = $135 + 4 | 0; //@line 11791
      $139 = $138; //@line 11792
      $140 = SAFE_HEAP_LOAD($139 | 0, 4, 0) | 0 | 0; //@line 11793
      $141 = $122 + 4 | 0; //@line 11794
      SAFE_HEAP_STORE($5 | 0, $141 | 0, 4);
      $$0254 = $137; //@line 11796
      $$pre363 = $141; //@line 11796
      break;
     }
    }
    $142 = ($$3272 | 0) == 0; //@line 11800
    if (!$142) {
     $$0 = -1; //@line 11802
     break L1;
    }
    if ($10) {
     $arglist_current2 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 11806
     $143 = $arglist_current2; //@line 11807
     $144 = 0 + 4 | 0; //@line 11808
     $expanded11 = $144; //@line 11809
     $expanded10 = $expanded11 - 1 | 0; //@line 11810
     $145 = $143 + $expanded10 | 0; //@line 11811
     $146 = 0 + 4 | 0; //@line 11812
     $expanded15 = $146; //@line 11813
     $expanded14 = $expanded15 - 1 | 0; //@line 11814
     $expanded13 = $expanded14 ^ -1; //@line 11815
     $147 = $145 & $expanded13; //@line 11816
     $148 = $147; //@line 11817
     $149 = SAFE_HEAP_LOAD($148 | 0, 4, 0) | 0 | 0; //@line 11818
     $arglist_next3 = $148 + 4 | 0; //@line 11819
     SAFE_HEAP_STORE($2 | 0, $arglist_next3 | 0, 4);
     $359 = $149; //@line 11821
    } else {
     $359 = 0; //@line 11823
    }
    $150 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 11825
    $151 = $150 + 2 | 0; //@line 11826
    SAFE_HEAP_STORE($5 | 0, $151 | 0, 4);
    $$0254 = $359; //@line 11828
    $$pre363 = $151; //@line 11828
   } else {
    $$0254 = -1; //@line 11830
    $$pre363 = $112; //@line 11830
   }
  } while (0);
  $$0252 = 0; //@line 11833
  $154 = $$pre363; //@line 11833
  while (1) {
   $153 = SAFE_HEAP_LOAD($154 >> 0 | 0, 1, 0) | 0 | 0; //@line 11835
   $155 = $153 << 24 >> 24; //@line 11836
   $156 = $155 + -65 | 0; //@line 11837
   $157 = $156 >>> 0 > 57; //@line 11838
   if ($157) {
    $$0 = -1; //@line 11840
    break L1;
   }
   $158 = $154 + 1 | 0; //@line 11843
   SAFE_HEAP_STORE($5 | 0, $158 | 0, 4);
   $159 = SAFE_HEAP_LOAD($154 >> 0 | 0, 1, 0) | 0 | 0; //@line 11845
   $160 = $159 << 24 >> 24; //@line 11846
   $161 = $160 + -65 | 0; //@line 11847
   $162 = (192 + ($$0252 * 58 | 0) | 0) + $161 | 0; //@line 11848
   $163 = SAFE_HEAP_LOAD($162 >> 0 | 0, 1, 0) | 0 | 0; //@line 11849
   $164 = $163 & 255; //@line 11850
   $165 = $164 + -1 | 0; //@line 11851
   $166 = $165 >>> 0 < 8; //@line 11852
   if ($166) {
    $$0252 = $164; //@line 11854
    $154 = $158; //@line 11854
   } else {
    break;
   }
  }
  $167 = $163 << 24 >> 24 == 0; //@line 11859
  if ($167) {
   $$0 = -1; //@line 11861
   break;
  }
  $168 = $163 << 24 >> 24 == 19; //@line 11864
  $169 = ($$0253 | 0) > -1; //@line 11865
  do {
   if ($168) {
    if ($169) {
     $$0 = -1; //@line 11869
     break L1;
    } else {
     label = 54; //@line 11872
    }
   } else {
    if ($169) {
     $170 = $4 + ($$0253 << 2) | 0; //@line 11876
     SAFE_HEAP_STORE($170 | 0, $164 | 0, 4);
     $171 = $3 + ($$0253 << 3) | 0; //@line 11878
     $172 = $171; //@line 11879
     $173 = $172; //@line 11880
     $174 = SAFE_HEAP_LOAD($173 | 0, 4, 0) | 0 | 0; //@line 11881
     $175 = $172 + 4 | 0; //@line 11882
     $176 = $175; //@line 11883
     $177 = SAFE_HEAP_LOAD($176 | 0, 4, 0) | 0 | 0; //@line 11884
     $178 = $6; //@line 11885
     $179 = $178; //@line 11886
     SAFE_HEAP_STORE($179 | 0, $174 | 0, 4);
     $180 = $178 + 4 | 0; //@line 11888
     $181 = $180; //@line 11889
     SAFE_HEAP_STORE($181 | 0, $177 | 0, 4);
     label = 54; //@line 11891
     break;
    }
    if (!$10) {
     $$0 = 0; //@line 11895
     break L1;
    }
    _pop_arg_658($6, $164, $2); //@line 11898
    $$pre364 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 11899
    $183 = $$pre364; //@line 11900
    label = 55; //@line 11901
   }
  } while (0);
  if ((label | 0) == 54) {
   label = 0; //@line 11905
   if ($10) {
    $183 = $158; //@line 11907
    label = 55; //@line 11908
   } else {
    $$0243$ph$be = 0; //@line 11910
   }
  }
  L77 : do {
   if ((label | 0) == 55) {
    label = 0; //@line 11915
    $182 = $183 + -1 | 0; //@line 11916
    $184 = SAFE_HEAP_LOAD($182 >> 0 | 0, 1, 0) | 0 | 0; //@line 11917
    $185 = $184 << 24 >> 24; //@line 11918
    $186 = ($$0252 | 0) != 0; //@line 11919
    $187 = $185 & 15; //@line 11920
    $188 = ($187 | 0) == 3; //@line 11921
    $or$cond276 = $186 & $188; //@line 11922
    $189 = $185 & -33; //@line 11923
    $$0235 = $or$cond276 ? $189 : $185; //@line 11924
    $190 = $$1263 & 8192; //@line 11925
    $191 = ($190 | 0) == 0; //@line 11926
    $192 = $$1263 & -65537; //@line 11927
    $spec$select = $191 ? $$1263 : $192; //@line 11928
    L79 : do {
     switch ($$0235 | 0) {
     case 110:
      {
       $trunc = $$0252 & 255; //@line 11932
       switch ($trunc << 24 >> 24) {
       case 0:
        {
         $199 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 11935
         SAFE_HEAP_STORE($199 | 0, $$1248 | 0, 4);
         $$0243$ph$be = 0; //@line 11937
         break L77;
         break;
        }
       case 1:
        {
         $200 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 11942
         SAFE_HEAP_STORE($200 | 0, $$1248 | 0, 4);
         $$0243$ph$be = 0; //@line 11944
         break L77;
         break;
        }
       case 2:
        {
         $201 = ($$1248 | 0) < 0; //@line 11949
         $202 = $201 << 31 >> 31; //@line 11950
         $203 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 11951
         $204 = $203; //@line 11952
         $205 = $204; //@line 11953
         SAFE_HEAP_STORE($205 | 0, $$1248 | 0, 4);
         $206 = $204 + 4 | 0; //@line 11955
         $207 = $206; //@line 11956
         SAFE_HEAP_STORE($207 | 0, $202 | 0, 4);
         $$0243$ph$be = 0; //@line 11958
         break L77;
         break;
        }
       case 3:
        {
         $208 = $$1248 & 65535; //@line 11963
         $209 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 11964
         SAFE_HEAP_STORE($209 | 0, $208 | 0, 2);
         $$0243$ph$be = 0; //@line 11966
         break L77;
         break;
        }
       case 4:
        {
         $210 = $$1248 & 255; //@line 11971
         $211 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 11972
         SAFE_HEAP_STORE($211 >> 0 | 0, $210 | 0, 1);
         $$0243$ph$be = 0; //@line 11974
         break L77;
         break;
        }
       case 6:
        {
         $212 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 11979
         SAFE_HEAP_STORE($212 | 0, $$1248 | 0, 4);
         $$0243$ph$be = 0; //@line 11981
         break L77;
         break;
        }
       case 7:
        {
         $213 = ($$1248 | 0) < 0; //@line 11986
         $214 = $213 << 31 >> 31; //@line 11987
         $215 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 11988
         $216 = $215; //@line 11989
         $217 = $216; //@line 11990
         SAFE_HEAP_STORE($217 | 0, $$1248 | 0, 4);
         $218 = $216 + 4 | 0; //@line 11992
         $219 = $218; //@line 11993
         SAFE_HEAP_STORE($219 | 0, $214 | 0, 4);
         $$0243$ph$be = 0; //@line 11995
         break L77;
         break;
        }
       default:
        {
         $$0243$ph$be = 0; //@line 12000
         break L77;
        }
       }
       break;
      }
     case 112:
      {
       $220 = $$0254 >>> 0 > 8; //@line 12007
       $221 = $220 ? $$0254 : 8; //@line 12008
       $222 = $spec$select | 8; //@line 12009
       $$1236 = 120; //@line 12010
       $$1255 = $221; //@line 12010
       $$3265 = $222; //@line 12010
       label = 67; //@line 12011
       break;
      }
     case 88:
     case 120:
      {
       $$1236 = $$0235; //@line 12015
       $$1255 = $$0254; //@line 12015
       $$3265 = $spec$select; //@line 12015
       label = 67; //@line 12016
       break;
      }
     case 111:
      {
       $238 = $6; //@line 12020
       $239 = $238; //@line 12021
       $240 = SAFE_HEAP_LOAD($239 | 0, 4, 0) | 0 | 0; //@line 12022
       $241 = $238 + 4 | 0; //@line 12023
       $242 = $241; //@line 12024
       $243 = SAFE_HEAP_LOAD($242 | 0, 4, 0) | 0 | 0; //@line 12025
       $244 = _fmt_o($240, $243, $11) | 0; //@line 12026
       $245 = $spec$select & 8; //@line 12027
       $246 = ($245 | 0) == 0; //@line 12028
       $247 = $244; //@line 12029
       $248 = $12 - $247 | 0; //@line 12030
       $249 = ($$0254 | 0) > ($248 | 0); //@line 12031
       $250 = $248 + 1 | 0; //@line 12032
       $251 = $246 | $249; //@line 12033
       $spec$select295 = $251 ? $$0254 : $250; //@line 12034
       $$0228 = $244; //@line 12035
       $$1233 = 0; //@line 12035
       $$1238 = 10130; //@line 12035
       $$2256 = $spec$select295; //@line 12035
       $$4266 = $spec$select; //@line 12035
       $277 = $240; //@line 12035
       $279 = $243; //@line 12035
       label = 73; //@line 12036
       break;
      }
     case 105:
     case 100:
      {
       $252 = $6; //@line 12040
       $253 = $252; //@line 12041
       $254 = SAFE_HEAP_LOAD($253 | 0, 4, 0) | 0 | 0; //@line 12042
       $255 = $252 + 4 | 0; //@line 12043
       $256 = $255; //@line 12044
       $257 = SAFE_HEAP_LOAD($256 | 0, 4, 0) | 0 | 0; //@line 12045
       $258 = ($257 | 0) < 0; //@line 12046
       if ($258) {
        $259 = _i64Subtract(0, 0, $254 | 0, $257 | 0) | 0; //@line 12048
        $260 = getTempRet0() | 0; //@line 12049
        $261 = $6; //@line 12050
        $262 = $261; //@line 12051
        SAFE_HEAP_STORE($262 | 0, $259 | 0, 4);
        $263 = $261 + 4 | 0; //@line 12053
        $264 = $263; //@line 12054
        SAFE_HEAP_STORE($264 | 0, $260 | 0, 4);
        $$0232 = 1; //@line 12056
        $$0237 = 10130; //@line 12056
        $271 = $259; //@line 12056
        $272 = $260; //@line 12056
        label = 72; //@line 12057
        break L79;
       } else {
        $265 = $spec$select & 2048; //@line 12060
        $266 = ($265 | 0) == 0; //@line 12061
        $267 = $spec$select & 1; //@line 12062
        $268 = ($267 | 0) == 0; //@line 12063
        $$ = $268 ? 10130 : 10132; //@line 12064
        $spec$select296 = $266 ? $$ : 10131; //@line 12065
        $269 = $spec$select & 2049; //@line 12066
        $270 = ($269 | 0) != 0; //@line 12067
        $spec$select297 = $270 & 1; //@line 12068
        $$0232 = $spec$select297; //@line 12069
        $$0237 = $spec$select296; //@line 12069
        $271 = $254; //@line 12069
        $272 = $257; //@line 12069
        label = 72; //@line 12070
        break L79;
       }
       break;
      }
     case 117:
      {
       $193 = $6; //@line 12076
       $194 = $193; //@line 12077
       $195 = SAFE_HEAP_LOAD($194 | 0, 4, 0) | 0 | 0; //@line 12078
       $196 = $193 + 4 | 0; //@line 12079
       $197 = $196; //@line 12080
       $198 = SAFE_HEAP_LOAD($197 | 0, 4, 0) | 0 | 0; //@line 12081
       $$0232 = 0; //@line 12082
       $$0237 = 10130; //@line 12082
       $271 = $195; //@line 12082
       $272 = $198; //@line 12082
       label = 72; //@line 12083
       break;
      }
     case 99:
      {
       $288 = $6; //@line 12087
       $289 = $288; //@line 12088
       $290 = SAFE_HEAP_LOAD($289 | 0, 4, 0) | 0 | 0; //@line 12089
       $291 = $288 + 4 | 0; //@line 12090
       $292 = $291; //@line 12091
       $293 = SAFE_HEAP_LOAD($292 | 0, 4, 0) | 0 | 0; //@line 12092
       $294 = $290 & 255; //@line 12093
       SAFE_HEAP_STORE($13 >> 0 | 0, $294 | 0, 1);
       $$2 = $13; //@line 12095
       $$2234 = 0; //@line 12095
       $$2239 = 10130; //@line 12095
       $$5 = 1; //@line 12095
       $$6268 = $192; //@line 12095
       $$pre$phiZ2D = $12; //@line 12095
       break;
      }
     case 109:
      {
       $295 = ___errno_location() | 0; //@line 12099
       $296 = SAFE_HEAP_LOAD($295 | 0, 4, 0) | 0 | 0; //@line 12100
       $297 = _strerror($296) | 0; //@line 12101
       $$1 = $297; //@line 12102
       label = 77; //@line 12103
       break;
      }
     case 115:
      {
       $298 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 12107
       $299 = ($298 | 0) == (0 | 0); //@line 12108
       $300 = $299 ? 10140 : $298; //@line 12109
       $$1 = $300; //@line 12110
       label = 77; //@line 12111
       break;
      }
     case 67:
      {
       $307 = $6; //@line 12115
       $308 = $307; //@line 12116
       $309 = SAFE_HEAP_LOAD($308 | 0, 4, 0) | 0 | 0; //@line 12117
       $310 = $307 + 4 | 0; //@line 12118
       $311 = $310; //@line 12119
       $312 = SAFE_HEAP_LOAD($311 | 0, 4, 0) | 0 | 0; //@line 12120
       SAFE_HEAP_STORE($8 | 0, $309 | 0, 4);
       SAFE_HEAP_STORE($14 | 0, 0 | 0, 4);
       SAFE_HEAP_STORE($6 | 0, $8 | 0, 4);
       $$4258370 = -1; //@line 12124
       label = 81; //@line 12125
       break;
      }
     case 83:
      {
       $313 = ($$0254 | 0) == 0; //@line 12129
       if ($313) {
        _pad_661($0, 32, $$1260, 0, $spec$select); //@line 12131
        $$0240313371 = 0; //@line 12132
        label = 91; //@line 12133
       } else {
        $$4258370 = $$0254; //@line 12135
        label = 81; //@line 12136
       }
       break;
      }
     case 65:
     case 71:
     case 70:
     case 69:
     case 97:
     case 103:
     case 102:
     case 101:
      {
       $336 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 12141
       $337 = _fmt_fp($0, $336, $$1260, $$0254, $spec$select, $$0235) | 0; //@line 12142
       $$0243$ph$be = $337; //@line 12143
       break L77;
       break;
      }
     default:
      {
       $$2 = $20; //@line 12148
       $$2234 = 0; //@line 12148
       $$2239 = 10130; //@line 12148
       $$5 = $$0254; //@line 12148
       $$6268 = $spec$select; //@line 12148
       $$pre$phiZ2D = $12; //@line 12148
      }
     }
    } while (0);
    L103 : do {
     if ((label | 0) == 67) {
      label = 0; //@line 12154
      $223 = $6; //@line 12155
      $224 = $223; //@line 12156
      $225 = SAFE_HEAP_LOAD($224 | 0, 4, 0) | 0 | 0; //@line 12157
      $226 = $223 + 4 | 0; //@line 12158
      $227 = $226; //@line 12159
      $228 = SAFE_HEAP_LOAD($227 | 0, 4, 0) | 0 | 0; //@line 12160
      $229 = $$1236 & 32; //@line 12161
      $230 = _fmt_x($225, $228, $11, $229) | 0; //@line 12162
      $231 = ($225 | 0) == 0; //@line 12163
      $232 = ($228 | 0) == 0; //@line 12164
      $233 = $231 & $232; //@line 12165
      $234 = $$3265 & 8; //@line 12166
      $235 = ($234 | 0) == 0; //@line 12167
      $or$cond278 = $235 | $233; //@line 12168
      $236 = $$1236 >>> 4; //@line 12169
      $237 = 10130 + $236 | 0; //@line 12170
      $spec$select293 = $or$cond278 ? 10130 : $237; //@line 12171
      $spec$select294 = $or$cond278 ? 0 : 2; //@line 12172
      $$0228 = $230; //@line 12173
      $$1233 = $spec$select294; //@line 12173
      $$1238 = $spec$select293; //@line 12173
      $$2256 = $$1255; //@line 12173
      $$4266 = $$3265; //@line 12173
      $277 = $225; //@line 12173
      $279 = $228; //@line 12173
      label = 73; //@line 12174
     } else if ((label | 0) == 72) {
      label = 0; //@line 12177
      $273 = _fmt_u($271, $272, $11) | 0; //@line 12178
      $$0228 = $273; //@line 12179
      $$1233 = $$0232; //@line 12179
      $$1238 = $$0237; //@line 12179
      $$2256 = $$0254; //@line 12179
      $$4266 = $spec$select; //@line 12179
      $277 = $271; //@line 12179
      $279 = $272; //@line 12179
      label = 73; //@line 12180
     } else if ((label | 0) == 77) {
      label = 0; //@line 12183
      $301 = _memchr($$1, 0, $$0254) | 0; //@line 12184
      $302 = ($301 | 0) == (0 | 0); //@line 12185
      $303 = $301; //@line 12186
      $304 = $$1; //@line 12187
      $305 = $303 - $304 | 0; //@line 12188
      $306 = $$1 + $$0254 | 0; //@line 12189
      $$3257 = $302 ? $$0254 : $305; //@line 12190
      $$1250 = $302 ? $306 : $301; //@line 12191
      $$pre368 = $$1250; //@line 12192
      $$2 = $$1; //@line 12193
      $$2234 = 0; //@line 12193
      $$2239 = 10130; //@line 12193
      $$5 = $$3257; //@line 12193
      $$6268 = $192; //@line 12193
      $$pre$phiZ2D = $$pre368; //@line 12193
     } else if ((label | 0) == 81) {
      label = 0; //@line 12196
      $314 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 12197
      $$0229334 = $314; //@line 12198
      $$0240333 = 0; //@line 12198
      while (1) {
       $315 = SAFE_HEAP_LOAD($$0229334 | 0, 4, 0) | 0 | 0; //@line 12200
       $316 = ($315 | 0) == 0; //@line 12201
       if ($316) {
        $$0240313 = $$0240333; //@line 12203
        break;
       }
       $317 = _wctomb($9, $315) | 0; //@line 12206
       $318 = ($317 | 0) < 0; //@line 12207
       $319 = $$4258370 - $$0240333 | 0; //@line 12208
       $320 = $317 >>> 0 > $319 >>> 0; //@line 12209
       $or$cond283 = $318 | $320; //@line 12210
       if ($or$cond283) {
        label = 85; //@line 12212
        break;
       }
       $321 = $$0229334 + 4 | 0; //@line 12215
       $322 = $317 + $$0240333 | 0; //@line 12216
       $323 = $$4258370 >>> 0 > $322 >>> 0; //@line 12217
       if ($323) {
        $$0229334 = $321; //@line 12219
        $$0240333 = $322; //@line 12219
       } else {
        $$0240313 = $322; //@line 12221
        break;
       }
      }
      if ((label | 0) == 85) {
       label = 0; //@line 12226
       if ($318) {
        $$0 = -1; //@line 12228
        break L1;
       } else {
        $$0240313 = $$0240333; //@line 12231
       }
      }
      _pad_661($0, 32, $$1260, $$0240313, $spec$select); //@line 12234
      $324 = ($$0240313 | 0) == 0; //@line 12235
      if ($324) {
       $$0240313371 = 0; //@line 12237
       label = 91; //@line 12238
      } else {
       $325 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 12240
       $$1230340 = $325; //@line 12241
       $$1241339 = 0; //@line 12241
       while (1) {
        $326 = SAFE_HEAP_LOAD($$1230340 | 0, 4, 0) | 0 | 0; //@line 12243
        $327 = ($326 | 0) == 0; //@line 12244
        if ($327) {
         $$0240313371 = $$0240313; //@line 12246
         label = 91; //@line 12247
         break L103;
        }
        $328 = _wctomb($9, $326) | 0; //@line 12250
        $329 = $328 + $$1241339 | 0; //@line 12251
        $330 = ($329 | 0) > ($$0240313 | 0); //@line 12252
        if ($330) {
         $$0240313371 = $$0240313; //@line 12254
         label = 91; //@line 12255
         break L103;
        }
        $331 = $$1230340 + 4 | 0; //@line 12258
        _out_655($0, $9, $328); //@line 12259
        $332 = $329 >>> 0 < $$0240313 >>> 0; //@line 12260
        if ($332) {
         $$1230340 = $331; //@line 12262
         $$1241339 = $329; //@line 12262
        } else {
         $$0240313371 = $$0240313; //@line 12264
         label = 91; //@line 12265
         break;
        }
       }
      }
     }
    } while (0);
    if ((label | 0) == 73) {
     label = 0; //@line 12273
     $274 = ($$2256 | 0) > -1; //@line 12274
     $275 = $$4266 & -65537; //@line 12275
     $spec$select281 = $274 ? $275 : $$4266; //@line 12276
     $276 = ($277 | 0) != 0; //@line 12277
     $278 = ($279 | 0) != 0; //@line 12278
     $280 = $276 | $278; //@line 12279
     $281 = ($$2256 | 0) != 0; //@line 12280
     $or$cond = $281 | $280; //@line 12281
     $282 = $$0228; //@line 12282
     $283 = $12 - $282 | 0; //@line 12283
     $284 = $280 ^ 1; //@line 12284
     $285 = $284 & 1; //@line 12285
     $286 = $283 + $285 | 0; //@line 12286
     $287 = ($$2256 | 0) > ($286 | 0); //@line 12287
     $$2256$ = $287 ? $$2256 : $286; //@line 12288
     $spec$select298 = $or$cond ? $$2256$ : 0; //@line 12289
     $spec$select299 = $or$cond ? $$0228 : $11; //@line 12290
     $$2 = $spec$select299; //@line 12291
     $$2234 = $$1233; //@line 12291
     $$2239 = $$1238; //@line 12291
     $$5 = $spec$select298; //@line 12291
     $$6268 = $spec$select281; //@line 12291
     $$pre$phiZ2D = $12; //@line 12291
    } else if ((label | 0) == 91) {
     label = 0; //@line 12294
     $333 = $spec$select ^ 8192; //@line 12295
     _pad_661($0, 32, $$1260, $$0240313371, $333); //@line 12296
     $334 = ($$1260 | 0) > ($$0240313371 | 0); //@line 12297
     $335 = $334 ? $$1260 : $$0240313371; //@line 12298
     $$0243$ph$be = $335; //@line 12299
     break;
    }
    $338 = $$2; //@line 12302
    $339 = $$pre$phiZ2D - $338 | 0; //@line 12303
    $340 = ($$5 | 0) < ($339 | 0); //@line 12304
    $spec$select284 = $340 ? $339 : $$5; //@line 12305
    $341 = $spec$select284 + $$2234 | 0; //@line 12306
    $342 = ($$1260 | 0) < ($341 | 0); //@line 12307
    $$2261 = $342 ? $341 : $$1260; //@line 12308
    _pad_661($0, 32, $$2261, $341, $$6268); //@line 12309
    _out_655($0, $$2239, $$2234); //@line 12310
    $343 = $$6268 ^ 65536; //@line 12311
    _pad_661($0, 48, $$2261, $341, $343); //@line 12312
    _pad_661($0, 48, $spec$select284, $339, 0); //@line 12313
    _out_655($0, $$2, $339); //@line 12314
    $344 = $$6268 ^ 8192; //@line 12315
    _pad_661($0, 32, $$2261, $341, $344); //@line 12316
    $$0243$ph$be = $$2261; //@line 12317
   }
  } while (0);
  $$0243$ph = $$0243$ph$be; //@line 12320
  $$0247$ph = $$1248; //@line 12320
  $$0269$ph = $$3272; //@line 12320
 }
 L125 : do {
  if ((label | 0) == 94) {
   $345 = ($0 | 0) == (0 | 0); //@line 12324
   if ($345) {
    $346 = ($$0269$ph | 0) == 0; //@line 12326
    if ($346) {
     $$0 = 0; //@line 12328
    } else {
     $$2242320 = 1; //@line 12330
     while (1) {
      $347 = $4 + ($$2242320 << 2) | 0; //@line 12332
      $348 = SAFE_HEAP_LOAD($347 | 0, 4, 0) | 0 | 0; //@line 12333
      $349 = ($348 | 0) == 0; //@line 12334
      if ($349) {
       break;
      }
      $350 = $3 + ($$2242320 << 3) | 0; //@line 12338
      _pop_arg_658($350, $348, $2); //@line 12339
      $351 = $$2242320 + 1 | 0; //@line 12340
      $352 = $351 >>> 0 < 10; //@line 12341
      if ($352) {
       $$2242320 = $351; //@line 12343
      } else {
       $$0 = 1; //@line 12345
       break L125;
      }
     }
     $$3317 = $$2242320; //@line 12349
     while (1) {
      $355 = $4 + ($$3317 << 2) | 0; //@line 12351
      $356 = SAFE_HEAP_LOAD($355 | 0, 4, 0) | 0 | 0; //@line 12352
      $357 = ($356 | 0) == 0; //@line 12353
      $354 = $$3317 + 1 | 0; //@line 12354
      if (!$357) {
       $$0 = -1; //@line 12356
       break L125;
      }
      $353 = $354 >>> 0 < 10; //@line 12359
      if ($353) {
       $$3317 = $354; //@line 12361
      } else {
       $$0 = 1; //@line 12363
       break;
      }
     }
    }
   } else {
    $$0 = $$1248; //@line 12369
   }
  }
 } while (0);
 STACKTOP = sp; //@line 12373
 return $$0 | 0; //@line 12373
}
function _free($0) {
 $0 = $0 | 0; //@line 8462
 var $$0211$i = 0, $$0211$in$i = 0, $$0381438 = 0, $$0382$lcssa = 0, $$0382437 = 0, $$0394 = 0, $$0401 = 0, $$1 = 0, $$1380 = 0, $$1385 = 0, $$1385$be = 0, $$1385$ph = 0, $$1388 = 0, $$1388$be = 0, $$1388$ph = 0, $$1396 = 0, $$1396$be = 0, $$1396$ph = 0, $$1400 = 0, $$1400$be = 0; //@line 8463
 var $$1400$ph = 0, $$2 = 0, $$3 = 0, $$3398 = 0, $$pre = 0, $$pre$phi444Z2D = 0, $$pre$phi446Z2D = 0, $$pre$phiZ2D = 0, $$pre443 = 0, $$pre445 = 0, $$sink = 0, $$sink456 = 0, $1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0; //@line 8464
 var $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0; //@line 8465
 var $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0; //@line 8466
 var $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0; //@line 8467
 var $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0; //@line 8468
 var $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0; //@line 8469
 var $197 = 0, $198 = 0, $199 = 0, $2 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0; //@line 8470
 var $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0; //@line 8471
 var $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0; //@line 8472
 var $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0; //@line 8473
 var $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0; //@line 8474
 var $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0, $299 = 0, $3 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0; //@line 8475
 var $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0, $311 = 0, $312 = 0, $313 = 0, $314 = 0, $315 = 0, $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0; //@line 8476
 var $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0; //@line 8477
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0; //@line 8478
 var $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0; //@line 8479
 var $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $cond419 = 0, $cond420 = 0; //@line 8480
 var label = 0, sp = 0; //@line 8481
 sp = STACKTOP; //@line 8482
 $1 = ($0 | 0) == (0 | 0); //@line 8483
 if ($1) {
  return;
 }
 $2 = $0 + -8 | 0; //@line 8487
 $3 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 8488
 $4 = $2 >>> 0 < $3 >>> 0; //@line 8489
 if ($4) {
  _abort(); //@line 8491
 }
 $5 = $0 + -4 | 0; //@line 8494
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 8495
 $7 = $6 & 3; //@line 8496
 $8 = ($7 | 0) == 1; //@line 8497
 if ($8) {
  _abort(); //@line 8499
 }
 $9 = $6 & -8; //@line 8502
 $10 = $2 + $9 | 0; //@line 8503
 $11 = $6 & 1; //@line 8504
 $12 = ($11 | 0) == 0; //@line 8505
 L10 : do {
  if ($12) {
   $13 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 8508
   $14 = ($7 | 0) == 0; //@line 8509
   if ($14) {
    return;
   }
   $15 = 0 - $13 | 0; //@line 8513
   $16 = $2 + $15 | 0; //@line 8514
   $17 = $13 + $9 | 0; //@line 8515
   $18 = $16 >>> 0 < $3 >>> 0; //@line 8516
   if ($18) {
    _abort(); //@line 8518
   }
   $19 = SAFE_HEAP_LOAD(11316 | 0, 4, 0) | 0 | 0; //@line 8521
   $20 = ($19 | 0) == ($16 | 0); //@line 8522
   if ($20) {
    $105 = $10 + 4 | 0; //@line 8524
    $106 = SAFE_HEAP_LOAD($105 | 0, 4, 0) | 0 | 0; //@line 8525
    $107 = $106 & 3; //@line 8526
    $108 = ($107 | 0) == 3; //@line 8527
    if (!$108) {
     $$1 = $16; //@line 8529
     $$1380 = $17; //@line 8529
     $114 = $16; //@line 8529
     break;
    }
    $109 = $16 + $17 | 0; //@line 8532
    $110 = $16 + 4 | 0; //@line 8533
    $111 = $17 | 1; //@line 8534
    $112 = $106 & -2; //@line 8535
    SAFE_HEAP_STORE(11304 | 0, $17 | 0, 4);
    SAFE_HEAP_STORE($105 | 0, $112 | 0, 4);
    SAFE_HEAP_STORE($110 | 0, $111 | 0, 4);
    SAFE_HEAP_STORE($109 | 0, $17 | 0, 4);
    return;
   }
   $21 = $13 >>> 3; //@line 8542
   $22 = $13 >>> 0 < 256; //@line 8543
   if ($22) {
    $23 = $16 + 8 | 0; //@line 8545
    $24 = SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0; //@line 8546
    $25 = $16 + 12 | 0; //@line 8547
    $26 = SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0; //@line 8548
    $27 = $21 << 1; //@line 8549
    $28 = 11336 + ($27 << 2) | 0; //@line 8550
    $29 = ($24 | 0) == ($28 | 0); //@line 8551
    if (!$29) {
     $30 = $3 >>> 0 > $24 >>> 0; //@line 8553
     if ($30) {
      _abort(); //@line 8555
     }
     $31 = $24 + 12 | 0; //@line 8558
     $32 = SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0; //@line 8559
     $33 = ($32 | 0) == ($16 | 0); //@line 8560
     if (!$33) {
      _abort(); //@line 8562
     }
    }
    $34 = ($26 | 0) == ($24 | 0); //@line 8566
    if ($34) {
     $35 = 1 << $21; //@line 8568
     $36 = $35 ^ -1; //@line 8569
     $37 = SAFE_HEAP_LOAD(2824 * 4 | 0, 4, 0) | 0 | 0; //@line 8570
     $38 = $37 & $36; //@line 8571
     SAFE_HEAP_STORE(2824 * 4 | 0, $38 | 0, 4);
     $$1 = $16; //@line 8573
     $$1380 = $17; //@line 8573
     $114 = $16; //@line 8573
     break;
    }
    $39 = ($26 | 0) == ($28 | 0); //@line 8576
    if ($39) {
     $$pre445 = $26 + 8 | 0; //@line 8578
     $$pre$phi446Z2D = $$pre445; //@line 8579
    } else {
     $40 = $3 >>> 0 > $26 >>> 0; //@line 8581
     if ($40) {
      _abort(); //@line 8583
     }
     $41 = $26 + 8 | 0; //@line 8586
     $42 = SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0; //@line 8587
     $43 = ($42 | 0) == ($16 | 0); //@line 8588
     if ($43) {
      $$pre$phi446Z2D = $41; //@line 8590
     } else {
      _abort(); //@line 8592
     }
    }
    $44 = $24 + 12 | 0; //@line 8596
    SAFE_HEAP_STORE($44 | 0, $26 | 0, 4);
    SAFE_HEAP_STORE($$pre$phi446Z2D | 0, $24 | 0, 4);
    $$1 = $16; //@line 8599
    $$1380 = $17; //@line 8599
    $114 = $16; //@line 8599
    break;
   }
   $45 = $16 + 24 | 0; //@line 8602
   $46 = SAFE_HEAP_LOAD($45 | 0, 4, 0) | 0 | 0; //@line 8603
   $47 = $16 + 12 | 0; //@line 8604
   $48 = SAFE_HEAP_LOAD($47 | 0, 4, 0) | 0 | 0; //@line 8605
   $49 = ($48 | 0) == ($16 | 0); //@line 8606
   do {
    if ($49) {
     $59 = $16 + 16 | 0; //@line 8609
     $60 = $59 + 4 | 0; //@line 8610
     $61 = SAFE_HEAP_LOAD($60 | 0, 4, 0) | 0 | 0; //@line 8611
     $62 = ($61 | 0) == (0 | 0); //@line 8612
     if ($62) {
      $63 = SAFE_HEAP_LOAD($59 | 0, 4, 0) | 0 | 0; //@line 8614
      $64 = ($63 | 0) == (0 | 0); //@line 8615
      if ($64) {
       $$3 = 0; //@line 8617
       break;
      } else {
       $$1385$ph = $63; //@line 8620
       $$1388$ph = $59; //@line 8620
      }
     } else {
      $$1385$ph = $61; //@line 8623
      $$1388$ph = $60; //@line 8623
     }
     $$1385 = $$1385$ph; //@line 8625
     $$1388 = $$1388$ph; //@line 8625
     while (1) {
      $65 = $$1385 + 20 | 0; //@line 8627
      $66 = SAFE_HEAP_LOAD($65 | 0, 4, 0) | 0 | 0; //@line 8628
      $67 = ($66 | 0) == (0 | 0); //@line 8629
      if ($67) {
       $68 = $$1385 + 16 | 0; //@line 8631
       $69 = SAFE_HEAP_LOAD($68 | 0, 4, 0) | 0 | 0; //@line 8632
       $70 = ($69 | 0) == (0 | 0); //@line 8633
       if ($70) {
        break;
       } else {
        $$1385$be = $69; //@line 8637
        $$1388$be = $68; //@line 8637
       }
      } else {
       $$1385$be = $66; //@line 8640
       $$1388$be = $65; //@line 8640
      }
      $$1385 = $$1385$be; //@line 8642
      $$1388 = $$1388$be; //@line 8642
     }
     $71 = $3 >>> 0 > $$1388 >>> 0; //@line 8644
     if ($71) {
      _abort(); //@line 8646
     } else {
      SAFE_HEAP_STORE($$1388 | 0, 0 | 0, 4);
      $$3 = $$1385; //@line 8650
      break;
     }
    } else {
     $50 = $16 + 8 | 0; //@line 8654
     $51 = SAFE_HEAP_LOAD($50 | 0, 4, 0) | 0 | 0; //@line 8655
     $52 = $3 >>> 0 > $51 >>> 0; //@line 8656
     if ($52) {
      _abort(); //@line 8658
     }
     $53 = $51 + 12 | 0; //@line 8661
     $54 = SAFE_HEAP_LOAD($53 | 0, 4, 0) | 0 | 0; //@line 8662
     $55 = ($54 | 0) == ($16 | 0); //@line 8663
     if (!$55) {
      _abort(); //@line 8665
     }
     $56 = $48 + 8 | 0; //@line 8668
     $57 = SAFE_HEAP_LOAD($56 | 0, 4, 0) | 0 | 0; //@line 8669
     $58 = ($57 | 0) == ($16 | 0); //@line 8670
     if ($58) {
      SAFE_HEAP_STORE($53 | 0, $48 | 0, 4);
      SAFE_HEAP_STORE($56 | 0, $51 | 0, 4);
      $$3 = $48; //@line 8674
      break;
     } else {
      _abort(); //@line 8677
     }
    }
   } while (0);
   $72 = ($46 | 0) == (0 | 0); //@line 8682
   if ($72) {
    $$1 = $16; //@line 8684
    $$1380 = $17; //@line 8684
    $114 = $16; //@line 8684
   } else {
    $73 = $16 + 28 | 0; //@line 8686
    $74 = SAFE_HEAP_LOAD($73 | 0, 4, 0) | 0 | 0; //@line 8687
    $75 = 11600 + ($74 << 2) | 0; //@line 8688
    $76 = SAFE_HEAP_LOAD($75 | 0, 4, 0) | 0 | 0; //@line 8689
    $77 = ($76 | 0) == ($16 | 0); //@line 8690
    do {
     if ($77) {
      SAFE_HEAP_STORE($75 | 0, $$3 | 0, 4);
      $cond419 = ($$3 | 0) == (0 | 0); //@line 8694
      if ($cond419) {
       $78 = 1 << $74; //@line 8696
       $79 = $78 ^ -1; //@line 8697
       $80 = SAFE_HEAP_LOAD(11300 | 0, 4, 0) | 0 | 0; //@line 8698
       $81 = $80 & $79; //@line 8699
       SAFE_HEAP_STORE(11300 | 0, $81 | 0, 4);
       $$1 = $16; //@line 8701
       $$1380 = $17; //@line 8701
       $114 = $16; //@line 8701
       break L10;
      }
     } else {
      $82 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 8705
      $83 = $82 >>> 0 > $46 >>> 0; //@line 8706
      if ($83) {
       _abort(); //@line 8708
      } else {
       $84 = $46 + 16 | 0; //@line 8711
       $85 = SAFE_HEAP_LOAD($84 | 0, 4, 0) | 0 | 0; //@line 8712
       $86 = ($85 | 0) == ($16 | 0); //@line 8713
       $87 = $46 + 20 | 0; //@line 8714
       $$sink = $86 ? $84 : $87; //@line 8715
       SAFE_HEAP_STORE($$sink | 0, $$3 | 0, 4);
       $88 = ($$3 | 0) == (0 | 0); //@line 8717
       if ($88) {
        $$1 = $16; //@line 8719
        $$1380 = $17; //@line 8719
        $114 = $16; //@line 8719
        break L10;
       } else {
        break;
       }
      }
     }
    } while (0);
    $89 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 8727
    $90 = $89 >>> 0 > $$3 >>> 0; //@line 8728
    if ($90) {
     _abort(); //@line 8730
    }
    $91 = $$3 + 24 | 0; //@line 8733
    SAFE_HEAP_STORE($91 | 0, $46 | 0, 4);
    $92 = $16 + 16 | 0; //@line 8735
    $93 = SAFE_HEAP_LOAD($92 | 0, 4, 0) | 0 | 0; //@line 8736
    $94 = ($93 | 0) == (0 | 0); //@line 8737
    do {
     if (!$94) {
      $95 = $89 >>> 0 > $93 >>> 0; //@line 8740
      if ($95) {
       _abort(); //@line 8742
      } else {
       $96 = $$3 + 16 | 0; //@line 8745
       SAFE_HEAP_STORE($96 | 0, $93 | 0, 4);
       $97 = $93 + 24 | 0; //@line 8747
       SAFE_HEAP_STORE($97 | 0, $$3 | 0, 4);
       break;
      }
     }
    } while (0);
    $98 = $92 + 4 | 0; //@line 8753
    $99 = SAFE_HEAP_LOAD($98 | 0, 4, 0) | 0 | 0; //@line 8754
    $100 = ($99 | 0) == (0 | 0); //@line 8755
    if ($100) {
     $$1 = $16; //@line 8757
     $$1380 = $17; //@line 8757
     $114 = $16; //@line 8757
    } else {
     $101 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 8759
     $102 = $101 >>> 0 > $99 >>> 0; //@line 8760
     if ($102) {
      _abort(); //@line 8762
     } else {
      $103 = $$3 + 20 | 0; //@line 8765
      SAFE_HEAP_STORE($103 | 0, $99 | 0, 4);
      $104 = $99 + 24 | 0; //@line 8767
      SAFE_HEAP_STORE($104 | 0, $$3 | 0, 4);
      $$1 = $16; //@line 8769
      $$1380 = $17; //@line 8769
      $114 = $16; //@line 8769
      break;
     }
    }
   }
  } else {
   $$1 = $2; //@line 8775
   $$1380 = $9; //@line 8775
   $114 = $2; //@line 8775
  }
 } while (0);
 $113 = $114 >>> 0 < $10 >>> 0; //@line 8778
 if (!$113) {
  _abort(); //@line 8780
 }
 $115 = $10 + 4 | 0; //@line 8783
 $116 = SAFE_HEAP_LOAD($115 | 0, 4, 0) | 0 | 0; //@line 8784
 $117 = $116 & 1; //@line 8785
 $118 = ($117 | 0) == 0; //@line 8786
 if ($118) {
  _abort(); //@line 8788
 }
 $119 = $116 & 2; //@line 8791
 $120 = ($119 | 0) == 0; //@line 8792
 if ($120) {
  $121 = SAFE_HEAP_LOAD(11320 | 0, 4, 0) | 0 | 0; //@line 8794
  $122 = ($121 | 0) == ($10 | 0); //@line 8795
  if ($122) {
   $123 = SAFE_HEAP_LOAD(11308 | 0, 4, 0) | 0 | 0; //@line 8797
   $124 = $123 + $$1380 | 0; //@line 8798
   SAFE_HEAP_STORE(11308 | 0, $124 | 0, 4);
   SAFE_HEAP_STORE(11320 | 0, $$1 | 0, 4);
   $125 = $124 | 1; //@line 8801
   $126 = $$1 + 4 | 0; //@line 8802
   SAFE_HEAP_STORE($126 | 0, $125 | 0, 4);
   $127 = SAFE_HEAP_LOAD(11316 | 0, 4, 0) | 0 | 0; //@line 8804
   $128 = ($$1 | 0) == ($127 | 0); //@line 8805
   if (!$128) {
    return;
   }
   SAFE_HEAP_STORE(11316 | 0, 0 | 0, 4);
   SAFE_HEAP_STORE(11304 | 0, 0 | 0, 4);
   return;
  }
  $129 = SAFE_HEAP_LOAD(11316 | 0, 4, 0) | 0 | 0; //@line 8813
  $130 = ($129 | 0) == ($10 | 0); //@line 8814
  if ($130) {
   $131 = SAFE_HEAP_LOAD(11304 | 0, 4, 0) | 0 | 0; //@line 8816
   $132 = $131 + $$1380 | 0; //@line 8817
   SAFE_HEAP_STORE(11304 | 0, $132 | 0, 4);
   SAFE_HEAP_STORE(11316 | 0, $114 | 0, 4);
   $133 = $132 | 1; //@line 8820
   $134 = $$1 + 4 | 0; //@line 8821
   SAFE_HEAP_STORE($134 | 0, $133 | 0, 4);
   $135 = $114 + $132 | 0; //@line 8823
   SAFE_HEAP_STORE($135 | 0, $132 | 0, 4);
   return;
  }
  $136 = $116 & -8; //@line 8827
  $137 = $136 + $$1380 | 0; //@line 8828
  $138 = $116 >>> 3; //@line 8829
  $139 = $116 >>> 0 < 256; //@line 8830
  L111 : do {
   if ($139) {
    $140 = $10 + 8 | 0; //@line 8833
    $141 = SAFE_HEAP_LOAD($140 | 0, 4, 0) | 0 | 0; //@line 8834
    $142 = $10 + 12 | 0; //@line 8835
    $143 = SAFE_HEAP_LOAD($142 | 0, 4, 0) | 0 | 0; //@line 8836
    $144 = $138 << 1; //@line 8837
    $145 = 11336 + ($144 << 2) | 0; //@line 8838
    $146 = ($141 | 0) == ($145 | 0); //@line 8839
    if (!$146) {
     $147 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 8841
     $148 = $147 >>> 0 > $141 >>> 0; //@line 8842
     if ($148) {
      _abort(); //@line 8844
     }
     $149 = $141 + 12 | 0; //@line 8847
     $150 = SAFE_HEAP_LOAD($149 | 0, 4, 0) | 0 | 0; //@line 8848
     $151 = ($150 | 0) == ($10 | 0); //@line 8849
     if (!$151) {
      _abort(); //@line 8851
     }
    }
    $152 = ($143 | 0) == ($141 | 0); //@line 8855
    if ($152) {
     $153 = 1 << $138; //@line 8857
     $154 = $153 ^ -1; //@line 8858
     $155 = SAFE_HEAP_LOAD(2824 * 4 | 0, 4, 0) | 0 | 0; //@line 8859
     $156 = $155 & $154; //@line 8860
     SAFE_HEAP_STORE(2824 * 4 | 0, $156 | 0, 4);
     break;
    }
    $157 = ($143 | 0) == ($145 | 0); //@line 8864
    if ($157) {
     $$pre443 = $143 + 8 | 0; //@line 8866
     $$pre$phi444Z2D = $$pre443; //@line 8867
    } else {
     $158 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 8869
     $159 = $158 >>> 0 > $143 >>> 0; //@line 8870
     if ($159) {
      _abort(); //@line 8872
     }
     $160 = $143 + 8 | 0; //@line 8875
     $161 = SAFE_HEAP_LOAD($160 | 0, 4, 0) | 0 | 0; //@line 8876
     $162 = ($161 | 0) == ($10 | 0); //@line 8877
     if ($162) {
      $$pre$phi444Z2D = $160; //@line 8879
     } else {
      _abort(); //@line 8881
     }
    }
    $163 = $141 + 12 | 0; //@line 8885
    SAFE_HEAP_STORE($163 | 0, $143 | 0, 4);
    SAFE_HEAP_STORE($$pre$phi444Z2D | 0, $141 | 0, 4);
   } else {
    $164 = $10 + 24 | 0; //@line 8889
    $165 = SAFE_HEAP_LOAD($164 | 0, 4, 0) | 0 | 0; //@line 8890
    $166 = $10 + 12 | 0; //@line 8891
    $167 = SAFE_HEAP_LOAD($166 | 0, 4, 0) | 0 | 0; //@line 8892
    $168 = ($167 | 0) == ($10 | 0); //@line 8893
    do {
     if ($168) {
      $179 = $10 + 16 | 0; //@line 8896
      $180 = $179 + 4 | 0; //@line 8897
      $181 = SAFE_HEAP_LOAD($180 | 0, 4, 0) | 0 | 0; //@line 8898
      $182 = ($181 | 0) == (0 | 0); //@line 8899
      if ($182) {
       $183 = SAFE_HEAP_LOAD($179 | 0, 4, 0) | 0 | 0; //@line 8901
       $184 = ($183 | 0) == (0 | 0); //@line 8902
       if ($184) {
        $$3398 = 0; //@line 8904
        break;
       } else {
        $$1396$ph = $183; //@line 8907
        $$1400$ph = $179; //@line 8907
       }
      } else {
       $$1396$ph = $181; //@line 8910
       $$1400$ph = $180; //@line 8910
      }
      $$1396 = $$1396$ph; //@line 8912
      $$1400 = $$1400$ph; //@line 8912
      while (1) {
       $185 = $$1396 + 20 | 0; //@line 8914
       $186 = SAFE_HEAP_LOAD($185 | 0, 4, 0) | 0 | 0; //@line 8915
       $187 = ($186 | 0) == (0 | 0); //@line 8916
       if ($187) {
        $188 = $$1396 + 16 | 0; //@line 8918
        $189 = SAFE_HEAP_LOAD($188 | 0, 4, 0) | 0 | 0; //@line 8919
        $190 = ($189 | 0) == (0 | 0); //@line 8920
        if ($190) {
         break;
        } else {
         $$1396$be = $189; //@line 8924
         $$1400$be = $188; //@line 8924
        }
       } else {
        $$1396$be = $186; //@line 8927
        $$1400$be = $185; //@line 8927
       }
       $$1396 = $$1396$be; //@line 8929
       $$1400 = $$1400$be; //@line 8929
      }
      $191 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 8931
      $192 = $191 >>> 0 > $$1400 >>> 0; //@line 8932
      if ($192) {
       _abort(); //@line 8934
      } else {
       SAFE_HEAP_STORE($$1400 | 0, 0 | 0, 4);
       $$3398 = $$1396; //@line 8938
       break;
      }
     } else {
      $169 = $10 + 8 | 0; //@line 8942
      $170 = SAFE_HEAP_LOAD($169 | 0, 4, 0) | 0 | 0; //@line 8943
      $171 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 8944
      $172 = $171 >>> 0 > $170 >>> 0; //@line 8945
      if ($172) {
       _abort(); //@line 8947
      }
      $173 = $170 + 12 | 0; //@line 8950
      $174 = SAFE_HEAP_LOAD($173 | 0, 4, 0) | 0 | 0; //@line 8951
      $175 = ($174 | 0) == ($10 | 0); //@line 8952
      if (!$175) {
       _abort(); //@line 8954
      }
      $176 = $167 + 8 | 0; //@line 8957
      $177 = SAFE_HEAP_LOAD($176 | 0, 4, 0) | 0 | 0; //@line 8958
      $178 = ($177 | 0) == ($10 | 0); //@line 8959
      if ($178) {
       SAFE_HEAP_STORE($173 | 0, $167 | 0, 4);
       SAFE_HEAP_STORE($176 | 0, $170 | 0, 4);
       $$3398 = $167; //@line 8963
       break;
      } else {
       _abort(); //@line 8966
      }
     }
    } while (0);
    $193 = ($165 | 0) == (0 | 0); //@line 8971
    if (!$193) {
     $194 = $10 + 28 | 0; //@line 8973
     $195 = SAFE_HEAP_LOAD($194 | 0, 4, 0) | 0 | 0; //@line 8974
     $196 = 11600 + ($195 << 2) | 0; //@line 8975
     $197 = SAFE_HEAP_LOAD($196 | 0, 4, 0) | 0 | 0; //@line 8976
     $198 = ($197 | 0) == ($10 | 0); //@line 8977
     do {
      if ($198) {
       SAFE_HEAP_STORE($196 | 0, $$3398 | 0, 4);
       $cond420 = ($$3398 | 0) == (0 | 0); //@line 8981
       if ($cond420) {
        $199 = 1 << $195; //@line 8983
        $200 = $199 ^ -1; //@line 8984
        $201 = SAFE_HEAP_LOAD(11300 | 0, 4, 0) | 0 | 0; //@line 8985
        $202 = $201 & $200; //@line 8986
        SAFE_HEAP_STORE(11300 | 0, $202 | 0, 4);
        break L111;
       }
      } else {
       $203 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 8991
       $204 = $203 >>> 0 > $165 >>> 0; //@line 8992
       if ($204) {
        _abort(); //@line 8994
       } else {
        $205 = $165 + 16 | 0; //@line 8997
        $206 = SAFE_HEAP_LOAD($205 | 0, 4, 0) | 0 | 0; //@line 8998
        $207 = ($206 | 0) == ($10 | 0); //@line 8999
        $208 = $165 + 20 | 0; //@line 9000
        $$sink456 = $207 ? $205 : $208; //@line 9001
        SAFE_HEAP_STORE($$sink456 | 0, $$3398 | 0, 4);
        $209 = ($$3398 | 0) == (0 | 0); //@line 9003
        if ($209) {
         break L111;
        } else {
         break;
        }
       }
      }
     } while (0);
     $210 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 9012
     $211 = $210 >>> 0 > $$3398 >>> 0; //@line 9013
     if ($211) {
      _abort(); //@line 9015
     }
     $212 = $$3398 + 24 | 0; //@line 9018
     SAFE_HEAP_STORE($212 | 0, $165 | 0, 4);
     $213 = $10 + 16 | 0; //@line 9020
     $214 = SAFE_HEAP_LOAD($213 | 0, 4, 0) | 0 | 0; //@line 9021
     $215 = ($214 | 0) == (0 | 0); //@line 9022
     do {
      if (!$215) {
       $216 = $210 >>> 0 > $214 >>> 0; //@line 9025
       if ($216) {
        _abort(); //@line 9027
       } else {
        $217 = $$3398 + 16 | 0; //@line 9030
        SAFE_HEAP_STORE($217 | 0, $214 | 0, 4);
        $218 = $214 + 24 | 0; //@line 9032
        SAFE_HEAP_STORE($218 | 0, $$3398 | 0, 4);
        break;
       }
      }
     } while (0);
     $219 = $213 + 4 | 0; //@line 9038
     $220 = SAFE_HEAP_LOAD($219 | 0, 4, 0) | 0 | 0; //@line 9039
     $221 = ($220 | 0) == (0 | 0); //@line 9040
     if (!$221) {
      $222 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 9042
      $223 = $222 >>> 0 > $220 >>> 0; //@line 9043
      if ($223) {
       _abort(); //@line 9045
      } else {
       $224 = $$3398 + 20 | 0; //@line 9048
       SAFE_HEAP_STORE($224 | 0, $220 | 0, 4);
       $225 = $220 + 24 | 0; //@line 9050
       SAFE_HEAP_STORE($225 | 0, $$3398 | 0, 4);
       break;
      }
     }
    }
   }
  } while (0);
  $226 = $137 | 1; //@line 9058
  $227 = $$1 + 4 | 0; //@line 9059
  SAFE_HEAP_STORE($227 | 0, $226 | 0, 4);
  $228 = $114 + $137 | 0; //@line 9061
  SAFE_HEAP_STORE($228 | 0, $137 | 0, 4);
  $229 = SAFE_HEAP_LOAD(11316 | 0, 4, 0) | 0 | 0; //@line 9063
  $230 = ($$1 | 0) == ($229 | 0); //@line 9064
  if ($230) {
   SAFE_HEAP_STORE(11304 | 0, $137 | 0, 4);
   return;
  } else {
   $$2 = $137; //@line 9069
  }
 } else {
  $231 = $116 & -2; //@line 9072
  SAFE_HEAP_STORE($115 | 0, $231 | 0, 4);
  $232 = $$1380 | 1; //@line 9074
  $233 = $$1 + 4 | 0; //@line 9075
  SAFE_HEAP_STORE($233 | 0, $232 | 0, 4);
  $234 = $114 + $$1380 | 0; //@line 9077
  SAFE_HEAP_STORE($234 | 0, $$1380 | 0, 4);
  $$2 = $$1380; //@line 9079
 }
 $235 = $$2 >>> 3; //@line 9081
 $236 = $$2 >>> 0 < 256; //@line 9082
 if ($236) {
  $237 = $235 << 1; //@line 9084
  $238 = 11336 + ($237 << 2) | 0; //@line 9085
  $239 = SAFE_HEAP_LOAD(2824 * 4 | 0, 4, 0) | 0 | 0; //@line 9086
  $240 = 1 << $235; //@line 9087
  $241 = $239 & $240; //@line 9088
  $242 = ($241 | 0) == 0; //@line 9089
  if ($242) {
   $243 = $239 | $240; //@line 9091
   SAFE_HEAP_STORE(2824 * 4 | 0, $243 | 0, 4);
   $$pre = $238 + 8 | 0; //@line 9093
   $$0401 = $238; //@line 9094
   $$pre$phiZ2D = $$pre; //@line 9094
  } else {
   $244 = $238 + 8 | 0; //@line 9096
   $245 = SAFE_HEAP_LOAD($244 | 0, 4, 0) | 0 | 0; //@line 9097
   $246 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 9098
   $247 = $246 >>> 0 > $245 >>> 0; //@line 9099
   if ($247) {
    _abort(); //@line 9101
   } else {
    $$0401 = $245; //@line 9104
    $$pre$phiZ2D = $244; //@line 9104
   }
  }
  SAFE_HEAP_STORE($$pre$phiZ2D | 0, $$1 | 0, 4);
  $248 = $$0401 + 12 | 0; //@line 9108
  SAFE_HEAP_STORE($248 | 0, $$1 | 0, 4);
  $249 = $$1 + 8 | 0; //@line 9110
  SAFE_HEAP_STORE($249 | 0, $$0401 | 0, 4);
  $250 = $$1 + 12 | 0; //@line 9112
  SAFE_HEAP_STORE($250 | 0, $238 | 0, 4);
  return;
 }
 $251 = $$2 >>> 8; //@line 9116
 $252 = ($251 | 0) == 0; //@line 9117
 if ($252) {
  $$0394 = 0; //@line 9119
 } else {
  $253 = $$2 >>> 0 > 16777215; //@line 9121
  if ($253) {
   $$0394 = 31; //@line 9123
  } else {
   $254 = $251 + 1048320 | 0; //@line 9125
   $255 = $254 >>> 16; //@line 9126
   $256 = $255 & 8; //@line 9127
   $257 = $251 << $256; //@line 9128
   $258 = $257 + 520192 | 0; //@line 9129
   $259 = $258 >>> 16; //@line 9130
   $260 = $259 & 4; //@line 9131
   $261 = $260 | $256; //@line 9132
   $262 = $257 << $260; //@line 9133
   $263 = $262 + 245760 | 0; //@line 9134
   $264 = $263 >>> 16; //@line 9135
   $265 = $264 & 2; //@line 9136
   $266 = $261 | $265; //@line 9137
   $267 = 14 - $266 | 0; //@line 9138
   $268 = $262 << $265; //@line 9139
   $269 = $268 >>> 15; //@line 9140
   $270 = $267 + $269 | 0; //@line 9141
   $271 = $270 << 1; //@line 9142
   $272 = $270 + 7 | 0; //@line 9143
   $273 = $$2 >>> $272; //@line 9144
   $274 = $273 & 1; //@line 9145
   $275 = $274 | $271; //@line 9146
   $$0394 = $275; //@line 9147
  }
 }
 $276 = 11600 + ($$0394 << 2) | 0; //@line 9150
 $277 = $$1 + 28 | 0; //@line 9151
 SAFE_HEAP_STORE($277 | 0, $$0394 | 0, 4);
 $278 = $$1 + 16 | 0; //@line 9153
 $279 = $$1 + 20 | 0; //@line 9154
 SAFE_HEAP_STORE($279 | 0, 0 | 0, 4);
 SAFE_HEAP_STORE($278 | 0, 0 | 0, 4);
 $280 = SAFE_HEAP_LOAD(11300 | 0, 4, 0) | 0 | 0; //@line 9157
 $281 = 1 << $$0394; //@line 9158
 $282 = $280 & $281; //@line 9159
 $283 = ($282 | 0) == 0; //@line 9160
 L197 : do {
  if ($283) {
   $284 = $280 | $281; //@line 9163
   SAFE_HEAP_STORE(11300 | 0, $284 | 0, 4);
   SAFE_HEAP_STORE($276 | 0, $$1 | 0, 4);
   $285 = $$1 + 24 | 0; //@line 9166
   SAFE_HEAP_STORE($285 | 0, $276 | 0, 4);
   $286 = $$1 + 12 | 0; //@line 9168
   SAFE_HEAP_STORE($286 | 0, $$1 | 0, 4);
   $287 = $$1 + 8 | 0; //@line 9170
   SAFE_HEAP_STORE($287 | 0, $$1 | 0, 4);
  } else {
   $288 = SAFE_HEAP_LOAD($276 | 0, 4, 0) | 0 | 0; //@line 9173
   $289 = $288 + 4 | 0; //@line 9174
   $290 = SAFE_HEAP_LOAD($289 | 0, 4, 0) | 0 | 0; //@line 9175
   $291 = $290 & -8; //@line 9176
   $292 = ($291 | 0) == ($$2 | 0); //@line 9177
   L200 : do {
    if ($292) {
     $$0382$lcssa = $288; //@line 9180
    } else {
     $293 = ($$0394 | 0) == 31; //@line 9182
     $294 = $$0394 >>> 1; //@line 9183
     $295 = 25 - $294 | 0; //@line 9184
     $296 = $293 ? 0 : $295; //@line 9185
     $297 = $$2 << $296; //@line 9186
     $$0381438 = $297; //@line 9187
     $$0382437 = $288; //@line 9187
     while (1) {
      $304 = $$0381438 >>> 31; //@line 9189
      $305 = ($$0382437 + 16 | 0) + ($304 << 2) | 0; //@line 9190
      $300 = SAFE_HEAP_LOAD($305 | 0, 4, 0) | 0 | 0; //@line 9191
      $306 = ($300 | 0) == (0 | 0); //@line 9192
      if ($306) {
       break;
      }
      $298 = $$0381438 << 1; //@line 9196
      $299 = $300 + 4 | 0; //@line 9197
      $301 = SAFE_HEAP_LOAD($299 | 0, 4, 0) | 0 | 0; //@line 9198
      $302 = $301 & -8; //@line 9199
      $303 = ($302 | 0) == ($$2 | 0); //@line 9200
      if ($303) {
       $$0382$lcssa = $300; //@line 9202
       break L200;
      } else {
       $$0381438 = $298; //@line 9205
       $$0382437 = $300; //@line 9205
      }
     }
     $307 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 9208
     $308 = $307 >>> 0 > $305 >>> 0; //@line 9209
     if ($308) {
      _abort(); //@line 9211
     } else {
      SAFE_HEAP_STORE($305 | 0, $$1 | 0, 4);
      $309 = $$1 + 24 | 0; //@line 9215
      SAFE_HEAP_STORE($309 | 0, $$0382437 | 0, 4);
      $310 = $$1 + 12 | 0; //@line 9217
      SAFE_HEAP_STORE($310 | 0, $$1 | 0, 4);
      $311 = $$1 + 8 | 0; //@line 9219
      SAFE_HEAP_STORE($311 | 0, $$1 | 0, 4);
      break L197;
     }
    }
   } while (0);
   $312 = $$0382$lcssa + 8 | 0; //@line 9225
   $313 = SAFE_HEAP_LOAD($312 | 0, 4, 0) | 0 | 0; //@line 9226
   $314 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 9227
   $315 = $314 >>> 0 <= $$0382$lcssa >>> 0; //@line 9228
   $316 = $314 >>> 0 <= $313 >>> 0; //@line 9229
   $317 = $316 & $315; //@line 9230
   if ($317) {
    $318 = $313 + 12 | 0; //@line 9232
    SAFE_HEAP_STORE($318 | 0, $$1 | 0, 4);
    SAFE_HEAP_STORE($312 | 0, $$1 | 0, 4);
    $319 = $$1 + 8 | 0; //@line 9235
    SAFE_HEAP_STORE($319 | 0, $313 | 0, 4);
    $320 = $$1 + 12 | 0; //@line 9237
    SAFE_HEAP_STORE($320 | 0, $$0382$lcssa | 0, 4);
    $321 = $$1 + 24 | 0; //@line 9239
    SAFE_HEAP_STORE($321 | 0, 0 | 0, 4);
    break;
   } else {
    _abort(); //@line 9243
   }
  }
 } while (0);
 $322 = SAFE_HEAP_LOAD(11328 | 0, 4, 0) | 0 | 0; //@line 9248
 $323 = $322 + -1 | 0; //@line 9249
 SAFE_HEAP_STORE(11328 | 0, $323 | 0, 4);
 $324 = ($323 | 0) == 0; //@line 9251
 if (!$324) {
  return;
 }
 $$0211$in$i = 11752; //@line 9255
 while (1) {
  $$0211$i = SAFE_HEAP_LOAD($$0211$in$i | 0, 4, 0) | 0 | 0; //@line 9257
  $325 = ($$0211$i | 0) == (0 | 0); //@line 9258
  $326 = $$0211$i + 8 | 0; //@line 9259
  if ($325) {
   break;
  } else {
   $$0211$in$i = $326; //@line 9263
  }
 }
 SAFE_HEAP_STORE(11328 | 0, -1 | 0, 4);
 return;
}
function _dispose_chunk($0, $1) {
 $0 = $0 | 0; //@line 9780
 $1 = $1 | 0; //@line 9781
 var $$041722 = 0, $$0418$lcssa = 0, $$041821 = 0, $$0429 = 0, $$0436 = 0, $$1 = 0, $$1416 = 0, $$1424 = 0, $$1424$be = 0, $$1424$ph = 0, $$1427 = 0, $$1427$be = 0, $$1427$ph = 0, $$1431 = 0, $$1431$be = 0, $$1431$ph = 0, $$1435 = 0, $$1435$be = 0, $$1435$ph = 0, $$2 = 0; //@line 9782
 var $$3 = 0, $$3433 = 0, $$pre = 0, $$pre$phi28Z2D = 0, $$pre$phi30Z2D = 0, $$pre$phiZ2D = 0, $$pre27 = 0, $$pre29 = 0, $$sink = 0, $$sink41 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0; //@line 9783
 var $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0; //@line 9784
 var $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0; //@line 9785
 var $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0; //@line 9786
 var $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0; //@line 9787
 var $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0; //@line 9788
 var $2 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0; //@line 9789
 var $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0; //@line 9790
 var $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0; //@line 9791
 var $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0; //@line 9792
 var $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0; //@line 9793
 var $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0, $299 = 0, $3 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0; //@line 9794
 var $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0; //@line 9795
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0; //@line 9796
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0; //@line 9797
 var $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $cond = 0; //@line 9798
 var $cond17 = 0, label = 0, sp = 0; //@line 9799
 sp = STACKTOP; //@line 9800
 $2 = $0 + $1 | 0; //@line 9801
 $3 = $0 + 4 | 0; //@line 9802
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 9803
 $5 = $4 & 1; //@line 9804
 $6 = ($5 | 0) == 0; //@line 9805
 L1 : do {
  if ($6) {
   $7 = SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0; //@line 9808
   $8 = $4 & 3; //@line 9809
   $9 = ($8 | 0) == 0; //@line 9810
   if ($9) {
    return;
   }
   $10 = 0 - $7 | 0; //@line 9814
   $11 = $0 + $10 | 0; //@line 9815
   $12 = $7 + $1 | 0; //@line 9816
   $13 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 9817
   $14 = $11 >>> 0 < $13 >>> 0; //@line 9818
   if ($14) {
    _abort(); //@line 9820
   }
   $15 = SAFE_HEAP_LOAD(11316 | 0, 4, 0) | 0 | 0; //@line 9823
   $16 = ($15 | 0) == ($11 | 0); //@line 9824
   if ($16) {
    $101 = $2 + 4 | 0; //@line 9826
    $102 = SAFE_HEAP_LOAD($101 | 0, 4, 0) | 0 | 0; //@line 9827
    $103 = $102 & 3; //@line 9828
    $104 = ($103 | 0) == 3; //@line 9829
    if (!$104) {
     $$1 = $11; //@line 9831
     $$1416 = $12; //@line 9831
     break;
    }
    $105 = $11 + 4 | 0; //@line 9834
    $106 = $12 | 1; //@line 9835
    $107 = $102 & -2; //@line 9836
    SAFE_HEAP_STORE(11304 | 0, $12 | 0, 4);
    SAFE_HEAP_STORE($101 | 0, $107 | 0, 4);
    SAFE_HEAP_STORE($105 | 0, $106 | 0, 4);
    SAFE_HEAP_STORE($2 | 0, $12 | 0, 4);
    return;
   }
   $17 = $7 >>> 3; //@line 9843
   $18 = $7 >>> 0 < 256; //@line 9844
   if ($18) {
    $19 = $11 + 8 | 0; //@line 9846
    $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 9847
    $21 = $11 + 12 | 0; //@line 9848
    $22 = SAFE_HEAP_LOAD($21 | 0, 4, 0) | 0 | 0; //@line 9849
    $23 = $17 << 1; //@line 9850
    $24 = 11336 + ($23 << 2) | 0; //@line 9851
    $25 = ($20 | 0) == ($24 | 0); //@line 9852
    if (!$25) {
     $26 = $13 >>> 0 > $20 >>> 0; //@line 9854
     if ($26) {
      _abort(); //@line 9856
     }
     $27 = $20 + 12 | 0; //@line 9859
     $28 = SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0; //@line 9860
     $29 = ($28 | 0) == ($11 | 0); //@line 9861
     if (!$29) {
      _abort(); //@line 9863
     }
    }
    $30 = ($22 | 0) == ($20 | 0); //@line 9867
    if ($30) {
     $31 = 1 << $17; //@line 9869
     $32 = $31 ^ -1; //@line 9870
     $33 = SAFE_HEAP_LOAD(2824 * 4 | 0, 4, 0) | 0 | 0; //@line 9871
     $34 = $33 & $32; //@line 9872
     SAFE_HEAP_STORE(2824 * 4 | 0, $34 | 0, 4);
     $$1 = $11; //@line 9874
     $$1416 = $12; //@line 9874
     break;
    }
    $35 = ($22 | 0) == ($24 | 0); //@line 9877
    if ($35) {
     $$pre29 = $22 + 8 | 0; //@line 9879
     $$pre$phi30Z2D = $$pre29; //@line 9880
    } else {
     $36 = $13 >>> 0 > $22 >>> 0; //@line 9882
     if ($36) {
      _abort(); //@line 9884
     }
     $37 = $22 + 8 | 0; //@line 9887
     $38 = SAFE_HEAP_LOAD($37 | 0, 4, 0) | 0 | 0; //@line 9888
     $39 = ($38 | 0) == ($11 | 0); //@line 9889
     if ($39) {
      $$pre$phi30Z2D = $37; //@line 9891
     } else {
      _abort(); //@line 9893
     }
    }
    $40 = $20 + 12 | 0; //@line 9897
    SAFE_HEAP_STORE($40 | 0, $22 | 0, 4);
    SAFE_HEAP_STORE($$pre$phi30Z2D | 0, $20 | 0, 4);
    $$1 = $11; //@line 9900
    $$1416 = $12; //@line 9900
    break;
   }
   $41 = $11 + 24 | 0; //@line 9903
   $42 = SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0; //@line 9904
   $43 = $11 + 12 | 0; //@line 9905
   $44 = SAFE_HEAP_LOAD($43 | 0, 4, 0) | 0 | 0; //@line 9906
   $45 = ($44 | 0) == ($11 | 0); //@line 9907
   do {
    if ($45) {
     $55 = $11 + 16 | 0; //@line 9910
     $56 = $55 + 4 | 0; //@line 9911
     $57 = SAFE_HEAP_LOAD($56 | 0, 4, 0) | 0 | 0; //@line 9912
     $58 = ($57 | 0) == (0 | 0); //@line 9913
     if ($58) {
      $59 = SAFE_HEAP_LOAD($55 | 0, 4, 0) | 0 | 0; //@line 9915
      $60 = ($59 | 0) == (0 | 0); //@line 9916
      if ($60) {
       $$3 = 0; //@line 9918
       break;
      } else {
       $$1424$ph = $59; //@line 9921
       $$1427$ph = $55; //@line 9921
      }
     } else {
      $$1424$ph = $57; //@line 9924
      $$1427$ph = $56; //@line 9924
     }
     $$1424 = $$1424$ph; //@line 9926
     $$1427 = $$1427$ph; //@line 9926
     while (1) {
      $61 = $$1424 + 20 | 0; //@line 9928
      $62 = SAFE_HEAP_LOAD($61 | 0, 4, 0) | 0 | 0; //@line 9929
      $63 = ($62 | 0) == (0 | 0); //@line 9930
      if ($63) {
       $64 = $$1424 + 16 | 0; //@line 9932
       $65 = SAFE_HEAP_LOAD($64 | 0, 4, 0) | 0 | 0; //@line 9933
       $66 = ($65 | 0) == (0 | 0); //@line 9934
       if ($66) {
        break;
       } else {
        $$1424$be = $65; //@line 9938
        $$1427$be = $64; //@line 9938
       }
      } else {
       $$1424$be = $62; //@line 9941
       $$1427$be = $61; //@line 9941
      }
      $$1424 = $$1424$be; //@line 9943
      $$1427 = $$1427$be; //@line 9943
     }
     $67 = $13 >>> 0 > $$1427 >>> 0; //@line 9945
     if ($67) {
      _abort(); //@line 9947
     } else {
      SAFE_HEAP_STORE($$1427 | 0, 0 | 0, 4);
      $$3 = $$1424; //@line 9951
      break;
     }
    } else {
     $46 = $11 + 8 | 0; //@line 9955
     $47 = SAFE_HEAP_LOAD($46 | 0, 4, 0) | 0 | 0; //@line 9956
     $48 = $13 >>> 0 > $47 >>> 0; //@line 9957
     if ($48) {
      _abort(); //@line 9959
     }
     $49 = $47 + 12 | 0; //@line 9962
     $50 = SAFE_HEAP_LOAD($49 | 0, 4, 0) | 0 | 0; //@line 9963
     $51 = ($50 | 0) == ($11 | 0); //@line 9964
     if (!$51) {
      _abort(); //@line 9966
     }
     $52 = $44 + 8 | 0; //@line 9969
     $53 = SAFE_HEAP_LOAD($52 | 0, 4, 0) | 0 | 0; //@line 9970
     $54 = ($53 | 0) == ($11 | 0); //@line 9971
     if ($54) {
      SAFE_HEAP_STORE($49 | 0, $44 | 0, 4);
      SAFE_HEAP_STORE($52 | 0, $47 | 0, 4);
      $$3 = $44; //@line 9975
      break;
     } else {
      _abort(); //@line 9978
     }
    }
   } while (0);
   $68 = ($42 | 0) == (0 | 0); //@line 9983
   if ($68) {
    $$1 = $11; //@line 9985
    $$1416 = $12; //@line 9985
   } else {
    $69 = $11 + 28 | 0; //@line 9987
    $70 = SAFE_HEAP_LOAD($69 | 0, 4, 0) | 0 | 0; //@line 9988
    $71 = 11600 + ($70 << 2) | 0; //@line 9989
    $72 = SAFE_HEAP_LOAD($71 | 0, 4, 0) | 0 | 0; //@line 9990
    $73 = ($72 | 0) == ($11 | 0); //@line 9991
    do {
     if ($73) {
      SAFE_HEAP_STORE($71 | 0, $$3 | 0, 4);
      $cond = ($$3 | 0) == (0 | 0); //@line 9995
      if ($cond) {
       $74 = 1 << $70; //@line 9997
       $75 = $74 ^ -1; //@line 9998
       $76 = SAFE_HEAP_LOAD(11300 | 0, 4, 0) | 0 | 0; //@line 9999
       $77 = $76 & $75; //@line 10000
       SAFE_HEAP_STORE(11300 | 0, $77 | 0, 4);
       $$1 = $11; //@line 10002
       $$1416 = $12; //@line 10002
       break L1;
      }
     } else {
      $78 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 10006
      $79 = $78 >>> 0 > $42 >>> 0; //@line 10007
      if ($79) {
       _abort(); //@line 10009
      } else {
       $80 = $42 + 16 | 0; //@line 10012
       $81 = SAFE_HEAP_LOAD($80 | 0, 4, 0) | 0 | 0; //@line 10013
       $82 = ($81 | 0) == ($11 | 0); //@line 10014
       $83 = $42 + 20 | 0; //@line 10015
       $$sink = $82 ? $80 : $83; //@line 10016
       SAFE_HEAP_STORE($$sink | 0, $$3 | 0, 4);
       $84 = ($$3 | 0) == (0 | 0); //@line 10018
       if ($84) {
        $$1 = $11; //@line 10020
        $$1416 = $12; //@line 10020
        break L1;
       } else {
        break;
       }
      }
     }
    } while (0);
    $85 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 10028
    $86 = $85 >>> 0 > $$3 >>> 0; //@line 10029
    if ($86) {
     _abort(); //@line 10031
    }
    $87 = $$3 + 24 | 0; //@line 10034
    SAFE_HEAP_STORE($87 | 0, $42 | 0, 4);
    $88 = $11 + 16 | 0; //@line 10036
    $89 = SAFE_HEAP_LOAD($88 | 0, 4, 0) | 0 | 0; //@line 10037
    $90 = ($89 | 0) == (0 | 0); //@line 10038
    do {
     if (!$90) {
      $91 = $85 >>> 0 > $89 >>> 0; //@line 10041
      if ($91) {
       _abort(); //@line 10043
      } else {
       $92 = $$3 + 16 | 0; //@line 10046
       SAFE_HEAP_STORE($92 | 0, $89 | 0, 4);
       $93 = $89 + 24 | 0; //@line 10048
       SAFE_HEAP_STORE($93 | 0, $$3 | 0, 4);
       break;
      }
     }
    } while (0);
    $94 = $88 + 4 | 0; //@line 10054
    $95 = SAFE_HEAP_LOAD($94 | 0, 4, 0) | 0 | 0; //@line 10055
    $96 = ($95 | 0) == (0 | 0); //@line 10056
    if ($96) {
     $$1 = $11; //@line 10058
     $$1416 = $12; //@line 10058
    } else {
     $97 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 10060
     $98 = $97 >>> 0 > $95 >>> 0; //@line 10061
     if ($98) {
      _abort(); //@line 10063
     } else {
      $99 = $$3 + 20 | 0; //@line 10066
      SAFE_HEAP_STORE($99 | 0, $95 | 0, 4);
      $100 = $95 + 24 | 0; //@line 10068
      SAFE_HEAP_STORE($100 | 0, $$3 | 0, 4);
      $$1 = $11; //@line 10070
      $$1416 = $12; //@line 10070
      break;
     }
    }
   }
  } else {
   $$1 = $0; //@line 10076
   $$1416 = $1; //@line 10076
  }
 } while (0);
 $108 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 10079
 $109 = $2 >>> 0 < $108 >>> 0; //@line 10080
 if ($109) {
  _abort(); //@line 10082
 }
 $110 = $2 + 4 | 0; //@line 10085
 $111 = SAFE_HEAP_LOAD($110 | 0, 4, 0) | 0 | 0; //@line 10086
 $112 = $111 & 2; //@line 10087
 $113 = ($112 | 0) == 0; //@line 10088
 if ($113) {
  $114 = SAFE_HEAP_LOAD(11320 | 0, 4, 0) | 0 | 0; //@line 10090
  $115 = ($114 | 0) == ($2 | 0); //@line 10091
  if ($115) {
   $116 = SAFE_HEAP_LOAD(11308 | 0, 4, 0) | 0 | 0; //@line 10093
   $117 = $116 + $$1416 | 0; //@line 10094
   SAFE_HEAP_STORE(11308 | 0, $117 | 0, 4);
   SAFE_HEAP_STORE(11320 | 0, $$1 | 0, 4);
   $118 = $117 | 1; //@line 10097
   $119 = $$1 + 4 | 0; //@line 10098
   SAFE_HEAP_STORE($119 | 0, $118 | 0, 4);
   $120 = SAFE_HEAP_LOAD(11316 | 0, 4, 0) | 0 | 0; //@line 10100
   $121 = ($$1 | 0) == ($120 | 0); //@line 10101
   if (!$121) {
    return;
   }
   SAFE_HEAP_STORE(11316 | 0, 0 | 0, 4);
   SAFE_HEAP_STORE(11304 | 0, 0 | 0, 4);
   return;
  }
  $122 = SAFE_HEAP_LOAD(11316 | 0, 4, 0) | 0 | 0; //@line 10109
  $123 = ($122 | 0) == ($2 | 0); //@line 10110
  if ($123) {
   $124 = SAFE_HEAP_LOAD(11304 | 0, 4, 0) | 0 | 0; //@line 10112
   $125 = $124 + $$1416 | 0; //@line 10113
   SAFE_HEAP_STORE(11304 | 0, $125 | 0, 4);
   SAFE_HEAP_STORE(11316 | 0, $$1 | 0, 4);
   $126 = $125 | 1; //@line 10116
   $127 = $$1 + 4 | 0; //@line 10117
   SAFE_HEAP_STORE($127 | 0, $126 | 0, 4);
   $128 = $$1 + $125 | 0; //@line 10119
   SAFE_HEAP_STORE($128 | 0, $125 | 0, 4);
   return;
  }
  $129 = $111 & -8; //@line 10123
  $130 = $129 + $$1416 | 0; //@line 10124
  $131 = $111 >>> 3; //@line 10125
  $132 = $111 >>> 0 < 256; //@line 10126
  L99 : do {
   if ($132) {
    $133 = $2 + 8 | 0; //@line 10129
    $134 = SAFE_HEAP_LOAD($133 | 0, 4, 0) | 0 | 0; //@line 10130
    $135 = $2 + 12 | 0; //@line 10131
    $136 = SAFE_HEAP_LOAD($135 | 0, 4, 0) | 0 | 0; //@line 10132
    $137 = $131 << 1; //@line 10133
    $138 = 11336 + ($137 << 2) | 0; //@line 10134
    $139 = ($134 | 0) == ($138 | 0); //@line 10135
    if (!$139) {
     $140 = $108 >>> 0 > $134 >>> 0; //@line 10137
     if ($140) {
      _abort(); //@line 10139
     }
     $141 = $134 + 12 | 0; //@line 10142
     $142 = SAFE_HEAP_LOAD($141 | 0, 4, 0) | 0 | 0; //@line 10143
     $143 = ($142 | 0) == ($2 | 0); //@line 10144
     if (!$143) {
      _abort(); //@line 10146
     }
    }
    $144 = ($136 | 0) == ($134 | 0); //@line 10150
    if ($144) {
     $145 = 1 << $131; //@line 10152
     $146 = $145 ^ -1; //@line 10153
     $147 = SAFE_HEAP_LOAD(2824 * 4 | 0, 4, 0) | 0 | 0; //@line 10154
     $148 = $147 & $146; //@line 10155
     SAFE_HEAP_STORE(2824 * 4 | 0, $148 | 0, 4);
     break;
    }
    $149 = ($136 | 0) == ($138 | 0); //@line 10159
    if ($149) {
     $$pre27 = $136 + 8 | 0; //@line 10161
     $$pre$phi28Z2D = $$pre27; //@line 10162
    } else {
     $150 = $108 >>> 0 > $136 >>> 0; //@line 10164
     if ($150) {
      _abort(); //@line 10166
     }
     $151 = $136 + 8 | 0; //@line 10169
     $152 = SAFE_HEAP_LOAD($151 | 0, 4, 0) | 0 | 0; //@line 10170
     $153 = ($152 | 0) == ($2 | 0); //@line 10171
     if ($153) {
      $$pre$phi28Z2D = $151; //@line 10173
     } else {
      _abort(); //@line 10175
     }
    }
    $154 = $134 + 12 | 0; //@line 10179
    SAFE_HEAP_STORE($154 | 0, $136 | 0, 4);
    SAFE_HEAP_STORE($$pre$phi28Z2D | 0, $134 | 0, 4);
   } else {
    $155 = $2 + 24 | 0; //@line 10183
    $156 = SAFE_HEAP_LOAD($155 | 0, 4, 0) | 0 | 0; //@line 10184
    $157 = $2 + 12 | 0; //@line 10185
    $158 = SAFE_HEAP_LOAD($157 | 0, 4, 0) | 0 | 0; //@line 10186
    $159 = ($158 | 0) == ($2 | 0); //@line 10187
    do {
     if ($159) {
      $169 = $2 + 16 | 0; //@line 10190
      $170 = $169 + 4 | 0; //@line 10191
      $171 = SAFE_HEAP_LOAD($170 | 0, 4, 0) | 0 | 0; //@line 10192
      $172 = ($171 | 0) == (0 | 0); //@line 10193
      if ($172) {
       $173 = SAFE_HEAP_LOAD($169 | 0, 4, 0) | 0 | 0; //@line 10195
       $174 = ($173 | 0) == (0 | 0); //@line 10196
       if ($174) {
        $$3433 = 0; //@line 10198
        break;
       } else {
        $$1431$ph = $173; //@line 10201
        $$1435$ph = $169; //@line 10201
       }
      } else {
       $$1431$ph = $171; //@line 10204
       $$1435$ph = $170; //@line 10204
      }
      $$1431 = $$1431$ph; //@line 10206
      $$1435 = $$1435$ph; //@line 10206
      while (1) {
       $175 = $$1431 + 20 | 0; //@line 10208
       $176 = SAFE_HEAP_LOAD($175 | 0, 4, 0) | 0 | 0; //@line 10209
       $177 = ($176 | 0) == (0 | 0); //@line 10210
       if ($177) {
        $178 = $$1431 + 16 | 0; //@line 10212
        $179 = SAFE_HEAP_LOAD($178 | 0, 4, 0) | 0 | 0; //@line 10213
        $180 = ($179 | 0) == (0 | 0); //@line 10214
        if ($180) {
         break;
        } else {
         $$1431$be = $179; //@line 10218
         $$1435$be = $178; //@line 10218
        }
       } else {
        $$1431$be = $176; //@line 10221
        $$1435$be = $175; //@line 10221
       }
       $$1431 = $$1431$be; //@line 10223
       $$1435 = $$1435$be; //@line 10223
      }
      $181 = $108 >>> 0 > $$1435 >>> 0; //@line 10225
      if ($181) {
       _abort(); //@line 10227
      } else {
       SAFE_HEAP_STORE($$1435 | 0, 0 | 0, 4);
       $$3433 = $$1431; //@line 10231
       break;
      }
     } else {
      $160 = $2 + 8 | 0; //@line 10235
      $161 = SAFE_HEAP_LOAD($160 | 0, 4, 0) | 0 | 0; //@line 10236
      $162 = $108 >>> 0 > $161 >>> 0; //@line 10237
      if ($162) {
       _abort(); //@line 10239
      }
      $163 = $161 + 12 | 0; //@line 10242
      $164 = SAFE_HEAP_LOAD($163 | 0, 4, 0) | 0 | 0; //@line 10243
      $165 = ($164 | 0) == ($2 | 0); //@line 10244
      if (!$165) {
       _abort(); //@line 10246
      }
      $166 = $158 + 8 | 0; //@line 10249
      $167 = SAFE_HEAP_LOAD($166 | 0, 4, 0) | 0 | 0; //@line 10250
      $168 = ($167 | 0) == ($2 | 0); //@line 10251
      if ($168) {
       SAFE_HEAP_STORE($163 | 0, $158 | 0, 4);
       SAFE_HEAP_STORE($166 | 0, $161 | 0, 4);
       $$3433 = $158; //@line 10255
       break;
      } else {
       _abort(); //@line 10258
      }
     }
    } while (0);
    $182 = ($156 | 0) == (0 | 0); //@line 10263
    if (!$182) {
     $183 = $2 + 28 | 0; //@line 10265
     $184 = SAFE_HEAP_LOAD($183 | 0, 4, 0) | 0 | 0; //@line 10266
     $185 = 11600 + ($184 << 2) | 0; //@line 10267
     $186 = SAFE_HEAP_LOAD($185 | 0, 4, 0) | 0 | 0; //@line 10268
     $187 = ($186 | 0) == ($2 | 0); //@line 10269
     do {
      if ($187) {
       SAFE_HEAP_STORE($185 | 0, $$3433 | 0, 4);
       $cond17 = ($$3433 | 0) == (0 | 0); //@line 10273
       if ($cond17) {
        $188 = 1 << $184; //@line 10275
        $189 = $188 ^ -1; //@line 10276
        $190 = SAFE_HEAP_LOAD(11300 | 0, 4, 0) | 0 | 0; //@line 10277
        $191 = $190 & $189; //@line 10278
        SAFE_HEAP_STORE(11300 | 0, $191 | 0, 4);
        break L99;
       }
      } else {
       $192 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 10283
       $193 = $192 >>> 0 > $156 >>> 0; //@line 10284
       if ($193) {
        _abort(); //@line 10286
       } else {
        $194 = $156 + 16 | 0; //@line 10289
        $195 = SAFE_HEAP_LOAD($194 | 0, 4, 0) | 0 | 0; //@line 10290
        $196 = ($195 | 0) == ($2 | 0); //@line 10291
        $197 = $156 + 20 | 0; //@line 10292
        $$sink41 = $196 ? $194 : $197; //@line 10293
        SAFE_HEAP_STORE($$sink41 | 0, $$3433 | 0, 4);
        $198 = ($$3433 | 0) == (0 | 0); //@line 10295
        if ($198) {
         break L99;
        } else {
         break;
        }
       }
      }
     } while (0);
     $199 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 10304
     $200 = $199 >>> 0 > $$3433 >>> 0; //@line 10305
     if ($200) {
      _abort(); //@line 10307
     }
     $201 = $$3433 + 24 | 0; //@line 10310
     SAFE_HEAP_STORE($201 | 0, $156 | 0, 4);
     $202 = $2 + 16 | 0; //@line 10312
     $203 = SAFE_HEAP_LOAD($202 | 0, 4, 0) | 0 | 0; //@line 10313
     $204 = ($203 | 0) == (0 | 0); //@line 10314
     do {
      if (!$204) {
       $205 = $199 >>> 0 > $203 >>> 0; //@line 10317
       if ($205) {
        _abort(); //@line 10319
       } else {
        $206 = $$3433 + 16 | 0; //@line 10322
        SAFE_HEAP_STORE($206 | 0, $203 | 0, 4);
        $207 = $203 + 24 | 0; //@line 10324
        SAFE_HEAP_STORE($207 | 0, $$3433 | 0, 4);
        break;
       }
      }
     } while (0);
     $208 = $202 + 4 | 0; //@line 10330
     $209 = SAFE_HEAP_LOAD($208 | 0, 4, 0) | 0 | 0; //@line 10331
     $210 = ($209 | 0) == (0 | 0); //@line 10332
     if (!$210) {
      $211 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 10334
      $212 = $211 >>> 0 > $209 >>> 0; //@line 10335
      if ($212) {
       _abort(); //@line 10337
      } else {
       $213 = $$3433 + 20 | 0; //@line 10340
       SAFE_HEAP_STORE($213 | 0, $209 | 0, 4);
       $214 = $209 + 24 | 0; //@line 10342
       SAFE_HEAP_STORE($214 | 0, $$3433 | 0, 4);
       break;
      }
     }
    }
   }
  } while (0);
  $215 = $130 | 1; //@line 10350
  $216 = $$1 + 4 | 0; //@line 10351
  SAFE_HEAP_STORE($216 | 0, $215 | 0, 4);
  $217 = $$1 + $130 | 0; //@line 10353
  SAFE_HEAP_STORE($217 | 0, $130 | 0, 4);
  $218 = SAFE_HEAP_LOAD(11316 | 0, 4, 0) | 0 | 0; //@line 10355
  $219 = ($$1 | 0) == ($218 | 0); //@line 10356
  if ($219) {
   SAFE_HEAP_STORE(11304 | 0, $130 | 0, 4);
   return;
  } else {
   $$2 = $130; //@line 10361
  }
 } else {
  $220 = $111 & -2; //@line 10364
  SAFE_HEAP_STORE($110 | 0, $220 | 0, 4);
  $221 = $$1416 | 1; //@line 10366
  $222 = $$1 + 4 | 0; //@line 10367
  SAFE_HEAP_STORE($222 | 0, $221 | 0, 4);
  $223 = $$1 + $$1416 | 0; //@line 10369
  SAFE_HEAP_STORE($223 | 0, $$1416 | 0, 4);
  $$2 = $$1416; //@line 10371
 }
 $224 = $$2 >>> 3; //@line 10373
 $225 = $$2 >>> 0 < 256; //@line 10374
 if ($225) {
  $226 = $224 << 1; //@line 10376
  $227 = 11336 + ($226 << 2) | 0; //@line 10377
  $228 = SAFE_HEAP_LOAD(2824 * 4 | 0, 4, 0) | 0 | 0; //@line 10378
  $229 = 1 << $224; //@line 10379
  $230 = $228 & $229; //@line 10380
  $231 = ($230 | 0) == 0; //@line 10381
  if ($231) {
   $232 = $228 | $229; //@line 10383
   SAFE_HEAP_STORE(2824 * 4 | 0, $232 | 0, 4);
   $$pre = $227 + 8 | 0; //@line 10385
   $$0436 = $227; //@line 10386
   $$pre$phiZ2D = $$pre; //@line 10386
  } else {
   $233 = $227 + 8 | 0; //@line 10388
   $234 = SAFE_HEAP_LOAD($233 | 0, 4, 0) | 0 | 0; //@line 10389
   $235 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 10390
   $236 = $235 >>> 0 > $234 >>> 0; //@line 10391
   if ($236) {
    _abort(); //@line 10393
   } else {
    $$0436 = $234; //@line 10396
    $$pre$phiZ2D = $233; //@line 10396
   }
  }
  SAFE_HEAP_STORE($$pre$phiZ2D | 0, $$1 | 0, 4);
  $237 = $$0436 + 12 | 0; //@line 10400
  SAFE_HEAP_STORE($237 | 0, $$1 | 0, 4);
  $238 = $$1 + 8 | 0; //@line 10402
  SAFE_HEAP_STORE($238 | 0, $$0436 | 0, 4);
  $239 = $$1 + 12 | 0; //@line 10404
  SAFE_HEAP_STORE($239 | 0, $227 | 0, 4);
  return;
 }
 $240 = $$2 >>> 8; //@line 10408
 $241 = ($240 | 0) == 0; //@line 10409
 if ($241) {
  $$0429 = 0; //@line 10411
 } else {
  $242 = $$2 >>> 0 > 16777215; //@line 10413
  if ($242) {
   $$0429 = 31; //@line 10415
  } else {
   $243 = $240 + 1048320 | 0; //@line 10417
   $244 = $243 >>> 16; //@line 10418
   $245 = $244 & 8; //@line 10419
   $246 = $240 << $245; //@line 10420
   $247 = $246 + 520192 | 0; //@line 10421
   $248 = $247 >>> 16; //@line 10422
   $249 = $248 & 4; //@line 10423
   $250 = $249 | $245; //@line 10424
   $251 = $246 << $249; //@line 10425
   $252 = $251 + 245760 | 0; //@line 10426
   $253 = $252 >>> 16; //@line 10427
   $254 = $253 & 2; //@line 10428
   $255 = $250 | $254; //@line 10429
   $256 = 14 - $255 | 0; //@line 10430
   $257 = $251 << $254; //@line 10431
   $258 = $257 >>> 15; //@line 10432
   $259 = $256 + $258 | 0; //@line 10433
   $260 = $259 << 1; //@line 10434
   $261 = $259 + 7 | 0; //@line 10435
   $262 = $$2 >>> $261; //@line 10436
   $263 = $262 & 1; //@line 10437
   $264 = $263 | $260; //@line 10438
   $$0429 = $264; //@line 10439
  }
 }
 $265 = 11600 + ($$0429 << 2) | 0; //@line 10442
 $266 = $$1 + 28 | 0; //@line 10443
 SAFE_HEAP_STORE($266 | 0, $$0429 | 0, 4);
 $267 = $$1 + 16 | 0; //@line 10445
 $268 = $$1 + 20 | 0; //@line 10446
 SAFE_HEAP_STORE($268 | 0, 0 | 0, 4);
 SAFE_HEAP_STORE($267 | 0, 0 | 0, 4);
 $269 = SAFE_HEAP_LOAD(11300 | 0, 4, 0) | 0 | 0; //@line 10449
 $270 = 1 << $$0429; //@line 10450
 $271 = $269 & $270; //@line 10451
 $272 = ($271 | 0) == 0; //@line 10452
 if ($272) {
  $273 = $269 | $270; //@line 10454
  SAFE_HEAP_STORE(11300 | 0, $273 | 0, 4);
  SAFE_HEAP_STORE($265 | 0, $$1 | 0, 4);
  $274 = $$1 + 24 | 0; //@line 10457
  SAFE_HEAP_STORE($274 | 0, $265 | 0, 4);
  $275 = $$1 + 12 | 0; //@line 10459
  SAFE_HEAP_STORE($275 | 0, $$1 | 0, 4);
  $276 = $$1 + 8 | 0; //@line 10461
  SAFE_HEAP_STORE($276 | 0, $$1 | 0, 4);
  return;
 }
 $277 = SAFE_HEAP_LOAD($265 | 0, 4, 0) | 0 | 0; //@line 10465
 $278 = $277 + 4 | 0; //@line 10466
 $279 = SAFE_HEAP_LOAD($278 | 0, 4, 0) | 0 | 0; //@line 10467
 $280 = $279 & -8; //@line 10468
 $281 = ($280 | 0) == ($$2 | 0); //@line 10469
 L189 : do {
  if ($281) {
   $$0418$lcssa = $277; //@line 10472
  } else {
   $282 = ($$0429 | 0) == 31; //@line 10474
   $283 = $$0429 >>> 1; //@line 10475
   $284 = 25 - $283 | 0; //@line 10476
   $285 = $282 ? 0 : $284; //@line 10477
   $286 = $$2 << $285; //@line 10478
   $$041722 = $286; //@line 10479
   $$041821 = $277; //@line 10479
   while (1) {
    $293 = $$041722 >>> 31; //@line 10481
    $294 = ($$041821 + 16 | 0) + ($293 << 2) | 0; //@line 10482
    $289 = SAFE_HEAP_LOAD($294 | 0, 4, 0) | 0 | 0; //@line 10483
    $295 = ($289 | 0) == (0 | 0); //@line 10484
    if ($295) {
     break;
    }
    $287 = $$041722 << 1; //@line 10488
    $288 = $289 + 4 | 0; //@line 10489
    $290 = SAFE_HEAP_LOAD($288 | 0, 4, 0) | 0 | 0; //@line 10490
    $291 = $290 & -8; //@line 10491
    $292 = ($291 | 0) == ($$2 | 0); //@line 10492
    if ($292) {
     $$0418$lcssa = $289; //@line 10494
     break L189;
    } else {
     $$041722 = $287; //@line 10497
     $$041821 = $289; //@line 10497
    }
   }
   $296 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 10500
   $297 = $296 >>> 0 > $294 >>> 0; //@line 10501
   if ($297) {
    _abort(); //@line 10503
   }
   SAFE_HEAP_STORE($294 | 0, $$1 | 0, 4);
   $298 = $$1 + 24 | 0; //@line 10507
   SAFE_HEAP_STORE($298 | 0, $$041821 | 0, 4);
   $299 = $$1 + 12 | 0; //@line 10509
   SAFE_HEAP_STORE($299 | 0, $$1 | 0, 4);
   $300 = $$1 + 8 | 0; //@line 10511
   SAFE_HEAP_STORE($300 | 0, $$1 | 0, 4);
   return;
  }
 } while (0);
 $301 = $$0418$lcssa + 8 | 0; //@line 10516
 $302 = SAFE_HEAP_LOAD($301 | 0, 4, 0) | 0 | 0; //@line 10517
 $303 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 10518
 $304 = $303 >>> 0 <= $$0418$lcssa >>> 0; //@line 10519
 $305 = $303 >>> 0 <= $302 >>> 0; //@line 10520
 $306 = $305 & $304; //@line 10521
 if (!$306) {
  _abort(); //@line 10523
 }
 $307 = $302 + 12 | 0; //@line 10526
 SAFE_HEAP_STORE($307 | 0, $$1 | 0, 4);
 SAFE_HEAP_STORE($301 | 0, $$1 | 0, 4);
 $308 = $$1 + 8 | 0; //@line 10529
 SAFE_HEAP_STORE($308 | 0, $302 | 0, 4);
 $309 = $$1 + 12 | 0; //@line 10531
 SAFE_HEAP_STORE($309 | 0, $$0418$lcssa | 0, 4);
 $310 = $$1 + 24 | 0; //@line 10533
 SAFE_HEAP_STORE($310 | 0, 0 | 0, 4);
 return;
}
function _ContactPoints($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 288
 $1 = $1 | 0; //@line 289
 $2 = $2 | 0; //@line 290
 $3 = $3 | 0; //@line 291
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy14 = 0, $$byval_copy15 = 0, $$byval_copy16 = 0, $$byval_copy17 = 0, $$byval_copy18 = 0, $$byval_copy19 = 0, $$byval_copy2 = 0, $$byval_copy20 = 0, $$byval_copy21 = 0, $$byval_copy22 = 0, $$byval_copy23 = 0, $$byval_copy24 = 0, $$byval_copy25 = 0, $$byval_copy26 = 0; //@line 292
 var $$byval_copy27 = 0, $$byval_copy28 = 0, $$byval_copy29 = 0, $$byval_copy3 = 0, $$byval_copy30 = 0, $$byval_copy31 = 0, $$byval_copy32 = 0, $$byval_copy33 = 0, $$byval_copy34 = 0, $$byval_copy35 = 0, $$byval_copy36 = 0, $$byval_copy37 = 0, $$byval_copy38 = 0, $$byval_copy39 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0; //@line 293
 var $10 = 0.0, $100 = 0, $101 = 0.0, $102 = 0.0, $103 = 0, $104 = 0.0, $105 = 0.0, $106 = 0.0, $107 = 0.0, $108 = 0.0, $109 = 0.0, $11 = 0.0, $110 = 0.0, $111 = 0.0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0;
 var $118 = 0, $119 = 0, $12 = 0.0, $120 = 0, $121 = 0, $122 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0.0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0; //@line 295
 var $27 = 0, $28 = 0.0, $29 = 0, $30 = 0, $31 = 0, $32 = 0.0, $33 = 0, $34 = 0.0, $35 = 0.0, $36 = 0, $37 = 0.0, $38 = 0.0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0.0, $44 = 0, $45 = 0.0; //@line 296
 var $46 = 0.0, $47 = 0, $48 = 0.0, $49 = 0.0, $5 = 0.0, $50 = 0.0, $51 = 0.0, $52 = 0.0, $53 = 0.0, $54 = 0.0, $55 = 0.0, $56 = 0.0, $57 = 0.0, $58 = 0.0, $59 = 0, $6 = 0, $60 = 0.0, $61 = 0, $62 = 0.0, $63 = 0.0;
 var $64 = 0.0, $65 = 0.0, $66 = 0.0, $67 = 0.0, $68 = 0, $69 = 0.0, $7 = 0.0, $70 = 0.0, $71 = 0, $72 = 0.0, $73 = 0.0, $74 = 0.0, $75 = 0.0, $76 = 0.0, $77 = 0.0, $78 = 0.0, $79 = 0.0, $8 = 0.0, $80 = 0, $81 = 0;
 var $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0.0, $90 = 0, $91 = 0, $92 = 0.0, $93 = 0, $94 = 0.0, $95 = 0.0, $96 = 0.0, $97 = 0.0, $98 = 0.0, $99 = 0.0, label = 0; //@line 299
 var sp = 0; //@line 300
 sp = STACKTOP; //@line 301
 STACKTOP = STACKTOP + 976 | 0; //@line 302
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(976 | 0); //@line 302
 $$byval_copy39 = sp + 936 | 0; //@line 303
 $$byval_copy38 = sp + 920 | 0; //@line 304
 $$byval_copy37 = sp + 904 | 0; //@line 305
 $$byval_copy36 = sp + 888 | 0; //@line 306
 $$byval_copy35 = sp + 872 | 0; //@line 307
 $$byval_copy34 = sp + 856 | 0; //@line 308
 $$byval_copy33 = sp + 840 | 0; //@line 309
 $$byval_copy32 = sp + 824 | 0; //@line 310
 $$byval_copy31 = sp + 808 | 0; //@line 311
 $$byval_copy30 = sp + 792 | 0; //@line 312
 $$byval_copy29 = sp + 776 | 0; //@line 313
 $$byval_copy28 = sp + 760 | 0; //@line 314
 $$byval_copy27 = sp + 744 | 0; //@line 315
 $$byval_copy26 = sp + 728 | 0; //@line 316
 $$byval_copy25 = sp + 712 | 0; //@line 317
 $$byval_copy24 = sp + 696 | 0; //@line 318
 $$byval_copy23 = sp + 680 | 0; //@line 319
 $$byval_copy22 = sp + 664 | 0; //@line 320
 $$byval_copy21 = sp + 648 | 0; //@line 321
 $$byval_copy20 = sp + 632 | 0; //@line 322
 $$byval_copy19 = sp + 616 | 0; //@line 323
 $$byval_copy18 = sp + 600 | 0; //@line 324
 $$byval_copy17 = sp + 584 | 0; //@line 325
 $$byval_copy16 = sp + 568 | 0; //@line 326
 $$byval_copy15 = sp + 552 | 0; //@line 327
 $$byval_copy14 = sp + 536 | 0; //@line 328
 $$byval_copy13 = sp + 520 | 0; //@line 329
 $$byval_copy12 = sp + 504 | 0; //@line 330
 $$byval_copy11 = sp + 488 | 0; //@line 331
 $$byval_copy10 = sp + 472 | 0; //@line 332
 $$byval_copy9 = sp + 456 | 0; //@line 333
 $$byval_copy8 = sp + 440 | 0; //@line 334
 $$byval_copy7 = sp + 424 | 0; //@line 335
 $$byval_copy6 = sp + 408 | 0; //@line 336
 $$byval_copy5 = sp + 392 | 0; //@line 337
 $$byval_copy4 = sp + 376 | 0; //@line 338
 $$byval_copy3 = sp + 360 | 0; //@line 339
 $$byval_copy2 = sp + 344 | 0; //@line 340
 $$byval_copy1 = sp + 328 | 0; //@line 341
 $$byval_copy = sp + 312 | 0; //@line 342
 $6 = sp + 288 | 0; //@line 343
 $13 = sp + 224 | 0; //@line 344
 $14 = sp + 208 | 0; //@line 345
 $15 = sp + 192 | 0; //@line 346
 $16 = sp + 176 | 0; //@line 347
 $17 = sp + 160 | 0; //@line 348
 $18 = sp + 144 | 0; //@line 349
 $20 = sp + 120 | 0; //@line 350
 $22 = sp + 104 | 0; //@line 351
 $23 = sp + 88 | 0; //@line 352
 $24 = sp + 72 | 0; //@line 353
 $25 = sp + 56 | 0; //@line 354
 $26 = sp + 40 | 0; //@line 355
 $27 = sp + 24 | 0; //@line 356
 $29 = sp; //@line 357
 $4 = $3; //@line 358
 $31 = $0 + 48 | 0; //@line 359
 $32 = +(+SAFE_HEAP_LOAD_D($31 | 0, 8)); //@line 360
 $33 = $1 + 48 | 0; //@line 361
 $34 = +(+SAFE_HEAP_LOAD_D($33 | 0, 8)); //@line 362
 $35 = $32 + $34; //@line 363
 $5 = $35; //@line 364
 $36 = $2 + 48 | 0; //@line 365
 $37 = +(+SAFE_HEAP_LOAD_D($36 | 0, 8)); //@line 366
 $38 = $5; //@line 367
 $39 = $37 <= $38; //@line 368
 if (!$39) {
  STACKTOP = sp; //@line 370
  return;
 }
 $40 = $4; //@line 372
 $41 = $40 + 16 | 0; //@line 373
 $42 = $2 + 32 | 0; //@line 374
 SAFE_HEAP_STORE($41 | 0, SAFE_HEAP_LOAD($42 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($41 + 4 | 0, SAFE_HEAP_LOAD($42 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($41 + 8 | 0, SAFE_HEAP_LOAD($42 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($41 + 12 | 0, SAFE_HEAP_LOAD($42 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 | 0, SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 4 | 0, SAFE_HEAP_LOAD($41 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 8 | 0, SAFE_HEAP_LOAD($41 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 12 | 0, SAFE_HEAP_LOAD($41 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $43 = +_cpvcross_63($$byval_copy, $$byval_copy1); //@line 379
 $7 = $43; //@line 380
 $44 = $0 + 24 | 0; //@line 381
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($44 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($44 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($44 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($44 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $45 = +_cpvcross_63($$byval_copy2, $$byval_copy3); //@line 384
 $8 = $45; //@line 385
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $46 = +_cpvcross_63($$byval_copy4, $$byval_copy5); //@line 388
 $9 = $46; //@line 389
 $47 = $1 + 24 | 0; //@line 390
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($47 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($47 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($47 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($47 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $48 = +_cpvcross_63($$byval_copy6, $$byval_copy7); //@line 393
 $10 = $48; //@line 394
 $49 = $8; //@line 395
 $50 = $7; //@line 396
 $51 = $49 - $50; //@line 397
 $52 = $51 + 2.2250738585072014e-308; //@line 398
 $53 = 1.0 / $52; //@line 399
 $11 = $53; //@line 400
 $54 = $10; //@line 401
 $55 = $9; //@line 402
 $56 = $54 - $55; //@line 403
 $57 = $56 + 2.2250738585072014e-308; //@line 404
 $58 = 1.0 / $57; //@line 405
 $12 = $58; //@line 406
 $59 = $0 + 48 | 0; //@line 407
 $60 = +(+SAFE_HEAP_LOAD_D($59 | 0, 8)); //@line 408
 SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_64($14, $$byval_copy8, $60); //@line 410
 $61 = $0 + 24 | 0; //@line 411
 $62 = $10; //@line 412
 $63 = $7; //@line 413
 $64 = $62 - $63; //@line 414
 $65 = $11; //@line 415
 $66 = $64 * $65; //@line 416
 $67 = +_cpfclamp01($66); //@line 417
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($61 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($61 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($61 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($61 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvlerp_65($15, $$byval_copy9, $$byval_copy10, $67); //@line 420
 SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 | 0, SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 4 | 0, SAFE_HEAP_LOAD($15 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 8 | 0, SAFE_HEAP_LOAD($15 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 12 | 0, SAFE_HEAP_LOAD($15 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_66($13, $$byval_copy11, $$byval_copy12); //@line 423
 $68 = $1 + 48 | 0; //@line 424
 $69 = +(+SAFE_HEAP_LOAD_D($68 | 0, 8)); //@line 425
 $70 = -$69; //@line 426
 SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_64($17, $$byval_copy13, $70); //@line 428
 $71 = $1 + 24 | 0; //@line 429
 $72 = $7; //@line 430
 $73 = $9; //@line 431
 $74 = $72 - $73; //@line 432
 $75 = $12; //@line 433
 $76 = $74 * $75; //@line 434
 $77 = +_cpfclamp01($76); //@line 435
 SAFE_HEAP_STORE($$byval_copy14 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy15 | 0, SAFE_HEAP_LOAD($71 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy15 + 4 | 0, SAFE_HEAP_LOAD($71 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy15 + 8 | 0, SAFE_HEAP_LOAD($71 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy15 + 12 | 0, SAFE_HEAP_LOAD($71 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvlerp_65($18, $$byval_copy14, $$byval_copy15, $77); //@line 438
 SAFE_HEAP_STORE($$byval_copy16 | 0, SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy16 + 4 | 0, SAFE_HEAP_LOAD($17 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy16 + 8 | 0, SAFE_HEAP_LOAD($17 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy16 + 12 | 0, SAFE_HEAP_LOAD($17 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy17 | 0, SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy17 + 4 | 0, SAFE_HEAP_LOAD($18 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy17 + 8 | 0, SAFE_HEAP_LOAD($18 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy17 + 12 | 0, SAFE_HEAP_LOAD($18 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_66($16, $$byval_copy16, $$byval_copy17); //@line 441
 SAFE_HEAP_STORE($$byval_copy18 | 0, SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy18 + 4 | 0, SAFE_HEAP_LOAD($16 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy18 + 8 | 0, SAFE_HEAP_LOAD($16 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy18 + 12 | 0, SAFE_HEAP_LOAD($16 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy19 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy19 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy19 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy19 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_67($20, $$byval_copy18, $$byval_copy19); //@line 444
 SAFE_HEAP_STORE($$byval_copy20 | 0, SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy20 + 4 | 0, SAFE_HEAP_LOAD($20 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy20 + 8 | 0, SAFE_HEAP_LOAD($20 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy20 + 12 | 0, SAFE_HEAP_LOAD($20 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy21 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy21 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy21 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy21 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $78 = +_cpvdot_68($$byval_copy20, $$byval_copy21); //@line 447
 $19 = $78; //@line 448
 $79 = $19; //@line 449
 $80 = $79 <= 0.0; //@line 450
 if ($80) {
  $81 = $0 + 16 | 0; //@line 452
  $82 = SAFE_HEAP_LOAD($81 | 0, 4, 0) | 0 | 0; //@line 453
  $83 = Math_imul($82, -950046239) | 0; //@line 454
  $84 = $1 + 24 | 0; //@line 455
  $85 = $84 + 16 | 0; //@line 456
  $86 = SAFE_HEAP_LOAD($85 | 0, 4, 0) | 0 | 0; //@line 457
  $87 = Math_imul($86, -950046239) | 0; //@line 458
  $88 = $83 ^ $87; //@line 459
  $21 = $88; //@line 460
  $89 = $4; //@line 461
  $90 = $21; //@line 462
  SAFE_HEAP_STORE($$byval_copy22 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy22 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy22 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy22 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy23 | 0, SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy23 + 4 | 0, SAFE_HEAP_LOAD($16 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy23 + 8 | 0, SAFE_HEAP_LOAD($16 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy23 + 12 | 0, SAFE_HEAP_LOAD($16 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpCollisionInfoPushContact($89, $$byval_copy22, $$byval_copy23, $90); //@line 465
 }
 $91 = $0 + 48 | 0; //@line 467
 $92 = +(+SAFE_HEAP_LOAD_D($91 | 0, 8)); //@line 468
 SAFE_HEAP_STORE($$byval_copy24 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy24 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy24 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy24 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_64($23, $$byval_copy24, $92); //@line 470
 $93 = $0 + 24 | 0; //@line 471
 $94 = $9; //@line 472
 $95 = $7; //@line 473
 $96 = $94 - $95; //@line 474
 $97 = $11; //@line 475
 $98 = $96 * $97; //@line 476
 $99 = +_cpfclamp01($98); //@line 477
 SAFE_HEAP_STORE($$byval_copy25 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy25 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy25 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy25 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy26 | 0, SAFE_HEAP_LOAD($93 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy26 + 4 | 0, SAFE_HEAP_LOAD($93 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy26 + 8 | 0, SAFE_HEAP_LOAD($93 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy26 + 12 | 0, SAFE_HEAP_LOAD($93 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvlerp_65($24, $$byval_copy25, $$byval_copy26, $99); //@line 480
 SAFE_HEAP_STORE($$byval_copy27 | 0, SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy27 + 4 | 0, SAFE_HEAP_LOAD($23 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy27 + 8 | 0, SAFE_HEAP_LOAD($23 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy27 + 12 | 0, SAFE_HEAP_LOAD($23 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy28 | 0, SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy28 + 4 | 0, SAFE_HEAP_LOAD($24 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy28 + 8 | 0, SAFE_HEAP_LOAD($24 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy28 + 12 | 0, SAFE_HEAP_LOAD($24 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_66($22, $$byval_copy27, $$byval_copy28); //@line 483
 $100 = $1 + 48 | 0; //@line 484
 $101 = +(+SAFE_HEAP_LOAD_D($100 | 0, 8)); //@line 485
 $102 = -$101; //@line 486
 SAFE_HEAP_STORE($$byval_copy29 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy29 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy29 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy29 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_64($26, $$byval_copy29, $102); //@line 488
 $103 = $1 + 24 | 0; //@line 489
 $104 = $8; //@line 490
 $105 = $9; //@line 491
 $106 = $104 - $105; //@line 492
 $107 = $12; //@line 493
 $108 = $106 * $107; //@line 494
 $109 = +_cpfclamp01($108); //@line 495
 SAFE_HEAP_STORE($$byval_copy30 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy30 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy30 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy30 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy31 | 0, SAFE_HEAP_LOAD($103 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy31 + 4 | 0, SAFE_HEAP_LOAD($103 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy31 + 8 | 0, SAFE_HEAP_LOAD($103 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy31 + 12 | 0, SAFE_HEAP_LOAD($103 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvlerp_65($27, $$byval_copy30, $$byval_copy31, $109); //@line 498
 SAFE_HEAP_STORE($$byval_copy32 | 0, SAFE_HEAP_LOAD($26 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy32 + 4 | 0, SAFE_HEAP_LOAD($26 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy32 + 8 | 0, SAFE_HEAP_LOAD($26 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy32 + 12 | 0, SAFE_HEAP_LOAD($26 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy33 | 0, SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy33 + 4 | 0, SAFE_HEAP_LOAD($27 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy33 + 8 | 0, SAFE_HEAP_LOAD($27 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy33 + 12 | 0, SAFE_HEAP_LOAD($27 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_66($25, $$byval_copy32, $$byval_copy33); //@line 501
 SAFE_HEAP_STORE($$byval_copy34 | 0, SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy34 + 4 | 0, SAFE_HEAP_LOAD($25 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy34 + 8 | 0, SAFE_HEAP_LOAD($25 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy34 + 12 | 0, SAFE_HEAP_LOAD($25 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy35 | 0, SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy35 + 4 | 0, SAFE_HEAP_LOAD($22 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy35 + 8 | 0, SAFE_HEAP_LOAD($22 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy35 + 12 | 0, SAFE_HEAP_LOAD($22 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_67($29, $$byval_copy34, $$byval_copy35); //@line 504
 SAFE_HEAP_STORE($$byval_copy36 | 0, SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy36 + 4 | 0, SAFE_HEAP_LOAD($29 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy36 + 8 | 0, SAFE_HEAP_LOAD($29 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy36 + 12 | 0, SAFE_HEAP_LOAD($29 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy37 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy37 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy37 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy37 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $110 = +_cpvdot_68($$byval_copy36, $$byval_copy37); //@line 507
 $28 = $110; //@line 508
 $111 = $28; //@line 509
 $112 = $111 <= 0.0; //@line 510
 if (!$112) {
  STACKTOP = sp; //@line 512
  return;
 }
 $113 = $0 + 24 | 0; //@line 514
 $114 = $113 + 16 | 0; //@line 515
 $115 = SAFE_HEAP_LOAD($114 | 0, 4, 0) | 0 | 0; //@line 516
 $116 = Math_imul($115, -950046239) | 0; //@line 517
 $117 = $1 + 16 | 0; //@line 518
 $118 = SAFE_HEAP_LOAD($117 | 0, 4, 0) | 0 | 0; //@line 519
 $119 = Math_imul($118, -950046239) | 0; //@line 520
 $120 = $116 ^ $119; //@line 521
 $30 = $120; //@line 522
 $121 = $4; //@line 523
 $122 = $30; //@line 524
 SAFE_HEAP_STORE($$byval_copy38 | 0, SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy38 + 4 | 0, SAFE_HEAP_LOAD($22 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy38 + 8 | 0, SAFE_HEAP_LOAD($22 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy38 + 12 | 0, SAFE_HEAP_LOAD($22 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy39 | 0, SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy39 + 4 | 0, SAFE_HEAP_LOAD($25 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy39 + 8 | 0, SAFE_HEAP_LOAD($25 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy39 + 12 | 0, SAFE_HEAP_LOAD($25 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpCollisionInfoPushContact($121, $$byval_copy38, $$byval_copy39, $122); //@line 527
 STACKTOP = sp; //@line 528
 return;
}
function _cpArbiterApplyImpulse($0) {
 $0 = $0 | 0; //@line 2303
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy14 = 0, $$byval_copy15 = 0, $$byval_copy16 = 0, $$byval_copy17 = 0, $$byval_copy18 = 0, $$byval_copy19 = 0, $$byval_copy2 = 0, $$byval_copy20 = 0, $$byval_copy21 = 0, $$byval_copy22 = 0, $$byval_copy23 = 0, $$byval_copy24 = 0, $$byval_copy25 = 0, $$byval_copy26 = 0; //@line 2304
 var $$byval_copy27 = 0, $$byval_copy28 = 0, $$byval_copy29 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $1 = 0, $10 = 0, $100 = 0.0, $101 = 0.0, $102 = 0.0, $103 = 0, $104 = 0, $105 = 0.0, $106 = 0.0, $107 = 0.0; //@line 2305
 var $108 = 0.0, $109 = 0.0, $11 = 0, $110 = 0, $111 = 0, $112 = 0.0, $113 = 0, $114 = 0, $115 = 0.0, $116 = 0.0, $117 = 0.0, $118 = 0.0, $119 = 0, $12 = 0, $120 = 0, $121 = 0.0, $122 = 0.0, $123 = 0, $124 = 0, $125 = 0.0;
 var $126 = 0.0, $127 = 0.0, $128 = 0.0, $129 = 0.0, $13 = 0, $130 = 0.0, $131 = 0.0, $132 = 0.0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0.0, $14 = 0, $140 = 0.0, $141 = 0.0, $142 = 0, $143 = 0;
 var $144 = 0, $145 = 0, $146 = 0.0, $147 = 0.0, $148 = 0.0, $149 = 0, $15 = 0, $150 = 0, $151 = 0.0, $152 = 0.0, $153 = 0.0, $154 = 0, $155 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0.0, $21 = 0; //@line 2308
 var $22 = 0.0, $23 = 0.0, $24 = 0, $25 = 0.0, $26 = 0.0, $27 = 0.0, $28 = 0.0, $29 = 0.0, $3 = 0, $30 = 0.0, $31 = 0.0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0;
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0.0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0; //@line 2310
 var $59 = 0, $6 = 0.0, $60 = 0.0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0.0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0.0, $74 = 0, $75 = 0, $76 = 0.0; //@line 2311
 var $77 = 0.0, $78 = 0.0, $79 = 0, $8 = 0, $80 = 0, $81 = 0.0, $82 = 0.0, $83 = 0.0, $84 = 0.0, $85 = 0.0, $86 = 0, $87 = 0, $88 = 0.0, $89 = 0.0, $9 = 0.0, $90 = 0.0, $91 = 0.0, $92 = 0.0, $93 = 0, $94 = 0;
 var $95 = 0, $96 = 0, $97 = 0.0, $98 = 0.0, $99 = 0.0, label = 0, sp = 0; //@line 2313
 sp = STACKTOP; //@line 2314
 STACKTOP = STACKTOP + 880 | 0; //@line 2315
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(880 | 0); //@line 2315
 $$byval_copy29 = sp + 832 | 0; //@line 2316
 $$byval_copy28 = sp + 816 | 0; //@line 2317
 $$byval_copy27 = sp + 800 | 0; //@line 2318
 $$byval_copy26 = sp + 784 | 0; //@line 2319
 $$byval_copy25 = sp + 768 | 0; //@line 2320
 $$byval_copy24 = sp + 752 | 0; //@line 2321
 $$byval_copy23 = sp + 736 | 0; //@line 2322
 $$byval_copy22 = sp + 720 | 0; //@line 2323
 $$byval_copy21 = sp + 704 | 0; //@line 2324
 $$byval_copy20 = sp + 688 | 0; //@line 2325
 $$byval_copy19 = sp + 672 | 0; //@line 2326
 $$byval_copy18 = sp + 656 | 0; //@line 2327
 $$byval_copy17 = sp + 640 | 0; //@line 2328
 $$byval_copy16 = sp + 624 | 0; //@line 2329
 $$byval_copy15 = sp + 608 | 0; //@line 2330
 $$byval_copy14 = sp + 592 | 0; //@line 2331
 $$byval_copy13 = sp + 576 | 0; //@line 2332
 $$byval_copy12 = sp + 560 | 0; //@line 2333
 $$byval_copy11 = sp + 544 | 0; //@line 2334
 $$byval_copy10 = sp + 528 | 0; //@line 2335
 $$byval_copy9 = sp + 512 | 0; //@line 2336
 $$byval_copy8 = sp + 496 | 0; //@line 2337
 $$byval_copy7 = sp + 480 | 0; //@line 2338
 $$byval_copy6 = sp + 464 | 0; //@line 2339
 $$byval_copy5 = sp + 448 | 0; //@line 2340
 $$byval_copy4 = sp + 432 | 0; //@line 2341
 $$byval_copy3 = sp + 416 | 0; //@line 2342
 $$byval_copy2 = sp + 400 | 0; //@line 2343
 $$byval_copy1 = sp + 384 | 0; //@line 2344
 $$byval_copy = sp + 368 | 0; //@line 2345
 $4 = sp + 352 | 0; //@line 2346
 $5 = sp + 336 | 0; //@line 2347
 $10 = sp + 304 | 0; //@line 2348
 $11 = sp + 288 | 0; //@line 2349
 $12 = sp + 272 | 0; //@line 2350
 $13 = sp + 256 | 0; //@line 2351
 $14 = sp + 240 | 0; //@line 2352
 $15 = sp + 224 | 0; //@line 2353
 $16 = sp + 208 | 0; //@line 2354
 $17 = sp + 192 | 0; //@line 2355
 $18 = sp + 176 | 0; //@line 2356
 $19 = sp + 160 | 0; //@line 2357
 $21 = sp + 136 | 0; //@line 2358
 $24 = sp + 104 | 0; //@line 2359
 $32 = sp + 32 | 0; //@line 2360
 $33 = sp + 16 | 0; //@line 2361
 $34 = sp; //@line 2362
 $1 = $0; //@line 2363
 $35 = $1; //@line 2364
 $36 = $35 + 44 | 0; //@line 2365
 $37 = SAFE_HEAP_LOAD($36 | 0, 4, 0) | 0 | 0; //@line 2366
 $2 = $37; //@line 2367
 $38 = $1; //@line 2368
 $39 = $38 + 48 | 0; //@line 2369
 $40 = SAFE_HEAP_LOAD($39 | 0, 4, 0) | 0 | 0; //@line 2370
 $3 = $40; //@line 2371
 $41 = $1; //@line 2372
 $42 = $41 + 80 | 0; //@line 2373
 SAFE_HEAP_STORE($4 | 0, SAFE_HEAP_LOAD($42 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($4 + 4 | 0, SAFE_HEAP_LOAD($42 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($4 + 8 | 0, SAFE_HEAP_LOAD($42 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($4 + 12 | 0, SAFE_HEAP_LOAD($42 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $43 = $1; //@line 2375
 $44 = $43 + 16 | 0; //@line 2376
 SAFE_HEAP_STORE($5 | 0, SAFE_HEAP_LOAD($44 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($5 + 4 | 0, SAFE_HEAP_LOAD($44 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($5 + 8 | 0, SAFE_HEAP_LOAD($44 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($5 + 12 | 0, SAFE_HEAP_LOAD($44 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $45 = $1; //@line 2378
 $46 = $45 + 8 | 0; //@line 2379
 $47 = +(+SAFE_HEAP_LOAD_D($46 | 0, 8)); //@line 2380
 $6 = $47; //@line 2381
 $7 = 0; //@line 2382
 while (1) {
  $48 = $7; //@line 2384
  $49 = $1; //@line 2385
  $50 = $49 + 68 | 0; //@line 2386
  $51 = SAFE_HEAP_LOAD($50 | 0, 4, 0) | 0 | 0; //@line 2387
  $52 = ($48 | 0) < ($51 | 0); //@line 2388
  if (!$52) {
   break;
  }
  $53 = $1; //@line 2392
  $54 = $53 + 72 | 0; //@line 2393
  $55 = SAFE_HEAP_LOAD($54 | 0, 4, 0) | 0 | 0; //@line 2394
  $56 = $7; //@line 2395
  $57 = $55 + ($56 * 96 | 0) | 0; //@line 2396
  $8 = $57; //@line 2397
  $58 = $8; //@line 2398
  $59 = $58 + 32 | 0; //@line 2399
  $60 = +(+SAFE_HEAP_LOAD_D($59 | 0, 8)); //@line 2400
  $9 = $60; //@line 2401
  $61 = $8; //@line 2402
  SAFE_HEAP_STORE($10 | 0, SAFE_HEAP_LOAD($61 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($10 + 4 | 0, SAFE_HEAP_LOAD($61 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($10 + 8 | 0, SAFE_HEAP_LOAD($61 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($10 + 12 | 0, SAFE_HEAP_LOAD($61 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $62 = $8; //@line 2404
  $63 = $62 + 16 | 0; //@line 2405
  SAFE_HEAP_STORE($11 | 0, SAFE_HEAP_LOAD($63 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($11 + 4 | 0, SAFE_HEAP_LOAD($63 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($11 + 8 | 0, SAFE_HEAP_LOAD($63 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($11 + 12 | 0, SAFE_HEAP_LOAD($63 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $64 = $2; //@line 2407
  $65 = $64 + 184 | 0; //@line 2408
  SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvperp($14, $$byval_copy); //@line 2410
  $66 = $2; //@line 2411
  $67 = $66 + 200 | 0; //@line 2412
  $68 = +(+SAFE_HEAP_LOAD_D($67 | 0, 8)); //@line 2413
  SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvmult_1($13, $$byval_copy1, $68); //@line 2415
  SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($65 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($65 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($65 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($65 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvadd_9($12, $$byval_copy2, $$byval_copy3); //@line 2418
  $69 = $3; //@line 2419
  $70 = $69 + 184 | 0; //@line 2420
  SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvperp($17, $$byval_copy4); //@line 2422
  $71 = $3; //@line 2423
  $72 = $71 + 200 | 0; //@line 2424
  $73 = +(+SAFE_HEAP_LOAD_D($72 | 0, 8)); //@line 2425
  SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($17 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($17 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($17 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvmult_1($16, $$byval_copy5, $73); //@line 2427
  SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($70 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($70 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($70 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($70 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($16 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($16 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($16 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvadd_9($15, $$byval_copy6, $$byval_copy7); //@line 2430
  $74 = $2; //@line 2431
  $75 = $3; //@line 2432
  SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _relative_velocity($19, $74, $75, $$byval_copy8, $$byval_copy9); //@line 2435
  SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($19 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($19 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($19 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvadd_9($18, $$byval_copy10, $$byval_copy11); //@line 2438
  SAFE_HEAP_STORE($$byval_copy12 | 0, SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy12 + 4 | 0, SAFE_HEAP_LOAD($15 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy12 + 8 | 0, SAFE_HEAP_LOAD($15 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy12 + 12 | 0, SAFE_HEAP_LOAD($15 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvsub_10($21, $$byval_copy12, $$byval_copy13); //@line 2441
  SAFE_HEAP_STORE($$byval_copy14 | 0, SAFE_HEAP_LOAD($21 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy14 + 4 | 0, SAFE_HEAP_LOAD($21 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy14 + 8 | 0, SAFE_HEAP_LOAD($21 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy14 + 12 | 0, SAFE_HEAP_LOAD($21 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $76 = +_cpvdot_11($$byval_copy14, $$byval_copy15); //@line 2444
  $20 = $76; //@line 2445
  SAFE_HEAP_STORE($$byval_copy16 | 0, SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy16 + 4 | 0, SAFE_HEAP_LOAD($18 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy16 + 8 | 0, SAFE_HEAP_LOAD($18 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy16 + 12 | 0, SAFE_HEAP_LOAD($18 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $77 = +_cpvdot_11($$byval_copy16, $$byval_copy17); //@line 2448
  $22 = $77; //@line 2449
  SAFE_HEAP_STORE($$byval_copy18 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy18 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy18 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy18 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvperp($24, $$byval_copy18); //@line 2451
  SAFE_HEAP_STORE($$byval_copy19 | 0, SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy19 + 4 | 0, SAFE_HEAP_LOAD($18 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy19 + 8 | 0, SAFE_HEAP_LOAD($18 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy19 + 12 | 0, SAFE_HEAP_LOAD($18 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 | 0, SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 + 4 | 0, SAFE_HEAP_LOAD($24 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 + 8 | 0, SAFE_HEAP_LOAD($24 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 + 12 | 0, SAFE_HEAP_LOAD($24 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $78 = +_cpvdot_11($$byval_copy19, $$byval_copy20); //@line 2454
  $23 = $78; //@line 2455
  $79 = $8; //@line 2456
  $80 = $79 + 80 | 0; //@line 2457
  $81 = +(+SAFE_HEAP_LOAD_D($80 | 0, 8)); //@line 2458
  $82 = $20; //@line 2459
  $83 = $81 - $82; //@line 2460
  $84 = $9; //@line 2461
  $85 = $83 * $84; //@line 2462
  $25 = $85; //@line 2463
  $86 = $8; //@line 2464
  $87 = $86 + 72 | 0; //@line 2465
  $88 = +(+SAFE_HEAP_LOAD_D($87 | 0, 8)); //@line 2466
  $26 = $88; //@line 2467
  $89 = $26; //@line 2468
  $90 = $25; //@line 2469
  $91 = $89 + $90; //@line 2470
  $92 = +_cpfmax($91, 0.0); //@line 2471
  $93 = $8; //@line 2472
  $94 = $93 + 72 | 0; //@line 2473
  SAFE_HEAP_STORE_D($94 | 0, +$92, 8);
  $95 = $8; //@line 2475
  $96 = $95 + 48 | 0; //@line 2476
  $97 = +(+SAFE_HEAP_LOAD_D($96 | 0, 8)); //@line 2477
  $98 = $22; //@line 2478
  $99 = $97 + $98; //@line 2479
  $100 = -$99; //@line 2480
  $101 = $9; //@line 2481
  $102 = $100 * $101; //@line 2482
  $27 = $102; //@line 2483
  $103 = $8; //@line 2484
  $104 = $103 + 56 | 0; //@line 2485
  $105 = +(+SAFE_HEAP_LOAD_D($104 | 0, 8)); //@line 2486
  $28 = $105; //@line 2487
  $106 = $28; //@line 2488
  $107 = $27; //@line 2489
  $108 = $106 + $107; //@line 2490
  $109 = +_cpfmax($108, 0.0); //@line 2491
  $110 = $8; //@line 2492
  $111 = $110 + 56 | 0; //@line 2493
  SAFE_HEAP_STORE_D($111 | 0, +$109, 8);
  $112 = $6; //@line 2495
  $113 = $8; //@line 2496
  $114 = $113 + 56 | 0; //@line 2497
  $115 = +(+SAFE_HEAP_LOAD_D($114 | 0, 8)); //@line 2498
  $116 = $112 * $115; //@line 2499
  $29 = $116; //@line 2500
  $117 = $23; //@line 2501
  $118 = -$117; //@line 2502
  $119 = $8; //@line 2503
  $120 = $119 + 40 | 0; //@line 2504
  $121 = +(+SAFE_HEAP_LOAD_D($120 | 0, 8)); //@line 2505
  $122 = $118 * $121; //@line 2506
  $30 = $122; //@line 2507
  $123 = $8; //@line 2508
  $124 = $123 + 64 | 0; //@line 2509
  $125 = +(+SAFE_HEAP_LOAD_D($124 | 0, 8)); //@line 2510
  $31 = $125; //@line 2511
  $126 = $31; //@line 2512
  $127 = $30; //@line 2513
  $128 = $126 + $127; //@line 2514
  $129 = $29; //@line 2515
  $130 = -$129; //@line 2516
  $131 = $29; //@line 2517
  $132 = +_cpfclamp($128, $130, $131); //@line 2518
  $133 = $8; //@line 2519
  $134 = $133 + 64 | 0; //@line 2520
  SAFE_HEAP_STORE_D($134 | 0, +$132, 8);
  $135 = $2; //@line 2522
  $136 = $3; //@line 2523
  $137 = $8; //@line 2524
  $138 = $137 + 72 | 0; //@line 2525
  $139 = +(+SAFE_HEAP_LOAD_D($138 | 0, 8)); //@line 2526
  $140 = $26; //@line 2527
  $141 = $139 - $140; //@line 2528
  SAFE_HEAP_STORE($$byval_copy21 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvmult_1($32, $$byval_copy21, $141); //@line 2530
  SAFE_HEAP_STORE($$byval_copy22 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy22 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy22 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy22 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy23 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy23 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy23 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy23 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy24 | 0, SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy24 + 4 | 0, SAFE_HEAP_LOAD($32 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy24 + 8 | 0, SAFE_HEAP_LOAD($32 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy24 + 12 | 0, SAFE_HEAP_LOAD($32 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _apply_bias_impulses($135, $136, $$byval_copy22, $$byval_copy23, $$byval_copy24); //@line 2534
  $142 = $2; //@line 2535
  $143 = $3; //@line 2536
  $144 = $8; //@line 2537
  $145 = $144 + 56 | 0; //@line 2538
  $146 = +(+SAFE_HEAP_LOAD_D($145 | 0, 8)); //@line 2539
  $147 = $28; //@line 2540
  $148 = $146 - $147; //@line 2541
  $149 = $8; //@line 2542
  $150 = $149 + 64 | 0; //@line 2543
  $151 = +(+SAFE_HEAP_LOAD_D($150 | 0, 8)); //@line 2544
  $152 = $31; //@line 2545
  $153 = $151 - $152; //@line 2546
  _cpv_2($34, $148, $153); //@line 2547
  SAFE_HEAP_STORE($$byval_copy25 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy25 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy25 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy25 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy26 | 0, SAFE_HEAP_LOAD($34 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy26 + 4 | 0, SAFE_HEAP_LOAD($34 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy26 + 8 | 0, SAFE_HEAP_LOAD($34 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy26 + 12 | 0, SAFE_HEAP_LOAD($34 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvrotate($33, $$byval_copy25, $$byval_copy26); //@line 2550
  SAFE_HEAP_STORE($$byval_copy27 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy27 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy27 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy27 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy28 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy28 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy28 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy28 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy29 | 0, SAFE_HEAP_LOAD($33 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy29 + 4 | 0, SAFE_HEAP_LOAD($33 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy29 + 8 | 0, SAFE_HEAP_LOAD($33 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy29 + 12 | 0, SAFE_HEAP_LOAD($33 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _apply_impulses($142, $143, $$byval_copy27, $$byval_copy28, $$byval_copy29); //@line 2554
  $154 = $7; //@line 2555
  $155 = $154 + 1 | 0; //@line 2556
  $7 = $155; //@line 2557
 }
 STACKTOP = sp; //@line 2559
 return;
}
function _cpSegmentShapeSegmentQuery($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 6689
 $1 = $1 | 0; //@line 6690
 $2 = $2 | 0; //@line 6691
 $3 = +$3; //@line 6692
 $4 = $4 | 0; //@line 6693
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy14 = 0, $$byval_copy15 = 0, $$byval_copy16 = 0, $$byval_copy17 = 0, $$byval_copy18 = 0, $$byval_copy19 = 0, $$byval_copy2 = 0, $$byval_copy20 = 0, $$byval_copy21 = 0, $$byval_copy22 = 0, $$byval_copy23 = 0, $$byval_copy24 = 0, $$byval_copy25 = 0, $$byval_copy26 = 0; //@line 6694
 var $$byval_copy27 = 0, $$byval_copy28 = 0, $$byval_copy29 = 0, $$byval_copy3 = 0, $$byval_copy30 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $100 = 0.0, $101 = 0.0, $102 = 0, $103 = 0.0, $104 = 0, $105 = 0.0, $106 = 0, $107 = 0; //@line 6695
 var $11 = 0.0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0.0, $20 = 0.0, $21 = 0.0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0;
 var $31 = 0.0, $32 = 0, $33 = 0, $34 = 0.0, $35 = 0.0, $36 = 0.0, $37 = 0.0, $38 = 0, $39 = 0.0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0.0, $45 = 0.0, $46 = 0.0, $47 = 0, $48 = 0.0, $49 = 0.0, $5 = 0;
 var $50 = 0, $51 = 0.0, $52 = 0.0, $53 = 0.0, $54 = 0.0, $55 = 0.0, $56 = 0.0, $57 = 0.0, $58 = 0.0, $59 = 0.0, $6 = 0.0, $60 = 0.0, $61 = 0.0, $62 = 0.0, $63 = 0, $64 = 0.0, $65 = 0.0, $66 = 0.0, $67 = 0.0, $68 = 0.0; //@line 6698
 var $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0.0, $74 = 0.0, $75 = 0, $76 = 0, $77 = 0.0, $78 = 0, $79 = 0, $8 = 0, $80 = 0.0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0; //@line 6699
 var $87 = 0, $88 = 0, $89 = 0, $9 = 0.0, $90 = 0, $91 = 0, $92 = 0, $93 = 0.0, $94 = 0.0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 6700
 sp = STACKTOP; //@line 6701
 STACKTOP = STACKTOP + 832 | 0; //@line 6702
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(832 | 0); //@line 6702
 $$byval_copy30 = sp + 808 | 0; //@line 6703
 $$byval_copy29 = sp + 792 | 0; //@line 6704
 $$byval_copy28 = sp + 776 | 0; //@line 6705
 $$byval_copy27 = sp + 760 | 0; //@line 6706
 $$byval_copy26 = sp + 744 | 0; //@line 6707
 $$byval_copy25 = sp + 728 | 0; //@line 6708
 $$byval_copy24 = sp + 712 | 0; //@line 6709
 $$byval_copy23 = sp + 696 | 0; //@line 6710
 $$byval_copy22 = sp + 680 | 0; //@line 6711
 $$byval_copy21 = sp + 664 | 0; //@line 6712
 $$byval_copy20 = sp + 648 | 0; //@line 6713
 $$byval_copy19 = sp + 632 | 0; //@line 6714
 $$byval_copy18 = sp + 616 | 0; //@line 6715
 $$byval_copy17 = sp + 600 | 0; //@line 6716
 $$byval_copy16 = sp + 584 | 0; //@line 6717
 $$byval_copy15 = sp + 568 | 0; //@line 6718
 $$byval_copy14 = sp + 552 | 0; //@line 6719
 $$byval_copy13 = sp + 536 | 0; //@line 6720
 $$byval_copy12 = sp + 520 | 0; //@line 6721
 $$byval_copy11 = sp + 504 | 0; //@line 6722
 $$byval_copy10 = sp + 488 | 0; //@line 6723
 $$byval_copy9 = sp + 472 | 0; //@line 6724
 $$byval_copy8 = sp + 456 | 0; //@line 6725
 $$byval_copy7 = sp + 440 | 0; //@line 6726
 $$byval_copy6 = sp + 424 | 0; //@line 6727
 $$byval_copy5 = sp + 408 | 0; //@line 6728
 $$byval_copy4 = sp + 392 | 0; //@line 6729
 $$byval_copy3 = sp + 376 | 0; //@line 6730
 $$byval_copy2 = sp + 360 | 0; //@line 6731
 $$byval_copy1 = sp + 344 | 0; //@line 6732
 $$byval_copy = sp + 328 | 0; //@line 6733
 $8 = sp + 304 | 0; //@line 6734
 $10 = sp + 280 | 0; //@line 6735
 $12 = sp + 256 | 0; //@line 6736
 $13 = sp + 240 | 0; //@line 6737
 $14 = sp + 224 | 0; //@line 6738
 $15 = sp + 208 | 0; //@line 6739
 $16 = sp + 192 | 0; //@line 6740
 $17 = sp + 176 | 0; //@line 6741
 $22 = sp + 128 | 0; //@line 6742
 $23 = sp + 112 | 0; //@line 6743
 $24 = sp + 96 | 0; //@line 6744
 $25 = sp + 48 | 0; //@line 6745
 $26 = sp; //@line 6746
 $5 = $0; //@line 6747
 $6 = $3; //@line 6748
 $7 = $4; //@line 6749
 $27 = $5; //@line 6750
 $28 = $27 + 240 | 0; //@line 6751
 SAFE_HEAP_STORE($8 | 0, SAFE_HEAP_LOAD($28 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 4 | 0, SAFE_HEAP_LOAD($28 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 8 | 0, SAFE_HEAP_LOAD($28 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 12 | 0, SAFE_HEAP_LOAD($28 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $29 = $5; //@line 6753
 $30 = $29 + 208 | 0; //@line 6754
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($30 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($30 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($30 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_354($10, $$byval_copy, $$byval_copy1); //@line 6757
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $31 = +_cpvdot_359($$byval_copy2, $$byval_copy3); //@line 6760
 $9 = $31; //@line 6761
 $32 = $5; //@line 6762
 $33 = $32 + 256 | 0; //@line 6763
 $34 = +(+SAFE_HEAP_LOAD_D($33 | 0, 8)); //@line 6764
 $35 = $6; //@line 6765
 $36 = $34 + $35; //@line 6766
 $11 = $36; //@line 6767
 $37 = $9; //@line 6768
 $38 = $37 > 0.0; //@line 6769
 if ($38) {
  SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvneg_360($12, $$byval_copy4); //@line 6772
 } else {
  SAFE_HEAP_STORE($12 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($12 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($12 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($12 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 }
 $39 = $11; //@line 6776
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_357($14, $$byval_copy5, $39); //@line 6778
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_354($13, $$byval_copy6, $$byval_copy7); //@line 6781
 $40 = $5; //@line 6782
 $41 = $40 + 208 | 0; //@line 6783
 SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($41 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($41 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($41 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_363($15, $$byval_copy8, $$byval_copy9); //@line 6786
 $42 = $5; //@line 6787
 $43 = $42 + 224 | 0; //@line 6788
 SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($43 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($43 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($43 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($43 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_363($16, $$byval_copy10, $$byval_copy11); //@line 6791
 SAFE_HEAP_STORE($$byval_copy12 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_354($17, $$byval_copy12, $$byval_copy13); //@line 6794
 SAFE_HEAP_STORE($$byval_copy14 | 0, SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 4 | 0, SAFE_HEAP_LOAD($17 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 8 | 0, SAFE_HEAP_LOAD($17 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 12 | 0, SAFE_HEAP_LOAD($17 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy15 | 0, SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy15 + 4 | 0, SAFE_HEAP_LOAD($15 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy15 + 8 | 0, SAFE_HEAP_LOAD($15 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy15 + 12 | 0, SAFE_HEAP_LOAD($15 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $44 = +_cpvcross_369($$byval_copy14, $$byval_copy15); //@line 6797
 SAFE_HEAP_STORE($$byval_copy16 | 0, SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy16 + 4 | 0, SAFE_HEAP_LOAD($17 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy16 + 8 | 0, SAFE_HEAP_LOAD($17 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy16 + 12 | 0, SAFE_HEAP_LOAD($17 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy17 | 0, SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy17 + 4 | 0, SAFE_HEAP_LOAD($16 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy17 + 8 | 0, SAFE_HEAP_LOAD($16 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy17 + 12 | 0, SAFE_HEAP_LOAD($16 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $45 = +_cpvcross_369($$byval_copy16, $$byval_copy17); //@line 6800
 $46 = $44 * $45; //@line 6801
 $47 = $46 <= 0.0; //@line 6802
 if ($47) {
  $48 = $9; //@line 6804
  $49 = $9; //@line 6805
  $50 = $49 > 0.0; //@line 6806
  $51 = $11; //@line 6807
  $52 = -$51; //@line 6808
  $53 = $50 ? $52 : $51; //@line 6809
  $54 = $48 + $53; //@line 6810
  $18 = $54; //@line 6811
  $55 = $18; //@line 6812
  $56 = -$55; //@line 6813
  $19 = $56; //@line 6814
  SAFE_HEAP_STORE($$byval_copy18 | 0, SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy18 + 4 | 0, SAFE_HEAP_LOAD($17 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy18 + 8 | 0, SAFE_HEAP_LOAD($17 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy18 + 12 | 0, SAFE_HEAP_LOAD($17 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy19 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy19 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy19 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy19 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $57 = +_cpvdot_359($$byval_copy18, $$byval_copy19); //@line 6817
  $58 = $18; //@line 6818
  $59 = $57 - $58; //@line 6819
  $20 = $59; //@line 6820
  $60 = $19; //@line 6821
  $61 = $20; //@line 6822
  $62 = $60 * $61; //@line 6823
  $63 = $62 < 0.0; //@line 6824
  if (!$63) {
   STACKTOP = sp; //@line 6826
   return;
  }
  $64 = $19; //@line 6828
  $65 = $19; //@line 6829
  $66 = $20; //@line 6830
  $67 = $65 - $66; //@line 6831
  $68 = $64 / $67; //@line 6832
  $21 = $68; //@line 6833
  $69 = $5; //@line 6834
  $70 = $7; //@line 6835
  SAFE_HEAP_STORE($70 | 0, $69 | 0, 4);
  $71 = $7; //@line 6837
  $72 = $71 + 8 | 0; //@line 6838
  $73 = $21; //@line 6839
  SAFE_HEAP_STORE($$byval_copy20 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvlerp_362($22, $$byval_copy20, $$byval_copy21, $73); //@line 6842
  $74 = $6; //@line 6843
  SAFE_HEAP_STORE($$byval_copy22 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy22 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy22 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy22 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvmult_357($23, $$byval_copy22, $74); //@line 6845
  SAFE_HEAP_STORE($$byval_copy23 | 0, SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy23 + 4 | 0, SAFE_HEAP_LOAD($22 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy23 + 8 | 0, SAFE_HEAP_LOAD($22 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy23 + 12 | 0, SAFE_HEAP_LOAD($22 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy24 | 0, SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy24 + 4 | 0, SAFE_HEAP_LOAD($23 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy24 + 8 | 0, SAFE_HEAP_LOAD($23 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy24 + 12 | 0, SAFE_HEAP_LOAD($23 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvsub_354($24, $$byval_copy23, $$byval_copy24); //@line 6848
  SAFE_HEAP_STORE($72 | 0, SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($72 + 4 | 0, SAFE_HEAP_LOAD($24 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($72 + 8 | 0, SAFE_HEAP_LOAD($24 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($72 + 12 | 0, SAFE_HEAP_LOAD($24 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $75 = $7; //@line 6850
  $76 = $75 + 24 | 0; //@line 6851
  SAFE_HEAP_STORE($76 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($76 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($76 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($76 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $77 = $21; //@line 6853
  $78 = $7; //@line 6854
  $79 = $78 + 40 | 0; //@line 6855
  SAFE_HEAP_STORE_D($79 | 0, +$77, 8);
  STACKTOP = sp; //@line 6857
  return;
 }
 $80 = $11; //@line 6859
 $81 = $80 != 0.0; //@line 6860
 if (!$81) {
  STACKTOP = sp; //@line 6862
  return;
 }
 SAFE_HEAP_STORE($25 | 0, 0 | 0, 4);
 $82 = $25 + 8 | 0; //@line 6865
 SAFE_HEAP_STORE($82 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($82 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($82 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($82 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $83 = $25 + 24 | 0; //@line 6867
 SAFE_HEAP_STORE($83 | 0, SAFE_HEAP_LOAD(11248 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($83 + 4 | 0, SAFE_HEAP_LOAD(11248 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($83 + 8 | 0, SAFE_HEAP_LOAD(11248 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($83 + 12 | 0, SAFE_HEAP_LOAD(11248 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $84 = $25 + 40 | 0; //@line 6869
 SAFE_HEAP_STORE_D($84 | 0, +1.0, 8);
 SAFE_HEAP_STORE($26 | 0, 0 | 0, 4);
 $85 = $26 + 8 | 0; //@line 6872
 SAFE_HEAP_STORE($85 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($85 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($85 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($85 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $86 = $26 + 24 | 0; //@line 6874
 SAFE_HEAP_STORE($86 | 0, SAFE_HEAP_LOAD(11248 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($86 + 4 | 0, SAFE_HEAP_LOAD(11248 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($86 + 8 | 0, SAFE_HEAP_LOAD(11248 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($86 + 12 | 0, SAFE_HEAP_LOAD(11248 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $87 = $26 + 40 | 0; //@line 6876
 SAFE_HEAP_STORE_D($87 | 0, +1.0, 8);
 $88 = $5; //@line 6878
 $89 = $5; //@line 6879
 $90 = $89 + 208 | 0; //@line 6880
 $91 = $5; //@line 6881
 $92 = $91 + 256 | 0; //@line 6882
 $93 = +(+SAFE_HEAP_LOAD_D($92 | 0, 8)); //@line 6883
 $94 = $6; //@line 6884
 SAFE_HEAP_STORE($$byval_copy25 | 0, SAFE_HEAP_LOAD($90 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy25 + 4 | 0, SAFE_HEAP_LOAD($90 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy25 + 8 | 0, SAFE_HEAP_LOAD($90 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy25 + 12 | 0, SAFE_HEAP_LOAD($90 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy26 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy26 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy26 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy26 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy27 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy27 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy27 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy27 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _CircleSegmentQuery_361($88, $$byval_copy25, $93, $$byval_copy26, $$byval_copy27, $94, $25); //@line 6888
 $95 = $5; //@line 6889
 $96 = $5; //@line 6890
 $97 = $96 + 224 | 0; //@line 6891
 $98 = $5; //@line 6892
 $99 = $98 + 256 | 0; //@line 6893
 $100 = +(+SAFE_HEAP_LOAD_D($99 | 0, 8)); //@line 6894
 $101 = $6; //@line 6895
 SAFE_HEAP_STORE($$byval_copy28 | 0, SAFE_HEAP_LOAD($97 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy28 + 4 | 0, SAFE_HEAP_LOAD($97 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy28 + 8 | 0, SAFE_HEAP_LOAD($97 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy28 + 12 | 0, SAFE_HEAP_LOAD($97 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy29 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy29 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy29 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy29 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy30 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy30 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy30 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy30 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _CircleSegmentQuery_361($95, $$byval_copy28, $100, $$byval_copy29, $$byval_copy30, $101, $26); //@line 6899
 $102 = $25 + 40 | 0; //@line 6900
 $103 = +(+SAFE_HEAP_LOAD_D($102 | 0, 8)); //@line 6901
 $104 = $26 + 40 | 0; //@line 6902
 $105 = +(+SAFE_HEAP_LOAD_D($104 | 0, 8)); //@line 6903
 $106 = $103 < $105; //@line 6904
 $107 = $7; //@line 6905
 if ($106) {
  dest = $107; //@line 6907
  src = $25; //@line 6907
  stop = dest + 48 | 0; //@line 6907
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 6907
   src = src + 4 | 0; //@line 6907
  } while ((dest | 0) < (stop | 0));
  STACKTOP = sp; //@line 6908
  return;
 } else {
  dest = $107; //@line 6910
  src = $26; //@line 6910
  stop = dest + 48 | 0; //@line 6910
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 6910
   src = src + 4 | 0; //@line 6910
  } while ((dest | 0) < (stop | 0));
  STACKTOP = sp; //@line 6911
  return;
 }
}
function _GJKRecurse($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 976
 $1 = $1 | 0; //@line 977
 $2 = $2 | 0; //@line 978
 $3 = $3 | 0; //@line 979
 $4 = $4 | 0; //@line 980
 var $$byval_copy = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy14 = 0, $$byval_copy15 = 0, $$byval_copy16 = 0, $$byval_copy17 = 0, $$byval_copy18 = 0, $$byval_copy19 = 0, $$byval_copy20 = 0, $$byval_copy21 = 0, $$byval_copy22 = 0, $$byval_copy23 = 0, $$byval_copy25 = 0, $$byval_copy26 = 0, $$byval_copy28 = 0, $$byval_copy29 = 0, $$byval_copy30 = 0; //@line 981
 var $$byval_copy31 = 0, $$byval_copy32 = 0, $$byval_copy33 = 0, $$byval_copy34 = 0, $$byval_copy35 = 0, $$byval_copy36 = 0, $$byval_copy37 = 0, $$byval_copy38 = 0, $$byval_copy39 = 0, $$byval_copy40 = 0, $$byval_copy41 = 0, $$byval_copy42 = 0, $$byval_copy43 = 0, $$byval_copy44 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0; //@line 982
 var $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0.0, $26 = 0.0, $27 = 0, $28 = 0.0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0; //@line 983
 var $34 = 0.0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0;
 var $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0.0, $61 = 0, $62 = 0, $63 = 0.0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $7 = 0.0, $8 = 0, $9 = 0, $cpvzero$61$byval_copy = 0; //@line 985
 var $cpvzero$61$byval_copy24 = 0, $cpvzero$61$byval_copy27 = 0, $or$cond = 0, $vararg_buffer = 0, $vararg_buffer2 = 0, $vararg_buffer5 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 986
 sp = STACKTOP; //@line 987
 STACKTOP = STACKTOP + 1296 | 0; //@line 988
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(1296 | 0); //@line 988
 $$byval_copy44 = sp + 1224 | 0; //@line 989
 $$byval_copy43 = sp + 1168 | 0; //@line 990
 $$byval_copy42 = sp + 1112 | 0; //@line 991
 $$byval_copy41 = sp + 1056 | 0; //@line 992
 $$byval_copy40 = sp + 1040 | 0; //@line 993
 $$byval_copy39 = sp + 1024 | 0; //@line 994
 $$byval_copy38 = sp + 1008 | 0; //@line 995
 $$byval_copy37 = sp + 992 | 0; //@line 996
 $$byval_copy36 = sp + 936 | 0; //@line 997
 $$byval_copy35 = sp + 880 | 0; //@line 998
 $$byval_copy34 = sp + 864 | 0; //@line 999
 $$byval_copy33 = sp + 848 | 0; //@line 1000
 $$byval_copy32 = sp + 832 | 0; //@line 1001
 $$byval_copy31 = sp + 816 | 0; //@line 1002
 $$byval_copy30 = sp + 760 | 0; //@line 1003
 $$byval_copy29 = sp + 704 | 0; //@line 1004
 $$byval_copy28 = sp + 648 | 0; //@line 1005
 $cpvzero$61$byval_copy27 = sp + 632 | 0; //@line 1006
 $$byval_copy26 = sp + 616 | 0; //@line 1007
 $$byval_copy25 = sp + 600 | 0; //@line 1008
 $cpvzero$61$byval_copy24 = sp + 584 | 0; //@line 1009
 $$byval_copy23 = sp + 568 | 0; //@line 1010
 $$byval_copy22 = sp + 552 | 0; //@line 1011
 $$byval_copy21 = sp + 536 | 0; //@line 1012
 $$byval_copy20 = sp + 520 | 0; //@line 1013
 $$byval_copy19 = sp + 504 | 0; //@line 1014
 $$byval_copy18 = sp + 488 | 0; //@line 1015
 $$byval_copy17 = sp + 472 | 0; //@line 1016
 $$byval_copy16 = sp + 456 | 0; //@line 1017
 $$byval_copy15 = sp + 440 | 0; //@line 1018
 $$byval_copy14 = sp + 424 | 0; //@line 1019
 $$byval_copy13 = sp + 408 | 0; //@line 1020
 $$byval_copy12 = sp + 352 | 0; //@line 1021
 $$byval_copy11 = sp + 296 | 0; //@line 1022
 $cpvzero$61$byval_copy = sp + 280 | 0; //@line 1023
 $$byval_copy10 = sp + 264 | 0; //@line 1024
 $$byval_copy9 = sp + 248 | 0; //@line 1025
 $$byval_copy8 = sp + 192 | 0; //@line 1026
 $$byval_copy = sp + 136 | 0; //@line 1027
 $vararg_buffer5 = sp + 128 | 0; //@line 1028
 $vararg_buffer2 = sp + 120 | 0; //@line 1029
 $vararg_buffer = sp + 112 | 0; //@line 1030
 $8 = sp + 88 | 0; //@line 1031
 $9 = sp + 72 | 0; //@line 1032
 $10 = sp + 56 | 0; //@line 1033
 $11 = sp; //@line 1034
 $5 = $1; //@line 1035
 $6 = $4; //@line 1036
 $12 = $6; //@line 1037
 $13 = ($12 | 0) > 30; //@line 1038
 if ($13) {
  $14 = $6; //@line 1040
  $15 = ($14 | 0) < 20; //@line 1041
  if (!$15) {
   $16 = $6; //@line 1043
   SAFE_HEAP_STORE($vararg_buffer | 0, $16 | 0, 4);
   _cpMessage(4736, 4624, 352, 0, 0, 4768, $vararg_buffer); //@line 1045
  }
  dest = $$byval_copy; //@line 1047
  src = $2; //@line 1047
  stop = dest + 56 | 0; //@line 1047
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 1047
   src = src + 4 | 0; //@line 1047
  } while ((dest | 0) < (stop | 0));
  dest = $$byval_copy8; //@line 1048
  src = $3; //@line 1048
  stop = dest + 56 | 0; //@line 1048
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 1048
   src = src + 4 | 0; //@line 1048
  } while ((dest | 0) < (stop | 0));
  _ClosestPointsNew($0, $$byval_copy, $$byval_copy8); //@line 1049
  STACKTOP = sp; //@line 1050
  return;
 }
 $17 = $3 + 32 | 0; //@line 1052
 $18 = $2 + 32 | 0; //@line 1053
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($17 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($17 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($17 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($18 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($18 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($18 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($cpvzero$61$byval_copy | 0, SAFE_HEAP_LOAD(11232 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($cpvzero$61$byval_copy + 4 | 0, SAFE_HEAP_LOAD(11232 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($cpvzero$61$byval_copy + 8 | 0, SAFE_HEAP_LOAD(11232 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($cpvzero$61$byval_copy + 12 | 0, SAFE_HEAP_LOAD(11232 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $19 = _cpCheckPointGreater($$byval_copy9, $$byval_copy10, $cpvzero$61$byval_copy) | 0; //@line 1057
 $20 = $19 << 24 >> 24 != 0; //@line 1058
 if ($20) {
  $21 = $5; //@line 1060
  $22 = $6; //@line 1061
  dest = $$byval_copy11; //@line 1062
  src = $3; //@line 1062
  stop = dest + 56 | 0; //@line 1062
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 1062
   src = src + 4 | 0; //@line 1062
  } while ((dest | 0) < (stop | 0));
  dest = $$byval_copy12; //@line 1063
  src = $2; //@line 1063
  stop = dest + 56 | 0; //@line 1063
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 1063
   src = src + 4 | 0; //@line 1063
  } while ((dest | 0) < (stop | 0));
  _GJKRecurse($0, $21, $$byval_copy11, $$byval_copy12, $22); //@line 1064
  STACKTOP = sp; //@line 1065
  return;
 }
 $23 = $2 + 32 | 0; //@line 1067
 $24 = $3 + 32 | 0; //@line 1068
 SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($23 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($23 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($23 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 | 0, SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 4 | 0, SAFE_HEAP_LOAD($24 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 8 | 0, SAFE_HEAP_LOAD($24 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 12 | 0, SAFE_HEAP_LOAD($24 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $25 = +_ClosestT($$byval_copy13, $$byval_copy14); //@line 1071
 $7 = $25; //@line 1072
 $26 = $7; //@line 1073
 $27 = -1.0 < $26; //@line 1074
 $28 = $7; //@line 1075
 $29 = $28 < 1.0; //@line 1076
 $or$cond = $27 & $29; //@line 1077
 if ($or$cond) {
  $30 = $3 + 32 | 0; //@line 1079
  $31 = $2 + 32 | 0; //@line 1080
  SAFE_HEAP_STORE($$byval_copy15 | 0, SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 + 4 | 0, SAFE_HEAP_LOAD($30 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 + 8 | 0, SAFE_HEAP_LOAD($30 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 + 12 | 0, SAFE_HEAP_LOAD($30 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy16 | 0, SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy16 + 4 | 0, SAFE_HEAP_LOAD($31 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy16 + 8 | 0, SAFE_HEAP_LOAD($31 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy16 + 12 | 0, SAFE_HEAP_LOAD($31 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvsub_67($9, $$byval_copy15, $$byval_copy16); //@line 1083
  SAFE_HEAP_STORE($$byval_copy17 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvperp_75($8, $$byval_copy17); //@line 1085
 } else {
  $32 = $2 + 32 | 0; //@line 1087
  $33 = $3 + 32 | 0; //@line 1088
  $34 = $7; //@line 1089
  SAFE_HEAP_STORE($$byval_copy18 | 0, SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy18 + 4 | 0, SAFE_HEAP_LOAD($32 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy18 + 8 | 0, SAFE_HEAP_LOAD($32 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy18 + 12 | 0, SAFE_HEAP_LOAD($32 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy19 | 0, SAFE_HEAP_LOAD($33 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy19 + 4 | 0, SAFE_HEAP_LOAD($33 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy19 + 8 | 0, SAFE_HEAP_LOAD($33 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy19 + 12 | 0, SAFE_HEAP_LOAD($33 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _LerpT($10, $$byval_copy18, $$byval_copy19, $34); //@line 1092
  SAFE_HEAP_STORE($$byval_copy20 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvneg_62($8, $$byval_copy20); //@line 1094
 }
 $35 = $5; //@line 1096
 SAFE_HEAP_STORE($$byval_copy21 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy21 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy21 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy21 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _Support($11, $35, $$byval_copy21); //@line 1098
 $36 = $11 + 32 | 0; //@line 1099
 $37 = $2 + 32 | 0; //@line 1100
 SAFE_HEAP_STORE($$byval_copy22 | 0, SAFE_HEAP_LOAD($36 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy22 + 4 | 0, SAFE_HEAP_LOAD($36 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy22 + 8 | 0, SAFE_HEAP_LOAD($36 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy22 + 12 | 0, SAFE_HEAP_LOAD($36 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy23 | 0, SAFE_HEAP_LOAD($37 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy23 + 4 | 0, SAFE_HEAP_LOAD($37 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy23 + 8 | 0, SAFE_HEAP_LOAD($37 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy23 + 12 | 0, SAFE_HEAP_LOAD($37 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($cpvzero$61$byval_copy24 | 0, SAFE_HEAP_LOAD(11232 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($cpvzero$61$byval_copy24 + 4 | 0, SAFE_HEAP_LOAD(11232 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($cpvzero$61$byval_copy24 + 8 | 0, SAFE_HEAP_LOAD(11232 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($cpvzero$61$byval_copy24 + 12 | 0, SAFE_HEAP_LOAD(11232 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $38 = _cpCheckPointGreater($$byval_copy22, $$byval_copy23, $cpvzero$61$byval_copy24) | 0; //@line 1104
 $39 = $38 & 255; //@line 1105
 $40 = ($39 | 0) != 0; //@line 1106
 if ($40) {
  $41 = $3 + 32 | 0; //@line 1108
  $42 = $11 + 32 | 0; //@line 1109
  SAFE_HEAP_STORE($$byval_copy25 | 0, SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy25 + 4 | 0, SAFE_HEAP_LOAD($41 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy25 + 8 | 0, SAFE_HEAP_LOAD($41 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy25 + 12 | 0, SAFE_HEAP_LOAD($41 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy26 | 0, SAFE_HEAP_LOAD($42 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy26 + 4 | 0, SAFE_HEAP_LOAD($42 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy26 + 8 | 0, SAFE_HEAP_LOAD($42 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy26 + 12 | 0, SAFE_HEAP_LOAD($42 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($cpvzero$61$byval_copy27 | 0, SAFE_HEAP_LOAD(11232 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($cpvzero$61$byval_copy27 + 4 | 0, SAFE_HEAP_LOAD(11232 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($cpvzero$61$byval_copy27 + 8 | 0, SAFE_HEAP_LOAD(11232 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($cpvzero$61$byval_copy27 + 12 | 0, SAFE_HEAP_LOAD(11232 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $43 = _cpCheckPointGreater($$byval_copy25, $$byval_copy26, $cpvzero$61$byval_copy27) | 0; //@line 1113
  $44 = $43 & 255; //@line 1114
  $45 = ($44 | 0) != 0; //@line 1115
  if ($45) {
   $46 = $6; //@line 1117
   $47 = ($46 | 0) < 20; //@line 1118
   if (!$47) {
    $48 = $6; //@line 1120
    SAFE_HEAP_STORE($vararg_buffer2 | 0, $48 | 0, 4);
    _cpMessage(4736, 4624, 374, 0, 0, 4792, $vararg_buffer2); //@line 1122
   }
   $49 = $5; //@line 1124
   dest = $$byval_copy28; //@line 1125
   src = $2; //@line 1125
   stop = dest + 56 | 0; //@line 1125
   do {
    SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
    dest = dest + 4 | 0; //@line 1125
    src = src + 4 | 0; //@line 1125
   } while ((dest | 0) < (stop | 0));
   dest = $$byval_copy29; //@line 1126
   src = $11; //@line 1126
   stop = dest + 56 | 0; //@line 1126
   do {
    SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
    dest = dest + 4 | 0; //@line 1126
    src = src + 4 | 0; //@line 1126
   } while ((dest | 0) < (stop | 0));
   dest = $$byval_copy30; //@line 1127
   src = $3; //@line 1127
   stop = dest + 56 | 0; //@line 1127
   do {
    SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
    dest = dest + 4 | 0; //@line 1127
    src = src + 4 | 0; //@line 1127
   } while ((dest | 0) < (stop | 0));
   _EPA($0, $49, $$byval_copy28, $$byval_copy29, $$byval_copy30); //@line 1128
   STACKTOP = sp; //@line 1129
   return;
  }
 }
 $50 = $2 + 32 | 0; //@line 1132
 $51 = $3 + 32 | 0; //@line 1133
 $52 = $11 + 32 | 0; //@line 1134
 SAFE_HEAP_STORE($$byval_copy31 | 0, SAFE_HEAP_LOAD($50 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy31 + 4 | 0, SAFE_HEAP_LOAD($50 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy31 + 8 | 0, SAFE_HEAP_LOAD($50 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy31 + 12 | 0, SAFE_HEAP_LOAD($50 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy32 | 0, SAFE_HEAP_LOAD($51 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy32 + 4 | 0, SAFE_HEAP_LOAD($51 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy32 + 8 | 0, SAFE_HEAP_LOAD($51 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy32 + 12 | 0, SAFE_HEAP_LOAD($51 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy33 | 0, SAFE_HEAP_LOAD($52 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy33 + 4 | 0, SAFE_HEAP_LOAD($52 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy33 + 8 | 0, SAFE_HEAP_LOAD($52 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy33 + 12 | 0, SAFE_HEAP_LOAD($52 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy34 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy34 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy34 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy34 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $53 = _cpCheckAxis($$byval_copy31, $$byval_copy32, $$byval_copy33, $$byval_copy34) | 0; //@line 1139
 $54 = $53 << 24 >> 24 != 0; //@line 1140
 if ($54) {
  $55 = $6; //@line 1142
  $56 = ($55 | 0) < 20; //@line 1143
  if (!$56) {
   $57 = $6; //@line 1145
   SAFE_HEAP_STORE($vararg_buffer5 | 0, $57 | 0, 4);
   _cpMessage(4736, 4624, 379, 0, 0, 4768, $vararg_buffer5); //@line 1147
  }
  dest = $$byval_copy35; //@line 1149
  src = $2; //@line 1149
  stop = dest + 56 | 0; //@line 1149
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 1149
   src = src + 4 | 0; //@line 1149
  } while ((dest | 0) < (stop | 0));
  dest = $$byval_copy36; //@line 1150
  src = $3; //@line 1150
  stop = dest + 56 | 0; //@line 1150
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 1150
   src = src + 4 | 0; //@line 1150
  } while ((dest | 0) < (stop | 0));
  _ClosestPointsNew($0, $$byval_copy35, $$byval_copy36); //@line 1151
  STACKTOP = sp; //@line 1152
  return;
 }
 $58 = $2 + 32 | 0; //@line 1154
 $59 = $11 + 32 | 0; //@line 1155
 SAFE_HEAP_STORE($$byval_copy37 | 0, SAFE_HEAP_LOAD($58 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy37 + 4 | 0, SAFE_HEAP_LOAD($58 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy37 + 8 | 0, SAFE_HEAP_LOAD($58 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy37 + 12 | 0, SAFE_HEAP_LOAD($58 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy38 | 0, SAFE_HEAP_LOAD($59 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy38 + 4 | 0, SAFE_HEAP_LOAD($59 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy38 + 8 | 0, SAFE_HEAP_LOAD($59 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy38 + 12 | 0, SAFE_HEAP_LOAD($59 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $60 = +_ClosestDist($$byval_copy37, $$byval_copy38); //@line 1158
 $61 = $11 + 32 | 0; //@line 1159
 $62 = $3 + 32 | 0; //@line 1160
 SAFE_HEAP_STORE($$byval_copy39 | 0, SAFE_HEAP_LOAD($61 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy39 + 4 | 0, SAFE_HEAP_LOAD($61 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy39 + 8 | 0, SAFE_HEAP_LOAD($61 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy39 + 12 | 0, SAFE_HEAP_LOAD($61 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy40 | 0, SAFE_HEAP_LOAD($62 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy40 + 4 | 0, SAFE_HEAP_LOAD($62 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy40 + 8 | 0, SAFE_HEAP_LOAD($62 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy40 + 12 | 0, SAFE_HEAP_LOAD($62 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $63 = +_ClosestDist($$byval_copy39, $$byval_copy40); //@line 1163
 $64 = $60 < $63; //@line 1164
 $65 = $5; //@line 1165
 $66 = $6; //@line 1166
 $67 = $66 + 1 | 0; //@line 1167
 if ($64) {
  dest = $$byval_copy41; //@line 1169
  src = $2; //@line 1169
  stop = dest + 56 | 0; //@line 1169
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 1169
   src = src + 4 | 0; //@line 1169
  } while ((dest | 0) < (stop | 0));
  dest = $$byval_copy42; //@line 1170
  src = $11; //@line 1170
  stop = dest + 56 | 0; //@line 1170
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 1170
   src = src + 4 | 0; //@line 1170
  } while ((dest | 0) < (stop | 0));
  _GJKRecurse($0, $65, $$byval_copy41, $$byval_copy42, $67); //@line 1171
  STACKTOP = sp; //@line 1172
  return;
 } else {
  dest = $$byval_copy43; //@line 1174
  src = $11; //@line 1174
  stop = dest + 56 | 0; //@line 1174
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 1174
   src = src + 4 | 0; //@line 1174
  } while ((dest | 0) < (stop | 0));
  dest = $$byval_copy44; //@line 1175
  src = $3; //@line 1175
  stop = dest + 56 | 0; //@line 1175
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 1175
   src = src + 4 | 0; //@line 1175
  } while ((dest | 0) < (stop | 0));
  _GJKRecurse($0, $65, $$byval_copy43, $$byval_copy44, $67); //@line 1176
  STACKTOP = sp; //@line 1177
  return;
 }
}
function _CircleToSegment($0, $1, $2) {
 $0 = $0 | 0; //@line 7823
 $1 = $1 | 0; //@line 7824
 $2 = $2 | 0; //@line 7825
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy14 = 0, $$byval_copy15 = 0, $$byval_copy16 = 0, $$byval_copy17 = 0, $$byval_copy18 = 0, $$byval_copy19 = 0, $$byval_copy2 = 0, $$byval_copy20 = 0, $$byval_copy21 = 0, $$byval_copy22 = 0, $$byval_copy23 = 0, $$byval_copy24 = 0, $$byval_copy25 = 0, $$byval_copy26 = 0; //@line 7826
 var $$byval_copy27 = 0, $$byval_copy28 = 0, $$byval_copy29 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0.0, $11 = 0, $12 = 0, $13 = 0, $14 = 0.0, $15 = 0, $16 = 0.0, $17 = 0.0, $18 = 0, $19 = 0; //@line 7827
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0.0, $34 = 0.0, $35 = 0.0, $36 = 0.0, $37 = 0.0, $38 = 0; //@line 7828
 var $39 = 0, $4 = 0, $40 = 0.0, $41 = 0, $42 = 0, $43 = 0.0, $44 = 0.0, $45 = 0.0, $46 = 0.0, $47 = 0.0, $48 = 0.0, $49 = 0.0, $5 = 0, $50 = 0, $51 = 0.0, $52 = 0.0, $53 = 0, $54 = 0, $55 = 0.0, $56 = 0; //@line 7829
 var $57 = 0.0, $58 = 0.0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0.0, $65 = 0, $66 = 0, $67 = 0, $68 = 0.0, $69 = 0, $7 = 0, $70 = 0.0, $71 = 0, $72 = 0, $73 = 0, $74 = 0.0;
 var $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0.0, $8 = 0, $80 = 0, $81 = 0, $82 = 0.0, $83 = 0.0, $9 = 0, label = 0, sp = 0; //@line 7831
 sp = STACKTOP; //@line 7832
 STACKTOP = STACKTOP + 800 | 0; //@line 7833
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(800 | 0); //@line 7833
 $$byval_copy29 = sp + 768 | 0; //@line 7834
 $$byval_copy28 = sp + 752 | 0; //@line 7835
 $$byval_copy27 = sp + 736 | 0; //@line 7836
 $$byval_copy26 = sp + 720 | 0; //@line 7837
 $$byval_copy25 = sp + 704 | 0; //@line 7838
 $$byval_copy24 = sp + 688 | 0; //@line 7839
 $$byval_copy23 = sp + 672 | 0; //@line 7840
 $$byval_copy22 = sp + 656 | 0; //@line 7841
 $$byval_copy21 = sp + 640 | 0; //@line 7842
 $$byval_copy20 = sp + 624 | 0; //@line 7843
 $$byval_copy19 = sp + 608 | 0; //@line 7844
 $$byval_copy18 = sp + 592 | 0; //@line 7845
 $$byval_copy17 = sp + 576 | 0; //@line 7846
 $$byval_copy16 = sp + 560 | 0; //@line 7847
 $$byval_copy15 = sp + 544 | 0; //@line 7848
 $$byval_copy14 = sp + 528 | 0; //@line 7849
 $$byval_copy13 = sp + 512 | 0; //@line 7850
 $$byval_copy12 = sp + 496 | 0; //@line 7851
 $$byval_copy11 = sp + 480 | 0; //@line 7852
 $$byval_copy10 = sp + 464 | 0; //@line 7853
 $$byval_copy9 = sp + 448 | 0; //@line 7854
 $$byval_copy8 = sp + 432 | 0; //@line 7855
 $$byval_copy7 = sp + 416 | 0; //@line 7856
 $$byval_copy6 = sp + 400 | 0; //@line 7857
 $$byval_copy5 = sp + 384 | 0; //@line 7858
 $$byval_copy4 = sp + 368 | 0; //@line 7859
 $$byval_copy3 = sp + 352 | 0; //@line 7860
 $$byval_copy2 = sp + 336 | 0; //@line 7861
 $$byval_copy1 = sp + 320 | 0; //@line 7862
 $$byval_copy = sp + 304 | 0; //@line 7863
 $6 = sp + 288 | 0; //@line 7864
 $7 = sp + 272 | 0; //@line 7865
 $8 = sp + 256 | 0; //@line 7866
 $9 = sp + 240 | 0; //@line 7867
 $11 = sp + 216 | 0; //@line 7868
 $12 = sp + 200 | 0; //@line 7869
 $13 = sp + 184 | 0; //@line 7870
 $15 = sp + 160 | 0; //@line 7871
 $18 = sp + 128 | 0; //@line 7872
 $19 = sp + 112 | 0; //@line 7873
 $20 = sp + 96 | 0; //@line 7874
 $21 = sp + 80 | 0; //@line 7875
 $22 = sp + 64 | 0; //@line 7876
 $23 = sp + 48 | 0; //@line 7877
 $24 = sp + 32 | 0; //@line 7878
 $25 = sp + 16 | 0; //@line 7879
 $26 = sp; //@line 7880
 $3 = $0; //@line 7881
 $4 = $1; //@line 7882
 $5 = $2; //@line 7883
 $27 = $4; //@line 7884
 $28 = $27 + 208 | 0; //@line 7885
 SAFE_HEAP_STORE($6 | 0, SAFE_HEAP_LOAD($28 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 4 | 0, SAFE_HEAP_LOAD($28 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 8 | 0, SAFE_HEAP_LOAD($28 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 12 | 0, SAFE_HEAP_LOAD($28 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $29 = $4; //@line 7887
 $30 = $29 + 224 | 0; //@line 7888
 SAFE_HEAP_STORE($7 | 0, SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 4 | 0, SAFE_HEAP_LOAD($30 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 8 | 0, SAFE_HEAP_LOAD($30 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 12 | 0, SAFE_HEAP_LOAD($30 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $31 = $3; //@line 7890
 $32 = $31 + 176 | 0; //@line 7891
 SAFE_HEAP_STORE($8 | 0, SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 4 | 0, SAFE_HEAP_LOAD($32 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 8 | 0, SAFE_HEAP_LOAD($32 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 12 | 0, SAFE_HEAP_LOAD($32 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_67($9, $$byval_copy, $$byval_copy1); //@line 7895
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_67($11, $$byval_copy2, $$byval_copy3); //@line 7898
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $33 = +_cpvdot_68($$byval_copy4, $$byval_copy5); //@line 7901
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $34 = +_cpvlengthsq_79($$byval_copy6); //@line 7903
 $35 = $33 / $34; //@line 7904
 $36 = +_cpfclamp01($35); //@line 7905
 $10 = $36; //@line 7906
 $37 = $10; //@line 7907
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_64($13, $$byval_copy7, $37); //@line 7909
 SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_66($12, $$byval_copy8, $$byval_copy9); //@line 7912
 $38 = $3; //@line 7913
 $39 = $38 + 192 | 0; //@line 7914
 $40 = +(+SAFE_HEAP_LOAD_D($39 | 0, 8)); //@line 7915
 $41 = $4; //@line 7916
 $42 = $41 + 256 | 0; //@line 7917
 $43 = +(+SAFE_HEAP_LOAD_D($42 | 0, 8)); //@line 7918
 $44 = $40 + $43; //@line 7919
 $14 = $44; //@line 7920
 SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_67($15, $$byval_copy10, $$byval_copy11); //@line 7923
 SAFE_HEAP_STORE($$byval_copy12 | 0, SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 4 | 0, SAFE_HEAP_LOAD($15 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 8 | 0, SAFE_HEAP_LOAD($15 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 12 | 0, SAFE_HEAP_LOAD($15 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $45 = +_cpvlengthsq_79($$byval_copy12); //@line 7925
 $16 = $45; //@line 7926
 $46 = $16; //@line 7927
 $47 = $14; //@line 7928
 $48 = $14; //@line 7929
 $49 = $47 * $48; //@line 7930
 $50 = $46 < $49; //@line 7931
 if (!$50) {
  STACKTOP = sp; //@line 7933
  return;
 }
 $51 = $16; //@line 7935
 $52 = +Math_sqrt(+$51); //@line 7936
 $17 = $52; //@line 7937
 $53 = $5; //@line 7938
 $54 = $53 + 16 | 0; //@line 7939
 $55 = $17; //@line 7940
 $56 = $55 != 0.0; //@line 7941
 if ($56) {
  $57 = $17; //@line 7943
  $58 = 1.0 / $57; //@line 7944
  SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($15 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($15 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($15 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvmult_64($19, $$byval_copy13, $58); //@line 7946
  SAFE_HEAP_STORE($54 | 0, SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($54 + 4 | 0, SAFE_HEAP_LOAD($19 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($54 + 8 | 0, SAFE_HEAP_LOAD($19 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($54 + 12 | 0, SAFE_HEAP_LOAD($19 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 } else {
  $59 = $4; //@line 7949
  $60 = $59 + 240 | 0; //@line 7950
  SAFE_HEAP_STORE($54 | 0, SAFE_HEAP_LOAD($60 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($54 + 4 | 0, SAFE_HEAP_LOAD($60 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($54 + 8 | 0, SAFE_HEAP_LOAD($60 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($54 + 12 | 0, SAFE_HEAP_LOAD($60 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 }
 SAFE_HEAP_STORE($18 | 0, SAFE_HEAP_LOAD($54 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($18 + 4 | 0, SAFE_HEAP_LOAD($54 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($18 + 8 | 0, SAFE_HEAP_LOAD($54 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($18 + 12 | 0, SAFE_HEAP_LOAD($54 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $61 = $4; //@line 7954
 $62 = $61 + 8 | 0; //@line 7955
 $63 = SAFE_HEAP_LOAD($62 | 0, 4, 0) | 0 | 0; //@line 7956
 _cpBodyGetRotation($20, $63); //@line 7957
 $64 = $10; //@line 7958
 $65 = $64 != 0.0; //@line 7959
 if (!$65) {
  $66 = $4; //@line 7961
  $67 = $66 + 264 | 0; //@line 7962
  SAFE_HEAP_STORE($$byval_copy14 | 0, SAFE_HEAP_LOAD($67 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy14 + 4 | 0, SAFE_HEAP_LOAD($67 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy14 + 8 | 0, SAFE_HEAP_LOAD($67 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy14 + 12 | 0, SAFE_HEAP_LOAD($67 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 | 0, SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 + 4 | 0, SAFE_HEAP_LOAD($20 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 + 8 | 0, SAFE_HEAP_LOAD($20 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 + 12 | 0, SAFE_HEAP_LOAD($20 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvrotate_86($21, $$byval_copy14, $$byval_copy15); //@line 7965
  SAFE_HEAP_STORE($$byval_copy16 | 0, SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy16 + 4 | 0, SAFE_HEAP_LOAD($18 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy16 + 8 | 0, SAFE_HEAP_LOAD($18 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy16 + 12 | 0, SAFE_HEAP_LOAD($18 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 | 0, SAFE_HEAP_LOAD($21 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 + 4 | 0, SAFE_HEAP_LOAD($21 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 + 8 | 0, SAFE_HEAP_LOAD($21 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 + 12 | 0, SAFE_HEAP_LOAD($21 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $68 = +_cpvdot_68($$byval_copy16, $$byval_copy17); //@line 7968
  $69 = $68 >= 0.0; //@line 7969
  if (!$69) {
   STACKTOP = sp; //@line 7971
   return;
  }
 }
 $70 = $10; //@line 7974
 $71 = $70 != 1.0; //@line 7975
 if (!$71) {
  $72 = $4; //@line 7977
  $73 = $72 + 280 | 0; //@line 7978
  SAFE_HEAP_STORE($$byval_copy18 | 0, SAFE_HEAP_LOAD($73 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy18 + 4 | 0, SAFE_HEAP_LOAD($73 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy18 + 8 | 0, SAFE_HEAP_LOAD($73 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy18 + 12 | 0, SAFE_HEAP_LOAD($73 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy19 | 0, SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy19 + 4 | 0, SAFE_HEAP_LOAD($20 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy19 + 8 | 0, SAFE_HEAP_LOAD($20 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy19 + 12 | 0, SAFE_HEAP_LOAD($20 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvrotate_86($22, $$byval_copy18, $$byval_copy19); //@line 7981
  SAFE_HEAP_STORE($$byval_copy20 | 0, SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 + 4 | 0, SAFE_HEAP_LOAD($18 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 + 8 | 0, SAFE_HEAP_LOAD($18 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 + 12 | 0, SAFE_HEAP_LOAD($18 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 | 0, SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 + 4 | 0, SAFE_HEAP_LOAD($22 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 + 8 | 0, SAFE_HEAP_LOAD($22 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 + 12 | 0, SAFE_HEAP_LOAD($22 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $74 = +_cpvdot_68($$byval_copy20, $$byval_copy21); //@line 7984
  $75 = $74 >= 0.0; //@line 7985
  if (!$75) {
   STACKTOP = sp; //@line 7987
   return;
  }
 }
 $76 = $5; //@line 7990
 $77 = $3; //@line 7991
 $78 = $77 + 192 | 0; //@line 7992
 $79 = +(+SAFE_HEAP_LOAD_D($78 | 0, 8)); //@line 7993
 SAFE_HEAP_STORE($$byval_copy22 | 0, SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy22 + 4 | 0, SAFE_HEAP_LOAD($18 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy22 + 8 | 0, SAFE_HEAP_LOAD($18 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy22 + 12 | 0, SAFE_HEAP_LOAD($18 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_64($24, $$byval_copy22, $79); //@line 7995
 SAFE_HEAP_STORE($$byval_copy23 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy23 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy23 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy23 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy24 | 0, SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy24 + 4 | 0, SAFE_HEAP_LOAD($24 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy24 + 8 | 0, SAFE_HEAP_LOAD($24 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy24 + 12 | 0, SAFE_HEAP_LOAD($24 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_66($23, $$byval_copy23, $$byval_copy24); //@line 7998
 $80 = $4; //@line 7999
 $81 = $80 + 256 | 0; //@line 8000
 $82 = +(+SAFE_HEAP_LOAD_D($81 | 0, 8)); //@line 8001
 $83 = -$82; //@line 8002
 SAFE_HEAP_STORE($$byval_copy25 | 0, SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy25 + 4 | 0, SAFE_HEAP_LOAD($18 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy25 + 8 | 0, SAFE_HEAP_LOAD($18 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy25 + 12 | 0, SAFE_HEAP_LOAD($18 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_64($26, $$byval_copy25, $83); //@line 8004
 SAFE_HEAP_STORE($$byval_copy26 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy26 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy26 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy26 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy27 | 0, SAFE_HEAP_LOAD($26 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy27 + 4 | 0, SAFE_HEAP_LOAD($26 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy27 + 8 | 0, SAFE_HEAP_LOAD($26 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy27 + 12 | 0, SAFE_HEAP_LOAD($26 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_66($25, $$byval_copy26, $$byval_copy27); //@line 8007
 SAFE_HEAP_STORE($$byval_copy28 | 0, SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy28 + 4 | 0, SAFE_HEAP_LOAD($23 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy28 + 8 | 0, SAFE_HEAP_LOAD($23 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy28 + 12 | 0, SAFE_HEAP_LOAD($23 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy29 | 0, SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy29 + 4 | 0, SAFE_HEAP_LOAD($25 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy29 + 8 | 0, SAFE_HEAP_LOAD($25 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy29 + 12 | 0, SAFE_HEAP_LOAD($25 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpCollisionInfoPushContact($76, $$byval_copy28, $$byval_copy29, 0); //@line 8010
 STACKTOP = sp; //@line 8011
 return;
}
function _cpPolyShapeSegmentQuery($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 4384
 $1 = $1 | 0; //@line 4385
 $2 = $2 | 0; //@line 4386
 $3 = +$3; //@line 4387
 $4 = $4 | 0; //@line 4388
 var $$byval_copy = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy14 = 0, $$byval_copy15 = 0, $$byval_copy16 = 0, $$byval_copy17 = 0, $$byval_copy18 = 0, $$byval_copy19 = 0, $$byval_copy2 = 0, $$byval_copy20 = 0, $$byval_copy21 = 0, $$byval_copy22 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0; //@line 4389
 var $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0.0, $100 = 0, $101 = 0.0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0.0, $110 = 0, $111 = 0, $112 = 0, $113 = 0.0, $114 = 0.0, $115 = 0; //@line 4390
 var $116 = 0.0, $117 = 0, $118 = 0, $119 = 0.0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $13 = 0, $14 = 0.0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0, $19 = 0.0, $20 = 0.0, $21 = 0.0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0.0, $36 = 0.0, $37 = 0.0, $38 = 0.0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0; //@line 4392
 var $44 = 0, $45 = 0, $46 = 0.0, $47 = 0.0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0.0, $52 = 0.0, $53 = 0.0, $54 = 0.0, $55 = 0.0, $56 = 0, $57 = 0.0, $58 = 0.0, $59 = 0.0, $6 = 0.0, $60 = 0.0, $61 = 0.0; //@line 4393
 var $62 = 0.0, $63 = 0.0, $64 = 0, $65 = 0.0, $66 = 0, $67 = 0.0, $68 = 0.0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0.0, $78 = 0, $79 = 0, $8 = 0;
 var $80 = 0, $81 = 0.0, $82 = 0.0, $83 = 0.0, $84 = 0, $85 = 0.0, $86 = 0.0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0.0, $93 = 0.0, $94 = 0, $95 = 0, $96 = 0.0, $97 = 0, $98 = 0; //@line 4395
 var $99 = 0, $or$cond = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 4396
 sp = STACKTOP; //@line 4397
 STACKTOP = STACKTOP + 592 | 0; //@line 4398
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(592 | 0); //@line 4398
 $$byval_copy22 = sp + 544 | 0; //@line 4399
 $$byval_copy21 = sp + 528 | 0; //@line 4400
 $$byval_copy20 = sp + 512 | 0; //@line 4401
 $$byval_copy19 = sp + 496 | 0; //@line 4402
 $$byval_copy18 = sp + 480 | 0; //@line 4403
 $$byval_copy17 = sp + 464 | 0; //@line 4404
 $$byval_copy16 = sp + 448 | 0; //@line 4405
 $$byval_copy15 = sp + 432 | 0; //@line 4406
 $$byval_copy14 = sp + 416 | 0; //@line 4407
 $$byval_copy13 = sp + 400 | 0; //@line 4408
 $$byval_copy12 = sp + 384 | 0; //@line 4409
 $$byval_copy11 = sp + 368 | 0; //@line 4410
 $$byval_copy10 = sp + 352 | 0; //@line 4411
 $$byval_copy9 = sp + 336 | 0; //@line 4412
 $$byval_copy8 = sp + 320 | 0; //@line 4413
 $$byval_copy7 = sp + 304 | 0; //@line 4414
 $$byval_copy6 = sp + 288 | 0; //@line 4415
 $$byval_copy5 = sp + 272 | 0; //@line 4416
 $$byval_copy4 = sp + 256 | 0; //@line 4417
 $$byval_copy3 = sp + 240 | 0; //@line 4418
 $$byval_copy2 = sp + 224 | 0; //@line 4419
 $$byval_copy = sp + 208 | 0; //@line 4420
 $13 = sp + 168 | 0; //@line 4421
 $18 = sp + 120 | 0; //@line 4422
 $22 = sp + 80 | 0; //@line 4423
 $23 = sp + 64 | 0; //@line 4424
 $24 = sp + 48 | 0; //@line 4425
 $26 = sp; //@line 4426
 $5 = $0; //@line 4427
 $6 = $3; //@line 4428
 $7 = $4; //@line 4429
 $27 = $5; //@line 4430
 $28 = $27 + 172 | 0; //@line 4431
 $29 = SAFE_HEAP_LOAD($28 | 0, 4, 0) | 0 | 0; //@line 4432
 $8 = $29; //@line 4433
 $30 = $5; //@line 4434
 $31 = $30 + 168 | 0; //@line 4435
 $32 = SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0; //@line 4436
 $9 = $32; //@line 4437
 $33 = $5; //@line 4438
 $34 = $33 + 160 | 0; //@line 4439
 $35 = +(+SAFE_HEAP_LOAD_D($34 | 0, 8)); //@line 4440
 $10 = $35; //@line 4441
 $36 = $10; //@line 4442
 $37 = $6; //@line 4443
 $38 = $36 + $37; //@line 4444
 $11 = $38; //@line 4445
 $12 = 0; //@line 4446
 while (1) {
  $39 = $12; //@line 4448
  $40 = $9; //@line 4449
  $41 = ($39 | 0) < ($40 | 0); //@line 4450
  if (!$41) {
   break;
  }
  $42 = $8; //@line 4454
  $43 = $12; //@line 4455
  $44 = $42 + ($43 << 5) | 0; //@line 4456
  $45 = $44 + 16 | 0; //@line 4457
  SAFE_HEAP_STORE($13 | 0, SAFE_HEAP_LOAD($45 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($13 + 4 | 0, SAFE_HEAP_LOAD($45 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($13 + 8 | 0, SAFE_HEAP_LOAD($45 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($13 + 12 | 0, SAFE_HEAP_LOAD($45 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $46 = +_cpvdot_272($$byval_copy, $$byval_copy2); //@line 4461
  $14 = $46; //@line 4462
  $47 = $14; //@line 4463
  $48 = $8; //@line 4464
  $49 = $12; //@line 4465
  $50 = $48 + ($49 << 5) | 0; //@line 4466
  SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($50 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($50 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($50 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($50 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $51 = +_cpvdot_272($$byval_copy3, $$byval_copy4); //@line 4469
  $52 = $47 - $51; //@line 4470
  $53 = $11; //@line 4471
  $54 = $52 - $53; //@line 4472
  $15 = $54; //@line 4473
  $55 = $15; //@line 4474
  $56 = $55 < 0.0; //@line 4475
  if (!$56) {
   SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   $57 = +_cpvdot_272($$byval_copy5, $$byval_copy6); //@line 4479
   $16 = $57; //@line 4480
   $58 = $15; //@line 4481
   $59 = $14; //@line 4482
   $60 = $16; //@line 4483
   $61 = $59 - $60; //@line 4484
   $62 = $58 / $61; //@line 4485
   $17 = $62; //@line 4486
   $63 = $17; //@line 4487
   $64 = $63 < 0.0; //@line 4488
   $65 = $17; //@line 4489
   $66 = 1.0 < $65; //@line 4490
   $or$cond = $64 | $66; //@line 4491
   if (!$or$cond) {
    $67 = $17; //@line 4493
    SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    _cpvlerp_273($18, $$byval_copy7, $$byval_copy8, $67); //@line 4496
    SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($18 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($18 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($18 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    $68 = +_cpvcross_274($$byval_copy9, $$byval_copy10); //@line 4499
    $19 = $68; //@line 4500
    $69 = $8; //@line 4501
    $70 = $12; //@line 4502
    $71 = $70 - 1 | 0; //@line 4503
    $72 = $9; //@line 4504
    $73 = $71 + $72 | 0; //@line 4505
    $74 = $9; //@line 4506
    $75 = ($73 | 0) % ($74 | 0) & -1; //@line 4507
    $76 = $69 + ($75 << 5) | 0; //@line 4508
    SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy12 | 0, SAFE_HEAP_LOAD($76 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy12 + 4 | 0, SAFE_HEAP_LOAD($76 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy12 + 8 | 0, SAFE_HEAP_LOAD($76 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy12 + 12 | 0, SAFE_HEAP_LOAD($76 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    $77 = +_cpvcross_274($$byval_copy11, $$byval_copy12); //@line 4511
    $20 = $77; //@line 4512
    $78 = $8; //@line 4513
    $79 = $12; //@line 4514
    $80 = $78 + ($79 << 5) | 0; //@line 4515
    SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy14 | 0, SAFE_HEAP_LOAD($80 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy14 + 4 | 0, SAFE_HEAP_LOAD($80 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy14 + 8 | 0, SAFE_HEAP_LOAD($80 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy14 + 12 | 0, SAFE_HEAP_LOAD($80 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    $81 = +_cpvcross_274($$byval_copy13, $$byval_copy14); //@line 4518
    $21 = $81; //@line 4519
    $82 = $20; //@line 4520
    $83 = $19; //@line 4521
    $84 = $82 <= $83; //@line 4522
    if ($84) {
     $85 = $19; //@line 4524
     $86 = $21; //@line 4525
     $87 = $85 <= $86; //@line 4526
     if ($87) {
      $88 = $5; //@line 4528
      $89 = $7; //@line 4529
      SAFE_HEAP_STORE($89 | 0, $88 | 0, 4);
      $90 = $7; //@line 4531
      $91 = $90 + 8 | 0; //@line 4532
      $92 = $17; //@line 4533
      SAFE_HEAP_STORE($$byval_copy15 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($$byval_copy15 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($$byval_copy15 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($$byval_copy15 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($$byval_copy16 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($$byval_copy16 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($$byval_copy16 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($$byval_copy16 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
      _cpvlerp_273($22, $$byval_copy15, $$byval_copy16, $92); //@line 4536
      $93 = $6; //@line 4537
      SAFE_HEAP_STORE($$byval_copy17 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($$byval_copy17 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($$byval_copy17 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($$byval_copy17 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
      _cpvmult_270($23, $$byval_copy17, $93); //@line 4539
      SAFE_HEAP_STORE($$byval_copy18 | 0, SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($$byval_copy18 + 4 | 0, SAFE_HEAP_LOAD($22 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($$byval_copy18 + 8 | 0, SAFE_HEAP_LOAD($22 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($$byval_copy18 + 12 | 0, SAFE_HEAP_LOAD($22 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($$byval_copy19 | 0, SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($$byval_copy19 + 4 | 0, SAFE_HEAP_LOAD($23 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($$byval_copy19 + 8 | 0, SAFE_HEAP_LOAD($23 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($$byval_copy19 + 12 | 0, SAFE_HEAP_LOAD($23 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
      _cpvsub_266($24, $$byval_copy18, $$byval_copy19); //@line 4542
      SAFE_HEAP_STORE($91 | 0, SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($91 + 4 | 0, SAFE_HEAP_LOAD($24 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($91 + 8 | 0, SAFE_HEAP_LOAD($24 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($91 + 12 | 0, SAFE_HEAP_LOAD($24 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
      $94 = $7; //@line 4544
      $95 = $94 + 24 | 0; //@line 4545
      SAFE_HEAP_STORE($95 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($95 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($95 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
      SAFE_HEAP_STORE($95 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
      $96 = $17; //@line 4547
      $97 = $7; //@line 4548
      $98 = $97 + 40 | 0; //@line 4549
      SAFE_HEAP_STORE_D($98 | 0, +$96, 8);
     }
    }
   }
  }
  $99 = $12; //@line 4555
  $100 = $99 + 1 | 0; //@line 4556
  $12 = $100; //@line 4557
 }
 $101 = $11; //@line 4559
 $102 = $101 > 0.0; //@line 4560
 if (!$102) {
  STACKTOP = sp; //@line 4562
  return;
 }
 $25 = 0; //@line 4564
 while (1) {
  $103 = $25; //@line 4566
  $104 = $9; //@line 4567
  $105 = ($103 | 0) < ($104 | 0); //@line 4568
  if (!$105) {
   break;
  }
  SAFE_HEAP_STORE($26 | 0, 0 | 0, 4);
  $106 = $26 + 8 | 0; //@line 4573
  SAFE_HEAP_STORE($106 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($106 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($106 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($106 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $107 = $26 + 24 | 0; //@line 4575
  SAFE_HEAP_STORE($107 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($107 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($107 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($107 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $108 = $26 + 40 | 0; //@line 4577
  SAFE_HEAP_STORE_D($108 | 0, +1.0, 8);
  $109 = $5; //@line 4579
  $110 = $8; //@line 4580
  $111 = $25; //@line 4581
  $112 = $110 + ($111 << 5) | 0; //@line 4582
  $113 = $10; //@line 4583
  $114 = $6; //@line 4584
  SAFE_HEAP_STORE($$byval_copy20 | 0, SAFE_HEAP_LOAD($112 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 + 4 | 0, SAFE_HEAP_LOAD($112 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 + 8 | 0, SAFE_HEAP_LOAD($112 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 + 12 | 0, SAFE_HEAP_LOAD($112 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy22 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy22 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy22 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy22 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _CircleSegmentQuery($109, $$byval_copy20, $113, $$byval_copy21, $$byval_copy22, $114, $26); //@line 4588
  $115 = $26 + 40 | 0; //@line 4589
  $116 = +(+SAFE_HEAP_LOAD_D($115 | 0, 8)); //@line 4590
  $117 = $7; //@line 4591
  $118 = $117 + 40 | 0; //@line 4592
  $119 = +(+SAFE_HEAP_LOAD_D($118 | 0, 8)); //@line 4593
  $120 = $116 < $119; //@line 4594
  if ($120) {
   $121 = $7; //@line 4596
   dest = $121; //@line 4597
   src = $26; //@line 4597
   stop = dest + 48 | 0; //@line 4597
   do {
    SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
    dest = dest + 4 | 0; //@line 4597
    src = src + 4 | 0; //@line 4597
   } while ((dest | 0) < (stop | 0));
  }
  $122 = $25; //@line 4599
  $123 = $122 + 1 | 0; //@line 4600
  $25 = $123; //@line 4601
 }
 STACKTOP = sp; //@line 4603
 return;
}
function _cpSpaceStep($0, $1) {
 $0 = $0 | 0; //@line 5131
 $1 = +$1; //@line 5132
 var $$byval_copy = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0.0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0; //@line 5133
 var $117 = 0, $118 = 0.0, $119 = 0, $12 = 0.0, $120 = 0, $121 = 0.0, $122 = 0.0, $123 = 0.0, $124 = 0.0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0.0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0; //@line 5134
 var $135 = 0.0, $136 = 0.0, $137 = 0.0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0;
 var $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0.0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0.0, $168 = 0.0, $169 = 0.0, $17 = 0, $170 = 0; //@line 5136
 var $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0.0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0.0, $186 = 0.0, $187 = 0, $188 = 0, $189 = 0.0; //@line 5137
 var $19 = 0, $190 = 0, $191 = 0.0, $192 = 0.0, $193 = 0.0, $194 = 0.0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $2 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0.0, $206 = 0; //@line 5138
 var $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0.0, $220 = 0, $221 = 0, $222 = 0, $223 = 0.0, $224 = 0; //@line 5139
 var $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0; //@line 5140
 var $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0.0, $258 = 0, $259 = 0, $26 = 0, $260 = 0; //@line 5141
 var $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0; //@line 5142
 var $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0, $297 = 0; //@line 5143
 var $298 = 0, $299 = 0, $3 = 0.0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0.0, $37 = 0, $38 = 0, $39 = 0, $4 = 0.0; //@line 5144
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0.0, $45 = 0.0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0; //@line 5145
 var $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0; //@line 5146
 var $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0; //@line 5147
 var $95 = 0, $96 = 0, $97 = 0.0, $98 = 0, $99 = 0, label = 0, sp = 0; //@line 5148
 sp = STACKTOP; //@line 5149
 STACKTOP = STACKTOP + 192 | 0; //@line 5150
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(192 | 0); //@line 5150
 $$byval_copy = sp + 64 | 0; //@line 5151
 $19 = sp + 8 | 0; //@line 5152
 $2 = $0; //@line 5153
 $3 = $1; //@line 5154
 $36 = $3; //@line 5155
 $37 = $36 == 0.0; //@line 5156
 if ($37) {
  STACKTOP = sp; //@line 5158
  return;
 }
 $38 = $2; //@line 5160
 $39 = $38 + 72 | 0; //@line 5161
 $40 = SAFE_HEAP_LOAD($39 | 0, 4, 0) | 0 | 0; //@line 5162
 $41 = $40 + 1 | 0; //@line 5163
 SAFE_HEAP_STORE($39 | 0, $41 | 0, 4);
 $42 = $2; //@line 5165
 $43 = $42 + 80 | 0; //@line 5166
 $44 = +(+SAFE_HEAP_LOAD_D($43 | 0, 8)); //@line 5167
 $4 = $44; //@line 5168
 $45 = $3; //@line 5169
 $46 = $2; //@line 5170
 $47 = $46 + 80 | 0; //@line 5171
 SAFE_HEAP_STORE_D($47 | 0, +$45, 8);
 $48 = $2; //@line 5173
 $49 = $48 + 88 | 0; //@line 5174
 $50 = SAFE_HEAP_LOAD($49 | 0, 4, 0) | 0 | 0; //@line 5175
 $5 = $50; //@line 5176
 $51 = $2; //@line 5177
 $52 = $51 + 116 | 0; //@line 5178
 $53 = SAFE_HEAP_LOAD($52 | 0, 4, 0) | 0 | 0; //@line 5179
 $6 = $53; //@line 5180
 $54 = $2; //@line 5181
 $55 = $54 + 120 | 0; //@line 5182
 $56 = SAFE_HEAP_LOAD($55 | 0, 4, 0) | 0 | 0; //@line 5183
 $7 = $56; //@line 5184
 $8 = 0; //@line 5185
 while (1) {
  $57 = $8; //@line 5187
  $58 = $7; //@line 5188
  $59 = SAFE_HEAP_LOAD($58 | 0, 4, 0) | 0 | 0; //@line 5189
  $60 = ($57 | 0) < ($59 | 0); //@line 5190
  $61 = $7; //@line 5191
  if (!$60) {
   break;
  }
  $62 = $61 + 8 | 0; //@line 5195
  $63 = SAFE_HEAP_LOAD($62 | 0, 4, 0) | 0 | 0; //@line 5196
  $64 = $8; //@line 5197
  $65 = $63 + ($64 << 2) | 0; //@line 5198
  $66 = SAFE_HEAP_LOAD($65 | 0, 4, 0) | 0 | 0; //@line 5199
  $9 = $66; //@line 5200
  $67 = $9; //@line 5201
  $68 = $67 + 116 | 0; //@line 5202
  SAFE_HEAP_STORE($68 | 0, 1 | 0, 4);
  $69 = $9; //@line 5204
  $70 = $69 + 44 | 0; //@line 5205
  $71 = SAFE_HEAP_LOAD($70 | 0, 4, 0) | 0 | 0; //@line 5206
  $72 = _cpBodyIsSleeping($71) | 0; //@line 5207
  $73 = $72 << 24 >> 24 != 0; //@line 5208
  if (!$73) {
   $74 = $9; //@line 5210
   $75 = $74 + 48 | 0; //@line 5211
   $76 = SAFE_HEAP_LOAD($75 | 0, 4, 0) | 0 | 0; //@line 5212
   $77 = _cpBodyIsSleeping($76) | 0; //@line 5213
   $78 = $77 << 24 >> 24 != 0; //@line 5214
   if (!$78) {
    $79 = $9; //@line 5216
    _cpArbiterUnthread($79); //@line 5217
   }
  }
  $80 = $8; //@line 5220
  $81 = $80 + 1 | 0; //@line 5221
  $8 = $81; //@line 5222
 }
 SAFE_HEAP_STORE($61 | 0, 0 | 0, 4);
 $82 = $2; //@line 5225
 _cpSpaceLock($82); //@line 5226
 $10 = 0; //@line 5227
 while (1) {
  $83 = $10; //@line 5229
  $84 = $5; //@line 5230
  $85 = SAFE_HEAP_LOAD($84 | 0, 4, 0) | 0 | 0; //@line 5231
  $86 = ($83 | 0) < ($85 | 0); //@line 5232
  if (!$86) {
   break;
  }
  $87 = $5; //@line 5236
  $88 = $87 + 8 | 0; //@line 5237
  $89 = SAFE_HEAP_LOAD($88 | 0, 4, 0) | 0 | 0; //@line 5238
  $90 = $10; //@line 5239
  $91 = $89 + ($90 << 2) | 0; //@line 5240
  $92 = SAFE_HEAP_LOAD($91 | 0, 4, 0) | 0 | 0; //@line 5241
  $11 = $92; //@line 5242
  $93 = $11; //@line 5243
  $94 = $93 + 4 | 0; //@line 5244
  $95 = SAFE_HEAP_LOAD($94 | 0, 4, 0) | 0 | 0; //@line 5245
  $96 = $11; //@line 5246
  $97 = $3; //@line 5247
  FUNCTION_TABLE_vid[(SAFE_FT_MASK($95 | 0, 63 | 0) | 0) & 63]($96, $97); //@line 5248
  $98 = $10; //@line 5249
  $99 = $98 + 1 | 0; //@line 5250
  $10 = $99; //@line 5251
 }
 $100 = $2; //@line 5253
 _cpSpacePushFreshContactBuffer($100); //@line 5254
 $101 = $2; //@line 5255
 $102 = $101 + 112 | 0; //@line 5256
 $103 = SAFE_HEAP_LOAD($102 | 0, 4, 0) | 0 | 0; //@line 5257
 _cpSpatialIndexEach_587($103, 74, 0); //@line 5258
 $104 = $2; //@line 5259
 $105 = $104 + 112 | 0; //@line 5260
 $106 = SAFE_HEAP_LOAD($105 | 0, 4, 0) | 0 | 0; //@line 5261
 $107 = $2; //@line 5262
 _cpSpatialIndexReindexQuery_588($106, 75, $107); //@line 5263
 $108 = $2; //@line 5264
 _cpSpaceUnlock($108, 0); //@line 5265
 $109 = $2; //@line 5266
 $110 = $3; //@line 5267
 _cpSpaceProcessComponents($109, $110); //@line 5268
 $111 = $2; //@line 5269
 _cpSpaceLock($111); //@line 5270
 $112 = $2; //@line 5271
 $113 = $112 + 128 | 0; //@line 5272
 $114 = SAFE_HEAP_LOAD($113 | 0, 4, 0) | 0 | 0; //@line 5273
 $115 = $2; //@line 5274
 _cpHashSetFilter($114, 76, $115); //@line 5275
 $116 = $2; //@line 5276
 $117 = $116 + 48 | 0; //@line 5277
 $118 = +(+SAFE_HEAP_LOAD_D($117 | 0, 8)); //@line 5278
 $12 = $118; //@line 5279
 $119 = $2; //@line 5280
 $120 = $119 + 56 | 0; //@line 5281
 $121 = +(+SAFE_HEAP_LOAD_D($120 | 0, 8)); //@line 5282
 $122 = $3; //@line 5283
 $123 = +Math_pow(+$121, +$122); //@line 5284
 $124 = 1.0 - $123; //@line 5285
 $13 = $124; //@line 5286
 $14 = 0; //@line 5287
 while (1) {
  $125 = $14; //@line 5289
  $126 = $7; //@line 5290
  $127 = SAFE_HEAP_LOAD($126 | 0, 4, 0) | 0 | 0; //@line 5291
  $128 = ($125 | 0) < ($127 | 0); //@line 5292
  if (!$128) {
   break;
  }
  $129 = $7; //@line 5296
  $130 = $129 + 8 | 0; //@line 5297
  $131 = SAFE_HEAP_LOAD($130 | 0, 4, 0) | 0 | 0; //@line 5298
  $132 = $14; //@line 5299
  $133 = $131 + ($132 << 2) | 0; //@line 5300
  $134 = SAFE_HEAP_LOAD($133 | 0, 4, 0) | 0 | 0; //@line 5301
  $135 = $3; //@line 5302
  $136 = $12; //@line 5303
  $137 = $13; //@line 5304
  _cpArbiterPreStep($134, $135, $136, $137); //@line 5305
  $138 = $14; //@line 5306
  $139 = $138 + 1 | 0; //@line 5307
  $14 = $139; //@line 5308
 }
 $15 = 0; //@line 5310
 while (1) {
  $140 = $15; //@line 5312
  $141 = $6; //@line 5313
  $142 = SAFE_HEAP_LOAD($141 | 0, 4, 0) | 0 | 0; //@line 5314
  $143 = ($140 | 0) < ($142 | 0); //@line 5315
  if (!$143) {
   break;
  }
  $144 = $6; //@line 5319
  $145 = $144 + 8 | 0; //@line 5320
  $146 = SAFE_HEAP_LOAD($145 | 0, 4, 0) | 0 | 0; //@line 5321
  $147 = $15; //@line 5322
  $148 = $146 + ($147 << 2) | 0; //@line 5323
  $149 = SAFE_HEAP_LOAD($148 | 0, 4, 0) | 0 | 0; //@line 5324
  $16 = $149; //@line 5325
  $150 = $16; //@line 5326
  $151 = $150 + 52 | 0; //@line 5327
  $152 = SAFE_HEAP_LOAD($151 | 0, 4, 0) | 0 | 0; //@line 5328
  $17 = $152; //@line 5329
  $153 = $17; //@line 5330
  $154 = ($153 | 0) != (0 | 0); //@line 5331
  if ($154) {
   $155 = $17; //@line 5333
   $156 = $16; //@line 5334
   $157 = $2; //@line 5335
   FUNCTION_TABLE_vii[(SAFE_FT_MASK($155 | 0, 127 | 0) | 0) & 127]($156, $157); //@line 5336
  }
  $158 = $16; //@line 5338
  $159 = SAFE_HEAP_LOAD($158 | 0, 4, 0) | 0 | 0; //@line 5339
  $160 = SAFE_HEAP_LOAD($159 | 0, 4, 0) | 0 | 0; //@line 5340
  $161 = $16; //@line 5341
  $162 = $3; //@line 5342
  FUNCTION_TABLE_vid[(SAFE_FT_MASK($160 | 0, 63 | 0) | 0) & 63]($161, $162); //@line 5343
  $163 = $15; //@line 5344
  $164 = $163 + 1 | 0; //@line 5345
  $15 = $164; //@line 5346
 }
 $165 = $2; //@line 5348
 $166 = $165 + 24 | 0; //@line 5349
 $167 = +(+SAFE_HEAP_LOAD_D($166 | 0, 8)); //@line 5350
 $168 = $3; //@line 5351
 $169 = +Math_pow(+$167, +$168); //@line 5352
 $18 = $169; //@line 5353
 $170 = $2; //@line 5354
 $171 = $170 + 8 | 0; //@line 5355
 SAFE_HEAP_STORE($19 | 0, SAFE_HEAP_LOAD($171 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($19 + 4 | 0, SAFE_HEAP_LOAD($171 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($19 + 8 | 0, SAFE_HEAP_LOAD($171 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($19 + 12 | 0, SAFE_HEAP_LOAD($171 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $20 = 0; //@line 5357
 while (1) {
  $172 = $20; //@line 5359
  $173 = $5; //@line 5360
  $174 = SAFE_HEAP_LOAD($173 | 0, 4, 0) | 0 | 0; //@line 5361
  $175 = ($172 | 0) < ($174 | 0); //@line 5362
  if (!$175) {
   break;
  }
  $176 = $5; //@line 5366
  $177 = $176 + 8 | 0; //@line 5367
  $178 = SAFE_HEAP_LOAD($177 | 0, 4, 0) | 0 | 0; //@line 5368
  $179 = $20; //@line 5369
  $180 = $178 + ($179 << 2) | 0; //@line 5370
  $181 = SAFE_HEAP_LOAD($180 | 0, 4, 0) | 0 | 0; //@line 5371
  $21 = $181; //@line 5372
  $182 = $21; //@line 5373
  $183 = SAFE_HEAP_LOAD($182 | 0, 4, 0) | 0 | 0; //@line 5374
  $184 = $21; //@line 5375
  $185 = $18; //@line 5376
  $186 = $3; //@line 5377
  SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($19 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($19 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($19 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  FUNCTION_TABLE_viidd[(SAFE_FT_MASK($183 | 0, 63 | 0) | 0) & 63]($184, $$byval_copy, $185, $186); //@line 5379
  $187 = $20; //@line 5380
  $188 = $187 + 1 | 0; //@line 5381
  $20 = $188; //@line 5382
 }
 $189 = $4; //@line 5384
 $190 = $189 == 0.0; //@line 5385
 if ($190) {
  $194 = 0.0; //@line 5387
 } else {
  $191 = $3; //@line 5389
  $192 = $4; //@line 5390
  $193 = $191 / $192; //@line 5391
  $194 = $193; //@line 5392
 }
 $22 = $194; //@line 5394
 $23 = 0; //@line 5395
 while (1) {
  $195 = $23; //@line 5397
  $196 = $7; //@line 5398
  $197 = SAFE_HEAP_LOAD($196 | 0, 4, 0) | 0 | 0; //@line 5399
  $198 = ($195 | 0) < ($197 | 0); //@line 5400
  if (!$198) {
   break;
  }
  $199 = $7; //@line 5404
  $200 = $199 + 8 | 0; //@line 5405
  $201 = SAFE_HEAP_LOAD($200 | 0, 4, 0) | 0 | 0; //@line 5406
  $202 = $23; //@line 5407
  $203 = $201 + ($202 << 2) | 0; //@line 5408
  $204 = SAFE_HEAP_LOAD($203 | 0, 4, 0) | 0 | 0; //@line 5409
  $205 = $22; //@line 5410
  _cpArbiterApplyCachedImpulse($204, $205); //@line 5411
  $206 = $23; //@line 5412
  $207 = $206 + 1 | 0; //@line 5413
  $23 = $207; //@line 5414
 }
 $24 = 0; //@line 5416
 while (1) {
  $208 = $24; //@line 5418
  $209 = $6; //@line 5419
  $210 = SAFE_HEAP_LOAD($209 | 0, 4, 0) | 0 | 0; //@line 5420
  $211 = ($208 | 0) < ($210 | 0); //@line 5421
  if (!$211) {
   break;
  }
  $212 = $6; //@line 5425
  $213 = $212 + 8 | 0; //@line 5426
  $214 = SAFE_HEAP_LOAD($213 | 0, 4, 0) | 0 | 0; //@line 5427
  $215 = $24; //@line 5428
  $216 = $214 + ($215 << 2) | 0; //@line 5429
  $217 = SAFE_HEAP_LOAD($216 | 0, 4, 0) | 0 | 0; //@line 5430
  $25 = $217; //@line 5431
  $218 = $25; //@line 5432
  $219 = SAFE_HEAP_LOAD($218 | 0, 4, 0) | 0 | 0; //@line 5433
  $220 = $219 + 4 | 0; //@line 5434
  $221 = SAFE_HEAP_LOAD($220 | 0, 4, 0) | 0 | 0; //@line 5435
  $222 = $25; //@line 5436
  $223 = $22; //@line 5437
  FUNCTION_TABLE_vid[(SAFE_FT_MASK($221 | 0, 63 | 0) | 0) & 63]($222, $223); //@line 5438
  $224 = $24; //@line 5439
  $225 = $224 + 1 | 0; //@line 5440
  $24 = $225; //@line 5441
 }
 $26 = 0; //@line 5443
 while (1) {
  $226 = $26; //@line 5445
  $227 = $2; //@line 5446
  $228 = SAFE_HEAP_LOAD($227 | 0, 4, 0) | 0 | 0; //@line 5447
  $229 = ($226 | 0) < ($228 | 0); //@line 5448
  if (!$229) {
   break;
  }
  $27 = 0; //@line 5452
  while (1) {
   $230 = $27; //@line 5454
   $231 = $7; //@line 5455
   $232 = SAFE_HEAP_LOAD($231 | 0, 4, 0) | 0 | 0; //@line 5456
   $233 = ($230 | 0) < ($232 | 0); //@line 5457
   if (!$233) {
    break;
   }
   $234 = $7; //@line 5461
   $235 = $234 + 8 | 0; //@line 5462
   $236 = SAFE_HEAP_LOAD($235 | 0, 4, 0) | 0 | 0; //@line 5463
   $237 = $27; //@line 5464
   $238 = $236 + ($237 << 2) | 0; //@line 5465
   $239 = SAFE_HEAP_LOAD($238 | 0, 4, 0) | 0 | 0; //@line 5466
   _cpArbiterApplyImpulse($239); //@line 5467
   $240 = $27; //@line 5468
   $241 = $240 + 1 | 0; //@line 5469
   $27 = $241; //@line 5470
  }
  $28 = 0; //@line 5472
  while (1) {
   $242 = $28; //@line 5474
   $243 = $6; //@line 5475
   $244 = SAFE_HEAP_LOAD($243 | 0, 4, 0) | 0 | 0; //@line 5476
   $245 = ($242 | 0) < ($244 | 0); //@line 5477
   if (!$245) {
    break;
   }
   $246 = $6; //@line 5481
   $247 = $246 + 8 | 0; //@line 5482
   $248 = SAFE_HEAP_LOAD($247 | 0, 4, 0) | 0 | 0; //@line 5483
   $249 = $28; //@line 5484
   $250 = $248 + ($249 << 2) | 0; //@line 5485
   $251 = SAFE_HEAP_LOAD($250 | 0, 4, 0) | 0 | 0; //@line 5486
   $29 = $251; //@line 5487
   $252 = $29; //@line 5488
   $253 = SAFE_HEAP_LOAD($252 | 0, 4, 0) | 0 | 0; //@line 5489
   $254 = $253 + 8 | 0; //@line 5490
   $255 = SAFE_HEAP_LOAD($254 | 0, 4, 0) | 0 | 0; //@line 5491
   $256 = $29; //@line 5492
   $257 = $3; //@line 5493
   FUNCTION_TABLE_vid[(SAFE_FT_MASK($255 | 0, 63 | 0) | 0) & 63]($256, $257); //@line 5494
   $258 = $28; //@line 5495
   $259 = $258 + 1 | 0; //@line 5496
   $28 = $259; //@line 5497
  }
  $260 = $26; //@line 5499
  $261 = $260 + 1 | 0; //@line 5500
  $26 = $261; //@line 5501
 }
 $30 = 0; //@line 5503
 while (1) {
  $262 = $30; //@line 5505
  $263 = $6; //@line 5506
  $264 = SAFE_HEAP_LOAD($263 | 0, 4, 0) | 0 | 0; //@line 5507
  $265 = ($262 | 0) < ($264 | 0); //@line 5508
  if (!$265) {
   break;
  }
  $266 = $6; //@line 5512
  $267 = $266 + 8 | 0; //@line 5513
  $268 = SAFE_HEAP_LOAD($267 | 0, 4, 0) | 0 | 0; //@line 5514
  $269 = $30; //@line 5515
  $270 = $268 + ($269 << 2) | 0; //@line 5516
  $271 = SAFE_HEAP_LOAD($270 | 0, 4, 0) | 0 | 0; //@line 5517
  $31 = $271; //@line 5518
  $272 = $31; //@line 5519
  $273 = $272 + 56 | 0; //@line 5520
  $274 = SAFE_HEAP_LOAD($273 | 0, 4, 0) | 0 | 0; //@line 5521
  $32 = $274; //@line 5522
  $275 = $32; //@line 5523
  $276 = ($275 | 0) != (0 | 0); //@line 5524
  if ($276) {
   $277 = $32; //@line 5526
   $278 = $31; //@line 5527
   $279 = $2; //@line 5528
   FUNCTION_TABLE_vii[(SAFE_FT_MASK($277 | 0, 127 | 0) | 0) & 127]($278, $279); //@line 5529
  }
  $280 = $30; //@line 5531
  $281 = $280 + 1 | 0; //@line 5532
  $30 = $281; //@line 5533
 }
 $33 = 0; //@line 5535
 while (1) {
  $282 = $33; //@line 5537
  $283 = $7; //@line 5538
  $284 = SAFE_HEAP_LOAD($283 | 0, 4, 0) | 0 | 0; //@line 5539
  $285 = ($282 | 0) < ($284 | 0); //@line 5540
  if (!$285) {
   break;
  }
  $286 = $7; //@line 5544
  $287 = $286 + 8 | 0; //@line 5545
  $288 = SAFE_HEAP_LOAD($287 | 0, 4, 0) | 0 | 0; //@line 5546
  $289 = $33; //@line 5547
  $290 = $288 + ($289 << 2) | 0; //@line 5548
  $291 = SAFE_HEAP_LOAD($290 | 0, 4, 0) | 0 | 0; //@line 5549
  $34 = $291; //@line 5550
  $292 = $34; //@line 5551
  $293 = $292 + 96 | 0; //@line 5552
  $294 = SAFE_HEAP_LOAD($293 | 0, 4, 0) | 0 | 0; //@line 5553
  $35 = $294; //@line 5554
  $295 = $35; //@line 5555
  $296 = $295 + 16 | 0; //@line 5556
  $297 = SAFE_HEAP_LOAD($296 | 0, 4, 0) | 0 | 0; //@line 5557
  $298 = $34; //@line 5558
  $299 = $2; //@line 5559
  $300 = $35; //@line 5560
  $301 = $300 + 24 | 0; //@line 5561
  $302 = SAFE_HEAP_LOAD($301 | 0, 4, 0) | 0 | 0; //@line 5562
  FUNCTION_TABLE_viii[(SAFE_FT_MASK($297 | 0, 127 | 0) | 0) & 127]($298, $299, $302); //@line 5563
  $303 = $33; //@line 5564
  $304 = $303 + 1 | 0; //@line 5565
  $33 = $304; //@line 5566
 }
 $305 = $2; //@line 5568
 _cpSpaceUnlock($305, 1); //@line 5569
 STACKTOP = sp; //@line 5570
 return;
}
function _EPARecurse($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 1422
 $1 = $1 | 0; //@line 1423
 $2 = $2 | 0; //@line 1424
 $3 = $3 | 0; //@line 1425
 $4 = $4 | 0; //@line 1426
 var $$alloca_mul = 0, $$byval_copy = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy14 = 0, $$byval_copy15 = 0, $$byval_copy16 = 0, $$byval_copy17 = 0, $$byval_copy18 = 0, $$byval_copy19 = 0, $$byval_copy20 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0.0, $100 = 0, $101 = 0; //@line 1427
 var $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0; //@line 1428
 var $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0.0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0; //@line 1429
 var $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0; //@line 1430
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0.0, $42 = 0.0, $43 = 0.0, $44 = 0, $45 = 0.0; //@line 1431
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0; //@line 1432
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0; //@line 1433
 var $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $or$cond = 0; //@line 1434
 var $vararg_buffer = 0, $vararg_buffer3 = 0, $vararg_ptr2 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 1435
 sp = STACKTOP; //@line 1436
 STACKTOP = STACKTOP + 720 | 0; //@line 1437
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(720 | 0); //@line 1437
 $$byval_copy20 = sp + 616 | 0; //@line 1438
 $$byval_copy19 = sp + 560 | 0; //@line 1439
 $$byval_copy18 = sp + 544 | 0; //@line 1440
 $$byval_copy17 = sp + 528 | 0; //@line 1441
 $$byval_copy16 = sp + 512 | 0; //@line 1442
 $$byval_copy15 = sp + 496 | 0; //@line 1443
 $$byval_copy14 = sp + 480 | 0; //@line 1444
 $$byval_copy13 = sp + 464 | 0; //@line 1445
 $$byval_copy12 = sp + 448 | 0; //@line 1446
 $$byval_copy11 = sp + 432 | 0; //@line 1447
 $$byval_copy10 = sp + 416 | 0; //@line 1448
 $$byval_copy9 = sp + 400 | 0; //@line 1449
 $$byval_copy8 = sp + 384 | 0; //@line 1450
 $$byval_copy7 = sp + 368 | 0; //@line 1451
 $$byval_copy6 = sp + 352 | 0; //@line 1452
 $$byval_copy = sp + 336 | 0; //@line 1453
 $vararg_buffer3 = sp + 328 | 0; //@line 1454
 $vararg_buffer = sp + 320 | 0; //@line 1455
 $14 = sp + 248 | 0; //@line 1456
 $15 = sp + 192 | 0; //@line 1457
 $16 = sp + 136 | 0; //@line 1458
 $17 = sp + 120 | 0; //@line 1459
 $18 = sp + 104 | 0; //@line 1460
 $24 = sp + 88 | 0; //@line 1461
 $25 = sp + 72 | 0; //@line 1462
 $26 = sp + 56 | 0; //@line 1463
 $27 = sp; //@line 1464
 $5 = $1; //@line 1465
 $6 = $2; //@line 1466
 $7 = $3; //@line 1467
 $8 = $4; //@line 1468
 $9 = 0; //@line 1469
 $10 = inf; //@line 1470
 $11 = 0; //@line 1471
 $28 = $6; //@line 1472
 $29 = $28 - 1 | 0; //@line 1473
 $12 = $29; //@line 1474
 while (1) {
  $30 = $11; //@line 1476
  $31 = $6; //@line 1477
  $32 = ($30 | 0) < ($31 | 0); //@line 1478
  $33 = $7; //@line 1479
  if (!$32) {
   break;
  }
  $34 = $12; //@line 1483
  $35 = $33 + ($34 * 56 | 0) | 0; //@line 1484
  $36 = $35 + 32 | 0; //@line 1485
  $37 = $7; //@line 1486
  $38 = $11; //@line 1487
  $39 = $37 + ($38 * 56 | 0) | 0; //@line 1488
  $40 = $39 + 32 | 0; //@line 1489
  SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($36 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($36 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($36 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($36 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($40 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($40 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($40 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($40 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $41 = +_ClosestDist($$byval_copy, $$byval_copy6); //@line 1492
  $13 = $41; //@line 1493
  $42 = $13; //@line 1494
  $43 = $10; //@line 1495
  $44 = $42 < $43; //@line 1496
  if ($44) {
   $45 = $13; //@line 1498
   $10 = $45; //@line 1499
   $46 = $12; //@line 1500
   $9 = $46; //@line 1501
  }
  $47 = $11; //@line 1503
  $12 = $47; //@line 1504
  $48 = $11; //@line 1505
  $49 = $48 + 1 | 0; //@line 1506
  $11 = $49; //@line 1507
 }
 $50 = $9; //@line 1509
 $51 = $33 + ($50 * 56 | 0) | 0; //@line 1510
 dest = $14; //@line 1511
 src = $51; //@line 1511
 stop = dest + 56 | 0; //@line 1511
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 1511
  src = src + 4 | 0; //@line 1511
 } while ((dest | 0) < (stop | 0));
 $52 = $7; //@line 1512
 $53 = $9; //@line 1513
 $54 = $53 + 1 | 0; //@line 1514
 $55 = $6; //@line 1515
 $56 = ($54 | 0) % ($55 | 0) & -1; //@line 1516
 $57 = $52 + ($56 * 56 | 0) | 0; //@line 1517
 dest = $15; //@line 1518
 src = $57; //@line 1518
 stop = dest + 56 | 0; //@line 1518
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 1518
  src = src + 4 | 0; //@line 1518
 } while ((dest | 0) < (stop | 0));
 $58 = $14 + 32 | 0; //@line 1519
 $59 = $15 + 32 | 0; //@line 1520
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($58 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($58 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($58 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($58 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($59 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($59 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($59 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($59 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $60 = _cpveql($$byval_copy7, $$byval_copy8) | 0; //@line 1523
 $61 = $60 << 24 >> 24 != 0; //@line 1524
 if ($61) {
  $62 = $9; //@line 1526
  $63 = $9; //@line 1527
  $64 = $63 + 1 | 0; //@line 1528
  $65 = $6; //@line 1529
  $66 = ($64 | 0) % ($65 | 0) & -1; //@line 1530
  SAFE_HEAP_STORE($vararg_buffer | 0, $62 | 0, 4);
  $vararg_ptr2 = $vararg_buffer + 4 | 0; //@line 1532
  SAFE_HEAP_STORE($vararg_ptr2 | 0, $66 | 0, 4);
  _cpMessage(4821, 4624, 288, 1, 0, 4843, $vararg_buffer); //@line 1534
  _abort(); //@line 1535
 }
 $67 = $5; //@line 1538
 $68 = $15 + 32 | 0; //@line 1539
 $69 = $14 + 32 | 0; //@line 1540
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($68 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($68 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($68 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($68 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($69 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($69 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($69 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($69 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_67($18, $$byval_copy9, $$byval_copy10); //@line 1543
 SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($18 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($18 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($18 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvperp_75($17, $$byval_copy11); //@line 1545
 SAFE_HEAP_STORE($$byval_copy12 | 0, SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 4 | 0, SAFE_HEAP_LOAD($17 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 8 | 0, SAFE_HEAP_LOAD($17 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 12 | 0, SAFE_HEAP_LOAD($17 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _Support($16, $67, $$byval_copy12); //@line 1547
 $70 = $16 + 48 | 0; //@line 1548
 $71 = SAFE_HEAP_LOAD($70 | 0, 4, 0) | 0 | 0; //@line 1549
 $72 = $14 + 48 | 0; //@line 1550
 $73 = SAFE_HEAP_LOAD($72 | 0, 4, 0) | 0 | 0; //@line 1551
 $74 = ($71 | 0) == ($73 | 0); //@line 1552
 if ($74) {
  $81 = 1; //@line 1554
 } else {
  $75 = $16 + 48 | 0; //@line 1556
  $76 = SAFE_HEAP_LOAD($75 | 0, 4, 0) | 0 | 0; //@line 1557
  $77 = $15 + 48 | 0; //@line 1558
  $78 = SAFE_HEAP_LOAD($77 | 0, 4, 0) | 0 | 0; //@line 1559
  $79 = ($76 | 0) == ($78 | 0); //@line 1560
  $81 = $79; //@line 1561
 }
 $80 = $81 & 1; //@line 1563
 $82 = $80 & 255; //@line 1564
 $19 = $82; //@line 1565
 $83 = $19; //@line 1566
 $84 = $83 << 24 >> 24 != 0; //@line 1567
 if (!$84) {
  $85 = $14 + 32 | 0; //@line 1569
  $86 = $15 + 32 | 0; //@line 1570
  $87 = $16 + 32 | 0; //@line 1571
  SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($85 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($85 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($85 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($85 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy14 | 0, SAFE_HEAP_LOAD($86 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy14 + 4 | 0, SAFE_HEAP_LOAD($86 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy14 + 8 | 0, SAFE_HEAP_LOAD($86 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy14 + 12 | 0, SAFE_HEAP_LOAD($86 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 | 0, SAFE_HEAP_LOAD($87 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 + 4 | 0, SAFE_HEAP_LOAD($87 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 + 8 | 0, SAFE_HEAP_LOAD($87 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 + 12 | 0, SAFE_HEAP_LOAD($87 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $88 = _cpCheckPointGreater($$byval_copy13, $$byval_copy14, $$byval_copy15) | 0; //@line 1575
  $89 = $88 & 255; //@line 1576
  $90 = ($89 | 0) != 0; //@line 1577
  $91 = $8; //@line 1578
  $92 = ($91 | 0) < 30; //@line 1579
  $or$cond = $90 & $92; //@line 1580
  if ($or$cond) {
   $93 = $6; //@line 1582
   $94 = $93 + 1 | 0; //@line 1583
   $95 = $94 * 56 | 0; //@line 1584
   $$alloca_mul = $95; //@line 1585
   $96 = STACKTOP; //@line 1586
   STACKTOP = STACKTOP + ((1 * $$alloca_mul | 0) + 15 & -16) | 0; //@line 1586
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow((1 * $$alloca_mul | 0) + 15 & -16 | 0); //@line 1586
   $20 = $96; //@line 1587
   $21 = 1; //@line 1588
   $97 = $20; //@line 1589
   dest = $97; //@line 1590
   src = $16; //@line 1590
   stop = dest + 56 | 0; //@line 1590
   do {
    SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
    dest = dest + 4 | 0; //@line 1590
    src = src + 4 | 0; //@line 1590
   } while ((dest | 0) < (stop | 0));
   $22 = 0; //@line 1591
   while (1) {
    $98 = $22; //@line 1593
    $99 = $6; //@line 1594
    $100 = ($98 | 0) < ($99 | 0); //@line 1595
    if (!$100) {
     break;
    }
    $101 = $9; //@line 1599
    $102 = $101 + 1 | 0; //@line 1600
    $103 = $22; //@line 1601
    $104 = $102 + $103 | 0; //@line 1602
    $105 = $6; //@line 1603
    $106 = ($104 | 0) % ($105 | 0) & -1; //@line 1604
    $23 = $106; //@line 1605
    $107 = $20; //@line 1606
    $108 = $21; //@line 1607
    $109 = $108 - 1 | 0; //@line 1608
    $110 = $107 + ($109 * 56 | 0) | 0; //@line 1609
    $111 = $110 + 32 | 0; //@line 1610
    SAFE_HEAP_STORE($24 | 0, SAFE_HEAP_LOAD($111 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($24 + 4 | 0, SAFE_HEAP_LOAD($111 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($24 + 8 | 0, SAFE_HEAP_LOAD($111 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($24 + 12 | 0, SAFE_HEAP_LOAD($111 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    $112 = $7; //@line 1612
    $113 = $23; //@line 1613
    $114 = $112 + ($113 * 56 | 0) | 0; //@line 1614
    $115 = $114 + 32 | 0; //@line 1615
    SAFE_HEAP_STORE($25 | 0, SAFE_HEAP_LOAD($115 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($25 + 4 | 0, SAFE_HEAP_LOAD($115 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($25 + 8 | 0, SAFE_HEAP_LOAD($115 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($25 + 12 | 0, SAFE_HEAP_LOAD($115 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    $116 = $22; //@line 1617
    $117 = $116 + 1 | 0; //@line 1618
    $118 = $6; //@line 1619
    $119 = ($117 | 0) < ($118 | 0); //@line 1620
    if ($119) {
     $120 = $7; //@line 1622
     $121 = $23; //@line 1623
     $122 = $121 + 1 | 0; //@line 1624
     $123 = $6; //@line 1625
     $124 = ($122 | 0) % ($123 | 0) & -1; //@line 1626
     $125 = $120 + ($124 * 56 | 0) | 0; //@line 1627
     dest = $27; //@line 1628
     src = $125; //@line 1628
     stop = dest + 56 | 0; //@line 1628
     do {
      SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
      dest = dest + 4 | 0; //@line 1628
      src = src + 4 | 0; //@line 1628
     } while ((dest | 0) < (stop | 0));
    } else {
     dest = $27; //@line 1630
     src = $16; //@line 1630
     stop = dest + 56 | 0; //@line 1630
     do {
      SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
      dest = dest + 4 | 0; //@line 1630
      src = src + 4 | 0; //@line 1630
     } while ((dest | 0) < (stop | 0));
    }
    $126 = $27 + 32 | 0; //@line 1632
    SAFE_HEAP_STORE($26 | 0, SAFE_HEAP_LOAD($126 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($26 + 4 | 0, SAFE_HEAP_LOAD($126 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($26 + 8 | 0, SAFE_HEAP_LOAD($126 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($26 + 12 | 0, SAFE_HEAP_LOAD($126 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy16 | 0, SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy16 + 4 | 0, SAFE_HEAP_LOAD($24 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy16 + 8 | 0, SAFE_HEAP_LOAD($24 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy16 + 12 | 0, SAFE_HEAP_LOAD($24 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy17 | 0, SAFE_HEAP_LOAD($26 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy17 + 4 | 0, SAFE_HEAP_LOAD($26 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy17 + 8 | 0, SAFE_HEAP_LOAD($26 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy17 + 12 | 0, SAFE_HEAP_LOAD($26 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy18 | 0, SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy18 + 4 | 0, SAFE_HEAP_LOAD($25 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy18 + 8 | 0, SAFE_HEAP_LOAD($25 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy18 + 12 | 0, SAFE_HEAP_LOAD($25 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    $127 = _cpCheckPointGreater($$byval_copy16, $$byval_copy17, $$byval_copy18) | 0; //@line 1637
    $128 = $127 << 24 >> 24 != 0; //@line 1638
    if ($128) {
     $129 = $20; //@line 1640
     $130 = $21; //@line 1641
     $131 = $129 + ($130 * 56 | 0) | 0; //@line 1642
     $132 = $7; //@line 1643
     $133 = $23; //@line 1644
     $134 = $132 + ($133 * 56 | 0) | 0; //@line 1645
     dest = $131; //@line 1646
     src = $134; //@line 1646
     stop = dest + 56 | 0; //@line 1646
     do {
      SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
      dest = dest + 4 | 0; //@line 1646
      src = src + 4 | 0; //@line 1646
     } while ((dest | 0) < (stop | 0));
     $135 = $21; //@line 1647
     $136 = $135 + 1 | 0; //@line 1648
     $21 = $136; //@line 1649
    }
    $137 = $22; //@line 1651
    $138 = $137 + 1 | 0; //@line 1652
    $22 = $138; //@line 1653
   }
   $139 = $5; //@line 1655
   $140 = $21; //@line 1656
   $141 = $20; //@line 1657
   $142 = $8; //@line 1658
   $143 = $142 + 1 | 0; //@line 1659
   _EPARecurse($0, $139, $140, $141, $143); //@line 1660
   STACKTOP = sp; //@line 1661
   return;
  }
 }
 $144 = $8; //@line 1664
 $145 = ($144 | 0) < 20; //@line 1665
 if (!$145) {
  $146 = $8; //@line 1667
  SAFE_HEAP_STORE($vararg_buffer3 | 0, $146 | 0, 4);
  _cpMessage(4897, 4624, 329, 0, 0, 4929, $vararg_buffer3); //@line 1669
 }
 dest = $$byval_copy19; //@line 1671
 src = $14; //@line 1671
 stop = dest + 56 | 0; //@line 1671
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 1671
  src = src + 4 | 0; //@line 1671
 } while ((dest | 0) < (stop | 0));
 dest = $$byval_copy20; //@line 1672
 src = $15; //@line 1672
 stop = dest + 56 | 0; //@line 1672
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 1672
  src = src + 4 | 0; //@line 1672
 } while ((dest | 0) < (stop | 0));
 _ClosestPointsNew($0, $$byval_copy19, $$byval_copy20); //@line 1673
 STACKTOP = sp; //@line 1674
 return;
}
function _SegmentToSegment($0, $1, $2) {
 $0 = $0 | 0; //@line 8014
 $1 = $1 | 0; //@line 8015
 $2 = $2 | 0; //@line 8016
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy14 = 0, $$byval_copy15 = 0, $$byval_copy16 = 0, $$byval_copy17 = 0, $$byval_copy18 = 0, $$byval_copy19 = 0, $$byval_copy2 = 0, $$byval_copy20 = 0, $$byval_copy21 = 0, $$byval_copy22 = 0, $$byval_copy23 = 0, $$byval_copy24 = 0, $$byval_copy25 = 0, $$byval_copy26 = 0; //@line 8017
 var $$byval_copy27 = 0, $$byval_copy28 = 0, $$byval_copy29 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0; //@line 8018
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0.0, $34 = 0, $35 = 0, $36 = 0.0, $37 = 0, $38 = 0; //@line 8019
 var $39 = 0.0, $4 = 0, $40 = 0.0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0.0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0.0;
 var $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0.0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0.0; //@line 8021
 var $75 = 0, $76 = 0, $77 = 0, $78 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 8022
 sp = STACKTOP; //@line 8023
 STACKTOP = STACKTOP + 1008 | 0; //@line 8024
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(1008 | 0); //@line 8024
 $$byval_copy29 = sp + 912 | 0; //@line 8025
 $$byval_copy28 = sp + 840 | 0; //@line 8026
 $$byval_copy27 = sp + 768 | 0; //@line 8027
 $$byval_copy26 = sp + 752 | 0; //@line 8028
 $$byval_copy25 = sp + 736 | 0; //@line 8029
 $$byval_copy24 = sp + 720 | 0; //@line 8030
 $$byval_copy23 = sp + 704 | 0; //@line 8031
 $$byval_copy22 = sp + 688 | 0; //@line 8032
 $$byval_copy21 = sp + 672 | 0; //@line 8033
 $$byval_copy20 = sp + 656 | 0; //@line 8034
 $$byval_copy19 = sp + 640 | 0; //@line 8035
 $$byval_copy18 = sp + 624 | 0; //@line 8036
 $$byval_copy17 = sp + 608 | 0; //@line 8037
 $$byval_copy16 = sp + 592 | 0; //@line 8038
 $$byval_copy15 = sp + 576 | 0; //@line 8039
 $$byval_copy14 = sp + 560 | 0; //@line 8040
 $$byval_copy13 = sp + 544 | 0; //@line 8041
 $$byval_copy12 = sp + 528 | 0; //@line 8042
 $$byval_copy11 = sp + 512 | 0; //@line 8043
 $$byval_copy10 = sp + 496 | 0; //@line 8044
 $$byval_copy9 = sp + 480 | 0; //@line 8045
 $$byval_copy8 = sp + 464 | 0; //@line 8046
 $$byval_copy7 = sp + 448 | 0; //@line 8047
 $$byval_copy6 = sp + 432 | 0; //@line 8048
 $$byval_copy5 = sp + 416 | 0; //@line 8049
 $$byval_copy4 = sp + 400 | 0; //@line 8050
 $$byval_copy3 = sp + 384 | 0; //@line 8051
 $$byval_copy2 = sp + 368 | 0; //@line 8052
 $$byval_copy1 = sp + 352 | 0; //@line 8053
 $$byval_copy = sp + 336 | 0; //@line 8054
 $6 = sp + 976 | 0; //@line 8055
 $7 = sp + 272 | 0; //@line 8056
 $8 = sp + 256 | 0; //@line 8057
 $9 = sp + 240 | 0; //@line 8058
 $10 = sp + 224 | 0; //@line 8059
 $11 = sp + 208 | 0; //@line 8060
 $12 = sp + 192 | 0; //@line 8061
 $13 = sp + 176 | 0; //@line 8062
 $14 = sp + 160 | 0; //@line 8063
 $15 = sp + 88 | 0; //@line 8064
 $16 = sp + 16 | 0; //@line 8065
 $17 = sp; //@line 8066
 $3 = $0; //@line 8067
 $4 = $1; //@line 8068
 $5 = $2; //@line 8069
 $18 = $3; //@line 8070
 SAFE_HEAP_STORE($6 | 0, $18 | 0, 4);
 $19 = $6 + 4 | 0; //@line 8072
 $20 = $4; //@line 8073
 SAFE_HEAP_STORE($19 | 0, $20 | 0, 4);
 $21 = $6 + 8 | 0; //@line 8075
 SAFE_HEAP_STORE($21 | 0, 55 | 0, 4);
 $22 = $6 + 12 | 0; //@line 8077
 SAFE_HEAP_STORE($22 | 0, 55 | 0, 4);
 $23 = $5; //@line 8079
 $24 = $23 + 8 | 0; //@line 8080
 _GJK($7, $6, $24); //@line 8081
 $25 = $7 + 32 | 0; //@line 8082
 SAFE_HEAP_STORE($8 | 0, SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 4 | 0, SAFE_HEAP_LOAD($25 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 8 | 0, SAFE_HEAP_LOAD($25 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 12 | 0, SAFE_HEAP_LOAD($25 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $26 = $3; //@line 8084
 $27 = $26 + 8 | 0; //@line 8085
 $28 = SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0; //@line 8086
 _cpBodyGetRotation($9, $28); //@line 8087
 $29 = $4; //@line 8088
 $30 = $29 + 8 | 0; //@line 8089
 $31 = SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0; //@line 8090
 _cpBodyGetRotation($10, $31); //@line 8091
 $32 = $7 + 48 | 0; //@line 8092
 $33 = +(+SAFE_HEAP_LOAD_D($32 | 0, 8)); //@line 8093
 $34 = $3; //@line 8094
 $35 = $34 + 256 | 0; //@line 8095
 $36 = +(+SAFE_HEAP_LOAD_D($35 | 0, 8)); //@line 8096
 $37 = $4; //@line 8097
 $38 = $37 + 256 | 0; //@line 8098
 $39 = +(+SAFE_HEAP_LOAD_D($38 | 0, 8)); //@line 8099
 $40 = $36 + $39; //@line 8100
 $41 = $33 <= $40; //@line 8101
 if (!$41) {
  STACKTOP = sp; //@line 8103
  return;
 }
 $42 = $3; //@line 8105
 $43 = $42 + 208 | 0; //@line 8106
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($43 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($43 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($43 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($43 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $44 = _cpveql($$byval_copy, $$byval_copy1) | 0; //@line 8109
 $45 = $44 << 24 >> 24 != 0; //@line 8110
 if ($45) {
  $46 = $3; //@line 8112
  $47 = $46 + 264 | 0; //@line 8113
  SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($47 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($47 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($47 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($47 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvrotate_86($11, $$byval_copy2, $$byval_copy3); //@line 8116
  SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $48 = +_cpvdot_68($$byval_copy4, $$byval_copy5); //@line 8119
  $49 = $48 <= 0.0; //@line 8120
  if (!$49) {
   STACKTOP = sp; //@line 8122
   return;
  }
 }
 $50 = $3; //@line 8125
 $51 = $50 + 224 | 0; //@line 8126
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($51 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($51 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($51 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($51 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $52 = _cpveql($$byval_copy6, $$byval_copy7) | 0; //@line 8129
 $53 = $52 << 24 >> 24 != 0; //@line 8130
 if ($53) {
  $54 = $3; //@line 8132
  $55 = $54 + 280 | 0; //@line 8133
  SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($55 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($55 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($55 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($55 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvrotate_86($12, $$byval_copy8, $$byval_copy9); //@line 8136
  SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $56 = +_cpvdot_68($$byval_copy10, $$byval_copy11); //@line 8139
  $57 = $56 <= 0.0; //@line 8140
  if (!$57) {
   STACKTOP = sp; //@line 8142
   return;
  }
 }
 $58 = $7 + 16 | 0; //@line 8145
 $59 = $4; //@line 8146
 $60 = $59 + 208 | 0; //@line 8147
 SAFE_HEAP_STORE($$byval_copy12 | 0, SAFE_HEAP_LOAD($58 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 4 | 0, SAFE_HEAP_LOAD($58 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 8 | 0, SAFE_HEAP_LOAD($58 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 12 | 0, SAFE_HEAP_LOAD($58 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($60 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($60 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($60 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($60 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $61 = _cpveql($$byval_copy12, $$byval_copy13) | 0; //@line 8150
 $62 = $61 << 24 >> 24 != 0; //@line 8151
 if ($62) {
  $63 = $4; //@line 8153
  $64 = $63 + 264 | 0; //@line 8154
  SAFE_HEAP_STORE($$byval_copy14 | 0, SAFE_HEAP_LOAD($64 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy14 + 4 | 0, SAFE_HEAP_LOAD($64 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy14 + 8 | 0, SAFE_HEAP_LOAD($64 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy14 + 12 | 0, SAFE_HEAP_LOAD($64 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvrotate_86($13, $$byval_copy14, $$byval_copy15); //@line 8157
  SAFE_HEAP_STORE($$byval_copy16 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy16 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy16 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy16 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $65 = +_cpvdot_68($$byval_copy16, $$byval_copy17); //@line 8160
  $66 = $65 >= 0.0; //@line 8161
  if (!$66) {
   STACKTOP = sp; //@line 8163
   return;
  }
 }
 $67 = $7 + 16 | 0; //@line 8166
 $68 = $4; //@line 8167
 $69 = $68 + 224 | 0; //@line 8168
 SAFE_HEAP_STORE($$byval_copy18 | 0, SAFE_HEAP_LOAD($67 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy18 + 4 | 0, SAFE_HEAP_LOAD($67 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy18 + 8 | 0, SAFE_HEAP_LOAD($67 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy18 + 12 | 0, SAFE_HEAP_LOAD($67 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy19 | 0, SAFE_HEAP_LOAD($69 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy19 + 4 | 0, SAFE_HEAP_LOAD($69 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy19 + 8 | 0, SAFE_HEAP_LOAD($69 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy19 + 12 | 0, SAFE_HEAP_LOAD($69 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $70 = _cpveql($$byval_copy18, $$byval_copy19) | 0; //@line 8171
 $71 = $70 << 24 >> 24 != 0; //@line 8172
 if ($71) {
  $72 = $4; //@line 8174
  $73 = $72 + 280 | 0; //@line 8175
  SAFE_HEAP_STORE($$byval_copy20 | 0, SAFE_HEAP_LOAD($73 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 + 4 | 0, SAFE_HEAP_LOAD($73 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 + 8 | 0, SAFE_HEAP_LOAD($73 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy20 + 12 | 0, SAFE_HEAP_LOAD($73 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy21 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvrotate_86($14, $$byval_copy20, $$byval_copy21); //@line 8178
  SAFE_HEAP_STORE($$byval_copy22 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy22 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy22 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy22 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy23 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy23 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy23 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy23 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $74 = +_cpvdot_68($$byval_copy22, $$byval_copy23); //@line 8181
  $75 = $74 >= 0.0; //@line 8182
  if (!$75) {
   STACKTOP = sp; //@line 8184
   return;
  }
 }
 $76 = $3; //@line 8187
 SAFE_HEAP_STORE($$byval_copy24 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy24 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy24 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy24 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _SupportEdgeForSegment($15, $76, $$byval_copy24); //@line 8189
 $77 = $4; //@line 8190
 SAFE_HEAP_STORE($$byval_copy25 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy25 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy25 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy25 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvneg_62($17, $$byval_copy25); //@line 8192
 SAFE_HEAP_STORE($$byval_copy26 | 0, SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy26 + 4 | 0, SAFE_HEAP_LOAD($17 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy26 + 8 | 0, SAFE_HEAP_LOAD($17 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy26 + 12 | 0, SAFE_HEAP_LOAD($17 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _SupportEdgeForSegment($16, $77, $$byval_copy26); //@line 8194
 $78 = $5; //@line 8195
 dest = $$byval_copy27; //@line 8196
 src = $15; //@line 8196
 stop = dest + 72 | 0; //@line 8196
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 8196
  src = src + 4 | 0; //@line 8196
 } while ((dest | 0) < (stop | 0));
 dest = $$byval_copy28; //@line 8197
 src = $16; //@line 8197
 stop = dest + 72 | 0; //@line 8197
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 8197
  src = src + 4 | 0; //@line 8197
 } while ((dest | 0) < (stop | 0));
 dest = $$byval_copy29; //@line 8198
 src = $7; //@line 8198
 stop = dest + 64 | 0; //@line 8198
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 8198
  src = src + 4 | 0; //@line 8198
 } while ((dest | 0) < (stop | 0));
 _ContactPoints($$byval_copy27, $$byval_copy28, $$byval_copy29, $78); //@line 8199
 STACKTOP = sp; //@line 8200
 return;
}
function _cpArbiterUpdate($0, $1, $2) {
 $0 = $0 | 0; //@line 1472
 $1 = $1 | 0; //@line 1473
 $2 = $2 | 0; //@line 1474
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy10 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0; //@line 1475
 var $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0.0, $116 = 0, $117 = 0, $118 = 0.0, $119 = 0.0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0.0, $124 = 0, $125 = 0; //@line 1476
 var $126 = 0.0, $127 = 0.0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0.0, $141 = 0, $142 = 0, $143 = 0;
 var $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0; //@line 1478
 var $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0; //@line 1479
 var $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0; //@line 1480
 var $199 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0; //@line 1481
 var $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0; //@line 1482
 var $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0; //@line 1483
 var $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0; //@line 1484
 var $88 = 0, $89 = 0, $9 = 0, $90 = 0.0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0.0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, label = 0, sp = 0; //@line 1485
 sp = STACKTOP; //@line 1486
 STACKTOP = STACKTOP + 320 | 0; //@line 1487
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(320 | 0); //@line 1487
 $$byval_copy10 = sp + 240 | 0; //@line 1488
 $$byval_copy9 = sp + 224 | 0; //@line 1489
 $$byval_copy8 = sp + 208 | 0; //@line 1490
 $$byval_copy7 = sp + 192 | 0; //@line 1491
 $$byval_copy6 = sp + 176 | 0; //@line 1492
 $$byval_copy5 = sp + 160 | 0; //@line 1493
 $$byval_copy4 = sp + 144 | 0; //@line 1494
 $$byval_copy3 = sp + 128 | 0; //@line 1495
 $$byval_copy2 = sp + 112 | 0; //@line 1496
 $$byval_copy1 = sp + 96 | 0; //@line 1497
 $$byval_copy = sp + 80 | 0; //@line 1498
 $10 = sp + 64 | 0; //@line 1499
 $11 = sp + 48 | 0; //@line 1500
 $14 = sp + 32 | 0; //@line 1501
 $15 = sp + 16 | 0; //@line 1502
 $16 = sp; //@line 1503
 $3 = $0; //@line 1504
 $4 = $1; //@line 1505
 $5 = $2; //@line 1506
 $22 = $4; //@line 1507
 $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 1508
 $6 = $23; //@line 1509
 $24 = $4; //@line 1510
 $25 = $24 + 4 | 0; //@line 1511
 $26 = SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0; //@line 1512
 $7 = $26; //@line 1513
 $27 = $6; //@line 1514
 $28 = $3; //@line 1515
 $29 = $28 + 36 | 0; //@line 1516
 SAFE_HEAP_STORE($29 | 0, $27 | 0, 4);
 $30 = $6; //@line 1518
 $31 = $30 + 8 | 0; //@line 1519
 $32 = SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0; //@line 1520
 $33 = $3; //@line 1521
 $34 = $33 + 44 | 0; //@line 1522
 SAFE_HEAP_STORE($34 | 0, $32 | 0, 4);
 $35 = $7; //@line 1524
 $36 = $3; //@line 1525
 $37 = $36 + 40 | 0; //@line 1526
 SAFE_HEAP_STORE($37 | 0, $35 | 0, 4);
 $38 = $7; //@line 1528
 $39 = $38 + 8 | 0; //@line 1529
 $40 = SAFE_HEAP_LOAD($39 | 0, 4, 0) | 0 | 0; //@line 1530
 $41 = $3; //@line 1531
 $42 = $41 + 48 | 0; //@line 1532
 SAFE_HEAP_STORE($42 | 0, $40 | 0, 4);
 $8 = 0; //@line 1534
 while (1) {
  $43 = $8; //@line 1536
  $44 = $4; //@line 1537
  $45 = $44 + 32 | 0; //@line 1538
  $46 = SAFE_HEAP_LOAD($45 | 0, 4, 0) | 0 | 0; //@line 1539
  $47 = ($43 | 0) < ($46 | 0); //@line 1540
  $48 = $4; //@line 1541
  $49 = $48 + 36 | 0; //@line 1542
  $50 = SAFE_HEAP_LOAD($49 | 0, 4, 0) | 0 | 0; //@line 1543
  if (!$47) {
   break;
  }
  $51 = $8; //@line 1547
  $52 = $50 + ($51 * 96 | 0) | 0; //@line 1548
  $9 = $52; //@line 1549
  $53 = $9; //@line 1550
  $54 = $9; //@line 1551
  $55 = $6; //@line 1552
  $56 = $55 + 8 | 0; //@line 1553
  $57 = SAFE_HEAP_LOAD($56 | 0, 4, 0) | 0 | 0; //@line 1554
  $58 = $57 + 56 | 0; //@line 1555
  SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($54 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($54 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($54 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($54 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($58 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($58 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($58 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($58 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvsub_10($10, $$byval_copy, $$byval_copy1); //@line 1558
  SAFE_HEAP_STORE($53 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($53 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($53 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($53 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $59 = $9; //@line 1560
  $60 = $59 + 16 | 0; //@line 1561
  $61 = $9; //@line 1562
  $62 = $61 + 16 | 0; //@line 1563
  $63 = $7; //@line 1564
  $64 = $63 + 8 | 0; //@line 1565
  $65 = SAFE_HEAP_LOAD($64 | 0, 4, 0) | 0 | 0; //@line 1566
  $66 = $65 + 56 | 0; //@line 1567
  SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($62 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($62 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($62 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($62 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($66 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($66 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($66 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($66 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvsub_10($11, $$byval_copy2, $$byval_copy3); //@line 1570
  SAFE_HEAP_STORE($60 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($60 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($60 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($60 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $67 = $9; //@line 1572
  $68 = $67 + 64 | 0; //@line 1573
  SAFE_HEAP_STORE_D($68 | 0, +0.0, 8);
  $69 = $9; //@line 1575
  $70 = $69 + 56 | 0; //@line 1576
  SAFE_HEAP_STORE_D($70 | 0, +0.0, 8);
  $12 = 0; //@line 1578
  while (1) {
   $71 = $12; //@line 1580
   $72 = $3; //@line 1581
   $73 = $72 + 68 | 0; //@line 1582
   $74 = SAFE_HEAP_LOAD($73 | 0, 4, 0) | 0 | 0; //@line 1583
   $75 = ($71 | 0) < ($74 | 0); //@line 1584
   if (!$75) {
    break;
   }
   $76 = $3; //@line 1588
   $77 = $76 + 72 | 0; //@line 1589
   $78 = SAFE_HEAP_LOAD($77 | 0, 4, 0) | 0 | 0; //@line 1590
   $79 = $12; //@line 1591
   $80 = $78 + ($79 * 96 | 0) | 0; //@line 1592
   $13 = $80; //@line 1593
   $81 = $9; //@line 1594
   $82 = $81 + 88 | 0; //@line 1595
   $83 = SAFE_HEAP_LOAD($82 | 0, 4, 0) | 0 | 0; //@line 1596
   $84 = $13; //@line 1597
   $85 = $84 + 88 | 0; //@line 1598
   $86 = SAFE_HEAP_LOAD($85 | 0, 4, 0) | 0 | 0; //@line 1599
   $87 = ($83 | 0) == ($86 | 0); //@line 1600
   if ($87) {
    $88 = $13; //@line 1602
    $89 = $88 + 56 | 0; //@line 1603
    $90 = +(+SAFE_HEAP_LOAD_D($89 | 0, 8)); //@line 1604
    $91 = $9; //@line 1605
    $92 = $91 + 56 | 0; //@line 1606
    SAFE_HEAP_STORE_D($92 | 0, +$90, 8);
    $93 = $13; //@line 1608
    $94 = $93 + 64 | 0; //@line 1609
    $95 = +(+SAFE_HEAP_LOAD_D($94 | 0, 8)); //@line 1610
    $96 = $9; //@line 1611
    $97 = $96 + 64 | 0; //@line 1612
    SAFE_HEAP_STORE_D($97 | 0, +$95, 8);
   }
   $98 = $12; //@line 1615
   $99 = $98 + 1 | 0; //@line 1616
   $12 = $99; //@line 1617
  }
  $100 = $8; //@line 1619
  $101 = $100 + 1 | 0; //@line 1620
  $8 = $101; //@line 1621
 }
 $102 = $3; //@line 1623
 $103 = $102 + 72 | 0; //@line 1624
 SAFE_HEAP_STORE($103 | 0, $50 | 0, 4);
 $104 = $4; //@line 1626
 $105 = $104 + 32 | 0; //@line 1627
 $106 = SAFE_HEAP_LOAD($105 | 0, 4, 0) | 0 | 0; //@line 1628
 $107 = $3; //@line 1629
 $108 = $107 + 68 | 0; //@line 1630
 SAFE_HEAP_STORE($108 | 0, $106 | 0, 4);
 $109 = $3; //@line 1632
 $110 = $109 + 80 | 0; //@line 1633
 $111 = $4; //@line 1634
 $112 = $111 + 16 | 0; //@line 1635
 SAFE_HEAP_STORE($110 | 0, SAFE_HEAP_LOAD($112 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($110 + 4 | 0, SAFE_HEAP_LOAD($112 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($110 + 8 | 0, SAFE_HEAP_LOAD($112 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($110 + 12 | 0, SAFE_HEAP_LOAD($112 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $113 = $6; //@line 1637
 $114 = $113 + 96 | 0; //@line 1638
 $115 = +(+SAFE_HEAP_LOAD_D($114 | 0, 8)); //@line 1639
 $116 = $7; //@line 1640
 $117 = $116 + 96 | 0; //@line 1641
 $118 = +(+SAFE_HEAP_LOAD_D($117 | 0, 8)); //@line 1642
 $119 = $115 * $118; //@line 1643
 $120 = $3; //@line 1644
 SAFE_HEAP_STORE_D($120 | 0, +$119, 8);
 $121 = $6; //@line 1646
 $122 = $121 + 104 | 0; //@line 1647
 $123 = +(+SAFE_HEAP_LOAD_D($122 | 0, 8)); //@line 1648
 $124 = $7; //@line 1649
 $125 = $124 + 104 | 0; //@line 1650
 $126 = +(+SAFE_HEAP_LOAD_D($125 | 0, 8)); //@line 1651
 $127 = $123 * $126; //@line 1652
 $128 = $3; //@line 1653
 $129 = $128 + 8 | 0; //@line 1654
 SAFE_HEAP_STORE_D($129 | 0, +$127, 8);
 $130 = $7; //@line 1656
 $131 = $130 + 112 | 0; //@line 1657
 $132 = $6; //@line 1658
 $133 = $132 + 112 | 0; //@line 1659
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($131 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($131 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($131 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($131 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($133 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($133 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($133 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($133 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_10($14, $$byval_copy4, $$byval_copy5); //@line 1662
 $134 = $3; //@line 1663
 $135 = $134 + 16 | 0; //@line 1664
 $136 = $4; //@line 1665
 $137 = $136 + 16 | 0; //@line 1666
 $138 = $4; //@line 1667
 $139 = $138 + 16 | 0; //@line 1668
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($139 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($139 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($139 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($139 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $140 = +_cpvdot_11($$byval_copy6, $$byval_copy7); //@line 1671
 SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($137 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($137 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($137 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($137 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_1($15, $$byval_copy8, $140); //@line 1673
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($15 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($15 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($15 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_10($16, $$byval_copy9, $$byval_copy10); //@line 1676
 SAFE_HEAP_STORE($135 | 0, SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($135 + 4 | 0, SAFE_HEAP_LOAD($16 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($135 + 8 | 0, SAFE_HEAP_LOAD($16 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($135 + 12 | 0, SAFE_HEAP_LOAD($16 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $141 = $4; //@line 1678
 $142 = SAFE_HEAP_LOAD($141 | 0, 4, 0) | 0 | 0; //@line 1679
 $143 = $142 + 132 | 0; //@line 1680
 $144 = SAFE_HEAP_LOAD($143 | 0, 4, 0) | 0 | 0; //@line 1681
 $17 = $144; //@line 1682
 $145 = $4; //@line 1683
 $146 = $145 + 4 | 0; //@line 1684
 $147 = SAFE_HEAP_LOAD($146 | 0, 4, 0) | 0 | 0; //@line 1685
 $148 = $147 + 132 | 0; //@line 1686
 $149 = SAFE_HEAP_LOAD($148 | 0, 4, 0) | 0 | 0; //@line 1687
 $18 = $149; //@line 1688
 $150 = $5; //@line 1689
 $151 = $150 + 152 | 0; //@line 1690
 $19 = $151; //@line 1691
 $152 = $5; //@line 1692
 $153 = $17; //@line 1693
 $154 = $18; //@line 1694
 $155 = $19; //@line 1695
 $156 = _cpSpaceLookupHandler($152, $153, $154, $155) | 0; //@line 1696
 $157 = $3; //@line 1697
 $158 = $157 + 96 | 0; //@line 1698
 SAFE_HEAP_STORE($158 | 0, $156 | 0, 4);
 $20 = $156; //@line 1700
 $159 = $17; //@line 1701
 $160 = $20; //@line 1702
 $161 = SAFE_HEAP_LOAD($160 | 0, 4, 0) | 0 | 0; //@line 1703
 $162 = ($159 | 0) != ($161 | 0); //@line 1704
 if ($162) {
  $163 = $20; //@line 1706
  $164 = SAFE_HEAP_LOAD($163 | 0, 4, 0) | 0 | 0; //@line 1707
  $165 = ($164 | 0) != -1; //@line 1708
  $167 = $165; //@line 1709
 } else {
  $167 = 0; //@line 1711
 }
 $166 = $167 & 1; //@line 1713
 $168 = $166 & 255; //@line 1714
 $169 = $3; //@line 1715
 $170 = $169 + 108 | 0; //@line 1716
 SAFE_HEAP_STORE($170 >> 0 | 0, $168 | 0, 1);
 $21 = $168; //@line 1718
 $171 = $20; //@line 1719
 $172 = $19; //@line 1720
 $173 = ($171 | 0) != ($172 | 0); //@line 1721
 if ($173) {
  label = 13; //@line 1723
 } else {
  $174 = $5; //@line 1725
  $175 = $174 + 144 | 0; //@line 1726
  $176 = SAFE_HEAP_LOAD($175 >> 0 | 0, 1, 0) | 0 | 0; //@line 1727
  $177 = $176 & 255; //@line 1728
  $178 = ($177 | 0) != 0; //@line 1729
  if ($178) {
   label = 13; //@line 1731
  }
 }
 if ((label | 0) == 13) {
  $179 = $5; //@line 1735
  $180 = $21; //@line 1736
  $181 = $180 & 255; //@line 1737
  $182 = ($181 | 0) != 0; //@line 1738
  $183 = $18; //@line 1739
  $184 = $17; //@line 1740
  $185 = $182 ? $183 : $184; //@line 1741
  $186 = _cpSpaceLookupHandler($179, $185, -1, 2712) | 0; //@line 1742
  $187 = $3; //@line 1743
  $188 = $187 + 100 | 0; //@line 1744
  SAFE_HEAP_STORE($188 | 0, $186 | 0, 4);
  $189 = $5; //@line 1746
  $190 = $21; //@line 1747
  $191 = $190 & 255; //@line 1748
  $192 = ($191 | 0) != 0; //@line 1749
  $193 = $17; //@line 1750
  $194 = $18; //@line 1751
  $195 = $192 ? $193 : $194; //@line 1752
  $196 = _cpSpaceLookupHandler($189, $195, -1, 2712) | 0; //@line 1753
  $197 = $3; //@line 1754
  $198 = $197 + 104 | 0; //@line 1755
  SAFE_HEAP_STORE($198 | 0, $196 | 0, 4);
 }
 $199 = $3; //@line 1758
 $200 = $199 + 116 | 0; //@line 1759
 $201 = SAFE_HEAP_LOAD($200 | 0, 4, 0) | 0 | 0; //@line 1760
 $202 = ($201 | 0) == 3; //@line 1761
 if (!$202) {
  STACKTOP = sp; //@line 1763
  return;
 }
 $203 = $3; //@line 1765
 $204 = $203 + 116 | 0; //@line 1766
 SAFE_HEAP_STORE($204 | 0, 0 | 0, 4);
 STACKTOP = sp; //@line 1768
 return;
}
function _preStep_394($0, $1) {
 $0 = $0 | 0; //@line 7291
 $1 = +$1; //@line 7292
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy14 = 0, $$byval_copy15 = 0, $$byval_copy16 = 0, $$byval_copy17 = 0, $$byval_copy18 = 0, $$byval_copy19 = 0, $$byval_copy2 = 0, $$byval_copy20 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0; //@line 7293
 var $$byval_copy9 = 0, $10 = 0, $100 = 0.0, $101 = 0.0, $102 = 0.0, $103 = 0.0, $104 = 0, $105 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0.0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $2 = 0, $20 = 0, $21 = 0; //@line 7294
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0.0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0; //@line 7295
 var $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0.0, $5 = 0, $50 = 0.0, $51 = 0, $52 = 0, $53 = 0.0, $54 = 0, $55 = 0.0, $56 = 0, $57 = 0, $58 = 0.0; //@line 7296
 var $59 = 0.0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0.0, $64 = 0, $65 = 0, $66 = 0, $67 = 0.0, $68 = 0.0, $69 = 0.0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0;
 var $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0.0, $84 = 0.0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0.0, $9 = 0, $90 = 0, $91 = 0, $92 = 0.0, $93 = 0.0, $94 = 0.0; //@line 7298
 var $95 = 0.0, $96 = 0.0, $97 = 0.0, $98 = 0.0, $99 = 0.0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP; //@line 7300
 STACKTOP = STACKTOP + 608 | 0; //@line 7301
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(608 | 0); //@line 7301
 $$byval_copy20 = sp + 576 | 0; //@line 7302
 $$byval_copy19 = sp + 560 | 0; //@line 7303
 $$byval_copy18 = sp + 544 | 0; //@line 7304
 $$byval_copy17 = sp + 528 | 0; //@line 7305
 $$byval_copy16 = sp + 512 | 0; //@line 7306
 $$byval_copy15 = sp + 496 | 0; //@line 7307
 $$byval_copy14 = sp + 480 | 0; //@line 7308
 $$byval_copy13 = sp + 464 | 0; //@line 7309
 $$byval_copy12 = sp + 448 | 0; //@line 7310
 $$byval_copy11 = sp + 432 | 0; //@line 7311
 $$byval_copy10 = sp + 416 | 0; //@line 7312
 $$byval_copy9 = sp + 400 | 0; //@line 7313
 $$byval_copy8 = sp + 384 | 0; //@line 7314
 $$byval_copy7 = sp + 368 | 0; //@line 7315
 $$byval_copy6 = sp + 320 | 0; //@line 7316
 $$byval_copy5 = sp + 304 | 0; //@line 7317
 $$byval_copy4 = sp + 288 | 0; //@line 7318
 $$byval_copy3 = sp + 272 | 0; //@line 7319
 $$byval_copy2 = sp + 224 | 0; //@line 7320
 $$byval_copy1 = sp + 208 | 0; //@line 7321
 $$byval_copy = sp + 192 | 0; //@line 7322
 $6 = sp + 168 | 0; //@line 7323
 $7 = sp + 152 | 0; //@line 7324
 $8 = sp + 136 | 0; //@line 7325
 $9 = sp + 120 | 0; //@line 7326
 $10 = sp + 104 | 0; //@line 7327
 $11 = sp + 88 | 0; //@line 7328
 $12 = sp + 72 | 0; //@line 7329
 $15 = sp + 40 | 0; //@line 7330
 $16 = sp + 24 | 0; //@line 7331
 $17 = sp + 8 | 0; //@line 7332
 $2 = $0; //@line 7333
 $3 = $1; //@line 7334
 $19 = $2; //@line 7335
 $20 = $19 + 8 | 0; //@line 7336
 $21 = SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0; //@line 7337
 $4 = $21; //@line 7338
 $22 = $2; //@line 7339
 $23 = $22 + 12 | 0; //@line 7340
 $24 = SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0; //@line 7341
 $5 = $24; //@line 7342
 $25 = $2; //@line 7343
 $26 = $25 + 112 | 0; //@line 7344
 $27 = $4; //@line 7345
 $28 = $27 + 128 | 0; //@line 7346
 $29 = $2; //@line 7347
 $30 = $29 + 64 | 0; //@line 7348
 $31 = $4; //@line 7349
 $32 = $31 + 40 | 0; //@line 7350
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($30 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($30 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($30 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($32 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($32 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($32 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_414($6, $$byval_copy, $$byval_copy1); //@line 7353
 dest = $$byval_copy2; //@line 7354
 src = $28; //@line 7354
 stop = dest + 48 | 0; //@line 7354
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 7354
  src = src + 4 | 0; //@line 7354
 } while ((dest | 0) < (stop | 0));
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpTransformVect_415($7, $$byval_copy2, $$byval_copy3); //@line 7356
 SAFE_HEAP_STORE($26 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($26 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($26 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($26 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $33 = $2; //@line 7358
 $34 = $33 + 128 | 0; //@line 7359
 $35 = $5; //@line 7360
 $36 = $35 + 128 | 0; //@line 7361
 $37 = $2; //@line 7362
 $38 = $37 + 80 | 0; //@line 7363
 $39 = $5; //@line 7364
 $40 = $39 + 40 | 0; //@line 7365
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($38 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($38 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($38 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($38 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($40 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($40 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($40 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($40 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_414($8, $$byval_copy4, $$byval_copy5); //@line 7368
 dest = $$byval_copy6; //@line 7369
 src = $36; //@line 7369
 stop = dest + 48 | 0; //@line 7369
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 7369
  src = src + 4 | 0; //@line 7369
 } while ((dest | 0) < (stop | 0));
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpTransformVect_415($9, $$byval_copy6, $$byval_copy7); //@line 7371
 SAFE_HEAP_STORE($34 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($34 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($34 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($34 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $41 = $5; //@line 7373
 $42 = $41 + 56 | 0; //@line 7374
 $43 = $2; //@line 7375
 $44 = $43 + 128 | 0; //@line 7376
 SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($42 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($42 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($42 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($42 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($44 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($44 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($44 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($44 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_408($11, $$byval_copy8, $$byval_copy9); //@line 7379
 $45 = $4; //@line 7380
 $46 = $45 + 56 | 0; //@line 7381
 $47 = $2; //@line 7382
 $48 = $47 + 112 | 0; //@line 7383
 SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($46 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($46 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($46 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($46 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($48 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($48 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($48 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($48 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_408($12, $$byval_copy10, $$byval_copy11); //@line 7386
 SAFE_HEAP_STORE($$byval_copy12 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_414($10, $$byval_copy12, $$byval_copy13); //@line 7389
 SAFE_HEAP_STORE($$byval_copy14 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $49 = +_cpvlength_416($$byval_copy14); //@line 7391
 $13 = $49; //@line 7392
 $14 = 0.0; //@line 7393
 $50 = $13; //@line 7394
 $51 = $2; //@line 7395
 $52 = $51 + 104 | 0; //@line 7396
 $53 = +(+SAFE_HEAP_LOAD_D($52 | 0, 8)); //@line 7397
 $54 = $50 > $53; //@line 7398
 $55 = $13; //@line 7399
 $56 = $2; //@line 7400
 do {
  if ($54) {
   $57 = $56 + 104 | 0; //@line 7403
   $58 = +(+SAFE_HEAP_LOAD_D($57 | 0, 8)); //@line 7404
   $59 = $55 - $58; //@line 7405
   $14 = $59; //@line 7406
   $60 = $2; //@line 7407
   $61 = $60 + 144 | 0; //@line 7408
   SAFE_HEAP_STORE($$byval_copy15 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy15 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy15 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy15 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   _cpvnormalize_417($15, $$byval_copy15); //@line 7410
   SAFE_HEAP_STORE($61 | 0, SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($61 + 4 | 0, SAFE_HEAP_LOAD($15 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($61 + 8 | 0, SAFE_HEAP_LOAD($15 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($61 + 12 | 0, SAFE_HEAP_LOAD($15 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  } else {
   $62 = $56 + 96 | 0; //@line 7413
   $63 = +(+SAFE_HEAP_LOAD_D($62 | 0, 8)); //@line 7414
   $64 = $55 < $63; //@line 7415
   $65 = $2; //@line 7416
   if ($64) {
    $66 = $65 + 96 | 0; //@line 7418
    $67 = +(+SAFE_HEAP_LOAD_D($66 | 0, 8)); //@line 7419
    $68 = $13; //@line 7420
    $69 = $67 - $68; //@line 7421
    $14 = $69; //@line 7422
    $70 = $2; //@line 7423
    $71 = $70 + 144 | 0; //@line 7424
    SAFE_HEAP_STORE($$byval_copy16 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy16 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy16 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy16 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    _cpvnormalize_417($16, $$byval_copy16); //@line 7426
    SAFE_HEAP_STORE($$byval_copy17 | 0, SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy17 + 4 | 0, SAFE_HEAP_LOAD($16 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy17 + 8 | 0, SAFE_HEAP_LOAD($16 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($$byval_copy17 + 12 | 0, SAFE_HEAP_LOAD($16 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    _cpvneg_406($17, $$byval_copy17); //@line 7428
    SAFE_HEAP_STORE($71 | 0, SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($71 + 4 | 0, SAFE_HEAP_LOAD($17 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($71 + 8 | 0, SAFE_HEAP_LOAD($17 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($71 + 12 | 0, SAFE_HEAP_LOAD($17 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    break;
   } else {
    $72 = $65 + 144 | 0; //@line 7432
    SAFE_HEAP_STORE($72 | 0, SAFE_HEAP_LOAD(11264 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($72 + 4 | 0, SAFE_HEAP_LOAD(11264 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($72 + 8 | 0, SAFE_HEAP_LOAD(11264 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($72 + 12 | 0, SAFE_HEAP_LOAD(11264 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
    $73 = $2; //@line 7434
    $74 = $73 + 168 | 0; //@line 7435
    SAFE_HEAP_STORE_D($74 | 0, +0.0, 8);
    break;
   }
  }
 } while (0);
 $75 = $4; //@line 7441
 $76 = $5; //@line 7442
 $77 = $2; //@line 7443
 $78 = $77 + 112 | 0; //@line 7444
 $79 = $2; //@line 7445
 $80 = $79 + 128 | 0; //@line 7446
 $81 = $2; //@line 7447
 $82 = $81 + 144 | 0; //@line 7448
 SAFE_HEAP_STORE($$byval_copy18 | 0, SAFE_HEAP_LOAD($78 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy18 + 4 | 0, SAFE_HEAP_LOAD($78 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy18 + 8 | 0, SAFE_HEAP_LOAD($78 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy18 + 12 | 0, SAFE_HEAP_LOAD($78 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy19 | 0, SAFE_HEAP_LOAD($80 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy19 + 4 | 0, SAFE_HEAP_LOAD($80 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy19 + 8 | 0, SAFE_HEAP_LOAD($80 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy19 + 12 | 0, SAFE_HEAP_LOAD($80 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy20 | 0, SAFE_HEAP_LOAD($82 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy20 + 4 | 0, SAFE_HEAP_LOAD($82 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy20 + 8 | 0, SAFE_HEAP_LOAD($82 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy20 + 12 | 0, SAFE_HEAP_LOAD($82 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $83 = +_k_scalar_418($75, $76, $$byval_copy18, $$byval_copy19, $$byval_copy20); //@line 7452
 $84 = 1.0 / $83; //@line 7453
 $85 = $2; //@line 7454
 $86 = $85 + 160 | 0; //@line 7455
 SAFE_HEAP_STORE_D($86 | 0, +$84, 8);
 $87 = $2; //@line 7457
 $88 = $87 + 40 | 0; //@line 7458
 $89 = +(+SAFE_HEAP_LOAD_D($88 | 0, 8)); //@line 7459
 $18 = $89; //@line 7460
 $90 = $2; //@line 7461
 $91 = $90 + 32 | 0; //@line 7462
 $92 = +(+SAFE_HEAP_LOAD_D($91 | 0, 8)); //@line 7463
 $93 = $3; //@line 7464
 $94 = +_bias_coef_419($92, $93); //@line 7465
 $95 = -$94; //@line 7466
 $96 = $14; //@line 7467
 $97 = $95 * $96; //@line 7468
 $98 = $3; //@line 7469
 $99 = $97 / $98; //@line 7470
 $100 = $18; //@line 7471
 $101 = -$100; //@line 7472
 $102 = $18; //@line 7473
 $103 = +_cpfclamp_403($99, $101, $102); //@line 7474
 $104 = $2; //@line 7475
 $105 = $104 + 176 | 0; //@line 7476
 SAFE_HEAP_STORE_D($105 | 0, +$103, 8);
 STACKTOP = sp; //@line 7478
 return;
}
function _SubtreeInsert($0, $1, $2) {
 $0 = $0 | 0; //@line 4598
 $1 = $1 | 0; //@line 4599
 $2 = $2 | 0; //@line 4600
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0; //@line 4601
 var $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0.0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0.0, $33 = 0.0, $34 = 0, $35 = 0, $36 = 0; //@line 4602
 var $37 = 0, $38 = 0.0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0.0, $47 = 0.0, $48 = 0.0, $49 = 0.0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0; //@line 4603
 var $55 = 0, $56 = 0, $57 = 0.0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0.0, $66 = 0.0, $67 = 0.0, $68 = 0, $69 = 0, $7 = 0.0, $70 = 0, $71 = 0, $72 = 0; //@line 4604
 var $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0.0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $9 = 0, label = 0, sp = 0; //@line 4605
 sp = STACKTOP; //@line 4606
 STACKTOP = STACKTOP + 448 | 0; //@line 4607
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(448 | 0); //@line 4607
 $$byval_copy11 = sp + 400 | 0; //@line 4608
 $$byval_copy10 = sp + 368 | 0; //@line 4609
 $$byval_copy9 = sp + 336 | 0; //@line 4610
 $$byval_copy8 = sp + 304 | 0; //@line 4611
 $$byval_copy7 = sp + 272 | 0; //@line 4612
 $$byval_copy6 = sp + 240 | 0; //@line 4613
 $$byval_copy5 = sp + 208 | 0; //@line 4614
 $$byval_copy4 = sp + 176 | 0; //@line 4615
 $$byval_copy3 = sp + 144 | 0; //@line 4616
 $$byval_copy2 = sp + 112 | 0; //@line 4617
 $$byval_copy1 = sp + 80 | 0; //@line 4618
 $$byval_copy = sp + 48 | 0; //@line 4619
 $9 = sp; //@line 4620
 $4 = $0; //@line 4621
 $5 = $1; //@line 4622
 $6 = $2; //@line 4623
 $10 = $4; //@line 4624
 $11 = ($10 | 0) == (0 | 0); //@line 4625
 if ($11) {
  $12 = $5; //@line 4627
  $3 = $12; //@line 4628
  $88 = $3; //@line 4629
  STACKTOP = sp; //@line 4630
  return $88 | 0; //@line 4630
 }
 $13 = $4; //@line 4632
 $14 = _NodeIsLeaf($13) | 0; //@line 4633
 $15 = $14 << 24 >> 24 != 0; //@line 4634
 if ($15) {
  $16 = $6; //@line 4636
  $17 = $5; //@line 4637
  $18 = $4; //@line 4638
  $19 = _NodeNew($16, $17, $18) | 0; //@line 4639
  $3 = $19; //@line 4640
  $88 = $3; //@line 4641
  STACKTOP = sp; //@line 4642
  return $88 | 0; //@line 4642
 }
 $20 = $4; //@line 4644
 $21 = $20 + 44 | 0; //@line 4645
 $22 = $21 + 4 | 0; //@line 4646
 $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 4647
 $24 = $23 + 8 | 0; //@line 4648
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($24 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($24 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($24 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 16 | 0, SAFE_HEAP_LOAD($24 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 20 | 0, SAFE_HEAP_LOAD($24 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 24 | 0, SAFE_HEAP_LOAD($24 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 28 | 0, SAFE_HEAP_LOAD($24 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 $25 = +_cpBBArea($$byval_copy); //@line 4650
 $26 = $4; //@line 4651
 $27 = $26 + 44 | 0; //@line 4652
 $28 = SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0; //@line 4653
 $29 = $28 + 8 | 0; //@line 4654
 $30 = $5; //@line 4655
 $31 = $30 + 8 | 0; //@line 4656
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($29 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($29 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($29 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 16 | 0, SAFE_HEAP_LOAD($29 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 20 | 0, SAFE_HEAP_LOAD($29 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 24 | 0, SAFE_HEAP_LOAD($29 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 28 | 0, SAFE_HEAP_LOAD($29 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($31 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($31 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($31 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 16 | 0, SAFE_HEAP_LOAD($31 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 20 | 0, SAFE_HEAP_LOAD($31 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 24 | 0, SAFE_HEAP_LOAD($31 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 28 | 0, SAFE_HEAP_LOAD($31 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 $32 = +_cpBBMergedArea($$byval_copy1, $$byval_copy2); //@line 4659
 $33 = $25 + $32; //@line 4660
 $7 = $33; //@line 4661
 $34 = $4; //@line 4662
 $35 = $34 + 44 | 0; //@line 4663
 $36 = SAFE_HEAP_LOAD($35 | 0, 4, 0) | 0 | 0; //@line 4664
 $37 = $36 + 8 | 0; //@line 4665
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($37 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($37 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($37 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($37 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 16 | 0, SAFE_HEAP_LOAD($37 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 20 | 0, SAFE_HEAP_LOAD($37 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 24 | 0, SAFE_HEAP_LOAD($37 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 28 | 0, SAFE_HEAP_LOAD($37 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 $38 = +_cpBBArea($$byval_copy3); //@line 4667
 $39 = $4; //@line 4668
 $40 = $39 + 44 | 0; //@line 4669
 $41 = $40 + 4 | 0; //@line 4670
 $42 = SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0; //@line 4671
 $43 = $42 + 8 | 0; //@line 4672
 $44 = $5; //@line 4673
 $45 = $44 + 8 | 0; //@line 4674
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($43 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($43 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($43 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($43 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 16 | 0, SAFE_HEAP_LOAD($43 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 20 | 0, SAFE_HEAP_LOAD($43 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 24 | 0, SAFE_HEAP_LOAD($43 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 28 | 0, SAFE_HEAP_LOAD($43 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($45 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($45 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($45 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($45 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 16 | 0, SAFE_HEAP_LOAD($45 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 20 | 0, SAFE_HEAP_LOAD($45 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 24 | 0, SAFE_HEAP_LOAD($45 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 28 | 0, SAFE_HEAP_LOAD($45 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 $46 = +_cpBBMergedArea($$byval_copy4, $$byval_copy5); //@line 4677
 $47 = $38 + $46; //@line 4678
 $8 = $47; //@line 4679
 $48 = $7; //@line 4680
 $49 = $8; //@line 4681
 $50 = $48 == $49; //@line 4682
 if ($50) {
  $51 = $4; //@line 4684
  $52 = $51 + 44 | 0; //@line 4685
  $53 = SAFE_HEAP_LOAD($52 | 0, 4, 0) | 0 | 0; //@line 4686
  $54 = $53 + 8 | 0; //@line 4687
  $55 = $5; //@line 4688
  $56 = $55 + 8 | 0; //@line 4689
  SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($54 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($54 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($54 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($54 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 16 | 0, SAFE_HEAP_LOAD($54 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 20 | 0, SAFE_HEAP_LOAD($54 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 24 | 0, SAFE_HEAP_LOAD($54 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 28 | 0, SAFE_HEAP_LOAD($54 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($56 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($56 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($56 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($56 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 16 | 0, SAFE_HEAP_LOAD($56 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 20 | 0, SAFE_HEAP_LOAD($56 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 24 | 0, SAFE_HEAP_LOAD($56 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 28 | 0, SAFE_HEAP_LOAD($56 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
  $57 = +_cpBBProximity($$byval_copy6, $$byval_copy7); //@line 4692
  $7 = $57; //@line 4693
  $58 = $4; //@line 4694
  $59 = $58 + 44 | 0; //@line 4695
  $60 = $59 + 4 | 0; //@line 4696
  $61 = SAFE_HEAP_LOAD($60 | 0, 4, 0) | 0 | 0; //@line 4697
  $62 = $61 + 8 | 0; //@line 4698
  $63 = $5; //@line 4699
  $64 = $63 + 8 | 0; //@line 4700
  SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($62 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($62 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($62 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($62 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 16 | 0, SAFE_HEAP_LOAD($62 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 20 | 0, SAFE_HEAP_LOAD($62 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 24 | 0, SAFE_HEAP_LOAD($62 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 28 | 0, SAFE_HEAP_LOAD($62 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($64 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($64 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($64 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($64 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 16 | 0, SAFE_HEAP_LOAD($64 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 20 | 0, SAFE_HEAP_LOAD($64 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 24 | 0, SAFE_HEAP_LOAD($64 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 28 | 0, SAFE_HEAP_LOAD($64 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
  $65 = +_cpBBProximity($$byval_copy8, $$byval_copy9); //@line 4703
  $8 = $65; //@line 4704
 }
 $66 = $8; //@line 4706
 $67 = $7; //@line 4707
 $68 = $66 < $67; //@line 4708
 $69 = $4; //@line 4709
 $70 = $4; //@line 4710
 $71 = $70 + 44 | 0; //@line 4711
 if ($68) {
  $72 = $71 + 4 | 0; //@line 4713
  $73 = SAFE_HEAP_LOAD($72 | 0, 4, 0) | 0 | 0; //@line 4714
  $74 = $5; //@line 4715
  $75 = $6; //@line 4716
  $76 = _SubtreeInsert($73, $74, $75) | 0; //@line 4717
  _NodeSetB($69, $76); //@line 4718
 } else {
  $77 = SAFE_HEAP_LOAD($71 | 0, 4, 0) | 0 | 0; //@line 4720
  $78 = $5; //@line 4721
  $79 = $6; //@line 4722
  $80 = _SubtreeInsert($77, $78, $79) | 0; //@line 4723
  _NodeSetA($69, $80); //@line 4724
 }
 $81 = $4; //@line 4726
 $82 = $81 + 8 | 0; //@line 4727
 $83 = $4; //@line 4728
 $84 = $83 + 8 | 0; //@line 4729
 $85 = $5; //@line 4730
 $86 = $85 + 8 | 0; //@line 4731
 SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($84 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($84 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($84 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($84 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 16 | 0, SAFE_HEAP_LOAD($84 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 20 | 0, SAFE_HEAP_LOAD($84 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 24 | 0, SAFE_HEAP_LOAD($84 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 28 | 0, SAFE_HEAP_LOAD($84 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($86 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($86 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($86 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($86 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 16 | 0, SAFE_HEAP_LOAD($86 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 20 | 0, SAFE_HEAP_LOAD($86 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 24 | 0, SAFE_HEAP_LOAD($86 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 28 | 0, SAFE_HEAP_LOAD($86 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpBBMerge($9, $$byval_copy10, $$byval_copy11); //@line 4734
 SAFE_HEAP_STORE($82 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($82 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($82 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($82 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($82 + 16 | 0, SAFE_HEAP_LOAD($9 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($82 + 20 | 0, SAFE_HEAP_LOAD($9 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($82 + 24 | 0, SAFE_HEAP_LOAD($9 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($82 + 28 | 0, SAFE_HEAP_LOAD($9 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 $87 = $4; //@line 4736
 $3 = $87; //@line 4737
 $88 = $3; //@line 4738
 STACKTOP = sp; //@line 4739
 return $88 | 0; //@line 4739
}
function _try_realloc_chunk($0, $1) {
 $0 = $0 | 0; //@line 9357
 $1 = $1 | 0; //@line 9358
 var $$1271 = 0, $$1271$be = 0, $$1271$ph = 0, $$1274 = 0, $$1274$be = 0, $$1274$ph = 0, $$2 = 0, $$3 = 0, $$pre = 0, $$pre$phiZ2D = 0, $$sink = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0; //@line 9359
 var $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0; //@line 9360
 var $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0; //@line 9361
 var $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0; //@line 9362
 var $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $18 = 0, $19 = 0, $2 = 0; //@line 9363
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0; //@line 9364
 var $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0; //@line 9365
 var $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0; //@line 9366
 var $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0; //@line 9367
 var $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $cond = 0, $or$cond$not = 0, $or$cond5 = 0, $storemerge = 0, $storemerge3 = 0, label = 0, sp = 0; //@line 9368
 sp = STACKTOP; //@line 9369
 $2 = $0 + 4 | 0; //@line 9370
 $3 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 9371
 $4 = $3 & -8; //@line 9372
 $5 = $0 + $4 | 0; //@line 9373
 $6 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 9374
 $7 = $6 >>> 0 <= $0 >>> 0; //@line 9375
 $8 = $3 & 3; //@line 9376
 $9 = ($8 | 0) != 1; //@line 9377
 $or$cond$not = $9 & $7; //@line 9378
 $10 = $5 >>> 0 > $0 >>> 0; //@line 9379
 $or$cond5 = $or$cond$not & $10; //@line 9380
 if (!$or$cond5) {
  _abort(); //@line 9382
 }
 $11 = $5 + 4 | 0; //@line 9385
 $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 9386
 $13 = $12 & 1; //@line 9387
 $14 = ($13 | 0) == 0; //@line 9388
 if ($14) {
  _abort(); //@line 9390
 }
 $15 = ($8 | 0) == 0; //@line 9393
 if ($15) {
  $16 = $1 >>> 0 < 256; //@line 9395
  if ($16) {
   $$2 = 0; //@line 9397
   return $$2 | 0; //@line 9398
  }
  $17 = $1 + 4 | 0; //@line 9400
  $18 = $4 >>> 0 < $17 >>> 0; //@line 9401
  if (!$18) {
   $19 = $4 - $1 | 0; //@line 9403
   $20 = SAFE_HEAP_LOAD(11776 | 0, 4, 0) | 0 | 0; //@line 9404
   $21 = $20 << 1; //@line 9405
   $22 = $19 >>> 0 > $21 >>> 0; //@line 9406
   if (!$22) {
    $$2 = $0; //@line 9408
    return $$2 | 0; //@line 9409
   }
  }
  $$2 = 0; //@line 9412
  return $$2 | 0; //@line 9413
 }
 $23 = $4 >>> 0 < $1 >>> 0; //@line 9415
 if (!$23) {
  $24 = $4 - $1 | 0; //@line 9417
  $25 = $24 >>> 0 > 15; //@line 9418
  if (!$25) {
   $$2 = $0; //@line 9420
   return $$2 | 0; //@line 9421
  }
  $26 = $0 + $1 | 0; //@line 9423
  $27 = $3 & 1; //@line 9424
  $28 = $27 | $1; //@line 9425
  $29 = $28 | 2; //@line 9426
  SAFE_HEAP_STORE($2 | 0, $29 | 0, 4);
  $30 = $26 + 4 | 0; //@line 9428
  $31 = $24 | 3; //@line 9429
  SAFE_HEAP_STORE($30 | 0, $31 | 0, 4);
  $32 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 9431
  $33 = $32 | 1; //@line 9432
  SAFE_HEAP_STORE($11 | 0, $33 | 0, 4);
  _dispose_chunk($26, $24); //@line 9434
  $$2 = $0; //@line 9435
  return $$2 | 0; //@line 9436
 }
 $34 = SAFE_HEAP_LOAD(11320 | 0, 4, 0) | 0 | 0; //@line 9438
 $35 = ($34 | 0) == ($5 | 0); //@line 9439
 if ($35) {
  $36 = SAFE_HEAP_LOAD(11308 | 0, 4, 0) | 0 | 0; //@line 9441
  $37 = $36 + $4 | 0; //@line 9442
  $38 = $37 >>> 0 > $1 >>> 0; //@line 9443
  $39 = $37 - $1 | 0; //@line 9444
  $40 = $0 + $1 | 0; //@line 9445
  if (!$38) {
   $$2 = 0; //@line 9447
   return $$2 | 0; //@line 9448
  }
  $41 = $39 | 1; //@line 9450
  $42 = $40 + 4 | 0; //@line 9451
  $43 = $3 & 1; //@line 9452
  $44 = $43 | $1; //@line 9453
  $45 = $44 | 2; //@line 9454
  SAFE_HEAP_STORE($2 | 0, $45 | 0, 4);
  SAFE_HEAP_STORE($42 | 0, $41 | 0, 4);
  SAFE_HEAP_STORE(11320 | 0, $40 | 0, 4);
  SAFE_HEAP_STORE(11308 | 0, $39 | 0, 4);
  $$2 = $0; //@line 9459
  return $$2 | 0; //@line 9460
 }
 $46 = SAFE_HEAP_LOAD(11316 | 0, 4, 0) | 0 | 0; //@line 9462
 $47 = ($46 | 0) == ($5 | 0); //@line 9463
 if ($47) {
  $48 = SAFE_HEAP_LOAD(11304 | 0, 4, 0) | 0 | 0; //@line 9465
  $49 = $48 + $4 | 0; //@line 9466
  $50 = $49 >>> 0 < $1 >>> 0; //@line 9467
  if ($50) {
   $$2 = 0; //@line 9469
   return $$2 | 0; //@line 9470
  }
  $51 = $49 - $1 | 0; //@line 9472
  $52 = $51 >>> 0 > 15; //@line 9473
  if ($52) {
   $53 = $0 + $1 | 0; //@line 9475
   $54 = $0 + $49 | 0; //@line 9476
   $55 = $3 & 1; //@line 9477
   $56 = $55 | $1; //@line 9478
   $57 = $56 | 2; //@line 9479
   SAFE_HEAP_STORE($2 | 0, $57 | 0, 4);
   $58 = $53 + 4 | 0; //@line 9481
   $59 = $51 | 1; //@line 9482
   SAFE_HEAP_STORE($58 | 0, $59 | 0, 4);
   SAFE_HEAP_STORE($54 | 0, $51 | 0, 4);
   $60 = $54 + 4 | 0; //@line 9485
   $61 = SAFE_HEAP_LOAD($60 | 0, 4, 0) | 0 | 0; //@line 9486
   $62 = $61 & -2; //@line 9487
   SAFE_HEAP_STORE($60 | 0, $62 | 0, 4);
   $storemerge = $53; //@line 9489
   $storemerge3 = $51; //@line 9489
  } else {
   $63 = $3 & 1; //@line 9491
   $64 = $63 | $49; //@line 9492
   $65 = $64 | 2; //@line 9493
   SAFE_HEAP_STORE($2 | 0, $65 | 0, 4);
   $66 = $0 + $49 | 0; //@line 9495
   $67 = $66 + 4 | 0; //@line 9496
   $68 = SAFE_HEAP_LOAD($67 | 0, 4, 0) | 0 | 0; //@line 9497
   $69 = $68 | 1; //@line 9498
   SAFE_HEAP_STORE($67 | 0, $69 | 0, 4);
   $storemerge = 0; //@line 9500
   $storemerge3 = 0; //@line 9500
  }
  SAFE_HEAP_STORE(11304 | 0, $storemerge3 | 0, 4);
  SAFE_HEAP_STORE(11316 | 0, $storemerge | 0, 4);
  $$2 = $0; //@line 9504
  return $$2 | 0; //@line 9505
 }
 $70 = $12 & 2; //@line 9507
 $71 = ($70 | 0) == 0; //@line 9508
 if (!$71) {
  $$2 = 0; //@line 9510
  return $$2 | 0; //@line 9511
 }
 $72 = $12 & -8; //@line 9513
 $73 = $72 + $4 | 0; //@line 9514
 $74 = $73 >>> 0 < $1 >>> 0; //@line 9515
 if ($74) {
  $$2 = 0; //@line 9517
  return $$2 | 0; //@line 9518
 }
 $75 = $73 - $1 | 0; //@line 9520
 $76 = $12 >>> 3; //@line 9521
 $77 = $12 >>> 0 < 256; //@line 9522
 L49 : do {
  if ($77) {
   $78 = $5 + 8 | 0; //@line 9525
   $79 = SAFE_HEAP_LOAD($78 | 0, 4, 0) | 0 | 0; //@line 9526
   $80 = $5 + 12 | 0; //@line 9527
   $81 = SAFE_HEAP_LOAD($80 | 0, 4, 0) | 0 | 0; //@line 9528
   $82 = $76 << 1; //@line 9529
   $83 = 11336 + ($82 << 2) | 0; //@line 9530
   $84 = ($79 | 0) == ($83 | 0); //@line 9531
   if (!$84) {
    $85 = $6 >>> 0 > $79 >>> 0; //@line 9533
    if ($85) {
     _abort(); //@line 9535
    }
    $86 = $79 + 12 | 0; //@line 9538
    $87 = SAFE_HEAP_LOAD($86 | 0, 4, 0) | 0 | 0; //@line 9539
    $88 = ($87 | 0) == ($5 | 0); //@line 9540
    if (!$88) {
     _abort(); //@line 9542
    }
   }
   $89 = ($81 | 0) == ($79 | 0); //@line 9546
   if ($89) {
    $90 = 1 << $76; //@line 9548
    $91 = $90 ^ -1; //@line 9549
    $92 = SAFE_HEAP_LOAD(2824 * 4 | 0, 4, 0) | 0 | 0; //@line 9550
    $93 = $92 & $91; //@line 9551
    SAFE_HEAP_STORE(2824 * 4 | 0, $93 | 0, 4);
    break;
   }
   $94 = ($81 | 0) == ($83 | 0); //@line 9555
   if ($94) {
    $$pre = $81 + 8 | 0; //@line 9557
    $$pre$phiZ2D = $$pre; //@line 9558
   } else {
    $95 = $6 >>> 0 > $81 >>> 0; //@line 9560
    if ($95) {
     _abort(); //@line 9562
    }
    $96 = $81 + 8 | 0; //@line 9565
    $97 = SAFE_HEAP_LOAD($96 | 0, 4, 0) | 0 | 0; //@line 9566
    $98 = ($97 | 0) == ($5 | 0); //@line 9567
    if ($98) {
     $$pre$phiZ2D = $96; //@line 9569
    } else {
     _abort(); //@line 9571
    }
   }
   $99 = $79 + 12 | 0; //@line 9575
   SAFE_HEAP_STORE($99 | 0, $81 | 0, 4);
   SAFE_HEAP_STORE($$pre$phiZ2D | 0, $79 | 0, 4);
  } else {
   $100 = $5 + 24 | 0; //@line 9579
   $101 = SAFE_HEAP_LOAD($100 | 0, 4, 0) | 0 | 0; //@line 9580
   $102 = $5 + 12 | 0; //@line 9581
   $103 = SAFE_HEAP_LOAD($102 | 0, 4, 0) | 0 | 0; //@line 9582
   $104 = ($103 | 0) == ($5 | 0); //@line 9583
   do {
    if ($104) {
     $114 = $5 + 16 | 0; //@line 9586
     $115 = $114 + 4 | 0; //@line 9587
     $116 = SAFE_HEAP_LOAD($115 | 0, 4, 0) | 0 | 0; //@line 9588
     $117 = ($116 | 0) == (0 | 0); //@line 9589
     if ($117) {
      $118 = SAFE_HEAP_LOAD($114 | 0, 4, 0) | 0 | 0; //@line 9591
      $119 = ($118 | 0) == (0 | 0); //@line 9592
      if ($119) {
       $$3 = 0; //@line 9594
       break;
      } else {
       $$1271$ph = $118; //@line 9597
       $$1274$ph = $114; //@line 9597
      }
     } else {
      $$1271$ph = $116; //@line 9600
      $$1274$ph = $115; //@line 9600
     }
     $$1271 = $$1271$ph; //@line 9602
     $$1274 = $$1274$ph; //@line 9602
     while (1) {
      $120 = $$1271 + 20 | 0; //@line 9604
      $121 = SAFE_HEAP_LOAD($120 | 0, 4, 0) | 0 | 0; //@line 9605
      $122 = ($121 | 0) == (0 | 0); //@line 9606
      if ($122) {
       $123 = $$1271 + 16 | 0; //@line 9608
       $124 = SAFE_HEAP_LOAD($123 | 0, 4, 0) | 0 | 0; //@line 9609
       $125 = ($124 | 0) == (0 | 0); //@line 9610
       if ($125) {
        break;
       } else {
        $$1271$be = $124; //@line 9614
        $$1274$be = $123; //@line 9614
       }
      } else {
       $$1271$be = $121; //@line 9617
       $$1274$be = $120; //@line 9617
      }
      $$1271 = $$1271$be; //@line 9619
      $$1274 = $$1274$be; //@line 9619
     }
     $126 = $6 >>> 0 > $$1274 >>> 0; //@line 9621
     if ($126) {
      _abort(); //@line 9623
     } else {
      SAFE_HEAP_STORE($$1274 | 0, 0 | 0, 4);
      $$3 = $$1271; //@line 9627
      break;
     }
    } else {
     $105 = $5 + 8 | 0; //@line 9631
     $106 = SAFE_HEAP_LOAD($105 | 0, 4, 0) | 0 | 0; //@line 9632
     $107 = $6 >>> 0 > $106 >>> 0; //@line 9633
     if ($107) {
      _abort(); //@line 9635
     }
     $108 = $106 + 12 | 0; //@line 9638
     $109 = SAFE_HEAP_LOAD($108 | 0, 4, 0) | 0 | 0; //@line 9639
     $110 = ($109 | 0) == ($5 | 0); //@line 9640
     if (!$110) {
      _abort(); //@line 9642
     }
     $111 = $103 + 8 | 0; //@line 9645
     $112 = SAFE_HEAP_LOAD($111 | 0, 4, 0) | 0 | 0; //@line 9646
     $113 = ($112 | 0) == ($5 | 0); //@line 9647
     if ($113) {
      SAFE_HEAP_STORE($108 | 0, $103 | 0, 4);
      SAFE_HEAP_STORE($111 | 0, $106 | 0, 4);
      $$3 = $103; //@line 9651
      break;
     } else {
      _abort(); //@line 9654
     }
    }
   } while (0);
   $127 = ($101 | 0) == (0 | 0); //@line 9659
   if (!$127) {
    $128 = $5 + 28 | 0; //@line 9661
    $129 = SAFE_HEAP_LOAD($128 | 0, 4, 0) | 0 | 0; //@line 9662
    $130 = 11600 + ($129 << 2) | 0; //@line 9663
    $131 = SAFE_HEAP_LOAD($130 | 0, 4, 0) | 0 | 0; //@line 9664
    $132 = ($131 | 0) == ($5 | 0); //@line 9665
    do {
     if ($132) {
      SAFE_HEAP_STORE($130 | 0, $$3 | 0, 4);
      $cond = ($$3 | 0) == (0 | 0); //@line 9669
      if ($cond) {
       $133 = 1 << $129; //@line 9671
       $134 = $133 ^ -1; //@line 9672
       $135 = SAFE_HEAP_LOAD(11300 | 0, 4, 0) | 0 | 0; //@line 9673
       $136 = $135 & $134; //@line 9674
       SAFE_HEAP_STORE(11300 | 0, $136 | 0, 4);
       break L49;
      }
     } else {
      $137 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 9679
      $138 = $137 >>> 0 > $101 >>> 0; //@line 9680
      if ($138) {
       _abort(); //@line 9682
      } else {
       $139 = $101 + 16 | 0; //@line 9685
       $140 = SAFE_HEAP_LOAD($139 | 0, 4, 0) | 0 | 0; //@line 9686
       $141 = ($140 | 0) == ($5 | 0); //@line 9687
       $142 = $101 + 20 | 0; //@line 9688
       $$sink = $141 ? $139 : $142; //@line 9689
       SAFE_HEAP_STORE($$sink | 0, $$3 | 0, 4);
       $143 = ($$3 | 0) == (0 | 0); //@line 9691
       if ($143) {
        break L49;
       } else {
        break;
       }
      }
     }
    } while (0);
    $144 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 9700
    $145 = $144 >>> 0 > $$3 >>> 0; //@line 9701
    if ($145) {
     _abort(); //@line 9703
    }
    $146 = $$3 + 24 | 0; //@line 9706
    SAFE_HEAP_STORE($146 | 0, $101 | 0, 4);
    $147 = $5 + 16 | 0; //@line 9708
    $148 = SAFE_HEAP_LOAD($147 | 0, 4, 0) | 0 | 0; //@line 9709
    $149 = ($148 | 0) == (0 | 0); //@line 9710
    do {
     if (!$149) {
      $150 = $144 >>> 0 > $148 >>> 0; //@line 9713
      if ($150) {
       _abort(); //@line 9715
      } else {
       $151 = $$3 + 16 | 0; //@line 9718
       SAFE_HEAP_STORE($151 | 0, $148 | 0, 4);
       $152 = $148 + 24 | 0; //@line 9720
       SAFE_HEAP_STORE($152 | 0, $$3 | 0, 4);
       break;
      }
     }
    } while (0);
    $153 = $147 + 4 | 0; //@line 9726
    $154 = SAFE_HEAP_LOAD($153 | 0, 4, 0) | 0 | 0; //@line 9727
    $155 = ($154 | 0) == (0 | 0); //@line 9728
    if (!$155) {
     $156 = SAFE_HEAP_LOAD(11312 | 0, 4, 0) | 0 | 0; //@line 9730
     $157 = $156 >>> 0 > $154 >>> 0; //@line 9731
     if ($157) {
      _abort(); //@line 9733
     } else {
      $158 = $$3 + 20 | 0; //@line 9736
      SAFE_HEAP_STORE($158 | 0, $154 | 0, 4);
      $159 = $154 + 24 | 0; //@line 9738
      SAFE_HEAP_STORE($159 | 0, $$3 | 0, 4);
      break;
     }
    }
   }
  }
 } while (0);
 $160 = $75 >>> 0 < 16; //@line 9746
 if ($160) {
  $161 = $3 & 1; //@line 9748
  $162 = $161 | $73; //@line 9749
  $163 = $162 | 2; //@line 9750
  SAFE_HEAP_STORE($2 | 0, $163 | 0, 4);
  $164 = $0 + $73 | 0; //@line 9752
  $165 = $164 + 4 | 0; //@line 9753
  $166 = SAFE_HEAP_LOAD($165 | 0, 4, 0) | 0 | 0; //@line 9754
  $167 = $166 | 1; //@line 9755
  SAFE_HEAP_STORE($165 | 0, $167 | 0, 4);
  $$2 = $0; //@line 9757
  return $$2 | 0; //@line 9758
 } else {
  $168 = $0 + $1 | 0; //@line 9760
  $169 = $3 & 1; //@line 9761
  $170 = $169 | $1; //@line 9762
  $171 = $170 | 2; //@line 9763
  SAFE_HEAP_STORE($2 | 0, $171 | 0, 4);
  $172 = $168 + 4 | 0; //@line 9765
  $173 = $75 | 3; //@line 9766
  SAFE_HEAP_STORE($172 | 0, $173 | 0, 4);
  $174 = $0 + $73 | 0; //@line 9768
  $175 = $174 + 4 | 0; //@line 9769
  $176 = SAFE_HEAP_LOAD($175 | 0, 4, 0) | 0 | 0; //@line 9770
  $177 = $176 | 1; //@line 9771
  SAFE_HEAP_STORE($175 | 0, $177 | 0, 4);
  _dispose_chunk($168, $75); //@line 9773
  $$2 = $0; //@line 9774
  return $$2 | 0; //@line 9775
 }
 return 0 | 0; //@line 9777
}
function _CircleSegmentQuery_361($0, $1, $2, $3, $4, $5, $6) {
 $0 = $0 | 0; //@line 5984
 $1 = $1 | 0; //@line 5985
 $2 = +$2; //@line 5986
 $3 = $3 | 0; //@line 5987
 $4 = $4 | 0; //@line 5988
 $5 = +$5; //@line 5989
 $6 = $6 | 0; //@line 5990
 var $$byval_copy = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy14 = 0, $$byval_copy15 = 0, $$byval_copy16 = 0, $$byval_copy17 = 0, $$byval_copy18 = 0, $$byval_copy19 = 0, $$byval_copy2 = 0, $$byval_copy20 = 0, $$byval_copy21 = 0, $$byval_copy22 = 0, $$byval_copy23 = 0, $$byval_copy24 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0; //@line 5991
 var $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0.0, $24 = 0.0, $25 = 0.0; //@line 5992
 var $26 = 0.0, $27 = 0.0, $28 = 0.0, $29 = 0.0, $30 = 0.0, $31 = 0.0, $32 = 0.0, $33 = 0.0, $34 = 0.0, $35 = 0.0, $36 = 0.0, $37 = 0.0, $38 = 0.0, $39 = 0.0, $40 = 0.0, $41 = 0.0, $42 = 0.0, $43 = 0.0, $44 = 0.0, $45 = 0.0;
 var $46 = 0.0, $47 = 0, $48 = 0.0, $49 = 0.0, $50 = 0.0, $51 = 0.0, $52 = 0.0, $53 = 0.0, $54 = 0.0, $55 = 0.0, $56 = 0, $57 = 0.0, $58 = 0, $59 = 0.0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0.0, $65 = 0.0;
 var $66 = 0, $67 = 0, $68 = 0.0, $69 = 0, $7 = 0, $70 = 0, $8 = 0.0, $9 = 0.0, $or$cond = 0, label = 0, sp = 0; //@line 5995
 sp = STACKTOP; //@line 5996
 STACKTOP = STACKTOP + 560 | 0; //@line 5997
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(560 | 0); //@line 5997
 $$byval_copy24 = sp + 536 | 0; //@line 5998
 $$byval_copy23 = sp + 520 | 0; //@line 5999
 $$byval_copy22 = sp + 504 | 0; //@line 6000
 $$byval_copy21 = sp + 488 | 0; //@line 6001
 $$byval_copy20 = sp + 472 | 0; //@line 6002
 $$byval_copy19 = sp + 456 | 0; //@line 6003
 $$byval_copy18 = sp + 440 | 0; //@line 6004
 $$byval_copy17 = sp + 424 | 0; //@line 6005
 $$byval_copy16 = sp + 408 | 0; //@line 6006
 $$byval_copy15 = sp + 392 | 0; //@line 6007
 $$byval_copy14 = sp + 376 | 0; //@line 6008
 $$byval_copy13 = sp + 360 | 0; //@line 6009
 $$byval_copy12 = sp + 344 | 0; //@line 6010
 $$byval_copy11 = sp + 328 | 0; //@line 6011
 $$byval_copy10 = sp + 312 | 0; //@line 6012
 $$byval_copy9 = sp + 296 | 0; //@line 6013
 $$byval_copy8 = sp + 280 | 0; //@line 6014
 $$byval_copy7 = sp + 264 | 0; //@line 6015
 $$byval_copy6 = sp + 248 | 0; //@line 6016
 $$byval_copy5 = sp + 232 | 0; //@line 6017
 $$byval_copy4 = sp + 216 | 0; //@line 6018
 $$byval_copy3 = sp + 200 | 0; //@line 6019
 $$byval_copy2 = sp + 184 | 0; //@line 6020
 $$byval_copy = sp + 168 | 0; //@line 6021
 $11 = sp + 136 | 0; //@line 6022
 $12 = sp + 120 | 0; //@line 6023
 $18 = sp + 64 | 0; //@line 6024
 $19 = sp + 48 | 0; //@line 6025
 $20 = sp + 32 | 0; //@line 6026
 $21 = sp + 16 | 0; //@line 6027
 $22 = sp; //@line 6028
 $7 = $0; //@line 6029
 $8 = $2; //@line 6030
 $9 = $5; //@line 6031
 $10 = $6; //@line 6032
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_354($11, $$byval_copy, $$byval_copy2); //@line 6035
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_354($12, $$byval_copy3, $$byval_copy4); //@line 6038
 $23 = $8; //@line 6039
 $24 = $9; //@line 6040
 $25 = $23 + $24; //@line 6041
 $13 = $25; //@line 6042
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $26 = +_cpvdot_359($$byval_copy5, $$byval_copy6); //@line 6045
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $27 = +_cpvdot_359($$byval_copy7, $$byval_copy8); //@line 6048
 $28 = 2.0 * $27; //@line 6049
 $29 = $26 - $28; //@line 6050
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $30 = +_cpvdot_359($$byval_copy9, $$byval_copy10); //@line 6053
 $31 = $29 + $30; //@line 6054
 $14 = $31; //@line 6055
 SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $32 = +_cpvdot_359($$byval_copy11, $$byval_copy12); //@line 6058
 SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $33 = +_cpvdot_359($$byval_copy13, $$byval_copy14); //@line 6061
 $34 = $32 - $33; //@line 6062
 $15 = $34; //@line 6063
 $35 = $15; //@line 6064
 $36 = $15; //@line 6065
 $37 = $35 * $36; //@line 6066
 $38 = $14; //@line 6067
 SAFE_HEAP_STORE($$byval_copy15 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy15 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy15 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy15 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy16 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy16 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy16 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy16 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $39 = +_cpvdot_359($$byval_copy15, $$byval_copy16); //@line 6070
 $40 = $13; //@line 6071
 $41 = $13; //@line 6072
 $42 = $40 * $41; //@line 6073
 $43 = $39 - $42; //@line 6074
 $44 = $38 * $43; //@line 6075
 $45 = $37 - $44; //@line 6076
 $16 = $45; //@line 6077
 $46 = $16; //@line 6078
 $47 = $46 >= 0.0; //@line 6079
 if (!$47) {
  STACKTOP = sp; //@line 6081
  return;
 }
 $48 = $15; //@line 6083
 $49 = -$48; //@line 6084
 $50 = $16; //@line 6085
 $51 = +Math_sqrt(+$50); //@line 6086
 $52 = $49 - $51; //@line 6087
 $53 = $14; //@line 6088
 $54 = $52 / $53; //@line 6089
 $17 = $54; //@line 6090
 $55 = $17; //@line 6091
 $56 = 0.0 <= $55; //@line 6092
 $57 = $17; //@line 6093
 $58 = $57 <= 1.0; //@line 6094
 $or$cond = $56 & $58; //@line 6095
 if (!$or$cond) {
  STACKTOP = sp; //@line 6097
  return;
 }
 $59 = $17; //@line 6099
 SAFE_HEAP_STORE($$byval_copy17 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy17 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy17 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy17 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy18 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy18 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy18 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy18 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvlerp_362($19, $$byval_copy17, $$byval_copy18, $59); //@line 6102
 SAFE_HEAP_STORE($$byval_copy19 | 0, SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy19 + 4 | 0, SAFE_HEAP_LOAD($19 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy19 + 8 | 0, SAFE_HEAP_LOAD($19 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy19 + 12 | 0, SAFE_HEAP_LOAD($19 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvnormalize_355($18, $$byval_copy19); //@line 6104
 $60 = $7; //@line 6105
 $61 = $10; //@line 6106
 SAFE_HEAP_STORE($61 | 0, $60 | 0, 4);
 $62 = $10; //@line 6108
 $63 = $62 + 8 | 0; //@line 6109
 $64 = $17; //@line 6110
 SAFE_HEAP_STORE($$byval_copy20 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy20 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy20 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy20 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy21 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy21 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy21 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy21 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvlerp_362($20, $$byval_copy20, $$byval_copy21, $64); //@line 6113
 $65 = $9; //@line 6114
 SAFE_HEAP_STORE($$byval_copy22 | 0, SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy22 + 4 | 0, SAFE_HEAP_LOAD($18 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy22 + 8 | 0, SAFE_HEAP_LOAD($18 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy22 + 12 | 0, SAFE_HEAP_LOAD($18 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_357($21, $$byval_copy22, $65); //@line 6116
 SAFE_HEAP_STORE($$byval_copy23 | 0, SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy23 + 4 | 0, SAFE_HEAP_LOAD($20 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy23 + 8 | 0, SAFE_HEAP_LOAD($20 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy23 + 12 | 0, SAFE_HEAP_LOAD($20 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy24 | 0, SAFE_HEAP_LOAD($21 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy24 + 4 | 0, SAFE_HEAP_LOAD($21 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy24 + 8 | 0, SAFE_HEAP_LOAD($21 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy24 + 12 | 0, SAFE_HEAP_LOAD($21 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_354($22, $$byval_copy23, $$byval_copy24); //@line 6119
 SAFE_HEAP_STORE($63 | 0, SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($63 + 4 | 0, SAFE_HEAP_LOAD($22 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($63 + 8 | 0, SAFE_HEAP_LOAD($22 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($63 + 12 | 0, SAFE_HEAP_LOAD($22 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $66 = $10; //@line 6121
 $67 = $66 + 24 | 0; //@line 6122
 SAFE_HEAP_STORE($67 | 0, SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($67 + 4 | 0, SAFE_HEAP_LOAD($18 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($67 + 8 | 0, SAFE_HEAP_LOAD($18 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($67 + 12 | 0, SAFE_HEAP_LOAD($18 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $68 = $17; //@line 6124
 $69 = $10; //@line 6125
 $70 = $69 + 40 | 0; //@line 6126
 SAFE_HEAP_STORE_D($70 | 0, +$68, 8);
 STACKTOP = sp; //@line 6128
 return;
}
function _CircleSegmentQuery($0, $1, $2, $3, $4, $5, $6) {
 $0 = $0 | 0; //@line 4649
 $1 = $1 | 0; //@line 4650
 $2 = +$2; //@line 4651
 $3 = $3 | 0; //@line 4652
 $4 = $4 | 0; //@line 4653
 $5 = +$5; //@line 4654
 $6 = $6 | 0; //@line 4655
 var $$byval_copy = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy14 = 0, $$byval_copy15 = 0, $$byval_copy16 = 0, $$byval_copy17 = 0, $$byval_copy18 = 0, $$byval_copy19 = 0, $$byval_copy2 = 0, $$byval_copy20 = 0, $$byval_copy21 = 0, $$byval_copy22 = 0, $$byval_copy23 = 0, $$byval_copy24 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0; //@line 4656
 var $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0.0, $24 = 0.0, $25 = 0.0; //@line 4657
 var $26 = 0.0, $27 = 0.0, $28 = 0.0, $29 = 0.0, $30 = 0.0, $31 = 0.0, $32 = 0.0, $33 = 0.0, $34 = 0.0, $35 = 0.0, $36 = 0.0, $37 = 0.0, $38 = 0.0, $39 = 0.0, $40 = 0.0, $41 = 0.0, $42 = 0.0, $43 = 0.0, $44 = 0.0, $45 = 0.0;
 var $46 = 0.0, $47 = 0, $48 = 0.0, $49 = 0.0, $50 = 0.0, $51 = 0.0, $52 = 0.0, $53 = 0.0, $54 = 0.0, $55 = 0.0, $56 = 0, $57 = 0.0, $58 = 0, $59 = 0.0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0.0, $65 = 0.0;
 var $66 = 0, $67 = 0, $68 = 0.0, $69 = 0, $7 = 0, $70 = 0, $8 = 0.0, $9 = 0.0, $or$cond = 0, label = 0, sp = 0; //@line 4660
 sp = STACKTOP; //@line 4661
 STACKTOP = STACKTOP + 560 | 0; //@line 4662
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(560 | 0); //@line 4662
 $$byval_copy24 = sp + 536 | 0; //@line 4663
 $$byval_copy23 = sp + 520 | 0; //@line 4664
 $$byval_copy22 = sp + 504 | 0; //@line 4665
 $$byval_copy21 = sp + 488 | 0; //@line 4666
 $$byval_copy20 = sp + 472 | 0; //@line 4667
 $$byval_copy19 = sp + 456 | 0; //@line 4668
 $$byval_copy18 = sp + 440 | 0; //@line 4669
 $$byval_copy17 = sp + 424 | 0; //@line 4670
 $$byval_copy16 = sp + 408 | 0; //@line 4671
 $$byval_copy15 = sp + 392 | 0; //@line 4672
 $$byval_copy14 = sp + 376 | 0; //@line 4673
 $$byval_copy13 = sp + 360 | 0; //@line 4674
 $$byval_copy12 = sp + 344 | 0; //@line 4675
 $$byval_copy11 = sp + 328 | 0; //@line 4676
 $$byval_copy10 = sp + 312 | 0; //@line 4677
 $$byval_copy9 = sp + 296 | 0; //@line 4678
 $$byval_copy8 = sp + 280 | 0; //@line 4679
 $$byval_copy7 = sp + 264 | 0; //@line 4680
 $$byval_copy6 = sp + 248 | 0; //@line 4681
 $$byval_copy5 = sp + 232 | 0; //@line 4682
 $$byval_copy4 = sp + 216 | 0; //@line 4683
 $$byval_copy3 = sp + 200 | 0; //@line 4684
 $$byval_copy2 = sp + 184 | 0; //@line 4685
 $$byval_copy = sp + 168 | 0; //@line 4686
 $11 = sp + 136 | 0; //@line 4687
 $12 = sp + 120 | 0; //@line 4688
 $18 = sp + 64 | 0; //@line 4689
 $19 = sp + 48 | 0; //@line 4690
 $20 = sp + 32 | 0; //@line 4691
 $21 = sp + 16 | 0; //@line 4692
 $22 = sp; //@line 4693
 $7 = $0; //@line 4694
 $8 = $2; //@line 4695
 $9 = $5; //@line 4696
 $10 = $6; //@line 4697
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_266($11, $$byval_copy, $$byval_copy2); //@line 4700
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_266($12, $$byval_copy3, $$byval_copy4); //@line 4703
 $23 = $8; //@line 4704
 $24 = $9; //@line 4705
 $25 = $23 + $24; //@line 4706
 $13 = $25; //@line 4707
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $26 = +_cpvdot_272($$byval_copy5, $$byval_copy6); //@line 4710
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $27 = +_cpvdot_272($$byval_copy7, $$byval_copy8); //@line 4713
 $28 = 2.0 * $27; //@line 4714
 $29 = $26 - $28; //@line 4715
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $30 = +_cpvdot_272($$byval_copy9, $$byval_copy10); //@line 4718
 $31 = $29 + $30; //@line 4719
 $14 = $31; //@line 4720
 SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $32 = +_cpvdot_272($$byval_copy11, $$byval_copy12); //@line 4723
 SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $33 = +_cpvdot_272($$byval_copy13, $$byval_copy14); //@line 4726
 $34 = $32 - $33; //@line 4727
 $15 = $34; //@line 4728
 $35 = $15; //@line 4729
 $36 = $15; //@line 4730
 $37 = $35 * $36; //@line 4731
 $38 = $14; //@line 4732
 SAFE_HEAP_STORE($$byval_copy15 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy15 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy15 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy15 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy16 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy16 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy16 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy16 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $39 = +_cpvdot_272($$byval_copy15, $$byval_copy16); //@line 4735
 $40 = $13; //@line 4736
 $41 = $13; //@line 4737
 $42 = $40 * $41; //@line 4738
 $43 = $39 - $42; //@line 4739
 $44 = $38 * $43; //@line 4740
 $45 = $37 - $44; //@line 4741
 $16 = $45; //@line 4742
 $46 = $16; //@line 4743
 $47 = $46 >= 0.0; //@line 4744
 if (!$47) {
  STACKTOP = sp; //@line 4746
  return;
 }
 $48 = $15; //@line 4748
 $49 = -$48; //@line 4749
 $50 = $16; //@line 4750
 $51 = +Math_sqrt(+$50); //@line 4751
 $52 = $49 - $51; //@line 4752
 $53 = $14; //@line 4753
 $54 = $52 / $53; //@line 4754
 $17 = $54; //@line 4755
 $55 = $17; //@line 4756
 $56 = 0.0 <= $55; //@line 4757
 $57 = $17; //@line 4758
 $58 = $57 <= 1.0; //@line 4759
 $or$cond = $56 & $58; //@line 4760
 if (!$or$cond) {
  STACKTOP = sp; //@line 4762
  return;
 }
 $59 = $17; //@line 4764
 SAFE_HEAP_STORE($$byval_copy17 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy17 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy17 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy17 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy18 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy18 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy18 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy18 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvlerp_273($19, $$byval_copy17, $$byval_copy18, $59); //@line 4767
 SAFE_HEAP_STORE($$byval_copy19 | 0, SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy19 + 4 | 0, SAFE_HEAP_LOAD($19 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy19 + 8 | 0, SAFE_HEAP_LOAD($19 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy19 + 12 | 0, SAFE_HEAP_LOAD($19 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvnormalize_268($18, $$byval_copy19); //@line 4769
 $60 = $7; //@line 4770
 $61 = $10; //@line 4771
 SAFE_HEAP_STORE($61 | 0, $60 | 0, 4);
 $62 = $10; //@line 4773
 $63 = $62 + 8 | 0; //@line 4774
 $64 = $17; //@line 4775
 SAFE_HEAP_STORE($$byval_copy20 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy20 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy20 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy20 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy21 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy21 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy21 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy21 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvlerp_273($20, $$byval_copy20, $$byval_copy21, $64); //@line 4778
 $65 = $9; //@line 4779
 SAFE_HEAP_STORE($$byval_copy22 | 0, SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy22 + 4 | 0, SAFE_HEAP_LOAD($18 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy22 + 8 | 0, SAFE_HEAP_LOAD($18 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy22 + 12 | 0, SAFE_HEAP_LOAD($18 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_270($21, $$byval_copy22, $65); //@line 4781
 SAFE_HEAP_STORE($$byval_copy23 | 0, SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy23 + 4 | 0, SAFE_HEAP_LOAD($20 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy23 + 8 | 0, SAFE_HEAP_LOAD($20 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy23 + 12 | 0, SAFE_HEAP_LOAD($20 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy24 | 0, SAFE_HEAP_LOAD($21 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy24 + 4 | 0, SAFE_HEAP_LOAD($21 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy24 + 8 | 0, SAFE_HEAP_LOAD($21 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy24 + 12 | 0, SAFE_HEAP_LOAD($21 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_266($22, $$byval_copy23, $$byval_copy24); //@line 4784
 SAFE_HEAP_STORE($63 | 0, SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($63 + 4 | 0, SAFE_HEAP_LOAD($22 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($63 + 8 | 0, SAFE_HEAP_LOAD($22 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($63 + 12 | 0, SAFE_HEAP_LOAD($22 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $66 = $10; //@line 4786
 $67 = $66 + 24 | 0; //@line 4787
 SAFE_HEAP_STORE($67 | 0, SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($67 + 4 | 0, SAFE_HEAP_LOAD($18 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($67 + 8 | 0, SAFE_HEAP_LOAD($18 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($67 + 12 | 0, SAFE_HEAP_LOAD($18 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $68 = $17; //@line 4789
 $69 = $10; //@line 4790
 $70 = $69 + 40 | 0; //@line 4791
 SAFE_HEAP_STORE_D($70 | 0, +$68, 8);
 STACKTOP = sp; //@line 4793
 return;
}
function _cpPolyShapePointQuery($0, $1, $2) {
 $0 = $0 | 0; //@line 4220
 $1 = $1 | 0; //@line 4221
 $2 = $2 | 0; //@line 4222
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy14 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0; //@line 4223
 var $15 = 0, $16 = 0, $17 = 0.0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0.0, $32 = 0, $33 = 0; //@line 4224
 var $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0.0, $5 = 0, $50 = 0, $51 = 0; //@line 4225
 var $52 = 0, $53 = 0, $54 = 0.0, $55 = 0.0, $56 = 0.0, $57 = 0, $58 = 0.0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0.0, $69 = 0.0, $7 = 0.0; //@line 4226
 var $70 = 0.0, $71 = 0.0, $72 = 0.0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0.0, $78 = 0.0, $79 = 0.0, $8 = 0, $80 = 0.0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0.0, $86 = 0, $9 = 0.0, label = 0;
 var sp = 0; //@line 4228
 sp = STACKTOP; //@line 4229
 STACKTOP = STACKTOP + 464 | 0; //@line 4230
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(464 | 0); //@line 4230
 $$byval_copy14 = sp + 416 | 0; //@line 4231
 $$byval_copy13 = sp + 400 | 0; //@line 4232
 $$byval_copy12 = sp + 384 | 0; //@line 4233
 $$byval_copy11 = sp + 368 | 0; //@line 4234
 $$byval_copy10 = sp + 352 | 0; //@line 4235
 $$byval_copy9 = sp + 336 | 0; //@line 4236
 $$byval_copy8 = sp + 320 | 0; //@line 4237
 $$byval_copy7 = sp + 304 | 0; //@line 4238
 $$byval_copy6 = sp + 288 | 0; //@line 4239
 $$byval_copy5 = sp + 272 | 0; //@line 4240
 $$byval_copy4 = sp + 256 | 0; //@line 4241
 $$byval_copy3 = sp + 240 | 0; //@line 4242
 $$byval_copy2 = sp + 224 | 0; //@line 4243
 $$byval_copy1 = sp + 208 | 0; //@line 4244
 $$byval_copy = sp + 192 | 0; //@line 4245
 $8 = sp + 168 | 0; //@line 4246
 $10 = sp + 144 | 0; //@line 4247
 $11 = sp + 128 | 0; //@line 4248
 $14 = sp + 112 | 0; //@line 4249
 $15 = sp + 96 | 0; //@line 4250
 $16 = sp + 80 | 0; //@line 4251
 $19 = sp + 48 | 0; //@line 4252
 $20 = sp + 32 | 0; //@line 4253
 $21 = sp + 16 | 0; //@line 4254
 $22 = sp; //@line 4255
 $3 = $0; //@line 4256
 $4 = $2; //@line 4257
 $23 = $3; //@line 4258
 $24 = $23 + 168 | 0; //@line 4259
 $25 = SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0; //@line 4260
 $5 = $25; //@line 4261
 $26 = $3; //@line 4262
 $27 = $26 + 172 | 0; //@line 4263
 $28 = SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0; //@line 4264
 $6 = $28; //@line 4265
 $29 = $3; //@line 4266
 $30 = $29 + 160 | 0; //@line 4267
 $31 = +(+SAFE_HEAP_LOAD_D($30 | 0, 8)); //@line 4268
 $7 = $31; //@line 4269
 $32 = $6; //@line 4270
 $33 = $5; //@line 4271
 $34 = $33 - 1 | 0; //@line 4272
 $35 = $32 + ($34 << 5) | 0; //@line 4273
 SAFE_HEAP_STORE($8 | 0, SAFE_HEAP_LOAD($35 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 4 | 0, SAFE_HEAP_LOAD($35 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 8 | 0, SAFE_HEAP_LOAD($35 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 12 | 0, SAFE_HEAP_LOAD($35 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $9 = inf; //@line 4275
 SAFE_HEAP_STORE($10 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $12 = 0; //@line 4278
 $13 = 0; //@line 4279
 while (1) {
  $36 = $13; //@line 4281
  $37 = $5; //@line 4282
  $38 = ($36 | 0) < ($37 | 0); //@line 4283
  if (!$38) {
   break;
  }
  $39 = $6; //@line 4287
  $40 = $13; //@line 4288
  $41 = $39 + ($40 << 5) | 0; //@line 4289
  SAFE_HEAP_STORE($14 | 0, SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($14 + 4 | 0, SAFE_HEAP_LOAD($41 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($14 + 8 | 0, SAFE_HEAP_LOAD($41 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($14 + 12 | 0, SAFE_HEAP_LOAD($41 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $42 = $12; //@line 4291
  $43 = $42 & 255; //@line 4292
  $44 = ($43 | 0) != 0; //@line 4293
  if ($44) {
   $52 = 1; //@line 4295
  } else {
   $45 = $6; //@line 4297
   $46 = $13; //@line 4298
   $47 = $45 + ($46 << 5) | 0; //@line 4299
   $48 = $47 + 16 | 0; //@line 4300
   SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   _cpvsub_266($15, $$byval_copy, $$byval_copy1); //@line 4303
   SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($48 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($48 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($48 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($48 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($15 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($15 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($15 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   $49 = +_cpvdot_272($$byval_copy2, $$byval_copy3); //@line 4306
   $50 = $49 > 0.0; //@line 4307
   $52 = $50; //@line 4308
  }
  $51 = $52 & 1; //@line 4310
  $53 = $51 & 255; //@line 4311
  $12 = $53; //@line 4312
  SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpClosetPointOnSegment($16, $$byval_copy4, $$byval_copy5, $$byval_copy6); //@line 4316
  SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($16 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($16 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($16 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $54 = +_cpvdist_277($$byval_copy7, $$byval_copy8); //@line 4319
  $17 = $54; //@line 4320
  $55 = $17; //@line 4321
  $56 = $9; //@line 4322
  $57 = $55 < $56; //@line 4323
  if ($57) {
   $58 = $17; //@line 4325
   $9 = $58; //@line 4326
   SAFE_HEAP_STORE($10 | 0, SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($10 + 4 | 0, SAFE_HEAP_LOAD($16 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($10 + 8 | 0, SAFE_HEAP_LOAD($16 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($10 + 12 | 0, SAFE_HEAP_LOAD($16 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   $59 = $6; //@line 4328
   $60 = $13; //@line 4329
   $61 = $59 + ($60 << 5) | 0; //@line 4330
   $62 = $61 + 16 | 0; //@line 4331
   SAFE_HEAP_STORE($11 | 0, SAFE_HEAP_LOAD($62 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($11 + 4 | 0, SAFE_HEAP_LOAD($62 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($11 + 8 | 0, SAFE_HEAP_LOAD($62 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($11 + 12 | 0, SAFE_HEAP_LOAD($62 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  }
  SAFE_HEAP_STORE($8 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($8 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($8 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($8 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $63 = $13; //@line 4335
  $64 = $63 + 1 | 0; //@line 4336
  $13 = $64; //@line 4337
 }
 $65 = $12; //@line 4339
 $66 = $65 & 255; //@line 4340
 $67 = ($66 | 0) != 0; //@line 4341
 $68 = $9; //@line 4342
 $69 = -$68; //@line 4343
 $70 = $67 ? $68 : $69; //@line 4344
 $18 = $70; //@line 4345
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_266($20, $$byval_copy9, $$byval_copy10); //@line 4348
 $71 = $18; //@line 4349
 $72 = 1.0 / $71; //@line 4350
 SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($20 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($20 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($20 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_270($19, $$byval_copy11, $72); //@line 4352
 $73 = $3; //@line 4353
 $74 = $4; //@line 4354
 SAFE_HEAP_STORE($74 | 0, $73 | 0, 4);
 $75 = $4; //@line 4356
 $76 = $75 + 8 | 0; //@line 4357
 $77 = $7; //@line 4358
 SAFE_HEAP_STORE($$byval_copy12 | 0, SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 4 | 0, SAFE_HEAP_LOAD($19 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 8 | 0, SAFE_HEAP_LOAD($19 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 12 | 0, SAFE_HEAP_LOAD($19 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_270($21, $$byval_copy12, $77); //@line 4360
 SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 | 0, SAFE_HEAP_LOAD($21 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 4 | 0, SAFE_HEAP_LOAD($21 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 8 | 0, SAFE_HEAP_LOAD($21 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 12 | 0, SAFE_HEAP_LOAD($21 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_276($22, $$byval_copy13, $$byval_copy14); //@line 4363
 SAFE_HEAP_STORE($76 | 0, SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($76 + 4 | 0, SAFE_HEAP_LOAD($22 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($76 + 8 | 0, SAFE_HEAP_LOAD($22 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($76 + 12 | 0, SAFE_HEAP_LOAD($22 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $78 = $18; //@line 4365
 $79 = $7; //@line 4366
 $80 = $78 - $79; //@line 4367
 $81 = $4; //@line 4368
 $82 = $81 + 24 | 0; //@line 4369
 SAFE_HEAP_STORE_D($82 | 0, +$80, 8);
 $83 = $4; //@line 4371
 $84 = $83 + 32 | 0; //@line 4372
 $85 = $9; //@line 4373
 $86 = $85 > 1.0e-5; //@line 4374
 if ($86) {
  SAFE_HEAP_STORE($84 | 0, SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($84 + 4 | 0, SAFE_HEAP_LOAD($19 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($84 + 8 | 0, SAFE_HEAP_LOAD($19 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($84 + 12 | 0, SAFE_HEAP_LOAD($19 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  STACKTOP = sp; //@line 4377
  return;
 } else {
  SAFE_HEAP_STORE($84 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($84 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($84 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($84 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  STACKTOP = sp; //@line 4380
  return;
 }
}
function _cpSpaceProcessComponents($0, $1) {
 $0 = $0 | 0; //@line 2550
 $1 = +$1; //@line 2551
 var $$byval_copy = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0.0, $104 = 0.0, $105 = 0.0, $106 = 0, $107 = 0, $108 = 0, $109 = 0.0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0; //@line 2552
 var $117 = 0, $118 = 0, $119 = 0, $12 = 0.0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0; //@line 2553
 var $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0; //@line 2554
 var $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0; //@line 2555
 var $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0; //@line 2556
 var $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $2 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0.0, $206 = 0; //@line 2557
 var $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0; //@line 2558
 var $225 = 0, $226 = 0, $227 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0.0, $3 = 0.0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0; //@line 2559
 var $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0; //@line 2560
 var $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0.0, $62 = 0.0, $63 = 0, $64 = 0.0, $65 = 0.0, $66 = 0.0, $67 = 0, $68 = 0, $69 = 0.0, $7 = 0, $70 = 0.0, $71 = 0.0, $72 = 0.0, $73 = 0.0, $74 = 0.0; //@line 2561
 var $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0.0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0.0, $89 = 0, $9 = 0.0, $90 = 0, $91 = 0, $92 = 0.0; //@line 2562
 var $93 = 0.0, $94 = 0.0, $95 = 0.0, $96 = 0, $97 = 0.0, $98 = 0.0, $99 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0;
 sp = STACKTOP; //@line 2564
 STACKTOP = STACKTOP + 160 | 0; //@line 2565
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(160 | 0); //@line 2565
 $$byval_copy = sp + 48 | 0; //@line 2566
 $vararg_buffer1 = sp + 40 | 0; //@line 2567
 $vararg_buffer = sp + 32 | 0; //@line 2568
 $2 = $0; //@line 2569
 $3 = $1; //@line 2570
 $27 = $2; //@line 2571
 $28 = $27 + 40 | 0; //@line 2572
 $29 = +(+SAFE_HEAP_LOAD_D($28 | 0, 8)); //@line 2573
 $30 = $29 != inf; //@line 2574
 $31 = $30 & 1; //@line 2575
 $32 = $31 & 255; //@line 2576
 $4 = $32; //@line 2577
 $33 = $2; //@line 2578
 $34 = $33 + 88 | 0; //@line 2579
 $35 = SAFE_HEAP_LOAD($34 | 0, 4, 0) | 0 | 0; //@line 2580
 $5 = $35; //@line 2581
 $6 = 0; //@line 2582
 while (1) {
  $36 = $6; //@line 2584
  $37 = $5; //@line 2585
  $38 = SAFE_HEAP_LOAD($37 | 0, 4, 0) | 0 | 0; //@line 2586
  $39 = ($36 | 0) < ($38 | 0); //@line 2587
  if (!$39) {
   label = 8; //@line 2589
   break;
  }
  $40 = $5; //@line 2592
  $41 = $40 + 8 | 0; //@line 2593
  $42 = SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0; //@line 2594
  $43 = $6; //@line 2595
  $44 = $42 + ($43 << 2) | 0; //@line 2596
  $45 = SAFE_HEAP_LOAD($44 | 0, 4, 0) | 0 | 0; //@line 2597
  $7 = $45; //@line 2598
  $46 = $7; //@line 2599
  $47 = $46 + 224 | 0; //@line 2600
  $48 = $47 + 4 | 0; //@line 2601
  $49 = SAFE_HEAP_LOAD($48 | 0, 4, 0) | 0 | 0; //@line 2602
  $50 = ($49 | 0) == (0 | 0); //@line 2603
  if (!$50) {
   label = 4; //@line 2605
   break;
  }
  $51 = $7; //@line 2608
  $52 = $51 + 224 | 0; //@line 2609
  $53 = SAFE_HEAP_LOAD($52 | 0, 4, 0) | 0 | 0; //@line 2610
  $54 = ($53 | 0) == (0 | 0); //@line 2611
  if (!$54) {
   label = 6; //@line 2613
   break;
  }
  $55 = $6; //@line 2616
  $56 = $55 + 1 | 0; //@line 2617
  $6 = $56; //@line 2618
 }
 if ((label | 0) == 4) {
  _cpMessage(8317, 7878, 230, 1, 0, 8345, $vararg_buffer); //@line 2621
  _abort(); //@line 2622
 } else if ((label | 0) == 6) {
  _cpMessage(8410, 7878, 231, 1, 0, 8438, $vararg_buffer1); //@line 2626
  _abort(); //@line 2627
 } else if ((label | 0) == 8) {
  $57 = $4; //@line 2631
  $58 = $57 << 24 >> 24 != 0; //@line 2632
  L8 : do {
   if ($58) {
    $59 = $2; //@line 2635
    $60 = $59 + 32 | 0; //@line 2636
    $61 = +(+SAFE_HEAP_LOAD_D($60 | 0, 8)); //@line 2637
    $8 = $61; //@line 2638
    $62 = $8; //@line 2639
    $63 = $62 != 0.0; //@line 2640
    if ($63) {
     $64 = $8; //@line 2642
     $65 = $8; //@line 2643
     $66 = $64 * $65; //@line 2644
     $74 = $66; //@line 2645
    } else {
     $67 = $2; //@line 2647
     $68 = $67 + 8 | 0; //@line 2648
     SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($68 | 0, 4, 0) | 0 | 0 | 0, 4);
     SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($68 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
     SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($68 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
     SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($68 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
     $69 = +_cpvlengthsq_498($$byval_copy); //@line 2650
     $70 = $3; //@line 2651
     $71 = $69 * $70; //@line 2652
     $72 = $3; //@line 2653
     $73 = $71 * $72; //@line 2654
     $74 = $73; //@line 2655
    }
    $9 = $74; //@line 2657
    $10 = 0; //@line 2658
    while (1) {
     $75 = $10; //@line 2660
     $76 = $5; //@line 2661
     $77 = SAFE_HEAP_LOAD($76 | 0, 4, 0) | 0 | 0; //@line 2662
     $78 = ($75 | 0) < ($77 | 0); //@line 2663
     if (!$78) {
      break L8;
     }
     $79 = $5; //@line 2667
     $80 = $79 + 8 | 0; //@line 2668
     $81 = SAFE_HEAP_LOAD($80 | 0, 4, 0) | 0 | 0; //@line 2669
     $82 = $10; //@line 2670
     $83 = $81 + ($82 << 2) | 0; //@line 2671
     $84 = SAFE_HEAP_LOAD($83 | 0, 4, 0) | 0 | 0; //@line 2672
     $11 = $84; //@line 2673
     $85 = $11; //@line 2674
     $86 = _cpBodyGetType($85) | 0; //@line 2675
     $87 = ($86 | 0) != 0; //@line 2676
     if (!$87) {
      $88 = $9; //@line 2678
      $89 = $88 != 0.0; //@line 2679
      if ($89) {
       $90 = $11; //@line 2681
       $91 = $90 + 8 | 0; //@line 2682
       $92 = +(+SAFE_HEAP_LOAD_D($91 | 0, 8)); //@line 2683
       $93 = $9; //@line 2684
       $94 = $92 * $93; //@line 2685
       $95 = $94; //@line 2686
      } else {
       $95 = 0.0; //@line 2688
      }
      $12 = $95; //@line 2690
      $96 = $11; //@line 2691
      $97 = +_cpBodyKineticEnergy($96); //@line 2692
      $98 = $12; //@line 2693
      $99 = $97 > $98; //@line 2694
      if ($99) {
       $109 = 0.0; //@line 2696
      } else {
       $100 = $11; //@line 2698
       $101 = $100 + 224 | 0; //@line 2699
       $102 = $101 + 8 | 0; //@line 2700
       $103 = +(+SAFE_HEAP_LOAD_D($102 | 0, 8)); //@line 2701
       $104 = $3; //@line 2702
       $105 = $103 + $104; //@line 2703
       $109 = $105; //@line 2704
      }
      $106 = $11; //@line 2706
      $107 = $106 + 224 | 0; //@line 2707
      $108 = $107 + 8 | 0; //@line 2708
      SAFE_HEAP_STORE_D($108 | 0, +$109, 8);
     }
     $110 = $10; //@line 2711
     $111 = $110 + 1 | 0; //@line 2712
     $10 = $111; //@line 2713
    }
   }
  } while (0);
  $112 = $2; //@line 2717
  $113 = $112 + 120 | 0; //@line 2718
  $114 = SAFE_HEAP_LOAD($113 | 0, 4, 0) | 0 | 0; //@line 2719
  $13 = $114; //@line 2720
  $14 = 0; //@line 2721
  $115 = $13; //@line 2722
  $116 = SAFE_HEAP_LOAD($115 | 0, 4, 0) | 0 | 0; //@line 2723
  $15 = $116; //@line 2724
  while (1) {
   $117 = $14; //@line 2726
   $118 = $15; //@line 2727
   $119 = ($117 | 0) < ($118 | 0); //@line 2728
   if (!$119) {
    break;
   }
   $120 = $13; //@line 2732
   $121 = $120 + 8 | 0; //@line 2733
   $122 = SAFE_HEAP_LOAD($121 | 0, 4, 0) | 0 | 0; //@line 2734
   $123 = $14; //@line 2735
   $124 = $122 + ($123 << 2) | 0; //@line 2736
   $125 = SAFE_HEAP_LOAD($124 | 0, 4, 0) | 0 | 0; //@line 2737
   $16 = $125; //@line 2738
   $126 = $16; //@line 2739
   $127 = $126 + 44 | 0; //@line 2740
   $128 = SAFE_HEAP_LOAD($127 | 0, 4, 0) | 0 | 0; //@line 2741
   $17 = $128; //@line 2742
   $129 = $16; //@line 2743
   $130 = $129 + 48 | 0; //@line 2744
   $131 = SAFE_HEAP_LOAD($130 | 0, 4, 0) | 0 | 0; //@line 2745
   $18 = $131; //@line 2746
   $132 = $4; //@line 2747
   $133 = $132 << 24 >> 24 != 0; //@line 2748
   do {
    if ($133) {
     $134 = $18; //@line 2751
     $135 = _cpBodyGetType($134) | 0; //@line 2752
     $136 = ($135 | 0) == 1; //@line 2753
     if ($136) {
      label = 26; //@line 2755
     } else {
      $137 = $17; //@line 2757
      $138 = _cpBodyIsSleeping($137) | 0; //@line 2758
      $139 = $138 & 255; //@line 2759
      $140 = ($139 | 0) != 0; //@line 2760
      if ($140) {
       label = 26; //@line 2762
      }
     }
     if ((label | 0) == 26) {
      label = 0; //@line 2766
      $141 = $17; //@line 2767
      _cpBodyActivate($141); //@line 2768
     }
     $142 = $17; //@line 2770
     $143 = _cpBodyGetType($142) | 0; //@line 2771
     $144 = ($143 | 0) == 1; //@line 2772
     if (!$144) {
      $145 = $18; //@line 2774
      $146 = _cpBodyIsSleeping($145) | 0; //@line 2775
      $147 = $146 & 255; //@line 2776
      $148 = ($147 | 0) != 0; //@line 2777
      if (!$148) {
       break;
      }
     }
     $149 = $18; //@line 2782
     _cpBodyActivate($149); //@line 2783
    }
   } while (0);
   $150 = $17; //@line 2786
   $151 = $16; //@line 2787
   _cpBodyPushArbiter($150, $151); //@line 2788
   $152 = $18; //@line 2789
   $153 = $16; //@line 2790
   _cpBodyPushArbiter($152, $153); //@line 2791
   $154 = $14; //@line 2792
   $155 = $154 + 1 | 0; //@line 2793
   $14 = $155; //@line 2794
  }
  $156 = $4; //@line 2796
  $157 = $156 << 24 >> 24 != 0; //@line 2797
  if (!$157) {
   STACKTOP = sp; //@line 2799
   return;
  }
  $158 = $2; //@line 2801
  $159 = $158 + 116 | 0; //@line 2802
  $160 = SAFE_HEAP_LOAD($159 | 0, 4, 0) | 0 | 0; //@line 2803
  $19 = $160; //@line 2804
  $20 = 0; //@line 2805
  while (1) {
   $161 = $20; //@line 2807
   $162 = $19; //@line 2808
   $163 = SAFE_HEAP_LOAD($162 | 0, 4, 0) | 0 | 0; //@line 2809
   $164 = ($161 | 0) < ($163 | 0); //@line 2810
   if (!$164) {
    break;
   }
   $165 = $19; //@line 2814
   $166 = $165 + 8 | 0; //@line 2815
   $167 = SAFE_HEAP_LOAD($166 | 0, 4, 0) | 0 | 0; //@line 2816
   $168 = $20; //@line 2817
   $169 = $167 + ($168 << 2) | 0; //@line 2818
   $170 = SAFE_HEAP_LOAD($169 | 0, 4, 0) | 0 | 0; //@line 2819
   $21 = $170; //@line 2820
   $171 = $21; //@line 2821
   $172 = $171 + 8 | 0; //@line 2822
   $173 = SAFE_HEAP_LOAD($172 | 0, 4, 0) | 0 | 0; //@line 2823
   $22 = $173; //@line 2824
   $174 = $21; //@line 2825
   $175 = $174 + 12 | 0; //@line 2826
   $176 = SAFE_HEAP_LOAD($175 | 0, 4, 0) | 0 | 0; //@line 2827
   $23 = $176; //@line 2828
   $177 = $23; //@line 2829
   $178 = _cpBodyGetType($177) | 0; //@line 2830
   $179 = ($178 | 0) == 1; //@line 2831
   if ($179) {
    $180 = $22; //@line 2833
    _cpBodyActivate($180); //@line 2834
   }
   $181 = $22; //@line 2836
   $182 = _cpBodyGetType($181) | 0; //@line 2837
   $183 = ($182 | 0) == 1; //@line 2838
   if ($183) {
    $184 = $23; //@line 2840
    _cpBodyActivate($184); //@line 2841
   }
   $185 = $20; //@line 2843
   $186 = $185 + 1 | 0; //@line 2844
   $20 = $186; //@line 2845
  }
  $24 = 0; //@line 2847
  while (1) {
   $187 = $24; //@line 2849
   $188 = $5; //@line 2850
   $189 = SAFE_HEAP_LOAD($188 | 0, 4, 0) | 0 | 0; //@line 2851
   $190 = ($187 | 0) < ($189 | 0); //@line 2852
   if (!$190) {
    break;
   }
   $191 = $5; //@line 2856
   $192 = $191 + 8 | 0; //@line 2857
   $193 = SAFE_HEAP_LOAD($192 | 0, 4, 0) | 0 | 0; //@line 2858
   $194 = $24; //@line 2859
   $195 = $193 + ($194 << 2) | 0; //@line 2860
   $196 = SAFE_HEAP_LOAD($195 | 0, 4, 0) | 0 | 0; //@line 2861
   $25 = $196; //@line 2862
   $197 = $25; //@line 2863
   $198 = _ComponentRoot($197) | 0; //@line 2864
   $199 = ($198 | 0) == (0 | 0); //@line 2865
   if ($199) {
    $200 = $25; //@line 2867
    $201 = $25; //@line 2868
    _FloodFillComponent($200, $201); //@line 2869
    $202 = $25; //@line 2870
    $203 = $2; //@line 2871
    $204 = $203 + 40 | 0; //@line 2872
    $205 = +(+SAFE_HEAP_LOAD_D($204 | 0, 8)); //@line 2873
    $206 = _ComponentActive($202, $205) | 0; //@line 2874
    $207 = $206 << 24 >> 24 != 0; //@line 2875
    if (!$207) {
     $208 = $2; //@line 2877
     $209 = $208 + 100 | 0; //@line 2878
     $210 = SAFE_HEAP_LOAD($209 | 0, 4, 0) | 0 | 0; //@line 2879
     $211 = $25; //@line 2880
     _cpArrayPush($210, $211); //@line 2881
     $212 = $25; //@line 2882
     $26 = $212; //@line 2883
     while (1) {
      $213 = $26; //@line 2885
      $214 = ($213 | 0) != (0 | 0); //@line 2886
      if (!$214) {
       break;
      }
      $215 = $2; //@line 2890
      $216 = $26; //@line 2891
      _cpSpaceDeactivateBody($215, $216); //@line 2892
      $217 = $26; //@line 2893
      $218 = $217 + 224 | 0; //@line 2894
      $219 = $218 + 4 | 0; //@line 2895
      $220 = SAFE_HEAP_LOAD($219 | 0, 4, 0) | 0 | 0; //@line 2896
      $26 = $220; //@line 2897
     }
     continue;
    }
   }
   $221 = $24; //@line 2902
   $222 = $221 + 1 | 0; //@line 2903
   $24 = $222; //@line 2904
   $223 = $25; //@line 2905
   $224 = $223 + 224 | 0; //@line 2906
   SAFE_HEAP_STORE($224 | 0, 0 | 0, 4);
   $225 = $25; //@line 2908
   $226 = $225 + 224 | 0; //@line 2909
   $227 = $226 + 4 | 0; //@line 2910
   SAFE_HEAP_STORE($227 | 0, 0 | 0, 4);
  }
  STACKTOP = sp; //@line 2913
  return;
 }
}
function _GJK($0, $1, $2) {
 $0 = $0 | 0; //@line 1
 $1 = $1 | 0; //@line 2
 $2 = $2 | 0; //@line 3
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0; //@line 4
 var $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0; //@line 5
 var $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0; //@line 6
 var $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 7
 sp = STACKTOP; //@line 8
 STACKTOP = STACKTOP + 960 | 0; //@line 9
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(960 | 0); //@line 9
 $$byval_copy13 = sp + 888 | 0; //@line 10
 $$byval_copy12 = sp + 832 | 0; //@line 11
 $$byval_copy11 = sp + 816 | 0; //@line 12
 $$byval_copy10 = sp + 800 | 0; //@line 13
 $$byval_copy9 = sp + 784 | 0; //@line 14
 $$byval_copy8 = sp + 768 | 0; //@line 15
 $$byval_copy7 = sp + 752 | 0; //@line 16
 $$byval_copy6 = sp + 736 | 0; //@line 17
 $$byval_copy5 = sp + 704 | 0; //@line 18
 $$byval_copy4 = sp + 672 | 0; //@line 19
 $$byval_copy3 = sp + 648 | 0; //@line 20
 $$byval_copy2 = sp + 624 | 0; //@line 21
 $$byval_copy1 = sp + 600 | 0; //@line 22
 $$byval_copy = sp + 576 | 0; //@line 23
 $5 = sp + 520 | 0; //@line 24
 $6 = sp + 464 | 0; //@line 25
 $7 = sp + 440 | 0; //@line 26
 $8 = sp + 416 | 0; //@line 27
 $9 = sp + 360 | 0; //@line 28
 $10 = sp + 336 | 0; //@line 29
 $11 = sp + 312 | 0; //@line 30
 $12 = sp + 256 | 0; //@line 31
 $13 = sp + 240 | 0; //@line 32
 $14 = sp + 224 | 0; //@line 33
 $15 = sp + 208 | 0; //@line 34
 $16 = sp + 192 | 0; //@line 35
 $17 = sp + 136 | 0; //@line 36
 $18 = sp + 120 | 0; //@line 37
 $19 = sp + 64 | 0; //@line 38
 $20 = sp; //@line 39
 $3 = $1; //@line 40
 $4 = $2; //@line 41
 $21 = $4; //@line 42
 $22 = SAFE_HEAP_LOAD($21 | 0, 4, 0) | 0 | 0; //@line 43
 $23 = ($22 | 0) != 0; //@line 44
 $24 = $3; //@line 45
 $25 = SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0; //@line 46
 if ($23) {
  $26 = $4; //@line 48
  $27 = SAFE_HEAP_LOAD($26 | 0, 4, 0) | 0 | 0; //@line 49
  $28 = $27 >>> 24; //@line 50
  $29 = $28 & 255; //@line 51
  _ShapePoint($7, $25, $29); //@line 52
  $30 = $3; //@line 53
  $31 = $30 + 4 | 0; //@line 54
  $32 = SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0; //@line 55
  $33 = $4; //@line 56
  $34 = SAFE_HEAP_LOAD($33 | 0, 4, 0) | 0 | 0; //@line 57
  $35 = $34 >>> 16; //@line 58
  $36 = $35 & 255; //@line 59
  _ShapePoint($8, $32, $36); //@line 60
  SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 16 | 0, SAFE_HEAP_LOAD($7 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 20 | 0, SAFE_HEAP_LOAD($7 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 16 | 0, SAFE_HEAP_LOAD($8 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 20 | 0, SAFE_HEAP_LOAD($8 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
  _MinkowskiPointNew($9, $$byval_copy, $$byval_copy1); //@line 63
  dest = $5; //@line 64
  src = $9; //@line 64
  stop = dest + 56 | 0; //@line 64
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 64
   src = src + 4 | 0; //@line 64
  } while ((dest | 0) < (stop | 0));
  $37 = $3; //@line 65
  $38 = SAFE_HEAP_LOAD($37 | 0, 4, 0) | 0 | 0; //@line 66
  $39 = $4; //@line 67
  $40 = SAFE_HEAP_LOAD($39 | 0, 4, 0) | 0 | 0; //@line 68
  $41 = $40 >>> 8; //@line 69
  $42 = $41 & 255; //@line 70
  _ShapePoint($10, $38, $42); //@line 71
  $43 = $3; //@line 72
  $44 = $43 + 4 | 0; //@line 73
  $45 = SAFE_HEAP_LOAD($44 | 0, 4, 0) | 0 | 0; //@line 74
  $46 = $4; //@line 75
  $47 = SAFE_HEAP_LOAD($46 | 0, 4, 0) | 0 | 0; //@line 76
  $48 = $47 & 255; //@line 77
  _ShapePoint($11, $45, $48); //@line 78
  SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 16 | 0, SAFE_HEAP_LOAD($10 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 20 | 0, SAFE_HEAP_LOAD($10 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 16 | 0, SAFE_HEAP_LOAD($11 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 20 | 0, SAFE_HEAP_LOAD($11 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
  _MinkowskiPointNew($12, $$byval_copy2, $$byval_copy3); //@line 81
  dest = $6; //@line 82
  src = $12; //@line 82
  stop = dest + 56 | 0; //@line 82
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 82
   src = src + 4 | 0; //@line 82
  } while ((dest | 0) < (stop | 0));
  $56 = $3; //@line 83
  dest = $$byval_copy12; //@line 84
  src = $5; //@line 84
  stop = dest + 56 | 0; //@line 84
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 84
   src = src + 4 | 0; //@line 84
  } while ((dest | 0) < (stop | 0));
  dest = $$byval_copy13; //@line 85
  src = $6; //@line 85
  stop = dest + 56 | 0; //@line 85
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 85
   src = src + 4 | 0; //@line 85
  } while ((dest | 0) < (stop | 0));
  _GJKRecurse($20, $56, $$byval_copy12, $$byval_copy13, 1); //@line 86
  $57 = $20 + 56 | 0; //@line 87
  $58 = SAFE_HEAP_LOAD($57 | 0, 4, 0) | 0 | 0; //@line 88
  $59 = $4; //@line 89
  SAFE_HEAP_STORE($59 | 0, $58 | 0, 4);
  dest = $0; //@line 91
  src = $20; //@line 91
  stop = dest + 64 | 0; //@line 91
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 91
   src = src + 4 | 0; //@line 91
  } while ((dest | 0) < (stop | 0));
  STACKTOP = sp; //@line 92
  return;
 } else {
  $49 = $25 + 56 | 0; //@line 94
  SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($49 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($49 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($49 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($49 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 16 | 0, SAFE_HEAP_LOAD($49 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 20 | 0, SAFE_HEAP_LOAD($49 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 24 | 0, SAFE_HEAP_LOAD($49 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 28 | 0, SAFE_HEAP_LOAD($49 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpBBCenter($15, $$byval_copy4); //@line 96
  $50 = $3; //@line 97
  $51 = $50 + 4 | 0; //@line 98
  $52 = SAFE_HEAP_LOAD($51 | 0, 4, 0) | 0 | 0; //@line 99
  $53 = $52 + 56 | 0; //@line 100
  SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($53 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($53 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($53 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($53 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 16 | 0, SAFE_HEAP_LOAD($53 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 20 | 0, SAFE_HEAP_LOAD($53 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 24 | 0, SAFE_HEAP_LOAD($53 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 28 | 0, SAFE_HEAP_LOAD($53 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpBBCenter($16, $$byval_copy5); //@line 102
  SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($15 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($15 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($15 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($16 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($16 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($16 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvsub_67($14, $$byval_copy6, $$byval_copy7); //@line 105
  SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvperp_75($13, $$byval_copy8); //@line 107
  $54 = $3; //@line 108
  SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _Support($17, $54, $$byval_copy9); //@line 110
  dest = $5; //@line 111
  src = $17; //@line 111
  stop = dest + 56 | 0; //@line 111
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 111
   src = src + 4 | 0; //@line 111
  } while ((dest | 0) < (stop | 0));
  $55 = $3; //@line 112
  SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvneg_62($18, $$byval_copy10); //@line 114
  SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($18 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($18 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($18 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _Support($19, $55, $$byval_copy11); //@line 116
  dest = $6; //@line 117
  src = $19; //@line 117
  stop = dest + 56 | 0; //@line 117
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 117
   src = src + 4 | 0; //@line 117
  } while ((dest | 0) < (stop | 0));
  $56 = $3; //@line 118
  dest = $$byval_copy12; //@line 119
  src = $5; //@line 119
  stop = dest + 56 | 0; //@line 119
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 119
   src = src + 4 | 0; //@line 119
  } while ((dest | 0) < (stop | 0));
  dest = $$byval_copy13; //@line 120
  src = $6; //@line 120
  stop = dest + 56 | 0; //@line 120
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 120
   src = src + 4 | 0; //@line 120
  } while ((dest | 0) < (stop | 0));
  _GJKRecurse($20, $56, $$byval_copy12, $$byval_copy13, 1); //@line 121
  $57 = $20 + 56 | 0; //@line 122
  $58 = SAFE_HEAP_LOAD($57 | 0, 4, 0) | 0 | 0; //@line 123
  $59 = $4; //@line 124
  SAFE_HEAP_STORE($59 | 0, $58 | 0, 4);
  dest = $0; //@line 126
  src = $20; //@line 126
  stop = dest + 64 | 0; //@line 126
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 126
   src = src + 4 | 0; //@line 126
  } while ((dest | 0) < (stop | 0));
  STACKTOP = sp; //@line 127
  return;
 }
}
function _pop_arg_658($0, $1, $2) {
 $0 = $0 | 0; //@line 12426
 $1 = $1 | 0; //@line 12427
 $2 = $2 | 0; //@line 12428
 var $$mask = 0, $$mask31 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0.0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0; //@line 12429
 var $116 = 0.0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0;
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0; //@line 12431
 var $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0; //@line 12432
 var $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0; //@line 12433
 var $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $arglist_current = 0, $arglist_current11 = 0, $arglist_current14 = 0, $arglist_current17 = 0; //@line 12434
 var $arglist_current2 = 0, $arglist_current20 = 0, $arglist_current23 = 0, $arglist_current26 = 0, $arglist_current5 = 0, $arglist_current8 = 0, $arglist_next = 0, $arglist_next12 = 0, $arglist_next15 = 0, $arglist_next18 = 0, $arglist_next21 = 0, $arglist_next24 = 0, $arglist_next27 = 0, $arglist_next3 = 0, $arglist_next6 = 0, $arglist_next9 = 0, $expanded = 0, $expanded28 = 0, $expanded30 = 0, $expanded31 = 0; //@line 12435
 var $expanded32 = 0, $expanded34 = 0, $expanded35 = 0, $expanded37 = 0, $expanded38 = 0, $expanded39 = 0, $expanded41 = 0, $expanded42 = 0, $expanded44 = 0, $expanded45 = 0, $expanded46 = 0, $expanded48 = 0, $expanded49 = 0, $expanded51 = 0, $expanded52 = 0, $expanded53 = 0, $expanded55 = 0, $expanded56 = 0, $expanded58 = 0, $expanded59 = 0; //@line 12436
 var $expanded60 = 0, $expanded62 = 0, $expanded63 = 0, $expanded65 = 0, $expanded66 = 0, $expanded67 = 0, $expanded69 = 0, $expanded70 = 0, $expanded72 = 0, $expanded73 = 0, $expanded74 = 0, $expanded76 = 0, $expanded77 = 0, $expanded79 = 0, $expanded80 = 0, $expanded81 = 0, $expanded83 = 0, $expanded84 = 0, $expanded86 = 0, $expanded87 = 0; //@line 12437
 var $expanded88 = 0, $expanded90 = 0, $expanded91 = 0, $expanded93 = 0, $expanded94 = 0, $expanded95 = 0, label = 0, sp = 0; //@line 12438
 sp = STACKTOP; //@line 12439
 $3 = $1 >>> 0 > 20; //@line 12440
 L1 : do {
  if (!$3) {
   do {
    switch ($1 | 0) {
    case 9:
     {
      $arglist_current = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 12446
      $4 = $arglist_current; //@line 12447
      $5 = 0 + 4 | 0; //@line 12448
      $expanded28 = $5; //@line 12449
      $expanded = $expanded28 - 1 | 0; //@line 12450
      $6 = $4 + $expanded | 0; //@line 12451
      $7 = 0 + 4 | 0; //@line 12452
      $expanded32 = $7; //@line 12453
      $expanded31 = $expanded32 - 1 | 0; //@line 12454
      $expanded30 = $expanded31 ^ -1; //@line 12455
      $8 = $6 & $expanded30; //@line 12456
      $9 = $8; //@line 12457
      $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 12458
      $arglist_next = $9 + 4 | 0; //@line 12459
      SAFE_HEAP_STORE($2 | 0, $arglist_next | 0, 4);
      SAFE_HEAP_STORE($0 | 0, $10 | 0, 4);
      break L1;
      break;
     }
    case 10:
     {
      $arglist_current2 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 12466
      $11 = $arglist_current2; //@line 12467
      $12 = 0 + 4 | 0; //@line 12468
      $expanded35 = $12; //@line 12469
      $expanded34 = $expanded35 - 1 | 0; //@line 12470
      $13 = $11 + $expanded34 | 0; //@line 12471
      $14 = 0 + 4 | 0; //@line 12472
      $expanded39 = $14; //@line 12473
      $expanded38 = $expanded39 - 1 | 0; //@line 12474
      $expanded37 = $expanded38 ^ -1; //@line 12475
      $15 = $13 & $expanded37; //@line 12476
      $16 = $15; //@line 12477
      $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 12478
      $arglist_next3 = $16 + 4 | 0; //@line 12479
      SAFE_HEAP_STORE($2 | 0, $arglist_next3 | 0, 4);
      $18 = ($17 | 0) < 0; //@line 12481
      $19 = $18 << 31 >> 31; //@line 12482
      $20 = $0; //@line 12483
      $21 = $20; //@line 12484
      SAFE_HEAP_STORE($21 | 0, $17 | 0, 4);
      $22 = $20 + 4 | 0; //@line 12486
      $23 = $22; //@line 12487
      SAFE_HEAP_STORE($23 | 0, $19 | 0, 4);
      break L1;
      break;
     }
    case 11:
     {
      $arglist_current5 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 12493
      $24 = $arglist_current5; //@line 12494
      $25 = 0 + 4 | 0; //@line 12495
      $expanded42 = $25; //@line 12496
      $expanded41 = $expanded42 - 1 | 0; //@line 12497
      $26 = $24 + $expanded41 | 0; //@line 12498
      $27 = 0 + 4 | 0; //@line 12499
      $expanded46 = $27; //@line 12500
      $expanded45 = $expanded46 - 1 | 0; //@line 12501
      $expanded44 = $expanded45 ^ -1; //@line 12502
      $28 = $26 & $expanded44; //@line 12503
      $29 = $28; //@line 12504
      $30 = SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0; //@line 12505
      $arglist_next6 = $29 + 4 | 0; //@line 12506
      SAFE_HEAP_STORE($2 | 0, $arglist_next6 | 0, 4);
      $31 = $0; //@line 12508
      $32 = $31; //@line 12509
      SAFE_HEAP_STORE($32 | 0, $30 | 0, 4);
      $33 = $31 + 4 | 0; //@line 12511
      $34 = $33; //@line 12512
      SAFE_HEAP_STORE($34 | 0, 0 | 0, 4);
      break L1;
      break;
     }
    case 12:
     {
      $arglist_current8 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 12518
      $35 = $arglist_current8; //@line 12519
      $36 = 0 + 8 | 0; //@line 12520
      $expanded49 = $36; //@line 12521
      $expanded48 = $expanded49 - 1 | 0; //@line 12522
      $37 = $35 + $expanded48 | 0; //@line 12523
      $38 = 0 + 8 | 0; //@line 12524
      $expanded53 = $38; //@line 12525
      $expanded52 = $expanded53 - 1 | 0; //@line 12526
      $expanded51 = $expanded52 ^ -1; //@line 12527
      $39 = $37 & $expanded51; //@line 12528
      $40 = $39; //@line 12529
      $41 = $40; //@line 12530
      $42 = $41; //@line 12531
      $43 = SAFE_HEAP_LOAD($42 | 0, 4, 0) | 0 | 0; //@line 12532
      $44 = $41 + 4 | 0; //@line 12533
      $45 = $44; //@line 12534
      $46 = SAFE_HEAP_LOAD($45 | 0, 4, 0) | 0 | 0; //@line 12535
      $arglist_next9 = $40 + 8 | 0; //@line 12536
      SAFE_HEAP_STORE($2 | 0, $arglist_next9 | 0, 4);
      $47 = $0; //@line 12538
      $48 = $47; //@line 12539
      SAFE_HEAP_STORE($48 | 0, $43 | 0, 4);
      $49 = $47 + 4 | 0; //@line 12541
      $50 = $49; //@line 12542
      SAFE_HEAP_STORE($50 | 0, $46 | 0, 4);
      break L1;
      break;
     }
    case 13:
     {
      $arglist_current11 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 12548
      $51 = $arglist_current11; //@line 12549
      $52 = 0 + 4 | 0; //@line 12550
      $expanded56 = $52; //@line 12551
      $expanded55 = $expanded56 - 1 | 0; //@line 12552
      $53 = $51 + $expanded55 | 0; //@line 12553
      $54 = 0 + 4 | 0; //@line 12554
      $expanded60 = $54; //@line 12555
      $expanded59 = $expanded60 - 1 | 0; //@line 12556
      $expanded58 = $expanded59 ^ -1; //@line 12557
      $55 = $53 & $expanded58; //@line 12558
      $56 = $55; //@line 12559
      $57 = SAFE_HEAP_LOAD($56 | 0, 4, 0) | 0 | 0; //@line 12560
      $arglist_next12 = $56 + 4 | 0; //@line 12561
      SAFE_HEAP_STORE($2 | 0, $arglist_next12 | 0, 4);
      $58 = $57 & 65535; //@line 12563
      $59 = $58 << 16 >> 16; //@line 12564
      $60 = ($59 | 0) < 0; //@line 12565
      $61 = $60 << 31 >> 31; //@line 12566
      $62 = $0; //@line 12567
      $63 = $62; //@line 12568
      SAFE_HEAP_STORE($63 | 0, $59 | 0, 4);
      $64 = $62 + 4 | 0; //@line 12570
      $65 = $64; //@line 12571
      SAFE_HEAP_STORE($65 | 0, $61 | 0, 4);
      break L1;
      break;
     }
    case 14:
     {
      $arglist_current14 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 12577
      $66 = $arglist_current14; //@line 12578
      $67 = 0 + 4 | 0; //@line 12579
      $expanded63 = $67; //@line 12580
      $expanded62 = $expanded63 - 1 | 0; //@line 12581
      $68 = $66 + $expanded62 | 0; //@line 12582
      $69 = 0 + 4 | 0; //@line 12583
      $expanded67 = $69; //@line 12584
      $expanded66 = $expanded67 - 1 | 0; //@line 12585
      $expanded65 = $expanded66 ^ -1; //@line 12586
      $70 = $68 & $expanded65; //@line 12587
      $71 = $70; //@line 12588
      $72 = SAFE_HEAP_LOAD($71 | 0, 4, 0) | 0 | 0; //@line 12589
      $arglist_next15 = $71 + 4 | 0; //@line 12590
      SAFE_HEAP_STORE($2 | 0, $arglist_next15 | 0, 4);
      $$mask31 = $72 & 65535; //@line 12592
      $73 = $0; //@line 12593
      $74 = $73; //@line 12594
      SAFE_HEAP_STORE($74 | 0, $$mask31 | 0, 4);
      $75 = $73 + 4 | 0; //@line 12596
      $76 = $75; //@line 12597
      SAFE_HEAP_STORE($76 | 0, 0 | 0, 4);
      break L1;
      break;
     }
    case 15:
     {
      $arglist_current17 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 12603
      $77 = $arglist_current17; //@line 12604
      $78 = 0 + 4 | 0; //@line 12605
      $expanded70 = $78; //@line 12606
      $expanded69 = $expanded70 - 1 | 0; //@line 12607
      $79 = $77 + $expanded69 | 0; //@line 12608
      $80 = 0 + 4 | 0; //@line 12609
      $expanded74 = $80; //@line 12610
      $expanded73 = $expanded74 - 1 | 0; //@line 12611
      $expanded72 = $expanded73 ^ -1; //@line 12612
      $81 = $79 & $expanded72; //@line 12613
      $82 = $81; //@line 12614
      $83 = SAFE_HEAP_LOAD($82 | 0, 4, 0) | 0 | 0; //@line 12615
      $arglist_next18 = $82 + 4 | 0; //@line 12616
      SAFE_HEAP_STORE($2 | 0, $arglist_next18 | 0, 4);
      $84 = $83 & 255; //@line 12618
      $85 = $84 << 24 >> 24; //@line 12619
      $86 = ($85 | 0) < 0; //@line 12620
      $87 = $86 << 31 >> 31; //@line 12621
      $88 = $0; //@line 12622
      $89 = $88; //@line 12623
      SAFE_HEAP_STORE($89 | 0, $85 | 0, 4);
      $90 = $88 + 4 | 0; //@line 12625
      $91 = $90; //@line 12626
      SAFE_HEAP_STORE($91 | 0, $87 | 0, 4);
      break L1;
      break;
     }
    case 16:
     {
      $arglist_current20 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 12632
      $92 = $arglist_current20; //@line 12633
      $93 = 0 + 4 | 0; //@line 12634
      $expanded77 = $93; //@line 12635
      $expanded76 = $expanded77 - 1 | 0; //@line 12636
      $94 = $92 + $expanded76 | 0; //@line 12637
      $95 = 0 + 4 | 0; //@line 12638
      $expanded81 = $95; //@line 12639
      $expanded80 = $expanded81 - 1 | 0; //@line 12640
      $expanded79 = $expanded80 ^ -1; //@line 12641
      $96 = $94 & $expanded79; //@line 12642
      $97 = $96; //@line 12643
      $98 = SAFE_HEAP_LOAD($97 | 0, 4, 0) | 0 | 0; //@line 12644
      $arglist_next21 = $97 + 4 | 0; //@line 12645
      SAFE_HEAP_STORE($2 | 0, $arglist_next21 | 0, 4);
      $$mask = $98 & 255; //@line 12647
      $99 = $0; //@line 12648
      $100 = $99; //@line 12649
      SAFE_HEAP_STORE($100 | 0, $$mask | 0, 4);
      $101 = $99 + 4 | 0; //@line 12651
      $102 = $101; //@line 12652
      SAFE_HEAP_STORE($102 | 0, 0 | 0, 4);
      break L1;
      break;
     }
    case 17:
     {
      $arglist_current23 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 12658
      $103 = $arglist_current23; //@line 12659
      $104 = 0 + 8 | 0; //@line 12660
      $expanded84 = $104; //@line 12661
      $expanded83 = $expanded84 - 1 | 0; //@line 12662
      $105 = $103 + $expanded83 | 0; //@line 12663
      $106 = 0 + 8 | 0; //@line 12664
      $expanded88 = $106; //@line 12665
      $expanded87 = $expanded88 - 1 | 0; //@line 12666
      $expanded86 = $expanded87 ^ -1; //@line 12667
      $107 = $105 & $expanded86; //@line 12668
      $108 = $107; //@line 12669
      $109 = +(+SAFE_HEAP_LOAD_D($108 | 0, 8)); //@line 12670
      $arglist_next24 = $108 + 8 | 0; //@line 12671
      SAFE_HEAP_STORE($2 | 0, $arglist_next24 | 0, 4);
      SAFE_HEAP_STORE_D($0 | 0, +$109, 8);
      break L1;
      break;
     }
    case 18:
     {
      $arglist_current26 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 12678
      $110 = $arglist_current26; //@line 12679
      $111 = 0 + 8 | 0; //@line 12680
      $expanded91 = $111; //@line 12681
      $expanded90 = $expanded91 - 1 | 0; //@line 12682
      $112 = $110 + $expanded90 | 0; //@line 12683
      $113 = 0 + 8 | 0; //@line 12684
      $expanded95 = $113; //@line 12685
      $expanded94 = $expanded95 - 1 | 0; //@line 12686
      $expanded93 = $expanded94 ^ -1; //@line 12687
      $114 = $112 & $expanded93; //@line 12688
      $115 = $114; //@line 12689
      $116 = +(+SAFE_HEAP_LOAD_D($115 | 0, 8)); //@line 12690
      $arglist_next27 = $115 + 8 | 0; //@line 12691
      SAFE_HEAP_STORE($2 | 0, $arglist_next27 | 0, 4);
      SAFE_HEAP_STORE_D($0 | 0, +$116, 8);
      break L1;
      break;
     }
    default:
     {
      break L1;
     }
    }
   } while (0);
  }
 } while (0);
 return;
}
function _ClosestPointsNew($0, $1, $2) {
 $0 = $0 | 0; //@line 1181
 $1 = $1 | 0; //@line 1182
 $2 = $2 | 0; //@line 1183
 var $$byval_copy = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy14 = 0, $$byval_copy15 = 0, $$byval_copy16 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $11 = 0.0, $12 = 0, $13 = 0.0; //@line 1184
 var $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0.0, $22 = 0.0, $23 = 0, $24 = 0, $25 = 0.0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0.0, $30 = 0, $31 = 0, $32 = 0; //@line 1185
 var $33 = 0, $34 = 0, $35 = 0, $36 = 0.0, $37 = 0.0, $38 = 0, $39 = 0.0, $4 = 0, $40 = 0, $41 = 0.0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0.0, $47 = 0, $48 = 0, $49 = 0.0, $5 = 0, $50 = 0.0; //@line 1186
 var $51 = 0.0, $52 = 0.0, $53 = 0, $54 = 0, $55 = 0, $56 = 0.0, $57 = 0, $58 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP; //@line 1188
 STACKTOP = STACKTOP + 528 | 0; //@line 1189
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(528 | 0); //@line 1189
 $$byval_copy16 = sp + 504 | 0; //@line 1190
 $$byval_copy15 = sp + 488 | 0; //@line 1191
 $$byval_copy14 = sp + 472 | 0; //@line 1192
 $$byval_copy13 = sp + 456 | 0; //@line 1193
 $$byval_copy12 = sp + 440 | 0; //@line 1194
 $$byval_copy11 = sp + 424 | 0; //@line 1195
 $$byval_copy10 = sp + 408 | 0; //@line 1196
 $$byval_copy9 = sp + 392 | 0; //@line 1197
 $$byval_copy8 = sp + 376 | 0; //@line 1198
 $$byval_copy7 = sp + 360 | 0; //@line 1199
 $$byval_copy6 = sp + 344 | 0; //@line 1200
 $$byval_copy5 = sp + 328 | 0; //@line 1201
 $$byval_copy4 = sp + 312 | 0; //@line 1202
 $$byval_copy3 = sp + 296 | 0; //@line 1203
 $$byval_copy2 = sp + 280 | 0; //@line 1204
 $$byval_copy = sp + 264 | 0; //@line 1205
 $4 = sp + 240 | 0; //@line 1206
 $5 = sp + 224 | 0; //@line 1207
 $6 = sp + 208 | 0; //@line 1208
 $8 = sp + 192 | 0; //@line 1209
 $9 = sp + 176 | 0; //@line 1210
 $10 = sp + 160 | 0; //@line 1211
 $12 = sp + 88 | 0; //@line 1212
 $14 = sp + 64 | 0; //@line 1213
 $15 = sp; //@line 1214
 $16 = $1 + 32 | 0; //@line 1215
 $17 = $2 + 32 | 0; //@line 1216
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($16 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($16 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($16 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($17 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($17 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($17 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $18 = +_ClosestT($$byval_copy, $$byval_copy2); //@line 1219
 $3 = $18; //@line 1220
 $19 = $1 + 32 | 0; //@line 1221
 $20 = $2 + 32 | 0; //@line 1222
 $21 = $3; //@line 1223
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($19 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($19 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($19 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($20 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($20 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($20 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _LerpT($4, $$byval_copy3, $$byval_copy4, $21); //@line 1226
 $22 = $3; //@line 1227
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _LerpT($5, $$byval_copy5, $$byval_copy6, $22); //@line 1230
 $23 = $1 + 16 | 0; //@line 1231
 $24 = $2 + 16 | 0; //@line 1232
 $25 = $3; //@line 1233
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($23 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($23 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($23 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($24 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($24 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($24 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _LerpT($6, $$byval_copy7, $$byval_copy8, $25); //@line 1236
 $26 = $1 + 48 | 0; //@line 1237
 $27 = SAFE_HEAP_LOAD($26 | 0, 4, 0) | 0 | 0; //@line 1238
 $28 = $27 & 65535; //@line 1239
 $29 = $28 << 16; //@line 1240
 $30 = $2 + 48 | 0; //@line 1241
 $31 = SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0; //@line 1242
 $32 = $31 & 65535; //@line 1243
 $33 = $29 | $32; //@line 1244
 $7 = $33; //@line 1245
 $34 = $2 + 32 | 0; //@line 1246
 $35 = $1 + 32 | 0; //@line 1247
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($34 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($34 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($34 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($34 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($35 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($35 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($35 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($35 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_67($8, $$byval_copy9, $$byval_copy10); //@line 1250
 SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvrperp($10, $$byval_copy11); //@line 1252
 SAFE_HEAP_STORE($$byval_copy12 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvnormalize($9, $$byval_copy12); //@line 1254
 SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $36 = +_cpvdot_68($$byval_copy13, $$byval_copy14); //@line 1257
 $11 = $36; //@line 1258
 $37 = $11; //@line 1259
 $38 = $37 <= 0.0; //@line 1260
 if (!$38) {
  $39 = $3; //@line 1262
  $40 = -1.0 < $39; //@line 1263
  $41 = $3; //@line 1264
  $42 = $41 < 1.0; //@line 1265
  $or$cond = $40 & $42; //@line 1266
  if (!$or$cond) {
   SAFE_HEAP_STORE($$byval_copy15 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy15 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy15 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy15 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   $49 = +_cpvlength_85($$byval_copy15); //@line 1269
   $13 = $49; //@line 1270
   $50 = $13; //@line 1271
   $51 = $50 + 2.2250738585072014e-308; //@line 1272
   $52 = 1.0 / $51; //@line 1273
   SAFE_HEAP_STORE($$byval_copy16 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy16 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy16 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy16 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   _cpvmult_64($14, $$byval_copy16, $52); //@line 1275
   SAFE_HEAP_STORE($15 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($15 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($15 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($15 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   $53 = $15 + 16 | 0; //@line 1277
   SAFE_HEAP_STORE($53 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($53 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($53 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($53 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   $54 = $15 + 32 | 0; //@line 1279
   SAFE_HEAP_STORE($54 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($54 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($54 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($54 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   $55 = $15 + 48 | 0; //@line 1281
   $56 = $13; //@line 1282
   SAFE_HEAP_STORE_D($55 | 0, +$56, 8);
   $57 = $15 + 56 | 0; //@line 1284
   $58 = $7; //@line 1285
   SAFE_HEAP_STORE($57 | 0, $58 | 0, 4);
   dest = $0; //@line 1287
   src = $15; //@line 1287
   stop = dest + 64 | 0; //@line 1287
   do {
    SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
    dest = dest + 4 | 0; //@line 1287
    src = src + 4 | 0; //@line 1287
   } while ((dest | 0) < (stop | 0));
   STACKTOP = sp; //@line 1288
   return;
  }
 }
 SAFE_HEAP_STORE($12 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $43 = $12 + 16 | 0; //@line 1292
 SAFE_HEAP_STORE($43 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($43 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($43 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($43 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $44 = $12 + 32 | 0; //@line 1294
 SAFE_HEAP_STORE($44 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($44 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($44 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($44 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $45 = $12 + 48 | 0; //@line 1296
 $46 = $11; //@line 1297
 SAFE_HEAP_STORE_D($45 | 0, +$46, 8);
 $47 = $12 + 56 | 0; //@line 1299
 $48 = $7; //@line 1300
 SAFE_HEAP_STORE($47 | 0, $48 | 0, 4);
 dest = $0; //@line 1302
 src = $12; //@line 1302
 stop = dest + 64 | 0; //@line 1302
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 1302
  src = src + 4 | 0; //@line 1302
 } while ((dest | 0) < (stop | 0));
 STACKTOP = sp; //@line 1303
 return;
}
function _preStep_235($0, $1) {
 $0 = $0 | 0; //@line 2901
 $1 = +$1; //@line 2902
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy14 = 0, $$byval_copy15 = 0, $$byval_copy16 = 0, $$byval_copy17 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $11 = 0; //@line 2903
 var $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0.0; //@line 2904
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0; //@line 2905
 var $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0.0, $59 = 0.0, $6 = 0, $60 = 0.0, $61 = 0.0, $62 = 0.0, $63 = 0.0, $64 = 0, $65 = 0, $66 = 0.0; //@line 2906
 var $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 2907
 sp = STACKTOP; //@line 2908
 STACKTOP = STACKTOP + 560 | 0; //@line 2909
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(560 | 0); //@line 2909
 $$byval_copy17 = sp + 520 | 0; //@line 2910
 $$byval_copy16 = sp + 504 | 0; //@line 2911
 $$byval_copy15 = sp + 488 | 0; //@line 2912
 $$byval_copy14 = sp + 472 | 0; //@line 2913
 $$byval_copy13 = sp + 456 | 0; //@line 2914
 $$byval_copy12 = sp + 440 | 0; //@line 2915
 $$byval_copy11 = sp + 424 | 0; //@line 2916
 $$byval_copy10 = sp + 408 | 0; //@line 2917
 $$byval_copy9 = sp + 392 | 0; //@line 2918
 $$byval_copy8 = sp + 376 | 0; //@line 2919
 $$byval_copy7 = sp + 360 | 0; //@line 2920
 $$byval_copy6 = sp + 312 | 0; //@line 2921
 $$byval_copy5 = sp + 296 | 0; //@line 2922
 $$byval_copy4 = sp + 280 | 0; //@line 2923
 $$byval_copy3 = sp + 264 | 0; //@line 2924
 $$byval_copy2 = sp + 216 | 0; //@line 2925
 $$byval_copy1 = sp + 200 | 0; //@line 2926
 $$byval_copy = sp + 184 | 0; //@line 2927
 $6 = sp + 160 | 0; //@line 2928
 $7 = sp + 144 | 0; //@line 2929
 $8 = sp + 128 | 0; //@line 2930
 $9 = sp + 112 | 0; //@line 2931
 $10 = sp + 80 | 0; //@line 2932
 $11 = sp + 64 | 0; //@line 2933
 $12 = sp + 48 | 0; //@line 2934
 $13 = sp + 32 | 0; //@line 2935
 $14 = sp + 16 | 0; //@line 2936
 $15 = sp; //@line 2937
 $2 = $0; //@line 2938
 $3 = $1; //@line 2939
 $16 = $2; //@line 2940
 $17 = $16 + 8 | 0; //@line 2941
 $18 = SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0; //@line 2942
 $4 = $18; //@line 2943
 $19 = $2; //@line 2944
 $20 = $19 + 12 | 0; //@line 2945
 $21 = SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0; //@line 2946
 $5 = $21; //@line 2947
 $22 = $2; //@line 2948
 $23 = $22 + 96 | 0; //@line 2949
 $24 = $4; //@line 2950
 $25 = $24 + 128 | 0; //@line 2951
 $26 = $2; //@line 2952
 $27 = $26 + 64 | 0; //@line 2953
 $28 = $4; //@line 2954
 $29 = $28 + 40 | 0; //@line 2955
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($27 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($27 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($27 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($29 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($29 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($29 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_242($6, $$byval_copy, $$byval_copy1); //@line 2958
 dest = $$byval_copy2; //@line 2959
 src = $25; //@line 2959
 stop = dest + 48 | 0; //@line 2959
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 2959
  src = src + 4 | 0; //@line 2959
 } while ((dest | 0) < (stop | 0));
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpTransformVect_254($7, $$byval_copy2, $$byval_copy3); //@line 2961
 SAFE_HEAP_STORE($23 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($23 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($23 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($23 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $30 = $2; //@line 2963
 $31 = $30 + 112 | 0; //@line 2964
 $32 = $5; //@line 2965
 $33 = $32 + 128 | 0; //@line 2966
 $34 = $2; //@line 2967
 $35 = $34 + 80 | 0; //@line 2968
 $36 = $5; //@line 2969
 $37 = $36 + 40 | 0; //@line 2970
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($35 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($35 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($35 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($35 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($37 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($37 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($37 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($37 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_242($8, $$byval_copy4, $$byval_copy5); //@line 2973
 dest = $$byval_copy6; //@line 2974
 src = $33; //@line 2974
 stop = dest + 48 | 0; //@line 2974
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 2974
  src = src + 4 | 0; //@line 2974
 } while ((dest | 0) < (stop | 0));
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpTransformVect_254($9, $$byval_copy6, $$byval_copy7); //@line 2976
 SAFE_HEAP_STORE($31 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($31 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($31 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($31 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $38 = $2; //@line 2978
 $39 = $38 + 128 | 0; //@line 2979
 $40 = $4; //@line 2980
 $41 = $5; //@line 2981
 $42 = $2; //@line 2982
 $43 = $42 + 96 | 0; //@line 2983
 $44 = $2; //@line 2984
 $45 = $44 + 112 | 0; //@line 2985
 SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($43 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($43 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($43 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($43 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($45 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($45 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($45 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($45 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _k_tensor_255($10, $40, $41, $$byval_copy8, $$byval_copy9); //@line 2988
 SAFE_HEAP_STORE($39 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($39 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($39 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($39 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($39 + 16 | 0, SAFE_HEAP_LOAD($10 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($39 + 20 | 0, SAFE_HEAP_LOAD($10 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($39 + 24 | 0, SAFE_HEAP_LOAD($10 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($39 + 28 | 0, SAFE_HEAP_LOAD($10 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 $46 = $5; //@line 2990
 $47 = $46 + 56 | 0; //@line 2991
 $48 = $2; //@line 2992
 $49 = $48 + 112 | 0; //@line 2993
 SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($47 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($47 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($47 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($47 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($49 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($49 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($49 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($49 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_244($12, $$byval_copy10, $$byval_copy11); //@line 2996
 $50 = $4; //@line 2997
 $51 = $50 + 56 | 0; //@line 2998
 $52 = $2; //@line 2999
 $53 = $52 + 96 | 0; //@line 3000
 SAFE_HEAP_STORE($$byval_copy12 | 0, SAFE_HEAP_LOAD($51 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 4 | 0, SAFE_HEAP_LOAD($51 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 8 | 0, SAFE_HEAP_LOAD($51 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 12 | 0, SAFE_HEAP_LOAD($51 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($53 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($53 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($53 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($53 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_244($13, $$byval_copy12, $$byval_copy13); //@line 3003
 SAFE_HEAP_STORE($$byval_copy14 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy15 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy15 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy15 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy15 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_242($11, $$byval_copy14, $$byval_copy15); //@line 3006
 $54 = $2; //@line 3007
 $55 = $54 + 176 | 0; //@line 3008
 $56 = $2; //@line 3009
 $57 = $56 + 32 | 0; //@line 3010
 $58 = +(+SAFE_HEAP_LOAD_D($57 | 0, 8)); //@line 3011
 $59 = $3; //@line 3012
 $60 = +_bias_coef_256($58, $59); //@line 3013
 $61 = -$60; //@line 3014
 $62 = $3; //@line 3015
 $63 = $61 / $62; //@line 3016
 SAFE_HEAP_STORE($$byval_copy16 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy16 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy16 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy16 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_249($14, $$byval_copy16, $63); //@line 3018
 $64 = $2; //@line 3019
 $65 = $64 + 40 | 0; //@line 3020
 $66 = +(+SAFE_HEAP_LOAD_D($65 | 0, 8)); //@line 3021
 SAFE_HEAP_STORE($$byval_copy17 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy17 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy17 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy17 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvclamp_245($15, $$byval_copy17, $66); //@line 3023
 SAFE_HEAP_STORE($55 | 0, SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($55 + 4 | 0, SAFE_HEAP_LOAD($15 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($55 + 8 | 0, SAFE_HEAP_LOAD($15 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($55 + 12 | 0, SAFE_HEAP_LOAD($15 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 3025
 return;
}
function _cpArbiterPreStep($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 1807
 $1 = +$1; //@line 1808
 $2 = +$2; //@line 1809
 $3 = +$3; //@line 1810
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy14 = 0, $$byval_copy15 = 0, $$byval_copy16 = 0, $$byval_copy17 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $11 = 0; //@line 1811
 var $12 = 0, $13 = 0, $14 = 0, $15 = 0.0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0; //@line 1812
 var $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0.0, $46 = 0.0, $47 = 0, $48 = 0, $49 = 0, $5 = 0.0; //@line 1813
 var $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0.0, $55 = 0.0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0.0, $60 = 0, $61 = 0.0, $62 = 0.0, $63 = 0.0, $64 = 0.0, $65 = 0.0, $66 = 0.0, $67 = 0.0, $68 = 0.0; //@line 1814
 var $69 = 0.0, $7 = 0.0, $70 = 0.0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0.0, $81 = 0, $82 = 0.0, $83 = 0.0, $84 = 0, $85 = 0, $86 = 0;
 var $87 = 0, $9 = 0, label = 0, sp = 0; //@line 1816
 sp = STACKTOP; //@line 1817
 STACKTOP = STACKTOP + 432 | 0; //@line 1818
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(432 | 0); //@line 1818
 $$byval_copy17 = sp + 384 | 0; //@line 1819
 $$byval_copy16 = sp + 368 | 0; //@line 1820
 $$byval_copy15 = sp + 352 | 0; //@line 1821
 $$byval_copy14 = sp + 336 | 0; //@line 1822
 $$byval_copy13 = sp + 320 | 0; //@line 1823
 $$byval_copy12 = sp + 304 | 0; //@line 1824
 $$byval_copy11 = sp + 288 | 0; //@line 1825
 $$byval_copy10 = sp + 272 | 0; //@line 1826
 $$byval_copy9 = sp + 256 | 0; //@line 1827
 $$byval_copy8 = sp + 240 | 0; //@line 1828
 $$byval_copy7 = sp + 224 | 0; //@line 1829
 $$byval_copy6 = sp + 208 | 0; //@line 1830
 $$byval_copy5 = sp + 192 | 0; //@line 1831
 $$byval_copy4 = sp + 176 | 0; //@line 1832
 $$byval_copy3 = sp + 160 | 0; //@line 1833
 $$byval_copy2 = sp + 144 | 0; //@line 1834
 $$byval_copy1 = sp + 128 | 0; //@line 1835
 $$byval_copy = sp + 112 | 0; //@line 1836
 $10 = sp + 72 | 0; //@line 1837
 $11 = sp + 56 | 0; //@line 1838
 $14 = sp + 40 | 0; //@line 1839
 $16 = sp + 16 | 0; //@line 1840
 $17 = sp; //@line 1841
 $4 = $0; //@line 1842
 $5 = $1; //@line 1843
 $6 = $2; //@line 1844
 $7 = $3; //@line 1845
 $18 = $4; //@line 1846
 $19 = $18 + 44 | 0; //@line 1847
 $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 1848
 $8 = $20; //@line 1849
 $21 = $4; //@line 1850
 $22 = $21 + 48 | 0; //@line 1851
 $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 1852
 $9 = $23; //@line 1853
 $24 = $4; //@line 1854
 $25 = $24 + 80 | 0; //@line 1855
 SAFE_HEAP_STORE($10 | 0, SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 4 | 0, SAFE_HEAP_LOAD($25 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 8 | 0, SAFE_HEAP_LOAD($25 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 12 | 0, SAFE_HEAP_LOAD($25 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $26 = $9; //@line 1857
 $27 = $26 + 56 | 0; //@line 1858
 $28 = $8; //@line 1859
 $29 = $28 + 56 | 0; //@line 1860
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($27 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($27 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($27 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($29 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($29 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($29 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_10($11, $$byval_copy, $$byval_copy1); //@line 1863
 $12 = 0; //@line 1864
 while (1) {
  $30 = $12; //@line 1866
  $31 = $4; //@line 1867
  $32 = $31 + 68 | 0; //@line 1868
  $33 = SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0; //@line 1869
  $34 = ($30 | 0) < ($33 | 0); //@line 1870
  if (!$34) {
   break;
  }
  $35 = $4; //@line 1874
  $36 = $35 + 72 | 0; //@line 1875
  $37 = SAFE_HEAP_LOAD($36 | 0, 4, 0) | 0 | 0; //@line 1876
  $38 = $12; //@line 1877
  $39 = $37 + ($38 * 96 | 0) | 0; //@line 1878
  $13 = $39; //@line 1879
  $40 = $8; //@line 1880
  $41 = $9; //@line 1881
  $42 = $13; //@line 1882
  $43 = $13; //@line 1883
  $44 = $43 + 16 | 0; //@line 1884
  SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($42 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($42 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($42 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($42 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($44 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($44 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($44 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($44 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $45 = +_k_scalar($40, $41, $$byval_copy2, $$byval_copy3, $$byval_copy4); //@line 1888
  $46 = 1.0 / $45; //@line 1889
  $47 = $13; //@line 1890
  $48 = $47 + 32 | 0; //@line 1891
  SAFE_HEAP_STORE_D($48 | 0, +$46, 8);
  $49 = $8; //@line 1893
  $50 = $9; //@line 1894
  $51 = $13; //@line 1895
  $52 = $13; //@line 1896
  $53 = $52 + 16 | 0; //@line 1897
  SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvperp($14, $$byval_copy5); //@line 1899
  SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($51 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($51 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($51 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($51 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($53 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($53 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($53 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($53 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $54 = +_k_scalar($49, $50, $$byval_copy6, $$byval_copy7, $$byval_copy8); //@line 1903
  $55 = 1.0 / $54; //@line 1904
  $56 = $13; //@line 1905
  $57 = $56 + 40 | 0; //@line 1906
  SAFE_HEAP_STORE_D($57 | 0, +$55, 8);
  $58 = $13; //@line 1908
  $59 = $58 + 16 | 0; //@line 1909
  $60 = $13; //@line 1910
  SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($59 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($59 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($59 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($59 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($60 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($60 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($60 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($60 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvsub_10($17, $$byval_copy9, $$byval_copy10); //@line 1913
  SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($17 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($17 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($17 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy12 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy12 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy12 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy12 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvadd_9($16, $$byval_copy11, $$byval_copy12); //@line 1916
  SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($16 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($16 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($16 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy14 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy14 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy14 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy14 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $61 = +_cpvdot_11($$byval_copy13, $$byval_copy14); //@line 1919
  $15 = $61; //@line 1920
  $62 = $7; //@line 1921
  $63 = -$62; //@line 1922
  $64 = $15; //@line 1923
  $65 = $6; //@line 1924
  $66 = $64 + $65; //@line 1925
  $67 = +_cpfmin(0.0, $66); //@line 1926
  $68 = $63 * $67; //@line 1927
  $69 = $5; //@line 1928
  $70 = $68 / $69; //@line 1929
  $71 = $13; //@line 1930
  $72 = $71 + 80 | 0; //@line 1931
  SAFE_HEAP_STORE_D($72 | 0, +$70, 8);
  $73 = $13; //@line 1933
  $74 = $73 + 72 | 0; //@line 1934
  SAFE_HEAP_STORE_D($74 | 0, +0.0, 8);
  $75 = $8; //@line 1936
  $76 = $9; //@line 1937
  $77 = $13; //@line 1938
  $78 = $13; //@line 1939
  $79 = $78 + 16 | 0; //@line 1940
  SAFE_HEAP_STORE($$byval_copy15 | 0, SAFE_HEAP_LOAD($77 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 + 4 | 0, SAFE_HEAP_LOAD($77 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 + 8 | 0, SAFE_HEAP_LOAD($77 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy15 + 12 | 0, SAFE_HEAP_LOAD($77 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy16 | 0, SAFE_HEAP_LOAD($79 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy16 + 4 | 0, SAFE_HEAP_LOAD($79 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy16 + 8 | 0, SAFE_HEAP_LOAD($79 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy16 + 12 | 0, SAFE_HEAP_LOAD($79 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy17 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $80 = +_normal_relative_velocity($75, $76, $$byval_copy15, $$byval_copy16, $$byval_copy17); //@line 1944
  $81 = $4; //@line 1945
  $82 = +(+SAFE_HEAP_LOAD_D($81 | 0, 8)); //@line 1946
  $83 = $80 * $82; //@line 1947
  $84 = $13; //@line 1948
  $85 = $84 + 48 | 0; //@line 1949
  SAFE_HEAP_STORE_D($85 | 0, +$83, 8);
  $86 = $12; //@line 1951
  $87 = $86 + 1 | 0; //@line 1952
  $12 = $87; //@line 1953
 }
 STACKTOP = sp; //@line 1955
 return;
}
function _SubtreeSegmentQuery($0, $1, $2, $3, $4, $5, $6) {
 $0 = $0 | 0; //@line 3355
 $1 = $1 | 0; //@line 3356
 $2 = $2 | 0; //@line 3357
 $3 = $3 | 0; //@line 3358
 $4 = +$4; //@line 3359
 $5 = $5 | 0; //@line 3360
 $6 = $6 | 0; //@line 3361
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0.0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0.0, $15 = 0; //@line 3362
 var $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0.0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0.0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0.0, $35 = 0.0; //@line 3363
 var $36 = 0.0, $37 = 0, $38 = 0.0, $39 = 0.0, $40 = 0, $41 = 0.0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0.0, $47 = 0, $48 = 0, $49 = 0.0, $50 = 0.0, $51 = 0.0, $52 = 0.0, $53 = 0, $54 = 0.0, $55 = 0;
 var $56 = 0, $57 = 0, $58 = 0, $59 = 0, $60 = 0.0, $61 = 0, $62 = 0, $63 = 0.0, $64 = 0.0, $65 = 0.0, $66 = 0.0, $67 = 0, $68 = 0.0, $69 = 0, $7 = 0.0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0.0; //@line 3365
 var $75 = 0, $76 = 0, $77 = 0.0, $78 = 0.0, $79 = 0.0, $8 = 0, $80 = 0.0, $81 = 0, $82 = 0.0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0.0, $88 = 0, $89 = 0, $9 = 0, $90 = 0.0, $91 = 0.0, $92 = 0.0; //@line 3366
 var $93 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3368
 STACKTOP = STACKTOP + 304 | 0; //@line 3369
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(304 | 0); //@line 3369
 $$byval_copy13 = sp + 272 | 0; //@line 3370
 $$byval_copy12 = sp + 256 | 0; //@line 3371
 $$byval_copy11 = sp + 240 | 0; //@line 3372
 $$byval_copy10 = sp + 224 | 0; //@line 3373
 $$byval_copy9 = sp + 208 | 0; //@line 3374
 $$byval_copy8 = sp + 192 | 0; //@line 3375
 $$byval_copy7 = sp + 176 | 0; //@line 3376
 $$byval_copy6 = sp + 160 | 0; //@line 3377
 $$byval_copy5 = sp + 144 | 0; //@line 3378
 $$byval_copy4 = sp + 128 | 0; //@line 3379
 $$byval_copy3 = sp + 96 | 0; //@line 3380
 $$byval_copy2 = sp + 80 | 0; //@line 3381
 $$byval_copy1 = sp + 64 | 0; //@line 3382
 $$byval_copy = sp + 32 | 0; //@line 3383
 $8 = $0; //@line 3384
 $9 = $1; //@line 3385
 $10 = $4; //@line 3386
 $11 = $5; //@line 3387
 $12 = $6; //@line 3388
 $15 = $8; //@line 3389
 $16 = _NodeIsLeaf($15) | 0; //@line 3390
 $17 = $16 << 24 >> 24 != 0; //@line 3391
 if ($17) {
  $18 = $11; //@line 3393
  $19 = $9; //@line 3394
  $20 = $8; //@line 3395
  $21 = SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0; //@line 3396
  $22 = $12; //@line 3397
  $23 = +FUNCTION_TABLE_diii[(SAFE_FT_MASK($18 | 0, 7 | 0) | 0) & 7]($19, $21, $22); //@line 3398
  $7 = $23; //@line 3399
  $93 = $7; //@line 3400
  STACKTOP = sp; //@line 3401
  return +$93;
 }
 $24 = $8; //@line 3403
 $25 = $24 + 44 | 0; //@line 3404
 $26 = SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0; //@line 3405
 $27 = $26 + 8 | 0; //@line 3406
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($27 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($27 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($27 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 16 | 0, SAFE_HEAP_LOAD($27 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 20 | 0, SAFE_HEAP_LOAD($27 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 24 | 0, SAFE_HEAP_LOAD($27 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 28 | 0, SAFE_HEAP_LOAD($27 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $28 = +_cpBBSegmentQuery($$byval_copy, $$byval_copy1, $$byval_copy2); //@line 3410
 $13 = $28; //@line 3411
 $29 = $8; //@line 3412
 $30 = $29 + 44 | 0; //@line 3413
 $31 = $30 + 4 | 0; //@line 3414
 $32 = SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0; //@line 3415
 $33 = $32 + 8 | 0; //@line 3416
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($33 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($33 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($33 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($33 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 16 | 0, SAFE_HEAP_LOAD($33 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 20 | 0, SAFE_HEAP_LOAD($33 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 24 | 0, SAFE_HEAP_LOAD($33 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 28 | 0, SAFE_HEAP_LOAD($33 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $34 = +_cpBBSegmentQuery($$byval_copy3, $$byval_copy4, $$byval_copy5); //@line 3420
 $14 = $34; //@line 3421
 $35 = $13; //@line 3422
 $36 = $14; //@line 3423
 $37 = $35 < $36; //@line 3424
 if ($37) {
  $38 = $13; //@line 3426
  $39 = $10; //@line 3427
  $40 = $38 < $39; //@line 3428
  if ($40) {
   $41 = $10; //@line 3430
   $42 = $8; //@line 3431
   $43 = $42 + 44 | 0; //@line 3432
   $44 = SAFE_HEAP_LOAD($43 | 0, 4, 0) | 0 | 0; //@line 3433
   $45 = $9; //@line 3434
   $46 = $10; //@line 3435
   $47 = $11; //@line 3436
   $48 = $12; //@line 3437
   SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   $49 = +_SubtreeSegmentQuery($44, $45, $$byval_copy6, $$byval_copy7, $46, $47, $48); //@line 3440
   $50 = +_cpfmin_18($41, $49); //@line 3441
   $10 = $50; //@line 3442
  }
  $51 = $14; //@line 3444
  $52 = $10; //@line 3445
  $53 = $51 < $52; //@line 3446
  if ($53) {
   $54 = $10; //@line 3448
   $55 = $8; //@line 3449
   $56 = $55 + 44 | 0; //@line 3450
   $57 = $56 + 4 | 0; //@line 3451
   $58 = SAFE_HEAP_LOAD($57 | 0, 4, 0) | 0 | 0; //@line 3452
   $59 = $9; //@line 3453
   $60 = $10; //@line 3454
   $61 = $11; //@line 3455
   $62 = $12; //@line 3456
   SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   $63 = +_SubtreeSegmentQuery($58, $59, $$byval_copy8, $$byval_copy9, $60, $61, $62); //@line 3459
   $64 = +_cpfmin_18($54, $63); //@line 3460
   $10 = $64; //@line 3461
  }
 } else {
  $65 = $14; //@line 3464
  $66 = $10; //@line 3465
  $67 = $65 < $66; //@line 3466
  if ($67) {
   $68 = $10; //@line 3468
   $69 = $8; //@line 3469
   $70 = $69 + 44 | 0; //@line 3470
   $71 = $70 + 4 | 0; //@line 3471
   $72 = SAFE_HEAP_LOAD($71 | 0, 4, 0) | 0 | 0; //@line 3472
   $73 = $9; //@line 3473
   $74 = $10; //@line 3474
   $75 = $11; //@line 3475
   $76 = $12; //@line 3476
   SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   $77 = +_SubtreeSegmentQuery($72, $73, $$byval_copy10, $$byval_copy11, $74, $75, $76); //@line 3479
   $78 = +_cpfmin_18($68, $77); //@line 3480
   $10 = $78; //@line 3481
  }
  $79 = $13; //@line 3483
  $80 = $10; //@line 3484
  $81 = $79 < $80; //@line 3485
  if ($81) {
   $82 = $10; //@line 3487
   $83 = $8; //@line 3488
   $84 = $83 + 44 | 0; //@line 3489
   $85 = SAFE_HEAP_LOAD($84 | 0, 4, 0) | 0 | 0; //@line 3490
   $86 = $9; //@line 3491
   $87 = $10; //@line 3492
   $88 = $11; //@line 3493
   $89 = $12; //@line 3494
   SAFE_HEAP_STORE($$byval_copy12 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy12 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy12 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy12 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   $90 = +_SubtreeSegmentQuery($85, $86, $$byval_copy12, $$byval_copy13, $87, $88, $89); //@line 3497
   $91 = +_cpfmin_18($82, $90); //@line 3498
   $10 = $91; //@line 3499
  }
 }
 $92 = $10; //@line 3502
 $7 = $92; //@line 3503
 $93 = $7; //@line 3504
 STACKTOP = sp; //@line 3505
 return +$93;
}
function _SegmentToPoly($0, $1, $2) {
 $0 = $0 | 0; //@line 8283
 $1 = $1 | 0; //@line 8284
 $2 = $2 | 0; //@line 8285
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy14 = 0, $$byval_copy15 = 0, $$byval_copy16 = 0, $$byval_copy17 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $11 = 0; //@line 8286
 var $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0.0, $28 = 0, $29 = 0, $3 = 0, $30 = 0.0; //@line 8287
 var $31 = 0.0, $32 = 0, $33 = 0, $34 = 0.0, $35 = 0.0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0.0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0;
 var $5 = 0, $50 = 0, $51 = 0.0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 8289
 sp = STACKTOP; //@line 8290
 STACKTOP = STACKTOP + 768 | 0; //@line 8291
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(768 | 0); //@line 8291
 $$byval_copy17 = sp + 672 | 0; //@line 8292
 $$byval_copy16 = sp + 600 | 0; //@line 8293
 $$byval_copy15 = sp + 528 | 0; //@line 8294
 $$byval_copy14 = sp + 512 | 0; //@line 8295
 $$byval_copy13 = sp + 496 | 0; //@line 8296
 $$byval_copy12 = sp + 480 | 0; //@line 8297
 $$byval_copy11 = sp + 464 | 0; //@line 8298
 $$byval_copy10 = sp + 448 | 0; //@line 8299
 $$byval_copy9 = sp + 432 | 0; //@line 8300
 $$byval_copy8 = sp + 416 | 0; //@line 8301
 $$byval_copy7 = sp + 400 | 0; //@line 8302
 $$byval_copy6 = sp + 384 | 0; //@line 8303
 $$byval_copy5 = sp + 368 | 0; //@line 8304
 $$byval_copy4 = sp + 352 | 0; //@line 8305
 $$byval_copy3 = sp + 336 | 0; //@line 8306
 $$byval_copy2 = sp + 320 | 0; //@line 8307
 $$byval_copy1 = sp + 304 | 0; //@line 8308
 $$byval_copy = sp + 288 | 0; //@line 8309
 $6 = sp + 736 | 0; //@line 8310
 $7 = sp + 224 | 0; //@line 8311
 $8 = sp + 208 | 0; //@line 8312
 $9 = sp + 192 | 0; //@line 8313
 $10 = sp + 176 | 0; //@line 8314
 $11 = sp + 160 | 0; //@line 8315
 $12 = sp + 88 | 0; //@line 8316
 $13 = sp + 16 | 0; //@line 8317
 $14 = sp; //@line 8318
 $3 = $0; //@line 8319
 $4 = $1; //@line 8320
 $5 = $2; //@line 8321
 $15 = $3; //@line 8322
 SAFE_HEAP_STORE($6 | 0, $15 | 0, 4);
 $16 = $6 + 4 | 0; //@line 8324
 $17 = $4; //@line 8325
 SAFE_HEAP_STORE($16 | 0, $17 | 0, 4);
 $18 = $6 + 8 | 0; //@line 8327
 SAFE_HEAP_STORE($18 | 0, 55 | 0, 4);
 $19 = $6 + 12 | 0; //@line 8329
 SAFE_HEAP_STORE($19 | 0, 57 | 0, 4);
 $20 = $5; //@line 8331
 $21 = $20 + 8 | 0; //@line 8332
 _GJK($7, $6, $21); //@line 8333
 $22 = $7 + 32 | 0; //@line 8334
 SAFE_HEAP_STORE($8 | 0, SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 4 | 0, SAFE_HEAP_LOAD($22 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 8 | 0, SAFE_HEAP_LOAD($22 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 12 | 0, SAFE_HEAP_LOAD($22 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $23 = $3; //@line 8336
 $24 = $23 + 8 | 0; //@line 8337
 $25 = SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0; //@line 8338
 _cpBodyGetRotation($9, $25); //@line 8339
 $26 = $7 + 48 | 0; //@line 8340
 $27 = +(+SAFE_HEAP_LOAD_D($26 | 0, 8)); //@line 8341
 $28 = $3; //@line 8342
 $29 = $28 + 256 | 0; //@line 8343
 $30 = +(+SAFE_HEAP_LOAD_D($29 | 0, 8)); //@line 8344
 $31 = $27 - $30; //@line 8345
 $32 = $4; //@line 8346
 $33 = $32 + 160 | 0; //@line 8347
 $34 = +(+SAFE_HEAP_LOAD_D($33 | 0, 8)); //@line 8348
 $35 = $31 - $34; //@line 8349
 $36 = $35 <= 0.0; //@line 8350
 if (!$36) {
  STACKTOP = sp; //@line 8352
  return;
 }
 $37 = $3; //@line 8354
 $38 = $37 + 208 | 0; //@line 8355
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($38 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($38 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($38 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($38 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $39 = _cpveql($$byval_copy, $$byval_copy1) | 0; //@line 8358
 $40 = $39 << 24 >> 24 != 0; //@line 8359
 if ($40) {
  $41 = $3; //@line 8361
  $42 = $41 + 264 | 0; //@line 8362
  SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($42 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($42 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($42 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($42 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvrotate_86($10, $$byval_copy2, $$byval_copy3); //@line 8365
  SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $43 = +_cpvdot_68($$byval_copy4, $$byval_copy5); //@line 8368
  $44 = $43 <= 0.0; //@line 8369
  if (!$44) {
   STACKTOP = sp; //@line 8371
   return;
  }
 }
 $45 = $3; //@line 8374
 $46 = $45 + 224 | 0; //@line 8375
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($46 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($46 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($46 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($46 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $47 = _cpveql($$byval_copy6, $$byval_copy7) | 0; //@line 8378
 $48 = $47 << 24 >> 24 != 0; //@line 8379
 if ($48) {
  $49 = $3; //@line 8381
  $50 = $49 + 280 | 0; //@line 8382
  SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($50 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($50 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($50 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($50 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvrotate_86($11, $$byval_copy8, $$byval_copy9); //@line 8385
  SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $51 = +_cpvdot_68($$byval_copy10, $$byval_copy11); //@line 8388
  $52 = $51 <= 0.0; //@line 8389
  if (!$52) {
   STACKTOP = sp; //@line 8391
   return;
  }
 }
 $53 = $3; //@line 8394
 SAFE_HEAP_STORE($$byval_copy12 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _SupportEdgeForSegment($12, $53, $$byval_copy12); //@line 8396
 $54 = $4; //@line 8397
 SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvneg_62($14, $$byval_copy13); //@line 8399
 SAFE_HEAP_STORE($$byval_copy14 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _SupportEdgeForPoly($13, $54, $$byval_copy14); //@line 8401
 $55 = $5; //@line 8402
 dest = $$byval_copy15; //@line 8403
 src = $12; //@line 8403
 stop = dest + 72 | 0; //@line 8403
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 8403
  src = src + 4 | 0; //@line 8403
 } while ((dest | 0) < (stop | 0));
 dest = $$byval_copy16; //@line 8404
 src = $13; //@line 8404
 stop = dest + 72 | 0; //@line 8404
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 8404
  src = src + 4 | 0; //@line 8404
 } while ((dest | 0) < (stop | 0));
 dest = $$byval_copy17; //@line 8405
 src = $7; //@line 8405
 stop = dest + 64 | 0; //@line 8405
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 8405
  src = src + 4 | 0; //@line 8405
 } while ((dest | 0) < (stop | 0));
 _ContactPoints($$byval_copy15, $$byval_copy16, $$byval_copy17, $55); //@line 8406
 STACKTOP = sp; //@line 8407
 return;
}
function ___udivmoddi4($a$0, $a$1, $b$0, $b$1, $rem) {
 $a$0 = $a$0 | 0; //@line 14195
 $a$1 = $a$1 | 0; //@line 14196
 $b$0 = $b$0 | 0; //@line 14197
 $b$1 = $b$1 | 0; //@line 14198
 $rem = $rem | 0; //@line 14199
 var $n_sroa_0_0_extract_trunc = 0, $n_sroa_1_4_extract_shift$0 = 0, $n_sroa_1_4_extract_trunc = 0, $d_sroa_0_0_extract_trunc = 0, $d_sroa_1_4_extract_shift$0 = 0, $d_sroa_1_4_extract_trunc = 0, $4 = 0, $17 = 0, $37 = 0, $49 = 0, $51 = 0, $57 = 0, $58 = 0, $66 = 0, $78 = 0, $86 = 0, $88 = 0, $89 = 0, $91 = 0, $92 = 0, $95 = 0, $105 = 0, $117 = 0, $119 = 0, $125 = 0, $126 = 0, $130 = 0, $q_sroa_1_1_ph = 0, $q_sroa_0_1_ph = 0, $r_sroa_1_1_ph = 0, $r_sroa_0_1_ph = 0, $sr_1_ph = 0, $d_sroa_0_0_insert_insert99$0 = 0, $d_sroa_0_0_insert_insert99$1 = 0, $137$0 = 0, $137$1 = 0, $carry_0203 = 0, $sr_1202 = 0, $r_sroa_0_1201 = 0, $r_sroa_1_1200 = 0, $q_sroa_0_1199 = 0, $q_sroa_1_1198 = 0, $147 = 0, $149 = 0, $r_sroa_0_0_insert_insert42$0 = 0, $r_sroa_0_0_insert_insert42$1 = 0, $150$1 = 0, $151$0 = 0, $152 = 0, $154$0 = 0, $r_sroa_0_0_extract_trunc = 0, $r_sroa_1_4_extract_trunc = 0, $155 = 0, $carry_0_lcssa$0 = 0, $carry_0_lcssa$1 = 0, $r_sroa_0_1_lcssa = 0, $r_sroa_1_1_lcssa = 0, $q_sroa_0_1_lcssa = 0, $q_sroa_1_1_lcssa = 0, $q_sroa_0_0_insert_ext75$0 = 0, $q_sroa_0_0_insert_ext75$1 = 0, $q_sroa_0_0_insert_insert77$1 = 0, $_0$0 = 0, $_0$1 = 0; //@line 14200
 $n_sroa_0_0_extract_trunc = $a$0; //@line 14201
 $n_sroa_1_4_extract_shift$0 = $a$1; //@line 14202
 $n_sroa_1_4_extract_trunc = $n_sroa_1_4_extract_shift$0; //@line 14203
 $d_sroa_0_0_extract_trunc = $b$0; //@line 14204
 $d_sroa_1_4_extract_shift$0 = $b$1; //@line 14205
 $d_sroa_1_4_extract_trunc = $d_sroa_1_4_extract_shift$0; //@line 14206
 if (($n_sroa_1_4_extract_trunc | 0) == 0) {
  $4 = ($rem | 0) != 0; //@line 14208
  if (($d_sroa_1_4_extract_trunc | 0) == 0) {
   if ($4) {
    SAFE_HEAP_STORE($rem | 0, ($n_sroa_0_0_extract_trunc >>> 0) % ($d_sroa_0_0_extract_trunc >>> 0) | 0, 4);
    SAFE_HEAP_STORE($rem + 4 | 0, 0 | 0, 4);
   }
   $_0$1 = 0; //@line 14214
   $_0$0 = ($n_sroa_0_0_extract_trunc >>> 0) / ($d_sroa_0_0_extract_trunc >>> 0) >>> 0; //@line 14215
   return (setTempRet0($_0$1 | 0), $_0$0) | 0; //@line 14216
  } else {
   if (!$4) {
    $_0$1 = 0; //@line 14219
    $_0$0 = 0; //@line 14220
    return (setTempRet0($_0$1 | 0), $_0$0) | 0; //@line 14221
   }
   SAFE_HEAP_STORE($rem | 0, $a$0 & -1 | 0, 4);
   SAFE_HEAP_STORE($rem + 4 | 0, $a$1 & 0 | 0, 4);
   $_0$1 = 0; //@line 14225
   $_0$0 = 0; //@line 14226
   return (setTempRet0($_0$1 | 0), $_0$0) | 0; //@line 14227
  }
 }
 $17 = ($d_sroa_1_4_extract_trunc | 0) == 0; //@line 14230
 do {
  if (($d_sroa_0_0_extract_trunc | 0) == 0) {
   if ($17) {
    if (($rem | 0) != 0) {
     SAFE_HEAP_STORE($rem | 0, ($n_sroa_1_4_extract_trunc >>> 0) % ($d_sroa_0_0_extract_trunc >>> 0) | 0, 4);
     SAFE_HEAP_STORE($rem + 4 | 0, 0 | 0, 4);
    }
    $_0$1 = 0; //@line 14238
    $_0$0 = ($n_sroa_1_4_extract_trunc >>> 0) / ($d_sroa_0_0_extract_trunc >>> 0) >>> 0; //@line 14239
    return (setTempRet0($_0$1 | 0), $_0$0) | 0; //@line 14240
   }
   if (($n_sroa_0_0_extract_trunc | 0) == 0) {
    if (($rem | 0) != 0) {
     SAFE_HEAP_STORE($rem | 0, 0 | 0, 4);
     SAFE_HEAP_STORE($rem + 4 | 0, ($n_sroa_1_4_extract_trunc >>> 0) % ($d_sroa_1_4_extract_trunc >>> 0) | 0, 4);
    }
    $_0$1 = 0; //@line 14247
    $_0$0 = ($n_sroa_1_4_extract_trunc >>> 0) / ($d_sroa_1_4_extract_trunc >>> 0) >>> 0; //@line 14248
    return (setTempRet0($_0$1 | 0), $_0$0) | 0; //@line 14249
   }
   $37 = $d_sroa_1_4_extract_trunc - 1 | 0; //@line 14251
   if (($37 & $d_sroa_1_4_extract_trunc | 0) == 0) {
    if (($rem | 0) != 0) {
     SAFE_HEAP_STORE($rem | 0, 0 | $a$0 & -1 | 0, 4);
     SAFE_HEAP_STORE($rem + 4 | 0, $37 & $n_sroa_1_4_extract_trunc | $a$1 & 0 | 0, 4);
    }
    $_0$1 = 0; //@line 14257
    $_0$0 = $n_sroa_1_4_extract_trunc >>> ((_llvm_cttz_i32($d_sroa_1_4_extract_trunc | 0) | 0) >>> 0); //@line 14258
    return (setTempRet0($_0$1 | 0), $_0$0) | 0; //@line 14259
   }
   $49 = Math_clz32($d_sroa_1_4_extract_trunc | 0) | 0; //@line 14261
   $51 = $49 - (Math_clz32($n_sroa_1_4_extract_trunc | 0) | 0) | 0; //@line 14262
   if ($51 >>> 0 <= 30) {
    $57 = $51 + 1 | 0; //@line 14264
    $58 = 31 - $51 | 0; //@line 14265
    $sr_1_ph = $57; //@line 14266
    $r_sroa_0_1_ph = $n_sroa_1_4_extract_trunc << $58 | $n_sroa_0_0_extract_trunc >>> ($57 >>> 0); //@line 14267
    $r_sroa_1_1_ph = $n_sroa_1_4_extract_trunc >>> ($57 >>> 0); //@line 14268
    $q_sroa_0_1_ph = 0; //@line 14269
    $q_sroa_1_1_ph = $n_sroa_0_0_extract_trunc << $58; //@line 14270
    break;
   }
   if (($rem | 0) == 0) {
    $_0$1 = 0; //@line 14274
    $_0$0 = 0; //@line 14275
    return (setTempRet0($_0$1 | 0), $_0$0) | 0; //@line 14276
   }
   SAFE_HEAP_STORE($rem | 0, 0 | $a$0 & -1 | 0, 4);
   SAFE_HEAP_STORE($rem + 4 | 0, $n_sroa_1_4_extract_shift$0 | $a$1 & 0 | 0, 4);
   $_0$1 = 0; //@line 14280
   $_0$0 = 0; //@line 14281
   return (setTempRet0($_0$1 | 0), $_0$0) | 0; //@line 14282
  } else {
   if (!$17) {
    $117 = Math_clz32($d_sroa_1_4_extract_trunc | 0) | 0; //@line 14285
    $119 = $117 - (Math_clz32($n_sroa_1_4_extract_trunc | 0) | 0) | 0; //@line 14286
    if ($119 >>> 0 <= 31) {
     $125 = $119 + 1 | 0; //@line 14288
     $126 = 31 - $119 | 0; //@line 14289
     $130 = $119 - 31 >> 31; //@line 14290
     $sr_1_ph = $125; //@line 14291
     $r_sroa_0_1_ph = $n_sroa_0_0_extract_trunc >>> ($125 >>> 0) & $130 | $n_sroa_1_4_extract_trunc << $126; //@line 14292
     $r_sroa_1_1_ph = $n_sroa_1_4_extract_trunc >>> ($125 >>> 0) & $130; //@line 14293
     $q_sroa_0_1_ph = 0; //@line 14294
     $q_sroa_1_1_ph = $n_sroa_0_0_extract_trunc << $126; //@line 14295
     break;
    }
    if (($rem | 0) == 0) {
     $_0$1 = 0; //@line 14299
     $_0$0 = 0; //@line 14300
     return (setTempRet0($_0$1 | 0), $_0$0) | 0; //@line 14301
    }
    SAFE_HEAP_STORE($rem | 0, 0 | $a$0 & -1 | 0, 4);
    SAFE_HEAP_STORE($rem + 4 | 0, $n_sroa_1_4_extract_shift$0 | $a$1 & 0 | 0, 4);
    $_0$1 = 0; //@line 14305
    $_0$0 = 0; //@line 14306
    return (setTempRet0($_0$1 | 0), $_0$0) | 0; //@line 14307
   }
   $66 = $d_sroa_0_0_extract_trunc - 1 | 0; //@line 14309
   if (($66 & $d_sroa_0_0_extract_trunc | 0) != 0) {
    $86 = (Math_clz32($d_sroa_0_0_extract_trunc | 0) | 0) + 33 | 0; //@line 14311
    $88 = $86 - (Math_clz32($n_sroa_1_4_extract_trunc | 0) | 0) | 0; //@line 14312
    $89 = 64 - $88 | 0; //@line 14313
    $91 = 32 - $88 | 0; //@line 14314
    $92 = $91 >> 31; //@line 14315
    $95 = $88 - 32 | 0; //@line 14316
    $105 = $95 >> 31; //@line 14317
    $sr_1_ph = $88; //@line 14318
    $r_sroa_0_1_ph = $91 - 1 >> 31 & $n_sroa_1_4_extract_trunc >>> ($95 >>> 0) | ($n_sroa_1_4_extract_trunc << $91 | $n_sroa_0_0_extract_trunc >>> ($88 >>> 0)) & $105; //@line 14319
    $r_sroa_1_1_ph = $105 & $n_sroa_1_4_extract_trunc >>> ($88 >>> 0); //@line 14320
    $q_sroa_0_1_ph = $n_sroa_0_0_extract_trunc << $89 & $92; //@line 14321
    $q_sroa_1_1_ph = ($n_sroa_1_4_extract_trunc << $89 | $n_sroa_0_0_extract_trunc >>> ($95 >>> 0)) & $92 | $n_sroa_0_0_extract_trunc << $91 & $88 - 33 >> 31; //@line 14322
    break;
   }
   if (($rem | 0) != 0) {
    SAFE_HEAP_STORE($rem | 0, $66 & $n_sroa_0_0_extract_trunc | 0, 4);
    SAFE_HEAP_STORE($rem + 4 | 0, 0 | 0, 4);
   }
   if (($d_sroa_0_0_extract_trunc | 0) == 1) {
    $_0$1 = $n_sroa_1_4_extract_shift$0 | $a$1 & 0; //@line 14330
    $_0$0 = 0 | $a$0 & -1; //@line 14331
    return (setTempRet0($_0$1 | 0), $_0$0) | 0; //@line 14332
   } else {
    $78 = _llvm_cttz_i32($d_sroa_0_0_extract_trunc | 0) | 0; //@line 14334
    $_0$1 = 0 | $n_sroa_1_4_extract_trunc >>> ($78 >>> 0); //@line 14335
    $_0$0 = $n_sroa_1_4_extract_trunc << 32 - $78 | $n_sroa_0_0_extract_trunc >>> ($78 >>> 0) | 0; //@line 14336
    return (setTempRet0($_0$1 | 0), $_0$0) | 0; //@line 14337
   }
  }
 } while (0);
 if (($sr_1_ph | 0) == 0) {
  $q_sroa_1_1_lcssa = $q_sroa_1_1_ph; //@line 14342
  $q_sroa_0_1_lcssa = $q_sroa_0_1_ph; //@line 14343
  $r_sroa_1_1_lcssa = $r_sroa_1_1_ph; //@line 14344
  $r_sroa_0_1_lcssa = $r_sroa_0_1_ph; //@line 14345
  $carry_0_lcssa$1 = 0; //@line 14346
  $carry_0_lcssa$0 = 0; //@line 14347
 } else {
  $d_sroa_0_0_insert_insert99$0 = 0 | $b$0 & -1; //@line 14349
  $d_sroa_0_0_insert_insert99$1 = $d_sroa_1_4_extract_shift$0 | $b$1 & 0; //@line 14350
  $137$0 = _i64Add($d_sroa_0_0_insert_insert99$0 | 0, $d_sroa_0_0_insert_insert99$1 | 0, -1, -1) | 0; //@line 14351
  $137$1 = getTempRet0() | 0; //@line 14352
  $q_sroa_1_1198 = $q_sroa_1_1_ph; //@line 14353
  $q_sroa_0_1199 = $q_sroa_0_1_ph; //@line 14354
  $r_sroa_1_1200 = $r_sroa_1_1_ph; //@line 14355
  $r_sroa_0_1201 = $r_sroa_0_1_ph; //@line 14356
  $sr_1202 = $sr_1_ph; //@line 14357
  $carry_0203 = 0; //@line 14358
  while (1) {
   $147 = $q_sroa_0_1199 >>> 31 | $q_sroa_1_1198 << 1; //@line 14360
   $149 = $carry_0203 | $q_sroa_0_1199 << 1; //@line 14361
   $r_sroa_0_0_insert_insert42$0 = 0 | ($r_sroa_0_1201 << 1 | $q_sroa_1_1198 >>> 31); //@line 14362
   $r_sroa_0_0_insert_insert42$1 = $r_sroa_0_1201 >>> 31 | $r_sroa_1_1200 << 1 | 0; //@line 14363
   _i64Subtract($137$0 | 0, $137$1 | 0, $r_sroa_0_0_insert_insert42$0 | 0, $r_sroa_0_0_insert_insert42$1 | 0) | 0; //@line 14364
   $150$1 = getTempRet0() | 0; //@line 14365
   $151$0 = $150$1 >> 31 | (($150$1 | 0) < 0 ? -1 : 0) << 1; //@line 14366
   $152 = $151$0 & 1; //@line 14367
   $154$0 = _i64Subtract($r_sroa_0_0_insert_insert42$0 | 0, $r_sroa_0_0_insert_insert42$1 | 0, $151$0 & $d_sroa_0_0_insert_insert99$0 | 0, ((($150$1 | 0) < 0 ? -1 : 0) >> 31 | (($150$1 | 0) < 0 ? -1 : 0) << 1) & $d_sroa_0_0_insert_insert99$1 | 0) | 0; //@line 14368
   $r_sroa_0_0_extract_trunc = $154$0; //@line 14369
   $r_sroa_1_4_extract_trunc = getTempRet0() | 0; //@line 14370
   $155 = $sr_1202 - 1 | 0; //@line 14371
   if (($155 | 0) == 0) {
    break;
   } else {
    $q_sroa_1_1198 = $147; //@line 14375
    $q_sroa_0_1199 = $149; //@line 14376
    $r_sroa_1_1200 = $r_sroa_1_4_extract_trunc; //@line 14377
    $r_sroa_0_1201 = $r_sroa_0_0_extract_trunc; //@line 14378
    $sr_1202 = $155; //@line 14379
    $carry_0203 = $152; //@line 14380
   }
  }
  $q_sroa_1_1_lcssa = $147; //@line 14383
  $q_sroa_0_1_lcssa = $149; //@line 14384
  $r_sroa_1_1_lcssa = $r_sroa_1_4_extract_trunc; //@line 14385
  $r_sroa_0_1_lcssa = $r_sroa_0_0_extract_trunc; //@line 14386
  $carry_0_lcssa$1 = 0; //@line 14387
  $carry_0_lcssa$0 = $152; //@line 14388
 }
 $q_sroa_0_0_insert_ext75$0 = $q_sroa_0_1_lcssa; //@line 14390
 $q_sroa_0_0_insert_ext75$1 = 0; //@line 14391
 $q_sroa_0_0_insert_insert77$1 = $q_sroa_1_1_lcssa | $q_sroa_0_0_insert_ext75$1; //@line 14392
 if (($rem | 0) != 0) {
  SAFE_HEAP_STORE($rem | 0, 0 | $r_sroa_0_1_lcssa | 0, 4);
  SAFE_HEAP_STORE($rem + 4 | 0, $r_sroa_1_1_lcssa | 0 | 0, 4);
 }
 $_0$1 = (0 | $q_sroa_0_0_insert_ext75$0) >>> 31 | $q_sroa_0_0_insert_insert77$1 << 1 | ($q_sroa_0_0_insert_ext75$1 << 1 | $q_sroa_0_0_insert_ext75$0 >>> 31) & 0 | $carry_0_lcssa$1; //@line 14397
 $_0$0 = ($q_sroa_0_0_insert_ext75$0 << 1 | 0 >>> 31) & -2 | $carry_0_lcssa$0; //@line 14398
 return (setTempRet0($_0$1 | 0), $_0$0) | 0; //@line 14399
}
function _applyImpulse_237($0, $1) {
 $0 = $0 | 0; //@line 3067
 $1 = +$1; //@line 3068
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0; //@line 3069
 var $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0.0, $30 = 0, $31 = 0, $32 = 0, $33 = 0; //@line 3070
 var $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0.0, $4 = 0, $40 = 0.0, $41 = 0.0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $6 = 0, $7 = 0; //@line 3071
 var $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3072
 sp = STACKTOP; //@line 3073
 STACKTOP = STACKTOP + 416 | 0; //@line 3074
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(416 | 0); //@line 3074
 $$byval_copy13 = sp + 376 | 0; //@line 3075
 $$byval_copy12 = sp + 360 | 0; //@line 3076
 $$byval_copy11 = sp + 344 | 0; //@line 3077
 $$byval_copy10 = sp + 328 | 0; //@line 3078
 $$byval_copy9 = sp + 312 | 0; //@line 3079
 $$byval_copy8 = sp + 296 | 0; //@line 3080
 $$byval_copy7 = sp + 280 | 0; //@line 3081
 $$byval_copy6 = sp + 264 | 0; //@line 3082
 $$byval_copy5 = sp + 248 | 0; //@line 3083
 $$byval_copy4 = sp + 216 | 0; //@line 3084
 $$byval_copy3 = sp + 200 | 0; //@line 3085
 $$byval_copy2 = sp + 184 | 0; //@line 3086
 $$byval_copy1 = sp + 168 | 0; //@line 3087
 $$byval_copy = sp + 152 | 0; //@line 3088
 $6 = sp + 128 | 0; //@line 3089
 $7 = sp + 112 | 0; //@line 3090
 $8 = sp + 96 | 0; //@line 3091
 $9 = sp + 80 | 0; //@line 3092
 $10 = sp + 64 | 0; //@line 3093
 $11 = sp + 48 | 0; //@line 3094
 $12 = sp + 32 | 0; //@line 3095
 $13 = sp + 16 | 0; //@line 3096
 $14 = sp; //@line 3097
 $2 = $0; //@line 3098
 $3 = $1; //@line 3099
 $15 = $2; //@line 3100
 $16 = $15 + 8 | 0; //@line 3101
 $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 3102
 $4 = $17; //@line 3103
 $18 = $2; //@line 3104
 $19 = $18 + 12 | 0; //@line 3105
 $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 3106
 $5 = $20; //@line 3107
 $21 = $2; //@line 3108
 $22 = $21 + 96 | 0; //@line 3109
 SAFE_HEAP_STORE($6 | 0, SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 4 | 0, SAFE_HEAP_LOAD($22 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 8 | 0, SAFE_HEAP_LOAD($22 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 12 | 0, SAFE_HEAP_LOAD($22 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $23 = $2; //@line 3111
 $24 = $23 + 112 | 0; //@line 3112
 SAFE_HEAP_STORE($7 | 0, SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 4 | 0, SAFE_HEAP_LOAD($24 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 8 | 0, SAFE_HEAP_LOAD($24 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 12 | 0, SAFE_HEAP_LOAD($24 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $25 = $4; //@line 3114
 $26 = $5; //@line 3115
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _relative_velocity_241($8, $25, $26, $$byval_copy, $$byval_copy1); //@line 3118
 $27 = $2; //@line 3119
 $28 = $27 + 128 | 0; //@line 3120
 $29 = $2; //@line 3121
 $30 = $29 + 176 | 0; //@line 3122
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($30 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($30 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($30 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_242($10, $$byval_copy2, $$byval_copy3); //@line 3125
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($28 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($28 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($28 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($28 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 16 | 0, SAFE_HEAP_LOAD($28 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 20 | 0, SAFE_HEAP_LOAD($28 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 24 | 0, SAFE_HEAP_LOAD($28 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 28 | 0, SAFE_HEAP_LOAD($28 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpMat2x2Transform_243($9, $$byval_copy4, $$byval_copy5); //@line 3128
 $31 = $2; //@line 3129
 $32 = $31 + 160 | 0; //@line 3130
 SAFE_HEAP_STORE($11 | 0, SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 4 | 0, SAFE_HEAP_LOAD($32 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 8 | 0, SAFE_HEAP_LOAD($32 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 12 | 0, SAFE_HEAP_LOAD($32 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $33 = $2; //@line 3132
 $34 = $33 + 160 | 0; //@line 3133
 $35 = $2; //@line 3134
 $36 = $35 + 160 | 0; //@line 3135
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($36 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($36 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($36 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($36 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_244($12, $$byval_copy6, $$byval_copy7); //@line 3138
 $37 = $2; //@line 3139
 $38 = $37 + 24 | 0; //@line 3140
 $39 = +(+SAFE_HEAP_LOAD_D($38 | 0, 8)); //@line 3141
 $40 = $3; //@line 3142
 $41 = $39 * $40; //@line 3143
 SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvclamp_245($13, $$byval_copy8, $41); //@line 3145
 SAFE_HEAP_STORE($34 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($34 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($34 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($34 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $42 = $2; //@line 3147
 $43 = $42 + 160 | 0; //@line 3148
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($43 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($43 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($43 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($43 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_242($14, $$byval_copy9, $$byval_copy10); //@line 3151
 SAFE_HEAP_STORE($9 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($9 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($9 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($9 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $44 = $4; //@line 3153
 $45 = $5; //@line 3154
 $46 = $2; //@line 3155
 $47 = $46 + 96 | 0; //@line 3156
 $48 = $2; //@line 3157
 $49 = $48 + 112 | 0; //@line 3158
 SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($47 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($47 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($47 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($47 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 | 0, SAFE_HEAP_LOAD($49 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 4 | 0, SAFE_HEAP_LOAD($49 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 8 | 0, SAFE_HEAP_LOAD($49 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy12 + 12 | 0, SAFE_HEAP_LOAD($49 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _apply_impulses_246($44, $45, $$byval_copy11, $$byval_copy12, $$byval_copy13); //@line 3162
 STACKTOP = sp; //@line 3163
 return;
}
function _SupportEdgeForPoly($0, $1, $2) {
 $0 = $0 | 0; //@line 131
 $1 = $1 | 0; //@line 132
 $2 = $2 | 0; //@line 133
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0; //@line 134
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0; //@line 135
 var $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0.0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0.0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0; //@line 136
 var $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0.0, $72 = 0, $73 = 0, $74 = 0; //@line 137
 var $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0; //@line 138
 var $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0.0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 139
 sp = STACKTOP; //@line 140
 STACKTOP = STACKTOP + 256 | 0; //@line 141
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(256 | 0); //@line 141
 $$byval_copy4 = sp + 208 | 0; //@line 142
 $$byval_copy3 = sp + 192 | 0; //@line 143
 $$byval_copy2 = sp + 176 | 0; //@line 144
 $$byval_copy1 = sp + 160 | 0; //@line 145
 $$byval_copy = sp + 144 | 0; //@line 146
 $10 = sp + 72 | 0; //@line 147
 $11 = sp; //@line 148
 $3 = $1; //@line 149
 $12 = $3; //@line 150
 $13 = $12 + 168 | 0; //@line 151
 $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 152
 $4 = $14; //@line 153
 $15 = $3; //@line 154
 $16 = $15 + 168 | 0; //@line 155
 $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 156
 $18 = $3; //@line 157
 $19 = $18 + 172 | 0; //@line 158
 $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 159
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $21 = _PolySupportPointIndex($17, $20, $$byval_copy) | 0; //@line 161
 $5 = $21; //@line 162
 $22 = $5; //@line 163
 $23 = $22 - 1 | 0; //@line 164
 $24 = $4; //@line 165
 $25 = $23 + $24 | 0; //@line 166
 $26 = $4; //@line 167
 $27 = ($25 | 0) % ($26 | 0) & -1; //@line 168
 $6 = $27; //@line 169
 $28 = $5; //@line 170
 $29 = $28 + 1 | 0; //@line 171
 $30 = $4; //@line 172
 $31 = ($29 | 0) % ($30 | 0) & -1; //@line 173
 $7 = $31; //@line 174
 $32 = $3; //@line 175
 $33 = $32 + 172 | 0; //@line 176
 $34 = SAFE_HEAP_LOAD($33 | 0, 4, 0) | 0 | 0; //@line 177
 $8 = $34; //@line 178
 $35 = $3; //@line 179
 $36 = $35 + 156 | 0; //@line 180
 $37 = SAFE_HEAP_LOAD($36 | 0, 4, 0) | 0 | 0; //@line 181
 $9 = $37; //@line 182
 $38 = $8; //@line 183
 $39 = $5; //@line 184
 $40 = $38 + ($39 << 5) | 0; //@line 185
 $41 = $40 + 16 | 0; //@line 186
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($41 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($41 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($41 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $42 = +_cpvdot_68($$byval_copy1, $$byval_copy2); //@line 189
 $43 = $8; //@line 190
 $44 = $7; //@line 191
 $45 = $43 + ($44 << 5) | 0; //@line 192
 $46 = $45 + 16 | 0; //@line 193
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($46 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($46 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($46 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($46 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $47 = +_cpvdot_68($$byval_copy3, $$byval_copy4); //@line 196
 $48 = $42 > $47; //@line 197
 if ($48) {
  $49 = $8; //@line 199
  $50 = $6; //@line 200
  $51 = $49 + ($50 << 5) | 0; //@line 201
  SAFE_HEAP_STORE($10 | 0, SAFE_HEAP_LOAD($51 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($10 + 4 | 0, SAFE_HEAP_LOAD($51 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($10 + 8 | 0, SAFE_HEAP_LOAD($51 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($10 + 12 | 0, SAFE_HEAP_LOAD($51 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $52 = $10 + 16 | 0; //@line 203
  $53 = $9; //@line 204
  $54 = Math_imul($53, -950046239) | 0; //@line 205
  $55 = $6; //@line 206
  $56 = Math_imul($55, -950046239) | 0; //@line 207
  $57 = $54 ^ $56; //@line 208
  SAFE_HEAP_STORE($52 | 0, $57 | 0, 4);
  $58 = $10 + 24 | 0; //@line 210
  $59 = $8; //@line 211
  $60 = $5; //@line 212
  $61 = $59 + ($60 << 5) | 0; //@line 213
  SAFE_HEAP_STORE($58 | 0, SAFE_HEAP_LOAD($61 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($58 + 4 | 0, SAFE_HEAP_LOAD($61 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($58 + 8 | 0, SAFE_HEAP_LOAD($61 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($58 + 12 | 0, SAFE_HEAP_LOAD($61 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $62 = $58 + 16 | 0; //@line 215
  $63 = $9; //@line 216
  $64 = Math_imul($63, -950046239) | 0; //@line 217
  $65 = $5; //@line 218
  $66 = Math_imul($65, -950046239) | 0; //@line 219
  $67 = $64 ^ $66; //@line 220
  SAFE_HEAP_STORE($62 | 0, $67 | 0, 4);
  $68 = $10 + 48 | 0; //@line 222
  $69 = $3; //@line 223
  $70 = $69 + 160 | 0; //@line 224
  $71 = +(+SAFE_HEAP_LOAD_D($70 | 0, 8)); //@line 225
  SAFE_HEAP_STORE_D($68 | 0, +$71, 8);
  $72 = $10 + 56 | 0; //@line 227
  $73 = $8; //@line 228
  $74 = $5; //@line 229
  $75 = $73 + ($74 << 5) | 0; //@line 230
  $76 = $75 + 16 | 0; //@line 231
  SAFE_HEAP_STORE($72 | 0, SAFE_HEAP_LOAD($76 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($72 + 4 | 0, SAFE_HEAP_LOAD($76 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($72 + 8 | 0, SAFE_HEAP_LOAD($76 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($72 + 12 | 0, SAFE_HEAP_LOAD($76 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = $0; //@line 233
  src = $10; //@line 233
  stop = dest + 72 | 0; //@line 233
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 233
   src = src + 4 | 0; //@line 233
  } while ((dest | 0) < (stop | 0));
  STACKTOP = sp; //@line 234
  return;
 } else {
  $77 = $8; //@line 236
  $78 = $5; //@line 237
  $79 = $77 + ($78 << 5) | 0; //@line 238
  SAFE_HEAP_STORE($11 | 0, SAFE_HEAP_LOAD($79 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($11 + 4 | 0, SAFE_HEAP_LOAD($79 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($11 + 8 | 0, SAFE_HEAP_LOAD($79 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($11 + 12 | 0, SAFE_HEAP_LOAD($79 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $80 = $11 + 16 | 0; //@line 240
  $81 = $9; //@line 241
  $82 = Math_imul($81, -950046239) | 0; //@line 242
  $83 = $5; //@line 243
  $84 = Math_imul($83, -950046239) | 0; //@line 244
  $85 = $82 ^ $84; //@line 245
  SAFE_HEAP_STORE($80 | 0, $85 | 0, 4);
  $86 = $11 + 24 | 0; //@line 247
  $87 = $8; //@line 248
  $88 = $7; //@line 249
  $89 = $87 + ($88 << 5) | 0; //@line 250
  SAFE_HEAP_STORE($86 | 0, SAFE_HEAP_LOAD($89 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($86 + 4 | 0, SAFE_HEAP_LOAD($89 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($86 + 8 | 0, SAFE_HEAP_LOAD($89 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($86 + 12 | 0, SAFE_HEAP_LOAD($89 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $90 = $86 + 16 | 0; //@line 252
  $91 = $9; //@line 253
  $92 = Math_imul($91, -950046239) | 0; //@line 254
  $93 = $7; //@line 255
  $94 = Math_imul($93, -950046239) | 0; //@line 256
  $95 = $92 ^ $94; //@line 257
  SAFE_HEAP_STORE($90 | 0, $95 | 0, 4);
  $96 = $11 + 48 | 0; //@line 259
  $97 = $3; //@line 260
  $98 = $97 + 160 | 0; //@line 261
  $99 = +(+SAFE_HEAP_LOAD_D($98 | 0, 8)); //@line 262
  SAFE_HEAP_STORE_D($96 | 0, +$99, 8);
  $100 = $11 + 56 | 0; //@line 264
  $101 = $8; //@line 265
  $102 = $7; //@line 266
  $103 = $101 + ($102 << 5) | 0; //@line 267
  $104 = $103 + 16 | 0; //@line 268
  SAFE_HEAP_STORE($100 | 0, SAFE_HEAP_LOAD($104 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($100 + 4 | 0, SAFE_HEAP_LOAD($104 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($100 + 8 | 0, SAFE_HEAP_LOAD($104 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($100 + 12 | 0, SAFE_HEAP_LOAD($104 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = $0; //@line 270
  src = $11; //@line 270
  stop = dest + 72 | 0; //@line 270
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 270
   src = src + 4 | 0; //@line 270
  } while ((dest | 0) < (stop | 0));
  STACKTOP = sp; //@line 271
  return;
 }
}
function _cpSpaceActivateBody($0, $1) {
 $0 = $0 | 0; //@line 1992
 $1 = $1 | 0; //@line 1993
 var $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0; //@line 1994
 var $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0; //@line 1995
 var $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0; //@line 1996
 var $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0; //@line 1997
 var $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0; //@line 1998
 var $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0; //@line 1999
 var $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0; //@line 2000
 var $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0; //@line 2001
 sp = STACKTOP; //@line 2002
 STACKTOP = STACKTOP + 80 | 0; //@line 2003
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(80 | 0); //@line 2003
 $vararg_buffer1 = sp + 8 | 0; //@line 2004
 $vararg_buffer = sp; //@line 2005
 $11 = sp + 24 | 0; //@line 2006
 $2 = $0; //@line 2007
 $3 = $1; //@line 2008
 $15 = $3; //@line 2009
 $16 = _cpBodyGetType($15) | 0; //@line 2010
 $17 = ($16 | 0) == 0; //@line 2011
 if (!$17) {
  _cpMessage(7834, 7878, 31, 1, 1, 7946, $vararg_buffer); //@line 2013
  _abort(); //@line 2014
 }
 $18 = $2; //@line 2017
 $19 = $18 + 140 | 0; //@line 2018
 $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 2019
 $21 = ($20 | 0) != 0; //@line 2020
 if ($21) {
  $22 = $2; //@line 2022
  $23 = $22 + 96 | 0; //@line 2023
  $24 = SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0; //@line 2024
  $25 = $3; //@line 2025
  $26 = _cpArrayContains($24, $25) | 0; //@line 2026
  $27 = $26 << 24 >> 24 != 0; //@line 2027
  if ($27) {
   STACKTOP = sp; //@line 2029
   return;
  }
  $28 = $2; //@line 2031
  $29 = $28 + 96 | 0; //@line 2032
  $30 = SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0; //@line 2033
  $31 = $3; //@line 2034
  _cpArrayPush($30, $31); //@line 2035
  STACKTOP = sp; //@line 2036
  return;
 }
 $32 = $3; //@line 2038
 $33 = $32 + 224 | 0; //@line 2039
 $34 = SAFE_HEAP_LOAD($33 | 0, 4, 0) | 0 | 0; //@line 2040
 $35 = ($34 | 0) == (0 | 0); //@line 2041
 if (!$35) {
  _cpMessage(8005, 7878, 37, 1, 0, 8064, $vararg_buffer1); //@line 2043
  _abort(); //@line 2044
 }
 $36 = $3; //@line 2047
 $37 = $36 + 224 | 0; //@line 2048
 $38 = $37 + 4 | 0; //@line 2049
 $39 = SAFE_HEAP_LOAD($38 | 0, 4, 0) | 0 | 0; //@line 2050
 $40 = ($39 | 0) == (0 | 0); //@line 2051
 if (!$40) {
  _cpMessage(8005, 7878, 37, 1, 0, 8064, $vararg_buffer1); //@line 2053
  _abort(); //@line 2054
 }
 $41 = $2; //@line 2057
 $42 = $41 + 88 | 0; //@line 2058
 $43 = SAFE_HEAP_LOAD($42 | 0, 4, 0) | 0 | 0; //@line 2059
 $44 = $3; //@line 2060
 _cpArrayPush($43, $44); //@line 2061
 $45 = $3; //@line 2062
 $46 = $45 + 212 | 0; //@line 2063
 $47 = SAFE_HEAP_LOAD($46 | 0, 4, 0) | 0 | 0; //@line 2064
 $4 = $47; //@line 2065
 while (1) {
  $48 = $4; //@line 2067
  $49 = ($48 | 0) != (0 | 0); //@line 2068
  if (!$49) {
   break;
  }
  $50 = $2; //@line 2072
  $51 = $50 + 108 | 0; //@line 2073
  $52 = SAFE_HEAP_LOAD($51 | 0, 4, 0) | 0 | 0; //@line 2074
  $53 = $4; //@line 2075
  $54 = $4; //@line 2076
  $55 = $54 + 156 | 0; //@line 2077
  $56 = SAFE_HEAP_LOAD($55 | 0, 4, 0) | 0 | 0; //@line 2078
  _cpSpatialIndexRemove_480($52, $53, $56); //@line 2079
  $57 = $2; //@line 2080
  $58 = $57 + 112 | 0; //@line 2081
  $59 = SAFE_HEAP_LOAD($58 | 0, 4, 0) | 0 | 0; //@line 2082
  $60 = $4; //@line 2083
  $61 = $4; //@line 2084
  $62 = $61 + 156 | 0; //@line 2085
  $63 = SAFE_HEAP_LOAD($62 | 0, 4, 0) | 0 | 0; //@line 2086
  _cpSpatialIndexInsert_481($59, $60, $63); //@line 2087
  $64 = $4; //@line 2088
  $65 = $64 + 148 | 0; //@line 2089
  $66 = SAFE_HEAP_LOAD($65 | 0, 4, 0) | 0 | 0; //@line 2090
  $4 = $66; //@line 2091
 }
 $67 = $3; //@line 2093
 $68 = $67 + 216 | 0; //@line 2094
 $69 = SAFE_HEAP_LOAD($68 | 0, 4, 0) | 0 | 0; //@line 2095
 $5 = $69; //@line 2096
 while (1) {
  $70 = $5; //@line 2098
  $71 = ($70 | 0) != (0 | 0); //@line 2099
  if (!$71) {
   break;
  }
  $72 = $5; //@line 2103
  $73 = $72 + 44 | 0; //@line 2104
  $74 = SAFE_HEAP_LOAD($73 | 0, 4, 0) | 0 | 0; //@line 2105
  $6 = $74; //@line 2106
  $75 = $3; //@line 2107
  $76 = $6; //@line 2108
  $77 = ($75 | 0) == ($76 | 0); //@line 2109
  if ($77) {
   label = 16; //@line 2111
  } else {
   $78 = $6; //@line 2113
   $79 = _cpBodyGetType($78) | 0; //@line 2114
   $80 = ($79 | 0) == 2; //@line 2115
   if ($80) {
    label = 16; //@line 2117
   }
  }
  if ((label | 0) == 16) {
   label = 0; //@line 2121
   $81 = $5; //@line 2122
   $82 = $81 + 68 | 0; //@line 2123
   $83 = SAFE_HEAP_LOAD($82 | 0, 4, 0) | 0 | 0; //@line 2124
   $7 = $83; //@line 2125
   $84 = $5; //@line 2126
   $85 = $84 + 72 | 0; //@line 2127
   $86 = SAFE_HEAP_LOAD($85 | 0, 4, 0) | 0 | 0; //@line 2128
   $8 = $86; //@line 2129
   $87 = $2; //@line 2130
   $88 = _cpContactBufferGetArray($87) | 0; //@line 2131
   $89 = $5; //@line 2132
   $90 = $89 + 72 | 0; //@line 2133
   SAFE_HEAP_STORE($90 | 0, $88 | 0, 4);
   $91 = $5; //@line 2135
   $92 = $91 + 72 | 0; //@line 2136
   $93 = SAFE_HEAP_LOAD($92 | 0, 4, 0) | 0 | 0; //@line 2137
   $94 = $8; //@line 2138
   $95 = $7; //@line 2139
   $96 = $95 * 96 | 0; //@line 2140
   _memcpy($93 | 0, $94 | 0, $96 | 0) | 0; //@line 2141
   $97 = $2; //@line 2142
   $98 = $7; //@line 2143
   _cpSpacePushContacts($97, $98); //@line 2144
   $99 = $5; //@line 2145
   $100 = $99 + 36 | 0; //@line 2146
   $101 = SAFE_HEAP_LOAD($100 | 0, 4, 0) | 0 | 0; //@line 2147
   $9 = $101; //@line 2148
   $102 = $5; //@line 2149
   $103 = $102 + 40 | 0; //@line 2150
   $104 = SAFE_HEAP_LOAD($103 | 0, 4, 0) | 0 | 0; //@line 2151
   $10 = $104; //@line 2152
   $105 = $9; //@line 2153
   SAFE_HEAP_STORE($11 | 0, $105 | 0, 4);
   $106 = $11 + 4 | 0; //@line 2155
   $107 = $10; //@line 2156
   SAFE_HEAP_STORE($106 | 0, $107 | 0, 4);
   $108 = $9; //@line 2158
   $109 = $108; //@line 2159
   $110 = Math_imul($109, -950046239) | 0; //@line 2160
   $111 = $10; //@line 2161
   $112 = $111; //@line 2162
   $113 = Math_imul($112, -950046239) | 0; //@line 2163
   $114 = $110 ^ $113; //@line 2164
   $12 = $114; //@line 2165
   $115 = $2; //@line 2166
   $116 = $115 + 128 | 0; //@line 2167
   $117 = SAFE_HEAP_LOAD($116 | 0, 4, 0) | 0 | 0; //@line 2168
   $118 = $12; //@line 2169
   $119 = $5; //@line 2170
   _cpHashSetInsert($117, $118, $11, 0, $119) | 0; //@line 2171
   $120 = $2; //@line 2172
   $121 = $120 + 72 | 0; //@line 2173
   $122 = SAFE_HEAP_LOAD($121 | 0, 4, 0) | 0 | 0; //@line 2174
   $123 = $5; //@line 2175
   $124 = $123 + 112 | 0; //@line 2176
   SAFE_HEAP_STORE($124 | 0, $122 | 0, 4);
   $125 = $2; //@line 2178
   $126 = $125 + 120 | 0; //@line 2179
   $127 = SAFE_HEAP_LOAD($126 | 0, 4, 0) | 0 | 0; //@line 2180
   $128 = $5; //@line 2181
   _cpArrayPush($127, $128); //@line 2182
   $129 = $8; //@line 2183
   _free($129); //@line 2184
  }
  $130 = $5; //@line 2186
  $131 = $3; //@line 2187
  $132 = _cpArbiterNext_482($130, $131) | 0; //@line 2188
  $5 = $132; //@line 2189
 }
 $133 = $3; //@line 2191
 $134 = $133 + 220 | 0; //@line 2192
 $135 = SAFE_HEAP_LOAD($134 | 0, 4, 0) | 0 | 0; //@line 2193
 $13 = $135; //@line 2194
 while (1) {
  $136 = $13; //@line 2196
  $137 = ($136 | 0) != (0 | 0); //@line 2197
  if (!$137) {
   break;
  }
  $138 = $13; //@line 2201
  $139 = $138 + 8 | 0; //@line 2202
  $140 = SAFE_HEAP_LOAD($139 | 0, 4, 0) | 0 | 0; //@line 2203
  $14 = $140; //@line 2204
  $141 = $3; //@line 2205
  $142 = $14; //@line 2206
  $143 = ($141 | 0) == ($142 | 0); //@line 2207
  if ($143) {
   label = 22; //@line 2209
  } else {
   $144 = $14; //@line 2211
   $145 = _cpBodyGetType($144) | 0; //@line 2212
   $146 = ($145 | 0) == 2; //@line 2213
   if ($146) {
    label = 22; //@line 2215
   }
  }
  if ((label | 0) == 22) {
   label = 0; //@line 2219
   $147 = $2; //@line 2220
   $148 = $147 + 116 | 0; //@line 2221
   $149 = SAFE_HEAP_LOAD($148 | 0, 4, 0) | 0 | 0; //@line 2222
   $150 = $13; //@line 2223
   _cpArrayPush($149, $150); //@line 2224
  }
  $151 = $13; //@line 2226
  $152 = $3; //@line 2227
  $153 = _cpConstraintNext_483($151, $152) | 0; //@line 2228
  $13 = $153; //@line 2229
 }
 STACKTOP = sp; //@line 2231
 return;
}
function _CircleToCircle($0, $1, $2) {
 $0 = $0 | 0; //@line 7704
 $1 = $1 | 0; //@line 7705
 $2 = $2 | 0; //@line 7706
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0; //@line 7707
 var $18 = 0, $19 = 0.0, $20 = 0, $21 = 0, $22 = 0.0, $23 = 0.0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0.0, $29 = 0.0, $3 = 0, $30 = 0.0, $31 = 0.0, $32 = 0.0, $33 = 0, $34 = 0.0, $35 = 0.0, $36 = 0; //@line 7708
 var $37 = 0, $38 = 0.0, $39 = 0, $4 = 0, $40 = 0.0, $41 = 0.0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0.0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0.0, $53 = 0.0, $6 = 0.0; //@line 7709
 var $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0; //@line 7710
 sp = STACKTOP; //@line 7711
 STACKTOP = STACKTOP + 368 | 0; //@line 7712
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(368 | 0); //@line 7712
 $$byval_copy11 = sp + 328 | 0; //@line 7713
 $$byval_copy10 = sp + 312 | 0; //@line 7714
 $$byval_copy9 = sp + 296 | 0; //@line 7715
 $$byval_copy8 = sp + 280 | 0; //@line 7716
 $$byval_copy7 = sp + 264 | 0; //@line 7717
 $$byval_copy6 = sp + 248 | 0; //@line 7718
 $$byval_copy5 = sp + 232 | 0; //@line 7719
 $$byval_copy4 = sp + 216 | 0; //@line 7720
 $$byval_copy3 = sp + 200 | 0; //@line 7721
 $$byval_copy2 = sp + 184 | 0; //@line 7722
 $$byval_copy1 = sp + 168 | 0; //@line 7723
 $$byval_copy = sp + 152 | 0; //@line 7724
 $7 = sp + 128 | 0; //@line 7725
 $10 = sp + 96 | 0; //@line 7726
 $11 = sp + 80 | 0; //@line 7727
 $12 = sp + 64 | 0; //@line 7728
 $13 = sp + 48 | 0; //@line 7729
 $14 = sp + 32 | 0; //@line 7730
 $15 = sp + 16 | 0; //@line 7731
 $16 = sp; //@line 7732
 $3 = $0; //@line 7733
 $4 = $1; //@line 7734
 $5 = $2; //@line 7735
 $17 = $3; //@line 7736
 $18 = $17 + 192 | 0; //@line 7737
 $19 = +(+SAFE_HEAP_LOAD_D($18 | 0, 8)); //@line 7738
 $20 = $4; //@line 7739
 $21 = $20 + 192 | 0; //@line 7740
 $22 = +(+SAFE_HEAP_LOAD_D($21 | 0, 8)); //@line 7741
 $23 = $19 + $22; //@line 7742
 $6 = $23; //@line 7743
 $24 = $4; //@line 7744
 $25 = $24 + 176 | 0; //@line 7745
 $26 = $3; //@line 7746
 $27 = $26 + 176 | 0; //@line 7747
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($25 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($25 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($25 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($27 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($27 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($27 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_67($7, $$byval_copy, $$byval_copy1); //@line 7750
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $28 = +_cpvlengthsq_79($$byval_copy2); //@line 7752
 $8 = $28; //@line 7753
 $29 = $8; //@line 7754
 $30 = $6; //@line 7755
 $31 = $6; //@line 7756
 $32 = $30 * $31; //@line 7757
 $33 = $29 < $32; //@line 7758
 if (!$33) {
  STACKTOP = sp; //@line 7760
  return;
 }
 $34 = $8; //@line 7762
 $35 = +Math_sqrt(+$34); //@line 7763
 $9 = $35; //@line 7764
 $36 = $5; //@line 7765
 $37 = $36 + 16 | 0; //@line 7766
 $38 = $9; //@line 7767
 $39 = $38 != 0.0; //@line 7768
 if ($39) {
  $40 = $9; //@line 7770
  $41 = 1.0 / $40; //@line 7771
  SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvmult_64($11, $$byval_copy3, $41); //@line 7773
  SAFE_HEAP_STORE($37 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($37 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($37 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($37 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 } else {
  _cpv_72($12, 1.0, 0.0); //@line 7776
  SAFE_HEAP_STORE($37 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($37 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($37 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($37 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 }
 SAFE_HEAP_STORE($10 | 0, SAFE_HEAP_LOAD($37 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 4 | 0, SAFE_HEAP_LOAD($37 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 8 | 0, SAFE_HEAP_LOAD($37 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 12 | 0, SAFE_HEAP_LOAD($37 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $42 = $5; //@line 7780
 $43 = $3; //@line 7781
 $44 = $43 + 176 | 0; //@line 7782
 $45 = $3; //@line 7783
 $46 = $45 + 192 | 0; //@line 7784
 $47 = +(+SAFE_HEAP_LOAD_D($46 | 0, 8)); //@line 7785
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_64($14, $$byval_copy4, $47); //@line 7787
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($44 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($44 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($44 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($44 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_66($13, $$byval_copy5, $$byval_copy6); //@line 7790
 $48 = $4; //@line 7791
 $49 = $48 + 176 | 0; //@line 7792
 $50 = $4; //@line 7793
 $51 = $50 + 192 | 0; //@line 7794
 $52 = +(+SAFE_HEAP_LOAD_D($51 | 0, 8)); //@line 7795
 $53 = -$52; //@line 7796
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_64($16, $$byval_copy7, $53); //@line 7798
 SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($49 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($49 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($49 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($49 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($16 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($16 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($16 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_66($15, $$byval_copy8, $$byval_copy9); //@line 7801
 SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($15 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($15 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($15 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpCollisionInfoPushContact($42, $$byval_copy10, $$byval_copy11, 0); //@line 7804
 STACKTOP = sp; //@line 7805
 return;
}
function _cpMomentForPoly($0, $1, $2, $3, $4) {
 $0 = +$0; //@line 435
 $1 = $1 | 0; //@line 436
 $2 = $2 | 0; //@line 437
 $3 = $3 | 0; //@line 438
 $4 = +$4; //@line 439
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy10 = 0, $$byval_copy11 = 0, $$byval_copy12 = 0, $$byval_copy13 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0.0, $11 = 0.0, $12 = 0, $13 = 0, $14 = 0, $15 = 0.0; //@line 440
 var $16 = 0.0, $17 = 0, $18 = 0, $19 = 0.0, $20 = 0, $21 = 0, $22 = 0, $23 = 0.0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0;
 var $36 = 0.0, $37 = 0.0, $38 = 0.0, $39 = 0.0, $40 = 0.0, $41 = 0.0, $42 = 0.0, $43 = 0.0, $44 = 0.0, $45 = 0.0, $46 = 0.0, $47 = 0.0, $48 = 0.0, $49 = 0.0, $5 = 0.0, $50 = 0, $51 = 0, $52 = 0.0, $53 = 0.0, $54 = 0.0;
 var $55 = 0.0, $56 = 0.0, $57 = 0.0, $58 = 0.0, $6 = 0.0, $7 = 0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 444
 STACKTOP = STACKTOP + 336 | 0; //@line 445
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(336 | 0); //@line 445
 $$byval_copy13 = sp + 296 | 0; //@line 446
 $$byval_copy12 = sp + 280 | 0; //@line 447
 $$byval_copy11 = sp + 264 | 0; //@line 448
 $$byval_copy10 = sp + 248 | 0; //@line 449
 $$byval_copy9 = sp + 232 | 0; //@line 450
 $$byval_copy8 = sp + 216 | 0; //@line 451
 $$byval_copy7 = sp + 200 | 0; //@line 452
 $$byval_copy6 = sp + 184 | 0; //@line 453
 $$byval_copy5 = sp + 168 | 0; //@line 454
 $$byval_copy4 = sp + 152 | 0; //@line 455
 $$byval_copy3 = sp + 136 | 0; //@line 456
 $$byval_copy2 = sp + 120 | 0; //@line 457
 $$byval_copy1 = sp + 104 | 0; //@line 458
 $$byval_copy = sp + 88 | 0; //@line 459
 $13 = sp + 32 | 0; //@line 460
 $14 = sp + 16 | 0; //@line 461
 $6 = $0; //@line 462
 $7 = $1; //@line 463
 $8 = $2; //@line 464
 $9 = $4; //@line 465
 $17 = $7; //@line 466
 $18 = ($17 | 0) == 2; //@line 467
 if ($18) {
  $19 = $6; //@line 469
  $20 = $8; //@line 470
  $21 = $8; //@line 471
  $22 = $21 + 16 | 0; //@line 472
  SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($20 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($20 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($20 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($22 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($22 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($22 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $23 = +_cpMomentForSegment($19, $$byval_copy, $$byval_copy1, 0.0); //@line 475
  $5 = $23; //@line 476
  $58 = $5; //@line 477
  STACKTOP = sp; //@line 478
  return +$58;
 }
 $10 = 0.0; //@line 480
 $11 = 0.0; //@line 481
 $12 = 0; //@line 482
 while (1) {
  $24 = $12; //@line 484
  $25 = $7; //@line 485
  $26 = ($24 | 0) < ($25 | 0); //@line 486
  if (!$26) {
   break;
  }
  $27 = $8; //@line 490
  $28 = $12; //@line 491
  $29 = $27 + ($28 << 4) | 0; //@line 492
  SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($29 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($29 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($29 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvadd($13, $$byval_copy2, $$byval_copy3); //@line 495
  $30 = $8; //@line 496
  $31 = $12; //@line 497
  $32 = $31 + 1 | 0; //@line 498
  $33 = $7; //@line 499
  $34 = ($32 | 0) % ($33 | 0) & -1; //@line 500
  $35 = $30 + ($34 << 4) | 0; //@line 501
  SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($35 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($35 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($35 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($35 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvadd($14, $$byval_copy4, $$byval_copy5); //@line 504
  SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $36 = +_cpvcross($$byval_copy6, $$byval_copy7); //@line 507
  $15 = $36; //@line 508
  SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $37 = +_cpvdot($$byval_copy8, $$byval_copy9); //@line 511
  SAFE_HEAP_STORE($$byval_copy10 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy10 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy11 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $38 = +_cpvdot($$byval_copy10, $$byval_copy11); //@line 514
  $39 = $37 + $38; //@line 515
  SAFE_HEAP_STORE($$byval_copy12 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy12 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy12 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy12 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $40 = +_cpvdot($$byval_copy12, $$byval_copy13); //@line 518
  $41 = $39 + $40; //@line 519
  $16 = $41; //@line 520
  $42 = $15; //@line 521
  $43 = $16; //@line 522
  $44 = $42 * $43; //@line 523
  $45 = $10; //@line 524
  $46 = $45 + $44; //@line 525
  $10 = $46; //@line 526
  $47 = $15; //@line 527
  $48 = $11; //@line 528
  $49 = $48 + $47; //@line 529
  $11 = $49; //@line 530
  $50 = $12; //@line 531
  $51 = $50 + 1 | 0; //@line 532
  $12 = $51; //@line 533
 }
 $52 = $6; //@line 535
 $53 = $10; //@line 536
 $54 = $52 * $53; //@line 537
 $55 = $11; //@line 538
 $56 = 6.0 * $55; //@line 539
 $57 = $54 / $56; //@line 540
 $5 = $57; //@line 541
 $58 = $5; //@line 542
 STACKTOP = sp; //@line 543
 return +$58;
}
function _applyImpulse_396($0, $1) {
 $0 = $0 | 0; //@line 7524
 $1 = +$1; //@line 7525
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $10 = 0.0, $11 = 0.0, $12 = 0.0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0; //@line 7526
 var $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0.0, $30 = 0, $31 = 0, $32 = 0.0, $33 = 0, $34 = 0, $35 = 0.0, $36 = 0.0, $37 = 0.0, $38 = 0; //@line 7527
 var $39 = 0, $4 = 0, $40 = 0.0, $41 = 0.0, $42 = 0, $43 = 0, $44 = 0.0, $45 = 0.0, $46 = 0.0, $47 = 0.0, $48 = 0, $49 = 0, $5 = 0, $50 = 0.0, $51 = 0.0, $52 = 0.0, $53 = 0.0, $54 = 0.0, $55 = 0, $56 = 0; //@line 7528
 var $57 = 0, $58 = 0, $59 = 0.0, $6 = 0, $60 = 0.0, $61 = 0.0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0.0, $7 = 0, $8 = 0, $9 = 0, $cpvzero$399$byval_copy = 0, label = 0, sp = 0; //@line 7529
 sp = STACKTOP; //@line 7530
 STACKTOP = STACKTOP + 288 | 0; //@line 7531
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(288 | 0); //@line 7531
 $$byval_copy8 = sp + 256 | 0; //@line 7532
 $$byval_copy7 = sp + 240 | 0; //@line 7533
 $$byval_copy6 = sp + 224 | 0; //@line 7534
 $$byval_copy5 = sp + 208 | 0; //@line 7535
 $$byval_copy4 = sp + 192 | 0; //@line 7536
 $$byval_copy3 = sp + 176 | 0; //@line 7537
 $$byval_copy2 = sp + 160 | 0; //@line 7538
 $$byval_copy1 = sp + 144 | 0; //@line 7539
 $cpvzero$399$byval_copy = sp + 128 | 0; //@line 7540
 $$byval_copy = sp + 112 | 0; //@line 7541
 $6 = sp + 88 | 0; //@line 7542
 $7 = sp + 72 | 0; //@line 7543
 $8 = sp + 56 | 0; //@line 7544
 $9 = sp + 40 | 0; //@line 7545
 $13 = sp; //@line 7546
 $2 = $0; //@line 7547
 $3 = $1; //@line 7548
 $14 = $2; //@line 7549
 $15 = $14 + 144 | 0; //@line 7550
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($15 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($15 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($15 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($cpvzero$399$byval_copy | 0, SAFE_HEAP_LOAD(11264 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($cpvzero$399$byval_copy + 4 | 0, SAFE_HEAP_LOAD(11264 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($cpvzero$399$byval_copy + 8 | 0, SAFE_HEAP_LOAD(11264 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($cpvzero$399$byval_copy + 12 | 0, SAFE_HEAP_LOAD(11264 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $16 = _cpveql_400($$byval_copy, $cpvzero$399$byval_copy) | 0; //@line 7553
 $17 = $16 << 24 >> 24 != 0; //@line 7554
 if ($17) {
  STACKTOP = sp; //@line 7556
  return;
 }
 $18 = $2; //@line 7558
 $19 = $18 + 8 | 0; //@line 7559
 $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 7560
 $4 = $20; //@line 7561
 $21 = $2; //@line 7562
 $22 = $21 + 12 | 0; //@line 7563
 $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 7564
 $5 = $23; //@line 7565
 $24 = $2; //@line 7566
 $25 = $24 + 144 | 0; //@line 7567
 SAFE_HEAP_STORE($6 | 0, SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 4 | 0, SAFE_HEAP_LOAD($25 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 8 | 0, SAFE_HEAP_LOAD($25 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 12 | 0, SAFE_HEAP_LOAD($25 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $26 = $2; //@line 7569
 $27 = $26 + 112 | 0; //@line 7570
 SAFE_HEAP_STORE($7 | 0, SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 4 | 0, SAFE_HEAP_LOAD($27 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 8 | 0, SAFE_HEAP_LOAD($27 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 12 | 0, SAFE_HEAP_LOAD($27 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $28 = $2; //@line 7572
 $29 = $28 + 128 | 0; //@line 7573
 SAFE_HEAP_STORE($8 | 0, SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 4 | 0, SAFE_HEAP_LOAD($29 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 8 | 0, SAFE_HEAP_LOAD($29 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 12 | 0, SAFE_HEAP_LOAD($29 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $30 = $4; //@line 7575
 $31 = $5; //@line 7576
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _relative_velocity_401($9, $30, $31, $$byval_copy1, $$byval_copy2); //@line 7579
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $32 = +_cpvdot_402($$byval_copy3, $$byval_copy4); //@line 7582
 $10 = $32; //@line 7583
 $33 = $2; //@line 7584
 $34 = $33 + 176 | 0; //@line 7585
 $35 = +(+SAFE_HEAP_LOAD_D($34 | 0, 8)); //@line 7586
 $36 = $10; //@line 7587
 $37 = $35 - $36; //@line 7588
 $38 = $2; //@line 7589
 $39 = $38 + 160 | 0; //@line 7590
 $40 = +(+SAFE_HEAP_LOAD_D($39 | 0, 8)); //@line 7591
 $41 = $37 * $40; //@line 7592
 $11 = $41; //@line 7593
 $42 = $2; //@line 7594
 $43 = $42 + 168 | 0; //@line 7595
 $44 = +(+SAFE_HEAP_LOAD_D($43 | 0, 8)); //@line 7596
 $12 = $44; //@line 7597
 $45 = $12; //@line 7598
 $46 = $11; //@line 7599
 $47 = $45 + $46; //@line 7600
 $48 = $2; //@line 7601
 $49 = $48 + 24 | 0; //@line 7602
 $50 = +(+SAFE_HEAP_LOAD_D($49 | 0, 8)); //@line 7603
 $51 = -$50; //@line 7604
 $52 = $3; //@line 7605
 $53 = $51 * $52; //@line 7606
 $54 = +_cpfclamp_403($47, $53, 0.0); //@line 7607
 $55 = $2; //@line 7608
 $56 = $55 + 168 | 0; //@line 7609
 SAFE_HEAP_STORE_D($56 | 0, +$54, 8);
 $57 = $2; //@line 7611
 $58 = $57 + 168 | 0; //@line 7612
 $59 = +(+SAFE_HEAP_LOAD_D($58 | 0, 8)); //@line 7613
 $60 = $12; //@line 7614
 $61 = $59 - $60; //@line 7615
 $11 = $61; //@line 7616
 $62 = $4; //@line 7617
 $63 = $5; //@line 7618
 $64 = $2; //@line 7619
 $65 = $64 + 112 | 0; //@line 7620
 $66 = $2; //@line 7621
 $67 = $66 + 128 | 0; //@line 7622
 $68 = $11; //@line 7623
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_404($13, $$byval_copy5, $68); //@line 7625
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($65 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($65 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($65 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($65 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($67 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($67 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($67 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($67 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _apply_impulses_405($62, $63, $$byval_copy6, $$byval_copy7, $$byval_copy8); //@line 7629
 STACKTOP = sp; //@line 7630
 return;
}
function _cpSpaceCollideShapes($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 4460
 $1 = $1 | 0; //@line 4461
 $2 = $2 | 0; //@line 4462
 $3 = $3 | 0; //@line 4463
 var $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0.0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0.0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0; //@line 4464
 var $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0; //@line 4465
 var $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0; //@line 4466
 var $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0; //@line 4467
 var $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0; //@line 4468
 var $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0; //@line 4469
 var $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, label = 0, sp = 0; //@line 4470
 sp = STACKTOP; //@line 4471
 STACKTOP = STACKTOP + 96 | 0; //@line 4472
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(96 | 0); //@line 4472
 $9 = sp; //@line 4473
 $10 = sp + 56 | 0; //@line 4474
 $5 = $0; //@line 4475
 $6 = $1; //@line 4476
 $7 = $2; //@line 4477
 $8 = $3; //@line 4478
 $14 = $5; //@line 4479
 $15 = $6; //@line 4480
 $16 = _QueryReject($14, $15) | 0; //@line 4481
 $17 = $16 << 24 >> 24 != 0; //@line 4482
 if ($17) {
  $18 = $7; //@line 4484
  $4 = $18; //@line 4485
  $135 = $4; //@line 4486
  STACKTOP = sp; //@line 4487
  return $135 | 0; //@line 4487
 }
 $19 = $5; //@line 4489
 $20 = $6; //@line 4490
 $21 = $7; //@line 4491
 $22 = $8; //@line 4492
 $23 = _cpContactBufferGetArray($22) | 0; //@line 4493
 _cpCollide($9, $19, $20, $21, $23); //@line 4494
 $24 = $9 + 32 | 0; //@line 4495
 $25 = SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0; //@line 4496
 $26 = ($25 | 0) == 0; //@line 4497
 if ($26) {
  $27 = $9 + 8 | 0; //@line 4499
  $28 = SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0; //@line 4500
  $4 = $28; //@line 4501
  $135 = $4; //@line 4502
  STACKTOP = sp; //@line 4503
  return $135 | 0; //@line 4503
 }
 $29 = $8; //@line 4505
 $30 = $9 + 32 | 0; //@line 4506
 $31 = SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0; //@line 4507
 _cpSpacePushContacts($29, $31); //@line 4508
 $32 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 4509
 SAFE_HEAP_STORE($10 | 0, $32 | 0, 4);
 $33 = $10 + 4 | 0; //@line 4511
 $34 = $9 + 4 | 0; //@line 4512
 $35 = SAFE_HEAP_LOAD($34 | 0, 4, 0) | 0 | 0; //@line 4513
 SAFE_HEAP_STORE($33 | 0, $35 | 0, 4);
 $36 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 4515
 $37 = $36; //@line 4516
 $38 = Math_imul($37, -950046239) | 0; //@line 4517
 $39 = $9 + 4 | 0; //@line 4518
 $40 = SAFE_HEAP_LOAD($39 | 0, 4, 0) | 0 | 0; //@line 4519
 $41 = $40; //@line 4520
 $42 = Math_imul($41, -950046239) | 0; //@line 4521
 $43 = $38 ^ $42; //@line 4522
 $11 = $43; //@line 4523
 $44 = $8; //@line 4524
 $45 = $44 + 128 | 0; //@line 4525
 $46 = SAFE_HEAP_LOAD($45 | 0, 4, 0) | 0 | 0; //@line 4526
 $47 = $11; //@line 4527
 $48 = $8; //@line 4528
 $49 = _cpHashSetInsert($46, $47, $10, 73, $48) | 0; //@line 4529
 $12 = $49; //@line 4530
 $50 = $12; //@line 4531
 $51 = $8; //@line 4532
 _cpArbiterUpdate($50, $9, $51); //@line 4533
 $52 = $12; //@line 4534
 $53 = $52 + 96 | 0; //@line 4535
 $54 = SAFE_HEAP_LOAD($53 | 0, 4, 0) | 0 | 0; //@line 4536
 $13 = $54; //@line 4537
 $55 = $12; //@line 4538
 $56 = $55 + 116 | 0; //@line 4539
 $57 = SAFE_HEAP_LOAD($56 | 0, 4, 0) | 0 | 0; //@line 4540
 $58 = ($57 | 0) == 0; //@line 4541
 if ($58) {
  $59 = $13; //@line 4543
  $60 = $59 + 8 | 0; //@line 4544
  $61 = SAFE_HEAP_LOAD($60 | 0, 4, 0) | 0 | 0; //@line 4545
  $62 = $12; //@line 4546
  $63 = $8; //@line 4547
  $64 = $13; //@line 4548
  $65 = $64 + 24 | 0; //@line 4549
  $66 = SAFE_HEAP_LOAD($65 | 0, 4, 0) | 0 | 0; //@line 4550
  $67 = FUNCTION_TABLE_iiii[(SAFE_FT_MASK($61 | 0, 127 | 0) | 0) & 127]($62, $63, $66) | 0; //@line 4551
  $68 = $67 << 24 >> 24 != 0; //@line 4552
  if (!$68) {
   $69 = $12; //@line 4554
   _cpArbiterIgnore($69) | 0; //@line 4555
  }
 }
 $70 = $12; //@line 4558
 $71 = $70 + 116 | 0; //@line 4559
 $72 = SAFE_HEAP_LOAD($71 | 0, 4, 0) | 0 | 0; //@line 4560
 $73 = ($72 | 0) != 2; //@line 4561
 do {
  if ($73) {
   $74 = $13; //@line 4564
   $75 = $74 + 12 | 0; //@line 4565
   $76 = SAFE_HEAP_LOAD($75 | 0, 4, 0) | 0 | 0; //@line 4566
   $77 = $12; //@line 4567
   $78 = $8; //@line 4568
   $79 = $13; //@line 4569
   $80 = $79 + 24 | 0; //@line 4570
   $81 = SAFE_HEAP_LOAD($80 | 0, 4, 0) | 0 | 0; //@line 4571
   $82 = FUNCTION_TABLE_iiii[(SAFE_FT_MASK($76 | 0, 127 | 0) | 0) & 127]($77, $78, $81) | 0; //@line 4572
   $83 = $82 & 255; //@line 4573
   $84 = ($83 | 0) != 0; //@line 4574
   if ($84) {
    $85 = $12; //@line 4576
    $86 = $85 + 116 | 0; //@line 4577
    $87 = SAFE_HEAP_LOAD($86 | 0, 4, 0) | 0 | 0; //@line 4578
    $88 = ($87 | 0) != 2; //@line 4579
    if ($88) {
     $89 = $5; //@line 4581
     $90 = $89 + 88 | 0; //@line 4582
     $91 = SAFE_HEAP_LOAD($90 >> 0 | 0, 1, 0) | 0 | 0; //@line 4583
     $92 = $91 & 255; //@line 4584
     $93 = ($92 | 0) != 0; //@line 4585
     if ($93) {
      label = 16; //@line 4587
     } else {
      $94 = $6; //@line 4589
      $95 = $94 + 88 | 0; //@line 4590
      $96 = SAFE_HEAP_LOAD($95 >> 0 | 0, 1, 0) | 0 | 0; //@line 4591
      $97 = $96 & 255; //@line 4592
      $98 = ($97 | 0) != 0; //@line 4593
      if ($98) {
       label = 16; //@line 4595
      } else {
       $99 = $5; //@line 4597
       $100 = $99 + 8 | 0; //@line 4598
       $101 = SAFE_HEAP_LOAD($100 | 0, 4, 0) | 0 | 0; //@line 4599
       $102 = $101 + 8 | 0; //@line 4600
       $103 = +(+SAFE_HEAP_LOAD_D($102 | 0, 8)); //@line 4601
       $104 = $103 == inf; //@line 4602
       if ($104) {
        $105 = $6; //@line 4604
        $106 = $105 + 8 | 0; //@line 4605
        $107 = SAFE_HEAP_LOAD($106 | 0, 4, 0) | 0 | 0; //@line 4606
        $108 = $107 + 8 | 0; //@line 4607
        $109 = +(+SAFE_HEAP_LOAD_D($108 | 0, 8)); //@line 4608
        $110 = $109 == inf; //@line 4609
        if ($110) {
         label = 16; //@line 4611
         break;
        }
       }
       $111 = $8; //@line 4615
       $112 = $111 + 120 | 0; //@line 4616
       $113 = SAFE_HEAP_LOAD($112 | 0, 4, 0) | 0 | 0; //@line 4617
       $114 = $12; //@line 4618
       _cpArrayPush($113, $114); //@line 4619
      }
     }
    } else {
     label = 16; //@line 4623
    }
   } else {
    label = 16; //@line 4626
   }
  } else {
   label = 16; //@line 4629
  }
 } while (0);
 if ((label | 0) == 16) {
  $115 = $8; //@line 4633
  $116 = $9 + 32 | 0; //@line 4634
  $117 = SAFE_HEAP_LOAD($116 | 0, 4, 0) | 0 | 0; //@line 4635
  _cpSpacePopContacts($115, $117); //@line 4636
  $118 = $12; //@line 4637
  $119 = $118 + 72 | 0; //@line 4638
  SAFE_HEAP_STORE($119 | 0, 0 | 0, 4);
  $120 = $12; //@line 4640
  $121 = $120 + 68 | 0; //@line 4641
  SAFE_HEAP_STORE($121 | 0, 0 | 0, 4);
  $122 = $12; //@line 4643
  $123 = $122 + 116 | 0; //@line 4644
  $124 = SAFE_HEAP_LOAD($123 | 0, 4, 0) | 0 | 0; //@line 4645
  $125 = ($124 | 0) != 2; //@line 4646
  if ($125) {
   $126 = $12; //@line 4648
   $127 = $126 + 116 | 0; //@line 4649
   SAFE_HEAP_STORE($127 | 0, 1 | 0, 4);
  }
 }
 $128 = $8; //@line 4653
 $129 = $128 + 72 | 0; //@line 4654
 $130 = SAFE_HEAP_LOAD($129 | 0, 4, 0) | 0 | 0; //@line 4655
 $131 = $12; //@line 4656
 $132 = $131 + 112 | 0; //@line 4657
 SAFE_HEAP_STORE($132 | 0, $130 | 0, 4);
 $133 = $9 + 8 | 0; //@line 4659
 $134 = SAFE_HEAP_LOAD($133 | 0, 4, 0) | 0 | 0; //@line 4660
 $4 = $134; //@line 4661
 $135 = $4; //@line 4662
 STACKTOP = sp; //@line 4663
 return $135 | 0; //@line 4663
}
function _cpShapesCollide($0, $1, $2) {
 $0 = $0 | 0; //@line 5659
 $1 = $1 | 0; //@line 5660
 $2 = $2 | 0; //@line 5661
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0; //@line 5662
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0; //@line 5663
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0.0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0; //@line 5664
 var dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 5665
 sp = STACKTOP; //@line 5666
 STACKTOP = STACKTOP + 496 | 0; //@line 5667
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(496 | 0); //@line 5667
 $$byval_copy4 = sp + 464 | 0; //@line 5668
 $$byval_copy3 = sp + 448 | 0; //@line 5669
 $$byval_copy2 = sp + 432 | 0; //@line 5670
 $$byval_copy1 = sp + 416 | 0; //@line 5671
 $$byval_copy = sp + 400 | 0; //@line 5672
 $5 = sp; //@line 5673
 $6 = sp + 360 | 0; //@line 5674
 $7 = sp + 256 | 0; //@line 5675
 $9 = sp + 240 | 0; //@line 5676
 $11 = sp + 224 | 0; //@line 5677
 $12 = sp + 208 | 0; //@line 5678
 $13 = sp + 192 | 0; //@line 5679
 $3 = $1; //@line 5680
 $4 = $2; //@line 5681
 $14 = $3; //@line 5682
 $15 = $4; //@line 5683
 _cpCollide($6, $14, $15, 0, $5); //@line 5684
 $16 = $6 + 32 | 0; //@line 5685
 $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 5686
 SAFE_HEAP_STORE($7 | 0, $17 | 0, 4);
 $18 = $3; //@line 5688
 $19 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 5689
 $20 = ($18 | 0) != ($19 | 0); //@line 5690
 $21 = $20 & 1; //@line 5691
 $22 = $21 & 255; //@line 5692
 $8 = $22; //@line 5693
 $23 = $7 + 8 | 0; //@line 5694
 $24 = $8; //@line 5695
 $25 = $24 & 255; //@line 5696
 $26 = ($25 | 0) != 0; //@line 5697
 $27 = $6 + 16 | 0; //@line 5698
 if ($26) {
  SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($27 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($27 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($27 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvneg_360($9, $$byval_copy); //@line 5701
  SAFE_HEAP_STORE($23 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($23 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($23 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($23 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 } else {
  SAFE_HEAP_STORE($23 | 0, SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($23 + 4 | 0, SAFE_HEAP_LOAD($27 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($23 + 8 | 0, SAFE_HEAP_LOAD($27 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($23 + 12 | 0, SAFE_HEAP_LOAD($27 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 }
 $10 = 0; //@line 5706
 while (1) {
  $28 = $10; //@line 5708
  $29 = $6 + 32 | 0; //@line 5709
  $30 = SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0; //@line 5710
  $31 = ($28 | 0) < ($30 | 0); //@line 5711
  if (!$31) {
   break;
  }
  $32 = $10; //@line 5715
  $33 = $5 + ($32 * 96 | 0) | 0; //@line 5716
  SAFE_HEAP_STORE($11 | 0, SAFE_HEAP_LOAD($33 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($11 + 4 | 0, SAFE_HEAP_LOAD($33 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($11 + 8 | 0, SAFE_HEAP_LOAD($33 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($11 + 12 | 0, SAFE_HEAP_LOAD($33 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $34 = $10; //@line 5718
  $35 = $5 + ($34 * 96 | 0) | 0; //@line 5719
  $36 = $35 + 16 | 0; //@line 5720
  SAFE_HEAP_STORE($12 | 0, SAFE_HEAP_LOAD($36 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($12 + 4 | 0, SAFE_HEAP_LOAD($36 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($12 + 8 | 0, SAFE_HEAP_LOAD($36 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($12 + 12 | 0, SAFE_HEAP_LOAD($36 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $37 = $7 + 24 | 0; //@line 5722
  $38 = $10; //@line 5723
  $39 = $37 + ($38 * 40 | 0) | 0; //@line 5724
  $40 = $8; //@line 5725
  $41 = $40 & 255; //@line 5726
  $42 = ($41 | 0) != 0; //@line 5727
  if ($42) {
   SAFE_HEAP_STORE($39 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($39 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($39 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($39 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  } else {
   SAFE_HEAP_STORE($39 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($39 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($39 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($39 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  }
  $43 = $7 + 24 | 0; //@line 5733
  $44 = $10; //@line 5734
  $45 = $43 + ($44 * 40 | 0) | 0; //@line 5735
  $46 = $45 + 16 | 0; //@line 5736
  $47 = $8; //@line 5737
  $48 = $47 & 255; //@line 5738
  $49 = ($48 | 0) != 0; //@line 5739
  if ($49) {
   SAFE_HEAP_STORE($46 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($46 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($46 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($46 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  } else {
   SAFE_HEAP_STORE($46 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($46 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($46 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($46 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  }
  SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvsub_354($13, $$byval_copy1, $$byval_copy2); //@line 5747
  $50 = $7 + 8 | 0; //@line 5748
  SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($50 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($50 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($50 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($50 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $51 = +_cpvdot_359($$byval_copy3, $$byval_copy4); //@line 5751
  $52 = $7 + 24 | 0; //@line 5752
  $53 = $10; //@line 5753
  $54 = $52 + ($53 * 40 | 0) | 0; //@line 5754
  $55 = $54 + 32 | 0; //@line 5755
  SAFE_HEAP_STORE_D($55 | 0, +$51, 8);
  $56 = $10; //@line 5757
  $57 = $56 + 1 | 0; //@line 5758
  $10 = $57; //@line 5759
 }
 dest = $0; //@line 5761
 src = $7; //@line 5761
 stop = dest + 104 | 0; //@line 5761
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 5761
  src = src + 4 | 0; //@line 5761
 } while ((dest | 0) < (stop | 0));
 STACKTOP = sp; //@line 5762
 return;
}
function _cpSegmentShapeCacheData($0, $1, $2) {
 $0 = $0 | 0; //@line 6465
 $1 = $1 | 0; //@line 6466
 $2 = $2 | 0; //@line 6467
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $10 = 0.0, $11 = 0.0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0; //@line 6468
 var $24 = 0, $25 = 0, $26 = 0.0, $27 = 0, $28 = 0, $29 = 0.0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0.0, $34 = 0, $35 = 0, $36 = 0.0, $37 = 0, $38 = 0.0, $39 = 0, $4 = 0, $40 = 0, $41 = 0.0; //@line 6469
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0.0, $46 = 0, $47 = 0, $48 = 0, $49 = 0.0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0.0, $55 = 0, $56 = 0, $57 = 0, $58 = 0.0, $59 = 0, $6 = 0; //@line 6470
 var $60 = 0, $61 = 0.0, $62 = 0, $63 = 0, $64 = 0, $65 = 0.0, $66 = 0, $67 = 0, $68 = 0.0, $69 = 0.0, $7 = 0.0, $70 = 0.0, $71 = 0.0, $72 = 0.0, $73 = 0.0, $74 = 0.0, $75 = 0.0, $76 = 0.0, $77 = 0.0, $78 = 0.0; //@line 6471
 var $79 = 0.0, $8 = 0.0, $80 = 0.0, $9 = 0.0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP; //@line 6473
 STACKTOP = STACKTOP + 288 | 0; //@line 6474
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(288 | 0); //@line 6474
 $$byval_copy5 = sp + 264 | 0; //@line 6475
 $$byval_copy4 = sp + 216 | 0; //@line 6476
 $$byval_copy3 = sp + 200 | 0; //@line 6477
 $$byval_copy2 = sp + 152 | 0; //@line 6478
 $$byval_copy1 = sp + 136 | 0; //@line 6479
 $$byval_copy = sp + 88 | 0; //@line 6480
 $4 = sp + 72 | 0; //@line 6481
 $5 = sp + 56 | 0; //@line 6482
 $6 = sp + 40 | 0; //@line 6483
 $3 = $1; //@line 6484
 $12 = $3; //@line 6485
 $13 = $12 + 208 | 0; //@line 6486
 $14 = $3; //@line 6487
 $15 = $14 + 160 | 0; //@line 6488
 dest = $$byval_copy; //@line 6489
 src = $2; //@line 6489
 stop = dest + 48 | 0; //@line 6489
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 6489
  src = src + 4 | 0; //@line 6489
 } while ((dest | 0) < (stop | 0));
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($15 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($15 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($15 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpTransformPoint_364($4, $$byval_copy, $$byval_copy1); //@line 6491
 SAFE_HEAP_STORE($13 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($13 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($13 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($13 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $16 = $3; //@line 6493
 $17 = $16 + 224 | 0; //@line 6494
 $18 = $3; //@line 6495
 $19 = $18 + 176 | 0; //@line 6496
 dest = $$byval_copy2; //@line 6497
 src = $2; //@line 6497
 stop = dest + 48 | 0; //@line 6497
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 6497
  src = src + 4 | 0; //@line 6497
 } while ((dest | 0) < (stop | 0));
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($19 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($19 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($19 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpTransformPoint_364($5, $$byval_copy2, $$byval_copy3); //@line 6499
 SAFE_HEAP_STORE($17 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($17 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($17 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($17 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $20 = $3; //@line 6501
 $21 = $20 + 240 | 0; //@line 6502
 $22 = $3; //@line 6503
 $23 = $22 + 192 | 0; //@line 6504
 dest = $$byval_copy4; //@line 6505
 src = $2; //@line 6505
 stop = dest + 48 | 0; //@line 6505
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 6505
  src = src + 4 | 0; //@line 6505
 } while ((dest | 0) < (stop | 0));
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($23 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($23 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($23 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpTransformVect_375($6, $$byval_copy4, $$byval_copy5); //@line 6507
 SAFE_HEAP_STORE($21 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($21 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($21 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($21 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $24 = $3; //@line 6509
 $25 = $24 + 208 | 0; //@line 6510
 $26 = +(+SAFE_HEAP_LOAD_D($25 | 0, 8)); //@line 6511
 $27 = $3; //@line 6512
 $28 = $27 + 224 | 0; //@line 6513
 $29 = +(+SAFE_HEAP_LOAD_D($28 | 0, 8)); //@line 6514
 $30 = $26 < $29; //@line 6515
 $31 = $3; //@line 6516
 if ($30) {
  $32 = $31 + 208 | 0; //@line 6518
  $33 = +(+SAFE_HEAP_LOAD_D($32 | 0, 8)); //@line 6519
  $7 = $33; //@line 6520
  $34 = $3; //@line 6521
  $35 = $34 + 224 | 0; //@line 6522
  $36 = +(+SAFE_HEAP_LOAD_D($35 | 0, 8)); //@line 6523
  $8 = $36; //@line 6524
 } else {
  $37 = $31 + 224 | 0; //@line 6526
  $38 = +(+SAFE_HEAP_LOAD_D($37 | 0, 8)); //@line 6527
  $7 = $38; //@line 6528
  $39 = $3; //@line 6529
  $40 = $39 + 208 | 0; //@line 6530
  $41 = +(+SAFE_HEAP_LOAD_D($40 | 0, 8)); //@line 6531
  $8 = $41; //@line 6532
 }
 $42 = $3; //@line 6534
 $43 = $42 + 208 | 0; //@line 6535
 $44 = $43 + 8 | 0; //@line 6536
 $45 = +(+SAFE_HEAP_LOAD_D($44 | 0, 8)); //@line 6537
 $46 = $3; //@line 6538
 $47 = $46 + 224 | 0; //@line 6539
 $48 = $47 + 8 | 0; //@line 6540
 $49 = +(+SAFE_HEAP_LOAD_D($48 | 0, 8)); //@line 6541
 $50 = $45 < $49; //@line 6542
 $51 = $3; //@line 6543
 if ($50) {
  $52 = $51 + 208 | 0; //@line 6545
  $53 = $52 + 8 | 0; //@line 6546
  $54 = +(+SAFE_HEAP_LOAD_D($53 | 0, 8)); //@line 6547
  $9 = $54; //@line 6548
  $55 = $3; //@line 6549
  $56 = $55 + 224 | 0; //@line 6550
  $57 = $56 + 8 | 0; //@line 6551
  $58 = +(+SAFE_HEAP_LOAD_D($57 | 0, 8)); //@line 6552
  $10 = $58; //@line 6553
  $66 = $3; //@line 6554
  $67 = $66 + 256 | 0; //@line 6555
  $68 = +(+SAFE_HEAP_LOAD_D($67 | 0, 8)); //@line 6556
  $11 = $68; //@line 6557
  $69 = $7; //@line 6558
  $70 = $11; //@line 6559
  $71 = $69 - $70; //@line 6560
  $72 = $9; //@line 6561
  $73 = $11; //@line 6562
  $74 = $72 - $73; //@line 6563
  $75 = $8; //@line 6564
  $76 = $11; //@line 6565
  $77 = $75 + $76; //@line 6566
  $78 = $10; //@line 6567
  $79 = $11; //@line 6568
  $80 = $78 + $79; //@line 6569
  _cpBBNew_365($0, $71, $74, $77, $80); //@line 6570
  STACKTOP = sp; //@line 6571
  return;
 } else {
  $59 = $51 + 224 | 0; //@line 6573
  $60 = $59 + 8 | 0; //@line 6574
  $61 = +(+SAFE_HEAP_LOAD_D($60 | 0, 8)); //@line 6575
  $9 = $61; //@line 6576
  $62 = $3; //@line 6577
  $63 = $62 + 208 | 0; //@line 6578
  $64 = $63 + 8 | 0; //@line 6579
  $65 = +(+SAFE_HEAP_LOAD_D($64 | 0, 8)); //@line 6580
  $10 = $65; //@line 6581
  $66 = $3; //@line 6582
  $67 = $66 + 256 | 0; //@line 6583
  $68 = +(+SAFE_HEAP_LOAD_D($67 | 0, 8)); //@line 6584
  $11 = $68; //@line 6585
  $69 = $7; //@line 6586
  $70 = $11; //@line 6587
  $71 = $69 - $70; //@line 6588
  $72 = $9; //@line 6589
  $73 = $11; //@line 6590
  $74 = $72 - $73; //@line 6591
  $75 = $8; //@line 6592
  $76 = $11; //@line 6593
  $77 = $75 + $76; //@line 6594
  $78 = $10; //@line 6595
  $79 = $11; //@line 6596
  $80 = $78 + $79; //@line 6597
  _cpBBNew_365($0, $71, $74, $77, $80); //@line 6598
  STACKTOP = sp; //@line 6599
  return;
 }
}
function _cpSegmentShapePointQuery($0, $1, $2) {
 $0 = $0 | 0; //@line 6603
 $1 = $1 | 0; //@line 6604
 $2 = $2 | 0; //@line 6605
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0.0, $17 = 0, $18 = 0, $19 = 0.0; //@line 6606
 var $20 = 0.0, $21 = 0.0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0.0, $27 = 0, $28 = 0.0, $29 = 0.0, $3 = 0, $30 = 0.0, $31 = 0.0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0.0, $37 = 0, $38 = 0;
 var $39 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0, label = 0, sp = 0; //@line 6608
 sp = STACKTOP; //@line 6609
 STACKTOP = STACKTOP + 272 | 0; //@line 6610
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(272 | 0); //@line 6610
 $$byval_copy9 = sp + 240 | 0; //@line 6611
 $$byval_copy8 = sp + 224 | 0; //@line 6612
 $$byval_copy7 = sp + 208 | 0; //@line 6613
 $$byval_copy6 = sp + 192 | 0; //@line 6614
 $$byval_copy5 = sp + 176 | 0; //@line 6615
 $$byval_copy4 = sp + 160 | 0; //@line 6616
 $$byval_copy3 = sp + 144 | 0; //@line 6617
 $$byval_copy2 = sp + 128 | 0; //@line 6618
 $$byval_copy1 = sp + 112 | 0; //@line 6619
 $$byval_copy = sp + 96 | 0; //@line 6620
 $5 = sp + 80 | 0; //@line 6621
 $6 = sp + 64 | 0; //@line 6622
 $9 = sp + 32 | 0; //@line 6623
 $10 = sp + 16 | 0; //@line 6624
 $11 = sp; //@line 6625
 $3 = $0; //@line 6626
 $4 = $2; //@line 6627
 $12 = $3; //@line 6628
 $13 = $12 + 208 | 0; //@line 6629
 $14 = $3; //@line 6630
 $15 = $14 + 224 | 0; //@line 6631
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($15 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($15 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($15 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpClosetPointOnSegment_370($5, $$byval_copy, $$byval_copy1, $$byval_copy2); //@line 6635
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_354($6, $$byval_copy3, $$byval_copy4); //@line 6638
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $16 = +_cpvlength_356($$byval_copy5); //@line 6640
 $7 = $16; //@line 6641
 $17 = $3; //@line 6642
 $18 = $17 + 256 | 0; //@line 6643
 $19 = +(+SAFE_HEAP_LOAD_D($18 | 0, 8)); //@line 6644
 $8 = $19; //@line 6645
 $20 = $7; //@line 6646
 $21 = 1.0 / $20; //@line 6647
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_357($9, $$byval_copy6, $21); //@line 6649
 $22 = $3; //@line 6650
 $23 = $4; //@line 6651
 SAFE_HEAP_STORE($23 | 0, $22 | 0, 4);
 $24 = $4; //@line 6653
 $25 = $24 + 8 | 0; //@line 6654
 $26 = $7; //@line 6655
 $27 = $26 != 0.0; //@line 6656
 if ($27) {
  $28 = $8; //@line 6658
  SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvmult_357($10, $$byval_copy7, $28); //@line 6660
  SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvadd_363($11, $$byval_copy8, $$byval_copy9); //@line 6663
  SAFE_HEAP_STORE($25 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($25 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($25 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($25 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 } else {
  SAFE_HEAP_STORE($25 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($25 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($25 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($25 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 }
 $29 = $7; //@line 6668
 $30 = $8; //@line 6669
 $31 = $29 - $30; //@line 6670
 $32 = $4; //@line 6671
 $33 = $32 + 24 | 0; //@line 6672
 SAFE_HEAP_STORE_D($33 | 0, +$31, 8);
 $34 = $4; //@line 6674
 $35 = $34 + 32 | 0; //@line 6675
 $36 = $7; //@line 6676
 $37 = $36 > 1.0e-5; //@line 6677
 if ($37) {
  SAFE_HEAP_STORE($35 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($35 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($35 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($35 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  STACKTOP = sp; //@line 6680
  return;
 } else {
  $38 = $3; //@line 6682
  $39 = $38 + 192 | 0; //@line 6683
  SAFE_HEAP_STORE($35 | 0, SAFE_HEAP_LOAD($39 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($35 + 4 | 0, SAFE_HEAP_LOAD($39 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($35 + 8 | 0, SAFE_HEAP_LOAD($39 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($35 + 12 | 0, SAFE_HEAP_LOAD($39 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  STACKTOP = sp; //@line 6685
  return;
 }
}
function _cpBodyUpdateVelocity($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 5609
 $1 = $1 | 0; //@line 5610
 $2 = +$2; //@line 5611
 $3 = +$3; //@line 5612
 var $$byval_copy = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0.0, $18 = 0, $19 = 0, $20 = 0, $21 = 0.0, $22 = 0; //@line 5613
 var $23 = 0, $24 = 0, $25 = 0.0, $26 = 0, $27 = 0, $28 = 0.0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0.0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0.0, $39 = 0.0, $4 = 0, $40 = 0, $41 = 0; //@line 5614
 var $42 = 0.0, $43 = 0.0, $44 = 0.0, $45 = 0, $46 = 0, $47 = 0.0, $48 = 0, $49 = 0, $5 = 0.0, $50 = 0.0, $51 = 0.0, $52 = 0.0, $53 = 0.0, $54 = 0.0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0.0;
 var $60 = 0, $61 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0; //@line 5616
 sp = STACKTOP; //@line 5617
 STACKTOP = STACKTOP + 240 | 0; //@line 5618
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(240 | 0); //@line 5618
 $$byval_copy7 = sp + 208 | 0; //@line 5619
 $$byval_copy6 = sp + 192 | 0; //@line 5620
 $$byval_copy5 = sp + 176 | 0; //@line 5621
 $$byval_copy4 = sp + 160 | 0; //@line 5622
 $$byval_copy3 = sp + 144 | 0; //@line 5623
 $$byval_copy2 = sp + 128 | 0; //@line 5624
 $$byval_copy = sp + 112 | 0; //@line 5625
 $vararg_buffer = sp + 96 | 0; //@line 5626
 $7 = sp + 64 | 0; //@line 5627
 $8 = sp + 48 | 0; //@line 5628
 $9 = sp + 32 | 0; //@line 5629
 $10 = sp + 16 | 0; //@line 5630
 $11 = sp; //@line 5631
 $4 = $0; //@line 5632
 $5 = $2; //@line 5633
 $6 = $3; //@line 5634
 $12 = $4; //@line 5635
 $13 = _cpBodyGetType($12) | 0; //@line 5636
 $14 = ($13 | 0) == 1; //@line 5637
 if ($14) {
  STACKTOP = sp; //@line 5639
  return;
 }
 $15 = $4; //@line 5641
 $16 = $15 + 8 | 0; //@line 5642
 $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 5643
 $18 = $17 > 0.0; //@line 5644
 if (!$18) {
  $23 = $4; //@line 5646
  $24 = $23 + 8 | 0; //@line 5647
  $25 = +(+SAFE_HEAP_LOAD_D($24 | 0, 8)); //@line 5648
  $26 = $4; //@line 5649
  $27 = $26 + 24 | 0; //@line 5650
  $28 = +(+SAFE_HEAP_LOAD_D($27 | 0, 8)); //@line 5651
  SAFE_HEAP_STORE_D($vararg_buffer | 0, +$25, 8);
  $vararg_ptr1 = $vararg_buffer + 8 | 0; //@line 5653
  SAFE_HEAP_STORE_D($vararg_ptr1 | 0, +$28, 8);
  _cpMessage(4473, 3674, 499, 1, 0, 4506, $vararg_buffer); //@line 5655
  _abort(); //@line 5656
 }
 $19 = $4; //@line 5659
 $20 = $19 + 24 | 0; //@line 5660
 $21 = +(+SAFE_HEAP_LOAD_D($20 | 0, 8)); //@line 5661
 $22 = $21 > 0.0; //@line 5662
 if (!$22) {
  $23 = $4; //@line 5664
  $24 = $23 + 8 | 0; //@line 5665
  $25 = +(+SAFE_HEAP_LOAD_D($24 | 0, 8)); //@line 5666
  $26 = $4; //@line 5667
  $27 = $26 + 24 | 0; //@line 5668
  $28 = +(+SAFE_HEAP_LOAD_D($27 | 0, 8)); //@line 5669
  SAFE_HEAP_STORE_D($vararg_buffer | 0, +$25, 8);
  $vararg_ptr1 = $vararg_buffer + 8 | 0; //@line 5671
  SAFE_HEAP_STORE_D($vararg_ptr1 | 0, +$28, 8);
  _cpMessage(4473, 3674, 499, 1, 0, 4506, $vararg_buffer); //@line 5673
  _abort(); //@line 5674
 }
 $29 = $4; //@line 5677
 $30 = $29 + 72 | 0; //@line 5678
 $31 = $4; //@line 5679
 $32 = $31 + 72 | 0; //@line 5680
 $33 = $5; //@line 5681
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($32 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($32 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($32 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_44($7, $$byval_copy, $33); //@line 5683
 $34 = $4; //@line 5684
 $35 = $34 + 88 | 0; //@line 5685
 $36 = $4; //@line 5686
 $37 = $36 + 16 | 0; //@line 5687
 $38 = +(+SAFE_HEAP_LOAD_D($37 | 0, 8)); //@line 5688
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($35 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($35 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($35 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($35 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_44($10, $$byval_copy2, $38); //@line 5690
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_43($9, $$byval_copy3, $$byval_copy4); //@line 5693
 $39 = $6; //@line 5694
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_44($8, $$byval_copy5, $39); //@line 5696
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_43($11, $$byval_copy6, $$byval_copy7); //@line 5699
 SAFE_HEAP_STORE($30 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($30 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($30 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($30 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $40 = $4; //@line 5701
 $41 = $40 + 112 | 0; //@line 5702
 $42 = +(+SAFE_HEAP_LOAD_D($41 | 0, 8)); //@line 5703
 $43 = $5; //@line 5704
 $44 = $42 * $43; //@line 5705
 $45 = $4; //@line 5706
 $46 = $45 + 120 | 0; //@line 5707
 $47 = +(+SAFE_HEAP_LOAD_D($46 | 0, 8)); //@line 5708
 $48 = $4; //@line 5709
 $49 = $48 + 32 | 0; //@line 5710
 $50 = +(+SAFE_HEAP_LOAD_D($49 | 0, 8)); //@line 5711
 $51 = $47 * $50; //@line 5712
 $52 = $6; //@line 5713
 $53 = $51 * $52; //@line 5714
 $54 = $44 + $53; //@line 5715
 $55 = $4; //@line 5716
 $56 = $55 + 112 | 0; //@line 5717
 SAFE_HEAP_STORE_D($56 | 0, +$54, 8);
 $57 = $4; //@line 5719
 $58 = $57 + 88 | 0; //@line 5720
 SAFE_HEAP_STORE($58 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($58 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($58 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($58 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $59 = $4; //@line 5722
 $60 = $59 + 120 | 0; //@line 5723
 SAFE_HEAP_STORE_D($60 | 0, +0.0, 8);
 $61 = $4; //@line 5725
 _cpBodySanityCheck($61); //@line 5726
 STACKTOP = sp; //@line 5727
 return;
}
function _cpBodyAccumulateMassFromShapes($0) {
 $0 = $0 | 0; //@line 6566
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0; //@line 6567
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0.0, $29 = 0.0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0.0, $34 = 0.0, $35 = 0.0, $36 = 0.0, $37 = 0, $38 = 0, $39 = 0.0, $4 = 0, $40 = 0.0; //@line 6568
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0.0, $46 = 0.0, $47 = 0, $48 = 0, $49 = 0.0, $5 = 0.0, $50 = 0.0, $51 = 0.0, $52 = 0.0, $53 = 0.0, $54 = 0.0, $55 = 0, $56 = 0, $57 = 0.0, $58 = 0.0, $59 = 0; //@line 6569
 var $6 = 0.0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0.0, $66 = 0.0, $67 = 0.0, $68 = 0.0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0.0, $77 = 0.0;
 var $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0.0, $83 = 0.0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $9 = 0, label = 0, sp = 0; //@line 6571
 sp = STACKTOP; //@line 6572
 STACKTOP = STACKTOP + 144 | 0; //@line 6573
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(144 | 0); //@line 6573
 $$byval_copy4 = sp + 112 | 0; //@line 6574
 $$byval_copy3 = sp + 96 | 0; //@line 6575
 $$byval_copy2 = sp + 80 | 0; //@line 6576
 $$byval_copy1 = sp + 64 | 0; //@line 6577
 $$byval_copy = sp + 48 | 0; //@line 6578
 $2 = sp + 32 | 0; //@line 6579
 $7 = sp; //@line 6580
 $1 = $0; //@line 6581
 $8 = $1; //@line 6582
 $9 = ($8 | 0) == (0 | 0); //@line 6583
 if ($9) {
  STACKTOP = sp; //@line 6585
  return;
 }
 $10 = $1; //@line 6587
 $11 = _cpBodyGetType($10) | 0; //@line 6588
 $12 = ($11 | 0) != 0; //@line 6589
 if ($12) {
  STACKTOP = sp; //@line 6591
  return;
 }
 $13 = $1; //@line 6593
 $14 = $13 + 24 | 0; //@line 6594
 SAFE_HEAP_STORE_D($14 | 0, +0.0, 8);
 $15 = $1; //@line 6596
 $16 = $15 + 8 | 0; //@line 6597
 SAFE_HEAP_STORE_D($16 | 0, +0.0, 8);
 $17 = $1; //@line 6599
 $18 = $17 + 40 | 0; //@line 6600
 SAFE_HEAP_STORE($18 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($18 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($18 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($18 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $19 = $1; //@line 6602
 _cpBodyGetPosition($2, $19); //@line 6603
 $20 = $1; //@line 6604
 $21 = $20 + 212 | 0; //@line 6605
 $22 = SAFE_HEAP_LOAD($21 | 0, 4, 0) | 0 | 0; //@line 6606
 $3 = $22; //@line 6607
 while (1) {
  $23 = $3; //@line 6609
  $24 = ($23 | 0) != (0 | 0); //@line 6610
  if (!$24) {
   break;
  }
  $25 = $3; //@line 6614
  $26 = $25 + 16 | 0; //@line 6615
  $4 = $26; //@line 6616
  $27 = $4; //@line 6617
  $28 = +(+SAFE_HEAP_LOAD_D($27 | 0, 8)); //@line 6618
  $5 = $28; //@line 6619
  $29 = $5; //@line 6620
  $30 = $29 > 0.0; //@line 6621
  if ($30) {
   $31 = $1; //@line 6623
   $32 = $31 + 8 | 0; //@line 6624
   $33 = +(+SAFE_HEAP_LOAD_D($32 | 0, 8)); //@line 6625
   $34 = $5; //@line 6626
   $35 = $33 + $34; //@line 6627
   $6 = $35; //@line 6628
   $36 = $5; //@line 6629
   $37 = $4; //@line 6630
   $38 = $37 + 8 | 0; //@line 6631
   $39 = +(+SAFE_HEAP_LOAD_D($38 | 0, 8)); //@line 6632
   $40 = $36 * $39; //@line 6633
   $41 = $1; //@line 6634
   $42 = $41 + 40 | 0; //@line 6635
   $43 = $4; //@line 6636
   $44 = $43 + 16 | 0; //@line 6637
   SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($42 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($42 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($42 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($42 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($44 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($44 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($44 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($44 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   $45 = +_cpvdistsq($$byval_copy, $$byval_copy1); //@line 6640
   $46 = $5; //@line 6641
   $47 = $1; //@line 6642
   $48 = $47 + 8 | 0; //@line 6643
   $49 = +(+SAFE_HEAP_LOAD_D($48 | 0, 8)); //@line 6644
   $50 = $46 * $49; //@line 6645
   $51 = $45 * $50; //@line 6646
   $52 = $6; //@line 6647
   $53 = $51 / $52; //@line 6648
   $54 = $40 + $53; //@line 6649
   $55 = $1; //@line 6650
   $56 = $55 + 24 | 0; //@line 6651
   $57 = +(+SAFE_HEAP_LOAD_D($56 | 0, 8)); //@line 6652
   $58 = $57 + $54; //@line 6653
   SAFE_HEAP_STORE_D($56 | 0, +$58, 8);
   $59 = $1; //@line 6655
   $60 = $59 + 40 | 0; //@line 6656
   $61 = $1; //@line 6657
   $62 = $61 + 40 | 0; //@line 6658
   $63 = $4; //@line 6659
   $64 = $63 + 16 | 0; //@line 6660
   $65 = $5; //@line 6661
   $66 = $6; //@line 6662
   $67 = $65 / $66; //@line 6663
   SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($62 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($62 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($62 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($62 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($64 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($64 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($64 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($64 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   _cpvlerp_48($7, $$byval_copy2, $$byval_copy3, $67); //@line 6666
   SAFE_HEAP_STORE($60 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($60 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($60 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($60 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   $68 = $6; //@line 6668
   $69 = $1; //@line 6669
   $70 = $69 + 8 | 0; //@line 6670
   SAFE_HEAP_STORE_D($70 | 0, +$68, 8);
  }
  $71 = $3; //@line 6673
  $72 = $71 + 148 | 0; //@line 6674
  $73 = SAFE_HEAP_LOAD($72 | 0, 4, 0) | 0 | 0; //@line 6675
  $3 = $73; //@line 6676
 }
 $74 = $1; //@line 6678
 $75 = $74 + 8 | 0; //@line 6679
 $76 = +(+SAFE_HEAP_LOAD_D($75 | 0, 8)); //@line 6680
 $77 = 1.0 / $76; //@line 6681
 $78 = $1; //@line 6682
 $79 = $78 + 16 | 0; //@line 6683
 SAFE_HEAP_STORE_D($79 | 0, +$77, 8);
 $80 = $1; //@line 6685
 $81 = $80 + 24 | 0; //@line 6686
 $82 = +(+SAFE_HEAP_LOAD_D($81 | 0, 8)); //@line 6687
 $83 = 1.0 / $82; //@line 6688
 $84 = $1; //@line 6689
 $85 = $84 + 32 | 0; //@line 6690
 SAFE_HEAP_STORE_D($85 | 0, +$83, 8);
 $86 = $1; //@line 6692
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpBodySetPosition($86, $$byval_copy4); //@line 6694
 $87 = $1; //@line 6695
 _cpBodySanityCheck($87); //@line 6696
 STACKTOP = sp; //@line 6697
 return;
}
function _cpPolyShapeCacheData($0, $1, $2) {
 $0 = $0 | 0; //@line 4091
 $1 = $1 | 0; //@line 4092
 $2 = $2 | 0; //@line 4093
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $10 = 0.0, $11 = 0, $12 = 0, $13 = 0, $14 = 0.0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0; //@line 4094
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0.0, $43 = 0.0; //@line 4095
 var $44 = 0.0, $45 = 0.0, $46 = 0.0, $47 = 0.0, $48 = 0.0, $49 = 0, $5 = 0, $50 = 0.0, $51 = 0.0, $52 = 0.0, $53 = 0, $54 = 0.0, $55 = 0.0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0.0, $61 = 0;
 var $62 = 0, $63 = 0.0, $64 = 0.0, $65 = 0.0, $66 = 0.0, $67 = 0.0, $68 = 0.0, $69 = 0.0, $7 = 0.0, $70 = 0.0, $71 = 0.0, $72 = 0.0, $73 = 0.0, $74 = 0.0, $8 = 0.0, $9 = 0.0, dest = 0, label = 0, sp = 0, src = 0; //@line 4097
 var stop = 0; //@line 4098
 sp = STACKTOP; //@line 4099
 STACKTOP = STACKTOP + 256 | 0; //@line 4100
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(256 | 0); //@line 4100
 $$byval_copy3 = sp + 216 | 0; //@line 4101
 $$byval_copy2 = sp + 168 | 0; //@line 4102
 $$byval_copy1 = sp + 152 | 0; //@line 4103
 $$byval_copy = sp + 104 | 0; //@line 4104
 $12 = sp + 56 | 0; //@line 4105
 $13 = sp + 40 | 0; //@line 4106
 $15 = sp; //@line 4107
 $3 = $1; //@line 4108
 $16 = $3; //@line 4109
 $17 = $16 + 168 | 0; //@line 4110
 $18 = SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0; //@line 4111
 $4 = $18; //@line 4112
 $19 = $3; //@line 4113
 $20 = $19 + 172 | 0; //@line 4114
 $21 = SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0; //@line 4115
 $5 = $21; //@line 4116
 $22 = $5; //@line 4117
 $23 = $4; //@line 4118
 $24 = $22 + ($23 << 5) | 0; //@line 4119
 $6 = $24; //@line 4120
 $7 = inf; //@line 4121
 $8 = -inf; //@line 4122
 $9 = inf; //@line 4123
 $10 = -inf; //@line 4124
 $11 = 0; //@line 4125
 while (1) {
  $25 = $11; //@line 4127
  $26 = $4; //@line 4128
  $27 = ($25 | 0) < ($26 | 0); //@line 4129
  if (!$27) {
   break;
  }
  $28 = $6; //@line 4133
  $29 = $11; //@line 4134
  $30 = $28 + ($29 << 5) | 0; //@line 4135
  dest = $$byval_copy; //@line 4136
  src = $2; //@line 4136
  stop = dest + 48 | 0; //@line 4136
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 4136
   src = src + 4 | 0; //@line 4136
  } while ((dest | 0) < (stop | 0));
  SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($30 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($30 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($30 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpTransformPoint_265($12, $$byval_copy, $$byval_copy1); //@line 4138
  $31 = $6; //@line 4139
  $32 = $11; //@line 4140
  $33 = $31 + ($32 << 5) | 0; //@line 4141
  $34 = $33 + 16 | 0; //@line 4142
  dest = $$byval_copy2; //@line 4143
  src = $2; //@line 4143
  stop = dest + 48 | 0; //@line 4143
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 4143
   src = src + 4 | 0; //@line 4143
  } while ((dest | 0) < (stop | 0));
  SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($34 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($34 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($34 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($34 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpTransformVect_282($13, $$byval_copy2, $$byval_copy3); //@line 4145
  $35 = $5; //@line 4146
  $36 = $11; //@line 4147
  $37 = $35 + ($36 << 5) | 0; //@line 4148
  SAFE_HEAP_STORE($37 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($37 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($37 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($37 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $38 = $5; //@line 4150
  $39 = $11; //@line 4151
  $40 = $38 + ($39 << 5) | 0; //@line 4152
  $41 = $40 + 16 | 0; //@line 4153
  SAFE_HEAP_STORE($41 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($41 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($41 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($41 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $42 = $7; //@line 4155
  $43 = +(+SAFE_HEAP_LOAD_D($12 | 0, 8)); //@line 4156
  $44 = +_cpfmin_280($42, $43); //@line 4157
  $7 = $44; //@line 4158
  $45 = $8; //@line 4159
  $46 = +(+SAFE_HEAP_LOAD_D($12 | 0, 8)); //@line 4160
  $47 = +_cpfmax_281($45, $46); //@line 4161
  $8 = $47; //@line 4162
  $48 = $9; //@line 4163
  $49 = $12 + 8 | 0; //@line 4164
  $50 = +(+SAFE_HEAP_LOAD_D($49 | 0, 8)); //@line 4165
  $51 = +_cpfmin_280($48, $50); //@line 4166
  $9 = $51; //@line 4167
  $52 = $10; //@line 4168
  $53 = $12 + 8 | 0; //@line 4169
  $54 = +(+SAFE_HEAP_LOAD_D($53 | 0, 8)); //@line 4170
  $55 = +_cpfmax_281($52, $54); //@line 4171
  $10 = $55; //@line 4172
  $56 = $11; //@line 4173
  $57 = $56 + 1 | 0; //@line 4174
  $11 = $57; //@line 4175
 }
 $58 = $3; //@line 4177
 $59 = $58 + 160 | 0; //@line 4178
 $60 = +(+SAFE_HEAP_LOAD_D($59 | 0, 8)); //@line 4179
 $14 = $60; //@line 4180
 $61 = $3; //@line 4181
 $62 = $61 + 56 | 0; //@line 4182
 $63 = $7; //@line 4183
 $64 = $14; //@line 4184
 $65 = $63 - $64; //@line 4185
 $66 = $9; //@line 4186
 $67 = $14; //@line 4187
 $68 = $66 - $67; //@line 4188
 $69 = $8; //@line 4189
 $70 = $14; //@line 4190
 $71 = $69 + $70; //@line 4191
 $72 = $10; //@line 4192
 $73 = $14; //@line 4193
 $74 = $72 + $73; //@line 4194
 _cpBBNew_283($15, $65, $68, $71, $74); //@line 4195
 SAFE_HEAP_STORE($62 | 0, SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($62 + 4 | 0, SAFE_HEAP_LOAD($15 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($62 + 8 | 0, SAFE_HEAP_LOAD($15 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($62 + 12 | 0, SAFE_HEAP_LOAD($15 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($62 + 16 | 0, SAFE_HEAP_LOAD($15 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($62 + 20 | 0, SAFE_HEAP_LOAD($15 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($62 + 24 | 0, SAFE_HEAP_LOAD($15 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($62 + 28 | 0, SAFE_HEAP_LOAD($15 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($62 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($62 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($62 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($62 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 16 | 0, SAFE_HEAP_LOAD($62 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 20 | 0, SAFE_HEAP_LOAD($62 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 24 | 0, SAFE_HEAP_LOAD($62 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 28 | 0, SAFE_HEAP_LOAD($62 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 4198
 return;
}
function _cpBodySanityCheck($0) {
 $0 = $0 | 0; //@line 6058
 var $$byval_copy = 0, $$byval_copy13 = 0, $$byval_copy14 = 0, $1 = 0, $10 = 0, $11 = 0.0, $12 = 0, $13 = 0, $14 = 0.0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $2 = 0, $20 = 0, $21 = 0.0, $22 = 0, $23 = 0, $24 = 0; //@line 6059
 var $25 = 0.0, $26 = 0, $27 = 0, $28 = 0.0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0.0, $33 = 0, $34 = 0, $35 = 0, $36 = 0.0, $37 = 0, $38 = 0, $39 = 0, $4 = 0.0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0.0, $47 = 0, $48 = 0, $49 = 0.0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0.0, $54 = 0.0, $55 = 0, $56 = 0, $57 = 0, $58 = 0.0, $59 = 0, $6 = 0, $60 = 0; //@line 6061
 var $61 = 0.0, $62 = 0, $63 = 0, $64 = 0, $65 = 0.0, $66 = 0.0, $67 = 0, $68 = 0, $69 = 0, $7 = 0.0, $70 = 0.0, $71 = 0, $72 = 0, $73 = 0.0, $74 = 0, $75 = 0, $76 = 0, $77 = 0.0, $78 = 0.0, $79 = 0;
 var $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer11 = 0, $vararg_buffer3 = 0, $vararg_buffer5 = 0, $vararg_buffer7 = 0, $vararg_buffer9 = 0, label = 0, sp = 0; //@line 6063
 sp = STACKTOP; //@line 6064
 STACKTOP = STACKTOP + 112 | 0; //@line 6065
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 6065
 $$byval_copy14 = sp + 88 | 0; //@line 6066
 $$byval_copy13 = sp + 72 | 0; //@line 6067
 $$byval_copy = sp + 56 | 0; //@line 6068
 $vararg_buffer11 = sp + 48 | 0; //@line 6069
 $vararg_buffer9 = sp + 40 | 0; //@line 6070
 $vararg_buffer7 = sp + 32 | 0; //@line 6071
 $vararg_buffer5 = sp + 24 | 0; //@line 6072
 $vararg_buffer3 = sp + 16 | 0; //@line 6073
 $vararg_buffer1 = sp + 8 | 0; //@line 6074
 $vararg_buffer = sp; //@line 6075
 $1 = $0; //@line 6076
 $2 = $1; //@line 6077
 $3 = $2 + 8 | 0; //@line 6078
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 6079
 $5 = $1; //@line 6080
 $6 = $5 + 8 | 0; //@line 6081
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 6082
 $8 = $4 == $7; //@line 6083
 if (!$8) {
  _cpMessage(3625, 3674, 113, 1, 1, 3732, $vararg_buffer); //@line 6085
  _abort(); //@line 6086
 }
 $9 = $1; //@line 6089
 $10 = $9 + 16 | 0; //@line 6090
 $11 = +(+SAFE_HEAP_LOAD_D($10 | 0, 8)); //@line 6091
 $12 = $1; //@line 6092
 $13 = $12 + 16 | 0; //@line 6093
 $14 = +(+SAFE_HEAP_LOAD_D($13 | 0, 8)); //@line 6094
 $15 = $11 == $14; //@line 6095
 if (!$15) {
  _cpMessage(3625, 3674, 113, 1, 1, 3732, $vararg_buffer); //@line 6097
  _abort(); //@line 6098
 }
 $16 = $1; //@line 6101
 $17 = $16 + 24 | 0; //@line 6102
 $18 = +(+SAFE_HEAP_LOAD_D($17 | 0, 8)); //@line 6103
 $19 = $1; //@line 6104
 $20 = $19 + 24 | 0; //@line 6105
 $21 = +(+SAFE_HEAP_LOAD_D($20 | 0, 8)); //@line 6106
 $22 = $18 == $21; //@line 6107
 if (!$22) {
  _cpMessage(3752, 3674, 114, 1, 1, 3801, $vararg_buffer1); //@line 6109
  _abort(); //@line 6110
 }
 $23 = $1; //@line 6113
 $24 = $23 + 32 | 0; //@line 6114
 $25 = +(+SAFE_HEAP_LOAD_D($24 | 0, 8)); //@line 6115
 $26 = $1; //@line 6116
 $27 = $26 + 32 | 0; //@line 6117
 $28 = +(+SAFE_HEAP_LOAD_D($27 | 0, 8)); //@line 6118
 $29 = $25 == $28; //@line 6119
 if (!$29) {
  _cpMessage(3752, 3674, 114, 1, 1, 3801, $vararg_buffer1); //@line 6121
  _abort(); //@line 6122
 }
 $30 = $1; //@line 6125
 $31 = $30 + 8 | 0; //@line 6126
 $32 = +(+SAFE_HEAP_LOAD_D($31 | 0, 8)); //@line 6127
 $33 = $32 >= 0.0; //@line 6128
 if (!$33) {
  _cpMessage(3823, 3674, 115, 1, 1, 3839, $vararg_buffer3); //@line 6130
  _abort(); //@line 6131
 }
 $34 = $1; //@line 6134
 $35 = $34 + 24 | 0; //@line 6135
 $36 = +(+SAFE_HEAP_LOAD_D($35 | 0, 8)); //@line 6136
 $37 = $36 >= 0.0; //@line 6137
 if (!$37) {
  _cpMessage(3864, 3674, 116, 1, 1, 3880, $vararg_buffer5); //@line 6139
  _abort(); //@line 6140
 }
 $38 = $1; //@line 6143
 $39 = $38 + 56 | 0; //@line 6144
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($39 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($39 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($39 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($39 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpv_assert_sane($$byval_copy, 3907); //@line 6146
 $40 = $1; //@line 6147
 $41 = $40 + 72 | 0; //@line 6148
 SAFE_HEAP_STORE($$byval_copy13 | 0, SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 4 | 0, SAFE_HEAP_LOAD($41 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 8 | 0, SAFE_HEAP_LOAD($41 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy13 + 12 | 0, SAFE_HEAP_LOAD($41 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpv_assert_sane($$byval_copy13, 3935); //@line 6150
 $42 = $1; //@line 6151
 $43 = $42 + 88 | 0; //@line 6152
 SAFE_HEAP_STORE($$byval_copy14 | 0, SAFE_HEAP_LOAD($43 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 4 | 0, SAFE_HEAP_LOAD($43 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 8 | 0, SAFE_HEAP_LOAD($43 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy14 + 12 | 0, SAFE_HEAP_LOAD($43 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpv_assert_sane($$byval_copy14, 3963); //@line 6154
 $44 = $1; //@line 6155
 $45 = $44 + 104 | 0; //@line 6156
 $46 = +(+SAFE_HEAP_LOAD_D($45 | 0, 8)); //@line 6157
 $47 = $1; //@line 6158
 $48 = $47 + 104 | 0; //@line 6159
 $49 = +(+SAFE_HEAP_LOAD_D($48 | 0, 8)); //@line 6160
 $50 = $46 == $49; //@line 6161
 if (!$50) {
  _cpMessage(3988, 3674, 122, 1, 1, 4038, $vararg_buffer7); //@line 6163
  _abort(); //@line 6164
 }
 $51 = $1; //@line 6167
 $52 = $51 + 104 | 0; //@line 6168
 $53 = +(+SAFE_HEAP_LOAD_D($52 | 0, 8)); //@line 6169
 $54 = +_cpfabs_35($53); //@line 6170
 $55 = $54 != inf; //@line 6171
 if (!$55) {
  _cpMessage(3988, 3674, 122, 1, 1, 4038, $vararg_buffer7); //@line 6173
  _abort(); //@line 6174
 }
 $56 = $1; //@line 6177
 $57 = $56 + 112 | 0; //@line 6178
 $58 = +(+SAFE_HEAP_LOAD_D($57 | 0, 8)); //@line 6179
 $59 = $1; //@line 6180
 $60 = $59 + 112 | 0; //@line 6181
 $61 = +(+SAFE_HEAP_LOAD_D($60 | 0, 8)); //@line 6182
 $62 = $58 == $61; //@line 6183
 if (!$62) {
  _cpMessage(4063, 3674, 123, 1, 1, 4113, $vararg_buffer9); //@line 6185
  _abort(); //@line 6186
 }
 $63 = $1; //@line 6189
 $64 = $63 + 112 | 0; //@line 6190
 $65 = +(+SAFE_HEAP_LOAD_D($64 | 0, 8)); //@line 6191
 $66 = +_cpfabs_35($65); //@line 6192
 $67 = $66 != inf; //@line 6193
 if (!$67) {
  _cpMessage(4063, 3674, 123, 1, 1, 4113, $vararg_buffer9); //@line 6195
  _abort(); //@line 6196
 }
 $68 = $1; //@line 6199
 $69 = $68 + 120 | 0; //@line 6200
 $70 = +(+SAFE_HEAP_LOAD_D($69 | 0, 8)); //@line 6201
 $71 = $1; //@line 6202
 $72 = $71 + 120 | 0; //@line 6203
 $73 = +(+SAFE_HEAP_LOAD_D($72 | 0, 8)); //@line 6204
 $74 = $70 == $73; //@line 6205
 if (!$74) {
  _cpMessage(4149, 3674, 124, 1, 1, 4199, $vararg_buffer11); //@line 6207
  _abort(); //@line 6208
 }
 $75 = $1; //@line 6211
 $76 = $75 + 120 | 0; //@line 6212
 $77 = +(+SAFE_HEAP_LOAD_D($76 | 0, 8)); //@line 6213
 $78 = +_cpfabs_35($77); //@line 6214
 $79 = $78 != inf; //@line 6215
 if ($79) {
  STACKTOP = sp; //@line 6217
  return;
 } else {
  _cpMessage(4149, 3674, 124, 1, 1, 4199, $vararg_buffer11); //@line 6219
  _abort(); //@line 6220
 }
}
function _cpCentroidForPoly($0, $1, $2) {
 $0 = $0 | 0; //@line 629
 $1 = $1 | 0; //@line 630
 $2 = $2 | 0; //@line 631
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $10 = 0.0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0; //@line 632
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0.0, $27 = 0.0, $28 = 0.0, $29 = 0.0, $3 = 0, $30 = 0.0, $31 = 0, $32 = 0, $33 = 0.0, $34 = 0.0, $35 = 0.0, $4 = 0, $5 = 0.0, $6 = 0, $7 = 0, $8 = 0; //@line 633
 var $9 = 0, label = 0, sp = 0; //@line 634
 sp = STACKTOP; //@line 635
 STACKTOP = STACKTOP + 256 | 0; //@line 636
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(256 | 0); //@line 636
 $$byval_copy7 = sp + 224 | 0; //@line 637
 $$byval_copy6 = sp + 208 | 0; //@line 638
 $$byval_copy5 = sp + 192 | 0; //@line 639
 $$byval_copy4 = sp + 176 | 0; //@line 640
 $$byval_copy3 = sp + 160 | 0; //@line 641
 $$byval_copy2 = sp + 144 | 0; //@line 642
 $$byval_copy1 = sp + 128 | 0; //@line 643
 $$byval_copy = sp + 112 | 0; //@line 644
 $6 = sp + 88 | 0; //@line 645
 $8 = sp + 72 | 0; //@line 646
 $9 = sp + 56 | 0; //@line 647
 $11 = sp + 32 | 0; //@line 648
 $12 = sp + 16 | 0; //@line 649
 $13 = sp; //@line 650
 $3 = $1; //@line 651
 $4 = $2; //@line 652
 $5 = 0.0; //@line 653
 SAFE_HEAP_STORE($6 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $7 = 0; //@line 655
 while (1) {
  $14 = $7; //@line 657
  $15 = $3; //@line 658
  $16 = ($14 | 0) < ($15 | 0); //@line 659
  if (!$16) {
   break;
  }
  $17 = $4; //@line 663
  $18 = $7; //@line 664
  $19 = $17 + ($18 << 4) | 0; //@line 665
  SAFE_HEAP_STORE($8 | 0, SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($8 + 4 | 0, SAFE_HEAP_LOAD($19 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($8 + 8 | 0, SAFE_HEAP_LOAD($19 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($8 + 12 | 0, SAFE_HEAP_LOAD($19 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $20 = $4; //@line 667
  $21 = $7; //@line 668
  $22 = $21 + 1 | 0; //@line 669
  $23 = $3; //@line 670
  $24 = ($22 | 0) % ($23 | 0) & -1; //@line 671
  $25 = $20 + ($24 << 4) | 0; //@line 672
  SAFE_HEAP_STORE($9 | 0, SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($9 + 4 | 0, SAFE_HEAP_LOAD($25 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($9 + 8 | 0, SAFE_HEAP_LOAD($25 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($9 + 12 | 0, SAFE_HEAP_LOAD($25 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $26 = +_cpvcross($$byval_copy, $$byval_copy1); //@line 676
  $10 = $26; //@line 677
  $27 = $10; //@line 678
  $28 = $5; //@line 679
  $29 = $28 + $27; //@line 680
  $5 = $29; //@line 681
  SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvadd($12, $$byval_copy2, $$byval_copy3); //@line 684
  $30 = $10; //@line 685
  SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvmult($11, $$byval_copy4, $30); //@line 687
  SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvadd($13, $$byval_copy5, $$byval_copy6); //@line 690
  SAFE_HEAP_STORE($6 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($6 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($6 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($6 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $31 = $7; //@line 692
  $32 = $31 + 1 | 0; //@line 693
  $7 = $32; //@line 694
 }
 $33 = $5; //@line 696
 $34 = 3.0 * $33; //@line 697
 $35 = 1.0 / $34; //@line 698
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult($0, $$byval_copy7, $35); //@line 700
 STACKTOP = sp; //@line 701
 return;
}
function _CircleToPoly($0, $1, $2) {
 $0 = $0 | 0; //@line 8203
 $1 = $1 | 0; //@line 8204
 $2 = $2 | 0; //@line 8205
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0.0; //@line 8206
 var $22 = 0, $23 = 0, $24 = 0.0, $25 = 0, $26 = 0, $27 = 0.0, $28 = 0.0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0.0, $37 = 0, $38 = 0, $39 = 0, $4 = 0; //@line 8207
 var $40 = 0.0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP; //@line 8209
 STACKTOP = STACKTOP + 304 | 0; //@line 8210
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(304 | 0); //@line 8210
 $$byval_copy7 = sp + 256 | 0; //@line 8211
 $$byval_copy6 = sp + 240 | 0; //@line 8212
 $$byval_copy5 = sp + 224 | 0; //@line 8213
 $$byval_copy4 = sp + 208 | 0; //@line 8214
 $$byval_copy3 = sp + 192 | 0; //@line 8215
 $$byval_copy2 = sp + 176 | 0; //@line 8216
 $$byval_copy1 = sp + 160 | 0; //@line 8217
 $$byval_copy = sp + 144 | 0; //@line 8218
 $6 = sp + 272 | 0; //@line 8219
 $7 = sp + 80 | 0; //@line 8220
 $8 = sp + 64 | 0; //@line 8221
 $9 = sp + 48 | 0; //@line 8222
 $10 = sp + 32 | 0; //@line 8223
 $11 = sp + 16 | 0; //@line 8224
 $12 = sp; //@line 8225
 $3 = $0; //@line 8226
 $4 = $1; //@line 8227
 $5 = $2; //@line 8228
 $13 = $3; //@line 8229
 SAFE_HEAP_STORE($6 | 0, $13 | 0, 4);
 $14 = $6 + 4 | 0; //@line 8231
 $15 = $4; //@line 8232
 SAFE_HEAP_STORE($14 | 0, $15 | 0, 4);
 $16 = $6 + 8 | 0; //@line 8234
 SAFE_HEAP_STORE($16 | 0, 56 | 0, 4);
 $17 = $6 + 12 | 0; //@line 8236
 SAFE_HEAP_STORE($17 | 0, 57 | 0, 4);
 $18 = $5; //@line 8238
 $19 = $18 + 8 | 0; //@line 8239
 _GJK($7, $6, $19); //@line 8240
 $20 = $7 + 48 | 0; //@line 8241
 $21 = +(+SAFE_HEAP_LOAD_D($20 | 0, 8)); //@line 8242
 $22 = $3; //@line 8243
 $23 = $22 + 192 | 0; //@line 8244
 $24 = +(+SAFE_HEAP_LOAD_D($23 | 0, 8)); //@line 8245
 $25 = $4; //@line 8246
 $26 = $25 + 160 | 0; //@line 8247
 $27 = +(+SAFE_HEAP_LOAD_D($26 | 0, 8)); //@line 8248
 $28 = $24 + $27; //@line 8249
 $29 = $21 <= $28; //@line 8250
 if (!$29) {
  STACKTOP = sp; //@line 8252
  return;
 }
 $30 = $5; //@line 8254
 $31 = $30 + 16 | 0; //@line 8255
 $32 = $7 + 32 | 0; //@line 8256
 SAFE_HEAP_STORE($31 | 0, SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($31 + 4 | 0, SAFE_HEAP_LOAD($32 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($31 + 8 | 0, SAFE_HEAP_LOAD($32 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($31 + 12 | 0, SAFE_HEAP_LOAD($32 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 | 0, SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 4 | 0, SAFE_HEAP_LOAD($31 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 8 | 0, SAFE_HEAP_LOAD($31 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 12 | 0, SAFE_HEAP_LOAD($31 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $33 = $5; //@line 8259
 $34 = $3; //@line 8260
 $35 = $34 + 192 | 0; //@line 8261
 $36 = +(+SAFE_HEAP_LOAD_D($35 | 0, 8)); //@line 8262
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_64($10, $$byval_copy, $36); //@line 8264
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_66($9, $$byval_copy1, $$byval_copy2); //@line 8267
 $37 = $7 + 16 | 0; //@line 8268
 $38 = $4; //@line 8269
 $39 = $38 + 160 | 0; //@line 8270
 $40 = +(+SAFE_HEAP_LOAD_D($39 | 0, 8)); //@line 8271
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_64($12, $$byval_copy3, $40); //@line 8273
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($37 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($37 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($37 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($37 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_66($11, $$byval_copy4, $$byval_copy5); //@line 8276
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpCollisionInfoPushContact($33, $$byval_copy6, $$byval_copy7, 0); //@line 8279
 STACKTOP = sp; //@line 8280
 return;
}
function _SupportEdgeForSegment($0, $1, $2) {
 $0 = $0 | 0; //@line 1838
 $1 = $1 | 0; //@line 1839
 $2 = $2 | 0; //@line 1840
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $10 = 0, $11 = 0, $12 = 0.0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0; //@line 1841
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0.0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0; //@line 1842
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0.0, $51 = 0, $52 = 0, $53 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 1843
 sp = STACKTOP; //@line 1844
 STACKTOP = STACKTOP + 208 | 0; //@line 1845
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(208 | 0); //@line 1845
 $$byval_copy2 = sp + 176 | 0; //@line 1846
 $$byval_copy1 = sp + 160 | 0; //@line 1847
 $$byval_copy = sp + 144 | 0; //@line 1848
 $5 = sp + 72 | 0; //@line 1849
 $6 = sp; //@line 1850
 $3 = $1; //@line 1851
 $7 = $3; //@line 1852
 $8 = $7 + 156 | 0; //@line 1853
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 1854
 $4 = $9; //@line 1855
 $10 = $3; //@line 1856
 $11 = $10 + 240 | 0; //@line 1857
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $12 = +_cpvdot_68($$byval_copy, $$byval_copy1); //@line 1860
 $13 = $12 > 0.0; //@line 1861
 if ($13) {
  $14 = $3; //@line 1863
  $15 = $14 + 208 | 0; //@line 1864
  SAFE_HEAP_STORE($5 | 0, SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($5 + 4 | 0, SAFE_HEAP_LOAD($15 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($5 + 8 | 0, SAFE_HEAP_LOAD($15 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($5 + 12 | 0, SAFE_HEAP_LOAD($15 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $16 = $5 + 16 | 0; //@line 1866
  $17 = $4; //@line 1867
  $18 = Math_imul($17, -950046239) | 0; //@line 1868
  $19 = $18 ^ 0; //@line 1869
  SAFE_HEAP_STORE($16 | 0, $19 | 0, 4);
  $20 = $5 + 24 | 0; //@line 1871
  $21 = $3; //@line 1872
  $22 = $21 + 224 | 0; //@line 1873
  SAFE_HEAP_STORE($20 | 0, SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($20 + 4 | 0, SAFE_HEAP_LOAD($22 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($20 + 8 | 0, SAFE_HEAP_LOAD($22 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($20 + 12 | 0, SAFE_HEAP_LOAD($22 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $23 = $20 + 16 | 0; //@line 1875
  $24 = $4; //@line 1876
  $25 = Math_imul($24, -950046239) | 0; //@line 1877
  $26 = $25 ^ -950046239; //@line 1878
  SAFE_HEAP_STORE($23 | 0, $26 | 0, 4);
  $27 = $5 + 48 | 0; //@line 1880
  $28 = $3; //@line 1881
  $29 = $28 + 256 | 0; //@line 1882
  $30 = +(+SAFE_HEAP_LOAD_D($29 | 0, 8)); //@line 1883
  SAFE_HEAP_STORE_D($27 | 0, +$30, 8);
  $31 = $5 + 56 | 0; //@line 1885
  $32 = $3; //@line 1886
  $33 = $32 + 240 | 0; //@line 1887
  SAFE_HEAP_STORE($31 | 0, SAFE_HEAP_LOAD($33 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($31 + 4 | 0, SAFE_HEAP_LOAD($33 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($31 + 8 | 0, SAFE_HEAP_LOAD($33 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($31 + 12 | 0, SAFE_HEAP_LOAD($33 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = $0; //@line 1889
  src = $5; //@line 1889
  stop = dest + 72 | 0; //@line 1889
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 1889
   src = src + 4 | 0; //@line 1889
  } while ((dest | 0) < (stop | 0));
  STACKTOP = sp; //@line 1890
  return;
 } else {
  $34 = $3; //@line 1892
  $35 = $34 + 224 | 0; //@line 1893
  SAFE_HEAP_STORE($6 | 0, SAFE_HEAP_LOAD($35 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($6 + 4 | 0, SAFE_HEAP_LOAD($35 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($6 + 8 | 0, SAFE_HEAP_LOAD($35 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($6 + 12 | 0, SAFE_HEAP_LOAD($35 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $36 = $6 + 16 | 0; //@line 1895
  $37 = $4; //@line 1896
  $38 = Math_imul($37, -950046239) | 0; //@line 1897
  $39 = $38 ^ -950046239; //@line 1898
  SAFE_HEAP_STORE($36 | 0, $39 | 0, 4);
  $40 = $6 + 24 | 0; //@line 1900
  $41 = $3; //@line 1901
  $42 = $41 + 208 | 0; //@line 1902
  SAFE_HEAP_STORE($40 | 0, SAFE_HEAP_LOAD($42 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($40 + 4 | 0, SAFE_HEAP_LOAD($42 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($40 + 8 | 0, SAFE_HEAP_LOAD($42 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($40 + 12 | 0, SAFE_HEAP_LOAD($42 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $43 = $40 + 16 | 0; //@line 1904
  $44 = $4; //@line 1905
  $45 = Math_imul($44, -950046239) | 0; //@line 1906
  $46 = $45 ^ 0; //@line 1907
  SAFE_HEAP_STORE($43 | 0, $46 | 0, 4);
  $47 = $6 + 48 | 0; //@line 1909
  $48 = $3; //@line 1910
  $49 = $48 + 256 | 0; //@line 1911
  $50 = +(+SAFE_HEAP_LOAD_D($49 | 0, 8)); //@line 1912
  SAFE_HEAP_STORE_D($47 | 0, +$50, 8);
  $51 = $6 + 56 | 0; //@line 1914
  $52 = $3; //@line 1915
  $53 = $52 + 240 | 0; //@line 1916
  SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($53 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($53 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($53 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($53 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvneg_62($51, $$byval_copy2); //@line 1918
  dest = $0; //@line 1919
  src = $6; //@line 1919
  stop = dest + 72 | 0; //@line 1919
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 1919
   src = src + 4 | 0; //@line 1919
  } while ((dest | 0) < (stop | 0));
  STACKTOP = sp; //@line 1920
  return;
 }
}
function _cpBBSegmentQuery($0, $1, $2) {
 $0 = $0 | 0; //@line 3521
 $1 = $1 | 0; //@line 3522
 $2 = $2 | 0; //@line 3523
 var $$byval_copy = 0, $$byval_copy4 = 0, $10 = 0.0, $11 = 0.0, $12 = 0, $13 = 0.0, $14 = 0.0, $15 = 0, $16 = 0, $17 = 0.0, $18 = 0.0, $19 = 0, $20 = 0.0, $21 = 0.0, $22 = 0.0, $23 = 0.0, $24 = 0.0, $25 = 0, $26 = 0.0, $27 = 0.0; //@line 3524
 var $28 = 0.0, $29 = 0.0, $3 = 0.0, $30 = 0.0, $31 = 0.0, $32 = 0.0, $33 = 0.0, $34 = 0.0, $35 = 0.0, $36 = 0.0, $37 = 0.0, $38 = 0.0, $39 = 0.0, $4 = 0, $40 = 0.0, $41 = 0, $42 = 0.0, $43 = 0, $44 = 0, $45 = 0.0;
 var $46 = 0, $47 = 0.0, $48 = 0, $49 = 0, $5 = 0.0, $50 = 0.0, $51 = 0, $52 = 0.0, $53 = 0, $54 = 0, $55 = 0.0, $56 = 0, $57 = 0.0, $58 = 0.0, $59 = 0, $6 = 0.0, $60 = 0.0, $61 = 0.0, $62 = 0, $63 = 0.0; //@line 3526
 var $64 = 0, $65 = 0.0, $66 = 0.0, $67 = 0, $68 = 0.0, $69 = 0.0, $7 = 0.0, $70 = 0.0, $71 = 0.0, $72 = 0.0, $73 = 0.0, $74 = 0.0, $75 = 0.0, $76 = 0.0, $77 = 0.0, $78 = 0.0, $79 = 0.0, $8 = 0.0, $80 = 0.0, $81 = 0.0; //@line 3527
 var $82 = 0, $83 = 0.0, $84 = 0, $85 = 0.0, $86 = 0, $87 = 0.0, $88 = 0.0, $89 = 0.0, $9 = 0.0, $or$cond = 0, $or$cond3 = 0, label = 0, sp = 0; //@line 3528
 sp = STACKTOP; //@line 3529
 STACKTOP = STACKTOP + 112 | 0; //@line 3530
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 3530
 $$byval_copy4 = sp + 88 | 0; //@line 3531
 $$byval_copy = sp + 72 | 0; //@line 3532
 $4 = sp + 48 | 0; //@line 3533
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_19($4, $$byval_copy, $$byval_copy4); //@line 3536
 $5 = -inf; //@line 3537
 $6 = inf; //@line 3538
 $11 = +(+SAFE_HEAP_LOAD_D($4 | 0, 8)); //@line 3539
 $12 = $11 == 0.0; //@line 3540
 do {
  if ($12) {
   $13 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3543
   $14 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 3544
   $15 = $13 < $14; //@line 3545
   if (!$15) {
    $16 = $0 + 16 | 0; //@line 3547
    $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 3548
    $18 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3549
    $19 = $17 < $18; //@line 3550
    if (!$19) {
     break;
    }
   }
   $3 = inf; //@line 3555
   $89 = $3; //@line 3556
   STACKTOP = sp; //@line 3557
   return +$89;
  } else {
   $20 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 3559
   $21 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3560
   $22 = $20 - $21; //@line 3561
   $23 = +(+SAFE_HEAP_LOAD_D($4 | 0, 8)); //@line 3562
   $24 = $22 / $23; //@line 3563
   $7 = $24; //@line 3564
   $25 = $0 + 16 | 0; //@line 3565
   $26 = +(+SAFE_HEAP_LOAD_D($25 | 0, 8)); //@line 3566
   $27 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3567
   $28 = $26 - $27; //@line 3568
   $29 = +(+SAFE_HEAP_LOAD_D($4 | 0, 8)); //@line 3569
   $30 = $28 / $29; //@line 3570
   $8 = $30; //@line 3571
   $31 = $5; //@line 3572
   $32 = $7; //@line 3573
   $33 = $8; //@line 3574
   $34 = +_cpfmin_18($32, $33); //@line 3575
   $35 = +_cpfmax_20($31, $34); //@line 3576
   $5 = $35; //@line 3577
   $36 = $6; //@line 3578
   $37 = $7; //@line 3579
   $38 = $8; //@line 3580
   $39 = +_cpfmax_20($37, $38); //@line 3581
   $40 = +_cpfmin_18($36, $39); //@line 3582
   $6 = $40; //@line 3583
  }
 } while (0);
 $41 = $4 + 8 | 0; //@line 3586
 $42 = +(+SAFE_HEAP_LOAD_D($41 | 0, 8)); //@line 3587
 $43 = $42 == 0.0; //@line 3588
 do {
  if ($43) {
   $44 = $1 + 8 | 0; //@line 3591
   $45 = +(+SAFE_HEAP_LOAD_D($44 | 0, 8)); //@line 3592
   $46 = $0 + 8 | 0; //@line 3593
   $47 = +(+SAFE_HEAP_LOAD_D($46 | 0, 8)); //@line 3594
   $48 = $45 < $47; //@line 3595
   if (!$48) {
    $49 = $0 + 24 | 0; //@line 3597
    $50 = +(+SAFE_HEAP_LOAD_D($49 | 0, 8)); //@line 3598
    $51 = $1 + 8 | 0; //@line 3599
    $52 = +(+SAFE_HEAP_LOAD_D($51 | 0, 8)); //@line 3600
    $53 = $50 < $52; //@line 3601
    if (!$53) {
     break;
    }
   }
   $3 = inf; //@line 3606
   $89 = $3; //@line 3607
   STACKTOP = sp; //@line 3608
   return +$89;
  } else {
   $54 = $0 + 8 | 0; //@line 3610
   $55 = +(+SAFE_HEAP_LOAD_D($54 | 0, 8)); //@line 3611
   $56 = $1 + 8 | 0; //@line 3612
   $57 = +(+SAFE_HEAP_LOAD_D($56 | 0, 8)); //@line 3613
   $58 = $55 - $57; //@line 3614
   $59 = $4 + 8 | 0; //@line 3615
   $60 = +(+SAFE_HEAP_LOAD_D($59 | 0, 8)); //@line 3616
   $61 = $58 / $60; //@line 3617
   $9 = $61; //@line 3618
   $62 = $0 + 24 | 0; //@line 3619
   $63 = +(+SAFE_HEAP_LOAD_D($62 | 0, 8)); //@line 3620
   $64 = $1 + 8 | 0; //@line 3621
   $65 = +(+SAFE_HEAP_LOAD_D($64 | 0, 8)); //@line 3622
   $66 = $63 - $65; //@line 3623
   $67 = $4 + 8 | 0; //@line 3624
   $68 = +(+SAFE_HEAP_LOAD_D($67 | 0, 8)); //@line 3625
   $69 = $66 / $68; //@line 3626
   $10 = $69; //@line 3627
   $70 = $5; //@line 3628
   $71 = $9; //@line 3629
   $72 = $10; //@line 3630
   $73 = +_cpfmin_18($71, $72); //@line 3631
   $74 = +_cpfmax_20($70, $73); //@line 3632
   $5 = $74; //@line 3633
   $75 = $6; //@line 3634
   $76 = $9; //@line 3635
   $77 = $10; //@line 3636
   $78 = +_cpfmax_20($76, $77); //@line 3637
   $79 = +_cpfmin_18($75, $78); //@line 3638
   $6 = $79; //@line 3639
  }
 } while (0);
 $80 = $5; //@line 3642
 $81 = $6; //@line 3643
 $82 = $80 <= $81; //@line 3644
 $83 = $6; //@line 3645
 $84 = 0.0 <= $83; //@line 3646
 $or$cond = $82 & $84; //@line 3647
 $85 = $5; //@line 3648
 $86 = $85 <= 1.0; //@line 3649
 $or$cond3 = $or$cond & $86; //@line 3650
 if ($or$cond3) {
  $87 = $5; //@line 3652
  $88 = +_cpfmax_20($87, 0.0); //@line 3653
  $3 = $88; //@line 3654
  $89 = $3; //@line 3655
  STACKTOP = sp; //@line 3656
  return +$89;
 } else {
  $3 = inf; //@line 3658
  $89 = $3; //@line 3659
  STACKTOP = sp; //@line 3660
  return +$89;
 }
 return +0.0;
}
function _cpCircleShapePointQuery($0, $1, $2) {
 $0 = $0 | 0; //@line 5872
 $1 = $1 | 0; //@line 5873
 $2 = $2 | 0; //@line 5874
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0.0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0.0, $22 = 0; //@line 5875
 var $23 = 0.0, $24 = 0.0, $25 = 0.0, $26 = 0.0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0.0, $32 = 0.0, $33 = 0.0, $34 = 0.0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0.0, $4 = 0, $40 = 0;
 var $41 = 0.0, $42 = 0.0, $5 = 0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP; //@line 5878
 STACKTOP = STACKTOP + 224 | 0; //@line 5879
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(224 | 0); //@line 5879
 $$byval_copy6 = sp + 200 | 0; //@line 5880
 $$byval_copy5 = sp + 184 | 0; //@line 5881
 $$byval_copy4 = sp + 168 | 0; //@line 5882
 $$byval_copy3 = sp + 152 | 0; //@line 5883
 $$byval_copy2 = sp + 136 | 0; //@line 5884
 $$byval_copy1 = sp + 120 | 0; //@line 5885
 $$byval_copy = sp + 104 | 0; //@line 5886
 $5 = sp + 88 | 0; //@line 5887
 $9 = sp + 48 | 0; //@line 5888
 $10 = sp + 32 | 0; //@line 5889
 $11 = sp + 16 | 0; //@line 5890
 $12 = sp; //@line 5891
 $3 = $0; //@line 5892
 $4 = $2; //@line 5893
 $13 = $3; //@line 5894
 $14 = $13 + 176 | 0; //@line 5895
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_354($5, $$byval_copy, $$byval_copy1); //@line 5898
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $15 = +_cpvlength_356($$byval_copy2); //@line 5900
 $6 = $15; //@line 5901
 $16 = $3; //@line 5902
 $17 = $16 + 192 | 0; //@line 5903
 $18 = +(+SAFE_HEAP_LOAD_D($17 | 0, 8)); //@line 5904
 $7 = $18; //@line 5905
 $19 = $3; //@line 5906
 $20 = $4; //@line 5907
 SAFE_HEAP_STORE($20 | 0, $19 | 0, 4);
 $21 = $6; //@line 5909
 $22 = $21 > 0.0; //@line 5910
 $23 = $7; //@line 5911
 if ($22) {
  $24 = $6; //@line 5913
  $25 = $23 / $24; //@line 5914
  $26 = $25; //@line 5915
 } else {
  $26 = $23; //@line 5917
 }
 $8 = $26; //@line 5919
 $27 = $4; //@line 5920
 $28 = $27 + 8 | 0; //@line 5921
 $29 = $3; //@line 5922
 $30 = $29 + 176 | 0; //@line 5923
 $31 = $8; //@line 5924
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_357($9, $$byval_copy3, $31); //@line 5926
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($30 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($30 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($30 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_363($10, $$byval_copy4, $$byval_copy5); //@line 5929
 SAFE_HEAP_STORE($28 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($28 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($28 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($28 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $32 = $6; //@line 5931
 $33 = $7; //@line 5932
 $34 = $32 - $33; //@line 5933
 $35 = $4; //@line 5934
 $36 = $35 + 24 | 0; //@line 5935
 SAFE_HEAP_STORE_D($36 | 0, +$34, 8);
 $37 = $4; //@line 5937
 $38 = $37 + 32 | 0; //@line 5938
 $39 = $6; //@line 5939
 $40 = $39 > 1.0e-5; //@line 5940
 if ($40) {
  $41 = $6; //@line 5942
  $42 = 1.0 / $41; //@line 5943
  SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvmult_357($11, $$byval_copy6, $42); //@line 5945
  SAFE_HEAP_STORE($38 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($38 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($38 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($38 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  STACKTOP = sp; //@line 5947
  return;
 } else {
  _cpv_358($12, 0.0, 1.0); //@line 5949
  SAFE_HEAP_STORE($38 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($38 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($38 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($38 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  STACKTOP = sp; //@line 5951
  return;
 }
}
function _cpBodySetType($0, $1) {
 $0 = $0 | 0; //@line 6397
 $1 = $1 | 0; //@line 6398
 var $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0.0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0; //@line 6399
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0; //@line 6400
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0; //@line 6401
 var $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0; //@line 6402
 var $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0; //@line 6403
 var $97 = 0, $98 = 0, $99 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 6404
 sp = STACKTOP; //@line 6405
 STACKTOP = STACKTOP + 48 | 0; //@line 6406
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 6406
 $vararg_buffer = sp; //@line 6407
 $2 = $0; //@line 6408
 $3 = $1; //@line 6409
 $11 = $2; //@line 6410
 $12 = _cpBodyGetType($11) | 0; //@line 6411
 $4 = $12; //@line 6412
 $13 = $4; //@line 6413
 $14 = $3; //@line 6414
 $15 = ($13 | 0) == ($14 | 0); //@line 6415
 if ($15) {
  STACKTOP = sp; //@line 6417
  return;
 }
 $16 = $3; //@line 6419
 $17 = ($16 | 0) == 2; //@line 6420
 $18 = $17 ? inf : 0.0; //@line 6421
 $19 = $18; //@line 6422
 $20 = $2; //@line 6423
 $21 = $20 + 224 | 0; //@line 6424
 $22 = $21 + 8 | 0; //@line 6425
 SAFE_HEAP_STORE_D($22 | 0, +$19, 8);
 $23 = $3; //@line 6427
 $24 = ($23 | 0) == 0; //@line 6428
 $25 = $2; //@line 6429
 $26 = $25 + 24 | 0; //@line 6430
 if ($24) {
  SAFE_HEAP_STORE_D($26 | 0, +0.0, 8);
  $27 = $2; //@line 6433
  $28 = $27 + 8 | 0; //@line 6434
  SAFE_HEAP_STORE_D($28 | 0, +0.0, 8);
  $29 = $2; //@line 6436
  $30 = $29 + 32 | 0; //@line 6437
  SAFE_HEAP_STORE_D($30 | 0, +inf, 8);
  $31 = $2; //@line 6439
  $32 = $31 + 16 | 0; //@line 6440
  SAFE_HEAP_STORE_D($32 | 0, +inf, 8);
  $33 = $2; //@line 6442
  _cpBodyAccumulateMassFromShapes($33); //@line 6443
 } else {
  SAFE_HEAP_STORE_D($26 | 0, +inf, 8);
  $34 = $2; //@line 6446
  $35 = $34 + 8 | 0; //@line 6447
  SAFE_HEAP_STORE_D($35 | 0, +inf, 8);
  $36 = $2; //@line 6449
  $37 = $36 + 32 | 0; //@line 6450
  SAFE_HEAP_STORE_D($37 | 0, +0.0, 8);
  $38 = $2; //@line 6452
  $39 = $38 + 16 | 0; //@line 6453
  SAFE_HEAP_STORE_D($39 | 0, +0.0, 8);
  $40 = $2; //@line 6455
  $41 = $40 + 72 | 0; //@line 6456
  SAFE_HEAP_STORE($41 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($41 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($41 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($41 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $42 = $2; //@line 6458
  $43 = $42 + 112 | 0; //@line 6459
  SAFE_HEAP_STORE_D($43 | 0, +0.0, 8);
 }
 $44 = $2; //@line 6462
 $45 = _cpBodyGetSpace($44) | 0; //@line 6463
 $5 = $45; //@line 6464
 $46 = $5; //@line 6465
 $47 = ($46 | 0) != (0 | 0); //@line 6466
 if (!$47) {
  STACKTOP = sp; //@line 6468
  return;
 }
 $48 = $5; //@line 6470
 $49 = $48 + 140 | 0; //@line 6471
 $50 = SAFE_HEAP_LOAD($49 | 0, 4, 0) | 0 | 0; //@line 6472
 $51 = ($50 | 0) != 0; //@line 6473
 if ($51) {
  _cpMessage(6649, 3674, 174, 1, 1, 6664, $vararg_buffer); //@line 6475
  _abort(); //@line 6476
 }
 $52 = $4; //@line 6479
 $53 = ($52 | 0) == 2; //@line 6480
 if (!$53) {
  $54 = $2; //@line 6482
  _cpBodyActivate($54); //@line 6483
 }
 $55 = $5; //@line 6485
 $56 = $4; //@line 6486
 $57 = _cpSpaceArrayForBodyType($55, $56) | 0; //@line 6487
 $6 = $57; //@line 6488
 $58 = $5; //@line 6489
 $59 = $3; //@line 6490
 $60 = _cpSpaceArrayForBodyType($58, $59) | 0; //@line 6491
 $7 = $60; //@line 6492
 $61 = $6; //@line 6493
 $62 = $7; //@line 6494
 $63 = ($61 | 0) != ($62 | 0); //@line 6495
 if ($63) {
  $64 = $6; //@line 6497
  $65 = $2; //@line 6498
  _cpArrayDeleteObj($64, $65); //@line 6499
  $66 = $7; //@line 6500
  $67 = $2; //@line 6501
  _cpArrayPush($66, $67); //@line 6502
 }
 $68 = $4; //@line 6504
 $69 = ($68 | 0) == 2; //@line 6505
 $70 = $5; //@line 6506
 if ($69) {
  $71 = $70 + 108 | 0; //@line 6508
  $72 = SAFE_HEAP_LOAD($71 | 0, 4, 0) | 0 | 0; //@line 6509
  $75 = $72; //@line 6510
 } else {
  $73 = $70 + 112 | 0; //@line 6512
  $74 = SAFE_HEAP_LOAD($73 | 0, 4, 0) | 0 | 0; //@line 6513
  $75 = $74; //@line 6514
 }
 $8 = $75; //@line 6516
 $76 = $3; //@line 6517
 $77 = ($76 | 0) == 2; //@line 6518
 $78 = $5; //@line 6519
 if ($77) {
  $79 = $78 + 108 | 0; //@line 6521
  $80 = SAFE_HEAP_LOAD($79 | 0, 4, 0) | 0 | 0; //@line 6522
  $83 = $80; //@line 6523
 } else {
  $81 = $78 + 112 | 0; //@line 6525
  $82 = SAFE_HEAP_LOAD($81 | 0, 4, 0) | 0 | 0; //@line 6526
  $83 = $82; //@line 6527
 }
 $9 = $83; //@line 6529
 $84 = $8; //@line 6530
 $85 = $9; //@line 6531
 $86 = ($84 | 0) != ($85 | 0); //@line 6532
 if (!$86) {
  STACKTOP = sp; //@line 6534
  return;
 }
 $87 = $2; //@line 6536
 $88 = $87 + 212 | 0; //@line 6537
 $89 = SAFE_HEAP_LOAD($88 | 0, 4, 0) | 0 | 0; //@line 6538
 $10 = $89; //@line 6539
 while (1) {
  $90 = $10; //@line 6541
  $91 = ($90 | 0) != (0 | 0); //@line 6542
  if (!$91) {
   break;
  }
  $92 = $8; //@line 6546
  $93 = $10; //@line 6547
  $94 = $10; //@line 6548
  $95 = $94 + 156 | 0; //@line 6549
  $96 = SAFE_HEAP_LOAD($95 | 0, 4, 0) | 0 | 0; //@line 6550
  _cpSpatialIndexRemove($92, $93, $96); //@line 6551
  $97 = $9; //@line 6552
  $98 = $10; //@line 6553
  $99 = $10; //@line 6554
  $100 = $99 + 156 | 0; //@line 6555
  $101 = SAFE_HEAP_LOAD($100 | 0, 4, 0) | 0 | 0; //@line 6556
  _cpSpatialIndexInsert($97, $98, $101); //@line 6557
  $102 = $10; //@line 6558
  $103 = $102 + 148 | 0; //@line 6559
  $104 = SAFE_HEAP_LOAD($103 | 0, 4, 0) | 0 | 0; //@line 6560
  $10 = $104; //@line 6561
 }
 STACKTOP = sp; //@line 6563
 return;
}
function _cpSpaceInit($0) {
 $0 = $0 | 0; //@line 194
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0.0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0; //@line 195
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0; //@line 196
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0; //@line 197
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0; //@line 198
 var $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0; //@line 199
 sp = STACKTOP; //@line 200
 STACKTOP = STACKTOP + 32 | 0; //@line 201
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 201
 $vararg_buffer1 = sp + 8 | 0; //@line 202
 $vararg_buffer = sp; //@line 203
 $1 = $0; //@line 204
 $3 = SAFE_HEAP_LOAD(11872 | 0, 1, 0) | 0 | 0; //@line 205
 $4 = $3 << 24 >> 24 != 0; //@line 206
 if (!$4) {
  SAFE_HEAP_STORE($vararg_buffer | 0, 3244 | 0, 4);
  _printf(6020, $vararg_buffer) | 0; //@line 209
  _printf(6073, $vararg_buffer1) | 0; //@line 210
  SAFE_HEAP_STORE(11872 | 0, 1 | 0, 1);
 }
 $5 = $1; //@line 213
 SAFE_HEAP_STORE($5 | 0, 10 | 0, 4);
 $6 = $1; //@line 215
 $7 = $6 + 8 | 0; //@line 216
 SAFE_HEAP_STORE($7 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $8 = $1; //@line 218
 $9 = $8 + 24 | 0; //@line 219
 SAFE_HEAP_STORE_D($9 | 0, +1.0, 8);
 $10 = $1; //@line 221
 $11 = $10 + 48 | 0; //@line 222
 SAFE_HEAP_STORE_D($11 | 0, +.10000000149011612, 8);
 $12 = +Math_pow(.8999999761581421, 60.0); //@line 224
 $13 = $1; //@line 225
 $14 = $13 + 56 | 0; //@line 226
 SAFE_HEAP_STORE_D($14 | 0, +$12, 8);
 $15 = $1; //@line 228
 $16 = $15 + 64 | 0; //@line 229
 SAFE_HEAP_STORE($16 | 0, 3 | 0, 4);
 $17 = $1; //@line 231
 $18 = $17 + 140 | 0; //@line 232
 SAFE_HEAP_STORE($18 | 0, 0 | 0, 4);
 $19 = $1; //@line 234
 $20 = $19 + 72 | 0; //@line 235
 SAFE_HEAP_STORE($20 | 0, 0 | 0, 4);
 $21 = $1; //@line 237
 $22 = $21 + 104 | 0; //@line 238
 SAFE_HEAP_STORE($22 | 0, 0 | 0, 4);
 $23 = _cpBBTreeNew(58, 0) | 0; //@line 240
 $24 = $1; //@line 241
 $25 = $24 + 108 | 0; //@line 242
 SAFE_HEAP_STORE($25 | 0, $23 | 0, 4);
 $26 = $1; //@line 244
 $27 = $26 + 108 | 0; //@line 245
 $28 = SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0; //@line 246
 $29 = _cpBBTreeNew(58, $28) | 0; //@line 247
 $30 = $1; //@line 248
 $31 = $30 + 112 | 0; //@line 249
 SAFE_HEAP_STORE($31 | 0, $29 | 0, 4);
 $32 = $1; //@line 251
 $33 = $32 + 112 | 0; //@line 252
 $34 = SAFE_HEAP_LOAD($33 | 0, 4, 0) | 0 | 0; //@line 253
 _cpBBTreeSetVelocityFunc($34, 59); //@line 254
 $35 = _cpArrayNew(0) | 0; //@line 255
 $36 = $1; //@line 256
 $37 = $36 + 136 | 0; //@line 257
 SAFE_HEAP_STORE($37 | 0, $35 | 0, 4);
 $38 = _cpArrayNew(0) | 0; //@line 259
 $39 = $1; //@line 260
 $40 = $39 + 88 | 0; //@line 261
 SAFE_HEAP_STORE($40 | 0, $38 | 0, 4);
 $41 = _cpArrayNew(0) | 0; //@line 263
 $42 = $1; //@line 264
 $43 = $42 + 92 | 0; //@line 265
 SAFE_HEAP_STORE($43 | 0, $41 | 0, 4);
 $44 = _cpArrayNew(0) | 0; //@line 267
 $45 = $1; //@line 268
 $46 = $45 + 100 | 0; //@line 269
 SAFE_HEAP_STORE($46 | 0, $44 | 0, 4);
 $47 = _cpArrayNew(0) | 0; //@line 271
 $48 = $1; //@line 272
 $49 = $48 + 96 | 0; //@line 273
 SAFE_HEAP_STORE($49 | 0, $47 | 0, 4);
 $50 = $1; //@line 275
 $51 = $50 + 40 | 0; //@line 276
 SAFE_HEAP_STORE_D($51 | 0, +inf, 8);
 $52 = $1; //@line 278
 $53 = $52 + 32 | 0; //@line 279
 SAFE_HEAP_STORE_D($53 | 0, +0.0, 8);
 $54 = _cpArrayNew(0) | 0; //@line 281
 $55 = $1; //@line 282
 $56 = $55 + 120 | 0; //@line 283
 SAFE_HEAP_STORE($56 | 0, $54 | 0, 4);
 $57 = _cpArrayNew(0) | 0; //@line 285
 $58 = $1; //@line 286
 $59 = $58 + 132 | 0; //@line 287
 SAFE_HEAP_STORE($59 | 0, $57 | 0, 4);
 $60 = $1; //@line 289
 $61 = $60 + 124 | 0; //@line 290
 SAFE_HEAP_STORE($61 | 0, 0 | 0, 4);
 $62 = _cpHashSetNew(0, 60) | 0; //@line 292
 $63 = $1; //@line 293
 $64 = $63 + 128 | 0; //@line 294
 SAFE_HEAP_STORE($64 | 0, $62 | 0, 4);
 $65 = _cpArrayNew(0) | 0; //@line 296
 $66 = $1; //@line 297
 $67 = $66 + 116 | 0; //@line 298
 SAFE_HEAP_STORE($67 | 0, $65 | 0, 4);
 $68 = $1; //@line 300
 $69 = $68 + 144 | 0; //@line 301
 SAFE_HEAP_STORE($69 >> 0 | 0, 0 | 0, 1);
 $70 = $1; //@line 303
 $71 = $70 + 152 | 0; //@line 304
 SAFE_HEAP_STORE($71 | 0, SAFE_HEAP_LOAD(2712 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($71 + 4 | 0, SAFE_HEAP_LOAD(2712 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($71 + 8 | 0, SAFE_HEAP_LOAD(2712 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($71 + 12 | 0, SAFE_HEAP_LOAD(2712 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($71 + 16 | 0, SAFE_HEAP_LOAD(2712 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($71 + 20 | 0, SAFE_HEAP_LOAD(2712 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($71 + 24 | 0, SAFE_HEAP_LOAD(2712 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 $72 = _cpHashSetNew(0, 61) | 0; //@line 306
 $73 = $1; //@line 307
 $74 = $73 + 148 | 0; //@line 308
 SAFE_HEAP_STORE($74 | 0, $72 | 0, 4);
 $75 = _cpArrayNew(0) | 0; //@line 310
 $76 = $1; //@line 311
 $77 = $76 + 184 | 0; //@line 312
 SAFE_HEAP_STORE($77 | 0, $75 | 0, 4);
 $78 = $1; //@line 314
 $79 = $78 + 180 | 0; //@line 315
 SAFE_HEAP_STORE($79 >> 0 | 0, 0 | 0, 1);
 $80 = $1; //@line 317
 $81 = $80 + 192 | 0; //@line 318
 $82 = _cpBodyInit($81, 0.0, 0.0) | 0; //@line 319
 $2 = $82; //@line 320
 $83 = $2; //@line 321
 _cpBodySetType($83, 2); //@line 322
 $84 = $1; //@line 323
 $85 = $2; //@line 324
 _cpSpaceSetStaticBody($84, $85); //@line 325
 $86 = $1; //@line 326
 STACKTOP = sp; //@line 327
 return $86 | 0; //@line 327
}
function _cpSegmentShapeInit($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 6347
 $1 = $1 | 0; //@line 6348
 $2 = $2 | 0; //@line 6349
 $3 = $3 | 0; //@line 6350
 $4 = +$4; //@line 6351
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0; //@line 6352
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0.0, $28 = 0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 6353
 sp = STACKTOP; //@line 6354
 STACKTOP = STACKTOP + 240 | 0; //@line 6355
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(240 | 0); //@line 6355
 $$byval_copy6 = sp + 192 | 0; //@line 6356
 $$byval_copy5 = sp + 176 | 0; //@line 6357
 $$byval_copy4 = sp + 160 | 0; //@line 6358
 $$byval_copy3 = sp + 144 | 0; //@line 6359
 $$byval_copy2 = sp + 128 | 0; //@line 6360
 $$byval_copy1 = sp + 112 | 0; //@line 6361
 $$byval_copy = sp + 96 | 0; //@line 6362
 $8 = sp + 72 | 0; //@line 6363
 $9 = sp + 56 | 0; //@line 6364
 $10 = sp + 40 | 0; //@line 6365
 $11 = sp; //@line 6366
 $5 = $0; //@line 6367
 $6 = $1; //@line 6368
 $7 = $4; //@line 6369
 $12 = $5; //@line 6370
 $13 = $12 + 160 | 0; //@line 6371
 SAFE_HEAP_STORE($13 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($13 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($13 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($13 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $14 = $5; //@line 6373
 $15 = $14 + 176 | 0; //@line 6374
 SAFE_HEAP_STORE($15 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($15 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($15 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($15 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $16 = $5; //@line 6376
 $17 = $16 + 192 | 0; //@line 6377
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_354($9, $$byval_copy, $$byval_copy1); //@line 6380
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvnormalize_355($8, $$byval_copy2); //@line 6382
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvrperp_368($10, $$byval_copy3); //@line 6384
 SAFE_HEAP_STORE($17 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($17 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($17 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($17 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $18 = $7; //@line 6386
 $19 = $5; //@line 6387
 $20 = $19 + 256 | 0; //@line 6388
 SAFE_HEAP_STORE_D($20 | 0, +$18, 8);
 $21 = $5; //@line 6390
 $22 = $21 + 264 | 0; //@line 6391
 SAFE_HEAP_STORE($22 | 0, SAFE_HEAP_LOAD(11248 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($22 + 4 | 0, SAFE_HEAP_LOAD(11248 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($22 + 8 | 0, SAFE_HEAP_LOAD(11248 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($22 + 12 | 0, SAFE_HEAP_LOAD(11248 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $23 = $5; //@line 6393
 $24 = $23 + 280 | 0; //@line 6394
 SAFE_HEAP_STORE($24 | 0, SAFE_HEAP_LOAD(11248 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($24 + 4 | 0, SAFE_HEAP_LOAD(11248 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($24 + 8 | 0, SAFE_HEAP_LOAD(11248 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($24 + 12 | 0, SAFE_HEAP_LOAD(11248 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $25 = $5; //@line 6396
 $26 = $6; //@line 6397
 $27 = $7; //@line 6398
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpSegmentShapeMassInfo($11, 0.0, $$byval_copy4, $$byval_copy5, $27); //@line 6401
 dest = $$byval_copy6; //@line 6402
 src = $11; //@line 6402
 stop = dest + 40 | 0; //@line 6402
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 6402
  src = src + 4 | 0; //@line 6402
 } while ((dest | 0) < (stop | 0));
 _cpShapeInit($25, 2676, $26, $$byval_copy6) | 0; //@line 6403
 $28 = $5; //@line 6404
 STACKTOP = sp; //@line 6405
 return $28 | 0; //@line 6405
}
function _k_tensor_255($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 3554
 $1 = $1 | 0; //@line 3555
 $2 = $2 | 0; //@line 3556
 $3 = $3 | 0; //@line 3557
 $4 = $4 | 0; //@line 3558
 var $10 = 0.0, $100 = 0.0, $101 = 0.0, $102 = 0.0, $103 = 0.0, $104 = 0.0, $105 = 0.0, $106 = 0.0, $107 = 0, $108 = 0.0, $109 = 0.0, $11 = 0.0, $110 = 0.0, $111 = 0.0, $112 = 0.0, $113 = 0.0, $114 = 0.0, $115 = 0.0, $116 = 0.0, $117 = 0.0;
 var $118 = 0.0, $119 = 0.0, $12 = 0.0, $120 = 0.0, $121 = 0.0, $122 = 0.0, $123 = 0.0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0.0, $19 = 0.0, $20 = 0.0, $21 = 0.0, $22 = 0, $23 = 0, $24 = 0.0, $25 = 0;
 var $26 = 0, $27 = 0.0, $28 = 0.0, $29 = 0.0, $30 = 0.0, $31 = 0, $32 = 0, $33 = 0.0, $34 = 0.0, $35 = 0.0, $36 = 0.0, $37 = 0.0, $38 = 0.0, $39 = 0, $40 = 0.0, $41 = 0, $42 = 0.0, $43 = 0.0, $44 = 0.0, $45 = 0.0; //@line 3561
 var $46 = 0.0, $47 = 0.0, $48 = 0, $49 = 0.0, $5 = 0, $50 = 0.0, $51 = 0.0, $52 = 0.0, $53 = 0.0, $54 = 0.0, $55 = 0.0, $56 = 0.0, $57 = 0.0, $58 = 0.0, $59 = 0.0, $6 = 0, $60 = 0.0, $61 = 0.0, $62 = 0.0, $63 = 0.0;
 var $64 = 0.0, $65 = 0, $66 = 0, $67 = 0.0, $68 = 0.0, $69 = 0.0, $7 = 0.0, $70 = 0.0, $71 = 0.0, $72 = 0.0, $73 = 0, $74 = 0.0, $75 = 0, $76 = 0.0, $77 = 0.0, $78 = 0.0, $79 = 0.0, $8 = 0.0, $80 = 0.0, $81 = 0.0;
 var $82 = 0, $83 = 0.0, $84 = 0.0, $85 = 0.0, $86 = 0.0, $87 = 0.0, $88 = 0.0, $89 = 0.0, $9 = 0.0, $90 = 0.0, $91 = 0.0, $92 = 0.0, $93 = 0.0, $94 = 0.0, $95 = 0.0, $96 = 0.0, $97 = 0.0, $98 = 0.0, $99 = 0.0, $vararg_buffer = 0; //@line 3564
 var label = 0, sp = 0; //@line 3565
 sp = STACKTOP; //@line 3566
 STACKTOP = STACKTOP + 144 | 0; //@line 3567
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(144 | 0); //@line 3567
 $vararg_buffer = sp + 120 | 0; //@line 3568
 $5 = $1; //@line 3569
 $6 = $2; //@line 3570
 $22 = $5; //@line 3571
 $23 = $22 + 16 | 0; //@line 3572
 $24 = +(+SAFE_HEAP_LOAD_D($23 | 0, 8)); //@line 3573
 $25 = $6; //@line 3574
 $26 = $25 + 16 | 0; //@line 3575
 $27 = +(+SAFE_HEAP_LOAD_D($26 | 0, 8)); //@line 3576
 $28 = $24 + $27; //@line 3577
 $7 = $28; //@line 3578
 $29 = $7; //@line 3579
 $8 = $29; //@line 3580
 $9 = 0.0; //@line 3581
 $10 = 0.0; //@line 3582
 $30 = $7; //@line 3583
 $11 = $30; //@line 3584
 $31 = $5; //@line 3585
 $32 = $31 + 32 | 0; //@line 3586
 $33 = +(+SAFE_HEAP_LOAD_D($32 | 0, 8)); //@line 3587
 $12 = $33; //@line 3588
 $34 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 3589
 $35 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 3590
 $36 = $34 * $35; //@line 3591
 $37 = $12; //@line 3592
 $38 = $36 * $37; //@line 3593
 $13 = $38; //@line 3594
 $39 = $3 + 8 | 0; //@line 3595
 $40 = +(+SAFE_HEAP_LOAD_D($39 | 0, 8)); //@line 3596
 $41 = $3 + 8 | 0; //@line 3597
 $42 = +(+SAFE_HEAP_LOAD_D($41 | 0, 8)); //@line 3598
 $43 = $40 * $42; //@line 3599
 $44 = $12; //@line 3600
 $45 = $43 * $44; //@line 3601
 $14 = $45; //@line 3602
 $46 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 3603
 $47 = -$46; //@line 3604
 $48 = $3 + 8 | 0; //@line 3605
 $49 = +(+SAFE_HEAP_LOAD_D($48 | 0, 8)); //@line 3606
 $50 = $47 * $49; //@line 3607
 $51 = $12; //@line 3608
 $52 = $50 * $51; //@line 3609
 $15 = $52; //@line 3610
 $53 = $14; //@line 3611
 $54 = $8; //@line 3612
 $55 = $54 + $53; //@line 3613
 $8 = $55; //@line 3614
 $56 = $15; //@line 3615
 $57 = $9; //@line 3616
 $58 = $57 + $56; //@line 3617
 $9 = $58; //@line 3618
 $59 = $15; //@line 3619
 $60 = $10; //@line 3620
 $61 = $60 + $59; //@line 3621
 $10 = $61; //@line 3622
 $62 = $13; //@line 3623
 $63 = $11; //@line 3624
 $64 = $63 + $62; //@line 3625
 $11 = $64; //@line 3626
 $65 = $6; //@line 3627
 $66 = $65 + 32 | 0; //@line 3628
 $67 = +(+SAFE_HEAP_LOAD_D($66 | 0, 8)); //@line 3629
 $16 = $67; //@line 3630
 $68 = +(+SAFE_HEAP_LOAD_D($4 | 0, 8)); //@line 3631
 $69 = +(+SAFE_HEAP_LOAD_D($4 | 0, 8)); //@line 3632
 $70 = $68 * $69; //@line 3633
 $71 = $16; //@line 3634
 $72 = $70 * $71; //@line 3635
 $17 = $72; //@line 3636
 $73 = $4 + 8 | 0; //@line 3637
 $74 = +(+SAFE_HEAP_LOAD_D($73 | 0, 8)); //@line 3638
 $75 = $4 + 8 | 0; //@line 3639
 $76 = +(+SAFE_HEAP_LOAD_D($75 | 0, 8)); //@line 3640
 $77 = $74 * $76; //@line 3641
 $78 = $16; //@line 3642
 $79 = $77 * $78; //@line 3643
 $18 = $79; //@line 3644
 $80 = +(+SAFE_HEAP_LOAD_D($4 | 0, 8)); //@line 3645
 $81 = -$80; //@line 3646
 $82 = $4 + 8 | 0; //@line 3647
 $83 = +(+SAFE_HEAP_LOAD_D($82 | 0, 8)); //@line 3648
 $84 = $81 * $83; //@line 3649
 $85 = $16; //@line 3650
 $86 = $84 * $85; //@line 3651
 $19 = $86; //@line 3652
 $87 = $18; //@line 3653
 $88 = $8; //@line 3654
 $89 = $88 + $87; //@line 3655
 $8 = $89; //@line 3656
 $90 = $19; //@line 3657
 $91 = $9; //@line 3658
 $92 = $91 + $90; //@line 3659
 $9 = $92; //@line 3660
 $93 = $19; //@line 3661
 $94 = $10; //@line 3662
 $95 = $94 + $93; //@line 3663
 $10 = $95; //@line 3664
 $96 = $17; //@line 3665
 $97 = $11; //@line 3666
 $98 = $97 + $96; //@line 3667
 $11 = $98; //@line 3668
 $99 = $8; //@line 3669
 $100 = $11; //@line 3670
 $101 = $99 * $100; //@line 3671
 $102 = $9; //@line 3672
 $103 = $10; //@line 3673
 $104 = $102 * $103; //@line 3674
 $105 = $101 - $104; //@line 3675
 $20 = $105; //@line 3676
 $106 = $20; //@line 3677
 $107 = $106 != 0.0; //@line 3678
 if ($107) {
  $108 = $20; //@line 3680
  $109 = 1.0 / $108; //@line 3681
  $21 = $109; //@line 3682
  $110 = $11; //@line 3683
  $111 = $21; //@line 3684
  $112 = $110 * $111; //@line 3685
  $113 = $9; //@line 3686
  $114 = -$113; //@line 3687
  $115 = $21; //@line 3688
  $116 = $114 * $115; //@line 3689
  $117 = $10; //@line 3690
  $118 = -$117; //@line 3691
  $119 = $21; //@line 3692
  $120 = $118 * $119; //@line 3693
  $121 = $8; //@line 3694
  $122 = $21; //@line 3695
  $123 = $121 * $122; //@line 3696
  _cpMat2x2New_260($0, $112, $116, $120, $123); //@line 3697
  STACKTOP = sp; //@line 3698
  return;
 } else {
  _cpMessage(5438, 5903, 255, 1, 0, 5449, $vararg_buffer); //@line 3700
  _abort(); //@line 3701
 }
}
function _SetVerts($0, $1, $2) {
 $0 = $0 | 0; //@line 3889
 $1 = $1 | 0; //@line 3890
 $2 = $2 | 0; //@line 3891
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0; //@line 3892
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0; //@line 3893
 var $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3894
 sp = STACKTOP; //@line 3895
 STACKTOP = STACKTOP + 160 | 0; //@line 3896
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(160 | 0); //@line 3896
 $$byval_copy3 = sp + 128 | 0; //@line 3897
 $$byval_copy2 = sp + 112 | 0; //@line 3898
 $$byval_copy1 = sp + 96 | 0; //@line 3899
 $$byval_copy = sp + 80 | 0; //@line 3900
 $7 = sp + 64 | 0; //@line 3901
 $8 = sp + 48 | 0; //@line 3902
 $9 = sp + 32 | 0; //@line 3903
 $10 = sp + 16 | 0; //@line 3904
 $11 = sp; //@line 3905
 $3 = $0; //@line 3906
 $4 = $1; //@line 3907
 $5 = $2; //@line 3908
 $12 = $4; //@line 3909
 $13 = $3; //@line 3910
 $14 = $13 + 168 | 0; //@line 3911
 SAFE_HEAP_STORE($14 | 0, $12 | 0, 4);
 $15 = $4; //@line 3913
 $16 = ($15 | 0) <= 6; //@line 3914
 if ($16) {
  $17 = $3; //@line 3916
  $18 = $17 + 176 | 0; //@line 3917
  $19 = $3; //@line 3918
  $20 = $19 + 172 | 0; //@line 3919
  SAFE_HEAP_STORE($20 | 0, $18 | 0, 4);
 } else {
  $21 = $4; //@line 3922
  $22 = $21 << 1; //@line 3923
  $23 = _calloc($22, 32) | 0; //@line 3924
  $24 = $3; //@line 3925
  $25 = $24 + 172 | 0; //@line 3926
  SAFE_HEAP_STORE($25 | 0, $23 | 0, 4);
 }
 $6 = 0; //@line 3929
 while (1) {
  $26 = $6; //@line 3931
  $27 = $4; //@line 3932
  $28 = ($26 | 0) < ($27 | 0); //@line 3933
  if (!$28) {
   break;
  }
  $29 = $5; //@line 3937
  $30 = $6; //@line 3938
  $31 = $30 - 1 | 0; //@line 3939
  $32 = $4; //@line 3940
  $33 = $31 + $32 | 0; //@line 3941
  $34 = $4; //@line 3942
  $35 = ($33 | 0) % ($34 | 0) & -1; //@line 3943
  $36 = $29 + ($35 << 4) | 0; //@line 3944
  SAFE_HEAP_STORE($7 | 0, SAFE_HEAP_LOAD($36 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($7 + 4 | 0, SAFE_HEAP_LOAD($36 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($7 + 8 | 0, SAFE_HEAP_LOAD($36 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($7 + 12 | 0, SAFE_HEAP_LOAD($36 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $37 = $5; //@line 3946
  $38 = $6; //@line 3947
  $39 = $37 + ($38 << 4) | 0; //@line 3948
  SAFE_HEAP_STORE($8 | 0, SAFE_HEAP_LOAD($39 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($8 + 4 | 0, SAFE_HEAP_LOAD($39 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($8 + 8 | 0, SAFE_HEAP_LOAD($39 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($8 + 12 | 0, SAFE_HEAP_LOAD($39 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvsub_266($11, $$byval_copy, $$byval_copy1); //@line 3952
  SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvrperp_267($10, $$byval_copy2); //@line 3954
  SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvnormalize_268($9, $$byval_copy3); //@line 3956
  $40 = $3; //@line 3957
  $41 = $40 + 172 | 0; //@line 3958
  $42 = SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0; //@line 3959
  $43 = $6; //@line 3960
  $44 = $4; //@line 3961
  $45 = $43 + $44 | 0; //@line 3962
  $46 = $42 + ($45 << 5) | 0; //@line 3963
  SAFE_HEAP_STORE($46 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($46 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($46 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($46 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $47 = $3; //@line 3965
  $48 = $47 + 172 | 0; //@line 3966
  $49 = SAFE_HEAP_LOAD($48 | 0, 4, 0) | 0 | 0; //@line 3967
  $50 = $6; //@line 3968
  $51 = $4; //@line 3969
  $52 = $50 + $51 | 0; //@line 3970
  $53 = $49 + ($52 << 5) | 0; //@line 3971
  $54 = $53 + 16 | 0; //@line 3972
  SAFE_HEAP_STORE($54 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($54 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($54 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($54 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $55 = $6; //@line 3974
  $56 = $55 + 1 | 0; //@line 3975
  $6 = $56; //@line 3976
 }
 STACKTOP = sp; //@line 3978
 return;
}
function _relative_velocity_401($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 7680
 $1 = $1 | 0; //@line 7681
 $2 = $2 | 0; //@line 7682
 $3 = $3 | 0; //@line 7683
 $4 = $4 | 0; //@line 7684
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0.0, $18 = 0, $19 = 0; //@line 7685
 var $20 = 0, $21 = 0, $22 = 0.0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 7686
 sp = STACKTOP; //@line 7687
 STACKTOP = STACKTOP + 272 | 0; //@line 7688
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(272 | 0); //@line 7688
 $$byval_copy9 = sp + 240 | 0; //@line 7689
 $$byval_copy8 = sp + 224 | 0; //@line 7690
 $$byval_copy7 = sp + 208 | 0; //@line 7691
 $$byval_copy6 = sp + 192 | 0; //@line 7692
 $$byval_copy5 = sp + 176 | 0; //@line 7693
 $$byval_copy4 = sp + 160 | 0; //@line 7694
 $$byval_copy3 = sp + 144 | 0; //@line 7695
 $$byval_copy2 = sp + 128 | 0; //@line 7696
 $$byval_copy1 = sp + 112 | 0; //@line 7697
 $$byval_copy = sp + 96 | 0; //@line 7698
 $7 = sp + 80 | 0; //@line 7699
 $8 = sp + 64 | 0; //@line 7700
 $9 = sp + 48 | 0; //@line 7701
 $10 = sp + 32 | 0; //@line 7702
 $11 = sp + 16 | 0; //@line 7703
 $12 = sp; //@line 7704
 $5 = $1; //@line 7705
 $6 = $2; //@line 7706
 $13 = $5; //@line 7707
 $14 = $13 + 72 | 0; //@line 7708
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvperp_413($9, $$byval_copy); //@line 7710
 $15 = $5; //@line 7711
 $16 = $15 + 112 | 0; //@line 7712
 $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 7713
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_404($8, $$byval_copy1, $17); //@line 7715
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_408($7, $$byval_copy2, $$byval_copy3); //@line 7718
 $18 = $6; //@line 7719
 $19 = $18 + 72 | 0; //@line 7720
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvperp_413($12, $$byval_copy4); //@line 7722
 $20 = $6; //@line 7723
 $21 = $20 + 112 | 0; //@line 7724
 $22 = +(+SAFE_HEAP_LOAD_D($21 | 0, 8)); //@line 7725
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_404($11, $$byval_copy5, $22); //@line 7727
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($19 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($19 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($19 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_408($10, $$byval_copy6, $$byval_copy7); //@line 7730
 SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_414($0, $$byval_copy8, $$byval_copy9); //@line 7733
 STACKTOP = sp; //@line 7734
 return;
}
function _relative_velocity_241($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 3208
 $1 = $1 | 0; //@line 3209
 $2 = $2 | 0; //@line 3210
 $3 = $3 | 0; //@line 3211
 $4 = $4 | 0; //@line 3212
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0.0, $18 = 0, $19 = 0; //@line 3213
 var $20 = 0, $21 = 0, $22 = 0.0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3214
 sp = STACKTOP; //@line 3215
 STACKTOP = STACKTOP + 272 | 0; //@line 3216
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(272 | 0); //@line 3216
 $$byval_copy9 = sp + 240 | 0; //@line 3217
 $$byval_copy8 = sp + 224 | 0; //@line 3218
 $$byval_copy7 = sp + 208 | 0; //@line 3219
 $$byval_copy6 = sp + 192 | 0; //@line 3220
 $$byval_copy5 = sp + 176 | 0; //@line 3221
 $$byval_copy4 = sp + 160 | 0; //@line 3222
 $$byval_copy3 = sp + 144 | 0; //@line 3223
 $$byval_copy2 = sp + 128 | 0; //@line 3224
 $$byval_copy1 = sp + 112 | 0; //@line 3225
 $$byval_copy = sp + 96 | 0; //@line 3226
 $7 = sp + 80 | 0; //@line 3227
 $8 = sp + 64 | 0; //@line 3228
 $9 = sp + 48 | 0; //@line 3229
 $10 = sp + 32 | 0; //@line 3230
 $11 = sp + 16 | 0; //@line 3231
 $12 = sp; //@line 3232
 $5 = $1; //@line 3233
 $6 = $2; //@line 3234
 $13 = $5; //@line 3235
 $14 = $13 + 72 | 0; //@line 3236
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvperp_253($9, $$byval_copy); //@line 3238
 $15 = $5; //@line 3239
 $16 = $15 + 112 | 0; //@line 3240
 $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 3241
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_249($8, $$byval_copy1, $17); //@line 3243
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_244($7, $$byval_copy2, $$byval_copy3); //@line 3246
 $18 = $6; //@line 3247
 $19 = $18 + 72 | 0; //@line 3248
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvperp_253($12, $$byval_copy4); //@line 3250
 $20 = $6; //@line 3251
 $21 = $20 + 112 | 0; //@line 3252
 $22 = +(+SAFE_HEAP_LOAD_D($21 | 0, 8)); //@line 3253
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_249($11, $$byval_copy5, $22); //@line 3255
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($19 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($19 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($19 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_244($10, $$byval_copy6, $$byval_copy7); //@line 3258
 SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_242($0, $$byval_copy8, $$byval_copy9); //@line 3261
 STACKTOP = sp; //@line 3262
 return;
}
function _relative_velocity($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 2050
 $1 = $1 | 0; //@line 2051
 $2 = $2 | 0; //@line 2052
 $3 = $3 | 0; //@line 2053
 $4 = $4 | 0; //@line 2054
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0.0, $18 = 0, $19 = 0; //@line 2055
 var $20 = 0, $21 = 0, $22 = 0.0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2056
 sp = STACKTOP; //@line 2057
 STACKTOP = STACKTOP + 272 | 0; //@line 2058
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(272 | 0); //@line 2058
 $$byval_copy9 = sp + 240 | 0; //@line 2059
 $$byval_copy8 = sp + 224 | 0; //@line 2060
 $$byval_copy7 = sp + 208 | 0; //@line 2061
 $$byval_copy6 = sp + 192 | 0; //@line 2062
 $$byval_copy5 = sp + 176 | 0; //@line 2063
 $$byval_copy4 = sp + 160 | 0; //@line 2064
 $$byval_copy3 = sp + 144 | 0; //@line 2065
 $$byval_copy2 = sp + 128 | 0; //@line 2066
 $$byval_copy1 = sp + 112 | 0; //@line 2067
 $$byval_copy = sp + 96 | 0; //@line 2068
 $7 = sp + 80 | 0; //@line 2069
 $8 = sp + 64 | 0; //@line 2070
 $9 = sp + 48 | 0; //@line 2071
 $10 = sp + 32 | 0; //@line 2072
 $11 = sp + 16 | 0; //@line 2073
 $12 = sp; //@line 2074
 $5 = $1; //@line 2075
 $6 = $2; //@line 2076
 $13 = $5; //@line 2077
 $14 = $13 + 72 | 0; //@line 2078
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvperp($9, $$byval_copy); //@line 2080
 $15 = $5; //@line 2081
 $16 = $15 + 112 | 0; //@line 2082
 $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 2083
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_1($8, $$byval_copy1, $17); //@line 2085
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_9($7, $$byval_copy2, $$byval_copy3); //@line 2088
 $18 = $6; //@line 2089
 $19 = $18 + 72 | 0; //@line 2090
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvperp($12, $$byval_copy4); //@line 2092
 $20 = $6; //@line 2093
 $21 = $20 + 112 | 0; //@line 2094
 $22 = +(+SAFE_HEAP_LOAD_D($21 | 0, 8)); //@line 2095
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_1($11, $$byval_copy5, $22); //@line 2097
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($19 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($19 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($19 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_9($10, $$byval_copy6, $$byval_copy7); //@line 2100
 SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_10($0, $$byval_copy8, $$byval_copy9); //@line 2103
 STACKTOP = sp; //@line 2104
 return;
}
function _cpBodyUpdatePosition($0, $1) {
 $0 = $0 | 0; //@line 5730
 $1 = +$1; //@line 5731
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0.0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0.0, $22 = 0; //@line 5732
 var $23 = 0, $24 = 0.0, $25 = 0, $26 = 0, $27 = 0.0, $28 = 0.0, $29 = 0.0, $3 = 0.0, $30 = 0.0, $31 = 0.0, $32 = 0.0, $33 = 0, $34 = 0.0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $5 = 0; //@line 5733
 var $6 = 0, $7 = 0, $8 = 0.0, $9 = 0, label = 0, sp = 0; //@line 5734
 sp = STACKTOP; //@line 5735
 STACKTOP = STACKTOP + 192 | 0; //@line 5736
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(192 | 0); //@line 5736
 $$byval_copy5 = sp + 160 | 0; //@line 5737
 $$byval_copy4 = sp + 144 | 0; //@line 5738
 $$byval_copy3 = sp + 128 | 0; //@line 5739
 $$byval_copy2 = sp + 112 | 0; //@line 5740
 $$byval_copy1 = sp + 96 | 0; //@line 5741
 $$byval_copy = sp + 80 | 0; //@line 5742
 $4 = sp + 56 | 0; //@line 5743
 $5 = sp + 40 | 0; //@line 5744
 $6 = sp + 24 | 0; //@line 5745
 $7 = sp + 8 | 0; //@line 5746
 $2 = $0; //@line 5747
 $3 = $1; //@line 5748
 $9 = $2; //@line 5749
 $10 = $9 + 56 | 0; //@line 5750
 $11 = $2; //@line 5751
 $12 = $11 + 56 | 0; //@line 5752
 $13 = $2; //@line 5753
 $14 = $13 + 72 | 0; //@line 5754
 $15 = $2; //@line 5755
 $16 = $15 + 184 | 0; //@line 5756
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($16 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($16 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($16 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_43($6, $$byval_copy, $$byval_copy1); //@line 5759
 $17 = $3; //@line 5760
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_44($5, $$byval_copy2, $17); //@line 5762
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_43($7, $$byval_copy3, $$byval_copy4); //@line 5765
 SAFE_HEAP_STORE($10 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($4 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($4 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($4 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($4 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $18 = $2; //@line 5768
 $19 = $2; //@line 5769
 $20 = $19 + 104 | 0; //@line 5770
 $21 = +(+SAFE_HEAP_LOAD_D($20 | 0, 8)); //@line 5771
 $22 = $2; //@line 5772
 $23 = $22 + 112 | 0; //@line 5773
 $24 = +(+SAFE_HEAP_LOAD_D($23 | 0, 8)); //@line 5774
 $25 = $2; //@line 5775
 $26 = $25 + 200 | 0; //@line 5776
 $27 = +(+SAFE_HEAP_LOAD_D($26 | 0, 8)); //@line 5777
 $28 = $24 + $27; //@line 5778
 $29 = $3; //@line 5779
 $30 = $28 * $29; //@line 5780
 $31 = $21 + $30; //@line 5781
 $32 = +_SetAngle($18, $31); //@line 5782
 $8 = $32; //@line 5783
 $33 = $2; //@line 5784
 $34 = $8; //@line 5785
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _SetTransform($33, $$byval_copy5, $34); //@line 5787
 $35 = $2; //@line 5788
 $36 = $35 + 184 | 0; //@line 5789
 SAFE_HEAP_STORE($36 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($36 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($36 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($36 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $37 = $2; //@line 5791
 $38 = $37 + 200 | 0; //@line 5792
 SAFE_HEAP_STORE_D($38 | 0, +0.0, 8);
 $39 = $2; //@line 5794
 _cpBodySanityCheck($39); //@line 5795
 STACKTOP = sp; //@line 5796
 return;
}
function _NodeReplaceChild($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 5199
 $1 = $1 | 0; //@line 5200
 $2 = $2 | 0; //@line 5201
 $3 = $3 | 0; //@line 5202
 var $$byval_copy = 0, $$byval_copy3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0; //@line 5203
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0; //@line 5204
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0; //@line 5205
 sp = STACKTOP; //@line 5206
 STACKTOP = STACKTOP + 144 | 0; //@line 5207
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(144 | 0); //@line 5207
 $$byval_copy3 = sp + 80 | 0; //@line 5208
 $$byval_copy = sp + 48 | 0; //@line 5209
 $vararg_buffer1 = sp + 40 | 0; //@line 5210
 $vararg_buffer = sp + 32 | 0; //@line 5211
 $9 = sp; //@line 5212
 $4 = $0; //@line 5213
 $5 = $1; //@line 5214
 $6 = $2; //@line 5215
 $7 = $3; //@line 5216
 $10 = $4; //@line 5217
 $11 = _NodeIsLeaf($10) | 0; //@line 5218
 $12 = $11 << 24 >> 24 != 0; //@line 5219
 if ($12) {
  _cpMessage(3402, 3342, 301, 1, 0, 3422, $vararg_buffer); //@line 5221
  _abort(); //@line 5222
 }
 $13 = $5; //@line 5225
 $14 = $4; //@line 5226
 $15 = $14 + 44 | 0; //@line 5227
 $16 = SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0; //@line 5228
 $17 = ($13 | 0) == ($16 | 0); //@line 5229
 if (!$17) {
  $18 = $5; //@line 5231
  $19 = $4; //@line 5232
  $20 = $19 + 44 | 0; //@line 5233
  $21 = $20 + 4 | 0; //@line 5234
  $22 = SAFE_HEAP_LOAD($21 | 0, 4, 0) | 0 | 0; //@line 5235
  $23 = ($18 | 0) == ($22 | 0); //@line 5236
  if (!$23) {
   _cpMessage(3470, 3342, 302, 1, 0, 3511, $vararg_buffer1); //@line 5238
   _abort(); //@line 5239
  }
 }
 $24 = $4; //@line 5243
 $25 = $24 + 44 | 0; //@line 5244
 $26 = SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0; //@line 5245
 $27 = $5; //@line 5246
 $28 = ($26 | 0) == ($27 | 0); //@line 5247
 $29 = $7; //@line 5248
 $30 = $4; //@line 5249
 $31 = $30 + 44 | 0; //@line 5250
 if ($28) {
  $32 = SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0; //@line 5252
  _NodeRecycle($29, $32); //@line 5253
  $33 = $4; //@line 5254
  $34 = $6; //@line 5255
  _NodeSetA($33, $34); //@line 5256
 } else {
  $35 = $31 + 4 | 0; //@line 5258
  $36 = SAFE_HEAP_LOAD($35 | 0, 4, 0) | 0 | 0; //@line 5259
  _NodeRecycle($29, $36); //@line 5260
  $37 = $4; //@line 5261
  $38 = $6; //@line 5262
  _NodeSetB($37, $38); //@line 5263
 }
 $39 = $4; //@line 5265
 $8 = $39; //@line 5266
 while (1) {
  $40 = $8; //@line 5268
  $41 = ($40 | 0) != (0 | 0); //@line 5269
  if (!$41) {
   break;
  }
  $42 = $8; //@line 5273
  $43 = $42 + 8 | 0; //@line 5274
  $44 = $8; //@line 5275
  $45 = $44 + 44 | 0; //@line 5276
  $46 = SAFE_HEAP_LOAD($45 | 0, 4, 0) | 0 | 0; //@line 5277
  $47 = $46 + 8 | 0; //@line 5278
  $48 = $8; //@line 5279
  $49 = $48 + 44 | 0; //@line 5280
  $50 = $49 + 4 | 0; //@line 5281
  $51 = SAFE_HEAP_LOAD($50 | 0, 4, 0) | 0 | 0; //@line 5282
  $52 = $51 + 8 | 0; //@line 5283
  SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($47 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($47 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($47 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($47 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 16 | 0, SAFE_HEAP_LOAD($47 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 20 | 0, SAFE_HEAP_LOAD($47 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 24 | 0, SAFE_HEAP_LOAD($47 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 28 | 0, SAFE_HEAP_LOAD($47 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($52 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($52 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($52 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($52 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 16 | 0, SAFE_HEAP_LOAD($52 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 20 | 0, SAFE_HEAP_LOAD($52 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 24 | 0, SAFE_HEAP_LOAD($52 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 28 | 0, SAFE_HEAP_LOAD($52 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpBBMerge($9, $$byval_copy, $$byval_copy3); //@line 5286
  SAFE_HEAP_STORE($43 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($43 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($43 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($43 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($43 + 16 | 0, SAFE_HEAP_LOAD($9 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($43 + 20 | 0, SAFE_HEAP_LOAD($9 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($43 + 24 | 0, SAFE_HEAP_LOAD($9 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($43 + 28 | 0, SAFE_HEAP_LOAD($9 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
  $53 = $8; //@line 5288
  $54 = $53 + 40 | 0; //@line 5289
  $55 = SAFE_HEAP_LOAD($54 | 0, 4, 0) | 0 | 0; //@line 5290
  $8 = $55; //@line 5291
 }
 STACKTOP = sp; //@line 5293
 return;
}
function _cpSpaceUnlock($0, $1) {
 $0 = $0 | 0; //@line 4138
 $1 = $1 | 0; //@line 4139
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 4140
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0; //@line 4141
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0; //@line 4142
 var $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0; //@line 4143
 var $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 4144
 sp = STACKTOP; //@line 4145
 STACKTOP = STACKTOP + 48 | 0; //@line 4146
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 4146
 $vararg_buffer = sp; //@line 4147
 $2 = $0; //@line 4148
 $3 = $1; //@line 4149
 $11 = $2; //@line 4150
 $12 = $11 + 140 | 0; //@line 4151
 $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 4152
 $14 = $13 + -1 | 0; //@line 4153
 SAFE_HEAP_STORE($12 | 0, $14 | 0, 4);
 $15 = $2; //@line 4155
 $16 = $15 + 140 | 0; //@line 4156
 $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 4157
 $18 = $17 >>> 0 >= 0; //@line 4158
 if (!$18) {
  _cpMessage(9795, 9556, 72, 1, 1, 9814, $vararg_buffer); //@line 4160
  _abort(); //@line 4161
 }
 $19 = $2; //@line 4164
 $20 = $19 + 140 | 0; //@line 4165
 $21 = SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0; //@line 4166
 $22 = ($21 | 0) == 0; //@line 4167
 if (!$22) {
  STACKTOP = sp; //@line 4169
  return;
 }
 $23 = $2; //@line 4171
 $24 = $23 + 96 | 0; //@line 4172
 $25 = SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0; //@line 4173
 $4 = $25; //@line 4174
 $5 = 0; //@line 4175
 $26 = $4; //@line 4176
 $27 = SAFE_HEAP_LOAD($26 | 0, 4, 0) | 0 | 0; //@line 4177
 $6 = $27; //@line 4178
 while (1) {
  $28 = $5; //@line 4180
  $29 = $6; //@line 4181
  $30 = ($28 | 0) < ($29 | 0); //@line 4182
  if (!$30) {
   break;
  }
  $31 = $2; //@line 4186
  $32 = $4; //@line 4187
  $33 = $32 + 8 | 0; //@line 4188
  $34 = SAFE_HEAP_LOAD($33 | 0, 4, 0) | 0 | 0; //@line 4189
  $35 = $5; //@line 4190
  $36 = $34 + ($35 << 2) | 0; //@line 4191
  $37 = SAFE_HEAP_LOAD($36 | 0, 4, 0) | 0 | 0; //@line 4192
  _cpSpaceActivateBody($31, $37); //@line 4193
  $38 = $4; //@line 4194
  $39 = $38 + 8 | 0; //@line 4195
  $40 = SAFE_HEAP_LOAD($39 | 0, 4, 0) | 0 | 0; //@line 4196
  $41 = $5; //@line 4197
  $42 = $40 + ($41 << 2) | 0; //@line 4198
  SAFE_HEAP_STORE($42 | 0, 0 | 0, 4);
  $43 = $5; //@line 4200
  $44 = $43 + 1 | 0; //@line 4201
  $5 = $44; //@line 4202
 }
 $45 = $4; //@line 4204
 SAFE_HEAP_STORE($45 | 0, 0 | 0, 4);
 $46 = $2; //@line 4206
 $47 = $46 + 140 | 0; //@line 4207
 $48 = SAFE_HEAP_LOAD($47 | 0, 4, 0) | 0 | 0; //@line 4208
 $49 = ($48 | 0) == 0; //@line 4209
 if (!$49) {
  STACKTOP = sp; //@line 4211
  return;
 }
 $50 = $3; //@line 4213
 $51 = $50 & 255; //@line 4214
 $52 = ($51 | 0) != 0; //@line 4215
 if (!$52) {
  STACKTOP = sp; //@line 4217
  return;
 }
 $53 = $2; //@line 4219
 $54 = $53 + 180 | 0; //@line 4220
 $55 = SAFE_HEAP_LOAD($54 >> 0 | 0, 1, 0) | 0 | 0; //@line 4221
 $56 = $55 << 24 >> 24 != 0; //@line 4222
 if ($56) {
  STACKTOP = sp; //@line 4224
  return;
 }
 $57 = $2; //@line 4226
 $58 = $57 + 180 | 0; //@line 4227
 SAFE_HEAP_STORE($58 >> 0 | 0, 1 | 0, 1);
 $59 = $2; //@line 4229
 $60 = $59 + 184 | 0; //@line 4230
 $61 = SAFE_HEAP_LOAD($60 | 0, 4, 0) | 0 | 0; //@line 4231
 $7 = $61; //@line 4232
 $8 = 0; //@line 4233
 while (1) {
  $62 = $8; //@line 4235
  $63 = $7; //@line 4236
  $64 = SAFE_HEAP_LOAD($63 | 0, 4, 0) | 0 | 0; //@line 4237
  $65 = ($62 | 0) < ($64 | 0); //@line 4238
  $66 = $7; //@line 4239
  if (!$65) {
   break;
  }
  $67 = $66 + 8 | 0; //@line 4243
  $68 = SAFE_HEAP_LOAD($67 | 0, 4, 0) | 0 | 0; //@line 4244
  $69 = $8; //@line 4245
  $70 = $68 + ($69 << 2) | 0; //@line 4246
  $71 = SAFE_HEAP_LOAD($70 | 0, 4, 0) | 0 | 0; //@line 4247
  $9 = $71; //@line 4248
  $72 = $9; //@line 4249
  $73 = SAFE_HEAP_LOAD($72 | 0, 4, 0) | 0 | 0; //@line 4250
  $10 = $73; //@line 4251
  $74 = $9; //@line 4252
  SAFE_HEAP_STORE($74 | 0, 0 | 0, 4);
  $75 = $10; //@line 4254
  $76 = ($75 | 0) != (0 | 0); //@line 4255
  if ($76) {
   $77 = $10; //@line 4257
   $78 = $2; //@line 4258
   $79 = $9; //@line 4259
   $80 = $79 + 4 | 0; //@line 4260
   $81 = SAFE_HEAP_LOAD($80 | 0, 4, 0) | 0 | 0; //@line 4261
   $82 = $9; //@line 4262
   $83 = $82 + 8 | 0; //@line 4263
   $84 = SAFE_HEAP_LOAD($83 | 0, 4, 0) | 0 | 0; //@line 4264
   FUNCTION_TABLE_viii[(SAFE_FT_MASK($77 | 0, 127 | 0) | 0) & 127]($78, $81, $84); //@line 4265
  }
  $85 = $7; //@line 4267
  $86 = $85 + 8 | 0; //@line 4268
  $87 = SAFE_HEAP_LOAD($86 | 0, 4, 0) | 0 | 0; //@line 4269
  $88 = $8; //@line 4270
  $89 = $87 + ($88 << 2) | 0; //@line 4271
  SAFE_HEAP_STORE($89 | 0, 0 | 0, 4);
  $90 = $9; //@line 4273
  _free($90); //@line 4274
  $91 = $8; //@line 4275
  $92 = $91 + 1 | 0; //@line 4276
  $8 = $92; //@line 4277
 }
 SAFE_HEAP_STORE($66 | 0, 0 | 0, 4);
 $93 = $2; //@line 4280
 $94 = $93 + 180 | 0; //@line 4281
 SAFE_HEAP_STORE($94 >> 0 | 0, 0 | 0, 1);
 STACKTOP = sp; //@line 4283
 return;
}
function _cpSpaceDeactivateBody($0, $1) {
 $0 = $0 | 0; //@line 3156
 $1 = $1 | 0; //@line 3157
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 3158
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0; //@line 3159
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0; //@line 3160
 var $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0; //@line 3161
 var $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 3162
 sp = STACKTOP; //@line 3163
 STACKTOP = STACKTOP + 48 | 0; //@line 3164
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 3164
 $vararg_buffer = sp; //@line 3165
 $2 = $0; //@line 3166
 $3 = $1; //@line 3167
 $11 = $3; //@line 3168
 $12 = _cpBodyGetType($11) | 0; //@line 3169
 $13 = ($12 | 0) == 0; //@line 3170
 if (!$13) {
  _cpMessage(7834, 7878, 85, 1, 1, 8503, $vararg_buffer); //@line 3172
  _abort(); //@line 3173
 }
 $14 = $2; //@line 3176
 $15 = $14 + 88 | 0; //@line 3177
 $16 = SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0; //@line 3178
 $17 = $3; //@line 3179
 _cpArrayDeleteObj($16, $17); //@line 3180
 $18 = $3; //@line 3181
 $19 = $18 + 212 | 0; //@line 3182
 $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 3183
 $4 = $20; //@line 3184
 while (1) {
  $21 = $4; //@line 3186
  $22 = ($21 | 0) != (0 | 0); //@line 3187
  if (!$22) {
   break;
  }
  $23 = $2; //@line 3191
  $24 = $23 + 112 | 0; //@line 3192
  $25 = SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0; //@line 3193
  $26 = $4; //@line 3194
  $27 = $4; //@line 3195
  $28 = $27 + 156 | 0; //@line 3196
  $29 = SAFE_HEAP_LOAD($28 | 0, 4, 0) | 0 | 0; //@line 3197
  _cpSpatialIndexRemove_480($25, $26, $29); //@line 3198
  $30 = $2; //@line 3199
  $31 = $30 + 108 | 0; //@line 3200
  $32 = SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0; //@line 3201
  $33 = $4; //@line 3202
  $34 = $4; //@line 3203
  $35 = $34 + 156 | 0; //@line 3204
  $36 = SAFE_HEAP_LOAD($35 | 0, 4, 0) | 0 | 0; //@line 3205
  _cpSpatialIndexInsert_481($32, $33, $36); //@line 3206
  $37 = $4; //@line 3207
  $38 = $37 + 148 | 0; //@line 3208
  $39 = SAFE_HEAP_LOAD($38 | 0, 4, 0) | 0 | 0; //@line 3209
  $4 = $39; //@line 3210
 }
 $40 = $3; //@line 3212
 $41 = $40 + 216 | 0; //@line 3213
 $42 = SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0; //@line 3214
 $5 = $42; //@line 3215
 while (1) {
  $43 = $5; //@line 3217
  $44 = ($43 | 0) != (0 | 0); //@line 3218
  if (!$44) {
   break;
  }
  $45 = $5; //@line 3222
  $46 = $45 + 44 | 0; //@line 3223
  $47 = SAFE_HEAP_LOAD($46 | 0, 4, 0) | 0 | 0; //@line 3224
  $6 = $47; //@line 3225
  $48 = $3; //@line 3226
  $49 = $6; //@line 3227
  $50 = ($48 | 0) == ($49 | 0); //@line 3228
  if ($50) {
   label = 10; //@line 3230
  } else {
   $51 = $6; //@line 3232
   $52 = _cpBodyGetType($51) | 0; //@line 3233
   $53 = ($52 | 0) == 2; //@line 3234
   if ($53) {
    label = 10; //@line 3236
   }
  }
  if ((label | 0) == 10) {
   label = 0; //@line 3240
   $54 = $2; //@line 3241
   $55 = $5; //@line 3242
   _cpSpaceUncacheArbiter($54, $55); //@line 3243
   $56 = $5; //@line 3244
   $57 = $56 + 68 | 0; //@line 3245
   $58 = SAFE_HEAP_LOAD($57 | 0, 4, 0) | 0 | 0; //@line 3246
   $59 = $58 * 96 | 0; //@line 3247
   $7 = $59; //@line 3248
   $60 = $7; //@line 3249
   $61 = _calloc(1, $60) | 0; //@line 3250
   $8 = $61; //@line 3251
   $62 = $8; //@line 3252
   $63 = $5; //@line 3253
   $64 = $63 + 72 | 0; //@line 3254
   $65 = SAFE_HEAP_LOAD($64 | 0, 4, 0) | 0 | 0; //@line 3255
   $66 = $7; //@line 3256
   _memcpy($62 | 0, $65 | 0, $66 | 0) | 0; //@line 3257
   $67 = $8; //@line 3258
   $68 = $5; //@line 3259
   $69 = $68 + 72 | 0; //@line 3260
   SAFE_HEAP_STORE($69 | 0, $67 | 0, 4);
  }
  $70 = $5; //@line 3263
  $71 = $3; //@line 3264
  $72 = _cpArbiterNext_482($70, $71) | 0; //@line 3265
  $5 = $72; //@line 3266
 }
 $73 = $3; //@line 3268
 $74 = $73 + 220 | 0; //@line 3269
 $75 = SAFE_HEAP_LOAD($74 | 0, 4, 0) | 0 | 0; //@line 3270
 $9 = $75; //@line 3271
 while (1) {
  $76 = $9; //@line 3273
  $77 = ($76 | 0) != (0 | 0); //@line 3274
  if (!$77) {
   break;
  }
  $78 = $9; //@line 3278
  $79 = $78 + 8 | 0; //@line 3279
  $80 = SAFE_HEAP_LOAD($79 | 0, 4, 0) | 0 | 0; //@line 3280
  $10 = $80; //@line 3281
  $81 = $3; //@line 3282
  $82 = $10; //@line 3283
  $83 = ($81 | 0) == ($82 | 0); //@line 3284
  if ($83) {
   label = 16; //@line 3286
  } else {
   $84 = $10; //@line 3288
   $85 = _cpBodyGetType($84) | 0; //@line 3289
   $86 = ($85 | 0) == 2; //@line 3290
   if ($86) {
    label = 16; //@line 3292
   }
  }
  if ((label | 0) == 16) {
   label = 0; //@line 3296
   $87 = $2; //@line 3297
   $88 = $87 + 116 | 0; //@line 3298
   $89 = SAFE_HEAP_LOAD($88 | 0, 4, 0) | 0 | 0; //@line 3299
   $90 = $9; //@line 3300
   _cpArrayDeleteObj($89, $90); //@line 3301
  }
  $91 = $9; //@line 3303
  $92 = $3; //@line 3304
  $93 = _cpConstraintNext_483($91, $92) | 0; //@line 3305
  $9 = $93; //@line 3306
 }
 STACKTOP = sp; //@line 3308
 return;
}
function _cpArbiterApplyCachedImpulse($0, $1) {
 $0 = $0 | 0; //@line 2150
 $1 = +$1; //@line 2151
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0; //@line 2152
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0.0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0.0, $36 = 0, $37 = 0, $38 = 0.0, $39 = 0, $4 = 0, $40 = 0; //@line 2153
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0.0, $45 = 0, $46 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2154
 sp = STACKTOP; //@line 2155
 STACKTOP = STACKTOP + 192 | 0; //@line 2156
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(192 | 0); //@line 2156
 $$byval_copy5 = sp + 152 | 0; //@line 2157
 $$byval_copy4 = sp + 136 | 0; //@line 2158
 $$byval_copy3 = sp + 120 | 0; //@line 2159
 $$byval_copy2 = sp + 104 | 0; //@line 2160
 $$byval_copy1 = sp + 88 | 0; //@line 2161
 $$byval_copy = sp + 72 | 0; //@line 2162
 $6 = sp + 48 | 0; //@line 2163
 $9 = sp + 32 | 0; //@line 2164
 $10 = sp + 16 | 0; //@line 2165
 $11 = sp; //@line 2166
 $2 = $0; //@line 2167
 $3 = $1; //@line 2168
 $12 = $2; //@line 2169
 $13 = _cpArbiterIsFirstContact($12) | 0; //@line 2170
 $14 = $13 << 24 >> 24 != 0; //@line 2171
 if ($14) {
  STACKTOP = sp; //@line 2173
  return;
 }
 $15 = $2; //@line 2175
 $16 = $15 + 44 | 0; //@line 2176
 $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 2177
 $4 = $17; //@line 2178
 $18 = $2; //@line 2179
 $19 = $18 + 48 | 0; //@line 2180
 $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 2181
 $5 = $20; //@line 2182
 $21 = $2; //@line 2183
 $22 = $21 + 80 | 0; //@line 2184
 SAFE_HEAP_STORE($6 | 0, SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 4 | 0, SAFE_HEAP_LOAD($22 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 8 | 0, SAFE_HEAP_LOAD($22 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 12 | 0, SAFE_HEAP_LOAD($22 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $7 = 0; //@line 2186
 while (1) {
  $23 = $7; //@line 2188
  $24 = $2; //@line 2189
  $25 = $24 + 68 | 0; //@line 2190
  $26 = SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0; //@line 2191
  $27 = ($23 | 0) < ($26 | 0); //@line 2192
  if (!$27) {
   break;
  }
  $28 = $2; //@line 2196
  $29 = $28 + 72 | 0; //@line 2197
  $30 = SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0; //@line 2198
  $31 = $7; //@line 2199
  $32 = $30 + ($31 * 96 | 0) | 0; //@line 2200
  $8 = $32; //@line 2201
  $33 = $8; //@line 2202
  $34 = $33 + 56 | 0; //@line 2203
  $35 = +(+SAFE_HEAP_LOAD_D($34 | 0, 8)); //@line 2204
  $36 = $8; //@line 2205
  $37 = $36 + 64 | 0; //@line 2206
  $38 = +(+SAFE_HEAP_LOAD_D($37 | 0, 8)); //@line 2207
  _cpv_2($10, $35, $38); //@line 2208
  SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvrotate($9, $$byval_copy, $$byval_copy1); //@line 2211
  $39 = $4; //@line 2212
  $40 = $5; //@line 2213
  $41 = $8; //@line 2214
  $42 = $8; //@line 2215
  $43 = $42 + 16 | 0; //@line 2216
  $44 = $3; //@line 2217
  SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvmult_1($11, $$byval_copy2, $44); //@line 2219
  SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($41 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($41 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($41 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($43 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($43 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($43 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($43 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _apply_impulses($39, $40, $$byval_copy3, $$byval_copy4, $$byval_copy5); //@line 2223
  $45 = $7; //@line 2224
  $46 = $45 + 1 | 0; //@line 2225
  $7 = $46; //@line 2226
 }
 STACKTOP = sp; //@line 2228
 return;
}
function _cpBodySleepWithGroup($0, $1) {
 $0 = $0 | 0; //@line 3433
 $1 = $1 | 0; //@line 3434
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 3435
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0; //@line 3436
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0; //@line 3437
 var $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $9 = 0; //@line 3438
 var $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer3 = 0, $vararg_buffer5 = 0, $vararg_buffer7 = 0, label = 0, sp = 0; //@line 3439
 sp = STACKTOP; //@line 3440
 STACKTOP = STACKTOP + 96 | 0; //@line 3441
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(96 | 0); //@line 3441
 $vararg_buffer7 = sp + 64 | 0; //@line 3442
 $vararg_buffer5 = sp + 56 | 0; //@line 3443
 $vararg_buffer3 = sp + 48 | 0; //@line 3444
 $vararg_buffer1 = sp + 40 | 0; //@line 3445
 $vararg_buffer = sp + 32 | 0; //@line 3446
 $6 = sp; //@line 3447
 $2 = $0; //@line 3448
 $3 = $1; //@line 3449
 $8 = $2; //@line 3450
 $9 = _cpBodyGetType($8) | 0; //@line 3451
 $10 = ($9 | 0) == 0; //@line 3452
 if (!$10) {
  _cpMessage(7834, 7878, 317, 1, 1, 8992, $vararg_buffer); //@line 3454
  _abort(); //@line 3455
 }
 $11 = $2; //@line 3458
 $12 = $11 + 208 | 0; //@line 3459
 $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 3460
 $4 = $13; //@line 3461
 $14 = $4; //@line 3462
 $15 = _cpSpaceIsLocked($14) | 0; //@line 3463
 $16 = $15 << 24 >> 24 != 0; //@line 3464
 if ($16) {
  _cpMessage(9035, 7878, 320, 1, 1, 9059, $vararg_buffer1); //@line 3466
  _abort(); //@line 3467
 }
 $17 = $4; //@line 3470
 $18 = +_cpSpaceGetSleepTimeThreshold($17); //@line 3471
 $19 = $18 < inf; //@line 3472
 if (!$19) {
  _cpMessage(9175, 7878, 321, 1, 1, 9222, $vararg_buffer3); //@line 3474
  _abort(); //@line 3475
 }
 $20 = $3; //@line 3478
 $21 = ($20 | 0) == (0 | 0); //@line 3479
 if (!$21) {
  $22 = $3; //@line 3481
  $23 = _cpBodyIsSleeping($22) | 0; //@line 3482
  $24 = $23 & 255; //@line 3483
  $25 = ($24 | 0) != 0; //@line 3484
  if (!$25) {
   _cpMessage(9337, 7878, 322, 1, 1, 9378, $vararg_buffer5); //@line 3486
   _abort(); //@line 3487
  }
 }
 $26 = $2; //@line 3491
 $27 = _cpBodyIsSleeping($26) | 0; //@line 3492
 $28 = $27 << 24 >> 24 != 0; //@line 3493
 $29 = $2; //@line 3494
 if ($28) {
  $30 = _ComponentRoot($29) | 0; //@line 3496
  $31 = $3; //@line 3497
  $32 = _ComponentRoot($31) | 0; //@line 3498
  $33 = ($30 | 0) == ($32 | 0); //@line 3499
  if ($33) {
   STACKTOP = sp; //@line 3501
   return;
  } else {
   _cpMessage(9432, 7878, 325, 1, 1, 9476, $vararg_buffer7); //@line 3503
   _abort(); //@line 3504
  }
 }
 $34 = $29 + 212 | 0; //@line 3508
 $35 = SAFE_HEAP_LOAD($34 | 0, 4, 0) | 0 | 0; //@line 3509
 $5 = $35; //@line 3510
 while (1) {
  $36 = $5; //@line 3512
  $37 = ($36 | 0) != (0 | 0); //@line 3513
  if (!$37) {
   break;
  }
  $38 = $5; //@line 3517
  _cpShapeCacheBB($6, $38); //@line 3518
  $39 = $5; //@line 3519
  $40 = $39 + 148 | 0; //@line 3520
  $41 = SAFE_HEAP_LOAD($40 | 0, 4, 0) | 0 | 0; //@line 3521
  $5 = $41; //@line 3522
 }
 $42 = $4; //@line 3524
 $43 = $2; //@line 3525
 _cpSpaceDeactivateBody($42, $43); //@line 3526
 $44 = $3; //@line 3527
 $45 = ($44 | 0) != (0 | 0); //@line 3528
 if ($45) {
  $46 = $3; //@line 3530
  $47 = _ComponentRoot($46) | 0; //@line 3531
  $7 = $47; //@line 3532
  $48 = $7; //@line 3533
  $49 = $2; //@line 3534
  $50 = $49 + 224 | 0; //@line 3535
  SAFE_HEAP_STORE($50 | 0, $48 | 0, 4);
  $51 = $7; //@line 3537
  $52 = $51 + 224 | 0; //@line 3538
  $53 = $52 + 4 | 0; //@line 3539
  $54 = SAFE_HEAP_LOAD($53 | 0, 4, 0) | 0 | 0; //@line 3540
  $55 = $2; //@line 3541
  $56 = $55 + 224 | 0; //@line 3542
  $57 = $56 + 4 | 0; //@line 3543
  SAFE_HEAP_STORE($57 | 0, $54 | 0, 4);
  $58 = $2; //@line 3545
  $59 = $58 + 224 | 0; //@line 3546
  $60 = $59 + 8 | 0; //@line 3547
  SAFE_HEAP_STORE_D($60 | 0, +0.0, 8);
  $61 = $2; //@line 3549
  $62 = $7; //@line 3550
  $63 = $62 + 224 | 0; //@line 3551
  $64 = $63 + 4 | 0; //@line 3552
  SAFE_HEAP_STORE($64 | 0, $61 | 0, 4);
 } else {
  $65 = $2; //@line 3555
  $66 = $2; //@line 3556
  $67 = $66 + 224 | 0; //@line 3557
  SAFE_HEAP_STORE($67 | 0, $65 | 0, 4);
  $68 = $2; //@line 3559
  $69 = $68 + 224 | 0; //@line 3560
  $70 = $69 + 4 | 0; //@line 3561
  SAFE_HEAP_STORE($70 | 0, 0 | 0, 4);
  $71 = $2; //@line 3563
  $72 = $71 + 224 | 0; //@line 3564
  $73 = $72 + 8 | 0; //@line 3565
  SAFE_HEAP_STORE_D($73 | 0, +0.0, 8);
  $74 = $4; //@line 3567
  $75 = $74 + 100 | 0; //@line 3568
  $76 = SAFE_HEAP_LOAD($75 | 0, 4, 0) | 0 | 0; //@line 3569
  $77 = $2; //@line 3570
  _cpArrayPush($76, $77); //@line 3571
 }
 $78 = $4; //@line 3573
 $79 = $78 + 88 | 0; //@line 3574
 $80 = SAFE_HEAP_LOAD($79 | 0, 4, 0) | 0 | 0; //@line 3575
 $81 = $2; //@line 3576
 _cpArrayDeleteObj($80, $81); //@line 3577
 STACKTOP = sp; //@line 3578
 return;
}
function _cpClosetPointOnSegment_370($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 6931
 $1 = $1 | 0; //@line 6932
 $2 = $2 | 0; //@line 6933
 $3 = $3 | 0; //@line 6934
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0.0, $11 = 0.0, $12 = 0.0, $4 = 0, $5 = 0.0, $6 = 0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0; //@line 6935
 var sp = 0; //@line 6936
 sp = STACKTOP; //@line 6937
 STACKTOP = STACKTOP + 224 | 0; //@line 6938
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(224 | 0); //@line 6938
 $$byval_copy9 = sp + 200 | 0; //@line 6939
 $$byval_copy8 = sp + 184 | 0; //@line 6940
 $$byval_copy7 = sp + 168 | 0; //@line 6941
 $$byval_copy6 = sp + 152 | 0; //@line 6942
 $$byval_copy5 = sp + 136 | 0; //@line 6943
 $$byval_copy4 = sp + 120 | 0; //@line 6944
 $$byval_copy3 = sp + 104 | 0; //@line 6945
 $$byval_copy2 = sp + 88 | 0; //@line 6946
 $$byval_copy1 = sp + 72 | 0; //@line 6947
 $$byval_copy = sp + 56 | 0; //@line 6948
 $4 = sp + 40 | 0; //@line 6949
 $6 = sp + 16 | 0; //@line 6950
 $7 = sp; //@line 6951
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_354($4, $$byval_copy, $$byval_copy1); //@line 6954
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_354($6, $$byval_copy2, $$byval_copy3); //@line 6957
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $8 = +_cpvdot_359($$byval_copy4, $$byval_copy5); //@line 6960
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $9 = +_cpvlengthsq_371($$byval_copy6); //@line 6962
 $10 = $8 / $9; //@line 6963
 $11 = +_cpfclamp01_372($10); //@line 6964
 $5 = $11; //@line 6965
 $12 = $5; //@line 6966
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_357($7, $$byval_copy7, $12); //@line 6968
 SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_363($0, $$byval_copy8, $$byval_copy9); //@line 6971
 STACKTOP = sp; //@line 6972
 return;
}
function _cpClosetPointOnSegment($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 4813
 $1 = $1 | 0; //@line 4814
 $2 = $2 | 0; //@line 4815
 $3 = $3 | 0; //@line 4816
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $$byval_copy8 = 0, $$byval_copy9 = 0, $10 = 0.0, $11 = 0.0, $12 = 0.0, $4 = 0, $5 = 0.0, $6 = 0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0; //@line 4817
 var sp = 0; //@line 4818
 sp = STACKTOP; //@line 4819
 STACKTOP = STACKTOP + 224 | 0; //@line 4820
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(224 | 0); //@line 4820
 $$byval_copy9 = sp + 200 | 0; //@line 4821
 $$byval_copy8 = sp + 184 | 0; //@line 4822
 $$byval_copy7 = sp + 168 | 0; //@line 4823
 $$byval_copy6 = sp + 152 | 0; //@line 4824
 $$byval_copy5 = sp + 136 | 0; //@line 4825
 $$byval_copy4 = sp + 120 | 0; //@line 4826
 $$byval_copy3 = sp + 104 | 0; //@line 4827
 $$byval_copy2 = sp + 88 | 0; //@line 4828
 $$byval_copy1 = sp + 72 | 0; //@line 4829
 $$byval_copy = sp + 56 | 0; //@line 4830
 $4 = sp + 40 | 0; //@line 4831
 $6 = sp + 16 | 0; //@line 4832
 $7 = sp; //@line 4833
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_266($4, $$byval_copy, $$byval_copy1); //@line 4836
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_266($6, $$byval_copy2, $$byval_copy3); //@line 4839
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $8 = +_cpvdot_272($$byval_copy4, $$byval_copy5); //@line 4842
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $9 = +_cpvlengthsq_278($$byval_copy6); //@line 4844
 $10 = $8 / $9; //@line 4845
 $11 = +_cpfclamp01_279($10); //@line 4846
 $5 = $11; //@line 4847
 $12 = $5; //@line 4848
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_270($7, $$byval_copy7, $12); //@line 4850
 SAFE_HEAP_STORE($$byval_copy8 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy8 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy9 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_276($0, $$byval_copy8, $$byval_copy9); //@line 4853
 STACKTOP = sp; //@line 4854
 return;
}
function _SubtreeQuery($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 3732
 $1 = $1 | 0; //@line 3733
 $2 = $2 | 0; //@line 3734
 $3 = $3 | 0; //@line 3735
 $4 = $4 | 0; //@line 3736
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0; //@line 3737
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3738
 sp = STACKTOP; //@line 3739
 STACKTOP = STACKTOP + 144 | 0; //@line 3740
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(144 | 0); //@line 3740
 $$byval_copy3 = sp + 96 | 0; //@line 3741
 $$byval_copy2 = sp + 64 | 0; //@line 3742
 $$byval_copy1 = sp + 32 | 0; //@line 3743
 $$byval_copy = sp; //@line 3744
 $5 = $0; //@line 3745
 $6 = $1; //@line 3746
 $7 = $3; //@line 3747
 $8 = $4; //@line 3748
 $9 = $5; //@line 3749
 $10 = $9 + 8 | 0; //@line 3750
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 16 | 0, SAFE_HEAP_LOAD($10 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 20 | 0, SAFE_HEAP_LOAD($10 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 24 | 0, SAFE_HEAP_LOAD($10 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 28 | 0, SAFE_HEAP_LOAD($10 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 16 | 0, SAFE_HEAP_LOAD($2 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 20 | 0, SAFE_HEAP_LOAD($2 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 24 | 0, SAFE_HEAP_LOAD($2 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 28 | 0, SAFE_HEAP_LOAD($2 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 $11 = _cpBBIntersects($$byval_copy, $$byval_copy1) | 0; //@line 3753
 $12 = $11 << 24 >> 24 != 0; //@line 3754
 if (!$12) {
  STACKTOP = sp; //@line 3756
  return;
 }
 $13 = $5; //@line 3758
 $14 = _NodeIsLeaf($13) | 0; //@line 3759
 $15 = $14 << 24 >> 24 != 0; //@line 3760
 if ($15) {
  $16 = $7; //@line 3762
  $17 = $6; //@line 3763
  $18 = $5; //@line 3764
  $19 = SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0; //@line 3765
  $20 = $8; //@line 3766
  FUNCTION_TABLE_iiiii[(SAFE_FT_MASK($16 | 0, 127 | 0) | 0) & 127]($17, $19, 0, $20) | 0; //@line 3767
  STACKTOP = sp; //@line 3768
  return;
 } else {
  $21 = $5; //@line 3770
  $22 = $21 + 44 | 0; //@line 3771
  $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 3772
  $24 = $6; //@line 3773
  $25 = $7; //@line 3774
  $26 = $8; //@line 3775
  SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 16 | 0, SAFE_HEAP_LOAD($2 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 20 | 0, SAFE_HEAP_LOAD($2 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 24 | 0, SAFE_HEAP_LOAD($2 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 28 | 0, SAFE_HEAP_LOAD($2 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
  _SubtreeQuery($23, $24, $$byval_copy2, $25, $26); //@line 3777
  $27 = $5; //@line 3778
  $28 = $27 + 44 | 0; //@line 3779
  $29 = $28 + 4 | 0; //@line 3780
  $30 = SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0; //@line 3781
  $31 = $6; //@line 3782
  $32 = $7; //@line 3783
  $33 = $8; //@line 3784
  SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 16 | 0, SAFE_HEAP_LOAD($2 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 20 | 0, SAFE_HEAP_LOAD($2 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 24 | 0, SAFE_HEAP_LOAD($2 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 28 | 0, SAFE_HEAP_LOAD($2 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
  _SubtreeQuery($30, $31, $$byval_copy3, $32, $33); //@line 3786
  STACKTOP = sp; //@line 3787
  return;
 }
}
function ___stdio_write($0, $1, $2) {
 $0 = $0 | 0; //@line 10552
 $1 = $1 | 0; //@line 10553
 $2 = $2 | 0; //@line 10554
 var $$0 = 0, $$04756 = 0, $$04855 = 0, $$04954 = 0, $$051 = 0, $$1 = 0, $$150 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0; //@line 10555
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0; //@line 10556
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer3 = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0; //@line 10557
 var $vararg_ptr6 = 0, $vararg_ptr7 = 0, label = 0, sp = 0; //@line 10558
 sp = STACKTOP; //@line 10559
 STACKTOP = STACKTOP + 48 | 0; //@line 10560
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 10560
 $vararg_buffer3 = sp + 32 | 0; //@line 10561
 $vararg_buffer = sp + 16 | 0; //@line 10562
 $3 = sp; //@line 10563
 $4 = $0 + 28 | 0; //@line 10564
 $5 = SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0; //@line 10565
 SAFE_HEAP_STORE($3 | 0, $5 | 0, 4);
 $6 = $3 + 4 | 0; //@line 10567
 $7 = $0 + 20 | 0; //@line 10568
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 10569
 $9 = $8 - $5 | 0; //@line 10570
 SAFE_HEAP_STORE($6 | 0, $9 | 0, 4);
 $10 = $3 + 8 | 0; //@line 10572
 SAFE_HEAP_STORE($10 | 0, $1 | 0, 4);
 $11 = $3 + 12 | 0; //@line 10574
 SAFE_HEAP_STORE($11 | 0, $2 | 0, 4);
 $12 = $9 + $2 | 0; //@line 10576
 $13 = $0 + 60 | 0; //@line 10577
 $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 10578
 $15 = $3; //@line 10579
 SAFE_HEAP_STORE($vararg_buffer | 0, $14 | 0, 4);
 $vararg_ptr1 = $vararg_buffer + 4 | 0; //@line 10581
 SAFE_HEAP_STORE($vararg_ptr1 | 0, $15 | 0, 4);
 $vararg_ptr2 = $vararg_buffer + 8 | 0; //@line 10583
 SAFE_HEAP_STORE($vararg_ptr2 | 0, 2 | 0, 4);
 $16 = ___syscall146(146, $vararg_buffer | 0) | 0; //@line 10585
 $17 = ___syscall_ret($16) | 0; //@line 10586
 $18 = ($12 | 0) == ($17 | 0); //@line 10587
 L1 : do {
  if ($18) {
   label = 3; //@line 10590
  } else {
   $$04756 = 2; //@line 10592
   $$04855 = $12; //@line 10592
   $$04954 = $3; //@line 10592
   $27 = $17; //@line 10592
   while (1) {
    $26 = ($27 | 0) < 0; //@line 10594
    if ($26) {
     break;
    }
    $35 = $$04855 - $27 | 0; //@line 10598
    $36 = $$04954 + 4 | 0; //@line 10599
    $37 = SAFE_HEAP_LOAD($36 | 0, 4, 0) | 0 | 0; //@line 10600
    $38 = $27 >>> 0 > $37 >>> 0; //@line 10601
    $39 = $$04954 + 8 | 0; //@line 10602
    $$150 = $38 ? $39 : $$04954; //@line 10603
    $40 = $38 << 31 >> 31; //@line 10604
    $$1 = $$04756 + $40 | 0; //@line 10605
    $41 = $38 ? $37 : 0; //@line 10606
    $$0 = $27 - $41 | 0; //@line 10607
    $42 = SAFE_HEAP_LOAD($$150 | 0, 4, 0) | 0 | 0; //@line 10608
    $43 = $42 + $$0 | 0; //@line 10609
    SAFE_HEAP_STORE($$150 | 0, $43 | 0, 4);
    $44 = $$150 + 4 | 0; //@line 10611
    $45 = SAFE_HEAP_LOAD($44 | 0, 4, 0) | 0 | 0; //@line 10612
    $46 = $45 - $$0 | 0; //@line 10613
    SAFE_HEAP_STORE($44 | 0, $46 | 0, 4);
    $47 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 10615
    $48 = $$150; //@line 10616
    SAFE_HEAP_STORE($vararg_buffer3 | 0, $47 | 0, 4);
    $vararg_ptr6 = $vararg_buffer3 + 4 | 0; //@line 10618
    SAFE_HEAP_STORE($vararg_ptr6 | 0, $48 | 0, 4);
    $vararg_ptr7 = $vararg_buffer3 + 8 | 0; //@line 10620
    SAFE_HEAP_STORE($vararg_ptr7 | 0, $$1 | 0, 4);
    $49 = ___syscall146(146, $vararg_buffer3 | 0) | 0; //@line 10622
    $50 = ___syscall_ret($49) | 0; //@line 10623
    $51 = ($35 | 0) == ($50 | 0); //@line 10624
    if ($51) {
     label = 3; //@line 10626
     break L1;
    } else {
     $$04756 = $$1; //@line 10629
     $$04855 = $35; //@line 10629
     $$04954 = $$150; //@line 10629
     $27 = $50; //@line 10629
    }
   }
   $28 = $0 + 16 | 0; //@line 10632
   SAFE_HEAP_STORE($28 | 0, 0 | 0, 4);
   SAFE_HEAP_STORE($4 | 0, 0 | 0, 4);
   SAFE_HEAP_STORE($7 | 0, 0 | 0, 4);
   $29 = SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0; //@line 10636
   $30 = $29 | 32; //@line 10637
   SAFE_HEAP_STORE($0 | 0, $30 | 0, 4);
   $31 = ($$04756 | 0) == 2; //@line 10639
   if ($31) {
    $$051 = 0; //@line 10641
   } else {
    $32 = $$04954 + 4 | 0; //@line 10643
    $33 = SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0; //@line 10644
    $34 = $2 - $33 | 0; //@line 10645
    $$051 = $34; //@line 10646
   }
  }
 } while (0);
 if ((label | 0) == 3) {
  $19 = $0 + 44 | 0; //@line 10651
  $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 10652
  $21 = $0 + 48 | 0; //@line 10653
  $22 = SAFE_HEAP_LOAD($21 | 0, 4, 0) | 0 | 0; //@line 10654
  $23 = $20 + $22 | 0; //@line 10655
  $24 = $0 + 16 | 0; //@line 10656
  SAFE_HEAP_STORE($24 | 0, $23 | 0, 4);
  $25 = $20; //@line 10658
  SAFE_HEAP_STORE($4 | 0, $25 | 0, 4);
  SAFE_HEAP_STORE($7 | 0, $25 | 0, 4);
  $$051 = $2; //@line 10661
 }
 STACKTOP = sp; //@line 10663
 return $$051 | 0; //@line 10663
}
function _MarkLeaf($0, $1) {
 $0 = $0 | 0; //@line 3928
 $1 = $1 | 0; //@line 3929
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 3930
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0; //@line 3931
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0; //@line 3932
 var $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0; //@line 3933
 var $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $9 = 0, label = 0, sp = 0; //@line 3934
 sp = STACKTOP; //@line 3935
 STACKTOP = STACKTOP + 32 | 0; //@line 3936
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 3936
 $2 = $0; //@line 3937
 $3 = $1; //@line 3938
 $8 = $3; //@line 3939
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 3940
 $4 = $9; //@line 3941
 $10 = $2; //@line 3942
 $11 = $10 + 44 | 0; //@line 3943
 $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 3944
 $13 = $4; //@line 3945
 $14 = _GetMasterTree($13) | 0; //@line 3946
 $15 = $14 + 40 | 0; //@line 3947
 $16 = SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0; //@line 3948
 $17 = ($12 | 0) == ($16 | 0); //@line 3949
 if (!$17) {
  $52 = $2; //@line 3951
  $53 = $52 + 44 | 0; //@line 3952
  $54 = $53 + 4 | 0; //@line 3953
  $55 = SAFE_HEAP_LOAD($54 | 0, 4, 0) | 0 | 0; //@line 3954
  $7 = $55; //@line 3955
  while (1) {
   $56 = $7; //@line 3957
   $57 = ($56 | 0) != (0 | 0); //@line 3958
   if (!$57) {
    break;
   }
   $58 = $2; //@line 3962
   $59 = $7; //@line 3963
   $60 = $59 + 12 | 0; //@line 3964
   $61 = $60 + 4 | 0; //@line 3965
   $62 = SAFE_HEAP_LOAD($61 | 0, 4, 0) | 0 | 0; //@line 3966
   $63 = ($58 | 0) == ($62 | 0); //@line 3967
   if ($63) {
    $64 = $3; //@line 3969
    $65 = $64 + 8 | 0; //@line 3970
    $66 = SAFE_HEAP_LOAD($65 | 0, 4, 0) | 0 | 0; //@line 3971
    $67 = $7; //@line 3972
    $68 = $67 + 4 | 0; //@line 3973
    $69 = SAFE_HEAP_LOAD($68 | 0, 4, 0) | 0 | 0; //@line 3974
    $70 = SAFE_HEAP_LOAD($69 | 0, 4, 0) | 0 | 0; //@line 3975
    $71 = $2; //@line 3976
    $72 = SAFE_HEAP_LOAD($71 | 0, 4, 0) | 0 | 0; //@line 3977
    $73 = $7; //@line 3978
    $74 = $73 + 24 | 0; //@line 3979
    $75 = SAFE_HEAP_LOAD($74 | 0, 4, 0) | 0 | 0; //@line 3980
    $76 = $3; //@line 3981
    $77 = $76 + 12 | 0; //@line 3982
    $78 = SAFE_HEAP_LOAD($77 | 0, 4, 0) | 0 | 0; //@line 3983
    $79 = FUNCTION_TABLE_iiiii[(SAFE_FT_MASK($66 | 0, 127 | 0) | 0) & 127]($70, $72, $75, $78) | 0; //@line 3984
    $80 = $7; //@line 3985
    $81 = $80 + 24 | 0; //@line 3986
    SAFE_HEAP_STORE($81 | 0, $79 | 0, 4);
    $82 = $7; //@line 3988
    $83 = $82 + 12 | 0; //@line 3989
    $84 = $83 + 8 | 0; //@line 3990
    $85 = SAFE_HEAP_LOAD($84 | 0, 4, 0) | 0 | 0; //@line 3991
    $7 = $85; //@line 3992
   } else {
    $86 = $7; //@line 3994
    $87 = $86 + 8 | 0; //@line 3995
    $88 = SAFE_HEAP_LOAD($87 | 0, 4, 0) | 0 | 0; //@line 3996
    $7 = $88; //@line 3997
   }
  }
  STACKTOP = sp; //@line 4000
  return;
 }
 $18 = $3; //@line 4002
 $19 = $18 + 4 | 0; //@line 4003
 $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 4004
 $5 = $20; //@line 4005
 $21 = $5; //@line 4006
 $22 = ($21 | 0) != (0 | 0); //@line 4007
 if ($22) {
  $23 = $5; //@line 4009
  $24 = $2; //@line 4010
  $25 = $3; //@line 4011
  _MarkLeafQuery($23, $24, 0, $25); //@line 4012
 }
 $26 = $2; //@line 4014
 $6 = $26; //@line 4015
 while (1) {
  $27 = $6; //@line 4017
  $28 = $27 + 40 | 0; //@line 4018
  $29 = SAFE_HEAP_LOAD($28 | 0, 4, 0) | 0 | 0; //@line 4019
  $30 = ($29 | 0) != (0 | 0); //@line 4020
  if (!$30) {
   break;
  }
  $31 = $6; //@line 4024
  $32 = $6; //@line 4025
  $33 = $32 + 40 | 0; //@line 4026
  $34 = SAFE_HEAP_LOAD($33 | 0, 4, 0) | 0 | 0; //@line 4027
  $35 = $34 + 44 | 0; //@line 4028
  $36 = SAFE_HEAP_LOAD($35 | 0, 4, 0) | 0 | 0; //@line 4029
  $37 = ($31 | 0) == ($36 | 0); //@line 4030
  $38 = $6; //@line 4031
  $39 = $38 + 40 | 0; //@line 4032
  $40 = SAFE_HEAP_LOAD($39 | 0, 4, 0) | 0 | 0; //@line 4033
  $41 = $40 + 44 | 0; //@line 4034
  if ($37) {
   $42 = $41 + 4 | 0; //@line 4036
   $43 = SAFE_HEAP_LOAD($42 | 0, 4, 0) | 0 | 0; //@line 4037
   $44 = $2; //@line 4038
   $45 = $3; //@line 4039
   _MarkLeafQuery($43, $44, 1, $45); //@line 4040
  } else {
   $46 = SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0; //@line 4042
   $47 = $2; //@line 4043
   $48 = $3; //@line 4044
   _MarkLeafQuery($46, $47, 0, $48); //@line 4045
  }
  $49 = $6; //@line 4047
  $50 = $49 + 40 | 0; //@line 4048
  $51 = SAFE_HEAP_LOAD($50 | 0, 4, 0) | 0 | 0; //@line 4049
  $6 = $51; //@line 4050
 }
 STACKTOP = sp; //@line 4052
 return;
}
function _cpBodyApplyForceAtWorldPoint($0, $1, $2) {
 $0 = $0 | 0; //@line 7381
 $1 = $1 | 0; //@line 7382
 $2 = $2 | 0; //@line 7383
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $$byval_copy7 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0.0, $17 = 0, $18 = 0, $19 = 0.0, $20 = 0.0, $3 = 0; //@line 7384
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 7385
 sp = STACKTOP; //@line 7386
 STACKTOP = STACKTOP + 224 | 0; //@line 7387
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(224 | 0); //@line 7387
 $$byval_copy7 = sp + 192 | 0; //@line 7388
 $$byval_copy6 = sp + 176 | 0; //@line 7389
 $$byval_copy5 = sp + 160 | 0; //@line 7390
 $$byval_copy4 = sp + 144 | 0; //@line 7391
 $$byval_copy3 = sp + 128 | 0; //@line 7392
 $$byval_copy2 = sp + 80 | 0; //@line 7393
 $$byval_copy1 = sp + 64 | 0; //@line 7394
 $$byval_copy = sp + 48 | 0; //@line 7395
 $4 = sp + 32 | 0; //@line 7396
 $5 = sp + 16 | 0; //@line 7397
 $6 = sp; //@line 7398
 $3 = $0; //@line 7399
 $7 = $3; //@line 7400
 _cpBodyActivate($7); //@line 7401
 $8 = $3; //@line 7402
 $9 = $8 + 88 | 0; //@line 7403
 $10 = $3; //@line 7404
 $11 = $10 + 88 | 0; //@line 7405
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_43($4, $$byval_copy, $$byval_copy1); //@line 7408
 SAFE_HEAP_STORE($9 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($9 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($9 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($9 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $12 = $3; //@line 7410
 $13 = $12 + 128 | 0; //@line 7411
 $14 = $3; //@line 7412
 $15 = $14 + 40 | 0; //@line 7413
 dest = $$byval_copy2; //@line 7414
 src = $13; //@line 7414
 stop = dest + 48 | 0; //@line 7414
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 7414
  src = src + 4 | 0; //@line 7414
 } while ((dest | 0) < (stop | 0));
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($15 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($15 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($15 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpTransformPoint($6, $$byval_copy2, $$byval_copy3); //@line 7416
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_49($5, $$byval_copy4, $$byval_copy5); //@line 7419
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy7 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $16 = +_cpvcross_52($$byval_copy6, $$byval_copy7); //@line 7422
 $17 = $3; //@line 7423
 $18 = $17 + 120 | 0; //@line 7424
 $19 = +(+SAFE_HEAP_LOAD_D($18 | 0, 8)); //@line 7425
 $20 = $19 + $16; //@line 7426
 SAFE_HEAP_STORE_D($18 | 0, +$20, 8);
 STACKTOP = sp; //@line 7428
 return;
}
function _memchr($0, $1, $2) {
 $0 = $0 | 0; //@line 11241
 $1 = $1 | 0; //@line 11242
 $2 = $2 | 0; //@line 11243
 var $$0$lcssa = 0, $$035$lcssa = 0, $$035$lcssa65 = 0, $$03555 = 0, $$036$lcssa = 0, $$036$lcssa64 = 0, $$03654 = 0, $$046 = 0, $$137$lcssa = 0, $$137$lcssa66 = 0, $$13745 = 0, $$140 = 0, $$23839 = 0, $$in = 0, $$lcssa = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0; //@line 11244
 var $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0; //@line 11245
 var $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond53 = 0, label = 0, sp = 0; //@line 11246
 sp = STACKTOP; //@line 11247
 $3 = $1 & 255; //@line 11248
 $4 = $0; //@line 11249
 $5 = $4 & 3; //@line 11250
 $6 = ($5 | 0) != 0; //@line 11251
 $7 = ($2 | 0) != 0; //@line 11252
 $or$cond53 = $7 & $6; //@line 11253
 L1 : do {
  if ($or$cond53) {
   $8 = $1 & 255; //@line 11256
   $$03555 = $0; //@line 11257
   $$03654 = $2; //@line 11257
   while (1) {
    $9 = SAFE_HEAP_LOAD($$03555 >> 0 | 0, 1, 0) | 0 | 0; //@line 11259
    $10 = $9 << 24 >> 24 == $8 << 24 >> 24; //@line 11260
    if ($10) {
     $$035$lcssa65 = $$03555; //@line 11262
     $$036$lcssa64 = $$03654; //@line 11262
     label = 6; //@line 11263
     break L1;
    }
    $11 = $$03555 + 1 | 0; //@line 11266
    $12 = $$03654 + -1 | 0; //@line 11267
    $13 = $11; //@line 11268
    $14 = $13 & 3; //@line 11269
    $15 = ($14 | 0) != 0; //@line 11270
    $16 = ($12 | 0) != 0; //@line 11271
    $or$cond = $16 & $15; //@line 11272
    if ($or$cond) {
     $$03555 = $11; //@line 11274
     $$03654 = $12; //@line 11274
    } else {
     $$035$lcssa = $11; //@line 11276
     $$036$lcssa = $12; //@line 11276
     $$lcssa = $16; //@line 11276
     label = 5; //@line 11277
     break;
    }
   }
  } else {
   $$035$lcssa = $0; //@line 11282
   $$036$lcssa = $2; //@line 11282
   $$lcssa = $7; //@line 11282
   label = 5; //@line 11283
  }
 } while (0);
 if ((label | 0) == 5) {
  if ($$lcssa) {
   $$035$lcssa65 = $$035$lcssa; //@line 11288
   $$036$lcssa64 = $$036$lcssa; //@line 11288
   label = 6; //@line 11289
  } else {
   label = 16; //@line 11291
  }
 }
 L8 : do {
  if ((label | 0) == 6) {
   $17 = SAFE_HEAP_LOAD($$035$lcssa65 >> 0 | 0, 1, 0) | 0 | 0; //@line 11296
   $18 = $1 & 255; //@line 11297
   $19 = $17 << 24 >> 24 == $18 << 24 >> 24; //@line 11298
   if ($19) {
    $38 = ($$036$lcssa64 | 0) == 0; //@line 11300
    if ($38) {
     label = 16; //@line 11302
     break;
    } else {
     $39 = $$035$lcssa65; //@line 11305
     break;
    }
   }
   $20 = Math_imul($3, 16843009) | 0; //@line 11309
   $21 = $$036$lcssa64 >>> 0 > 3; //@line 11310
   L13 : do {
    if ($21) {
     $$046 = $$035$lcssa65; //@line 11313
     $$13745 = $$036$lcssa64; //@line 11313
     while (1) {
      $22 = SAFE_HEAP_LOAD($$046 | 0, 4, 0) | 0 | 0; //@line 11315
      $23 = $22 ^ $20; //@line 11316
      $24 = $23 + -16843009 | 0; //@line 11317
      $25 = $23 & -2139062144; //@line 11318
      $26 = $25 ^ -2139062144; //@line 11319
      $27 = $26 & $24; //@line 11320
      $28 = ($27 | 0) == 0; //@line 11321
      if (!$28) {
       $$137$lcssa66 = $$13745; //@line 11323
       $$in = $$046; //@line 11323
       break L13;
      }
      $29 = $$046 + 4 | 0; //@line 11326
      $30 = $$13745 + -4 | 0; //@line 11327
      $31 = $30 >>> 0 > 3; //@line 11328
      if ($31) {
       $$046 = $29; //@line 11330
       $$13745 = $30; //@line 11330
      } else {
       $$0$lcssa = $29; //@line 11332
       $$137$lcssa = $30; //@line 11332
       label = 11; //@line 11333
       break;
      }
     }
    } else {
     $$0$lcssa = $$035$lcssa65; //@line 11338
     $$137$lcssa = $$036$lcssa64; //@line 11338
     label = 11; //@line 11339
    }
   } while (0);
   if ((label | 0) == 11) {
    $32 = ($$137$lcssa | 0) == 0; //@line 11343
    if ($32) {
     label = 16; //@line 11345
     break;
    } else {
     $$137$lcssa66 = $$137$lcssa; //@line 11348
     $$in = $$0$lcssa; //@line 11348
    }
   }
   $$140 = $$in; //@line 11351
   $$23839 = $$137$lcssa66; //@line 11351
   while (1) {
    $33 = SAFE_HEAP_LOAD($$140 >> 0 | 0, 1, 0) | 0 | 0; //@line 11353
    $34 = $33 << 24 >> 24 == $18 << 24 >> 24; //@line 11354
    if ($34) {
     $39 = $$140; //@line 11356
     break L8;
    }
    $35 = $$140 + 1 | 0; //@line 11359
    $36 = $$23839 + -1 | 0; //@line 11360
    $37 = ($36 | 0) == 0; //@line 11361
    if ($37) {
     label = 16; //@line 11363
     break;
    } else {
     $$140 = $35; //@line 11366
     $$23839 = $36; //@line 11366
    }
   }
  }
 } while (0);
 if ((label | 0) == 16) {
  $39 = 0; //@line 11372
 }
 return $39 | 0; //@line 11374
}
function _LeafUpdate($0, $1) {
 $0 = $0 | 0; //@line 4343
 $1 = $1 | 0; //@line 4344
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0; //@line 4345
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $5 = 0; //@line 4346
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 4347
 sp = STACKTOP; //@line 4348
 STACKTOP = STACKTOP + 144 | 0; //@line 4349
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(144 | 0); //@line 4349
 $$byval_copy1 = sp + 96 | 0; //@line 4350
 $$byval_copy = sp + 64 | 0; //@line 4351
 $6 = sp + 32 | 0; //@line 4352
 $7 = sp; //@line 4353
 $3 = $0; //@line 4354
 $4 = $1; //@line 4355
 $8 = $4; //@line 4356
 $9 = $8 + 24 | 0; //@line 4357
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 4358
 $5 = $10; //@line 4359
 $11 = $4; //@line 4360
 $12 = $11 + 4 | 0; //@line 4361
 $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 4362
 $14 = $3; //@line 4363
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 4364
 FUNCTION_TABLE_vii[(SAFE_FT_MASK($13 | 0, 127 | 0) | 0) & 127]($6, $15); //@line 4365
 $16 = $3; //@line 4366
 $17 = $16 + 8 | 0; //@line 4367
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($17 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($17 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($17 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 16 | 0, SAFE_HEAP_LOAD($17 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 20 | 0, SAFE_HEAP_LOAD($17 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 24 | 0, SAFE_HEAP_LOAD($17 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 28 | 0, SAFE_HEAP_LOAD($17 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 16 | 0, SAFE_HEAP_LOAD($6 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 20 | 0, SAFE_HEAP_LOAD($6 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 24 | 0, SAFE_HEAP_LOAD($6 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 28 | 0, SAFE_HEAP_LOAD($6 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 $18 = _cpBBContainsBB($$byval_copy, $$byval_copy1) | 0; //@line 4370
 $19 = $18 << 24 >> 24 != 0; //@line 4371
 if ($19) {
  $2 = 0; //@line 4373
  $43 = $2; //@line 4374
  STACKTOP = sp; //@line 4375
  return $43 | 0; //@line 4375
 } else {
  $20 = $3; //@line 4377
  $21 = $20 + 8 | 0; //@line 4378
  $22 = $4; //@line 4379
  $23 = $3; //@line 4380
  $24 = SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0; //@line 4381
  _GetBB($7, $22, $24); //@line 4382
  SAFE_HEAP_STORE($21 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($21 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($21 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($21 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($21 + 16 | 0, SAFE_HEAP_LOAD($7 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($21 + 20 | 0, SAFE_HEAP_LOAD($7 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($21 + 24 | 0, SAFE_HEAP_LOAD($7 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($21 + 28 | 0, SAFE_HEAP_LOAD($7 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
  $25 = $5; //@line 4384
  $26 = $3; //@line 4385
  $27 = $4; //@line 4386
  $28 = _SubtreeRemove($25, $26, $27) | 0; //@line 4387
  $5 = $28; //@line 4388
  $29 = $5; //@line 4389
  $30 = $3; //@line 4390
  $31 = $4; //@line 4391
  $32 = _SubtreeInsert($29, $30, $31) | 0; //@line 4392
  $33 = $4; //@line 4393
  $34 = $33 + 24 | 0; //@line 4394
  SAFE_HEAP_STORE($34 | 0, $32 | 0, 4);
  $35 = $3; //@line 4396
  $36 = $4; //@line 4397
  _PairsClear($35, $36); //@line 4398
  $37 = $4; //@line 4399
  $38 = _GetMasterTree($37) | 0; //@line 4400
  $39 = $38 + 40 | 0; //@line 4401
  $40 = SAFE_HEAP_LOAD($39 | 0, 4, 0) | 0 | 0; //@line 4402
  $41 = $3; //@line 4403
  $42 = $41 + 44 | 0; //@line 4404
  SAFE_HEAP_STORE($42 | 0, $40 | 0, 4);
  $2 = 1; //@line 4406
  $43 = $2; //@line 4407
  STACKTOP = sp; //@line 4408
  return $43 | 0; //@line 4408
 }
 return 0 | 0; //@line 4410
}
function _MarkLeafQuery($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 4073
 $1 = $1 | 0; //@line 4074
 $2 = $2 | 0; //@line 4075
 $3 = $3 | 0; //@line 4076
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0; //@line 4077
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0; //@line 4078
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 4079
 sp = STACKTOP; //@line 4080
 STACKTOP = STACKTOP + 80 | 0; //@line 4081
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(80 | 0); //@line 4081
 $$byval_copy1 = sp + 32 | 0; //@line 4082
 $$byval_copy = sp; //@line 4083
 $4 = $0; //@line 4084
 $5 = $1; //@line 4085
 $6 = $2; //@line 4086
 $7 = $3; //@line 4087
 $8 = $5; //@line 4088
 $9 = $8 + 8 | 0; //@line 4089
 $10 = $4; //@line 4090
 $11 = $10 + 8 | 0; //@line 4091
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 16 | 0, SAFE_HEAP_LOAD($9 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 20 | 0, SAFE_HEAP_LOAD($9 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 24 | 0, SAFE_HEAP_LOAD($9 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 28 | 0, SAFE_HEAP_LOAD($9 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 16 | 0, SAFE_HEAP_LOAD($11 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 20 | 0, SAFE_HEAP_LOAD($11 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 24 | 0, SAFE_HEAP_LOAD($11 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 28 | 0, SAFE_HEAP_LOAD($11 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 $12 = _cpBBIntersects($$byval_copy, $$byval_copy1) | 0; //@line 4094
 $13 = $12 << 24 >> 24 != 0; //@line 4095
 if (!$13) {
  STACKTOP = sp; //@line 4097
  return;
 }
 $14 = $4; //@line 4099
 $15 = _NodeIsLeaf($14) | 0; //@line 4100
 $16 = $15 << 24 >> 24 != 0; //@line 4101
 if (!$16) {
  $44 = $4; //@line 4103
  $45 = $44 + 44 | 0; //@line 4104
  $46 = SAFE_HEAP_LOAD($45 | 0, 4, 0) | 0 | 0; //@line 4105
  $47 = $5; //@line 4106
  $48 = $6; //@line 4107
  $49 = $7; //@line 4108
  _MarkLeafQuery($46, $47, $48, $49); //@line 4109
  $50 = $4; //@line 4110
  $51 = $50 + 44 | 0; //@line 4111
  $52 = $51 + 4 | 0; //@line 4112
  $53 = SAFE_HEAP_LOAD($52 | 0, 4, 0) | 0 | 0; //@line 4113
  $54 = $5; //@line 4114
  $55 = $6; //@line 4115
  $56 = $7; //@line 4116
  _MarkLeafQuery($53, $54, $55, $56); //@line 4117
  STACKTOP = sp; //@line 4118
  return;
 }
 $17 = $6; //@line 4120
 $18 = $17 << 24 >> 24 != 0; //@line 4121
 if ($18) {
  $19 = $5; //@line 4123
  $20 = $4; //@line 4124
  $21 = $7; //@line 4125
  $22 = SAFE_HEAP_LOAD($21 | 0, 4, 0) | 0 | 0; //@line 4126
  _PairInsert($19, $20, $22); //@line 4127
  STACKTOP = sp; //@line 4128
  return;
 }
 $23 = $4; //@line 4130
 $24 = $23 + 44 | 0; //@line 4131
 $25 = SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0; //@line 4132
 $26 = $5; //@line 4133
 $27 = $26 + 44 | 0; //@line 4134
 $28 = SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0; //@line 4135
 $29 = $25 >>> 0 < $28 >>> 0; //@line 4136
 if ($29) {
  $30 = $4; //@line 4138
  $31 = $5; //@line 4139
  $32 = $7; //@line 4140
  $33 = SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0; //@line 4141
  _PairInsert($30, $31, $33); //@line 4142
 }
 $34 = $7; //@line 4144
 $35 = $34 + 8 | 0; //@line 4145
 $36 = SAFE_HEAP_LOAD($35 | 0, 4, 0) | 0 | 0; //@line 4146
 $37 = $5; //@line 4147
 $38 = SAFE_HEAP_LOAD($37 | 0, 4, 0) | 0 | 0; //@line 4148
 $39 = $4; //@line 4149
 $40 = SAFE_HEAP_LOAD($39 | 0, 4, 0) | 0 | 0; //@line 4150
 $41 = $7; //@line 4151
 $42 = $41 + 12 | 0; //@line 4152
 $43 = SAFE_HEAP_LOAD($42 | 0, 4, 0) | 0 | 0; //@line 4153
 FUNCTION_TABLE_iiiii[(SAFE_FT_MASK($36 | 0, 127 | 0) | 0) & 127]($38, $40, 0, $43) | 0; //@line 4154
 STACKTOP = sp; //@line 4155
 return;
}
function ___mo_lookup($0, $1, $2) {
 $0 = $0 | 0; //@line 10969
 $1 = $1 | 0; //@line 10970
 $2 = $2 | 0; //@line 10971
 var $$090 = 0, $$094 = 0, $$191 = 0, $$195 = 0, $$4 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0; //@line 10972
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0; //@line 10973
 var $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0; //@line 10974
 var $61 = 0, $62 = 0, $63 = 0, $64 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond102 = 0, $or$cond104 = 0, $spec$select = 0, label = 0, sp = 0; //@line 10975
 sp = STACKTOP; //@line 10976
 $3 = SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0; //@line 10977
 $4 = $3 + 1794895138 | 0; //@line 10978
 $5 = $0 + 8 | 0; //@line 10979
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 10980
 $7 = _swapc($6, $4) | 0; //@line 10981
 $8 = $0 + 12 | 0; //@line 10982
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 10983
 $10 = _swapc($9, $4) | 0; //@line 10984
 $11 = $0 + 16 | 0; //@line 10985
 $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 10986
 $13 = _swapc($12, $4) | 0; //@line 10987
 $14 = $1 >>> 2; //@line 10988
 $15 = $7 >>> 0 < $14 >>> 0; //@line 10989
 L1 : do {
  if ($15) {
   $16 = $7 << 2; //@line 10992
   $17 = $1 - $16 | 0; //@line 10993
   $18 = $10 >>> 0 < $17 >>> 0; //@line 10994
   $19 = $13 >>> 0 < $17 >>> 0; //@line 10995
   $or$cond = $18 & $19; //@line 10996
   if ($or$cond) {
    $20 = $13 | $10; //@line 10998
    $21 = $20 & 3; //@line 10999
    $22 = ($21 | 0) == 0; //@line 11000
    if ($22) {
     $23 = $10 >>> 2; //@line 11002
     $24 = $13 >>> 2; //@line 11003
     $$090 = 0; //@line 11004
     $$094 = $7; //@line 11004
     while (1) {
      $25 = $$094 >>> 1; //@line 11006
      $26 = $$090 + $25 | 0; //@line 11007
      $27 = $26 << 1; //@line 11008
      $28 = $27 + $23 | 0; //@line 11009
      $29 = $0 + ($28 << 2) | 0; //@line 11010
      $30 = SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0; //@line 11011
      $31 = _swapc($30, $4) | 0; //@line 11012
      $32 = $28 + 1 | 0; //@line 11013
      $33 = $0 + ($32 << 2) | 0; //@line 11014
      $34 = SAFE_HEAP_LOAD($33 | 0, 4, 0) | 0 | 0; //@line 11015
      $35 = _swapc($34, $4) | 0; //@line 11016
      $36 = $35 >>> 0 < $1 >>> 0; //@line 11017
      $37 = $1 - $35 | 0; //@line 11018
      $38 = $31 >>> 0 < $37 >>> 0; //@line 11019
      $or$cond102 = $36 & $38; //@line 11020
      if (!$or$cond102) {
       $$4 = 0; //@line 11022
       break L1;
      }
      $39 = $35 + $31 | 0; //@line 11025
      $40 = $0 + $39 | 0; //@line 11026
      $41 = SAFE_HEAP_LOAD($40 >> 0 | 0, 1, 0) | 0 | 0; //@line 11027
      $42 = $41 << 24 >> 24 == 0; //@line 11028
      if (!$42) {
       $$4 = 0; //@line 11030
       break L1;
      }
      $43 = $0 + $35 | 0; //@line 11033
      $44 = _strcmp($2, $43) | 0; //@line 11034
      $45 = ($44 | 0) == 0; //@line 11035
      if ($45) {
       break;
      }
      $62 = ($$094 | 0) == 1; //@line 11039
      $63 = ($44 | 0) < 0; //@line 11040
      if ($62) {
       $$4 = 0; //@line 11042
       break L1;
      }
      $$191 = $63 ? $$090 : $26; //@line 11045
      $64 = $$094 - $25 | 0; //@line 11046
      $$195 = $63 ? $25 : $64; //@line 11047
      $$090 = $$191; //@line 11048
      $$094 = $$195; //@line 11048
     }
     $46 = $27 + $24 | 0; //@line 11050
     $47 = $0 + ($46 << 2) | 0; //@line 11051
     $48 = SAFE_HEAP_LOAD($47 | 0, 4, 0) | 0 | 0; //@line 11052
     $49 = _swapc($48, $4) | 0; //@line 11053
     $50 = $46 + 1 | 0; //@line 11054
     $51 = $0 + ($50 << 2) | 0; //@line 11055
     $52 = SAFE_HEAP_LOAD($51 | 0, 4, 0) | 0 | 0; //@line 11056
     $53 = _swapc($52, $4) | 0; //@line 11057
     $54 = $53 >>> 0 < $1 >>> 0; //@line 11058
     $55 = $1 - $53 | 0; //@line 11059
     $56 = $49 >>> 0 < $55 >>> 0; //@line 11060
     $or$cond104 = $54 & $56; //@line 11061
     if ($or$cond104) {
      $57 = $0 + $53 | 0; //@line 11063
      $58 = $53 + $49 | 0; //@line 11064
      $59 = $0 + $58 | 0; //@line 11065
      $60 = SAFE_HEAP_LOAD($59 >> 0 | 0, 1, 0) | 0 | 0; //@line 11066
      $61 = $60 << 24 >> 24 == 0; //@line 11067
      $spec$select = $61 ? $57 : 0; //@line 11068
      $$4 = $spec$select; //@line 11069
     } else {
      $$4 = 0; //@line 11071
     }
    } else {
     $$4 = 0; //@line 11074
    }
   } else {
    $$4 = 0; //@line 11077
   }
  } else {
   $$4 = 0; //@line 11080
  }
 } while (0);
 return $$4 | 0; //@line 11083
}
function _cpSpaceShapeQuery($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 3853
 $1 = $1 | 0; //@line 3854
 $2 = $2 | 0; //@line 3855
 $3 = $3 | 0; //@line 3856
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0; //@line 3857
 var $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 3858
 sp = STACKTOP; //@line 3859
 STACKTOP = STACKTOP + 176 | 0; //@line 3860
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(176 | 0); //@line 3860
 $$byval_copy2 = sp + 112 | 0; //@line 3861
 $$byval_copy1 = sp + 80 | 0; //@line 3862
 $$byval_copy = sp + 32 | 0; //@line 3863
 $9 = sp; //@line 3864
 $10 = sp + 144 | 0; //@line 3865
 $4 = $0; //@line 3866
 $5 = $1; //@line 3867
 $6 = $2; //@line 3868
 $7 = $3; //@line 3869
 $11 = $5; //@line 3870
 $12 = $11 + 8 | 0; //@line 3871
 $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 3872
 $8 = $13; //@line 3873
 $14 = $8; //@line 3874
 $15 = ($14 | 0) != (0 | 0); //@line 3875
 $16 = $5; //@line 3876
 if ($15) {
  $17 = $8; //@line 3878
  $18 = $17 + 128 | 0; //@line 3879
  dest = $$byval_copy; //@line 3880
  src = $18; //@line 3880
  stop = dest + 48 | 0; //@line 3880
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 3880
   src = src + 4 | 0; //@line 3880
  } while ((dest | 0) < (stop | 0));
  _cpShapeUpdate($9, $16, $$byval_copy); //@line 3881
 } else {
  $19 = $16 + 56 | 0; //@line 3883
  SAFE_HEAP_STORE($9 | 0, SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($9 + 4 | 0, SAFE_HEAP_LOAD($19 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($9 + 8 | 0, SAFE_HEAP_LOAD($19 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($9 + 12 | 0, SAFE_HEAP_LOAD($19 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($9 + 16 | 0, SAFE_HEAP_LOAD($19 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($9 + 20 | 0, SAFE_HEAP_LOAD($19 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($9 + 24 | 0, SAFE_HEAP_LOAD($19 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($9 + 28 | 0, SAFE_HEAP_LOAD($19 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 }
 $20 = $6; //@line 3886
 SAFE_HEAP_STORE($10 | 0, $20 | 0, 4);
 $21 = $10 + 4 | 0; //@line 3888
 $22 = $7; //@line 3889
 SAFE_HEAP_STORE($21 | 0, $22 | 0, 4);
 $23 = $10 + 8 | 0; //@line 3891
 SAFE_HEAP_STORE($23 >> 0 | 0, 0 | 0, 1);
 $24 = $4; //@line 3893
 _cpSpaceLock($24); //@line 3894
 $25 = $4; //@line 3895
 $26 = $25 + 112 | 0; //@line 3896
 $27 = SAFE_HEAP_LOAD($26 | 0, 4, 0) | 0 | 0; //@line 3897
 $28 = $5; //@line 3898
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 16 | 0, SAFE_HEAP_LOAD($9 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 20 | 0, SAFE_HEAP_LOAD($9 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 24 | 0, SAFE_HEAP_LOAD($9 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 28 | 0, SAFE_HEAP_LOAD($9 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpSpatialIndexQuery($27, $28, $$byval_copy1, 71, $10); //@line 3900
 $29 = $4; //@line 3901
 $30 = $29 + 108 | 0; //@line 3902
 $31 = SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0; //@line 3903
 $32 = $5; //@line 3904
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 16 | 0, SAFE_HEAP_LOAD($9 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 20 | 0, SAFE_HEAP_LOAD($9 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 24 | 0, SAFE_HEAP_LOAD($9 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 28 | 0, SAFE_HEAP_LOAD($9 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpSpatialIndexQuery($31, $32, $$byval_copy2, 71, $10); //@line 3906
 $33 = $4; //@line 3907
 _cpSpaceUnlock($33, 1); //@line 3908
 $34 = $10 + 8 | 0; //@line 3909
 $35 = SAFE_HEAP_LOAD($34 >> 0 | 0, 1, 0) | 0 | 0; //@line 3910
 STACKTOP = sp; //@line 3911
 return $35 | 0; //@line 3911
}
function _ShapePoint($0, $1, $2) {
 $0 = $0 | 0; //@line 796
 $1 = $1 | 0; //@line 797
 $2 = $2 | 0; //@line 798
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0; //@line 799
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cpvzero$61$byval_copy = 0, label = 0, sp = 0; //@line 800
 sp = STACKTOP; //@line 801
 STACKTOP = STACKTOP + 112 | 0; //@line 802
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 802
 $cpvzero$61$byval_copy = sp + 64 | 0; //@line 803
 $$byval_copy2 = sp + 48 | 0; //@line 804
 $$byval_copy1 = sp + 32 | 0; //@line 805
 $$byval_copy = sp + 16 | 0; //@line 806
 $6 = sp; //@line 807
 $3 = $1; //@line 808
 $4 = $2; //@line 809
 $9 = $3; //@line 810
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 811
 $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 812
 switch ($11 | 0) {
 case 0:
  {
   $12 = $3; //@line 815
   $13 = $12 + 176 | 0; //@line 816
   SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   _SupportPointNew($0, $$byval_copy, 0); //@line 818
   STACKTOP = sp; //@line 819
   return;
   break;
  }
 case 1:
  {
   $14 = $3; //@line 823
   $5 = $14; //@line 824
   $15 = $4; //@line 825
   $16 = ($15 | 0) == 0; //@line 826
   $17 = $5; //@line 827
   if ($16) {
    $18 = $17 + 208 | 0; //@line 829
    SAFE_HEAP_STORE($6 | 0, SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($6 + 4 | 0, SAFE_HEAP_LOAD($18 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($6 + 8 | 0, SAFE_HEAP_LOAD($18 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($6 + 12 | 0, SAFE_HEAP_LOAD($18 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   } else {
    $19 = $17 + 224 | 0; //@line 832
    SAFE_HEAP_STORE($6 | 0, SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($6 + 4 | 0, SAFE_HEAP_LOAD($19 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($6 + 8 | 0, SAFE_HEAP_LOAD($19 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
    SAFE_HEAP_STORE($6 + 12 | 0, SAFE_HEAP_LOAD($19 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   }
   $20 = $4; //@line 835
   SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   _SupportPointNew($0, $$byval_copy1, $20); //@line 837
   STACKTOP = sp; //@line 838
   return;
   break;
  }
 case 2:
  {
   $21 = $3; //@line 842
   $7 = $21; //@line 843
   $22 = $4; //@line 844
   $23 = $7; //@line 845
   $24 = $23 + 168 | 0; //@line 846
   $25 = SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0; //@line 847
   $26 = ($22 | 0) < ($25 | 0); //@line 848
   $27 = $4; //@line 849
   $28 = $26 ? $27 : 0; //@line 850
   $8 = $28; //@line 851
   $29 = $7; //@line 852
   $30 = $29 + 172 | 0; //@line 853
   $31 = SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0; //@line 854
   $32 = $8; //@line 855
   $33 = $31 + ($32 << 5) | 0; //@line 856
   $34 = $8; //@line 857
   SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($33 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($33 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($33 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($33 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   _SupportPointNew($0, $$byval_copy2, $34); //@line 859
   STACKTOP = sp; //@line 860
   return;
   break;
  }
 default:
  {
   SAFE_HEAP_STORE($cpvzero$61$byval_copy | 0, SAFE_HEAP_LOAD(11232 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($cpvzero$61$byval_copy + 4 | 0, SAFE_HEAP_LOAD(11232 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($cpvzero$61$byval_copy + 8 | 0, SAFE_HEAP_LOAD(11232 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($cpvzero$61$byval_copy + 12 | 0, SAFE_HEAP_LOAD(11232 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
   _SupportPointNew($0, $cpvzero$61$byval_copy, 0); //@line 865
   STACKTOP = sp; //@line 866
   return;
  }
 }
}
function _QueryReject($0, $1) {
 $0 = $0 | 0; //@line 4666
 $1 = $1 | 0; //@line 4667
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0; //@line 4668
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 4669
 sp = STACKTOP; //@line 4670
 STACKTOP = STACKTOP + 96 | 0; //@line 4671
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(96 | 0); //@line 4671
 $$byval_copy3 = sp + 84 | 0; //@line 4672
 $$byval_copy2 = sp + 72 | 0; //@line 4673
 $$byval_copy1 = sp + 32 | 0; //@line 4674
 $$byval_copy = sp; //@line 4675
 $2 = $0; //@line 4676
 $3 = $1; //@line 4677
 $4 = $2; //@line 4678
 $5 = $4 + 56 | 0; //@line 4679
 $6 = $3; //@line 4680
 $7 = $6 + 56 | 0; //@line 4681
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 16 | 0, SAFE_HEAP_LOAD($5 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 20 | 0, SAFE_HEAP_LOAD($5 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 24 | 0, SAFE_HEAP_LOAD($5 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 28 | 0, SAFE_HEAP_LOAD($5 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 16 | 0, SAFE_HEAP_LOAD($7 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 20 | 0, SAFE_HEAP_LOAD($7 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 24 | 0, SAFE_HEAP_LOAD($7 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 28 | 0, SAFE_HEAP_LOAD($7 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 $8 = _cpBBIntersects_580($$byval_copy, $$byval_copy1) | 0; //@line 4684
 $9 = $8 << 24 >> 24 != 0; //@line 4685
 if (!$9) {
  $34 = 1; //@line 4687
  $33 = $34 & 1; //@line 4688
  $35 = $33 & 255; //@line 4689
  STACKTOP = sp; //@line 4690
  return $35 | 0; //@line 4690
 }
 $10 = $2; //@line 4692
 $11 = $10 + 8 | 0; //@line 4693
 $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 4694
 $13 = $3; //@line 4695
 $14 = $13 + 8 | 0; //@line 4696
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 4697
 $16 = ($12 | 0) == ($15 | 0); //@line 4698
 if ($16) {
  $34 = 1; //@line 4700
  $33 = $34 & 1; //@line 4701
  $35 = $33 & 255; //@line 4702
  STACKTOP = sp; //@line 4703
  return $35 | 0; //@line 4703
 }
 $17 = $2; //@line 4705
 $18 = $17 + 136 | 0; //@line 4706
 $19 = $3; //@line 4707
 $20 = $19 + 136 | 0; //@line 4708
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($18 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($18 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($20 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($20 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 $21 = _cpShapeFilterReject_581($$byval_copy2, $$byval_copy3) | 0; //@line 4711
 $22 = $21 & 255; //@line 4712
 $23 = ($22 | 0) != 0; //@line 4713
 if ($23) {
  $34 = 1; //@line 4715
  $33 = $34 & 1; //@line 4716
  $35 = $33 & 255; //@line 4717
  STACKTOP = sp; //@line 4718
  return $35 | 0; //@line 4718
 }
 $24 = $2; //@line 4720
 $25 = $24 + 8 | 0; //@line 4721
 $26 = SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0; //@line 4722
 $27 = $3; //@line 4723
 $28 = $27 + 8 | 0; //@line 4724
 $29 = SAFE_HEAP_LOAD($28 | 0, 4, 0) | 0 | 0; //@line 4725
 $30 = _QueryRejectConstraint($26, $29) | 0; //@line 4726
 $31 = $30 & 255; //@line 4727
 $32 = ($31 | 0) != 0; //@line 4728
 $34 = $32; //@line 4729
 $33 = $34 & 1; //@line 4730
 $35 = $33 & 255; //@line 4731
 STACKTOP = sp; //@line 4732
 return $35 | 0; //@line 4732
}
function _GetBB($0, $1, $2) {
 $0 = $0 | 0; //@line 4454
 $1 = $1 | 0; //@line 4455
 $2 = $2 | 0; //@line 4456
 var $$byval_copy = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0.0, $23 = 0.0, $24 = 0.0, $25 = 0.0, $26 = 0.0, $27 = 0, $28 = 0.0; //@line 4457
 var $29 = 0, $3 = 0, $30 = 0.0, $31 = 0.0, $32 = 0.0, $33 = 0.0, $34 = 0, $35 = 0, $36 = 0.0, $37 = 0.0, $38 = 0.0, $39 = 0.0, $4 = 0, $40 = 0.0, $41 = 0.0, $42 = 0, $43 = 0.0, $44 = 0.0, $45 = 0.0, $46 = 0; //@line 4458
 var $47 = 0.0, $48 = 0.0, $49 = 0.0, $5 = 0, $50 = 0, $51 = 0.0, $52 = 0.0, $53 = 0.0, $54 = 0.0, $55 = 0.0, $56 = 0, $57 = 0.0, $58 = 0.0, $59 = 0, $6 = 0, $60 = 0.0, $61 = 0.0, $62 = 0.0, $7 = 0.0, $8 = 0.0;
 var $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 4461
 STACKTOP = STACKTOP + 128 | 0; //@line 4462
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(128 | 0); //@line 4462
 $$byval_copy = sp + 88 | 0; //@line 4463
 $5 = sp + 56 | 0; //@line 4464
 $10 = sp + 16 | 0; //@line 4465
 $11 = sp; //@line 4466
 $3 = $1; //@line 4467
 $4 = $2; //@line 4468
 $12 = $3; //@line 4469
 $13 = $12 + 4 | 0; //@line 4470
 $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 4471
 $15 = $4; //@line 4472
 FUNCTION_TABLE_vii[(SAFE_FT_MASK($14 | 0, 127 | 0) | 0) & 127]($5, $15); //@line 4473
 $16 = $3; //@line 4474
 $17 = $16 + 16 | 0; //@line 4475
 $18 = SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0; //@line 4476
 $6 = $18; //@line 4477
 $19 = $6; //@line 4478
 $20 = ($19 | 0) != (0 | 0); //@line 4479
 if ($20) {
  $7 = .10000000149011612; //@line 4481
  $21 = $5 + 16 | 0; //@line 4482
  $22 = +(+SAFE_HEAP_LOAD_D($21 | 0, 8)); //@line 4483
  $23 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 4484
  $24 = $22 - $23; //@line 4485
  $25 = $7; //@line 4486
  $26 = $24 * $25; //@line 4487
  $8 = $26; //@line 4488
  $27 = $5 + 24 | 0; //@line 4489
  $28 = +(+SAFE_HEAP_LOAD_D($27 | 0, 8)); //@line 4490
  $29 = $5 + 8 | 0; //@line 4491
  $30 = +(+SAFE_HEAP_LOAD_D($29 | 0, 8)); //@line 4492
  $31 = $28 - $30; //@line 4493
  $32 = $7; //@line 4494
  $33 = $31 * $32; //@line 4495
  $9 = $33; //@line 4496
  $34 = $6; //@line 4497
  $35 = $4; //@line 4498
  FUNCTION_TABLE_vii[(SAFE_FT_MASK($34 | 0, 127 | 0) | 0) & 127]($11, $35); //@line 4499
  SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvmult_28($10, $$byval_copy, .10000000149011612); //@line 4501
  $36 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 4502
  $37 = $8; //@line 4503
  $38 = -$37; //@line 4504
  $39 = +(+SAFE_HEAP_LOAD_D($10 | 0, 8)); //@line 4505
  $40 = +_cpfmin_18($38, $39); //@line 4506
  $41 = $36 + $40; //@line 4507
  $42 = $5 + 8 | 0; //@line 4508
  $43 = +(+SAFE_HEAP_LOAD_D($42 | 0, 8)); //@line 4509
  $44 = $9; //@line 4510
  $45 = -$44; //@line 4511
  $46 = $10 + 8 | 0; //@line 4512
  $47 = +(+SAFE_HEAP_LOAD_D($46 | 0, 8)); //@line 4513
  $48 = +_cpfmin_18($45, $47); //@line 4514
  $49 = $43 + $48; //@line 4515
  $50 = $5 + 16 | 0; //@line 4516
  $51 = +(+SAFE_HEAP_LOAD_D($50 | 0, 8)); //@line 4517
  $52 = $8; //@line 4518
  $53 = +(+SAFE_HEAP_LOAD_D($10 | 0, 8)); //@line 4519
  $54 = +_cpfmax_20($52, $53); //@line 4520
  $55 = $51 + $54; //@line 4521
  $56 = $5 + 24 | 0; //@line 4522
  $57 = +(+SAFE_HEAP_LOAD_D($56 | 0, 8)); //@line 4523
  $58 = $9; //@line 4524
  $59 = $10 + 8 | 0; //@line 4525
  $60 = +(+SAFE_HEAP_LOAD_D($59 | 0, 8)); //@line 4526
  $61 = +_cpfmax_20($58, $60); //@line 4527
  $62 = $57 + $61; //@line 4528
  _cpBBNew($0, $41, $49, $55, $62); //@line 4529
  STACKTOP = sp; //@line 4530
  return;
 } else {
  SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 16 | 0, SAFE_HEAP_LOAD($5 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 20 | 0, SAFE_HEAP_LOAD($5 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 24 | 0, SAFE_HEAP_LOAD($5 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 28 | 0, SAFE_HEAP_LOAD($5 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
  STACKTOP = sp; //@line 4533
  return;
 }
}
function _cpSpaceAddShape($0, $1) {
 $0 = $0 | 0; //@line 1191
 $1 = $1 | 0; //@line 1192
 var $$byval_copy = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0; //@line 1193
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0; //@line 1194
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0; //@line 1195
 var $vararg_buffer3 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 1196
 sp = STACKTOP; //@line 1197
 STACKTOP = STACKTOP + 128 | 0; //@line 1198
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(128 | 0); //@line 1198
 $$byval_copy = sp + 56 | 0; //@line 1199
 $vararg_buffer3 = sp + 48 | 0; //@line 1200
 $vararg_buffer1 = sp + 40 | 0; //@line 1201
 $vararg_buffer = sp + 32 | 0; //@line 1202
 $6 = sp; //@line 1203
 $2 = $0; //@line 1204
 $3 = $1; //@line 1205
 $7 = $3; //@line 1206
 $8 = $7 + 8 | 0; //@line 1207
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 1208
 $4 = $9; //@line 1209
 $10 = $3; //@line 1210
 $11 = $10 + 4 | 0; //@line 1211
 $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 1212
 $13 = $2; //@line 1213
 $14 = ($12 | 0) != ($13 | 0); //@line 1214
 if (!$14) {
  _cpMessage(6446, 6192, 422, 1, 1, 6468, $vararg_buffer); //@line 1216
  _abort(); //@line 1217
 }
 $15 = $3; //@line 1220
 $16 = $15 + 4 | 0; //@line 1221
 $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 1222
 $18 = ($17 | 0) != (0 | 0); //@line 1223
 if ($18) {
  _cpMessage(6552, 6192, 423, 1, 1, 6566, $vararg_buffer1); //@line 1225
  _abort(); //@line 1226
 }
 $19 = $2; //@line 1229
 $20 = $19 + 140 | 0; //@line 1230
 $21 = SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0; //@line 1231
 $22 = ($21 | 0) != 0; //@line 1232
 if ($22) {
  _cpMessage(6649, 6192, 425, 1, 1, 6664, $vararg_buffer3); //@line 1234
  _abort(); //@line 1235
 }
 $23 = $4; //@line 1238
 $24 = _cpBodyGetType($23) | 0; //@line 1239
 $25 = ($24 | 0) == 2; //@line 1240
 $26 = $25 & 1; //@line 1241
 $27 = $26 & 255; //@line 1242
 $5 = $27; //@line 1243
 $28 = $5; //@line 1244
 $29 = $28 << 24 >> 24 != 0; //@line 1245
 if (!$29) {
  $30 = $4; //@line 1247
  _cpBodyActivate($30); //@line 1248
 }
 $31 = $4; //@line 1250
 $32 = $3; //@line 1251
 _cpBodyAddShape($31, $32); //@line 1252
 $33 = $2; //@line 1253
 $34 = $33 + 104 | 0; //@line 1254
 $35 = SAFE_HEAP_LOAD($34 | 0, 4, 0) | 0 | 0; //@line 1255
 $36 = $35 + 1 | 0; //@line 1256
 SAFE_HEAP_STORE($34 | 0, $36 | 0, 4);
 $37 = $3; //@line 1258
 $38 = $37 + 156 | 0; //@line 1259
 SAFE_HEAP_STORE($38 | 0, $35 | 0, 4);
 $39 = $3; //@line 1261
 $40 = $4; //@line 1262
 $41 = $40 + 128 | 0; //@line 1263
 dest = $$byval_copy; //@line 1264
 src = $41; //@line 1264
 stop = dest + 48 | 0; //@line 1264
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 1264
  src = src + 4 | 0; //@line 1264
 } while ((dest | 0) < (stop | 0));
 _cpShapeUpdate($6, $39, $$byval_copy); //@line 1265
 $42 = $5; //@line 1266
 $43 = $42 & 255; //@line 1267
 $44 = ($43 | 0) != 0; //@line 1268
 $45 = $2; //@line 1269
 if ($44) {
  $46 = $45 + 108 | 0; //@line 1271
  $47 = SAFE_HEAP_LOAD($46 | 0, 4, 0) | 0 | 0; //@line 1272
  $54 = $47; //@line 1273
  $50 = $3; //@line 1274
  $51 = $3; //@line 1275
  $52 = $51 + 156 | 0; //@line 1276
  $53 = SAFE_HEAP_LOAD($52 | 0, 4, 0) | 0 | 0; //@line 1277
  _cpSpatialIndexInsert_452($54, $50, $53); //@line 1278
  $55 = $2; //@line 1279
  $56 = $3; //@line 1280
  $57 = $56 + 4 | 0; //@line 1281
  SAFE_HEAP_STORE($57 | 0, $55 | 0, 4);
  $58 = $3; //@line 1283
  STACKTOP = sp; //@line 1284
  return $58 | 0; //@line 1284
 } else {
  $48 = $45 + 112 | 0; //@line 1286
  $49 = SAFE_HEAP_LOAD($48 | 0, 4, 0) | 0 | 0; //@line 1287
  $54 = $49; //@line 1288
  $50 = $3; //@line 1289
  $51 = $3; //@line 1290
  $52 = $51 + 156 | 0; //@line 1291
  $53 = SAFE_HEAP_LOAD($52 | 0, 4, 0) | 0 | 0; //@line 1292
  _cpSpatialIndexInsert_452($54, $50, $53); //@line 1293
  $55 = $2; //@line 1294
  $56 = $3; //@line 1295
  $57 = $56 + 4 | 0; //@line 1296
  SAFE_HEAP_STORE($57 | 0, $55 | 0, 4);
  $58 = $3; //@line 1298
  STACKTOP = sp; //@line 1299
  return $58 | 0; //@line 1299
 }
 return 0 | 0; //@line 1301
}
function _cpBodyActivate($0) {
 $0 = $0 | 0; //@line 2328
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0; //@line 2329
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0; //@line 2330
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0; //@line 2331
 var $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 2332
 sp = STACKTOP; //@line 2333
 STACKTOP = STACKTOP + 32 | 0; //@line 2334
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 2334
 $vararg_buffer = sp; //@line 2335
 $1 = $0; //@line 2336
 $8 = $1; //@line 2337
 $9 = ($8 | 0) != (0 | 0); //@line 2338
 if (!$9) {
  STACKTOP = sp; //@line 2340
  return;
 }
 $10 = $1; //@line 2342
 $11 = _cpBodyGetType($10) | 0; //@line 2343
 $12 = ($11 | 0) == 0; //@line 2344
 if (!$12) {
  STACKTOP = sp; //@line 2346
  return;
 }
 $13 = $1; //@line 2348
 $14 = $13 + 224 | 0; //@line 2349
 $15 = $14 + 8 | 0; //@line 2350
 SAFE_HEAP_STORE_D($15 | 0, +0.0, 8);
 $16 = $1; //@line 2352
 $17 = _ComponentRoot($16) | 0; //@line 2353
 $2 = $17; //@line 2354
 $18 = $2; //@line 2355
 $19 = ($18 | 0) != (0 | 0); //@line 2356
 if ($19) {
  $20 = $2; //@line 2358
  $21 = _cpBodyIsSleeping($20) | 0; //@line 2359
  $22 = $21 & 255; //@line 2360
  $23 = ($22 | 0) != 0; //@line 2361
  if ($23) {
   $24 = $2; //@line 2363
   $25 = _cpBodyGetType($24) | 0; //@line 2364
   $26 = ($25 | 0) == 0; //@line 2365
   if (!$26) {
    _cpMessage(8120, 7878, 128, 1, 0, 8164, $vararg_buffer); //@line 2367
    _abort(); //@line 2368
   }
   $27 = $2; //@line 2371
   $28 = $27 + 208 | 0; //@line 2372
   $29 = SAFE_HEAP_LOAD($28 | 0, 4, 0) | 0 | 0; //@line 2373
   $3 = $29; //@line 2374
   $30 = $2; //@line 2375
   $4 = $30; //@line 2376
   while (1) {
    $31 = $4; //@line 2378
    $32 = ($31 | 0) != (0 | 0); //@line 2379
    if (!$32) {
     break;
    }
    $33 = $4; //@line 2383
    $34 = $33 + 224 | 0; //@line 2384
    $35 = $34 + 4 | 0; //@line 2385
    $36 = SAFE_HEAP_LOAD($35 | 0, 4, 0) | 0 | 0; //@line 2386
    $5 = $36; //@line 2387
    $37 = $4; //@line 2388
    $38 = $37 + 224 | 0; //@line 2389
    $39 = $38 + 8 | 0; //@line 2390
    SAFE_HEAP_STORE_D($39 | 0, +0.0, 8);
    $40 = $4; //@line 2392
    $41 = $40 + 224 | 0; //@line 2393
    SAFE_HEAP_STORE($41 | 0, 0 | 0, 4);
    $42 = $4; //@line 2395
    $43 = $42 + 224 | 0; //@line 2396
    $44 = $43 + 4 | 0; //@line 2397
    SAFE_HEAP_STORE($44 | 0, 0 | 0, 4);
    $45 = $3; //@line 2399
    $46 = $4; //@line 2400
    _cpSpaceActivateBody($45, $46); //@line 2401
    $47 = $5; //@line 2402
    $4 = $47; //@line 2403
   }
   $48 = $3; //@line 2405
   $49 = $48 + 100 | 0; //@line 2406
   $50 = SAFE_HEAP_LOAD($49 | 0, 4, 0) | 0 | 0; //@line 2407
   $51 = $2; //@line 2408
   _cpArrayDeleteObj($50, $51); //@line 2409
  }
 }
 $52 = $1; //@line 2412
 $53 = $52 + 216 | 0; //@line 2413
 $54 = SAFE_HEAP_LOAD($53 | 0, 4, 0) | 0 | 0; //@line 2414
 $6 = $54; //@line 2415
 while (1) {
  $55 = $6; //@line 2417
  $56 = ($55 | 0) != (0 | 0); //@line 2418
  if (!$56) {
   break;
  }
  $57 = $6; //@line 2422
  $58 = $57 + 44 | 0; //@line 2423
  $59 = SAFE_HEAP_LOAD($58 | 0, 4, 0) | 0 | 0; //@line 2424
  $60 = $1; //@line 2425
  $61 = ($59 | 0) == ($60 | 0); //@line 2426
  $62 = $6; //@line 2427
  if ($61) {
   $63 = $62 + 48 | 0; //@line 2429
   $64 = SAFE_HEAP_LOAD($63 | 0, 4, 0) | 0 | 0; //@line 2430
   $67 = $64; //@line 2431
  } else {
   $65 = $62 + 44 | 0; //@line 2433
   $66 = SAFE_HEAP_LOAD($65 | 0, 4, 0) | 0 | 0; //@line 2434
   $67 = $66; //@line 2435
  }
  $7 = $67; //@line 2437
  $68 = $7; //@line 2438
  $69 = _cpBodyGetType($68) | 0; //@line 2439
  $70 = ($69 | 0) != 2; //@line 2440
  if ($70) {
   $71 = $7; //@line 2442
   $72 = $71 + 224 | 0; //@line 2443
   $73 = $72 + 8 | 0; //@line 2444
   SAFE_HEAP_STORE_D($73 | 0, +0.0, 8);
  }
  $74 = $6; //@line 2447
  $75 = $1; //@line 2448
  $76 = _cpArbiterNext_482($74, $75) | 0; //@line 2449
  $6 = $76; //@line 2450
 }
 STACKTOP = sp; //@line 2452
 return;
}
function _cpHashSetInsert($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 2292
 $1 = $1 | 0; //@line 2293
 $2 = $2 | 0; //@line 2294
 $3 = $3 | 0; //@line 2295
 $4 = $4 | 0; //@line 2296
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0; //@line 2297
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0; //@line 2298
 var $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0; //@line 2299
 var $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2300
 sp = STACKTOP; //@line 2301
 STACKTOP = STACKTOP + 32 | 0; //@line 2302
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 2302
 $5 = $0; //@line 2303
 $6 = $1; //@line 2304
 $7 = $2; //@line 2305
 $8 = $3; //@line 2306
 $9 = $4; //@line 2307
 $12 = $6; //@line 2308
 $13 = $5; //@line 2309
 $14 = $13 + 4 | 0; //@line 2310
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 2311
 $16 = ($12 >>> 0) % ($15 >>> 0) & -1; //@line 2312
 $10 = $16; //@line 2313
 $17 = $5; //@line 2314
 $18 = $17 + 16 | 0; //@line 2315
 $19 = SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0; //@line 2316
 $20 = $10; //@line 2317
 $21 = $19 + ($20 << 2) | 0; //@line 2318
 $22 = SAFE_HEAP_LOAD($21 | 0, 4, 0) | 0 | 0; //@line 2319
 $11 = $22; //@line 2320
 while (1) {
  $23 = $11; //@line 2322
  $24 = ($23 | 0) != (0 | 0); //@line 2323
  if ($24) {
   $25 = $5; //@line 2325
   $26 = $25 + 8 | 0; //@line 2326
   $27 = SAFE_HEAP_LOAD($26 | 0, 4, 0) | 0 | 0; //@line 2327
   $28 = $7; //@line 2328
   $29 = $11; //@line 2329
   $30 = SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0; //@line 2330
   $31 = FUNCTION_TABLE_iii[(SAFE_FT_MASK($27 | 0, 127 | 0) | 0) & 127]($28, $30) | 0; //@line 2331
   $32 = $31 << 24 >> 24 != 0; //@line 2332
   $33 = $32 ^ 1; //@line 2333
   $75 = $33; //@line 2334
  } else {
   $75 = 0; //@line 2336
  }
  $34 = $11; //@line 2338
  if (!$75) {
   break;
  }
  $35 = $34 + 8 | 0; //@line 2342
  $36 = SAFE_HEAP_LOAD($35 | 0, 4, 0) | 0 | 0; //@line 2343
  $11 = $36; //@line 2344
 }
 $37 = ($34 | 0) != (0 | 0); //@line 2346
 if ($37) {
  $73 = $11; //@line 2348
  $74 = SAFE_HEAP_LOAD($73 | 0, 4, 0) | 0 | 0; //@line 2349
  STACKTOP = sp; //@line 2350
  return $74 | 0; //@line 2350
 }
 $38 = $5; //@line 2352
 $39 = _getUnusedBin($38) | 0; //@line 2353
 $11 = $39; //@line 2354
 $40 = $6; //@line 2355
 $41 = $11; //@line 2356
 $42 = $41 + 4 | 0; //@line 2357
 SAFE_HEAP_STORE($42 | 0, $40 | 0, 4);
 $43 = $8; //@line 2359
 $44 = ($43 | 0) != (0 | 0); //@line 2360
 if ($44) {
  $45 = $8; //@line 2362
  $46 = $7; //@line 2363
  $47 = $9; //@line 2364
  $48 = FUNCTION_TABLE_iii[(SAFE_FT_MASK($45 | 0, 127 | 0) | 0) & 127]($46, $47) | 0; //@line 2365
  $51 = $48; //@line 2366
 } else {
  $49 = $9; //@line 2368
  $51 = $49; //@line 2369
 }
 $50 = $11; //@line 2371
 SAFE_HEAP_STORE($50 | 0, $51 | 0, 4);
 $52 = $5; //@line 2373
 $53 = $52 + 16 | 0; //@line 2374
 $54 = SAFE_HEAP_LOAD($53 | 0, 4, 0) | 0 | 0; //@line 2375
 $55 = $10; //@line 2376
 $56 = $54 + ($55 << 2) | 0; //@line 2377
 $57 = SAFE_HEAP_LOAD($56 | 0, 4, 0) | 0 | 0; //@line 2378
 $58 = $11; //@line 2379
 $59 = $58 + 8 | 0; //@line 2380
 SAFE_HEAP_STORE($59 | 0, $57 | 0, 4);
 $60 = $11; //@line 2382
 $61 = $5; //@line 2383
 $62 = $61 + 16 | 0; //@line 2384
 $63 = SAFE_HEAP_LOAD($62 | 0, 4, 0) | 0 | 0; //@line 2385
 $64 = $10; //@line 2386
 $65 = $63 + ($64 << 2) | 0; //@line 2387
 SAFE_HEAP_STORE($65 | 0, $60 | 0, 4);
 $66 = $5; //@line 2389
 $67 = SAFE_HEAP_LOAD($66 | 0, 4, 0) | 0 | 0; //@line 2390
 $68 = $67 + 1 | 0; //@line 2391
 SAFE_HEAP_STORE($66 | 0, $68 | 0, 4);
 $69 = $5; //@line 2393
 $70 = _setIsFull($69) | 0; //@line 2394
 $71 = ($70 | 0) != 0; //@line 2395
 if (!$71) {
  $73 = $11; //@line 2397
  $74 = SAFE_HEAP_LOAD($73 | 0, 4, 0) | 0 | 0; //@line 2398
  STACKTOP = sp; //@line 2399
  return $74 | 0; //@line 2399
 }
 $72 = $5; //@line 2401
 _cpHashSetResize($72); //@line 2402
 $73 = $11; //@line 2403
 $74 = SAFE_HEAP_LOAD($73 | 0, 4, 0) | 0 | 0; //@line 2404
 STACKTOP = sp; //@line 2405
 return $74 | 0; //@line 2405
}
function _PolyToPoly($0, $1, $2) {
 $0 = $0 | 0; //@line 8410
 $1 = $1 | 0; //@line 8411
 $2 = $2 | 0; //@line 8412
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0.0, $20 = 0, $21 = 0, $22 = 0.0, $23 = 0.0; //@line 8413
 var $24 = 0, $25 = 0, $26 = 0.0, $27 = 0.0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0; //@line 8414
 var src = 0, stop = 0; //@line 8415
 sp = STACKTOP; //@line 8416
 STACKTOP = STACKTOP + 512 | 0; //@line 8417
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(512 | 0); //@line 8417
 $$byval_copy5 = sp + 416 | 0; //@line 8418
 $$byval_copy4 = sp + 344 | 0; //@line 8419
 $$byval_copy3 = sp + 272 | 0; //@line 8420
 $$byval_copy2 = sp + 256 | 0; //@line 8421
 $$byval_copy1 = sp + 240 | 0; //@line 8422
 $$byval_copy = sp + 224 | 0; //@line 8423
 $6 = sp + 480 | 0; //@line 8424
 $7 = sp + 160 | 0; //@line 8425
 $8 = sp + 88 | 0; //@line 8426
 $9 = sp + 16 | 0; //@line 8427
 $10 = sp; //@line 8428
 $3 = $0; //@line 8429
 $4 = $1; //@line 8430
 $5 = $2; //@line 8431
 $11 = $3; //@line 8432
 SAFE_HEAP_STORE($6 | 0, $11 | 0, 4);
 $12 = $6 + 4 | 0; //@line 8434
 $13 = $4; //@line 8435
 SAFE_HEAP_STORE($12 | 0, $13 | 0, 4);
 $14 = $6 + 8 | 0; //@line 8437
 SAFE_HEAP_STORE($14 | 0, 57 | 0, 4);
 $15 = $6 + 12 | 0; //@line 8439
 SAFE_HEAP_STORE($15 | 0, 57 | 0, 4);
 $16 = $5; //@line 8441
 $17 = $16 + 8 | 0; //@line 8442
 _GJK($7, $6, $17); //@line 8443
 $18 = $7 + 48 | 0; //@line 8444
 $19 = +(+SAFE_HEAP_LOAD_D($18 | 0, 8)); //@line 8445
 $20 = $3; //@line 8446
 $21 = $20 + 160 | 0; //@line 8447
 $22 = +(+SAFE_HEAP_LOAD_D($21 | 0, 8)); //@line 8448
 $23 = $19 - $22; //@line 8449
 $24 = $4; //@line 8450
 $25 = $24 + 160 | 0; //@line 8451
 $26 = +(+SAFE_HEAP_LOAD_D($25 | 0, 8)); //@line 8452
 $27 = $23 - $26; //@line 8453
 $28 = $27 <= 0.0; //@line 8454
 if (!$28) {
  STACKTOP = sp; //@line 8456
  return;
 }
 $29 = $3; //@line 8458
 $30 = $7 + 32 | 0; //@line 8459
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($30 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($30 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($30 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _SupportEdgeForPoly($8, $29, $$byval_copy); //@line 8461
 $31 = $4; //@line 8462
 $32 = $7 + 32 | 0; //@line 8463
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($32 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($32 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($32 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvneg_62($10, $$byval_copy1); //@line 8465
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _SupportEdgeForPoly($9, $31, $$byval_copy2); //@line 8467
 $33 = $5; //@line 8468
 dest = $$byval_copy3; //@line 8469
 src = $8; //@line 8469
 stop = dest + 72 | 0; //@line 8469
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 8469
  src = src + 4 | 0; //@line 8469
 } while ((dest | 0) < (stop | 0));
 dest = $$byval_copy4; //@line 8470
 src = $9; //@line 8470
 stop = dest + 72 | 0; //@line 8470
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 8470
  src = src + 4 | 0; //@line 8470
 } while ((dest | 0) < (stop | 0));
 dest = $$byval_copy5; //@line 8471
 src = $7; //@line 8471
 stop = dest + 64 | 0; //@line 8471
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 8471
  src = src + 4 | 0; //@line 8471
 } while ((dest | 0) < (stop | 0));
 _ContactPoints($$byval_copy3, $$byval_copy4, $$byval_copy5, $33); //@line 8472
 STACKTOP = sp; //@line 8473
 return;
}
function _cpAreaForPoly($0, $1, $2) {
 $0 = $0 | 0; //@line 562
 $1 = $1 | 0; //@line 563
 $2 = +$2; //@line 564
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0.0, $24 = 0.0, $25 = 0.0; //@line 565
 var $26 = 0.0, $27 = 0.0, $28 = 0.0, $29 = 0, $3 = 0, $30 = 0, $31 = 0.0, $32 = 0.0, $33 = 0.0, $34 = 0.0, $35 = 0.0, $36 = 0.0, $37 = 0.0, $38 = 0.0, $39 = 0.0, $4 = 0, $40 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0;
 var $8 = 0, $9 = 0, label = 0, sp = 0; //@line 567
 sp = STACKTOP; //@line 568
 STACKTOP = STACKTOP + 144 | 0; //@line 569
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(144 | 0); //@line 569
 $$byval_copy3 = sp + 104 | 0; //@line 570
 $$byval_copy2 = sp + 88 | 0; //@line 571
 $$byval_copy1 = sp + 72 | 0; //@line 572
 $$byval_copy = sp + 56 | 0; //@line 573
 $9 = sp + 16 | 0; //@line 574
 $10 = sp; //@line 575
 $3 = $0; //@line 576
 $4 = $1; //@line 577
 $5 = $2; //@line 578
 $6 = 0.0; //@line 579
 $7 = 0.0; //@line 580
 $8 = 0; //@line 581
 while (1) {
  $11 = $8; //@line 583
  $12 = $3; //@line 584
  $13 = ($11 | 0) < ($12 | 0); //@line 585
  if (!$13) {
   break;
  }
  $14 = $4; //@line 589
  $15 = $8; //@line 590
  $16 = $14 + ($15 << 4) | 0; //@line 591
  SAFE_HEAP_STORE($9 | 0, SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($9 + 4 | 0, SAFE_HEAP_LOAD($16 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($9 + 8 | 0, SAFE_HEAP_LOAD($16 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($9 + 12 | 0, SAFE_HEAP_LOAD($16 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $17 = $4; //@line 593
  $18 = $8; //@line 594
  $19 = $18 + 1 | 0; //@line 595
  $20 = $3; //@line 596
  $21 = ($19 | 0) % ($20 | 0) & -1; //@line 597
  $22 = $17 + ($21 << 4) | 0; //@line 598
  SAFE_HEAP_STORE($10 | 0, SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($10 + 4 | 0, SAFE_HEAP_LOAD($22 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($10 + 8 | 0, SAFE_HEAP_LOAD($22 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($10 + 12 | 0, SAFE_HEAP_LOAD($22 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $23 = +_cpvcross($$byval_copy, $$byval_copy1); //@line 602
  $24 = $6; //@line 603
  $25 = $24 + $23; //@line 604
  $6 = $25; //@line 605
  SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $26 = +_cpvdist($$byval_copy2, $$byval_copy3); //@line 608
  $27 = $7; //@line 609
  $28 = $27 + $26; //@line 610
  $7 = $28; //@line 611
  $29 = $8; //@line 612
  $30 = $29 + 1 | 0; //@line 613
  $8 = $30; //@line 614
 }
 $31 = $5; //@line 616
 $32 = $5; //@line 617
 $33 = +_cpfabs($32); //@line 618
 $34 = 3.141592653589793 * $33; //@line 619
 $35 = $7; //@line 620
 $36 = $34 + $35; //@line 621
 $37 = $31 * $36; //@line 622
 $38 = $6; //@line 623
 $39 = $38 / 2.0; //@line 624
 $40 = $37 + $39; //@line 625
 STACKTOP = sp; //@line 626
 return +$40;
}
function _cpSpacePointQuery($0, $1, $2, $3, $4, $5) {
 $0 = $0 | 0; //@line 3581
 $1 = $1 | 0; //@line 3582
 $2 = +$2; //@line 3583
 $3 = $3 | 0; //@line 3584
 $4 = $4 | 0; //@line 3585
 $5 = $5 | 0; //@line 3586
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0.0, $18 = 0.0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0; //@line 3587
 var $27 = 0, $28 = 0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3588
 sp = STACKTOP; //@line 3589
 STACKTOP = STACKTOP + 176 | 0; //@line 3590
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(176 | 0); //@line 3590
 $$byval_copy2 = sp + 128 | 0; //@line 3591
 $$byval_copy1 = sp + 96 | 0; //@line 3592
 $$byval_copy = sp + 80 | 0; //@line 3593
 $10 = sp + 32 | 0; //@line 3594
 $11 = sp; //@line 3595
 $6 = $0; //@line 3596
 $7 = $2; //@line 3597
 $8 = $4; //@line 3598
 $9 = $5; //@line 3599
 SAFE_HEAP_STORE($10 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $12 = $10 + 16 | 0; //@line 3601
 $13 = $7; //@line 3602
 SAFE_HEAP_STORE_D($12 | 0, +$13, 8);
 $14 = $10 + 24 | 0; //@line 3604
 SAFE_HEAP_STORE($14 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($14 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($14 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 $15 = $10 + 36 | 0; //@line 3606
 $16 = $8; //@line 3607
 SAFE_HEAP_STORE($15 | 0, $16 | 0, 4);
 $17 = $7; //@line 3609
 $18 = +_cpfmax_547($17, 0.0); //@line 3610
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpBBNewForCircle_548($11, $$byval_copy, $18); //@line 3612
 $19 = $6; //@line 3613
 _cpSpaceLock($19); //@line 3614
 $20 = $6; //@line 3615
 $21 = $20 + 112 | 0; //@line 3616
 $22 = SAFE_HEAP_LOAD($21 | 0, 4, 0) | 0 | 0; //@line 3617
 $23 = $9; //@line 3618
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 16 | 0, SAFE_HEAP_LOAD($11 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 20 | 0, SAFE_HEAP_LOAD($11 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 24 | 0, SAFE_HEAP_LOAD($11 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 28 | 0, SAFE_HEAP_LOAD($11 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpSpatialIndexQuery($22, $10, $$byval_copy1, 70, $23); //@line 3620
 $24 = $6; //@line 3621
 $25 = $24 + 108 | 0; //@line 3622
 $26 = SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0; //@line 3623
 $27 = $9; //@line 3624
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 16 | 0, SAFE_HEAP_LOAD($11 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 20 | 0, SAFE_HEAP_LOAD($11 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 24 | 0, SAFE_HEAP_LOAD($11 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 28 | 0, SAFE_HEAP_LOAD($11 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpSpatialIndexQuery($26, $10, $$byval_copy2, 70, $27); //@line 3626
 $28 = $6; //@line 3627
 _cpSpaceUnlock($28, 1); //@line 3628
 STACKTOP = sp; //@line 3629
 return;
}
function _cachedArbitersFilter($0, $1) {
 $0 = $0 | 0; //@line 1530
 $1 = $1 | 0; //@line 1531
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 1532
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0; //@line 1533
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0; //@line 1534
 var $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond3 = 0, label = 0, sp = 0; //@line 1535
 sp = STACKTOP; //@line 1536
 STACKTOP = STACKTOP + 32 | 0; //@line 1537
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 1537
 $3 = $0; //@line 1538
 $4 = $1; //@line 1539
 $8 = $4; //@line 1540
 $9 = $8 + 8 | 0; //@line 1541
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 1542
 $5 = $10; //@line 1543
 $11 = $4; //@line 1544
 $12 = $11 + 4 | 0; //@line 1545
 $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 1546
 $6 = $13; //@line 1547
 $14 = $6; //@line 1548
 $15 = $3; //@line 1549
 $16 = $15 + 44 | 0; //@line 1550
 $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 1551
 $18 = ($14 | 0) == ($17 | 0); //@line 1552
 if ($18) {
  $19 = $5; //@line 1554
  $20 = $3; //@line 1555
  $21 = $20 + 36 | 0; //@line 1556
  $22 = SAFE_HEAP_LOAD($21 | 0, 4, 0) | 0 | 0; //@line 1557
  $23 = ($19 | 0) == ($22 | 0); //@line 1558
  $24 = $5; //@line 1559
  $25 = ($24 | 0) == (0 | 0); //@line 1560
  $or$cond = $23 | $25; //@line 1561
  if (!$or$cond) {
   label = 3; //@line 1563
  }
 } else {
  label = 3; //@line 1566
 }
 do {
  if ((label | 0) == 3) {
   $26 = $6; //@line 1570
   $27 = $3; //@line 1571
   $28 = $27 + 48 | 0; //@line 1572
   $29 = SAFE_HEAP_LOAD($28 | 0, 4, 0) | 0 | 0; //@line 1573
   $30 = ($26 | 0) == ($29 | 0); //@line 1574
   if ($30) {
    $31 = $5; //@line 1576
    $32 = $3; //@line 1577
    $33 = $32 + 40 | 0; //@line 1578
    $34 = SAFE_HEAP_LOAD($33 | 0, 4, 0) | 0 | 0; //@line 1579
    $35 = ($31 | 0) == ($34 | 0); //@line 1580
    $36 = $5; //@line 1581
    $37 = ($36 | 0) == (0 | 0); //@line 1582
    $or$cond3 = $35 | $37; //@line 1583
    if ($or$cond3) {
     break;
    }
   }
   $2 = 1; //@line 1588
   $69 = $2; //@line 1589
   STACKTOP = sp; //@line 1590
   return $69 | 0; //@line 1590
  }
 } while (0);
 $38 = $5; //@line 1593
 $39 = ($38 | 0) != (0 | 0); //@line 1594
 if ($39) {
  $40 = $3; //@line 1596
  $41 = $40 + 116 | 0; //@line 1597
  $42 = SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0; //@line 1598
  $43 = ($42 | 0) != 3; //@line 1599
  if ($43) {
   $44 = $3; //@line 1601
   $45 = $44 + 116 | 0; //@line 1602
   SAFE_HEAP_STORE($45 | 0, 4 | 0, 4);
   $46 = $3; //@line 1604
   $47 = $46 + 96 | 0; //@line 1605
   $48 = SAFE_HEAP_LOAD($47 | 0, 4, 0) | 0 | 0; //@line 1606
   $7 = $48; //@line 1607
   $49 = $7; //@line 1608
   $50 = $49 + 20 | 0; //@line 1609
   $51 = SAFE_HEAP_LOAD($50 | 0, 4, 0) | 0 | 0; //@line 1610
   $52 = $3; //@line 1611
   $53 = $4; //@line 1612
   $54 = SAFE_HEAP_LOAD($53 | 0, 4, 0) | 0 | 0; //@line 1613
   $55 = $7; //@line 1614
   $56 = $55 + 24 | 0; //@line 1615
   $57 = SAFE_HEAP_LOAD($56 | 0, 4, 0) | 0 | 0; //@line 1616
   FUNCTION_TABLE_viii[(SAFE_FT_MASK($51 | 0, 127 | 0) | 0) & 127]($52, $54, $57); //@line 1617
  }
 }
 $58 = $3; //@line 1620
 _cpArbiterUnthread($58); //@line 1621
 $59 = $4; //@line 1622
 $60 = SAFE_HEAP_LOAD($59 | 0, 4, 0) | 0 | 0; //@line 1623
 $61 = $60 + 120 | 0; //@line 1624
 $62 = SAFE_HEAP_LOAD($61 | 0, 4, 0) | 0 | 0; //@line 1625
 $63 = $3; //@line 1626
 _cpArrayDeleteObj($62, $63); //@line 1627
 $64 = $4; //@line 1628
 $65 = SAFE_HEAP_LOAD($64 | 0, 4, 0) | 0 | 0; //@line 1629
 $66 = $65 + 132 | 0; //@line 1630
 $67 = SAFE_HEAP_LOAD($66 | 0, 4, 0) | 0 | 0; //@line 1631
 $68 = $3; //@line 1632
 _cpArrayPush($67, $68); //@line 1633
 $2 = 0; //@line 1634
 $69 = $2; //@line 1635
 STACKTOP = sp; //@line 1636
 return $69 | 0; //@line 1636
}
function _NearestPointQuery($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 3663
 $1 = $1 | 0; //@line 3664
 $2 = $2 | 0; //@line 3665
 $3 = $3 | 0; //@line 3666
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0.0, $21 = 0, $22 = 0, $23 = 0.0, $24 = 0; //@line 3667
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $30 = 0, $31 = 0.0, $32 = 0, $33 = 0, $34 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3668
 sp = STACKTOP; //@line 3669
 STACKTOP = STACKTOP + 144 | 0; //@line 3670
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(144 | 0); //@line 3670
 $$byval_copy4 = sp + 80 | 0; //@line 3671
 $$byval_copy3 = sp + 64 | 0; //@line 3672
 $$byval_copy2 = sp + 48 | 0; //@line 3673
 $$byval_copy1 = sp + 124 | 0; //@line 3674
 $$byval_copy = sp + 112 | 0; //@line 3675
 $8 = sp; //@line 3676
 $4 = $0; //@line 3677
 $5 = $1; //@line 3678
 $6 = $2; //@line 3679
 $7 = $3; //@line 3680
 $9 = $5; //@line 3681
 $10 = $9 + 136 | 0; //@line 3682
 $11 = $4; //@line 3683
 $12 = $11 + 24 | 0; //@line 3684
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 $13 = _cpShapeFilterReject($$byval_copy, $$byval_copy1) | 0; //@line 3687
 $14 = $13 << 24 >> 24 != 0; //@line 3688
 if ($14) {
  $34 = $6; //@line 3690
  STACKTOP = sp; //@line 3691
  return $34 | 0; //@line 3691
 }
 $15 = $5; //@line 3693
 $16 = $4; //@line 3694
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($16 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($16 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($16 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 +_cpShapePointQuery($15, $$byval_copy2, $8);
 $17 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 3697
 $18 = ($17 | 0) != (0 | 0); //@line 3698
 if (!$18) {
  $34 = $6; //@line 3700
  STACKTOP = sp; //@line 3701
  return $34 | 0; //@line 3701
 }
 $19 = $8 + 24 | 0; //@line 3703
 $20 = +(+SAFE_HEAP_LOAD_D($19 | 0, 8)); //@line 3704
 $21 = $4; //@line 3705
 $22 = $21 + 16 | 0; //@line 3706
 $23 = +(+SAFE_HEAP_LOAD_D($22 | 0, 8)); //@line 3707
 $24 = $20 < $23; //@line 3708
 if (!$24) {
  $34 = $6; //@line 3710
  STACKTOP = sp; //@line 3711
  return $34 | 0; //@line 3711
 }
 $25 = $4; //@line 3713
 $26 = $25 + 36 | 0; //@line 3714
 $27 = SAFE_HEAP_LOAD($26 | 0, 4, 0) | 0 | 0; //@line 3715
 $28 = $5; //@line 3716
 $29 = $8 + 8 | 0; //@line 3717
 $30 = $8 + 24 | 0; //@line 3718
 $31 = +(+SAFE_HEAP_LOAD_D($30 | 0, 8)); //@line 3719
 $32 = $8 + 32 | 0; //@line 3720
 $33 = $7; //@line 3721
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($29 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($29 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($29 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($32 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($32 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($32 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 FUNCTION_TABLE_viidii[(SAFE_FT_MASK($27 | 0, 7 | 0) | 0) & 7]($28, $$byval_copy3, $31, $$byval_copy4, $33); //@line 3724
 $34 = $6; //@line 3725
 STACKTOP = sp; //@line 3726
 return $34 | 0; //@line 3726
}
function _cpSpaceEachBody($0, $1, $2) {
 $0 = $0 | 0; //@line 618
 $1 = $1 | 0; //@line 619
 $2 = $2 | 0; //@line 620
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0; //@line 621
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0; //@line 622
 var $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0; //@line 623
 var $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 624
 sp = STACKTOP; //@line 625
 STACKTOP = STACKTOP + 48 | 0; //@line 626
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 626
 $3 = $0; //@line 627
 $4 = $1; //@line 628
 $5 = $2; //@line 629
 $15 = $3; //@line 630
 _cpSpaceLock($15); //@line 631
 $16 = $3; //@line 632
 $17 = $16 + 88 | 0; //@line 633
 $18 = SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0; //@line 634
 $6 = $18; //@line 635
 $7 = 0; //@line 636
 while (1) {
  $19 = $7; //@line 638
  $20 = $6; //@line 639
  $21 = SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0; //@line 640
  $22 = ($19 | 0) < ($21 | 0); //@line 641
  if (!$22) {
   break;
  }
  $23 = $4; //@line 645
  $24 = $6; //@line 646
  $25 = $24 + 8 | 0; //@line 647
  $26 = SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0; //@line 648
  $27 = $7; //@line 649
  $28 = $26 + ($27 << 2) | 0; //@line 650
  $29 = SAFE_HEAP_LOAD($28 | 0, 4, 0) | 0 | 0; //@line 651
  $30 = $5; //@line 652
  FUNCTION_TABLE_vii[(SAFE_FT_MASK($23 | 0, 127 | 0) | 0) & 127]($29, $30); //@line 653
  $31 = $7; //@line 654
  $32 = $31 + 1 | 0; //@line 655
  $7 = $32; //@line 656
 }
 $33 = $3; //@line 658
 $34 = $33 + 92 | 0; //@line 659
 $35 = SAFE_HEAP_LOAD($34 | 0, 4, 0) | 0 | 0; //@line 660
 $8 = $35; //@line 661
 $9 = 0; //@line 662
 while (1) {
  $36 = $9; //@line 664
  $37 = $8; //@line 665
  $38 = SAFE_HEAP_LOAD($37 | 0, 4, 0) | 0 | 0; //@line 666
  $39 = ($36 | 0) < ($38 | 0); //@line 667
  if (!$39) {
   break;
  }
  $40 = $4; //@line 671
  $41 = $8; //@line 672
  $42 = $41 + 8 | 0; //@line 673
  $43 = SAFE_HEAP_LOAD($42 | 0, 4, 0) | 0 | 0; //@line 674
  $44 = $9; //@line 675
  $45 = $43 + ($44 << 2) | 0; //@line 676
  $46 = SAFE_HEAP_LOAD($45 | 0, 4, 0) | 0 | 0; //@line 677
  $47 = $5; //@line 678
  FUNCTION_TABLE_vii[(SAFE_FT_MASK($40 | 0, 127 | 0) | 0) & 127]($46, $47); //@line 679
  $48 = $9; //@line 680
  $49 = $48 + 1 | 0; //@line 681
  $9 = $49; //@line 682
 }
 $50 = $3; //@line 684
 $51 = $50 + 100 | 0; //@line 685
 $52 = SAFE_HEAP_LOAD($51 | 0, 4, 0) | 0 | 0; //@line 686
 $10 = $52; //@line 687
 $11 = 0; //@line 688
 while (1) {
  $53 = $11; //@line 690
  $54 = $10; //@line 691
  $55 = SAFE_HEAP_LOAD($54 | 0, 4, 0) | 0 | 0; //@line 692
  $56 = ($53 | 0) < ($55 | 0); //@line 693
  if (!$56) {
   break;
  }
  $57 = $10; //@line 697
  $58 = $57 + 8 | 0; //@line 698
  $59 = SAFE_HEAP_LOAD($58 | 0, 4, 0) | 0 | 0; //@line 699
  $60 = $11; //@line 700
  $61 = $59 + ($60 << 2) | 0; //@line 701
  $62 = SAFE_HEAP_LOAD($61 | 0, 4, 0) | 0 | 0; //@line 702
  $12 = $62; //@line 703
  $63 = $12; //@line 704
  $13 = $63; //@line 705
  while (1) {
   $64 = $13; //@line 707
   $65 = ($64 | 0) != (0 | 0); //@line 708
   if (!$65) {
    break;
   }
   $66 = $13; //@line 712
   $67 = $66 + 224 | 0; //@line 713
   $68 = $67 + 4 | 0; //@line 714
   $69 = SAFE_HEAP_LOAD($68 | 0, 4, 0) | 0 | 0; //@line 715
   $14 = $69; //@line 716
   $70 = $4; //@line 717
   $71 = $13; //@line 718
   $72 = $5; //@line 719
   FUNCTION_TABLE_vii[(SAFE_FT_MASK($70 | 0, 127 | 0) | 0) & 127]($71, $72); //@line 720
   $73 = $14; //@line 721
   $13 = $73; //@line 722
  }
  $74 = $11; //@line 724
  $75 = $74 + 1 | 0; //@line 725
  $11 = $75; //@line 726
 }
 $76 = $3; //@line 728
 _cpSpaceUnlock($76, 1); //@line 729
 STACKTOP = sp; //@line 730
 return;
}
function _cpSpaceArbiterSetFilter($0, $1) {
 $0 = $0 | 0; //@line 5005
 $1 = $1 | 0; //@line 5006
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 5007
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0; //@line 5008
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0; //@line 5009
 var $65 = 0, $66 = 0, $67 = 0, $68 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5010
 sp = STACKTOP; //@line 5011
 STACKTOP = STACKTOP + 32 | 0; //@line 5012
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 5012
 $3 = $0; //@line 5013
 $4 = $1; //@line 5014
 $9 = $4; //@line 5015
 $10 = $9 + 72 | 0; //@line 5016
 $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 5017
 $12 = $3; //@line 5018
 $13 = $12 + 112 | 0; //@line 5019
 $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 5020
 $15 = $11 - $14 | 0; //@line 5021
 $5 = $15; //@line 5022
 $16 = $3; //@line 5023
 $17 = $16 + 44 | 0; //@line 5024
 $18 = SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0; //@line 5025
 $6 = $18; //@line 5026
 $19 = $3; //@line 5027
 $20 = $19 + 48 | 0; //@line 5028
 $21 = SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0; //@line 5029
 $7 = $21; //@line 5030
 $22 = $6; //@line 5031
 $23 = _cpBodyGetType($22) | 0; //@line 5032
 $24 = ($23 | 0) == 2; //@line 5033
 if ($24) {
  label = 3; //@line 5035
 } else {
  $25 = $6; //@line 5037
  $26 = _cpBodyIsSleeping($25) | 0; //@line 5038
  $27 = $26 & 255; //@line 5039
  $28 = ($27 | 0) != 0; //@line 5040
  if ($28) {
   label = 3; //@line 5042
  }
 }
 do {
  if ((label | 0) == 3) {
   $29 = $7; //@line 5047
   $30 = _cpBodyGetType($29) | 0; //@line 5048
   $31 = ($30 | 0) == 2; //@line 5049
   if (!$31) {
    $32 = $7; //@line 5051
    $33 = _cpBodyIsSleeping($32) | 0; //@line 5052
    $34 = $33 & 255; //@line 5053
    $35 = ($34 | 0) != 0; //@line 5054
    if (!$35) {
     break;
    }
   }
   $2 = 1; //@line 5059
   $68 = $2; //@line 5060
   STACKTOP = sp; //@line 5061
   return $68 | 0; //@line 5061
  }
 } while (0);
 $36 = $5; //@line 5064
 $37 = $36 >>> 0 >= 1; //@line 5065
 if ($37) {
  $38 = $3; //@line 5067
  $39 = $38 + 116 | 0; //@line 5068
  $40 = SAFE_HEAP_LOAD($39 | 0, 4, 0) | 0 | 0; //@line 5069
  $41 = ($40 | 0) != 3; //@line 5070
  if ($41) {
   $42 = $3; //@line 5072
   $43 = $42 + 116 | 0; //@line 5073
   SAFE_HEAP_STORE($43 | 0, 3 | 0, 4);
   $44 = $3; //@line 5075
   $45 = $44 + 96 | 0; //@line 5076
   $46 = SAFE_HEAP_LOAD($45 | 0, 4, 0) | 0 | 0; //@line 5077
   $8 = $46; //@line 5078
   $47 = $8; //@line 5079
   $48 = $47 + 20 | 0; //@line 5080
   $49 = SAFE_HEAP_LOAD($48 | 0, 4, 0) | 0 | 0; //@line 5081
   $50 = $3; //@line 5082
   $51 = $4; //@line 5083
   $52 = $8; //@line 5084
   $53 = $52 + 24 | 0; //@line 5085
   $54 = SAFE_HEAP_LOAD($53 | 0, 4, 0) | 0 | 0; //@line 5086
   FUNCTION_TABLE_viii[(SAFE_FT_MASK($49 | 0, 127 | 0) | 0) & 127]($50, $51, $54); //@line 5087
  }
 }
 $55 = $5; //@line 5090
 $56 = $4; //@line 5091
 $57 = $56 + 64 | 0; //@line 5092
 $58 = SAFE_HEAP_LOAD($57 | 0, 4, 0) | 0 | 0; //@line 5093
 $59 = $55 >>> 0 >= $58 >>> 0; //@line 5094
 if ($59) {
  $60 = $3; //@line 5096
  $61 = $60 + 72 | 0; //@line 5097
  SAFE_HEAP_STORE($61 | 0, 0 | 0, 4);
  $62 = $3; //@line 5099
  $63 = $62 + 68 | 0; //@line 5100
  SAFE_HEAP_STORE($63 | 0, 0 | 0, 4);
  $64 = $4; //@line 5102
  $65 = $64 + 132 | 0; //@line 5103
  $66 = SAFE_HEAP_LOAD($65 | 0, 4, 0) | 0 | 0; //@line 5104
  $67 = $3; //@line 5105
  _cpArrayPush($66, $67); //@line 5106
  $2 = 0; //@line 5107
  $68 = $2; //@line 5108
  STACKTOP = sp; //@line 5109
  return $68 | 0; //@line 5109
 } else {
  $2 = 1; //@line 5111
  $68 = $2; //@line 5112
  STACKTOP = sp; //@line 5113
  return $68 | 0; //@line 5113
 }
 return 0 | 0; //@line 5115
}
function _cpSegmentShapeMassInfo($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 6420
 $1 = +$1; //@line 6421
 $2 = $2 | 0; //@line 6422
 $3 = $3 | 0; //@line 6423
 $4 = +$4; //@line 6424
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $10 = 0.0, $11 = 0.0, $12 = 0.0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0.0, $17 = 0, $18 = 0, $19 = 0.0, $20 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0; //@line 6425
 var $8 = 0.0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP; //@line 6427
 STACKTOP = STACKTOP + 160 | 0; //@line 6428
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(160 | 0); //@line 6428
 $$byval_copy5 = sp + 136 | 0; //@line 6429
 $$byval_copy4 = sp + 120 | 0; //@line 6430
 $$byval_copy3 = sp + 104 | 0; //@line 6431
 $$byval_copy2 = sp + 88 | 0; //@line 6432
 $$byval_copy1 = sp + 72 | 0; //@line 6433
 $$byval_copy = sp + 56 | 0; //@line 6434
 $7 = sp; //@line 6435
 $5 = $1; //@line 6436
 $6 = $4; //@line 6437
 $8 = $5; //@line 6438
 SAFE_HEAP_STORE_D($7 | 0, +$8, 8);
 $9 = $7 + 8 | 0; //@line 6440
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $10 = +_cpvdist_376($$byval_copy, $$byval_copy1); //@line 6443
 $11 = $6; //@line 6444
 $12 = 2.0 * $11; //@line 6445
 $13 = $10 + $12; //@line 6446
 $14 = $6; //@line 6447
 $15 = 2.0 * $14; //@line 6448
 $16 = +_cpMomentForBox(1.0, $13, $15); //@line 6449
 SAFE_HEAP_STORE_D($9 | 0, +$16, 8);
 $17 = $7 + 16 | 0; //@line 6451
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvlerp_362($17, $$byval_copy2, $$byval_copy3, .5); //@line 6454
 $18 = $7 + 32 | 0; //@line 6455
 $19 = $6; //@line 6456
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $20 = +_cpAreaForSegment($$byval_copy4, $$byval_copy5, $19); //@line 6459
 SAFE_HEAP_STORE_D($18 | 0, +$20, 8);
 dest = $0; //@line 6461
 src = $7; //@line 6461
 stop = dest + 40 | 0; //@line 6461
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 6461
  src = src + 4 | 0; //@line 6461
 } while ((dest | 0) < (stop | 0));
 STACKTOP = sp; //@line 6462
 return;
}
function _cpSpaceDestroy($0) {
 $0 = $0 | 0; //@line 506
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0; //@line 507
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0; //@line 508
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $7 = 0; //@line 509
 var $8 = 0, $9 = 0, label = 0, sp = 0; //@line 510
 sp = STACKTOP; //@line 511
 STACKTOP = STACKTOP + 16 | 0; //@line 512
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 512
 $1 = $0; //@line 513
 $2 = $1; //@line 514
 _cpSpaceEachBody($2, 62, 0); //@line 515
 $3 = $1; //@line 516
 $4 = $3 + 108 | 0; //@line 517
 $5 = SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0; //@line 518
 _cpSpatialIndexFree($5); //@line 519
 $6 = $1; //@line 520
 $7 = $6 + 112 | 0; //@line 521
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 522
 _cpSpatialIndexFree($8); //@line 523
 $9 = $1; //@line 524
 $10 = $9 + 88 | 0; //@line 525
 $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 526
 _cpArrayFree($11); //@line 527
 $12 = $1; //@line 528
 $13 = $12 + 92 | 0; //@line 529
 $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 530
 _cpArrayFree($14); //@line 531
 $15 = $1; //@line 532
 $16 = $15 + 100 | 0; //@line 533
 $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 534
 _cpArrayFree($17); //@line 535
 $18 = $1; //@line 536
 $19 = $18 + 96 | 0; //@line 537
 $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 538
 _cpArrayFree($20); //@line 539
 $21 = $1; //@line 540
 $22 = $21 + 116 | 0; //@line 541
 $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 542
 _cpArrayFree($23); //@line 543
 $24 = $1; //@line 544
 $25 = $24 + 128 | 0; //@line 545
 $26 = SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0; //@line 546
 _cpHashSetFree($26); //@line 547
 $27 = $1; //@line 548
 $28 = $27 + 120 | 0; //@line 549
 $29 = SAFE_HEAP_LOAD($28 | 0, 4, 0) | 0 | 0; //@line 550
 _cpArrayFree($29); //@line 551
 $30 = $1; //@line 552
 $31 = $30 + 132 | 0; //@line 553
 $32 = SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0; //@line 554
 _cpArrayFree($32); //@line 555
 $33 = $1; //@line 556
 $34 = $33 + 136 | 0; //@line 557
 $35 = SAFE_HEAP_LOAD($34 | 0, 4, 0) | 0 | 0; //@line 558
 $36 = ($35 | 0) != (0 | 0); //@line 559
 if ($36) {
  $37 = $1; //@line 561
  $38 = $37 + 136 | 0; //@line 562
  $39 = SAFE_HEAP_LOAD($38 | 0, 4, 0) | 0 | 0; //@line 563
  _cpArrayFreeEach($39, 48); //@line 564
  $40 = $1; //@line 565
  $41 = $40 + 136 | 0; //@line 566
  $42 = SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0; //@line 567
  _cpArrayFree($42); //@line 568
 }
 $43 = $1; //@line 570
 $44 = $43 + 184 | 0; //@line 571
 $45 = SAFE_HEAP_LOAD($44 | 0, 4, 0) | 0 | 0; //@line 572
 $46 = ($45 | 0) != (0 | 0); //@line 573
 if ($46) {
  $47 = $1; //@line 575
  $48 = $47 + 184 | 0; //@line 576
  $49 = SAFE_HEAP_LOAD($48 | 0, 4, 0) | 0 | 0; //@line 577
  _cpArrayFreeEach($49, 48); //@line 578
  $50 = $1; //@line 579
  $51 = $50 + 184 | 0; //@line 580
  $52 = SAFE_HEAP_LOAD($51 | 0, 4, 0) | 0 | 0; //@line 581
  _cpArrayFree($52); //@line 582
 }
 $53 = $1; //@line 584
 $54 = $53 + 148 | 0; //@line 585
 $55 = SAFE_HEAP_LOAD($54 | 0, 4, 0) | 0 | 0; //@line 586
 $56 = ($55 | 0) != (0 | 0); //@line 587
 if (!$56) {
  $60 = $1; //@line 589
  $61 = $60 + 148 | 0; //@line 590
  $62 = SAFE_HEAP_LOAD($61 | 0, 4, 0) | 0 | 0; //@line 591
  _cpHashSetFree($62); //@line 592
  STACKTOP = sp; //@line 593
  return;
 }
 $57 = $1; //@line 595
 $58 = $57 + 148 | 0; //@line 596
 $59 = SAFE_HEAP_LOAD($58 | 0, 4, 0) | 0 | 0; //@line 597
 _cpHashSetEach($59, 63, 0); //@line 598
 $60 = $1; //@line 599
 $61 = $60 + 148 | 0; //@line 600
 $62 = SAFE_HEAP_LOAD($61 | 0, 4, 0) | 0 | 0; //@line 601
 _cpHashSetFree($62); //@line 602
 STACKTOP = sp; //@line 603
 return;
}
function _wcrtomb($0, $1, $2) {
 $0 = $0 | 0; //@line 13934
 $1 = $1 | 0; //@line 13935
 $2 = $2 | 0; //@line 13936
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 13937
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0; //@line 13938
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0; //@line 13939
 sp = STACKTOP; //@line 13940
 $3 = ($0 | 0) == (0 | 0); //@line 13941
 do {
  if ($3) {
   $$0 = 1; //@line 13944
  } else {
   $4 = $1 >>> 0 < 128; //@line 13946
   if ($4) {
    $5 = $1 & 255; //@line 13948
    SAFE_HEAP_STORE($0 >> 0 | 0, $5 | 0, 1);
    $$0 = 1; //@line 13950
    break;
   }
   $6 = ___pthread_self_888() | 0; //@line 13953
   $7 = $6 + 188 | 0; //@line 13954
   $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 13955
   $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 13956
   $10 = ($9 | 0) == (0 | 0); //@line 13957
   if ($10) {
    $11 = $1 & -128; //@line 13959
    $12 = ($11 | 0) == 57216; //@line 13960
    if ($12) {
     $14 = $1 & 255; //@line 13962
     SAFE_HEAP_STORE($0 >> 0 | 0, $14 | 0, 1);
     $$0 = 1; //@line 13964
     break;
    } else {
     $13 = ___errno_location() | 0; //@line 13967
     SAFE_HEAP_STORE($13 | 0, 84 | 0, 4);
     $$0 = -1; //@line 13969
     break;
    }
   }
   $15 = $1 >>> 0 < 2048; //@line 13973
   if ($15) {
    $16 = $1 >>> 6; //@line 13975
    $17 = $16 | 192; //@line 13976
    $18 = $17 & 255; //@line 13977
    $19 = $0 + 1 | 0; //@line 13978
    SAFE_HEAP_STORE($0 >> 0 | 0, $18 | 0, 1);
    $20 = $1 & 63; //@line 13980
    $21 = $20 | 128; //@line 13981
    $22 = $21 & 255; //@line 13982
    SAFE_HEAP_STORE($19 >> 0 | 0, $22 | 0, 1);
    $$0 = 2; //@line 13984
    break;
   }
   $23 = $1 >>> 0 < 55296; //@line 13987
   $24 = $1 & -8192; //@line 13988
   $25 = ($24 | 0) == 57344; //@line 13989
   $or$cond = $23 | $25; //@line 13990
   if ($or$cond) {
    $26 = $1 >>> 12; //@line 13992
    $27 = $26 | 224; //@line 13993
    $28 = $27 & 255; //@line 13994
    $29 = $0 + 1 | 0; //@line 13995
    SAFE_HEAP_STORE($0 >> 0 | 0, $28 | 0, 1);
    $30 = $1 >>> 6; //@line 13997
    $31 = $30 & 63; //@line 13998
    $32 = $31 | 128; //@line 13999
    $33 = $32 & 255; //@line 14000
    $34 = $0 + 2 | 0; //@line 14001
    SAFE_HEAP_STORE($29 >> 0 | 0, $33 | 0, 1);
    $35 = $1 & 63; //@line 14003
    $36 = $35 | 128; //@line 14004
    $37 = $36 & 255; //@line 14005
    SAFE_HEAP_STORE($34 >> 0 | 0, $37 | 0, 1);
    $$0 = 3; //@line 14007
    break;
   }
   $38 = $1 + -65536 | 0; //@line 14010
   $39 = $38 >>> 0 < 1048576; //@line 14011
   if ($39) {
    $40 = $1 >>> 18; //@line 14013
    $41 = $40 | 240; //@line 14014
    $42 = $41 & 255; //@line 14015
    $43 = $0 + 1 | 0; //@line 14016
    SAFE_HEAP_STORE($0 >> 0 | 0, $42 | 0, 1);
    $44 = $1 >>> 12; //@line 14018
    $45 = $44 & 63; //@line 14019
    $46 = $45 | 128; //@line 14020
    $47 = $46 & 255; //@line 14021
    $48 = $0 + 2 | 0; //@line 14022
    SAFE_HEAP_STORE($43 >> 0 | 0, $47 | 0, 1);
    $49 = $1 >>> 6; //@line 14024
    $50 = $49 & 63; //@line 14025
    $51 = $50 | 128; //@line 14026
    $52 = $51 & 255; //@line 14027
    $53 = $0 + 3 | 0; //@line 14028
    SAFE_HEAP_STORE($48 >> 0 | 0, $52 | 0, 1);
    $54 = $1 & 63; //@line 14030
    $55 = $54 | 128; //@line 14031
    $56 = $55 & 255; //@line 14032
    SAFE_HEAP_STORE($53 >> 0 | 0, $56 | 0, 1);
    $$0 = 4; //@line 14034
    break;
   } else {
    $57 = ___errno_location() | 0; //@line 14037
    SAFE_HEAP_STORE($57 | 0, 84 | 0, 4);
    $$0 = -1; //@line 14039
    break;
   }
  }
 } while (0);
 return $$0 | 0; //@line 14044
}
function _cpBodyInit($0, $1, $2) {
 $0 = $0 | 0; //@line 5534
 $1 = +$1; //@line 5535
 $2 = +$2; //@line 5536
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0; //@line 5537
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0.0, $40 = 0, $41 = 0, $42 = 0.0, $43 = 0, $44 = 0.0, $45 = 0, $46 = 0, $5 = 0.0; //@line 5538
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5539
 sp = STACKTOP; //@line 5540
 STACKTOP = STACKTOP + 32 | 0; //@line 5541
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 5541
 $3 = $0; //@line 5542
 $4 = $1; //@line 5543
 $5 = $2; //@line 5544
 $6 = $3; //@line 5545
 $7 = $6 + 208 | 0; //@line 5546
 SAFE_HEAP_STORE($7 | 0, 0 | 0, 4);
 $8 = $3; //@line 5548
 $9 = $8 + 212 | 0; //@line 5549
 SAFE_HEAP_STORE($9 | 0, 0 | 0, 4);
 $10 = $3; //@line 5551
 $11 = $10 + 216 | 0; //@line 5552
 SAFE_HEAP_STORE($11 | 0, 0 | 0, 4);
 $12 = $3; //@line 5554
 $13 = $12 + 220 | 0; //@line 5555
 SAFE_HEAP_STORE($13 | 0, 0 | 0, 4);
 $14 = $3; //@line 5557
 SAFE_HEAP_STORE($14 | 0, 53 | 0, 4);
 $15 = $3; //@line 5559
 $16 = $15 + 4 | 0; //@line 5560
 SAFE_HEAP_STORE($16 | 0, 54 | 0, 4);
 $17 = $3; //@line 5562
 $18 = $17 + 224 | 0; //@line 5563
 SAFE_HEAP_STORE($18 | 0, 0 | 0, 4);
 $19 = $3; //@line 5565
 $20 = $19 + 224 | 0; //@line 5566
 $21 = $20 + 4 | 0; //@line 5567
 SAFE_HEAP_STORE($21 | 0, 0 | 0, 4);
 $22 = $3; //@line 5569
 $23 = $22 + 224 | 0; //@line 5570
 $24 = $23 + 8 | 0; //@line 5571
 SAFE_HEAP_STORE_D($24 | 0, +0.0, 8);
 $25 = $3; //@line 5573
 $26 = $25 + 56 | 0; //@line 5574
 SAFE_HEAP_STORE($26 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($26 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($26 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($26 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $27 = $3; //@line 5576
 $28 = $27 + 72 | 0; //@line 5577
 SAFE_HEAP_STORE($28 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($28 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($28 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($28 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $29 = $3; //@line 5579
 $30 = $29 + 88 | 0; //@line 5580
 SAFE_HEAP_STORE($30 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($30 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($30 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($30 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $31 = $3; //@line 5582
 $32 = $31 + 112 | 0; //@line 5583
 SAFE_HEAP_STORE_D($32 | 0, +0.0, 8);
 $33 = $3; //@line 5585
 $34 = $33 + 120 | 0; //@line 5586
 SAFE_HEAP_STORE_D($34 | 0, +0.0, 8);
 $35 = $3; //@line 5588
 $36 = $35 + 184 | 0; //@line 5589
 SAFE_HEAP_STORE($36 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($36 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($36 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($36 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $37 = $3; //@line 5591
 $38 = $37 + 200 | 0; //@line 5592
 SAFE_HEAP_STORE_D($38 | 0, +0.0, 8);
 $39 = $3; //@line 5594
 $40 = $39 + 176 | 0; //@line 5595
 SAFE_HEAP_STORE($40 | 0, 0 | 0, 4);
 $41 = $3; //@line 5597
 $42 = $4; //@line 5598
 _cpBodySetMass($41, $42); //@line 5599
 $43 = $3; //@line 5600
 $44 = $5; //@line 5601
 _cpBodySetMoment($43, $44); //@line 5602
 $45 = $3; //@line 5603
 _cpBodySetAngle($45, 0.0); //@line 5604
 $46 = $3; //@line 5605
 STACKTOP = sp; //@line 5606
 return $46 | 0; //@line 5606
}
function _PairInsert($0, $1, $2) {
 $0 = $0 | 0; //@line 4158
 $1 = $1 | 0; //@line 4159
 $2 = $2 | 0; //@line 4160
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0; //@line 4161
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0; //@line 4162
 var $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 4163
 sp = STACKTOP; //@line 4164
 STACKTOP = STACKTOP + 64 | 0; //@line 4165
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 4165
 $9 = sp; //@line 4166
 $3 = $0; //@line 4167
 $4 = $1; //@line 4168
 $5 = $2; //@line 4169
 $10 = $3; //@line 4170
 $11 = $10 + 44 | 0; //@line 4171
 $12 = $11 + 4 | 0; //@line 4172
 $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 4173
 $6 = $13; //@line 4174
 $14 = $4; //@line 4175
 $15 = $14 + 44 | 0; //@line 4176
 $16 = $15 + 4 | 0; //@line 4177
 $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 4178
 $7 = $17; //@line 4179
 $18 = $5; //@line 4180
 $19 = _PairFromPool($18) | 0; //@line 4181
 $8 = $19; //@line 4182
 SAFE_HEAP_STORE($9 | 0, 0 | 0, 4);
 $20 = $9 + 4 | 0; //@line 4184
 $21 = $3; //@line 4185
 SAFE_HEAP_STORE($20 | 0, $21 | 0, 4);
 $22 = $9 + 8 | 0; //@line 4187
 $23 = $6; //@line 4188
 SAFE_HEAP_STORE($22 | 0, $23 | 0, 4);
 $24 = $9 + 12 | 0; //@line 4190
 SAFE_HEAP_STORE($24 | 0, 0 | 0, 4);
 $25 = $24 + 4 | 0; //@line 4192
 $26 = $4; //@line 4193
 SAFE_HEAP_STORE($25 | 0, $26 | 0, 4);
 $27 = $24 + 8 | 0; //@line 4195
 $28 = $7; //@line 4196
 SAFE_HEAP_STORE($27 | 0, $28 | 0, 4);
 $29 = $9 + 24 | 0; //@line 4198
 SAFE_HEAP_STORE($29 | 0, 0 | 0, 4);
 $30 = $8; //@line 4200
 $31 = $4; //@line 4201
 $32 = $31 + 44 | 0; //@line 4202
 $33 = $32 + 4 | 0; //@line 4203
 SAFE_HEAP_STORE($33 | 0, $30 | 0, 4);
 $34 = $3; //@line 4205
 $35 = $34 + 44 | 0; //@line 4206
 $36 = $35 + 4 | 0; //@line 4207
 SAFE_HEAP_STORE($36 | 0, $30 | 0, 4);
 $37 = $8; //@line 4209
 SAFE_HEAP_STORE($37 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($37 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($37 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($37 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($37 + 16 | 0, SAFE_HEAP_LOAD($9 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($37 + 20 | 0, SAFE_HEAP_LOAD($9 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($37 + 24 | 0, SAFE_HEAP_LOAD($9 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 $38 = $6; //@line 4211
 $39 = ($38 | 0) != (0 | 0); //@line 4212
 do {
  if ($39) {
   $40 = $6; //@line 4215
   $41 = $40 + 4 | 0; //@line 4216
   $42 = SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0; //@line 4217
   $43 = $3; //@line 4218
   $44 = ($42 | 0) == ($43 | 0); //@line 4219
   $45 = $8; //@line 4220
   $46 = $6; //@line 4221
   if ($44) {
    SAFE_HEAP_STORE($46 | 0, $45 | 0, 4);
    break;
   } else {
    $47 = $46 + 12 | 0; //@line 4226
    SAFE_HEAP_STORE($47 | 0, $45 | 0, 4);
    break;
   }
  }
 } while (0);
 $48 = $7; //@line 4232
 $49 = ($48 | 0) != (0 | 0); //@line 4233
 if (!$49) {
  STACKTOP = sp; //@line 4235
  return;
 }
 $50 = $7; //@line 4237
 $51 = $50 + 4 | 0; //@line 4238
 $52 = SAFE_HEAP_LOAD($51 | 0, 4, 0) | 0 | 0; //@line 4239
 $53 = $4; //@line 4240
 $54 = ($52 | 0) == ($53 | 0); //@line 4241
 $55 = $8; //@line 4242
 $56 = $7; //@line 4243
 if ($54) {
  SAFE_HEAP_STORE($56 | 0, $55 | 0, 4);
  STACKTOP = sp; //@line 4246
  return;
 } else {
  $57 = $56 + 12 | 0; //@line 4248
  SAFE_HEAP_STORE($57 | 0, $55 | 0, 4);
  STACKTOP = sp; //@line 4250
  return;
 }
}
function _cpBodySetPosition($0, $1) {
 $0 = $0 | 0; //@line 6835
 $1 = $1 | 0; //@line 6836
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0.0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0; //@line 6837
 var $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 6838
 sp = STACKTOP; //@line 6839
 STACKTOP = STACKTOP + 176 | 0; //@line 6840
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(176 | 0); //@line 6840
 $$byval_copy4 = sp + 144 | 0; //@line 6841
 $$byval_copy3 = sp + 128 | 0; //@line 6842
 $$byval_copy2 = sp + 112 | 0; //@line 6843
 $$byval_copy1 = sp + 96 | 0; //@line 6844
 $$byval_copy = sp + 48 | 0; //@line 6845
 $3 = sp + 32 | 0; //@line 6846
 $4 = sp + 16 | 0; //@line 6847
 $5 = sp; //@line 6848
 $2 = $0; //@line 6849
 $6 = $2; //@line 6850
 _cpBodyActivate($6); //@line 6851
 $7 = $2; //@line 6852
 $8 = $7 + 56 | 0; //@line 6853
 $9 = $2; //@line 6854
 $10 = $9 + 128 | 0; //@line 6855
 $11 = $2; //@line 6856
 $12 = $11 + 40 | 0; //@line 6857
 dest = $$byval_copy; //@line 6858
 src = $10; //@line 6858
 stop = dest + 48 | 0; //@line 6858
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 6858
  src = src + 4 | 0; //@line 6858
 } while ((dest | 0) < (stop | 0));
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpTransformVect($4, $$byval_copy, $$byval_copy1); //@line 6860
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_43($5, $$byval_copy2, $$byval_copy3); //@line 6863
 SAFE_HEAP_STORE($8 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($3 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($3 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($3 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($3 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $13 = $2; //@line 6866
 _cpBodySanityCheck($13); //@line 6867
 $14 = $2; //@line 6868
 $15 = $2; //@line 6869
 $16 = $15 + 104 | 0; //@line 6870
 $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 6871
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _SetTransform($14, $$byval_copy4, $17); //@line 6873
 STACKTOP = sp; //@line 6874
 return;
}
function _vfprintf($0, $1, $2) {
 $0 = $0 | 0; //@line 11389
 $1 = $1 | 0; //@line 11390
 $2 = $2 | 0; //@line 11391
 var $$0 = 0, $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0; //@line 11392
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0; //@line 11393
 var $spec$select = 0, $spec$select41 = 0, $vacopy_currentptr = 0, dest = 0, label = 0, sp = 0, stop = 0; //@line 11394
 sp = STACKTOP; //@line 11395
 STACKTOP = STACKTOP + 224 | 0; //@line 11396
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(224 | 0); //@line 11396
 $3 = sp + 208 | 0; //@line 11397
 $4 = sp + 160 | 0; //@line 11398
 $5 = sp + 80 | 0; //@line 11399
 $6 = sp; //@line 11400
 dest = $4; //@line 11401
 stop = dest + 40 | 0; //@line 11401
 do {
  SAFE_HEAP_STORE(dest | 0, 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 11401
 } while ((dest | 0) < (stop | 0));
 $vacopy_currentptr = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 11402
 SAFE_HEAP_STORE($3 | 0, $vacopy_currentptr | 0, 4);
 $7 = _printf_core(0, $1, $3, $5, $4) | 0; //@line 11404
 $8 = ($7 | 0) < 0; //@line 11405
 if ($8) {
  $$0 = -1; //@line 11407
 } else {
  $9 = $0 + 76 | 0; //@line 11409
  $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 11410
  $11 = ($10 | 0) > -1; //@line 11411
  if ($11) {
   $12 = ___lockfile($0) | 0; //@line 11413
   $40 = $12; //@line 11414
  } else {
   $40 = 0; //@line 11416
  }
  $13 = SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0; //@line 11418
  $14 = $13 & 32; //@line 11419
  $15 = $0 + 74 | 0; //@line 11420
  $16 = SAFE_HEAP_LOAD($15 >> 0 | 0, 1, 0) | 0 | 0; //@line 11421
  $17 = $16 << 24 >> 24 < 1; //@line 11422
  if ($17) {
   $18 = $13 & -33; //@line 11424
   SAFE_HEAP_STORE($0 | 0, $18 | 0, 4);
  }
  $19 = $0 + 48 | 0; //@line 11427
  $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 11428
  $21 = ($20 | 0) == 0; //@line 11429
  if ($21) {
   $23 = $0 + 44 | 0; //@line 11431
   $24 = SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0; //@line 11432
   SAFE_HEAP_STORE($23 | 0, $6 | 0, 4);
   $25 = $0 + 28 | 0; //@line 11434
   SAFE_HEAP_STORE($25 | 0, $6 | 0, 4);
   $26 = $0 + 20 | 0; //@line 11436
   SAFE_HEAP_STORE($26 | 0, $6 | 0, 4);
   SAFE_HEAP_STORE($19 | 0, 80 | 0, 4);
   $27 = $6 + 80 | 0; //@line 11439
   $28 = $0 + 16 | 0; //@line 11440
   SAFE_HEAP_STORE($28 | 0, $27 | 0, 4);
   $29 = _printf_core($0, $1, $3, $5, $4) | 0; //@line 11442
   $30 = ($24 | 0) == (0 | 0); //@line 11443
   if ($30) {
    $$1 = $29; //@line 11445
   } else {
    $31 = $0 + 36 | 0; //@line 11447
    $32 = SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0; //@line 11448
    FUNCTION_TABLE_iiii[(SAFE_FT_MASK($32 | 0, 127 | 0) | 0) & 127]($0, 0, 0) | 0; //@line 11449
    $33 = SAFE_HEAP_LOAD($26 | 0, 4, 0) | 0 | 0; //@line 11450
    $34 = ($33 | 0) == (0 | 0); //@line 11451
    $spec$select = $34 ? -1 : $29; //@line 11452
    SAFE_HEAP_STORE($23 | 0, $24 | 0, 4);
    SAFE_HEAP_STORE($19 | 0, 0 | 0, 4);
    SAFE_HEAP_STORE($28 | 0, 0 | 0, 4);
    SAFE_HEAP_STORE($25 | 0, 0 | 0, 4);
    SAFE_HEAP_STORE($26 | 0, 0 | 0, 4);
    $$1 = $spec$select; //@line 11458
   }
  } else {
   $22 = _printf_core($0, $1, $3, $5, $4) | 0; //@line 11461
   $$1 = $22; //@line 11462
  }
  $35 = SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0; //@line 11464
  $36 = $35 & 32; //@line 11465
  $37 = ($36 | 0) == 0; //@line 11466
  $spec$select41 = $37 ? $$1 : -1; //@line 11467
  $38 = $35 | $14; //@line 11468
  SAFE_HEAP_STORE($0 | 0, $38 | 0, 4);
  $39 = ($40 | 0) == 0; //@line 11470
  if (!$39) {
   ___unlockfile($0); //@line 11472
  }
  $$0 = $spec$select41; //@line 11474
 }
 STACKTOP = sp; //@line 11476
 return $$0 | 0; //@line 11476
}
function _Support($0, $1, $2) {
 $0 = $0 | 0; //@line 937
 $1 = $1 | 0; //@line 938
 $2 = $2 | 0; //@line 939
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0; //@line 940
 var label = 0, sp = 0; //@line 941
 sp = STACKTOP; //@line 942
 STACKTOP = STACKTOP + 176 | 0; //@line 943
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(176 | 0); //@line 943
 $$byval_copy4 = sp + 136 | 0; //@line 944
 $$byval_copy3 = sp + 112 | 0; //@line 945
 $$byval_copy2 = sp + 96 | 0; //@line 946
 $$byval_copy1 = sp + 80 | 0; //@line 947
 $$byval_copy = sp + 64 | 0; //@line 948
 $4 = sp + 40 | 0; //@line 949
 $5 = sp + 24 | 0; //@line 950
 $6 = sp; //@line 951
 $3 = $1; //@line 952
 $7 = $3; //@line 953
 $8 = $7 + 8 | 0; //@line 954
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 955
 $10 = $3; //@line 956
 $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 957
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvneg_62($5, $$byval_copy); //@line 959
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($9 | 0, 127 | 0) | 0) & 127]($4, $11, $$byval_copy1); //@line 961
 $12 = $3; //@line 962
 $13 = $12 + 12 | 0; //@line 963
 $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 964
 $15 = $3; //@line 965
 $16 = $15 + 4 | 0; //@line 966
 $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 967
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($14 | 0, 127 | 0) | 0) & 127]($6, $17, $$byval_copy2); //@line 969
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 16 | 0, SAFE_HEAP_LOAD($4 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 20 | 0, SAFE_HEAP_LOAD($4 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 16 | 0, SAFE_HEAP_LOAD($6 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 20 | 0, SAFE_HEAP_LOAD($6 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 _MinkowskiPointNew($0, $$byval_copy3, $$byval_copy4); //@line 972
 STACKTOP = sp; //@line 973
 return;
}
function _cpSpaceAddConstraint($0, $1) {
 $0 = $0 | 0; //@line 1403
 $1 = $1 | 0; //@line 1404
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 1405
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0; //@line 1406
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $vararg_buffer = 0, $vararg_buffer2 = 0, $vararg_buffer4 = 0, $vararg_buffer6 = 0, label = 0, sp = 0; //@line 1407
 sp = STACKTOP; //@line 1408
 STACKTOP = STACKTOP + 48 | 0; //@line 1409
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 1409
 $vararg_buffer6 = sp + 24 | 0; //@line 1410
 $vararg_buffer4 = sp + 16 | 0; //@line 1411
 $vararg_buffer2 = sp + 8 | 0; //@line 1412
 $vararg_buffer = sp; //@line 1413
 $2 = $0; //@line 1414
 $3 = $1; //@line 1415
 $6 = $3; //@line 1416
 $7 = $6 + 4 | 0; //@line 1417
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 1418
 $9 = $2; //@line 1419
 $10 = ($8 | 0) != ($9 | 0); //@line 1420
 if (!$10) {
  _cpMessage(6993, 6192, 455, 1, 1, 7020, $vararg_buffer); //@line 1422
  _abort(); //@line 1423
 }
 $11 = $3; //@line 1426
 $12 = $11 + 4 | 0; //@line 1427
 $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 1428
 $14 = ($13 | 0) != (0 | 0); //@line 1429
 if ($14) {
  _cpMessage(7109, 6192, 456, 1, 1, 7128, $vararg_buffer2); //@line 1431
  _abort(); //@line 1432
 }
 $15 = $2; //@line 1435
 $16 = $15 + 140 | 0; //@line 1436
 $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 1437
 $18 = ($17 | 0) != 0; //@line 1438
 if ($18) {
  _cpMessage(6649, 6192, 457, 1, 1, 6664, $vararg_buffer4); //@line 1440
  _abort(); //@line 1441
 }
 $19 = $3; //@line 1444
 $20 = $19 + 8 | 0; //@line 1445
 $21 = SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0; //@line 1446
 $4 = $21; //@line 1447
 $22 = $3; //@line 1448
 $23 = $22 + 12 | 0; //@line 1449
 $24 = SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0; //@line 1450
 $5 = $24; //@line 1451
 $25 = $4; //@line 1452
 $26 = ($25 | 0) != (0 | 0); //@line 1453
 $27 = $5; //@line 1454
 $28 = ($27 | 0) != (0 | 0); //@line 1455
 $or$cond = $26 & $28; //@line 1456
 if ($or$cond) {
  $29 = $4; //@line 1458
  _cpBodyActivate($29); //@line 1459
  $30 = $5; //@line 1460
  _cpBodyActivate($30); //@line 1461
  $31 = $2; //@line 1462
  $32 = $31 + 116 | 0; //@line 1463
  $33 = SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0; //@line 1464
  $34 = $3; //@line 1465
  _cpArrayPush($33, $34); //@line 1466
  $35 = $4; //@line 1467
  $36 = $35 + 220 | 0; //@line 1468
  $37 = SAFE_HEAP_LOAD($36 | 0, 4, 0) | 0 | 0; //@line 1469
  $38 = $3; //@line 1470
  $39 = $38 + 16 | 0; //@line 1471
  SAFE_HEAP_STORE($39 | 0, $37 | 0, 4);
  $40 = $3; //@line 1473
  $41 = $4; //@line 1474
  $42 = $41 + 220 | 0; //@line 1475
  SAFE_HEAP_STORE($42 | 0, $40 | 0, 4);
  $43 = $5; //@line 1477
  $44 = $43 + 220 | 0; //@line 1478
  $45 = SAFE_HEAP_LOAD($44 | 0, 4, 0) | 0 | 0; //@line 1479
  $46 = $3; //@line 1480
  $47 = $46 + 20 | 0; //@line 1481
  SAFE_HEAP_STORE($47 | 0, $45 | 0, 4);
  $48 = $3; //@line 1483
  $49 = $5; //@line 1484
  $50 = $49 + 220 | 0; //@line 1485
  SAFE_HEAP_STORE($50 | 0, $48 | 0, 4);
  $51 = $2; //@line 1487
  $52 = $3; //@line 1488
  $53 = $52 + 4 | 0; //@line 1489
  SAFE_HEAP_STORE($53 | 0, $51 | 0, 4);
  $54 = $3; //@line 1491
  STACKTOP = sp; //@line 1492
  return $54 | 0; //@line 1492
 } else {
  _cpMessage(7216, 6192, 460, 1, 1, 7239, $vararg_buffer6); //@line 1494
  _abort(); //@line 1495
 }
 return 0 | 0; //@line 1498
}
function _apply_impulse_407($0, $1, $2) {
 $0 = $0 | 0; //@line 7830
 $1 = $1 | 0; //@line 7831
 $2 = $2 | 0; //@line 7832
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $10 = 0, $11 = 0, $12 = 0.0, $13 = 0, $14 = 0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0, $19 = 0, $20 = 0.0, $21 = 0.0, $3 = 0, $4 = 0, $5 = 0; //@line 7833
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 7834
 sp = STACKTOP; //@line 7835
 STACKTOP = STACKTOP + 128 | 0; //@line 7836
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(128 | 0); //@line 7836
 $$byval_copy4 = sp + 96 | 0; //@line 7837
 $$byval_copy3 = sp + 80 | 0; //@line 7838
 $$byval_copy2 = sp + 64 | 0; //@line 7839
 $$byval_copy1 = sp + 48 | 0; //@line 7840
 $$byval_copy = sp + 32 | 0; //@line 7841
 $4 = sp + 16 | 0; //@line 7842
 $5 = sp; //@line 7843
 $3 = $0; //@line 7844
 $6 = $3; //@line 7845
 $7 = $6 + 72 | 0; //@line 7846
 $8 = $3; //@line 7847
 $9 = $8 + 72 | 0; //@line 7848
 $10 = $3; //@line 7849
 $11 = $10 + 16 | 0; //@line 7850
 $12 = +(+SAFE_HEAP_LOAD_D($11 | 0, 8)); //@line 7851
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_404($4, $$byval_copy, $12); //@line 7853
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_408($5, $$byval_copy1, $$byval_copy2); //@line 7856
 SAFE_HEAP_STORE($7 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $13 = $3; //@line 7858
 $14 = $13 + 32 | 0; //@line 7859
 $15 = +(+SAFE_HEAP_LOAD_D($14 | 0, 8)); //@line 7860
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $16 = +_cpvcross_409($$byval_copy3, $$byval_copy4); //@line 7863
 $17 = $15 * $16; //@line 7864
 $18 = $3; //@line 7865
 $19 = $18 + 112 | 0; //@line 7866
 $20 = +(+SAFE_HEAP_LOAD_D($19 | 0, 8)); //@line 7867
 $21 = $20 + $17; //@line 7868
 SAFE_HEAP_STORE_D($19 | 0, +$21, 8);
 STACKTOP = sp; //@line 7870
 return;
}
function _apply_impulse_248($0, $1, $2) {
 $0 = $0 | 0; //@line 3402
 $1 = $1 | 0; //@line 3403
 $2 = $2 | 0; //@line 3404
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $10 = 0, $11 = 0, $12 = 0.0, $13 = 0, $14 = 0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0, $19 = 0, $20 = 0.0, $21 = 0.0, $3 = 0, $4 = 0, $5 = 0; //@line 3405
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3406
 sp = STACKTOP; //@line 3407
 STACKTOP = STACKTOP + 128 | 0; //@line 3408
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(128 | 0); //@line 3408
 $$byval_copy4 = sp + 96 | 0; //@line 3409
 $$byval_copy3 = sp + 80 | 0; //@line 3410
 $$byval_copy2 = sp + 64 | 0; //@line 3411
 $$byval_copy1 = sp + 48 | 0; //@line 3412
 $$byval_copy = sp + 32 | 0; //@line 3413
 $4 = sp + 16 | 0; //@line 3414
 $5 = sp; //@line 3415
 $3 = $0; //@line 3416
 $6 = $3; //@line 3417
 $7 = $6 + 72 | 0; //@line 3418
 $8 = $3; //@line 3419
 $9 = $8 + 72 | 0; //@line 3420
 $10 = $3; //@line 3421
 $11 = $10 + 16 | 0; //@line 3422
 $12 = +(+SAFE_HEAP_LOAD_D($11 | 0, 8)); //@line 3423
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_249($4, $$byval_copy, $12); //@line 3425
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_244($5, $$byval_copy1, $$byval_copy2); //@line 3428
 SAFE_HEAP_STORE($7 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $13 = $3; //@line 3430
 $14 = $13 + 32 | 0; //@line 3431
 $15 = +(+SAFE_HEAP_LOAD_D($14 | 0, 8)); //@line 3432
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $16 = +_cpvcross_250($$byval_copy3, $$byval_copy4); //@line 3435
 $17 = $15 * $16; //@line 3436
 $18 = $3; //@line 3437
 $19 = $18 + 112 | 0; //@line 3438
 $20 = +(+SAFE_HEAP_LOAD_D($19 | 0, 8)); //@line 3439
 $21 = $20 + $17; //@line 3440
 SAFE_HEAP_STORE_D($19 | 0, +$21, 8);
 STACKTOP = sp; //@line 3442
 return;
}
function _apply_bias_impulse($0, $1, $2) {
 $0 = $0 | 0; //@line 2624
 $1 = $1 | 0; //@line 2625
 $2 = $2 | 0; //@line 2626
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $10 = 0, $11 = 0, $12 = 0.0, $13 = 0, $14 = 0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0, $19 = 0, $20 = 0.0, $21 = 0.0, $3 = 0, $4 = 0, $5 = 0; //@line 2627
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2628
 sp = STACKTOP; //@line 2629
 STACKTOP = STACKTOP + 128 | 0; //@line 2630
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(128 | 0); //@line 2630
 $$byval_copy4 = sp + 96 | 0; //@line 2631
 $$byval_copy3 = sp + 80 | 0; //@line 2632
 $$byval_copy2 = sp + 64 | 0; //@line 2633
 $$byval_copy1 = sp + 48 | 0; //@line 2634
 $$byval_copy = sp + 32 | 0; //@line 2635
 $4 = sp + 16 | 0; //@line 2636
 $5 = sp; //@line 2637
 $3 = $0; //@line 2638
 $6 = $3; //@line 2639
 $7 = $6 + 184 | 0; //@line 2640
 $8 = $3; //@line 2641
 $9 = $8 + 184 | 0; //@line 2642
 $10 = $3; //@line 2643
 $11 = $10 + 16 | 0; //@line 2644
 $12 = +(+SAFE_HEAP_LOAD_D($11 | 0, 8)); //@line 2645
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_1($4, $$byval_copy, $12); //@line 2647
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_9($5, $$byval_copy1, $$byval_copy2); //@line 2650
 SAFE_HEAP_STORE($7 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $13 = $3; //@line 2652
 $14 = $13 + 32 | 0; //@line 2653
 $15 = +(+SAFE_HEAP_LOAD_D($14 | 0, 8)); //@line 2654
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $16 = +_cpvcross_17($$byval_copy3, $$byval_copy4); //@line 2657
 $17 = $15 * $16; //@line 2658
 $18 = $3; //@line 2659
 $19 = $18 + 200 | 0; //@line 2660
 $20 = +(+SAFE_HEAP_LOAD_D($19 | 0, 8)); //@line 2661
 $21 = $20 + $17; //@line 2662
 SAFE_HEAP_STORE_D($19 | 0, +$21, 8);
 STACKTOP = sp; //@line 2664
 return;
}
function _apply_impulse_53($0, $1, $2) {
 $0 = $0 | 0; //@line 7513
 $1 = $1 | 0; //@line 7514
 $2 = $2 | 0; //@line 7515
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $10 = 0, $11 = 0, $12 = 0.0, $13 = 0, $14 = 0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0, $19 = 0, $20 = 0.0, $21 = 0.0, $3 = 0, $4 = 0, $5 = 0; //@line 7516
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 7517
 sp = STACKTOP; //@line 7518
 STACKTOP = STACKTOP + 128 | 0; //@line 7519
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(128 | 0); //@line 7519
 $$byval_copy4 = sp + 96 | 0; //@line 7520
 $$byval_copy3 = sp + 80 | 0; //@line 7521
 $$byval_copy2 = sp + 64 | 0; //@line 7522
 $$byval_copy1 = sp + 48 | 0; //@line 7523
 $$byval_copy = sp + 32 | 0; //@line 7524
 $4 = sp + 16 | 0; //@line 7525
 $5 = sp; //@line 7526
 $3 = $0; //@line 7527
 $6 = $3; //@line 7528
 $7 = $6 + 72 | 0; //@line 7529
 $8 = $3; //@line 7530
 $9 = $8 + 72 | 0; //@line 7531
 $10 = $3; //@line 7532
 $11 = $10 + 16 | 0; //@line 7533
 $12 = +(+SAFE_HEAP_LOAD_D($11 | 0, 8)); //@line 7534
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_44($4, $$byval_copy, $12); //@line 7536
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_43($5, $$byval_copy1, $$byval_copy2); //@line 7539
 SAFE_HEAP_STORE($7 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $13 = $3; //@line 7541
 $14 = $13 + 32 | 0; //@line 7542
 $15 = +(+SAFE_HEAP_LOAD_D($14 | 0, 8)); //@line 7543
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $16 = +_cpvcross_52($$byval_copy3, $$byval_copy4); //@line 7546
 $17 = $15 * $16; //@line 7547
 $18 = $3; //@line 7548
 $19 = $18 + 112 | 0; //@line 7549
 $20 = +(+SAFE_HEAP_LOAD_D($19 | 0, 8)); //@line 7550
 $21 = $20 + $17; //@line 7551
 SAFE_HEAP_STORE_D($19 | 0, +$21, 8);
 STACKTOP = sp; //@line 7553
 return;
}
function _apply_impulse($0, $1, $2) {
 $0 = $0 | 0; //@line 2260
 $1 = $1 | 0; //@line 2261
 $2 = $2 | 0; //@line 2262
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $10 = 0, $11 = 0, $12 = 0.0, $13 = 0, $14 = 0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0, $19 = 0, $20 = 0.0, $21 = 0.0, $3 = 0, $4 = 0, $5 = 0; //@line 2263
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2264
 sp = STACKTOP; //@line 2265
 STACKTOP = STACKTOP + 128 | 0; //@line 2266
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(128 | 0); //@line 2266
 $$byval_copy4 = sp + 96 | 0; //@line 2267
 $$byval_copy3 = sp + 80 | 0; //@line 2268
 $$byval_copy2 = sp + 64 | 0; //@line 2269
 $$byval_copy1 = sp + 48 | 0; //@line 2270
 $$byval_copy = sp + 32 | 0; //@line 2271
 $4 = sp + 16 | 0; //@line 2272
 $5 = sp; //@line 2273
 $3 = $0; //@line 2274
 $6 = $3; //@line 2275
 $7 = $6 + 72 | 0; //@line 2276
 $8 = $3; //@line 2277
 $9 = $8 + 72 | 0; //@line 2278
 $10 = $3; //@line 2279
 $11 = $10 + 16 | 0; //@line 2280
 $12 = +(+SAFE_HEAP_LOAD_D($11 | 0, 8)); //@line 2281
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_1($4, $$byval_copy, $12); //@line 2283
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_9($5, $$byval_copy1, $$byval_copy2); //@line 2286
 SAFE_HEAP_STORE($7 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $13 = $3; //@line 2288
 $14 = $13 + 32 | 0; //@line 2289
 $15 = +(+SAFE_HEAP_LOAD_D($14 | 0, 8)); //@line 2290
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $16 = +_cpvcross_17($$byval_copy3, $$byval_copy4); //@line 2293
 $17 = $15 * $16; //@line 2294
 $18 = $3; //@line 2295
 $19 = $18 + 112 | 0; //@line 2296
 $20 = +(+SAFE_HEAP_LOAD_D($19 | 0, 8)); //@line 2297
 $21 = $20 + $17; //@line 2298
 SAFE_HEAP_STORE_D($19 | 0, +$21, 8);
 STACKTOP = sp; //@line 2300
 return;
}
function _ClosestT($0, $1) {
 $0 = $0 | 0; //@line 1306
 $1 = $1 | 0; //@line 1307
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $$byval_copy6 = 0, $2 = 0, $3 = 0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0.0, label = 0, sp = 0; //@line 1308
 sp = STACKTOP; //@line 1309
 STACKTOP = STACKTOP + 144 | 0; //@line 1310
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(144 | 0); //@line 1310
 $$byval_copy6 = sp + 128 | 0; //@line 1311
 $$byval_copy5 = sp + 112 | 0; //@line 1312
 $$byval_copy4 = sp + 96 | 0; //@line 1313
 $$byval_copy3 = sp + 80 | 0; //@line 1314
 $$byval_copy2 = sp + 64 | 0; //@line 1315
 $$byval_copy1 = sp + 48 | 0; //@line 1316
 $$byval_copy = sp + 32 | 0; //@line 1317
 $2 = sp + 16 | 0; //@line 1318
 $3 = sp; //@line 1319
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_67($2, $$byval_copy, $$byval_copy1); //@line 1322
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_66($3, $$byval_copy2, $$byval_copy3); //@line 1325
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $4 = +_cpvdot_68($$byval_copy4, $$byval_copy5); //@line 1328
 SAFE_HEAP_STORE($$byval_copy6 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy6 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $5 = +_cpvlengthsq_79($$byval_copy6); //@line 1330
 $6 = $4 / $5; //@line 1331
 $7 = +_cpfclamp_84($6, -1.0, 1.0); //@line 1332
 $8 = -$7; //@line 1333
 STACKTOP = sp; //@line 1334
 return +$8;
}
function _ShapeQuery($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 3914
 $1 = $1 | 0; //@line 3915
 $2 = $2 | 0; //@line 3916
 $3 = $3 | 0; //@line 3917
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0; //@line 3918
 var $28 = 0, $29 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0; //@line 3919
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3920
 sp = STACKTOP; //@line 3921
 STACKTOP = STACKTOP + 160 | 0; //@line 3922
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(160 | 0); //@line 3922
 $$byval_copy1 = sp + 136 | 0; //@line 3923
 $$byval_copy = sp + 124 | 0; //@line 3924
 $9 = sp; //@line 3925
 $5 = $0; //@line 3926
 $6 = $1; //@line 3927
 $7 = $2; //@line 3928
 $8 = $3; //@line 3929
 $10 = $5; //@line 3930
 $11 = $10 + 136 | 0; //@line 3931
 $12 = $6; //@line 3932
 $13 = $12 + 136 | 0; //@line 3933
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 $14 = _cpShapeFilterReject($$byval_copy, $$byval_copy1) | 0; //@line 3936
 $15 = $14 & 255; //@line 3937
 $16 = ($15 | 0) != 0; //@line 3938
 if (!$16) {
  $17 = $5; //@line 3940
  $18 = $6; //@line 3941
  $19 = ($17 | 0) == ($18 | 0); //@line 3942
  if (!$19) {
   $21 = $5; //@line 3944
   $22 = $6; //@line 3945
   _cpShapesCollide($9, $21, $22); //@line 3946
   $23 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 3947
   $24 = ($23 | 0) != 0; //@line 3948
   if ($24) {
    $25 = $8; //@line 3950
    $26 = SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0; //@line 3951
    $27 = ($26 | 0) != (0 | 0); //@line 3952
    if ($27) {
     $28 = $8; //@line 3954
     $29 = SAFE_HEAP_LOAD($28 | 0, 4, 0) | 0 | 0; //@line 3955
     $30 = $6; //@line 3956
     $31 = $8; //@line 3957
     $32 = $31 + 4 | 0; //@line 3958
     $33 = SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0; //@line 3959
     FUNCTION_TABLE_viii[(SAFE_FT_MASK($29 | 0, 127 | 0) | 0) & 127]($30, $9, $33); //@line 3960
    }
    $34 = $5; //@line 3962
    $35 = $34 + 88 | 0; //@line 3963
    $36 = SAFE_HEAP_LOAD($35 >> 0 | 0, 1, 0) | 0 | 0; //@line 3964
    $37 = $36 & 255; //@line 3965
    $38 = ($37 | 0) != 0; //@line 3966
    if ($38) {
     $45 = 1; //@line 3968
    } else {
     $39 = $6; //@line 3970
     $40 = $39 + 88 | 0; //@line 3971
     $41 = SAFE_HEAP_LOAD($40 >> 0 | 0, 1, 0) | 0 | 0; //@line 3972
     $42 = $41 & 255; //@line 3973
     $43 = ($42 | 0) != 0; //@line 3974
     $45 = $43; //@line 3975
    }
    $44 = $45 ^ 1; //@line 3977
    $46 = $44 & 1; //@line 3978
    $47 = $46 & 255; //@line 3979
    $48 = $8; //@line 3980
    $49 = $48 + 8 | 0; //@line 3981
    SAFE_HEAP_STORE($49 >> 0 | 0, $47 | 0, 1);
   }
   $50 = $7; //@line 3984
   $4 = $50; //@line 3985
   $51 = $4; //@line 3986
   STACKTOP = sp; //@line 3987
   return $51 | 0; //@line 3987
  }
 }
 $20 = $7; //@line 3990
 $4 = $20; //@line 3991
 $51 = $4; //@line 3992
 STACKTOP = sp; //@line 3993
 return $51 | 0; //@line 3993
}
function _cpArbiterInit($0, $1, $2) {
 $0 = $0 | 0; //@line 1385
 $1 = $1 | 0; //@line 1386
 $2 = $2 | 0; //@line 1387
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0; //@line 1388
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0; //@line 1389
 var $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1390
 sp = STACKTOP; //@line 1391
 STACKTOP = STACKTOP + 16 | 0; //@line 1392
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1392
 $3 = $0; //@line 1393
 $4 = $1; //@line 1394
 $5 = $2; //@line 1395
 $6 = $3; //@line 1396
 $7 = $6 + 96 | 0; //@line 1397
 SAFE_HEAP_STORE($7 | 0, 0 | 0, 4);
 $8 = $3; //@line 1399
 $9 = $8 + 108 | 0; //@line 1400
 SAFE_HEAP_STORE($9 >> 0 | 0, 0 | 0, 1);
 $10 = $3; //@line 1402
 $11 = $10 + 96 | 0; //@line 1403
 SAFE_HEAP_STORE($11 | 0, 0 | 0, 4);
 $12 = $3; //@line 1405
 $13 = $12 + 100 | 0; //@line 1406
 SAFE_HEAP_STORE($13 | 0, 0 | 0, 4);
 $14 = $3; //@line 1408
 $15 = $14 + 104 | 0; //@line 1409
 SAFE_HEAP_STORE($15 | 0, 0 | 0, 4);
 $16 = $3; //@line 1411
 SAFE_HEAP_STORE_D($16 | 0, +0.0, 8);
 $17 = $3; //@line 1413
 $18 = $17 + 8 | 0; //@line 1414
 SAFE_HEAP_STORE_D($18 | 0, +0.0, 8);
 $19 = $3; //@line 1416
 $20 = $19 + 16 | 0; //@line 1417
 SAFE_HEAP_STORE($20 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($20 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($20 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($20 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $21 = $3; //@line 1419
 $22 = $21 + 68 | 0; //@line 1420
 SAFE_HEAP_STORE($22 | 0, 0 | 0, 4);
 $23 = $3; //@line 1422
 $24 = $23 + 72 | 0; //@line 1423
 SAFE_HEAP_STORE($24 | 0, 0 | 0, 4);
 $25 = $4; //@line 1425
 $26 = $3; //@line 1426
 $27 = $26 + 36 | 0; //@line 1427
 SAFE_HEAP_STORE($27 | 0, $25 | 0, 4);
 $28 = $4; //@line 1429
 $29 = $28 + 8 | 0; //@line 1430
 $30 = SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0; //@line 1431
 $31 = $3; //@line 1432
 $32 = $31 + 44 | 0; //@line 1433
 SAFE_HEAP_STORE($32 | 0, $30 | 0, 4);
 $33 = $5; //@line 1435
 $34 = $3; //@line 1436
 $35 = $34 + 40 | 0; //@line 1437
 SAFE_HEAP_STORE($35 | 0, $33 | 0, 4);
 $36 = $5; //@line 1439
 $37 = $36 + 8 | 0; //@line 1440
 $38 = SAFE_HEAP_LOAD($37 | 0, 4, 0) | 0 | 0; //@line 1441
 $39 = $3; //@line 1442
 $40 = $39 + 48 | 0; //@line 1443
 SAFE_HEAP_STORE($40 | 0, $38 | 0, 4);
 $41 = $3; //@line 1445
 $42 = $41 + 52 | 0; //@line 1446
 SAFE_HEAP_STORE($42 | 0, 0 | 0, 4);
 $43 = $3; //@line 1448
 $44 = $43 + 60 | 0; //@line 1449
 SAFE_HEAP_STORE($44 | 0, 0 | 0, 4);
 $45 = $3; //@line 1451
 $46 = $45 + 52 | 0; //@line 1452
 $47 = $46 + 4 | 0; //@line 1453
 SAFE_HEAP_STORE($47 | 0, 0 | 0, 4);
 $48 = $3; //@line 1455
 $49 = $48 + 60 | 0; //@line 1456
 $50 = $49 + 4 | 0; //@line 1457
 SAFE_HEAP_STORE($50 | 0, 0 | 0, 4);
 $51 = $3; //@line 1459
 $52 = $51 + 112 | 0; //@line 1460
 SAFE_HEAP_STORE($52 | 0, 0 | 0, 4);
 $53 = $3; //@line 1462
 $54 = $53 + 116 | 0; //@line 1463
 SAFE_HEAP_STORE($54 | 0, 0 | 0, 4);
 $55 = $3; //@line 1465
 $56 = $55 + 32 | 0; //@line 1466
 SAFE_HEAP_STORE($56 | 0, 0 | 0, 4);
 $57 = $3; //@line 1468
 STACKTOP = sp; //@line 1469
 return $57 | 0; //@line 1469
}
function ___fwritex($0, $1, $2) {
 $0 = $0 | 0; //@line 10860
 $1 = $1 | 0; //@line 10861
 $2 = $2 | 0; //@line 10862
 var $$03846 = 0, $$042 = 0, $$1 = 0, $$139 = 0, $$141 = 0, $$143 = 0, $$pre = 0, $$pre48 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0; //@line 10863
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0; //@line 10864
 var $9 = 0, $or$cond = 0, label = 0, sp = 0; //@line 10865
 sp = STACKTOP; //@line 10866
 $3 = $2 + 16 | 0; //@line 10867
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 10868
 $5 = ($4 | 0) == (0 | 0); //@line 10869
 if ($5) {
  $7 = ___towrite($2) | 0; //@line 10871
  $8 = ($7 | 0) == 0; //@line 10872
  if ($8) {
   $$pre = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 10874
   $12 = $$pre; //@line 10875
   label = 5; //@line 10876
  } else {
   $$1 = 0; //@line 10878
  }
 } else {
  $6 = $4; //@line 10881
  $12 = $6; //@line 10882
  label = 5; //@line 10883
 }
 L5 : do {
  if ((label | 0) == 5) {
   $9 = $2 + 20 | 0; //@line 10887
   $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 10888
   $11 = $12 - $10 | 0; //@line 10889
   $13 = $11 >>> 0 < $1 >>> 0; //@line 10890
   $14 = $10; //@line 10891
   if ($13) {
    $15 = $2 + 36 | 0; //@line 10893
    $16 = SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0; //@line 10894
    $17 = FUNCTION_TABLE_iiii[(SAFE_FT_MASK($16 | 0, 127 | 0) | 0) & 127]($2, $0, $1) | 0; //@line 10895
    $$1 = $17; //@line 10896
    break;
   }
   $18 = $2 + 75 | 0; //@line 10899
   $19 = SAFE_HEAP_LOAD($18 >> 0 | 0, 1, 0) | 0 | 0; //@line 10900
   $20 = $19 << 24 >> 24 < 0; //@line 10901
   $21 = ($1 | 0) == 0; //@line 10902
   $or$cond = $20 | $21; //@line 10903
   L10 : do {
    if ($or$cond) {
     $$139 = 0; //@line 10906
     $$141 = $0; //@line 10906
     $$143 = $1; //@line 10906
     $32 = $14; //@line 10906
    } else {
     $$03846 = $1; //@line 10908
     while (1) {
      $23 = $$03846 + -1 | 0; //@line 10910
      $24 = $0 + $23 | 0; //@line 10911
      $25 = SAFE_HEAP_LOAD($24 >> 0 | 0, 1, 0) | 0 | 0; //@line 10912
      $26 = $25 << 24 >> 24 == 10; //@line 10913
      if ($26) {
       break;
      }
      $22 = ($23 | 0) == 0; //@line 10917
      if ($22) {
       $$139 = 0; //@line 10919
       $$141 = $0; //@line 10919
       $$143 = $1; //@line 10919
       $32 = $14; //@line 10919
       break L10;
      } else {
       $$03846 = $23; //@line 10922
      }
     }
     $27 = $2 + 36 | 0; //@line 10925
     $28 = SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0; //@line 10926
     $29 = FUNCTION_TABLE_iiii[(SAFE_FT_MASK($28 | 0, 127 | 0) | 0) & 127]($2, $0, $$03846) | 0; //@line 10927
     $30 = $29 >>> 0 < $$03846 >>> 0; //@line 10928
     if ($30) {
      $$1 = $29; //@line 10930
      break L5;
     }
     $31 = $0 + $$03846 | 0; //@line 10933
     $$042 = $1 - $$03846 | 0; //@line 10934
     $$pre48 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 10935
     $$139 = $$03846; //@line 10936
     $$141 = $31; //@line 10936
     $$143 = $$042; //@line 10936
     $32 = $$pre48; //@line 10936
    }
   } while (0);
   _memcpy($32 | 0, $$141 | 0, $$143 | 0) | 0; //@line 10939
   $33 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 10940
   $34 = $33 + $$143 | 0; //@line 10941
   SAFE_HEAP_STORE($9 | 0, $34 | 0, 4);
   $35 = $$139 + $$143 | 0; //@line 10943
   $$1 = $35; //@line 10944
  }
 } while (0);
 return $$1 | 0; //@line 10947
}
function _FloodFillComponent($0, $1) {
 $0 = $0 | 0; //@line 3008
 $1 = $1 | 0; //@line 3009
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 3010
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0; //@line 3011
 var $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 3012
 sp = STACKTOP; //@line 3013
 STACKTOP = STACKTOP + 32 | 0; //@line 3014
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 3014
 $vararg_buffer = sp; //@line 3015
 $2 = $0; //@line 3016
 $3 = $1; //@line 3017
 $7 = $3; //@line 3018
 $8 = _cpBodyGetType($7) | 0; //@line 3019
 $9 = ($8 | 0) == 0; //@line 3020
 if (!$9) {
  STACKTOP = sp; //@line 3022
  return;
 }
 $10 = $3; //@line 3024
 $11 = _ComponentRoot($10) | 0; //@line 3025
 $4 = $11; //@line 3026
 $12 = $4; //@line 3027
 $13 = ($12 | 0) == (0 | 0); //@line 3028
 if (!$13) {
  $56 = $4; //@line 3030
  $57 = $2; //@line 3031
  $58 = ($56 | 0) == ($57 | 0); //@line 3032
  if ($58) {
   STACKTOP = sp; //@line 3034
   return;
  } else {
   _cpMessage(8564, 7878, 205, 1, 0, 8583, $vararg_buffer); //@line 3036
   _abort(); //@line 3037
  }
 }
 $14 = $2; //@line 3041
 $15 = $3; //@line 3042
 _ComponentAdd($14, $15); //@line 3043
 $16 = $3; //@line 3044
 $17 = $16 + 216 | 0; //@line 3045
 $18 = SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0; //@line 3046
 $5 = $18; //@line 3047
 while (1) {
  $19 = $5; //@line 3049
  $20 = ($19 | 0) != (0 | 0); //@line 3050
  if (!$20) {
   break;
  }
  $21 = $2; //@line 3054
  $22 = $3; //@line 3055
  $23 = $5; //@line 3056
  $24 = $23 + 44 | 0; //@line 3057
  $25 = SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0; //@line 3058
  $26 = ($22 | 0) == ($25 | 0); //@line 3059
  $27 = $5; //@line 3060
  if ($26) {
   $28 = $27 + 48 | 0; //@line 3062
   $29 = SAFE_HEAP_LOAD($28 | 0, 4, 0) | 0 | 0; //@line 3063
   $32 = $29; //@line 3064
  } else {
   $30 = $27 + 44 | 0; //@line 3066
   $31 = SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0; //@line 3067
   $32 = $31; //@line 3068
  }
  _FloodFillComponent($21, $32); //@line 3070
  $33 = $5; //@line 3071
  $34 = $3; //@line 3072
  $35 = _cpArbiterNext_482($33, $34) | 0; //@line 3073
  $5 = $35; //@line 3074
 }
 $36 = $3; //@line 3076
 $37 = $36 + 220 | 0; //@line 3077
 $38 = SAFE_HEAP_LOAD($37 | 0, 4, 0) | 0 | 0; //@line 3078
 $6 = $38; //@line 3079
 while (1) {
  $39 = $6; //@line 3081
  $40 = ($39 | 0) != (0 | 0); //@line 3082
  if (!$40) {
   break;
  }
  $41 = $2; //@line 3086
  $42 = $3; //@line 3087
  $43 = $6; //@line 3088
  $44 = $43 + 8 | 0; //@line 3089
  $45 = SAFE_HEAP_LOAD($44 | 0, 4, 0) | 0 | 0; //@line 3090
  $46 = ($42 | 0) == ($45 | 0); //@line 3091
  $47 = $6; //@line 3092
  if ($46) {
   $48 = $47 + 12 | 0; //@line 3094
   $49 = SAFE_HEAP_LOAD($48 | 0, 4, 0) | 0 | 0; //@line 3095
   $52 = $49; //@line 3096
  } else {
   $50 = $47 + 8 | 0; //@line 3098
   $51 = SAFE_HEAP_LOAD($50 | 0, 4, 0) | 0 | 0; //@line 3099
   $52 = $51; //@line 3100
  }
  _FloodFillComponent($41, $52); //@line 3102
  $53 = $6; //@line 3103
  $54 = $3; //@line 3104
  $55 = _cpConstraintNext_483($53, $54) | 0; //@line 3105
  $6 = $55; //@line 3106
 }
 STACKTOP = sp; //@line 3108
 return;
}
function _NodeNew($0, $1, $2) {
 $0 = $0 | 0; //@line 4867
 $1 = $1 | 0; //@line 4868
 $2 = $2 | 0; //@line 4869
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0; //@line 4870
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 4871
 sp = STACKTOP; //@line 4872
 STACKTOP = STACKTOP + 112 | 0; //@line 4873
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 4873
 $$byval_copy1 = sp + 64 | 0; //@line 4874
 $$byval_copy = sp + 32 | 0; //@line 4875
 $7 = sp; //@line 4876
 $3 = $0; //@line 4877
 $4 = $1; //@line 4878
 $5 = $2; //@line 4879
 $8 = $3; //@line 4880
 $9 = _NodeFromPool($8) | 0; //@line 4881
 $6 = $9; //@line 4882
 $10 = $6; //@line 4883
 SAFE_HEAP_STORE($10 | 0, 0 | 0, 4);
 $11 = $6; //@line 4885
 $12 = $11 + 8 | 0; //@line 4886
 $13 = $4; //@line 4887
 $14 = $13 + 8 | 0; //@line 4888
 $15 = $5; //@line 4889
 $16 = $15 + 8 | 0; //@line 4890
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 16 | 0, SAFE_HEAP_LOAD($14 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 20 | 0, SAFE_HEAP_LOAD($14 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 24 | 0, SAFE_HEAP_LOAD($14 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 28 | 0, SAFE_HEAP_LOAD($14 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($16 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($16 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($16 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 16 | 0, SAFE_HEAP_LOAD($16 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 20 | 0, SAFE_HEAP_LOAD($16 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 24 | 0, SAFE_HEAP_LOAD($16 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 28 | 0, SAFE_HEAP_LOAD($16 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpBBMerge($7, $$byval_copy, $$byval_copy1); //@line 4893
 SAFE_HEAP_STORE($12 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 16 | 0, SAFE_HEAP_LOAD($7 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 20 | 0, SAFE_HEAP_LOAD($7 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 24 | 0, SAFE_HEAP_LOAD($7 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 28 | 0, SAFE_HEAP_LOAD($7 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 $17 = $6; //@line 4895
 $18 = $17 + 40 | 0; //@line 4896
 SAFE_HEAP_STORE($18 | 0, 0 | 0, 4);
 $19 = $6; //@line 4898
 $20 = $4; //@line 4899
 _NodeSetA($19, $20); //@line 4900
 $21 = $6; //@line 4901
 $22 = $5; //@line 4902
 _NodeSetB($21, $22); //@line 4903
 $23 = $6; //@line 4904
 STACKTOP = sp; //@line 4905
 return $23 | 0; //@line 4905
}
function _SegmentSupportPoint($0, $1, $2) {
 $0 = $0 | 0; //@line 1773
 $1 = $1 | 0; //@line 1774
 $2 = $2 | 0; //@line 1775
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0, $9 = 0.0, label = 0, sp = 0; //@line 1776
 sp = STACKTOP; //@line 1777
 STACKTOP = STACKTOP + 112 | 0; //@line 1778
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 1778
 $$byval_copy5 = sp + 80 | 0; //@line 1779
 $$byval_copy4 = sp + 64 | 0; //@line 1780
 $$byval_copy3 = sp + 48 | 0; //@line 1781
 $$byval_copy2 = sp + 32 | 0; //@line 1782
 $$byval_copy1 = sp + 16 | 0; //@line 1783
 $$byval_copy = sp; //@line 1784
 $3 = $1; //@line 1785
 $4 = $3; //@line 1786
 $5 = $4 + 208 | 0; //@line 1787
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $6 = +_cpvdot_68($$byval_copy, $$byval_copy1); //@line 1790
 $7 = $3; //@line 1791
 $8 = $7 + 224 | 0; //@line 1792
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $9 = +_cpvdot_68($$byval_copy2, $$byval_copy3); //@line 1795
 $10 = $6 > $9; //@line 1796
 $11 = $3; //@line 1797
 if ($10) {
  $12 = $11 + 208 | 0; //@line 1799
  SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($12 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($12 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($12 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _SupportPointNew($0, $$byval_copy4, 0); //@line 1801
  STACKTOP = sp; //@line 1802
  return;
 } else {
  $13 = $11 + 224 | 0; //@line 1804
  SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($13 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($13 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($13 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _SupportPointNew($0, $$byval_copy5, 1); //@line 1806
  STACKTOP = sp; //@line 1807
  return;
 }
}
function _memcpy(dest, src, num) {
 dest = dest | 0; //@line 1
 src = src | 0; //@line 1
 num = num | 0; //@line 1
 var ret = 0; //@line 2
 var aligned_dest_end = 0; //@line 3
 var block_aligned_dest_end = 0; //@line 4
 var dest_end = 0; //@line 5
 if ((num | 0) >= 8192) {
  return _emscripten_memcpy_big(dest | 0, src | 0, num | 0) | 0; //@line 10
 }
 ret = dest | 0; //@line 13
 dest_end = dest + num | 0; //@line 14
 if ((dest & 3) == (src & 3)) {
  while (dest & 3) {
   if ((num | 0) == 0) return ret | 0; //@line 18
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 1, 0) | 0 | 0, 1); //@line 19
   dest = dest + 1 | 0; //@line 20
   src = src + 1 | 0; //@line 21
   num = num - 1 | 0; //@line 22
  }
  aligned_dest_end = dest_end & -4 | 0; //@line 24
  block_aligned_dest_end = aligned_dest_end - 64 | 0; //@line 25
  while ((dest | 0) <= (block_aligned_dest_end | 0)) {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0, 4); //@line 27
   SAFE_HEAP_STORE(dest + 4 | 0, SAFE_HEAP_LOAD(src + 4 | 0, 4, 0) | 0 | 0, 4); //@line 28
   SAFE_HEAP_STORE(dest + 8 | 0, SAFE_HEAP_LOAD(src + 8 | 0, 4, 0) | 0 | 0, 4); //@line 29
   SAFE_HEAP_STORE(dest + 12 | 0, SAFE_HEAP_LOAD(src + 12 | 0, 4, 0) | 0 | 0, 4); //@line 30
   SAFE_HEAP_STORE(dest + 16 | 0, SAFE_HEAP_LOAD(src + 16 | 0, 4, 0) | 0 | 0, 4); //@line 31
   SAFE_HEAP_STORE(dest + 20 | 0, SAFE_HEAP_LOAD(src + 20 | 0, 4, 0) | 0 | 0, 4); //@line 32
   SAFE_HEAP_STORE(dest + 24 | 0, SAFE_HEAP_LOAD(src + 24 | 0, 4, 0) | 0 | 0, 4); //@line 33
   SAFE_HEAP_STORE(dest + 28 | 0, SAFE_HEAP_LOAD(src + 28 | 0, 4, 0) | 0 | 0, 4); //@line 34
   SAFE_HEAP_STORE(dest + 32 | 0, SAFE_HEAP_LOAD(src + 32 | 0, 4, 0) | 0 | 0, 4); //@line 35
   SAFE_HEAP_STORE(dest + 36 | 0, SAFE_HEAP_LOAD(src + 36 | 0, 4, 0) | 0 | 0, 4); //@line 36
   SAFE_HEAP_STORE(dest + 40 | 0, SAFE_HEAP_LOAD(src + 40 | 0, 4, 0) | 0 | 0, 4); //@line 37
   SAFE_HEAP_STORE(dest + 44 | 0, SAFE_HEAP_LOAD(src + 44 | 0, 4, 0) | 0 | 0, 4); //@line 38
   SAFE_HEAP_STORE(dest + 48 | 0, SAFE_HEAP_LOAD(src + 48 | 0, 4, 0) | 0 | 0, 4); //@line 39
   SAFE_HEAP_STORE(dest + 52 | 0, SAFE_HEAP_LOAD(src + 52 | 0, 4, 0) | 0 | 0, 4); //@line 40
   SAFE_HEAP_STORE(dest + 56 | 0, SAFE_HEAP_LOAD(src + 56 | 0, 4, 0) | 0 | 0, 4); //@line 41
   SAFE_HEAP_STORE(dest + 60 | 0, SAFE_HEAP_LOAD(src + 60 | 0, 4, 0) | 0 | 0, 4); //@line 42
   dest = dest + 64 | 0; //@line 43
   src = src + 64 | 0; //@line 44
  }
  while ((dest | 0) < (aligned_dest_end | 0)) {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0, 4); //@line 47
   dest = dest + 4 | 0; //@line 48
   src = src + 4 | 0; //@line 49
  }
 } else {
  aligned_dest_end = dest_end - 4 | 0; //@line 53
  while ((dest | 0) < (aligned_dest_end | 0)) {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 1, 0) | 0 | 0, 1); //@line 55
   SAFE_HEAP_STORE(dest + 1 | 0, SAFE_HEAP_LOAD(src + 1 | 0, 1, 0) | 0 | 0, 1); //@line 56
   SAFE_HEAP_STORE(dest + 2 | 0, SAFE_HEAP_LOAD(src + 2 | 0, 1, 0) | 0 | 0, 1); //@line 57
   SAFE_HEAP_STORE(dest + 3 | 0, SAFE_HEAP_LOAD(src + 3 | 0, 1, 0) | 0 | 0, 1); //@line 58
   dest = dest + 4 | 0; //@line 59
   src = src + 4 | 0; //@line 60
  }
 }
 while ((dest | 0) < (dest_end | 0)) {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 1, 0) | 0 | 0, 1); //@line 65
  dest = dest + 1 | 0; //@line 66
  src = src + 1 | 0; //@line 67
 }
 return ret | 0; //@line 69
}
function _cpBodyApplyImpulseAtWorldPoint($0, $1, $2) {
 $0 = $0 | 0; //@line 7479
 $1 = $1 | 0; //@line 7480
 $2 = $2 | 0; //@line 7481
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $10 = 0, $11 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 7482
 sp = STACKTOP; //@line 7483
 STACKTOP = STACKTOP + 176 | 0; //@line 7484
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(176 | 0); //@line 7484
 $$byval_copy5 = sp + 144 | 0; //@line 7485
 $$byval_copy4 = sp + 128 | 0; //@line 7486
 $$byval_copy3 = sp + 112 | 0; //@line 7487
 $$byval_copy2 = sp + 96 | 0; //@line 7488
 $$byval_copy1 = sp + 80 | 0; //@line 7489
 $$byval_copy = sp + 32 | 0; //@line 7490
 $4 = sp + 16 | 0; //@line 7491
 $5 = sp; //@line 7492
 $3 = $0; //@line 7493
 $6 = $3; //@line 7494
 _cpBodyActivate($6); //@line 7495
 $7 = $3; //@line 7496
 $8 = $7 + 128 | 0; //@line 7497
 $9 = $3; //@line 7498
 $10 = $9 + 40 | 0; //@line 7499
 dest = $$byval_copy; //@line 7500
 src = $8; //@line 7500
 stop = dest + 48 | 0; //@line 7500
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 7500
  src = src + 4 | 0; //@line 7500
 } while ((dest | 0) < (stop | 0));
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpTransformPoint($5, $$byval_copy, $$byval_copy1); //@line 7502
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_49($4, $$byval_copy2, $$byval_copy3); //@line 7505
 $11 = $3; //@line 7506
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _apply_impulse_53($11, $$byval_copy4, $$byval_copy5); //@line 7509
 STACKTOP = sp; //@line 7510
 return;
}
function _cpMomentForSegment($0, $1, $2, $3) {
 $0 = +$0; //@line 244
 $1 = $1 | 0; //@line 245
 $2 = $2 | 0; //@line 246
 $3 = +$3; //@line 247
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $10 = 0.0, $11 = 0.0, $12 = 0.0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0.0, $19 = 0.0, $20 = 0.0, $21 = 0.0, $22 = 0.0, $23 = 0.0, $24 = 0.0; //@line 248
 var $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 250
 STACKTOP = STACKTOP + 128 | 0; //@line 251
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(128 | 0); //@line 251
 $$byval_copy4 = sp + 104 | 0; //@line 252
 $$byval_copy3 = sp + 88 | 0; //@line 253
 $$byval_copy2 = sp + 72 | 0; //@line 254
 $$byval_copy1 = sp + 56 | 0; //@line 255
 $$byval_copy = sp + 40 | 0; //@line 256
 $6 = sp + 8 | 0; //@line 257
 $4 = $0; //@line 258
 $5 = $3; //@line 259
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvlerp($6, $$byval_copy, $$byval_copy1, .5); //@line 262
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $8 = +_cpvdist($$byval_copy2, $$byval_copy3); //@line 265
 $9 = $5; //@line 266
 $10 = 2.0 * $9; //@line 267
 $11 = $8 + $10; //@line 268
 $7 = $11; //@line 269
 $12 = $4; //@line 270
 $13 = $7; //@line 271
 $14 = $7; //@line 272
 $15 = $13 * $14; //@line 273
 $16 = $5; //@line 274
 $17 = 4.0 * $16; //@line 275
 $18 = $5; //@line 276
 $19 = $17 * $18; //@line 277
 $20 = $15 + $19; //@line 278
 $21 = $20 / 12.0; //@line 279
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $22 = +_cpvlengthsq($$byval_copy4); //@line 281
 $23 = $21 + $22; //@line 282
 $24 = $12 * $23; //@line 283
 STACKTOP = sp; //@line 284
 return +$24;
}
function _cpHashSetRemove($0, $1, $2) {
 $0 = $0 | 0; //@line 2588
 $1 = $1 | 0; //@line 2589
 $2 = $2 | 0; //@line 2590
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0; //@line 2591
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0; //@line 2592
 var $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2593
 sp = STACKTOP; //@line 2594
 STACKTOP = STACKTOP + 32 | 0; //@line 2595
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 2595
 $4 = $0; //@line 2596
 $5 = $1; //@line 2597
 $6 = $2; //@line 2598
 $11 = $5; //@line 2599
 $12 = $4; //@line 2600
 $13 = $12 + 4 | 0; //@line 2601
 $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 2602
 $15 = ($11 >>> 0) % ($14 >>> 0) & -1; //@line 2603
 $7 = $15; //@line 2604
 $16 = $4; //@line 2605
 $17 = $16 + 16 | 0; //@line 2606
 $18 = SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0; //@line 2607
 $19 = $7; //@line 2608
 $20 = $18 + ($19 << 2) | 0; //@line 2609
 $8 = $20; //@line 2610
 $21 = $4; //@line 2611
 $22 = $21 + 16 | 0; //@line 2612
 $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 2613
 $24 = $7; //@line 2614
 $25 = $23 + ($24 << 2) | 0; //@line 2615
 $26 = SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0; //@line 2616
 $9 = $26; //@line 2617
 while (1) {
  $27 = $9; //@line 2619
  $28 = ($27 | 0) != (0 | 0); //@line 2620
  if ($28) {
   $29 = $4; //@line 2622
   $30 = $29 + 8 | 0; //@line 2623
   $31 = SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0; //@line 2624
   $32 = $6; //@line 2625
   $33 = $9; //@line 2626
   $34 = SAFE_HEAP_LOAD($33 | 0, 4, 0) | 0 | 0; //@line 2627
   $35 = FUNCTION_TABLE_iii[(SAFE_FT_MASK($31 | 0, 127 | 0) | 0) & 127]($32, $34) | 0; //@line 2628
   $36 = $35 << 24 >> 24 != 0; //@line 2629
   $37 = $36 ^ 1; //@line 2630
   $57 = $37; //@line 2631
  } else {
   $57 = 0; //@line 2633
  }
  $38 = $9; //@line 2635
  if (!$57) {
   break;
  }
  $39 = $38 + 8 | 0; //@line 2639
  $8 = $39; //@line 2640
  $40 = $9; //@line 2641
  $41 = $40 + 8 | 0; //@line 2642
  $42 = SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0; //@line 2643
  $9 = $42; //@line 2644
 }
 $43 = ($38 | 0) != (0 | 0); //@line 2646
 if ($43) {
  $44 = $9; //@line 2648
  $45 = $44 + 8 | 0; //@line 2649
  $46 = SAFE_HEAP_LOAD($45 | 0, 4, 0) | 0 | 0; //@line 2650
  $47 = $8; //@line 2651
  SAFE_HEAP_STORE($47 | 0, $46 | 0, 4);
  $48 = $4; //@line 2653
  $49 = SAFE_HEAP_LOAD($48 | 0, 4, 0) | 0 | 0; //@line 2654
  $50 = $49 + -1 | 0; //@line 2655
  SAFE_HEAP_STORE($48 | 0, $50 | 0, 4);
  $51 = $9; //@line 2657
  $52 = SAFE_HEAP_LOAD($51 | 0, 4, 0) | 0 | 0; //@line 2658
  $10 = $52; //@line 2659
  $53 = $4; //@line 2660
  $54 = $9; //@line 2661
  _recycleBin($53, $54); //@line 2662
  $55 = $10; //@line 2663
  $3 = $55; //@line 2664
  $56 = $3; //@line 2665
  STACKTOP = sp; //@line 2666
  return $56 | 0; //@line 2666
 } else {
  $3 = 0; //@line 2668
  $56 = $3; //@line 2669
  STACKTOP = sp; //@line 2670
  return $56 | 0; //@line 2670
 }
 return 0 | 0; //@line 2672
}
function _cpCollide($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 7641
 $1 = $1 | 0; //@line 7642
 $2 = $2 | 0; //@line 7643
 $3 = $3 | 0; //@line 7644
 $4 = $4 | 0; //@line 7645
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0; //@line 7646
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $40 = 0, $41 = 0, $42 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0; //@line 7647
 var sp = 0, src = 0, stop = 0; //@line 7648
 sp = STACKTOP; //@line 7649
 STACKTOP = STACKTOP + 64 | 0; //@line 7650
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 7650
 $9 = sp; //@line 7651
 $5 = $1; //@line 7652
 $6 = $2; //@line 7653
 $7 = $3; //@line 7654
 $8 = $4; //@line 7655
 $10 = $5; //@line 7656
 SAFE_HEAP_STORE($9 | 0, $10 | 0, 4);
 $11 = $9 + 4 | 0; //@line 7658
 $12 = $6; //@line 7659
 SAFE_HEAP_STORE($11 | 0, $12 | 0, 4);
 $13 = $9 + 8 | 0; //@line 7661
 $14 = $7; //@line 7662
 SAFE_HEAP_STORE($13 | 0, $14 | 0, 4);
 $15 = $9 + 16 | 0; //@line 7664
 SAFE_HEAP_STORE($15 | 0, SAFE_HEAP_LOAD(11232 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($15 + 4 | 0, SAFE_HEAP_LOAD(11232 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($15 + 8 | 0, SAFE_HEAP_LOAD(11232 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($15 + 12 | 0, SAFE_HEAP_LOAD(11232 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $16 = $9 + 32 | 0; //@line 7666
 SAFE_HEAP_STORE($16 | 0, 0 | 0, 4);
 $17 = $9 + 36 | 0; //@line 7668
 $18 = $8; //@line 7669
 SAFE_HEAP_STORE($17 | 0, $18 | 0, 4);
 $19 = $5; //@line 7671
 $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 7672
 $21 = SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0; //@line 7673
 $22 = $6; //@line 7674
 $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 7675
 $24 = SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0; //@line 7676
 $25 = $21 >>> 0 > $24 >>> 0; //@line 7677
 if ($25) {
  $26 = $6; //@line 7679
  SAFE_HEAP_STORE($9 | 0, $26 | 0, 4);
  $27 = $5; //@line 7681
  $28 = $9 + 4 | 0; //@line 7682
  SAFE_HEAP_STORE($28 | 0, $27 | 0, 4);
 }
 $29 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 7685
 $30 = SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0; //@line 7686
 $31 = SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0; //@line 7687
 $32 = $9 + 4 | 0; //@line 7688
 $33 = SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0; //@line 7689
 $34 = SAFE_HEAP_LOAD($33 | 0, 4, 0) | 0 | 0; //@line 7690
 $35 = SAFE_HEAP_LOAD($34 | 0, 4, 0) | 0 | 0; //@line 7691
 $36 = $35 * 3 | 0; //@line 7692
 $37 = $31 + $36 | 0; //@line 7693
 $38 = 16 + ($37 << 2) | 0; //@line 7694
 $39 = SAFE_HEAP_LOAD($38 | 0, 4, 0) | 0 | 0; //@line 7695
 $40 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 7696
 $41 = $9 + 4 | 0; //@line 7697
 $42 = SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0; //@line 7698
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($39 | 0, 127 | 0) | 0) & 127]($40, $42, $9); //@line 7699
 dest = $0; //@line 7700
 src = $9; //@line 7700
 stop = dest + 40 | 0; //@line 7700
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 7700
  src = src + 4 | 0; //@line 7700
 } while ((dest | 0) < (stop | 0));
 STACKTOP = sp; //@line 7701
 return;
}
function _cpCheckAxis($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 5056
 $1 = $1 | 0; //@line 5057
 $2 = $2 | 0; //@line 5058
 $3 = $3 | 0; //@line 5059
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $10 = 0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5060
 sp = STACKTOP; //@line 5061
 STACKTOP = STACKTOP + 96 | 0; //@line 5062
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(96 | 0); //@line 5062
 $$byval_copy5 = sp + 80 | 0; //@line 5063
 $$byval_copy4 = sp + 64 | 0; //@line 5064
 $$byval_copy3 = sp + 48 | 0; //@line 5065
 $$byval_copy2 = sp + 32 | 0; //@line 5066
 $$byval_copy1 = sp + 16 | 0; //@line 5067
 $$byval_copy = sp; //@line 5068
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $4 = +_cpvdot_328($$byval_copy, $$byval_copy1); //@line 5071
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $5 = +_cpvdot_328($$byval_copy2, $$byval_copy3); //@line 5074
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $6 = +_cpvdot_328($$byval_copy4, $$byval_copy5); //@line 5077
 $7 = +_cpfmax_329($5, $6); //@line 5078
 $8 = $4 <= $7; //@line 5079
 $9 = $8 & 1; //@line 5080
 $10 = $9 & 255; //@line 5081
 STACKTOP = sp; //@line 5082
 return $10 | 0; //@line 5082
}
function _cpBodyApplyImpulseAtLocalPoint($0, $1, $2) {
 $0 = $0 | 0; //@line 7556
 $1 = $1 | 0; //@line 7557
 $2 = $2 | 0; //@line 7558
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $10 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 7559
 sp = STACKTOP; //@line 7560
 STACKTOP = STACKTOP + 208 | 0; //@line 7561
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(208 | 0); //@line 7561
 $$byval_copy5 = sp + 176 | 0; //@line 7562
 $$byval_copy4 = sp + 160 | 0; //@line 7563
 $$byval_copy3 = sp + 144 | 0; //@line 7564
 $$byval_copy2 = sp + 96 | 0; //@line 7565
 $$byval_copy1 = sp + 80 | 0; //@line 7566
 $$byval_copy = sp + 32 | 0; //@line 7567
 $4 = sp + 16 | 0; //@line 7568
 $5 = sp; //@line 7569
 $3 = $0; //@line 7570
 $6 = $3; //@line 7571
 $7 = $3; //@line 7572
 $8 = $7 + 128 | 0; //@line 7573
 dest = $$byval_copy; //@line 7574
 src = $8; //@line 7574
 stop = dest + 48 | 0; //@line 7574
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 7574
  src = src + 4 | 0; //@line 7574
 } while ((dest | 0) < (stop | 0));
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpTransformVect($4, $$byval_copy, $$byval_copy1); //@line 7576
 $9 = $3; //@line 7577
 $10 = $9 + 128 | 0; //@line 7578
 dest = $$byval_copy2; //@line 7579
 src = $10; //@line 7579
 stop = dest + 48 | 0; //@line 7579
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 7579
  src = src + 4 | 0; //@line 7579
 } while ((dest | 0) < (stop | 0));
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpTransformPoint($5, $$byval_copy2, $$byval_copy3); //@line 7581
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpBodyApplyImpulseAtWorldPoint($6, $$byval_copy4, $$byval_copy5); //@line 7584
 STACKTOP = sp; //@line 7585
 return;
}
function _cpBodyApplyForceAtLocalPoint($0, $1, $2) {
 $0 = $0 | 0; //@line 7447
 $1 = $1 | 0; //@line 7448
 $2 = $2 | 0; //@line 7449
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $$byval_copy5 = 0, $10 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 7450
 sp = STACKTOP; //@line 7451
 STACKTOP = STACKTOP + 208 | 0; //@line 7452
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(208 | 0); //@line 7452
 $$byval_copy5 = sp + 176 | 0; //@line 7453
 $$byval_copy4 = sp + 160 | 0; //@line 7454
 $$byval_copy3 = sp + 144 | 0; //@line 7455
 $$byval_copy2 = sp + 96 | 0; //@line 7456
 $$byval_copy1 = sp + 80 | 0; //@line 7457
 $$byval_copy = sp + 32 | 0; //@line 7458
 $4 = sp + 16 | 0; //@line 7459
 $5 = sp; //@line 7460
 $3 = $0; //@line 7461
 $6 = $3; //@line 7462
 $7 = $3; //@line 7463
 $8 = $7 + 128 | 0; //@line 7464
 dest = $$byval_copy; //@line 7465
 src = $8; //@line 7465
 stop = dest + 48 | 0; //@line 7465
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 7465
  src = src + 4 | 0; //@line 7465
 } while ((dest | 0) < (stop | 0));
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpTransformVect($4, $$byval_copy, $$byval_copy1); //@line 7467
 $9 = $3; //@line 7468
 $10 = $9 + 128 | 0; //@line 7469
 dest = $$byval_copy2; //@line 7470
 src = $10; //@line 7470
 stop = dest + 48 | 0; //@line 7470
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 7470
  src = src + 4 | 0; //@line 7470
 } while ((dest | 0) < (stop | 0));
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpTransformPoint($5, $$byval_copy2, $$byval_copy3); //@line 7472
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy5 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpBodyApplyForceAtWorldPoint($6, $$byval_copy4, $$byval_copy5); //@line 7475
 STACKTOP = sp; //@line 7476
 return;
}
function _applyCachedImpulse_395($0, $1) {
 $0 = $0 | 0; //@line 7481
 $1 = +$1; //@line 7482
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0.0, $18 = 0.0, $19 = 0.0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0; //@line 7483
 var $25 = 0, $3 = 0.0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 7484
 sp = STACKTOP; //@line 7485
 STACKTOP = STACKTOP + 112 | 0; //@line 7486
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 7486
 $$byval_copy3 = sp + 72 | 0; //@line 7487
 $$byval_copy2 = sp + 56 | 0; //@line 7488
 $$byval_copy1 = sp + 40 | 0; //@line 7489
 $$byval_copy = sp + 24 | 0; //@line 7490
 $6 = sp; //@line 7491
 $2 = $0; //@line 7492
 $3 = $1; //@line 7493
 $7 = $2; //@line 7494
 $8 = $7 + 8 | 0; //@line 7495
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 7496
 $4 = $9; //@line 7497
 $10 = $2; //@line 7498
 $11 = $10 + 12 | 0; //@line 7499
 $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 7500
 $5 = $12; //@line 7501
 $13 = $2; //@line 7502
 $14 = $13 + 144 | 0; //@line 7503
 $15 = $2; //@line 7504
 $16 = $15 + 168 | 0; //@line 7505
 $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 7506
 $18 = $3; //@line 7507
 $19 = $17 * $18; //@line 7508
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($14 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($14 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($14 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_404($6, $$byval_copy, $19); //@line 7510
 $20 = $4; //@line 7511
 $21 = $5; //@line 7512
 $22 = $2; //@line 7513
 $23 = $22 + 112 | 0; //@line 7514
 $24 = $2; //@line 7515
 $25 = $24 + 128 | 0; //@line 7516
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($23 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($23 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($23 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($25 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($25 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($25 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _apply_impulses_405($20, $21, $$byval_copy1, $$byval_copy2, $$byval_copy3); //@line 7520
 STACKTOP = sp; //@line 7521
 return;
}
function _SetTransform($0, $1, $2) {
 $0 = $0 | 0; //@line 5932
 $1 = $1 | 0; //@line 5933
 $2 = +$2; //@line 5934
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0.0, $19 = 0.0, $20 = 0.0, $21 = 0, $22 = 0.0, $23 = 0, $24 = 0.0, $25 = 0.0, $26 = 0.0, $27 = 0.0, $28 = 0, $29 = 0.0; //@line 5935
 var $3 = 0, $30 = 0.0, $31 = 0, $32 = 0.0, $33 = 0.0, $34 = 0, $35 = 0.0, $36 = 0.0, $37 = 0, $38 = 0.0, $39 = 0.0, $4 = 0.0, $40 = 0.0, $41 = 0.0, $42 = 0.0, $5 = 0, $6 = 0, $7 = 0, $8 = 0.0, $9 = 0; //@line 5936
 var dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 5937
 sp = STACKTOP; //@line 5938
 STACKTOP = STACKTOP + 96 | 0; //@line 5939
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(96 | 0); //@line 5939
 $5 = sp + 64 | 0; //@line 5940
 $6 = sp + 48 | 0; //@line 5941
 $7 = sp; //@line 5942
 $3 = $0; //@line 5943
 $4 = $2; //@line 5944
 $8 = $4; //@line 5945
 _cpvforangle($5, $8); //@line 5946
 $9 = $3; //@line 5947
 $10 = $9 + 40 | 0; //@line 5948
 SAFE_HEAP_STORE($6 | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $11 = $3; //@line 5950
 $12 = $11 + 128 | 0; //@line 5951
 $13 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 5952
 $14 = $5 + 8 | 0; //@line 5953
 $15 = +(+SAFE_HEAP_LOAD_D($14 | 0, 8)); //@line 5954
 $16 = -$15; //@line 5955
 $17 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 5956
 $18 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 5957
 $19 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 5958
 $20 = $18 * $19; //@line 5959
 $21 = $6 + 8 | 0; //@line 5960
 $22 = +(+SAFE_HEAP_LOAD_D($21 | 0, 8)); //@line 5961
 $23 = $5 + 8 | 0; //@line 5962
 $24 = +(+SAFE_HEAP_LOAD_D($23 | 0, 8)); //@line 5963
 $25 = $22 * $24; //@line 5964
 $26 = $20 - $25; //@line 5965
 $27 = $17 - $26; //@line 5966
 $28 = $5 + 8 | 0; //@line 5967
 $29 = +(+SAFE_HEAP_LOAD_D($28 | 0, 8)); //@line 5968
 $30 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 5969
 $31 = $1 + 8 | 0; //@line 5970
 $32 = +(+SAFE_HEAP_LOAD_D($31 | 0, 8)); //@line 5971
 $33 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 5972
 $34 = $5 + 8 | 0; //@line 5973
 $35 = +(+SAFE_HEAP_LOAD_D($34 | 0, 8)); //@line 5974
 $36 = $33 * $35; //@line 5975
 $37 = $6 + 8 | 0; //@line 5976
 $38 = +(+SAFE_HEAP_LOAD_D($37 | 0, 8)); //@line 5977
 $39 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 5978
 $40 = $38 * $39; //@line 5979
 $41 = $36 + $40; //@line 5980
 $42 = $32 - $41; //@line 5981
 _cpTransformNewTranspose($7, $13, $16, $27, $29, $30, $42); //@line 5982
 dest = $12; //@line 5983
 src = $7; //@line 5983
 stop = dest + 48 | 0; //@line 5983
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 5983
  src = src + 4 | 0; //@line 5983
 } while ((dest | 0) < (stop | 0));
 STACKTOP = sp; //@line 5984
 return;
}
function _cpSpaceRemoveShape($0, $1) {
 $0 = $0 | 0; //@line 1639
 $1 = $1 | 0; //@line 1640
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 1641
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0; //@line 1642
 var $47 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0; //@line 1643
 sp = STACKTOP; //@line 1644
 STACKTOP = STACKTOP + 32 | 0; //@line 1645
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 1645
 $vararg_buffer1 = sp + 8 | 0; //@line 1646
 $vararg_buffer = sp; //@line 1647
 $2 = $0; //@line 1648
 $3 = $1; //@line 1649
 $6 = $3; //@line 1650
 $7 = $6 + 8 | 0; //@line 1651
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 1652
 $4 = $8; //@line 1653
 $9 = $2; //@line 1654
 $10 = $3; //@line 1655
 $11 = _cpSpaceContainsShape($9, $10) | 0; //@line 1656
 $12 = $11 << 24 >> 24 != 0; //@line 1657
 if (!$12) {
  _cpMessage(7278, 6192, 525, 1, 1, 7313, $vararg_buffer); //@line 1659
  _abort(); //@line 1660
 }
 $13 = $2; //@line 1663
 $14 = $13 + 140 | 0; //@line 1664
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 1665
 $16 = ($15 | 0) != 0; //@line 1666
 if ($16) {
  _cpMessage(6649, 6192, 526, 1, 1, 6664, $vararg_buffer1); //@line 1668
  _abort(); //@line 1669
 }
 $17 = $4; //@line 1672
 $18 = _cpBodyGetType($17) | 0; //@line 1673
 $19 = ($18 | 0) == 2; //@line 1674
 $20 = $19 & 1; //@line 1675
 $21 = $20 & 255; //@line 1676
 $5 = $21; //@line 1677
 $22 = $5; //@line 1678
 $23 = $22 << 24 >> 24 != 0; //@line 1679
 $24 = $4; //@line 1680
 if ($23) {
  $25 = $3; //@line 1682
  _cpBodyActivateStatic($24, $25); //@line 1683
 } else {
  _cpBodyActivate($24); //@line 1685
 }
 $26 = $4; //@line 1687
 $27 = $3; //@line 1688
 _cpBodyRemoveShape($26, $27); //@line 1689
 $28 = $2; //@line 1690
 $29 = $4; //@line 1691
 $30 = $3; //@line 1692
 _cpSpaceFilterArbiters($28, $29, $30); //@line 1693
 $31 = $5; //@line 1694
 $32 = $31 & 255; //@line 1695
 $33 = ($32 | 0) != 0; //@line 1696
 $34 = $2; //@line 1697
 if ($33) {
  $35 = $34 + 108 | 0; //@line 1699
  $36 = SAFE_HEAP_LOAD($35 | 0, 4, 0) | 0 | 0; //@line 1700
  $43 = $36; //@line 1701
 } else {
  $37 = $34 + 112 | 0; //@line 1703
  $38 = SAFE_HEAP_LOAD($37 | 0, 4, 0) | 0 | 0; //@line 1704
  $43 = $38; //@line 1705
 }
 $39 = $3; //@line 1707
 $40 = $3; //@line 1708
 $41 = $40 + 156 | 0; //@line 1709
 $42 = SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0; //@line 1710
 _cpSpatialIndexRemove_466($43, $39, $42); //@line 1711
 $44 = $3; //@line 1712
 $45 = $44 + 4 | 0; //@line 1713
 SAFE_HEAP_STORE($45 | 0, 0 | 0, 4);
 $46 = $3; //@line 1715
 $47 = $46 + 156 | 0; //@line 1716
 SAFE_HEAP_STORE($47 | 0, 0 | 0, 4);
 STACKTOP = sp; //@line 1718
 return;
}
function _fflush($0) {
 $0 = $0 | 0; //@line 11108
 var $$0 = 0, $$023 = 0, $$02325 = 0, $$02327 = 0, $$024$lcssa = 0, $$02426 = 0, $$1 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0; //@line 11109
 var $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $phitmp = 0, label = 0, sp = 0; //@line 11110
 sp = STACKTOP; //@line 11111
 $1 = ($0 | 0) == (0 | 0); //@line 11112
 do {
  if ($1) {
   $8 = SAFE_HEAP_LOAD(749 * 4 | 0, 4, 0) | 0 | 0; //@line 11115
   $9 = ($8 | 0) == (0 | 0); //@line 11116
   if ($9) {
    $29 = 0; //@line 11118
   } else {
    $10 = SAFE_HEAP_LOAD(749 * 4 | 0, 4, 0) | 0 | 0; //@line 11120
    $11 = _fflush($10) | 0; //@line 11121
    $29 = $11; //@line 11122
   }
   $12 = ___ofl_lock() | 0; //@line 11124
   $$02325 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 11125
   $13 = ($$02325 | 0) == (0 | 0); //@line 11126
   if ($13) {
    $$024$lcssa = $29; //@line 11128
   } else {
    $$02327 = $$02325; //@line 11130
    $$02426 = $29; //@line 11130
    while (1) {
     $14 = $$02327 + 76 | 0; //@line 11132
     $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 11133
     $16 = ($15 | 0) > -1; //@line 11134
     if ($16) {
      $17 = ___lockfile($$02327) | 0; //@line 11136
      $26 = $17; //@line 11137
     } else {
      $26 = 0; //@line 11139
     }
     $18 = $$02327 + 20 | 0; //@line 11141
     $19 = SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0; //@line 11142
     $20 = $$02327 + 28 | 0; //@line 11143
     $21 = SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0; //@line 11144
     $22 = $19 >>> 0 > $21 >>> 0; //@line 11145
     if ($22) {
      $23 = ___fflush_unlocked($$02327) | 0; //@line 11147
      $24 = $23 | $$02426; //@line 11148
      $$1 = $24; //@line 11149
     } else {
      $$1 = $$02426; //@line 11151
     }
     $25 = ($26 | 0) == 0; //@line 11153
     if (!$25) {
      ___unlockfile($$02327); //@line 11155
     }
     $27 = $$02327 + 56 | 0; //@line 11157
     $$023 = SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0; //@line 11158
     $28 = ($$023 | 0) == (0 | 0); //@line 11159
     if ($28) {
      $$024$lcssa = $$1; //@line 11161
      break;
     } else {
      $$02327 = $$023; //@line 11164
      $$02426 = $$1; //@line 11164
     }
    }
   }
   ___ofl_unlock(); //@line 11168
   $$0 = $$024$lcssa; //@line 11169
  } else {
   $2 = $0 + 76 | 0; //@line 11171
   $3 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 11172
   $4 = ($3 | 0) > -1; //@line 11173
   if (!$4) {
    $5 = ___fflush_unlocked($0) | 0; //@line 11175
    $$0 = $5; //@line 11176
    break;
   }
   $6 = ___lockfile($0) | 0; //@line 11179
   $phitmp = ($6 | 0) == 0; //@line 11180
   $7 = ___fflush_unlocked($0) | 0; //@line 11181
   if ($phitmp) {
    $$0 = $7; //@line 11183
   } else {
    ___unlockfile($0); //@line 11185
    $$0 = $7; //@line 11186
   }
  }
 } while (0);
 return $$0 | 0; //@line 11190
}
function _cpHashSetResize($0) {
 $0 = $0 | 0; //@line 2486
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0; //@line 2487
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0; //@line 2488
 var $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2489
 sp = STACKTOP; //@line 2490
 STACKTOP = STACKTOP + 32 | 0; //@line 2491
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 2491
 $1 = $0; //@line 2492
 $8 = $1; //@line 2493
 $9 = $8 + 4 | 0; //@line 2494
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 2495
 $11 = $10 + 1 | 0; //@line 2496
 $12 = _next_prime($11) | 0; //@line 2497
 $2 = $12; //@line 2498
 $13 = $2; //@line 2499
 $14 = _calloc($13, 4) | 0; //@line 2500
 $3 = $14; //@line 2501
 $4 = 0; //@line 2502
 while (1) {
  $15 = $4; //@line 2504
  $16 = $1; //@line 2505
  $17 = $16 + 4 | 0; //@line 2506
  $18 = SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0; //@line 2507
  $19 = $15 >>> 0 < $18 >>> 0; //@line 2508
  $20 = $1; //@line 2509
  $21 = $20 + 16 | 0; //@line 2510
  $22 = SAFE_HEAP_LOAD($21 | 0, 4, 0) | 0 | 0; //@line 2511
  if (!$19) {
   break;
  }
  $23 = $4; //@line 2515
  $24 = $22 + ($23 << 2) | 0; //@line 2516
  $25 = SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0; //@line 2517
  $5 = $25; //@line 2518
  while (1) {
   $26 = $5; //@line 2520
   $27 = ($26 | 0) != (0 | 0); //@line 2521
   if (!$27) {
    break;
   }
   $28 = $5; //@line 2525
   $29 = $28 + 8 | 0; //@line 2526
   $30 = SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0; //@line 2527
   $6 = $30; //@line 2528
   $31 = $5; //@line 2529
   $32 = $31 + 4 | 0; //@line 2530
   $33 = SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0; //@line 2531
   $34 = $2; //@line 2532
   $35 = ($33 >>> 0) % ($34 >>> 0) & -1; //@line 2533
   $7 = $35; //@line 2534
   $36 = $3; //@line 2535
   $37 = $7; //@line 2536
   $38 = $36 + ($37 << 2) | 0; //@line 2537
   $39 = SAFE_HEAP_LOAD($38 | 0, 4, 0) | 0 | 0; //@line 2538
   $40 = $5; //@line 2539
   $41 = $40 + 8 | 0; //@line 2540
   SAFE_HEAP_STORE($41 | 0, $39 | 0, 4);
   $42 = $5; //@line 2542
   $43 = $3; //@line 2543
   $44 = $7; //@line 2544
   $45 = $43 + ($44 << 2) | 0; //@line 2545
   SAFE_HEAP_STORE($45 | 0, $42 | 0, 4);
   $46 = $6; //@line 2547
   $5 = $46; //@line 2548
  }
  $47 = $4; //@line 2550
  $48 = $47 + 1 | 0; //@line 2551
  $4 = $48; //@line 2552
 }
 _free($22); //@line 2554
 $49 = $3; //@line 2555
 $50 = $1; //@line 2556
 $51 = $50 + 16 | 0; //@line 2557
 SAFE_HEAP_STORE($51 | 0, $49 | 0, 4);
 $52 = $2; //@line 2559
 $53 = $1; //@line 2560
 $54 = $53 + 4 | 0; //@line 2561
 SAFE_HEAP_STORE($54 | 0, $52 | 0, 4);
 STACKTOP = sp; //@line 2563
 return;
}
function _cpBodyPushArbiter($0, $1) {
 $0 = $0 | 0; //@line 2929
 $1 = $1 | 0; //@line 2930
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 2931
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0; //@line 2932
 var $vararg_buffer1 = 0, $vararg_buffer3 = 0, label = 0, sp = 0; //@line 2933
 sp = STACKTOP; //@line 2934
 STACKTOP = STACKTOP + 32 | 0; //@line 2935
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 2935
 $vararg_buffer3 = sp + 16 | 0; //@line 2936
 $vararg_buffer1 = sp + 8 | 0; //@line 2937
 $vararg_buffer = sp; //@line 2938
 $2 = $0; //@line 2939
 $3 = $1; //@line 2940
 $5 = $3; //@line 2941
 $6 = $2; //@line 2942
 $7 = _cpArbiterThreadForBody_502($5, $6) | 0; //@line 2943
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 2944
 $9 = ($8 | 0) == (0 | 0); //@line 2945
 if (!$9) {
  _cpMessage(8645, 7878, 172, 1, 0, 8693, $vararg_buffer); //@line 2947
  _abort(); //@line 2948
 }
 $10 = $3; //@line 2951
 $11 = $2; //@line 2952
 $12 = _cpArbiterThreadForBody_502($10, $11) | 0; //@line 2953
 $13 = $12 + 4 | 0; //@line 2954
 $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 2955
 $15 = ($14 | 0) == (0 | 0); //@line 2956
 if (!$15) {
  _cpMessage(8755, 7878, 173, 1, 0, 8803, $vararg_buffer1); //@line 2958
  _abort(); //@line 2959
 }
 $16 = $2; //@line 2962
 $17 = $16 + 216 | 0; //@line 2963
 $18 = SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0; //@line 2964
 $4 = $18; //@line 2965
 $19 = $4; //@line 2966
 $20 = ($19 | 0) == (0 | 0); //@line 2967
 if (!$20) {
  $21 = $4; //@line 2969
  $22 = $2; //@line 2970
  $23 = _cpArbiterThreadForBody_502($21, $22) | 0; //@line 2971
  $24 = $23 + 4 | 0; //@line 2972
  $25 = SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0; //@line 2973
  $26 = ($25 | 0) == (0 | 0); //@line 2974
  if (!$26) {
   _cpMessage(8865, 7878, 176, 1, 0, 8930, $vararg_buffer3); //@line 2976
   _abort(); //@line 2977
  }
 }
 $27 = $4; //@line 2981
 $28 = $3; //@line 2982
 $29 = $2; //@line 2983
 $30 = _cpArbiterThreadForBody_502($28, $29) | 0; //@line 2984
 SAFE_HEAP_STORE($30 | 0, $27 | 0, 4);
 $31 = $4; //@line 2986
 $32 = ($31 | 0) != (0 | 0); //@line 2987
 if (!$32) {
  $38 = $3; //@line 2989
  $39 = $2; //@line 2990
  $40 = $39 + 216 | 0; //@line 2991
  SAFE_HEAP_STORE($40 | 0, $38 | 0, 4);
  STACKTOP = sp; //@line 2993
  return;
 }
 $33 = $3; //@line 2995
 $34 = $4; //@line 2996
 $35 = $2; //@line 2997
 $36 = _cpArbiterThreadForBody_502($34, $35) | 0; //@line 2998
 $37 = $36 + 4 | 0; //@line 2999
 SAFE_HEAP_STORE($37 | 0, $33 | 0, 4);
 $38 = $3; //@line 3001
 $39 = $2; //@line 3002
 $40 = $39 + 216 | 0; //@line 3003
 SAFE_HEAP_STORE($40 | 0, $38 | 0, 4);
 STACKTOP = sp; //@line 3005
 return;
}
function _cpShapeInit($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 5117
 $1 = $1 | 0; //@line 5118
 $2 = $2 | 0; //@line 5119
 $3 = $3 | 0; //@line 5120
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0; //@line 5121
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0; //@line 5122
 var src = 0, stop = 0; //@line 5123
 sp = STACKTOP; //@line 5124
 STACKTOP = STACKTOP + 16 | 0; //@line 5125
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5125
 $4 = $0; //@line 5126
 $5 = $1; //@line 5127
 $6 = $2; //@line 5128
 $7 = $5; //@line 5129
 $8 = $4; //@line 5130
 SAFE_HEAP_STORE($8 | 0, $7 | 0, 4);
 $9 = $6; //@line 5132
 $10 = $4; //@line 5133
 $11 = $10 + 8 | 0; //@line 5134
 SAFE_HEAP_STORE($11 | 0, $9 | 0, 4);
 $12 = $4; //@line 5136
 $13 = $12 + 16 | 0; //@line 5137
 dest = $13; //@line 5138
 src = $3; //@line 5138
 stop = dest + 40 | 0; //@line 5138
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 5138
  src = src + 4 | 0; //@line 5138
 } while ((dest | 0) < (stop | 0));
 $14 = $4; //@line 5139
 $15 = $14 + 88 | 0; //@line 5140
 SAFE_HEAP_STORE($15 >> 0 | 0, 0 | 0, 1);
 $16 = $4; //@line 5142
 $17 = $16 + 96 | 0; //@line 5143
 SAFE_HEAP_STORE_D($17 | 0, +0.0, 8);
 $18 = $4; //@line 5145
 $19 = $18 + 104 | 0; //@line 5146
 SAFE_HEAP_STORE_D($19 | 0, +0.0, 8);
 $20 = $4; //@line 5148
 $21 = $20 + 112 | 0; //@line 5149
 SAFE_HEAP_STORE($21 | 0, SAFE_HEAP_LOAD(11248 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($21 + 4 | 0, SAFE_HEAP_LOAD(11248 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($21 + 8 | 0, SAFE_HEAP_LOAD(11248 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($21 + 12 | 0, SAFE_HEAP_LOAD(11248 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $22 = $4; //@line 5151
 $23 = $22 + 132 | 0; //@line 5152
 SAFE_HEAP_STORE($23 | 0, 0 | 0, 4);
 $24 = $4; //@line 5154
 $25 = $24 + 136 | 0; //@line 5155
 SAFE_HEAP_STORE($25 | 0, 0 | 0, 4);
 $26 = $4; //@line 5157
 $27 = $26 + 136 | 0; //@line 5158
 $28 = $27 + 4 | 0; //@line 5159
 SAFE_HEAP_STORE($28 | 0, -1 | 0, 4);
 $29 = $4; //@line 5161
 $30 = $29 + 136 | 0; //@line 5162
 $31 = $30 + 8 | 0; //@line 5163
 SAFE_HEAP_STORE($31 | 0, -1 | 0, 4);
 $32 = $4; //@line 5165
 $33 = $32 + 128 | 0; //@line 5166
 SAFE_HEAP_STORE($33 | 0, 0 | 0, 4);
 $34 = $4; //@line 5168
 $35 = $34 + 4 | 0; //@line 5169
 SAFE_HEAP_STORE($35 | 0, 0 | 0, 4);
 $36 = $4; //@line 5171
 $37 = $36 + 148 | 0; //@line 5172
 SAFE_HEAP_STORE($37 | 0, 0 | 0, 4);
 $38 = $4; //@line 5174
 $39 = $38 + 152 | 0; //@line 5175
 SAFE_HEAP_STORE($39 | 0, 0 | 0, 4);
 $40 = $4; //@line 5177
 STACKTOP = sp; //@line 5178
 return $40 | 0; //@line 5178
}
function _applyCachedImpulse_236($0, $1) {
 $0 = $0 | 0; //@line 3028
 $1 = +$1; //@line 3029
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0.0, $3 = 0.0, $4 = 0, $5 = 0; //@line 3030
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3031
 sp = STACKTOP; //@line 3032
 STACKTOP = STACKTOP + 112 | 0; //@line 3033
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 3033
 $$byval_copy3 = sp + 72 | 0; //@line 3034
 $$byval_copy2 = sp + 56 | 0; //@line 3035
 $$byval_copy1 = sp + 40 | 0; //@line 3036
 $$byval_copy = sp + 24 | 0; //@line 3037
 $6 = sp; //@line 3038
 $2 = $0; //@line 3039
 $3 = $1; //@line 3040
 $7 = $2; //@line 3041
 $8 = $7 + 8 | 0; //@line 3042
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 3043
 $4 = $9; //@line 3044
 $10 = $2; //@line 3045
 $11 = $10 + 12 | 0; //@line 3046
 $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 3047
 $5 = $12; //@line 3048
 $13 = $4; //@line 3049
 $14 = $5; //@line 3050
 $15 = $2; //@line 3051
 $16 = $15 + 96 | 0; //@line 3052
 $17 = $2; //@line 3053
 $18 = $17 + 112 | 0; //@line 3054
 $19 = $2; //@line 3055
 $20 = $19 + 160 | 0; //@line 3056
 $21 = $3; //@line 3057
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($20 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($20 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($20 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_249($6, $$byval_copy, $21); //@line 3059
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($16 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($16 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($16 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($18 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($18 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($18 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _apply_impulses_246($13, $14, $$byval_copy1, $$byval_copy2, $$byval_copy3); //@line 3063
 STACKTOP = sp; //@line 3064
 return;
}
function _cpPolyShapeMassInfo($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 3845
 $1 = +$1; //@line 3846
 $2 = $2 | 0; //@line 3847
 $3 = $3 | 0; //@line 3848
 $4 = +$4; //@line 3849
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0.0, $15 = 0, $16 = 0, $17 = 0, $18 = 0.0, $19 = 0.0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0.0, $25 = 0.0, $5 = 0.0, $6 = 0; //@line 3850
 var $7 = 0, $8 = 0.0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 3851
 sp = STACKTOP; //@line 3852
 STACKTOP = STACKTOP + 128 | 0; //@line 3853
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(128 | 0); //@line 3853
 $$byval_copy1 = sp + 104 | 0; //@line 3854
 $$byval_copy = sp + 88 | 0; //@line 3855
 $9 = sp + 56 | 0; //@line 3856
 $10 = sp + 16 | 0; //@line 3857
 $11 = sp; //@line 3858
 $5 = $1; //@line 3859
 $6 = $2; //@line 3860
 $7 = $3; //@line 3861
 $8 = $4; //@line 3862
 $12 = $6; //@line 3863
 $13 = $7; //@line 3864
 _cpCentroidForPoly($9, $12, $13); //@line 3865
 $14 = $5; //@line 3866
 SAFE_HEAP_STORE_D($10 | 0, +$14, 8);
 $15 = $10 + 8 | 0; //@line 3868
 $16 = $6; //@line 3869
 $17 = $7; //@line 3870
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvneg_284($11, $$byval_copy); //@line 3872
 $18 = $8; //@line 3873
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $19 = +_cpMomentForPoly(1.0, $16, $17, $$byval_copy1, $18); //@line 3875
 SAFE_HEAP_STORE_D($15 | 0, +$19, 8);
 $20 = $10 + 16 | 0; //@line 3877
 SAFE_HEAP_STORE($20 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($20 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($20 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($20 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $21 = $10 + 32 | 0; //@line 3879
 $22 = $6; //@line 3880
 $23 = $7; //@line 3881
 $24 = $8; //@line 3882
 $25 = +_cpAreaForPoly($22, $23, $24); //@line 3883
 SAFE_HEAP_STORE_D($21 | 0, +$25, 8);
 dest = $0; //@line 3885
 src = $10; //@line 3885
 stop = dest + 40 | 0; //@line 3885
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 3885
  src = src + 4 | 0; //@line 3885
 } while ((dest | 0) < (stop | 0));
 STACKTOP = sp; //@line 3886
 return;
}
function _cpCircleShapeSetOffset($0, $1) {
 $0 = $0 | 0; //@line 7192
 $1 = $1 | 0; //@line 7193
 var $$byval_copy = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0.0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0.0, $2 = 0, $20 = 0, $21 = 0, $22 = 0.0, $23 = 0, $24 = 0, $25 = 0.0, $26 = 0, $27 = 0; //@line 7194
 var $28 = 0, $29 = 0, $3 = 0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 7195
 sp = STACKTOP; //@line 7196
 STACKTOP = STACKTOP + 80 | 0; //@line 7197
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(80 | 0); //@line 7197
 $$byval_copy = sp + 56 | 0; //@line 7198
 $vararg_buffer = sp + 48 | 0; //@line 7199
 $5 = sp; //@line 7200
 $2 = $0; //@line 7201
 $6 = $2; //@line 7202
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 7203
 $8 = ($7 | 0) == (2656 | 0); //@line 7204
 if (!$8) {
  _cpMessage(5758, 5494, 568, 1, 1, 5794, $vararg_buffer); //@line 7206
  _abort(); //@line 7207
 }
 $9 = $2; //@line 7210
 $3 = $9; //@line 7211
 $10 = $3; //@line 7212
 $11 = $10 + 160 | 0; //@line 7213
 SAFE_HEAP_STORE($11 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $12 = $2; //@line 7215
 $13 = $12 + 16 | 0; //@line 7216
 $14 = +(+SAFE_HEAP_LOAD_D($13 | 0, 8)); //@line 7217
 $4 = $14; //@line 7218
 $15 = $2; //@line 7219
 $16 = $15 + 16 | 0; //@line 7220
 $17 = $2; //@line 7221
 $18 = $17 + 16 | 0; //@line 7222
 $19 = +(+SAFE_HEAP_LOAD_D($18 | 0, 8)); //@line 7223
 $20 = $3; //@line 7224
 $21 = $20 + 192 | 0; //@line 7225
 $22 = +(+SAFE_HEAP_LOAD_D($21 | 0, 8)); //@line 7226
 $23 = $3; //@line 7227
 $24 = $23 + 160 | 0; //@line 7228
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($24 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($24 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($24 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpCircleShapeMassInfo($5, $19, $22, $$byval_copy); //@line 7230
 dest = $16; //@line 7231
 src = $5; //@line 7231
 stop = dest + 40 | 0; //@line 7231
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 7231
  src = src + 4 | 0; //@line 7231
 } while ((dest | 0) < (stop | 0));
 $25 = $4; //@line 7232
 $26 = $25 > 0.0; //@line 7233
 if (!$26) {
  STACKTOP = sp; //@line 7235
  return;
 }
 $27 = $2; //@line 7237
 $28 = $27 + 8 | 0; //@line 7238
 $29 = SAFE_HEAP_LOAD($28 | 0, 4, 0) | 0 | 0; //@line 7239
 _cpBodyAccumulateMassFromShapes($29); //@line 7240
 STACKTOP = sp; //@line 7241
 return;
}
function _cpBBTreeReindexQuery($0, $1, $2) {
 $0 = $0 | 0; //@line 3208
 $1 = $1 | 0; //@line 3209
 $2 = $2 | 0; //@line 3210
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0; //@line 3211
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0; //@line 3212
 var $48 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0; //@line 3213
 sp = STACKTOP; //@line 3214
 STACKTOP = STACKTOP + 48 | 0; //@line 3215
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 3215
 $8 = sp; //@line 3216
 $3 = $0; //@line 3217
 $4 = $1; //@line 3218
 $5 = $2; //@line 3219
 $9 = $3; //@line 3220
 $10 = $9 + 24 | 0; //@line 3221
 $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 3222
 $12 = ($11 | 0) != (0 | 0); //@line 3223
 if (!$12) {
  STACKTOP = sp; //@line 3225
  return;
 }
 $13 = $3; //@line 3227
 $14 = $13 + 20 | 0; //@line 3228
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 3229
 $16 = $3; //@line 3230
 _cpHashSetEach($15, 52, $16); //@line 3231
 $17 = $3; //@line 3232
 $18 = $17 + 8 | 0; //@line 3233
 $19 = SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0; //@line 3234
 $6 = $19; //@line 3235
 $20 = $6; //@line 3236
 $21 = ($20 | 0) != (0 | 0); //@line 3237
 if ($21) {
  $22 = $6; //@line 3239
  $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 3240
  $24 = _Klass() | 0; //@line 3241
  $25 = ($23 | 0) == ($24 | 0); //@line 3242
  if ($25) {
   $26 = $6; //@line 3244
   $27 = $26 + 24 | 0; //@line 3245
   $28 = SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0; //@line 3246
   $29 = $28; //@line 3247
  } else {
   $29 = 0; //@line 3249
  }
 } else {
  $29 = 0; //@line 3252
 }
 $7 = $29; //@line 3254
 $30 = $3; //@line 3255
 SAFE_HEAP_STORE($8 | 0, $30 | 0, 4);
 $31 = $8 + 4 | 0; //@line 3257
 $32 = $7; //@line 3258
 SAFE_HEAP_STORE($31 | 0, $32 | 0, 4);
 $33 = $8 + 8 | 0; //@line 3260
 $34 = $4; //@line 3261
 SAFE_HEAP_STORE($33 | 0, $34 | 0, 4);
 $35 = $8 + 12 | 0; //@line 3263
 $36 = $5; //@line 3264
 SAFE_HEAP_STORE($35 | 0, $36 | 0, 4);
 $37 = $3; //@line 3266
 $38 = $37 + 24 | 0; //@line 3267
 $39 = SAFE_HEAP_LOAD($38 | 0, 4, 0) | 0 | 0; //@line 3268
 _MarkSubtree($39, $8); //@line 3269
 $40 = $6; //@line 3270
 $41 = ($40 | 0) == (0 | 0); //@line 3271
 $42 = $7; //@line 3272
 $43 = ($42 | 0) != (0 | 0); //@line 3273
 $or$cond = $41 | $43; //@line 3274
 if (!$or$cond) {
  $44 = $3; //@line 3276
  $45 = $6; //@line 3277
  $46 = $4; //@line 3278
  $47 = $5; //@line 3279
  _cpSpatialIndexCollideStatic($44, $45, $46, $47); //@line 3280
 }
 $48 = $3; //@line 3282
 _IncrementStamp($48); //@line 3283
 STACKTOP = sp; //@line 3284
 return;
}
function _apply_impulses_405($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 7788
 $1 = $1 | 0; //@line 7789
 $2 = $2 | 0; //@line 7790
 $3 = $3 | 0; //@line 7791
 $4 = $4 | 0; //@line 7792
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 7793
 sp = STACKTOP; //@line 7794
 STACKTOP = STACKTOP + 112 | 0; //@line 7795
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 7795
 $$byval_copy4 = sp + 80 | 0; //@line 7796
 $$byval_copy3 = sp + 64 | 0; //@line 7797
 $$byval_copy2 = sp + 48 | 0; //@line 7798
 $$byval_copy1 = sp + 32 | 0; //@line 7799
 $$byval_copy = sp + 16 | 0; //@line 7800
 $7 = sp; //@line 7801
 $5 = $0; //@line 7802
 $6 = $1; //@line 7803
 $8 = $5; //@line 7804
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvneg_406($7, $$byval_copy); //@line 7806
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _apply_impulse_407($8, $$byval_copy1, $$byval_copy2); //@line 7809
 $9 = $6; //@line 7810
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _apply_impulse_407($9, $$byval_copy3, $$byval_copy4); //@line 7813
 STACKTOP = sp; //@line 7814
 return;
}
function _apply_impulses_246($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 3360
 $1 = $1 | 0; //@line 3361
 $2 = $2 | 0; //@line 3362
 $3 = $3 | 0; //@line 3363
 $4 = $4 | 0; //@line 3364
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3365
 sp = STACKTOP; //@line 3366
 STACKTOP = STACKTOP + 112 | 0; //@line 3367
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 3367
 $$byval_copy4 = sp + 80 | 0; //@line 3368
 $$byval_copy3 = sp + 64 | 0; //@line 3369
 $$byval_copy2 = sp + 48 | 0; //@line 3370
 $$byval_copy1 = sp + 32 | 0; //@line 3371
 $$byval_copy = sp + 16 | 0; //@line 3372
 $7 = sp; //@line 3373
 $5 = $0; //@line 3374
 $6 = $1; //@line 3375
 $8 = $5; //@line 3376
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvneg_247($7, $$byval_copy); //@line 3378
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _apply_impulse_248($8, $$byval_copy1, $$byval_copy2); //@line 3381
 $9 = $6; //@line 3382
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _apply_impulse_248($9, $$byval_copy3, $$byval_copy4); //@line 3385
 STACKTOP = sp; //@line 3386
 return;
}
function _apply_bias_impulses($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 2595
 $1 = $1 | 0; //@line 2596
 $2 = $2 | 0; //@line 2597
 $3 = $3 | 0; //@line 2598
 $4 = $4 | 0; //@line 2599
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2600
 sp = STACKTOP; //@line 2601
 STACKTOP = STACKTOP + 112 | 0; //@line 2602
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 2602
 $$byval_copy4 = sp + 80 | 0; //@line 2603
 $$byval_copy3 = sp + 64 | 0; //@line 2604
 $$byval_copy2 = sp + 48 | 0; //@line 2605
 $$byval_copy1 = sp + 32 | 0; //@line 2606
 $$byval_copy = sp + 16 | 0; //@line 2607
 $7 = sp; //@line 2608
 $5 = $0; //@line 2609
 $6 = $1; //@line 2610
 $8 = $5; //@line 2611
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvneg($7, $$byval_copy); //@line 2613
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _apply_bias_impulse($8, $$byval_copy1, $$byval_copy2); //@line 2616
 $9 = $6; //@line 2617
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _apply_bias_impulse($9, $$byval_copy3, $$byval_copy4); //@line 2620
 STACKTOP = sp; //@line 2621
 return;
}
function _apply_impulses($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 2231
 $1 = $1 | 0; //@line 2232
 $2 = $2 | 0; //@line 2233
 $3 = $3 | 0; //@line 2234
 $4 = $4 | 0; //@line 2235
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2236
 sp = STACKTOP; //@line 2237
 STACKTOP = STACKTOP + 112 | 0; //@line 2238
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 2238
 $$byval_copy4 = sp + 80 | 0; //@line 2239
 $$byval_copy3 = sp + 64 | 0; //@line 2240
 $$byval_copy2 = sp + 48 | 0; //@line 2241
 $$byval_copy1 = sp + 32 | 0; //@line 2242
 $$byval_copy = sp + 16 | 0; //@line 2243
 $7 = sp; //@line 2244
 $5 = $0; //@line 2245
 $6 = $1; //@line 2246
 $8 = $5; //@line 2247
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvneg($7, $$byval_copy); //@line 2249
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _apply_impulse($8, $$byval_copy1, $$byval_copy2); //@line 2252
 $9 = $6; //@line 2253
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _apply_impulse($9, $$byval_copy3, $$byval_copy4); //@line 2256
 STACKTOP = sp; //@line 2257
 return;
}
function _cpvclamp_245($0, $1, $2) {
 $0 = $0 | 0; //@line 3328
 $1 = $1 | 0; //@line 3329
 $2 = +$2; //@line 3330
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $10 = 0.0, $3 = 0.0, $4 = 0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0, label = 0, sp = 0; //@line 3331
 sp = STACKTOP; //@line 3332
 STACKTOP = STACKTOP + 96 | 0; //@line 3333
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(96 | 0); //@line 3333
 $$byval_copy3 = sp + 72 | 0; //@line 3334
 $$byval_copy2 = sp + 56 | 0; //@line 3335
 $$byval_copy1 = sp + 40 | 0; //@line 3336
 $$byval_copy = sp + 24 | 0; //@line 3337
 $4 = sp; //@line 3338
 $3 = $2; //@line 3339
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $5 = +_cpvdot_240($$byval_copy, $$byval_copy1); //@line 3342
 $6 = $3; //@line 3343
 $7 = $3; //@line 3344
 $8 = $6 * $7; //@line 3345
 $9 = $5 > $8; //@line 3346
 if ($9) {
  SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvnormalize_252($4, $$byval_copy2); //@line 3349
  $10 = $3; //@line 3350
  SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  _cpvmult_249($0, $$byval_copy3, $10); //@line 3352
  STACKTOP = sp; //@line 3353
  return;
 } else {
  SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  STACKTOP = sp; //@line 3356
  return;
 }
}
function _cpHashSetFilter($0, $1, $2) {
 $0 = $0 | 0; //@line 2791
 $1 = $1 | 0; //@line 2792
 $2 = $2 | 0; //@line 2793
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0; //@line 2794
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0; //@line 2795
 var $48 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2796
 sp = STACKTOP; //@line 2797
 STACKTOP = STACKTOP + 32 | 0; //@line 2798
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 2798
 $3 = $0; //@line 2799
 $4 = $1; //@line 2800
 $5 = $2; //@line 2801
 $6 = 0; //@line 2802
 while (1) {
  $10 = $6; //@line 2804
  $11 = $3; //@line 2805
  $12 = $11 + 4 | 0; //@line 2806
  $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 2807
  $14 = $10 >>> 0 < $13 >>> 0; //@line 2808
  if (!$14) {
   break;
  }
  $15 = $3; //@line 2812
  $16 = $15 + 16 | 0; //@line 2813
  $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 2814
  $18 = $6; //@line 2815
  $19 = $17 + ($18 << 2) | 0; //@line 2816
  $7 = $19; //@line 2817
  $20 = $3; //@line 2818
  $21 = $20 + 16 | 0; //@line 2819
  $22 = SAFE_HEAP_LOAD($21 | 0, 4, 0) | 0 | 0; //@line 2820
  $23 = $6; //@line 2821
  $24 = $22 + ($23 << 2) | 0; //@line 2822
  $25 = SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0; //@line 2823
  $8 = $25; //@line 2824
  while (1) {
   $26 = $8; //@line 2826
   $27 = ($26 | 0) != (0 | 0); //@line 2827
   if (!$27) {
    break;
   }
   $28 = $8; //@line 2831
   $29 = $28 + 8 | 0; //@line 2832
   $30 = SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0; //@line 2833
   $9 = $30; //@line 2834
   $31 = $4; //@line 2835
   $32 = $8; //@line 2836
   $33 = SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0; //@line 2837
   $34 = $5; //@line 2838
   $35 = FUNCTION_TABLE_iii[(SAFE_FT_MASK($31 | 0, 127 | 0) | 0) & 127]($33, $34) | 0; //@line 2839
   $36 = $35 << 24 >> 24 != 0; //@line 2840
   if ($36) {
    $37 = $8; //@line 2842
    $38 = $37 + 8 | 0; //@line 2843
    $7 = $38; //@line 2844
   } else {
    $39 = $9; //@line 2846
    $40 = $7; //@line 2847
    SAFE_HEAP_STORE($40 | 0, $39 | 0, 4);
    $41 = $3; //@line 2849
    $42 = SAFE_HEAP_LOAD($41 | 0, 4, 0) | 0 | 0; //@line 2850
    $43 = $42 + -1 | 0; //@line 2851
    SAFE_HEAP_STORE($41 | 0, $43 | 0, 4);
    $44 = $3; //@line 2853
    $45 = $8; //@line 2854
    _recycleBin($44, $45); //@line 2855
   }
   $46 = $9; //@line 2857
   $8 = $46; //@line 2858
  }
  $47 = $6; //@line 2860
  $48 = $47 + 1 | 0; //@line 2861
  $6 = $48; //@line 2862
 }
 STACKTOP = sp; //@line 2864
 return;
}
function _cpSpacePushFreshContactBuffer($0) {
 $0 = $0 | 0; //@line 4286
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0; //@line 4287
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0; //@line 4288
 var $46 = 0, $47 = 0, $48 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 4289
 sp = STACKTOP; //@line 4290
 STACKTOP = STACKTOP + 32 | 0; //@line 4291
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 4291
 $1 = $0; //@line 4292
 $6 = $1; //@line 4293
 $7 = $6 + 72 | 0; //@line 4294
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 4295
 $2 = $8; //@line 4296
 $9 = $1; //@line 4297
 $10 = $9 + 124 | 0; //@line 4298
 $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 4299
 $3 = $11; //@line 4300
 $12 = $3; //@line 4301
 $13 = ($12 | 0) != (0 | 0); //@line 4302
 if (!$13) {
  $14 = $1; //@line 4304
  $15 = _cpSpaceAllocContactBuffer($14) | 0; //@line 4305
  $16 = $2; //@line 4306
  $17 = _cpContactBufferHeaderInit($15, $16, 0) | 0; //@line 4307
  $18 = $1; //@line 4308
  $19 = $18 + 124 | 0; //@line 4309
  SAFE_HEAP_STORE($19 | 0, $17 | 0, 4);
  STACKTOP = sp; //@line 4311
  return;
 }
 $20 = $2; //@line 4313
 $21 = $3; //@line 4314
 $22 = $21 + 4 | 0; //@line 4315
 $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 4316
 $24 = SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0; //@line 4317
 $25 = $20 - $24 | 0; //@line 4318
 $26 = $1; //@line 4319
 $27 = $26 + 64 | 0; //@line 4320
 $28 = SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0; //@line 4321
 $29 = $25 >>> 0 > $28 >>> 0; //@line 4322
 if ($29) {
  $30 = $3; //@line 4324
  $31 = $30 + 4 | 0; //@line 4325
  $32 = SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0; //@line 4326
  $4 = $32; //@line 4327
  $33 = $4; //@line 4328
  $34 = $2; //@line 4329
  $35 = $4; //@line 4330
  $36 = _cpContactBufferHeaderInit($33, $34, $35) | 0; //@line 4331
  $37 = $1; //@line 4332
  $38 = $37 + 124 | 0; //@line 4333
  SAFE_HEAP_STORE($38 | 0, $36 | 0, 4);
  STACKTOP = sp; //@line 4335
  return;
 } else {
  $39 = $1; //@line 4337
  $40 = _cpSpaceAllocContactBuffer($39) | 0; //@line 4338
  $41 = $2; //@line 4339
  $42 = $3; //@line 4340
  $43 = _cpContactBufferHeaderInit($40, $41, $42) | 0; //@line 4341
  $5 = $43; //@line 4342
  $44 = $5; //@line 4343
  $45 = $3; //@line 4344
  $46 = $45 + 4 | 0; //@line 4345
  SAFE_HEAP_STORE($46 | 0, $44 | 0, 4);
  $47 = $1; //@line 4347
  $48 = $47 + 124 | 0; //@line 4348
  SAFE_HEAP_STORE($48 | 0, $44 | 0, 4);
  STACKTOP = sp; //@line 4350
  return;
 }
}
function _k_scalar($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 1958
 $1 = $1 | 0; //@line 1959
 $2 = $2 | 0; //@line 1960
 $3 = $3 | 0; //@line 1961
 $4 = $4 | 0; //@line 1962
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $10 = 0, $11 = 0.0, $12 = 0.0, $13 = 0.0, $14 = 0, $15 = 0.0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, $vararg_buffer = 0, label = 0, sp = 0; //@line 1963
 sp = STACKTOP; //@line 1964
 STACKTOP = STACKTOP + 96 | 0; //@line 1965
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(96 | 0); //@line 1965
 $$byval_copy3 = sp + 64 | 0; //@line 1966
 $$byval_copy2 = sp + 48 | 0; //@line 1967
 $$byval_copy1 = sp + 32 | 0; //@line 1968
 $$byval_copy = sp + 16 | 0; //@line 1969
 $vararg_buffer = sp + 8 | 0; //@line 1970
 $5 = $0; //@line 1971
 $6 = $1; //@line 1972
 $8 = $5; //@line 1973
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $9 = +_k_scalar_body($8, $$byval_copy, $$byval_copy1); //@line 1976
 $10 = $6; //@line 1977
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $11 = +_k_scalar_body($10, $$byval_copy2, $$byval_copy3); //@line 1980
 $12 = $9 + $11; //@line 1981
 $7 = $12; //@line 1982
 $13 = $7; //@line 1983
 $14 = $13 != 0.0; //@line 1984
 if ($14) {
  $15 = $7; //@line 1986
  STACKTOP = sp; //@line 1987
  return +$15;
 } else {
  _cpMessage(5890, 5903, 223, 1, 0, 5984, $vararg_buffer); //@line 1989
  _abort(); //@line 1990
 }
 return +0.0;
}
function _PairsClear($0, $1) {
 $0 = $0 | 0; //@line 4742
 $1 = $1 | 0; //@line 4743
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0; //@line 4744
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 4745
 sp = STACKTOP; //@line 4746
 STACKTOP = STACKTOP + 48 | 0; //@line 4747
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 4747
 $$byval_copy1 = sp + 32 | 0; //@line 4748
 $$byval_copy = sp + 20 | 0; //@line 4749
 $2 = $0; //@line 4750
 $3 = $1; //@line 4751
 $7 = $2; //@line 4752
 $8 = $7 + 44 | 0; //@line 4753
 $9 = $8 + 4 | 0; //@line 4754
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 4755
 $4 = $10; //@line 4756
 $11 = $2; //@line 4757
 $12 = $11 + 44 | 0; //@line 4758
 $13 = $12 + 4 | 0; //@line 4759
 SAFE_HEAP_STORE($13 | 0, 0 | 0, 4);
 while (1) {
  $14 = $4; //@line 4762
  $15 = ($14 | 0) != (0 | 0); //@line 4763
  if (!$15) {
   break;
  }
  $16 = $4; //@line 4767
  $17 = $16 + 4 | 0; //@line 4768
  $18 = SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0; //@line 4769
  $19 = $2; //@line 4770
  $20 = ($18 | 0) == ($19 | 0); //@line 4771
  $21 = $4; //@line 4772
  if ($20) {
   $22 = $21 + 8 | 0; //@line 4774
   $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 4775
   $5 = $23; //@line 4776
   $24 = $4; //@line 4777
   $25 = $24 + 12 | 0; //@line 4778
   SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($25 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($25 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   _ThreadUnlink($$byval_copy); //@line 4780
   $26 = $3; //@line 4781
   $27 = $4; //@line 4782
   _PairRecycle($26, $27); //@line 4783
   $28 = $5; //@line 4784
   $4 = $28; //@line 4785
  } else {
   $29 = $21 + 12 | 0; //@line 4787
   $30 = $29 + 8 | 0; //@line 4788
   $31 = SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0; //@line 4789
   $6 = $31; //@line 4790
   $32 = $4; //@line 4791
   SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($32 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
   SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($32 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
   _ThreadUnlink($$byval_copy1); //@line 4793
   $33 = $3; //@line 4794
   $34 = $4; //@line 4795
   _PairRecycle($33, $34); //@line 4796
   $35 = $6; //@line 4797
   $4 = $35; //@line 4798
  }
 }
 STACKTOP = sp; //@line 4801
 return;
}
function _cpShapePointQuery($0, $1, $2) {
 $0 = $0 | 0; //@line 5521
 $1 = $1 | 0; //@line 5522
 $2 = $2 | 0; //@line 5523
 var $$byval_copy = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0.0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0; //@line 5524
 var label = 0, sp = 0, src = 0, stop = 0; //@line 5525
 sp = STACKTOP; //@line 5526
 STACKTOP = STACKTOP + 80 | 0; //@line 5527
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(80 | 0); //@line 5527
 $$byval_copy = sp + 48 | 0; //@line 5528
 $5 = sp; //@line 5529
 $3 = $0; //@line 5530
 $4 = $2; //@line 5531
 SAFE_HEAP_STORE($5 | 0, 0 | 0, 4);
 $6 = $5 + 8 | 0; //@line 5533
 SAFE_HEAP_STORE($6 | 0, SAFE_HEAP_LOAD(11248 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 4 | 0, SAFE_HEAP_LOAD(11248 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 8 | 0, SAFE_HEAP_LOAD(11248 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 12 | 0, SAFE_HEAP_LOAD(11248 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $7 = $5 + 24 | 0; //@line 5535
 SAFE_HEAP_STORE_D($7 | 0, +inf, 8);
 $8 = $5 + 32 | 0; //@line 5537
 SAFE_HEAP_STORE($8 | 0, SAFE_HEAP_LOAD(11248 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 4 | 0, SAFE_HEAP_LOAD(11248 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 8 | 0, SAFE_HEAP_LOAD(11248 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($8 + 12 | 0, SAFE_HEAP_LOAD(11248 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $9 = $4; //@line 5539
 $10 = ($9 | 0) != (0 | 0); //@line 5540
 if ($10) {
  $11 = $4; //@line 5542
  dest = $11; //@line 5543
  src = $5; //@line 5543
  stop = dest + 48 | 0; //@line 5543
  do {
   SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
   dest = dest + 4 | 0; //@line 5543
   src = src + 4 | 0; //@line 5543
  } while ((dest | 0) < (stop | 0));
 } else {
  $4 = $5; //@line 5545
 }
 $12 = $3; //@line 5547
 $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 5548
 $14 = $13 + 12 | 0; //@line 5549
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 5550
 $16 = $3; //@line 5551
 $17 = $4; //@line 5552
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($15 | 0, 127 | 0) | 0) & 127]($16, $$byval_copy, $17); //@line 5554
 $18 = $4; //@line 5555
 $19 = $18 + 24 | 0; //@line 5556
 $20 = +(+SAFE_HEAP_LOAD_D($19 | 0, 8)); //@line 5557
 STACKTOP = sp; //@line 5558
 return +$20;
}
function _k_scalar_418($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 59
 $1 = $1 | 0; //@line 60
 $2 = $2 | 0; //@line 61
 $3 = $3 | 0; //@line 62
 $4 = $4 | 0; //@line 63
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $10 = 0, $11 = 0.0, $12 = 0.0, $13 = 0.0, $14 = 0, $15 = 0.0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, $vararg_buffer = 0, label = 0, sp = 0; //@line 64
 sp = STACKTOP; //@line 65
 STACKTOP = STACKTOP + 96 | 0; //@line 66
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(96 | 0); //@line 66
 $$byval_copy3 = sp + 64 | 0; //@line 67
 $$byval_copy2 = sp + 48 | 0; //@line 68
 $$byval_copy1 = sp + 32 | 0; //@line 69
 $$byval_copy = sp + 16 | 0; //@line 70
 $vararg_buffer = sp + 8 | 0; //@line 71
 $5 = $0; //@line 72
 $6 = $1; //@line 73
 $8 = $5; //@line 74
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $9 = +_k_scalar_body_420($8, $$byval_copy, $$byval_copy1); //@line 77
 $10 = $6; //@line 78
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $11 = +_k_scalar_body_420($10, $$byval_copy2, $$byval_copy3); //@line 81
 $12 = $9 + $11; //@line 82
 $7 = $12; //@line 83
 $13 = $7; //@line 84
 $14 = $13 != 0.0; //@line 85
 if ($14) {
  $15 = $7; //@line 87
  STACKTOP = sp; //@line 88
  return +$15;
 } else {
  _cpMessage(5890, 5903, 223, 1, 0, 5984, $vararg_buffer); //@line 90
  _abort(); //@line 91
 }
 return +0.0;
}
function _cpCircleShapeCacheData($0, $1, $2) {
 $0 = $0 | 0; //@line 5843
 $1 = $1 | 0; //@line 5844
 $2 = $2 | 0; //@line 5845
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $10 = 0, $11 = 0, $12 = 0.0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 5846
 sp = STACKTOP; //@line 5847
 STACKTOP = STACKTOP + 128 | 0; //@line 5848
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(128 | 0); //@line 5848
 $$byval_copy2 = sp + 96 | 0; //@line 5849
 $$byval_copy1 = sp + 80 | 0; //@line 5850
 $$byval_copy = sp + 32 | 0; //@line 5851
 $4 = sp + 16 | 0; //@line 5852
 $5 = sp; //@line 5853
 $3 = $1; //@line 5854
 $6 = $3; //@line 5855
 $7 = $6 + 176 | 0; //@line 5856
 $8 = $3; //@line 5857
 $9 = $8 + 160 | 0; //@line 5858
 dest = $$byval_copy; //@line 5859
 src = $2; //@line 5859
 stop = dest + 48 | 0; //@line 5859
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 5859
  src = src + 4 | 0; //@line 5859
 } while ((dest | 0) < (stop | 0));
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpTransformPoint_364($5, $$byval_copy, $$byval_copy1); //@line 5861
 SAFE_HEAP_STORE($7 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($4 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($4 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($4 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($4 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $10 = $3; //@line 5864
 $11 = $10 + 192 | 0; //@line 5865
 $12 = +(+SAFE_HEAP_LOAD_D($11 | 0, 8)); //@line 5866
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpBBNewForCircle($0, $$byval_copy2, $12); //@line 5868
 STACKTOP = sp; //@line 5869
 return;
}
function _MinkowskiPointNew($0, $1, $2) {
 $0 = $0 | 0; //@line 871
 $1 = $1 | 0; //@line 872
 $2 = $2 | 0; //@line 873
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 874
 sp = STACKTOP; //@line 875
 STACKTOP = STACKTOP + 96 | 0; //@line 876
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(96 | 0); //@line 876
 $$byval_copy1 = sp + 72 | 0; //@line 877
 $$byval_copy = sp + 56 | 0; //@line 878
 $3 = sp; //@line 879
 SAFE_HEAP_STORE($3 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($3 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($3 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($3 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $4 = $3 + 16 | 0; //@line 881
 SAFE_HEAP_STORE($4 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($4 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($4 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($4 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $5 = $3 + 32 | 0; //@line 883
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_67($5, $$byval_copy, $$byval_copy1); //@line 886
 $6 = $3 + 48 | 0; //@line 887
 $7 = $1 + 16 | 0; //@line 888
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 889
 $9 = $8 & 255; //@line 890
 $10 = $9 << 8; //@line 891
 $11 = $2 + 16 | 0; //@line 892
 $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 893
 $13 = $12 & 255; //@line 894
 $14 = $10 | $13; //@line 895
 SAFE_HEAP_STORE($6 | 0, $14 | 0, 4);
 dest = $0; //@line 897
 src = $3; //@line 897
 stop = dest + 56 | 0; //@line 897
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 897
  src = src + 4 | 0; //@line 897
 } while ((dest | 0) < (stop | 0));
 STACKTOP = sp; //@line 898
 return;
}
function _cpBodyKineticEnergy($0) {
 $0 = $0 | 0; //@line 7588
 var $$byval_copy = 0, $$byval_copy1 = 0, $1 = 0, $10 = 0, $11 = 0.0, $12 = 0, $13 = 0, $14 = 0.0, $15 = 0.0, $16 = 0.0, $17 = 0, $18 = 0.0, $19 = 0, $2 = 0.0, $20 = 0, $21 = 0.0, $22 = 0.0, $23 = 0.0, $24 = 0, $25 = 0.0; //@line 7589
 var $26 = 0, $27 = 0, $28 = 0.0, $29 = 0.0, $3 = 0.0, $30 = 0.0, $31 = 0.0, $32 = 0.0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0.0, $9 = 0, label = 0, sp = 0; //@line 7590
 sp = STACKTOP; //@line 7591
 STACKTOP = STACKTOP + 64 | 0; //@line 7592
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 7592
 $$byval_copy1 = sp + 32 | 0; //@line 7593
 $$byval_copy = sp + 16 | 0; //@line 7594
 $1 = $0; //@line 7595
 $4 = $1; //@line 7596
 $5 = $4 + 72 | 0; //@line 7597
 $6 = $1; //@line 7598
 $7 = $6 + 72 | 0; //@line 7599
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $8 = +_cpvdot_51($$byval_copy, $$byval_copy1); //@line 7602
 $2 = $8; //@line 7603
 $9 = $1; //@line 7604
 $10 = $9 + 112 | 0; //@line 7605
 $11 = +(+SAFE_HEAP_LOAD_D($10 | 0, 8)); //@line 7606
 $12 = $1; //@line 7607
 $13 = $12 + 112 | 0; //@line 7608
 $14 = +(+SAFE_HEAP_LOAD_D($13 | 0, 8)); //@line 7609
 $15 = $11 * $14; //@line 7610
 $3 = $15; //@line 7611
 $16 = $2; //@line 7612
 $17 = $16 != 0.0; //@line 7613
 if ($17) {
  $18 = $2; //@line 7615
  $19 = $1; //@line 7616
  $20 = $19 + 8 | 0; //@line 7617
  $21 = +(+SAFE_HEAP_LOAD_D($20 | 0, 8)); //@line 7618
  $22 = $18 * $21; //@line 7619
  $31 = $22; //@line 7620
 } else {
  $31 = 0.0; //@line 7622
 }
 $23 = $3; //@line 7624
 $24 = $23 != 0.0; //@line 7625
 if (!$24) {
  $32 = 0.0; //@line 7627
  $30 = $31 + $32; //@line 7628
  STACKTOP = sp; //@line 7629
  return +$30;
 }
 $25 = $3; //@line 7631
 $26 = $1; //@line 7632
 $27 = $26 + 24 | 0; //@line 7633
 $28 = +(+SAFE_HEAP_LOAD_D($27 | 0, 8)); //@line 7634
 $29 = $25 * $28; //@line 7635
 $32 = $29; //@line 7636
 $30 = $31 + $32; //@line 7637
 STACKTOP = sp; //@line 7638
 return +$30;
}
function _chipmunk_cpBodyApplyImpulseAtWorldPoint($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 6028
 $1 = +$1; //@line 6029
 $2 = +$2; //@line 6030
 $3 = +$3; //@line 6031
 $4 = +$4; //@line 6032
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0, $11 = 0, $12 = 0.0, $13 = 0.0, $14 = 0, $15 = 0.0, $16 = 0.0, $17 = 0, $18 = 0, $5 = 0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0; //@line 6033
 sp = STACKTOP; //@line 6034
 STACKTOP = STACKTOP + 112 | 0; //@line 6035
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 6035
 $$byval_copy1 = sp + 80 | 0; //@line 6036
 $$byval_copy = sp + 64 | 0; //@line 6037
 $10 = sp + 16 | 0; //@line 6038
 $11 = sp; //@line 6039
 $5 = $0; //@line 6040
 $6 = $1; //@line 6041
 $7 = $2; //@line 6042
 $8 = $3; //@line 6043
 $9 = $4; //@line 6044
 SAFE_HEAP_STORE($10 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $12 = $6; //@line 6047
 SAFE_HEAP_STORE_D($10 | 0, +$12, 8);
 $13 = $7; //@line 6049
 $14 = $10 + 8 | 0; //@line 6050
 SAFE_HEAP_STORE_D($14 | 0, +$13, 8);
 $15 = $8; //@line 6052
 SAFE_HEAP_STORE_D($11 | 0, +$15, 8);
 $16 = $9; //@line 6054
 $17 = $11 + 8 | 0; //@line 6055
 SAFE_HEAP_STORE_D($17 | 0, +$16, 8);
 $18 = $5; //@line 6057
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpBodyApplyImpulseAtWorldPoint($18, $$byval_copy, $$byval_copy1); //@line 6060
 STACKTOP = sp; //@line 6061
 return;
}
function _chipmunk_cpBodyApplyImpulseAtLocalPoint($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 6064
 $1 = +$1; //@line 6065
 $2 = +$2; //@line 6066
 $3 = +$3; //@line 6067
 $4 = +$4; //@line 6068
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0, $11 = 0, $12 = 0.0, $13 = 0.0, $14 = 0, $15 = 0.0, $16 = 0.0, $17 = 0, $18 = 0, $5 = 0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0; //@line 6069
 sp = STACKTOP; //@line 6070
 STACKTOP = STACKTOP + 112 | 0; //@line 6071
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 6071
 $$byval_copy1 = sp + 80 | 0; //@line 6072
 $$byval_copy = sp + 64 | 0; //@line 6073
 $10 = sp + 16 | 0; //@line 6074
 $11 = sp; //@line 6075
 $5 = $0; //@line 6076
 $6 = $1; //@line 6077
 $7 = $2; //@line 6078
 $8 = $3; //@line 6079
 $9 = $4; //@line 6080
 SAFE_HEAP_STORE($10 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $12 = $6; //@line 6083
 SAFE_HEAP_STORE_D($10 | 0, +$12, 8);
 $13 = $7; //@line 6085
 $14 = $10 + 8 | 0; //@line 6086
 SAFE_HEAP_STORE_D($14 | 0, +$13, 8);
 $15 = $8; //@line 6088
 SAFE_HEAP_STORE_D($11 | 0, +$15, 8);
 $16 = $9; //@line 6090
 $17 = $11 + 8 | 0; //@line 6091
 SAFE_HEAP_STORE_D($17 | 0, +$16, 8);
 $18 = $5; //@line 6093
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpBodyApplyImpulseAtLocalPoint($18, $$byval_copy, $$byval_copy1); //@line 6096
 STACKTOP = sp; //@line 6097
 return;
}
function _chipmunk_cpBodyApplyForceAtWorldPoint($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 5956
 $1 = +$1; //@line 5957
 $2 = +$2; //@line 5958
 $3 = +$3; //@line 5959
 $4 = +$4; //@line 5960
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0, $11 = 0, $12 = 0.0, $13 = 0.0, $14 = 0, $15 = 0.0, $16 = 0.0, $17 = 0, $18 = 0, $5 = 0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0; //@line 5961
 sp = STACKTOP; //@line 5962
 STACKTOP = STACKTOP + 112 | 0; //@line 5963
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 5963
 $$byval_copy1 = sp + 80 | 0; //@line 5964
 $$byval_copy = sp + 64 | 0; //@line 5965
 $10 = sp + 16 | 0; //@line 5966
 $11 = sp; //@line 5967
 $5 = $0; //@line 5968
 $6 = $1; //@line 5969
 $7 = $2; //@line 5970
 $8 = $3; //@line 5971
 $9 = $4; //@line 5972
 SAFE_HEAP_STORE($10 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $12 = $6; //@line 5975
 SAFE_HEAP_STORE_D($10 | 0, +$12, 8);
 $13 = $7; //@line 5977
 $14 = $10 + 8 | 0; //@line 5978
 SAFE_HEAP_STORE_D($14 | 0, +$13, 8);
 $15 = $8; //@line 5980
 SAFE_HEAP_STORE_D($11 | 0, +$15, 8);
 $16 = $9; //@line 5982
 $17 = $11 + 8 | 0; //@line 5983
 SAFE_HEAP_STORE_D($17 | 0, +$16, 8);
 $18 = $5; //@line 5985
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpBodyApplyForceAtWorldPoint($18, $$byval_copy, $$byval_copy1); //@line 5988
 STACKTOP = sp; //@line 5989
 return;
}
function _chipmunk_cpBodyApplyForceAtLocalPoint($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 5992
 $1 = +$1; //@line 5993
 $2 = +$2; //@line 5994
 $3 = +$3; //@line 5995
 $4 = +$4; //@line 5996
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0, $11 = 0, $12 = 0.0, $13 = 0.0, $14 = 0, $15 = 0.0, $16 = 0.0, $17 = 0, $18 = 0, $5 = 0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0; //@line 5997
 sp = STACKTOP; //@line 5998
 STACKTOP = STACKTOP + 112 | 0; //@line 5999
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 5999
 $$byval_copy1 = sp + 80 | 0; //@line 6000
 $$byval_copy = sp + 64 | 0; //@line 6001
 $10 = sp + 16 | 0; //@line 6002
 $11 = sp; //@line 6003
 $5 = $0; //@line 6004
 $6 = $1; //@line 6005
 $7 = $2; //@line 6006
 $8 = $3; //@line 6007
 $9 = $4; //@line 6008
 SAFE_HEAP_STORE($10 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $12 = $6; //@line 6011
 SAFE_HEAP_STORE_D($10 | 0, +$12, 8);
 $13 = $7; //@line 6013
 $14 = $10 + 8 | 0; //@line 6014
 SAFE_HEAP_STORE_D($14 | 0, +$13, 8);
 $15 = $8; //@line 6016
 SAFE_HEAP_STORE_D($11 | 0, +$15, 8);
 $16 = $9; //@line 6018
 $17 = $11 + 8 | 0; //@line 6019
 SAFE_HEAP_STORE_D($17 | 0, +$16, 8);
 $18 = $5; //@line 6021
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($11 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($11 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($11 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpBodyApplyForceAtLocalPoint($18, $$byval_copy, $$byval_copy1); //@line 6024
 STACKTOP = sp; //@line 6025
 return;
}
function _ClosestDist($0, $1) {
 $0 = $0 | 0; //@line 1388
 $1 = $1 | 0; //@line 1389
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $$byval_copy4 = 0, $2 = 0, $3 = 0.0, $4 = 0.0, label = 0, sp = 0; //@line 1390
 sp = STACKTOP; //@line 1391
 STACKTOP = STACKTOP + 96 | 0; //@line 1392
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(96 | 0); //@line 1392
 $$byval_copy4 = sp + 80 | 0; //@line 1393
 $$byval_copy3 = sp + 64 | 0; //@line 1394
 $$byval_copy2 = sp + 48 | 0; //@line 1395
 $$byval_copy1 = sp + 32 | 0; //@line 1396
 $$byval_copy = sp + 16 | 0; //@line 1397
 $2 = sp; //@line 1398
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $3 = +_ClosestT($$byval_copy, $$byval_copy1); //@line 1401
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _LerpT($2, $$byval_copy2, $$byval_copy3, $3); //@line 1404
 SAFE_HEAP_STORE($$byval_copy4 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy4 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $4 = +_cpvlengthsq_79($$byval_copy4); //@line 1406
 STACKTOP = sp; //@line 1407
 return +$4;
}
function _cpBodyActivateStatic($0, $1) {
 $0 = $0 | 0; //@line 2473
 $1 = $1 | 0; //@line 2474
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 2475
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 2476
 sp = STACKTOP; //@line 2477
 STACKTOP = STACKTOP + 16 | 0; //@line 2478
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2478
 $vararg_buffer = sp; //@line 2479
 $2 = $0; //@line 2480
 $3 = $1; //@line 2481
 $5 = $2; //@line 2482
 $6 = _cpBodyGetType($5) | 0; //@line 2483
 $7 = ($6 | 0) == 2; //@line 2484
 if (!$7) {
  _cpMessage(8222, 7878, 158, 1, 1, 8265, $vararg_buffer); //@line 2486
  _abort(); //@line 2487
 }
 $8 = $2; //@line 2490
 $9 = $8 + 216 | 0; //@line 2491
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 2492
 $4 = $10; //@line 2493
 while (1) {
  $11 = $4; //@line 2495
  $12 = ($11 | 0) != (0 | 0); //@line 2496
  if (!$12) {
   break;
  }
  $13 = $3; //@line 2500
  $14 = ($13 | 0) != (0 | 0); //@line 2501
  if ($14) {
   $15 = $3; //@line 2503
   $16 = $4; //@line 2504
   $17 = $16 + 36 | 0; //@line 2505
   $18 = SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0; //@line 2506
   $19 = ($15 | 0) == ($18 | 0); //@line 2507
   if ($19) {
    label = 8; //@line 2509
   } else {
    $20 = $3; //@line 2511
    $21 = $4; //@line 2512
    $22 = $21 + 40 | 0; //@line 2513
    $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 2514
    $24 = ($20 | 0) == ($23 | 0); //@line 2515
    if ($24) {
     label = 8; //@line 2517
    }
   }
  } else {
   label = 8; //@line 2521
  }
  if ((label | 0) == 8) {
   label = 0; //@line 2524
   $25 = $4; //@line 2525
   $26 = $25 + 44 | 0; //@line 2526
   $27 = SAFE_HEAP_LOAD($26 | 0, 4, 0) | 0 | 0; //@line 2527
   $28 = $2; //@line 2528
   $29 = ($27 | 0) == ($28 | 0); //@line 2529
   $30 = $4; //@line 2530
   if ($29) {
    $31 = $30 + 48 | 0; //@line 2532
    $32 = SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0; //@line 2533
    $35 = $32; //@line 2534
   } else {
    $33 = $30 + 44 | 0; //@line 2536
    $34 = SAFE_HEAP_LOAD($33 | 0, 4, 0) | 0 | 0; //@line 2537
    $35 = $34; //@line 2538
   }
   _cpBodyActivate($35); //@line 2540
  }
  $36 = $4; //@line 2542
  $37 = $2; //@line 2543
  $38 = _cpArbiterNext_482($36, $37) | 0; //@line 2544
  $4 = $38; //@line 2545
 }
 STACKTOP = sp; //@line 2547
 return;
}
function _cpCircleShapeSetRadius($0, $1) {
 $0 = $0 | 0; //@line 7140
 $1 = +$1; //@line 7141
 var $$byval_copy = 0, $10 = 0, $11 = 0.0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0.0, $17 = 0, $18 = 0, $19 = 0.0, $2 = 0, $20 = 0, $21 = 0, $22 = 0.0, $23 = 0, $24 = 0, $25 = 0.0, $26 = 0, $27 = 0; //@line 7142
 var $28 = 0, $29 = 0, $3 = 0.0, $4 = 0, $5 = 0.0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 7143
 sp = STACKTOP; //@line 7144
 STACKTOP = STACKTOP + 96 | 0; //@line 7145
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(96 | 0); //@line 7145
 $$byval_copy = sp + 64 | 0; //@line 7146
 $vararg_buffer = sp + 56 | 0; //@line 7147
 $6 = sp; //@line 7148
 $2 = $0; //@line 7149
 $3 = $1; //@line 7150
 $7 = $2; //@line 7151
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 7152
 $9 = ($8 | 0) == (2656 | 0); //@line 7153
 if (!$9) {
  _cpMessage(5758, 5494, 555, 1, 1, 5794, $vararg_buffer); //@line 7155
  _abort(); //@line 7156
 }
 $10 = $2; //@line 7159
 $4 = $10; //@line 7160
 $11 = $3; //@line 7161
 $12 = $4; //@line 7162
 $13 = $12 + 192 | 0; //@line 7163
 SAFE_HEAP_STORE_D($13 | 0, +$11, 8);
 $14 = $2; //@line 7165
 $15 = $14 + 16 | 0; //@line 7166
 $16 = +(+SAFE_HEAP_LOAD_D($15 | 0, 8)); //@line 7167
 $5 = $16; //@line 7168
 $17 = $2; //@line 7169
 $18 = $17 + 16 | 0; //@line 7170
 $19 = $5; //@line 7171
 $20 = $4; //@line 7172
 $21 = $20 + 192 | 0; //@line 7173
 $22 = +(+SAFE_HEAP_LOAD_D($21 | 0, 8)); //@line 7174
 $23 = $4; //@line 7175
 $24 = $23 + 160 | 0; //@line 7176
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($24 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($24 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($24 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpCircleShapeMassInfo($6, $19, $22, $$byval_copy); //@line 7178
 dest = $18; //@line 7179
 src = $6; //@line 7179
 stop = dest + 40 | 0; //@line 7179
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 7179
  src = src + 4 | 0; //@line 7179
 } while ((dest | 0) < (stop | 0));
 $25 = $5; //@line 7180
 $26 = $25 > 0.0; //@line 7181
 if (!$26) {
  STACKTOP = sp; //@line 7183
  return;
 }
 $27 = $2; //@line 7185
 $28 = $27 + 8 | 0; //@line 7186
 $29 = SAFE_HEAP_LOAD($28 | 0, 4, 0) | 0 | 0; //@line 7187
 _cpBodyAccumulateMassFromShapes($29); //@line 7188
 STACKTOP = sp; //@line 7189
 return;
}
function _LerpT($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 1337
 $1 = $1 | 0; //@line 1338
 $2 = $2 | 0; //@line 1339
 $3 = +$3; //@line 1340
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $10 = 0.0, $11 = 0.0, $12 = 0.0, $13 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0; //@line 1341
 sp = STACKTOP; //@line 1342
 STACKTOP = STACKTOP + 112 | 0; //@line 1343
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 1343
 $$byval_copy3 = sp + 96 | 0; //@line 1344
 $$byval_copy2 = sp + 80 | 0; //@line 1345
 $$byval_copy1 = sp + 64 | 0; //@line 1346
 $$byval_copy = sp + 48 | 0; //@line 1347
 $6 = sp + 16 | 0; //@line 1348
 $7 = sp; //@line 1349
 $4 = $3; //@line 1350
 $8 = $4; //@line 1351
 $9 = .5 * $8; //@line 1352
 $5 = $9; //@line 1353
 $10 = $5; //@line 1354
 $11 = .5 - $10; //@line 1355
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_64($6, $$byval_copy, $11); //@line 1357
 $12 = $5; //@line 1358
 $13 = .5 + $12; //@line 1359
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_64($7, $$byval_copy1, $13); //@line 1361
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_66($0, $$byval_copy2, $$byval_copy3); //@line 1364
 STACKTOP = sp; //@line 1365
 return;
}
function _QueryRejectConstraint($0, $1) {
 $0 = $0 | 0; //@line 4903
 $1 = $1 | 0; //@line 4904
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 4905
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 4906
 sp = STACKTOP; //@line 4907
 STACKTOP = STACKTOP + 16 | 0; //@line 4908
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 4908
 $3 = $0; //@line 4909
 $4 = $1; //@line 4910
 $6 = $3; //@line 4911
 $7 = $6 + 220 | 0; //@line 4912
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 4913
 $5 = $8; //@line 4914
 while (1) {
  $9 = $5; //@line 4916
  $10 = ($9 | 0) != (0 | 0); //@line 4917
  if (!$10) {
   label = 10; //@line 4919
   break;
  }
  $11 = $5; //@line 4922
  $12 = $11 + 48 | 0; //@line 4923
  $13 = SAFE_HEAP_LOAD($12 >> 0 | 0, 1, 0) | 0 | 0; //@line 4924
  $14 = $13 << 24 >> 24 != 0; //@line 4925
  if (!$14) {
   $15 = $5; //@line 4927
   $16 = $15 + 8 | 0; //@line 4928
   $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 4929
   $18 = $3; //@line 4930
   $19 = ($17 | 0) == ($18 | 0); //@line 4931
   if ($19) {
    $20 = $5; //@line 4933
    $21 = $20 + 12 | 0; //@line 4934
    $22 = SAFE_HEAP_LOAD($21 | 0, 4, 0) | 0 | 0; //@line 4935
    $23 = $4; //@line 4936
    $24 = ($22 | 0) == ($23 | 0); //@line 4937
    if ($24) {
     label = 8; //@line 4939
     break;
    }
   }
   $25 = $5; //@line 4943
   $26 = $25 + 8 | 0; //@line 4944
   $27 = SAFE_HEAP_LOAD($26 | 0, 4, 0) | 0 | 0; //@line 4945
   $28 = $4; //@line 4946
   $29 = ($27 | 0) == ($28 | 0); //@line 4947
   if ($29) {
    $30 = $5; //@line 4949
    $31 = $30 + 12 | 0; //@line 4950
    $32 = SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0; //@line 4951
    $33 = $3; //@line 4952
    $34 = ($32 | 0) == ($33 | 0); //@line 4953
    if ($34) {
     label = 8; //@line 4955
     break;
    }
   }
  }
  $35 = $5; //@line 4960
  $36 = $3; //@line 4961
  $37 = _cpConstraintNext_582($35, $36) | 0; //@line 4962
  $5 = $37; //@line 4963
 }
 if ((label | 0) == 8) {
  $2 = 1; //@line 4966
  $38 = $2; //@line 4967
  STACKTOP = sp; //@line 4968
  return $38 | 0; //@line 4968
 } else if ((label | 0) == 10) {
  $2 = 0; //@line 4971
  $38 = $2; //@line 4972
  STACKTOP = sp; //@line 4973
  return $38 | 0; //@line 4973
 }
 return 0 | 0; //@line 4975
}
function _cpSpaceArbiterSetTrans($0, $1) {
 $0 = $0 | 0; //@line 4735
 $1 = $1 | 0; //@line 4736
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 4737
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0; //@line 4738
 var sp = 0; //@line 4739
 sp = STACKTOP; //@line 4740
 STACKTOP = STACKTOP + 32 | 0; //@line 4741
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 4741
 $vararg_buffer = sp; //@line 4742
 $2 = $0; //@line 4743
 $3 = $1; //@line 4744
 $7 = $3; //@line 4745
 $8 = $7 + 132 | 0; //@line 4746
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 4747
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 4748
 $11 = ($10 | 0) == 0; //@line 4749
 L1 : do {
  if ($11) {
   $4 = 273; //@line 4752
   $12 = $4; //@line 4753
   $13 = ($12 | 0) != 0; //@line 4754
   if (!$13) {
    _cpMessage(9930, 9556, 193, 1, 1, 9936, $vararg_buffer); //@line 4756
    _abort(); //@line 4757
   }
   $14 = _calloc(1, 32768) | 0; //@line 4760
   $5 = $14; //@line 4761
   $15 = $3; //@line 4762
   $16 = $15 + 136 | 0; //@line 4763
   $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 4764
   $18 = $5; //@line 4765
   _cpArrayPush($17, $18); //@line 4766
   $6 = 0; //@line 4767
   while (1) {
    $19 = $6; //@line 4769
    $20 = $4; //@line 4770
    $21 = ($19 | 0) < ($20 | 0); //@line 4771
    if (!$21) {
     break L1;
    }
    $22 = $3; //@line 4775
    $23 = $22 + 132 | 0; //@line 4776
    $24 = SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0; //@line 4777
    $25 = $5; //@line 4778
    $26 = $6; //@line 4779
    $27 = $25 + ($26 * 120 | 0) | 0; //@line 4780
    _cpArrayPush($24, $27); //@line 4781
    $28 = $6; //@line 4782
    $29 = $28 + 1 | 0; //@line 4783
    $6 = $29; //@line 4784
   }
  }
 } while (0);
 $30 = $3; //@line 4788
 $31 = $30 + 132 | 0; //@line 4789
 $32 = SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0; //@line 4790
 $33 = _cpArrayPop($32) | 0; //@line 4791
 $34 = $2; //@line 4792
 $35 = SAFE_HEAP_LOAD($34 | 0, 4, 0) | 0 | 0; //@line 4793
 $36 = $2; //@line 4794
 $37 = $36 + 4 | 0; //@line 4795
 $38 = SAFE_HEAP_LOAD($37 | 0, 4, 0) | 0 | 0; //@line 4796
 $39 = _cpArbiterInit($33, $35, $38) | 0; //@line 4797
 STACKTOP = sp; //@line 4798
 return $39 | 0; //@line 4798
}
function _PolySupportPointIndex($0, $1, $2) {
 $0 = $0 | 0; //@line 749
 $1 = $1 | 0; //@line 750
 $2 = $2 | 0; //@line 751
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0.0, $17 = 0.0, $18 = 0.0, $19 = 0, $20 = 0.0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0.0; //@line 752
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0.0, label = 0, sp = 0; //@line 753
 sp = STACKTOP; //@line 754
 STACKTOP = STACKTOP + 80 | 0; //@line 755
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(80 | 0); //@line 755
 $$byval_copy1 = sp + 48 | 0; //@line 756
 $$byval_copy = sp + 32 | 0; //@line 757
 $8 = sp + 8 | 0; //@line 758
 $3 = $0; //@line 759
 $4 = $1; //@line 760
 $5 = -inf; //@line 761
 $6 = 0; //@line 762
 $7 = 0; //@line 763
 while (1) {
  $10 = $7; //@line 765
  $11 = $3; //@line 766
  $12 = ($10 | 0) < ($11 | 0); //@line 767
  if (!$12) {
   break;
  }
  $13 = $4; //@line 771
  $14 = $7; //@line 772
  $15 = $13 + ($14 << 5) | 0; //@line 773
  SAFE_HEAP_STORE($8 | 0, SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($8 + 4 | 0, SAFE_HEAP_LOAD($15 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($8 + 8 | 0, SAFE_HEAP_LOAD($15 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($8 + 12 | 0, SAFE_HEAP_LOAD($15 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($8 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($8 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($8 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $16 = +_cpvdot_68($$byval_copy, $$byval_copy1); //@line 777
  $9 = $16; //@line 778
  $17 = $9; //@line 779
  $18 = $5; //@line 780
  $19 = $17 > $18; //@line 781
  if ($19) {
   $20 = $9; //@line 783
   $5 = $20; //@line 784
   $21 = $7; //@line 785
   $6 = $21; //@line 786
  }
  $22 = $7; //@line 788
  $23 = $22 + 1 | 0; //@line 789
  $7 = $23; //@line 790
 }
 $24 = $6; //@line 792
 STACKTOP = sp; //@line 793
 return $24 | 0; //@line 793
}
function _fmt_u($0, $1, $2) {
 $0 = $0 | 0; //@line 12780
 $1 = $1 | 0; //@line 12781
 $2 = $2 | 0; //@line 12782
 var $$010$lcssa$off0 = 0, $$012 = 0, $$09$lcssa = 0, $$0914 = 0, $$1$lcssa = 0, $$111 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0; //@line 12783
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 12784
 sp = STACKTOP; //@line 12785
 $3 = $1 >>> 0 > 0; //@line 12786
 $4 = $0 >>> 0 > 4294967295; //@line 12787
 $5 = ($1 | 0) == 0; //@line 12788
 $6 = $5 & $4; //@line 12789
 $7 = $3 | $6; //@line 12790
 if ($7) {
  $$0914 = $2; //@line 12792
  $8 = $0; //@line 12792
  $9 = $1; //@line 12792
  while (1) {
   $10 = ___udivdi3($8 | 0, $9 | 0, 10, 0) | 0; //@line 12794
   $11 = getTempRet0() | 0; //@line 12795
   $12 = ___muldi3($10 | 0, $11 | 0, 10, 0) | 0; //@line 12796
   $13 = getTempRet0() | 0; //@line 12797
   $14 = _i64Subtract($8 | 0, $9 | 0, $12 | 0, $13 | 0) | 0; //@line 12798
   $15 = getTempRet0() | 0; //@line 12799
   $16 = $14 & 255; //@line 12800
   $17 = $16 | 48; //@line 12801
   $18 = $$0914 + -1 | 0; //@line 12802
   SAFE_HEAP_STORE($18 >> 0 | 0, $17 | 0, 1);
   $19 = $9 >>> 0 > 9; //@line 12804
   $20 = $8 >>> 0 > 4294967295; //@line 12805
   $21 = ($9 | 0) == 9; //@line 12806
   $22 = $21 & $20; //@line 12807
   $23 = $19 | $22; //@line 12808
   if ($23) {
    $$0914 = $18; //@line 12810
    $8 = $10; //@line 12810
    $9 = $11; //@line 12810
   } else {
    break;
   }
  }
  $$010$lcssa$off0 = $10; //@line 12815
  $$09$lcssa = $18; //@line 12815
 } else {
  $$010$lcssa$off0 = $0; //@line 12817
  $$09$lcssa = $2; //@line 12817
 }
 $24 = ($$010$lcssa$off0 | 0) == 0; //@line 12819
 if ($24) {
  $$1$lcssa = $$09$lcssa; //@line 12821
 } else {
  $$012 = $$010$lcssa$off0; //@line 12823
  $$111 = $$09$lcssa; //@line 12823
  while (1) {
   $25 = ($$012 >>> 0) / 10 & -1; //@line 12825
   $26 = $25 * 10 | 0; //@line 12826
   $27 = $$012 - $26 | 0; //@line 12827
   $28 = $27 | 48; //@line 12828
   $29 = $28 & 255; //@line 12829
   $30 = $$111 + -1 | 0; //@line 12830
   SAFE_HEAP_STORE($30 >> 0 | 0, $29 | 0, 1);
   $31 = $$012 >>> 0 < 10; //@line 12832
   if ($31) {
    $$1$lcssa = $30; //@line 12834
    break;
   } else {
    $$012 = $25; //@line 12837
    $$111 = $30; //@line 12837
   }
  }
 }
 return $$1$lcssa | 0; //@line 12841
}
function _cpShapeUpdate($0, $1, $2) {
 $0 = $0 | 0; //@line 5498
 $1 = $1 | 0; //@line 5499
 $2 = $2 | 0; //@line 5500
 var $$byval_copy = 0, $10 = 0, $11 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 5501
 sp = STACKTOP; //@line 5502
 STACKTOP = STACKTOP + 96 | 0; //@line 5503
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(96 | 0); //@line 5503
 $$byval_copy = sp + 32 | 0; //@line 5504
 $4 = sp; //@line 5505
 $3 = $1; //@line 5506
 $5 = $3; //@line 5507
 $6 = $5 + 56 | 0; //@line 5508
 $7 = $3; //@line 5509
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 5510
 $9 = $8 + 4 | 0; //@line 5511
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 5512
 $11 = $3; //@line 5513
 dest = $$byval_copy; //@line 5514
 src = $2; //@line 5514
 stop = dest + 48 | 0; //@line 5514
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 5514
  src = src + 4 | 0; //@line 5514
 } while ((dest | 0) < (stop | 0));
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($10 | 0, 127 | 0) | 0) & 127]($4, $11, $$byval_copy); //@line 5515
 SAFE_HEAP_STORE($6 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 16 | 0, SAFE_HEAP_LOAD($4 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 20 | 0, SAFE_HEAP_LOAD($4 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 24 | 0, SAFE_HEAP_LOAD($4 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 28 | 0, SAFE_HEAP_LOAD($4 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 16 | 0, SAFE_HEAP_LOAD($6 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 20 | 0, SAFE_HEAP_LOAD($6 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 24 | 0, SAFE_HEAP_LOAD($6 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 28 | 0, SAFE_HEAP_LOAD($6 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 5518
 return;
}
function _cpHashSetFind($0, $1, $2) {
 $0 = $0 | 0; //@line 2675
 $1 = $1 | 0; //@line 2676
 $2 = $2 | 0; //@line 2677
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0; //@line 2678
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2679
 sp = STACKTOP; //@line 2680
 STACKTOP = STACKTOP + 32 | 0; //@line 2681
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 2681
 $3 = $0; //@line 2682
 $4 = $1; //@line 2683
 $5 = $2; //@line 2684
 $8 = $4; //@line 2685
 $9 = $3; //@line 2686
 $10 = $9 + 4 | 0; //@line 2687
 $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 2688
 $12 = ($8 >>> 0) % ($11 >>> 0) & -1; //@line 2689
 $6 = $12; //@line 2690
 $13 = $3; //@line 2691
 $14 = $13 + 16 | 0; //@line 2692
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 2693
 $16 = $6; //@line 2694
 $17 = $15 + ($16 << 2) | 0; //@line 2695
 $18 = SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0; //@line 2696
 $7 = $18; //@line 2697
 while (1) {
  $19 = $7; //@line 2699
  $20 = ($19 | 0) != (0 | 0); //@line 2700
  if ($20) {
   $21 = $3; //@line 2702
   $22 = $21 + 8 | 0; //@line 2703
   $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 2704
   $24 = $5; //@line 2705
   $25 = $7; //@line 2706
   $26 = SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0; //@line 2707
   $27 = FUNCTION_TABLE_iii[(SAFE_FT_MASK($23 | 0, 127 | 0) | 0) & 127]($24, $26) | 0; //@line 2708
   $28 = $27 << 24 >> 24 != 0; //@line 2709
   $29 = $28 ^ 1; //@line 2710
   $40 = $29; //@line 2711
  } else {
   $40 = 0; //@line 2713
  }
  $30 = $7; //@line 2715
  if (!$40) {
   break;
  }
  $31 = $30 + 8 | 0; //@line 2719
  $32 = SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0; //@line 2720
  $7 = $32; //@line 2721
 }
 $33 = ($30 | 0) != (0 | 0); //@line 2723
 if ($33) {
  $34 = $7; //@line 2725
  $35 = SAFE_HEAP_LOAD($34 | 0, 4, 0) | 0 | 0; //@line 2726
  $39 = $35; //@line 2727
  STACKTOP = sp; //@line 2728
  return $39 | 0; //@line 2728
 } else {
  $36 = $3; //@line 2730
  $37 = $36 + 12 | 0; //@line 2731
  $38 = SAFE_HEAP_LOAD($37 | 0, 4, 0) | 0 | 0; //@line 2732
  $39 = $38; //@line 2733
  STACKTOP = sp; //@line 2734
  return $39 | 0; //@line 2734
 }
 return 0 | 0; //@line 2736
}
function _cpArrayDeleteObj($0, $1) {
 $0 = $0 | 0; //@line 2796
 $1 = $1 | 0; //@line 2797
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 2798
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2799
 sp = STACKTOP; //@line 2800
 STACKTOP = STACKTOP + 16 | 0; //@line 2801
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2801
 $2 = $0; //@line 2802
 $3 = $1; //@line 2803
 $4 = 0; //@line 2804
 while (1) {
  $5 = $4; //@line 2806
  $6 = $2; //@line 2807
  $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 2808
  $8 = ($5 | 0) < ($7 | 0); //@line 2809
  if (!$8) {
   label = 6; //@line 2811
   break;
  }
  $9 = $2; //@line 2814
  $10 = $9 + 8 | 0; //@line 2815
  $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 2816
  $12 = $4; //@line 2817
  $13 = $11 + ($12 << 2) | 0; //@line 2818
  $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 2819
  $15 = $3; //@line 2820
  $16 = ($14 | 0) == ($15 | 0); //@line 2821
  if ($16) {
   break;
  }
  $38 = $4; //@line 2825
  $39 = $38 + 1 | 0; //@line 2826
  $4 = $39; //@line 2827
 }
 if ((label | 0) == 6) {
  STACKTOP = sp; //@line 2830
  return;
 }
 $17 = $2; //@line 2832
 $18 = SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0; //@line 2833
 $19 = $18 + -1 | 0; //@line 2834
 SAFE_HEAP_STORE($17 | 0, $19 | 0, 4);
 $20 = $2; //@line 2836
 $21 = $20 + 8 | 0; //@line 2837
 $22 = SAFE_HEAP_LOAD($21 | 0, 4, 0) | 0 | 0; //@line 2838
 $23 = $2; //@line 2839
 $24 = SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0; //@line 2840
 $25 = $22 + ($24 << 2) | 0; //@line 2841
 $26 = SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0; //@line 2842
 $27 = $2; //@line 2843
 $28 = $27 + 8 | 0; //@line 2844
 $29 = SAFE_HEAP_LOAD($28 | 0, 4, 0) | 0 | 0; //@line 2845
 $30 = $4; //@line 2846
 $31 = $29 + ($30 << 2) | 0; //@line 2847
 SAFE_HEAP_STORE($31 | 0, $26 | 0, 4);
 $32 = $2; //@line 2849
 $33 = $32 + 8 | 0; //@line 2850
 $34 = SAFE_HEAP_LOAD($33 | 0, 4, 0) | 0 | 0; //@line 2851
 $35 = $2; //@line 2852
 $36 = SAFE_HEAP_LOAD($35 | 0, 4, 0) | 0 | 0; //@line 2853
 $37 = $34 + ($36 << 2) | 0; //@line 2854
 SAFE_HEAP_STORE($37 | 0, 0 | 0, 4);
 STACKTOP = sp; //@line 2856
 return;
}
function _cpvlerp_362($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 6131
 $1 = $1 | 0; //@line 6132
 $2 = $2 | 0; //@line 6133
 $3 = +$3; //@line 6134
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0; //@line 6135
 sp = STACKTOP; //@line 6136
 STACKTOP = STACKTOP + 112 | 0; //@line 6137
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 6137
 $$byval_copy3 = sp + 88 | 0; //@line 6138
 $$byval_copy2 = sp + 72 | 0; //@line 6139
 $$byval_copy1 = sp + 56 | 0; //@line 6140
 $$byval_copy = sp + 40 | 0; //@line 6141
 $5 = sp + 16 | 0; //@line 6142
 $6 = sp; //@line 6143
 $4 = $3; //@line 6144
 $7 = $4; //@line 6145
 $8 = 1.0 - $7; //@line 6146
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_357($5, $$byval_copy, $8); //@line 6148
 $9 = $4; //@line 6149
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_357($6, $$byval_copy1, $9); //@line 6151
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_363($0, $$byval_copy2, $$byval_copy3); //@line 6154
 STACKTOP = sp; //@line 6155
 return;
}
function _cpvlerp_273($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 4606
 $1 = $1 | 0; //@line 4607
 $2 = $2 | 0; //@line 4608
 $3 = +$3; //@line 4609
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0; //@line 4610
 sp = STACKTOP; //@line 4611
 STACKTOP = STACKTOP + 112 | 0; //@line 4612
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 4612
 $$byval_copy3 = sp + 88 | 0; //@line 4613
 $$byval_copy2 = sp + 72 | 0; //@line 4614
 $$byval_copy1 = sp + 56 | 0; //@line 4615
 $$byval_copy = sp + 40 | 0; //@line 4616
 $5 = sp + 16 | 0; //@line 4617
 $6 = sp; //@line 4618
 $4 = $3; //@line 4619
 $7 = $4; //@line 4620
 $8 = 1.0 - $7; //@line 4621
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_270($5, $$byval_copy, $8); //@line 4623
 $9 = $4; //@line 4624
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_270($6, $$byval_copy1, $9); //@line 4626
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_276($0, $$byval_copy2, $$byval_copy3); //@line 4629
 STACKTOP = sp; //@line 4630
 return;
}
function _cpvlerp_48($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 6808
 $1 = $1 | 0; //@line 6809
 $2 = $2 | 0; //@line 6810
 $3 = +$3; //@line 6811
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0; //@line 6812
 sp = STACKTOP; //@line 6813
 STACKTOP = STACKTOP + 112 | 0; //@line 6814
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 6814
 $$byval_copy3 = sp + 88 | 0; //@line 6815
 $$byval_copy2 = sp + 72 | 0; //@line 6816
 $$byval_copy1 = sp + 56 | 0; //@line 6817
 $$byval_copy = sp + 40 | 0; //@line 6818
 $5 = sp + 16 | 0; //@line 6819
 $6 = sp; //@line 6820
 $4 = $3; //@line 6821
 $7 = $4; //@line 6822
 $8 = 1.0 - $7; //@line 6823
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_44($5, $$byval_copy, $8); //@line 6825
 $9 = $4; //@line 6826
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_44($6, $$byval_copy1, $9); //@line 6828
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_43($0, $$byval_copy2, $$byval_copy3); //@line 6831
 STACKTOP = sp; //@line 6832
 return;
}
function _normal_relative_velocity($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 2024
 $1 = $1 | 0; //@line 2025
 $2 = $2 | 0; //@line 2026
 $3 = $3 | 0; //@line 2027
 $4 = $4 | 0; //@line 2028
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $10 = 0.0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2029
 sp = STACKTOP; //@line 2030
 STACKTOP = STACKTOP + 96 | 0; //@line 2031
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(96 | 0); //@line 2031
 $$byval_copy3 = sp + 64 | 0; //@line 2032
 $$byval_copy2 = sp + 48 | 0; //@line 2033
 $$byval_copy1 = sp + 32 | 0; //@line 2034
 $$byval_copy = sp + 16 | 0; //@line 2035
 $7 = sp; //@line 2036
 $5 = $0; //@line 2037
 $6 = $1; //@line 2038
 $8 = $5; //@line 2039
 $9 = $6; //@line 2040
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _relative_velocity($7, $8, $9, $$byval_copy, $$byval_copy1); //@line 2043
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $10 = +_cpvdot_11($$byval_copy2, $$byval_copy3); //@line 2046
 STACKTOP = sp; //@line 2047
 return +$10;
}
function _cpvlerp_65($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 576
 $1 = $1 | 0; //@line 577
 $2 = $2 | 0; //@line 578
 $3 = +$3; //@line 579
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0; //@line 580
 sp = STACKTOP; //@line 581
 STACKTOP = STACKTOP + 112 | 0; //@line 582
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 582
 $$byval_copy3 = sp + 88 | 0; //@line 583
 $$byval_copy2 = sp + 72 | 0; //@line 584
 $$byval_copy1 = sp + 56 | 0; //@line 585
 $$byval_copy = sp + 40 | 0; //@line 586
 $5 = sp + 16 | 0; //@line 587
 $6 = sp; //@line 588
 $4 = $3; //@line 589
 $7 = $4; //@line 590
 $8 = 1.0 - $7; //@line 591
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_64($5, $$byval_copy, $8); //@line 593
 $9 = $4; //@line 594
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_64($6, $$byval_copy1, $9); //@line 596
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd_66($0, $$byval_copy2, $$byval_copy3); //@line 599
 STACKTOP = sp; //@line 600
 return;
}
function _cpvlerp($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 287
 $1 = $1 | 0; //@line 288
 $2 = $2 | 0; //@line 289
 $3 = +$3; //@line 290
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $$byval_copy3 = 0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0; //@line 291
 sp = STACKTOP; //@line 292
 STACKTOP = STACKTOP + 112 | 0; //@line 293
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 293
 $$byval_copy3 = sp + 88 | 0; //@line 294
 $$byval_copy2 = sp + 72 | 0; //@line 295
 $$byval_copy1 = sp + 56 | 0; //@line 296
 $$byval_copy = sp + 40 | 0; //@line 297
 $5 = sp + 16 | 0; //@line 298
 $6 = sp; //@line 299
 $4 = $3; //@line 300
 $7 = $4; //@line 301
 $8 = 1.0 - $7; //@line 302
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult($5, $$byval_copy, $8); //@line 304
 $9 = $4; //@line 305
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult($6, $$byval_copy1, $9); //@line 307
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy3 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvadd($0, $$byval_copy2, $$byval_copy3); //@line 310
 STACKTOP = sp; //@line 311
 return;
}
function _PairFromPool($0) {
 $0 = $0 | 0; //@line 4254
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0; //@line 4255
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 4256
 sp = STACKTOP; //@line 4257
 STACKTOP = STACKTOP + 32 | 0; //@line 4258
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 4258
 $vararg_buffer = sp; //@line 4259
 $2 = $0; //@line 4260
 $7 = $2; //@line 4261
 $8 = _GetMasterTree($7) | 0; //@line 4262
 $2 = $8; //@line 4263
 $9 = $2; //@line 4264
 $10 = $9 + 32 | 0; //@line 4265
 $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 4266
 $3 = $11; //@line 4267
 $12 = $3; //@line 4268
 $13 = ($12 | 0) != (0 | 0); //@line 4269
 if ($13) {
  $14 = $3; //@line 4271
  $15 = $14 + 8 | 0; //@line 4272
  $16 = SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0; //@line 4273
  $17 = $2; //@line 4274
  $18 = $17 + 32 | 0; //@line 4275
  SAFE_HEAP_STORE($18 | 0, $16 | 0, 4);
  $19 = $3; //@line 4277
  $1 = $19; //@line 4278
  $37 = $1; //@line 4279
  STACKTOP = sp; //@line 4280
  return $37 | 0; //@line 4280
 }
 $4 = 1170; //@line 4282
 $20 = $4; //@line 4283
 $21 = ($20 | 0) != 0; //@line 4284
 if (!$21) {
  _cpMessage(9930, 3342, 157, 1, 1, 5396, $vararg_buffer); //@line 4286
  _abort(); //@line 4287
 }
 $22 = _calloc(1, 32768) | 0; //@line 4290
 $5 = $22; //@line 4291
 $23 = $2; //@line 4292
 $24 = $23 + 36 | 0; //@line 4293
 $25 = SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0; //@line 4294
 $26 = $5; //@line 4295
 _cpArrayPush($25, $26); //@line 4296
 $6 = 1; //@line 4297
 while (1) {
  $27 = $6; //@line 4299
  $28 = $4; //@line 4300
  $29 = ($27 | 0) < ($28 | 0); //@line 4301
  if (!$29) {
   break;
  }
  $30 = $2; //@line 4305
  $31 = $5; //@line 4306
  $32 = $6; //@line 4307
  $33 = $31 + ($32 * 28 | 0) | 0; //@line 4308
  _PairRecycle($30, $33); //@line 4309
  $34 = $6; //@line 4310
  $35 = $34 + 1 | 0; //@line 4311
  $6 = $35; //@line 4312
 }
 $36 = $5; //@line 4314
 $1 = $36; //@line 4315
 $37 = $1; //@line 4316
 STACKTOP = sp; //@line 4317
 return $37 | 0; //@line 4317
}
function _cpCollisionInfoPushContact($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 653
 $1 = $1 | 0; //@line 654
 $2 = $2 | 0; //@line 655
 $3 = $3 | 0; //@line 656
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $4 = 0, $5 = 0; //@line 657
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 658
 sp = STACKTOP; //@line 659
 STACKTOP = STACKTOP + 16 | 0; //@line 660
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 660
 $vararg_buffer = sp; //@line 661
 $4 = $0; //@line 662
 $5 = $3; //@line 663
 $7 = $4; //@line 664
 $8 = $7 + 32 | 0; //@line 665
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 666
 $10 = ($9 | 0) <= 2; //@line 667
 if ($10) {
  $11 = $4; //@line 669
  $12 = $11 + 36 | 0; //@line 670
  $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 671
  $14 = $4; //@line 672
  $15 = $14 + 32 | 0; //@line 673
  $16 = SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0; //@line 674
  $17 = $13 + ($16 * 96 | 0) | 0; //@line 675
  $6 = $17; //@line 676
  $18 = $6; //@line 677
  SAFE_HEAP_STORE($18 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($18 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($18 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($18 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $19 = $6; //@line 679
  $20 = $19 + 16 | 0; //@line 680
  SAFE_HEAP_STORE($20 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($20 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($20 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($20 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  $21 = $5; //@line 682
  $22 = $6; //@line 683
  $23 = $22 + 88 | 0; //@line 684
  SAFE_HEAP_STORE($23 | 0, $21 | 0, 4);
  $24 = $4; //@line 686
  $25 = $24 + 32 | 0; //@line 687
  $26 = SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0; //@line 688
  $27 = $26 + 1 | 0; //@line 689
  SAFE_HEAP_STORE($25 | 0, $27 | 0, 4);
  STACKTOP = sp; //@line 691
  return;
 } else {
  _cpMessage(4581, 4624, 47, 1, 0, 4687, $vararg_buffer); //@line 693
  _abort(); //@line 694
 }
}
function _cpSpaceRemoveConstraint($0, $1) {
 $0 = $0 | 0; //@line 1828
 $1 = $1 | 0; //@line 1829
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 1830
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0; //@line 1831
 sp = STACKTOP; //@line 1832
 STACKTOP = STACKTOP + 32 | 0; //@line 1833
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 1833
 $vararg_buffer1 = sp + 8 | 0; //@line 1834
 $vararg_buffer = sp; //@line 1835
 $2 = $0; //@line 1836
 $3 = $1; //@line 1837
 $4 = $2; //@line 1838
 $5 = $3; //@line 1839
 $6 = _cpSpaceContainsConstraint($4, $5) | 0; //@line 1840
 $7 = $6 << 24 >> 24 != 0; //@line 1841
 if (!$7) {
  _cpMessage(7593, 6192, 560, 1, 1, 7638, $vararg_buffer); //@line 1843
  _abort(); //@line 1844
 }
 $8 = $2; //@line 1847
 $9 = $8 + 140 | 0; //@line 1848
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 1849
 $11 = ($10 | 0) != 0; //@line 1850
 if ($11) {
  _cpMessage(6649, 6192, 561, 1, 1, 6664, $vararg_buffer1); //@line 1852
  _abort(); //@line 1853
 } else {
  $12 = $3; //@line 1856
  $13 = $12 + 8 | 0; //@line 1857
  $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 1858
  _cpBodyActivate($14); //@line 1859
  $15 = $3; //@line 1860
  $16 = $15 + 12 | 0; //@line 1861
  $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 1862
  _cpBodyActivate($17); //@line 1863
  $18 = $2; //@line 1864
  $19 = $18 + 116 | 0; //@line 1865
  $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 1866
  $21 = $3; //@line 1867
  _cpArrayDeleteObj($20, $21); //@line 1868
  $22 = $3; //@line 1869
  $23 = $22 + 8 | 0; //@line 1870
  $24 = SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0; //@line 1871
  $25 = $3; //@line 1872
  _cpBodyRemoveConstraint($24, $25); //@line 1873
  $26 = $3; //@line 1874
  $27 = $26 + 12 | 0; //@line 1875
  $28 = SAFE_HEAP_LOAD($27 | 0, 4, 0) | 0 | 0; //@line 1876
  $29 = $3; //@line 1877
  _cpBodyRemoveConstraint($28, $29); //@line 1878
  $30 = $3; //@line 1879
  $31 = $30 + 4 | 0; //@line 1880
  SAFE_HEAP_STORE($31 | 0, 0 | 0, 4);
  STACKTOP = sp; //@line 1882
  return;
 }
}
function _unthreadHelper($0, $1) {
 $0 = $0 | 0; //@line 744
 $1 = $1 | 0; //@line 745
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 746
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 747
 sp = STACKTOP; //@line 748
 STACKTOP = STACKTOP + 32 | 0; //@line 749
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 749
 $2 = $0; //@line 750
 $3 = $1; //@line 751
 $7 = $2; //@line 752
 $8 = $3; //@line 753
 $9 = _cpArbiterThreadForBody($7, $8) | 0; //@line 754
 $4 = $9; //@line 755
 $10 = $4; //@line 756
 $11 = $10 + 4 | 0; //@line 757
 $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 758
 $5 = $12; //@line 759
 $13 = $4; //@line 760
 $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 761
 $6 = $14; //@line 762
 $15 = $5; //@line 763
 $16 = ($15 | 0) != (0 | 0); //@line 764
 if ($16) {
  $17 = $6; //@line 766
  $18 = $5; //@line 767
  $19 = $3; //@line 768
  $20 = _cpArbiterThreadForBody($18, $19) | 0; //@line 769
  SAFE_HEAP_STORE($20 | 0, $17 | 0, 4);
 } else {
  $21 = $3; //@line 772
  $22 = $21 + 216 | 0; //@line 773
  $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 774
  $24 = $2; //@line 775
  $25 = ($23 | 0) == ($24 | 0); //@line 776
  if ($25) {
   $26 = $6; //@line 778
   $27 = $3; //@line 779
   $28 = $27 + 216 | 0; //@line 780
   SAFE_HEAP_STORE($28 | 0, $26 | 0, 4);
  }
 }
 $29 = $6; //@line 784
 $30 = ($29 | 0) != (0 | 0); //@line 785
 if (!$30) {
  $36 = $4; //@line 787
  $37 = $36 + 4 | 0; //@line 788
  SAFE_HEAP_STORE($37 | 0, 0 | 0, 4);
  $38 = $4; //@line 790
  SAFE_HEAP_STORE($38 | 0, 0 | 0, 4);
  STACKTOP = sp; //@line 792
  return;
 }
 $31 = $5; //@line 794
 $32 = $6; //@line 795
 $33 = $3; //@line 796
 $34 = _cpArbiterThreadForBody($32, $33) | 0; //@line 797
 $35 = $34 + 4 | 0; //@line 798
 SAFE_HEAP_STORE($35 | 0, $31 | 0, 4);
 $36 = $4; //@line 800
 $37 = $36 + 4 | 0; //@line 801
 SAFE_HEAP_STORE($37 | 0, 0 | 0, 4);
 $38 = $4; //@line 803
 SAFE_HEAP_STORE($38 | 0, 0 | 0, 4);
 STACKTOP = sp; //@line 805
 return;
}
function _ThreadUnlink($0) {
 $0 = $0 | 0; //@line 4804
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0; //@line 4805
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 4806
 sp = STACKTOP; //@line 4807
 STACKTOP = STACKTOP + 16 | 0; //@line 4808
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 4808
 $3 = $0 + 8 | 0; //@line 4809
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 4810
 $1 = $4; //@line 4811
 $5 = SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0; //@line 4812
 $2 = $5; //@line 4813
 $6 = $1; //@line 4814
 $7 = ($6 | 0) != (0 | 0); //@line 4815
 do {
  if ($7) {
   $8 = $1; //@line 4818
   $9 = $8 + 4 | 0; //@line 4819
   $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 4820
   $11 = $0 + 4 | 0; //@line 4821
   $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 4822
   $13 = ($10 | 0) == ($12 | 0); //@line 4823
   $14 = $2; //@line 4824
   $15 = $1; //@line 4825
   if ($13) {
    SAFE_HEAP_STORE($15 | 0, $14 | 0, 4);
    break;
   } else {
    $16 = $15 + 12 | 0; //@line 4830
    SAFE_HEAP_STORE($16 | 0, $14 | 0, 4);
    break;
   }
  }
 } while (0);
 $17 = $2; //@line 4836
 $18 = ($17 | 0) != (0 | 0); //@line 4837
 if (!$18) {
  $30 = $1; //@line 4839
  $31 = $0 + 4 | 0; //@line 4840
  $32 = SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0; //@line 4841
  $33 = $32 + 44 | 0; //@line 4842
  $34 = $33 + 4 | 0; //@line 4843
  SAFE_HEAP_STORE($34 | 0, $30 | 0, 4);
  STACKTOP = sp; //@line 4845
  return;
 }
 $19 = $2; //@line 4847
 $20 = $19 + 4 | 0; //@line 4848
 $21 = SAFE_HEAP_LOAD($20 | 0, 4, 0) | 0 | 0; //@line 4849
 $22 = $0 + 4 | 0; //@line 4850
 $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 4851
 $24 = ($21 | 0) == ($23 | 0); //@line 4852
 $25 = $1; //@line 4853
 $26 = $2; //@line 4854
 if ($24) {
  $27 = $26 + 8 | 0; //@line 4856
  SAFE_HEAP_STORE($27 | 0, $25 | 0, 4);
  STACKTOP = sp; //@line 4858
  return;
 } else {
  $28 = $26 + 12 | 0; //@line 4860
  $29 = $28 + 8 | 0; //@line 4861
  SAFE_HEAP_STORE($29 | 0, $25 | 0, 4);
  STACKTOP = sp; //@line 4863
  return;
 }
}
function _SubtreeRemove($0, $1, $2) {
 $0 = $0 | 0; //@line 4537
 $1 = $1 | 0; //@line 4538
 $2 = $2 | 0; //@line 4539
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0; //@line 4540
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 4541
 sp = STACKTOP; //@line 4542
 STACKTOP = STACKTOP + 32 | 0; //@line 4543
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 4543
 $4 = $0; //@line 4544
 $5 = $1; //@line 4545
 $6 = $2; //@line 4546
 $9 = $5; //@line 4547
 $10 = $4; //@line 4548
 $11 = ($9 | 0) == ($10 | 0); //@line 4549
 if ($11) {
  $3 = 0; //@line 4551
  $38 = $3; //@line 4552
  STACKTOP = sp; //@line 4553
  return $38 | 0; //@line 4553
 }
 $12 = $5; //@line 4555
 $13 = $12 + 40 | 0; //@line 4556
 $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 4557
 $7 = $14; //@line 4558
 $15 = $7; //@line 4559
 $16 = $4; //@line 4560
 $17 = ($15 | 0) == ($16 | 0); //@line 4561
 if ($17) {
  $18 = $4; //@line 4563
  $19 = $5; //@line 4564
  $20 = _NodeOther($18, $19) | 0; //@line 4565
  $8 = $20; //@line 4566
  $21 = $4; //@line 4567
  $22 = $21 + 40 | 0; //@line 4568
  $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 4569
  $24 = $8; //@line 4570
  $25 = $24 + 40 | 0; //@line 4571
  SAFE_HEAP_STORE($25 | 0, $23 | 0, 4);
  $26 = $6; //@line 4573
  $27 = $4; //@line 4574
  _NodeRecycle($26, $27); //@line 4575
  $28 = $8; //@line 4576
  $3 = $28; //@line 4577
  $38 = $3; //@line 4578
  STACKTOP = sp; //@line 4579
  return $38 | 0; //@line 4579
 } else {
  $29 = $7; //@line 4581
  $30 = $29 + 40 | 0; //@line 4582
  $31 = SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0; //@line 4583
  $32 = $7; //@line 4584
  $33 = $7; //@line 4585
  $34 = $5; //@line 4586
  $35 = _NodeOther($33, $34) | 0; //@line 4587
  $36 = $6; //@line 4588
  _NodeReplaceChild($31, $32, $35, $36); //@line 4589
  $37 = $4; //@line 4590
  $3 = $37; //@line 4591
  $38 = $3; //@line 4592
  STACKTOP = sp; //@line 4593
  return $38 | 0; //@line 4593
 }
 return 0 | 0; //@line 4595
}
function _LeafAddPairs($0, $1) {
 $0 = $0 | 0; //@line 5314
 $1 = $1 | 0; //@line 5315
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 5316
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5317
 sp = STACKTOP; //@line 5318
 STACKTOP = STACKTOP + 64 | 0; //@line 5319
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 5319
 $7 = sp + 24 | 0; //@line 5320
 $9 = sp; //@line 5321
 $2 = $0; //@line 5322
 $3 = $1; //@line 5323
 $10 = $3; //@line 5324
 $11 = $10 + 12 | 0; //@line 5325
 $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 5326
 $4 = $12; //@line 5327
 $13 = $4; //@line 5328
 $14 = ($13 | 0) != (0 | 0); //@line 5329
 if (!$14) {
  $27 = $3; //@line 5331
  $28 = $27 + 8 | 0; //@line 5332
  $29 = SAFE_HEAP_LOAD($28 | 0, 4, 0) | 0 | 0; //@line 5333
  $30 = _GetRootIfTree($29) | 0; //@line 5334
  $8 = $30; //@line 5335
  $31 = $3; //@line 5336
  SAFE_HEAP_STORE($9 | 0, $31 | 0, 4);
  $32 = $9 + 4 | 0; //@line 5338
  $33 = $8; //@line 5339
  SAFE_HEAP_STORE($32 | 0, $33 | 0, 4);
  $34 = $9 + 8 | 0; //@line 5341
  SAFE_HEAP_STORE($34 | 0, 51 | 0, 4);
  $35 = $9 + 12 | 0; //@line 5343
  SAFE_HEAP_STORE($35 | 0, 0 | 0, 4);
  $36 = $2; //@line 5345
  _MarkLeaf($36, $9); //@line 5346
  STACKTOP = sp; //@line 5347
  return;
 }
 $15 = $4; //@line 5349
 $16 = _GetRootIfTree($15) | 0; //@line 5350
 $5 = $16; //@line 5351
 $17 = $5; //@line 5352
 $18 = ($17 | 0) != (0 | 0); //@line 5353
 if (!$18) {
  STACKTOP = sp; //@line 5355
  return;
 }
 $19 = $4; //@line 5357
 $20 = _GetTree($19) | 0; //@line 5358
 $6 = $20; //@line 5359
 $21 = $6; //@line 5360
 SAFE_HEAP_STORE($7 | 0, $21 | 0, 4);
 $22 = $7 + 4 | 0; //@line 5362
 SAFE_HEAP_STORE($22 | 0, 0 | 0, 4);
 $23 = $7 + 8 | 0; //@line 5364
 SAFE_HEAP_STORE($23 | 0, 0 | 0, 4);
 $24 = $7 + 12 | 0; //@line 5366
 SAFE_HEAP_STORE($24 | 0, 0 | 0, 4);
 $25 = $5; //@line 5368
 $26 = $2; //@line 5369
 _MarkLeafQuery($25, $26, 1, $7); //@line 5370
 STACKTOP = sp; //@line 5371
 return;
}
function _NodeFromPool($0) {
 $0 = $0 | 0; //@line 5089
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0; //@line 5090
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 5091
 sp = STACKTOP; //@line 5092
 STACKTOP = STACKTOP + 32 | 0; //@line 5093
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 5093
 $vararg_buffer = sp; //@line 5094
 $2 = $0; //@line 5095
 $7 = $2; //@line 5096
 $8 = $7 + 28 | 0; //@line 5097
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 5098
 $3 = $9; //@line 5099
 $10 = $3; //@line 5100
 $11 = ($10 | 0) != (0 | 0); //@line 5101
 if ($11) {
  $12 = $3; //@line 5103
  $13 = $12 + 40 | 0; //@line 5104
  $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 5105
  $15 = $2; //@line 5106
  $16 = $15 + 28 | 0; //@line 5107
  SAFE_HEAP_STORE($16 | 0, $14 | 0, 4);
  $17 = $3; //@line 5109
  $1 = $17; //@line 5110
  $35 = $1; //@line 5111
  STACKTOP = sp; //@line 5112
  return $35 | 0; //@line 5112
 }
 $4 = 585; //@line 5114
 $18 = $4; //@line 5115
 $19 = ($18 | 0) != 0; //@line 5116
 if (!$19) {
  _cpMessage(9930, 3342, 246, 1, 1, 5396, $vararg_buffer); //@line 5118
  _abort(); //@line 5119
 }
 $20 = _calloc(1, 32768) | 0; //@line 5122
 $5 = $20; //@line 5123
 $21 = $2; //@line 5124
 $22 = $21 + 36 | 0; //@line 5125
 $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 5126
 $24 = $5; //@line 5127
 _cpArrayPush($23, $24); //@line 5128
 $6 = 1; //@line 5129
 while (1) {
  $25 = $6; //@line 5131
  $26 = $4; //@line 5132
  $27 = ($25 | 0) < ($26 | 0); //@line 5133
  if (!$27) {
   break;
  }
  $28 = $2; //@line 5137
  $29 = $5; //@line 5138
  $30 = $6; //@line 5139
  $31 = $29 + ($30 * 56 | 0) | 0; //@line 5140
  _NodeRecycle($28, $31); //@line 5141
  $32 = $6; //@line 5142
  $33 = $32 + 1 | 0; //@line 5143
  $6 = $33; //@line 5144
 }
 $34 = $5; //@line 5146
 $1 = $34; //@line 5147
 $35 = $1; //@line 5148
 STACKTOP = sp; //@line 5149
 return $35 | 0; //@line 5149
}
function _getUnusedBin($0) {
 $0 = $0 | 0; //@line 2408
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0; //@line 2409
 var $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 2410
 sp = STACKTOP; //@line 2411
 STACKTOP = STACKTOP + 32 | 0; //@line 2412
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 2412
 $vararg_buffer = sp; //@line 2413
 $2 = $0; //@line 2414
 $7 = $2; //@line 2415
 $8 = $7 + 20 | 0; //@line 2416
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 2417
 $3 = $9; //@line 2418
 $10 = $3; //@line 2419
 $11 = ($10 | 0) != (0 | 0); //@line 2420
 if ($11) {
  $12 = $3; //@line 2422
  $13 = $12 + 8 | 0; //@line 2423
  $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 2424
  $15 = $2; //@line 2425
  $16 = $15 + 20 | 0; //@line 2426
  SAFE_HEAP_STORE($16 | 0, $14 | 0, 4);
  $17 = $3; //@line 2428
  $1 = $17; //@line 2429
  $35 = $1; //@line 2430
  STACKTOP = sp; //@line 2431
  return $35 | 0; //@line 2431
 }
 $4 = 2730; //@line 2433
 $18 = $4; //@line 2434
 $19 = ($18 | 0) != 0; //@line 2435
 if (!$19) {
  _cpMessage(9930, 5335, 135, 1, 1, 5396, $vararg_buffer); //@line 2437
  _abort(); //@line 2438
 }
 $20 = _calloc(1, 32768) | 0; //@line 2441
 $5 = $20; //@line 2442
 $21 = $2; //@line 2443
 $22 = $21 + 24 | 0; //@line 2444
 $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 2445
 $24 = $5; //@line 2446
 _cpArrayPush($23, $24); //@line 2447
 $6 = 1; //@line 2448
 while (1) {
  $25 = $6; //@line 2450
  $26 = $4; //@line 2451
  $27 = ($25 | 0) < ($26 | 0); //@line 2452
  if (!$27) {
   break;
  }
  $28 = $2; //@line 2456
  $29 = $5; //@line 2457
  $30 = $6; //@line 2458
  $31 = $29 + ($30 * 12 | 0) | 0; //@line 2459
  _recycleBin($28, $31); //@line 2460
  $32 = $6; //@line 2461
  $33 = $32 + 1 | 0; //@line 2462
  $6 = $33; //@line 2463
 }
 $34 = $5; //@line 2465
 $1 = $34; //@line 2466
 $35 = $1; //@line 2467
 STACKTOP = sp; //@line 2468
 return $35 | 0; //@line 2468
}
function _cpCircleShapeSegmentQuery($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 5955
 $1 = $1 | 0; //@line 5956
 $2 = $2 | 0; //@line 5957
 $3 = +$3; //@line 5958
 $4 = $4 | 0; //@line 5959
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0.0, $15 = 0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5960
 sp = STACKTOP; //@line 5961
 STACKTOP = STACKTOP + 64 | 0; //@line 5962
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 5962
 $$byval_copy2 = sp + 40 | 0; //@line 5963
 $$byval_copy1 = sp + 24 | 0; //@line 5964
 $$byval_copy = sp + 8 | 0; //@line 5965
 $5 = $0; //@line 5966
 $6 = $3; //@line 5967
 $7 = $4; //@line 5968
 $8 = $5; //@line 5969
 $9 = $5; //@line 5970
 $10 = $9 + 176 | 0; //@line 5971
 $11 = $5; //@line 5972
 $12 = $11 + 192 | 0; //@line 5973
 $13 = +(+SAFE_HEAP_LOAD_D($12 | 0, 8)); //@line 5974
 $14 = $6; //@line 5975
 $15 = $7; //@line 5976
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _CircleSegmentQuery_361($8, $$byval_copy, $13, $$byval_copy1, $$byval_copy2, $14, $15); //@line 5980
 STACKTOP = sp; //@line 5981
 return;
}
function _cpSpaceAddPostStepCallback($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 4056
 $1 = $1 | 0; //@line 4057
 $2 = $2 | 0; //@line 4058
 $3 = $3 | 0; //@line 4059
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0; //@line 4060
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 4061
 sp = STACKTOP; //@line 4062
 STACKTOP = STACKTOP + 32 | 0; //@line 4063
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 4063
 $vararg_buffer = sp; //@line 4064
 $5 = $0; //@line 4065
 $6 = $1; //@line 4066
 $7 = $2; //@line 4067
 $8 = $3; //@line 4068
 $10 = $5; //@line 4069
 $11 = $10 + 140 | 0; //@line 4070
 $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 4071
 $13 = ($12 | 0) != 0; //@line 4072
 if (!$13) {
  _cpMessage(9542, 9556, 45, 0, 0, 9619, $vararg_buffer); //@line 4074
 }
 $14 = $5; //@line 4076
 $15 = $7; //@line 4077
 $16 = _cpSpaceGetPostStepCallback($14, $15) | 0; //@line 4078
 $17 = ($16 | 0) != (0 | 0); //@line 4079
 if ($17) {
  $4 = 0; //@line 4081
  $34 = $4; //@line 4082
  STACKTOP = sp; //@line 4083
  return $34 | 0; //@line 4083
 } else {
  $18 = _calloc(1, 12) | 0; //@line 4085
  $9 = $18; //@line 4086
  $19 = $6; //@line 4087
  $20 = ($19 | 0) != (0 | 0); //@line 4088
  $21 = $6; //@line 4089
  $22 = $20 ? $21 : 72; //@line 4090
  $23 = $9; //@line 4091
  SAFE_HEAP_STORE($23 | 0, $22 | 0, 4);
  $24 = $7; //@line 4093
  $25 = $9; //@line 4094
  $26 = $25 + 4 | 0; //@line 4095
  SAFE_HEAP_STORE($26 | 0, $24 | 0, 4);
  $27 = $8; //@line 4097
  $28 = $9; //@line 4098
  $29 = $28 + 8 | 0; //@line 4099
  SAFE_HEAP_STORE($29 | 0, $27 | 0, 4);
  $30 = $5; //@line 4101
  $31 = $30 + 184 | 0; //@line 4102
  $32 = SAFE_HEAP_LOAD($31 | 0, 4, 0) | 0 | 0; //@line 4103
  $33 = $9; //@line 4104
  _cpArrayPush($32, $33); //@line 4105
  $4 = 1; //@line 4106
  $34 = $4; //@line 4107
  STACKTOP = sp; //@line 4108
  return $34 | 0; //@line 4108
 }
 return 0 | 0; //@line 4110
}
function _cpArrayPush($0, $1) {
 $0 = $0 | 0; //@line 2716
 $1 = $1 | 0; //@line 2717
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 2718
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2719
 sp = STACKTOP; //@line 2720
 STACKTOP = STACKTOP + 16 | 0; //@line 2721
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2721
 $2 = $0; //@line 2722
 $3 = $1; //@line 2723
 $4 = $2; //@line 2724
 $5 = SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0; //@line 2725
 $6 = $2; //@line 2726
 $7 = $6 + 4 | 0; //@line 2727
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 2728
 $9 = ($5 | 0) == ($8 | 0); //@line 2729
 if ($9) {
  $10 = $2; //@line 2731
  $11 = $10 + 4 | 0; //@line 2732
  $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 2733
  $13 = $12 + 1 | 0; //@line 2734
  $14 = $13 * 3 | 0; //@line 2735
  $15 = ($14 | 0) / 2 & -1; //@line 2736
  $16 = $2; //@line 2737
  $17 = $16 + 4 | 0; //@line 2738
  SAFE_HEAP_STORE($17 | 0, $15 | 0, 4);
  $18 = $2; //@line 2740
  $19 = $18 + 8 | 0; //@line 2741
  $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 2742
  $21 = $2; //@line 2743
  $22 = $21 + 4 | 0; //@line 2744
  $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 2745
  $24 = $23 << 2; //@line 2746
  $25 = _realloc($20, $24) | 0; //@line 2747
  $26 = $2; //@line 2748
  $27 = $26 + 8 | 0; //@line 2749
  SAFE_HEAP_STORE($27 | 0, $25 | 0, 4);
 }
 $28 = $3; //@line 2752
 $29 = $2; //@line 2753
 $30 = $29 + 8 | 0; //@line 2754
 $31 = SAFE_HEAP_LOAD($30 | 0, 4, 0) | 0 | 0; //@line 2755
 $32 = $2; //@line 2756
 $33 = SAFE_HEAP_LOAD($32 | 0, 4, 0) | 0 | 0; //@line 2757
 $34 = $31 + ($33 << 2) | 0; //@line 2758
 SAFE_HEAP_STORE($34 | 0, $28 | 0, 4);
 $35 = $2; //@line 2760
 $36 = SAFE_HEAP_LOAD($35 | 0, 4, 0) | 0 | 0; //@line 2761
 $37 = $36 + 1 | 0; //@line 2762
 SAFE_HEAP_STORE($35 | 0, $37 | 0, 4);
 STACKTOP = sp; //@line 2764
 return;
}
function _cpBodyRemoveShape($0, $1) {
 $0 = $0 | 0; //@line 7104
 $1 = $1 | 0; //@line 7105
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 7106
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0.0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 7107
 sp = STACKTOP; //@line 7108
 STACKTOP = STACKTOP + 16 | 0; //@line 7109
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7109
 $2 = $0; //@line 7110
 $3 = $1; //@line 7111
 $6 = $3; //@line 7112
 $7 = $6 + 152 | 0; //@line 7113
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 7114
 $4 = $8; //@line 7115
 $9 = $3; //@line 7116
 $10 = $9 + 148 | 0; //@line 7117
 $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 7118
 $5 = $11; //@line 7119
 $12 = $4; //@line 7120
 $13 = ($12 | 0) != (0 | 0); //@line 7121
 $14 = $5; //@line 7122
 if ($13) {
  $15 = $4; //@line 7124
  $16 = $15 + 148 | 0; //@line 7125
  SAFE_HEAP_STORE($16 | 0, $14 | 0, 4);
 } else {
  $17 = $2; //@line 7128
  $18 = $17 + 212 | 0; //@line 7129
  SAFE_HEAP_STORE($18 | 0, $14 | 0, 4);
 }
 $19 = $5; //@line 7132
 $20 = ($19 | 0) != (0 | 0); //@line 7133
 if ($20) {
  $21 = $4; //@line 7135
  $22 = $5; //@line 7136
  $23 = $22 + 152 | 0; //@line 7137
  SAFE_HEAP_STORE($23 | 0, $21 | 0, 4);
 }
 $24 = $3; //@line 7140
 $25 = $24 + 152 | 0; //@line 7141
 SAFE_HEAP_STORE($25 | 0, 0 | 0, 4);
 $26 = $3; //@line 7143
 $27 = $26 + 148 | 0; //@line 7144
 SAFE_HEAP_STORE($27 | 0, 0 | 0, 4);
 $28 = $2; //@line 7146
 $29 = _cpBodyGetType($28) | 0; //@line 7147
 $30 = ($29 | 0) == 0; //@line 7148
 if (!$30) {
  STACKTOP = sp; //@line 7150
  return;
 }
 $31 = $3; //@line 7152
 $32 = $31 + 16 | 0; //@line 7153
 $33 = +(+SAFE_HEAP_LOAD_D($32 | 0, 8)); //@line 7154
 $34 = $33 > 0.0; //@line 7155
 if (!$34) {
  STACKTOP = sp; //@line 7157
  return;
 }
 $35 = $2; //@line 7159
 _cpBodyAccumulateMassFromShapes($35); //@line 7160
 STACKTOP = sp; //@line 7161
 return;
}
function _cpCircleShapeInit($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 5784
 $1 = $1 | 0; //@line 5785
 $2 = +$2; //@line 5786
 $3 = $3 | 0; //@line 5787
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0.0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0.0, $16 = 0, $4 = 0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 5788
 sp = STACKTOP; //@line 5789
 STACKTOP = STACKTOP + 112 | 0; //@line 5790
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 5790
 $$byval_copy1 = sp + 64 | 0; //@line 5791
 $$byval_copy = sp + 48 | 0; //@line 5792
 $7 = sp; //@line 5793
 $4 = $0; //@line 5794
 $5 = $1; //@line 5795
 $6 = $2; //@line 5796
 $8 = $4; //@line 5797
 $9 = $8 + 160 | 0; //@line 5798
 SAFE_HEAP_STORE($9 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($9 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($9 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($9 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $10 = $6; //@line 5800
 $11 = $4; //@line 5801
 $12 = $11 + 192 | 0; //@line 5802
 SAFE_HEAP_STORE_D($12 | 0, +$10, 8);
 $13 = $4; //@line 5804
 $14 = $5; //@line 5805
 $15 = $6; //@line 5806
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpCircleShapeMassInfo($7, 0.0, $15, $$byval_copy); //@line 5808
 dest = $$byval_copy1; //@line 5809
 src = $7; //@line 5809
 stop = dest + 40 | 0; //@line 5809
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 5809
  src = src + 4 | 0; //@line 5809
 } while ((dest | 0) < (stop | 0));
 _cpShapeInit($13, 2656, $14, $$byval_copy1) | 0; //@line 5810
 $16 = $4; //@line 5811
 STACKTOP = sp; //@line 5812
 return $16 | 0; //@line 5812
}
function _cpMessage($0, $1, $2, $3, $4, $5, $varargs) {
 $0 = $0 | 0; //@line 110
 $1 = $1 | 0; //@line 111
 $2 = $2 | 0; //@line 112
 $3 = $3 | 0; //@line 113
 $4 = $4 | 0; //@line 114
 $5 = $5 | 0; //@line 115
 $varargs = $varargs | 0; //@line 116
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0; //@line 117
 var $vararg_buffer1 = 0, $vararg_buffer3 = 0, $vararg_buffer5 = 0, $vararg_ptr8 = 0, label = 0, sp = 0; //@line 118
 sp = STACKTOP; //@line 119
 STACKTOP = STACKTOP + 80 | 0; //@line 120
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(80 | 0); //@line 120
 $vararg_buffer5 = sp + 40 | 0; //@line 121
 $vararg_buffer3 = sp + 32 | 0; //@line 122
 $vararg_buffer1 = sp + 24 | 0; //@line 123
 $vararg_buffer = sp + 16 | 0; //@line 124
 $12 = sp; //@line 125
 $6 = $0; //@line 126
 $7 = $1; //@line 127
 $8 = $2; //@line 128
 $9 = $3; //@line 129
 $10 = $4; //@line 130
 $11 = $5; //@line 131
 $13 = SAFE_HEAP_LOAD(685 * 4 | 0, 4, 0) | 0 | 0; //@line 132
 $14 = $9; //@line 133
 $15 = ($14 | 0) != 0; //@line 134
 $16 = $15 ? 3250 : 3283; //@line 135
 _fprintf($13, $16, $vararg_buffer) | 0; //@line 136
 SAFE_HEAP_STORE($12 | 0, $varargs | 0, 4);
 $17 = SAFE_HEAP_LOAD(685 * 4 | 0, 4, 0) | 0 | 0; //@line 138
 $18 = $11; //@line 139
 _vfprintf($17, $18, $12) | 0; //@line 140
 $19 = SAFE_HEAP_LOAD(685 * 4 | 0, 4, 0) | 0 | 0; //@line 141
 _fprintf($19, 3302, $vararg_buffer1) | 0; //@line 142
 $20 = SAFE_HEAP_LOAD(685 * 4 | 0, 4, 0) | 0 | 0; //@line 143
 $21 = $6; //@line 144
 SAFE_HEAP_STORE($vararg_buffer3 | 0, $21 | 0, 4);
 _fprintf($20, 3304, $vararg_buffer3) | 0; //@line 146
 $22 = SAFE_HEAP_LOAD(685 * 4 | 0, 4, 0) | 0 | 0; //@line 147
 $23 = $7; //@line 148
 $24 = $8; //@line 149
 SAFE_HEAP_STORE($vararg_buffer5 | 0, $23 | 0, 4);
 $vararg_ptr8 = $vararg_buffer5 + 4 | 0; //@line 151
 SAFE_HEAP_STORE($vararg_ptr8 | 0, $24 | 0, 4);
 _fprintf($22, 3327, $vararg_buffer5) | 0; //@line 153
 STACKTOP = sp; //@line 154
 return;
}
function _cpCircleShapeMassInfo($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 5815
 $1 = +$1; //@line 5816
 $2 = +$2; //@line 5817
 $3 = $3 | 0; //@line 5818
 var $10 = 0.0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, $cpvzero$346$byval_copy = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP; //@line 5820
 STACKTOP = STACKTOP + 80 | 0; //@line 5821
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(80 | 0); //@line 5821
 $cpvzero$346$byval_copy = sp + 56 | 0; //@line 5822
 $6 = sp; //@line 5823
 $4 = $1; //@line 5824
 $5 = $2; //@line 5825
 $7 = $4; //@line 5826
 SAFE_HEAP_STORE_D($6 | 0, +$7, 8);
 $8 = $6 + 8 | 0; //@line 5828
 $9 = $5; //@line 5829
 SAFE_HEAP_STORE($cpvzero$346$byval_copy | 0, SAFE_HEAP_LOAD(11248 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($cpvzero$346$byval_copy + 4 | 0, SAFE_HEAP_LOAD(11248 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($cpvzero$346$byval_copy + 8 | 0, SAFE_HEAP_LOAD(11248 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($cpvzero$346$byval_copy + 12 | 0, SAFE_HEAP_LOAD(11248 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $10 = +_cpMomentForCircle(1.0, 0.0, $9, $cpvzero$346$byval_copy); //@line 5831
 SAFE_HEAP_STORE_D($8 | 0, +$10, 8);
 $11 = $6 + 16 | 0; //@line 5833
 SAFE_HEAP_STORE($11 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($11 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $12 = $6 + 32 | 0; //@line 5835
 $13 = $5; //@line 5836
 $14 = +_cpAreaForCircle(0.0, $13); //@line 5837
 SAFE_HEAP_STORE_D($12 | 0, +$14, 8);
 dest = $0; //@line 5839
 src = $6; //@line 5839
 stop = dest + 40 | 0; //@line 5839
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 5839
  src = src + 4 | 0; //@line 5839
 } while ((dest | 0) < (stop | 0));
 STACKTOP = sp; //@line 5840
 return;
}
function _cpSpaceAddBody($0, $1) {
 $0 = $0 | 0; //@line 1324
 $1 = $1 | 0; //@line 1325
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $3 = 0, $4 = 0, $5 = 0; //@line 1326
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer3 = 0, label = 0, sp = 0; //@line 1327
 sp = STACKTOP; //@line 1328
 STACKTOP = STACKTOP + 32 | 0; //@line 1329
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 1329
 $vararg_buffer3 = sp + 16 | 0; //@line 1330
 $vararg_buffer1 = sp + 8 | 0; //@line 1331
 $vararg_buffer = sp; //@line 1332
 $2 = $0; //@line 1333
 $3 = $1; //@line 1334
 $4 = $3; //@line 1335
 $5 = $4 + 208 | 0; //@line 1336
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 1337
 $7 = $2; //@line 1338
 $8 = ($6 | 0) != ($7 | 0); //@line 1339
 if (!$8) {
  _cpMessage(6794, 6192, 442, 1, 1, 6815, $vararg_buffer); //@line 1341
  _abort(); //@line 1342
 }
 $9 = $3; //@line 1345
 $10 = $9 + 208 | 0; //@line 1346
 $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 1347
 $12 = ($11 | 0) != (0 | 0); //@line 1348
 if ($12) {
  _cpMessage(6898, 6192, 443, 1, 1, 6911, $vararg_buffer1); //@line 1350
  _abort(); //@line 1351
 }
 $13 = $2; //@line 1354
 $14 = $13 + 140 | 0; //@line 1355
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 1356
 $16 = ($15 | 0) != 0; //@line 1357
 if ($16) {
  _cpMessage(6649, 6192, 444, 1, 1, 6664, $vararg_buffer3); //@line 1359
  _abort(); //@line 1360
 } else {
  $17 = $2; //@line 1363
  $18 = $3; //@line 1364
  $19 = _cpBodyGetType($18) | 0; //@line 1365
  $20 = _cpSpaceArrayForBodyType_457($17, $19) | 0; //@line 1366
  $21 = $3; //@line 1367
  _cpArrayPush($20, $21); //@line 1368
  $22 = $2; //@line 1369
  $23 = $3; //@line 1370
  $24 = $23 + 208 | 0; //@line 1371
  SAFE_HEAP_STORE($24 | 0, $22 | 0, 4);
  $25 = $3; //@line 1373
  STACKTOP = sp; //@line 1374
  return $25 | 0; //@line 1374
 }
 return 0 | 0; //@line 1376
}
function _cpSlideJointInit($0, $1, $2, $3, $4, $5, $6) {
 $0 = $0 | 0; //@line 7250
 $1 = $1 | 0; //@line 7251
 $2 = $2 | 0; //@line 7252
 $3 = $3 | 0; //@line 7253
 $4 = $4 | 0; //@line 7254
 $5 = +$5; //@line 7255
 $6 = +$6; //@line 7256
 var $10 = 0.0, $11 = 0.0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0.0, $20 = 0, $21 = 0, $22 = 0.0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0; //@line 7258
 sp = STACKTOP; //@line 7259
 STACKTOP = STACKTOP + 32 | 0; //@line 7260
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 7260
 $7 = $0; //@line 7261
 $8 = $1; //@line 7262
 $9 = $2; //@line 7263
 $10 = $5; //@line 7264
 $11 = $6; //@line 7265
 $12 = $7; //@line 7266
 $13 = $8; //@line 7267
 $14 = $9; //@line 7268
 _cpConstraintInit($12, 2696, $13, $14); //@line 7269
 $15 = $7; //@line 7270
 $16 = $15 + 64 | 0; //@line 7271
 SAFE_HEAP_STORE($16 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($16 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($16 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($16 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $17 = $7; //@line 7273
 $18 = $17 + 80 | 0; //@line 7274
 SAFE_HEAP_STORE($18 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($18 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($18 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($18 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $19 = $10; //@line 7276
 $20 = $7; //@line 7277
 $21 = $20 + 96 | 0; //@line 7278
 SAFE_HEAP_STORE_D($21 | 0, +$19, 8);
 $22 = $11; //@line 7280
 $23 = $7; //@line 7281
 $24 = $23 + 104 | 0; //@line 7282
 SAFE_HEAP_STORE_D($24 | 0, +$22, 8);
 $25 = $7; //@line 7284
 $26 = $25 + 168 | 0; //@line 7285
 SAFE_HEAP_STORE_D($26 | 0, +0.0, 8);
 $27 = $7; //@line 7287
 STACKTOP = sp; //@line 7288
 return $27 | 0; //@line 7288
}
function _cpSpaceGetPostStepCallback($0, $1) {
 $0 = $0 | 0; //@line 3996
 $1 = $1 | 0; //@line 3997
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 3998
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3999
 sp = STACKTOP; //@line 4000
 STACKTOP = STACKTOP + 32 | 0; //@line 4001
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 4001
 $3 = $0; //@line 4002
 $4 = $1; //@line 4003
 $8 = $3; //@line 4004
 $9 = $8 + 184 | 0; //@line 4005
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 4006
 $5 = $10; //@line 4007
 $6 = 0; //@line 4008
 while (1) {
  $11 = $6; //@line 4010
  $12 = $5; //@line 4011
  $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 4012
  $14 = ($11 | 0) < ($13 | 0); //@line 4013
  if (!$14) {
   label = 7; //@line 4015
   break;
  }
  $15 = $5; //@line 4018
  $16 = $15 + 8 | 0; //@line 4019
  $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 4020
  $18 = $6; //@line 4021
  $19 = $17 + ($18 << 2) | 0; //@line 4022
  $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 4023
  $7 = $20; //@line 4024
  $21 = $7; //@line 4025
  $22 = ($21 | 0) != (0 | 0); //@line 4026
  if ($22) {
   $23 = $7; //@line 4028
   $24 = $23 + 4 | 0; //@line 4029
   $25 = SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0; //@line 4030
   $26 = $4; //@line 4031
   $27 = ($25 | 0) == ($26 | 0); //@line 4032
   if ($27) {
    label = 5; //@line 4034
    break;
   }
  }
  $29 = $6; //@line 4038
  $30 = $29 + 1 | 0; //@line 4039
  $6 = $30; //@line 4040
 }
 if ((label | 0) == 5) {
  $28 = $7; //@line 4043
  $2 = $28; //@line 4044
  $31 = $2; //@line 4045
  STACKTOP = sp; //@line 4046
  return $31 | 0; //@line 4046
 } else if ((label | 0) == 7) {
  $2 = 0; //@line 4049
  $31 = $2; //@line 4050
  STACKTOP = sp; //@line 4051
  return $31 | 0; //@line 4051
 }
 return 0 | 0; //@line 4053
}
function _cpBBTreeSegmentQuery($0, $1, $2, $3, $4, $5, $6) {
 $0 = $0 | 0; //@line 3318
 $1 = $1 | 0; //@line 3319
 $2 = $2 | 0; //@line 3320
 $3 = $3 | 0; //@line 3321
 $4 = +$4; //@line 3322
 $5 = $5 | 0; //@line 3323
 $6 = $6 | 0; //@line 3324
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0.0, $21 = 0, $22 = 0, $7 = 0, $8 = 0, $9 = 0.0, label = 0, sp = 0; //@line 3325
 sp = STACKTOP; //@line 3326
 STACKTOP = STACKTOP + 64 | 0; //@line 3327
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 3327
 $$byval_copy1 = sp + 24 | 0; //@line 3328
 $$byval_copy = sp + 8 | 0; //@line 3329
 $7 = $0; //@line 3330
 $8 = $1; //@line 3331
 $9 = $4; //@line 3332
 $10 = $5; //@line 3333
 $11 = $6; //@line 3334
 $13 = $7; //@line 3335
 $14 = $13 + 24 | 0; //@line 3336
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 3337
 $12 = $15; //@line 3338
 $16 = $12; //@line 3339
 $17 = ($16 | 0) != (0 | 0); //@line 3340
 if (!$17) {
  STACKTOP = sp; //@line 3342
  return;
 }
 $18 = $12; //@line 3344
 $19 = $8; //@line 3345
 $20 = $9; //@line 3346
 $21 = $10; //@line 3347
 $22 = $11; //@line 3348
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 +_SubtreeSegmentQuery($18, $19, $$byval_copy, $$byval_copy1, $20, $21, $22);
 STACKTOP = sp; //@line 3352
 return;
}
function _cpConstraintInit($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 1964
 $1 = $1 | 0; //@line 1965
 $2 = $2 | 0; //@line 1966
 $3 = $3 | 0; //@line 1967
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0.0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0; //@line 1968
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1969
 sp = STACKTOP; //@line 1970
 STACKTOP = STACKTOP + 16 | 0; //@line 1971
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1971
 $4 = $0; //@line 1972
 $5 = $1; //@line 1973
 $6 = $2; //@line 1974
 $7 = $3; //@line 1975
 $8 = $5; //@line 1976
 $9 = $4; //@line 1977
 SAFE_HEAP_STORE($9 | 0, $8 | 0, 4);
 $10 = $6; //@line 1979
 $11 = $4; //@line 1980
 $12 = $11 + 8 | 0; //@line 1981
 SAFE_HEAP_STORE($12 | 0, $10 | 0, 4);
 $13 = $7; //@line 1983
 $14 = $4; //@line 1984
 $15 = $14 + 12 | 0; //@line 1985
 SAFE_HEAP_STORE($15 | 0, $13 | 0, 4);
 $16 = $4; //@line 1987
 $17 = $16 + 4 | 0; //@line 1988
 SAFE_HEAP_STORE($17 | 0, 0 | 0, 4);
 $18 = $4; //@line 1990
 $19 = $18 + 16 | 0; //@line 1991
 SAFE_HEAP_STORE($19 | 0, 0 | 0, 4);
 $20 = $4; //@line 1993
 $21 = $20 + 20 | 0; //@line 1994
 SAFE_HEAP_STORE($21 | 0, 0 | 0, 4);
 $22 = $4; //@line 1996
 $23 = $22 + 24 | 0; //@line 1997
 SAFE_HEAP_STORE_D($23 | 0, +inf, 8);
 $24 = +Math_pow(.8999999761581421, 60.0); //@line 1999
 $25 = $4; //@line 2000
 $26 = $25 + 32 | 0; //@line 2001
 SAFE_HEAP_STORE_D($26 | 0, +$24, 8);
 $27 = $4; //@line 2003
 $28 = $27 + 40 | 0; //@line 2004
 SAFE_HEAP_STORE_D($28 | 0, +inf, 8);
 $29 = $4; //@line 2006
 $30 = $29 + 48 | 0; //@line 2007
 SAFE_HEAP_STORE($30 >> 0 | 0, 1 | 0, 1);
 $31 = $4; //@line 2009
 $32 = $31 + 52 | 0; //@line 2010
 SAFE_HEAP_STORE($32 | 0, 0 | 0, 4);
 $33 = $4; //@line 2012
 $34 = $33 + 56 | 0; //@line 2013
 SAFE_HEAP_STORE($34 | 0, 0 | 0, 4);
 STACKTOP = sp; //@line 2015
 return;
}
function _cpArbiterCallWildcardPreSolveB($0, $1) {
 $0 = $0 | 0; //@line 1205
 $1 = $1 | 0; //@line 1206
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 1207
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1208
 sp = STACKTOP; //@line 1209
 STACKTOP = STACKTOP + 16 | 0; //@line 1210
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1210
 $2 = $0; //@line 1211
 $3 = $1; //@line 1212
 $6 = $2; //@line 1213
 $7 = $6 + 104 | 0; //@line 1214
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 1215
 $4 = $8; //@line 1216
 $9 = $2; //@line 1217
 $10 = $9 + 108 | 0; //@line 1218
 $11 = SAFE_HEAP_LOAD($10 >> 0 | 0, 1, 0) | 0 | 0; //@line 1219
 $12 = $11 << 24 >> 24 != 0; //@line 1220
 $13 = $12 ^ 1; //@line 1221
 $14 = $13 & 1; //@line 1222
 $15 = $14 & 255; //@line 1223
 $16 = $2; //@line 1224
 $17 = $16 + 108 | 0; //@line 1225
 SAFE_HEAP_STORE($17 >> 0 | 0, $15 | 0, 1);
 $18 = $4; //@line 1227
 $19 = $18 + 12 | 0; //@line 1228
 $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 1229
 $21 = $2; //@line 1230
 $22 = $3; //@line 1231
 $23 = $4; //@line 1232
 $24 = $23 + 24 | 0; //@line 1233
 $25 = SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0; //@line 1234
 $26 = FUNCTION_TABLE_iiii[(SAFE_FT_MASK($20 | 0, 127 | 0) | 0) & 127]($21, $22, $25) | 0; //@line 1235
 $5 = $26; //@line 1236
 $27 = $2; //@line 1237
 $28 = $27 + 108 | 0; //@line 1238
 $29 = SAFE_HEAP_LOAD($28 >> 0 | 0, 1, 0) | 0 | 0; //@line 1239
 $30 = $29 << 24 >> 24 != 0; //@line 1240
 $31 = $30 ^ 1; //@line 1241
 $32 = $31 & 1; //@line 1242
 $33 = $32 & 255; //@line 1243
 $34 = $2; //@line 1244
 $35 = $34 + 108 | 0; //@line 1245
 SAFE_HEAP_STORE($35 >> 0 | 0, $33 | 0, 1);
 $36 = $5; //@line 1247
 STACKTOP = sp; //@line 1248
 return $36 | 0; //@line 1248
}
function _cpArbiterCallWildcardBeginB($0, $1) {
 $0 = $0 | 0; //@line 1136
 $1 = $1 | 0; //@line 1137
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 1138
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1139
 sp = STACKTOP; //@line 1140
 STACKTOP = STACKTOP + 16 | 0; //@line 1141
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1141
 $2 = $0; //@line 1142
 $3 = $1; //@line 1143
 $6 = $2; //@line 1144
 $7 = $6 + 104 | 0; //@line 1145
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 1146
 $4 = $8; //@line 1147
 $9 = $2; //@line 1148
 $10 = $9 + 108 | 0; //@line 1149
 $11 = SAFE_HEAP_LOAD($10 >> 0 | 0, 1, 0) | 0 | 0; //@line 1150
 $12 = $11 << 24 >> 24 != 0; //@line 1151
 $13 = $12 ^ 1; //@line 1152
 $14 = $13 & 1; //@line 1153
 $15 = $14 & 255; //@line 1154
 $16 = $2; //@line 1155
 $17 = $16 + 108 | 0; //@line 1156
 SAFE_HEAP_STORE($17 >> 0 | 0, $15 | 0, 1);
 $18 = $4; //@line 1158
 $19 = $18 + 8 | 0; //@line 1159
 $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 1160
 $21 = $2; //@line 1161
 $22 = $3; //@line 1162
 $23 = $4; //@line 1163
 $24 = $23 + 24 | 0; //@line 1164
 $25 = SAFE_HEAP_LOAD($24 | 0, 4, 0) | 0 | 0; //@line 1165
 $26 = FUNCTION_TABLE_iiii[(SAFE_FT_MASK($20 | 0, 127 | 0) | 0) & 127]($21, $22, $25) | 0; //@line 1166
 $5 = $26; //@line 1167
 $27 = $2; //@line 1168
 $28 = $27 + 108 | 0; //@line 1169
 $29 = SAFE_HEAP_LOAD($28 >> 0 | 0, 1, 0) | 0 | 0; //@line 1170
 $30 = $29 << 24 >> 24 != 0; //@line 1171
 $31 = $30 ^ 1; //@line 1172
 $32 = $31 & 1; //@line 1173
 $33 = $32 & 255; //@line 1174
 $34 = $2; //@line 1175
 $35 = $34 + 108 | 0; //@line 1176
 SAFE_HEAP_STORE($35 >> 0 | 0, $33 | 0, 1);
 $36 = $5; //@line 1178
 STACKTOP = sp; //@line 1179
 return $36 | 0; //@line 1179
}
function _filterConstraints($0, $1, $2) {
 $0 = $0 | 0; //@line 7183
 $1 = $1 | 0; //@line 7184
 $2 = $2 | 0; //@line 7185
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0; //@line 7186
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 7187
 sp = STACKTOP; //@line 7188
 STACKTOP = STACKTOP + 16 | 0; //@line 7189
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7189
 $4 = $0; //@line 7190
 $5 = $1; //@line 7191
 $6 = $2; //@line 7192
 $7 = $4; //@line 7193
 $8 = $6; //@line 7194
 $9 = ($7 | 0) == ($8 | 0); //@line 7195
 $10 = $4; //@line 7196
 if ($9) {
  $11 = $5; //@line 7198
  $12 = _cpConstraintNext($10, $11) | 0; //@line 7199
  $3 = $12; //@line 7200
  $33 = $3; //@line 7201
  STACKTOP = sp; //@line 7202
  return $33 | 0; //@line 7202
 }
 $13 = $10 + 8 | 0; //@line 7204
 $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 7205
 $15 = $5; //@line 7206
 $16 = ($14 | 0) == ($15 | 0); //@line 7207
 $17 = $4; //@line 7208
 if ($16) {
  $18 = $17 + 16 | 0; //@line 7210
  $19 = SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0; //@line 7211
  $20 = $5; //@line 7212
  $21 = $6; //@line 7213
  $22 = _filterConstraints($19, $20, $21) | 0; //@line 7214
  $23 = $4; //@line 7215
  $24 = $23 + 16 | 0; //@line 7216
  SAFE_HEAP_STORE($24 | 0, $22 | 0, 4);
 } else {
  $25 = $17 + 20 | 0; //@line 7219
  $26 = SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0; //@line 7220
  $27 = $5; //@line 7221
  $28 = $6; //@line 7222
  $29 = _filterConstraints($26, $27, $28) | 0; //@line 7223
  $30 = $4; //@line 7224
  $31 = $30 + 20 | 0; //@line 7225
  SAFE_HEAP_STORE($31 | 0, $29 | 0, 4);
 }
 $32 = $4; //@line 7228
 $3 = $32; //@line 7229
 $33 = $3; //@line 7230
 STACKTOP = sp; //@line 7231
 return $33 | 0; //@line 7231
}
function _cpSpaceRemoveBody($0, $1) {
 $0 = $0 | 0; //@line 1758
 $1 = $1 | 0; //@line 1759
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0; //@line 1760
 var $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, $vararg_buffer3 = 0, label = 0, sp = 0; //@line 1761
 sp = STACKTOP; //@line 1762
 STACKTOP = STACKTOP + 32 | 0; //@line 1763
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 1763
 $vararg_buffer3 = sp + 16 | 0; //@line 1764
 $vararg_buffer1 = sp + 8 | 0; //@line 1765
 $vararg_buffer = sp; //@line 1766
 $2 = $0; //@line 1767
 $3 = $1; //@line 1768
 $4 = $3; //@line 1769
 $5 = $2; //@line 1770
 $6 = _cpSpaceGetStaticBody($5) | 0; //@line 1771
 $7 = ($4 | 0) != ($6 | 0); //@line 1772
 if (!$7) {
  _cpMessage(7391, 6192, 545, 1, 1, 7427, $vararg_buffer); //@line 1774
  _abort(); //@line 1775
 }
 $8 = $2; //@line 1778
 $9 = $3; //@line 1779
 $10 = _cpSpaceContainsBody($8, $9) | 0; //@line 1780
 $11 = $10 << 24 >> 24 != 0; //@line 1781
 if (!$11) {
  _cpMessage(7483, 6192, 546, 1, 1, 7516, $vararg_buffer1); //@line 1783
  _abort(); //@line 1784
 }
 $12 = $2; //@line 1787
 $13 = $12 + 140 | 0; //@line 1788
 $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 1789
 $15 = ($14 | 0) != 0; //@line 1790
 if ($15) {
  _cpMessage(6649, 6192, 549, 1, 1, 6664, $vararg_buffer3); //@line 1792
  _abort(); //@line 1793
 } else {
  $16 = $3; //@line 1796
  _cpBodyActivate($16); //@line 1797
  $17 = $2; //@line 1798
  $18 = $3; //@line 1799
  $19 = _cpBodyGetType($18) | 0; //@line 1800
  $20 = _cpSpaceArrayForBodyType_457($17, $19) | 0; //@line 1801
  $21 = $3; //@line 1802
  _cpArrayDeleteObj($20, $21); //@line 1803
  $22 = $3; //@line 1804
  $23 = $22 + 208 | 0; //@line 1805
  SAFE_HEAP_STORE($23 | 0, 0 | 0, 4);
  STACKTOP = sp; //@line 1807
  return;
 }
}
function _arbiterSetEql($0, $1) {
 $0 = $0 | 0; //@line 344
 $1 = $1 | 0; //@line 345
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 346
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 347
 sp = STACKTOP; //@line 348
 STACKTOP = STACKTOP + 16 | 0; //@line 349
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 349
 $2 = $0; //@line 350
 $3 = $1; //@line 351
 $6 = $2; //@line 352
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 353
 $4 = $7; //@line 354
 $8 = $2; //@line 355
 $9 = $8 + 4 | 0; //@line 356
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 357
 $5 = $10; //@line 358
 $11 = $4; //@line 359
 $12 = $3; //@line 360
 $13 = $12 + 36 | 0; //@line 361
 $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 362
 $15 = ($11 | 0) == ($14 | 0); //@line 363
 if ($15) {
  $16 = $5; //@line 365
  $17 = $3; //@line 366
  $18 = $17 + 40 | 0; //@line 367
  $19 = SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0; //@line 368
  $20 = ($16 | 0) == ($19 | 0); //@line 369
  if ($20) {
   $32 = 1; //@line 371
  } else {
   label = 3; //@line 373
  }
 } else {
  label = 3; //@line 376
 }
 if ((label | 0) == 3) {
  $21 = $5; //@line 379
  $22 = $3; //@line 380
  $23 = $22 + 36 | 0; //@line 381
  $24 = SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0; //@line 382
  $25 = ($21 | 0) == ($24 | 0); //@line 383
  if ($25) {
   $26 = $4; //@line 385
   $27 = $3; //@line 386
   $28 = $27 + 40 | 0; //@line 387
   $29 = SAFE_HEAP_LOAD($28 | 0, 4, 0) | 0 | 0; //@line 388
   $30 = ($26 | 0) == ($29 | 0); //@line 389
   $32 = $30; //@line 390
  } else {
   $32 = 0; //@line 392
  }
 }
 $31 = $32 & 1; //@line 395
 $33 = $31 & 255; //@line 396
 STACKTOP = sp; //@line 397
 return $33 | 0; //@line 397
}
function _dynamicToStaticIter($0, $1) {
 $0 = $0 | 0; //@line 5752
 $1 = $1 | 0; //@line 5753
 var $$byval_copy = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5754
 sp = STACKTOP; //@line 5755
 STACKTOP = STACKTOP + 80 | 0; //@line 5756
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(80 | 0); //@line 5756
 $$byval_copy = sp + 32 | 0; //@line 5757
 $4 = sp; //@line 5758
 $2 = $0; //@line 5759
 $3 = $1; //@line 5760
 $5 = $3; //@line 5761
 $6 = $5 + 4 | 0; //@line 5762
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 5763
 $8 = $2; //@line 5764
 $9 = $3; //@line 5765
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 5766
 $11 = $2; //@line 5767
 FUNCTION_TABLE_vii[(SAFE_FT_MASK($10 | 0, 127 | 0) | 0) & 127]($4, $11); //@line 5768
 $12 = $3; //@line 5769
 $13 = $12 + 8 | 0; //@line 5770
 $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 5771
 $15 = $3; //@line 5772
 $16 = $15 + 12 | 0; //@line 5773
 $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 5774
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 16 | 0, SAFE_HEAP_LOAD($4 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 20 | 0, SAFE_HEAP_LOAD($4 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 24 | 0, SAFE_HEAP_LOAD($4 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 28 | 0, SAFE_HEAP_LOAD($4 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpSpatialIndexQuery_599($7, $8, $$byval_copy, $14, $17); //@line 5776
 STACKTOP = sp; //@line 5777
 return;
}
function _LeafNew($0, $1, $2) {
 $0 = $0 | 0; //@line 5436
 $1 = $1 | 0; //@line 5437
 $2 = $2 | 0; //@line 5438
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0; //@line 5439
 var label = 0, sp = 0; //@line 5440
 sp = STACKTOP; //@line 5441
 STACKTOP = STACKTOP + 48 | 0; //@line 5442
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 5442
 $6 = sp; //@line 5443
 $3 = $0; //@line 5444
 $4 = $1; //@line 5445
 $7 = $3; //@line 5446
 $8 = _NodeFromPool($7) | 0; //@line 5447
 $5 = $8; //@line 5448
 $9 = $4; //@line 5449
 $10 = $5; //@line 5450
 SAFE_HEAP_STORE($10 | 0, $9 | 0, 4);
 $11 = $5; //@line 5452
 $12 = $11 + 8 | 0; //@line 5453
 $13 = $3; //@line 5454
 $14 = $4; //@line 5455
 _GetBB($6, $13, $14); //@line 5456
 SAFE_HEAP_STORE($12 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 16 | 0, SAFE_HEAP_LOAD($6 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 20 | 0, SAFE_HEAP_LOAD($6 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 24 | 0, SAFE_HEAP_LOAD($6 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 28 | 0, SAFE_HEAP_LOAD($6 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 $15 = $5; //@line 5458
 $16 = $15 + 40 | 0; //@line 5459
 SAFE_HEAP_STORE($16 | 0, 0 | 0, 4);
 $17 = $5; //@line 5461
 $18 = $17 + 44 | 0; //@line 5462
 SAFE_HEAP_STORE($18 | 0, 0 | 0, 4);
 $19 = $5; //@line 5464
 $20 = $19 + 44 | 0; //@line 5465
 $21 = $20 + 4 | 0; //@line 5466
 SAFE_HEAP_STORE($21 | 0, 0 | 0, 4);
 $22 = $5; //@line 5468
 STACKTOP = sp; //@line 5469
 return $22 | 0; //@line 5469
}
function _memset(ptr, value, num) {
 ptr = ptr | 0; //@line 72
 value = value | 0; //@line 72
 num = num | 0; //@line 72
 var end = 0, aligned_end = 0, block_aligned_end = 0, value4 = 0; //@line 73
 end = ptr + num | 0; //@line 74
 value = value & 255; //@line 76
 if ((num | 0) >= 67) {
  while ((ptr & 3) != 0) {
   SAFE_HEAP_STORE(ptr | 0, value | 0, 1); //@line 79
   ptr = ptr + 1 | 0; //@line 80
  }
  aligned_end = end & -4 | 0; //@line 83
  block_aligned_end = aligned_end - 64 | 0; //@line 84
  value4 = value | value << 8 | value << 16 | value << 24; //@line 85
  while ((ptr | 0) <= (block_aligned_end | 0)) {
   SAFE_HEAP_STORE(ptr | 0, value4 | 0, 4); //@line 88
   SAFE_HEAP_STORE(ptr + 4 | 0, value4 | 0, 4); //@line 89
   SAFE_HEAP_STORE(ptr + 8 | 0, value4 | 0, 4); //@line 90
   SAFE_HEAP_STORE(ptr + 12 | 0, value4 | 0, 4); //@line 91
   SAFE_HEAP_STORE(ptr + 16 | 0, value4 | 0, 4); //@line 92
   SAFE_HEAP_STORE(ptr + 20 | 0, value4 | 0, 4); //@line 93
   SAFE_HEAP_STORE(ptr + 24 | 0, value4 | 0, 4); //@line 94
   SAFE_HEAP_STORE(ptr + 28 | 0, value4 | 0, 4); //@line 95
   SAFE_HEAP_STORE(ptr + 32 | 0, value4 | 0, 4); //@line 96
   SAFE_HEAP_STORE(ptr + 36 | 0, value4 | 0, 4); //@line 97
   SAFE_HEAP_STORE(ptr + 40 | 0, value4 | 0, 4); //@line 98
   SAFE_HEAP_STORE(ptr + 44 | 0, value4 | 0, 4); //@line 99
   SAFE_HEAP_STORE(ptr + 48 | 0, value4 | 0, 4); //@line 100
   SAFE_HEAP_STORE(ptr + 52 | 0, value4 | 0, 4); //@line 101
   SAFE_HEAP_STORE(ptr + 56 | 0, value4 | 0, 4); //@line 102
   SAFE_HEAP_STORE(ptr + 60 | 0, value4 | 0, 4); //@line 103
   ptr = ptr + 64 | 0; //@line 104
  }
  while ((ptr | 0) < (aligned_end | 0)) {
   SAFE_HEAP_STORE(ptr | 0, value4 | 0, 4); //@line 108
   ptr = ptr + 4 | 0; //@line 109
  }
 }
 while ((ptr | 0) < (end | 0)) {
  SAFE_HEAP_STORE(ptr | 0, value | 0, 1); //@line 114
  ptr = ptr + 1 | 0; //@line 115
 }
 return end - num | 0; //@line 117
}
function _cpArbiterCallWildcardPostSolveB($0, $1) {
 $0 = $0 | 0; //@line 1274
 $1 = $1 | 0; //@line 1275
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 1276
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1277
 sp = STACKTOP; //@line 1278
 STACKTOP = STACKTOP + 16 | 0; //@line 1279
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1279
 $2 = $0; //@line 1280
 $3 = $1; //@line 1281
 $5 = $2; //@line 1282
 $6 = $5 + 104 | 0; //@line 1283
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 1284
 $4 = $7; //@line 1285
 $8 = $2; //@line 1286
 $9 = $8 + 108 | 0; //@line 1287
 $10 = SAFE_HEAP_LOAD($9 >> 0 | 0, 1, 0) | 0 | 0; //@line 1288
 $11 = $10 << 24 >> 24 != 0; //@line 1289
 $12 = $11 ^ 1; //@line 1290
 $13 = $12 & 1; //@line 1291
 $14 = $13 & 255; //@line 1292
 $15 = $2; //@line 1293
 $16 = $15 + 108 | 0; //@line 1294
 SAFE_HEAP_STORE($16 >> 0 | 0, $14 | 0, 1);
 $17 = $4; //@line 1296
 $18 = $17 + 16 | 0; //@line 1297
 $19 = SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0; //@line 1298
 $20 = $2; //@line 1299
 $21 = $3; //@line 1300
 $22 = $4; //@line 1301
 $23 = $22 + 24 | 0; //@line 1302
 $24 = SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0; //@line 1303
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($19 | 0, 127 | 0) | 0) & 127]($20, $21, $24); //@line 1304
 $25 = $2; //@line 1305
 $26 = $25 + 108 | 0; //@line 1306
 $27 = SAFE_HEAP_LOAD($26 >> 0 | 0, 1, 0) | 0 | 0; //@line 1307
 $28 = $27 << 24 >> 24 != 0; //@line 1308
 $29 = $28 ^ 1; //@line 1309
 $30 = $29 & 1; //@line 1310
 $31 = $30 & 255; //@line 1311
 $32 = $2; //@line 1312
 $33 = $32 + 108 | 0; //@line 1313
 SAFE_HEAP_STORE($33 >> 0 | 0, $31 | 0, 1);
 STACKTOP = sp; //@line 1315
 return;
}
function _cpArbiterCallWildcardSeparateB($0, $1) {
 $0 = $0 | 0; //@line 1341
 $1 = $1 | 0; //@line 1342
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 1343
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1344
 sp = STACKTOP; //@line 1345
 STACKTOP = STACKTOP + 16 | 0; //@line 1346
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1346
 $2 = $0; //@line 1347
 $3 = $1; //@line 1348
 $5 = $2; //@line 1349
 $6 = $5 + 104 | 0; //@line 1350
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 1351
 $4 = $7; //@line 1352
 $8 = $2; //@line 1353
 $9 = $8 + 108 | 0; //@line 1354
 $10 = SAFE_HEAP_LOAD($9 >> 0 | 0, 1, 0) | 0 | 0; //@line 1355
 $11 = $10 << 24 >> 24 != 0; //@line 1356
 $12 = $11 ^ 1; //@line 1357
 $13 = $12 & 1; //@line 1358
 $14 = $13 & 255; //@line 1359
 $15 = $2; //@line 1360
 $16 = $15 + 108 | 0; //@line 1361
 SAFE_HEAP_STORE($16 >> 0 | 0, $14 | 0, 1);
 $17 = $4; //@line 1363
 $18 = $17 + 20 | 0; //@line 1364
 $19 = SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0; //@line 1365
 $20 = $2; //@line 1366
 $21 = $3; //@line 1367
 $22 = $4; //@line 1368
 $23 = $22 + 24 | 0; //@line 1369
 $24 = SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0; //@line 1370
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($19 | 0, 127 | 0) | 0) & 127]($20, $21, $24); //@line 1371
 $25 = $2; //@line 1372
 $26 = $25 + 108 | 0; //@line 1373
 $27 = SAFE_HEAP_LOAD($26 >> 0 | 0, 1, 0) | 0 | 0; //@line 1374
 $28 = $27 << 24 >> 24 != 0; //@line 1375
 $29 = $28 ^ 1; //@line 1376
 $30 = $29 & 1; //@line 1377
 $31 = $30 & 255; //@line 1378
 $32 = $2; //@line 1379
 $33 = $32 + 108 | 0; //@line 1380
 SAFE_HEAP_STORE($33 >> 0 | 0, $31 | 0, 1);
 STACKTOP = sp; //@line 1382
 return;
}
function _handlerSetEql($0, $1) {
 $0 = $0 | 0; //@line 400
 $1 = $1 | 0; //@line 401
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 402
 var $29 = 0, $3 = 0, $30 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 403
 sp = STACKTOP; //@line 404
 STACKTOP = STACKTOP + 16 | 0; //@line 405
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 405
 $2 = $0; //@line 406
 $3 = $1; //@line 407
 $4 = $2; //@line 408
 $5 = SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0; //@line 409
 $6 = $3; //@line 410
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 411
 $8 = ($5 | 0) == ($7 | 0); //@line 412
 if ($8) {
  $9 = $2; //@line 414
  $10 = $9 + 4 | 0; //@line 415
  $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 416
  $12 = $3; //@line 417
  $13 = $12 + 4 | 0; //@line 418
  $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 419
  $15 = ($11 | 0) == ($14 | 0); //@line 420
  if ($15) {
   $29 = 1; //@line 422
  } else {
   label = 3; //@line 424
  }
 } else {
  label = 3; //@line 427
 }
 if ((label | 0) == 3) {
  $16 = $2; //@line 430
  $17 = $16 + 4 | 0; //@line 431
  $18 = SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0; //@line 432
  $19 = $3; //@line 433
  $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 434
  $21 = ($18 | 0) == ($20 | 0); //@line 435
  if ($21) {
   $22 = $2; //@line 437
   $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 438
   $24 = $3; //@line 439
   $25 = $24 + 4 | 0; //@line 440
   $26 = SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0; //@line 441
   $27 = ($23 | 0) == ($26 | 0); //@line 442
   $29 = $27; //@line 443
  } else {
   $29 = 0; //@line 445
  }
 }
 $28 = $29 & 1; //@line 448
 $30 = $28 & 255; //@line 449
 STACKTOP = sp; //@line 450
 return $30 | 0; //@line 450
}
function _cpBodySetMass($0, $1) {
 $0 = $0 | 0; //@line 5799
 $1 = +$1; //@line 5800
 var $10 = 0, $11 = 0, $12 = 0.0, $13 = 0, $14 = 0, $15 = 0.0, $16 = 0, $17 = 0.0, $18 = 0.0, $19 = 0, $2 = 0, $20 = 0, $21 = 0.0, $22 = 0, $3 = 0.0, $4 = 0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0; //@line 5801
 var $9 = 0.0, $or$cond = 0, $vararg_buffer = 0, $vararg_buffer2 = 0, label = 0, sp = 0;
 sp = STACKTOP; //@line 5803
 STACKTOP = STACKTOP + 32 | 0; //@line 5804
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 5804
 $vararg_buffer2 = sp + 16 | 0; //@line 5805
 $vararg_buffer = sp + 8 | 0; //@line 5806
 $2 = $0; //@line 5807
 $3 = $1; //@line 5808
 $4 = $2; //@line 5809
 $5 = _cpBodyGetType($4) | 0; //@line 5810
 $6 = ($5 | 0) == 0; //@line 5811
 if (!$6) {
  _cpMessage(7834, 3674, 256, 1, 1, 4352, $vararg_buffer); //@line 5813
  _abort(); //@line 5814
 }
 $7 = $3; //@line 5817
 $8 = 0.0 <= $7; //@line 5818
 $9 = $3; //@line 5819
 $10 = $9 < inf; //@line 5820
 $or$cond = $8 & $10; //@line 5821
 if (!$or$cond) {
  _cpMessage(4407, 3674, 257, 1, 1, 4439, $vararg_buffer2); //@line 5823
  _abort(); //@line 5824
 }
 $11 = $2; //@line 5827
 _cpBodyActivate($11); //@line 5828
 $12 = $3; //@line 5829
 $13 = $2; //@line 5830
 $14 = $13 + 8 | 0; //@line 5831
 SAFE_HEAP_STORE_D($14 | 0, +$12, 8);
 $15 = $3; //@line 5833
 $16 = $15 == 0.0; //@line 5834
 if ($16) {
  $21 = inf; //@line 5836
  $19 = $2; //@line 5837
  $20 = $19 + 16 | 0; //@line 5838
  SAFE_HEAP_STORE_D($20 | 0, +$21, 8);
  $22 = $2; //@line 5840
  _cpBodySanityCheck($22); //@line 5841
  STACKTOP = sp; //@line 5842
  return;
 }
 $17 = $3; //@line 5844
 $18 = 1.0 / $17; //@line 5845
 $21 = $18; //@line 5846
 $19 = $2; //@line 5847
 $20 = $19 + 16 | 0; //@line 5848
 SAFE_HEAP_STORE_D($20 | 0, +$21, 8);
 $22 = $2; //@line 5850
 _cpBodySanityCheck($22); //@line 5851
 STACKTOP = sp; //@line 5852
 return;
}
function _cpPivotJointInit($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 2873
 $1 = $1 | 0; //@line 2874
 $2 = $2 | 0; //@line 2875
 $3 = $3 | 0; //@line 2876
 $4 = $4 | 0; //@line 2877
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2878
 sp = STACKTOP; //@line 2879
 STACKTOP = STACKTOP + 16 | 0; //@line 2880
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2880
 $5 = $0; //@line 2881
 $6 = $1; //@line 2882
 $7 = $2; //@line 2883
 $8 = $5; //@line 2884
 $9 = $6; //@line 2885
 $10 = $7; //@line 2886
 _cpConstraintInit($8, 2620, $9, $10); //@line 2887
 $11 = $5; //@line 2888
 $12 = $11 + 64 | 0; //@line 2889
 SAFE_HEAP_STORE($12 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($12 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $13 = $5; //@line 2891
 $14 = $13 + 80 | 0; //@line 2892
 SAFE_HEAP_STORE($14 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($14 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($14 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($14 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $15 = $5; //@line 2894
 $16 = $15 + 160 | 0; //@line 2895
 SAFE_HEAP_STORE($16 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($16 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($16 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($16 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $17 = $5; //@line 2897
 STACKTOP = sp; //@line 2898
 return $17 | 0; //@line 2898
}
function _PolySupportPoint($0, $1, $2) {
 $0 = $0 | 0; //@line 8476
 $1 = $1 | 0; //@line 8477
 $2 = $2 | 0; //@line 8478
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 8479
 sp = STACKTOP; //@line 8480
 STACKTOP = STACKTOP + 48 | 0; //@line 8481
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 8481
 $$byval_copy1 = sp + 16 | 0; //@line 8482
 $$byval_copy = sp; //@line 8483
 $3 = $1; //@line 8484
 $6 = $3; //@line 8485
 $7 = $6 + 172 | 0; //@line 8486
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 8487
 $4 = $8; //@line 8488
 $9 = $3; //@line 8489
 $10 = $9 + 168 | 0; //@line 8490
 $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 8491
 $12 = $4; //@line 8492
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $13 = _PolySupportPointIndex($11, $12, $$byval_copy) | 0; //@line 8494
 $5 = $13; //@line 8495
 $14 = $4; //@line 8496
 $15 = $5; //@line 8497
 $16 = $14 + ($15 << 5) | 0; //@line 8498
 $17 = $5; //@line 8499
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($16 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($16 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($16 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _SupportPointNew($0, $$byval_copy1, $17); //@line 8501
 STACKTOP = sp; //@line 8502
 return;
}
function _cpBBTreeQuery($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 3287
 $1 = $1 | 0; //@line 3288
 $2 = $2 | 0; //@line 3289
 $3 = $3 | 0; //@line 3290
 $4 = $4 | 0; //@line 3291
 var $$byval_copy = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3292
 sp = STACKTOP; //@line 3293
 STACKTOP = STACKTOP + 48 | 0; //@line 3294
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 3294
 $$byval_copy = sp; //@line 3295
 $5 = $0; //@line 3296
 $6 = $1; //@line 3297
 $7 = $3; //@line 3298
 $8 = $4; //@line 3299
 $9 = $5; //@line 3300
 $10 = $9 + 24 | 0; //@line 3301
 $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 3302
 $12 = ($11 | 0) != (0 | 0); //@line 3303
 if (!$12) {
  STACKTOP = sp; //@line 3305
  return;
 }
 $13 = $5; //@line 3307
 $14 = $13 + 24 | 0; //@line 3308
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 3309
 $16 = $6; //@line 3310
 $17 = $7; //@line 3311
 $18 = $8; //@line 3312
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 16 | 0, SAFE_HEAP_LOAD($2 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 20 | 0, SAFE_HEAP_LOAD($2 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 24 | 0, SAFE_HEAP_LOAD($2 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 28 | 0, SAFE_HEAP_LOAD($2 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 _SubtreeQuery($15, $16, $$byval_copy, $17, $18); //@line 3314
 STACKTOP = sp; //@line 3315
 return;
}
function _cpHashSetEach($0, $1, $2) {
 $0 = $0 | 0; //@line 2739
 $1 = $1 | 0; //@line 2740
 $2 = $2 | 0; //@line 2741
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0; //@line 2742
 var $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2743
 sp = STACKTOP; //@line 2744
 STACKTOP = STACKTOP + 32 | 0; //@line 2745
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 2745
 $3 = $0; //@line 2746
 $4 = $1; //@line 2747
 $5 = $2; //@line 2748
 $6 = 0; //@line 2749
 while (1) {
  $9 = $6; //@line 2751
  $10 = $3; //@line 2752
  $11 = $10 + 4 | 0; //@line 2753
  $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 2754
  $13 = $9 >>> 0 < $12 >>> 0; //@line 2755
  if (!$13) {
   break;
  }
  $14 = $3; //@line 2759
  $15 = $14 + 16 | 0; //@line 2760
  $16 = SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0; //@line 2761
  $17 = $6; //@line 2762
  $18 = $16 + ($17 << 2) | 0; //@line 2763
  $19 = SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0; //@line 2764
  $7 = $19; //@line 2765
  while (1) {
   $20 = $7; //@line 2767
   $21 = ($20 | 0) != (0 | 0); //@line 2768
   if (!$21) {
    break;
   }
   $22 = $7; //@line 2772
   $23 = $22 + 8 | 0; //@line 2773
   $24 = SAFE_HEAP_LOAD($23 | 0, 4, 0) | 0 | 0; //@line 2774
   $8 = $24; //@line 2775
   $25 = $4; //@line 2776
   $26 = $7; //@line 2777
   $27 = SAFE_HEAP_LOAD($26 | 0, 4, 0) | 0 | 0; //@line 2778
   $28 = $5; //@line 2779
   FUNCTION_TABLE_vii[(SAFE_FT_MASK($25 | 0, 127 | 0) | 0) & 127]($27, $28); //@line 2780
   $29 = $8; //@line 2781
   $7 = $29; //@line 2782
  }
  $30 = $6; //@line 2784
  $31 = $30 + 1 | 0; //@line 2785
  $6 = $31; //@line 2786
 }
 STACKTOP = sp; //@line 2788
 return;
}
function ___strerror_l($0, $1) {
 $0 = $0 | 0; //@line 14059
 $1 = $1 | 0; //@line 14060
 var $$012$lcssa = 0, $$01214 = 0, $$016 = 0, $$113 = 0, $$115 = 0, $$115$ph = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0; //@line 14061
 var $9 = 0, label = 0, sp = 0; //@line 14062
 sp = STACKTOP; //@line 14063
 $$016 = 0; //@line 14064
 while (1) {
  $2 = 672 + $$016 | 0; //@line 14066
  $3 = SAFE_HEAP_LOAD($2 >> 0 | 0, 1, 0) | 0 | 0; //@line 14067
  $4 = $3 & 255; //@line 14068
  $5 = ($4 | 0) == ($0 | 0); //@line 14069
  if ($5) {
   label = 4; //@line 14071
   break;
  }
  $6 = $$016 + 1 | 0; //@line 14074
  $7 = ($6 | 0) == 87; //@line 14075
  if ($7) {
   $$115$ph = 87; //@line 14077
   label = 5; //@line 14078
   break;
  } else {
   $$016 = $6; //@line 14081
  }
 }
 if ((label | 0) == 4) {
  $8 = ($$016 | 0) == 0; //@line 14085
  if ($8) {
   $$012$lcssa = 768; //@line 14087
  } else {
   $$115$ph = $$016; //@line 14089
   label = 5; //@line 14090
  }
 }
 if ((label | 0) == 5) {
  $$01214 = 768; //@line 14094
  $$115 = $$115$ph; //@line 14094
  while (1) {
   $$113 = $$01214; //@line 14096
   while (1) {
    $9 = SAFE_HEAP_LOAD($$113 >> 0 | 0, 1, 0) | 0 | 0; //@line 14098
    $10 = $9 << 24 >> 24 == 0; //@line 14099
    $11 = $$113 + 1 | 0; //@line 14100
    if ($10) {
     break;
    } else {
     $$113 = $11; //@line 14104
    }
   }
   $12 = $$115 + -1 | 0; //@line 14107
   $13 = ($12 | 0) == 0; //@line 14108
   if ($13) {
    $$012$lcssa = $11; //@line 14110
    break;
   } else {
    $$01214 = $11; //@line 14113
    $$115 = $12; //@line 14113
   }
  }
 }
 $14 = $1 + 20 | 0; //@line 14117
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 14118
 $16 = ___lctrans($$012$lcssa, $15) | 0; //@line 14119
 return $16 | 0; //@line 14120
}
function ___fflush_unlocked($0) {
 $0 = $0 | 0; //@line 11193
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0; //@line 11194
 var $9 = 0, label = 0, sp = 0; //@line 11195
 sp = STACKTOP; //@line 11196
 $1 = $0 + 20 | 0; //@line 11197
 $2 = SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0; //@line 11198
 $3 = $0 + 28 | 0; //@line 11199
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 11200
 $5 = $2 >>> 0 > $4 >>> 0; //@line 11201
 if ($5) {
  $6 = $0 + 36 | 0; //@line 11203
  $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 11204
  FUNCTION_TABLE_iiii[(SAFE_FT_MASK($7 | 0, 127 | 0) | 0) & 127]($0, 0, 0) | 0; //@line 11205
  $8 = SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0; //@line 11206
  $9 = ($8 | 0) == (0 | 0); //@line 11207
  if ($9) {
   $$0 = -1; //@line 11209
  } else {
   label = 3; //@line 11211
  }
 } else {
  label = 3; //@line 11214
 }
 if ((label | 0) == 3) {
  $10 = $0 + 4 | 0; //@line 11217
  $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 11218
  $12 = $0 + 8 | 0; //@line 11219
  $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 11220
  $14 = $11 >>> 0 < $13 >>> 0; //@line 11221
  if ($14) {
   $15 = $11; //@line 11223
   $16 = $13; //@line 11224
   $17 = $15 - $16 | 0; //@line 11225
   $18 = $0 + 40 | 0; //@line 11226
   $19 = SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0; //@line 11227
   FUNCTION_TABLE_iiii[(SAFE_FT_MASK($19 | 0, 127 | 0) | 0) & 127]($0, $17, 1) | 0; //@line 11228
  }
  $20 = $0 + 16 | 0; //@line 11230
  SAFE_HEAP_STORE($20 | 0, 0 | 0, 4);
  SAFE_HEAP_STORE($3 | 0, 0 | 0, 4);
  SAFE_HEAP_STORE($1 | 0, 0 | 0, 4);
  SAFE_HEAP_STORE($12 | 0, 0 | 0, 4);
  SAFE_HEAP_STORE($10 | 0, 0 | 0, 4);
  $$0 = 0; //@line 11236
 }
 return $$0 | 0; //@line 11238
}
function _k_scalar_body($0, $1, $2) {
 $0 = $0 | 0; //@line 2107
 $1 = $1 | 0; //@line 2108
 $2 = $2 | 0; //@line 2109
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0, $11 = 0.0, $12 = 0.0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0.0, $3 = 0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0, $8 = 0.0, $9 = 0, label = 0, sp = 0; //@line 2110
 sp = STACKTOP; //@line 2111
 STACKTOP = STACKTOP + 48 | 0; //@line 2112
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 2112
 $$byval_copy1 = sp + 24 | 0; //@line 2113
 $$byval_copy = sp + 8 | 0; //@line 2114
 $3 = $0; //@line 2115
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $5 = +_cpvcross_17($$byval_copy, $$byval_copy1); //@line 2118
 $4 = $5; //@line 2119
 $6 = $3; //@line 2120
 $7 = $6 + 16 | 0; //@line 2121
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 2122
 $9 = $3; //@line 2123
 $10 = $9 + 32 | 0; //@line 2124
 $11 = +(+SAFE_HEAP_LOAD_D($10 | 0, 8)); //@line 2125
 $12 = $4; //@line 2126
 $13 = $11 * $12; //@line 2127
 $14 = $4; //@line 2128
 $15 = $13 * $14; //@line 2129
 $16 = $8 + $15; //@line 2130
 STACKTOP = sp; //@line 2131
 return +$16;
}
function _cpSpatialIndexQuery_599($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 5800
 $1 = $1 | 0; //@line 5801
 $2 = $2 | 0; //@line 5802
 $3 = $3 | 0; //@line 5803
 $4 = $4 | 0; //@line 5804
 var $$byval_copy = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5805
 sp = STACKTOP; //@line 5806
 STACKTOP = STACKTOP + 48 | 0; //@line 5807
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 5807
 $$byval_copy = sp; //@line 5808
 $5 = $0; //@line 5809
 $6 = $1; //@line 5810
 $7 = $3; //@line 5811
 $8 = $4; //@line 5812
 $9 = $5; //@line 5813
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 5814
 $11 = $10 + 36 | 0; //@line 5815
 $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 5816
 $13 = $5; //@line 5817
 $14 = $6; //@line 5818
 $15 = $7; //@line 5819
 $16 = $8; //@line 5820
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 16 | 0, SAFE_HEAP_LOAD($2 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 20 | 0, SAFE_HEAP_LOAD($2 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 24 | 0, SAFE_HEAP_LOAD($2 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 28 | 0, SAFE_HEAP_LOAD($2 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 FUNCTION_TABLE_viiiii[(SAFE_FT_MASK($12 | 0, 15 | 0) | 0) & 15]($13, $14, $$byval_copy, $15, $16); //@line 5822
 STACKTOP = sp; //@line 5823
 return;
}
function _k_scalar_body_420($0, $1, $2) {
 $0 = $0 | 0; //@line 111
 $1 = $1 | 0; //@line 112
 $2 = $2 | 0; //@line 113
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0, $11 = 0.0, $12 = 0.0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0.0, $3 = 0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0, $8 = 0.0, $9 = 0, label = 0, sp = 0; //@line 114
 sp = STACKTOP; //@line 115
 STACKTOP = STACKTOP + 48 | 0; //@line 116
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 116
 $$byval_copy1 = sp + 24 | 0; //@line 117
 $$byval_copy = sp + 8 | 0; //@line 118
 $3 = $0; //@line 119
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $5 = +_cpvcross_409($$byval_copy, $$byval_copy1); //@line 122
 $4 = $5; //@line 123
 $6 = $3; //@line 124
 $7 = $6 + 16 | 0; //@line 125
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 126
 $9 = $3; //@line 127
 $10 = $9 + 32 | 0; //@line 128
 $11 = +(+SAFE_HEAP_LOAD_D($10 | 0, 8)); //@line 129
 $12 = $4; //@line 130
 $13 = $11 * $12; //@line 131
 $14 = $4; //@line 132
 $15 = $13 * $14; //@line 133
 $16 = $8 + $15; //@line 134
 STACKTOP = sp; //@line 135
 return +$16;
}
function _cpSpatialIndexQuery($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 3729
 $1 = $1 | 0; //@line 3730
 $2 = $2 | 0; //@line 3731
 $3 = $3 | 0; //@line 3732
 $4 = $4 | 0; //@line 3733
 var $$byval_copy = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3734
 sp = STACKTOP; //@line 3735
 STACKTOP = STACKTOP + 48 | 0; //@line 3736
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 3736
 $$byval_copy = sp; //@line 3737
 $5 = $0; //@line 3738
 $6 = $1; //@line 3739
 $7 = $3; //@line 3740
 $8 = $4; //@line 3741
 $9 = $5; //@line 3742
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 3743
 $11 = $10 + 36 | 0; //@line 3744
 $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 3745
 $13 = $5; //@line 3746
 $14 = $6; //@line 3747
 $15 = $7; //@line 3748
 $16 = $8; //@line 3749
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 16 | 0, SAFE_HEAP_LOAD($2 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 20 | 0, SAFE_HEAP_LOAD($2 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 24 | 0, SAFE_HEAP_LOAD($2 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 28 | 0, SAFE_HEAP_LOAD($2 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 FUNCTION_TABLE_viiiii[(SAFE_FT_MASK($12 | 0, 15 | 0) | 0) & 15]($13, $14, $$byval_copy, $15, $16); //@line 3751
 STACKTOP = sp; //@line 3752
 return;
}
function _cpSpaceUncacheArbiter($0, $1) {
 $0 = $0 | 0; //@line 3311
 $1 = $1 | 0; //@line 3312
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0; //@line 3313
 var $29 = 0, $3 = 0, $30 = 0, $31 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3314
 sp = STACKTOP; //@line 3315
 STACKTOP = STACKTOP + 32 | 0; //@line 3316
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 3316
 $6 = sp + 8 | 0; //@line 3317
 $2 = $0; //@line 3318
 $3 = $1; //@line 3319
 $8 = $3; //@line 3320
 $9 = $8 + 36 | 0; //@line 3321
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 3322
 $4 = $10; //@line 3323
 $11 = $3; //@line 3324
 $12 = $11 + 40 | 0; //@line 3325
 $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 3326
 $5 = $13; //@line 3327
 $14 = $4; //@line 3328
 SAFE_HEAP_STORE($6 | 0, $14 | 0, 4);
 $15 = $6 + 4 | 0; //@line 3330
 $16 = $5; //@line 3331
 SAFE_HEAP_STORE($15 | 0, $16 | 0, 4);
 $17 = $4; //@line 3333
 $18 = $17; //@line 3334
 $19 = Math_imul($18, -950046239) | 0; //@line 3335
 $20 = $5; //@line 3336
 $21 = $20; //@line 3337
 $22 = Math_imul($21, -950046239) | 0; //@line 3338
 $23 = $19 ^ $22; //@line 3339
 $7 = $23; //@line 3340
 $24 = $2; //@line 3341
 $25 = $24 + 128 | 0; //@line 3342
 $26 = SAFE_HEAP_LOAD($25 | 0, 4, 0) | 0 | 0; //@line 3343
 $27 = $7; //@line 3344
 _cpHashSetRemove($26, $27, $6) | 0; //@line 3345
 $28 = $2; //@line 3346
 $29 = $28 + 120 | 0; //@line 3347
 $30 = SAFE_HEAP_LOAD($29 | 0, 4, 0) | 0 | 0; //@line 3348
 $31 = $3; //@line 3349
 _cpArrayDeleteObj($30, $31); //@line 3350
 STACKTOP = sp; //@line 3351
 return;
}
function _cpBBTreeInsert($0, $1, $2) {
 $0 = $0 | 0; //@line 3083
 $1 = $1 | 0; //@line 3084
 $2 = $2 | 0; //@line 3085
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0; //@line 3086
 var $3 = 0, $30 = 0, $31 = 0, $32 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3087
 sp = STACKTOP; //@line 3088
 STACKTOP = STACKTOP + 32 | 0; //@line 3089
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 3089
 $3 = $0; //@line 3090
 $4 = $1; //@line 3091
 $5 = $2; //@line 3092
 $8 = $3; //@line 3093
 $9 = $8 + 20 | 0; //@line 3094
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 3095
 $11 = $5; //@line 3096
 $12 = $4; //@line 3097
 $13 = $3; //@line 3098
 $14 = _cpHashSetInsert($10, $11, $12, 50, $13) | 0; //@line 3099
 $6 = $14; //@line 3100
 $15 = $3; //@line 3101
 $16 = $15 + 24 | 0; //@line 3102
 $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 3103
 $7 = $17; //@line 3104
 $18 = $7; //@line 3105
 $19 = $6; //@line 3106
 $20 = $3; //@line 3107
 $21 = _SubtreeInsert($18, $19, $20) | 0; //@line 3108
 $22 = $3; //@line 3109
 $23 = $22 + 24 | 0; //@line 3110
 SAFE_HEAP_STORE($23 | 0, $21 | 0, 4);
 $24 = $3; //@line 3112
 $25 = _GetMasterTree($24) | 0; //@line 3113
 $26 = $25 + 40 | 0; //@line 3114
 $27 = SAFE_HEAP_LOAD($26 | 0, 4, 0) | 0 | 0; //@line 3115
 $28 = $6; //@line 3116
 $29 = $28 + 44 | 0; //@line 3117
 SAFE_HEAP_STORE($29 | 0, $27 | 0, 4);
 $30 = $6; //@line 3119
 $31 = $3; //@line 3120
 _LeafAddPairs($30, $31); //@line 3121
 $32 = $3; //@line 3122
 _IncrementStamp($32); //@line 3123
 STACKTOP = sp; //@line 3124
 return;
}
function _frexp($0, $1) {
 $0 = +$0; //@line 13890
 $1 = $1 | 0; //@line 13891
 var $$0 = 0.0, $$016 = 0.0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0.0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0.0, $9 = 0.0, $storemerge = 0, $trunc$clear = 0, label = 0;
 var sp = 0; //@line 13893
 sp = STACKTOP; //@line 13894
 SAFE_HEAP_STORE_D(tempDoublePtr | 0, +$0, 8);
 $2 = SAFE_HEAP_LOAD(tempDoublePtr | 0, 4, 0) | 0 | 0; //@line 13895
 $3 = SAFE_HEAP_LOAD(tempDoublePtr + 4 | 0, 4, 0) | 0 | 0; //@line 13896
 $4 = _bitshift64Lshr($2 | 0, $3 | 0, 52) | 0; //@line 13897
 $5 = getTempRet0() | 0; //@line 13898
 $6 = $4 & 65535; //@line 13899
 $trunc$clear = $6 & 2047; //@line 13900
 switch ($trunc$clear << 16 >> 16) {
 case 0:
  {
   $7 = $0 != 0.0; //@line 13903
   if ($7) {
    $8 = $0 * 18446744073709552000.0; //@line 13905
    $9 = +_frexp($8, $1); //@line 13906
    $10 = SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0; //@line 13907
    $11 = $10 + -64 | 0; //@line 13908
    $$016 = $9; //@line 13909
    $storemerge = $11; //@line 13909
   } else {
    $$016 = $0; //@line 13911
    $storemerge = 0; //@line 13911
   }
   SAFE_HEAP_STORE($1 | 0, $storemerge | 0, 4);
   $$0 = $$016; //@line 13914
   break;
  }
 case 2047:
  {
   $$0 = $0; //@line 13918
   break;
  }
 default:
  {
   $12 = $4 & 2047; //@line 13922
   $13 = $12 + -1022 | 0; //@line 13923
   SAFE_HEAP_STORE($1 | 0, $13 | 0, 4);
   $14 = $3 & -2146435073; //@line 13925
   $15 = $14 | 1071644672; //@line 13926
   SAFE_HEAP_STORE(tempDoublePtr | 0, $2 | 0, 4);
   SAFE_HEAP_STORE(tempDoublePtr + 4 | 0, $15 | 0, 4);
   $16 = +(+SAFE_HEAP_LOAD_D(tempDoublePtr | 0, 8)); //@line 13927
   $$0 = $16; //@line 13928
  }
 }
 return +$$0;
}
function _cpvdist_376($0, $1) {
 $0 = $0 | 0; //@line 7059
 $1 = $1 | 0; //@line 7060
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $2 = 0, $3 = 0.0, label = 0, sp = 0; //@line 7061
 sp = STACKTOP; //@line 7062
 STACKTOP = STACKTOP + 64 | 0; //@line 7063
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 7063
 $$byval_copy2 = sp + 48 | 0; //@line 7064
 $$byval_copy1 = sp + 32 | 0; //@line 7065
 $$byval_copy = sp + 16 | 0; //@line 7066
 $2 = sp; //@line 7067
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_354($2, $$byval_copy, $$byval_copy1); //@line 7070
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $3 = +_cpvlength_356($$byval_copy2); //@line 7072
 STACKTOP = sp; //@line 7073
 return +$3;
}
function _cpvdist_277($0, $1) {
 $0 = $0 | 0; //@line 4857
 $1 = $1 | 0; //@line 4858
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $2 = 0, $3 = 0.0, label = 0, sp = 0; //@line 4859
 sp = STACKTOP; //@line 4860
 STACKTOP = STACKTOP + 64 | 0; //@line 4861
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 4861
 $$byval_copy2 = sp + 48 | 0; //@line 4862
 $$byval_copy1 = sp + 32 | 0; //@line 4863
 $$byval_copy = sp + 16 | 0; //@line 4864
 $2 = sp; //@line 4865
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_266($2, $$byval_copy, $$byval_copy1); //@line 4868
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $3 = +_cpvlength_269($$byval_copy2); //@line 4870
 STACKTOP = sp; //@line 4871
 return +$3;
}
function _cpvdistsq($0, $1) {
 $0 = $0 | 0; //@line 6791
 $1 = $1 | 0; //@line 6792
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $2 = 0, $3 = 0.0, label = 0, sp = 0; //@line 6793
 sp = STACKTOP; //@line 6794
 STACKTOP = STACKTOP + 64 | 0; //@line 6795
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 6795
 $$byval_copy2 = sp + 48 | 0; //@line 6796
 $$byval_copy1 = sp + 32 | 0; //@line 6797
 $$byval_copy = sp + 16 | 0; //@line 6798
 $2 = sp; //@line 6799
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub_49($2, $$byval_copy, $$byval_copy1); //@line 6802
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $3 = +_cpvlengthsq_50($$byval_copy2); //@line 6804
 STACKTOP = sp; //@line 6805
 return +$3;
}
function _chipmunk_cpBodyUpdateVelocity($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 5914
 $1 = +$1; //@line 5915
 $2 = +$2; //@line 5916
 $3 = +$3; //@line 5917
 $4 = +$4; //@line 5918
 var $$byval_copy = 0, $10 = 0, $11 = 0.0, $12 = 0.0, $13 = 0, $14 = 0, $15 = 0.0, $16 = 0.0, $5 = 0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0; //@line 5919
 sp = STACKTOP; //@line 5920
 STACKTOP = STACKTOP + 80 | 0; //@line 5921
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(80 | 0); //@line 5921
 $$byval_copy = sp + 48 | 0; //@line 5922
 $10 = sp; //@line 5923
 $5 = $0; //@line 5924
 $6 = $1; //@line 5925
 $7 = $2; //@line 5926
 $8 = $3; //@line 5927
 $9 = $4; //@line 5928
 SAFE_HEAP_STORE($10 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($10 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $11 = $6; //@line 5930
 SAFE_HEAP_STORE_D($10 | 0, +$11, 8);
 $12 = $7; //@line 5932
 $13 = $10 + 8 | 0; //@line 5933
 SAFE_HEAP_STORE_D($13 | 0, +$12, 8);
 $14 = $5; //@line 5935
 $15 = $8; //@line 5936
 $16 = $9; //@line 5937
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($10 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($10 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($10 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpBodyUpdateVelocity($14, $$byval_copy, $15, $16); //@line 5939
 STACKTOP = sp; //@line 5940
 return;
}
function _cpBBCenter($0, $1) {
 $0 = $0 | 0; //@line 901
 $1 = $1 | 0; //@line 902
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0.0, $2 = 0, $3 = 0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0, label = 0, sp = 0; //@line 903
 sp = STACKTOP; //@line 904
 STACKTOP = STACKTOP + 64 | 0; //@line 905
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 905
 $$byval_copy1 = sp + 48 | 0; //@line 906
 $$byval_copy = sp + 32 | 0; //@line 907
 $2 = sp + 16 | 0; //@line 908
 $3 = sp; //@line 909
 $4 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 910
 $5 = $1 + 8 | 0; //@line 911
 $6 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 912
 _cpv_72($2, $4, $6); //@line 913
 $7 = $1 + 16 | 0; //@line 914
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 915
 $9 = $1 + 24 | 0; //@line 916
 $10 = +(+SAFE_HEAP_LOAD_D($9 | 0, 8)); //@line 917
 _cpv_72($3, $8, $10); //@line 918
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvlerp_65($0, $$byval_copy, $$byval_copy1, .5); //@line 921
 STACKTOP = sp; //@line 922
 return;
}
function _realloc($0, $1) {
 $0 = $0 | 0; //@line 9306
 $1 = $1 | 0; //@line 9307
 var $$1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0; //@line 9308
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 9309
 sp = STACKTOP; //@line 9310
 $2 = ($0 | 0) == (0 | 0); //@line 9311
 if ($2) {
  $3 = _malloc($1) | 0; //@line 9313
  $$1 = $3; //@line 9314
  return $$1 | 0; //@line 9315
 }
 $4 = $1 >>> 0 > 4294967231; //@line 9317
 if ($4) {
  $5 = ___errno_location() | 0; //@line 9319
  SAFE_HEAP_STORE($5 | 0, 12 | 0, 4);
  $$1 = 0; //@line 9321
  return $$1 | 0; //@line 9322
 }
 $6 = $1 >>> 0 < 11; //@line 9324
 $7 = $1 + 11 | 0; //@line 9325
 $8 = $7 & -8; //@line 9326
 $9 = $6 ? 16 : $8; //@line 9327
 $10 = $0 + -8 | 0; //@line 9328
 $11 = _try_realloc_chunk($10, $9) | 0; //@line 9329
 $12 = ($11 | 0) == (0 | 0); //@line 9330
 if (!$12) {
  $13 = $11 + 8 | 0; //@line 9332
  $$1 = $13; //@line 9333
  return $$1 | 0; //@line 9334
 }
 $14 = _malloc($1) | 0; //@line 9336
 $15 = ($14 | 0) == (0 | 0); //@line 9337
 if ($15) {
  $$1 = 0; //@line 9339
  return $$1 | 0; //@line 9340
 }
 $16 = $0 + -4 | 0; //@line 9342
 $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 9343
 $18 = $17 & -8; //@line 9344
 $19 = $17 & 3; //@line 9345
 $20 = ($19 | 0) == 0; //@line 9346
 $21 = $20 ? 8 : 4; //@line 9347
 $22 = $18 - $21 | 0; //@line 9348
 $23 = $22 >>> 0 < $1 >>> 0; //@line 9349
 $24 = $23 ? $22 : $1; //@line 9350
 _memcpy($14 | 0, $0 | 0, $24 | 0) | 0; //@line 9351
 _free($0); //@line 9352
 $$1 = $14; //@line 9353
 return $$1 | 0; //@line 9354
}
function _cpvdist($0, $1) {
 $0 = $0 | 0; //@line 314
 $1 = $1 | 0; //@line 315
 var $$byval_copy = 0, $$byval_copy1 = 0, $$byval_copy2 = 0, $2 = 0, $3 = 0.0, label = 0, sp = 0; //@line 316
 sp = STACKTOP; //@line 317
 STACKTOP = STACKTOP + 64 | 0; //@line 318
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 318
 $$byval_copy2 = sp + 48 | 0; //@line 319
 $$byval_copy1 = sp + 32 | 0; //@line 320
 $$byval_copy = sp + 16 | 0; //@line 321
 $2 = sp; //@line 322
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvsub($2, $$byval_copy, $$byval_copy1); //@line 325
 SAFE_HEAP_STORE($$byval_copy2 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy2 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $3 = +_cpvlength($$byval_copy2); //@line 327
 STACKTOP = sp; //@line 328
 return +$3;
}
function _cpSlideJointNew($0, $1, $2, $3, $4, $5) {
 $0 = $0 | 0; //@line 138
 $1 = $1 | 0; //@line 139
 $2 = $2 | 0; //@line 140
 $3 = $3 | 0; //@line 141
 $4 = +$4; //@line 142
 $5 = +$5; //@line 143
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0.0, $15 = 0, $6 = 0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0; //@line 144
 sp = STACKTOP; //@line 145
 STACKTOP = STACKTOP + 64 | 0; //@line 146
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 146
 $$byval_copy1 = sp + 32 | 0; //@line 147
 $$byval_copy = sp + 16 | 0; //@line 148
 $6 = $0; //@line 149
 $7 = $1; //@line 150
 $8 = $4; //@line 151
 $9 = $5; //@line 152
 $10 = _cpSlideJointAlloc() | 0; //@line 153
 $11 = $6; //@line 154
 $12 = $7; //@line 155
 $13 = $8; //@line 156
 $14 = $9; //@line 157
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $15 = _cpSlideJointInit($10, $11, $12, $$byval_copy, $$byval_copy1, $13, $14) | 0; //@line 160
 STACKTOP = sp; //@line 161
 return $15 | 0; //@line 161
}
function _cpSpatialIndexInit($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 5649
 $1 = $1 | 0; //@line 5650
 $2 = $2 | 0; //@line 5651
 $3 = $3 | 0; //@line 5652
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0; //@line 5653
 var $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 5654
 sp = STACKTOP; //@line 5655
 STACKTOP = STACKTOP + 32 | 0; //@line 5656
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 5656
 $vararg_buffer = sp; //@line 5657
 $4 = $0; //@line 5658
 $5 = $1; //@line 5659
 $6 = $2; //@line 5660
 $7 = $3; //@line 5661
 $8 = $5; //@line 5662
 $9 = $4; //@line 5663
 SAFE_HEAP_STORE($9 | 0, $8 | 0, 4);
 $10 = $6; //@line 5665
 $11 = $4; //@line 5666
 $12 = $11 + 4 | 0; //@line 5667
 SAFE_HEAP_STORE($12 | 0, $10 | 0, 4);
 $13 = $7; //@line 5669
 $14 = $4; //@line 5670
 $15 = $14 + 8 | 0; //@line 5671
 SAFE_HEAP_STORE($15 | 0, $13 | 0, 4);
 $16 = $7; //@line 5673
 $17 = ($16 | 0) != (0 | 0); //@line 5674
 if (!$17) {
  $25 = $4; //@line 5676
  STACKTOP = sp; //@line 5677
  return $25 | 0; //@line 5677
 }
 $18 = $7; //@line 5679
 $19 = $18 + 12 | 0; //@line 5680
 $20 = SAFE_HEAP_LOAD($19 | 0, 4, 0) | 0 | 0; //@line 5681
 $21 = ($20 | 0) != (0 | 0); //@line 5682
 if ($21) {
  _cpMessage(9975, 10002, 41, 1, 1, 10068, $vararg_buffer); //@line 5684
  _abort(); //@line 5685
 }
 $22 = $4; //@line 5688
 $23 = $7; //@line 5689
 $24 = $23 + 12 | 0; //@line 5690
 SAFE_HEAP_STORE($24 | 0, $22 | 0, 4);
 $25 = $4; //@line 5692
 STACKTOP = sp; //@line 5693
 return $25 | 0; //@line 5693
}
function _cpTransformNewTranspose($0, $1, $2, $3, $4, $5, $6) {
 $0 = $0 | 0; //@line 6001
 $1 = +$1; //@line 6002
 $2 = +$2; //@line 6003
 $3 = +$3; //@line 6004
 $4 = +$4; //@line 6005
 $5 = +$5; //@line 6006
 $6 = +$6; //@line 6007
 var $10 = 0.0, $11 = 0.0, $12 = 0.0, $13 = 0, $14 = 0.0, $15 = 0, $16 = 0.0, $17 = 0, $18 = 0.0, $19 = 0, $20 = 0.0, $21 = 0, $22 = 0.0, $23 = 0, $24 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0.0, dest = 0, label = 0;
 var sp = 0, src = 0, stop = 0; //@line 6009
 sp = STACKTOP; //@line 6010
 STACKTOP = STACKTOP + 96 | 0; //@line 6011
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(96 | 0); //@line 6011
 $13 = sp; //@line 6012
 $7 = $1; //@line 6013
 $8 = $2; //@line 6014
 $9 = $3; //@line 6015
 $10 = $4; //@line 6016
 $11 = $5; //@line 6017
 $12 = $6; //@line 6018
 $14 = $7; //@line 6019
 SAFE_HEAP_STORE_D($13 | 0, +$14, 8);
 $15 = $13 + 8 | 0; //@line 6021
 $16 = $10; //@line 6022
 SAFE_HEAP_STORE_D($15 | 0, +$16, 8);
 $17 = $13 + 16 | 0; //@line 6024
 $18 = $8; //@line 6025
 SAFE_HEAP_STORE_D($17 | 0, +$18, 8);
 $19 = $13 + 24 | 0; //@line 6027
 $20 = $11; //@line 6028
 SAFE_HEAP_STORE_D($19 | 0, +$20, 8);
 $21 = $13 + 32 | 0; //@line 6030
 $22 = $9; //@line 6031
 SAFE_HEAP_STORE_D($21 | 0, +$22, 8);
 $23 = $13 + 40 | 0; //@line 6033
 $24 = $12; //@line 6034
 SAFE_HEAP_STORE_D($23 | 0, +$24, 8);
 dest = $0; //@line 6036
 src = $13; //@line 6036
 stop = dest + 48 | 0; //@line 6036
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 6036
  src = src + 4 | 0; //@line 6036
 } while ((dest | 0) < (stop | 0));
 STACKTOP = sp; //@line 6037
 return;
}
function _cpSpaceReindexShape($0, $1) {
 $0 = $0 | 0; //@line 1903
 $1 = $1 | 0; //@line 1904
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0; //@line 1905
 var $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 1906
 sp = STACKTOP; //@line 1907
 STACKTOP = STACKTOP + 48 | 0; //@line 1908
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 1908
 $vararg_buffer = sp + 32 | 0; //@line 1909
 $4 = sp; //@line 1910
 $2 = $0; //@line 1911
 $3 = $1; //@line 1912
 $5 = $2; //@line 1913
 $6 = $5 + 140 | 0; //@line 1914
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 1915
 $8 = ($7 | 0) != 0; //@line 1916
 if ($8) {
  _cpMessage(6649, 6192, 664, 1, 1, 7721, $vararg_buffer); //@line 1918
  _abort(); //@line 1919
 } else {
  $9 = $3; //@line 1922
  _cpShapeCacheBB($4, $9); //@line 1923
  $10 = $2; //@line 1924
  $11 = $10 + 112 | 0; //@line 1925
  $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 1926
  $13 = $3; //@line 1927
  $14 = $3; //@line 1928
  $15 = $14 + 156 | 0; //@line 1929
  $16 = SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0; //@line 1930
  _cpSpatialIndexReindexObject($12, $13, $16); //@line 1931
  $17 = $2; //@line 1932
  $18 = $17 + 108 | 0; //@line 1933
  $19 = SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0; //@line 1934
  $20 = $3; //@line 1935
  $21 = $3; //@line 1936
  $22 = $21 + 156 | 0; //@line 1937
  $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 1938
  _cpSpatialIndexReindexObject($19, $20, $23); //@line 1939
  STACKTOP = sp; //@line 1940
  return;
 }
}
function _cpSpaceSetStaticBody($0, $1) {
 $0 = $0 | 0; //@line 453
 $1 = $1 | 0; //@line 454
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0; //@line 455
 var $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 456
 sp = STACKTOP; //@line 457
 STACKTOP = STACKTOP + 16 | 0; //@line 458
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 458
 $vararg_buffer = sp; //@line 459
 $2 = $0; //@line 460
 $3 = $1; //@line 461
 $4 = $2; //@line 462
 $5 = $4 + 188 | 0; //@line 463
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 464
 $7 = ($6 | 0) != (0 | 0); //@line 465
 do {
  if ($7) {
   $8 = $2; //@line 468
   $9 = $8 + 188 | 0; //@line 469
   $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 470
   $11 = $10 + 212 | 0; //@line 471
   $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 472
   $13 = ($12 | 0) == (0 | 0); //@line 473
   if ($13) {
    $14 = $2; //@line 475
    $15 = $14 + 188 | 0; //@line 476
    $16 = SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0; //@line 477
    $17 = $16 + 208 | 0; //@line 478
    SAFE_HEAP_STORE($17 | 0, 0 | 0, 4);
    break;
   } else {
    _cpMessage(6155, 6192, 366, 1, 1, 6251, $vararg_buffer); //@line 482
    _abort(); //@line 483
   }
  }
 } while (0);
 $18 = $3; //@line 488
 $19 = $2; //@line 489
 $20 = $19 + 188 | 0; //@line 490
 SAFE_HEAP_STORE($20 | 0, $18 | 0, 4);
 $21 = $2; //@line 492
 $22 = $3; //@line 493
 $23 = $22 + 208 | 0; //@line 494
 SAFE_HEAP_STORE($23 | 0, $21 | 0, 4);
 STACKTOP = sp; //@line 496
 return;
}
function _cpHashSetNew($0, $1) {
 $0 = $0 | 0; //@line 2198
 $1 = $1 | 0; //@line 2199
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0; //@line 2200
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2201
 sp = STACKTOP; //@line 2202
 STACKTOP = STACKTOP + 16 | 0; //@line 2203
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2203
 $2 = $0; //@line 2204
 $3 = $1; //@line 2205
 $5 = _calloc(1, 28) | 0; //@line 2206
 $4 = $5; //@line 2207
 $6 = $2; //@line 2208
 $7 = _next_prime($6) | 0; //@line 2209
 $8 = $4; //@line 2210
 $9 = $8 + 4 | 0; //@line 2211
 SAFE_HEAP_STORE($9 | 0, $7 | 0, 4);
 $10 = $4; //@line 2213
 SAFE_HEAP_STORE($10 | 0, 0 | 0, 4);
 $11 = $3; //@line 2215
 $12 = $4; //@line 2216
 $13 = $12 + 8 | 0; //@line 2217
 SAFE_HEAP_STORE($13 | 0, $11 | 0, 4);
 $14 = $4; //@line 2219
 $15 = $14 + 12 | 0; //@line 2220
 SAFE_HEAP_STORE($15 | 0, 0 | 0, 4);
 $16 = $4; //@line 2222
 $17 = $16 + 4 | 0; //@line 2223
 $18 = SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0; //@line 2224
 $19 = _calloc($18, 4) | 0; //@line 2225
 $20 = $4; //@line 2226
 $21 = $20 + 16 | 0; //@line 2227
 SAFE_HEAP_STORE($21 | 0, $19 | 0, 4);
 $22 = $4; //@line 2229
 $23 = $22 + 20 | 0; //@line 2230
 SAFE_HEAP_STORE($23 | 0, 0 | 0, 4);
 $24 = _cpArrayNew(0) | 0; //@line 2232
 $25 = $4; //@line 2233
 $26 = $25 + 24 | 0; //@line 2234
 SAFE_HEAP_STORE($26 | 0, $24 | 0, 4);
 $27 = $4; //@line 2236
 STACKTOP = sp; //@line 2237
 return $27 | 0; //@line 2237
}
function _cpPolyShapeInitRaw($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 3809
 $1 = $1 | 0; //@line 3810
 $2 = $2 | 0; //@line 3811
 $3 = $3 | 0; //@line 3812
 $4 = +$4; //@line 3813
 var $$byval_copy = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0.0, $16 = 0, $17 = 0, $18 = 0, $19 = 0.0, $20 = 0, $21 = 0, $22 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0.0, dest = 0; //@line 3814
 var label = 0, sp = 0, src = 0, stop = 0; //@line 3815
 sp = STACKTOP; //@line 3816
 STACKTOP = STACKTOP + 112 | 0; //@line 3817
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(112 | 0); //@line 3817
 $$byval_copy = sp + 48 | 0; //@line 3818
 $10 = sp; //@line 3819
 $5 = $0; //@line 3820
 $6 = $1; //@line 3821
 $7 = $2; //@line 3822
 $8 = $3; //@line 3823
 $9 = $4; //@line 3824
 $11 = $5; //@line 3825
 $12 = $6; //@line 3826
 $13 = $7; //@line 3827
 $14 = $8; //@line 3828
 $15 = $9; //@line 3829
 _cpPolyShapeMassInfo($10, 0.0, $13, $14, $15); //@line 3830
 dest = $$byval_copy; //@line 3831
 src = $10; //@line 3831
 stop = dest + 40 | 0; //@line 3831
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 3831
  src = src + 4 | 0; //@line 3831
 } while ((dest | 0) < (stop | 0));
 _cpShapeInit($11, 2636, $12, $$byval_copy) | 0; //@line 3832
 $16 = $5; //@line 3833
 $17 = $7; //@line 3834
 $18 = $8; //@line 3835
 _SetVerts($16, $17, $18); //@line 3836
 $19 = $9; //@line 3837
 $20 = $5; //@line 3838
 $21 = $20 + 160 | 0; //@line 3839
 SAFE_HEAP_STORE_D($21 | 0, +$19, 8);
 $22 = $5; //@line 3841
 STACKTOP = sp; //@line 3842
 return $22 | 0; //@line 3842
}
function _cpSpaceAddCollisionHandler($0, $1, $2) {
 $0 = $0 | 0; //@line 1135
 $1 = $1 | 0; //@line 1136
 $2 = $2 | 0; //@line 1137
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0; //@line 1138
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1139
 sp = STACKTOP; //@line 1140
 STACKTOP = STACKTOP + 48 | 0; //@line 1141
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 1141
 $7 = sp; //@line 1142
 $3 = $0; //@line 1143
 $4 = $1; //@line 1144
 $5 = $2; //@line 1145
 $8 = $4; //@line 1146
 $9 = Math_imul($8, -950046239) | 0; //@line 1147
 $10 = $5; //@line 1148
 $11 = Math_imul($10, -950046239) | 0; //@line 1149
 $12 = $9 ^ $11; //@line 1150
 $6 = $12; //@line 1151
 $13 = $4; //@line 1152
 SAFE_HEAP_STORE($7 | 0, $13 | 0, 4);
 $14 = $7 + 4 | 0; //@line 1154
 $15 = $5; //@line 1155
 SAFE_HEAP_STORE($14 | 0, $15 | 0, 4);
 $16 = $7 + 8 | 0; //@line 1157
 SAFE_HEAP_STORE($16 | 0, 64 | 0, 4);
 $17 = $7 + 12 | 0; //@line 1159
 SAFE_HEAP_STORE($17 | 0, 65 | 0, 4);
 $18 = $7 + 16 | 0; //@line 1161
 SAFE_HEAP_STORE($18 | 0, 66 | 0, 4);
 $19 = $7 + 20 | 0; //@line 1163
 SAFE_HEAP_STORE($19 | 0, 67 | 0, 4);
 $20 = $7 + 24 | 0; //@line 1165
 SAFE_HEAP_STORE($20 | 0, 0 | 0, 4);
 $21 = $3; //@line 1167
 $22 = $21 + 148 | 0; //@line 1168
 $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 1169
 $24 = $6; //@line 1170
 $25 = _cpHashSetInsert($23, $24, $7, 68, 0) | 0; //@line 1171
 STACKTOP = sp; //@line 1172
 return $25 | 0; //@line 1172
}
function _cpMat2x2New_260($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 3720
 $1 = +$1; //@line 3721
 $2 = +$2; //@line 3722
 $3 = +$3; //@line 3723
 $4 = +$4; //@line 3724
 var $10 = 0.0, $11 = 0, $12 = 0.0, $13 = 0, $14 = 0.0, $15 = 0, $16 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3726
 STACKTOP = STACKTOP + 64 | 0; //@line 3727
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 3727
 $9 = sp; //@line 3728
 $5 = $1; //@line 3729
 $6 = $2; //@line 3730
 $7 = $3; //@line 3731
 $8 = $4; //@line 3732
 $10 = $5; //@line 3733
 SAFE_HEAP_STORE_D($9 | 0, +$10, 8);
 $11 = $9 + 8 | 0; //@line 3735
 $12 = $6; //@line 3736
 SAFE_HEAP_STORE_D($11 | 0, +$12, 8);
 $13 = $9 + 16 | 0; //@line 3738
 $14 = $7; //@line 3739
 SAFE_HEAP_STORE_D($13 | 0, +$14, 8);
 $15 = $9 + 24 | 0; //@line 3741
 $16 = $8; //@line 3742
 SAFE_HEAP_STORE_D($15 | 0, +$16, 8);
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 16 | 0, SAFE_HEAP_LOAD($9 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 20 | 0, SAFE_HEAP_LOAD($9 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 24 | 0, SAFE_HEAP_LOAD($9 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 28 | 0, SAFE_HEAP_LOAD($9 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 3745
 return;
}
function _cpBBNew_550($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 3825
 $1 = +$1; //@line 3826
 $2 = +$2; //@line 3827
 $3 = +$3; //@line 3828
 $4 = +$4; //@line 3829
 var $10 = 0.0, $11 = 0, $12 = 0.0, $13 = 0, $14 = 0.0, $15 = 0, $16 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3831
 STACKTOP = STACKTOP + 64 | 0; //@line 3832
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 3832
 $9 = sp; //@line 3833
 $5 = $1; //@line 3834
 $6 = $2; //@line 3835
 $7 = $3; //@line 3836
 $8 = $4; //@line 3837
 $10 = $5; //@line 3838
 SAFE_HEAP_STORE_D($9 | 0, +$10, 8);
 $11 = $9 + 8 | 0; //@line 3840
 $12 = $6; //@line 3841
 SAFE_HEAP_STORE_D($11 | 0, +$12, 8);
 $13 = $9 + 16 | 0; //@line 3843
 $14 = $7; //@line 3844
 SAFE_HEAP_STORE_D($13 | 0, +$14, 8);
 $15 = $9 + 24 | 0; //@line 3846
 $16 = $8; //@line 3847
 SAFE_HEAP_STORE_D($15 | 0, +$16, 8);
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 16 | 0, SAFE_HEAP_LOAD($9 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 20 | 0, SAFE_HEAP_LOAD($9 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 24 | 0, SAFE_HEAP_LOAD($9 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 28 | 0, SAFE_HEAP_LOAD($9 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 3850
 return;
}
function _cpBBNew_365($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 6252
 $1 = +$1; //@line 6253
 $2 = +$2; //@line 6254
 $3 = +$3; //@line 6255
 $4 = +$4; //@line 6256
 var $10 = 0.0, $11 = 0, $12 = 0.0, $13 = 0, $14 = 0.0, $15 = 0, $16 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP; //@line 6258
 STACKTOP = STACKTOP + 64 | 0; //@line 6259
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 6259
 $9 = sp; //@line 6260
 $5 = $1; //@line 6261
 $6 = $2; //@line 6262
 $7 = $3; //@line 6263
 $8 = $4; //@line 6264
 $10 = $5; //@line 6265
 SAFE_HEAP_STORE_D($9 | 0, +$10, 8);
 $11 = $9 + 8 | 0; //@line 6267
 $12 = $6; //@line 6268
 SAFE_HEAP_STORE_D($11 | 0, +$12, 8);
 $13 = $9 + 16 | 0; //@line 6270
 $14 = $7; //@line 6271
 SAFE_HEAP_STORE_D($13 | 0, +$14, 8);
 $15 = $9 + 24 | 0; //@line 6273
 $16 = $8; //@line 6274
 SAFE_HEAP_STORE_D($15 | 0, +$16, 8);
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 16 | 0, SAFE_HEAP_LOAD($9 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 20 | 0, SAFE_HEAP_LOAD($9 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 24 | 0, SAFE_HEAP_LOAD($9 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 28 | 0, SAFE_HEAP_LOAD($9 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 6277
 return;
}
function _cpBBNew_283($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 4958
 $1 = +$1; //@line 4959
 $2 = +$2; //@line 4960
 $3 = +$3; //@line 4961
 $4 = +$4; //@line 4962
 var $10 = 0.0, $11 = 0, $12 = 0.0, $13 = 0, $14 = 0.0, $15 = 0, $16 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP; //@line 4964
 STACKTOP = STACKTOP + 64 | 0; //@line 4965
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 4965
 $9 = sp; //@line 4966
 $5 = $1; //@line 4967
 $6 = $2; //@line 4968
 $7 = $3; //@line 4969
 $8 = $4; //@line 4970
 $10 = $5; //@line 4971
 SAFE_HEAP_STORE_D($9 | 0, +$10, 8);
 $11 = $9 + 8 | 0; //@line 4973
 $12 = $6; //@line 4974
 SAFE_HEAP_STORE_D($11 | 0, +$12, 8);
 $13 = $9 + 16 | 0; //@line 4976
 $14 = $7; //@line 4977
 SAFE_HEAP_STORE_D($13 | 0, +$14, 8);
 $15 = $9 + 24 | 0; //@line 4979
 $16 = $8; //@line 4980
 SAFE_HEAP_STORE_D($15 | 0, +$16, 8);
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 16 | 0, SAFE_HEAP_LOAD($9 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 20 | 0, SAFE_HEAP_LOAD($9 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 24 | 0, SAFE_HEAP_LOAD($9 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 28 | 0, SAFE_HEAP_LOAD($9 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 4983
 return;
}
function _cpCheckPointGreater($0, $1, $2) {
 $0 = $0 | 0; //@line 5019
 $1 = $1 | 0; //@line 5020
 $2 = $2 | 0; //@line 5021
 var $10 = 0.0, $11 = 0.0, $12 = 0.0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0, $19 = 0.0, $20 = 0, $21 = 0.0, $22 = 0.0, $23 = 0, $24 = 0.0, $25 = 0.0, $26 = 0.0, $27 = 0.0, $28 = 0, $29 = 0;
 var $3 = 0, $30 = 0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0; //@line 5023
 sp = STACKTOP; //@line 5024
 $3 = $1 + 8 | 0; //@line 5025
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 5026
 $5 = $0 + 8 | 0; //@line 5027
 $6 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 5028
 $7 = $4 - $6; //@line 5029
 $8 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 5030
 $9 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 5031
 $10 = $8 + $9; //@line 5032
 $11 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 5033
 $12 = 2.0 * $11; //@line 5034
 $13 = $10 - $12; //@line 5035
 $14 = $7 * $13; //@line 5036
 $15 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 5037
 $16 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 5038
 $17 = $15 - $16; //@line 5039
 $18 = $0 + 8 | 0; //@line 5040
 $19 = +(+SAFE_HEAP_LOAD_D($18 | 0, 8)); //@line 5041
 $20 = $1 + 8 | 0; //@line 5042
 $21 = +(+SAFE_HEAP_LOAD_D($20 | 0, 8)); //@line 5043
 $22 = $19 + $21; //@line 5044
 $23 = $2 + 8 | 0; //@line 5045
 $24 = +(+SAFE_HEAP_LOAD_D($23 | 0, 8)); //@line 5046
 $25 = 2.0 * $24; //@line 5047
 $26 = $22 - $25; //@line 5048
 $27 = $17 * $26; //@line 5049
 $28 = $14 > $27; //@line 5050
 $29 = $28 & 1; //@line 5051
 $30 = $29 & 255; //@line 5052
 return $30 | 0; //@line 5053
}
function _cpSpaceSetGravity($0, $1) {
 $0 = $0 | 0; //@line 806
 $1 = $1 | 0; //@line 807
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0; //@line 808
 var label = 0, sp = 0; //@line 809
 sp = STACKTOP; //@line 810
 STACKTOP = STACKTOP + 16 | 0; //@line 811
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 811
 $2 = $0; //@line 812
 $5 = $2; //@line 813
 $6 = $5 + 8 | 0; //@line 814
 SAFE_HEAP_STORE($6 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $7 = $2; //@line 816
 $8 = $7 + 100 | 0; //@line 817
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 818
 $3 = $9; //@line 819
 $4 = 0; //@line 820
 while (1) {
  $10 = $4; //@line 822
  $11 = $3; //@line 823
  $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 824
  $13 = ($10 | 0) < ($12 | 0); //@line 825
  if (!$13) {
   break;
  }
  $14 = $3; //@line 829
  $15 = $14 + 8 | 0; //@line 830
  $16 = SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0; //@line 831
  $17 = $4; //@line 832
  $18 = $16 + ($17 << 2) | 0; //@line 833
  $19 = SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0; //@line 834
  _cpBodyActivate($19); //@line 835
  $20 = $4; //@line 836
  $21 = $20 + 1 | 0; //@line 837
  $4 = $21; //@line 838
 }
 STACKTOP = sp; //@line 840
 return;
}
function _cpBBNew($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 5048
 $1 = +$1; //@line 5049
 $2 = +$2; //@line 5050
 $3 = +$3; //@line 5051
 $4 = +$4; //@line 5052
 var $10 = 0.0, $11 = 0, $12 = 0.0, $13 = 0, $14 = 0.0, $15 = 0, $16 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP; //@line 5054
 STACKTOP = STACKTOP + 64 | 0; //@line 5055
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 5055
 $9 = sp; //@line 5056
 $5 = $1; //@line 5057
 $6 = $2; //@line 5058
 $7 = $3; //@line 5059
 $8 = $4; //@line 5060
 $10 = $5; //@line 5061
 SAFE_HEAP_STORE_D($9 | 0, +$10, 8);
 $11 = $9 + 8 | 0; //@line 5063
 $12 = $6; //@line 5064
 SAFE_HEAP_STORE_D($11 | 0, +$12, 8);
 $13 = $9 + 16 | 0; //@line 5066
 $14 = $7; //@line 5067
 SAFE_HEAP_STORE_D($13 | 0, +$14, 8);
 $15 = $9 + 24 | 0; //@line 5069
 $16 = $8; //@line 5070
 SAFE_HEAP_STORE_D($15 | 0, +$16, 8);
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 16 | 0, SAFE_HEAP_LOAD($9 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 20 | 0, SAFE_HEAP_LOAD($9 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 24 | 0, SAFE_HEAP_LOAD($9 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 28 | 0, SAFE_HEAP_LOAD($9 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 5073
 return;
}
function _leafSetTrans($0, $1) {
 $0 = $0 | 0; //@line 5415
 $1 = $1 | 0; //@line 5416
 var $$byval_copy = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5417
 sp = STACKTOP; //@line 5418
 STACKTOP = STACKTOP + 80 | 0; //@line 5419
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(80 | 0); //@line 5419
 $$byval_copy = sp + 32 | 0; //@line 5420
 $4 = sp; //@line 5421
 $2 = $0; //@line 5422
 $3 = $1; //@line 5423
 $5 = $3; //@line 5424
 $6 = $2; //@line 5425
 $7 = $3; //@line 5426
 $8 = $7 + 4 | 0; //@line 5427
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 5428
 $10 = $2; //@line 5429
 FUNCTION_TABLE_vii[(SAFE_FT_MASK($9 | 0, 127 | 0) | 0) & 127]($4, $10); //@line 5430
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 16 | 0, SAFE_HEAP_LOAD($4 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 20 | 0, SAFE_HEAP_LOAD($4 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 24 | 0, SAFE_HEAP_LOAD($4 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 28 | 0, SAFE_HEAP_LOAD($4 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 $11 = _LeafNew($5, $6, $$byval_copy) | 0; //@line 5432
 STACKTOP = sp; //@line 5433
 return $11 | 0; //@line 5433
}
function _cpArbiterGetShapes($0, $1, $2) {
 $0 = $0 | 0; //@line 1047
 $1 = $1 | 0; //@line 1048
 $2 = $2 | 0; //@line 1049
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0; //@line 1050
 var $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1051
 sp = STACKTOP; //@line 1052
 STACKTOP = STACKTOP + 16 | 0; //@line 1053
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1053
 $3 = $0; //@line 1054
 $4 = $1; //@line 1055
 $5 = $2; //@line 1056
 $6 = $3; //@line 1057
 $7 = $6 + 108 | 0; //@line 1058
 $8 = SAFE_HEAP_LOAD($7 >> 0 | 0, 1, 0) | 0 | 0; //@line 1059
 $9 = $8 << 24 >> 24 != 0; //@line 1060
 $10 = $3; //@line 1061
 if ($9) {
  $11 = $10 + 40 | 0; //@line 1063
  $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 1064
  $13 = $4; //@line 1065
  SAFE_HEAP_STORE($13 | 0, $12 | 0, 4);
  $14 = $3; //@line 1067
  $15 = $14 + 36 | 0; //@line 1068
  $16 = SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0; //@line 1069
  $17 = $5; //@line 1070
  SAFE_HEAP_STORE($17 | 0, $16 | 0, 4);
  STACKTOP = sp; //@line 1072
  return;
 } else {
  $18 = $10 + 36 | 0; //@line 1074
  $19 = SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0; //@line 1075
  $20 = $4; //@line 1076
  SAFE_HEAP_STORE($20 | 0, $19 | 0, 4);
  $21 = $3; //@line 1078
  $22 = $21 + 40 | 0; //@line 1079
  $23 = SAFE_HEAP_LOAD($22 | 0, 4, 0) | 0 | 0; //@line 1080
  $24 = $5; //@line 1081
  SAFE_HEAP_STORE($24 | 0, $23 | 0, 4);
  STACKTOP = sp; //@line 1083
  return;
 }
}
function ___towrite($0) {
 $0 = $0 | 0; //@line 10820
 var $$0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0; //@line 10821
 var $8 = 0, $9 = 0, label = 0, sp = 0; //@line 10822
 sp = STACKTOP; //@line 10823
 $1 = $0 + 74 | 0; //@line 10824
 $2 = SAFE_HEAP_LOAD($1 >> 0 | 0, 1, 0) | 0 | 0; //@line 10825
 $3 = $2 << 24 >> 24; //@line 10826
 $4 = $3 + 255 | 0; //@line 10827
 $5 = $4 | $3; //@line 10828
 $6 = $5 & 255; //@line 10829
 SAFE_HEAP_STORE($1 >> 0 | 0, $6 | 0, 1);
 $7 = SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0; //@line 10831
 $8 = $7 & 8; //@line 10832
 $9 = ($8 | 0) == 0; //@line 10833
 if ($9) {
  $11 = $0 + 8 | 0; //@line 10835
  SAFE_HEAP_STORE($11 | 0, 0 | 0, 4);
  $12 = $0 + 4 | 0; //@line 10837
  SAFE_HEAP_STORE($12 | 0, 0 | 0, 4);
  $13 = $0 + 44 | 0; //@line 10839
  $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 10840
  $15 = $0 + 28 | 0; //@line 10841
  SAFE_HEAP_STORE($15 | 0, $14 | 0, 4);
  $16 = $0 + 20 | 0; //@line 10843
  SAFE_HEAP_STORE($16 | 0, $14 | 0, 4);
  $17 = $14; //@line 10845
  $18 = $0 + 48 | 0; //@line 10846
  $19 = SAFE_HEAP_LOAD($18 | 0, 4, 0) | 0 | 0; //@line 10847
  $20 = $17 + $19 | 0; //@line 10848
  $21 = $0 + 16 | 0; //@line 10849
  SAFE_HEAP_STORE($21 | 0, $20 | 0, 4);
  $$0 = 0; //@line 10851
 } else {
  $10 = $7 | 32; //@line 10853
  SAFE_HEAP_STORE($0 | 0, $10 | 0, 4);
  $$0 = -1; //@line 10855
 }
 return $$0 | 0; //@line 10857
}
function _cpArrayContains($0, $1) {
 $0 = $0 | 0; //@line 2890
 $1 = $1 | 0; //@line 2891
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0; //@line 2892
 var sp = 0; //@line 2893
 sp = STACKTOP; //@line 2894
 STACKTOP = STACKTOP + 16 | 0; //@line 2895
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2895
 $3 = $0; //@line 2896
 $4 = $1; //@line 2897
 $5 = 0; //@line 2898
 while (1) {
  $6 = $5; //@line 2900
  $7 = $3; //@line 2901
  $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 2902
  $9 = ($6 | 0) < ($8 | 0); //@line 2903
  if (!$9) {
   label = 6; //@line 2905
   break;
  }
  $10 = $3; //@line 2908
  $11 = $10 + 8 | 0; //@line 2909
  $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 2910
  $13 = $5; //@line 2911
  $14 = $12 + ($13 << 2) | 0; //@line 2912
  $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 2913
  $16 = $4; //@line 2914
  $17 = ($15 | 0) == ($16 | 0); //@line 2915
  if ($17) {
   label = 4; //@line 2917
   break;
  }
  $18 = $5; //@line 2920
  $19 = $18 + 1 | 0; //@line 2921
  $5 = $19; //@line 2922
 }
 if ((label | 0) == 4) {
  $2 = 1; //@line 2925
  $20 = $2; //@line 2926
  STACKTOP = sp; //@line 2927
  return $20 | 0; //@line 2927
 } else if ((label | 0) == 6) {
  $2 = 0; //@line 2930
  $20 = $2; //@line 2931
  STACKTOP = sp; //@line 2932
  return $20 | 0; //@line 2932
 }
 return 0 | 0; //@line 2934
}
function _cpArbiterSetSurfaceVelocity($0, $1) {
 $0 = $0 | 0; //@line 1025
 $1 = $1 | 0; //@line 1026
 var $$byval_copy = 0, $10 = 0, $11 = 0.0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1027
 sp = STACKTOP; //@line 1028
 STACKTOP = STACKTOP + 48 | 0; //@line 1029
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 1029
 $$byval_copy = sp + 16 | 0; //@line 1030
 $3 = sp; //@line 1031
 $2 = $0; //@line 1032
 $4 = $2; //@line 1033
 $5 = $4 + 16 | 0; //@line 1034
 $6 = $2; //@line 1035
 $7 = $6 + 108 | 0; //@line 1036
 $8 = SAFE_HEAP_LOAD($7 >> 0 | 0, 1, 0) | 0 | 0; //@line 1037
 $9 = $8 & 255; //@line 1038
 $10 = ($9 | 0) != 0; //@line 1039
 $11 = $10 ? -1.0 : 1.0; //@line 1040
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_1($3, $$byval_copy, $11); //@line 1042
 SAFE_HEAP_STORE($5 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($5 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($5 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($5 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 1044
 return;
}
function ___stdio_seek($0, $1, $2) {
 $0 = $0 | 0; //@line 10666
 $1 = $1 | 0; //@line 10667
 $2 = $2 | 0; //@line 10668
 var $$pre = 0, $10 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $vararg_ptr3 = 0, $vararg_ptr4 = 0, label = 0, sp = 0; //@line 10669
 sp = STACKTOP; //@line 10670
 STACKTOP = STACKTOP + 32 | 0; //@line 10671
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 10671
 $vararg_buffer = sp; //@line 10672
 $3 = sp + 20 | 0; //@line 10673
 $4 = $0 + 60 | 0; //@line 10674
 $5 = SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0; //@line 10675
 $6 = $3; //@line 10676
 SAFE_HEAP_STORE($vararg_buffer | 0, $5 | 0, 4);
 $vararg_ptr1 = $vararg_buffer + 4 | 0; //@line 10678
 SAFE_HEAP_STORE($vararg_ptr1 | 0, 0 | 0, 4);
 $vararg_ptr2 = $vararg_buffer + 8 | 0; //@line 10680
 SAFE_HEAP_STORE($vararg_ptr2 | 0, $1 | 0, 4);
 $vararg_ptr3 = $vararg_buffer + 12 | 0; //@line 10682
 SAFE_HEAP_STORE($vararg_ptr3 | 0, $6 | 0, 4);
 $vararg_ptr4 = $vararg_buffer + 16 | 0; //@line 10684
 SAFE_HEAP_STORE($vararg_ptr4 | 0, $2 | 0, 4);
 $7 = ___syscall140(140, $vararg_buffer | 0) | 0; //@line 10686
 $8 = ___syscall_ret($7) | 0; //@line 10687
 $9 = ($8 | 0) < 0; //@line 10688
 if ($9) {
  SAFE_HEAP_STORE($3 | 0, -1 | 0, 4);
  $10 = -1; //@line 10691
 } else {
  $$pre = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 10693
  $10 = $$pre; //@line 10694
 }
 STACKTOP = sp; //@line 10696
 return $10 | 0; //@line 10696
}
function _cpSpatialIndexCollideStatic($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 5696
 $1 = $1 | 0; //@line 5697
 $2 = $2 | 0; //@line 5698
 $3 = $3 | 0; //@line 5699
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0; //@line 5700
 var label = 0, sp = 0; //@line 5701
 sp = STACKTOP; //@line 5702
 STACKTOP = STACKTOP + 32 | 0; //@line 5703
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 5703
 $8 = sp; //@line 5704
 $4 = $0; //@line 5705
 $5 = $1; //@line 5706
 $6 = $2; //@line 5707
 $7 = $3; //@line 5708
 $9 = $5; //@line 5709
 $10 = ($9 | 0) != (0 | 0); //@line 5710
 if (!$10) {
  STACKTOP = sp; //@line 5712
  return;
 }
 $11 = $5; //@line 5714
 $12 = _cpSpatialIndexCount($11) | 0; //@line 5715
 $13 = ($12 | 0) > 0; //@line 5716
 if (!$13) {
  STACKTOP = sp; //@line 5718
  return;
 }
 $14 = $4; //@line 5720
 $15 = $14 + 4 | 0; //@line 5721
 $16 = SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0; //@line 5722
 SAFE_HEAP_STORE($8 | 0, $16 | 0, 4);
 $17 = $8 + 4 | 0; //@line 5724
 $18 = $5; //@line 5725
 SAFE_HEAP_STORE($17 | 0, $18 | 0, 4);
 $19 = $8 + 8 | 0; //@line 5727
 $20 = $6; //@line 5728
 SAFE_HEAP_STORE($19 | 0, $20 | 0, 4);
 $21 = $8 + 12 | 0; //@line 5730
 $22 = $7; //@line 5731
 SAFE_HEAP_STORE($21 | 0, $22 | 0, 4);
 $23 = $4; //@line 5733
 _cpSpatialIndexEach_598($23, 77, $8); //@line 5734
 STACKTOP = sp; //@line 5735
 return;
}
function _cpSegmentShapeNew($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 7076
 $1 = $1 | 0; //@line 7077
 $2 = $2 | 0; //@line 7078
 $3 = +$3; //@line 7079
 var $$byval_copy = 0, $$byval_copy1 = 0, $4 = 0, $5 = 0.0, $6 = 0, $7 = 0, $8 = 0.0, $9 = 0, label = 0, sp = 0; //@line 7080
 sp = STACKTOP; //@line 7081
 STACKTOP = STACKTOP + 48 | 0; //@line 7082
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 7082
 $$byval_copy1 = sp + 24 | 0; //@line 7083
 $$byval_copy = sp + 8 | 0; //@line 7084
 $4 = $0; //@line 7085
 $5 = $3; //@line 7086
 $6 = _cpSegmentShapeAlloc() | 0; //@line 7087
 $7 = $4; //@line 7088
 $8 = $5; //@line 7089
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $9 = _cpSegmentShapeInit($6, $7, $$byval_copy, $$byval_copy1, $8) | 0; //@line 7092
 STACKTOP = sp; //@line 7093
 return $9 | 0; //@line 7093
}
function _cpAreaForSegment($0, $1, $2) {
 $0 = $0 | 0; //@line 414
 $1 = $1 | 0; //@line 415
 $2 = +$2; //@line 416
 var $$byval_copy = 0, $$byval_copy1 = 0, $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0; //@line 417
 sp = STACKTOP; //@line 418
 STACKTOP = STACKTOP + 48 | 0; //@line 419
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 419
 $$byval_copy1 = sp + 24 | 0; //@line 420
 $$byval_copy = sp + 8 | 0; //@line 421
 $3 = $2; //@line 422
 $4 = $3; //@line 423
 $5 = $3; //@line 424
 $6 = 3.141592653589793 * $5; //@line 425
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $7 = +_cpvdist($$byval_copy, $$byval_copy1); //@line 428
 $8 = 2.0 * $7; //@line 429
 $9 = $6 + $8; //@line 430
 $10 = $4 * $9; //@line 431
 STACKTOP = sp; //@line 432
 return +$10;
}
function _cpPivotJointNew2($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 3748
 $1 = $1 | 0; //@line 3749
 $2 = $2 | 0; //@line 3750
 $3 = $3 | 0; //@line 3751
 var $$byval_copy = 0, $$byval_copy1 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3752
 sp = STACKTOP; //@line 3753
 STACKTOP = STACKTOP + 48 | 0; //@line 3754
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 3754
 $$byval_copy1 = sp + 16 | 0; //@line 3755
 $$byval_copy = sp; //@line 3756
 $4 = $0; //@line 3757
 $5 = $1; //@line 3758
 $6 = _cpPivotJointAlloc() | 0; //@line 3759
 $7 = $4; //@line 3760
 $8 = $5; //@line 3761
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $9 = _cpPivotJointInit($6, $7, $8, $$byval_copy, $$byval_copy1) | 0; //@line 3764
 STACKTOP = sp; //@line 3765
 return $9 | 0; //@line 3765
}
function _cpBBTreeInit($0, $1, $2) {
 $0 = $0 | 0; //@line 2943
 $1 = $1 | 0; //@line 2944
 $2 = $2 | 0; //@line 2945
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0; //@line 2946
 var $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2947
 sp = STACKTOP; //@line 2948
 STACKTOP = STACKTOP + 16 | 0; //@line 2949
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2949
 $3 = $0; //@line 2950
 $4 = $1; //@line 2951
 $5 = $2; //@line 2952
 $6 = $3; //@line 2953
 $7 = _Klass() | 0; //@line 2954
 $8 = $4; //@line 2955
 $9 = $5; //@line 2956
 _cpSpatialIndexInit($6, $7, $8, $9) | 0; //@line 2957
 $10 = $3; //@line 2958
 $11 = $10 + 16 | 0; //@line 2959
 SAFE_HEAP_STORE($11 | 0, 0 | 0, 4);
 $12 = _cpHashSetNew(0, 47) | 0; //@line 2961
 $13 = $3; //@line 2962
 $14 = $13 + 20 | 0; //@line 2963
 SAFE_HEAP_STORE($14 | 0, $12 | 0, 4);
 $15 = $3; //@line 2965
 $16 = $15 + 24 | 0; //@line 2966
 SAFE_HEAP_STORE($16 | 0, 0 | 0, 4);
 $17 = $3; //@line 2968
 $18 = $17 + 28 | 0; //@line 2969
 SAFE_HEAP_STORE($18 | 0, 0 | 0, 4);
 $19 = _cpArrayNew(0) | 0; //@line 2971
 $20 = $3; //@line 2972
 $21 = $20 + 36 | 0; //@line 2973
 SAFE_HEAP_STORE($21 | 0, $19 | 0, 4);
 $22 = $3; //@line 2975
 $23 = $22 + 40 | 0; //@line 2976
 SAFE_HEAP_STORE($23 | 0, 0 | 0, 4);
 $24 = $3; //@line 2978
 STACKTOP = sp; //@line 2979
 return $24 | 0; //@line 2979
}
function _cpTransformPoint_364($0, $1, $2) {
 $0 = $0 | 0; //@line 6175
 $1 = $1 | 0; //@line 6176
 $2 = $2 | 0; //@line 6177
 var $10 = 0.0, $11 = 0.0, $12 = 0, $13 = 0.0, $14 = 0.0, $15 = 0, $16 = 0.0, $17 = 0.0, $18 = 0.0, $19 = 0, $20 = 0.0, $21 = 0, $22 = 0.0, $23 = 0.0, $24 = 0.0, $25 = 0, $26 = 0.0, $27 = 0.0, $3 = 0.0, $4 = 0.0;
 var $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 6180
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 6181
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 6182
 $5 = $3 * $4; //@line 6183
 $6 = $1 + 16 | 0; //@line 6184
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 6185
 $8 = $2 + 8 | 0; //@line 6186
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 6187
 $10 = $7 * $9; //@line 6188
 $11 = $5 + $10; //@line 6189
 $12 = $1 + 32 | 0; //@line 6190
 $13 = +(+SAFE_HEAP_LOAD_D($12 | 0, 8)); //@line 6191
 $14 = $11 + $13; //@line 6192
 $15 = $1 + 8 | 0; //@line 6193
 $16 = +(+SAFE_HEAP_LOAD_D($15 | 0, 8)); //@line 6194
 $17 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 6195
 $18 = $16 * $17; //@line 6196
 $19 = $1 + 24 | 0; //@line 6197
 $20 = +(+SAFE_HEAP_LOAD_D($19 | 0, 8)); //@line 6198
 $21 = $2 + 8 | 0; //@line 6199
 $22 = +(+SAFE_HEAP_LOAD_D($21 | 0, 8)); //@line 6200
 $23 = $20 * $22; //@line 6201
 $24 = $18 + $23; //@line 6202
 $25 = $1 + 40 | 0; //@line 6203
 $26 = +(+SAFE_HEAP_LOAD_D($25 | 0, 8)); //@line 6204
 $27 = $24 + $26; //@line 6205
 _cpv_358($0, $14, $27); //@line 6206
 return;
}
function _cpTransformPoint_265($0, $1, $2) {
 $0 = $0 | 0; //@line 3774
 $1 = $1 | 0; //@line 3775
 $2 = $2 | 0; //@line 3776
 var $10 = 0.0, $11 = 0.0, $12 = 0, $13 = 0.0, $14 = 0.0, $15 = 0, $16 = 0.0, $17 = 0.0, $18 = 0.0, $19 = 0, $20 = 0.0, $21 = 0, $22 = 0.0, $23 = 0.0, $24 = 0.0, $25 = 0, $26 = 0.0, $27 = 0.0, $3 = 0.0, $4 = 0.0;
 var $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3779
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3780
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 3781
 $5 = $3 * $4; //@line 3782
 $6 = $1 + 16 | 0; //@line 3783
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 3784
 $8 = $2 + 8 | 0; //@line 3785
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 3786
 $10 = $7 * $9; //@line 3787
 $11 = $5 + $10; //@line 3788
 $12 = $1 + 32 | 0; //@line 3789
 $13 = +(+SAFE_HEAP_LOAD_D($12 | 0, 8)); //@line 3790
 $14 = $11 + $13; //@line 3791
 $15 = $1 + 8 | 0; //@line 3792
 $16 = +(+SAFE_HEAP_LOAD_D($15 | 0, 8)); //@line 3793
 $17 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 3794
 $18 = $16 * $17; //@line 3795
 $19 = $1 + 24 | 0; //@line 3796
 $20 = +(+SAFE_HEAP_LOAD_D($19 | 0, 8)); //@line 3797
 $21 = $2 + 8 | 0; //@line 3798
 $22 = +(+SAFE_HEAP_LOAD_D($21 | 0, 8)); //@line 3799
 $23 = $20 * $22; //@line 3800
 $24 = $18 + $23; //@line 3801
 $25 = $1 + 40 | 0; //@line 3802
 $26 = +(+SAFE_HEAP_LOAD_D($25 | 0, 8)); //@line 3803
 $27 = $24 + $26; //@line 3804
 _cpv_271($0, $14, $27); //@line 3805
 return;
}
function _cpTransformPoint($0, $1, $2) {
 $0 = $0 | 0; //@line 6951
 $1 = $1 | 0; //@line 6952
 $2 = $2 | 0; //@line 6953
 var $10 = 0.0, $11 = 0.0, $12 = 0, $13 = 0.0, $14 = 0.0, $15 = 0, $16 = 0.0, $17 = 0.0, $18 = 0.0, $19 = 0, $20 = 0.0, $21 = 0, $22 = 0.0, $23 = 0.0, $24 = 0.0, $25 = 0, $26 = 0.0, $27 = 0.0, $3 = 0.0, $4 = 0.0;
 var $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 6956
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 6957
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 6958
 $5 = $3 * $4; //@line 6959
 $6 = $1 + 16 | 0; //@line 6960
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 6961
 $8 = $2 + 8 | 0; //@line 6962
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 6963
 $10 = $7 * $9; //@line 6964
 $11 = $5 + $10; //@line 6965
 $12 = $1 + 32 | 0; //@line 6966
 $13 = +(+SAFE_HEAP_LOAD_D($12 | 0, 8)); //@line 6967
 $14 = $11 + $13; //@line 6968
 $15 = $1 + 8 | 0; //@line 6969
 $16 = +(+SAFE_HEAP_LOAD_D($15 | 0, 8)); //@line 6970
 $17 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 6971
 $18 = $16 * $17; //@line 6972
 $19 = $1 + 24 | 0; //@line 6973
 $20 = +(+SAFE_HEAP_LOAD_D($19 | 0, 8)); //@line 6974
 $21 = $2 + 8 | 0; //@line 6975
 $22 = +(+SAFE_HEAP_LOAD_D($21 | 0, 8)); //@line 6976
 $23 = $20 * $22; //@line 6977
 $24 = $18 + $23; //@line 6978
 $25 = $1 + 40 | 0; //@line 6979
 $26 = +(+SAFE_HEAP_LOAD_D($25 | 0, 8)); //@line 6980
 $27 = $24 + $26; //@line 6981
 _cpv_33($0, $14, $27); //@line 6982
 return;
}
function _chipmunk_cpBodySetVelocity($0, $1, $2) {
 $0 = $0 | 0; //@line 5891
 $1 = +$1; //@line 5892
 $2 = +$2; //@line 5893
 var $$byval_copy = 0, $10 = 0, $3 = 0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0, label = 0, sp = 0; //@line 5894
 sp = STACKTOP; //@line 5895
 STACKTOP = STACKTOP + 64 | 0; //@line 5896
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 5896
 $$byval_copy = sp + 32 | 0; //@line 5897
 $6 = sp; //@line 5898
 $3 = $0; //@line 5899
 $4 = $1; //@line 5900
 $5 = $2; //@line 5901
 SAFE_HEAP_STORE($6 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $7 = $4; //@line 5903
 SAFE_HEAP_STORE_D($6 | 0, +$7, 8);
 $8 = $5; //@line 5905
 $9 = $6 + 8 | 0; //@line 5906
 SAFE_HEAP_STORE_D($9 | 0, +$8, 8);
 $10 = $3; //@line 5908
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpBodySetVelocity($10, $$byval_copy); //@line 5910
 STACKTOP = sp; //@line 5911
 return;
}
function _chipmunk_cpBodySetPosition($0, $1, $2) {
 $0 = $0 | 0; //@line 5847
 $1 = +$1; //@line 5848
 $2 = +$2; //@line 5849
 var $$byval_copy = 0, $10 = 0, $3 = 0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0, label = 0, sp = 0; //@line 5850
 sp = STACKTOP; //@line 5851
 STACKTOP = STACKTOP + 64 | 0; //@line 5852
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 5852
 $$byval_copy = sp + 32 | 0; //@line 5853
 $6 = sp; //@line 5854
 $3 = $0; //@line 5855
 $4 = $1; //@line 5856
 $5 = $2; //@line 5857
 SAFE_HEAP_STORE($6 | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $7 = $4; //@line 5859
 SAFE_HEAP_STORE_D($6 | 0, +$7, 8);
 $8 = $5; //@line 5861
 $9 = $6 + 8 | 0; //@line 5862
 SAFE_HEAP_STORE_D($9 | 0, +$8, 8);
 $10 = $3; //@line 5864
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpBodySetPosition($10, $$byval_copy); //@line 5866
 STACKTOP = sp; //@line 5867
 return;
}
function _EPA($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 1368
 $1 = $1 | 0; //@line 1369
 $2 = $2 | 0; //@line 1370
 $3 = $3 | 0; //@line 1371
 $4 = $4 | 0; //@line 1372
 var $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 1373
 sp = STACKTOP; //@line 1374
 STACKTOP = STACKTOP + 176 | 0; //@line 1375
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(176 | 0); //@line 1375
 $6 = sp; //@line 1376
 $5 = $1; //@line 1377
 dest = $6; //@line 1378
 src = $2; //@line 1378
 stop = dest + 56 | 0; //@line 1378
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 1378
  src = src + 4 | 0; //@line 1378
 } while ((dest | 0) < (stop | 0));
 $7 = $6 + 56 | 0; //@line 1379
 dest = $7; //@line 1380
 src = $3; //@line 1380
 stop = dest + 56 | 0; //@line 1380
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 1380
  src = src + 4 | 0; //@line 1380
 } while ((dest | 0) < (stop | 0));
 $8 = $7 + 56 | 0; //@line 1381
 dest = $8; //@line 1382
 src = $4; //@line 1382
 stop = dest + 56 | 0; //@line 1382
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 1382
  src = src + 4 | 0; //@line 1382
 } while ((dest | 0) < (stop | 0));
 $9 = $5; //@line 1383
 _EPARecurse($0, $9, 3, $6, 1); //@line 1384
 STACKTOP = sp; //@line 1385
 return;
}
function _pad_661($0, $1, $2, $3, $4) {
 $0 = $0 | 0; //@line 12854
 $1 = $1 | 0; //@line 12855
 $2 = $2 | 0; //@line 12856
 $3 = $3 | 0; //@line 12857
 $4 = $4 | 0; //@line 12858
 var $$0$lcssa = 0, $$011 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0; //@line 12859
 sp = STACKTOP; //@line 12860
 STACKTOP = STACKTOP + 256 | 0; //@line 12861
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(256 | 0); //@line 12861
 $5 = sp; //@line 12862
 $6 = $4 & 73728; //@line 12863
 $7 = ($6 | 0) == 0; //@line 12864
 $8 = ($2 | 0) > ($3 | 0); //@line 12865
 $or$cond = $8 & $7; //@line 12866
 if ($or$cond) {
  $9 = $2 - $3 | 0; //@line 12868
  $10 = $1 << 24 >> 24; //@line 12869
  $11 = $9 >>> 0 < 256; //@line 12870
  $12 = $11 ? $9 : 256; //@line 12871
  _memset($5 | 0, $10 | 0, $12 | 0) | 0; //@line 12872
  $13 = $9 >>> 0 > 255; //@line 12873
  if ($13) {
   $14 = $2 - $3 | 0; //@line 12875
   $$011 = $9; //@line 12876
   while (1) {
    _out_655($0, $5, 256); //@line 12878
    $15 = $$011 + -256 | 0; //@line 12879
    $16 = $15 >>> 0 > 255; //@line 12880
    if ($16) {
     $$011 = $15; //@line 12882
    } else {
     break;
    }
   }
   $17 = $14 & 255; //@line 12887
   $$0$lcssa = $17; //@line 12888
  } else {
   $$0$lcssa = $9; //@line 12890
  }
  _out_655($0, $5, $$0$lcssa); //@line 12892
 }
 STACKTOP = sp; //@line 12894
 return;
}
function ___stdout_write($0, $1, $2) {
 $0 = $0 | 0; //@line 10725
 $1 = $1 | 0; //@line 10726
 $2 = $2 | 0; //@line 10727
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, label = 0, sp = 0; //@line 10728
 sp = STACKTOP; //@line 10729
 STACKTOP = STACKTOP + 32 | 0; //@line 10730
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 10730
 $vararg_buffer = sp; //@line 10731
 $3 = sp + 16 | 0; //@line 10732
 $4 = $0 + 36 | 0; //@line 10733
 SAFE_HEAP_STORE($4 | 0, 44 | 0, 4);
 $5 = SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0; //@line 10735
 $6 = $5 & 64; //@line 10736
 $7 = ($6 | 0) == 0; //@line 10737
 if ($7) {
  $8 = $0 + 60 | 0; //@line 10739
  $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 10740
  $10 = $3; //@line 10741
  SAFE_HEAP_STORE($vararg_buffer | 0, $9 | 0, 4);
  $vararg_ptr1 = $vararg_buffer + 4 | 0; //@line 10743
  SAFE_HEAP_STORE($vararg_ptr1 | 0, 21523 | 0, 4);
  $vararg_ptr2 = $vararg_buffer + 8 | 0; //@line 10745
  SAFE_HEAP_STORE($vararg_ptr2 | 0, $10 | 0, 4);
  $11 = ___syscall54(54, $vararg_buffer | 0) | 0; //@line 10747
  $12 = ($11 | 0) == 0; //@line 10748
  if (!$12) {
   $13 = $0 + 75 | 0; //@line 10750
   SAFE_HEAP_STORE($13 >> 0 | 0, -1 | 0, 1);
  }
 }
 $14 = ___stdio_write($0, $1, $2) | 0; //@line 10754
 STACKTOP = sp; //@line 10755
 return $14 | 0; //@line 10755
}
function _strcmp($0, $1) {
 $0 = $0 | 0; //@line 10772
 $1 = $1 | 0; //@line 10773
 var $$011 = 0, $$0710 = 0, $$lcssa = 0, $$lcssa8 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond9 = 0, label = 0; //@line 10774
 var sp = 0; //@line 10775
 sp = STACKTOP; //@line 10776
 $2 = SAFE_HEAP_LOAD($0 >> 0 | 0, 1, 0) | 0 | 0; //@line 10777
 $3 = SAFE_HEAP_LOAD($1 >> 0 | 0, 1, 0) | 0 | 0; //@line 10778
 $4 = $2 << 24 >> 24 != $3 << 24 >> 24; //@line 10779
 $5 = $2 << 24 >> 24 == 0; //@line 10780
 $or$cond9 = $5 | $4; //@line 10781
 if ($or$cond9) {
  $$lcssa = $3; //@line 10783
  $$lcssa8 = $2; //@line 10783
 } else {
  $$011 = $1; //@line 10785
  $$0710 = $0; //@line 10785
  while (1) {
   $6 = $$0710 + 1 | 0; //@line 10787
   $7 = $$011 + 1 | 0; //@line 10788
   $8 = SAFE_HEAP_LOAD($6 >> 0 | 0, 1, 0) | 0 | 0; //@line 10789
   $9 = SAFE_HEAP_LOAD($7 >> 0 | 0, 1, 0) | 0 | 0; //@line 10790
   $10 = $8 << 24 >> 24 != $9 << 24 >> 24; //@line 10791
   $11 = $8 << 24 >> 24 == 0; //@line 10792
   $or$cond = $11 | $10; //@line 10793
   if ($or$cond) {
    $$lcssa = $9; //@line 10795
    $$lcssa8 = $8; //@line 10795
    break;
   } else {
    $$011 = $7; //@line 10798
    $$0710 = $6; //@line 10798
   }
  }
 }
 $12 = $$lcssa8 & 255; //@line 10802
 $13 = $$lcssa & 255; //@line 10803
 $14 = $12 - $13 | 0; //@line 10804
 return $14 | 0; //@line 10805
}
function _cpShapeFilterReject_581($0, $1) {
 $0 = $0 | 0; //@line 4860
 $1 = $1 | 0; //@line 4861
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0; //@line 4862
 var label = 0, sp = 0; //@line 4863
 sp = STACKTOP; //@line 4864
 $2 = SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0; //@line 4865
 $3 = ($2 | 0) != 0; //@line 4866
 if ($3) {
  $4 = SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0; //@line 4868
  $5 = SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0; //@line 4869
  $6 = ($4 | 0) == ($5 | 0); //@line 4870
  if ($6) {
   $20 = 1; //@line 4872
  } else {
   label = 3; //@line 4874
  }
 } else {
  label = 3; //@line 4877
 }
 if ((label | 0) == 3) {
  $7 = $0 + 4 | 0; //@line 4880
  $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 4881
  $9 = $1 + 8 | 0; //@line 4882
  $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 4883
  $11 = $8 & $10; //@line 4884
  $12 = ($11 | 0) == 0; //@line 4885
  if ($12) {
   $20 = 1; //@line 4887
  } else {
   $13 = $1 + 4 | 0; //@line 4889
   $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 4890
   $15 = $0 + 8 | 0; //@line 4891
   $16 = SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0; //@line 4892
   $17 = $14 & $16; //@line 4893
   $18 = ($17 | 0) == 0; //@line 4894
   $20 = $18; //@line 4895
  }
 }
 $19 = $20 & 1; //@line 4898
 $21 = $19 & 255; //@line 4899
 return $21 | 0; //@line 4900
}
function _cpSpaceLookupHandler($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 1771
 $1 = $1 | 0; //@line 1772
 $2 = $2 | 0; //@line 1773
 $3 = $3 | 0; //@line 1774
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $4 = 0, $5 = 0, $6 = 0; //@line 1775
 var $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1776
 sp = STACKTOP; //@line 1777
 STACKTOP = STACKTOP + 32 | 0; //@line 1778
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 1778
 $8 = sp + 8 | 0; //@line 1779
 $4 = $0; //@line 1780
 $5 = $1; //@line 1781
 $6 = $2; //@line 1782
 $7 = $3; //@line 1783
 $10 = $5; //@line 1784
 SAFE_HEAP_STORE($8 | 0, $10 | 0, 4);
 $11 = $8 + 4 | 0; //@line 1786
 $12 = $6; //@line 1787
 SAFE_HEAP_STORE($11 | 0, $12 | 0, 4);
 $13 = $4; //@line 1789
 $14 = $13 + 148 | 0; //@line 1790
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 1791
 $16 = $5; //@line 1792
 $17 = Math_imul($16, -950046239) | 0; //@line 1793
 $18 = $6; //@line 1794
 $19 = Math_imul($18, -950046239) | 0; //@line 1795
 $20 = $17 ^ $19; //@line 1796
 $21 = _cpHashSetFind($15, $20, $8) | 0; //@line 1797
 $9 = $21; //@line 1798
 $22 = $9; //@line 1799
 $23 = ($22 | 0) != (0 | 0); //@line 1800
 $24 = $9; //@line 1801
 $25 = $7; //@line 1802
 $26 = $23 ? $24 : $25; //@line 1803
 STACKTOP = sp; //@line 1804
 return $26 | 0; //@line 1804
}
function _cpShapeFilterReject($0, $1) {
 $0 = $0 | 0; //@line 3755
 $1 = $1 | 0; //@line 3756
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0; //@line 3757
 var label = 0, sp = 0; //@line 3758
 sp = STACKTOP; //@line 3759
 $2 = SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0; //@line 3760
 $3 = ($2 | 0) != 0; //@line 3761
 if ($3) {
  $4 = SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0; //@line 3763
  $5 = SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0; //@line 3764
  $6 = ($4 | 0) == ($5 | 0); //@line 3765
  if ($6) {
   $20 = 1; //@line 3767
  } else {
   label = 3; //@line 3769
  }
 } else {
  label = 3; //@line 3772
 }
 if ((label | 0) == 3) {
  $7 = $0 + 4 | 0; //@line 3775
  $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 3776
  $9 = $1 + 8 | 0; //@line 3777
  $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 3778
  $11 = $8 & $10; //@line 3779
  $12 = ($11 | 0) == 0; //@line 3780
  if ($12) {
   $20 = 1; //@line 3782
  } else {
   $13 = $1 + 4 | 0; //@line 3784
   $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 3785
   $15 = $0 + 8 | 0; //@line 3786
   $16 = SAFE_HEAP_LOAD($15 | 0, 4, 0) | 0 | 0; //@line 3787
   $17 = $14 & $16; //@line 3788
   $18 = ($17 | 0) == 0; //@line 3789
   $20 = $18; //@line 3790
  }
 }
 $19 = $20 & 1; //@line 3793
 $21 = $19 & 255; //@line 3794
 return $21 | 0; //@line 3795
}
function _cpBodyAddShape($0, $1) {
 $0 = $0 | 0; //@line 7064
 $1 = $1 | 0; //@line 7065
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0.0, $22 = 0, $23 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0; //@line 7066
 var $8 = 0, $9 = 0, label = 0, sp = 0; //@line 7067
 sp = STACKTOP; //@line 7068
 STACKTOP = STACKTOP + 16 | 0; //@line 7069
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7069
 $2 = $0; //@line 7070
 $3 = $1; //@line 7071
 $5 = $2; //@line 7072
 $6 = $5 + 212 | 0; //@line 7073
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 7074
 $4 = $7; //@line 7075
 $8 = $4; //@line 7076
 $9 = ($8 | 0) != (0 | 0); //@line 7077
 if ($9) {
  $10 = $3; //@line 7079
  $11 = $4; //@line 7080
  $12 = $11 + 152 | 0; //@line 7081
  SAFE_HEAP_STORE($12 | 0, $10 | 0, 4);
 }
 $13 = $4; //@line 7084
 $14 = $3; //@line 7085
 $15 = $14 + 148 | 0; //@line 7086
 SAFE_HEAP_STORE($15 | 0, $13 | 0, 4);
 $16 = $3; //@line 7088
 $17 = $2; //@line 7089
 $18 = $17 + 212 | 0; //@line 7090
 SAFE_HEAP_STORE($18 | 0, $16 | 0, 4);
 $19 = $3; //@line 7092
 $20 = $19 + 16 | 0; //@line 7093
 $21 = +(+SAFE_HEAP_LOAD_D($20 | 0, 8)); //@line 7094
 $22 = $21 > 0.0; //@line 7095
 if (!$22) {
  STACKTOP = sp; //@line 7097
  return;
 }
 $23 = $2; //@line 7099
 _cpBodyAccumulateMassFromShapes($23); //@line 7100
 STACKTOP = sp; //@line 7101
 return;
}
function _cpBBIntersects_580($0, $1) {
 $0 = $0 | 0; //@line 4819
 $1 = $1 | 0; //@line 4820
 var $10 = 0, $11 = 0.0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0.0, $17 = 0, $18 = 0.0, $19 = 0, $2 = 0.0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0; //@line 4821
 var $9 = 0, label = 0, sp = 0; //@line 4822
 sp = STACKTOP; //@line 4823
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 4824
 $3 = $1 + 16 | 0; //@line 4825
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 4826
 $5 = $2 <= $4; //@line 4827
 if ($5) {
  $6 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 4829
  $7 = $0 + 16 | 0; //@line 4830
  $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 4831
  $9 = $6 <= $8; //@line 4832
  if ($9) {
   $10 = $0 + 8 | 0; //@line 4834
   $11 = +(+SAFE_HEAP_LOAD_D($10 | 0, 8)); //@line 4835
   $12 = $1 + 24 | 0; //@line 4836
   $13 = +(+SAFE_HEAP_LOAD_D($12 | 0, 8)); //@line 4837
   $14 = $11 <= $13; //@line 4838
   if ($14) {
    $15 = $1 + 8 | 0; //@line 4840
    $16 = +(+SAFE_HEAP_LOAD_D($15 | 0, 8)); //@line 4841
    $17 = $0 + 24 | 0; //@line 4842
    $18 = +(+SAFE_HEAP_LOAD_D($17 | 0, 8)); //@line 4843
    $19 = $16 <= $18; //@line 4844
    $21 = $19; //@line 4845
   } else {
    $21 = 0; //@line 4847
   }
  } else {
   $21 = 0; //@line 4850
  }
 } else {
  $21 = 0; //@line 4853
 }
 $20 = $21 & 1; //@line 4855
 $22 = $20 & 255; //@line 4856
 return $22 | 0; //@line 4857
}
function _cpBBContainsBB($0, $1) {
 $0 = $0 | 0; //@line 4413
 $1 = $1 | 0; //@line 4414
 var $10 = 0, $11 = 0.0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0.0, $17 = 0, $18 = 0.0, $19 = 0, $2 = 0.0, $20 = 0, $21 = 0, $22 = 0, $3 = 0.0, $4 = 0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0; //@line 4415
 var $9 = 0, label = 0, sp = 0; //@line 4416
 sp = STACKTOP; //@line 4417
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 4418
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 4419
 $4 = $2 <= $3; //@line 4420
 if ($4) {
  $5 = $0 + 16 | 0; //@line 4422
  $6 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 4423
  $7 = $1 + 16 | 0; //@line 4424
  $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 4425
  $9 = $6 >= $8; //@line 4426
  if ($9) {
   $10 = $0 + 8 | 0; //@line 4428
   $11 = +(+SAFE_HEAP_LOAD_D($10 | 0, 8)); //@line 4429
   $12 = $1 + 8 | 0; //@line 4430
   $13 = +(+SAFE_HEAP_LOAD_D($12 | 0, 8)); //@line 4431
   $14 = $11 <= $13; //@line 4432
   if ($14) {
    $15 = $0 + 24 | 0; //@line 4434
    $16 = +(+SAFE_HEAP_LOAD_D($15 | 0, 8)); //@line 4435
    $17 = $1 + 24 | 0; //@line 4436
    $18 = +(+SAFE_HEAP_LOAD_D($17 | 0, 8)); //@line 4437
    $19 = $16 >= $18; //@line 4438
    $21 = $19; //@line 4439
   } else {
    $21 = 0; //@line 4441
   }
  } else {
   $21 = 0; //@line 4444
  }
 } else {
  $21 = 0; //@line 4447
 }
 $20 = $21 & 1; //@line 4449
 $22 = $20 & 255; //@line 4450
 return $22 | 0; //@line 4451
}
function _cpBBIntersects($0, $1) {
 $0 = $0 | 0; //@line 3791
 $1 = $1 | 0; //@line 3792
 var $10 = 0, $11 = 0.0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0.0, $17 = 0, $18 = 0.0, $19 = 0, $2 = 0.0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0; //@line 3793
 var $9 = 0, label = 0, sp = 0; //@line 3794
 sp = STACKTOP; //@line 3795
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 3796
 $3 = $1 + 16 | 0; //@line 3797
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 3798
 $5 = $2 <= $4; //@line 3799
 if ($5) {
  $6 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3801
  $7 = $0 + 16 | 0; //@line 3802
  $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 3803
  $9 = $6 <= $8; //@line 3804
  if ($9) {
   $10 = $0 + 8 | 0; //@line 3806
   $11 = +(+SAFE_HEAP_LOAD_D($10 | 0, 8)); //@line 3807
   $12 = $1 + 24 | 0; //@line 3808
   $13 = +(+SAFE_HEAP_LOAD_D($12 | 0, 8)); //@line 3809
   $14 = $11 <= $13; //@line 3810
   if ($14) {
    $15 = $1 + 8 | 0; //@line 3812
    $16 = +(+SAFE_HEAP_LOAD_D($15 | 0, 8)); //@line 3813
    $17 = $0 + 24 | 0; //@line 3814
    $18 = +(+SAFE_HEAP_LOAD_D($17 | 0, 8)); //@line 3815
    $19 = $16 <= $18; //@line 3816
    $21 = $19; //@line 3817
   } else {
    $21 = 0; //@line 3819
   }
  } else {
   $21 = 0; //@line 3822
  }
 } else {
  $21 = 0; //@line 3825
 }
 $20 = $21 & 1; //@line 3827
 $22 = $20 & 255; //@line 3828
 return $22 | 0; //@line 3829
}
function _ComponentActive($0, $1) {
 $0 = $0 | 0; //@line 3111
 $1 = +$1; //@line 3112
 var $10 = 0, $11 = 0, $12 = 0.0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3113
 sp = STACKTOP; //@line 3114
 STACKTOP = STACKTOP + 32 | 0; //@line 3115
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 3115
 $3 = $0; //@line 3116
 $4 = $1; //@line 3117
 $6 = $3; //@line 3118
 $5 = $6; //@line 3119
 while (1) {
  $7 = $5; //@line 3121
  $8 = ($7 | 0) != (0 | 0); //@line 3122
  if (!$8) {
   label = 6; //@line 3124
   break;
  }
  $9 = $5; //@line 3127
  $10 = $9 + 224 | 0; //@line 3128
  $11 = $10 + 8 | 0; //@line 3129
  $12 = +(+SAFE_HEAP_LOAD_D($11 | 0, 8)); //@line 3130
  $13 = $4; //@line 3131
  $14 = $12 < $13; //@line 3132
  if ($14) {
   label = 4; //@line 3134
   break;
  }
  $15 = $5; //@line 3137
  $16 = $15 + 224 | 0; //@line 3138
  $17 = $16 + 4 | 0; //@line 3139
  $18 = SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0; //@line 3140
  $5 = $18; //@line 3141
 }
 if ((label | 0) == 4) {
  $2 = 1; //@line 3144
  $19 = $2; //@line 3145
  STACKTOP = sp; //@line 3146
  return $19 | 0; //@line 3146
 } else if ((label | 0) == 6) {
  $2 = 0; //@line 3149
  $19 = $2; //@line 3150
  STACKTOP = sp; //@line 3151
  return $19 | 0; //@line 3151
 }
 return 0 | 0; //@line 3153
}
function _fmt_x($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 12707
 $1 = $1 | 0; //@line 12708
 $2 = $2 | 0; //@line 12709
 $3 = $3 | 0; //@line 12710
 var $$05$lcssa = 0, $$056 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0; //@line 12711
 var sp = 0; //@line 12712
 sp = STACKTOP; //@line 12713
 $4 = ($0 | 0) == 0; //@line 12714
 $5 = ($1 | 0) == 0; //@line 12715
 $6 = $4 & $5; //@line 12716
 if ($6) {
  $$05$lcssa = $2; //@line 12718
 } else {
  $$056 = $2; //@line 12720
  $15 = $1; //@line 12720
  $8 = $0; //@line 12720
  while (1) {
   $7 = $8 & 15; //@line 12722
   $9 = 656 + $7 | 0; //@line 12723
   $10 = SAFE_HEAP_LOAD($9 >> 0 | 0, 1, 0) | 0 | 0; //@line 12724
   $11 = $10 & 255; //@line 12725
   $12 = $11 | $3; //@line 12726
   $13 = $12 & 255; //@line 12727
   $14 = $$056 + -1 | 0; //@line 12728
   SAFE_HEAP_STORE($14 >> 0 | 0, $13 | 0, 1);
   $16 = _bitshift64Lshr($8 | 0, $15 | 0, 4) | 0; //@line 12730
   $17 = getTempRet0() | 0; //@line 12731
   $18 = ($16 | 0) == 0; //@line 12732
   $19 = ($17 | 0) == 0; //@line 12733
   $20 = $18 & $19; //@line 12734
   if ($20) {
    $$05$lcssa = $14; //@line 12736
    break;
   } else {
    $$056 = $14; //@line 12739
    $15 = $17; //@line 12739
    $8 = $16; //@line 12739
   }
  }
 }
 return $$05$lcssa | 0; //@line 12743
}
function _next_prime($0) {
 $0 = $0 | 0; //@line 2240
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 2241
 sp = STACKTOP; //@line 2242
 STACKTOP = STACKTOP + 16 | 0; //@line 2243
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2243
 $vararg_buffer = sp; //@line 2244
 $1 = $0; //@line 2245
 $2 = 0; //@line 2246
 while (1) {
  $3 = $1; //@line 2248
  $4 = $2; //@line 2249
  $5 = 64 + ($4 << 2) | 0; //@line 2250
  $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 2251
  $7 = ($3 | 0) > ($6 | 0); //@line 2252
  $8 = $2; //@line 2253
  if (!$7) {
   label = 6; //@line 2255
   break;
  }
  $9 = $8 + 1 | 0; //@line 2258
  $2 = $9; //@line 2259
  $10 = $2; //@line 2260
  $11 = 64 + ($10 << 2) | 0; //@line 2261
  $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 2262
  $13 = ($12 | 0) != 0; //@line 2263
  if (!$13) {
   label = 4; //@line 2265
   break;
  }
 }
 if ((label | 0) == 4) {
  _cpMessage(5201, 5211, 64, 1, 1, 5268, $vararg_buffer); //@line 2270
  _abort(); //@line 2271
 } else if ((label | 0) == 6) {
  $14 = 64 + ($8 << 2) | 0; //@line 2275
  $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 2276
  STACKTOP = sp; //@line 2277
  return $15 | 0; //@line 2277
 }
 return 0 | 0; //@line 2279
}
function _cpBBTreeRemove($0, $1, $2) {
 $0 = $0 | 0; //@line 3127
 $1 = $1 | 0; //@line 3128
 $2 = $2 | 0; //@line 3129
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0; //@line 3130
 var $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3131
 sp = STACKTOP; //@line 3132
 STACKTOP = STACKTOP + 16 | 0; //@line 3133
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3133
 $3 = $0; //@line 3134
 $4 = $1; //@line 3135
 $5 = $2; //@line 3136
 $7 = $3; //@line 3137
 $8 = $7 + 20 | 0; //@line 3138
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 3139
 $10 = $5; //@line 3140
 $11 = $4; //@line 3141
 $12 = _cpHashSetRemove($9, $10, $11) | 0; //@line 3142
 $6 = $12; //@line 3143
 $13 = $3; //@line 3144
 $14 = $13 + 24 | 0; //@line 3145
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 3146
 $16 = $6; //@line 3147
 $17 = $3; //@line 3148
 $18 = _SubtreeRemove($15, $16, $17) | 0; //@line 3149
 $19 = $3; //@line 3150
 $20 = $19 + 24 | 0; //@line 3151
 SAFE_HEAP_STORE($20 | 0, $18 | 0, 4);
 $21 = $6; //@line 3153
 $22 = $3; //@line 3154
 _PairsClear($21, $22); //@line 3155
 $23 = $3; //@line 3156
 $24 = $6; //@line 3157
 _NodeRecycle($23, $24); //@line 3158
 STACKTOP = sp; //@line 3159
 return;
}
function _cpvnormalize_355($0, $1) {
 $0 = $0 | 0; //@line 5578
 $1 = $1 | 0; //@line 5579
 var $$byval_copy = 0, $$byval_copy1 = 0, $2 = 0.0, $3 = 0.0, $4 = 0.0, label = 0, sp = 0; //@line 5580
 sp = STACKTOP; //@line 5581
 STACKTOP = STACKTOP + 32 | 0; //@line 5582
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 5582
 $$byval_copy1 = sp + 16 | 0; //@line 5583
 $$byval_copy = sp; //@line 5584
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $2 = +_cpvlength_356($$byval_copy); //@line 5586
 $3 = $2 + 2.2250738585072014e-308; //@line 5587
 $4 = 1.0 / $3; //@line 5588
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_357($0, $$byval_copy1, $4); //@line 5590
 STACKTOP = sp; //@line 5591
 return;
}
function _cpvnormalize_268($0, $1) {
 $0 = $0 | 0; //@line 4010
 $1 = $1 | 0; //@line 4011
 var $$byval_copy = 0, $$byval_copy1 = 0, $2 = 0.0, $3 = 0.0, $4 = 0.0, label = 0, sp = 0; //@line 4012
 sp = STACKTOP; //@line 4013
 STACKTOP = STACKTOP + 32 | 0; //@line 4014
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 4014
 $$byval_copy1 = sp + 16 | 0; //@line 4015
 $$byval_copy = sp; //@line 4016
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $2 = +_cpvlength_269($$byval_copy); //@line 4018
 $3 = $2 + 2.2250738585072014e-308; //@line 4019
 $4 = 1.0 / $3; //@line 4020
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_270($0, $$byval_copy1, $4); //@line 4022
 STACKTOP = sp; //@line 4023
 return;
}
function _cpvnormalize_252($0, $1) {
 $0 = $0 | 0; //@line 3497
 $1 = $1 | 0; //@line 3498
 var $$byval_copy = 0, $$byval_copy1 = 0, $2 = 0.0, $3 = 0.0, $4 = 0.0, label = 0, sp = 0; //@line 3499
 sp = STACKTOP; //@line 3500
 STACKTOP = STACKTOP + 32 | 0; //@line 3501
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 3501
 $$byval_copy1 = sp + 16 | 0; //@line 3502
 $$byval_copy = sp; //@line 3503
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $2 = +_cpvlength_239($$byval_copy); //@line 3505
 $3 = $2 + 2.2250738585072014e-308; //@line 3506
 $4 = 1.0 / $3; //@line 3507
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_249($0, $$byval_copy1, $4); //@line 3509
 STACKTOP = sp; //@line 3510
 return;
}
function _cpBodyGetPosition($0, $1) {
 $0 = $0 | 0; //@line 6775
 $1 = $1 | 0; //@line 6776
 var $$byval_copy = 0, $2 = 0, $3 = 0, $4 = 0, $cpvzero$32$byval_copy = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 6777
 sp = STACKTOP; //@line 6778
 STACKTOP = STACKTOP + 80 | 0; //@line 6779
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(80 | 0); //@line 6779
 $cpvzero$32$byval_copy = sp + 48 | 0; //@line 6780
 $$byval_copy = sp; //@line 6781
 $2 = $1; //@line 6782
 $3 = $2; //@line 6783
 $4 = $3 + 128 | 0; //@line 6784
 dest = $$byval_copy; //@line 6785
 src = $4; //@line 6785
 stop = dest + 48 | 0; //@line 6785
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 6785
  src = src + 4 | 0; //@line 6785
 } while ((dest | 0) < (stop | 0));
 SAFE_HEAP_STORE($cpvzero$32$byval_copy | 0, SAFE_HEAP_LOAD(11280 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($cpvzero$32$byval_copy + 4 | 0, SAFE_HEAP_LOAD(11280 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($cpvzero$32$byval_copy + 8 | 0, SAFE_HEAP_LOAD(11280 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($cpvzero$32$byval_copy + 12 | 0, SAFE_HEAP_LOAD(11280 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpTransformPoint($0, $$byval_copy, $cpvzero$32$byval_copy); //@line 6787
 STACKTOP = sp; //@line 6788
 return;
}
function _cpvnormalize($0, $1) {
 $0 = $0 | 0; //@line 1728
 $1 = $1 | 0; //@line 1729
 var $$byval_copy = 0, $$byval_copy1 = 0, $2 = 0.0, $3 = 0.0, $4 = 0.0, label = 0, sp = 0; //@line 1730
 sp = STACKTOP; //@line 1731
 STACKTOP = STACKTOP + 32 | 0; //@line 1732
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 1732
 $$byval_copy1 = sp + 16 | 0; //@line 1733
 $$byval_copy = sp; //@line 1734
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $2 = +_cpvlength_85($$byval_copy); //@line 1736
 $3 = $2 + 2.2250738585072014e-308; //@line 1737
 $4 = 1.0 / $3; //@line 1738
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_64($0, $$byval_copy1, $4); //@line 1740
 STACKTOP = sp; //@line 1741
 return;
}
function _cpMomentForCircle($0, $1, $2, $3) {
 $0 = +$0; //@line 157
 $1 = +$1; //@line 158
 $2 = +$2; //@line 159
 $3 = $3 | 0; //@line 160
 var $$byval_copy = 0, $10 = 0.0, $11 = 0.0, $12 = 0.0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0.0, $17 = 0.0, $18 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0; //@line 161
 sp = STACKTOP; //@line 162
 STACKTOP = STACKTOP + 48 | 0; //@line 163
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 163
 $$byval_copy = sp + 24 | 0; //@line 164
 $4 = $0; //@line 165
 $5 = $1; //@line 166
 $6 = $2; //@line 167
 $7 = $4; //@line 168
 $8 = $5; //@line 169
 $9 = $5; //@line 170
 $10 = $8 * $9; //@line 171
 $11 = $6; //@line 172
 $12 = $6; //@line 173
 $13 = $11 * $12; //@line 174
 $14 = $10 + $13; //@line 175
 $15 = .5 * $14; //@line 176
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $16 = +_cpvlengthsq($$byval_copy); //@line 178
 $17 = $15 + $16; //@line 179
 $18 = $7 * $17; //@line 180
 STACKTOP = sp; //@line 181
 return +$18;
}
function _DefaultPreSolve($0, $1, $2) {
 $0 = $0 | 0; //@line 1063
 $1 = $1 | 0; //@line 1064
 $2 = $2 | 0; //@line 1065
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0; //@line 1066
 var label = 0, sp = 0; //@line 1067
 sp = STACKTOP; //@line 1068
 STACKTOP = STACKTOP + 16 | 0; //@line 1069
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1069
 $3 = $0; //@line 1070
 $4 = $1; //@line 1071
 $5 = $2; //@line 1072
 $8 = $3; //@line 1073
 $9 = $4; //@line 1074
 $10 = _cpArbiterCallWildcardPreSolveA($8, $9) | 0; //@line 1075
 $6 = $10; //@line 1076
 $11 = $3; //@line 1077
 $12 = $4; //@line 1078
 $13 = _cpArbiterCallWildcardPreSolveB($11, $12) | 0; //@line 1079
 $7 = $13; //@line 1080
 $14 = $6; //@line 1081
 $15 = $14 & 255; //@line 1082
 $16 = ($15 | 0) != 0; //@line 1083
 if (!$16) {
  $21 = 0; //@line 1085
  $20 = $21 & 1; //@line 1086
  $22 = $20 & 255; //@line 1087
  STACKTOP = sp; //@line 1088
  return $22 | 0; //@line 1088
 }
 $17 = $7; //@line 1090
 $18 = $17 & 255; //@line 1091
 $19 = ($18 | 0) != 0; //@line 1092
 $21 = $19; //@line 1093
 $20 = $21 & 1; //@line 1094
 $22 = $20 & 255; //@line 1095
 STACKTOP = sp; //@line 1096
 return $22 | 0; //@line 1096
}
function _cpv_assert_sane($0, $1) {
 $0 = $0 | 0; //@line 6225
 $1 = $1 | 0; //@line 6226
 var $$byval_copy = 0, $$byval_copy1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0; //@line 6227
 sp = STACKTOP; //@line 6228
 STACKTOP = STACKTOP + 48 | 0; //@line 6229
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 6229
 $$byval_copy1 = sp + 16 | 0; //@line 6230
 $$byval_copy = sp; //@line 6231
 $2 = $1; //@line 6232
 $3 = $2; //@line 6233
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpv_assert_nan($$byval_copy, $3); //@line 6235
 $4 = $2; //@line 6236
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpv_assert_infinite($$byval_copy1, $4); //@line 6238
 STACKTOP = sp; //@line 6239
 return;
}
function _DefaultBegin($0, $1, $2) {
 $0 = $0 | 0; //@line 1027
 $1 = $1 | 0; //@line 1028
 $2 = $2 | 0; //@line 1029
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0; //@line 1030
 var label = 0, sp = 0; //@line 1031
 sp = STACKTOP; //@line 1032
 STACKTOP = STACKTOP + 16 | 0; //@line 1033
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1033
 $3 = $0; //@line 1034
 $4 = $1; //@line 1035
 $5 = $2; //@line 1036
 $8 = $3; //@line 1037
 $9 = $4; //@line 1038
 $10 = _cpArbiterCallWildcardBeginA($8, $9) | 0; //@line 1039
 $6 = $10; //@line 1040
 $11 = $3; //@line 1041
 $12 = $4; //@line 1042
 $13 = _cpArbiterCallWildcardBeginB($11, $12) | 0; //@line 1043
 $7 = $13; //@line 1044
 $14 = $6; //@line 1045
 $15 = $14 & 255; //@line 1046
 $16 = ($15 | 0) != 0; //@line 1047
 if (!$16) {
  $21 = 0; //@line 1049
  $20 = $21 & 1; //@line 1050
  $22 = $20 & 255; //@line 1051
  STACKTOP = sp; //@line 1052
  return $22 | 0; //@line 1052
 }
 $17 = $7; //@line 1054
 $18 = $17 & 255; //@line 1055
 $19 = ($18 | 0) != 0; //@line 1056
 $21 = $19; //@line 1057
 $20 = $21 & 1; //@line 1058
 $22 = $20 & 255; //@line 1059
 STACKTOP = sp; //@line 1060
 return $22 | 0; //@line 1060
}
function _cpvnormalize_417($0, $1) {
 $0 = $0 | 0; //@line 43
 $1 = $1 | 0; //@line 44
 var $$byval_copy = 0, $$byval_copy1 = 0, $2 = 0.0, $3 = 0.0, $4 = 0.0, label = 0, sp = 0; //@line 45
 sp = STACKTOP; //@line 46
 STACKTOP = STACKTOP + 32 | 0; //@line 47
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 47
 $$byval_copy1 = sp + 16 | 0; //@line 48
 $$byval_copy = sp; //@line 49
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $2 = +_cpvlength_416($$byval_copy); //@line 51
 $3 = $2 + 2.2250738585072014e-308; //@line 52
 $4 = 1.0 / $3; //@line 53
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_404($0, $$byval_copy1, $4); //@line 55
 STACKTOP = sp; //@line 56
 return;
}
function _SupportPointNew($0, $1, $2) {
 $0 = $0 | 0; //@line 1757
 $1 = $1 | 0; //@line 1758
 $2 = $2 | 0; //@line 1759
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0; //@line 1760
 sp = STACKTOP; //@line 1761
 STACKTOP = STACKTOP + 32 | 0; //@line 1762
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 1762
 $4 = sp; //@line 1763
 $3 = $2; //@line 1764
 SAFE_HEAP_STORE($4 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($4 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($4 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($4 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $5 = $4 + 16 | 0; //@line 1766
 $6 = $3; //@line 1767
 SAFE_HEAP_STORE($5 | 0, $6 | 0, 4);
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 16 | 0, SAFE_HEAP_LOAD($4 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 20 | 0, SAFE_HEAP_LOAD($4 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 1770
 return;
}
function _cpShapeActive($0) {
 $0 = $0 | 0; //@line 5272
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0; //@line 5273
 var sp = 0; //@line 5274
 sp = STACKTOP; //@line 5275
 STACKTOP = STACKTOP + 16 | 0; //@line 5276
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5276
 $1 = $0; //@line 5277
 $2 = $1; //@line 5278
 $3 = $2 + 152 | 0; //@line 5279
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 5280
 $5 = ($4 | 0) != (0 | 0); //@line 5281
 if ($5) {
  $18 = 1; //@line 5283
 } else {
  $6 = $1; //@line 5285
  $7 = $6 + 8 | 0; //@line 5286
  $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 5287
  $9 = ($8 | 0) != (0 | 0); //@line 5288
  if ($9) {
   $10 = $1; //@line 5290
   $11 = $10 + 8 | 0; //@line 5291
   $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 5292
   $13 = $12 + 212 | 0; //@line 5293
   $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 5294
   $15 = $1; //@line 5295
   $16 = ($14 | 0) == ($15 | 0); //@line 5296
   $18 = $16; //@line 5297
  } else {
   $18 = 0; //@line 5299
  }
 }
 $17 = $18 & 1; //@line 5302
 $19 = $17 & 255; //@line 5303
 STACKTOP = sp; //@line 5304
 return $19 | 0; //@line 5304
}
function _cpBBProximity($0, $1) {
 $0 = $0 | 0; //@line 4953
 $1 = $1 | 0; //@line 4954
 var $10 = 0.0, $11 = 0.0, $12 = 0, $13 = 0.0, $14 = 0, $15 = 0.0, $16 = 0.0, $17 = 0, $18 = 0.0, $19 = 0.0, $2 = 0.0, $20 = 0, $21 = 0.0, $22 = 0.0, $23 = 0.0, $24 = 0.0, $3 = 0, $4 = 0.0, $5 = 0.0, $6 = 0.0;
 var $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 4957
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 4958
 $3 = $0 + 16 | 0; //@line 4959
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 4960
 $5 = $2 + $4; //@line 4961
 $6 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 4962
 $7 = $5 - $6; //@line 4963
 $8 = $1 + 16 | 0; //@line 4964
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 4965
 $10 = $7 - $9; //@line 4966
 $11 = +_cpfabs_25($10); //@line 4967
 $12 = $0 + 8 | 0; //@line 4968
 $13 = +(+SAFE_HEAP_LOAD_D($12 | 0, 8)); //@line 4969
 $14 = $0 + 24 | 0; //@line 4970
 $15 = +(+SAFE_HEAP_LOAD_D($14 | 0, 8)); //@line 4971
 $16 = $13 + $15; //@line 4972
 $17 = $1 + 8 | 0; //@line 4973
 $18 = +(+SAFE_HEAP_LOAD_D($17 | 0, 8)); //@line 4974
 $19 = $16 - $18; //@line 4975
 $20 = $1 + 24 | 0; //@line 4976
 $21 = +(+SAFE_HEAP_LOAD_D($20 | 0, 8)); //@line 4977
 $22 = $19 - $21; //@line 4978
 $23 = +_cpfabs_25($22); //@line 4979
 $24 = $11 + $23; //@line 4980
 return +$24;
}
function _getint_656($0) {
 $0 = $0 | 0; //@line 12390
 var $$0$lcssa = 0, $$04 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 12391
 sp = STACKTOP; //@line 12392
 $1 = SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0; //@line 12393
 $2 = SAFE_HEAP_LOAD($1 >> 0 | 0, 1, 0) | 0 | 0; //@line 12394
 $3 = $2 << 24 >> 24; //@line 12395
 $4 = _isdigit($3) | 0; //@line 12396
 $5 = ($4 | 0) == 0; //@line 12397
 if ($5) {
  $$0$lcssa = 0; //@line 12399
 } else {
  $$04 = 0; //@line 12401
  while (1) {
   $6 = $$04 * 10 | 0; //@line 12403
   $7 = SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0; //@line 12404
   $8 = SAFE_HEAP_LOAD($7 >> 0 | 0, 1, 0) | 0 | 0; //@line 12405
   $9 = $8 << 24 >> 24; //@line 12406
   $10 = $6 + -48 | 0; //@line 12407
   $11 = $10 + $9 | 0; //@line 12408
   $12 = $7 + 1 | 0; //@line 12409
   SAFE_HEAP_STORE($0 | 0, $12 | 0, 4);
   $13 = SAFE_HEAP_LOAD($12 >> 0 | 0, 1, 0) | 0 | 0; //@line 12411
   $14 = $13 << 24 >> 24; //@line 12412
   $15 = _isdigit($14) | 0; //@line 12413
   $16 = ($15 | 0) == 0; //@line 12414
   if ($16) {
    $$0$lcssa = $11; //@line 12416
    break;
   } else {
    $$04 = $11; //@line 12419
   }
  }
 }
 return $$0$lcssa | 0; //@line 12423
}
function _cpArrayPop($0) {
 $0 = $0 | 0; //@line 2767
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0; //@line 2768
 var sp = 0; //@line 2769
 sp = STACKTOP; //@line 2770
 STACKTOP = STACKTOP + 16 | 0; //@line 2771
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2771
 $1 = $0; //@line 2772
 $3 = $1; //@line 2773
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 2774
 $5 = $4 + -1 | 0; //@line 2775
 SAFE_HEAP_STORE($3 | 0, $5 | 0, 4);
 $6 = $1; //@line 2777
 $7 = $6 + 8 | 0; //@line 2778
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 2779
 $9 = $1; //@line 2780
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 2781
 $11 = $8 + ($10 << 2) | 0; //@line 2782
 $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 2783
 $2 = $12; //@line 2784
 $13 = $1; //@line 2785
 $14 = $13 + 8 | 0; //@line 2786
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 2787
 $16 = $1; //@line 2788
 $17 = SAFE_HEAP_LOAD($16 | 0, 4, 0) | 0 | 0; //@line 2789
 $18 = $15 + ($17 << 2) | 0; //@line 2790
 SAFE_HEAP_STORE($18 | 0, 0 | 0, 4);
 $19 = $2; //@line 2792
 STACKTOP = sp; //@line 2793
 return $19 | 0; //@line 2793
}
function _cpBBTreeReindexObject($0, $1, $2) {
 $0 = $0 | 0; //@line 3172
 $1 = $1 | 0; //@line 3173
 $2 = $2 | 0; //@line 3174
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0; //@line 3175
 var sp = 0; //@line 3176
 sp = STACKTOP; //@line 3177
 STACKTOP = STACKTOP + 16 | 0; //@line 3178
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3178
 $3 = $0; //@line 3179
 $4 = $1; //@line 3180
 $5 = $2; //@line 3181
 $7 = $3; //@line 3182
 $8 = $7 + 20 | 0; //@line 3183
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 3184
 $10 = $5; //@line 3185
 $11 = $4; //@line 3186
 $12 = _cpHashSetFind($9, $10, $11) | 0; //@line 3187
 $6 = $12; //@line 3188
 $13 = $6; //@line 3189
 $14 = ($13 | 0) != (0 | 0); //@line 3190
 if (!$14) {
  STACKTOP = sp; //@line 3192
  return;
 }
 $15 = $6; //@line 3194
 $16 = $3; //@line 3195
 $17 = _LeafUpdate($15, $16) | 0; //@line 3196
 $18 = $17 << 24 >> 24 != 0; //@line 3197
 if ($18) {
  $19 = $6; //@line 3199
  $20 = $3; //@line 3200
  _LeafAddPairs($19, $20); //@line 3201
 }
 $21 = $3; //@line 3203
 _IncrementStamp($21); //@line 3204
 STACKTOP = sp; //@line 3205
 return;
}
function _cpBodySetMoment($0, $1) {
 $0 = $0 | 0; //@line 5855
 $1 = +$1; //@line 5856
 var $10 = 0.0, $11 = 0, $12 = 0.0, $13 = 0.0, $14 = 0, $15 = 0, $16 = 0.0, $17 = 0, $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP; //@line 5858
 STACKTOP = STACKTOP + 16 | 0; //@line 5859
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5859
 $vararg_buffer = sp + 8 | 0; //@line 5860
 $2 = $0; //@line 5861
 $3 = $1; //@line 5862
 $4 = $3; //@line 5863
 $5 = $4 >= 0.0; //@line 5864
 if (!$5) {
  _cpMessage(4301, 3674, 274, 1, 1, 4316, $vararg_buffer); //@line 5866
  _abort(); //@line 5867
 }
 $6 = $2; //@line 5870
 _cpBodyActivate($6); //@line 5871
 $7 = $3; //@line 5872
 $8 = $2; //@line 5873
 $9 = $8 + 24 | 0; //@line 5874
 SAFE_HEAP_STORE_D($9 | 0, +$7, 8);
 $10 = $3; //@line 5876
 $11 = $10 == 0.0; //@line 5877
 if ($11) {
  $16 = inf; //@line 5879
 } else {
  $12 = $3; //@line 5881
  $13 = 1.0 / $12; //@line 5882
  $16 = $13; //@line 5883
 }
 $14 = $2; //@line 5885
 $15 = $14 + 32 | 0; //@line 5886
 SAFE_HEAP_STORE_D($15 | 0, +$16, 8);
 $17 = $2; //@line 5888
 _cpBodySanityCheck($17); //@line 5889
 STACKTOP = sp; //@line 5890
 return;
}
function _cpBBMergedArea($0, $1) {
 $0 = $0 | 0; //@line 4924
 $1 = $1 | 0; //@line 4925
 var $10 = 0.0, $11 = 0, $12 = 0.0, $13 = 0, $14 = 0.0, $15 = 0.0, $16 = 0, $17 = 0.0, $18 = 0, $19 = 0.0, $2 = 0, $20 = 0.0, $21 = 0.0, $22 = 0.0, $3 = 0.0, $4 = 0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0.0;
 var $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 4928
 $2 = $0 + 16 | 0; //@line 4929
 $3 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 4930
 $4 = $1 + 16 | 0; //@line 4931
 $5 = +(+SAFE_HEAP_LOAD_D($4 | 0, 8)); //@line 4932
 $6 = +_cpfmax_20($3, $5); //@line 4933
 $7 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 4934
 $8 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 4935
 $9 = +_cpfmin_18($7, $8); //@line 4936
 $10 = $6 - $9; //@line 4937
 $11 = $0 + 24 | 0; //@line 4938
 $12 = +(+SAFE_HEAP_LOAD_D($11 | 0, 8)); //@line 4939
 $13 = $1 + 24 | 0; //@line 4940
 $14 = +(+SAFE_HEAP_LOAD_D($13 | 0, 8)); //@line 4941
 $15 = +_cpfmax_20($12, $14); //@line 4942
 $16 = $0 + 8 | 0; //@line 4943
 $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 4944
 $18 = $1 + 8 | 0; //@line 4945
 $19 = +(+SAFE_HEAP_LOAD_D($18 | 0, 8)); //@line 4946
 $20 = +_cpfmin_18($17, $19); //@line 4947
 $21 = $15 - $20; //@line 4948
 $22 = $10 * $21; //@line 4949
 return +$22;
}
function _cpContactBufferGetArray($0) {
 $0 = $0 | 0; //@line 4403
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0; //@line 4404
 var sp = 0; //@line 4405
 sp = STACKTOP; //@line 4406
 STACKTOP = STACKTOP + 16 | 0; //@line 4407
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 4407
 $1 = $0; //@line 4408
 $3 = $1; //@line 4409
 $4 = $3 + 124 | 0; //@line 4410
 $5 = SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0; //@line 4411
 $6 = $5 + 8 | 0; //@line 4412
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 4413
 $8 = $7 + 2 | 0; //@line 4414
 $9 = $8 >>> 0 > 341; //@line 4415
 if ($9) {
  $10 = $1; //@line 4417
  _cpSpacePushFreshContactBuffer($10); //@line 4418
 }
 $11 = $1; //@line 4420
 $12 = $11 + 124 | 0; //@line 4421
 $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 4422
 $2 = $13; //@line 4423
 $14 = $2; //@line 4424
 $15 = $14 + 16 | 0; //@line 4425
 $16 = $2; //@line 4426
 $17 = $16 + 8 | 0; //@line 4427
 $18 = SAFE_HEAP_LOAD($17 | 0, 4, 0) | 0 | 0; //@line 4428
 $19 = $15 + ($18 * 96 | 0) | 0; //@line 4429
 STACKTOP = sp; //@line 4430
 return $19 | 0; //@line 4430
}
function _ComponentAdd($0, $1) {
 $0 = $0 | 0; //@line 3354
 $1 = $1 | 0; //@line 3355
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0; //@line 3356
 var sp = 0; //@line 3357
 sp = STACKTOP; //@line 3358
 STACKTOP = STACKTOP + 16 | 0; //@line 3359
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3359
 $2 = $0; //@line 3360
 $3 = $1; //@line 3361
 $4 = $2; //@line 3362
 $5 = $3; //@line 3363
 $6 = $5 + 224 | 0; //@line 3364
 SAFE_HEAP_STORE($6 | 0, $4 | 0, 4);
 $7 = $3; //@line 3366
 $8 = $2; //@line 3367
 $9 = ($7 | 0) != ($8 | 0); //@line 3368
 if (!$9) {
  STACKTOP = sp; //@line 3370
  return;
 }
 $10 = $2; //@line 3372
 $11 = $10 + 224 | 0; //@line 3373
 $12 = $11 + 4 | 0; //@line 3374
 $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 3375
 $14 = $3; //@line 3376
 $15 = $14 + 224 | 0; //@line 3377
 $16 = $15 + 4 | 0; //@line 3378
 SAFE_HEAP_STORE($16 | 0, $13 | 0, 4);
 $17 = $3; //@line 3380
 $18 = $2; //@line 3381
 $19 = $18 + 224 | 0; //@line 3382
 $20 = $19 + 4 | 0; //@line 3383
 SAFE_HEAP_STORE($20 | 0, $17 | 0, 4);
 STACKTOP = sp; //@line 3385
 return;
}
function _cpvlength_356($0) {
 $0 = $0 | 0; //@line 5594
 var $$byval_copy = 0, $$byval_copy1 = 0, $1 = 0.0, $2 = 0.0, label = 0, sp = 0; //@line 5595
 sp = STACKTOP; //@line 5596
 STACKTOP = STACKTOP + 32 | 0; //@line 5597
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 5597
 $$byval_copy1 = sp + 16 | 0; //@line 5598
 $$byval_copy = sp; //@line 5599
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $1 = +_cpvdot_359($$byval_copy, $$byval_copy1); //@line 5602
 $2 = +Math_sqrt(+$1); //@line 5603
 STACKTOP = sp; //@line 5604
 return +$2;
}
function _cpvlength_269($0) {
 $0 = $0 | 0; //@line 4026
 var $$byval_copy = 0, $$byval_copy1 = 0, $1 = 0.0, $2 = 0.0, label = 0, sp = 0; //@line 4027
 sp = STACKTOP; //@line 4028
 STACKTOP = STACKTOP + 32 | 0; //@line 4029
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 4029
 $$byval_copy1 = sp + 16 | 0; //@line 4030
 $$byval_copy = sp; //@line 4031
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $1 = +_cpvdot_272($$byval_copy, $$byval_copy1); //@line 4034
 $2 = +Math_sqrt(+$1); //@line 4035
 STACKTOP = sp; //@line 4036
 return +$2;
}
function _cpvlength_239($0) {
 $0 = $0 | 0; //@line 3179
 var $$byval_copy = 0, $$byval_copy1 = 0, $1 = 0.0, $2 = 0.0, label = 0, sp = 0; //@line 3180
 sp = STACKTOP; //@line 3181
 STACKTOP = STACKTOP + 32 | 0; //@line 3182
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 3182
 $$byval_copy1 = sp + 16 | 0; //@line 3183
 $$byval_copy = sp; //@line 3184
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $1 = +_cpvdot_240($$byval_copy, $$byval_copy1); //@line 3187
 $2 = +Math_sqrt(+$1); //@line 3188
 STACKTOP = sp; //@line 3189
 return +$2;
}
function _cpvlength_85($0) {
 $0 = $0 | 0; //@line 1744
 var $$byval_copy = 0, $$byval_copy1 = 0, $1 = 0.0, $2 = 0.0, label = 0, sp = 0; //@line 1745
 sp = STACKTOP; //@line 1746
 STACKTOP = STACKTOP + 32 | 0; //@line 1747
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 1747
 $$byval_copy1 = sp + 16 | 0; //@line 1748
 $$byval_copy = sp; //@line 1749
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $1 = +_cpvdot_68($$byval_copy, $$byval_copy1); //@line 1752
 $2 = +Math_sqrt(+$1); //@line 1753
 STACKTOP = sp; //@line 1754
 return +$2;
}
function _cpvlength($0) {
 $0 = $0 | 0; //@line 348
 var $$byval_copy = 0, $$byval_copy1 = 0, $1 = 0.0, $2 = 0.0, label = 0, sp = 0; //@line 349
 sp = STACKTOP; //@line 350
 STACKTOP = STACKTOP + 32 | 0; //@line 351
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 351
 $$byval_copy1 = sp + 16 | 0; //@line 352
 $$byval_copy = sp; //@line 353
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $1 = +_cpvdot($$byval_copy, $$byval_copy1); //@line 356
 $2 = +Math_sqrt(+$1); //@line 357
 STACKTOP = sp; //@line 358
 return +$2;
}
function _cpvlength_416($0) {
 $0 = $0 | 0; //@line 30
 var $$byval_copy = 0, $$byval_copy1 = 0, $1 = 0.0, $2 = 0.0, label = 0, sp = 0; //@line 31
 sp = STACKTOP; //@line 32
 STACKTOP = STACKTOP + 32 | 0; //@line 33
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 33
 $$byval_copy1 = sp + 16 | 0; //@line 34
 $$byval_copy = sp; //@line 35
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $1 = +_cpvdot_402($$byval_copy, $$byval_copy1); //@line 38
 $2 = +Math_sqrt(+$1); //@line 39
 STACKTOP = sp; //@line 40
 return +$2;
}
function _cpMat2x2Transform_243($0, $1, $2) {
 $0 = $0 | 0; //@line 3282
 $1 = $1 | 0; //@line 3283
 $2 = $2 | 0; //@line 3284
 var $10 = 0.0, $11 = 0.0, $12 = 0.0, $13 = 0, $14 = 0.0, $15 = 0.0, $16 = 0, $17 = 0.0, $18 = 0, $19 = 0.0, $20 = 0.0, $21 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0;
 var sp = 0; //@line 3286
 sp = STACKTOP; //@line 3287
 $3 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 3288
 $4 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3289
 $5 = $3 * $4; //@line 3290
 $6 = $2 + 8 | 0; //@line 3291
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 3292
 $8 = $1 + 8 | 0; //@line 3293
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 3294
 $10 = $7 * $9; //@line 3295
 $11 = $5 + $10; //@line 3296
 $12 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 3297
 $13 = $1 + 16 | 0; //@line 3298
 $14 = +(+SAFE_HEAP_LOAD_D($13 | 0, 8)); //@line 3299
 $15 = $12 * $14; //@line 3300
 $16 = $2 + 8 | 0; //@line 3301
 $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 3302
 $18 = $1 + 24 | 0; //@line 3303
 $19 = +(+SAFE_HEAP_LOAD_D($18 | 0, 8)); //@line 3304
 $20 = $17 * $19; //@line 3305
 $21 = $15 + $20; //@line 3306
 _cpv_251($0, $11, $21); //@line 3307
 return;
}
function _cpTransformVect_375($0, $1, $2) {
 $0 = $0 | 0; //@line 7030
 $1 = $1 | 0; //@line 7031
 $2 = $2 | 0; //@line 7032
 var $10 = 0.0, $11 = 0.0, $12 = 0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0, $17 = 0.0, $18 = 0, $19 = 0.0, $20 = 0.0, $21 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0;
 var sp = 0; //@line 7034
 sp = STACKTOP; //@line 7035
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 7036
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 7037
 $5 = $3 * $4; //@line 7038
 $6 = $1 + 16 | 0; //@line 7039
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 7040
 $8 = $2 + 8 | 0; //@line 7041
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 7042
 $10 = $7 * $9; //@line 7043
 $11 = $5 + $10; //@line 7044
 $12 = $1 + 8 | 0; //@line 7045
 $13 = +(+SAFE_HEAP_LOAD_D($12 | 0, 8)); //@line 7046
 $14 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 7047
 $15 = $13 * $14; //@line 7048
 $16 = $1 + 24 | 0; //@line 7049
 $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 7050
 $18 = $2 + 8 | 0; //@line 7051
 $19 = +(+SAFE_HEAP_LOAD_D($18 | 0, 8)); //@line 7052
 $20 = $17 * $19; //@line 7053
 $21 = $15 + $20; //@line 7054
 _cpv_358($0, $11, $21); //@line 7055
 return;
}
function _cpTransformVect_282($0, $1, $2) {
 $0 = $0 | 0; //@line 4929
 $1 = $1 | 0; //@line 4930
 $2 = $2 | 0; //@line 4931
 var $10 = 0.0, $11 = 0.0, $12 = 0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0, $17 = 0.0, $18 = 0, $19 = 0.0, $20 = 0.0, $21 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0;
 var sp = 0; //@line 4933
 sp = STACKTOP; //@line 4934
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 4935
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 4936
 $5 = $3 * $4; //@line 4937
 $6 = $1 + 16 | 0; //@line 4938
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 4939
 $8 = $2 + 8 | 0; //@line 4940
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 4941
 $10 = $7 * $9; //@line 4942
 $11 = $5 + $10; //@line 4943
 $12 = $1 + 8 | 0; //@line 4944
 $13 = +(+SAFE_HEAP_LOAD_D($12 | 0, 8)); //@line 4945
 $14 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 4946
 $15 = $13 * $14; //@line 4947
 $16 = $1 + 24 | 0; //@line 4948
 $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 4949
 $18 = $2 + 8 | 0; //@line 4950
 $19 = +(+SAFE_HEAP_LOAD_D($18 | 0, 8)); //@line 4951
 $20 = $17 * $19; //@line 4952
 $21 = $15 + $20; //@line 4953
 _cpv_271($0, $11, $21); //@line 4954
 return;
}
function _cpTransformVect_254($0, $1, $2) {
 $0 = $0 | 0; //@line 3525
 $1 = $1 | 0; //@line 3526
 $2 = $2 | 0; //@line 3527
 var $10 = 0.0, $11 = 0.0, $12 = 0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0, $17 = 0.0, $18 = 0, $19 = 0.0, $20 = 0.0, $21 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0;
 var sp = 0; //@line 3529
 sp = STACKTOP; //@line 3530
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3531
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 3532
 $5 = $3 * $4; //@line 3533
 $6 = $1 + 16 | 0; //@line 3534
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 3535
 $8 = $2 + 8 | 0; //@line 3536
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 3537
 $10 = $7 * $9; //@line 3538
 $11 = $5 + $10; //@line 3539
 $12 = $1 + 8 | 0; //@line 3540
 $13 = +(+SAFE_HEAP_LOAD_D($12 | 0, 8)); //@line 3541
 $14 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 3542
 $15 = $13 * $14; //@line 3543
 $16 = $1 + 24 | 0; //@line 3544
 $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 3545
 $18 = $2 + 8 | 0; //@line 3546
 $19 = +(+SAFE_HEAP_LOAD_D($18 | 0, 8)); //@line 3547
 $20 = $17 * $19; //@line 3548
 $21 = $15 + $20; //@line 3549
 _cpv_251($0, $11, $21); //@line 3550
 return;
}
function _cpTransformVect($0, $1, $2) {
 $0 = $0 | 0; //@line 6877
 $1 = $1 | 0; //@line 6878
 $2 = $2 | 0; //@line 6879
 var $10 = 0.0, $11 = 0.0, $12 = 0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0, $17 = 0.0, $18 = 0, $19 = 0.0, $20 = 0.0, $21 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0;
 var sp = 0; //@line 6881
 sp = STACKTOP; //@line 6882
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 6883
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 6884
 $5 = $3 * $4; //@line 6885
 $6 = $1 + 16 | 0; //@line 6886
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 6887
 $8 = $2 + 8 | 0; //@line 6888
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 6889
 $10 = $7 * $9; //@line 6890
 $11 = $5 + $10; //@line 6891
 $12 = $1 + 8 | 0; //@line 6892
 $13 = +(+SAFE_HEAP_LOAD_D($12 | 0, 8)); //@line 6893
 $14 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 6894
 $15 = $13 * $14; //@line 6895
 $16 = $1 + 24 | 0; //@line 6896
 $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 6897
 $18 = $2 + 8 | 0; //@line 6898
 $19 = +(+SAFE_HEAP_LOAD_D($18 | 0, 8)); //@line 6899
 $20 = $17 * $19; //@line 6900
 $21 = $15 + $20; //@line 6901
 _cpv_33($0, $11, $21); //@line 6902
 return;
}
function _cpBBMerge($0, $1, $2) {
 $0 = $0 | 0; //@line 5021
 $1 = $1 | 0; //@line 5022
 $2 = $2 | 0; //@line 5023
 var $10 = 0.0, $11 = 0, $12 = 0.0, $13 = 0, $14 = 0.0, $15 = 0.0, $16 = 0, $17 = 0.0, $18 = 0, $19 = 0.0, $20 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 5025
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 5026
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 5027
 $5 = +_cpfmin_18($3, $4); //@line 5028
 $6 = $1 + 8 | 0; //@line 5029
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 5030
 $8 = $2 + 8 | 0; //@line 5031
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 5032
 $10 = +_cpfmin_18($7, $9); //@line 5033
 $11 = $1 + 16 | 0; //@line 5034
 $12 = +(+SAFE_HEAP_LOAD_D($11 | 0, 8)); //@line 5035
 $13 = $2 + 16 | 0; //@line 5036
 $14 = +(+SAFE_HEAP_LOAD_D($13 | 0, 8)); //@line 5037
 $15 = +_cpfmax_20($12, $14); //@line 5038
 $16 = $1 + 24 | 0; //@line 5039
 $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 5040
 $18 = $2 + 24 | 0; //@line 5041
 $19 = +(+SAFE_HEAP_LOAD_D($18 | 0, 8)); //@line 5042
 $20 = +_cpfmax_20($17, $19); //@line 5043
 _cpBBNew($0, $5, $10, $15, $20); //@line 5044
 return;
}
function _cpvlengthsq_498($0) {
 $0 = $0 | 0; //@line 2917
 var $$byval_copy = 0, $$byval_copy1 = 0, $1 = 0.0, label = 0, sp = 0; //@line 2918
 sp = STACKTOP; //@line 2919
 STACKTOP = STACKTOP + 32 | 0; //@line 2920
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 2920
 $$byval_copy1 = sp + 16 | 0; //@line 2921
 $$byval_copy = sp; //@line 2922
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $1 = +_cpvdot_509($$byval_copy, $$byval_copy1); //@line 2925
 STACKTOP = sp; //@line 2926
 return +$1;
}
function _cpvlengthsq_371($0) {
 $0 = $0 | 0; //@line 6975
 var $$byval_copy = 0, $$byval_copy1 = 0, $1 = 0.0, label = 0, sp = 0; //@line 6976
 sp = STACKTOP; //@line 6977
 STACKTOP = STACKTOP + 32 | 0; //@line 6978
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 6978
 $$byval_copy1 = sp + 16 | 0; //@line 6979
 $$byval_copy = sp; //@line 6980
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $1 = +_cpvdot_359($$byval_copy, $$byval_copy1); //@line 6983
 STACKTOP = sp; //@line 6984
 return +$1;
}
function _cpvlengthsq_278($0) {
 $0 = $0 | 0; //@line 4874
 var $$byval_copy = 0, $$byval_copy1 = 0, $1 = 0.0, label = 0, sp = 0; //@line 4875
 sp = STACKTOP; //@line 4876
 STACKTOP = STACKTOP + 32 | 0; //@line 4877
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 4877
 $$byval_copy1 = sp + 16 | 0; //@line 4878
 $$byval_copy = sp; //@line 4879
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $1 = +_cpvdot_272($$byval_copy, $$byval_copy1); //@line 4882
 STACKTOP = sp; //@line 4883
 return +$1;
}
function _cpvlengthsq_79($0) {
 $0 = $0 | 0; //@line 1410
 var $$byval_copy = 0, $$byval_copy1 = 0, $1 = 0.0, label = 0, sp = 0; //@line 1411
 sp = STACKTOP; //@line 1412
 STACKTOP = STACKTOP + 32 | 0; //@line 1413
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 1413
 $$byval_copy1 = sp + 16 | 0; //@line 1414
 $$byval_copy = sp; //@line 1415
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $1 = +_cpvdot_68($$byval_copy, $$byval_copy1); //@line 1418
 STACKTOP = sp; //@line 1419
 return +$1;
}
function _cpvlengthsq_50($0) {
 $0 = $0 | 0; //@line 6923
 var $$byval_copy = 0, $$byval_copy1 = 0, $1 = 0.0, label = 0, sp = 0; //@line 6924
 sp = STACKTOP; //@line 6925
 STACKTOP = STACKTOP + 32 | 0; //@line 6926
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 6926
 $$byval_copy1 = sp + 16 | 0; //@line 6927
 $$byval_copy = sp; //@line 6928
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $1 = +_cpvdot_51($$byval_copy, $$byval_copy1); //@line 6931
 STACKTOP = sp; //@line 6932
 return +$1;
}
function _cpContactBufferHeaderInit($0, $1, $2) {
 $0 = $0 | 0; //@line 4370
 $1 = $1 | 0; //@line 4371
 $2 = $2 | 0; //@line 4372
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 4373
 sp = STACKTOP; //@line 4374
 STACKTOP = STACKTOP + 16 | 0; //@line 4375
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 4375
 $3 = $0; //@line 4376
 $4 = $1; //@line 4377
 $5 = $2; //@line 4378
 $6 = $4; //@line 4379
 $7 = $3; //@line 4380
 SAFE_HEAP_STORE($7 | 0, $6 | 0, 4);
 $8 = $5; //@line 4382
 $9 = ($8 | 0) != (0 | 0); //@line 4383
 if ($9) {
  $10 = $5; //@line 4385
  $11 = $10 + 4 | 0; //@line 4386
  $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 4387
  $16 = $12; //@line 4388
 } else {
  $13 = $3; //@line 4390
  $16 = $13; //@line 4391
 }
 $14 = $3; //@line 4393
 $15 = $14 + 4 | 0; //@line 4394
 SAFE_HEAP_STORE($15 | 0, $16 | 0, 4);
 $17 = $3; //@line 4396
 $18 = $17 + 8 | 0; //@line 4397
 SAFE_HEAP_STORE($18 | 0, 0 | 0, 4);
 $19 = $3; //@line 4399
 STACKTOP = sp; //@line 4400
 return $19 | 0; //@line 4400
}
function _fmt_o($0, $1, $2) {
 $0 = $0 | 0; //@line 12746
 $1 = $1 | 0; //@line 12747
 $2 = $2 | 0; //@line 12748
 var $$0$lcssa = 0, $$06 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 12749
 sp = STACKTOP; //@line 12750
 $3 = ($0 | 0) == 0; //@line 12751
 $4 = ($1 | 0) == 0; //@line 12752
 $5 = $3 & $4; //@line 12753
 if ($5) {
  $$0$lcssa = $2; //@line 12755
 } else {
  $$06 = $2; //@line 12757
  $11 = $1; //@line 12757
  $7 = $0; //@line 12757
  while (1) {
   $6 = $7 & 255; //@line 12759
   $8 = $6 & 7; //@line 12760
   $9 = $8 | 48; //@line 12761
   $10 = $$06 + -1 | 0; //@line 12762
   SAFE_HEAP_STORE($10 >> 0 | 0, $9 | 0, 1);
   $12 = _bitshift64Lshr($7 | 0, $11 | 0, 3) | 0; //@line 12764
   $13 = getTempRet0() | 0; //@line 12765
   $14 = ($12 | 0) == 0; //@line 12766
   $15 = ($13 | 0) == 0; //@line 12767
   $16 = $14 & $15; //@line 12768
   if ($16) {
    $$0$lcssa = $10; //@line 12770
    break;
   } else {
    $$06 = $10; //@line 12773
    $11 = $13; //@line 12773
    $7 = $12; //@line 12773
   }
  }
 }
 return $$0$lcssa | 0; //@line 12777
}
function _cpvlengthsq($0) {
 $0 = $0 | 0; //@line 184
 var $$byval_copy = 0, $$byval_copy1 = 0, $1 = 0.0, label = 0, sp = 0; //@line 185
 sp = STACKTOP; //@line 186
 STACKTOP = STACKTOP + 32 | 0; //@line 187
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 187
 $$byval_copy1 = sp + 16 | 0; //@line 188
 $$byval_copy = sp; //@line 189
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 | 0, SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 4 | 0, SAFE_HEAP_LOAD($0 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 8 | 0, SAFE_HEAP_LOAD($0 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy1 + 12 | 0, SAFE_HEAP_LOAD($0 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $1 = +_cpvdot($$byval_copy, $$byval_copy1); //@line 192
 STACKTOP = sp; //@line 193
 return +$1;
}
function _cpArrayFreeEach($0, $1) {
 $0 = $0 | 0; //@line 2859
 $1 = $1 | 0; //@line 2860
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2861
 sp = STACKTOP; //@line 2862
 STACKTOP = STACKTOP + 16 | 0; //@line 2863
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2863
 $2 = $0; //@line 2864
 $3 = $1; //@line 2865
 $4 = 0; //@line 2866
 while (1) {
  $5 = $4; //@line 2868
  $6 = $2; //@line 2869
  $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 2870
  $8 = ($5 | 0) < ($7 | 0); //@line 2871
  if (!$8) {
   break;
  }
  $9 = $3; //@line 2875
  $10 = $2; //@line 2876
  $11 = $10 + 8 | 0; //@line 2877
  $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 2878
  $13 = $4; //@line 2879
  $14 = $12 + ($13 << 2) | 0; //@line 2880
  $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 2881
  FUNCTION_TABLE_vi[(SAFE_FT_MASK($9 | 0, 63 | 0) | 0) & 63]($15); //@line 2882
  $16 = $4; //@line 2883
  $17 = $16 + 1 | 0; //@line 2884
  $4 = $17; //@line 2885
 }
 STACKTOP = sp; //@line 2887
 return;
}
function _cpShapeDestroy($0) {
 $0 = $0 | 0; //@line 5181
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5182
 sp = STACKTOP; //@line 5183
 STACKTOP = STACKTOP + 16 | 0; //@line 5184
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5184
 $1 = $0; //@line 5185
 $2 = $1; //@line 5186
 $3 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 5187
 $4 = ($3 | 0) != (0 | 0); //@line 5188
 if (!$4) {
  STACKTOP = sp; //@line 5190
  return;
 }
 $5 = $1; //@line 5192
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 5193
 $7 = $6 + 8 | 0; //@line 5194
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 5195
 $9 = ($8 | 0) != (0 | 0); //@line 5196
 if (!$9) {
  STACKTOP = sp; //@line 5198
  return;
 }
 $10 = $1; //@line 5200
 $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 5201
 $12 = $11 + 8 | 0; //@line 5202
 $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 5203
 $14 = $1; //@line 5204
 FUNCTION_TABLE_vi[(SAFE_FT_MASK($13 | 0, 63 | 0) | 0) & 63]($14); //@line 5205
 STACKTOP = sp; //@line 5206
 return;
}
function _cpTransformVect_415($0, $1, $2) {
 $0 = $0 | 0; //@line 1
 $1 = $1 | 0; //@line 2
 $2 = $2 | 0; //@line 3
 var $10 = 0.0, $11 = 0.0, $12 = 0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0, $17 = 0.0, $18 = 0, $19 = 0.0, $20 = 0.0, $21 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0;
 var sp = 0; //@line 5
 sp = STACKTOP; //@line 6
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 7
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 8
 $5 = $3 * $4; //@line 9
 $6 = $1 + 16 | 0; //@line 10
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 11
 $8 = $2 + 8 | 0; //@line 12
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 13
 $10 = $7 * $9; //@line 14
 $11 = $5 + $10; //@line 15
 $12 = $1 + 8 | 0; //@line 16
 $13 = +(+SAFE_HEAP_LOAD_D($12 | 0, 8)); //@line 17
 $14 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 18
 $15 = $13 * $14; //@line 19
 $16 = $1 + 24 | 0; //@line 20
 $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 21
 $18 = $2 + 8 | 0; //@line 22
 $19 = +(+SAFE_HEAP_LOAD_D($18 | 0, 8)); //@line 23
 $20 = $17 * $19; //@line 24
 $21 = $15 + $20; //@line 25
 _cpv_410($0, $11, $21); //@line 26
 return;
}
function _IncrementStamp($0) {
 $0 = $0 | 0; //@line 3875
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3876
 sp = STACKTOP; //@line 3877
 STACKTOP = STACKTOP + 16 | 0; //@line 3878
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3878
 $1 = $0; //@line 3879
 $3 = $1; //@line 3880
 $4 = $3 + 12 | 0; //@line 3881
 $5 = SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0; //@line 3882
 $6 = _GetTree($5) | 0; //@line 3883
 $2 = $6; //@line 3884
 $7 = $2; //@line 3885
 $8 = ($7 | 0) != (0 | 0); //@line 3886
 if ($8) {
  $9 = $2; //@line 3888
  $10 = $9 + 40 | 0; //@line 3889
  $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 3890
  $12 = $11 + 1 | 0; //@line 3891
  SAFE_HEAP_STORE($10 | 0, $12 | 0, 4);
  STACKTOP = sp; //@line 3893
  return;
 } else {
  $13 = $1; //@line 3895
  $14 = $13 + 40 | 0; //@line 3896
  $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 3897
  $16 = $15 + 1 | 0; //@line 3898
  SAFE_HEAP_STORE($14 | 0, $16 | 0, 4);
  STACKTOP = sp; //@line 3900
  return;
 }
}
function _cpvrotate_86($0, $1, $2) {
 $0 = $0 | 0; //@line 1811
 $1 = $1 | 0; //@line 1812
 $2 = $2 | 0; //@line 1813
 var $10 = 0.0, $11 = 0.0, $12 = 0.0, $13 = 0, $14 = 0.0, $15 = 0.0, $16 = 0, $17 = 0.0, $18 = 0.0, $19 = 0.0, $20 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 1815
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 1816
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 1817
 $5 = $3 * $4; //@line 1818
 $6 = $1 + 8 | 0; //@line 1819
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 1820
 $8 = $2 + 8 | 0; //@line 1821
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 1822
 $10 = $7 * $9; //@line 1823
 $11 = $5 - $10; //@line 1824
 $12 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 1825
 $13 = $2 + 8 | 0; //@line 1826
 $14 = +(+SAFE_HEAP_LOAD_D($13 | 0, 8)); //@line 1827
 $15 = $12 * $14; //@line 1828
 $16 = $1 + 8 | 0; //@line 1829
 $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 1830
 $18 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 1831
 $19 = $17 * $18; //@line 1832
 $20 = $15 + $19; //@line 1833
 _cpv_72($0, $11, $20); //@line 1834
 return;
}
function _cpBodySetAngle($0, $1) {
 $0 = $0 | 0; //@line 5893
 $1 = +$1; //@line 5894
 var $$byval_copy = 0, $10 = 0.0, $2 = 0, $3 = 0.0, $4 = 0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5895
 sp = STACKTOP; //@line 5896
 STACKTOP = STACKTOP + 32 | 0; //@line 5897
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 5897
 $$byval_copy = sp + 8 | 0; //@line 5898
 $2 = $0; //@line 5899
 $3 = $1; //@line 5900
 $4 = $2; //@line 5901
 _cpBodyActivate($4); //@line 5902
 $5 = $2; //@line 5903
 $6 = $3; //@line 5904
 +_SetAngle($5, $6);
 $7 = $2; //@line 5906
 $8 = $2; //@line 5907
 $9 = $8 + 56 | 0; //@line 5908
 $10 = $3; //@line 5909
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($9 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($9 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($9 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _SetTransform($7, $$byval_copy, $10); //@line 5911
 STACKTOP = sp; //@line 5912
 return;
}
function _handlerSetTrans($0, $1) {
 $0 = $0 | 0; //@line 1175
 $1 = $1 | 0; //@line 1176
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0; //@line 1177
 sp = STACKTOP; //@line 1178
 STACKTOP = STACKTOP + 16 | 0; //@line 1179
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1179
 $2 = $0; //@line 1180
 $3 = $1; //@line 1181
 $5 = _calloc(1, 28) | 0; //@line 1182
 $4 = $5; //@line 1183
 $6 = $4; //@line 1184
 $7 = $2; //@line 1185
 SAFE_HEAP_STORE($6 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 16 | 0, SAFE_HEAP_LOAD($7 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 20 | 0, SAFE_HEAP_LOAD($7 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($6 + 24 | 0, SAFE_HEAP_LOAD($7 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 $8 = $4; //@line 1187
 STACKTOP = sp; //@line 1188
 return $8 | 0; //@line 1188
}
function _cpArbiterGetNormal($0, $1) {
 $0 = $0 | 0; //@line 841
 $1 = $1 | 0; //@line 842
 var $$byval_copy = 0, $10 = 0.0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 843
 sp = STACKTOP; //@line 844
 STACKTOP = STACKTOP + 32 | 0; //@line 845
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 845
 $$byval_copy = sp; //@line 846
 $2 = $1; //@line 847
 $3 = $2; //@line 848
 $4 = $3 + 80 | 0; //@line 849
 $5 = $2; //@line 850
 $6 = $5 + 108 | 0; //@line 851
 $7 = SAFE_HEAP_LOAD($6 >> 0 | 0, 1, 0) | 0 | 0; //@line 852
 $8 = $7 & 255; //@line 853
 $9 = ($8 | 0) != 0; //@line 854
 $10 = $9 ? -1.0 : 1.0; //@line 855
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpvmult_1($0, $$byval_copy, $10); //@line 857
 STACKTOP = sp; //@line 858
 return;
}
function _cpBBNewForExtents_549($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 3798
 $1 = $1 | 0; //@line 3799
 $2 = +$2; //@line 3800
 $3 = +$3; //@line 3801
 var $10 = 0.0, $11 = 0.0, $12 = 0.0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0, $17 = 0.0, $18 = 0.0, $19 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3803
 STACKTOP = STACKTOP + 16 | 0; //@line 3804
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3804
 $4 = $2; //@line 3805
 $5 = $3; //@line 3806
 $6 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3807
 $7 = $4; //@line 3808
 $8 = $6 - $7; //@line 3809
 $9 = $1 + 8 | 0; //@line 3810
 $10 = +(+SAFE_HEAP_LOAD_D($9 | 0, 8)); //@line 3811
 $11 = $5; //@line 3812
 $12 = $10 - $11; //@line 3813
 $13 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3814
 $14 = $4; //@line 3815
 $15 = $13 + $14; //@line 3816
 $16 = $1 + 8 | 0; //@line 3817
 $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 3818
 $18 = $5; //@line 3819
 $19 = $17 + $18; //@line 3820
 _cpBBNew_550($0, $8, $12, $15, $19); //@line 3821
 STACKTOP = sp; //@line 3822
 return;
}
function _cpBBNewForExtents($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 6225
 $1 = $1 | 0; //@line 6226
 $2 = +$2; //@line 6227
 $3 = +$3; //@line 6228
 var $10 = 0.0, $11 = 0.0, $12 = 0.0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0, $17 = 0.0, $18 = 0.0, $19 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP; //@line 6230
 STACKTOP = STACKTOP + 16 | 0; //@line 6231
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 6231
 $4 = $2; //@line 6232
 $5 = $3; //@line 6233
 $6 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 6234
 $7 = $4; //@line 6235
 $8 = $6 - $7; //@line 6236
 $9 = $1 + 8 | 0; //@line 6237
 $10 = +(+SAFE_HEAP_LOAD_D($9 | 0, 8)); //@line 6238
 $11 = $5; //@line 6239
 $12 = $10 - $11; //@line 6240
 $13 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 6241
 $14 = $4; //@line 6242
 $15 = $13 + $14; //@line 6243
 $16 = $1 + 8 | 0; //@line 6244
 $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 6245
 $18 = $5; //@line 6246
 $19 = $17 + $18; //@line 6247
 _cpBBNew_365($0, $8, $12, $15, $19); //@line 6248
 STACKTOP = sp; //@line 6249
 return;
}
function _MarkSubtree($0, $1) {
 $0 = $0 | 0; //@line 3845
 $1 = $1 | 0; //@line 3846
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3847
 sp = STACKTOP; //@line 3848
 STACKTOP = STACKTOP + 16 | 0; //@line 3849
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3849
 $2 = $0; //@line 3850
 $3 = $1; //@line 3851
 $4 = $2; //@line 3852
 $5 = _NodeIsLeaf($4) | 0; //@line 3853
 $6 = $5 << 24 >> 24 != 0; //@line 3854
 $7 = $2; //@line 3855
 if ($6) {
  $8 = $3; //@line 3857
  _MarkLeaf($7, $8); //@line 3858
  STACKTOP = sp; //@line 3859
  return;
 } else {
  $9 = $7 + 44 | 0; //@line 3861
  $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 3862
  $11 = $3; //@line 3863
  _MarkSubtree($10, $11); //@line 3864
  $12 = $2; //@line 3865
  $13 = $12 + 44 | 0; //@line 3866
  $14 = $13 + 4 | 0; //@line 3867
  $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 3868
  $16 = $3; //@line 3869
  _MarkSubtree($15, $16); //@line 3870
  STACKTOP = sp; //@line 3871
  return;
 }
}
function _cpvrotate($0, $1, $2) {
 $0 = $0 | 0; //@line 960
 $1 = $1 | 0; //@line 961
 $2 = $2 | 0; //@line 962
 var $10 = 0.0, $11 = 0.0, $12 = 0.0, $13 = 0, $14 = 0.0, $15 = 0.0, $16 = 0, $17 = 0.0, $18 = 0.0, $19 = 0.0, $20 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 964
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 965
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 966
 $5 = $3 * $4; //@line 967
 $6 = $1 + 8 | 0; //@line 968
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 969
 $8 = $2 + 8 | 0; //@line 970
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 971
 $10 = $7 * $9; //@line 972
 $11 = $5 - $10; //@line 973
 $12 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 974
 $13 = $2 + 8 | 0; //@line 975
 $14 = +(+SAFE_HEAP_LOAD_D($13 | 0, 8)); //@line 976
 $15 = $12 * $14; //@line 977
 $16 = $1 + 8 | 0; //@line 978
 $17 = +(+SAFE_HEAP_LOAD_D($16 | 0, 8)); //@line 979
 $18 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 980
 $19 = $17 * $18; //@line 981
 $20 = $15 + $19; //@line 982
 _cpv_2($0, $11, $20); //@line 983
 return;
}
function _cpSpaceFilterArbiters($0, $1, $2) {
 $0 = $0 | 0; //@line 1501
 $1 = $1 | 0; //@line 1502
 $2 = $2 | 0; //@line 1503
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1504
 sp = STACKTOP; //@line 1505
 STACKTOP = STACKTOP + 32 | 0; //@line 1506
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 1506
 $6 = sp; //@line 1507
 $3 = $0; //@line 1508
 $4 = $1; //@line 1509
 $5 = $2; //@line 1510
 $7 = $3; //@line 1511
 _cpSpaceLock($7); //@line 1512
 $8 = $3; //@line 1513
 SAFE_HEAP_STORE($6 | 0, $8 | 0, 4);
 $9 = $6 + 4 | 0; //@line 1515
 $10 = $4; //@line 1516
 SAFE_HEAP_STORE($9 | 0, $10 | 0, 4);
 $11 = $6 + 8 | 0; //@line 1518
 $12 = $5; //@line 1519
 SAFE_HEAP_STORE($11 | 0, $12 | 0, 4);
 $13 = $3; //@line 1521
 $14 = $13 + 128 | 0; //@line 1522
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 1523
 _cpHashSetFilter($15, 69, $6); //@line 1524
 $16 = $3; //@line 1525
 _cpSpaceUnlock($16, 1); //@line 1526
 STACKTOP = sp; //@line 1527
 return;
}
function _calloc($0, $1) {
 $0 = $0 | 0; //@line 9270
 $1 = $1 | 0; //@line 9271
 var $$0 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spec$select = 0, label = 0, sp = 0; //@line 9272
 sp = STACKTOP; //@line 9273
 $2 = ($0 | 0) == 0; //@line 9274
 if ($2) {
  $$0 = 0; //@line 9276
 } else {
  $3 = Math_imul($1, $0) | 0; //@line 9278
  $4 = $1 | $0; //@line 9279
  $5 = $4 >>> 0 > 65535; //@line 9280
  if ($5) {
   $6 = ($3 >>> 0) / ($0 >>> 0) & -1; //@line 9282
   $7 = ($6 | 0) == ($1 | 0); //@line 9283
   $spec$select = $7 ? $3 : -1; //@line 9284
   $$0 = $spec$select; //@line 9285
  } else {
   $$0 = $3; //@line 9287
  }
 }
 $8 = _malloc($$0) | 0; //@line 9290
 $9 = ($8 | 0) == (0 | 0); //@line 9291
 if ($9) {
  return $8 | 0; //@line 9293
 }
 $10 = $8 + -4 | 0; //@line 9295
 $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 9296
 $12 = $11 & 3; //@line 9297
 $13 = ($12 | 0) == 0; //@line 9298
 if ($13) {
  return $8 | 0; //@line 9300
 }
 _memset($8 | 0, 0, $$0 | 0) | 0; //@line 9302
 return $8 | 0; //@line 9303
}
function _cpArbiterGetBodies($0, $1, $2) {
 $0 = $0 | 0; //@line 1087
 $1 = $1 | 0; //@line 1088
 $2 = $2 | 0; //@line 1089
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1090
 sp = STACKTOP; //@line 1091
 STACKTOP = STACKTOP + 32 | 0; //@line 1092
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 1092
 $6 = sp + 4 | 0; //@line 1093
 $7 = sp; //@line 1094
 $3 = $0; //@line 1095
 $4 = $1; //@line 1096
 $5 = $2; //@line 1097
 $8 = $3; //@line 1098
 _cpArbiterGetShapes($8, $6, $7); //@line 1099
 $9 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 1100
 $10 = $9 + 8 | 0; //@line 1101
 $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 1102
 $12 = $4; //@line 1103
 SAFE_HEAP_STORE($12 | 0, $11 | 0, 4);
 $13 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 1105
 $14 = $13 + 8 | 0; //@line 1106
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 1107
 $16 = $5; //@line 1108
 SAFE_HEAP_STORE($16 | 0, $15 | 0, 4);
 STACKTOP = sp; //@line 1110
 return;
}
function _cpArrayNew($0) {
 $0 = $0 | 0; //@line 2667
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2668
 sp = STACKTOP; //@line 2669
 STACKTOP = STACKTOP + 16 | 0; //@line 2670
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2670
 $1 = $0; //@line 2671
 $3 = _calloc(1, 12) | 0; //@line 2672
 $2 = $3; //@line 2673
 $4 = $2; //@line 2674
 SAFE_HEAP_STORE($4 | 0, 0 | 0, 4);
 $5 = $1; //@line 2676
 $6 = ($5 | 0) != 0; //@line 2677
 $7 = $1; //@line 2678
 $8 = $6 ? $7 : 4; //@line 2679
 $9 = $2; //@line 2680
 $10 = $9 + 4 | 0; //@line 2681
 SAFE_HEAP_STORE($10 | 0, $8 | 0, 4);
 $11 = $2; //@line 2683
 $12 = $11 + 4 | 0; //@line 2684
 $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 2685
 $14 = _calloc($13, 4) | 0; //@line 2686
 $15 = $2; //@line 2687
 $16 = $15 + 8 | 0; //@line 2688
 SAFE_HEAP_STORE($16 | 0, $14 | 0, 4);
 $17 = $2; //@line 2690
 STACKTOP = sp; //@line 2691
 return $17 | 0; //@line 2691
}
function _cpCircleShapeGetOffset($0, $1) {
 $0 = $0 | 0; //@line 6297
 $1 = $1 | 0; //@line 6298
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 6299
 sp = STACKTOP; //@line 6300
 STACKTOP = STACKTOP + 16 | 0; //@line 6301
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 6301
 $vararg_buffer = sp; //@line 6302
 $2 = $1; //@line 6303
 $3 = $2; //@line 6304
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 6305
 $5 = ($4 | 0) == (2656 | 0); //@line 6306
 if ($5) {
  $6 = $2; //@line 6308
  $7 = $6 + 160 | 0; //@line 6309
  SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  STACKTOP = sp; //@line 6311
  return;
 } else {
  _cpMessage(5758, 5494, 360, 1, 1, 5794, $vararg_buffer); //@line 6313
  _abort(); //@line 6314
 }
}
function _cpSegmentShapeGetB($0, $1) {
 $0 = $0 | 0; //@line 7118
 $1 = $1 | 0; //@line 7119
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 7120
 sp = STACKTOP; //@line 7121
 STACKTOP = STACKTOP + 16 | 0; //@line 7122
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7122
 $vararg_buffer = sp; //@line 7123
 $2 = $1; //@line 7124
 $3 = $2; //@line 7125
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 7126
 $5 = ($4 | 0) == (2676 | 0); //@line 7127
 if ($5) {
  $6 = $2; //@line 7129
  $7 = $6 + 176 | 0; //@line 7130
  SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  STACKTOP = sp; //@line 7132
  return;
 } else {
  _cpMessage(5823, 5494, 520, 1, 1, 5860, $vararg_buffer); //@line 7134
  _abort(); //@line 7135
 }
}
function _cpSegmentShapeGetA($0, $1) {
 $0 = $0 | 0; //@line 7096
 $1 = $1 | 0; //@line 7097
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 7098
 sp = STACKTOP; //@line 7099
 STACKTOP = STACKTOP + 16 | 0; //@line 7100
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7100
 $vararg_buffer = sp; //@line 7101
 $2 = $1; //@line 7102
 $3 = $2; //@line 7103
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 7104
 $5 = ($4 | 0) == (2676 | 0); //@line 7105
 if ($5) {
  $6 = $2; //@line 7107
  $7 = $6 + 160 | 0; //@line 7108
  SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($7 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($7 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
  SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($7 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
  STACKTOP = sp; //@line 7110
  return;
 } else {
  _cpMessage(5823, 5494, 513, 1, 1, 5860, $vararg_buffer); //@line 7112
  _abort(); //@line 7113
 }
}
function _cpConstraintNext_582($0, $1) {
 $0 = $0 | 0; //@line 4978
 $1 = $1 | 0; //@line 4979
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 4980
 sp = STACKTOP; //@line 4981
 STACKTOP = STACKTOP + 16 | 0; //@line 4982
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 4982
 $2 = $0; //@line 4983
 $3 = $1; //@line 4984
 $4 = $2; //@line 4985
 $5 = $4 + 8 | 0; //@line 4986
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 4987
 $7 = $3; //@line 4988
 $8 = ($6 | 0) == ($7 | 0); //@line 4989
 $9 = $2; //@line 4990
 if ($8) {
  $10 = $9 + 16 | 0; //@line 4992
  $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 4993
  $14 = $11; //@line 4994
  STACKTOP = sp; //@line 4995
  return $14 | 0; //@line 4995
 } else {
  $12 = $9 + 20 | 0; //@line 4997
  $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 4998
  $14 = $13; //@line 4999
  STACKTOP = sp; //@line 5000
  return $14 | 0; //@line 5000
 }
 return 0 | 0; //@line 5002
}
function _cpConstraintNext_483($0, $1) {
 $0 = $0 | 0; //@line 2301
 $1 = $1 | 0; //@line 2302
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2303
 sp = STACKTOP; //@line 2304
 STACKTOP = STACKTOP + 16 | 0; //@line 2305
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2305
 $2 = $0; //@line 2306
 $3 = $1; //@line 2307
 $4 = $2; //@line 2308
 $5 = $4 + 8 | 0; //@line 2309
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 2310
 $7 = $3; //@line 2311
 $8 = ($6 | 0) == ($7 | 0); //@line 2312
 $9 = $2; //@line 2313
 if ($8) {
  $10 = $9 + 16 | 0; //@line 2315
  $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 2316
  $14 = $11; //@line 2317
  STACKTOP = sp; //@line 2318
  return $14 | 0; //@line 2318
 } else {
  $12 = $9 + 20 | 0; //@line 2320
  $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 2321
  $14 = $13; //@line 2322
  STACKTOP = sp; //@line 2323
  return $14 | 0; //@line 2323
 }
 return 0 | 0; //@line 2325
}
function _cpShapeGetBB($0, $1) {
 $0 = $0 | 0; //@line 5307
 $1 = $1 | 0; //@line 5308
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0; //@line 5309
 sp = STACKTOP; //@line 5310
 STACKTOP = STACKTOP + 16 | 0; //@line 5311
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5311
 $2 = $1; //@line 5312
 $3 = $2; //@line 5313
 $4 = $3 + 56 | 0; //@line 5314
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 16 | 0, SAFE_HEAP_LOAD($4 + 16 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 20 | 0, SAFE_HEAP_LOAD($4 + 20 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 24 | 0, SAFE_HEAP_LOAD($4 + 24 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 28 | 0, SAFE_HEAP_LOAD($4 + 28 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 5316
 return;
}
function _cpArbiterNext_482($0, $1) {
 $0 = $0 | 0; //@line 2274
 $1 = $1 | 0; //@line 2275
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2276
 sp = STACKTOP; //@line 2277
 STACKTOP = STACKTOP + 16 | 0; //@line 2278
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2278
 $2 = $0; //@line 2279
 $3 = $1; //@line 2280
 $4 = $2; //@line 2281
 $5 = $4 + 44 | 0; //@line 2282
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 2283
 $7 = $3; //@line 2284
 $8 = ($6 | 0) == ($7 | 0); //@line 2285
 $9 = $2; //@line 2286
 if ($8) {
  $10 = $9 + 52 | 0; //@line 2288
  $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 2289
  $14 = $11; //@line 2290
  STACKTOP = sp; //@line 2291
  return $14 | 0; //@line 2291
 } else {
  $12 = $9 + 60 | 0; //@line 2293
  $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 2294
  $14 = $13; //@line 2295
  STACKTOP = sp; //@line 2296
  return $14 | 0; //@line 2296
 }
 return 0 | 0; //@line 2298
}
function _cpBBTreeDestroy($0) {
 $0 = $0 | 0; //@line 3002
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3003
 sp = STACKTOP; //@line 3004
 STACKTOP = STACKTOP + 16 | 0; //@line 3005
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3005
 $1 = $0; //@line 3006
 $2 = $1; //@line 3007
 $3 = $2 + 20 | 0; //@line 3008
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 3009
 _cpHashSetFree($4); //@line 3010
 $5 = $1; //@line 3011
 $6 = $5 + 36 | 0; //@line 3012
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 3013
 $8 = ($7 | 0) != (0 | 0); //@line 3014
 if ($8) {
  $9 = $1; //@line 3016
  $10 = $9 + 36 | 0; //@line 3017
  $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 3018
  _cpArrayFreeEach($11, 48); //@line 3019
 }
 $12 = $1; //@line 3021
 $13 = $12 + 36 | 0; //@line 3022
 $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 3023
 _cpArrayFree($14); //@line 3024
 STACKTOP = sp; //@line 3025
 return;
}
function _cpConstraintNext($0, $1) {
 $0 = $0 | 0; //@line 7234
 $1 = $1 | 0; //@line 7235
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 7236
 sp = STACKTOP; //@line 7237
 STACKTOP = STACKTOP + 16 | 0; //@line 7238
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7238
 $2 = $0; //@line 7239
 $3 = $1; //@line 7240
 $4 = $2; //@line 7241
 $5 = $4 + 8 | 0; //@line 7242
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 7243
 $7 = $3; //@line 7244
 $8 = ($6 | 0) == ($7 | 0); //@line 7245
 $9 = $2; //@line 7246
 if ($8) {
  $10 = $9 + 16 | 0; //@line 7248
  $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 7249
  $14 = $11; //@line 7250
  STACKTOP = sp; //@line 7251
  return $14 | 0; //@line 7251
 } else {
  $12 = $9 + 20 | 0; //@line 7253
  $13 = SAFE_HEAP_LOAD($12 | 0, 4, 0) | 0 | 0; //@line 7254
  $14 = $13; //@line 7255
  STACKTOP = sp; //@line 7256
  return $14 | 0; //@line 7256
 }
 return 0 | 0; //@line 7258
}
function _cpArbiterCallWildcardPreSolveA($0, $1) {
 $0 = $0 | 0; //@line 1182
 $1 = $1 | 0; //@line 1183
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1184
 sp = STACKTOP; //@line 1185
 STACKTOP = STACKTOP + 16 | 0; //@line 1186
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1186
 $2 = $0; //@line 1187
 $3 = $1; //@line 1188
 $5 = $2; //@line 1189
 $6 = $5 + 100 | 0; //@line 1190
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 1191
 $4 = $7; //@line 1192
 $8 = $4; //@line 1193
 $9 = $8 + 12 | 0; //@line 1194
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 1195
 $11 = $2; //@line 1196
 $12 = $3; //@line 1197
 $13 = $4; //@line 1198
 $14 = $13 + 24 | 0; //@line 1199
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 1200
 $16 = FUNCTION_TABLE_iiii[(SAFE_FT_MASK($10 | 0, 127 | 0) | 0) & 127]($11, $12, $15) | 0; //@line 1201
 STACKTOP = sp; //@line 1202
 return $16 | 0; //@line 1202
}
function _cpArbiterCallWildcardBeginA($0, $1) {
 $0 = $0 | 0; //@line 1113
 $1 = $1 | 0; //@line 1114
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1115
 sp = STACKTOP; //@line 1116
 STACKTOP = STACKTOP + 16 | 0; //@line 1117
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1117
 $2 = $0; //@line 1118
 $3 = $1; //@line 1119
 $5 = $2; //@line 1120
 $6 = $5 + 100 | 0; //@line 1121
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 1122
 $4 = $7; //@line 1123
 $8 = $4; //@line 1124
 $9 = $8 + 8 | 0; //@line 1125
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 1126
 $11 = $2; //@line 1127
 $12 = $3; //@line 1128
 $13 = $4; //@line 1129
 $14 = $13 + 24 | 0; //@line 1130
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 1131
 $16 = FUNCTION_TABLE_iiii[(SAFE_FT_MASK($10 | 0, 127 | 0) | 0) & 127]($11, $12, $15) | 0; //@line 1132
 STACKTOP = sp; //@line 1133
 return $16 | 0; //@line 1133
}
function _NodeOther($0, $1) {
 $0 = $0 | 0; //@line 5172
 $1 = $1 | 0; //@line 5173
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5174
 sp = STACKTOP; //@line 5175
 STACKTOP = STACKTOP + 16 | 0; //@line 5176
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5176
 $2 = $0; //@line 5177
 $3 = $1; //@line 5178
 $4 = $2; //@line 5179
 $5 = $4 + 44 | 0; //@line 5180
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 5181
 $7 = $3; //@line 5182
 $8 = ($6 | 0) == ($7 | 0); //@line 5183
 $9 = $2; //@line 5184
 $10 = $9 + 44 | 0; //@line 5185
 if ($8) {
  $11 = $10 + 4 | 0; //@line 5187
  $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 5188
  $14 = $12; //@line 5189
  STACKTOP = sp; //@line 5190
  return $14 | 0; //@line 5190
 } else {
  $13 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 5192
  $14 = $13; //@line 5193
  STACKTOP = sp; //@line 5194
  return $14 | 0; //@line 5194
 }
 return 0 | 0; //@line 5196
}
function _cpCircleShapeNew($0, $1, $2) {
 $0 = $0 | 0; //@line 6280
 $1 = +$1; //@line 6281
 $2 = $2 | 0; //@line 6282
 var $$byval_copy = 0, $3 = 0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0, label = 0, sp = 0; //@line 6283
 sp = STACKTOP; //@line 6284
 STACKTOP = STACKTOP + 32 | 0; //@line 6285
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 6285
 $$byval_copy = sp + 8 | 0; //@line 6286
 $3 = $0; //@line 6287
 $4 = $1; //@line 6288
 $5 = _cpCircleShapeAlloc() | 0; //@line 6289
 $6 = $3; //@line 6290
 $7 = $4; //@line 6291
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($2 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($2 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($2 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $8 = _cpCircleShapeInit($5, $6, $7, $$byval_copy) | 0; //@line 6293
 STACKTOP = sp; //@line 6294
 return $8 | 0; //@line 6294
}
function _cpHashSetFree($0) {
 $0 = $0 | 0; //@line 2171
 var $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2172
 sp = STACKTOP; //@line 2173
 STACKTOP = STACKTOP + 16 | 0; //@line 2174
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2174
 $1 = $0; //@line 2175
 $2 = $1; //@line 2176
 $3 = ($2 | 0) != (0 | 0); //@line 2177
 if (!$3) {
  STACKTOP = sp; //@line 2179
  return;
 }
 $4 = $1; //@line 2181
 $5 = $4 + 16 | 0; //@line 2182
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 2183
 _free($6); //@line 2184
 $7 = $1; //@line 2185
 $8 = $7 + 24 | 0; //@line 2186
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 2187
 _cpArrayFreeEach($9, 48); //@line 2188
 $10 = $1; //@line 2189
 $11 = $10 + 24 | 0; //@line 2190
 $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 2191
 _cpArrayFree($12); //@line 2192
 $13 = $1; //@line 2193
 _free($13); //@line 2194
 STACKTOP = sp; //@line 2195
 return;
}
function _cpArbiterCallWildcardPostSolveA($0, $1) {
 $0 = $0 | 0; //@line 1251
 $1 = $1 | 0; //@line 1252
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1253
 sp = STACKTOP; //@line 1254
 STACKTOP = STACKTOP + 16 | 0; //@line 1255
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1255
 $2 = $0; //@line 1256
 $3 = $1; //@line 1257
 $5 = $2; //@line 1258
 $6 = $5 + 100 | 0; //@line 1259
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 1260
 $4 = $7; //@line 1261
 $8 = $4; //@line 1262
 $9 = $8 + 16 | 0; //@line 1263
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 1264
 $11 = $2; //@line 1265
 $12 = $3; //@line 1266
 $13 = $4; //@line 1267
 $14 = $13 + 24 | 0; //@line 1268
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 1269
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($10 | 0, 127 | 0) | 0) & 127]($11, $12, $15); //@line 1270
 STACKTOP = sp; //@line 1271
 return;
}
function _cpArbiterCallWildcardSeparateA($0, $1) {
 $0 = $0 | 0; //@line 1318
 $1 = $1 | 0; //@line 1319
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1320
 sp = STACKTOP; //@line 1321
 STACKTOP = STACKTOP + 16 | 0; //@line 1322
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1322
 $2 = $0; //@line 1323
 $3 = $1; //@line 1324
 $5 = $2; //@line 1325
 $6 = $5 + 100 | 0; //@line 1326
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 1327
 $4 = $7; //@line 1328
 $8 = $4; //@line 1329
 $9 = $8 + 20 | 0; //@line 1330
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 1331
 $11 = $2; //@line 1332
 $12 = $3; //@line 1333
 $13 = $4; //@line 1334
 $14 = $13 + 24 | 0; //@line 1335
 $15 = SAFE_HEAP_LOAD($14 | 0, 4, 0) | 0 | 0; //@line 1336
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($10 | 0, 127 | 0) | 0) & 127]($11, $12, $15); //@line 1337
 STACKTOP = sp; //@line 1338
 return;
}
function _cpSpacePushContacts($0, $1) {
 $0 = $0 | 0; //@line 4433
 $1 = $1 | 0; //@line 4434
 var $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 4435
 sp = STACKTOP; //@line 4436
 STACKTOP = STACKTOP + 16 | 0; //@line 4437
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 4437
 $vararg_buffer = sp; //@line 4438
 $2 = $0; //@line 4439
 $3 = $1; //@line 4440
 $4 = $3; //@line 4441
 $5 = ($4 | 0) <= 2; //@line 4442
 if ($5) {
  $6 = $3; //@line 4444
  $7 = $2; //@line 4445
  $8 = $7 + 124 | 0; //@line 4446
  $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 4447
  $10 = $9 + 8 | 0; //@line 4448
  $11 = SAFE_HEAP_LOAD($10 | 0, 4, 0) | 0 | 0; //@line 4449
  $12 = $11 + $6 | 0; //@line 4450
  SAFE_HEAP_STORE($10 | 0, $12 | 0, 4);
  STACKTOP = sp; //@line 4452
  return;
 } else {
  _cpMessage(9852, 9556, 176, 1, 1, 9889, $vararg_buffer); //@line 4454
  _abort(); //@line 4455
 }
}
function _cpv_assert_nan($0, $1) {
 $0 = $0 | 0; //@line 6255
 $1 = $1 | 0; //@line 6256
 var $10 = 0, $11 = 0, $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, $vararg_buffer = 0, label = 0, sp = 0; //@line 6257
 sp = STACKTOP; //@line 6258
 STACKTOP = STACKTOP + 16 | 0; //@line 6259
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 6259
 $vararg_buffer = sp; //@line 6260
 $2 = $1; //@line 6261
 $3 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 6262
 $4 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 6263
 $5 = $3 == $4; //@line 6264
 if ($5) {
  $6 = $0 + 8 | 0; //@line 6266
  $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 6267
  $8 = $0 + 8 | 0; //@line 6268
  $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 6269
  $10 = $7 == $9; //@line 6270
  if ($10) {
   STACKTOP = sp; //@line 6272
   return;
  }
 }
 $11 = $2; //@line 6275
 _cpMessage(4276, 3674, 106, 1, 1, $11, $vararg_buffer); //@line 6276
 _abort(); //@line 6277
}
function _cpSpaceReindexShapesForBody($0, $1) {
 $0 = $0 | 0; //@line 1964
 $1 = $1 | 0; //@line 1965
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1966
 sp = STACKTOP; //@line 1967
 STACKTOP = STACKTOP + 16 | 0; //@line 1968
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1968
 $2 = $0; //@line 1969
 $3 = $1; //@line 1970
 $5 = $3; //@line 1971
 $6 = $5 + 212 | 0; //@line 1972
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 1973
 $4 = $7; //@line 1974
 while (1) {
  $8 = $4; //@line 1976
  $9 = ($8 | 0) != (0 | 0); //@line 1977
  if (!$9) {
   break;
  }
  $10 = $2; //@line 1981
  $11 = $4; //@line 1982
  _cpSpaceReindexShape($10, $11); //@line 1983
  $12 = $4; //@line 1984
  $13 = $12 + 148 | 0; //@line 1985
  $14 = SAFE_HEAP_LOAD($13 | 0, 4, 0) | 0 | 0; //@line 1986
  $4 = $14; //@line 1987
 }
 STACKTOP = sp; //@line 1989
 return;
}
function _cpShapeCacheBB($0, $1) {
 $0 = $0 | 0; //@line 5481
 $1 = $1 | 0; //@line 5482
 var $$byval_copy = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0; //@line 5483
 sp = STACKTOP; //@line 5484
 STACKTOP = STACKTOP + 64 | 0; //@line 5485
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(64 | 0); //@line 5485
 $$byval_copy = sp; //@line 5486
 $2 = $1; //@line 5487
 $3 = $2; //@line 5488
 $4 = $2; //@line 5489
 $5 = $4 + 8 | 0; //@line 5490
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 5491
 $7 = $6 + 128 | 0; //@line 5492
 dest = $$byval_copy; //@line 5493
 src = $7; //@line 5493
 stop = dest + 48 | 0; //@line 5493
 do {
  SAFE_HEAP_STORE(dest | 0, SAFE_HEAP_LOAD(src | 0, 4, 0) | 0 | 0 | 0, 4);
  dest = dest + 4 | 0; //@line 5493
  src = src + 4 | 0; //@line 5493
 } while ((dest | 0) < (stop | 0));
 _cpShapeUpdate($0, $3, $$byval_copy); //@line 5494
 STACKTOP = sp; //@line 5495
 return;
}
function _cpShapeSetElasticity($0, $1) {
 $0 = $0 | 0; //@line 5359
 $1 = +$1; //@line 5360
 var $10 = 0, $11 = 0, $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0.0, $vararg_buffer = 0, label = 0, sp = 0; //@line 5361
 sp = STACKTOP; //@line 5362
 STACKTOP = STACKTOP + 16 | 0; //@line 5363
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5363
 $vararg_buffer = sp + 8 | 0; //@line 5364
 $2 = $0; //@line 5365
 $3 = $1; //@line 5366
 $4 = $3; //@line 5367
 $5 = $4 >= 0.0; //@line 5368
 if ($5) {
  $6 = $2; //@line 5370
  $7 = $6 + 8 | 0; //@line 5371
  $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 5372
  _cpBodyActivate($8); //@line 5373
  $9 = $3; //@line 5374
  $10 = $2; //@line 5375
  $11 = $10 + 96 | 0; //@line 5376
  SAFE_HEAP_STORE_D($11 | 0, +$9, 8);
  STACKTOP = sp; //@line 5378
  return;
 } else {
  _cpMessage(5667, 5494, 140, 1, 1, 5686, $vararg_buffer); //@line 5380
  _abort(); //@line 5381
 }
}
function _cpShapeSetFriction($0, $1) {
 $0 = $0 | 0; //@line 5397
 $1 = +$1; //@line 5398
 var $10 = 0, $11 = 0, $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0.0, $vararg_buffer = 0, label = 0, sp = 0; //@line 5399
 sp = STACKTOP; //@line 5400
 STACKTOP = STACKTOP + 16 | 0; //@line 5401
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5401
 $vararg_buffer = sp + 8 | 0; //@line 5402
 $2 = $0; //@line 5403
 $3 = $1; //@line 5404
 $4 = $3; //@line 5405
 $5 = $4 >= 0.0; //@line 5406
 if ($5) {
  $6 = $2; //@line 5408
  $7 = $6 + 8 | 0; //@line 5409
  $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 5410
  _cpBodyActivate($8); //@line 5411
  $9 = $3; //@line 5412
  $10 = $2; //@line 5413
  $11 = $10 + 104 | 0; //@line 5414
  SAFE_HEAP_STORE_D($11 | 0, +$9, 8);
  STACKTOP = sp; //@line 5416
  return;
 } else {
  _cpMessage(5715, 5494, 154, 1, 1, 5732, $vararg_buffer); //@line 5418
  _abort(); //@line 5419
 }
}
function _cpBodyGetType($0) {
 $0 = $0 | 0; //@line 6306
 var $1 = 0, $10 = 0.0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 6307
 sp = STACKTOP; //@line 6308
 STACKTOP = STACKTOP + 16 | 0; //@line 6309
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 6309
 $2 = $0; //@line 6310
 $3 = $2; //@line 6311
 $4 = $3 + 224 | 0; //@line 6312
 $5 = $4 + 8 | 0; //@line 6313
 $6 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 6314
 $7 = $6 == inf; //@line 6315
 do {
  if ($7) {
   $1 = 2; //@line 6318
  } else {
   $8 = $2; //@line 6320
   $9 = $8 + 8 | 0; //@line 6321
   $10 = +(+SAFE_HEAP_LOAD_D($9 | 0, 8)); //@line 6322
   $11 = $10 == inf; //@line 6323
   if ($11) {
    $1 = 1; //@line 6325
    break;
   } else {
    $1 = 0; //@line 6328
    break;
   }
  }
 } while (0);
 $12 = $1; //@line 6333
 STACKTOP = sp; //@line 6334
 return $12 | 0; //@line 6334
}
function _cpBBNewForCircle_548($0, $1, $2) {
 $0 = $0 | 0; //@line 3648
 $1 = $1 | 0; //@line 3649
 $2 = +$2; //@line 3650
 var $$byval_copy = 0, $3 = 0.0, $4 = 0.0, $5 = 0.0, label = 0, sp = 0; //@line 3651
 sp = STACKTOP; //@line 3652
 STACKTOP = STACKTOP + 32 | 0; //@line 3653
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 3653
 $$byval_copy = sp + 8 | 0; //@line 3654
 $3 = $2; //@line 3655
 $4 = $3; //@line 3656
 $5 = $3; //@line 3657
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpBBNewForExtents_549($0, $$byval_copy, $4, $5); //@line 3659
 STACKTOP = sp; //@line 3660
 return;
}
function _cpBBNewForCircle($0, $1, $2) {
 $0 = $0 | 0; //@line 6210
 $1 = $1 | 0; //@line 6211
 $2 = +$2; //@line 6212
 var $$byval_copy = 0, $3 = 0.0, $4 = 0.0, $5 = 0.0, label = 0, sp = 0; //@line 6213
 sp = STACKTOP; //@line 6214
 STACKTOP = STACKTOP + 32 | 0; //@line 6215
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 6215
 $$byval_copy = sp + 8 | 0; //@line 6216
 $3 = $2; //@line 6217
 $4 = $3; //@line 6218
 $5 = $3; //@line 6219
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _cpBBNewForExtents($0, $$byval_copy, $4, $5); //@line 6221
 STACKTOP = sp; //@line 6222
 return;
}
function _cpBBTreeSetVelocityFunc($0, $1) {
 $0 = $0 | 0; //@line 5490
 $1 = $1 | 0; //@line 5491
 var $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 5492
 sp = STACKTOP; //@line 5493
 STACKTOP = STACKTOP + 16 | 0; //@line 5494
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5494
 $vararg_buffer = sp; //@line 5495
 $2 = $0; //@line 5496
 $3 = $1; //@line 5497
 $4 = $2; //@line 5498
 $5 = SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0; //@line 5499
 $6 = _Klass() | 0; //@line 5500
 $7 = ($5 | 0) != ($6 | 0); //@line 5501
 if ($7) {
  _cpMessage(4953, 3342, 581, 0, 0, 3558, $vararg_buffer); //@line 5503
  STACKTOP = sp; //@line 5504
  return;
 } else {
  $8 = $3; //@line 5506
  $9 = $2; //@line 5507
  $10 = $9 + 16 | 0; //@line 5508
  SAFE_HEAP_STORE($10 | 0, $8 | 0, 4);
  STACKTOP = sp; //@line 5510
  return;
 }
}
function _CircleSupportPoint($0, $1, $2) {
 $0 = $0 | 0; //@line 1924
 $1 = $1 | 0; //@line 1925
 $2 = $2 | 0; //@line 1926
 var $$byval_copy = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0; //@line 1927
 sp = STACKTOP; //@line 1928
 STACKTOP = STACKTOP + 32 | 0; //@line 1929
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 1929
 $$byval_copy = sp; //@line 1930
 $3 = $1; //@line 1931
 $4 = $3; //@line 1932
 $5 = $4 + 176 | 0; //@line 1933
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 _SupportPointNew($0, $$byval_copy, 0); //@line 1935
 STACKTOP = sp; //@line 1936
 return;
}
function _cpSpaceArrayForBodyType_457($0, $1) {
 $0 = $0 | 0; //@line 1379
 $1 = $1 | 0; //@line 1380
 var $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1381
 sp = STACKTOP; //@line 1382
 STACKTOP = STACKTOP + 16 | 0; //@line 1383
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1383
 $2 = $0; //@line 1384
 $3 = $1; //@line 1385
 $4 = $3; //@line 1386
 $5 = ($4 | 0) == 2; //@line 1387
 $6 = $2; //@line 1388
 if ($5) {
  $7 = $6 + 92 | 0; //@line 1390
  $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 1391
  $11 = $8; //@line 1392
  STACKTOP = sp; //@line 1393
  return $11 | 0; //@line 1393
 } else {
  $9 = $6 + 88 | 0; //@line 1395
  $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 1396
  $11 = $10; //@line 1397
  STACKTOP = sp; //@line 1398
  return $11 | 0; //@line 1398
 }
 return 0 | 0; //@line 1400
}
function _cpv_410($0, $1, $2) {
 $0 = $0 | 0; //@line 7906
 $1 = +$1; //@line 7907
 $2 = +$2; //@line 7908
 var $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 7910
 STACKTOP = STACKTOP + 32 | 0; //@line 7911
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 7911
 $5 = sp; //@line 7912
 $3 = $1; //@line 7913
 $4 = $2; //@line 7914
 $6 = $3; //@line 7915
 SAFE_HEAP_STORE_D($5 | 0, +$6, 8);
 $7 = $5 + 8 | 0; //@line 7917
 $8 = $4; //@line 7918
 SAFE_HEAP_STORE_D($7 | 0, +$8, 8);
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 7921
 return;
}
function _cpv_358($0, $1, $2) {
 $0 = $0 | 0; //@line 5625
 $1 = +$1; //@line 5626
 $2 = +$2; //@line 5627
 var $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 5629
 STACKTOP = STACKTOP + 32 | 0; //@line 5630
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 5630
 $5 = sp; //@line 5631
 $3 = $1; //@line 5632
 $4 = $2; //@line 5633
 $6 = $3; //@line 5634
 SAFE_HEAP_STORE_D($5 | 0, +$6, 8);
 $7 = $5 + 8 | 0; //@line 5636
 $8 = $4; //@line 5637
 SAFE_HEAP_STORE_D($7 | 0, +$8, 8);
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 5640
 return;
}
function _cpv_271($0, $1, $2) {
 $0 = $0 | 0; //@line 4057
 $1 = +$1; //@line 4058
 $2 = +$2; //@line 4059
 var $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 4061
 STACKTOP = STACKTOP + 32 | 0; //@line 4062
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 4062
 $5 = sp; //@line 4063
 $3 = $1; //@line 4064
 $4 = $2; //@line 4065
 $6 = $3; //@line 4066
 SAFE_HEAP_STORE_D($5 | 0, +$6, 8);
 $7 = $5 + 8 | 0; //@line 4068
 $8 = $4; //@line 4069
 SAFE_HEAP_STORE_D($7 | 0, +$8, 8);
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 4072
 return;
}
function _cpv_251($0, $1, $2) {
 $0 = $0 | 0; //@line 3479
 $1 = +$1; //@line 3480
 $2 = +$2; //@line 3481
 var $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3483
 STACKTOP = STACKTOP + 32 | 0; //@line 3484
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 3484
 $5 = sp; //@line 3485
 $3 = $1; //@line 3486
 $4 = $2; //@line 3487
 $6 = $3; //@line 3488
 SAFE_HEAP_STORE_D($5 | 0, +$6, 8);
 $7 = $5 + 8 | 0; //@line 3490
 $8 = $4; //@line 3491
 SAFE_HEAP_STORE_D($7 | 0, +$8, 8);
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 3494
 return;
}
function _cpv_33($0, $1, $2) {
 $0 = $0 | 0; //@line 6040
 $1 = +$1; //@line 6041
 $2 = +$2; //@line 6042
 var $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 6044
 STACKTOP = STACKTOP + 32 | 0; //@line 6045
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 6045
 $5 = sp; //@line 6046
 $3 = $1; //@line 6047
 $4 = $2; //@line 6048
 $6 = $3; //@line 6049
 SAFE_HEAP_STORE_D($5 | 0, +$6, 8);
 $7 = $5 + 8 | 0; //@line 6051
 $8 = $4; //@line 6052
 SAFE_HEAP_STORE_D($7 | 0, +$8, 8);
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 6055
 return;
}
function _cpv_21($0, $1, $2) {
 $0 = $0 | 0; //@line 3714
 $1 = +$1; //@line 3715
 $2 = +$2; //@line 3716
 var $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3718
 STACKTOP = STACKTOP + 32 | 0; //@line 3719
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 3719
 $5 = sp; //@line 3720
 $3 = $1; //@line 3721
 $4 = $2; //@line 3722
 $6 = $3; //@line 3723
 SAFE_HEAP_STORE_D($5 | 0, +$6, 8);
 $7 = $5 + 8 | 0; //@line 3725
 $8 = $4; //@line 3726
 SAFE_HEAP_STORE_D($7 | 0, +$8, 8);
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 3729
 return;
}
function _cpv_assert_infinite($0, $1) {
 $0 = $0 | 0; //@line 6281
 $1 = $1 | 0; //@line 6282
 var $10 = 0, $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 6283
 sp = STACKTOP; //@line 6284
 STACKTOP = STACKTOP + 16 | 0; //@line 6285
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 6285
 $vararg_buffer = sp; //@line 6286
 $2 = $1; //@line 6287
 $3 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 6288
 $4 = +_cpfabs_35($3); //@line 6289
 $5 = $4 != inf; //@line 6290
 if ($5) {
  $6 = $0 + 8 | 0; //@line 6292
  $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 6293
  $8 = +_cpfabs_35($7); //@line 6294
  $9 = $8 != inf; //@line 6295
  if ($9) {
   STACKTOP = sp; //@line 6297
   return;
  }
 }
 $10 = $2; //@line 6300
 _cpMessage(4225, 3674, 107, 1, 1, $10, $vararg_buffer); //@line 6301
 _abort(); //@line 6302
}
function _cpSpaceArrayForBodyType($0, $1) {
 $0 = $0 | 0; //@line 6711
 $1 = $1 | 0; //@line 6712
 var $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 6713
 sp = STACKTOP; //@line 6714
 STACKTOP = STACKTOP + 16 | 0; //@line 6715
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 6715
 $2 = $0; //@line 6716
 $3 = $1; //@line 6717
 $4 = $3; //@line 6718
 $5 = ($4 | 0) == 2; //@line 6719
 $6 = $2; //@line 6720
 if ($5) {
  $7 = $6 + 92 | 0; //@line 6722
  $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 6723
  $11 = $8; //@line 6724
  STACKTOP = sp; //@line 6725
  return $11 | 0; //@line 6725
 } else {
  $9 = $6 + 88 | 0; //@line 6727
  $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 6728
  $11 = $10; //@line 6729
  STACKTOP = sp; //@line 6730
  return $11 | 0; //@line 6730
 }
 return 0 | 0; //@line 6732
}
function _sbrk(increment) {
 increment = increment | 0; //@line 120
 var oldDynamicTop = 0; //@line 121
 var oldDynamicTopOnChange = 0; //@line 122
 var newDynamicTop = 0; //@line 123
 var totalMemory = 0; //@line 124
 oldDynamicTop = SAFE_HEAP_LOAD(DYNAMICTOP_PTR | 0, 4, 0) | 0 | 0; //@line 125
 newDynamicTop = oldDynamicTop + increment | 0; //@line 126
 if ((increment | 0) > 0 & (newDynamicTop | 0) < (oldDynamicTop | 0) | (newDynamicTop | 0) < 0) {
  abortOnCannotGrowMemory() | 0; //@line 130
  ___setErrNo(12); //@line 131
  return -1;
 }
 SAFE_HEAP_STORE(DYNAMICTOP_PTR | 0, newDynamicTop | 0, 4);
 totalMemory = getTotalMemory() | 0; //@line 136
 if ((newDynamicTop | 0) > (totalMemory | 0)) {
  if ((enlargeMemory() | 0) == 0) {
   SAFE_HEAP_STORE(DYNAMICTOP_PTR | 0, oldDynamicTop | 0, 4);
   ___setErrNo(12); //@line 140
   return -1;
  }
 }
 return oldDynamicTop | 0; //@line 144
}
function _cpv_72($0, $1, $2) {
 $0 = $0 | 0; //@line 699
 $1 = +$1; //@line 700
 $2 = +$2; //@line 701
 var $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 703
 STACKTOP = STACKTOP + 32 | 0; //@line 704
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 704
 $5 = sp; //@line 705
 $3 = $1; //@line 706
 $4 = $2; //@line 707
 $6 = $3; //@line 708
 SAFE_HEAP_STORE_D($5 | 0, +$6, 8);
 $7 = $5 + 8 | 0; //@line 710
 $8 = $4; //@line 711
 SAFE_HEAP_STORE_D($7 | 0, +$8, 8);
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 714
 return;
}
function _cpv_2($0, $1, $2) {
 $0 = $0 | 0; //@line 879
 $1 = +$1; //@line 880
 $2 = +$2; //@line 881
 var $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 883
 STACKTOP = STACKTOP + 32 | 0; //@line 884
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 884
 $5 = sp; //@line 885
 $3 = $1; //@line 886
 $4 = $2; //@line 887
 $6 = $3; //@line 888
 SAFE_HEAP_STORE_D($5 | 0, +$6, 8);
 $7 = $5 + 8 | 0; //@line 890
 $8 = $4; //@line 891
 SAFE_HEAP_STORE_D($7 | 0, +$8, 8);
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 894
 return;
}
function _cpv($0, $1, $2) {
 $0 = $0 | 0; //@line 361
 $1 = +$1; //@line 362
 $2 = +$2; //@line 363
 var $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 365
 STACKTOP = STACKTOP + 32 | 0; //@line 366
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 366
 $5 = sp; //@line 367
 $3 = $1; //@line 368
 $4 = $2; //@line 369
 $6 = $3; //@line 370
 SAFE_HEAP_STORE_D($5 | 0, +$6, 8);
 $7 = $5 + 8 | 0; //@line 372
 $8 = $4; //@line 373
 SAFE_HEAP_STORE_D($7 | 0, +$8, 8);
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($5 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($5 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($5 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 376
 return;
}
function _GetRootIfTree($0) {
 $0 = $0 | 0; //@line 5374
 var $1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5375
 sp = STACKTOP; //@line 5376
 STACKTOP = STACKTOP + 16 | 0; //@line 5377
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5377
 $1 = $0; //@line 5378
 $2 = $1; //@line 5379
 $3 = ($2 | 0) != (0 | 0); //@line 5380
 if ($3) {
  $4 = $1; //@line 5382
  $5 = SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0; //@line 5383
  $6 = _Klass() | 0; //@line 5384
  $7 = ($5 | 0) == ($6 | 0); //@line 5385
  if ($7) {
   $8 = $1; //@line 5387
   $9 = $8 + 24 | 0; //@line 5388
   $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 5389
   $11 = $10; //@line 5390
  } else {
   $11 = 0; //@line 5392
  }
 } else {
  $11 = 0; //@line 5395
 }
 STACKTOP = sp; //@line 5397
 return $11 | 0; //@line 5397
}
function _PairRecycle($0, $1) {
 $0 = $0 | 0; //@line 4320
 $1 = $1 | 0; //@line 4321
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 4322
 sp = STACKTOP; //@line 4323
 STACKTOP = STACKTOP + 16 | 0; //@line 4324
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 4324
 $2 = $0; //@line 4325
 $3 = $1; //@line 4326
 $4 = $2; //@line 4327
 $5 = _GetMasterTree($4) | 0; //@line 4328
 $2 = $5; //@line 4329
 $6 = $2; //@line 4330
 $7 = $6 + 32 | 0; //@line 4331
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 4332
 $9 = $3; //@line 4333
 $10 = $9 + 8 | 0; //@line 4334
 SAFE_HEAP_STORE($10 | 0, $8 | 0, 4);
 $11 = $3; //@line 4336
 $12 = $2; //@line 4337
 $13 = $12 + 32 | 0; //@line 4338
 SAFE_HEAP_STORE($13 | 0, $11 | 0, 4);
 STACKTOP = sp; //@line 4340
 return;
}
function _cpConstraintSetErrorBias($0, $1) {
 $0 = $0 | 0; //@line 2085
 $1 = +$1; //@line 2086
 var $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 2087
 sp = STACKTOP; //@line 2088
 STACKTOP = STACKTOP + 16 | 0; //@line 2089
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2089
 $vararg_buffer = sp + 8 | 0; //@line 2090
 $2 = $0; //@line 2091
 $3 = $1; //@line 2092
 $4 = $3; //@line 2093
 $5 = $4 >= 0.0; //@line 2094
 if ($5) {
  $6 = $2; //@line 2096
  _cpConstraintActivateBodies($6); //@line 2097
  $7 = $3; //@line 2098
  $8 = $2; //@line 2099
  $9 = $8 + 32 | 0; //@line 2100
  SAFE_HEAP_STORE_D($9 | 0, +$7, 8);
  STACKTOP = sp; //@line 2102
  return;
 } else {
  _cpMessage(5113, 5022, 100, 1, 1, 5131, $vararg_buffer); //@line 2104
  _abort(); //@line 2105
 }
}
function _cpConstraintSetMaxForce($0, $1) {
 $0 = $0 | 0; //@line 2029
 $1 = +$1; //@line 2030
 var $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 2031
 sp = STACKTOP; //@line 2032
 STACKTOP = STACKTOP + 16 | 0; //@line 2033
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2033
 $vararg_buffer = sp + 8 | 0; //@line 2034
 $2 = $0; //@line 2035
 $3 = $1; //@line 2036
 $4 = $3; //@line 2037
 $5 = $4 >= 0.0; //@line 2038
 if ($5) {
  $6 = $2; //@line 2040
  _cpConstraintActivateBodies($6); //@line 2041
  $7 = $3; //@line 2042
  $8 = $2; //@line 2043
  $9 = $8 + 24 | 0; //@line 2044
  SAFE_HEAP_STORE_D($9 | 0, +$7, 8);
  STACKTOP = sp; //@line 2046
  return;
 } else {
  _cpMessage(5005, 5022, 86, 1, 1, 5086, $vararg_buffer); //@line 2048
  _abort(); //@line 2049
 }
}
function _cpConstraintSetMaxBias($0, $1) {
 $0 = $0 | 0; //@line 2121
 $1 = +$1; //@line 2122
 var $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 2123
 sp = STACKTOP; //@line 2124
 STACKTOP = STACKTOP + 16 | 0; //@line 2125
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2125
 $vararg_buffer = sp + 8 | 0; //@line 2126
 $2 = $0; //@line 2127
 $3 = $1; //@line 2128
 $4 = $3; //@line 2129
 $5 = $4 >= 0.0; //@line 2130
 if ($5) {
  $6 = $2; //@line 2132
  _cpConstraintActivateBodies($6); //@line 2133
  $7 = $3; //@line 2134
  $8 = $2; //@line 2135
  $9 = $8 + 40 | 0; //@line 2136
  SAFE_HEAP_STORE_D($9 | 0, +$7, 8);
  STACKTOP = sp; //@line 2138
  return;
 } else {
  _cpMessage(5159, 5022, 114, 1, 1, 5175, $vararg_buffer); //@line 2140
  _abort(); //@line 2141
 }
}
function _cpBodySetVelocity($0, $1) {
 $0 = $0 | 0; //@line 7273
 $1 = $1 | 0; //@line 7274
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0; //@line 7275
 sp = STACKTOP; //@line 7276
 STACKTOP = STACKTOP + 16 | 0; //@line 7277
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7277
 $2 = $0; //@line 7278
 $3 = $2; //@line 7279
 _cpBodyActivate($3); //@line 7280
 $4 = $2; //@line 7281
 $5 = $4 + 72 | 0; //@line 7282
 SAFE_HEAP_STORE($5 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($5 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($5 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($5 + 12 | 0, SAFE_HEAP_LOAD($1 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $6 = $2; //@line 7284
 _cpBodySanityCheck($6); //@line 7285
 STACKTOP = sp; //@line 7286
 return;
}
function _cpBBTreeContains($0, $1, $2) {
 $0 = $0 | 0; //@line 3062
 $1 = $1 | 0; //@line 3063
 $2 = $2 | 0; //@line 3064
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3065
 sp = STACKTOP; //@line 3066
 STACKTOP = STACKTOP + 16 | 0; //@line 3067
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3067
 $3 = $0; //@line 3068
 $4 = $1; //@line 3069
 $5 = $2; //@line 3070
 $6 = $3; //@line 3071
 $7 = $6 + 20 | 0; //@line 3072
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 3073
 $9 = $5; //@line 3074
 $10 = $4; //@line 3075
 $11 = _cpHashSetFind($8, $9, $10) | 0; //@line 3076
 $12 = ($11 | 0) != (0 | 0); //@line 3077
 $13 = $12 & 1; //@line 3078
 $14 = $13 & 255; //@line 3079
 STACKTOP = sp; //@line 3080
 return $14 | 0; //@line 3080
}
function _getImpulse_238($0) {
 $0 = $0 | 0; //@line 3166
 var $$byval_copy = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0.0, label = 0, sp = 0; //@line 3167
 sp = STACKTOP; //@line 3168
 STACKTOP = STACKTOP + 32 | 0; //@line 3169
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 3169
 $$byval_copy = sp; //@line 3170
 $1 = $0; //@line 3171
 $2 = $1; //@line 3172
 $3 = $2 + 160 | 0; //@line 3173
 SAFE_HEAP_STORE($$byval_copy | 0, SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 4 | 0, SAFE_HEAP_LOAD($3 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 8 | 0, SAFE_HEAP_LOAD($3 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($$byval_copy + 12 | 0, SAFE_HEAP_LOAD($3 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 $4 = +_cpvlength_239($$byval_copy); //@line 3175
 STACKTOP = sp; //@line 3176
 return +$4;
}
function _cpSpatialIndexReindexQuery_588($0, $1, $2) {
 $0 = $0 | 0; //@line 5593
 $1 = $1 | 0; //@line 5594
 $2 = $2 | 0; //@line 5595
 var $10 = 0, $11 = 0, $12 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5596
 sp = STACKTOP; //@line 5597
 STACKTOP = STACKTOP + 16 | 0; //@line 5598
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5598
 $3 = $0; //@line 5599
 $4 = $1; //@line 5600
 $5 = $2; //@line 5601
 $6 = $3; //@line 5602
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 5603
 $8 = $7 + 32 | 0; //@line 5604
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 5605
 $10 = $3; //@line 5606
 $11 = $4; //@line 5607
 $12 = $5; //@line 5608
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($9 | 0, 127 | 0) | 0) & 127]($10, $11, $12); //@line 5609
 STACKTOP = sp; //@line 5610
 return;
}
function _cpSpatialIndexReindexObject($0, $1, $2) {
 $0 = $0 | 0; //@line 1944
 $1 = $1 | 0; //@line 1945
 $2 = $2 | 0; //@line 1946
 var $10 = 0, $11 = 0, $12 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1947
 sp = STACKTOP; //@line 1948
 STACKTOP = STACKTOP + 16 | 0; //@line 1949
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1949
 $3 = $0; //@line 1950
 $4 = $1; //@line 1951
 $5 = $2; //@line 1952
 $6 = $3; //@line 1953
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 1954
 $8 = $7 + 28 | 0; //@line 1955
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 1956
 $10 = $3; //@line 1957
 $11 = $4; //@line 1958
 $12 = $5; //@line 1959
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($9 | 0, 127 | 0) | 0) & 127]($10, $11, $12); //@line 1960
 STACKTOP = sp; //@line 1961
 return;
}
function _cpSpatialIndexRemove_480($0, $1, $2) {
 $0 = $0 | 0; //@line 2234
 $1 = $1 | 0; //@line 2235
 $2 = $2 | 0; //@line 2236
 var $10 = 0, $11 = 0, $12 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2237
 sp = STACKTOP; //@line 2238
 STACKTOP = STACKTOP + 16 | 0; //@line 2239
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2239
 $3 = $0; //@line 2240
 $4 = $1; //@line 2241
 $5 = $2; //@line 2242
 $6 = $3; //@line 2243
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 2244
 $8 = $7 + 20 | 0; //@line 2245
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 2246
 $10 = $3; //@line 2247
 $11 = $4; //@line 2248
 $12 = $5; //@line 2249
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($9 | 0, 127 | 0) | 0) & 127]($10, $11, $12); //@line 2250
 STACKTOP = sp; //@line 2251
 return;
}
function _cpSpatialIndexRemove_466($0, $1, $2) {
 $0 = $0 | 0; //@line 1738
 $1 = $1 | 0; //@line 1739
 $2 = $2 | 0; //@line 1740
 var $10 = 0, $11 = 0, $12 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1741
 sp = STACKTOP; //@line 1742
 STACKTOP = STACKTOP + 16 | 0; //@line 1743
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1743
 $3 = $0; //@line 1744
 $4 = $1; //@line 1745
 $5 = $2; //@line 1746
 $6 = $3; //@line 1747
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 1748
 $8 = $7 + 20 | 0; //@line 1749
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 1750
 $10 = $3; //@line 1751
 $11 = $4; //@line 1752
 $12 = $5; //@line 1753
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($9 | 0, 127 | 0) | 0) & 127]($10, $11, $12); //@line 1754
 STACKTOP = sp; //@line 1755
 return;
}
function _cpSpatialIndexInsert_481($0, $1, $2) {
 $0 = $0 | 0; //@line 2254
 $1 = $1 | 0; //@line 2255
 $2 = $2 | 0; //@line 2256
 var $10 = 0, $11 = 0, $12 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2257
 sp = STACKTOP; //@line 2258
 STACKTOP = STACKTOP + 16 | 0; //@line 2259
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2259
 $3 = $0; //@line 2260
 $4 = $1; //@line 2261
 $5 = $2; //@line 2262
 $6 = $3; //@line 2263
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 2264
 $8 = $7 + 16 | 0; //@line 2265
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 2266
 $10 = $3; //@line 2267
 $11 = $4; //@line 2268
 $12 = $5; //@line 2269
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($9 | 0, 127 | 0) | 0) & 127]($10, $11, $12); //@line 2270
 STACKTOP = sp; //@line 2271
 return;
}
function _cpSpatialIndexInsert_452($0, $1, $2) {
 $0 = $0 | 0; //@line 1304
 $1 = $1 | 0; //@line 1305
 $2 = $2 | 0; //@line 1306
 var $10 = 0, $11 = 0, $12 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1307
 sp = STACKTOP; //@line 1308
 STACKTOP = STACKTOP + 16 | 0; //@line 1309
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1309
 $3 = $0; //@line 1310
 $4 = $1; //@line 1311
 $5 = $2; //@line 1312
 $6 = $3; //@line 1313
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 1314
 $8 = $7 + 16 | 0; //@line 1315
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 1316
 $10 = $3; //@line 1317
 $11 = $4; //@line 1318
 $12 = $5; //@line 1319
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($9 | 0, 127 | 0) | 0) & 127]($10, $11, $12); //@line 1320
 STACKTOP = sp; //@line 1321
 return;
}
function _cpSpatialIndexEach_598($0, $1, $2) {
 $0 = $0 | 0; //@line 5780
 $1 = $1 | 0; //@line 5781
 $2 = $2 | 0; //@line 5782
 var $10 = 0, $11 = 0, $12 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5783
 sp = STACKTOP; //@line 5784
 STACKTOP = STACKTOP + 16 | 0; //@line 5785
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5785
 $3 = $0; //@line 5786
 $4 = $1; //@line 5787
 $5 = $2; //@line 5788
 $6 = $3; //@line 5789
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 5790
 $8 = $7 + 8 | 0; //@line 5791
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 5792
 $10 = $3; //@line 5793
 $11 = $4; //@line 5794
 $12 = $5; //@line 5795
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($9 | 0, 127 | 0) | 0) & 127]($10, $11, $12); //@line 5796
 STACKTOP = sp; //@line 5797
 return;
}
function _cpSpatialIndexEach_587($0, $1, $2) {
 $0 = $0 | 0; //@line 5573
 $1 = $1 | 0; //@line 5574
 $2 = $2 | 0; //@line 5575
 var $10 = 0, $11 = 0, $12 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5576
 sp = STACKTOP; //@line 5577
 STACKTOP = STACKTOP + 16 | 0; //@line 5578
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5578
 $3 = $0; //@line 5579
 $4 = $1; //@line 5580
 $5 = $2; //@line 5581
 $6 = $3; //@line 5582
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 5583
 $8 = $7 + 8 | 0; //@line 5584
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 5585
 $10 = $3; //@line 5586
 $11 = $4; //@line 5587
 $12 = $5; //@line 5588
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($9 | 0, 127 | 0) | 0) & 127]($10, $11, $12); //@line 5589
 STACKTOP = sp; //@line 5590
 return;
}
function _cpSpatialIndexRemove($0, $1, $2) {
 $0 = $0 | 0; //@line 6735
 $1 = $1 | 0; //@line 6736
 $2 = $2 | 0; //@line 6737
 var $10 = 0, $11 = 0, $12 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 6738
 sp = STACKTOP; //@line 6739
 STACKTOP = STACKTOP + 16 | 0; //@line 6740
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 6740
 $3 = $0; //@line 6741
 $4 = $1; //@line 6742
 $5 = $2; //@line 6743
 $6 = $3; //@line 6744
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 6745
 $8 = $7 + 20 | 0; //@line 6746
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 6747
 $10 = $3; //@line 6748
 $11 = $4; //@line 6749
 $12 = $5; //@line 6750
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($9 | 0, 127 | 0) | 0) & 127]($10, $11, $12); //@line 6751
 STACKTOP = sp; //@line 6752
 return;
}
function _cpSpatialIndexInsert($0, $1, $2) {
 $0 = $0 | 0; //@line 6755
 $1 = $1 | 0; //@line 6756
 $2 = $2 | 0; //@line 6757
 var $10 = 0, $11 = 0, $12 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 6758
 sp = STACKTOP; //@line 6759
 STACKTOP = STACKTOP + 16 | 0; //@line 6760
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 6760
 $3 = $0; //@line 6761
 $4 = $1; //@line 6762
 $5 = $2; //@line 6763
 $6 = $3; //@line 6764
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 6765
 $8 = $7 + 16 | 0; //@line 6766
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 6767
 $10 = $3; //@line 6768
 $11 = $4; //@line 6769
 $12 = $5; //@line 6770
 FUNCTION_TABLE_viii[(SAFE_FT_MASK($9 | 0, 127 | 0) | 0) & 127]($10, $11, $12); //@line 6771
 STACKTOP = sp; //@line 6772
 return;
}
function _chipmunk_cpBodyGetVelocity($0, $1) {
 $0 = $0 | 0; //@line 5870
 $1 = $1 | 0; //@line 5871
 var $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0, $9 = 0.0, label = 0, sp = 0; //@line 5872
 sp = STACKTOP; //@line 5873
 STACKTOP = STACKTOP + 32 | 0; //@line 5874
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 5874
 $4 = sp; //@line 5875
 $2 = $0; //@line 5876
 $3 = $1; //@line 5877
 $5 = $2; //@line 5878
 _cpBodyGetVelocity($4, $5); //@line 5879
 $6 = +(+SAFE_HEAP_LOAD_D($4 | 0, 8)); //@line 5880
 $7 = $3; //@line 5881
 SAFE_HEAP_STORE_D($7 | 0, +$6, 8);
 $8 = $4 + 8 | 0; //@line 5883
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 5884
 $10 = $3; //@line 5885
 $11 = $10 + 8 | 0; //@line 5886
 SAFE_HEAP_STORE_D($11 | 0, +$9, 8);
 STACKTOP = sp; //@line 5888
 return;
}
function _chipmunk_cpBodyGetPosition($0, $1) {
 $0 = $0 | 0; //@line 5826
 $1 = $1 | 0; //@line 5827
 var $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0, $9 = 0.0, label = 0, sp = 0; //@line 5828
 sp = STACKTOP; //@line 5829
 STACKTOP = STACKTOP + 32 | 0; //@line 5830
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 5830
 $4 = sp; //@line 5831
 $2 = $0; //@line 5832
 $3 = $1; //@line 5833
 $5 = $2; //@line 5834
 _cpBodyGetPosition($4, $5); //@line 5835
 $6 = +(+SAFE_HEAP_LOAD_D($4 | 0, 8)); //@line 5836
 $7 = $3; //@line 5837
 SAFE_HEAP_STORE_D($7 | 0, +$6, 8);
 $8 = $4 + 8 | 0; //@line 5839
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 5840
 $10 = $3; //@line 5841
 $11 = $10 + 8 | 0; //@line 5842
 SAFE_HEAP_STORE_D($11 | 0, +$9, 8);
 STACKTOP = sp; //@line 5844
 return;
}
function _recycleBin($0, $1) {
 $0 = $0 | 0; //@line 2566
 $1 = $1 | 0; //@line 2567
 var $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2568
 sp = STACKTOP; //@line 2569
 STACKTOP = STACKTOP + 16 | 0; //@line 2570
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2570
 $2 = $0; //@line 2571
 $3 = $1; //@line 2572
 $4 = $2; //@line 2573
 $5 = $4 + 20 | 0; //@line 2574
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 2575
 $7 = $3; //@line 2576
 $8 = $7 + 8 | 0; //@line 2577
 SAFE_HEAP_STORE($8 | 0, $6 | 0, 4);
 $9 = $3; //@line 2579
 $10 = $2; //@line 2580
 $11 = $10 + 20 | 0; //@line 2581
 SAFE_HEAP_STORE($11 | 0, $9 | 0, 4);
 $12 = $3; //@line 2583
 SAFE_HEAP_STORE($12 | 0, 0 | 0, 4);
 STACKTOP = sp; //@line 2585
 return;
}
function _cpBBTreeEach($0, $1, $2) {
 $0 = $0 | 0; //@line 3040
 $1 = $1 | 0; //@line 3041
 $2 = $2 | 0; //@line 3042
 var $10 = 0, $11 = 0, $12 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3043
 sp = STACKTOP; //@line 3044
 STACKTOP = STACKTOP + 32 | 0; //@line 3045
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 3045
 $6 = sp; //@line 3046
 $3 = $0; //@line 3047
 $4 = $1; //@line 3048
 $5 = $2; //@line 3049
 $7 = $4; //@line 3050
 SAFE_HEAP_STORE($6 | 0, $7 | 0, 4);
 $8 = $6 + 4 | 0; //@line 3052
 $9 = $5; //@line 3053
 SAFE_HEAP_STORE($8 | 0, $9 | 0, 4);
 $10 = $3; //@line 3055
 $11 = $10 + 20 | 0; //@line 3056
 $12 = SAFE_HEAP_LOAD($11 | 0, 4, 0) | 0 | 0; //@line 3057
 _cpHashSetEach($12, 49, $6); //@line 3058
 STACKTOP = sp; //@line 3059
 return;
}
function _cpShapeSetBody($0, $1) {
 $0 = $0 | 0; //@line 5248
 $1 = $1 | 0; //@line 5249
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 5250
 sp = STACKTOP; //@line 5251
 STACKTOP = STACKTOP + 16 | 0; //@line 5252
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5252
 $vararg_buffer = sp; //@line 5253
 $2 = $0; //@line 5254
 $3 = $1; //@line 5255
 $4 = $2; //@line 5256
 $5 = _cpShapeActive($4) | 0; //@line 5257
 $6 = $5 << 24 >> 24 != 0; //@line 5258
 if ($6) {
  _cpMessage(5472, 5494, 90, 1, 1, 5553, $vararg_buffer); //@line 5260
  _abort(); //@line 5261
 } else {
  $7 = $3; //@line 5264
  $8 = $2; //@line 5265
  $9 = $8 + 8 | 0; //@line 5266
  SAFE_HEAP_STORE($9 | 0, $7 | 0, 4);
  STACKTOP = sp; //@line 5268
  return;
 }
}
function _ShapeVelocityFunc($0, $1) {
 $0 = $0 | 0; //@line 330
 $1 = $1 | 0; //@line 331
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0; //@line 332
 sp = STACKTOP; //@line 333
 STACKTOP = STACKTOP + 16 | 0; //@line 334
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 334
 $2 = $1; //@line 335
 $3 = $2; //@line 336
 $4 = $3 + 8 | 0; //@line 337
 $5 = SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0; //@line 338
 $6 = $5 + 72 | 0; //@line 339
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($6 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($6 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($6 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 341
 return;
}
function _cpShapeSetFilter($0, $1) {
 $0 = $0 | 0; //@line 5465
 $1 = $1 | 0; //@line 5466
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0; //@line 5467
 sp = STACKTOP; //@line 5468
 STACKTOP = STACKTOP + 16 | 0; //@line 5469
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5469
 $2 = $0; //@line 5470
 $3 = $2; //@line 5471
 $4 = $3 + 8 | 0; //@line 5472
 $5 = SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0; //@line 5473
 _cpBodyActivate($5); //@line 5474
 $6 = $2; //@line 5475
 $7 = $6 + 136 | 0; //@line 5476
 SAFE_HEAP_STORE($7 | 0, SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 4 | 0, SAFE_HEAP_LOAD($1 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($7 + 8 | 0, SAFE_HEAP_LOAD($1 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 5478
 return;
}
function _cpCircleShapeGetRadius($0) {
 $0 = $0 | 0; //@line 6319
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0.0, $vararg_buffer = 0, label = 0, sp = 0; //@line 6320
 sp = STACKTOP; //@line 6321
 STACKTOP = STACKTOP + 16 | 0; //@line 6322
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 6322
 $vararg_buffer = sp; //@line 6323
 $1 = $0; //@line 6324
 $2 = $1; //@line 6325
 $3 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 6326
 $4 = ($3 | 0) == (2656 | 0); //@line 6327
 if ($4) {
  $5 = $1; //@line 6329
  $6 = $5 + 192 | 0; //@line 6330
  $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 6331
  STACKTOP = sp; //@line 6332
  return +$7;
 } else {
  _cpMessage(5758, 5494, 367, 1, 1, 5794, $vararg_buffer); //@line 6334
  _abort(); //@line 6335
 }
 return +0.0;
}
function _cpConstraintActivateBodies($0) {
 $0 = $0 | 0; //@line 2054
 var $1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2055
 sp = STACKTOP; //@line 2056
 STACKTOP = STACKTOP + 16 | 0; //@line 2057
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2057
 $1 = $0; //@line 2058
 $4 = $1; //@line 2059
 $5 = $4 + 8 | 0; //@line 2060
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 2061
 $2 = $6; //@line 2062
 $7 = $2; //@line 2063
 _cpBodyActivate($7); //@line 2064
 $8 = $1; //@line 2065
 $9 = $8 + 12 | 0; //@line 2066
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 2067
 $3 = $10; //@line 2068
 $11 = $3; //@line 2069
 _cpBodyActivate($11); //@line 2070
 STACKTOP = sp; //@line 2071
 return;
}
function _cpSpatialIndexDestroy($0) {
 $0 = $0 | 0; //@line 5630
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0; //@line 5631
 sp = STACKTOP; //@line 5632
 STACKTOP = STACKTOP + 16 | 0; //@line 5633
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5633
 $1 = $0; //@line 5634
 $2 = $1; //@line 5635
 $3 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 5636
 $4 = ($3 | 0) != (0 | 0); //@line 5637
 if (!$4) {
  STACKTOP = sp; //@line 5639
  return;
 }
 $5 = $1; //@line 5641
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 5642
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 5643
 $8 = $1; //@line 5644
 FUNCTION_TABLE_vi[(SAFE_FT_MASK($7 | 0, 63 | 0) | 0) & 63]($8); //@line 5645
 STACKTOP = sp; //@line 5646
 return;
}
function _each_helper($0, $1) {
 $0 = $0 | 0; //@line 5472
 $1 = $1 | 0; //@line 5473
 var $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5474
 sp = STACKTOP; //@line 5475
 STACKTOP = STACKTOP + 16 | 0; //@line 5476
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5476
 $2 = $0; //@line 5477
 $3 = $1; //@line 5478
 $4 = $3; //@line 5479
 $5 = SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0; //@line 5480
 $6 = $2; //@line 5481
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 5482
 $8 = $3; //@line 5483
 $9 = $8 + 4 | 0; //@line 5484
 $10 = SAFE_HEAP_LOAD($9 | 0, 4, 0) | 0 | 0; //@line 5485
 FUNCTION_TABLE_vii[(SAFE_FT_MASK($5 | 0, 127 | 0) | 0) & 127]($7, $10); //@line 5486
 STACKTOP = sp; //@line 5487
 return;
}
function _cpArbiterThreadForBody_502($0, $1) {
 $0 = $0 | 0; //@line 3388
 $1 = $1 | 0; //@line 3389
 var $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3390
 sp = STACKTOP; //@line 3391
 STACKTOP = STACKTOP + 16 | 0; //@line 3392
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3392
 $2 = $0; //@line 3393
 $3 = $1; //@line 3394
 $4 = $2; //@line 3395
 $5 = $4 + 44 | 0; //@line 3396
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 3397
 $7 = $3; //@line 3398
 $8 = ($6 | 0) == ($7 | 0); //@line 3399
 $9 = $2; //@line 3400
 $10 = $9 + 52 | 0; //@line 3401
 $11 = $9 + 60 | 0; //@line 3402
 $12 = $8 ? $10 : $11; //@line 3403
 STACKTOP = sp; //@line 3404
 return $12 | 0; //@line 3404
}
function _cpPolyShapeNewRaw($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 4999
 $1 = $1 | 0; //@line 5000
 $2 = $2 | 0; //@line 5001
 $3 = +$3; //@line 5002
 var $10 = 0, $11 = 0, $12 = 0.0, $13 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5003
 sp = STACKTOP; //@line 5004
 STACKTOP = STACKTOP + 32 | 0; //@line 5005
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 5005
 $4 = $0; //@line 5006
 $5 = $1; //@line 5007
 $6 = $2; //@line 5008
 $7 = $3; //@line 5009
 $8 = _cpPolyShapeAlloc() | 0; //@line 5010
 $9 = $4; //@line 5011
 $10 = $5; //@line 5012
 $11 = $6; //@line 5013
 $12 = $7; //@line 5014
 $13 = _cpPolyShapeInitRaw($8, $9, $10, $11, $12) | 0; //@line 5015
 STACKTOP = sp; //@line 5016
 return $13 | 0; //@line 5016
}
function _cpMomentForBox($0, $1, $2) {
 $0 = +$0; //@line 704
 $1 = +$1; //@line 705
 $2 = +$2; //@line 706
 var $10 = 0.0, $11 = 0.0, $12 = 0.0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 708
 STACKTOP = STACKTOP + 32 | 0; //@line 709
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 709
 $3 = $0; //@line 710
 $4 = $1; //@line 711
 $5 = $2; //@line 712
 $6 = $3; //@line 713
 $7 = $4; //@line 714
 $8 = $4; //@line 715
 $9 = $7 * $8; //@line 716
 $10 = $5; //@line 717
 $11 = $5; //@line 718
 $12 = $10 * $11; //@line 719
 $13 = $9 + $12; //@line 720
 $14 = $6 * $13; //@line 721
 $15 = $14 / 12.0; //@line 722
 STACKTOP = sp; //@line 723
 return +$15;
}
function _cpArrayFree($0) {
 $0 = $0 | 0; //@line 2694
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 2695
 sp = STACKTOP; //@line 2696
 STACKTOP = STACKTOP + 16 | 0; //@line 2697
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2697
 $1 = $0; //@line 2698
 $2 = $1; //@line 2699
 $3 = ($2 | 0) != (0 | 0); //@line 2700
 if (!$3) {
  STACKTOP = sp; //@line 2702
  return;
 }
 $4 = $1; //@line 2704
 $5 = $4 + 8 | 0; //@line 2705
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 2706
 _free($6); //@line 2707
 $7 = $1; //@line 2708
 $8 = $7 + 8 | 0; //@line 2709
 SAFE_HEAP_STORE($8 | 0, 0 | 0, 4);
 $9 = $1; //@line 2711
 _free($9); //@line 2712
 STACKTOP = sp; //@line 2713
 return;
}
function _cpSpaceSetDamping($0, $1) {
 $0 = $0 | 0; //@line 854
 $1 = +$1; //@line 855
 var $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 856
 sp = STACKTOP; //@line 857
 STACKTOP = STACKTOP + 16 | 0; //@line 858
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 858
 $vararg_buffer = sp + 8 | 0; //@line 859
 $2 = $0; //@line 860
 $3 = $1; //@line 861
 $4 = $3; //@line 862
 $5 = $4 >= 0.0; //@line 863
 if ($5) {
  $6 = $3; //@line 865
  $7 = $2; //@line 866
  $8 = $7 + 24 | 0; //@line 867
  SAFE_HEAP_STORE_D($8 | 0, +$6, 8);
  STACKTOP = sp; //@line 869
  return;
 } else {
  _cpMessage(6405, 6192, 274, 1, 1, 6420, $vararg_buffer); //@line 871
  _abort(); //@line 872
 }
}
function _cpArbiterThreadForBody($0, $1) {
 $0 = $0 | 0; //@line 808
 $1 = $1 | 0; //@line 809
 var $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 810
 sp = STACKTOP; //@line 811
 STACKTOP = STACKTOP + 16 | 0; //@line 812
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 812
 $2 = $0; //@line 813
 $3 = $1; //@line 814
 $4 = $2; //@line 815
 $5 = $4 + 44 | 0; //@line 816
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 817
 $7 = $3; //@line 818
 $8 = ($6 | 0) == ($7 | 0); //@line 819
 $9 = $2; //@line 820
 $10 = $9 + 52 | 0; //@line 821
 $11 = $9 + 60 | 0; //@line 822
 $12 = $8 ? $10 : $11; //@line 823
 STACKTOP = sp; //@line 824
 return $12 | 0; //@line 824
}
function _NodeRecycle($0, $1) {
 $0 = $0 | 0; //@line 5152
 $1 = $1 | 0; //@line 5153
 var $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5154
 sp = STACKTOP; //@line 5155
 STACKTOP = STACKTOP + 16 | 0; //@line 5156
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5156
 $2 = $0; //@line 5157
 $3 = $1; //@line 5158
 $4 = $2; //@line 5159
 $5 = $4 + 28 | 0; //@line 5160
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 5161
 $7 = $3; //@line 5162
 $8 = $7 + 40 | 0; //@line 5163
 SAFE_HEAP_STORE($8 | 0, $6 | 0, 4);
 $9 = $3; //@line 5165
 $10 = $2; //@line 5166
 $11 = $10 + 28 | 0; //@line 5167
 SAFE_HEAP_STORE($11 | 0, $9 | 0, 4);
 STACKTOP = sp; //@line 5169
 return;
}
function _cpBodyRemoveConstraint($0, $1) {
 $0 = $0 | 0; //@line 7164
 $1 = $1 | 0; //@line 7165
 var $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 7166
 sp = STACKTOP; //@line 7167
 STACKTOP = STACKTOP + 16 | 0; //@line 7168
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7168
 $2 = $0; //@line 7169
 $3 = $1; //@line 7170
 $4 = $2; //@line 7171
 $5 = $4 + 220 | 0; //@line 7172
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 7173
 $7 = $2; //@line 7174
 $8 = $3; //@line 7175
 $9 = _filterConstraints($6, $7, $8) | 0; //@line 7176
 $10 = $2; //@line 7177
 $11 = $10 + 220 | 0; //@line 7178
 SAFE_HEAP_STORE($11 | 0, $9 | 0, 4);
 STACKTOP = sp; //@line 7180
 return;
}
function _GetTree($0) {
 $0 = $0 | 0; //@line 3904
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 3905
 sp = STACKTOP; //@line 3906
 STACKTOP = STACKTOP + 16 | 0; //@line 3907
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3907
 $1 = $0; //@line 3908
 $2 = $1; //@line 3909
 $3 = ($2 | 0) != (0 | 0); //@line 3910
 if ($3) {
  $4 = $1; //@line 3912
  $5 = SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0; //@line 3913
  $6 = _Klass() | 0; //@line 3914
  $7 = ($5 | 0) == ($6 | 0); //@line 3915
  if ($7) {
   $8 = $1; //@line 3917
   $9 = $8; //@line 3918
  } else {
   $9 = 0; //@line 3920
  }
 } else {
  $9 = 0; //@line 3923
 }
 STACKTOP = sp; //@line 3925
 return $9 | 0; //@line 3925
}
function _cpveql_400($0, $1) {
 $0 = $0 | 0; //@line 7658
 $1 = $1 | 0; //@line 7659
 var $10 = 0, $11 = 0, $12 = 0, $2 = 0.0, $3 = 0.0, $4 = 0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0, label = 0, sp = 0; //@line 7660
 sp = STACKTOP; //@line 7661
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 7662
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 7663
 $4 = $2 == $3; //@line 7664
 if ($4) {
  $5 = $0 + 8 | 0; //@line 7666
  $6 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 7667
  $7 = $1 + 8 | 0; //@line 7668
  $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 7669
  $9 = $6 == $8; //@line 7670
  $11 = $9; //@line 7671
 } else {
  $11 = 0; //@line 7673
 }
 $10 = $11 & 1; //@line 7675
 $12 = $10 & 255; //@line 7676
 return $12 | 0; //@line 7677
}
function _cpveql($0, $1) {
 $0 = $0 | 0; //@line 1677
 $1 = $1 | 0; //@line 1678
 var $10 = 0, $11 = 0, $12 = 0, $2 = 0.0, $3 = 0.0, $4 = 0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0, label = 0, sp = 0; //@line 1679
 sp = STACKTOP; //@line 1680
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 1681
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 1682
 $4 = $2 == $3; //@line 1683
 if ($4) {
  $5 = $0 + 8 | 0; //@line 1685
  $6 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 1686
  $7 = $1 + 8 | 0; //@line 1687
  $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 1688
  $9 = $6 == $8; //@line 1689
  $11 = $9; //@line 1690
 } else {
  $11 = 0; //@line 1692
 }
 $10 = $11 & 1; //@line 1694
 $12 = $10 & 255; //@line 1695
 return $12 | 0; //@line 1696
}
function _GetMasterTree($0) {
 $0 = $0 | 0; //@line 4055
 var $1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 4056
 sp = STACKTOP; //@line 4057
 STACKTOP = STACKTOP + 16 | 0; //@line 4058
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 4058
 $1 = $0; //@line 4059
 $3 = $1; //@line 4060
 $4 = $3 + 12 | 0; //@line 4061
 $5 = SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0; //@line 4062
 $6 = _GetTree($5) | 0; //@line 4063
 $2 = $6; //@line 4064
 $7 = $2; //@line 4065
 $8 = ($7 | 0) != (0 | 0); //@line 4066
 $9 = $2; //@line 4067
 $10 = $1; //@line 4068
 $11 = $8 ? $9 : $10; //@line 4069
 STACKTOP = sp; //@line 4070
 return $11 | 0; //@line 4070
}
function _cpSpacePopContacts($0, $1) {
 $0 = $0 | 0; //@line 4801
 $1 = $1 | 0; //@line 4802
 var $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 4803
 sp = STACKTOP; //@line 4804
 STACKTOP = STACKTOP + 16 | 0; //@line 4805
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 4805
 $2 = $0; //@line 4806
 $3 = $1; //@line 4807
 $4 = $3; //@line 4808
 $5 = $2; //@line 4809
 $6 = $5 + 124 | 0; //@line 4810
 $7 = SAFE_HEAP_LOAD($6 | 0, 4, 0) | 0 | 0; //@line 4811
 $8 = $7 + 8 | 0; //@line 4812
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 4813
 $10 = $9 - $4 | 0; //@line 4814
 SAFE_HEAP_STORE($8 | 0, $10 | 0, 4);
 STACKTOP = sp; //@line 4816
 return;
}
function _cpBodyGetVelocity($0, $1) {
 $0 = $0 | 0; //@line 7261
 $1 = $1 | 0; //@line 7262
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0; //@line 7263
 sp = STACKTOP; //@line 7264
 STACKTOP = STACKTOP + 16 | 0; //@line 7265
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7265
 $2 = $1; //@line 7266
 $3 = $2; //@line 7267
 $4 = $3 + 72 | 0; //@line 7268
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 7270
 return;
}
function _cpSpaceSetIterations($0, $1) {
 $0 = $0 | 0; //@line 772
 $1 = $1 | 0; //@line 773
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 774
 sp = STACKTOP; //@line 775
 STACKTOP = STACKTOP + 16 | 0; //@line 776
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 776
 $vararg_buffer = sp; //@line 777
 $2 = $0; //@line 778
 $3 = $1; //@line 779
 $4 = $3; //@line 780
 $5 = ($4 | 0) > 0; //@line 781
 if ($5) {
  $6 = $3; //@line 783
  $7 = $2; //@line 784
  SAFE_HEAP_STORE($7 | 0, $6 | 0, 4);
  STACKTOP = sp; //@line 786
  return;
 } else {
  _cpMessage(6348, 6192, 243, 1, 1, 6363, $vararg_buffer); //@line 788
  _abort(); //@line 789
 }
}
function _cpSpaceGetGravity($0, $1) {
 $0 = $0 | 0; //@line 794
 $1 = $1 | 0; //@line 795
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0; //@line 796
 sp = STACKTOP; //@line 797
 STACKTOP = STACKTOP + 16 | 0; //@line 798
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 798
 $2 = $1; //@line 799
 $3 = $2; //@line 800
 $4 = $3 + 8 | 0; //@line 801
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 12 | 0, SAFE_HEAP_LOAD($4 + 12 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 803
 return;
}
function ___muldi3($a$0, $a$1, $b$0, $b$1) {
 $a$0 = $a$0 | 0; //@line 14158
 $a$1 = $a$1 | 0; //@line 14159
 $b$0 = $b$0 | 0; //@line 14160
 $b$1 = $b$1 | 0; //@line 14161
 var $x_sroa_0_0_extract_trunc = 0, $y_sroa_0_0_extract_trunc = 0, $1$0 = 0, $1$1 = 0, $2 = 0; //@line 14162
 $x_sroa_0_0_extract_trunc = $a$0; //@line 14163
 $y_sroa_0_0_extract_trunc = $b$0; //@line 14164
 $1$0 = ___muldsi3($x_sroa_0_0_extract_trunc, $y_sroa_0_0_extract_trunc) | 0; //@line 14165
 $1$1 = getTempRet0() | 0; //@line 14166
 $2 = Math_imul($a$1, $y_sroa_0_0_extract_trunc) | 0; //@line 14167
 return (setTempRet0(((Math_imul($b$1, $x_sroa_0_0_extract_trunc) | 0) + $2 | 0) + $1$1 | $1$1 & 0 | 0), 0 | $1$0 & -1) | 0; //@line 14168
}
function _cpPolyShapeDestroy($0) {
 $0 = $0 | 0; //@line 4201
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0; //@line 4202
 sp = STACKTOP; //@line 4203
 STACKTOP = STACKTOP + 16 | 0; //@line 4204
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 4204
 $1 = $0; //@line 4205
 $2 = $1; //@line 4206
 $3 = $2 + 168 | 0; //@line 4207
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 4208
 $5 = ($4 | 0) > 6; //@line 4209
 if (!$5) {
  STACKTOP = sp; //@line 4211
  return;
 }
 $6 = $1; //@line 4213
 $7 = $6 + 172 | 0; //@line 4214
 $8 = SAFE_HEAP_LOAD($7 | 0, 4, 0) | 0 | 0; //@line 4215
 _free($8); //@line 4216
 STACKTOP = sp; //@line 4217
 return;
}
function _cpArbiterUnthread($0) {
 $0 = $0 | 0; //@line 726
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 727
 sp = STACKTOP; //@line 728
 STACKTOP = STACKTOP + 16 | 0; //@line 729
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 729
 $1 = $0; //@line 730
 $2 = $1; //@line 731
 $3 = $1; //@line 732
 $4 = $3 + 44 | 0; //@line 733
 $5 = SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0; //@line 734
 _unthreadHelper($2, $5); //@line 735
 $6 = $1; //@line 736
 $7 = $1; //@line 737
 $8 = $7 + 48 | 0; //@line 738
 $9 = SAFE_HEAP_LOAD($8 | 0, 4, 0) | 0 | 0; //@line 739
 _unthreadHelper($6, $9); //@line 740
 STACKTOP = sp; //@line 741
 return;
}
function _cpvmult_404($0, $1, $2) {
 $0 = $0 | 0; //@line 7770
 $1 = $1 | 0; //@line 7771
 $2 = +$2; //@line 7772
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 7774
 STACKTOP = STACKTOP + 16 | 0; //@line 7775
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7775
 $3 = $2; //@line 7776
 $4 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 7777
 $5 = $3; //@line 7778
 $6 = $4 * $5; //@line 7779
 $7 = $1 + 8 | 0; //@line 7780
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 7781
 $9 = $3; //@line 7782
 $10 = $8 * $9; //@line 7783
 _cpv_410($0, $6, $10); //@line 7784
 STACKTOP = sp; //@line 7785
 return;
}
function _cpvmult_357($0, $1, $2) {
 $0 = $0 | 0; //@line 5607
 $1 = $1 | 0; //@line 5608
 $2 = +$2; //@line 5609
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 5611
 STACKTOP = STACKTOP + 16 | 0; //@line 5612
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5612
 $3 = $2; //@line 5613
 $4 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 5614
 $5 = $3; //@line 5615
 $6 = $4 * $5; //@line 5616
 $7 = $1 + 8 | 0; //@line 5617
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 5618
 $9 = $3; //@line 5619
 $10 = $8 * $9; //@line 5620
 _cpv_358($0, $6, $10); //@line 5621
 STACKTOP = sp; //@line 5622
 return;
}
function _cpvmult_270($0, $1, $2) {
 $0 = $0 | 0; //@line 4039
 $1 = $1 | 0; //@line 4040
 $2 = +$2; //@line 4041
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 4043
 STACKTOP = STACKTOP + 16 | 0; //@line 4044
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 4044
 $3 = $2; //@line 4045
 $4 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 4046
 $5 = $3; //@line 4047
 $6 = $4 * $5; //@line 4048
 $7 = $1 + 8 | 0; //@line 4049
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 4050
 $9 = $3; //@line 4051
 $10 = $8 * $9; //@line 4052
 _cpv_271($0, $6, $10); //@line 4053
 STACKTOP = sp; //@line 4054
 return;
}
function _cpvmult_249($0, $1, $2) {
 $0 = $0 | 0; //@line 3445
 $1 = $1 | 0; //@line 3446
 $2 = +$2; //@line 3447
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3449
 STACKTOP = STACKTOP + 16 | 0; //@line 3450
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3450
 $3 = $2; //@line 3451
 $4 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3452
 $5 = $3; //@line 3453
 $6 = $4 * $5; //@line 3454
 $7 = $1 + 8 | 0; //@line 3455
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 3456
 $9 = $3; //@line 3457
 $10 = $8 * $9; //@line 3458
 _cpv_251($0, $6, $10); //@line 3459
 STACKTOP = sp; //@line 3460
 return;
}
function _cpvmult_44($0, $1, $2) {
 $0 = $0 | 0; //@line 6354
 $1 = $1 | 0; //@line 6355
 $2 = +$2; //@line 6356
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 6358
 STACKTOP = STACKTOP + 16 | 0; //@line 6359
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 6359
 $3 = $2; //@line 6360
 $4 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 6361
 $5 = $3; //@line 6362
 $6 = $4 * $5; //@line 6363
 $7 = $1 + 8 | 0; //@line 6364
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 6365
 $9 = $3; //@line 6366
 $10 = $8 * $9; //@line 6367
 _cpv_33($0, $6, $10); //@line 6368
 STACKTOP = sp; //@line 6369
 return;
}
function _cpvmult_28($0, $1, $2) {
 $0 = $0 | 0; //@line 5296
 $1 = $1 | 0; //@line 5297
 $2 = +$2; //@line 5298
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 5300
 STACKTOP = STACKTOP + 16 | 0; //@line 5301
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5301
 $3 = $2; //@line 5302
 $4 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 5303
 $5 = $3; //@line 5304
 $6 = $4 * $5; //@line 5305
 $7 = $1 + 8 | 0; //@line 5306
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 5307
 $9 = $3; //@line 5308
 $10 = $8 * $9; //@line 5309
 _cpv_21($0, $6, $10); //@line 5310
 STACKTOP = sp; //@line 5311
 return;
}
function _cpAreaForCircle($0, $1) {
 $0 = +$0; //@line 212
 $1 = +$1; //@line 213
 var $10 = 0.0, $11 = 0.0, $12 = 0.0, $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 215
 STACKTOP = STACKTOP + 16 | 0; //@line 216
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 216
 $2 = $0; //@line 217
 $3 = $1; //@line 218
 $4 = $2; //@line 219
 $5 = $2; //@line 220
 $6 = $4 * $5; //@line 221
 $7 = $3; //@line 222
 $8 = $3; //@line 223
 $9 = $7 * $8; //@line 224
 $10 = $6 - $9; //@line 225
 $11 = +_cpfabs($10); //@line 226
 $12 = 3.141592653589793 * $11; //@line 227
 STACKTOP = sp; //@line 228
 return +$12;
}
function _cpSpaceContainsConstraint($0, $1) {
 $0 = $0 | 0; //@line 1886
 $1 = $1 | 0; //@line 1887
 var $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1888
 sp = STACKTOP; //@line 1889
 STACKTOP = STACKTOP + 16 | 0; //@line 1890
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1890
 $2 = $0; //@line 1891
 $3 = $1; //@line 1892
 $4 = $3; //@line 1893
 $5 = $4 + 4 | 0; //@line 1894
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 1895
 $7 = $2; //@line 1896
 $8 = ($6 | 0) == ($7 | 0); //@line 1897
 $9 = $8 & 1; //@line 1898
 $10 = $9 & 255; //@line 1899
 STACKTOP = sp; //@line 1900
 return $10 | 0; //@line 1900
}
function _cpShapeSetCollisionType($0, $1) {
 $0 = $0 | 0; //@line 5435
 $1 = $1 | 0; //@line 5436
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5437
 sp = STACKTOP; //@line 5438
 STACKTOP = STACKTOP + 16 | 0; //@line 5439
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5439
 $2 = $0; //@line 5440
 $3 = $1; //@line 5441
 $4 = $2; //@line 5442
 $5 = $4 + 8 | 0; //@line 5443
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 5444
 _cpBodyActivate($6); //@line 5445
 $7 = $3; //@line 5446
 $8 = $2; //@line 5447
 $9 = $8 + 132 | 0; //@line 5448
 SAFE_HEAP_STORE($9 | 0, $7 | 0, 4);
 STACKTOP = sp; //@line 5450
 return;
}
function _cpSpaceContainsBody($0, $1) {
 $0 = $0 | 0; //@line 1811
 $1 = $1 | 0; //@line 1812
 var $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1813
 sp = STACKTOP; //@line 1814
 STACKTOP = STACKTOP + 16 | 0; //@line 1815
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1815
 $2 = $0; //@line 1816
 $3 = $1; //@line 1817
 $4 = $3; //@line 1818
 $5 = $4 + 208 | 0; //@line 1819
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 1820
 $7 = $2; //@line 1821
 $8 = ($6 | 0) == ($7 | 0); //@line 1822
 $9 = $8 & 1; //@line 1823
 $10 = $9 & 255; //@line 1824
 STACKTOP = sp; //@line 1825
 return $10 | 0; //@line 1825
}
function _cpSpaceContainsShape($0, $1) {
 $0 = $0 | 0; //@line 1721
 $1 = $1 | 0; //@line 1722
 var $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1723
 sp = STACKTOP; //@line 1724
 STACKTOP = STACKTOP + 16 | 0; //@line 1725
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1725
 $2 = $0; //@line 1726
 $3 = $1; //@line 1727
 $4 = $3; //@line 1728
 $5 = $4 + 4 | 0; //@line 1729
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 1730
 $7 = $2; //@line 1731
 $8 = ($6 | 0) == ($7 | 0); //@line 1732
 $9 = $8 & 1; //@line 1733
 $10 = $9 & 255; //@line 1734
 STACKTOP = sp; //@line 1735
 return $10 | 0; //@line 1735
}
function _cpShapeSetSensor($0, $1) {
 $0 = $0 | 0; //@line 5330
 $1 = $1 | 0; //@line 5331
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5332
 sp = STACKTOP; //@line 5333
 STACKTOP = STACKTOP + 16 | 0; //@line 5334
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5334
 $2 = $0; //@line 5335
 $3 = $1; //@line 5336
 $4 = $2; //@line 5337
 $5 = $4 + 8 | 0; //@line 5338
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 5339
 _cpBodyActivate($6); //@line 5340
 $7 = $3; //@line 5341
 $8 = $2; //@line 5342
 $9 = $8 + 88 | 0; //@line 5343
 SAFE_HEAP_STORE($9 >> 0 | 0, $7 | 0, 1);
 STACKTOP = sp; //@line 5345
 return;
}
function _cpBodyGetRotation($0, $1) {
 $0 = $0 | 0; //@line 7047
 $1 = $1 | 0; //@line 7048
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0.0, $6 = 0, $7 = 0, $8 = 0, $9 = 0.0, label = 0, sp = 0; //@line 7049
 sp = STACKTOP; //@line 7050
 STACKTOP = STACKTOP + 16 | 0; //@line 7051
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7051
 $2 = $1; //@line 7052
 $3 = $2; //@line 7053
 $4 = $3 + 128 | 0; //@line 7054
 $5 = +(+SAFE_HEAP_LOAD_D($4 | 0, 8)); //@line 7055
 $6 = $2; //@line 7056
 $7 = $6 + 128 | 0; //@line 7057
 $8 = $7 + 8 | 0; //@line 7058
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 7059
 _cpv_33($0, $5, $9); //@line 7060
 STACKTOP = sp; //@line 7061
 return;
}
function _NodeSetB($0, $1) {
 $0 = $0 | 0; //@line 4984
 $1 = $1 | 0; //@line 4985
 var $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 4986
 sp = STACKTOP; //@line 4987
 STACKTOP = STACKTOP + 16 | 0; //@line 4988
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 4988
 $2 = $0; //@line 4989
 $3 = $1; //@line 4990
 $4 = $3; //@line 4991
 $5 = $2; //@line 4992
 $6 = $5 + 44 | 0; //@line 4993
 $7 = $6 + 4 | 0; //@line 4994
 SAFE_HEAP_STORE($7 | 0, $4 | 0, 4);
 $8 = $2; //@line 4996
 $9 = $3; //@line 4997
 $10 = $9 + 40 | 0; //@line 4998
 SAFE_HEAP_STORE($10 | 0, $8 | 0, 4);
 STACKTOP = sp; //@line 5000
 return;
}
function _cpvmult_64($0, $1, $2) {
 $0 = $0 | 0; //@line 547
 $1 = $1 | 0; //@line 548
 $2 = +$2; //@line 549
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 551
 STACKTOP = STACKTOP + 16 | 0; //@line 552
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 552
 $3 = $2; //@line 553
 $4 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 554
 $5 = $3; //@line 555
 $6 = $4 * $5; //@line 556
 $7 = $1 + 8 | 0; //@line 557
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 558
 $9 = $3; //@line 559
 $10 = $8 * $9; //@line 560
 _cpv_72($0, $6, $10); //@line 561
 STACKTOP = sp; //@line 562
 return;
}
function ___stdio_close($0) {
 $0 = $0 | 0; //@line 10538
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 10539
 sp = STACKTOP; //@line 10540
 STACKTOP = STACKTOP + 16 | 0; //@line 10541
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 10541
 $vararg_buffer = sp; //@line 10542
 $1 = $0 + 60 | 0; //@line 10543
 $2 = SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0; //@line 10544
 $3 = _dummy($2) | 0; //@line 10545
 SAFE_HEAP_STORE($vararg_buffer | 0, $3 | 0, 4);
 $4 = ___syscall6(6, $vararg_buffer | 0) | 0; //@line 10547
 $5 = ___syscall_ret($4) | 0; //@line 10548
 STACKTOP = sp; //@line 10549
 return $5 | 0; //@line 10549
}
function _cpvmult_1($0, $1, $2) {
 $0 = $0 | 0; //@line 861
 $1 = $1 | 0; //@line 862
 $2 = +$2; //@line 863
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 865
 STACKTOP = STACKTOP + 16 | 0; //@line 866
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 866
 $3 = $2; //@line 867
 $4 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 868
 $5 = $3; //@line 869
 $6 = $4 * $5; //@line 870
 $7 = $1 + 8 | 0; //@line 871
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 872
 $9 = $3; //@line 873
 $10 = $8 * $9; //@line 874
 _cpv_2($0, $6, $10); //@line 875
 STACKTOP = sp; //@line 876
 return;
}
function _cpvmult($0, $1, $2) {
 $0 = $0 | 0; //@line 379
 $1 = $1 | 0; //@line 380
 $2 = +$2; //@line 381
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 383
 STACKTOP = STACKTOP + 16 | 0; //@line 384
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 384
 $3 = $2; //@line 385
 $4 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 386
 $5 = $3; //@line 387
 $6 = $4 * $5; //@line 388
 $7 = $1 + 8 | 0; //@line 389
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 390
 $9 = $3; //@line 391
 $10 = $8 * $9; //@line 392
 _cpv($0, $6, $10); //@line 393
 STACKTOP = sp; //@line 394
 return;
}
function _ComponentRoot($0) {
 $0 = $0 | 0; //@line 2455
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0; //@line 2456
 sp = STACKTOP; //@line 2457
 STACKTOP = STACKTOP + 16 | 0; //@line 2458
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2458
 $1 = $0; //@line 2459
 $2 = $1; //@line 2460
 $3 = ($2 | 0) != (0 | 0); //@line 2461
 if (!$3) {
  $7 = 0; //@line 2463
  STACKTOP = sp; //@line 2464
  return $7 | 0; //@line 2464
 }
 $4 = $1; //@line 2466
 $5 = $4 + 224 | 0; //@line 2467
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 2468
 $7 = $6; //@line 2469
 STACKTOP = sp; //@line 2470
 return $7 | 0; //@line 2470
}
function _DefaultPostSolve($0, $1, $2) {
 $0 = $0 | 0; //@line 1099
 $1 = $1 | 0; //@line 1100
 $2 = $2 | 0; //@line 1101
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1102
 sp = STACKTOP; //@line 1103
 STACKTOP = STACKTOP + 16 | 0; //@line 1104
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1104
 $3 = $0; //@line 1105
 $4 = $1; //@line 1106
 $5 = $2; //@line 1107
 $6 = $3; //@line 1108
 $7 = $4; //@line 1109
 _cpArbiterCallWildcardPostSolveA($6, $7); //@line 1110
 $8 = $3; //@line 1111
 $9 = $4; //@line 1112
 _cpArbiterCallWildcardPostSolveB($8, $9); //@line 1113
 STACKTOP = sp; //@line 1114
 return;
}
function SAFE_HEAP_LOAD(dest, bytes, unsigned) {
 dest = dest | 0; //@line 69
 bytes = bytes | 0; //@line 70
 unsigned = unsigned | 0; //@line 71
 if ((dest | 0) <= 0) segfault(); //@line 72
 if ((dest + bytes | 0) > (HEAP32[DYNAMICTOP_PTR >> 2] | 0)) segfault(); //@line 73
 if ((bytes | 0) == 4) {
  if (dest & 3) alignfault(); //@line 75
  return HEAP32[dest >> 2] | 0; //@line 76
 } else if ((bytes | 0) == 1) {
  if (unsigned) {
   return HEAPU8[dest >> 0] | 0; //@line 79
  } else {
   return HEAP8[dest >> 0] | 0; //@line 81
  }
 }
 if (dest & 1) alignfault(); //@line 84
 if (unsigned) return HEAPU16[dest >> 1] | 0; //@line 85
 return HEAP16[dest >> 1] | 0; //@line 86
}
function _DefaultSeparate($0, $1, $2) {
 $0 = $0 | 0; //@line 1117
 $1 = $1 | 0; //@line 1118
 $2 = $2 | 0; //@line 1119
 var $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 1120
 sp = STACKTOP; //@line 1121
 STACKTOP = STACKTOP + 16 | 0; //@line 1122
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1122
 $3 = $0; //@line 1123
 $4 = $1; //@line 1124
 $5 = $2; //@line 1125
 $6 = $3; //@line 1126
 $7 = $4; //@line 1127
 _cpArbiterCallWildcardSeparateA($6, $7); //@line 1128
 $8 = $3; //@line 1129
 $9 = $4; //@line 1130
 _cpArbiterCallWildcardSeparateB($8, $9); //@line 1131
 STACKTOP = sp; //@line 1132
 return;
}
function _cpSpatialIndexCount($0) {
 $0 = $0 | 0; //@line 5738
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0; //@line 5739
 sp = STACKTOP; //@line 5740
 STACKTOP = STACKTOP + 16 | 0; //@line 5741
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5741
 $1 = $0; //@line 5742
 $2 = $1; //@line 5743
 $3 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 5744
 $4 = $3 + 4 | 0; //@line 5745
 $5 = SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0; //@line 5746
 $6 = $1; //@line 5747
 $7 = FUNCTION_TABLE_ii[(SAFE_FT_MASK($5 | 0, 63 | 0) | 0) & 63]($6) | 0; //@line 5748
 STACKTOP = sp; //@line 5749
 return $7 | 0; //@line 5749
}
function _cpSpaceAllocContactBuffer($0) {
 $0 = $0 | 0; //@line 4354
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0; //@line 4355
 sp = STACKTOP; //@line 4356
 STACKTOP = STACKTOP + 16 | 0; //@line 4357
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 4357
 $1 = $0; //@line 4358
 $3 = _calloc(1, 32752) | 0; //@line 4359
 $2 = $3; //@line 4360
 $4 = $1; //@line 4361
 $5 = $4 + 136 | 0; //@line 4362
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 4363
 $7 = $2; //@line 4364
 _cpArrayPush($6, $7); //@line 4365
 $8 = $2; //@line 4366
 STACKTOP = sp; //@line 4367
 return $8 | 0; //@line 4367
}
function _cpBodySetAngularVelocity($0, $1) {
 $0 = $0 | 0; //@line 7311
 $1 = +$1; //@line 7312
 var $2 = 0, $3 = 0.0, $4 = 0, $5 = 0.0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0; //@line 7313
 sp = STACKTOP; //@line 7314
 STACKTOP = STACKTOP + 16 | 0; //@line 7315
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7315
 $2 = $0; //@line 7316
 $3 = $1; //@line 7317
 $4 = $2; //@line 7318
 _cpBodyActivate($4); //@line 7319
 $5 = $3; //@line 7320
 $6 = $2; //@line 7321
 $7 = $6 + 112 | 0; //@line 7322
 SAFE_HEAP_STORE_D($7 | 0, +$5, 8);
 $8 = $2; //@line 7324
 _cpBodySanityCheck($8); //@line 7325
 STACKTOP = sp; //@line 7326
 return;
}
function _cpShapeGetFilter($0, $1) {
 $0 = $0 | 0; //@line 5453
 $1 = $1 | 0; //@line 5454
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0; //@line 5455
 sp = STACKTOP; //@line 5456
 STACKTOP = STACKTOP + 16 | 0; //@line 5457
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5457
 $2 = $1; //@line 5458
 $3 = $2; //@line 5459
 $4 = $3 + 136 | 0; //@line 5460
 SAFE_HEAP_STORE($0 | 0, SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 4 | 0, SAFE_HEAP_LOAD($4 + 4 | 0, 4, 0) | 0 | 0 | 0, 4);
 SAFE_HEAP_STORE($0 + 8 | 0, SAFE_HEAP_LOAD($4 + 8 | 0, 4, 0) | 0 | 0 | 0, 4);
 STACKTOP = sp; //@line 5462
 return;
}
function _NodeSetA($0, $1) {
 $0 = $0 | 0; //@line 5003
 $1 = $1 | 0; //@line 5004
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, label = 0, sp = 0; //@line 5005
 sp = STACKTOP; //@line 5006
 STACKTOP = STACKTOP + 16 | 0; //@line 5007
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5007
 $2 = $0; //@line 5008
 $3 = $1; //@line 5009
 $4 = $3; //@line 5010
 $5 = $2; //@line 5011
 $6 = $5 + 44 | 0; //@line 5012
 SAFE_HEAP_STORE($6 | 0, $4 | 0, 4);
 $7 = $2; //@line 5014
 $8 = $3; //@line 5015
 $9 = $8 + 40 | 0; //@line 5016
 SAFE_HEAP_STORE($9 | 0, $7 | 0, 4);
 STACKTOP = sp; //@line 5018
 return;
}
function ___lctrans_impl($0, $1) {
 $0 = $0 | 0; //@line 10950
 $1 = $1 | 0; //@line 10951
 var $$0 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0; //@line 10952
 sp = STACKTOP; //@line 10953
 $2 = ($1 | 0) == (0 | 0); //@line 10954
 if ($2) {
  $$0 = 0; //@line 10956
 } else {
  $3 = SAFE_HEAP_LOAD($1 | 0, 4, 0) | 0 | 0; //@line 10958
  $4 = $1 + 4 | 0; //@line 10959
  $5 = SAFE_HEAP_LOAD($4 | 0, 4, 0) | 0 | 0; //@line 10960
  $6 = ___mo_lookup($3, $5, $0) | 0; //@line 10961
  $$0 = $6; //@line 10962
 }
 $7 = ($$0 | 0) == (0 | 0); //@line 10964
 $8 = $7 ? $0 : $$0; //@line 10965
 return $8 | 0; //@line 10966
}
function _setIsFull($0) {
 $0 = $0 | 0; //@line 2471
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0; //@line 2472
 sp = STACKTOP; //@line 2473
 STACKTOP = STACKTOP + 16 | 0; //@line 2474
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2474
 $1 = $0; //@line 2475
 $2 = $1; //@line 2476
 $3 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 2477
 $4 = $1; //@line 2478
 $5 = $4 + 4 | 0; //@line 2479
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 2480
 $7 = $3 >>> 0 >= $6 >>> 0; //@line 2481
 $8 = $7 & 1; //@line 2482
 STACKTOP = sp; //@line 2483
 return $8 | 0; //@line 2483
}
function runPostSets() {}
function ___muldsi3($a, $b) {
 $a = $a | 0; //@line 14145
 $b = $b | 0; //@line 14146
 var $1 = 0, $2 = 0, $3 = 0, $6 = 0, $8 = 0, $11 = 0, $12 = 0; //@line 14147
 $1 = $a & 65535; //@line 14148
 $2 = $b & 65535; //@line 14149
 $3 = Math_imul($2, $1) | 0; //@line 14150
 $6 = $a >>> 16; //@line 14151
 $8 = ($3 >>> 16) + (Math_imul($2, $6) | 0) | 0; //@line 14152
 $11 = $b >>> 16; //@line 14153
 $12 = Math_imul($11, $1) | 0; //@line 14154
 return (setTempRet0((($8 >>> 16) + (Math_imul($11, $6) | 0) | 0) + ((($8 & 65535) + $12 | 0) >>> 16) | 0 | 0), 0 | ($8 + $12 << 16 | $3 & 65535)) | 0; //@line 14155
}
function _cpfclamp_403($0, $1, $2) {
 $0 = +$0; //@line 7753
 $1 = +$1; //@line 7754
 $2 = +$2; //@line 7755
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 7757
 STACKTOP = STACKTOP + 32 | 0; //@line 7758
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 7758
 $3 = $0; //@line 7759
 $4 = $1; //@line 7760
 $5 = $2; //@line 7761
 $6 = $3; //@line 7762
 $7 = $4; //@line 7763
 $8 = +_cpfmax_411($6, $7); //@line 7764
 $9 = $5; //@line 7765
 $10 = +_cpfmin_412($8, $9); //@line 7766
 STACKTOP = sp; //@line 7767
 return +$10;
}
function _cpfclamp_84($0, $1, $2) {
 $0 = +$0; //@line 1699
 $1 = +$1; //@line 1700
 $2 = +$2; //@line 1701
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 1703
 STACKTOP = STACKTOP + 32 | 0; //@line 1704
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 1704
 $3 = $0; //@line 1705
 $4 = $1; //@line 1706
 $5 = $2; //@line 1707
 $6 = $3; //@line 1708
 $7 = $4; //@line 1709
 $8 = +_cpfmax_74($6, $7); //@line 1710
 $9 = $5; //@line 1711
 $10 = +_cpfmin_73($8, $9); //@line 1712
 STACKTOP = sp; //@line 1713
 return +$10;
}
function _cpfclamp($0, $1, $2) {
 $0 = +$0; //@line 2578
 $1 = +$1; //@line 2579
 $2 = +$2; //@line 2580
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 2582
 STACKTOP = STACKTOP + 32 | 0; //@line 2583
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(32 | 0); //@line 2583
 $3 = $0; //@line 2584
 $4 = $1; //@line 2585
 $5 = $2; //@line 2586
 $6 = $3; //@line 2587
 $7 = $4; //@line 2588
 $8 = +_cpfmax($6, $7); //@line 2589
 $9 = $5; //@line 2590
 $10 = +_cpfmin($8, $9); //@line 2591
 STACKTOP = sp; //@line 2592
 return +$10;
}
function _SetAngle($0, $1) {
 $0 = $0 | 0; //@line 5915
 $1 = +$1; //@line 5916
 var $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0, $7 = 0, $8 = 0.0, label = 0, sp = 0; //@line 5917
 sp = STACKTOP; //@line 5918
 STACKTOP = STACKTOP + 16 | 0; //@line 5919
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5919
 $2 = $0; //@line 5920
 $3 = $1; //@line 5921
 $4 = $3; //@line 5922
 $5 = $2; //@line 5923
 $6 = $5 + 104 | 0; //@line 5924
 SAFE_HEAP_STORE_D($6 | 0, +$4, 8);
 $7 = $2; //@line 5926
 _cpBodySanityCheck($7); //@line 5927
 $8 = $3; //@line 5928
 STACKTOP = sp; //@line 5929
 return +$8;
}
function _cpvsub_414($0, $1, $2) {
 $0 = $0 | 0; //@line 7968
 $1 = $1 | 0; //@line 7969
 $2 = $2 | 0; //@line 7970
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 7972
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 7973
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 7974
 $5 = $3 - $4; //@line 7975
 $6 = $1 + 8 | 0; //@line 7976
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 7977
 $8 = $2 + 8 | 0; //@line 7978
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 7979
 $10 = $7 - $9; //@line 7980
 _cpv_410($0, $5, $10); //@line 7981
 return;
}
function _cpvsub_354($0, $1, $2) {
 $0 = $0 | 0; //@line 5561
 $1 = $1 | 0; //@line 5562
 $2 = $2 | 0; //@line 5563
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 5565
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 5566
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 5567
 $5 = $3 - $4; //@line 5568
 $6 = $1 + 8 | 0; //@line 5569
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 5570
 $8 = $2 + 8 | 0; //@line 5571
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 5572
 $10 = $7 - $9; //@line 5573
 _cpv_358($0, $5, $10); //@line 5574
 return;
}
function _cpvsub_266($0, $1, $2) {
 $0 = $0 | 0; //@line 3981
 $1 = $1 | 0; //@line 3982
 $2 = $2 | 0; //@line 3983
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3985
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3986
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 3987
 $5 = $3 - $4; //@line 3988
 $6 = $1 + 8 | 0; //@line 3989
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 3990
 $8 = $2 + 8 | 0; //@line 3991
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 3992
 $10 = $7 - $9; //@line 3993
 _cpv_271($0, $5, $10); //@line 3994
 return;
}
function _cpvsub_242($0, $1, $2) {
 $0 = $0 | 0; //@line 3265
 $1 = $1 | 0; //@line 3266
 $2 = $2 | 0; //@line 3267
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3269
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3270
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 3271
 $5 = $3 - $4; //@line 3272
 $6 = $1 + 8 | 0; //@line 3273
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 3274
 $8 = $2 + 8 | 0; //@line 3275
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 3276
 $10 = $7 - $9; //@line 3277
 _cpv_251($0, $5, $10); //@line 3278
 return;
}
function _cpvadd_408($0, $1, $2) {
 $0 = $0 | 0; //@line 7873
 $1 = $1 | 0; //@line 7874
 $2 = $2 | 0; //@line 7875
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 7877
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 7878
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 7879
 $5 = $3 + $4; //@line 7880
 $6 = $1 + 8 | 0; //@line 7881
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 7882
 $8 = $2 + 8 | 0; //@line 7883
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 7884
 $10 = $7 + $9; //@line 7885
 _cpv_410($0, $5, $10); //@line 7886
 return;
}
function _cpvadd_363($0, $1, $2) {
 $0 = $0 | 0; //@line 6158
 $1 = $1 | 0; //@line 6159
 $2 = $2 | 0; //@line 6160
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 6162
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 6163
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 6164
 $5 = $3 + $4; //@line 6165
 $6 = $1 + 8 | 0; //@line 6166
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 6167
 $8 = $2 + 8 | 0; //@line 6168
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 6169
 $10 = $7 + $9; //@line 6170
 _cpv_358($0, $5, $10); //@line 6171
 return;
}
function _cpvadd_276($0, $1, $2) {
 $0 = $0 | 0; //@line 4796
 $1 = $1 | 0; //@line 4797
 $2 = $2 | 0; //@line 4798
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 4800
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 4801
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 4802
 $5 = $3 + $4; //@line 4803
 $6 = $1 + 8 | 0; //@line 4804
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 4805
 $8 = $2 + 8 | 0; //@line 4806
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 4807
 $10 = $7 + $9; //@line 4808
 _cpv_271($0, $5, $10); //@line 4809
 return;
}
function _cpvadd_244($0, $1, $2) {
 $0 = $0 | 0; //@line 3311
 $1 = $1 | 0; //@line 3312
 $2 = $2 | 0; //@line 3313
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3315
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3316
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 3317
 $5 = $3 + $4; //@line 3318
 $6 = $1 + 8 | 0; //@line 3319
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 3320
 $8 = $2 + 8 | 0; //@line 3321
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 3322
 $10 = $7 + $9; //@line 3323
 _cpv_251($0, $5, $10); //@line 3324
 return;
}
function _cpvsub_49($0, $1, $2) {
 $0 = $0 | 0; //@line 6906
 $1 = $1 | 0; //@line 6907
 $2 = $2 | 0; //@line 6908
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 6910
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 6911
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 6912
 $5 = $3 - $4; //@line 6913
 $6 = $1 + 8 | 0; //@line 6914
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 6915
 $8 = $2 + 8 | 0; //@line 6916
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 6917
 $10 = $7 - $9; //@line 6918
 _cpv_33($0, $5, $10); //@line 6919
 return;
}
function _cpvsub_19($0, $1, $2) {
 $0 = $0 | 0; //@line 3681
 $1 = $1 | 0; //@line 3682
 $2 = $2 | 0; //@line 3683
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3685
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3686
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 3687
 $5 = $3 - $4; //@line 3688
 $6 = $1 + 8 | 0; //@line 3689
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 3690
 $8 = $2 + 8 | 0; //@line 3691
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 3692
 $10 = $7 - $9; //@line 3693
 _cpv_21($0, $5, $10); //@line 3694
 return;
}
function _cpvadd_43($0, $1, $2) {
 $0 = $0 | 0; //@line 6337
 $1 = $1 | 0; //@line 6338
 $2 = $2 | 0; //@line 6339
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 6341
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 6342
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 6343
 $5 = $3 + $4; //@line 6344
 $6 = $1 + 8 | 0; //@line 6345
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 6346
 $8 = $2 + 8 | 0; //@line 6347
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 6348
 $10 = $7 + $9; //@line 6349
 _cpv_33($0, $5, $10); //@line 6350
 return;
}
function _cpBBArea($0) {
 $0 = $0 | 0; //@line 4908
 var $1 = 0, $10 = 0.0, $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0; //@line 4909
 sp = STACKTOP; //@line 4910
 $1 = $0 + 16 | 0; //@line 4911
 $2 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 4912
 $3 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 4913
 $4 = $2 - $3; //@line 4914
 $5 = $0 + 24 | 0; //@line 4915
 $6 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 4916
 $7 = $0 + 8 | 0; //@line 4917
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 4918
 $9 = $6 - $8; //@line 4919
 $10 = $4 * $9; //@line 4920
 return +$10;
}
function _leafSetEql($0, $1) {
 $0 = $0 | 0; //@line 2987
 $1 = $1 | 0; //@line 2988
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0; //@line 2989
 sp = STACKTOP; //@line 2990
 STACKTOP = STACKTOP + 16 | 0; //@line 2991
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2991
 $2 = $0; //@line 2992
 $3 = $1; //@line 2993
 $4 = $2; //@line 2994
 $5 = $3; //@line 2995
 $6 = SAFE_HEAP_LOAD($5 | 0, 4, 0) | 0 | 0; //@line 2996
 $7 = ($4 | 0) == ($6 | 0); //@line 2997
 $8 = $7 & 1; //@line 2998
 STACKTOP = sp; //@line 2999
 return $8 | 0; //@line 2999
}
function _cpvsub_67($0, $1, $2) {
 $0 = $0 | 0; //@line 620
 $1 = $1 | 0; //@line 621
 $2 = $2 | 0; //@line 622
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 624
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 625
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 626
 $5 = $3 - $4; //@line 627
 $6 = $1 + 8 | 0; //@line 628
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 629
 $8 = $2 + 8 | 0; //@line 630
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 631
 $10 = $7 - $9; //@line 632
 _cpv_72($0, $5, $10); //@line 633
 return;
}
function _cpvadd_66($0, $1, $2) {
 $0 = $0 | 0; //@line 603
 $1 = $1 | 0; //@line 604
 $2 = $2 | 0; //@line 605
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 607
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 608
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 609
 $5 = $3 + $4; //@line 610
 $6 = $1 + 8 | 0; //@line 611
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 612
 $8 = $2 + 8 | 0; //@line 613
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 614
 $10 = $7 + $9; //@line 615
 _cpv_72($0, $5, $10); //@line 616
 return;
}
function _cpvsub_10($0, $1, $2) {
 $0 = $0 | 0; //@line 914
 $1 = $1 | 0; //@line 915
 $2 = $2 | 0; //@line 916
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 918
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 919
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 920
 $5 = $3 - $4; //@line 921
 $6 = $1 + 8 | 0; //@line 922
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 923
 $8 = $2 + 8 | 0; //@line 924
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 925
 $10 = $7 - $9; //@line 926
 _cpv_2($0, $5, $10); //@line 927
 return;
}
function _cpvadd_9($0, $1, $2) {
 $0 = $0 | 0; //@line 897
 $1 = $1 | 0; //@line 898
 $2 = $2 | 0; //@line 899
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 901
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 902
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 903
 $5 = $3 + $4; //@line 904
 $6 = $1 + 8 | 0; //@line 905
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 906
 $8 = $2 + 8 | 0; //@line 907
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 908
 $10 = $7 + $9; //@line 909
 _cpv_2($0, $5, $10); //@line 910
 return;
}
function _cpvsub($0, $1, $2) {
 $0 = $0 | 0; //@line 331
 $1 = $1 | 0; //@line 332
 $2 = $2 | 0; //@line 333
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 335
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 336
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 337
 $5 = $3 - $4; //@line 338
 $6 = $1 + 8 | 0; //@line 339
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 340
 $8 = $2 + 8 | 0; //@line 341
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 342
 $10 = $7 - $9; //@line 343
 _cpv($0, $5, $10); //@line 344
 return;
}
function _cpvadd($0, $1, $2) {
 $0 = $0 | 0; //@line 397
 $1 = $1 | 0; //@line 398
 $2 = $2 | 0; //@line 399
 var $10 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 401
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 402
 $4 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 403
 $5 = $3 + $4; //@line 404
 $6 = $1 + 8 | 0; //@line 405
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 406
 $8 = $2 + 8 | 0; //@line 407
 $9 = +(+SAFE_HEAP_LOAD_D($8 | 0, 8)); //@line 408
 $10 = $7 + $9; //@line 409
 _cpv($0, $5, $10); //@line 410
 return;
}
function _cpBodyIsSleeping($0) {
 $0 = $0 | 0; //@line 7022
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0; //@line 7023
 sp = STACKTOP; //@line 7024
 STACKTOP = STACKTOP + 16 | 0; //@line 7025
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7025
 $1 = $0; //@line 7026
 $2 = $1; //@line 7027
 $3 = $2 + 224 | 0; //@line 7028
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 7029
 $5 = ($4 | 0) != (0 | 0); //@line 7030
 $6 = $5 & 1; //@line 7031
 $7 = $6 & 255; //@line 7032
 STACKTOP = sp; //@line 7033
 return $7 | 0; //@line 7033
}
function _cpvcross_409($0, $1) {
 $0 = $0 | 0; //@line 7890
 $1 = $1 | 0; //@line 7891
 var $10 = 0.0, $2 = 0.0, $3 = 0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 7893
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 7894
 $3 = $1 + 8 | 0; //@line 7895
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 7896
 $5 = $2 * $4; //@line 7897
 $6 = $0 + 8 | 0; //@line 7898
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 7899
 $8 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 7900
 $9 = $7 * $8; //@line 7901
 $10 = $5 - $9; //@line 7902
 return +$10;
}
function _cpvcross_369($0, $1) {
 $0 = $0 | 0; //@line 6915
 $1 = $1 | 0; //@line 6916
 var $10 = 0.0, $2 = 0.0, $3 = 0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 6918
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 6919
 $3 = $1 + 8 | 0; //@line 6920
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 6921
 $5 = $2 * $4; //@line 6922
 $6 = $0 + 8 | 0; //@line 6923
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 6924
 $8 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 6925
 $9 = $7 * $8; //@line 6926
 $10 = $5 - $9; //@line 6927
 return +$10;
}
function _cpvcross_274($0, $1) {
 $0 = $0 | 0; //@line 4633
 $1 = $1 | 0; //@line 4634
 var $10 = 0.0, $2 = 0.0, $3 = 0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 4636
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 4637
 $3 = $1 + 8 | 0; //@line 4638
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 4639
 $5 = $2 * $4; //@line 4640
 $6 = $0 + 8 | 0; //@line 4641
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 4642
 $8 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 4643
 $9 = $7 * $8; //@line 4644
 $10 = $5 - $9; //@line 4645
 return +$10;
}
function _cpvcross_250($0, $1) {
 $0 = $0 | 0; //@line 3463
 $1 = $1 | 0; //@line 3464
 var $10 = 0.0, $2 = 0.0, $3 = 0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3466
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 3467
 $3 = $1 + 8 | 0; //@line 3468
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 3469
 $5 = $2 * $4; //@line 3470
 $6 = $0 + 8 | 0; //@line 3471
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 3472
 $8 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3473
 $9 = $7 * $8; //@line 3474
 $10 = $5 - $9; //@line 3475
 return +$10;
}
function _cpvcross_52($0, $1) {
 $0 = $0 | 0; //@line 7431
 $1 = $1 | 0; //@line 7432
 var $10 = 0.0, $2 = 0.0, $3 = 0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 7434
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 7435
 $3 = $1 + 8 | 0; //@line 7436
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 7437
 $5 = $2 * $4; //@line 7438
 $6 = $0 + 8 | 0; //@line 7439
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 7440
 $8 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 7441
 $9 = $7 * $8; //@line 7442
 $10 = $5 - $9; //@line 7443
 return +$10;
}
function _cpvcross_17($0, $1) {
 $0 = $0 | 0; //@line 2134
 $1 = $1 | 0; //@line 2135
 var $10 = 0.0, $2 = 0.0, $3 = 0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 2137
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 2138
 $3 = $1 + 8 | 0; //@line 2139
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 2140
 $5 = $2 * $4; //@line 2141
 $6 = $0 + 8 | 0; //@line 2142
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 2143
 $8 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 2144
 $9 = $7 * $8; //@line 2145
 $10 = $5 - $9; //@line 2146
 return +$10;
}
function _cpvdot_509($0, $1) {
 $0 = $0 | 0; //@line 3407
 $1 = $1 | 0; //@line 3408
 var $10 = 0.0, $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3410
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 3411
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3412
 $4 = $2 * $3; //@line 3413
 $5 = $0 + 8 | 0; //@line 3414
 $6 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 3415
 $7 = $1 + 8 | 0; //@line 3416
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 3417
 $9 = $6 * $8; //@line 3418
 $10 = $4 + $9; //@line 3419
 return +$10;
}
function _cpvdot_402($0, $1) {
 $0 = $0 | 0; //@line 7737
 $1 = $1 | 0; //@line 7738
 var $10 = 0.0, $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 7740
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 7741
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 7742
 $4 = $2 * $3; //@line 7743
 $5 = $0 + 8 | 0; //@line 7744
 $6 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 7745
 $7 = $1 + 8 | 0; //@line 7746
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 7747
 $9 = $6 * $8; //@line 7748
 $10 = $4 + $9; //@line 7749
 return +$10;
}
function _cpvdot_359($0, $1) {
 $0 = $0 | 0; //@line 5643
 $1 = $1 | 0; //@line 5644
 var $10 = 0.0, $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 5646
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 5647
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 5648
 $4 = $2 * $3; //@line 5649
 $5 = $0 + 8 | 0; //@line 5650
 $6 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 5651
 $7 = $1 + 8 | 0; //@line 5652
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 5653
 $9 = $6 * $8; //@line 5654
 $10 = $4 + $9; //@line 5655
 return +$10;
}
function _cpvdot_328($0, $1) {
 $0 = $0 | 0; //@line 5085
 $1 = $1 | 0; //@line 5086
 var $10 = 0.0, $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 5088
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 5089
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 5090
 $4 = $2 * $3; //@line 5091
 $5 = $0 + 8 | 0; //@line 5092
 $6 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 5093
 $7 = $1 + 8 | 0; //@line 5094
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 5095
 $9 = $6 * $8; //@line 5096
 $10 = $4 + $9; //@line 5097
 return +$10;
}
function _cpvdot_272($0, $1) {
 $0 = $0 | 0; //@line 4075
 $1 = $1 | 0; //@line 4076
 var $10 = 0.0, $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 4078
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 4079
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 4080
 $4 = $2 * $3; //@line 4081
 $5 = $0 + 8 | 0; //@line 4082
 $6 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 4083
 $7 = $1 + 8 | 0; //@line 4084
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 4085
 $9 = $6 * $8; //@line 4086
 $10 = $4 + $9; //@line 4087
 return +$10;
}
function _cpvdot_240($0, $1) {
 $0 = $0 | 0; //@line 3192
 $1 = $1 | 0; //@line 3193
 var $10 = 0.0, $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3195
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 3196
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3197
 $4 = $2 * $3; //@line 3198
 $5 = $0 + 8 | 0; //@line 3199
 $6 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 3200
 $7 = $1 + 8 | 0; //@line 3201
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 3202
 $9 = $6 * $8; //@line 3203
 $10 = $4 + $9; //@line 3204
 return +$10;
}
function _cpvdot_51($0, $1) {
 $0 = $0 | 0; //@line 6935
 $1 = $1 | 0; //@line 6936
 var $10 = 0.0, $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 6938
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 6939
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 6940
 $4 = $2 * $3; //@line 6941
 $5 = $0 + 8 | 0; //@line 6942
 $6 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 6943
 $7 = $1 + 8 | 0; //@line 6944
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 6945
 $9 = $6 * $8; //@line 6946
 $10 = $4 + $9; //@line 6947
 return +$10;
}
function _cpSpaceIsLocked($0) {
 $0 = $0 | 0; //@line 1013
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0; //@line 1014
 sp = STACKTOP; //@line 1015
 STACKTOP = STACKTOP + 16 | 0; //@line 1016
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1016
 $1 = $0; //@line 1017
 $2 = $1; //@line 1018
 $3 = $2 + 140 | 0; //@line 1019
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 1020
 $5 = $4 >>> 0 > 0; //@line 1021
 $6 = $5 & 1; //@line 1022
 $7 = $6 & 255; //@line 1023
 STACKTOP = sp; //@line 1024
 return $7 | 0; //@line 1024
}
function _cpSpatialIndexFree($0) {
 $0 = $0 | 0; //@line 5613
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0; //@line 5614
 sp = STACKTOP; //@line 5615
 STACKTOP = STACKTOP + 16 | 0; //@line 5616
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5616
 $1 = $0; //@line 5617
 $2 = $1; //@line 5618
 $3 = ($2 | 0) != (0 | 0); //@line 5619
 if (!$3) {
  STACKTOP = sp; //@line 5621
  return;
 }
 $4 = $1; //@line 5623
 _cpSpatialIndexDestroy($4); //@line 5624
 $5 = $1; //@line 5625
 _free($5); //@line 5626
 STACKTOP = sp; //@line 5627
 return;
}
function _cpArbiterIsFirstContact($0) {
 $0 = $0 | 0; //@line 827
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0; //@line 828
 sp = STACKTOP; //@line 829
 STACKTOP = STACKTOP + 16 | 0; //@line 830
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 830
 $1 = $0; //@line 831
 $2 = $1; //@line 832
 $3 = $2 + 116 | 0; //@line 833
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 834
 $5 = ($4 | 0) == 0; //@line 835
 $6 = $5 & 1; //@line 836
 $7 = $6 & 255; //@line 837
 STACKTOP = sp; //@line 838
 return $7 | 0; //@line 838
}
function _cpvcross_63($0, $1) {
 $0 = $0 | 0; //@line 531
 $1 = $1 | 0; //@line 532
 var $10 = 0.0, $2 = 0.0, $3 = 0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 534
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 535
 $3 = $1 + 8 | 0; //@line 536
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 537
 $5 = $2 * $4; //@line 538
 $6 = $0 + 8 | 0; //@line 539
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 540
 $8 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 541
 $9 = $7 * $8; //@line 542
 $10 = $5 - $9; //@line 543
 return +$10;
}
function _cpvdot_68($0, $1) {
 $0 = $0 | 0; //@line 637
 $1 = $1 | 0; //@line 638
 var $10 = 0.0, $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 640
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 641
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 642
 $4 = $2 * $3; //@line 643
 $5 = $0 + 8 | 0; //@line 644
 $6 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 645
 $7 = $1 + 8 | 0; //@line 646
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 647
 $9 = $6 * $8; //@line 648
 $10 = $4 + $9; //@line 649
 return +$10;
}
function _cpvdot_11($0, $1) {
 $0 = $0 | 0; //@line 931
 $1 = $1 | 0; //@line 932
 var $10 = 0.0, $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 934
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 935
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 936
 $4 = $2 * $3; //@line 937
 $5 = $0 + 8 | 0; //@line 938
 $6 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 939
 $7 = $1 + 8 | 0; //@line 940
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 941
 $9 = $6 * $8; //@line 942
 $10 = $4 + $9; //@line 943
 return +$10;
}
function _cpConstraintFree($0) {
 $0 = $0 | 0; //@line 1947
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0; //@line 1948
 sp = STACKTOP; //@line 1949
 STACKTOP = STACKTOP + 16 | 0; //@line 1950
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1950
 $1 = $0; //@line 1951
 $2 = $1; //@line 1952
 $3 = ($2 | 0) != (0 | 0); //@line 1953
 if (!$3) {
  STACKTOP = sp; //@line 1955
  return;
 }
 $4 = $1; //@line 1957
 _cpConstraintDestroy($4); //@line 1958
 $5 = $1; //@line 1959
 _free($5); //@line 1960
 STACKTOP = sp; //@line 1961
 return;
}
function _cpvcross($0, $1) {
 $0 = $0 | 0; //@line 546
 $1 = $1 | 0; //@line 547
 var $10 = 0.0, $2 = 0.0, $3 = 0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 549
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 550
 $3 = $1 + 8 | 0; //@line 551
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 552
 $5 = $2 * $4; //@line 553
 $6 = $0 + 8 | 0; //@line 554
 $7 = +(+SAFE_HEAP_LOAD_D($6 | 0, 8)); //@line 555
 $8 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 556
 $9 = $7 * $8; //@line 557
 $10 = $5 - $9; //@line 558
 return +$10;
}
function _cpvdot($0, $1) {
 $0 = $0 | 0; //@line 196
 $1 = $1 | 0; //@line 197
 var $10 = 0.0, $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0.0, $7 = 0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 199
 $2 = +(+SAFE_HEAP_LOAD_D($0 | 0, 8)); //@line 200
 $3 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 201
 $4 = $2 * $3; //@line 202
 $5 = $0 + 8 | 0; //@line 203
 $6 = +(+SAFE_HEAP_LOAD_D($5 | 0, 8)); //@line 204
 $7 = $1 + 8 | 0; //@line 205
 $8 = +(+SAFE_HEAP_LOAD_D($7 | 0, 8)); //@line 206
 $9 = $6 * $8; //@line 207
 $10 = $4 + $9; //@line 208
 return +$10;
}
function _cpfmin_412($0, $1) {
 $0 = +$0; //@line 7940
 $1 = +$1; //@line 7941
 var $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 7943
 STACKTOP = STACKTOP + 16 | 0; //@line 7944
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7944
 $2 = $0; //@line 7945
 $3 = $1; //@line 7946
 $4 = $2; //@line 7947
 $5 = $3; //@line 7948
 $6 = $4 < $5; //@line 7949
 $7 = $2; //@line 7950
 $8 = $3; //@line 7951
 $9 = $6 ? $7 : $8; //@line 7952
 STACKTOP = sp; //@line 7953
 return +$9;
}
function _cpfmin_373($0, $1) {
 $0 = +$0; //@line 6998
 $1 = +$1; //@line 6999
 var $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 7001
 STACKTOP = STACKTOP + 16 | 0; //@line 7002
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7002
 $2 = $0; //@line 7003
 $3 = $1; //@line 7004
 $4 = $2; //@line 7005
 $5 = $3; //@line 7006
 $6 = $4 < $5; //@line 7007
 $7 = $2; //@line 7008
 $8 = $3; //@line 7009
 $9 = $6 ? $7 : $8; //@line 7010
 STACKTOP = sp; //@line 7011
 return +$9;
}
function _cpfmin_280($0, $1) {
 $0 = +$0; //@line 4897
 $1 = +$1; //@line 4898
 var $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 4900
 STACKTOP = STACKTOP + 16 | 0; //@line 4901
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 4901
 $2 = $0; //@line 4902
 $3 = $1; //@line 4903
 $4 = $2; //@line 4904
 $5 = $3; //@line 4905
 $6 = $4 < $5; //@line 4906
 $7 = $2; //@line 4907
 $8 = $3; //@line 4908
 $9 = $6 ? $7 : $8; //@line 4909
 STACKTOP = sp; //@line 4910
 return +$9;
}
function _cpfmax_547($0, $1) {
 $0 = +$0; //@line 3632
 $1 = +$1; //@line 3633
 var $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3635
 STACKTOP = STACKTOP + 16 | 0; //@line 3636
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3636
 $2 = $0; //@line 3637
 $3 = $1; //@line 3638
 $4 = $2; //@line 3639
 $5 = $3; //@line 3640
 $6 = $4 > $5; //@line 3641
 $7 = $2; //@line 3642
 $8 = $3; //@line 3643
 $9 = $6 ? $7 : $8; //@line 3644
 STACKTOP = sp; //@line 3645
 return +$9;
}
function _cpfmax_411($0, $1) {
 $0 = +$0; //@line 7924
 $1 = +$1; //@line 7925
 var $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 7927
 STACKTOP = STACKTOP + 16 | 0; //@line 7928
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7928
 $2 = $0; //@line 7929
 $3 = $1; //@line 7930
 $4 = $2; //@line 7931
 $5 = $3; //@line 7932
 $6 = $4 > $5; //@line 7933
 $7 = $2; //@line 7934
 $8 = $3; //@line 7935
 $9 = $6 ? $7 : $8; //@line 7936
 STACKTOP = sp; //@line 7937
 return +$9;
}
function _cpfmax_374($0, $1) {
 $0 = +$0; //@line 7014
 $1 = +$1; //@line 7015
 var $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 7017
 STACKTOP = STACKTOP + 16 | 0; //@line 7018
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7018
 $2 = $0; //@line 7019
 $3 = $1; //@line 7020
 $4 = $2; //@line 7021
 $5 = $3; //@line 7022
 $6 = $4 > $5; //@line 7023
 $7 = $2; //@line 7024
 $8 = $3; //@line 7025
 $9 = $6 ? $7 : $8; //@line 7026
 STACKTOP = sp; //@line 7027
 return +$9;
}
function _cpfmax_329($0, $1) {
 $0 = +$0; //@line 5101
 $1 = +$1; //@line 5102
 var $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 5104
 STACKTOP = STACKTOP + 16 | 0; //@line 5105
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5105
 $2 = $0; //@line 5106
 $3 = $1; //@line 5107
 $4 = $2; //@line 5108
 $5 = $3; //@line 5109
 $6 = $4 > $5; //@line 5110
 $7 = $2; //@line 5111
 $8 = $3; //@line 5112
 $9 = $6 ? $7 : $8; //@line 5113
 STACKTOP = sp; //@line 5114
 return +$9;
}
function _cpfmax_281($0, $1) {
 $0 = +$0; //@line 4913
 $1 = +$1; //@line 4914
 var $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 4916
 STACKTOP = STACKTOP + 16 | 0; //@line 4917
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 4917
 $2 = $0; //@line 4918
 $3 = $1; //@line 4919
 $4 = $2; //@line 4920
 $5 = $3; //@line 4921
 $6 = $4 > $5; //@line 4922
 $7 = $2; //@line 4923
 $8 = $3; //@line 4924
 $9 = $6 ? $7 : $8; //@line 4925
 STACKTOP = sp; //@line 4926
 return +$9;
}
function _cpfmin_18($0, $1) {
 $0 = +$0; //@line 3665
 $1 = +$1; //@line 3666
 var $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3668
 STACKTOP = STACKTOP + 16 | 0; //@line 3669
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3669
 $2 = $0; //@line 3670
 $3 = $1; //@line 3671
 $4 = $2; //@line 3672
 $5 = $3; //@line 3673
 $6 = $4 < $5; //@line 3674
 $7 = $2; //@line 3675
 $8 = $3; //@line 3676
 $9 = $6 ? $7 : $8; //@line 3677
 STACKTOP = sp; //@line 3678
 return +$9;
}
function _cpfmax_20($0, $1) {
 $0 = +$0; //@line 3698
 $1 = +$1; //@line 3699
 var $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3701
 STACKTOP = STACKTOP + 16 | 0; //@line 3702
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3702
 $2 = $0; //@line 3703
 $3 = $1; //@line 3704
 $4 = $2; //@line 3705
 $5 = $3; //@line 3706
 $6 = $4 > $5; //@line 3707
 $7 = $2; //@line 3708
 $8 = $3; //@line 3709
 $9 = $6 ? $7 : $8; //@line 3710
 STACKTOP = sp; //@line 3711
 return +$9;
}
function _cpfmin($0, $1) {
 $0 = +$0; //@line 2008
 $1 = +$1; //@line 2009
 var $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 2011
 STACKTOP = STACKTOP + 16 | 0; //@line 2012
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2012
 $2 = $0; //@line 2013
 $3 = $1; //@line 2014
 $4 = $2; //@line 2015
 $5 = $3; //@line 2016
 $6 = $4 < $5; //@line 2017
 $7 = $2; //@line 2018
 $8 = $3; //@line 2019
 $9 = $6 ? $7 : $8; //@line 2020
 STACKTOP = sp; //@line 2021
 return +$9;
}
function _cpfmax($0, $1) {
 $0 = +$0; //@line 2562
 $1 = +$1; //@line 2563
 var $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 2565
 STACKTOP = STACKTOP + 16 | 0; //@line 2566
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2566
 $2 = $0; //@line 2567
 $3 = $1; //@line 2568
 $4 = $2; //@line 2569
 $5 = $3; //@line 2570
 $6 = $4 > $5; //@line 2571
 $7 = $2; //@line 2572
 $8 = $3; //@line 2573
 $9 = $6 ? $7 : $8; //@line 2574
 STACKTOP = sp; //@line 2575
 return +$9;
}
function _cpShapeFree($0) {
 $0 = $0 | 0; //@line 5209
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0; //@line 5210
 sp = STACKTOP; //@line 5211
 STACKTOP = STACKTOP + 16 | 0; //@line 5212
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5212
 $1 = $0; //@line 5213
 $2 = $1; //@line 5214
 $3 = ($2 | 0) != (0 | 0); //@line 5215
 if (!$3) {
  STACKTOP = sp; //@line 5217
  return;
 }
 $4 = $1; //@line 5219
 _cpShapeDestroy($4); //@line 5220
 $5 = $1; //@line 5221
 _free($5); //@line 5222
 STACKTOP = sp; //@line 5223
 return;
}
function _cpBodyFree($0) {
 $0 = $0 | 0; //@line 7005
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0; //@line 7006
 sp = STACKTOP; //@line 7007
 STACKTOP = STACKTOP + 16 | 0; //@line 7008
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7008
 $1 = $0; //@line 7009
 $2 = $1; //@line 7010
 $3 = ($2 | 0) != (0 | 0); //@line 7011
 if (!$3) {
  STACKTOP = sp; //@line 7013
  return;
 }
 $4 = $1; //@line 7015
 _cpBodyDestroy($4); //@line 7016
 $5 = $1; //@line 7017
 _free($5); //@line 7018
 STACKTOP = sp; //@line 7019
 return;
}
function _cpBBTreeNew($0, $1) {
 $0 = $0 | 0; //@line 5514
 $1 = $1 | 0; //@line 5515
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, label = 0, sp = 0; //@line 5516
 sp = STACKTOP; //@line 5517
 STACKTOP = STACKTOP + 16 | 0; //@line 5518
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5518
 $2 = $0; //@line 5519
 $3 = $1; //@line 5520
 $4 = _cpBBTreeAlloc() | 0; //@line 5521
 $5 = $2; //@line 5522
 $6 = $3; //@line 5523
 $7 = _cpBBTreeInit($4, $5, $6) | 0; //@line 5524
 STACKTOP = sp; //@line 5525
 return $7 | 0; //@line 5525
}
function _cpfmin_73($0, $1) {
 $0 = +$0; //@line 717
 $1 = +$1; //@line 718
 var $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 720
 STACKTOP = STACKTOP + 16 | 0; //@line 721
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 721
 $2 = $0; //@line 722
 $3 = $1; //@line 723
 $4 = $2; //@line 724
 $5 = $3; //@line 725
 $6 = $4 < $5; //@line 726
 $7 = $2; //@line 727
 $8 = $3; //@line 728
 $9 = $6 ? $7 : $8; //@line 729
 STACKTOP = sp; //@line 730
 return +$9;
}
function _cpfmax_74($0, $1) {
 $0 = +$0; //@line 733
 $1 = +$1; //@line 734
 var $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0, $7 = 0.0, $8 = 0.0, $9 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 736
 STACKTOP = STACKTOP + 16 | 0; //@line 737
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 737
 $2 = $0; //@line 738
 $3 = $1; //@line 739
 $4 = $2; //@line 740
 $5 = $3; //@line 741
 $6 = $4 > $5; //@line 742
 $7 = $2; //@line 743
 $8 = $3; //@line 744
 $9 = $6 ? $7 : $8; //@line 745
 STACKTOP = sp; //@line 746
 return +$9;
}
function _printf($0, $varargs) {
 $0 = $0 | 0; //@line 14131
 $varargs = $varargs | 0; //@line 14132
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0; //@line 14133
 sp = STACKTOP; //@line 14134
 STACKTOP = STACKTOP + 16 | 0; //@line 14135
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 14135
 $1 = sp; //@line 14136
 SAFE_HEAP_STORE($1 | 0, $varargs | 0, 4);
 $2 = SAFE_HEAP_LOAD(717 * 4 | 0, 4, 0) | 0 | 0; //@line 14138
 $3 = _vfprintf($2, $0, $1) | 0; //@line 14139
 STACKTOP = sp; //@line 14140
 return $3 | 0; //@line 14140
}
function _cpSpaceFree($0) {
 $0 = $0 | 0; //@line 745
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0; //@line 746
 sp = STACKTOP; //@line 747
 STACKTOP = STACKTOP + 16 | 0; //@line 748
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 748
 $1 = $0; //@line 749
 $2 = $1; //@line 750
 $3 = ($2 | 0) != (0 | 0); //@line 751
 if (!$3) {
  STACKTOP = sp; //@line 753
  return;
 }
 $4 = $1; //@line 755
 _cpSpaceDestroy($4); //@line 756
 $5 = $1; //@line 757
 _free($5); //@line 758
 STACKTOP = sp; //@line 759
 return;
}
function _VoidQueryFunc($0, $1, $2, $3) {
 $0 = $0 | 0; //@line 5400
 $1 = $1 | 0; //@line 5401
 $2 = $2 | 0; //@line 5402
 $3 = $3 | 0; //@line 5403
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, label = 0, sp = 0; //@line 5404
 sp = STACKTOP; //@line 5405
 STACKTOP = STACKTOP + 16 | 0; //@line 5406
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5406
 $4 = $0; //@line 5407
 $5 = $1; //@line 5408
 $6 = $2; //@line 5409
 $7 = $3; //@line 5410
 $8 = $6; //@line 5411
 STACKTOP = sp; //@line 5412
 return $8 | 0; //@line 5412
}
function _CollisionError($0, $1, $2) {
 $0 = $0 | 0; //@line 7808
 $1 = $1 | 0; //@line 7809
 $2 = $2 | 0; //@line 7810
 var $3 = 0, $4 = 0, $5 = 0, $vararg_buffer = 0, label = 0, sp = 0; //@line 7811
 sp = STACKTOP; //@line 7812
 STACKTOP = STACKTOP + 16 | 0; //@line 7813
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7813
 $vararg_buffer = sp; //@line 7814
 $3 = $0; //@line 7815
 $4 = $1; //@line 7816
 $5 = $2; //@line 7817
 _cpMessage(4953, 4624, 684, 1, 1, 4961, $vararg_buffer); //@line 7818
 _abort(); //@line 7819
}
function _NodeIsLeaf($0) {
 $0 = $0 | 0; //@line 3508
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0; //@line 3509
 sp = STACKTOP; //@line 3510
 STACKTOP = STACKTOP + 16 | 0; //@line 3511
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3511
 $1 = $0; //@line 3512
 $2 = $1; //@line 3513
 $3 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 3514
 $4 = ($3 | 0) != (0 | 0); //@line 3515
 $5 = $4 & 1; //@line 3516
 $6 = $5 & 255; //@line 3517
 STACKTOP = sp; //@line 3518
 return $6 | 0; //@line 3518
}
function _cpBodyNew($0, $1) {
 $0 = +$0; //@line 6372
 $1 = +$1; //@line 6373
 var $2 = 0.0, $3 = 0.0, $4 = 0, $5 = 0.0, $6 = 0.0, $7 = 0, label = 0, sp = 0;
 sp = STACKTOP; //@line 6375
 STACKTOP = STACKTOP + 16 | 0; //@line 6376
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 6376
 $2 = $0; //@line 6377
 $3 = $1; //@line 6378
 $4 = _cpBodyAlloc() | 0; //@line 6379
 $5 = $2; //@line 6380
 $6 = $3; //@line 6381
 $7 = _cpBodyInit($4, $5, $6) | 0; //@line 6382
 STACKTOP = sp; //@line 6383
 return $7 | 0; //@line 6383
}
function SAFE_HEAP_STORE(dest, value, bytes) {
 dest = dest | 0; //@line 39
 value = value | 0; //@line 40
 bytes = bytes | 0; //@line 41
 if ((dest | 0) <= 0) segfault(); //@line 42
 if ((dest + bytes | 0) > (HEAP32[DYNAMICTOP_PTR >> 2] | 0)) segfault(); //@line 43
 if ((bytes | 0) == 4) {
  if (dest & 3) alignfault(); //@line 45
  HEAP32[dest >> 2] = value; //@line 46
 } else if ((bytes | 0) == 1) {
  HEAP8[dest >> 0] = value; //@line 48
 } else {
  if (dest & 1) alignfault(); //@line 50
  HEAP16[dest >> 1] = value; //@line 51
 }
}
function _cpBodySetPositionUpdateFunc($0, $1) {
 $0 = $0 | 0; //@line 7367
 $1 = $1 | 0; //@line 7368
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0; //@line 7369
 sp = STACKTOP; //@line 7370
 STACKTOP = STACKTOP + 16 | 0; //@line 7371
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7371
 $2 = $0; //@line 7372
 $3 = $1; //@line 7373
 $4 = $3; //@line 7374
 $5 = $2; //@line 7375
 $6 = $5 + 4 | 0; //@line 7376
 SAFE_HEAP_STORE($6 | 0, $4 | 0, 4);
 STACKTOP = sp; //@line 7378
 return;
}
function _cpSpaceLock($0) {
 $0 = $0 | 0; //@line 4125
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0; //@line 4126
 sp = STACKTOP; //@line 4127
 STACKTOP = STACKTOP + 16 | 0; //@line 4128
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 4128
 $1 = $0; //@line 4129
 $2 = $1; //@line 4130
 $3 = $2 + 140 | 0; //@line 4131
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 4132
 $5 = $4 + 1 | 0; //@line 4133
 SAFE_HEAP_STORE($3 | 0, $5 | 0, 4);
 STACKTOP = sp; //@line 4135
 return;
}
function _cpConstraintSetUserData($0, $1) {
 $0 = $0 | 0; //@line 2157
 $1 = $1 | 0; //@line 2158
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0; //@line 2159
 sp = STACKTOP; //@line 2160
 STACKTOP = STACKTOP + 16 | 0; //@line 2161
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2161
 $2 = $0; //@line 2162
 $3 = $1; //@line 2163
 $4 = $3; //@line 2164
 $5 = $2; //@line 2165
 $6 = $5 + 60 | 0; //@line 2166
 SAFE_HEAP_STORE($6 | 0, $4 | 0, 4);
 STACKTOP = sp; //@line 2168
 return;
}
function _cpBBTreeCount($0) {
 $0 = $0 | 0; //@line 3028
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0; //@line 3029
 sp = STACKTOP; //@line 3030
 STACKTOP = STACKTOP + 16 | 0; //@line 3031
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3031
 $1 = $0; //@line 3032
 $2 = $1; //@line 3033
 $3 = $2 + 20 | 0; //@line 3034
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 3035
 $5 = _cpHashSetCount($4) | 0; //@line 3036
 STACKTOP = sp; //@line 3037
 return $5 | 0; //@line 3037
}
function _cpArbiterSetFriction($0, $1) {
 $0 = $0 | 0; //@line 1011
 $1 = +$1; //@line 1012
 var $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0, label = 0, sp = 0; //@line 1013
 sp = STACKTOP; //@line 1014
 STACKTOP = STACKTOP + 16 | 0; //@line 1015
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1015
 $2 = $0; //@line 1016
 $3 = $1; //@line 1017
 $4 = $3; //@line 1018
 $5 = $2; //@line 1019
 $6 = $5 + 8 | 0; //@line 1020
 SAFE_HEAP_STORE_D($6 | 0, +$4, 8);
 STACKTOP = sp; //@line 1022
 return;
}
function _cpvforangle($0, $1) {
 $0 = $0 | 0; //@line 5987
 $1 = +$1; //@line 5988
 var $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 5990
 STACKTOP = STACKTOP + 16 | 0; //@line 5991
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5991
 $2 = $1; //@line 5992
 $3 = $2; //@line 5993
 $4 = +Math_cos(+$3); //@line 5994
 $5 = $2; //@line 5995
 $6 = +Math_sin(+$5); //@line 5996
 _cpv_33($0, $4, $6); //@line 5997
 STACKTOP = sp; //@line 5998
 return;
}
function _cpBodySetUserData($0, $1) {
 $0 = $0 | 0; //@line 7340
 $1 = $1 | 0; //@line 7341
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0; //@line 7342
 sp = STACKTOP; //@line 7343
 STACKTOP = STACKTOP + 16 | 0; //@line 7344
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7344
 $2 = $0; //@line 7345
 $3 = $1; //@line 7346
 $4 = $3; //@line 7347
 $5 = $2; //@line 7348
 $6 = $5 + 176 | 0; //@line 7349
 SAFE_HEAP_STORE($6 | 0, $4 | 0, 4);
 STACKTOP = sp; //@line 7351
 return;
}
function _bias_coef_256($0, $1) {
 $0 = +$0; //@line 3706
 $1 = +$1; //@line 3707
 var $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3709
 STACKTOP = STACKTOP + 16 | 0; //@line 3710
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3710
 $2 = $0; //@line 3711
 $3 = $1; //@line 3712
 $4 = $2; //@line 3713
 $5 = $3; //@line 3714
 $6 = +Math_pow(+$4, +$5); //@line 3715
 $7 = 1.0 - $6; //@line 3716
 STACKTOP = sp; //@line 3717
 return +$7;
}
function _cpSpaceSetSleepTimeThreshold($0, $1) {
 $0 = $0 | 0; //@line 913
 $1 = +$1; //@line 914
 var $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0, label = 0, sp = 0; //@line 915
 sp = STACKTOP; //@line 916
 STACKTOP = STACKTOP + 16 | 0; //@line 917
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 917
 $2 = $0; //@line 918
 $3 = $1; //@line 919
 $4 = $3; //@line 920
 $5 = $2; //@line 921
 $6 = $5 + 40 | 0; //@line 922
 SAFE_HEAP_STORE_D($6 | 0, +$4, 8);
 STACKTOP = sp; //@line 924
 return;
}
function _cpSpaceSetIdleSpeedThreshold($0, $1) {
 $0 = $0 | 0; //@line 888
 $1 = +$1; //@line 889
 var $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0, label = 0, sp = 0; //@line 890
 sp = STACKTOP; //@line 891
 STACKTOP = STACKTOP + 16 | 0; //@line 892
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 892
 $2 = $0; //@line 893
 $3 = $1; //@line 894
 $4 = $3; //@line 895
 $5 = $2; //@line 896
 $6 = $5 + 32 | 0; //@line 897
 SAFE_HEAP_STORE_D($6 | 0, +$4, 8);
 STACKTOP = sp; //@line 899
 return;
}
function _fprintf($0, $1, $varargs) {
 $0 = $0 | 0; //@line 11377
 $1 = $1 | 0; //@line 11378
 $varargs = $varargs | 0; //@line 11379
 var $2 = 0, $3 = 0, label = 0, sp = 0; //@line 11380
 sp = STACKTOP; //@line 11381
 STACKTOP = STACKTOP + 16 | 0; //@line 11382
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 11382
 $2 = sp; //@line 11383
 SAFE_HEAP_STORE($2 | 0, $varargs | 0, 4);
 $3 = _vfprintf($0, $1, $2) | 0; //@line 11385
 STACKTOP = sp; //@line 11386
 return $3 | 0; //@line 11386
}
function _cpSpaceSetCollisionSlop($0, $1) {
 $0 = $0 | 0; //@line 938
 $1 = +$1; //@line 939
 var $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0, label = 0, sp = 0; //@line 940
 sp = STACKTOP; //@line 941
 STACKTOP = STACKTOP + 16 | 0; //@line 942
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 942
 $2 = $0; //@line 943
 $3 = $1; //@line 944
 $4 = $3; //@line 945
 $5 = $2; //@line 946
 $6 = $5 + 48 | 0; //@line 947
 SAFE_HEAP_STORE_D($6 | 0, +$4, 8);
 STACKTOP = sp; //@line 949
 return;
}
function _cpSpaceSetCollisionBias($0, $1) {
 $0 = $0 | 0; //@line 963
 $1 = +$1; //@line 964
 var $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0, $6 = 0, label = 0, sp = 0; //@line 965
 sp = STACKTOP; //@line 966
 STACKTOP = STACKTOP + 16 | 0; //@line 967
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 967
 $2 = $0; //@line 968
 $3 = $1; //@line 969
 $4 = $3; //@line 970
 $5 = $2; //@line 971
 $6 = $5 + 56 | 0; //@line 972
 SAFE_HEAP_STORE_D($6 | 0, +$4, 8);
 STACKTOP = sp; //@line 974
 return;
}
function _chipmunk_cpBodySetVelocityUpdateFunc($0, $1) {
 $0 = $0 | 0; //@line 5943
 $1 = $1 | 0; //@line 5944
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0; //@line 5945
 sp = STACKTOP; //@line 5946
 STACKTOP = STACKTOP + 16 | 0; //@line 5947
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5947
 $2 = $0; //@line 5948
 $3 = $1; //@line 5949
 $4 = $2; //@line 5950
 $5 = $3; //@line 5951
 _cpBodySetVelocityUpdateFunc($4, $5); //@line 5952
 STACKTOP = sp; //@line 5953
 return;
}
function _cpSpaceSetUserData($0, $1) {
 $0 = $0 | 0; //@line 988
 $1 = $1 | 0; //@line 989
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, label = 0, sp = 0; //@line 990
 sp = STACKTOP; //@line 991
 STACKTOP = STACKTOP + 16 | 0; //@line 992
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 992
 $2 = $0; //@line 993
 $3 = $1; //@line 994
 $4 = $3; //@line 995
 $5 = $2; //@line 996
 $6 = $5 + 68 | 0; //@line 997
 SAFE_HEAP_STORE($6 | 0, $4 | 0, 4);
 STACKTOP = sp; //@line 999
 return;
}
function _bias_coef_419($0, $1) {
 $0 = +$0; //@line 97
 $1 = +$1; //@line 98
 var $2 = 0.0, $3 = 0.0, $4 = 0.0, $5 = 0.0, $6 = 0.0, $7 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 100
 STACKTOP = STACKTOP + 16 | 0; //@line 101
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 101
 $2 = $0; //@line 102
 $3 = $1; //@line 103
 $4 = $2; //@line 104
 $5 = $3; //@line 105
 $6 = +Math_pow(+$4, +$5); //@line 106
 $7 = 1.0 - $6; //@line 107
 STACKTOP = sp; //@line 108
 return +$7;
}
function _getImpulse_397($0) {
 $0 = $0 | 0; //@line 7633
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0.0, $5 = 0.0, label = 0, sp = 0; //@line 7634
 sp = STACKTOP; //@line 7635
 STACKTOP = STACKTOP + 16 | 0; //@line 7636
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7636
 $1 = $0; //@line 7637
 $2 = $1; //@line 7638
 $3 = $2 + 168 | 0; //@line 7639
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 7640
 $5 = +_cpfabs_398($4); //@line 7641
 STACKTOP = sp; //@line 7642
 return +$5;
}
function _cpBodySetVelocityUpdateFunc($0, $1) {
 $0 = $0 | 0; //@line 7354
 $1 = $1 | 0; //@line 7355
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0; //@line 7356
 sp = STACKTOP; //@line 7357
 STACKTOP = STACKTOP + 16 | 0; //@line 7358
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7358
 $2 = $0; //@line 7359
 $3 = $1; //@line 7360
 $4 = $3; //@line 7361
 $5 = $2; //@line 7362
 SAFE_HEAP_STORE($5 | 0, $4 | 0, 4);
 STACKTOP = sp; //@line 7364
 return;
}
function _cpArbiterSetRestitution($0, $1) {
 $0 = $0 | 0; //@line 998
 $1 = +$1; //@line 999
 var $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0, label = 0, sp = 0; //@line 1000
 sp = STACKTOP; //@line 1001
 STACKTOP = STACKTOP + 16 | 0; //@line 1002
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1002
 $2 = $0; //@line 1003
 $3 = $1; //@line 1004
 $4 = $3; //@line 1005
 $5 = $2; //@line 1006
 SAFE_HEAP_STORE_D($5 | 0, +$4, 8);
 STACKTOP = sp; //@line 1008
 return;
}
function _cpfabs_398($0) {
 $0 = +$0; //@line 7645
 var $1 = 0.0, $2 = 0.0, $3 = 0, $4 = 0.0, $5 = 0.0, $6 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 7647
 STACKTOP = STACKTOP + 16 | 0; //@line 7648
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7648
 $1 = $0; //@line 7649
 $2 = $1; //@line 7650
 $3 = $2 < 0.0; //@line 7651
 $4 = $1; //@line 7652
 $5 = -$4; //@line 7653
 $6 = $3 ? $5 : $4; //@line 7654
 STACKTOP = sp; //@line 7655
 return +$6;
}
function _cpShapeUpdateFunc($0, $1) {
 $0 = $0 | 0; //@line 5118
 $1 = $1 | 0; //@line 5119
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0; //@line 5120
 sp = STACKTOP; //@line 5121
 STACKTOP = STACKTOP + 48 | 0; //@line 5122
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(48 | 0); //@line 5122
 $4 = sp; //@line 5123
 $2 = $0; //@line 5124
 $3 = $1; //@line 5125
 $5 = $2; //@line 5126
 _cpShapeCacheBB($4, $5); //@line 5127
 STACKTOP = sp; //@line 5128
 return;
}
function _cpShapeGetCollisionType($0) {
 $0 = $0 | 0; //@line 5424
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0; //@line 5425
 sp = STACKTOP; //@line 5426
 STACKTOP = STACKTOP + 16 | 0; //@line 5427
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5427
 $1 = $0; //@line 5428
 $2 = $1; //@line 5429
 $3 = $2 + 132 | 0; //@line 5430
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 5431
 STACKTOP = sp; //@line 5432
 return $4 | 0; //@line 5432
}
function _cpfabs_35($0) {
 $0 = +$0; //@line 6242
 var $1 = 0.0, $2 = 0.0, $3 = 0, $4 = 0.0, $5 = 0.0, $6 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 6244
 STACKTOP = STACKTOP + 16 | 0; //@line 6245
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 6245
 $1 = $0; //@line 6246
 $2 = $1; //@line 6247
 $3 = $2 < 0.0; //@line 6248
 $4 = $1; //@line 6249
 $5 = -$4; //@line 6250
 $6 = $3 ? $5 : $4; //@line 6251
 STACKTOP = sp; //@line 6252
 return +$6;
}
function _cpfabs_25($0) {
 $0 = +$0; //@line 5076
 var $1 = 0.0, $2 = 0.0, $3 = 0, $4 = 0.0, $5 = 0.0, $6 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 5078
 STACKTOP = STACKTOP + 16 | 0; //@line 5079
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5079
 $1 = $0; //@line 5080
 $2 = $1; //@line 5081
 $3 = $2 < 0.0; //@line 5082
 $4 = $1; //@line 5083
 $5 = -$4; //@line 5084
 $6 = $3 ? $5 : $4; //@line 5085
 STACKTOP = sp; //@line 5086
 return +$6;
}
function _cpConstraintGetUserData($0) {
 $0 = $0 | 0; //@line 2146
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0; //@line 2147
 sp = STACKTOP; //@line 2148
 STACKTOP = STACKTOP + 16 | 0; //@line 2149
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2149
 $1 = $0; //@line 2150
 $2 = $1; //@line 2151
 $3 = $2 + 60 | 0; //@line 2152
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 2153
 STACKTOP = sp; //@line 2154
 return $4 | 0; //@line 2154
}
function _cpSpaceGetStaticBody($0) {
 $0 = $0 | 0; //@line 1002
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0; //@line 1003
 sp = STACKTOP; //@line 1004
 STACKTOP = STACKTOP + 16 | 0; //@line 1005
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1005
 $1 = $0; //@line 1006
 $2 = $1; //@line 1007
 $3 = $2 + 188 | 0; //@line 1008
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 1009
 STACKTOP = sp; //@line 1010
 return $4 | 0; //@line 1010
}
function _cpShapeGetSensor($0) {
 $0 = $0 | 0; //@line 5319
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0; //@line 5320
 sp = STACKTOP; //@line 5321
 STACKTOP = STACKTOP + 16 | 0; //@line 5322
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5322
 $1 = $0; //@line 5323
 $2 = $1; //@line 5324
 $3 = $2 + 88 | 0; //@line 5325
 $4 = SAFE_HEAP_LOAD($3 >> 0 | 0, 1, 0) | 0 | 0; //@line 5326
 STACKTOP = sp; //@line 5327
 return $4 | 0; //@line 5327
}
function _LeafUpdateWrap($0, $1) {
 $0 = $0 | 0; //@line 3832
 $1 = $1 | 0; //@line 3833
 var $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0; //@line 3834
 sp = STACKTOP; //@line 3835
 STACKTOP = STACKTOP + 16 | 0; //@line 3836
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3836
 $2 = $0; //@line 3837
 $3 = $1; //@line 3838
 $4 = $2; //@line 3839
 $5 = $3; //@line 3840
 _LeafUpdate($4, $5) | 0; //@line 3841
 STACKTOP = sp; //@line 3842
 return;
}
function _cpBodyGetUserData($0) {
 $0 = $0 | 0; //@line 7329
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0; //@line 7330
 sp = STACKTOP; //@line 7331
 STACKTOP = STACKTOP + 16 | 0; //@line 7332
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7332
 $1 = $0; //@line 7333
 $2 = $1; //@line 7334
 $3 = $2 + 176 | 0; //@line 7335
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 7336
 STACKTOP = sp; //@line 7337
 return $4 | 0; //@line 7337
}
function _cpBodyGetSpace($0) {
 $0 = $0 | 0; //@line 6700
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0; //@line 6701
 sp = STACKTOP; //@line 6702
 STACKTOP = STACKTOP + 16 | 0; //@line 6703
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 6703
 $1 = $0; //@line 6704
 $2 = $1; //@line 6705
 $3 = $2 + 208 | 0; //@line 6706
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 6707
 STACKTOP = sp; //@line 6708
 return $4 | 0; //@line 6708
}
function _cpShapeGetSpace($0) {
 $0 = $0 | 0; //@line 5226
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0; //@line 5227
 sp = STACKTOP; //@line 5228
 STACKTOP = STACKTOP + 16 | 0; //@line 5229
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5229
 $1 = $0; //@line 5230
 $2 = $1; //@line 5231
 $3 = $2 + 4 | 0; //@line 5232
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 5233
 STACKTOP = sp; //@line 5234
 return $4 | 0; //@line 5234
}
function _cpShapeGetBody($0) {
 $0 = $0 | 0; //@line 5237
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0; //@line 5238
 sp = STACKTOP; //@line 5239
 STACKTOP = STACKTOP + 16 | 0; //@line 5240
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5240
 $1 = $0; //@line 5241
 $2 = $1; //@line 5242
 $3 = $2 + 8 | 0; //@line 5243
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 5244
 STACKTOP = sp; //@line 5245
 return $4 | 0; //@line 5245
}
function _cpfabs($0) {
 $0 = +$0; //@line 231
 var $1 = 0.0, $2 = 0.0, $3 = 0, $4 = 0.0, $5 = 0.0, $6 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 233
 STACKTOP = STACKTOP + 16 | 0; //@line 234
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 234
 $1 = $0; //@line 235
 $2 = $1; //@line 236
 $3 = $2 < 0.0; //@line 237
 $4 = $1; //@line 238
 $5 = -$4; //@line 239
 $6 = $3 ? $5 : $4; //@line 240
 STACKTOP = sp; //@line 241
 return +$6;
}
function SAFE_HEAP_STORE_D(dest, value, bytes) {
 dest = dest | 0; //@line 55
 value = +value; //@line 56
 bytes = bytes | 0; //@line 57
 if ((dest | 0) <= 0) segfault(); //@line 58
 if ((dest + bytes | 0) > (HEAP32[DYNAMICTOP_PTR >> 2] | 0)) segfault(); //@line 59
 if ((bytes | 0) == 8) {
  if (dest & 7) alignfault(); //@line 61
  HEAPF64[dest >> 3] = value; //@line 62
 } else {
  if (dest & 3) alignfault(); //@line 64
  HEAPF32[dest >> 2] = value; //@line 65
 }
}
function _cpSpaceGetUserData($0) {
 $0 = $0 | 0; //@line 977
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0; //@line 978
 sp = STACKTOP; //@line 979
 STACKTOP = STACKTOP + 16 | 0; //@line 980
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 980
 $1 = $0; //@line 981
 $2 = $1; //@line 982
 $3 = $2 + 68 | 0; //@line 983
 $4 = SAFE_HEAP_LOAD($3 | 0, 4, 0) | 0 | 0; //@line 984
 STACKTOP = sp; //@line 985
 return $4 | 0; //@line 985
}
function _cpBodyGetAngularVelocity($0) {
 $0 = $0 | 0; //@line 7300
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0.0, label = 0, sp = 0; //@line 7301
 sp = STACKTOP; //@line 7302
 STACKTOP = STACKTOP + 16 | 0; //@line 7303
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7303
 $1 = $0; //@line 7304
 $2 = $1; //@line 7305
 $3 = $2 + 112 | 0; //@line 7306
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 7307
 STACKTOP = sp; //@line 7308
 return +$4;
}
function _cpConstraintGetErrorBias($0) {
 $0 = $0 | 0; //@line 2074
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0.0, label = 0, sp = 0; //@line 2075
 sp = STACKTOP; //@line 2076
 STACKTOP = STACKTOP + 16 | 0; //@line 2077
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2077
 $1 = $0; //@line 2078
 $2 = $1; //@line 2079
 $3 = $2 + 32 | 0; //@line 2080
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 2081
 STACKTOP = sp; //@line 2082
 return +$4;
}
function _cpBodyNewKinematic() {
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0; //@line 6386
 sp = STACKTOP; //@line 6387
 STACKTOP = STACKTOP + 16 | 0; //@line 6388
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 6388
 $1 = _cpBodyNew(0.0, 0.0) | 0; //@line 6389
 $0 = $1; //@line 6390
 $2 = $0; //@line 6391
 _cpBodySetType($2, 1); //@line 6392
 $3 = $0; //@line 6393
 STACKTOP = sp; //@line 6394
 return $3 | 0; //@line 6394
}
function _cpConstraintGetMaxForce($0) {
 $0 = $0 | 0; //@line 2018
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0.0, label = 0, sp = 0; //@line 2019
 sp = STACKTOP; //@line 2020
 STACKTOP = STACKTOP + 16 | 0; //@line 2021
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2021
 $1 = $0; //@line 2022
 $2 = $1; //@line 2023
 $3 = $2 + 24 | 0; //@line 2024
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 2025
 STACKTOP = sp; //@line 2026
 return +$4;
}
function _cpConstraintGetMaxBias($0) {
 $0 = $0 | 0; //@line 2110
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0.0, label = 0, sp = 0; //@line 2111
 sp = STACKTOP; //@line 2112
 STACKTOP = STACKTOP + 16 | 0; //@line 2113
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2113
 $1 = $0; //@line 2114
 $2 = $1; //@line 2115
 $3 = $2 + 40 | 0; //@line 2116
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 2117
 STACKTOP = sp; //@line 2118
 return +$4;
}
function _cpBodyNewStatic() {
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0; //@line 6986
 sp = STACKTOP; //@line 6987
 STACKTOP = STACKTOP + 16 | 0; //@line 6988
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 6988
 $1 = _cpBodyNew(0.0, 0.0) | 0; //@line 6989
 $0 = $1; //@line 6990
 $2 = $0; //@line 6991
 _cpBodySetType($2, 2); //@line 6992
 $3 = $0; //@line 6993
 STACKTOP = sp; //@line 6994
 return $3 | 0; //@line 6994
}
function _cpShapeGetElasticity($0) {
 $0 = $0 | 0; //@line 5348
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0.0, label = 0, sp = 0; //@line 5349
 sp = STACKTOP; //@line 5350
 STACKTOP = STACKTOP + 16 | 0; //@line 5351
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5351
 $1 = $0; //@line 5352
 $2 = $1; //@line 5353
 $3 = $2 + 96 | 0; //@line 5354
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 5355
 STACKTOP = sp; //@line 5356
 return +$4;
}
function _cpShapeGetFriction($0) {
 $0 = $0 | 0; //@line 5386
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0.0, label = 0, sp = 0; //@line 5387
 sp = STACKTOP; //@line 5388
 STACKTOP = STACKTOP + 16 | 0; //@line 5389
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 5389
 $1 = $0; //@line 5390
 $2 = $1; //@line 5391
 $3 = $2 + 104 | 0; //@line 5392
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 5393
 STACKTOP = sp; //@line 5394
 return +$4;
}
function _cpSpaceGetSleepTimeThreshold($0) {
 $0 = $0 | 0; //@line 902
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0.0, label = 0, sp = 0; //@line 903
 sp = STACKTOP; //@line 904
 STACKTOP = STACKTOP + 16 | 0; //@line 905
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 905
 $1 = $0; //@line 906
 $2 = $1; //@line 907
 $3 = $2 + 40 | 0; //@line 908
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 909
 STACKTOP = sp; //@line 910
 return +$4;
}
function _cpSpaceGetIdleSpeedThreshold($0) {
 $0 = $0 | 0; //@line 877
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0.0, label = 0, sp = 0; //@line 878
 sp = STACKTOP; //@line 879
 STACKTOP = STACKTOP + 16 | 0; //@line 880
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 880
 $1 = $0; //@line 881
 $2 = $1; //@line 882
 $3 = $2 + 32 | 0; //@line 883
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 884
 STACKTOP = sp; //@line 885
 return +$4;
}
function _cpBodyGetAngle($0) {
 $0 = $0 | 0; //@line 7289
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0.0, label = 0, sp = 0; //@line 7290
 sp = STACKTOP; //@line 7291
 STACKTOP = STACKTOP + 16 | 0; //@line 7292
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7292
 $1 = $0; //@line 7293
 $2 = $1; //@line 7294
 $3 = $2 + 104 | 0; //@line 7295
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 7296
 STACKTOP = sp; //@line 7297
 return +$4;
}
function _cpSpaceGetCollisionSlop($0) {
 $0 = $0 | 0; //@line 927
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0.0, label = 0, sp = 0; //@line 928
 sp = STACKTOP; //@line 929
 STACKTOP = STACKTOP + 16 | 0; //@line 930
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 930
 $1 = $0; //@line 931
 $2 = $1; //@line 932
 $3 = $2 + 48 | 0; //@line 933
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 934
 STACKTOP = sp; //@line 935
 return +$4;
}
function _cpSpaceGetCollisionBias($0) {
 $0 = $0 | 0; //@line 952
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0.0, label = 0, sp = 0; //@line 953
 sp = STACKTOP; //@line 954
 STACKTOP = STACKTOP + 16 | 0; //@line 955
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 955
 $1 = $0; //@line 956
 $2 = $1; //@line 957
 $3 = $2 + 56 | 0; //@line 958
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 959
 STACKTOP = sp; //@line 960
 return +$4;
}
function _cpBodyGetMass($0) {
 $0 = $0 | 0; //@line 7036
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0.0, label = 0, sp = 0; //@line 7037
 sp = STACKTOP; //@line 7038
 STACKTOP = STACKTOP + 16 | 0; //@line 7039
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7039
 $1 = $0; //@line 7040
 $2 = $1; //@line 7041
 $3 = $2 + 8 | 0; //@line 7042
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 7043
 STACKTOP = sp; //@line 7044
 return +$4;
}
function _cpSpaceGetDamping($0) {
 $0 = $0 | 0; //@line 843
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0.0, label = 0, sp = 0; //@line 844
 sp = STACKTOP; //@line 845
 STACKTOP = STACKTOP + 16 | 0; //@line 846
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 846
 $1 = $0; //@line 847
 $2 = $1; //@line 848
 $3 = $2 + 24 | 0; //@line 849
 $4 = +(+SAFE_HEAP_LOAD_D($3 | 0, 8)); //@line 850
 STACKTOP = sp; //@line 851
 return +$4;
}
function _cpfclamp01_372($0) {
 $0 = +$0; //@line 6987
 var $1 = 0.0, $2 = 0.0, $3 = 0.0, $4 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 6989
 STACKTOP = STACKTOP + 16 | 0; //@line 6990
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 6990
 $1 = $0; //@line 6991
 $2 = $1; //@line 6992
 $3 = +_cpfmin_373($2, 1.0); //@line 6993
 $4 = +_cpfmax_374(0.0, $3); //@line 6994
 STACKTOP = sp; //@line 6995
 return +$4;
}
function _cpfclamp01_279($0) {
 $0 = +$0; //@line 4886
 var $1 = 0.0, $2 = 0.0, $3 = 0.0, $4 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 4888
 STACKTOP = STACKTOP + 16 | 0; //@line 4889
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 4889
 $1 = $0; //@line 4890
 $2 = $1; //@line 4891
 $3 = +_cpfmin_280($2, 1.0); //@line 4892
 $4 = +_cpfmax_281(0.0, $3); //@line 4893
 STACKTOP = sp; //@line 4894
 return +$4;
}
function _PostStepDoNothing($0, $1, $2) {
 $0 = $0 | 0; //@line 4113
 $1 = $1 | 0; //@line 4114
 $2 = $2 | 0; //@line 4115
 var $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0; //@line 4116
 sp = STACKTOP; //@line 4117
 STACKTOP = STACKTOP + 16 | 0; //@line 4118
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 4118
 $3 = $0; //@line 4119
 $4 = $1; //@line 4120
 $5 = $2; //@line 4121
 STACKTOP = sp; //@line 4122
 return;
}
function _AlwaysCollide($0, $1, $2) {
 $0 = $0 | 0; //@line 164
 $1 = $1 | 0; //@line 165
 $2 = $2 | 0; //@line 166
 var $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0; //@line 167
 sp = STACKTOP; //@line 168
 STACKTOP = STACKTOP + 16 | 0; //@line 169
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 169
 $3 = $0; //@line 170
 $4 = $1; //@line 171
 $5 = $2; //@line 172
 STACKTOP = sp; //@line 173
 return 1; //@line 173
}
function _bitshift64Shl(low, high, bits) {
 low = low | 0; //@line 14422
 high = high | 0; //@line 14422
 bits = bits | 0; //@line 14422
 var ander = 0; //@line 14423
 if ((bits | 0) < 32) {
  ander = (1 << bits) - 1 | 0; //@line 14425
  setTempRet0(high << bits | (low & ander << 32 - bits) >>> 32 - bits | 0); //@line 14426
  return low << bits; //@line 14427
 }
 setTempRet0(low << bits - 32 | 0); //@line 14429
 return 0; //@line 14430
}
function _cpBodyActivateWrap($0, $1) {
 $0 = $0 | 0; //@line 606
 $1 = $1 | 0; //@line 607
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0; //@line 608
 sp = STACKTOP; //@line 609
 STACKTOP = STACKTOP + 16 | 0; //@line 610
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 610
 $2 = $0; //@line 611
 $3 = $1; //@line 612
 $4 = $2; //@line 613
 _cpBodyActivate($4); //@line 614
 STACKTOP = sp; //@line 615
 return;
}
function _bitshift64Lshr(low, high, bits) {
 low = low | 0; //@line 14411
 high = high | 0; //@line 14411
 bits = bits | 0; //@line 14411
 var ander = 0; //@line 14412
 if ((bits | 0) < 32) {
  ander = (1 << bits) - 1 | 0; //@line 14414
  setTempRet0(high >>> bits | 0); //@line 14415
  return low >>> bits | (high & ander) << 32 - bits; //@line 14416
 }
 setTempRet0(0 | 0); //@line 14418
 return high >>> bits - 32 | 0; //@line 14419
}
function _cpHashSetCount($0) {
 $0 = $0 | 0; //@line 2282
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0; //@line 2283
 sp = STACKTOP; //@line 2284
 STACKTOP = STACKTOP + 16 | 0; //@line 2285
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 2285
 $1 = $0; //@line 2286
 $2 = $1; //@line 2287
 $3 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 2288
 STACKTOP = sp; //@line 2289
 return $3 | 0; //@line 2289
}
function _cpArbiterIgnore($0) {
 $0 = $0 | 0; //@line 987
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0; //@line 988
 sp = STACKTOP; //@line 989
 STACKTOP = STACKTOP + 16 | 0; //@line 990
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 990
 $1 = $0; //@line 991
 $2 = $1; //@line 992
 $3 = $2 + 116 | 0; //@line 993
 SAFE_HEAP_STORE($3 | 0, 2 | 0, 4);
 STACKTOP = sp; //@line 995
 return 0; //@line 995
}
function _cpfclamp01($0) {
 $0 = +$0; //@line 565
 var $1 = 0.0, $2 = 0.0, $3 = 0.0, $4 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 567
 STACKTOP = STACKTOP + 16 | 0; //@line 568
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 568
 $1 = $0; //@line 569
 $2 = $1; //@line 570
 $3 = +_cpfmin_73($2, 1.0); //@line 571
 $4 = +_cpfmax_74(0.0, $3); //@line 572
 STACKTOP = sp; //@line 573
 return +$4;
}
function _cpSpaceGetIterations($0) {
 $0 = $0 | 0; //@line 762
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0; //@line 763
 sp = STACKTOP; //@line 764
 STACKTOP = STACKTOP + 16 | 0; //@line 765
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 765
 $1 = $0; //@line 766
 $2 = $1; //@line 767
 $3 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 768
 STACKTOP = sp; //@line 769
 return $3 | 0; //@line 769
}
function ___syscall_ret($0) {
 $0 = $0 | 0; //@line 10699
 var $$0 = 0, $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0; //@line 10700
 sp = STACKTOP; //@line 10701
 $1 = $0 >>> 0 > 4294963200; //@line 10702
 if ($1) {
  $2 = 0 - $0 | 0; //@line 10704
  $3 = ___errno_location() | 0; //@line 10705
  SAFE_HEAP_STORE($3 | 0, $2 | 0, 4);
  $$0 = -1; //@line 10707
 } else {
  $$0 = $0; //@line 10709
 }
 return $$0 | 0; //@line 10711
}
function _DoNothing($0, $1, $2) {
 $0 = $0 | 0; //@line 176
 $1 = $1 | 0; //@line 177
 $2 = $2 | 0; //@line 178
 var $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0; //@line 179
 sp = STACKTOP; //@line 180
 STACKTOP = STACKTOP + 16 | 0; //@line 181
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 181
 $3 = $0; //@line 182
 $4 = $1; //@line 183
 $5 = $2; //@line 184
 STACKTOP = sp; //@line 185
 return;
}
function _FreeWrap($0, $1) {
 $0 = $0 | 0; //@line 733
 $1 = $1 | 0; //@line 734
 var $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0; //@line 735
 sp = STACKTOP; //@line 736
 STACKTOP = STACKTOP + 16 | 0; //@line 737
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 737
 $2 = $0; //@line 738
 $3 = $1; //@line 739
 $4 = $2; //@line 740
 _free($4); //@line 741
 STACKTOP = sp; //@line 742
 return;
}
function _cpvneg_406($0, $1) {
 $0 = $0 | 0; //@line 7817
 $1 = $1 | 0; //@line 7818
 var $2 = 0.0, $3 = 0.0, $4 = 0, $5 = 0.0, $6 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 7820
 $2 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 7821
 $3 = -$2; //@line 7822
 $4 = $1 + 8 | 0; //@line 7823
 $5 = +(+SAFE_HEAP_LOAD_D($4 | 0, 8)); //@line 7824
 $6 = -$5; //@line 7825
 _cpv_410($0, $3, $6); //@line 7826
 return;
}
function _cpvneg_360($0, $1) {
 $0 = $0 | 0; //@line 5765
 $1 = $1 | 0; //@line 5766
 var $2 = 0.0, $3 = 0.0, $4 = 0, $5 = 0.0, $6 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 5768
 $2 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 5769
 $3 = -$2; //@line 5770
 $4 = $1 + 8 | 0; //@line 5771
 $5 = +(+SAFE_HEAP_LOAD_D($4 | 0, 8)); //@line 5772
 $6 = -$5; //@line 5773
 _cpv_358($0, $3, $6); //@line 5774
 return;
}
function _cpvneg_284($0, $1) {
 $0 = $0 | 0; //@line 4986
 $1 = $1 | 0; //@line 4987
 var $2 = 0.0, $3 = 0.0, $4 = 0, $5 = 0.0, $6 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 4989
 $2 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 4990
 $3 = -$2; //@line 4991
 $4 = $1 + 8 | 0; //@line 4992
 $5 = +(+SAFE_HEAP_LOAD_D($4 | 0, 8)); //@line 4993
 $6 = -$5; //@line 4994
 _cpv_271($0, $3, $6); //@line 4995
 return;
}
function _cpvneg_247($0, $1) {
 $0 = $0 | 0; //@line 3389
 $1 = $1 | 0; //@line 3390
 var $2 = 0.0, $3 = 0.0, $4 = 0, $5 = 0.0, $6 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 3392
 $2 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3393
 $3 = -$2; //@line 3394
 $4 = $1 + 8 | 0; //@line 3395
 $5 = +(+SAFE_HEAP_LOAD_D($4 | 0, 8)); //@line 3396
 $6 = -$5; //@line 3397
 _cpv_251($0, $3, $6); //@line 3398
 return;
}
function dynCall_viiiidii(index, a1, a2, a3, a4, a5, a6, a7) {
 index = index | 0; //@line 604
 a1 = a1 | 0; //@line 605
 a2 = a2 | 0; //@line 605
 a3 = a3 | 0; //@line 605
 a4 = a4 | 0; //@line 605
 a5 = +a5; //@line 605
 a6 = a6 | 0; //@line 605
 a7 = a7 | 0; //@line 605
 FUNCTION_TABLE_viiiidii[(SAFE_FT_MASK(index | 0, 15 | 0) | 0) & 15](a1 | 0, a2 | 0, a3 | 0, a4 | 0, +a5, a6 | 0, a7 | 0); //@line 606
}
function _cpvneg_62($0, $1) {
 $0 = $0 | 0; //@line 275
 $1 = $1 | 0; //@line 276
 var $2 = 0.0, $3 = 0.0, $4 = 0, $5 = 0.0, $6 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 278
 $2 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 279
 $3 = -$2; //@line 280
 $4 = $1 + 8 | 0; //@line 281
 $5 = +(+SAFE_HEAP_LOAD_D($4 | 0, 8)); //@line 282
 $6 = -$5; //@line 283
 _cpv_72($0, $3, $6); //@line 284
 return;
}
function _cpvneg($0, $1) {
 $0 = $0 | 0; //@line 947
 $1 = $1 | 0; //@line 948
 var $2 = 0.0, $3 = 0.0, $4 = 0, $5 = 0.0, $6 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 950
 $2 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 951
 $3 = -$2; //@line 952
 $4 = $1 + 8 | 0; //@line 953
 $5 = +(+SAFE_HEAP_LOAD_D($4 | 0, 8)); //@line 954
 $6 = -$5; //@line 955
 _cpv_2($0, $3, $6); //@line 956
 return;
}
function _cpBBTreeReindex($0) {
 $0 = $0 | 0; //@line 3162
 var $1 = 0, $2 = 0, label = 0, sp = 0; //@line 3163
 sp = STACKTOP; //@line 3164
 STACKTOP = STACKTOP + 16 | 0; //@line 3165
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3165
 $1 = $0; //@line 3166
 $2 = $1; //@line 3167
 _cpBBTreeReindexQuery($2, 51, 0); //@line 3168
 STACKTOP = sp; //@line 3169
 return;
}
function ___DOUBLE_BITS_662($0) {
 $0 = +$0; //@line 13873
 var $1 = 0, $2 = 0, label = 0, sp = 0; //@line 13874
 sp = STACKTOP; //@line 13875
 SAFE_HEAP_STORE_D(tempDoublePtr | 0, +$0, 8);
 $1 = SAFE_HEAP_LOAD(tempDoublePtr | 0, 4, 0) | 0 | 0; //@line 13876
 $2 = SAFE_HEAP_LOAD(tempDoublePtr + 4 | 0, 4, 0) | 0 | 0; //@line 13877
 setTempRet0($2 | 0); //@line 13878
 return $1 | 0; //@line 13879
}
function SAFE_HEAP_LOAD_D(dest, bytes) {
 dest = dest | 0; //@line 89
 bytes = bytes | 0; //@line 90
 if ((dest | 0) <= 0) segfault(); //@line 91
 if ((dest + bytes | 0) > (HEAP32[DYNAMICTOP_PTR >> 2] | 0)) segfault(); //@line 92
 if ((bytes | 0) == 8) {
  if (dest & 7) alignfault(); //@line 94
  return +HEAPF64[dest >> 3];
 }
 if (dest & 3) alignfault(); //@line 97
 return +HEAPF32[dest >> 2];
}
function _out_655($0, $1, $2) {
 $0 = $0 | 0; //@line 12376
 $1 = $1 | 0; //@line 12377
 $2 = $2 | 0; //@line 12378
 var $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0; //@line 12379
 sp = STACKTOP; //@line 12380
 $3 = SAFE_HEAP_LOAD($0 | 0, 4, 0) | 0 | 0; //@line 12381
 $4 = $3 & 32; //@line 12382
 $5 = ($4 | 0) == 0; //@line 12383
 if ($5) {
  ___fwritex($1, $2, $0) | 0; //@line 12385
 }
 return;
}
function _cpvrperp_368($0, $1) {
 $0 = $0 | 0; //@line 6408
 $1 = $1 | 0; //@line 6409
 var $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0.0, label = 0, sp = 0; //@line 6410
 sp = STACKTOP; //@line 6411
 $2 = $1 + 8 | 0; //@line 6412
 $3 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 6413
 $4 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 6414
 $5 = -$4; //@line 6415
 _cpv_358($0, $3, $5); //@line 6416
 return;
}
function _cpvrperp_267($0, $1) {
 $0 = $0 | 0; //@line 3998
 $1 = $1 | 0; //@line 3999
 var $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0.0, label = 0, sp = 0; //@line 4000
 sp = STACKTOP; //@line 4001
 $2 = $1 + 8 | 0; //@line 4002
 $3 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 4003
 $4 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 4004
 $5 = -$4; //@line 4005
 _cpv_271($0, $3, $5); //@line 4006
 return;
}
function _cpvperp_413($0, $1) {
 $0 = $0 | 0; //@line 7956
 $1 = $1 | 0; //@line 7957
 var $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0.0, label = 0, sp = 0; //@line 7958
 sp = STACKTOP; //@line 7959
 $2 = $1 + 8 | 0; //@line 7960
 $3 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 7961
 $4 = -$3; //@line 7962
 $5 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 7963
 _cpv_410($0, $4, $5); //@line 7964
 return;
}
function _cpvperp_253($0, $1) {
 $0 = $0 | 0; //@line 3513
 $1 = $1 | 0; //@line 3514
 var $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0.0, label = 0, sp = 0; //@line 3515
 sp = STACKTOP; //@line 3516
 $2 = $1 + 8 | 0; //@line 3517
 $3 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 3518
 $4 = -$3; //@line 3519
 $5 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 3520
 _cpv_251($0, $4, $5); //@line 3521
 return;
}
function _cpvrperp($0, $1) {
 $0 = $0 | 0; //@line 1716
 $1 = $1 | 0; //@line 1717
 var $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0.0, label = 0, sp = 0; //@line 1718
 sp = STACKTOP; //@line 1719
 $2 = $1 + 8 | 0; //@line 1720
 $3 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 1721
 $4 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 1722
 $5 = -$4; //@line 1723
 _cpv_72($0, $3, $5); //@line 1724
 return;
}
function _cpBodySleep($0) {
 $0 = $0 | 0; //@line 3423
 var $1 = 0, $2 = 0, label = 0, sp = 0; //@line 3424
 sp = STACKTOP; //@line 3425
 STACKTOP = STACKTOP + 16 | 0; //@line 3426
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 3426
 $1 = $0; //@line 3427
 $2 = $1; //@line 3428
 _cpBodySleepWithGroup($2, 0); //@line 3429
 STACKTOP = sp; //@line 3430
 return;
}
function _cpvperp($0, $1) {
 $0 = $0 | 0; //@line 1996
 $1 = $1 | 0; //@line 1997
 var $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0.0, label = 0, sp = 0; //@line 1998
 sp = STACKTOP; //@line 1999
 $2 = $1 + 8 | 0; //@line 2000
 $3 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 2001
 $4 = -$3; //@line 2002
 $5 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 2003
 _cpv_2($0, $4, $5); //@line 2004
 return;
}
function _cpvperp_75($0, $1) {
 $0 = $0 | 0; //@line 925
 $1 = $1 | 0; //@line 926
 var $2 = 0, $3 = 0.0, $4 = 0.0, $5 = 0.0, label = 0, sp = 0; //@line 927
 sp = STACKTOP; //@line 928
 $2 = $1 + 8 | 0; //@line 929
 $3 = +(+SAFE_HEAP_LOAD_D($2 | 0, 8)); //@line 930
 $4 = -$3; //@line 931
 $5 = +(+SAFE_HEAP_LOAD_D($1 | 0, 8)); //@line 932
 _cpv_72($0, $4, $5); //@line 933
 return;
}
function _wctomb($0, $1) {
 $0 = $0 | 0; //@line 12897
 $1 = $1 | 0; //@line 12898
 var $$0 = 0, $2 = 0, $3 = 0, label = 0, sp = 0; //@line 12899
 sp = STACKTOP; //@line 12900
 $2 = ($0 | 0) == (0 | 0); //@line 12901
 if ($2) {
  $$0 = 0; //@line 12903
 } else {
  $3 = _wcrtomb($0, $1, 0) | 0; //@line 12905
  $$0 = $3; //@line 12906
 }
 return $$0 | 0; //@line 12908
}
function _strerror($0) {
 $0 = $0 | 0; //@line 12844
 var $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0; //@line 12845
 sp = STACKTOP; //@line 12846
 $1 = ___pthread_self_78() | 0; //@line 12847
 $2 = $1 + 188 | 0; //@line 12848
 $3 = SAFE_HEAP_LOAD($2 | 0, 4, 0) | 0 | 0; //@line 12849
 $4 = ___strerror_l($0, $3) | 0; //@line 12850
 return $4 | 0; //@line 12851
}
function _swapc($0, $1) {
 $0 = $0 | 0; //@line 11086
 $1 = $1 | 0; //@line 11087
 var $2 = 0, $3 = 0, $spec$select = 0, label = 0, sp = 0; //@line 11088
 sp = STACKTOP; //@line 11089
 $2 = ($1 | 0) == 0; //@line 11090
 $3 = _llvm_bswap_i32($0 | 0) | 0; //@line 11091
 $spec$select = $2 ? $0 : $3; //@line 11092
 return $spec$select | 0; //@line 11093
}
function _i64Subtract(a, b, c, d) {
 a = a | 0; //@line 14183
 b = b | 0; //@line 14183
 c = c | 0; //@line 14183
 d = d | 0; //@line 14183
 var l = 0, h = 0; //@line 14184
 l = a - c >>> 0; //@line 14185
 h = b - d >>> 0; //@line 14186
 h = b - d - (c >>> 0 > a >>> 0 | 0) >>> 0; //@line 14187
 return (setTempRet0(h | 0), l | 0) | 0; //@line 14188
}
function dynCall_viiiii(index, a1, a2, a3, a4, a5) {
 index = index | 0; //@line 639
 a1 = a1 | 0; //@line 640
 a2 = a2 | 0; //@line 640
 a3 = a3 | 0; //@line 640
 a4 = a4 | 0; //@line 640
 a5 = a5 | 0; //@line 640
 FUNCTION_TABLE_viiiii[(SAFE_FT_MASK(index | 0, 15 | 0) | 0) & 15](a1 | 0, a2 | 0, a3 | 0, a4 | 0, a5 | 0); //@line 641
}
function dynCall_viiidi(index, a1, a2, a3, a4, a5) {
 index = index | 0; //@line 569
 a1 = a1 | 0; //@line 570
 a2 = a2 | 0; //@line 570
 a3 = a3 | 0; //@line 570
 a4 = +a4; //@line 570
 a5 = a5 | 0; //@line 570
 FUNCTION_TABLE_viiidi[(SAFE_FT_MASK(index | 0, 63 | 0) | 0) & 63](a1 | 0, a2 | 0, a3 | 0, +a4, a5 | 0); //@line 571
}
function dynCall_viidii(index, a1, a2, a3, a4, a5) {
 index = index | 0; //@line 499
 a1 = a1 | 0; //@line 500
 a2 = a2 | 0; //@line 500
 a3 = +a3; //@line 500
 a4 = a4 | 0; //@line 500
 a5 = a5 | 0; //@line 500
 FUNCTION_TABLE_viidii[(SAFE_FT_MASK(index | 0, 7 | 0) | 0) & 7](a1 | 0, a2 | 0, +a3, a4 | 0, a5 | 0); //@line 501
}
function _cpConstraintDestroy($0) {
 $0 = $0 | 0; //@line 1939
 var $1 = 0, label = 0, sp = 0; //@line 1940
 sp = STACKTOP; //@line 1941
 STACKTOP = STACKTOP + 16 | 0; //@line 1942
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 1942
 $1 = $0; //@line 1943
 STACKTOP = sp; //@line 1944
 return;
}
function jsCall_viiiidii_3(a1, a2, a3, a4, a5, a6, a7) {
 a1 = a1 | 0; //@line 632
 a2 = a2 | 0; //@line 632
 a3 = a3 | 0; //@line 632
 a4 = a4 | 0; //@line 632
 a5 = +a5; //@line 632
 a6 = a6 | 0; //@line 632
 a7 = a7 | 0; //@line 632
 jsCall_viiiidii(3, a1 | 0, a2 | 0, a3 | 0, a4 | 0, +a5, a6 | 0, a7 | 0); //@line 633
}
function jsCall_viiiidii_2(a1, a2, a3, a4, a5, a6, a7) {
 a1 = a1 | 0; //@line 625
 a2 = a2 | 0; //@line 625
 a3 = a3 | 0; //@line 625
 a4 = a4 | 0; //@line 625
 a5 = +a5; //@line 625
 a6 = a6 | 0; //@line 625
 a7 = a7 | 0; //@line 625
 jsCall_viiiidii(2, a1 | 0, a2 | 0, a3 | 0, a4 | 0, +a5, a6 | 0, a7 | 0); //@line 626
}
function jsCall_viiiidii_1(a1, a2, a3, a4, a5, a6, a7) {
 a1 = a1 | 0; //@line 618
 a2 = a2 | 0; //@line 618
 a3 = a3 | 0; //@line 618
 a4 = a4 | 0; //@line 618
 a5 = +a5; //@line 618
 a6 = a6 | 0; //@line 618
 a7 = a7 | 0; //@line 618
 jsCall_viiiidii(1, a1 | 0, a2 | 0, a3 | 0, a4 | 0, +a5, a6 | 0, a7 | 0); //@line 619
}
function jsCall_viiiidii_0(a1, a2, a3, a4, a5, a6, a7) {
 a1 = a1 | 0; //@line 611
 a2 = a2 | 0; //@line 611
 a3 = a3 | 0; //@line 611
 a4 = a4 | 0; //@line 611
 a5 = +a5; //@line 611
 a6 = a6 | 0; //@line 611
 a7 = a7 | 0; //@line 611
 jsCall_viiiidii(0, a1 | 0, a2 | 0, a3 | 0, a4 | 0, +a5, a6 | 0, a7 | 0); //@line 612
}
function _cpBodyDestroy($0) {
 $0 = $0 | 0; //@line 6997
 var $1 = 0, label = 0, sp = 0; //@line 6998
 sp = STACKTOP; //@line 6999
 STACKTOP = STACKTOP + 16 | 0; //@line 7000
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(16 | 0); //@line 7000
 $1 = $0; //@line 7001
 STACKTOP = sp; //@line 7002
 return;
}
function _i64Add(a, b, c, d) {
 a = a | 0; //@line 14176
 b = b | 0; //@line 14176
 c = c | 0; //@line 14176
 d = d | 0; //@line 14176
 var l = 0, h = 0; //@line 14177
 l = a + c >>> 0; //@line 14178
 h = b + d + (l >>> 0 < a >>> 0 | 0) >>> 0; //@line 14179
 return (setTempRet0(h | 0), l | 0) | 0; //@line 14180
}
function dynCall_iiiii(index, a1, a2, a3, a4) {
 index = index | 0; //@line 324
 a1 = a1 | 0; //@line 325
 a2 = a2 | 0; //@line 325
 a3 = a3 | 0; //@line 325
 a4 = a4 | 0; //@line 325
 return FUNCTION_TABLE_iiiii[(SAFE_FT_MASK(index | 0, 127 | 0) | 0) & 127](a1 | 0, a2 | 0, a3 | 0, a4 | 0) | 0; //@line 326
}
function ___udivdi3($a$0, $a$1, $b$0, $b$1) {
 $a$0 = $a$0 | 0; //@line 14402
 $a$1 = $a$1 | 0; //@line 14403
 $b$0 = $b$0 | 0; //@line 14404
 $b$1 = $b$1 | 0; //@line 14405
 var $1$0 = 0; //@line 14406
 $1$0 = ___udivmoddi4($a$0, $a$1, $b$0, $b$1, 0) | 0; //@line 14407
 return $1$0 | 0; //@line 14408
}
function stackAlloc(size) {
 size = size | 0; //@line 2
 var ret = 0; //@line 3
 ret = STACKTOP; //@line 4
 STACKTOP = STACKTOP + size | 0; //@line 5
 STACKTOP = STACKTOP + 15 & -16; //@line 6
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(size | 0); //@line 7
 return ret | 0; //@line 9
}
function dynCall_viidd(index, a1, a2, a3, a4) {
 index = index | 0; //@line 464
 a1 = a1 | 0; //@line 465
 a2 = a2 | 0; //@line 465
 a3 = +a3; //@line 465
 a4 = +a4; //@line 465
 FUNCTION_TABLE_viidd[(SAFE_FT_MASK(index | 0, 63 | 0) | 0) & 63](a1 | 0, a2 | 0, +a3, +a4); //@line 466
}
function _isdigit($0) {
 $0 = $0 | 0; //@line 10758
 var $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0; //@line 10759
 sp = STACKTOP; //@line 10760
 $1 = $0 + -48 | 0; //@line 10761
 $2 = $1 >>> 0 < 10; //@line 10762
 $3 = $2 & 1; //@line 10763
 return $3 | 0; //@line 10764
}
function dynCall_iiii(index, a1, a2, a3) {
 index = index | 0; //@line 289
 a1 = a1 | 0; //@line 290
 a2 = a2 | 0; //@line 290
 a3 = a3 | 0; //@line 290
 return FUNCTION_TABLE_iiii[(SAFE_FT_MASK(index | 0, 127 | 0) | 0) & 127](a1 | 0, a2 | 0, a3 | 0) | 0; //@line 291
}
function b13(p0, p1, p2, p3, p4, p5, p6) {
 p0 = p0 | 0; //@line 712
 p1 = p1 | 0; //@line 712
 p2 = p2 | 0; //@line 712
 p3 = p3 | 0; //@line 712
 p4 = +p4; //@line 712
 p5 = p5 | 0; //@line 712
 p6 = p6 | 0; //@line 712
 nullFunc_viiiidii(13); //@line 712
}
function dynCall_viii(index, a1, a2, a3) {
 index = index | 0; //@line 534
 a1 = a1 | 0; //@line 535
 a2 = a2 | 0; //@line 535
 a3 = a3 | 0; //@line 535
 FUNCTION_TABLE_viii[(SAFE_FT_MASK(index | 0, 127 | 0) | 0) & 127](a1 | 0, a2 | 0, a3 | 0); //@line 536
}
function dynCall_diii(index, a1, a2, a3) {
 index = index | 0; //@line 184
 a1 = a1 | 0; //@line 185
 a2 = a2 | 0; //@line 185
 a3 = a3 | 0; //@line 185
 return +FUNCTION_TABLE_diii[(SAFE_FT_MASK(index | 0, 7 | 0) | 0) & 7](a1 | 0, a2 | 0, a3 | 0);
}
function jsCall_viiiii_3(a1, a2, a3, a4, a5) {
 a1 = a1 | 0; //@line 667
 a2 = a2 | 0; //@line 667
 a3 = a3 | 0; //@line 667
 a4 = a4 | 0; //@line 667
 a5 = a5 | 0; //@line 667
 jsCall_viiiii(3, a1 | 0, a2 | 0, a3 | 0, a4 | 0, a5 | 0); //@line 668
}
function jsCall_viiiii_2(a1, a2, a3, a4, a5) {
 a1 = a1 | 0; //@line 660
 a2 = a2 | 0; //@line 660
 a3 = a3 | 0; //@line 660
 a4 = a4 | 0; //@line 660
 a5 = a5 | 0; //@line 660
 jsCall_viiiii(2, a1 | 0, a2 | 0, a3 | 0, a4 | 0, a5 | 0); //@line 661
}
function jsCall_viiiii_1(a1, a2, a3, a4, a5) {
 a1 = a1 | 0; //@line 653
 a2 = a2 | 0; //@line 653
 a3 = a3 | 0; //@line 653
 a4 = a4 | 0; //@line 653
 a5 = a5 | 0; //@line 653
 jsCall_viiiii(1, a1 | 0, a2 | 0, a3 | 0, a4 | 0, a5 | 0); //@line 654
}
function jsCall_viiiii_0(a1, a2, a3, a4, a5) {
 a1 = a1 | 0; //@line 646
 a2 = a2 | 0; //@line 646
 a3 = a3 | 0; //@line 646
 a4 = a4 | 0; //@line 646
 a5 = a5 | 0; //@line 646
 jsCall_viiiii(0, a1 | 0, a2 | 0, a3 | 0, a4 | 0, a5 | 0); //@line 647
}
function jsCall_viiidi_3(a1, a2, a3, a4, a5) {
 a1 = a1 | 0; //@line 597
 a2 = a2 | 0; //@line 597
 a3 = a3 | 0; //@line 597
 a4 = +a4; //@line 597
 a5 = a5 | 0; //@line 597
 jsCall_viiidi(3, a1 | 0, a2 | 0, a3 | 0, +a4, a5 | 0); //@line 598
}
function jsCall_viiidi_2(a1, a2, a3, a4, a5) {
 a1 = a1 | 0; //@line 590
 a2 = a2 | 0; //@line 590
 a3 = a3 | 0; //@line 590
 a4 = +a4; //@line 590
 a5 = a5 | 0; //@line 590
 jsCall_viiidi(2, a1 | 0, a2 | 0, a3 | 0, +a4, a5 | 0); //@line 591
}
function jsCall_viiidi_1(a1, a2, a3, a4, a5) {
 a1 = a1 | 0; //@line 583
 a2 = a2 | 0; //@line 583
 a3 = a3 | 0; //@line 583
 a4 = +a4; //@line 583
 a5 = a5 | 0; //@line 583
 jsCall_viiidi(1, a1 | 0, a2 | 0, a3 | 0, +a4, a5 | 0); //@line 584
}
function jsCall_viiidi_0(a1, a2, a3, a4, a5) {
 a1 = a1 | 0; //@line 576
 a2 = a2 | 0; //@line 576
 a3 = a3 | 0; //@line 576
 a4 = +a4; //@line 576
 a5 = a5 | 0; //@line 576
 jsCall_viiidi(0, a1 | 0, a2 | 0, a3 | 0, +a4, a5 | 0); //@line 577
}
function jsCall_viidii_3(a1, a2, a3, a4, a5) {
 a1 = a1 | 0; //@line 527
 a2 = a2 | 0; //@line 527
 a3 = +a3; //@line 527
 a4 = a4 | 0; //@line 527
 a5 = a5 | 0; //@line 527
 jsCall_viidii(3, a1 | 0, a2 | 0, +a3, a4 | 0, a5 | 0); //@line 528
}
function jsCall_viidii_2(a1, a2, a3, a4, a5) {
 a1 = a1 | 0; //@line 520
 a2 = a2 | 0; //@line 520
 a3 = +a3; //@line 520
 a4 = a4 | 0; //@line 520
 a5 = a5 | 0; //@line 520
 jsCall_viidii(2, a1 | 0, a2 | 0, +a3, a4 | 0, a5 | 0); //@line 521
}
function jsCall_viidii_1(a1, a2, a3, a4, a5) {
 a1 = a1 | 0; //@line 513
 a2 = a2 | 0; //@line 513
 a3 = +a3; //@line 513
 a4 = a4 | 0; //@line 513
 a5 = a5 | 0; //@line 513
 jsCall_viidii(1, a1 | 0, a2 | 0, +a3, a4 | 0, a5 | 0); //@line 514
}
function jsCall_viidii_0(a1, a2, a3, a4, a5) {
 a1 = a1 | 0; //@line 506
 a2 = a2 | 0; //@line 506
 a3 = +a3; //@line 506
 a4 = a4 | 0; //@line 506
 a5 = a5 | 0; //@line 506
 jsCall_viidii(0, a1 | 0, a2 | 0, +a3, a4 | 0, a5 | 0); //@line 507
}
function ___lctrans($0, $1) {
 $0 = $0 | 0; //@line 14123
 $1 = $1 | 0; //@line 14124
 var $2 = 0, label = 0, sp = 0; //@line 14125
 sp = STACKTOP; //@line 14126
 $2 = ___lctrans_impl($0, $1) | 0; //@line 14127
 return $2 | 0; //@line 14128
}
function SAFE_FT_MASK(value, mask) {
 value = value | 0; //@line 101
 mask = mask | 0; //@line 102
 var ret = 0; //@line 103
 ret = value & mask; //@line 104
 if ((ret | 0) != (value | 0)) ftfault(); //@line 105
 return ret | 0; //@line 106
}
function dynCall_iii(index, a1, a2) {
 index = index | 0; //@line 254
 a1 = a1 | 0; //@line 255
 a2 = a2 | 0; //@line 255
 return FUNCTION_TABLE_iii[(SAFE_FT_MASK(index | 0, 127 | 0) | 0) & 127](a1 | 0, a2 | 0) | 0; //@line 256
}
function jsCall_iiiii_3(a1, a2, a3, a4) {
 a1 = a1 | 0; //@line 352
 a2 = a2 | 0; //@line 352
 a3 = a3 | 0; //@line 352
 a4 = a4 | 0; //@line 352
 return jsCall_iiiii(3, a1 | 0, a2 | 0, a3 | 0, a4 | 0) | 0; //@line 353
}
function jsCall_iiiii_2(a1, a2, a3, a4) {
 a1 = a1 | 0; //@line 345
 a2 = a2 | 0; //@line 345
 a3 = a3 | 0; //@line 345
 a4 = a4 | 0; //@line 345
 return jsCall_iiiii(2, a1 | 0, a2 | 0, a3 | 0, a4 | 0) | 0; //@line 346
}
function jsCall_iiiii_1(a1, a2, a3, a4) {
 a1 = a1 | 0; //@line 338
 a2 = a2 | 0; //@line 338
 a3 = a3 | 0; //@line 338
 a4 = a4 | 0; //@line 338
 return jsCall_iiiii(1, a1 | 0, a2 | 0, a3 | 0, a4 | 0) | 0; //@line 339
}
function jsCall_iiiii_0(a1, a2, a3, a4) {
 a1 = a1 | 0; //@line 331
 a2 = a2 | 0; //@line 331
 a3 = a3 | 0; //@line 331
 a4 = a4 | 0; //@line 331
 return jsCall_iiiii(0, a1 | 0, a2 | 0, a3 | 0, a4 | 0) | 0; //@line 332
}
function dynCall_vii(index, a1, a2) {
 index = index | 0; //@line 429
 a1 = a1 | 0; //@line 430
 a2 = a2 | 0; //@line 430
 FUNCTION_TABLE_vii[(SAFE_FT_MASK(index | 0, 127 | 0) | 0) & 127](a1 | 0, a2 | 0); //@line 431
}
function _cpSpaceNew() {
 var $0 = 0, $1 = 0, label = 0, sp = 0; //@line 499
 sp = STACKTOP; //@line 500
 $0 = _cpSpaceAlloc() | 0; //@line 501
 $1 = _cpSpaceInit($0) | 0; //@line 502
 return $1 | 0; //@line 503
}
function dynCall_vid(index, a1, a2) {
 index = index | 0; //@line 394
 a1 = a1 | 0; //@line 395
 a2 = +a2; //@line 395
 FUNCTION_TABLE_vid[(SAFE_FT_MASK(index | 0, 63 | 0) | 0) & 63](a1 | 0, +a2); //@line 396
}
function b14(p0, p1, p2, p3, p4) {
 p0 = p0 | 0; //@line 715
 p1 = p1 | 0; //@line 715
 p2 = p2 | 0; //@line 715
 p3 = p3 | 0; //@line 715
 p4 = p4 | 0; //@line 715
 nullFunc_viiiii(14); //@line 715
}
function jsCall_viidd_3(a1, a2, a3, a4) {
 a1 = a1 | 0; //@line 492
 a2 = a2 | 0; //@line 492
 a3 = +a3; //@line 492
 a4 = +a4; //@line 492
 jsCall_viidd(3, a1 | 0, a2 | 0, +a3, +a4); //@line 493
}
function jsCall_viidd_2(a1, a2, a3, a4) {
 a1 = a1 | 0; //@line 485
 a2 = a2 | 0; //@line 485
 a3 = +a3; //@line 485
 a4 = +a4; //@line 485
 jsCall_viidd(2, a1 | 0, a2 | 0, +a3, +a4); //@line 486
}
function jsCall_viidd_1(a1, a2, a3, a4) {
 a1 = a1 | 0; //@line 478
 a2 = a2 | 0; //@line 478
 a3 = +a3; //@line 478
 a4 = +a4; //@line 478
 jsCall_viidd(1, a1 | 0, a2 | 0, +a3, +a4); //@line 479
}
function jsCall_viidd_0(a1, a2, a3, a4) {
 a1 = a1 | 0; //@line 471
 a2 = a2 | 0; //@line 471
 a3 = +a3; //@line 471
 a4 = +a4; //@line 471
 jsCall_viidd(0, a1 | 0, a2 | 0, +a3, +a4); //@line 472
}
function establishStackSpace(stackBase, stackMax) {
 stackBase = stackBase | 0; //@line 19
 stackMax = stackMax | 0; //@line 20
 STACKTOP = stackBase; //@line 21
 STACK_MAX = stackMax; //@line 22
}
function b12(p0, p1, p2, p3, p4) {
 p0 = p0 | 0; //@line 709
 p1 = p1 | 0; //@line 709
 p2 = p2 | 0; //@line 709
 p3 = +p3; //@line 709
 p4 = p4 | 0; //@line 709
 nullFunc_viiidi(12); //@line 709
}
function b10(p0, p1, p2, p3, p4) {
 p0 = p0 | 0; //@line 703
 p1 = p1 | 0; //@line 703
 p2 = +p2; //@line 703
 p3 = p3 | 0; //@line 703
 p4 = p4 | 0; //@line 703
 nullFunc_viidii(10); //@line 703
}
function _frexpl($0, $1) {
 $0 = +$0; //@line 13882
 $1 = $1 | 0; //@line 13883
 var $2 = 0.0, label = 0, sp = 0;
 sp = STACKTOP; //@line 13885
 $2 = +_frexp($0, $1); //@line 13886
 return +$2;
}
function setThrew(threw, value) {
 threw = threw | 0; //@line 25
 value = value | 0; //@line 26
 if ((__THREW__ | 0) == 0) {
  __THREW__ = threw; //@line 28
  threwValue = value; //@line 29
 }
}
function b5(p0, p1, p2, p3) {
 p0 = p0 | 0; //@line 688
 p1 = p1 | 0; //@line 688
 p2 = p2 | 0; //@line 688
 p3 = p3 | 0; //@line 688
 nullFunc_iiiii(5); //@line 688
 return 0; //@line 688
}
function dynCall_ii(index, a1) {
 index = index | 0; //@line 219
 a1 = a1 | 0; //@line 220
 return FUNCTION_TABLE_ii[(SAFE_FT_MASK(index | 0, 63 | 0) | 0) & 63](a1 | 0) | 0; //@line 221
}
function ___pthread_self_888() {
 var $0 = 0, label = 0, sp = 0; //@line 14047
 sp = STACKTOP; //@line 14048
 $0 = _pthread_self() | 0; //@line 14049
 return $0 | 0; //@line 14050
}
function jsCall_iiii_3(a1, a2, a3) {
 a1 = a1 | 0; //@line 317
 a2 = a2 | 0; //@line 317
 a3 = a3 | 0; //@line 317
 return jsCall_iiii(3, a1 | 0, a2 | 0, a3 | 0) | 0; //@line 318
}
function jsCall_iiii_2(a1, a2, a3) {
 a1 = a1 | 0; //@line 310
 a2 = a2 | 0; //@line 310
 a3 = a3 | 0; //@line 310
 return jsCall_iiii(2, a1 | 0, a2 | 0, a3 | 0) | 0; //@line 311
}
function jsCall_iiii_1(a1, a2, a3) {
 a1 = a1 | 0; //@line 303
 a2 = a2 | 0; //@line 303
 a3 = a3 | 0; //@line 303
 return jsCall_iiii(1, a1 | 0, a2 | 0, a3 | 0) | 0; //@line 304
}
function jsCall_iiii_0(a1, a2, a3) {
 a1 = a1 | 0; //@line 296
 a2 = a2 | 0; //@line 296
 a3 = a3 | 0; //@line 296
 return jsCall_iiii(0, a1 | 0, a2 | 0, a3 | 0) | 0; //@line 297
}
function ___pthread_self_78() {
 var $0 = 0, label = 0, sp = 0; //@line 14053
 sp = STACKTOP; //@line 14054
 $0 = _pthread_self() | 0; //@line 14055
 return $0 | 0; //@line 14056
}
function _cpSegmentShapeAlloc() {
 var $0 = 0, label = 0, sp = 0; //@line 6341
 sp = STACKTOP; //@line 6342
 $0 = _calloc(1, 296) | 0; //@line 6343
 return $0 | 0; //@line 6344
}
function _cpCircleShapeAlloc() {
 var $0 = 0, label = 0, sp = 0; //@line 5778
 sp = STACKTOP; //@line 5779
 $0 = _calloc(1, 200) | 0; //@line 5780
 return $0 | 0; //@line 5781
}
function dynCall_vi(index, a1) {
 index = index | 0; //@line 359
 a1 = a1 | 0; //@line 360
 FUNCTION_TABLE_vi[(SAFE_FT_MASK(index | 0, 63 | 0) | 0) & 63](a1 | 0); //@line 361
}
function _cpSlideJointAlloc() {
 var $0 = 0, label = 0, sp = 0; //@line 7244
 sp = STACKTOP; //@line 7245
 $0 = _calloc(1, 184) | 0; //@line 7246
 return $0 | 0; //@line 7247
}
function _cpPivotJointAlloc() {
 var $0 = 0, label = 0, sp = 0; //@line 2867
 sp = STACKTOP; //@line 2868
 $0 = _calloc(1, 192) | 0; //@line 2869
 return $0 | 0; //@line 2870
}
function _cpPolyShapeAlloc() {
 var $0 = 0, label = 0, sp = 0; //@line 3768
 sp = STACKTOP; //@line 3769
 $0 = _calloc(1, 560) | 0; //@line 3770
 return $0 | 0; //@line 3771
}
function dynCall_di(index, a1) {
 index = index | 0; //@line 149
 a1 = a1 | 0; //@line 150
 return +FUNCTION_TABLE_di[(SAFE_FT_MASK(index | 0, 63 | 0) | 0) & 63](a1 | 0);
}
function _cpBBTreeAlloc() {
 var $0 = 0, label = 0, sp = 0; //@line 2937
 sp = STACKTOP; //@line 2938
 $0 = _calloc(1, 44) | 0; //@line 2939
 return $0 | 0; //@line 2940
}
function _cpBodyAlloc() {
 var $0 = 0, label = 0, sp = 0; //@line 5528
 sp = STACKTOP; //@line 5529
 $0 = _calloc(1, 240) | 0; //@line 5530
 return $0 | 0; //@line 5531
}
function jsCall_viii_3(a1, a2, a3) {
 a1 = a1 | 0; //@line 562
 a2 = a2 | 0; //@line 562
 a3 = a3 | 0; //@line 562
 jsCall_viii(3, a1 | 0, a2 | 0, a3 | 0); //@line 563
}
function jsCall_viii_2(a1, a2, a3) {
 a1 = a1 | 0; //@line 555
 a2 = a2 | 0; //@line 555
 a3 = a3 | 0; //@line 555
 jsCall_viii(2, a1 | 0, a2 | 0, a3 | 0); //@line 556
}
function jsCall_viii_1(a1, a2, a3) {
 a1 = a1 | 0; //@line 548
 a2 = a2 | 0; //@line 548
 a3 = a3 | 0; //@line 548
 jsCall_viii(1, a1 | 0, a2 | 0, a3 | 0); //@line 549
}
function jsCall_viii_0(a1, a2, a3) {
 a1 = a1 | 0; //@line 541
 a2 = a2 | 0; //@line 541
 a3 = a3 | 0; //@line 541
 jsCall_viii(0, a1 | 0, a2 | 0, a3 | 0); //@line 542
}
function _cpSpaceAlloc() {
 var $0 = 0, label = 0, sp = 0; //@line 188
 sp = STACKTOP; //@line 189
 $0 = _calloc(1, 432) | 0; //@line 190
 return $0 | 0; //@line 191
}
function jsCall_diii_3(a1, a2, a3) {
 a1 = a1 | 0; //@line 212
 a2 = a2 | 0; //@line 212
 a3 = a3 | 0; //@line 212
 return +jsCall_diii(3, a1 | 0, a2 | 0, a3 | 0);
}
function jsCall_diii_2(a1, a2, a3) {
 a1 = a1 | 0; //@line 205
 a2 = a2 | 0; //@line 205
 a3 = a3 | 0; //@line 205
 return +jsCall_diii(2, a1 | 0, a2 | 0, a3 | 0);
}
function jsCall_diii_1(a1, a2, a3) {
 a1 = a1 | 0; //@line 198
 a2 = a2 | 0; //@line 198
 a3 = a3 | 0; //@line 198
 return +jsCall_diii(1, a1 | 0, a2 | 0, a3 | 0);
}
function jsCall_diii_0(a1, a2, a3) {
 a1 = a1 | 0; //@line 191
 a2 = a2 | 0; //@line 191
 a3 = a3 | 0; //@line 191
 return +jsCall_diii(0, a1 | 0, a2 | 0, a3 | 0);
}
function ___ofl_lock() {
 var label = 0, sp = 0; //@line 11096
 sp = STACKTOP; //@line 11097
 ___lock(11860 | 0); //@line 11098
 return 11868 | 0; //@line 11099
}
function b9(p0, p1, p2, p3) {
 p0 = p0 | 0; //@line 700
 p1 = p1 | 0; //@line 700
 p2 = +p2; //@line 700
 p3 = +p3; //@line 700
 nullFunc_viidd(9); //@line 700
}
function b4(p0, p1, p2) {
 p0 = p0 | 0; //@line 685
 p1 = p1 | 0; //@line 685
 p2 = p2 | 0; //@line 685
 nullFunc_iiii(4); //@line 685
 return 0; //@line 685
}
function _llvm_bswap_i32(x) {
 x = x | 0; //@line 14433
 return (x & 255) << 24 | (x >> 8 & 255) << 16 | (x >> 16 & 255) << 8 | x >>> 24 | 0; //@line 14434
}
function b1(p0, p1, p2) {
 p0 = p0 | 0; //@line 676
 p1 = p1 | 0; //@line 676
 p2 = p2 | 0; //@line 676
 nullFunc_diii(1); //@line 676
 return 0.0;
}
function _dummy($0) {
 $0 = $0 | 0; //@line 10719
 var label = 0, sp = 0; //@line 10720
 sp = STACKTOP; //@line 10721
 return $0 | 0; //@line 10722
}
function ___lockfile($0) {
 $0 = $0 | 0; //@line 10814
 var label = 0, sp = 0; //@line 10815
 sp = STACKTOP; //@line 10816
 return 1; //@line 10817
}
function ___ofl_unlock() {
 var label = 0, sp = 0; //@line 11102
 sp = STACKTOP; //@line 11103
 ___unlock(11860 | 0); //@line 11104
 return;
}
function jsCall_iii_3(a1, a2) {
 a1 = a1 | 0; //@line 282
 a2 = a2 | 0; //@line 282
 return jsCall_iii(3, a1 | 0, a2 | 0) | 0; //@line 283
}
function jsCall_iii_2(a1, a2) {
 a1 = a1 | 0; //@line 275
 a2 = a2 | 0; //@line 275
 return jsCall_iii(2, a1 | 0, a2 | 0) | 0; //@line 276
}
function jsCall_iii_1(a1, a2) {
 a1 = a1 | 0; //@line 268
 a2 = a2 | 0; //@line 268
 return jsCall_iii(1, a1 | 0, a2 | 0) | 0; //@line 269
}
function jsCall_iii_0(a1, a2) {
 a1 = a1 | 0; //@line 261
 a2 = a2 | 0; //@line 261
 return jsCall_iii(0, a1 | 0, a2 | 0) | 0; //@line 262
}
function b11(p0, p1, p2) {
 p0 = p0 | 0; //@line 706
 p1 = p1 | 0; //@line 706
 p2 = p2 | 0; //@line 706
 nullFunc_viii(11); //@line 706
}
function ___unlockfile($0) {
 $0 = $0 | 0; //@line 10808
 var label = 0, sp = 0; //@line 10809
 sp = STACKTOP; //@line 10810
 return;
}
function ___errno_location() {
 var label = 0, sp = 0; //@line 10714
 sp = STACKTOP; //@line 10715
 return 11856 | 0; //@line 10716
}
function _llvm_cttz_i32(x) {
 x = x | 0; //@line 14191
 return (x ? 31 - (Math_clz32(x ^ x - 1) | 0) | 0 : 32) | 0; //@line 14192
}
function jsCall_vii_3(a1, a2) {
 a1 = a1 | 0; //@line 457
 a2 = a2 | 0; //@line 457
 jsCall_vii(3, a1 | 0, a2 | 0); //@line 458
}
function jsCall_vii_2(a1, a2) {
 a1 = a1 | 0; //@line 450
 a2 = a2 | 0; //@line 450
 jsCall_vii(2, a1 | 0, a2 | 0); //@line 451
}
function jsCall_vii_1(a1, a2) {
 a1 = a1 | 0; //@line 443
 a2 = a2 | 0; //@line 443
 jsCall_vii(1, a1 | 0, a2 | 0); //@line 444
}
function jsCall_vii_0(a1, a2) {
 a1 = a1 | 0; //@line 436
 a2 = a2 | 0; //@line 436
 jsCall_vii(0, a1 | 0, a2 | 0); //@line 437
}
function b3(p0, p1) {
 p0 = p0 | 0; //@line 682
 p1 = p1 | 0; //@line 682
 nullFunc_iii(3); //@line 682
 return 0; //@line 682
}
function _pthread_self() {
 var label = 0, sp = 0; //@line 10767
 sp = STACKTOP; //@line 10768
 return 3e3 | 0; //@line 10769
}
function jsCall_vid_3(a1, a2) {
 a1 = a1 | 0; //@line 422
 a2 = +a2; //@line 422
 jsCall_vid(3, a1 | 0, +a2); //@line 423
}
function jsCall_vid_2(a1, a2) {
 a1 = a1 | 0; //@line 415
 a2 = +a2; //@line 415
 jsCall_vid(2, a1 | 0, +a2); //@line 416
}
function jsCall_vid_1(a1, a2) {
 a1 = a1 | 0; //@line 408
 a2 = +a2; //@line 408
 jsCall_vid(1, a1 | 0, +a2); //@line 409
}
function jsCall_vid_0(a1, a2) {
 a1 = a1 | 0; //@line 401
 a2 = +a2; //@line 401
 jsCall_vid(0, a1 | 0, +a2); //@line 402
}
function _Klass() {
 var label = 0, sp = 0; //@line 2982
 sp = STACKTOP; //@line 2983
 return 2576 | 0; //@line 2984
}
function setDynamicTop(value) {
 value = value | 0; //@line 34
 SAFE_HEAP_STORE(DYNAMICTOP_PTR | 0, value | 0, 4);
}
function b8(p0, p1) {
 p0 = p0 | 0; //@line 697
 p1 = p1 | 0; //@line 697
 nullFunc_vii(8); //@line 697
}
function b7(p0, p1) {
 p0 = p0 | 0; //@line 694
 p1 = +p1; //@line 694
 nullFunc_vid(7); //@line 694
}
function jsCall_ii_3(a1) {
 a1 = a1 | 0; //@line 247
 return jsCall_ii(3, a1 | 0) | 0; //@line 248
}
function jsCall_ii_2(a1) {
 a1 = a1 | 0; //@line 240
 return jsCall_ii(2, a1 | 0) | 0; //@line 241
}
function jsCall_ii_1(a1) {
 a1 = a1 | 0; //@line 233
 return jsCall_ii(1, a1 | 0) | 0; //@line 234
}
function jsCall_ii_0(a1) {
 a1 = a1 | 0; //@line 226
 return jsCall_ii(0, a1 | 0) | 0; //@line 227
}
function b2(p0) {
 p0 = p0 | 0; //@line 679
 nullFunc_ii(2); //@line 679
 return 0; //@line 679
}
function jsCall_vi_3(a1) {
 a1 = a1 | 0; //@line 387
 jsCall_vi(3, a1 | 0); //@line 388
}
function jsCall_vi_2(a1) {
 a1 = a1 | 0; //@line 380
 jsCall_vi(2, a1 | 0); //@line 381
}
function jsCall_vi_1(a1) {
 a1 = a1 | 0; //@line 373
 jsCall_vi(1, a1 | 0); //@line 374
}
function jsCall_vi_0(a1) {
 a1 = a1 | 0; //@line 366
 jsCall_vi(0, a1 | 0); //@line 367
}
function b0(p0) {
 p0 = p0 | 0; //@line 673
 nullFunc_di(0); //@line 673
 return 0.0;
}
function stackRestore(top) {
 top = top | 0; //@line 15
 STACKTOP = top; //@line 16
}
function jsCall_di_3(a1) {
 a1 = a1 | 0; //@line 177
 return +jsCall_di(3, a1 | 0);
}
function jsCall_di_2(a1) {
 a1 = a1 | 0; //@line 170
 return +jsCall_di(2, a1 | 0);
}
function jsCall_di_1(a1) {
 a1 = a1 | 0; //@line 163
 return +jsCall_di(1, a1 | 0);
}
function jsCall_di_0(a1) {
 a1 = a1 | 0; //@line 156
 return +jsCall_di(0, a1 | 0);
}
function b6(p0) {
 p0 = p0 | 0; //@line 691
 nullFunc_vi(6); //@line 691
}
function stackSave() {
 return STACKTOP | 0; //@line 12
}

// EMSCRIPTEN_END_FUNCS
var FUNCTION_TABLE_di = [b0,jsCall_di_0,jsCall_di_1,jsCall_di_2,jsCall_di_3,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,_getImpulse_238,b0,b0
,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,_getImpulse_397,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0,b0
,b0,b0,b0,b0,b0];
var FUNCTION_TABLE_diii = [b1,jsCall_diii_0,jsCall_diii_1,jsCall_diii_2,jsCall_diii_3,b1,b1,b1];
var FUNCTION_TABLE_ii = [b2,jsCall_ii_0,jsCall_ii_1,jsCall_ii_2,jsCall_ii_3,b2,_cpBBTreeCount,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2
,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,___stdio_close,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2,b2
,b2,b2,b2,b2,b2];
var FUNCTION_TABLE_iii = [b3,jsCall_iii_0,jsCall_iii_1,jsCall_iii_2,jsCall_iii_3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3
,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,_leafSetEql,b3,b3,_leafSetTrans,b3,b3,b3,b3,b3,b3,b3,b3
,b3,_arbiterSetEql,_handlerSetEql,b3,b3,b3,b3,b3,b3,_handlerSetTrans,_cachedArbitersFilter,b3,b3,b3,_cpSpaceArbiterSetTrans,b3,b3,_cpSpaceArbiterSetFilter,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3
,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3
,b3,b3,b3,b3,b3,b3,b3,b3,b3];
var FUNCTION_TABLE_iiii = [b4,jsCall_iiii_0,jsCall_iiii_1,jsCall_iiii_2,jsCall_iiii_3,b4,b4,b4,_cpBBTreeContains,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4
,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,_AlwaysCollide,b4,b4,___stdio_write,___stdio_seek,___stdout_write,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4
,b4,b4,b4,b4,b4,_DefaultBegin,_DefaultPreSolve,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4
,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4
,b4,b4,b4,b4,b4,b4,b4,b4,b4];
var FUNCTION_TABLE_iiiii = [b5,jsCall_iiiii_0,jsCall_iiiii_1,jsCall_iiiii_2,jsCall_iiiii_3,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5
,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,_VoidQueryFunc,b5,b5,b5,b5,b5,b5,b5
,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,_NearestPointQuery,_ShapeQuery,b5,b5,b5,_cpSpaceCollideShapes,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5
,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5,b5
,b5,b5,b5,b5,b5,b5,b5,b5,b5];
var FUNCTION_TABLE_vi = [b6,jsCall_vi_0,jsCall_vi_1,jsCall_vi_2,jsCall_vi_3,_cpBBTreeDestroy,b6,b6,b6,b6,b6,_cpBBTreeReindex,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,_cpPolyShapeDestroy
,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6,_free,b6,b6,b6,b6,b6,b6,b6,b6,b6,b6
,b6,b6,b6,b6,b6];
var FUNCTION_TABLE_vid = [b7,jsCall_vid_0,jsCall_vid_1,jsCall_vid_2,jsCall_vid_3,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,_preStep_235,_applyCachedImpulse_236,_applyImpulse_237,b7,b7,b7
,b7,b7,b7,b7,b7,b7,b7,b7,_preStep_394,_applyCachedImpulse_395,_applyImpulse_396,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,b7,_cpBodyUpdatePosition,b7,b7,b7,b7
,b7,b7,b7,b7,b7];
var FUNCTION_TABLE_vii = [b8,jsCall_vii_0,jsCall_vii_1,jsCall_vii_2,jsCall_vii_3,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8
,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,_each_helper,b8,b8,_LeafUpdateWrap,b8,b8,b8,b8,b8,_cpShapeGetBB
,_ShapeVelocityFunc,b8,b8,_cpBodyActivateWrap,_FreeWrap,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,_cpShapeUpdateFunc,b8,b8,_dynamicToStaticIter,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8
,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8,b8
,b8,b8,b8,b8,b8,b8,b8,b8,b8];
var FUNCTION_TABLE_viidd = [b9,jsCall_viidd_0,jsCall_viidd_1,jsCall_viidd_2,jsCall_viidd_3,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9
,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,b9,_cpBodyUpdateVelocity,b9,b9,b9,b9,b9
,b9,b9,b9,b9,b9];
var FUNCTION_TABLE_viidii = [b10,jsCall_viidii_0,jsCall_viidii_1,jsCall_viidii_2,jsCall_viidii_3,b10,b10,b10];
var FUNCTION_TABLE_viii = [b11,jsCall_viii_0,jsCall_viii_1,jsCall_viii_2,jsCall_viii_3,b11,b11,_cpBBTreeEach,b11,_cpBBTreeInsert,_cpBBTreeRemove,b11,_cpBBTreeReindexObject,_cpBBTreeReindexQuery,b11,b11,_CircleToCircle,_CollisionError,_CircleToSegment,_SegmentToSegment,_CircleToPoly,_SegmentToPoly,_PolyToPoly,b11,b11,b11,b11,_cpPolyShapeCacheData,b11
,_cpPolyShapePointQuery,b11,_cpCircleShapeCacheData,_cpCircleShapePointQuery,b11,_cpSegmentShapeCacheData,_cpSegmentShapePointQuery,b11,b11,b11,b11,b11,b11,_DoNothing,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,_SegmentSupportPoint,_CircleSupportPoint,_PolySupportPoint,b11
,b11,b11,b11,b11,b11,b11,b11,_DefaultPostSolve,_DefaultSeparate,b11,b11,b11,b11,_PostStepDoNothing,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11
,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11,b11
,b11,b11,b11,b11,b11,b11,b11,b11,b11];
var FUNCTION_TABLE_viiidi = [b12,jsCall_viiidi_0,jsCall_viiidi_1,jsCall_viiidi_2,jsCall_viiidi_3,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12
,b12,_cpPolyShapeSegmentQuery,b12,b12,_cpCircleShapeSegmentQuery,b12,b12,_cpSegmentShapeSegmentQuery,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12
,b12,b12,b12,b12,b12];
var FUNCTION_TABLE_viiiidii = [b13,jsCall_viiiidii_0,jsCall_viiiidii_1,jsCall_viiiidii_2,jsCall_viiiidii_3,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,_cpBBTreeSegmentQuery];
var FUNCTION_TABLE_viiiii = [b14,jsCall_viiiii_0,jsCall_viiiii_1,jsCall_viiiii_2,jsCall_viiiii_3,b14,b14,b14,b14,b14,b14,b14,b14,b14,_cpBBTreeQuery,b14];

  return { ___errno_location: ___errno_location, ___muldi3: ___muldi3, ___udivdi3: ___udivdi3, _bitshift64Lshr: _bitshift64Lshr, _bitshift64Shl: _bitshift64Shl, _chipmunk_cpBodyApplyForceAtLocalPoint: _chipmunk_cpBodyApplyForceAtLocalPoint, _chipmunk_cpBodyApplyForceAtWorldPoint: _chipmunk_cpBodyApplyForceAtWorldPoint, _chipmunk_cpBodyApplyImpulseAtLocalPoint: _chipmunk_cpBodyApplyImpulseAtLocalPoint, _chipmunk_cpBodyApplyImpulseAtWorldPoint: _chipmunk_cpBodyApplyImpulseAtWorldPoint, _chipmunk_cpBodyGetPosition: _chipmunk_cpBodyGetPosition, _chipmunk_cpBodyGetVelocity: _chipmunk_cpBodyGetVelocity, _chipmunk_cpBodySetPosition: _chipmunk_cpBodySetPosition, _chipmunk_cpBodySetVelocity: _chipmunk_cpBodySetVelocity, _chipmunk_cpBodySetVelocityUpdateFunc: _chipmunk_cpBodySetVelocityUpdateFunc, _chipmunk_cpBodyUpdateVelocity: _chipmunk_cpBodyUpdateVelocity, _cpArbiterGetBodies: _cpArbiterGetBodies, _cpArbiterGetNormal: _cpArbiterGetNormal, _cpArbiterGetShapes: _cpArbiterGetShapes, _cpArbiterIgnore: _cpArbiterIgnore, _cpArbiterSetFriction: _cpArbiterSetFriction, _cpArbiterSetRestitution: _cpArbiterSetRestitution, _cpArbiterSetSurfaceVelocity: _cpArbiterSetSurfaceVelocity, _cpBodyActivate: _cpBodyActivate, _cpBodyFree: _cpBodyFree, _cpBodyGetAngle: _cpBodyGetAngle, _cpBodyGetAngularVelocity: _cpBodyGetAngularVelocity, _cpBodyGetMass: _cpBodyGetMass, _cpBodyGetType: _cpBodyGetType, _cpBodyGetUserData: _cpBodyGetUserData, _cpBodyIsSleeping: _cpBodyIsSleeping, _cpBodyNew: _cpBodyNew, _cpBodyNewKinematic: _cpBodyNewKinematic, _cpBodyNewStatic: _cpBodyNewStatic, _cpBodySetAngle: _cpBodySetAngle, _cpBodySetAngularVelocity: _cpBodySetAngularVelocity, _cpBodySetMass: _cpBodySetMass, _cpBodySetPositionUpdateFunc: _cpBodySetPositionUpdateFunc, _cpBodySetType: _cpBodySetType, _cpBodySetUserData: _cpBodySetUserData, _cpBodySleep: _cpBodySleep, _cpBodyUpdatePosition: _cpBodyUpdatePosition, _cpCircleShapeGetOffset: _cpCircleShapeGetOffset, _cpCircleShapeGetRadius: _cpCircleShapeGetRadius, _cpCircleShapeNew: _cpCircleShapeNew, _cpCircleShapeSetOffset: _cpCircleShapeSetOffset, _cpCircleShapeSetRadius: _cpCircleShapeSetRadius, _cpConstraintFree: _cpConstraintFree, _cpConstraintGetErrorBias: _cpConstraintGetErrorBias, _cpConstraintGetMaxBias: _cpConstraintGetMaxBias, _cpConstraintGetMaxForce: _cpConstraintGetMaxForce, _cpConstraintGetUserData: _cpConstraintGetUserData, _cpConstraintSetErrorBias: _cpConstraintSetErrorBias, _cpConstraintSetMaxBias: _cpConstraintSetMaxBias, _cpConstraintSetMaxForce: _cpConstraintSetMaxForce, _cpConstraintSetUserData: _cpConstraintSetUserData, _cpPivotJointNew2: _cpPivotJointNew2, _cpPolyShapeNewRaw: _cpPolyShapeNewRaw, _cpSegmentShapeGetA: _cpSegmentShapeGetA, _cpSegmentShapeGetB: _cpSegmentShapeGetB, _cpSegmentShapeNew: _cpSegmentShapeNew, _cpShapeFree: _cpShapeFree, _cpShapeGetBody: _cpShapeGetBody, _cpShapeGetCollisionType: _cpShapeGetCollisionType, _cpShapeGetElasticity: _cpShapeGetElasticity, _cpShapeGetFilter: _cpShapeGetFilter, _cpShapeGetFriction: _cpShapeGetFriction, _cpShapeGetSensor: _cpShapeGetSensor, _cpShapeGetSpace: _cpShapeGetSpace, _cpShapeSetBody: _cpShapeSetBody, _cpShapeSetCollisionType: _cpShapeSetCollisionType, _cpShapeSetElasticity: _cpShapeSetElasticity, _cpShapeSetFilter: _cpShapeSetFilter, _cpShapeSetFriction: _cpShapeSetFriction, _cpShapeSetSensor: _cpShapeSetSensor, _cpSlideJointNew: _cpSlideJointNew, _cpSpaceAddBody: _cpSpaceAddBody, _cpSpaceAddCollisionHandler: _cpSpaceAddCollisionHandler, _cpSpaceAddConstraint: _cpSpaceAddConstraint, _cpSpaceAddPostStepCallback: _cpSpaceAddPostStepCallback, _cpSpaceAddShape: _cpSpaceAddShape, _cpSpaceContainsBody: _cpSpaceContainsBody, _cpSpaceContainsShape: _cpSpaceContainsShape, _cpSpaceFree: _cpSpaceFree, _cpSpaceGetCollisionBias: _cpSpaceGetCollisionBias, _cpSpaceGetCollisionSlop: _cpSpaceGetCollisionSlop, _cpSpaceGetDamping: _cpSpaceGetDamping, _cpSpaceGetGravity: _cpSpaceGetGravity, _cpSpaceGetIdleSpeedThreshold: _cpSpaceGetIdleSpeedThreshold, _cpSpaceGetIterations: _cpSpaceGetIterations, _cpSpaceGetSleepTimeThreshold: _cpSpaceGetSleepTimeThreshold, _cpSpaceGetUserData: _cpSpaceGetUserData, _cpSpaceNew: _cpSpaceNew, _cpSpacePointQuery: _cpSpacePointQuery, _cpSpaceReindexShapesForBody: _cpSpaceReindexShapesForBody, _cpSpaceRemoveBody: _cpSpaceRemoveBody, _cpSpaceRemoveConstraint: _cpSpaceRemoveConstraint, _cpSpaceRemoveShape: _cpSpaceRemoveShape, _cpSpaceSetCollisionBias: _cpSpaceSetCollisionBias, _cpSpaceSetCollisionSlop: _cpSpaceSetCollisionSlop, _cpSpaceSetDamping: _cpSpaceSetDamping, _cpSpaceSetGravity: _cpSpaceSetGravity, _cpSpaceSetIdleSpeedThreshold: _cpSpaceSetIdleSpeedThreshold, _cpSpaceSetIterations: _cpSpaceSetIterations, _cpSpaceSetSleepTimeThreshold: _cpSpaceSetSleepTimeThreshold, _cpSpaceSetUserData: _cpSpaceSetUserData, _cpSpaceShapeQuery: _cpSpaceShapeQuery, _cpSpaceStep: _cpSpaceStep, _fflush: _fflush, _free: _free, _i64Add: _i64Add, _i64Subtract: _i64Subtract, _llvm_bswap_i32: _llvm_bswap_i32, _malloc: _malloc, _memcpy: _memcpy, _memset: _memset, _sbrk: _sbrk, dynCall_di: dynCall_di, dynCall_diii: dynCall_diii, dynCall_ii: dynCall_ii, dynCall_iii: dynCall_iii, dynCall_iiii: dynCall_iiii, dynCall_iiiii: dynCall_iiiii, dynCall_vi: dynCall_vi, dynCall_vid: dynCall_vid, dynCall_vii: dynCall_vii, dynCall_viidd: dynCall_viidd, dynCall_viidii: dynCall_viidii, dynCall_viii: dynCall_viii, dynCall_viiidi: dynCall_viiidi, dynCall_viiiidii: dynCall_viiiidii, dynCall_viiiii: dynCall_viiiii, establishStackSpace: establishStackSpace, runPostSets: runPostSets, setDynamicTop: setDynamicTop, setThrew: setThrew, stackAlloc: stackAlloc, stackRestore: stackRestore, stackSave: stackSave };
})
// EMSCRIPTEN_END_ASM
(Module.asmGlobalArg, Module.asmLibraryArg, buffer);

var real____errno_location = asm["___errno_location"]; asm["___errno_location"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real____errno_location.apply(null, arguments);
};

var real____muldi3 = asm["___muldi3"]; asm["___muldi3"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real____muldi3.apply(null, arguments);
};

var real____udivdi3 = asm["___udivdi3"]; asm["___udivdi3"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real____udivdi3.apply(null, arguments);
};

var real__bitshift64Lshr = asm["_bitshift64Lshr"]; asm["_bitshift64Lshr"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__bitshift64Lshr.apply(null, arguments);
};

var real__bitshift64Shl = asm["_bitshift64Shl"]; asm["_bitshift64Shl"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__bitshift64Shl.apply(null, arguments);
};

var real__chipmunk_cpBodyApplyForceAtLocalPoint = asm["_chipmunk_cpBodyApplyForceAtLocalPoint"]; asm["_chipmunk_cpBodyApplyForceAtLocalPoint"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__chipmunk_cpBodyApplyForceAtLocalPoint.apply(null, arguments);
};

var real__chipmunk_cpBodyApplyForceAtWorldPoint = asm["_chipmunk_cpBodyApplyForceAtWorldPoint"]; asm["_chipmunk_cpBodyApplyForceAtWorldPoint"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__chipmunk_cpBodyApplyForceAtWorldPoint.apply(null, arguments);
};

var real__chipmunk_cpBodyApplyImpulseAtLocalPoint = asm["_chipmunk_cpBodyApplyImpulseAtLocalPoint"]; asm["_chipmunk_cpBodyApplyImpulseAtLocalPoint"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__chipmunk_cpBodyApplyImpulseAtLocalPoint.apply(null, arguments);
};

var real__chipmunk_cpBodyApplyImpulseAtWorldPoint = asm["_chipmunk_cpBodyApplyImpulseAtWorldPoint"]; asm["_chipmunk_cpBodyApplyImpulseAtWorldPoint"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__chipmunk_cpBodyApplyImpulseAtWorldPoint.apply(null, arguments);
};

var real__chipmunk_cpBodyGetPosition = asm["_chipmunk_cpBodyGetPosition"]; asm["_chipmunk_cpBodyGetPosition"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__chipmunk_cpBodyGetPosition.apply(null, arguments);
};

var real__chipmunk_cpBodyGetVelocity = asm["_chipmunk_cpBodyGetVelocity"]; asm["_chipmunk_cpBodyGetVelocity"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__chipmunk_cpBodyGetVelocity.apply(null, arguments);
};

var real__chipmunk_cpBodySetPosition = asm["_chipmunk_cpBodySetPosition"]; asm["_chipmunk_cpBodySetPosition"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__chipmunk_cpBodySetPosition.apply(null, arguments);
};

var real__chipmunk_cpBodySetVelocity = asm["_chipmunk_cpBodySetVelocity"]; asm["_chipmunk_cpBodySetVelocity"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__chipmunk_cpBodySetVelocity.apply(null, arguments);
};

var real__chipmunk_cpBodySetVelocityUpdateFunc = asm["_chipmunk_cpBodySetVelocityUpdateFunc"]; asm["_chipmunk_cpBodySetVelocityUpdateFunc"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__chipmunk_cpBodySetVelocityUpdateFunc.apply(null, arguments);
};

var real__chipmunk_cpBodyUpdateVelocity = asm["_chipmunk_cpBodyUpdateVelocity"]; asm["_chipmunk_cpBodyUpdateVelocity"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__chipmunk_cpBodyUpdateVelocity.apply(null, arguments);
};

var real__cpArbiterGetBodies = asm["_cpArbiterGetBodies"]; asm["_cpArbiterGetBodies"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpArbiterGetBodies.apply(null, arguments);
};

var real__cpArbiterGetNormal = asm["_cpArbiterGetNormal"]; asm["_cpArbiterGetNormal"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpArbiterGetNormal.apply(null, arguments);
};

var real__cpArbiterGetShapes = asm["_cpArbiterGetShapes"]; asm["_cpArbiterGetShapes"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpArbiterGetShapes.apply(null, arguments);
};

var real__cpArbiterIgnore = asm["_cpArbiterIgnore"]; asm["_cpArbiterIgnore"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpArbiterIgnore.apply(null, arguments);
};

var real__cpArbiterSetFriction = asm["_cpArbiterSetFriction"]; asm["_cpArbiterSetFriction"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpArbiterSetFriction.apply(null, arguments);
};

var real__cpArbiterSetRestitution = asm["_cpArbiterSetRestitution"]; asm["_cpArbiterSetRestitution"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpArbiterSetRestitution.apply(null, arguments);
};

var real__cpArbiterSetSurfaceVelocity = asm["_cpArbiterSetSurfaceVelocity"]; asm["_cpArbiterSetSurfaceVelocity"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpArbiterSetSurfaceVelocity.apply(null, arguments);
};

var real__cpBodyActivate = asm["_cpBodyActivate"]; asm["_cpBodyActivate"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodyActivate.apply(null, arguments);
};

var real__cpBodyFree = asm["_cpBodyFree"]; asm["_cpBodyFree"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodyFree.apply(null, arguments);
};

var real__cpBodyGetAngle = asm["_cpBodyGetAngle"]; asm["_cpBodyGetAngle"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodyGetAngle.apply(null, arguments);
};

var real__cpBodyGetAngularVelocity = asm["_cpBodyGetAngularVelocity"]; asm["_cpBodyGetAngularVelocity"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodyGetAngularVelocity.apply(null, arguments);
};

var real__cpBodyGetMass = asm["_cpBodyGetMass"]; asm["_cpBodyGetMass"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodyGetMass.apply(null, arguments);
};

var real__cpBodyGetType = asm["_cpBodyGetType"]; asm["_cpBodyGetType"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodyGetType.apply(null, arguments);
};

var real__cpBodyGetUserData = asm["_cpBodyGetUserData"]; asm["_cpBodyGetUserData"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodyGetUserData.apply(null, arguments);
};

var real__cpBodyIsSleeping = asm["_cpBodyIsSleeping"]; asm["_cpBodyIsSleeping"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodyIsSleeping.apply(null, arguments);
};

var real__cpBodyNew = asm["_cpBodyNew"]; asm["_cpBodyNew"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodyNew.apply(null, arguments);
};

var real__cpBodyNewKinematic = asm["_cpBodyNewKinematic"]; asm["_cpBodyNewKinematic"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodyNewKinematic.apply(null, arguments);
};

var real__cpBodyNewStatic = asm["_cpBodyNewStatic"]; asm["_cpBodyNewStatic"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodyNewStatic.apply(null, arguments);
};

var real__cpBodySetAngle = asm["_cpBodySetAngle"]; asm["_cpBodySetAngle"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodySetAngle.apply(null, arguments);
};

var real__cpBodySetAngularVelocity = asm["_cpBodySetAngularVelocity"]; asm["_cpBodySetAngularVelocity"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodySetAngularVelocity.apply(null, arguments);
};

var real__cpBodySetMass = asm["_cpBodySetMass"]; asm["_cpBodySetMass"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodySetMass.apply(null, arguments);
};

var real__cpBodySetPositionUpdateFunc = asm["_cpBodySetPositionUpdateFunc"]; asm["_cpBodySetPositionUpdateFunc"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodySetPositionUpdateFunc.apply(null, arguments);
};

var real__cpBodySetType = asm["_cpBodySetType"]; asm["_cpBodySetType"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodySetType.apply(null, arguments);
};

var real__cpBodySetUserData = asm["_cpBodySetUserData"]; asm["_cpBodySetUserData"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodySetUserData.apply(null, arguments);
};

var real__cpBodySleep = asm["_cpBodySleep"]; asm["_cpBodySleep"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodySleep.apply(null, arguments);
};

var real__cpBodyUpdatePosition = asm["_cpBodyUpdatePosition"]; asm["_cpBodyUpdatePosition"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpBodyUpdatePosition.apply(null, arguments);
};

var real__cpCircleShapeGetOffset = asm["_cpCircleShapeGetOffset"]; asm["_cpCircleShapeGetOffset"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpCircleShapeGetOffset.apply(null, arguments);
};

var real__cpCircleShapeGetRadius = asm["_cpCircleShapeGetRadius"]; asm["_cpCircleShapeGetRadius"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpCircleShapeGetRadius.apply(null, arguments);
};

var real__cpCircleShapeNew = asm["_cpCircleShapeNew"]; asm["_cpCircleShapeNew"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpCircleShapeNew.apply(null, arguments);
};

var real__cpCircleShapeSetOffset = asm["_cpCircleShapeSetOffset"]; asm["_cpCircleShapeSetOffset"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpCircleShapeSetOffset.apply(null, arguments);
};

var real__cpCircleShapeSetRadius = asm["_cpCircleShapeSetRadius"]; asm["_cpCircleShapeSetRadius"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpCircleShapeSetRadius.apply(null, arguments);
};

var real__cpConstraintFree = asm["_cpConstraintFree"]; asm["_cpConstraintFree"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpConstraintFree.apply(null, arguments);
};

var real__cpConstraintGetErrorBias = asm["_cpConstraintGetErrorBias"]; asm["_cpConstraintGetErrorBias"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpConstraintGetErrorBias.apply(null, arguments);
};

var real__cpConstraintGetMaxBias = asm["_cpConstraintGetMaxBias"]; asm["_cpConstraintGetMaxBias"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpConstraintGetMaxBias.apply(null, arguments);
};

var real__cpConstraintGetMaxForce = asm["_cpConstraintGetMaxForce"]; asm["_cpConstraintGetMaxForce"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpConstraintGetMaxForce.apply(null, arguments);
};

var real__cpConstraintGetUserData = asm["_cpConstraintGetUserData"]; asm["_cpConstraintGetUserData"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpConstraintGetUserData.apply(null, arguments);
};

var real__cpConstraintSetErrorBias = asm["_cpConstraintSetErrorBias"]; asm["_cpConstraintSetErrorBias"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpConstraintSetErrorBias.apply(null, arguments);
};

var real__cpConstraintSetMaxBias = asm["_cpConstraintSetMaxBias"]; asm["_cpConstraintSetMaxBias"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpConstraintSetMaxBias.apply(null, arguments);
};

var real__cpConstraintSetMaxForce = asm["_cpConstraintSetMaxForce"]; asm["_cpConstraintSetMaxForce"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpConstraintSetMaxForce.apply(null, arguments);
};

var real__cpConstraintSetUserData = asm["_cpConstraintSetUserData"]; asm["_cpConstraintSetUserData"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpConstraintSetUserData.apply(null, arguments);
};

var real__cpPivotJointNew2 = asm["_cpPivotJointNew2"]; asm["_cpPivotJointNew2"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpPivotJointNew2.apply(null, arguments);
};

var real__cpPolyShapeNewRaw = asm["_cpPolyShapeNewRaw"]; asm["_cpPolyShapeNewRaw"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpPolyShapeNewRaw.apply(null, arguments);
};

var real__cpSegmentShapeGetA = asm["_cpSegmentShapeGetA"]; asm["_cpSegmentShapeGetA"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSegmentShapeGetA.apply(null, arguments);
};

var real__cpSegmentShapeGetB = asm["_cpSegmentShapeGetB"]; asm["_cpSegmentShapeGetB"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSegmentShapeGetB.apply(null, arguments);
};

var real__cpSegmentShapeNew = asm["_cpSegmentShapeNew"]; asm["_cpSegmentShapeNew"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSegmentShapeNew.apply(null, arguments);
};

var real__cpShapeFree = asm["_cpShapeFree"]; asm["_cpShapeFree"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpShapeFree.apply(null, arguments);
};

var real__cpShapeGetBody = asm["_cpShapeGetBody"]; asm["_cpShapeGetBody"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpShapeGetBody.apply(null, arguments);
};

var real__cpShapeGetCollisionType = asm["_cpShapeGetCollisionType"]; asm["_cpShapeGetCollisionType"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpShapeGetCollisionType.apply(null, arguments);
};

var real__cpShapeGetElasticity = asm["_cpShapeGetElasticity"]; asm["_cpShapeGetElasticity"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpShapeGetElasticity.apply(null, arguments);
};

var real__cpShapeGetFilter = asm["_cpShapeGetFilter"]; asm["_cpShapeGetFilter"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpShapeGetFilter.apply(null, arguments);
};

var real__cpShapeGetFriction = asm["_cpShapeGetFriction"]; asm["_cpShapeGetFriction"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpShapeGetFriction.apply(null, arguments);
};

var real__cpShapeGetSensor = asm["_cpShapeGetSensor"]; asm["_cpShapeGetSensor"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpShapeGetSensor.apply(null, arguments);
};

var real__cpShapeGetSpace = asm["_cpShapeGetSpace"]; asm["_cpShapeGetSpace"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpShapeGetSpace.apply(null, arguments);
};

var real__cpShapeSetBody = asm["_cpShapeSetBody"]; asm["_cpShapeSetBody"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpShapeSetBody.apply(null, arguments);
};

var real__cpShapeSetCollisionType = asm["_cpShapeSetCollisionType"]; asm["_cpShapeSetCollisionType"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpShapeSetCollisionType.apply(null, arguments);
};

var real__cpShapeSetElasticity = asm["_cpShapeSetElasticity"]; asm["_cpShapeSetElasticity"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpShapeSetElasticity.apply(null, arguments);
};

var real__cpShapeSetFilter = asm["_cpShapeSetFilter"]; asm["_cpShapeSetFilter"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpShapeSetFilter.apply(null, arguments);
};

var real__cpShapeSetFriction = asm["_cpShapeSetFriction"]; asm["_cpShapeSetFriction"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpShapeSetFriction.apply(null, arguments);
};

var real__cpShapeSetSensor = asm["_cpShapeSetSensor"]; asm["_cpShapeSetSensor"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpShapeSetSensor.apply(null, arguments);
};

var real__cpSlideJointNew = asm["_cpSlideJointNew"]; asm["_cpSlideJointNew"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSlideJointNew.apply(null, arguments);
};

var real__cpSpaceAddBody = asm["_cpSpaceAddBody"]; asm["_cpSpaceAddBody"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceAddBody.apply(null, arguments);
};

var real__cpSpaceAddCollisionHandler = asm["_cpSpaceAddCollisionHandler"]; asm["_cpSpaceAddCollisionHandler"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceAddCollisionHandler.apply(null, arguments);
};

var real__cpSpaceAddConstraint = asm["_cpSpaceAddConstraint"]; asm["_cpSpaceAddConstraint"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceAddConstraint.apply(null, arguments);
};

var real__cpSpaceAddPostStepCallback = asm["_cpSpaceAddPostStepCallback"]; asm["_cpSpaceAddPostStepCallback"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceAddPostStepCallback.apply(null, arguments);
};

var real__cpSpaceAddShape = asm["_cpSpaceAddShape"]; asm["_cpSpaceAddShape"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceAddShape.apply(null, arguments);
};

var real__cpSpaceContainsBody = asm["_cpSpaceContainsBody"]; asm["_cpSpaceContainsBody"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceContainsBody.apply(null, arguments);
};

var real__cpSpaceContainsShape = asm["_cpSpaceContainsShape"]; asm["_cpSpaceContainsShape"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceContainsShape.apply(null, arguments);
};

var real__cpSpaceFree = asm["_cpSpaceFree"]; asm["_cpSpaceFree"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceFree.apply(null, arguments);
};

var real__cpSpaceGetCollisionBias = asm["_cpSpaceGetCollisionBias"]; asm["_cpSpaceGetCollisionBias"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceGetCollisionBias.apply(null, arguments);
};

var real__cpSpaceGetCollisionSlop = asm["_cpSpaceGetCollisionSlop"]; asm["_cpSpaceGetCollisionSlop"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceGetCollisionSlop.apply(null, arguments);
};

var real__cpSpaceGetDamping = asm["_cpSpaceGetDamping"]; asm["_cpSpaceGetDamping"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceGetDamping.apply(null, arguments);
};

var real__cpSpaceGetGravity = asm["_cpSpaceGetGravity"]; asm["_cpSpaceGetGravity"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceGetGravity.apply(null, arguments);
};

var real__cpSpaceGetIdleSpeedThreshold = asm["_cpSpaceGetIdleSpeedThreshold"]; asm["_cpSpaceGetIdleSpeedThreshold"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceGetIdleSpeedThreshold.apply(null, arguments);
};

var real__cpSpaceGetIterations = asm["_cpSpaceGetIterations"]; asm["_cpSpaceGetIterations"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceGetIterations.apply(null, arguments);
};

var real__cpSpaceGetSleepTimeThreshold = asm["_cpSpaceGetSleepTimeThreshold"]; asm["_cpSpaceGetSleepTimeThreshold"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceGetSleepTimeThreshold.apply(null, arguments);
};

var real__cpSpaceGetUserData = asm["_cpSpaceGetUserData"]; asm["_cpSpaceGetUserData"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceGetUserData.apply(null, arguments);
};

var real__cpSpaceNew = asm["_cpSpaceNew"]; asm["_cpSpaceNew"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceNew.apply(null, arguments);
};

var real__cpSpacePointQuery = asm["_cpSpacePointQuery"]; asm["_cpSpacePointQuery"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpacePointQuery.apply(null, arguments);
};

var real__cpSpaceReindexShapesForBody = asm["_cpSpaceReindexShapesForBody"]; asm["_cpSpaceReindexShapesForBody"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceReindexShapesForBody.apply(null, arguments);
};

var real__cpSpaceRemoveBody = asm["_cpSpaceRemoveBody"]; asm["_cpSpaceRemoveBody"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceRemoveBody.apply(null, arguments);
};

var real__cpSpaceRemoveConstraint = asm["_cpSpaceRemoveConstraint"]; asm["_cpSpaceRemoveConstraint"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceRemoveConstraint.apply(null, arguments);
};

var real__cpSpaceRemoveShape = asm["_cpSpaceRemoveShape"]; asm["_cpSpaceRemoveShape"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceRemoveShape.apply(null, arguments);
};

var real__cpSpaceSetCollisionBias = asm["_cpSpaceSetCollisionBias"]; asm["_cpSpaceSetCollisionBias"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceSetCollisionBias.apply(null, arguments);
};

var real__cpSpaceSetCollisionSlop = asm["_cpSpaceSetCollisionSlop"]; asm["_cpSpaceSetCollisionSlop"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceSetCollisionSlop.apply(null, arguments);
};

var real__cpSpaceSetDamping = asm["_cpSpaceSetDamping"]; asm["_cpSpaceSetDamping"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceSetDamping.apply(null, arguments);
};

var real__cpSpaceSetGravity = asm["_cpSpaceSetGravity"]; asm["_cpSpaceSetGravity"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceSetGravity.apply(null, arguments);
};

var real__cpSpaceSetIdleSpeedThreshold = asm["_cpSpaceSetIdleSpeedThreshold"]; asm["_cpSpaceSetIdleSpeedThreshold"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceSetIdleSpeedThreshold.apply(null, arguments);
};

var real__cpSpaceSetIterations = asm["_cpSpaceSetIterations"]; asm["_cpSpaceSetIterations"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceSetIterations.apply(null, arguments);
};

var real__cpSpaceSetSleepTimeThreshold = asm["_cpSpaceSetSleepTimeThreshold"]; asm["_cpSpaceSetSleepTimeThreshold"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceSetSleepTimeThreshold.apply(null, arguments);
};

var real__cpSpaceSetUserData = asm["_cpSpaceSetUserData"]; asm["_cpSpaceSetUserData"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceSetUserData.apply(null, arguments);
};

var real__cpSpaceShapeQuery = asm["_cpSpaceShapeQuery"]; asm["_cpSpaceShapeQuery"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceShapeQuery.apply(null, arguments);
};

var real__cpSpaceStep = asm["_cpSpaceStep"]; asm["_cpSpaceStep"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__cpSpaceStep.apply(null, arguments);
};

var real__fflush = asm["_fflush"]; asm["_fflush"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__fflush.apply(null, arguments);
};

var real__free = asm["_free"]; asm["_free"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__free.apply(null, arguments);
};

var real__i64Add = asm["_i64Add"]; asm["_i64Add"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__i64Add.apply(null, arguments);
};

var real__i64Subtract = asm["_i64Subtract"]; asm["_i64Subtract"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__i64Subtract.apply(null, arguments);
};

var real__llvm_bswap_i32 = asm["_llvm_bswap_i32"]; asm["_llvm_bswap_i32"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__llvm_bswap_i32.apply(null, arguments);
};

var real__malloc = asm["_malloc"]; asm["_malloc"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__malloc.apply(null, arguments);
};

var real__sbrk = asm["_sbrk"]; asm["_sbrk"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real__sbrk.apply(null, arguments);
};

var real_establishStackSpace = asm["establishStackSpace"]; asm["establishStackSpace"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real_establishStackSpace.apply(null, arguments);
};

var real_setDynamicTop = asm["setDynamicTop"]; asm["setDynamicTop"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real_setDynamicTop.apply(null, arguments);
};

var real_setThrew = asm["setThrew"]; asm["setThrew"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real_setThrew.apply(null, arguments);
};

var real_stackAlloc = asm["stackAlloc"]; asm["stackAlloc"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real_stackAlloc.apply(null, arguments);
};

var real_stackRestore = asm["stackRestore"]; asm["stackRestore"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real_stackRestore.apply(null, arguments);
};

var real_stackSave = asm["stackSave"]; asm["stackSave"] = function() {
  assert(runtimeInitialized, 'you need to wait for the runtime to be ready (e.g. wait for main() to be called)');
  assert(!runtimeExited, 'the runtime was exited (use NO_EXIT_RUNTIME to keep it alive after main() exits)');
  return real_stackSave.apply(null, arguments);
};
var ___errno_location = Module["___errno_location"] = asm["___errno_location"];
var ___muldi3 = Module["___muldi3"] = asm["___muldi3"];
var ___udivdi3 = Module["___udivdi3"] = asm["___udivdi3"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _chipmunk_cpBodyApplyForceAtLocalPoint = Module["_chipmunk_cpBodyApplyForceAtLocalPoint"] = asm["_chipmunk_cpBodyApplyForceAtLocalPoint"];
var _chipmunk_cpBodyApplyForceAtWorldPoint = Module["_chipmunk_cpBodyApplyForceAtWorldPoint"] = asm["_chipmunk_cpBodyApplyForceAtWorldPoint"];
var _chipmunk_cpBodyApplyImpulseAtLocalPoint = Module["_chipmunk_cpBodyApplyImpulseAtLocalPoint"] = asm["_chipmunk_cpBodyApplyImpulseAtLocalPoint"];
var _chipmunk_cpBodyApplyImpulseAtWorldPoint = Module["_chipmunk_cpBodyApplyImpulseAtWorldPoint"] = asm["_chipmunk_cpBodyApplyImpulseAtWorldPoint"];
var _chipmunk_cpBodyGetPosition = Module["_chipmunk_cpBodyGetPosition"] = asm["_chipmunk_cpBodyGetPosition"];
var _chipmunk_cpBodyGetVelocity = Module["_chipmunk_cpBodyGetVelocity"] = asm["_chipmunk_cpBodyGetVelocity"];
var _chipmunk_cpBodySetPosition = Module["_chipmunk_cpBodySetPosition"] = asm["_chipmunk_cpBodySetPosition"];
var _chipmunk_cpBodySetVelocity = Module["_chipmunk_cpBodySetVelocity"] = asm["_chipmunk_cpBodySetVelocity"];
var _chipmunk_cpBodySetVelocityUpdateFunc = Module["_chipmunk_cpBodySetVelocityUpdateFunc"] = asm["_chipmunk_cpBodySetVelocityUpdateFunc"];
var _chipmunk_cpBodyUpdateVelocity = Module["_chipmunk_cpBodyUpdateVelocity"] = asm["_chipmunk_cpBodyUpdateVelocity"];
var _cpArbiterGetBodies = Module["_cpArbiterGetBodies"] = asm["_cpArbiterGetBodies"];
var _cpArbiterGetNormal = Module["_cpArbiterGetNormal"] = asm["_cpArbiterGetNormal"];
var _cpArbiterGetShapes = Module["_cpArbiterGetShapes"] = asm["_cpArbiterGetShapes"];
var _cpArbiterIgnore = Module["_cpArbiterIgnore"] = asm["_cpArbiterIgnore"];
var _cpArbiterSetFriction = Module["_cpArbiterSetFriction"] = asm["_cpArbiterSetFriction"];
var _cpArbiterSetRestitution = Module["_cpArbiterSetRestitution"] = asm["_cpArbiterSetRestitution"];
var _cpArbiterSetSurfaceVelocity = Module["_cpArbiterSetSurfaceVelocity"] = asm["_cpArbiterSetSurfaceVelocity"];
var _cpBodyActivate = Module["_cpBodyActivate"] = asm["_cpBodyActivate"];
var _cpBodyFree = Module["_cpBodyFree"] = asm["_cpBodyFree"];
var _cpBodyGetAngle = Module["_cpBodyGetAngle"] = asm["_cpBodyGetAngle"];
var _cpBodyGetAngularVelocity = Module["_cpBodyGetAngularVelocity"] = asm["_cpBodyGetAngularVelocity"];
var _cpBodyGetMass = Module["_cpBodyGetMass"] = asm["_cpBodyGetMass"];
var _cpBodyGetType = Module["_cpBodyGetType"] = asm["_cpBodyGetType"];
var _cpBodyGetUserData = Module["_cpBodyGetUserData"] = asm["_cpBodyGetUserData"];
var _cpBodyIsSleeping = Module["_cpBodyIsSleeping"] = asm["_cpBodyIsSleeping"];
var _cpBodyNew = Module["_cpBodyNew"] = asm["_cpBodyNew"];
var _cpBodyNewKinematic = Module["_cpBodyNewKinematic"] = asm["_cpBodyNewKinematic"];
var _cpBodyNewStatic = Module["_cpBodyNewStatic"] = asm["_cpBodyNewStatic"];
var _cpBodySetAngle = Module["_cpBodySetAngle"] = asm["_cpBodySetAngle"];
var _cpBodySetAngularVelocity = Module["_cpBodySetAngularVelocity"] = asm["_cpBodySetAngularVelocity"];
var _cpBodySetMass = Module["_cpBodySetMass"] = asm["_cpBodySetMass"];
var _cpBodySetPositionUpdateFunc = Module["_cpBodySetPositionUpdateFunc"] = asm["_cpBodySetPositionUpdateFunc"];
var _cpBodySetType = Module["_cpBodySetType"] = asm["_cpBodySetType"];
var _cpBodySetUserData = Module["_cpBodySetUserData"] = asm["_cpBodySetUserData"];
var _cpBodySleep = Module["_cpBodySleep"] = asm["_cpBodySleep"];
var _cpBodyUpdatePosition = Module["_cpBodyUpdatePosition"] = asm["_cpBodyUpdatePosition"];
var _cpCircleShapeGetOffset = Module["_cpCircleShapeGetOffset"] = asm["_cpCircleShapeGetOffset"];
var _cpCircleShapeGetRadius = Module["_cpCircleShapeGetRadius"] = asm["_cpCircleShapeGetRadius"];
var _cpCircleShapeNew = Module["_cpCircleShapeNew"] = asm["_cpCircleShapeNew"];
var _cpCircleShapeSetOffset = Module["_cpCircleShapeSetOffset"] = asm["_cpCircleShapeSetOffset"];
var _cpCircleShapeSetRadius = Module["_cpCircleShapeSetRadius"] = asm["_cpCircleShapeSetRadius"];
var _cpConstraintFree = Module["_cpConstraintFree"] = asm["_cpConstraintFree"];
var _cpConstraintGetErrorBias = Module["_cpConstraintGetErrorBias"] = asm["_cpConstraintGetErrorBias"];
var _cpConstraintGetMaxBias = Module["_cpConstraintGetMaxBias"] = asm["_cpConstraintGetMaxBias"];
var _cpConstraintGetMaxForce = Module["_cpConstraintGetMaxForce"] = asm["_cpConstraintGetMaxForce"];
var _cpConstraintGetUserData = Module["_cpConstraintGetUserData"] = asm["_cpConstraintGetUserData"];
var _cpConstraintSetErrorBias = Module["_cpConstraintSetErrorBias"] = asm["_cpConstraintSetErrorBias"];
var _cpConstraintSetMaxBias = Module["_cpConstraintSetMaxBias"] = asm["_cpConstraintSetMaxBias"];
var _cpConstraintSetMaxForce = Module["_cpConstraintSetMaxForce"] = asm["_cpConstraintSetMaxForce"];
var _cpConstraintSetUserData = Module["_cpConstraintSetUserData"] = asm["_cpConstraintSetUserData"];
var _cpPivotJointNew2 = Module["_cpPivotJointNew2"] = asm["_cpPivotJointNew2"];
var _cpPolyShapeNewRaw = Module["_cpPolyShapeNewRaw"] = asm["_cpPolyShapeNewRaw"];
var _cpSegmentShapeGetA = Module["_cpSegmentShapeGetA"] = asm["_cpSegmentShapeGetA"];
var _cpSegmentShapeGetB = Module["_cpSegmentShapeGetB"] = asm["_cpSegmentShapeGetB"];
var _cpSegmentShapeNew = Module["_cpSegmentShapeNew"] = asm["_cpSegmentShapeNew"];
var _cpShapeFree = Module["_cpShapeFree"] = asm["_cpShapeFree"];
var _cpShapeGetBody = Module["_cpShapeGetBody"] = asm["_cpShapeGetBody"];
var _cpShapeGetCollisionType = Module["_cpShapeGetCollisionType"] = asm["_cpShapeGetCollisionType"];
var _cpShapeGetElasticity = Module["_cpShapeGetElasticity"] = asm["_cpShapeGetElasticity"];
var _cpShapeGetFilter = Module["_cpShapeGetFilter"] = asm["_cpShapeGetFilter"];
var _cpShapeGetFriction = Module["_cpShapeGetFriction"] = asm["_cpShapeGetFriction"];
var _cpShapeGetSensor = Module["_cpShapeGetSensor"] = asm["_cpShapeGetSensor"];
var _cpShapeGetSpace = Module["_cpShapeGetSpace"] = asm["_cpShapeGetSpace"];
var _cpShapeSetBody = Module["_cpShapeSetBody"] = asm["_cpShapeSetBody"];
var _cpShapeSetCollisionType = Module["_cpShapeSetCollisionType"] = asm["_cpShapeSetCollisionType"];
var _cpShapeSetElasticity = Module["_cpShapeSetElasticity"] = asm["_cpShapeSetElasticity"];
var _cpShapeSetFilter = Module["_cpShapeSetFilter"] = asm["_cpShapeSetFilter"];
var _cpShapeSetFriction = Module["_cpShapeSetFriction"] = asm["_cpShapeSetFriction"];
var _cpShapeSetSensor = Module["_cpShapeSetSensor"] = asm["_cpShapeSetSensor"];
var _cpSlideJointNew = Module["_cpSlideJointNew"] = asm["_cpSlideJointNew"];
var _cpSpaceAddBody = Module["_cpSpaceAddBody"] = asm["_cpSpaceAddBody"];
var _cpSpaceAddCollisionHandler = Module["_cpSpaceAddCollisionHandler"] = asm["_cpSpaceAddCollisionHandler"];
var _cpSpaceAddConstraint = Module["_cpSpaceAddConstraint"] = asm["_cpSpaceAddConstraint"];
var _cpSpaceAddPostStepCallback = Module["_cpSpaceAddPostStepCallback"] = asm["_cpSpaceAddPostStepCallback"];
var _cpSpaceAddShape = Module["_cpSpaceAddShape"] = asm["_cpSpaceAddShape"];
var _cpSpaceContainsBody = Module["_cpSpaceContainsBody"] = asm["_cpSpaceContainsBody"];
var _cpSpaceContainsShape = Module["_cpSpaceContainsShape"] = asm["_cpSpaceContainsShape"];
var _cpSpaceFree = Module["_cpSpaceFree"] = asm["_cpSpaceFree"];
var _cpSpaceGetCollisionBias = Module["_cpSpaceGetCollisionBias"] = asm["_cpSpaceGetCollisionBias"];
var _cpSpaceGetCollisionSlop = Module["_cpSpaceGetCollisionSlop"] = asm["_cpSpaceGetCollisionSlop"];
var _cpSpaceGetDamping = Module["_cpSpaceGetDamping"] = asm["_cpSpaceGetDamping"];
var _cpSpaceGetGravity = Module["_cpSpaceGetGravity"] = asm["_cpSpaceGetGravity"];
var _cpSpaceGetIdleSpeedThreshold = Module["_cpSpaceGetIdleSpeedThreshold"] = asm["_cpSpaceGetIdleSpeedThreshold"];
var _cpSpaceGetIterations = Module["_cpSpaceGetIterations"] = asm["_cpSpaceGetIterations"];
var _cpSpaceGetSleepTimeThreshold = Module["_cpSpaceGetSleepTimeThreshold"] = asm["_cpSpaceGetSleepTimeThreshold"];
var _cpSpaceGetUserData = Module["_cpSpaceGetUserData"] = asm["_cpSpaceGetUserData"];
var _cpSpaceNew = Module["_cpSpaceNew"] = asm["_cpSpaceNew"];
var _cpSpacePointQuery = Module["_cpSpacePointQuery"] = asm["_cpSpacePointQuery"];
var _cpSpaceReindexShapesForBody = Module["_cpSpaceReindexShapesForBody"] = asm["_cpSpaceReindexShapesForBody"];
var _cpSpaceRemoveBody = Module["_cpSpaceRemoveBody"] = asm["_cpSpaceRemoveBody"];
var _cpSpaceRemoveConstraint = Module["_cpSpaceRemoveConstraint"] = asm["_cpSpaceRemoveConstraint"];
var _cpSpaceRemoveShape = Module["_cpSpaceRemoveShape"] = asm["_cpSpaceRemoveShape"];
var _cpSpaceSetCollisionBias = Module["_cpSpaceSetCollisionBias"] = asm["_cpSpaceSetCollisionBias"];
var _cpSpaceSetCollisionSlop = Module["_cpSpaceSetCollisionSlop"] = asm["_cpSpaceSetCollisionSlop"];
var _cpSpaceSetDamping = Module["_cpSpaceSetDamping"] = asm["_cpSpaceSetDamping"];
var _cpSpaceSetGravity = Module["_cpSpaceSetGravity"] = asm["_cpSpaceSetGravity"];
var _cpSpaceSetIdleSpeedThreshold = Module["_cpSpaceSetIdleSpeedThreshold"] = asm["_cpSpaceSetIdleSpeedThreshold"];
var _cpSpaceSetIterations = Module["_cpSpaceSetIterations"] = asm["_cpSpaceSetIterations"];
var _cpSpaceSetSleepTimeThreshold = Module["_cpSpaceSetSleepTimeThreshold"] = asm["_cpSpaceSetSleepTimeThreshold"];
var _cpSpaceSetUserData = Module["_cpSpaceSetUserData"] = asm["_cpSpaceSetUserData"];
var _cpSpaceShapeQuery = Module["_cpSpaceShapeQuery"] = asm["_cpSpaceShapeQuery"];
var _cpSpaceStep = Module["_cpSpaceStep"] = asm["_cpSpaceStep"];
var _fflush = Module["_fflush"] = asm["_fflush"];
var _free = Module["_free"] = asm["_free"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _llvm_bswap_i32 = Module["_llvm_bswap_i32"] = asm["_llvm_bswap_i32"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _memset = Module["_memset"] = asm["_memset"];
var _sbrk = Module["_sbrk"] = asm["_sbrk"];
var establishStackSpace = Module["establishStackSpace"] = asm["establishStackSpace"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var setDynamicTop = Module["setDynamicTop"] = asm["setDynamicTop"];
var setThrew = Module["setThrew"] = asm["setThrew"];
var stackAlloc = Module["stackAlloc"] = asm["stackAlloc"];
var stackRestore = Module["stackRestore"] = asm["stackRestore"];
var stackSave = Module["stackSave"] = asm["stackSave"];
var dynCall_di = Module["dynCall_di"] = asm["dynCall_di"];
var dynCall_diii = Module["dynCall_diii"] = asm["dynCall_diii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vid = Module["dynCall_vid"] = asm["dynCall_vid"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_viidd = Module["dynCall_viidd"] = asm["dynCall_viidd"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_viiidi = Module["dynCall_viiidi"] = asm["dynCall_viiidi"];
var dynCall_viiiidii = Module["dynCall_viiiidii"] = asm["dynCall_viiiidii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
;



// === Auto-generated postamble setup entry stuff ===

Module['asm'] = asm;

if (!Module["intArrayFromString"]) Module["intArrayFromString"] = function() { abort("'intArrayFromString' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["intArrayToString"]) Module["intArrayToString"] = function() { abort("'intArrayToString' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
Module["ccall"] = ccall;
Module["cwrap"] = cwrap;
Module["setValue"] = setValue;
Module["getValue"] = getValue;
Module["allocate"] = allocate;
if (!Module["getMemory"]) Module["getMemory"] = function() { abort("'getMemory' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["Pointer_stringify"]) Module["Pointer_stringify"] = function() { abort("'Pointer_stringify' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["AsciiToString"]) Module["AsciiToString"] = function() { abort("'AsciiToString' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["stringToAscii"]) Module["stringToAscii"] = function() { abort("'stringToAscii' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["UTF8ArrayToString"]) Module["UTF8ArrayToString"] = function() { abort("'UTF8ArrayToString' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["UTF8ToString"]) Module["UTF8ToString"] = function() { abort("'UTF8ToString' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["stringToUTF8Array"]) Module["stringToUTF8Array"] = function() { abort("'stringToUTF8Array' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["stringToUTF8"]) Module["stringToUTF8"] = function() { abort("'stringToUTF8' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["lengthBytesUTF8"]) Module["lengthBytesUTF8"] = function() { abort("'lengthBytesUTF8' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["UTF16ToString"]) Module["UTF16ToString"] = function() { abort("'UTF16ToString' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["stringToUTF16"]) Module["stringToUTF16"] = function() { abort("'stringToUTF16' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["lengthBytesUTF16"]) Module["lengthBytesUTF16"] = function() { abort("'lengthBytesUTF16' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["UTF32ToString"]) Module["UTF32ToString"] = function() { abort("'UTF32ToString' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["stringToUTF32"]) Module["stringToUTF32"] = function() { abort("'stringToUTF32' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["lengthBytesUTF32"]) Module["lengthBytesUTF32"] = function() { abort("'lengthBytesUTF32' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["allocateUTF8"]) Module["allocateUTF8"] = function() { abort("'allocateUTF8' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["stackTrace"]) Module["stackTrace"] = function() { abort("'stackTrace' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["addOnPreRun"]) Module["addOnPreRun"] = function() { abort("'addOnPreRun' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["addOnInit"]) Module["addOnInit"] = function() { abort("'addOnInit' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["addOnPreMain"]) Module["addOnPreMain"] = function() { abort("'addOnPreMain' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["addOnExit"]) Module["addOnExit"] = function() { abort("'addOnExit' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["addOnPostRun"]) Module["addOnPostRun"] = function() { abort("'addOnPostRun' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["writeStringToMemory"]) Module["writeStringToMemory"] = function() { abort("'writeStringToMemory' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["writeArrayToMemory"]) Module["writeArrayToMemory"] = function() { abort("'writeArrayToMemory' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["writeAsciiToMemory"]) Module["writeAsciiToMemory"] = function() { abort("'writeAsciiToMemory' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["addRunDependency"]) Module["addRunDependency"] = function() { abort("'addRunDependency' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["removeRunDependency"]) Module["removeRunDependency"] = function() { abort("'removeRunDependency' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["ENV"]) Module["ENV"] = function() { abort("'ENV' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["FS"]) Module["FS"] = function() { abort("'FS' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["FS_createFolder"]) Module["FS_createFolder"] = function() { abort("'FS_createFolder' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["FS_createPath"]) Module["FS_createPath"] = function() { abort("'FS_createPath' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["FS_createDataFile"]) Module["FS_createDataFile"] = function() { abort("'FS_createDataFile' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["FS_createPreloadedFile"]) Module["FS_createPreloadedFile"] = function() { abort("'FS_createPreloadedFile' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["FS_createLazyFile"]) Module["FS_createLazyFile"] = function() { abort("'FS_createLazyFile' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["FS_createLink"]) Module["FS_createLink"] = function() { abort("'FS_createLink' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["FS_createDevice"]) Module["FS_createDevice"] = function() { abort("'FS_createDevice' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["FS_unlink"]) Module["FS_unlink"] = function() { abort("'FS_unlink' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ). Alternatively, forcing filesystem support (-s FORCE_FILESYSTEM=1) can export this for you") };
if (!Module["GL"]) Module["GL"] = function() { abort("'GL' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["staticAlloc"]) Module["staticAlloc"] = function() { abort("'staticAlloc' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["dynamicAlloc"]) Module["dynamicAlloc"] = function() { abort("'dynamicAlloc' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["warnOnce"]) Module["warnOnce"] = function() { abort("'warnOnce' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["loadDynamicLibrary"]) Module["loadDynamicLibrary"] = function() { abort("'loadDynamicLibrary' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["loadWebAssemblyModule"]) Module["loadWebAssemblyModule"] = function() { abort("'loadWebAssemblyModule' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["getLEB"]) Module["getLEB"] = function() { abort("'getLEB' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["getFunctionTables"]) Module["getFunctionTables"] = function() { abort("'getFunctionTables' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["alignFunctionTables"]) Module["alignFunctionTables"] = function() { abort("'alignFunctionTables' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["registerFunctions"]) Module["registerFunctions"] = function() { abort("'registerFunctions' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["addFunction"]) Module["addFunction"] = function() { abort("'addFunction' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["removeFunction"]) Module["removeFunction"] = function() { abort("'removeFunction' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["getFuncWrapper"]) Module["getFuncWrapper"] = function() { abort("'getFuncWrapper' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["prettyPrint"]) Module["prettyPrint"] = function() { abort("'prettyPrint' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["makeBigInt"]) Module["makeBigInt"] = function() { abort("'makeBigInt' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["dynCall"]) Module["dynCall"] = function() { abort("'dynCall' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["getCompilerSetting"]) Module["getCompilerSetting"] = function() { abort("'getCompilerSetting' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["stackSave"]) Module["stackSave"] = function() { abort("'stackSave' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["stackRestore"]) Module["stackRestore"] = function() { abort("'stackRestore' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["stackAlloc"]) Module["stackAlloc"] = function() { abort("'stackAlloc' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["establishStackSpace"]) Module["establishStackSpace"] = function() { abort("'establishStackSpace' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["print"]) Module["print"] = function() { abort("'print' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };
if (!Module["printErr"]) Module["printErr"] = function() { abort("'printErr' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") };if (!Module["ALLOC_NORMAL"]) Object.defineProperty(Module, "ALLOC_NORMAL", { get: function() { abort("'ALLOC_NORMAL' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") } });
Module["ALLOC_STACK"] = ALLOC_STACK;
if (!Module["ALLOC_STATIC"]) Object.defineProperty(Module, "ALLOC_STATIC", { get: function() { abort("'ALLOC_STATIC' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") } });
if (!Module["ALLOC_DYNAMIC"]) Object.defineProperty(Module, "ALLOC_DYNAMIC", { get: function() { abort("'ALLOC_DYNAMIC' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") } });
if (!Module["ALLOC_NONE"]) Object.defineProperty(Module, "ALLOC_NONE", { get: function() { abort("'ALLOC_NONE' was not exported. add it to EXTRA_EXPORTED_RUNTIME_METHODS (see the FAQ)") } });

if (memoryInitializer) {
  if (!isDataURI(memoryInitializer)) {
    memoryInitializer = locateFile(memoryInitializer);
  }
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, GLOBAL_BASE);
  } else {
    addRunDependency('memory initializer');
    var applyMemoryInitializer = function(data) {
      if (data.byteLength) data = new Uint8Array(data);
      for (var i = 0; i < data.length; i++) {
        assert(HEAPU8[GLOBAL_BASE + i] === 0, "area for memory initializer should not have been touched before it's loaded");
      }
      HEAPU8.set(data, GLOBAL_BASE);
      // Delete the typed array that contains the large blob of the memory initializer request response so that
      // we won't keep unnecessary memory lying around. However, keep the XHR object itself alive so that e.g.
      // its .status field can still be accessed later.
      if (Module['memoryInitializerRequest']) delete Module['memoryInitializerRequest'].response;
      removeRunDependency('memory initializer');
    }
    function doBrowserLoad() {
      Module['readAsync'](memoryInitializer, applyMemoryInitializer, function() {
        throw 'could not load memory initializer ' + memoryInitializer;
      });
    }
    if (Module['memoryInitializerRequest']) {
      // a network request has already been created, just use that
      function useRequest() {
        var request = Module['memoryInitializerRequest'];
        var response = request.response;
        if (request.status !== 200 && request.status !== 0) {
            // If you see this warning, the issue may be that you are using locateFile and defining it in JS. That
            // means that the HTML file doesn't know about it, and when it tries to create the mem init request early, does it to the wrong place.
            // Look in your browser's devtools network console to see what's going on.
            console.warn('a problem seems to have happened with Module.memoryInitializerRequest, status: ' + request.status + ', retrying ' + memoryInitializer);
            doBrowserLoad();
            return;
        }
        applyMemoryInitializer(response);
      }
      if (Module['memoryInitializerRequest'].response) {
        setTimeout(useRequest, 0); // it's already here; but, apply it asynchronously
      } else {
        Module['memoryInitializerRequest'].addEventListener('load', useRequest); // wait for it
      }
    } else {
      // fetch it from the network ourselves
      doBrowserLoad();
    }
  }
}


// Modularize mode returns a function, which can be called to
// create instances. The instances provide a then() method,
// must like a Promise, that receives a callback. The callback
// is called when the module is ready to run, with the module
// as a parameter. (Like a Promise, it also returns the module
// so you can use the output of .then(..)).
Module['then'] = function(func) {
  // We may already be ready to run code at this time. if
  // so, just queue a call to the callback.
  if (Module['calledRun']) {
    func(Module);
  } else {
    // we are not ready to call then() yet. we must call it
    // at the same time we would call onRuntimeInitialized.
    var old = Module['onRuntimeInitialized'];
    Module['onRuntimeInitialized'] = function() {
      if (old) old();
      func(Module);
    };
  }
  return Module;
};

/**
 * @constructor
 * @extends {Error}
 * @this {ExitStatus}
 */
function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun']) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}





/** @type {function(Array=)} */
function run(args) {
  args = args || Module['arguments'];

  if (runDependencies > 0) {
    return;
  }

  writeStackCookie();

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    if (ABORT) return;

    ensureInitRuntime();

    preMain();

    if (Module['onRuntimeInitialized']) Module['onRuntimeInitialized']();

    assert(!Module['_main'], 'compiled without a main, but one is present. if you added it from JS, use Module["onRuntimeInitialized"]');

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      doRun();
    }, 1);
  } else {
    doRun();
  }
  checkStackCookie();
}
Module['run'] = run;

function checkUnflushedContent() {
  // Compiler settings do not allow exiting the runtime, so flushing
  // the streams is not possible. but in ASSERTIONS mode we check
  // if there was something to flush, and if so tell the user they
  // should request that the runtime be exitable.
  // Normally we would not even include flush() at all, but in ASSERTIONS
  // builds we do so just for this check, and here we see if there is any
  // content to flush, that is, we check if there would have been
  // something a non-ASSERTIONS build would have not seen.
  // How we flush the streams depends on whether we are in FILESYSTEM=0
  // mode (which has its own special function for this; otherwise, all
  // the code is inside libc)
  var print = out;
  var printErr = err;
  var has = false;
  out = err = function(x) {
    has = true;
  }
  try { // it doesn't matter if it fails
    var flush = flush_NO_FILESYSTEM;
    if (flush) flush(0);
  } catch(e) {}
  out = print;
  err = printErr;
  if (has) {
    warnOnce('stdio streams had content in them that was not flushed. you should set EXIT_RUNTIME to 1 (see the FAQ), or make sure to emit a newline when you printf etc.');
    warnOnce('(this may also be due to not including full filesystem support - try building with -s FORCE_FILESYSTEM=1)');
  }
}

function exit(status, implicit) {
  checkUnflushedContent();

  // if this is just main exit-ing implicitly, and the status is 0, then we
  // don't need to do anything here and can just leave. if the status is
  // non-zero, though, then we need to report it.
  // (we may have warned about this earlier, if a situation justifies doing so)
  if (implicit && Module['noExitRuntime'] && status === 0) {
    return;
  }

  if (Module['noExitRuntime']) {
    // if exit() was called, we may warn the user if the runtime isn't actually being shut down
    if (!implicit) {
      err('exit(' + status + ') called, but EXIT_RUNTIME is not set, so halting execution but not exiting the runtime or preventing further async execution (build with EXIT_RUNTIME=1, if you want a true shutdown)');
    }
  } else {

    ABORT = true;
    EXITSTATUS = status;
    STACKTOP = initialStackTop;

    exitRuntime();

    if (Module['onExit']) Module['onExit'](status);
  }

  Module['quit'](status, new ExitStatus(status));
}

var abortDecorators = [];

function abort(what) {
  if (Module['onAbort']) {
    Module['onAbort'](what);
  }

  if (what !== undefined) {
    out(what);
    err(what);
    what = JSON.stringify(what)
  } else {
    what = '';
  }

  ABORT = true;
  EXITSTATUS = 1;

  var extra = '';
  var output = 'abort(' + what + ') at ' + stackTrace() + extra;
  if (abortDecorators) {
    abortDecorators.forEach(function(decorator) {
      output = decorator(output, what);
    });
  }
  throw output;
}
Module['abort'] = abort;

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}


  Module["noExitRuntime"] = true;

run();





// {{MODULE_ADDITIONS}}








  return Module;
}
);
})();
if (typeof exports === 'object' && typeof module === 'object')
    module.exports = Module;
  else if (typeof define === 'function' && define['amd'])
    define([], function() { return Module; });
  else if (typeof exports === 'object')
    exports["Module"] = Module;
  
}).call(this,require('_process'),"/src")
},{"_process":6,"fs":4,"path":5}],8:[function(require,module,exports){
const chipmunk = require('./lib/chipmunk').chipmunk;
const libchipmunk = require('./lib/chipmunk').webassembly;
const cpvlib = require('./lib/chipmunk').cpvlib;

libchipmunk().then(function(runtime) {
    chipmunk.runtime = runtime;
    var space = chipmunk.cpSpaceNew();
    var body = chipmunk.cpBodyNew(1.0, 1.0);
    var userData = { a: 1.0, b: "hello" };
    chipmunk.cpBodySetUserData(body, userData);
    userData = chipmunk.cpBodyGetUserData(body);
    console.log("userData: ", userData);
    var position = chipmunk.cpBodyGetPosition(body);
    console.log("position: ", position);
    chipmunk.cpBodySetPosition(body, new cpVect(1.0, 3.0));
    position = chipmunk.cpBodyGetPosition(body);
    console.log("position: ", position);

    var velocity = chipmunk.cpBodyGetVelocity(body);
    console.log("velocity: ", velocity);
    chipmunk.cpBodySetVelocity(body, new cpVect(1.0, 3.0));
    velocity = chipmunk.cpBodyGetVelocity(body);
    console.log("velocity: ", velocity);

    var mass = chipmunk.cpBodyGetMass(body);
    console.log("mass: ", mass);
    chipmunk.cpBodySetMass(body, 32.0);
    mass = chipmunk.cpBodyGetMass(body);    
    console.log("mass: ", mass);

    var angle = chipmunk.cpBodyGetAngle(body);
    console.log("angle: ", angle);
    chipmunk.cpBodySetAngle(body, 32.0);
    angle = chipmunk.cpBodyGetAngle(body);    
    console.log("angle: ", angle);

    var angularVelocity = chipmunk.cpBodyGetAngularVelocity(body);
    console.log("angularVelocity: ", angularVelocity);
    chipmunk.cpBodySetAngularVelocity(body, 32.0);
    angularVelocity = chipmunk.cpBodyGetAngularVelocity(body);    
    console.log("angularVelocity: ", angularVelocity);
    console.log("isSleeping: ", chipmunk.cpBodyIsSleeping(body));
    chipmunk.cpBodySetType(body, chipmunk.CP_BODY_TYPE_DYNAMIC);        
    chipmunk.cpBodyActivate(body);
    chipmunk.cpSpaceAddBody(space, body);
    console.log("cpSpaceContainsBody: ", chipmunk.cpSpaceContainsBody(space, body));
    chipmunk.cpBodyUpdateVelocity(body, new cpVect(2.0, 9.0), 0.1, 0.1);
    chipmunk.cpBodyApplyForceAtWorldPoint(body, new cpVect(2.0, 9.0), cpvlib.cpvzero);
    chipmunk.cpBodyApplyForceAtLocalPoint(body, new cpVect(2.0, 9.0), cpvlib.cpvzero);
    chipmunk.cpBodyApplyImpulseAtWorldPoint(body, new cpVect(2.0, 9.0), cpvlib.cpvzero);
    chipmunk.cpBodyApplyImpulseAtLocalPoint(body, new cpVect(2.0, 9.0), cpvlib.cpvzero);    
    chipmunk.cpSpaceRemoveBody(space, body);
    console.log("cpSpaceContainsBody: ", chipmunk.cpSpaceContainsBody(space, body));
    chipmunk.cpBodyFree(body);
    chipmunk.cpSpaceFree(space);    
});

},{"./lib/chipmunk":1}]},{},[8]);
